#define XDEBUG 0

/*
#define DEBUG  1
*/

/*
================================================================================
	D e X I n p u t . c
================================================================================

	Methods file for DeXInput widget.

	Author : Denis LAMBOLEZ
		 b3e CHU ST-ANTOINE

	History: 
		 - Version 1.0: January 1994
		   January, 3th 1994: Creation (DLZ)
		 - Version 2.0: octobre 1995
			correction de bugs invisibles sous OSF ou Ultrix
			pour fonctionnement sur Sun Solaris (JFV + EB)
================================================================================
*/

/*
================================================================================
	Header files and specials macros
================================================================================
*/

/*Standard library header files*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>

/*X11 header files*/
#include <X11/keysym.h>

/*Intrinsic library header files*/
#include <X11/IntrinsicP.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

/*Xt superclass header files*/
#include <X11/CoreP.h>
#include <X11/Core.h>
#include <X11/CompositeP.h>
#include <X11/Composite.h>
#include <X11/ConstrainP.h>
#include <X11/Constraint.h>

/*Motif library and superclass header files*/
#include <Xm/Xm.h>
#include <Xm/BulletinBP.h>
#include <Xm/BulletinB.h>
#include <Xm/TextF.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>

#ifndef XtInheritGeoMatrixCreate
#define XtInheritGeoMatrixCreate ((XmGeoCreateProc) _XtInherit)
#endif
 
/*DeX library header files*/
#include "DeXInputP.h"
#include "DeXInput.h"

#ifdef __cplusplus
extern "C"{
#endif
/*
================================================================================
	Action function declaration
================================================================================
*/

/*
================================================================================
	Method function declaration
================================================================================
*/

static void		Initialize(Widget, Widget, ArgList, Cardinal *);
static XtGeometryResult GeometryManager(Widget, XtWidgetGeometry *, XtWidgetGeometry *);
static void		Resize(Widget);
static void		Destroy(Widget);
static Boolean		SetValues(Widget, Widget, Widget, ArgList, Cardinal *);
/*static void		Redisplay(Widget, XExposeEvent *);*/
/*
================================================================================
	Internal callback, Internal event handler and Time procedure declaration
================================================================================
*/

static void verify_text_cb(Widget, XtPointer, XtPointer);
static void button_ok_cb(Widget, XtPointer, XtPointer);
static void button_default_cb(Widget, XtPointer, XtPointer);
static void prev_values(Widget , XtPointer, XEvent *, Boolean *);
static void activate_incrementation(Widget , XtPointer, XEvent *, Boolean *);
static void stop_incrementation(Widget, XtPointer, XEvent *, Boolean *);
static void activate_decrementation(Widget , XtPointer, XEvent *, Boolean *);
static void stop_decrementation(Widget, XtPointer, XEvent *, Boolean *);
static void increment_proc(XtPointer, XtIntervalId *);
static void decrement_proc(XtPointer, XtIntervalId *);

#ifdef __cplusplus
}
#endif
/*
================================================================================
	Ressource list
================================================================================
*/

static XtResource resources[] = 
{
  	{
	DeXNincrement, DeXCIncrement, XtRInt, sizeof (int),
    	XtOffset(DeXInputWidget, input.increment), XtRString, "1"  
	},
  	{
	DeXNvalue, DeXCValue, XtRInt, sizeof (int),
    	XtOffset(DeXInputWidget, input.value), XtRString, "100"  
	},
  	{
	DeXNdefaultValue, DeXCDefaultValue, XtRInt, sizeof (int),
    	XtOffset(DeXInputWidget, input.default_value), XtRString, "100"  
	},
  	{
	DeXNdecimalPoint, DeXCDecimalPoint, XtRInt, sizeof (int),
    	XtOffset(DeXInputWidget, input.decimal_point), XtRString, "2"  
	},
  	{
	DeXNlabelString, DeXCLabelString, XtRString, (sizeof (char) * 60),
    	XtOffset(DeXInputWidget, input.label_string), XtRString, "Label of DeXInput"
	},
  	{
	DeXNokCallback, DeXCOkCallback, XtRCallback, 
	sizeof (XtPointer),
    	XtOffset(DeXInputWidget, input.ok_callback), XtRCallback, NULL 
	}
 };

/*
================================================================================
	Class record initialization
================================================================================
*/

DeXInputClassRec  DeXinputClassRec = 
{
     /* CoreClassPart */
  	{
   	(WidgetClass) &xmBulletinBoardClassRec,	/* superclass            */
   	"DeXInput",				/* class_name            */
   	sizeof(DeXInputRec),			/* widget_size           */
   	NULL,					/* class_initialize      */
   	NULL,					/* class_part_initialize */
   	FALSE,					/* class_inited          */
   	Initialize,				/* initialize            */
   	NULL,					/* initialize_hook       */
   	XtInheritRealize,			/* realize               */
   	NULL,					/* actions               */
   	0,					/* num_actions           */
   	resources,				/* resources             */
   	XtNumber(resources),			/* num_resources         */
   	NULLQUARK,				/* xrm_class             */
   	TRUE,					/* compress_motion       */
   	TRUE,					/* compress_exposure     */
   	TRUE,					/* compress_enterleave   */
   	TRUE,					/* visible_interest      */
   	Destroy,				/* destroy               */
   	Resize,					/* resize                */
   	NULL,					/* expose		 */
   	SetValues,				/* set_values            */
   	NULL,					/* set_values_hook       */
   	XtInheritSetValuesAlmost,		/* set_values_almost     */
   	NULL,					/* get_values_hook       */
   	NULL,					/* accept_focus          */
   	XtVersion,				/* version               */
   	NULL,					/* callback private      */
   	NULL,					/* tm_table              */
   	NULL,					/* query_geometry        */
   	NULL,					/* display_accelerator   */
   	NULL					/* extension             */
   	},
     /* CompositeClassPart */
  	{
	XtInheritGeometryManager,		/* geometry_manager		*/
	NULL,					/* change_managed		*/
	XtInheritInsertChild,			/* insert_child			*/
	XtInheritDeleteChild,			/* delete_child			*/
	NULL					/* pointer to extension record  */
   	},
     /* ConstraintClassPart */
  	{
	NULL,					/* constraint resource list	*/
	0,					/* number of constraint in list */
	sizeof(XmManagerConstraintRec),		/* size of constraint record    */
	NULL,					/* constraint initialization	*/
	NULL,					/* constraint destroy proc      */
	0,					/* constraint set values proc   */
	NULL					/* pointer to extension record  */
   	},
     /* ManagerClassPart */
  	{
	XtInheritTranslations,			/* translation table			*/
	NULL,					/* synthetic resources			*/
	0,					/* nb of synthetic resources		*/
	NULL,					/* synthetic constraint resources	*/
	0,					/* nb of synthetic constraint resources */
	XmInheritParentProcess,			/* parent_proc				*/
	NULL					/* pointer to extension record		*/
   	},
     /* BulletinBoardClassPart */
  	{
	TRUE,					/* always install accelerator		*/
	XtInheritGeoMatrixCreate,		/* goemetry matrix create procedure	*/
	XmInheritFocusMovedProc,		/* focus moved procedure		*/
	NULL					/* pointer to extension record		*/
   	},
     /* InputClassPart */
  	{
   	0					/* ignore				*/
   	}
};

/*shadow record*/
WidgetClass DeXinputWidgetClass = (WidgetClass) &DeXinputClassRec; 

/*
================================================================================
	Method function definition
================================================================================
*/

static int button_plus = PLUS;
static int button_minus = MINUS;
static char tmp_buff[80];
static DeXinputCallbackStruct cb_struct;

static void Initialize (Widget request_in, Widget New_in,
			ArgList arg, Cardinal *num_arg)
{
	DeXInputWidget request = (DeXInputWidget)request_in;
	DeXInputWidget New = (DeXInputWidget)New_in;
	XmString xmstring;
	GC gc;
	Arg  arglist[20];
	double tmp_double;
	Pixel background, foreground, top_shadow, bottom_shadow, select_color;
	int  argcount, i;
	char format[80], string[80];
	
#ifdef DEBUG
	printf("Initialize\n");
	XSynchronize(XtDisplay(New), 1);
#endif

/*
Make sure the window size is not zero. The Core 
Initialize() method doesn't do this.
*/
  	if (request->core.width == 0)
    		New->core.width = 300;
  	if (request->core.height == 0)
    		New->core.height = 85;

/* Check validity of the label */
/*
	if(New->input.label_string == NULL)
	{
		New->input.label_string = (char *)calloc(20, sizeof(char)); 
	}
	else
	{
		tmp_buff = (char *)calloc(strlen(New->input.label_string) + 1, sizeof(char));
		tmp_buff = (char *)calloc(60, sizeof(char));
		New->input.label_string = tmp_buff;
	}
*/
	if (strlen(New->input.label_string))
	{
		/* store in a static area the label string */
		strcpy(tmp_buff, New->input.label_string);
	}
	else
	{
		/* default value for the label string */
		strcpy(New->input.label_string, "Label of DeXInput");
		strcpy(tmp_buff, New->input.label_string);
	}
/*
Make sure teh previous values are set to 0
*/
	for (i = 0; i < 10; i++)
	{
		New->input.prev_values[i] = 0;
	}

/*
Make sure the increment an decimal Point values are valid
*/
	if (New->input.increment <= 0)
	{
    		XtWarning ("DeXInput: Increment must be greater than 0!");
    		New->input.increment = 1;
 	}
	if (New->input.decimal_point < 0)
	{
    		XtWarning ("DeXInput: Decimal Point mustn't be lower than 0!");
    		New->input.decimal_point = 0;
 	}

/*
Create GC and Pixmaps for buttons
*/
	gc = XCreateGC(XtDisplay(New), RootWindowOfScreen(DefaultScreenOfDisplay(XtDisplay(New))),
		       0, NULL);
	New->input.label_pixmap_plus_off = XCreatePixmap(XtDisplay(New),
				     RootWindowOfScreen(DefaultScreenOfDisplay(XtDisplay(New))),
				     16, 16,
				     DefaultDepthOfScreen(DefaultScreenOfDisplay(XtDisplay(New))));
	New->input.label_pixmap_minus_off = XCreatePixmap(XtDisplay(New),
				     RootWindowOfScreen(DefaultScreenOfDisplay(XtDisplay(New))),
				     16, 16,
				     DefaultDepthOfScreen(DefaultScreenOfDisplay(XtDisplay(New))));
	New->input.label_pixmap_plus_on = XCreatePixmap(XtDisplay(New),
				     RootWindowOfScreen(DefaultScreenOfDisplay(XtDisplay(New))),
				     16, 16,
				     DefaultDepthOfScreen(DefaultScreenOfDisplay(XtDisplay(New))));
	New->input.label_pixmap_minus_on = XCreatePixmap(XtDisplay(New),
				     RootWindowOfScreen(DefaultScreenOfDisplay(XtDisplay(New))),
				     16, 16,
				     DefaultDepthOfScreen(DefaultScreenOfDisplay(XtDisplay(New))));
	
#if DEBUG
	printf("Pixmap label_pixmap_plus_off : 0x%x\nPixmap label_pixmap_minus_off : 0x%x\n\
Pixmap label_pixmap_plus_on : 0x%x\nPixmap label_pixmap_minus_on : 0x%x\n",
	New->input.label_pixmap_plus_off, New->input.label_pixmap_minus_off,
	New->input.label_pixmap_plus_on, New->input.label_pixmap_minus_on);
#endif
	/* get background color from parent */
	argcount = 0;
	XtSetArg(arglist[argcount], XmNbackground, &background); argcount++;
	XtGetValues(New->core.parent, arglist, argcount);
	/* compute other colors */
	XmGetColors(DefaultScreenOfDisplay(XtDisplay(New)), New->core.colormap, background,
		    &foreground, &top_shadow, &bottom_shadow, &select_color);


/*
Create childs
*/
	/* XmLabel*/
	xmstring = XmStringCreateLocalized(New->input.label_string);
	New->input.label_height = XmStringHeight(BB_LabelFontList(New), xmstring);
	argcount = 0;
	XtSetArg(arglist[argcount], XmNlabelString, xmstring); argcount++;
	XtSetArg(arglist[argcount], XmNrecomputeSize, True); argcount++;
	XtSetArg(arglist[argcount], XmNlabelType, XmSTRING); argcount++;
	XtSetArg(arglist[argcount], XmNx, BB_MarginWidth(New)); argcount++;
	XtSetArg(arglist[argcount], XmNy, BB_MarginHeight(New)); argcount++;
	XtSetArg(arglist[argcount], XmNheight, New->input.label_height); argcount++;
	XtSetArg(arglist[argcount], XmNalignment, XmALIGNMENT_BEGINNING); argcount++;
	XtSetArg(arglist[argcount], XmNfontList, BB_LabelFontList(New)); argcount++;
	New->input.children[DEXINPUT_LABEL] = (Widget) XmCreateLabel((Widget)New, "DeXInput_Label",
							arglist, argcount);
	XmStringFree(xmstring);

	/* XmPushButton */
	xmstring = XmStringCreateLocalized("D");
	argcount = 0;
	XtSetArg(arglist[argcount], XmNx, BB_MarginWidth(New)); argcount++;
	XtSetArg(arglist[argcount], XmNy, BB_MarginHeight(New) + New->input.label_height + 5); argcount++;
	XtSetArg(arglist[argcount], XmNheight, New->core.height -
		 (2 * BB_MarginHeight(New) + New->input.label_height + 5)); argcount++;
	XtSetArg(arglist[argcount], XmNwidth, 30); argcount++;
	XtSetArg(arglist[argcount], XmNlabelString, xmstring); argcount++;
	XtSetArg(arglist[argcount], XmNfontList, BB_ButtonFontList(New)); argcount++;
	New->input.children[DEXINPUT_BUTTON_DEFAULT] = (Widget) XmCreatePushButton((Widget)New, "DeXInput_Button_Default",
									  arglist, argcount);
	XmStringFree(xmstring);

	/* XmTextField */
	argcount = 0;
	XtSetArg(arglist[argcount], XmNx, BB_MarginWidth(New) + 30); argcount++;
	XtSetArg(arglist[argcount], XmNy, BB_MarginHeight(New) + New->input.label_height + 5); argcount++;
	XtSetArg(arglist[argcount], XmNheight, New->core.height -
		 (2 * BB_MarginHeight(New) + New->input.label_height + 5)); argcount++;
	XtSetArg(arglist[argcount], XmNwidth, New->core.width -
		 (2 * BB_MarginWidth(New) + 90)); argcount++;
	XtSetArg(arglist[argcount], XmNvalue, "0"); argcount++;
	New->input.children[DEXINPUT_TEXT] = (Widget) XmCreateTextField((Widget)New, "DeXInput_Text", arglist, argcount);
#if XDEBUG
	printf("Initialize: New->input.children[DEXINPUT_TEXT]: %p\n", New->input.children[DEXINPUT_TEXT]);
#endif

	/* XmPushButton */
	XSetLineAttributes(XtDisplay(New), gc, 2, LineSolid, CapButt, JoinMiter);
	XSetForeground(XtDisplay(New), gc, background);
	XFillRectangle(XtDisplay(New), New->input.label_pixmap_plus_off, gc, 0, 0, 16, 16);
	XSetForeground(XtDisplay(New), gc, foreground);
	XDrawLine(XtDisplay(New), New->input.label_pixmap_plus_off, gc, 8, 4, 8, 12);
	XDrawLine(XtDisplay(New), New->input.label_pixmap_plus_off, gc, 4, 8, 12, 8);
	XSetForeground(XtDisplay(New), gc, select_color);
	XFillRectangle(XtDisplay(New), New->input.label_pixmap_plus_on, gc, 0, 0, 16, 16);
	XSetForeground(XtDisplay(New), gc, foreground);
	XDrawLine(XtDisplay(New), New->input.label_pixmap_plus_on, gc, 8, 4, 8, 12);
	XDrawLine(XtDisplay(New), New->input.label_pixmap_plus_on, gc, 4, 8, 12, 8);

	argcount = 0;
	XtSetArg(arglist[argcount], XmNx, New->core.width - (BB_MarginWidth(New) + 60)); argcount++;
	XtSetArg(arglist[argcount], XmNy, BB_MarginHeight(New) + New->input.label_height + 5); argcount++;
	XtSetArg(arglist[argcount], XmNheight, (New->core.height -
		 (2 * BB_MarginHeight(New) + New->input.label_height + 5)) / 2); argcount++;
	XtSetArg(arglist[argcount], XmNwidth, 20); argcount++;
	XtSetArg(arglist[argcount], XmNlabelType, XmPIXMAP); argcount++;
	XtSetArg(arglist[argcount], XmNlabelPixmap, New->input.label_pixmap_plus_off); argcount++;
	XtSetArg(arglist[argcount], XmNarmPixmap, New->input.label_pixmap_plus_on); argcount++;
	XtSetArg(arglist[argcount], XmNfontList, BB_TextFontList(New)); argcount++;
	New->input.children[DEXINPUT_BUTTON_PLUS] = (Widget) XmCreatePushButton((Widget)New, "DeXInput_Button_plus",
								   arglist, argcount);

   	/* XmPushButton */
	XSetForeground(XtDisplay(New), gc, background);
	XFillRectangle(XtDisplay(New), New->input.label_pixmap_minus_off, gc, 0, 0, 16, 16);
	XSetForeground(XtDisplay(New), gc, foreground);
	XDrawLine(XtDisplay(New), New->input.label_pixmap_minus_off, gc, 4, 8, 12, 8);
	XSetForeground(XtDisplay(New), gc, select_color);
	XFillRectangle(XtDisplay(New), New->input.label_pixmap_minus_on, gc, 0, 0, 16, 16);
	XSetForeground(XtDisplay(New), gc, foreground);
	XDrawLine(XtDisplay(New), New->input.label_pixmap_minus_on, gc, 4, 8, 12, 8);

	argcount = 0;
	XtSetArg(arglist[argcount], XmNx, New->core.width - (BB_MarginWidth(New) + 60)); argcount++;
	XtSetArg(arglist[argcount], XmNy, (New->core.height + New->input.label_height + 5) / 2); argcount++;
	XtSetArg(arglist[argcount], XmNheight, (New->core.height -
		 (2 * BB_MarginHeight(New) + New->input.label_height + 5)) / 2); argcount++;
	XtSetArg(arglist[argcount], XmNwidth, 20); argcount++;
	XtSetArg(arglist[argcount], XmNlabelType, XmPIXMAP); argcount++;
	XtSetArg(arglist[argcount], XmNlabelPixmap, New->input.label_pixmap_minus_off); argcount++;
	XtSetArg(arglist[argcount], XmNarmPixmap, New->input.label_pixmap_minus_on); argcount++;
	New->input.children[DEXINPUT_BUTTON_MINUS] = (Widget) XmCreatePushButton((Widget)New, "DeXInput_Button_Minus",
								   arglist, argcount);
	
	/* XmPushButton */
	xmstring = XmStringCreateLocalized("Ok");
	argcount = 0;
	XtSetArg(arglist[argcount], XmNx, New->core.width - (BB_MarginWidth(New) + 40)); argcount++;
	XtSetArg(arglist[argcount], XmNy, BB_MarginHeight(New) + New->input.label_height + 5); argcount++;
	XtSetArg(arglist[argcount], XmNheight, New->core.height -
		 (2 * BB_MarginHeight(New) + New->input.label_height + 5)); argcount++;
	XtSetArg(arglist[argcount], XmNwidth, 40); argcount++;
	XtSetArg(arglist[argcount], XmNlabelString, xmstring); argcount++;
	XtSetArg(arglist[argcount], XmNfontList, BB_ButtonFontList(New)); argcount++;
	New->input.children[DEXINPUT_BUTTON_OK] = (Widget) XmCreatePushButton((Widget)New, "DeXInput_Button_Ok",
									  arglist, argcount);
	XmStringFree(xmstring);

/*
Free GC
*/
	XFreeGC(XtDisplay(New), gc);

/*
Initialize number of previous values
*/
	New->input.nb_prev_values = 0;

/*
Initialize text child
*/
	tmp_double = (double)New->input.value / pow(10.0, (double)New->input.decimal_point);
	/* construct the format */
	sprintf(format, "%%.%df", New->input.decimal_point);
	sprintf(string, format, tmp_double);

#if XDEBUG
	printf("Initialize: New->input.children[DEXINPUT_TEXT]: %s\n", string);
#endif
	XmTextFieldSetString(New->input.children[DEXINPUT_TEXT], string);
/*
Initialize position in the prev_values array
*/
	New->input.prev_values[0] = tmp_double;
	New->input.nb_prev_values = 1;
	New->input.prev_values_index = 1;

/*
Add Internals Callbacks and Events Handlers
*/
	XtAddCallback(New->input.children[DEXINPUT_TEXT], XmNmodifyVerifyCallback, verify_text_cb, NULL);
	XtAddCallback(New->input.children[DEXINPUT_TEXT], XmNactivateCallback, button_ok_cb, NULL);
	XtAddCallback(New->input.children[DEXINPUT_BUTTON_OK], XmNactivateCallback, button_ok_cb, NULL);
	XtAddCallback(New->input.children[DEXINPUT_BUTTON_DEFAULT], XmNactivateCallback,
		      button_default_cb, NULL);

	XtAddEventHandler(New->input.children[DEXINPUT_BUTTON_PLUS], ButtonPressMask, FALSE, activate_incrementation,
			  &button_plus);
	XtAddEventHandler(New->input.children[DEXINPUT_BUTTON_PLUS], ButtonReleaseMask /* | LeaveWindowMask */,
			  FALSE, stop_incrementation, &button_plus);
	XtAddEventHandler(New->input.children[DEXINPUT_BUTTON_MINUS], ButtonPressMask, FALSE, activate_decrementation,
			  &button_minus);
	XtAddEventHandler(New->input.children[DEXINPUT_BUTTON_MINUS], ButtonReleaseMask /* | LeaveWindowMask */,
			  FALSE, stop_decrementation, &button_minus);
	XtAddEventHandler(New->input.children[DEXINPUT_TEXT], KeyPressMask,
			  FALSE, prev_values, NULL);

/*
Manage childs
*/
	XtManageChild(New->input.children[DEXINPUT_LABEL]);
	XtManageChild(New->input.children[DEXINPUT_BUTTON_DEFAULT]);
	XtManageChild(New->input.children[DEXINPUT_TEXT]);
	XtManageChild(New->input.children[DEXINPUT_BUTTON_PLUS]);
	XtManageChild(New->input.children[DEXINPUT_BUTTON_MINUS]);
	XtManageChild(New->input.children[DEXINPUT_BUTTON_OK]);

#ifdef DEBUG
	printf("End of Initialize\n");
#endif
}

/*============================================================================*/

static void Destroy (Widget w_in)
{
	DeXInputWidget w = (DeXInputWidget)w_in;

#ifdef DEBUG
	printf("Destroy\n");
#endif


	XFreePixmap(XtDisplay(w), w->input.label_pixmap_plus_on);
	XFreePixmap(XtDisplay(w), w->input.label_pixmap_minus_on);
	XFreePixmap(XtDisplay(w), w->input.label_pixmap_plus_off);
	XFreePixmap(XtDisplay(w), w->input.label_pixmap_minus_off);

/**	free(w->input.label_string); **/
#ifdef DEBUG
	printf("End of Destroy\n");
#endif

}

/*============================================================================*/

static void Resize (Widget w_in)
{
	DeXInputWidget w = (DeXInputWidget)w_in;
	Arg arglist[10];
	int argcount;

#ifdef DEBUG
	printf("Resize\n");
#endif

/*
Resize childs
*/
	/* XmLabel */
	argcount = 0;
	XtSetArg(arglist[argcount], XmNx, BB_MarginWidth(w)); argcount++;
	XtSetArg(arglist[argcount], XmNy, BB_MarginHeight(w)); argcount++;
	XtSetArg(arglist[argcount], XmNheight, w->input.label_height); argcount++;
	XtSetArg(arglist[argcount], XmNwidth, w->core.width -
		 (2 * BB_MarginWidth(w))); argcount++;
	XtSetValues(w->input.children[DEXINPUT_LABEL], arglist, argcount);

	/* XmPushButton */
	argcount = 0;
	XtSetArg(arglist[argcount], XmNx, BB_MarginWidth(w)); argcount++;
	XtSetArg(arglist[argcount], XmNy, BB_MarginHeight(w) + w->input.label_height + 5); argcount++;
	XtSetArg(arglist[argcount], XmNheight, w->core.height -
		 (2 * BB_MarginHeight(w) + w->input.label_height + 5)); argcount++;
	XtSetArg(arglist[argcount], XmNwidth, 30); argcount++;
	XtSetValues(w->input.children[DEXINPUT_BUTTON_DEFAULT], arglist, argcount);

	/* XmTextField */
	argcount = 0;
	XtSetArg(arglist[argcount], XmNx, BB_MarginWidth(w) + 30); argcount++;
	XtSetArg(arglist[argcount], XmNy, BB_MarginHeight(w) + w->input.label_height + 5); argcount++;
	XtSetArg(arglist[argcount], XmNheight, w->core.height -
		 (2 * BB_MarginHeight(w) + w->input.label_height + 5)); argcount++;
	XtSetArg(arglist[argcount], XmNwidth, w->core.width -
		 (2 * BB_MarginWidth(w) + 90)); argcount++;
#if XDEBUG
	printf("Resize: w->input.children[DEXINPUT_TEXT]: %d\n", w->input.children[DEXINPUT_TEXT]);
#endif

	XtSetValues(w->input.children[DEXINPUT_TEXT], arglist, argcount);

	/* XmPushButton */
	argcount = 0;
	XtSetArg(arglist[argcount], XmNx, w->core.width - (BB_MarginWidth(w) + 60)); argcount++;
	XtSetArg(arglist[argcount], XmNy, BB_MarginHeight(w) + w->input.label_height + 5); argcount++;
	XtSetArg(arglist[argcount], XmNheight, (w->core.height -
		 (2 * BB_MarginHeight(w) + w->input.label_height + 5)) / 2); argcount++;
	XtSetArg(arglist[argcount], XmNwidth, 20); argcount++;
	XtSetValues(w->input.children[DEXINPUT_BUTTON_PLUS], arglist, argcount);

   	/* XmPushButton */
	argcount = 0;
	XtSetArg(arglist[argcount], XmNx, w->core.width - (BB_MarginWidth(w) + 60)); argcount++;
	XtSetArg(arglist[argcount], XmNy, (w->core.height + w->input.label_height + 5) / 2); argcount++;
	XtSetArg(arglist[argcount], XmNheight, (w->core.height -
		 (2 * BB_MarginHeight(w) + w->input.label_height + 5)) / 2); argcount++;
	XtSetArg(arglist[argcount], XmNwidth, 20); argcount++;
	XtSetValues(w->input.children[DEXINPUT_BUTTON_MINUS], arglist, argcount);
	
	/* XmPushButton */
	argcount = 0;
	XtSetArg(arglist[argcount], XmNx, w->core.width - (BB_MarginWidth(w) + 40)); argcount++;
	XtSetArg(arglist[argcount], XmNy, BB_MarginHeight(w) + w->input.label_height + 5); argcount++;
	XtSetArg(arglist[argcount], XmNheight, w->core.height -
		 (2 * BB_MarginHeight(w) + w->input.label_height + 5)); argcount++;
	XtSetArg(arglist[argcount], XmNwidth, 40); argcount++;
	XtSetValues(w->input.children[DEXINPUT_BUTTON_OK], arglist, argcount);

#ifdef DEBUG
	printf("End of Resize\n");
#endif
} 

/*============================================================================*/

static Boolean SetValues (Widget current_in, Widget request_in, 
			  Widget New_in, ArgList arg, Cardinal *num_arg)
{
	DeXInputWidget current = (DeXInputWidget)current_in;
	DeXInputWidget request = (DeXInputWidget)request_in;
	DeXInputWidget New = (DeXInputWidget)New_in;
	XmString xmstring;
	Arg arglist[10];
	double tmp_double;
	int argcount;
	char format[80], string[80];
	
#ifdef DEBUG
	printf("Set Values\n");
#endif

/* Make sure the window size is not zero. */
  	if (request->core.width == 0)
    		New->core.width = 300;
  	if (request->core.height == 0)
    		New->core.height = 80;
		
/* Make sure the increment an decimal Point values are valid */
	if (New->input.increment <= 0)
	{
    		XtWarning ("DeXInput: Increment must be greater than 0!");
    		New->input.increment = current->input.increment;
 	}
	if (New->input.decimal_point < 0)
	{
    		XtWarning ("DeXInput: Decimal Point mustn't be lower than 0!");
    		New->input.decimal_point = current->input.decimal_point;
 	}

/* Check validity of the label */
#if 0
	if(New->input.label_string == NULL)
	{
		New->input.label_string = (char *)calloc(6, sizeof(char)); 
		/* default value for the label string */
		strcpy(New->input.label_string, "Label");
	}
#endif
	if(!strlen(New->input.label_string))
	{
		/* default value for the label string */
		strcpy(New->input.label_string, "Label");
	}


#ifdef DEBUG
	printf("Current Label : %s\nRequest Label : %s\nNew Label : %s\n",
	       current->input.label_string, request->input.label_string, New->input.label_string);
	printf("Diff Current Label/New Label : %d\n", strcmp(current->input.label_string, New->input.label_string));
#endif	    
/* if the label has been modified */
	if(strcmp(current->input.label_string, New->input.label_string))
	{
/**		free(current->input.label_string); **/

		/* store in a static area the label string */
/*
		tmp_buff = (char *)calloc(strlen(New->input.label_string) + 1, sizeof(char));
*/
		strcpy(tmp_buff, New->input.label_string);
/*		New->input.label_string = tmp_buff; */

		/* change the label */
		xmstring = XmStringCreateLocalized(New->input.label_string);
		New->input.label_height = XmStringHeight(BB_LabelFontList(New), xmstring);
		argcount = 0;
		XtSetArg(arglist[argcount], XmNlabelString, xmstring); argcount++;
		XtSetValues(New->input.children[DEXINPUT_LABEL], arglist, argcount);

		XtResizeWidget(New->input.children[DEXINPUT_LABEL],
			       XmStringWidth(BB_LabelFontList(New), xmstring) + 20,
			       New->input.label_height, 0);
		XmStringFree(xmstring);
	}

/* if decimal point has changed. We loose previous values but we recompute the the current value*/
/* and the default value*/
	XtRemoveCallback( New->input.children[DEXINPUT_TEXT], XmNmodifyVerifyCallback, verify_text_cb, NULL);

	if(current->input.decimal_point != New->input.decimal_point)
	{
		New->input.nb_prev_values = 0;
		New->input.prev_values_index = 0;
		tmp_double = (double)New->input.value /
			     pow(10.0, (double)New->input.decimal_point);
			     
		/* construct the format */
		sprintf(format, "%%.%df", New->input.decimal_point);
		sprintf(string, format, tmp_double);
#if XDEBUG
		printf("Set_value: New->input.children[DEXINPUT_TEXT]: %s\n", string);
#endif
/*		
		XmTextFieldSetString(New->input.children[DEXINPUT_TEXT], "0");
		XmTextFieldSetString(New->input.children[DEXINPUT_TEXT], string);
*/
		XtVaSetValues(New->input.children[DEXINPUT_TEXT],
			      XmNvalue, string,
			      NULL);
	}

/* if value has changed */
        if(current->input.value != New->input.value)
	{
		tmp_double = (double)New->input.value /
			     pow(10.0, (double)New->input.decimal_point);
			     
		/* construct the format */
		sprintf(format, "%%.%df", New->input.decimal_point);
		sprintf(string, format, tmp_double);
#if XDEBUG
		printf("Set_value: New->input.children[DEXINPUT_TEXT]: %s\n", string);
#endif
		XtVaSetValues(New->input.children[DEXINPUT_TEXT],
			      XmNvalue, string,
			      NULL);
	}

	XtAddCallback( New->input.children[DEXINPUT_TEXT], XmNmodifyVerifyCallback, verify_text_cb, NULL);

/* if width, height or margin have been modified */
	if(New->input.label_height != current->input.label_height ||
	   BB_MarginWidth(New) != BB_MarginWidth(current)	  ||
	   BB_MarginHeight(New) != BB_MarginHeight(current)	  ||
	   New->core.width != current->core.width		  ||
	   New->core.height != current->core.height)
		Resize((Widget)New);

#ifdef DEBUG
	printf("End of Set Values\n");
#endif
	/*no expose requested*/
	return FALSE;
} 

/*
================================================================================
	Action function definition
================================================================================
*/

/*
================================================================================
	Internal callback definition
================================================================================
*/

static void verify_text_cb(Widget w, XtPointer tag, XtPointer cb)
{
	XmTextVerifyPtr verify_cb_struct;
	char *ptr, *ptr_pt;
	char *string;
	DeXInputWidget parent;
	Arg arglist[1];
	int argcount;
	int point_pos, char_pos;

#ifdef DEBUG
	printf("Verify callback\n");
#endif

	/* get back the value in the text field */
	string = (char *)XmTextFieldGetString(w);
#ifdef DEBUG
	printf("\tverify cb: %s\n",string);
#endif
	/* get back parent id */
	parent = (DeXInputWidget)XtParent(w);

	if(((XmAnyCallbackStruct *)cb)->reason == XmCR_MODIFYING_TEXT_VALUE)
	{
		verify_cb_struct = (XmTextVerifyPtr)cb;

		for(ptr = verify_cb_struct->text->ptr;
		    (int)(ptr - verify_cb_struct->text->ptr) < verify_cb_struct->text->length;
		    ptr++)
		{
			/* test if we have valid characters (0123456789+-) */
#if 0
		        if (! strchr("0123456789-+.",*ptr))
			  {
#endif
			if(!isdigit(*ptr))
			{
				if(((*ptr == '-' || *ptr == '+') &&
				    (ptr != verify_cb_struct->text->ptr ||
				     verify_cb_struct->startPos != 0))          ||
				   (*ptr == '.' && strchr(string, '.') != NULL) ||
				   (*ptr != '-' && *ptr != '+' && *ptr != '.'))
				{
					/* modification is not accepted */
#ifdef DEBUG
        printf("Verify Not a valid character: %c\n", *ptr);
	printf("Test 1 : ((*ptr == '-' || *ptr == '+') &&\n\t(ptr != verify_cb_struct->text->ptr || \
verify_cb_struct->startPos != 0)) = %s\n\
Test 2 : (*ptr == '.' && strchr(string, '.') != NULL) = %s\n\
Test 3 : (*ptr != '-' && *ptr != '+' && *ptr != '.') = %s\n",
	       ((*ptr == '-' || *ptr == '+') && (ptr != verify_cb_struct->text->ptr ||
						 verify_cb_struct->startPos != 0)) ? "True" : "False",
		(*ptr == '.' && strchr(string, '.')) ? "True" : "False",
		(*ptr != '-' && *ptr != '+' && *ptr != '.') ? "True" : "False");
#endif
					verify_cb_struct->doit = FALSE;
					XtFree(string);
#ifdef DEBUG
	printf("End of Verify callback\n");
#endif
				
					return;
				}
			}
			else	/* test if the value respect the value of decimal point */
			{
				point_pos = (ptr_pt = strchr(string, '.')) ? (int)(ptr_pt - string) : -1;
				if(point_pos >= 0)
				{
					char_pos = (int)(ptr - verify_cb_struct->text->ptr) 
					           + (int)verify_cb_struct->startPos;
					/* compare position of the inserted character with the position of the point*/
					/* and computes the number of character after the point */
					if(
					   char_pos > point_pos &&
					   ((strlen(ptr_pt) - 1) + verify_cb_struct->text->length) 
					   > parent->input.decimal_point)
					{
						/* modification is not accepted */
#ifdef DEBUG
        printf("Verify Not a valid point: char_pos %d point_pos %d\n", char_pos, point_pos);
#endif
					        verify_cb_struct->doit = FALSE;
						XtFree(string);
#ifdef DEBUG
	printf("End of Verify callback\n");
#endif
						return;
					}
				}
			}
		}

		/* modification is accepted */
		XtFree(string);
		verify_cb_struct->doit = TRUE;

		/* set changed color */
		argcount = 0;
		XtSetArg(arglist[argcount], XmNforeground, parent->manager.highlight_color); argcount++;
		XtSetValues(parent->input.children[DEXINPUT_LABEL], arglist, argcount);

	}
#ifdef DEBUG
	printf("End of Verify callback\n");
#endif
}

/*============================================================================*/

static void prev_values(Widget w, XtPointer data, XEvent *event, Boolean *cont)
{
	DeXInputWidget parent;
	double tmp_double;
	Arg arglist[1];
	int argcount;
	KeySym keysym;
	char string[80], format[80];

	/* get back parent id */
	parent = (DeXInputWidget)XtParent(w);

#ifdef DEBUG
	printf("Prev Values\n");
	printf("Index before %d: %f\n", parent->input.prev_values_index,
	       parent->input.prev_values[parent->input.prev_values_index]);
#endif

	/* get keysym */
	keysym = XKeycodeToKeysym(XtDisplay(parent), event->xkey.keycode, 0);
	
	switch(keysym)
	{
		case XK_Up:
			if(parent->input.prev_values_index > 0)
				parent->input.prev_values_index--;
			else
			{
				XBell(XtDisplay(parent), 50);
#ifdef DEBUG
        printf("Index after %d: %f\n", parent->input.prev_values_index,
	       parent->input.prev_values[parent->input.prev_values_index]);
	printf("End of Prev Values\n");
#endif
				return;
			}
			break;
#if NO_DOWN
		case XK_Down:
			if(parent->input.prev_values_index < parent->input.nb_prev_values - 1)
				parent->input.prev_values_index++;
			else
			{
				XBell(XtDisplay(parent), 50);
#ifdef DEBUG
        printf("Index after %d\n", parent->input.prev_values_index);
	printf("End of Prev Values\n");
#endif
				return;
			}
			break;
#endif
		default :
#ifdef DEBUG
        printf("Index after %d\n", parent->input.prev_values_index);
	printf("End of Prev Values\n");
#endif
			return;
			
	}

	/* construct the format */
	sprintf(format, "%%.%df", parent->input.decimal_point);

	/* set previous value */
	tmp_double = parent->input.prev_values[parent->input.prev_values_index];

	sprintf(string, format, tmp_double);
#if XDEBUG
		printf("prev_value: parent->input.children[DEXINPUT_TEXT]: %d ; chaine: %s\n", parent->input.children[DEXINPUT_TEXT], string);
#endif
	XtVaSetValues(parent->input.children[DEXINPUT_TEXT],
		      XmNvalue, string,
		      NULL);

	/* set changed color */
	argcount = 0;
	XtSetArg(arglist[argcount], XmNforeground, parent->manager.highlight_color); argcount++;
	XtSetValues(parent->input.children[DEXINPUT_LABEL], arglist, argcount);

#ifdef DEBUG
        printf("Index after %d\n", parent->input.prev_values_index);
	printf("End of Prev Values\n");
#endif

}

/*============================================================================*/

static void button_ok_cb(Widget w, XtPointer tag, XtPointer cb)
{
	char *get_string;
	Arg arglist[2];
	DeXInputWidget parent;
	double tmp_double;
	int i, argcount;
	Boolean in = FALSE;
	char string[80], format[80];

#ifdef DEBUG
	printf("Button Ok callback\n");
#endif
	/* get back parent id */
	parent = (DeXInputWidget)XtParent(w);
	
	/* get back the value in the text field */
	get_string = XmTextFieldGetString(parent->input.children[DEXINPUT_TEXT]);

#ifdef DEBUG
	printf("get_string: %s\n", get_string);
#endif

	/* check if we have a value */
	if(!(*get_string) ||
	   ((*get_string == '.' || *get_string == '+' || *get_string == '-') && strlen(get_string) == 1))
	{
		/* reset the previous value */
		XBell(XtDisplay(w), 50);
		tmp_double = (double)parent->input.value / pow(10.0, (double)parent->input.decimal_point);
		/* construct the format */
		sprintf(format, "%%.%df", parent->input.decimal_point);
		sprintf(string, format, tmp_double);
		XmTextFieldSetString(w, "0");
		XmTextFieldSetString(w, string);

		/* set normal color */
		argcount = 0;
		XtSetArg(arglist[argcount], XmNforeground, parent->manager.foreground); argcount++;
		XtSetValues(parent->input.children[DEXINPUT_LABEL], arglist, argcount);

		/* Reset position in the prev_values array */
		parent->input.prev_values_index = 0;
	}
	else	/* we have a correct value */
	{
		tmp_double = atof(get_string);
		/* search if this value is already in the roll buffer */
		for(i = 0; i < parent->input.nb_prev_values; i++)
			if(in = (parent->input.prev_values[i] == tmp_double))
				break;
		/* if not */
		if(!in)
		{
			/* roll down the buffer */
			for(i = 8; i >= 0; i--)
				parent->input.prev_values[i+1] = parent->input.prev_values[i];
			/* insert on top the New value */
				parent->input.prev_values[0] = tmp_double;
			/* there is one more value in the roll buffer */
			if(parent->input.nb_prev_values < 10 )
				parent->input.nb_prev_values++;
		}
		/* set normal color */
		argcount = 0;
		XtSetArg(arglist[argcount], XmNforeground, parent->manager.foreground); argcount++;
		XtSetValues(parent->input.children[DEXINPUT_LABEL], arglist, argcount);

		/* Reset position in the prev_values array */
		parent->input.prev_values_index = 0;

		/* set value ressource */
		parent->input.value = (int)floor(tmp_double * pow(10.0, (double)parent->input.decimal_point));
	}
	
	if (get_string)
		XtFree(get_string);

	/* construct the callback structure */
	cb_struct.reason = DEX_OK;
	cb_struct.event = ((XmAnyCallbackStruct *)cb)->event;
	cb_struct.value = parent->input.value;
	cb_struct.increment = parent->input.increment;
	cb_struct.decimal_point = parent->input.decimal_point;

	/* call ok callback */
	XtCallCallbacks((Widget)parent, DeXNokCallback, &cb_struct);
	
#ifdef DEBUG
	printf("End of Button Ok callback\n");
#endif
}

/*===========================================================================*/

static void button_default_cb(Widget w, XtPointer tag, XtPointer cb)
{
	DeXInputWidget parent;
	double tmp_double;
	Arg arglist[1];
	int argcount;
	static char string[80];
	char format[80];

#ifdef DEBUG
	printf("Button Defaul callback\n");
#endif

	/* get back parent id */
	parent = (DeXInputWidget)XtParent(w);


	XtRemoveCallback( parent->input.children[DEXINPUT_TEXT], XmNmodifyVerifyCallback, verify_text_cb, NULL);
	/* reset the default value */
	tmp_double = (double)parent->input.default_value / pow(10.0, (double)parent->input.decimal_point);
	/* construct the format */
#if DEBUG
	printf("tmp_double: %g, decimal_point: %d\n",tmp_double, parent->input.decimal_point);
#endif
	sprintf(format, "%%.%df", parent->input.decimal_point);
	sprintf(string, format, tmp_double);
#if XDEBUG
	printf("button_default_cb: parent->input.children[DEXINPUT_TEXT]: %d; chaine: %s\n", 
	       parent->input.children[DEXINPUT_TEXT], string);
#endif
#if 0
	XmTextFieldSetString(parent->input.children[DEXINPUT_TEXT], "0"); 
#if DEBUG
	printf("%s\n",string);
#endif
	XmTextFieldSetString(parent->input.children[DEXINPUT_TEXT],string);
#endif
	/* set normal color */

	XtVaSetValues(parent->input.children[DEXINPUT_LABEL],
		      XmNforeground, parent->manager.foreground,
		      NULL);

	XtVaSetValues(parent->input.children[DEXINPUT_TEXT],
		      XmNvalue, string,
		      NULL);

	XtAddCallback( parent->input.children[DEXINPUT_TEXT], XmNmodifyVerifyCallback, verify_text_cb, NULL);

	/* Reset position in the prev_values array */
	parent->input.prev_values_index = 0;

	/* set value ressource */
	parent->input.value = (int)floor(tmp_double * pow(10.0, (double)parent->input.decimal_point));

#if DEBUG
	printf("value = %d\n", parent->input.value);
#endif

	/* construct the callback structure */
	cb_struct.reason = DEX_OK;
	cb_struct.event = ((XmAnyCallbackStruct *)cb)->event;
	cb_struct.value = parent->input.value;
	cb_struct.increment = parent->input.increment;
	cb_struct.decimal_point = parent->input.decimal_point;

	/* call ok callback */
	XtCallCallbacks((Widget)parent, DeXNokCallback, &cb_struct); 


#ifdef DEBUG
	printf("End of Button Default callback\n");
#endif
}

/*
================================================================================
	Internal Event Handler definition
================================================================================
*/

static void activate_incrementation(Widget w, XtPointer data, XEvent *event, Boolean *cont)
{
	DeXInputWidget parent;
	Arg arglist[1];
	int argcount;

#ifdef DEBUG
	printf("Activate Incrementation\n");
#endif

	if(event->xbutton.button == Button1)
	{
		/* get parent id */
		parent = (DeXInputWidget)XtParent(w);

		/* remove the verify callback to optimize reponse */
		XtRemoveAllCallbacks(parent->input.children[DEXINPUT_TEXT],
				 XmNmodifyVerifyCallback);

		/* initialize the timer counter */
		parent->input.timer_count = 0;

		/* set changed color */
		argcount = 0;
		XtSetArg(arglist[argcount], XmNforeground, parent->manager.highlight_color); argcount++;
		XtSetValues(parent->input.children[DEXINPUT_LABEL], arglist, argcount);

		/* activate the time procedure */
		parent->input.which_time_proc = PLUS;
		parent->input.time_proc_id = XtAppAddTimeOut(XtWidgetToApplicationContext((Widget)w),
							     100, increment_proc, (XtPointer)parent);
	}
#ifdef DEBUG
	printf("End of Activate Incrementation\n");
#endif
}

/*============================================================================*/

static void stop_incrementation(Widget w, XtPointer data, XEvent *event, Boolean *cont)
{
	DeXInputWidget parent;

#ifdef DEBUG
	printf("Stop Incrementation\n");
#endif

	/* parent id */
	parent = (DeXInputWidget)XtParent(w);

	if(event->xbutton.button == Button1 && parent->input.which_time_proc == PLUS)
	{
		/* remove the work procedure */
		XtRemoveTimeOut(parent->input.time_proc_id);
		parent->input.which_time_proc = NONE;
		/* add the verify callback */
		XtAddCallback(parent->input.children[DEXINPUT_TEXT],
				 XmNmodifyVerifyCallback, verify_text_cb, NULL);
	}
#ifdef DEBUG
	printf("End of Stop Incrementation\n");
#endif
}

/*============================================================================*/

static void activate_decrementation(Widget w, XtPointer data, XEvent *event, Boolean *cont)
{
	DeXInputWidget parent;
	Arg arglist[1];
	int argcount;

#ifdef DEBUG
	printf("Activate Decrementation\n");
#endif
	if(event->xbutton.button == Button1)
	{
		/* get parent id */
		parent = (DeXInputWidget)XtParent(w);

		/* remove the verify callback to optimize reponse */
		XtRemoveAllCallbacks(parent->input.children[DEXINPUT_TEXT],
				 XmNmodifyVerifyCallback);

		/* initialize the timer counter */
		parent->input.timer_count = 0;

		/* set changed color */
		argcount = 0;
		XtSetArg(arglist[argcount], XmNforeground, parent->manager.highlight_color); argcount++;
		XtSetValues(parent->input.children[DEXINPUT_LABEL], arglist, argcount);

		/* activate the time procedure */
		parent->input.which_time_proc = MINUS;
		parent->input.time_proc_id = XtAppAddTimeOut(XtWidgetToApplicationContext((Widget)w),
							     100, decrement_proc, (XtPointer)parent);
	}
#ifdef DEBUG
	printf("End of Activate Decrementation\n");
#endif

}

/*============================================================================*/

static void stop_decrementation(Widget w, XtPointer data, XEvent *event, Boolean *cont)
{
	DeXInputWidget parent;

#ifdef DEBUG
	printf("Stop Decrementation\n");
#endif
	/* parent id */
	parent = (DeXInputWidget)XtParent(w);

	if(event->xbutton.button == Button1 && parent->input.which_time_proc == MINUS)
	{
		/* remove the work procedure */
		XtRemoveTimeOut(parent->input.time_proc_id);
		parent->input.which_time_proc = NONE;
		/* add the verify callback */
		XtAddCallback(parent->input.children[DEXINPUT_TEXT],
				 XmNmodifyVerifyCallback, verify_text_cb, NULL);
	}
#ifdef DEBUG
	printf("End of Stop Decrementation\n");
#endif
}

/*
================================================================================
	Internal time Procedure definition
================================================================================
*/

static void increment_proc(XtPointer w_in, XtIntervalId *timer)
{
	DeXInputWidget w = (DeXInputWidget)w_in;
	char *get_string;
	double tmp_double;
	unsigned long time = 100;
	char string[80], format[80];
	
#ifdef DEBUG
	printf("Incrementation\n");
#endif

	/* get back the previous value */
	get_string = (char *)XmTextFieldGetString(w->input.children[DEXINPUT_TEXT]);
	tmp_double = atof(get_string);
	XtFree(get_string);
	
	if(w->input.timer_count < 10)
		tmp_double += (double)w->input.increment /
			     pow(10.0, (double)w->input.decimal_point);
	else if(w->input.timer_count >= 10 && w->input.timer_count < 20)
		tmp_double += (double)(5 * w->input.increment ) /
			     pow(10.0, (double)w->input.decimal_point);
	else if(w->input.timer_count >= 20 && w->input.timer_count < 40)
		tmp_double += (double)(10 * w->input.increment ) /
			     pow(10.0, (double)w->input.decimal_point);
	else if(w->input.timer_count >= 40 && w->input.timer_count < 70)
	{
		tmp_double += (double)(100 * w->input.increment ) /
			     pow(10.0, (double)w->input.decimal_point);
		time = 50;
	}
	else if(w->input.timer_count >= 70)
	{
		tmp_double += (double)(100 * w->input.increment ) /
			     pow(10.0, (double)w->input.decimal_point);
		time = 10;
	}
			     
	/* construct the format */
	sprintf(format, "%%.%df", w->input.decimal_point);
	sprintf(string, format, tmp_double);
	XmTextFieldSetString(w->input.children[DEXINPUT_TEXT], string);

	/* one more call */
	w->input.timer_count++;
	
	/* reactivate the time procedure */
	w->input.time_proc_id = XtAppAddTimeOut(XtWidgetToApplicationContext((Widget)w),
		   			        time, increment_proc, w);
#ifdef DEBUG
	printf("End of Incrementation\n");
#endif
}

/*============================================================================*/

static void decrement_proc(XtPointer w_in, XtIntervalId *timer)
{
	DeXInputWidget w = (DeXInputWidget)w_in;
	char *get_string;
	double tmp_double;
	unsigned long time = 100;
	char string[80], format[80];
	
#ifdef DEBUG
	printf("Decrementation\n");
#endif
	/* get back the previous value */
	get_string = (char *)XmTextFieldGetString(w->input.children[DEXINPUT_TEXT]);
	tmp_double = atof(get_string);
	XtFree(get_string);

	if(w->input.timer_count < 10)
		tmp_double -= (double)( w->input.increment ) /
			     pow(10.0, (double)w->input.decimal_point);
	else if(w->input.timer_count >= 10 && w->input.timer_count < 20)
		tmp_double -= (double)( 5 * w->input.increment ) /
			     pow(10.0, (double)w->input.decimal_point);
	else if(w->input.timer_count >= 20 && w->input.timer_count < 40)
		tmp_double -= (double)( 10 * w->input.increment ) /
			     pow(10.0, (double)w->input.decimal_point);
	else if(w->input.timer_count >= 40 && w->input.timer_count < 70)
	{
		tmp_double -= (double)( 100 * w->input.increment ) /
			     pow(10.0, (double)w->input.decimal_point);
		time = 50;
	}
	else if(w->input.timer_count >= 70)
	{
		tmp_double -= (double)( 100 * w->input.increment ) /
			     pow(10.0, (double)w->input.decimal_point);
		time = 10;
	}
			     
	/* construct the format */
	sprintf(format, "%%.%df", w->input.decimal_point);
	sprintf(string, format, tmp_double);
	XmTextFieldSetString(w->input.children[DEXINPUT_TEXT], string);
	
	/* one more call */
	w->input.timer_count++;
	
	/* reactivate the time procedure */
	w->input.time_proc_id = XtAppAddTimeOut(XtWidgetToApplicationContext((Widget)w),
		   			        time, decrement_proc, w);
#ifdef DEBUG
	printf("End of Decrementation\n");
#endif

}

/*
================================================================================
	Convenience functions
================================================================================
*/
Widget DeXCreateInput (Widget parent, char *name,
		       ArgList arglist, Cardinal argcount)
{
	return ( XtCreateWidget(name, DeXinputWidgetClass, parent, arglist,
				argcount));
}
