/*
================================================================================
	D e X I n p u t . h
================================================================================

	Public header file for DeXInput widget.

	Author : Denis LAMBOLEZ
		 b3e CHU ST-ANTOINE, FRANCE

	History: 
		 - Version 1.0: January 1994
		   January, 3th 1994: Creation from DeXDial.h
================================================================================
*/

#ifndef  DeXInput_h
#define  DeXInput_h

typedef struct _DeXInputClassRec* DeXInputWidgetClass;
typedef struct _DeXInputRec*      DeXInputWidget;

/*
================================================================================
 Callback structure for the DeXInput widget.
================================================================================
*/

typedef struct _DeXInputCallbackStruct
{
  	unsigned long	reason;
  	XEvent		*event;
  	int		value;
	int		increment;
	int		decimal_point;
} DeXinputCallbackStruct;

/*
================================================================================
 Define resource strings for the DeXInput widget.
================================================================================
*/
#define DeXNokCallback   "okCallback"
#define DeXNincrement    "increment"
#define DeXNvalue        "value"
#define DeXNdefaultValue "defaultValue"
#define DeXNdecimalPoint "decimalPoint"
#define DeXNlabelString  "labelString"
 
#define DeXCOkCallback   "OkCallback"
#define DeXCIncrement    "Increment"
#define DeXCValue        "Value"
#define DeXCDefaultValue "DefaultValue"
#define DeXCDecimalPoint "DecimalPoint"
#define DeXCLabelString  "LabelString"

#define DEX_OK  1 /*reason*/

/*
================================================================================
 Convenience functions
================================================================================
*/
#ifdef c__plusplus  /* for vms cxx */
#define __cplusplus c__plusplus
#endif
#ifdef __cplusplus
extern "C"{
#endif
extern WidgetClass DeXinputWidgetClass;

Widget DeXCreateInput (Widget,char*,ArgList,Cardinal);
#ifdef __cplusplus
}
#endif


#ifdef OCI
OCiBindDeXInput();
#endif


#endif /*DeXInput_h*/
