/*
================================================================================
	D e X D D i a l . h
================================================================================

	Public header file for DeXDDial widget.

	Author : Jean-Francois VIBERT a partir de DeXDial de Denis Lambolez
		 b3e CHU ST-ANTOINE

	Author : Denis LAMBOLEZ et Jean-Francois VIBERT
		 b3e CHU ST-ANTOINE

	History: 
		 - Version 1.0: Septembre 1994
		   September, 5th 1994: Creation from DeXDial.c (Denis Lambolez et JFV)
		   September, 21th 1994: Creation from DeXDialScale.c (et JFV)

================================================================================
*/

#ifndef  DeXDDial_h
#define  DeXDDial_h

#ifndef ONO_X_H
#include <X11/Intrinsic.h>
#endif

#include <DeXInput.h>

typedef struct _DeXDDialClassRec* DeXDDialWidgetClass;
typedef struct _DeXDDialRec*      DeXDDialWidget;

/*
================================================================================
 Callback structure for the DeXDDial widget.
================================================================================
*/

typedef struct _DeXDDialCallbackStruct
{
  	unsigned long reason;
  	XEvent *event;
	double converted_value;
	long  value;
	int decimal_point;
} DeXdDialCallbackStruct;

/*
================================================================================
 Define resource strings for the DeXDDial widget.
================================================================================
*/

/* Deja definis dans DeXInput.h */

/*
#define DeXNdefaultValue	 "defaultValue"
#define DeXNincrement		 "increment"
#define DeXNvalue	 	 "value"
#define DeXNdecimalPoint 	 "decimalPoint"
#define DeXNlabelString		 "labelString"
*/

#define DeXNvalueChangedCallback "valueChangedCallback"
#define DeXNdragCallback	 "dragCallback"
#define DeXNminimum        	 "minimum"
#define DeXNmaximum        	 "maximum"
#define DeXNmarkersNumber	 "markersNumber"
#define DeXNturnStep		 "turnStep"
#define DeXNchangeTurn		 "changeTurn"
#define DeXNindicatorColor	 "indicatorColor"

/* Deja definis dans DeXInput.h */

/*
#define DeXCDefaultValue	 "DefaultValue"
#define DeXCIncrement		 "Increment"
#define DeXCValue	 	 "Value"
#define DeXCDecimalPoint 	 "DecimalPoint"
#define DeXCLabelString		 "LabelString"
*/

#define DeXCValueChangedCallback "ValueChangedCallback"
#define DeXCDragCallback	 "DragCallback"
#define DeXCMinimum        	 "Minimum"
#define DeXCMaximum        	 "Maximum"
#define DeXCMarkersNumber	 "MarkersNumber"
#define DeXCTurnStep		 "TurnStep"
#define DeXCChangeTurn		 "ChangeTurn"
#define DeXCIndicatorColor	 "IndicatorColor"

#define DEX_VALUE_CHANGED  1 /*reason*/
#define DEX_DRAG	   2

#ifdef c__plusplus  /* for vms cxx */
#define __cplusplus c__plusplus
#endif
#ifdef __cplusplus
extern "C"{
#endif
extern WidgetClass DeXdDialWidgetClass;
#ifdef __cplusplus
}
#endif


#ifdef OCI
OCiBindDeXDDial();
#endif


#endif /*DeXDDial_h*/
