#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- 5 modifications in this file -------------*/

#endif

/* ---------------------------------------------------------
			G_DESSIN.C
   ---------------------------------------------------------*/
#include <stdio.h>
#include <math.h>


#undef MAIN
#include "G_neuron.h"
#include "G_synap.h"
#include "G_interface.h"
#include "G_reference.h"
#include "G_dessin.h"

#ifndef PI
#    define PI              3.1415926535
#endif



#ifndef TRUE
#	define TRUE	1
#endif

#ifndef FALSE
#	define FALSE	0
#endif

#define MAX_TIME	200
#define SPIKE_TOP       20.

extern	int		NOIR,
			ROUGE,
			BLEU,
			VERT,
			VIOLET,
			MAUVE,
			TURQ,
			JAUNE;

extern	Window		root_window;
extern	Display		*disp;
extern	Widget		Drawing_A1,
			Drawing_A2,
			Drawing_A3;
extern	REFERENCE	ref1,
			ref2,
			ref3;

extern	float   reference1_max, reference1_min,
		reference2_max_p, reference2_min_p,
		reference3_max_p, reference3_min_p,
		reference2_max_g, reference2_min_g,
		reference3_max_g, reference3_min_g;


extern  file_saved;			
extern  void trier_tab(void );

void dessine_detection(float *, int, REFERENCE *);
void dessine_equil(float *, int, REFERENCE *);

void ajouter_spikes(int position)
{
  int i;

  realloc_mem_tab_tempo(nb_spikes );
  for (i=0;i<nb_spikes;i++)
    {
      tab_tempo[i].t_arrivee = tab_syn[i].t_arrivee;
      tab_tempo[i].weight = tab_syn[i].weight;
    }

  nb_spikes++;
  taille_tab_syn=nb_spikes;

  realloc_mem_tab_syn(nb_spikes );
  for (i=0;i<nb_spikes;i++)
    {
      if (i==(nb_spikes-1)) 
	{	
	  tab_syn[i].t_arrivee = (float )((position-2.)*time_step-2.)+delai_recurrence;
	  tab_syn[i].weight = (float ) ponderation_recurrence;
	}
      else
	{
	  tab_syn[i].t_arrivee = tab_tempo[i].t_arrivee;
	  tab_syn[i].weight = tab_tempo[i].weight;
	}
    }
  trier_tab();   

}

/*--------------------------------------------------------------------
 *      c a l c u l _ n e u r o n _ c o n d u c t
 *------------------------------------------------------------------*/
/************************************************

   neurone a conductance
   permet de calculer les valeurs des parametres d'un neurone
   grace a la fonction update_r_k ou update_expon contenue dans le fichier
   G_equation.c	

***************************************************/

void calcul_neuron_conduct(void)
{
	float	Ca_i_t = Ca_i;	/* variable tampon pour retrouver la meme
				   concenration en calcium a la fin de la simulation */
	float	alpha, beta;	/* variables intermediaires */
	float	m_value;
	float	h_value;
	int	i, 
                deb_stim, fin_stim;
	int     previous_spike;
	int     inter_spike;
	int     started;

	if (flag_Tms_Input)
	  trier_tab();   

	if(flag_no_update)
		return;

	XDefineCursor(disp, XtWindow(top_levelG), wait_cursor);
	if (Top_Level_Conductance)
	  XDefineCursor(disp, XtWindow(Top_Level_Conductance), wait_cursor);
	if (Top_Level_Phenom)
	  XDefineCursor(disp, XtWindow(Top_Level_Phenom), wait_cursor);
	XFlush(disp);

	if (!flag_spike_detect) spike_slope = 10000.;
	else spike_slope = 20.;
		
	spike = FALSE;

	input_current = input_fact;

	/* reprise des valeurs initiales */

#ifdef ADD_CURRENT

/*--------   To add a current modify and adapt   -------*/   

/*-------------- Check if you need to initialize 
      some values related to you new current -------------*/
	h_New = h_New_init;
	m_New = m_New_init;
#endif
/*
	le_potentiel_E_Na = le_potentiel_E_Na_init;
	le_potentiel_E_K = le_potentiel_E_K_init;
*/	
	reactualise_E_Na_K();
	le_potentiel_E_Na = E_Na;
	le_potentiel_E_K = E_K;

	m_ahp = m_ahp_init;
	m_K = m_K_init;
	h_Na = h_Na_init;
	rest_pot = le_potentiel = le_potentiel_init = E_Goldman;
	m_Ca = m_Ca_init;
	Ca_i = Ca_i_init;
	h_A = h_A_init;
	m_Nap = m_Nap_init;
	m_Cab = m_Cab_init;
	m_Ih = m_Ih_init;
	h_Cab = h_Cab_init;
	K_rest = 2.5;

	m_M = 1. / (1. + (exp ((E_fuite + V_Im) * A_Im)));

	if((Ca_i == 0.0001) || (E_fuite < -32.))
		m_C = 0.;
	else
		m_C = (250. * Ca_i * exp (E_fuite/24.)) /
			((250. * Ca_i * exp (E_fuite/24.)) +
			(0.1 * exp (E_fuite/(-24.))));


	if (integration_type == RUNGE_KUTTA || integration_type == EULER)
	{
		/* initialisation du tableau pour le runge_kutta */

	  neur_param_avant[d_V] = rest_pot;
	  neur_param_avant[d_m_K] = m_K;
	  neur_param_avant[d_m_Ca] = m_Ca;
	  neur_param_avant[d_h_A] = h_A;
	  neur_param_avant[d_m_M] = m_M;
	  neur_param_avant[d_m_C] = m_C;
	  neur_param_avant[d_m_Ih] = m_Ih;
	  neur_param_avant[d_m_Nap] = m_Nap;
	  neur_param_avant[d_m_Cab] = m_Cab;
	  neur_param_avant[d_h_Cab] = h_Cab;
	  neur_param_avant[d_Ca_i] = Ca_i;

	  neur_param_avant[d_K_ext]  = K_ext;
#ifdef ADD_CURRENT
/*--------   To add a current modify and adapt   -------*/   

/*-------------- Check if you need to initialize 
      some values related to you new current -------------*/
	  neur_param_avant[d_h_New] = h_New;
	  neur_param_avant[d_m_New] = m_New;
#endif
	}



	if (voltage_clamp)
	{
		potentiel[0] = le_potentiel = clamp_pot;
		
	} 
	else
	{
		potentiel[0] = le_potentiel = le_potentiel_init;
		ramp_input[0] = -80.;
		courant_global[0] = 0.;
		courant_K[0]= 0.;
		courant_Na[0]= 0.;
		courant_Ia[0]= 0.;
		courant_Im[0]= 0.;
		courant_Iahp[0]= 0.;
		courant_Ic[0]= 0.;
		courant_Nap[0]= 0.;
		courant_Cab[0]= 0.;
		courant_Ca[0]= 0.;
		les_intervalles[0]= 0.;
		l_histogramme[0]= 0.;
#ifdef ADD_CURRENT

/*--------   To add a current modify and adapt   -------*/   

		courant_New[0]= 0.;
#endif
/*
		potentiel_E_Na[0] =le_potentiel_E_Na_init;
		potentiel_E_K[0] =le_potentiel_E_K_init;
*/
		potentiel_E_Na[0] = E_Na;
		potentiel_E_K[0] = E_K;

		valeur_m[0]= 0.;
		valeur_h[0]= 0.;

		synaptique[0]= 0.;
		Ca[0]= 0.;
		les_spikes[0] = 100.;
	}

/*	table_size = (int)((float) duree_simul / time_step); */

	m_value = 0.;
	h_value = 0.;
	input_current = 0.;
	input_voltage = 0.;
	deb_stim = (float)debut_stim / time_step;
	fin_stim = (float)(debut_stim + duree_stim)/time_step;
	g_tot = 0.00000001; /* to avoid div by 0 */

	if (!flag_Tms_Input) nb_spikes = nb_connexions;
	else nb_spikes = number_of_event;

	started = 0;
	previous_spike = 0;

	for (i = 0; i < nb_receptors; i++)
	{
	        Receptors[i].tau_a_psp = Receptors[i].tau_attack / time_step;
	        Receptors[i].tau_d_psp = Receptors[i].tau_decay / time_step;
	}

	for (i = 1; i < table_size; i++)
	{

	        /*---     calcul de l'input       --------*/

		if ((i >= deb_stim)  &&
		    (i < fin_stim))
		{
		      input_current = input_fact;
		      input_voltage =  input_volt + input_current / g_tot;
		} /* fin du if */
		else
		{
		      input_current = input_voltage = 0.;
		} /* fin du if */


		(*update_neurone)(i);

		if (la_spike)
		{
		  if (started)
		  {
		    inter_spike = i - previous_spike;
		    previous_spike = i;
		    started = TRUE;
		  }
		}

		if (set_g_Na)
		{
			m_value = m_Na;
			h_value = ((model_type == HH_SIMPLE_MODEL)? h_Na: 0.);
		} /* fin du if */
		else if (set_g_K)
		{
			m_value = m_K;
			h_value = 0.;
		} /* fin du if */
		else if (set_g_Nap)
		{
			m_value = m_Nap;
			h_value = 0.;
		} /* fin du if */
 		else if (set_g_M)
		{
			m_value = m_M;
			h_value = 0.;
		} /* fin du  if */
 		else if (set_g_A)
		{
			m_value = m_A;
			h_value = h_A;
		} /* fin du  if */
 		else if (set_g_C)
		{
			m_value = m_C;
			h_value = 0.;
		} /* fin du  if */
 		else if (set_g_ahp)
		{
			m_value = m_ahp;
			h_value = 0.;
		} /* fin du  if */
 		else if (set_g_H)
		{
			m_value = m_Ih;
			h_value = 0.;
		} /* fin du  if */
    	else if (set_g_Ca)
		{
			m_value = m_Ca;
			h_value = h_Ca;
		} /* fin du  if */
 		else if (set_g_Cab)
		{
			m_value = m_Cab;
			h_value = h_Cab;
		} /* fin du  if */
#if 0
		else if (set_g_NMDA)
		{
			m_value = m_NMDA;
			h_value = h_NMDA;
		} /* fin du  if */
#endif

		if (la_spike)
		  * ( l_histogramme + i)  = (int)((float)inter_spike * time_step);     /* les interspikes intervals */
		else
		  * ( l_histogramme + i)  = * (les_intervalles + (i-1));

		if (la_spike)
		  * ( les_intervalles + i)  = (int)((float)inter_spike * time_step);     /* les interspikes intervals */
		else
		  * ( les_intervalles + i)  = 0;

		* ( potentiel + i)       =  le_potentiel;
		* ( ramp_input + i)      = (input_current) + ramp_input[0];
		* ( courant_global + i)  = -(courant_tot);
		* ( courant_K + i)       = ( I_K       * .01);
		* ( courant_Na + i)      = ( I_Na      * .01);
		* ( courant_Ia + i)      = ( I_A       * .01);
		* ( courant_Im + i)      = ( I_M       * .01);
		* ( courant_Iahp + i)    = ( I_ahp     * .01);
		* ( courant_Ca + i)      = ( I_Ca      * .01);
		* ( courant_Nap + i)     = ( I_Nap     * .01);
		* ( courant_Cab + i)     = ( I_Cab     * .01);
		* ( courant_Ic + i)      = ( I_C       * .01);
#ifdef ADD_CURRENT

/*--------   To add a current modify and adapt   -------*/   

		* ( courant_New + i)     = ( I_New     * .01);
#endif
		* ( potentiel_E_Na + i)  = ( E_Na);
		* ( potentiel_E_K + i)   = ( E_K);

		* ( valeur_m + i) 	 = ( m_value   );
		* ( valeur_h + i) 	 = ( h_value   );

		* ( synaptique + i)      = ( I_Syn_pos  * .01);
		* ( Ca + i)              = Ca_i * 5.;
		* ( les_spikes + i)      = la_spike; 
	        if (la_spike && recurrentEPSP) ajouter_spikes(i); 
	      
	      } /* fin du for */

	Ca_i = Ca_i_t;
	
	if (flag_Tms_Output) save_currentstms();
	  
	file_saved = FALSE;

#if DEBUG
	for (i=0;i<taille_tab_syn;i++)
	    {
	      printf("tab syn[%d]: %f\t%f\t%d\n",i,tab_syn[i].t_arrivee,tab_syn[i].weight,tab_syn[i].transmetteur);
	    }
	  printf("\n");
#endif
}

/*--------------------------------------------------------------------
 *      d r a w _ n e u r o n _ c o n d u c t 
 *------------------------------------------------------------------*/
/* 
   neurone a conductance

   permet de dessiner les axes des 3 reperes et les differents
   parametres d'un neurone sur les 3 aires de dessin prevues 
   selon num, on dessine les 3 dessins (num=0)
   ou seulement la dessin 1, 2 ou 3
*/

void	draw_neuron_conduct (int num)
{
  
  
  int	flag[4];
  
  
  if (flag_no_update || (num > 3))
    return;
  
  if (num == 0)
    {
      flag[1] = 1;
      flag[2] = 2;
      flag[3] = 3;
    }
  else
    {
      flag[num] = num;
      flag[(num+1)%4] = 0;
      flag[(num+2)%4] = 0;
      flag[(num+3)%4] = 0;
    }
  
  /* initialisation des variables ref1, ref2, ref3 de type
     reference, et trace des axes				*/
  
  /*--- Dessin 1 -----------------------------------------------------*/
  
  if (flag[1])
    {
      ref1.window = XtWindow (Drawing_A1);
      
      if (!ref1.gc)
	ref1.gc = XCreateGC (disp, root_window,
			     0, NULL);
      ref1.lower_x = 0.;
      ref1.upper_x = (float) duree_simul;
      ref1.grad_x = 10.;
      ref1.lower_y =reference1_min;
      ref1.upper_y =reference1_max;
      ref1.grad_y = 20.;
      ref1.decimals_x = 0;
      ref1.decimals_y = 0;
      ref1.identificateur = 1;
      
      if (!draw_reference (disp, &ref1))
	{
	  return;
	}
    }
  
  /*--- Dessin 2 -----------------------------------------------------*/
  
  
  
  
  if (flag[2])
    {
      ref2.window = XtWindow (Drawing_A2);
      if (!ref2.gc)
	ref2.gc = XCreateGC (disp, root_window,
			     0, NULL);
      ref2.lower_x = 0;
      ref2.upper_x = (float)duree_simul;
      ref2.grad_x = 10.;
      ref2.lower_y = reference2_min_g;     /*reference2.lower_y;*/
      ref2.upper_y = reference2_max_g;      /*reference2.upper_y;*/
      ref2.grad_y = 1.;
      ref2.decimals_x = 0;
      ref2.decimals_y = 1;
      ref2.identificateur = 2;
      
      if (!draw_reference (disp, &ref2))
	{
	  return;
	}
    }
  
  /*--- Dessin 3 -----------------------------------------------------*/
  
  if (flag[3])
    {
      ref3.window = XtWindow (Drawing_A3);
      if (!ref3.gc)
	ref3.gc = XCreateGC (disp, root_window,
			     0, NULL);
      ref3.lower_x = 0.;
      ref3.upper_x = (float)duree_simul;
      ref3.grad_x = 10.;
      ref3.lower_y = reference3_min_g;  /*reference3.lower_y;*/
      ref3.upper_y = reference3_max_g;   /*reference3.upper_y;*/
      ref3.grad_y = 0.2;
      ref3.decimals_x = 0;
      ref3.decimals_y = 2;
      ref3.identificateur = 3;
      
      if (!draw_reference (disp, &ref3))
	{
	  return;
	}
    }
  
  /*---- fin partie dessin axes --------------------------------------*/
  
     switch(num)
     {
     case 0 :
       {
	 dessine (potentiel, NOIR, &ref1);
	 dessine (ramp_input, TURQ, &ref1);
	 dessine_detection (les_spikes, VIOLET, &ref1);
	 
	 if (voltage_clamp)
	   dessine (courant_global, VERT, &ref1);
	 
	 dessine_equil (potentiel_E_Na,ROUGE , &ref1);
	 dessine_equil (potentiel_E_K ,BLEU  , &ref1);
	 dessine_pot_rev();
	 if (draw_currents)
	 {
		 dessine (courant_K, BLEU, &ref2);
		 dessine (courant_Na, ROUGE,&ref2);
		 dessine (courant_Ic,JAUNE, &ref2);
		 
		 dessine (courant_Ia, VERT, &ref3);
		 dessine (courant_Im, VIOLET, &ref3);
		 dessine (courant_Iahp,TURQ, &ref3);
		 dessine (courant_Ca, MAUVE, &ref3);
	 } /* fin du if */
	 dessine (l_histogramme, MAUVE,&ref2);
	 dessine_dots (les_intervalles, NOIR, &ref3);

	 break;
       }
     case 1 :
       {
	 if (flag[1])
	   {
	     dessine (potentiel, NOIR, &ref1);
	     dessine (ramp_input,TURQ,&ref1);
	     
	     dessine_detection (les_spikes, VIOLET, &ref1);
	     if (voltage_clamp)
	       dessine (courant_global, VERT, &ref1);
	     dessine_pot_rev();
	   }
	 break;
       }
     case 2 :
       {
	 if (flag[2])
	   {
		 if (draw_currents)
		 {
		     dessine (courant_K, BLEU, &ref2);
		     dessine (courant_Na, ROUGE, &ref2);
		     dessine (courant_Ic, JAUNE, &ref2);
		     dessine(courant_Iahp, VERT, &ref2);
		     dessine (courant_Nap, TURQ, &ref2);
		 }
	   }
	 break;
       }
     case 3 :
       {
	 if (flag[3])
	   {
		 if (draw_currents)
		 {
		     dessine(courant_Ia, VERT, &ref3);
		     dessine(courant_Im, VIOLET, &ref3);
		     dessine (courant_Ca, MAUVE, &ref3);
		     dessine (courant_Cab, ROUGE, &ref3);
		     dessine(Ca, TURQ, &ref3);
		 
#ifdef ADD_CURRENT
		     
		     /*--------   To add a current modify and adapt   -------*/
		     /*- ATTENTION: Check if the place is OK (ref2 or ref3) -*/
		     /*--------  ATTENTION: Check if the color is OK --------*/
		     
		     dessine (courant_New, BLEU, &ref3);
#endif
		 }
	   }
	 break;
       }
       
     }

	XUndefineCursor(disp, XtWindow(top_levelG));
	if (Top_Level_Conductance)
	  XUndefineCursor(disp, XtWindow(Top_Level_Conductance));
	if (Top_Level_Phenom)
	  XUndefineCursor(disp, XtWindow(Top_Level_Phenom));
     
     
}

/*--------------------------------------------------------------------
 *      c a l c u l _ n e u r o n _ p h e n o m 
 *------------------------------------------------------------------*/
/***************************************************

   neurone phenomenologique

   permet de calculer les valeurs des parametres d'un neurone
   grace a la fonction update_xnbc ou update_leaky, etc. contenue dans le fichier
   G_equation_phenom.c	

*******************************************************/


void calcul_neuron_phenom(void)
{
	float	alpha, beta;	/* variables intermediaires */
	float	m_value;
	float	h_value;
	int     previous_spike;
	int	i; 
        int     deb_stim, fin_stim;
	int     inter_spike;
	int     started;
	


	if (flag_Tms_Input)
	  trier_tab();   

	if(flag_no_update)
		return;

	XDefineCursor(disp, XtWindow(top_levelG), wait_cursor);
	if (Top_Level_Conductance)
	  XDefineCursor(disp, XtWindow(Top_Level_Conductance), wait_cursor);
	if (Top_Level_Phenom)
	  XDefineCursor(disp, XtWindow(Top_Level_Phenom), wait_cursor);
	XFlush(disp);

	if (!flag_spike_detect) spike_slope = 10000.;
	else spike_slope = 20.;
		
	spike = FALSE;

	decharge_lag = 32000. / time_step;
	soma = le_potentiel = p_rest_pot; 

	overshoot = pot_post_spike -  p_rest_pot;
	if (model_type ==  LEAKY_INTEG_MODEL)
	  soma_post_spike = pot_post_spike;
	else
	  soma_post_spike = soma + overshoot;

	i_tau_mb_pot = 1. / tau_mb_pot;
	i_tau_seuil = 1./ tau_seuil;

	threshold = seuil;
	seuil_peak =  seuil_post_spike +  seuil;
	delta_seuil = seuil_post_spike;

	input_current = 0.;
	input_voltage = 0.;
	deb_stim = (float)debut_stim / time_step;
	fin_stim = (float)(debut_stim + duree_stim)/time_step;

	/* reprise des valeurs initiales */


	le_potentiel_E_Na = le_potentiel_E_Na_init;
	le_potentiel_E_K = le_potentiel_E_K_init;
	
	potentiel[0] = p_rest_pot;
	ramp_input[0] = -80.;
	le_seuil[0] = seuil;
	les_intervalles[0]= 0.;
	l_histogramme[0]= 0.;


	potentiel_E_Na[0] =le_potentiel_E_Na_init;
	potentiel_E_K[0] =le_potentiel_E_K_init;

	synaptique[0]= 0.;

	les_spikes[0] = 100.;


/*
	table_size = (int)((float) duree_simul / time_step); 

	printf("Input_fact %f Decharge_lag %f\n",input_fact, decharge_lag);
*/

	if (!flag_Tms_Input) nb_spikes = nb_connexions;
	else nb_spikes = number_of_event;

	for (i = 0; i < nb_receptors; i++)
	{
	        Receptors[i].tau_a_psp = Receptors[i].tau_attack / time_step;
	        Receptors[i].tau_d_psp = Receptors[i].tau_decay / time_step;
	}
	
	previous_spike = 0;

	for (i = 1; i < table_size; i++)
	{

	        /*---     calcul de l'input       --------*/

		if ((i >= deb_stim)  &&
		    (i < fin_stim))
		{
		      input_voltage  = input_fact;
		} /* fin du if */
		else
		{
		      input_voltage = 0.;
		} /* fin du if */


		(*update_neurone)(i);

		if (la_spike)
		{
		  if (started)
		  {
		    inter_spike = i - previous_spike;
		    previous_spike = i;
		    started = TRUE;
		  }
		}

		if (le_potentiel == pot_post_spike)
		{
		  * ( potentiel + (i-1)) = * ( le_seuil + (i-1))  = threshold  ;
		}
		* ( potentiel + i)       =  le_potentiel;
		* ( ramp_input + i)      = (input_voltage) + ramp_input[0];

		* ( le_seuil + i)       =  threshold ;

		if (la_spike)
		  * ( l_histogramme + i)  = (int)((float)inter_spike * time_step);     /* les interspikes intervals */
		else
		  * ( l_histogramme + i)  = * (les_intervalles + (i-1));

		if (la_spike)
		  * ( les_intervalles + i)  = (int)((float)inter_spike * time_step);     /* les interspikes intervals */
		else
		  * ( les_intervalles + i)  = 0;


		* ( potentiel_E_Na + i)  = ( E_Na);
		* ( potentiel_E_K + i)   = ( E_K);


	        if (la_spike && recurrentEPSP) ajouter_spikes(i); 
	      
	      } /* fin du for */

	
	if (flag_Tms_Output) save_currentstms();
	  
	file_saved = FALSE;

#if DEBUG_V8
	for (i=0;i<taille_tab_syn;i++)
	    {
	      printf("tab syn[%d]: %f\t%f\t%d\n",i,tab_syn[i].t_arrivee,tab_syn[i].weight,tab_syn[i].transmetteur);
	    }
	  printf("\n");
#endif
}


/*--------------------------------------------------------------------
 *      d r a w _ n e u r o n _ p h e n o m 
 *------------------------------------------------------------------*/
/* 
   neurone phenomenologique

   permet de dessiner les axes des 3 reperes et les differents
   parametres d'un neurone sur les 3 aires de dessin prevues 
   selon num, on dessine les 3 dessins (num=0)
   ou seulement la dessin 1, 2 ou 3
*/

void	draw_neuron_phenom (int num)
{
  
  
  int	flag[4];
  
  
  if (flag_no_update || (num > 3))
    return;
  
  if (num == 0)
    {
      flag[1] = 1;
      flag[2] = 2;
      flag[3] = 3;
    }
  else
    {
      flag[num] = num;
      flag[(num+1)%4] = 0;
      flag[(num+2)%4] = 0;
      flag[(num+3)%4] = 0;
    }
  
  /* initialisation des variables ref1, ref2, ref3 de type
     reference, et trace des axes				*/
  
  /*--- Dessin 1 -----------------------------------------------------*/
  
  if (flag[1])
    {
      ref1.window = XtWindow (Drawing_A1);
      
      if (!ref1.gc)
	ref1.gc = XCreateGC (disp, root_window,
			     0, NULL);
      ref1.lower_x = 0.;
      ref1.upper_x = (float) duree_simul;
      ref1.grad_x = 10.;
      ref1.lower_y =reference1_min;
      ref1.upper_y =reference1_max;
      ref1.grad_y = 20.;
      ref1.decimals_x = 0;
      ref1.decimals_y = 0;
      ref1.identificateur = 1;
      
      if (!draw_reference (disp, &ref1))
	{
	  return;
	}
    }
  
  /*--- Dessin 2 -----------------------------------------------------*/
  
  
  
  
  if (flag[2])
    {
      ref2.window = XtWindow (Drawing_A2);
      if (!ref2.gc)
	ref2.gc = XCreateGC (disp, root_window,
			     0, NULL);
      ref2.lower_x = 0;
      ref2.upper_x = (float)duree_simul;
      ref2.grad_x = 10.;
      ref2.lower_y = reference2_min_p;     /*reference2.lower_y;*/
      ref2.upper_y = reference2_max_p;      /*reference2.upper_y;*/
      ref2.grad_y = 1.;
      ref2.decimals_x = 0;
      ref2.decimals_y = 1;
      ref2.identificateur = 2;
      
      if (!draw_reference (disp, &ref2))
	{
	  return;
	}
    }
  
  /*--- Dessin 3 -----------------------------------------------------*/
  
  if (flag[3])
    {
      ref3.window = XtWindow (Drawing_A3);
      if (!ref3.gc)
	ref3.gc = XCreateGC (disp, root_window,
			     0, NULL);
      ref3.lower_x = 0.;
      ref3.upper_x = (float)duree_simul;
      ref3.grad_x = 10.;
      ref3.lower_y = reference3_min_p;  /*reference3.lower_y;*/
      ref3.upper_y = reference3_max_p;   /*reference3.upper_y;*/
      ref3.grad_y = 0.2;
      ref3.decimals_x = 0;
      ref3.decimals_y = 2;
      ref3.identificateur = 3;
      
      if (!draw_reference (disp, &ref3))
	{
	  return;
	}
    }
  
  /*---- fin partie dessin axes --------------------------------------*/
  
     switch(num)
     {
     case 0 :
       {
		 dessine (ramp_input, TURQ, &ref1);                   /* input */
		 dessine_detection (les_spikes, VIOLET, &ref1);       /* */
		 
		 dessine_equil (potentiel_E_Na,ROUGE , &ref1);              /* pos rev pot */
		 dessine_equil (potentiel_E_K ,BLEU  , &ref1);              /* neg rev pot */
		 dessine (le_seuil, MAUVE, &ref1);                   /* threshold */
		 dessine_pot_rev();
		 dessine (potentiel, NOIR, &ref1);                    /* mb pot */
		 dessine (l_histogramme, ROUGE,&ref2);
		 dessine_dots (les_intervalles, NOIR, &ref3);
		 break;
       }
     case 1 :
       {
	 if (flag[1])
	   {
	     dessine (ramp_input,TURQ,&ref1);
	     dessine_detection (les_spikes, VIOLET, &ref1);
	     dessine_pot_rev();
	     dessine (potentiel, NOIR, &ref1);
	   }
	 break;
       }
     case 2 :
       {
	 if (flag[2])
	   {
	       dessine (courant_global, NOIR, &ref1);
	   }
	 break;
       }
     }

	XUndefineCursor(disp, XtWindow(top_levelG));
	if (Top_Level_Conductance)
	  XUndefineCursor(disp, XtWindow(Top_Level_Conductance));
	if (Top_Level_Phenom)
	  XUndefineCursor(disp, XtWindow(Top_Level_Phenom));
     
     
}



/*--------------------------------------------------------------------
 *			d e s s i n e 
 *------------------------------------------------------------------*/
/* fonction qui permet de dessiner sur l'aire determinee par ref,
avec la couleur "couleur", les valeurs contenues dans "tableau" */

void    dessine (float *tableau, int couleur, REFERENCE *ref)

{	
	float   x1, y1, x2, y2, x3;
	int     i,j;


	XSetForeground (disp, ref->gc, couleur);
	XSetLineAttributes (disp, ref->gc, 2,LineSolid,CapRound,JoinRound);

	x1 = 0.;
	y1 = tableau [0];
	for (i = 1; i < table_size; i++)
	{
		x2 = (float) i * time_step;
		y2 = *(tableau + i);
		if (y2 == pot_post_spike)
		{
		  x3 =  (x2 - (time_step/2.));
		  draw_segment (disp, ref, x1, y1, x3, SPIKE_TOP);
		  draw_segment(disp, ref, x3, SPIKE_TOP, x2, y2);
		}
		else
		  draw_segment (disp, ref, x1, y1, x2, y2);
		x1 = x2;
		y1 = y2;
	}

}


/*--------------------------------------------------------------------
 *			d e s s i n e _equil
 *------------------------------------------------------------------*/
/* fonction qui permet de dessiner sur l'aire determinee par ref,
avec la couleur "couleur", les valeurs contenues dans "tableau" , mais seulement quelques points pour ne pas masquer le reste */

void    dessine_equil (float *tableau, int couleur, REFERENCE *ref)

{	
	float   x1, y1, x2, y2, x3;
	int     i,j;


	XSetForeground (disp, ref->gc, couleur);
	XSetLineAttributes (disp, ref->gc, 2,LineSolid,CapRound,JoinRound);

	x1 = 0.;
	y1 = tableau [0];
	for (i = 1; i < 10; i++)
	{
		x2 = (float) i * time_step;
		y2 = *(tableau + i);
		if (y2 == pot_post_spike)
		{
		  x3 =  (x2 - (time_step/2.));
		  draw_segment (disp, ref, x1, y1, x3, SPIKE_TOP);
		  draw_segment(disp, ref, x3, SPIKE_TOP, x2, y2);
		}
		else
		  draw_segment (disp, ref, x1, y1, x2, y2);
		x1 = x2;
		y1 = y2;
	}

}


/*--------------------------------------------------------------------
 *			d e s s i n e _ d o t s
 *------------------------------------------------------------------*/
/* fonction qui permet de dessiner sur l'aire determinee par ref,
avec la couleur "couleur", les valeurs contenues dans "tableau" */

void    dessine_dots (float *tableau, int couleur, REFERENCE *ref)

{	
	float   x1, y1;
	int     px1, py1;
	int     i,j;


	XSetForeground (disp, ref->gc, couleur);
	XSetLineAttributes (disp, ref->gc, 4,LineSolid,CapRound,JoinRound);

	for (i = 1; i < table_size; i++)
	{
		x1 = (float) i * time_step;
		y1 = *(tableau + i);
		px1 = (int) floor (ref->A_x * x1 + ref->B_x + 0.5);
		py1 = (int) floor (ref->A_y * y1 + ref->B_y + 0.5);
		  /* XDrawPoint (disp, ref->window, ref->gc, px1, py1); */
		XDrawLine (disp, ref->window, ref->gc, px1, py1, px1, py1);

	}
	XSetLineAttributes (disp, ref->gc, 2,LineSolid,CapRound,JoinRound);

}

/*-----------------------------------------------------------------
 *      d e s s i n e _ p o t _ r e v
 *----------------------------------------------------------------*/

 void dessine_pot_rev()
 {
	/*----   Trace du potentiel de reversion positif      ___*/
	
	XSetLineAttributes(disp, ref1.gc, 1, LineOnOffDash, CapButt,
			   JoinRound);
	XSetForeground(disp, ref1.gc,ROUGE);
	draw_segment(disp, &ref1, ref1.lower_x, E_Na,
		     ref1.upper_x, E_Na);


	/*----   Trace du potentiel de reversion negatif      ___*/

	XSetLineAttributes(disp, ref1.gc, 1, LineOnOffDash, CapButt,
			   JoinRound);
	XSetForeground(disp, ref1.gc,BLEU);
	draw_segment(disp, &ref1, ref1.lower_x, E_K,
		     ref1.upper_x, E_K);

	XSetLineAttributes(disp, ref1.gc, 1, LineSolid, CapButt,
			   JoinRound);
		   
 } /* fin dessine_pot_rev */

/*--------------------------------------------------------------------
 *			d e s s i n e  d e t e c t i o n
 *------------------------------------------------------------------*/
/* fonction qui permet de dessiner sur l'aire determinee par ref,
avec la couleur "couleur", les valeurs contenues dans "tableau */

void    dessine_detection (float *tableau, int couleur, REFERENCE *ref)

{	
	float   x1, y1, x2, y2, f_i;
	int     i,j;


	XSetForeground (disp, ref->gc, couleur);

	x1 = 0.;
	y1 = tableau [0];
	for (i = 1; i < table_size; i++)
	{
		x1 = (float) i * time_step;
		if ( *(tableau + i) == 1.)
			if (flag_spike_visible==1) draw_segment (disp, ref, x1, -100., x1, 40.);
	}

}














