#define DEBUG 0
#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- no modification in this file -------------*/

#endif
/*--------------------------------------------------------------------
 *			d r a w _ X _ Y _ g r a p h
 *------------------------------------------------------------------*/
/* fonction qui permet de dessiner sur l'aire determinee par ref,
avec la couleur "couleur", les valeurs contenues dans "tableau" */



#include "G_neuron.h"
#include "G_interface.h"
#include "G_reference.h"
#undef MAIN

#include "G_synap.h"
#include "G_dessin.h"


#ifndef TRUE
#	define TRUE	1
#endif

#ifndef FALSE
#	define FALSE	0
#endif

#define	LEFT_OFFSET	50
#define UP_OFFSET	15
#define BOTTOM_OFFSET	30
#define RIGHT_OFFSET	15

extern int NOIR,
	   ROUGE,
	   BLEU,
	   VERT,
	   VIOLET,
	   MAUVE,
	   TURQ,
	   JAUNE;

extern	Display		*disp;

extern	REFERENCE	refXY;

extern float	*X_graph,
		*Y_graph;

extern	char	X_legend[20],
		Y_legend[20];

float		XY_graph_scale;

void draw_X_Y_graph(void)
{
	int	i;
	char	buffer[255];
	float	X_max, X_min,
		Y_max, Y_min;

#if DEBUG
	printf("draw_X_Y_graph\n");
#endif
	

	if(flag_XY)
	{
#if DEBUG
	printf("flag_XY = True\n");
#endif
		XtPopup(Top_Level_XY,XtGrabNone);
	}
	else
	{
#if DEBUG
	printf("flag_XY = False\n");
#endif
		fabrique_XY_area();
		flag_XY = 1;
	} /* fin du else */

#if DEBUG
	printf("draw_X_Y_graph avant for (table_size = %d)\n", table_size);
#endif

	X_min = X_max = X_graph[0];
	Y_min = Y_max = Y_graph[0];
	for (i = 1; i < table_size-1; i++)
	{
		if(X_graph[i] > X_max)
			X_max = X_graph[i];
		else
			if(X_graph[i] < X_min)
				X_min = X_graph[i];
		if(Y_graph[i] > Y_max)
			Y_max = Y_graph[i];
		else
			if(Y_graph[i] < Y_min)
				Y_min = Y_graph[i];
	} /* fin du for */

#if DEBUG
	sprintf(buffer,"X_min: %f X_max: %f Y_min: %f Y_max: %f\n",
	       X_min, X_max, Y_min, Y_max);
	XtWarning(buffer);
#endif
	sprintf(buffer,"%s = f(%s)",Y_legend,X_legend);

	if (draw_XY_reference(buffer,X_legend, Y_legend,
			  X_min, X_max, Y_min, Y_max))
	{
		dessine_XY();
	}

}



/*----------------------------------------------------------------
 *	d r a w _ r e f e r e n c e
 *--------------------------------------------------------------*/

int	draw_XY_reference (char *titre, char *X_leg, char *Y_leg,
			   float X_min, float X_max,
			   float Y_min, float Y_max)
{
	int			win_height, win_width;
	XWindowAttributes	win_attr;
	float	a, b, c, A, B, x, y;
	int	px, py, px_before, py_before;
	int	first_px = TRUE, first_py = TRUE;
	char	number[10];
	char	legende[40];
	int	nchar;


	disp = XtDisplay(Top_Level_XY);

	refXY.window = XtWindow (Drawing_XY);

	if (!refXY.gc)
		refXY.gc = XCreateGC (disp, root_window,
					     0, NULL);
	refXY.lower_x = X_min;
	refXY.upper_x = X_max;
	refXY.grad_x = (X_max-X_min)/10.;
	refXY.lower_y = Y_min;
	refXY.upper_y = Y_max;
	refXY.grad_y = (Y_max-Y_min)/10.;
	refXY.identificateur = 1;
	
	if (!refXY.window || !refXY.gc)
	{
		return FALSE;
	}


	XSetForeground(disp, refXY.gc, NOIR );
	
	XGetWindowAttributes (disp, refXY.window, &win_attr);
	win_height = (int) win_attr.height;
	win_width  = (int) win_attr.width;

	XY_graph_scale = (float)(win_width)/(float)(win_height);
	
/*--- Blanchissage de la window ---------------------------------*/

	XClearArea (disp, refXY.window, 0, 0,
	    win_width - 1, win_height - 1, False);

	if (win_height < BOTTOM_OFFSET + UP_OFFSET + 20 ||
	    win_width < LEFT_OFFSET + RIGHT_OFFSET + 30)
	{
		return FALSE;
	}

/*--- Equations de changement de repere -------------------------*/
/* permet de definir des coordonnees absolues des valeurs min et max
de chaque axe par rapport au systeme de coordonnees de la fenetre   */

	a = refXY.lower_x;
	b = refXY.upper_x;

	if ((c = (a - b)) == 0.)
	{
		XDrawString(disp, refXY.window, refXY.gc,
			    ((int)(win_width/2) - 100),
			    (int)(win_height/2),
			    "X min = X max: no graph possible",32);
		return FALSE;
	}

	A = (float) LEFT_OFFSET;
	B = (float) win_width - (float) RIGHT_OFFSET;
	
	refXY.A_x = (A - B) / c;
	refXY.B_x = (a * B - b * A) / c;

	a = refXY.upper_y;
	b = refXY.lower_y;
	A = (float) UP_OFFSET;
	B = (float) win_height - (float) BOTTOM_OFFSET;
	

	if ((c = (a - b)) == 0.)
	{
		XDrawString(disp, refXY.window, refXY.gc,
			    ((int)(win_width/2) - 100),
			    (int)(win_height/2),
			    "Y min = Y max: no graph possible",32);
		return FALSE;
	}

	refXY.A_y = (A - B) / c;
	refXY.B_y = (a * B - b * A) / c;

/*--- Trace de l'axe vertical ----------------------------------*/
	
	XDrawLine (disp, refXY.window, refXY.gc,
	    LEFT_OFFSET,
	    UP_OFFSET,
	    LEFT_OFFSET,
	    win_height - BOTTOM_OFFSET);

/*--- Trace de l'axe horizontal --------------------------------*/
	
	XDrawLine (disp, refXY.window, refXY.gc,
	    LEFT_OFFSET,
	    win_height - BOTTOM_OFFSET,
	    win_width - RIGHT_OFFSET,
	    win_height - BOTTOM_OFFSET);

/*--- Trace des graduations horizontales -----------------------*/

	x = refXY.lower_x;
	y = refXY.lower_y;
	py = (int) floor (refXY.A_y * y + refXY.B_y + 0.5);

	do
	{
		px = (int) floor (refXY.A_x * x + refXY.B_x + 0.5);

		if ((px - px_before) > 35 || first_px)
		/* pour que les chiffres correspondant aux
		graduations ne se chevauchent pas */
		{
			px_before = px;
			first_px = FALSE;
		
			switch (refXY.decimals_x)
			{
				case 0:
					sprintf (number, "%5.0f", x);
					break;
				case 1:
					sprintf (number, "%5.1f", x);
					break;
				case 2:
				default:
					sprintf (number, "%5.2f", x);
					break;
			}

			XDrawLine (disp, refXY.window, refXY.gc,
				   px, py, px,py + 6);
			XDrawString (disp, refXY.window, refXY.gc,
				     px - 15, py + 20, number, 5);
		}
		else
		{
			XDrawLine (disp, refXY.window, refXY.gc,
				   px, py, px, py + 3);
		}
		
		x += refXY.grad_x;
		
	} while (x <= refXY.upper_x);

/*--- Trace des graduations verticales ----------------------------*/

	x = refXY.lower_x;
	y = refXY.lower_y;
	px = (int) floor (refXY.A_x * x + refXY.B_x + 0.5);


	do
	{
		py = (int) floor (refXY.A_y * y + refXY.B_y + 0.5);
		
		if ((py_before - py) > 10 || first_py)
		{
			py_before = py;
			first_py = FALSE;
		
			switch (refXY.decimals_y)
			{
				case 0:
					sprintf (number, "%5.0f", y);
					break;
				case 1:
					sprintf (number, "%5.1f", y);
					break;
				case 2:
				default:
					sprintf (number, "%5.2f", y);
					break;
			}

			XDrawLine (disp, refXY.window, refXY.gc, px,
				   py, px - 6, py);
			XDrawString (disp, refXY.window, refXY.gc,
				     px - 40, py + 5, number, 5);
		}
		else
		{
			XDrawLine (disp, refXY.window, refXY.gc,
				   px, py,px - 3, py);
		}
		
		y += refXY.grad_y;
		
	} while (y <= refXY.upper_y);



/*---	trace des legendes --------------------------------------*/


	XDrawString(disp, refXY.window, refXY.gc,
			    win_width - 100,
			    win_height - (BOTTOM_OFFSET + 5),
			    X_leg,strlen(X_leg));
	XDrawString(disp, refXY.window, refXY.gc,
			    (LEFT_OFFSET + 5),
			    (UP_OFFSET + 10),
			    Y_leg,strlen(Y_leg));

	return TRUE;
}



/*--------------------------------------------------------------------
 *			d e s s i n e _ X Y
 *------------------------------------------------------------------*/
/* fonction qui permet de dessiner sur l'aire determinee par ref,
avec la couleur "couleur", les valeurs contenues dans "tableau */

void    dessine_XY (void)
{	
	float   x1, y1, x2, y2;
	int     i,j;


	XSetForeground (disp, refXY.gc, ROUGE);

	x1 = X_graph[0];
	y1 = Y_graph[0];
	for (i = 1; i < table_size-1; i++)
	{
		x2 = *(X_graph + i);
		y2 = *(Y_graph + i);
		draw_segment (disp, &refXY, x1, y1, x2, y2);
		x1 = x2;
		y1 = y2;
	}

}
