#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- 25 modifications in this file -------------*/
*/
#endif
/*-----------------------------------------------------------------
 * 			E N T R E E _ S O R T I E . C    
 *---------------------------------------------------------------*/


#undef	MAIN
#include "G_neuron.h"
#include "G_synap.h"
#include "G_interface.h"

#include	<math.h>


extern float    reference1_max,reference1_min,
		reference2_max_p, reference2_min_p,
		reference3_max_p, reference3_min_p,
		reference2_max_g, reference2_min_g,
		reference3_max_g, reference3_min_g;

extern float	XY_graph_scale;
/*extern char     file_saved;*/
#ifndef	PI
#define	PI	3.14159265
#define	CALLOC (nb,x) ((x * )calloc(nb, sizeof(x )))

#endif


void realloc_mem_tab_syn(int );
void realloc_mem_tab_transitoire(int );
void realloc_mem_tab_type_value(int );
void realloc_mem_tab_type_ponderation(int );
void realloc_mem_tab_tempo(int );



Widget  xs_create_scale_button(Widget w, char  *chaine, XmString titre)
{       

  Widget  button;
  Arg     wargs[20];
  int     n;
  
  n = 0;
  XtSetArg(wargs[n], XmNwidth, 284); n++;
  XtSetArg(wargs[n], XmNheight,70 ); n++;
  XtSetArg(wargs[n], XmNorientation, XmHORIZONTAL); n++;
  XtSetArg(wargs[n], XmNscaleWidth, 284); n++;
  XtSetArg(wargs[n], XmNscaleHeight, 20); n++;
  XtSetArg(wargs[n], XmNborderWidth, 1); n++;
  XtSetArg(wargs[n], XmNminimum, 0); n++;
  XtSetArg(wargs[n], XmNmaximum, 100); n++;
  XtSetArg(wargs[n], XmNvalue, 0); n++;
  XtSetArg(wargs[n], XmNshowValue, True); n++;
  XtSetArg(wargs[n], XmNbottomOffset, 5); n++;
  XtSetArg(wargs[n], XmNdecimalPoints, 0); n++;
  XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  XtSetArg(wargs[n], XmNtitleString, titre); n++;
  button = XtCreateManagedWidget(chaine, xmScaleWidgetClass, w, wargs, n);
  return  (button);
  
}


Widget  xs_create_dexinput_button(Widget w, char  *chaine, char *titre, int width, int decimalPoints, 
				  int default_val, int valeur)
{
  
  Widget  button;
  Arg     wargs[20];
  int     n;
  
  n = 0;
  XtSetArg(wargs[n], XmNtopOffset, 0);n++;
  XtSetArg(wargs[n], XmNwidth, width);n++;
  XtSetArg(wargs[n], DeXNdefaultValue, default_val);n++;
  XtSetArg(wargs[n], DeXNvalue, valeur);n++;
  XtSetArg(wargs[n], XmNbottomOffset, 5); n++;
  XtSetArg(wargs[n], DeXNdecimalPoint, decimalPoints); n++;
  XtSetArg(wargs[n], XmNborderWidth, 1); n++;
  XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_FORM); n++;
  XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM);n++;
  XtSetArg(wargs[n], DeXNlabelString, titre);n++;
  button = XtCreateManagedWidget(chaine, DeXinputWidgetClass, w, wargs, n);

  XtVaSetValues(button, DeXNvalue, valeur, NULL, NULL);

  return  (button);


}
/*--------------------------------------------------------------------
 *      s e t _ d e f a u l t s
 *------------------------------------------------------------------*/

/* mise en place des valeurs par default */

void set_defaults ()
{
  Arg	warg,
  wargs[10];
  XmString	string1;
  float	alpha, beta;	/* variables intermediares */
  int	i, n;
  
  diametre = 20.;
  
  surface = 4 * PI * (0.5 * diametre * 1e-4) * (0.5 * diametre * 1e-4);

  taubar_l=i_taubar_l;
  taubar_r=i_taubar_r;
/*
Ion [Out] 	[Out] 	[In] 	Equilibrium potential 
     K+ 	5.5 mmol 	100 mmol 	-88.3 mV 
    Na+ 	150 mmol 	15 mmol 	+61.5 mV 
    Cl- 	          125 mmol 	9 mmol 	-70.3 mV 
    Ca2+ 	100 mmol 	0.0001 mmol 	+184 mV 

*/  
/*  E_K = -72.;  */             /* potentiel d'equilibre du potassium */
/*  E_Na = 55.;  */             /* potentiel d'equilibre du sodium */
/*  E_Cl = -89. ;*/			/* potentiel d'equilibre du chlore */
  E_Ca = 184.;            /* potentiel d'equilibre du calcium */
  Na_ext = 150.;          /* concentration extracellulaire de sodium */
  Na_int = 15.;           /* concentration intracellulaire de sodium */
  K_ext = 5.5;             /* concentration extracellulaire de potassium */
  K_int = 100.;           /* concentration intracellulaire de potassium */
  Cl_ext = 125.;          /* concentration extracellulaire de Chlore */
  Cl_int = 9.;           /* concentration intracellulaire de Chlore */

  Temp = 20.;             /* temperature du neuron */ 

  reactualise_E_Na_K();

  /*  E_H = -43. */;             /* potentiel d'equilibre du calcium */

  E_fuite = E_Goldman;         /* potentiel de fuite */
  rest_pot = E_fuite;    	/* potentiel de repos du neurone */

  g_fuite = 0.3;		/* conductance du courant de fuite en S/cm2 */
  g_fuite_Na = 0.;		/* conductance du courant de fuite Na en S/cm2 */
  g_fuite_K = 0.;		/* conductance du courant de fuite K en S/cm2 */
  g_Na = 120.0;		/* conductance Na  en S/cm2 */
  g_K = 40.0;		/* conductance K en S/cm2 */
  g_Ca = 1.0;		/* conductance Ca */
  g_Cl = 0.;              /* conductance Cl */
  g_A = 0.;               /* conductance K pour Ia */
  g_M = 0.;               /* conductance K pour Im */
  g_C = 0.;               /* conductance K pour Ic */
  g_ahp = 0.;		/* conductance K pour Iahp */
  g_Nap = 0.;		/* conductance K pour INap */
  g_Cab = 0.;		/* conductance K pour ICab */
  g_H = 0.;		/* conductance K pour Ih */
  capacite = 1.0;	   /* capacite de la membrane en F/cm2 */
  input_fact = 0.;        /* courant injecte */
 
  Ca_i = 0.0001;	 /* concentration en calcium intracellulaire
				   en mMol*/
  tau_decay_Ca = 20;	/* Cste de temps de l'absorption du Ca IC */
  tau_Ca = 5.;		/* constante de temps de g_Ca */
  clamp_pot = rest_pot;	/* potentiel impose	*/
  input_volt = 0.;	/* potentiel impose	*/
  spike_slope = 20.;	/* Detecteur de spikes mV/ms */
  
  g_NMDA = 1.8;		/* conductance des canaux NMDA sensibles en S */
  tau_attack_NMDA = 80.;  /* cste montee NMDA en ms */
  tau_decay_NMDA = 0.66;  /* cste descente NMDA en ms */
  eta_NMDA = 0.33;	/* coefficient de dependance de G_NMDA a la
			   concentration extracellulaire en Mg++ en mM-1 */
  gamma_NMDA = 0.06;	/* coefficient reliant G_NMDA et Vm en mV-1 */
  magnesium = 1;		/* concentration extracellulaire en Mg++ */
  rev_pot_NMDA = 0;	/* potentiel de reversion du NMDA */
  
  
  duree_simul = 100;	/* duree de la simulation en ms */
  fin_stim = 40;	        /* fin de la stimulation en ms */
  duree_stim = 20;        /* duree de la stimulation en ms */
  debut_stim = 20;	/* debut de la stimulation en ms */
  time_step = .1;		/* pas de temps en ms */
  Ca_Influx = 0.00015;	/* Vitesse d'entree du calcium */
  Ca_Removal = 0.005;	/* Vitesse de sortie du calcium */
  Ca_Kd = 1.;		/* Constante de dissociation du calcium */
  K_Ca_Kd = 0.5;		/* Constante de dissociation du calcium pour I_K */
  lambda_Ik = .07;	/* Constante dependant de la temperature */
  if (model_type == MICHAELIS_MENTON_MODEL)
	lambda_Ik = .081;	/* Constante dependant de la temperature */
  if (model_type == HH_SIMPLE_MODEL)
	lambda_Ik = .06;	/* Constante dependant de la temperature */
  lambda_Ic = 5.;		/* Constante dependant de la temperature */
  lambda_Im = 0.003;	/* Constante deoendant de la temperature */
  lambda_Inap = 0.1;	/* Constante deoendant de la temperature */
  lambda_Icab = 0.005;	/* Constante deoendant de la temperature */
  lambda_Ih = 0.0005;	/* Constante deoendant de la temperature */
  tau_m_cab = 10.0;	/* cste de temps m Icab */
  /*
   * variable globales pour la sigmoide
   * d'activation/inactivation
   */
  
  V_Na = -31.;		/* V 1/2 pour la Na */
  A_Na = .0651;		/* coeff a pour le Na */
  Pow_Na = 3.;		/* Exposant pour le Na */
  V_K = -46.;		/* V 1/2 pour la K */
  A_K = .0551;		/* coeff a pour le K */
  Pow_K = 4.;		/* Exposant pour le K */
  V_Ca = -40.;		/* V 1/2 pour la Ca */
  A_Ca = .2;		/* coeff a pour le Ca */
  Pow_Ca = 2.;		/* Exposant pour le Ca */
  Tau_Ca = 50.;		/* Cste de temps pour le Ca */
  V_Ia_A = -20.;		/* V 1/2 pour Ia activation */
  A_Ia_A = .021;		/* coeff a pour Ia activation */
  Pow_Ia_A = 1.;		/* Exposant pour Ia activation */
  V_Ia_B = -70.;		/* V 1/2 pour Ia inactivation */
  A_Ia_B = -0.1;		/* coeff a pour Ia inactivation */
  Pow_Ia_B = 1.;		/* Exposant pour Ia inactivation */
  Tau_Ia_B = 10.; 	/* Cste de temps pour Ia inactivation */
  V_Im = -35.;		/* V 1/2 pour Im  (potentiel du point d'inflexion) */
  A_Im = 0.05;		/* coeff a pour Im (pente de la sigmoide) */
  V_Ic = -90.;		/* V 1/2 pour Ic (potentiel du point d'inflexion) */
  A_Ic = 0.05;		/* coeff a pour Ic (pente de la sigmoide) */
  V_Inap = -56.;		/* V 1/2 pour Inap (potentiel du point d'inflexion) */
  A_Inap = 0.07;		/* coeff a pour Inap (pente de la sigmoide) */
  Vm_Icab = -45.;		/* V 1/2 pour m Icab (potentiel du point d'inflexion) */
  Am_Icab = 0.1;		/* coeff a pour h Icab (pente de la sigmoide) */
  Vh_Icab = -70.;		/* V 1/2 pour h Icab (potentiel du point d'inflexion) */
  Ah_Icab = 0.1;		/* coeff a pour h Icab (pente de la sigmoide) */
  Pow_m_cab = 3.;		/* Exposant pour le Ca LVA */
  V_Ih = -75.;		/* V 1/2 pour Ih (potentiel du point d'inflexion) */
  A_Ih = -0.09;		/* coeff a pour Ih (pente de la sigmoide) */

  backgrd_noise_m = 0.;	/* bruit de fond */
  backgrd_noise_sd = 0.;
  
  
  A_INa_A = .056;		/* coeff a pour le Na */
  A_INa_B = -0.04;	/* coeff a pour Ia inactivation */
  Tau_INa_B = 1.;
  Tau_INa_A = 3.;
  Pow_INa_A = 3.;
  Pow_INa_B = 1.;
  V_INa_A = -31;
  V_INa_B = -59;
  P_bar_Na = 6.0e-6;      /* permeabilite pour Na en m/s */
  P_bar_K  = 2.0e-6;      /* permeabilite pour K  en m/s */  
  
#ifdef ADD_CURRENT
  
  /*--------   To add a current copy, modify and adapt   -------*/   
  /* ----------------- Adapt the default values ----------------*/
  g_New = 0.;
  E_New = 0.;
  V_INew_A = 0.;
  A_INew_A = 0.;
  Pow_INew_A = 0.;
  Tau_INew_A = 0.;
  V_INew_B = 0.;
  A_INew_B = 0.;
  Pow_INew_B = 0.;
  Tau_INew_B = 0.;
  lambda_INew = 0.;
  m_INew_init = 0.;
  h_INew_init = 0.;

  
  
#endif
  /*-------------------------pour le graphe ----------------------------*/

  
  reference1_max = 61.;
  reference1_min = -100.;

  /* phenomeno */
  reference2_max_p = 100.;
  reference2_min_p = 0.;
  reference3_max_p = 100.;
  reference3_min_p = 0.; 

  /* conductance */
  reference2_max_g = 20.;
  reference2_min_g = -40.;
  reference3_max_g = 5.;
  reference3_min_g = -5.; 


  
  /*--------------------------------------------------------------------*/

  /*
   * les PSP
   */

  for (i = 0; i < NB_MAX_RECEPTORS; i++)
  {
    Receptors[i].g_Syn = 0.05;
    Receptors[i].tau_attack = 2.5;
    Receptors[i].tau_decay = 10;
    Receptors[i].rev_pot = -10.;
    Receptors[i].transmetteur = ANY;
    Receptors[i].num_transm = NB_ANY;
	strcpy(Receptors[i].nom,"Any");
  }

  /* l'epsp */

  Receptors[0].g_Syn = 0.05;
  Receptors[0].tau_attack = 2.5;
  Receptors[0].tau_decay = 10;
  Receptors[0].rev_pot = -10.;
  Receptors[0].transmetteur = ACETYLCHOLINE;
  Receptors[0].num_transm = NB_ACETYLCHOLINE;
  strcpy(Receptors[0].nom,"Acetylcholine");

  /* l'ipsp */

  Receptors[1].g_Syn = 0.05;
  Receptors[1].tau_attack = 2.5;
  Receptors[1].tau_decay = 10;
  Receptors[1].rev_pot = -90.;
  Receptors[1].transmetteur = GABA_A;
  Receptors[1].num_transm = NB_GABA_A;
  strcpy(Receptors[1].nom,"GABA A");

  
  /* 
   *  Sera a supprimer quand nbc_x V12 sera pret
   *  actuellement conserve pour compatibitlite
   */

  g_Syn_pos = 0.05;	/* conductance synaptique epsp */
  g_Syn_neg = 0.05;	/* conductance synaptique ipsp */
  tau_attack_epsp = 2.5;	/* constante de temps de montee du epsp */
  tau_decay_epsp = 10.;	/* constante de temps de descente du epsp */
  tau_attack_ipsp = 2.5;	/* constante de temps de montee du ipsp */
  tau_decay_ipsp = 10.;	/* constante de temps de descente du ipsp */

  
  voltage_clamp = FALSE;
  nb_connexions_NMDA = 0;

  if (flag_horizontal)
    {
      duree_simul = 1000;	/* duree de la simulation en ms */
      duree_stim = 200;         /* duree de la stimulation en ms */
      debut_stim = 200;	        /* debut de la stimulation en ms */
      fin_stim = 400;	        /* fin de la stimulation en ms */
    }
  else
    {
      duree_simul = 100;	/* duree de la simulation en ms */
      duree_stim = 20;          /* duree de la stimulation en ms */
      debut_stim = 20;	        /* debut de la stimulation en ms */
      fin_stim = 40;	        /* fin de la stimulation en ms */
    }
  if (flag_Phenom)
      time_step = 1;		/* pas de temps en ms */
  else
      time_step = .1;		/* pas de temps en ms */


  no_NMDA = 0;
  table_size = (int) ((float)(duree_simul + 2) / time_step) + 2;
  /* allocation de tableaux pour les dessins */
  potentiel      = (float *) calloc(table_size, sizeof(float));
  potentiel_E_Na = (float *) calloc(table_size, sizeof(float));
  potentiel_E_K  = (float *) calloc(table_size, sizeof(float));
  ramp_input     = (float *) calloc(table_size, sizeof(float));
  courant_global = (float *) calloc(table_size, sizeof(float));
  courant_K      = (float *) calloc(table_size, sizeof(float));
  courant_Na     = (float *) calloc(table_size, sizeof(float));
  courant_Ia     = (float *) calloc(table_size, sizeof(float));
  courant_Im     = (float *) calloc(table_size, sizeof(float));
  courant_Iahp   = (float *) calloc(table_size, sizeof(float));
  courant_Ic     = (float *) calloc(table_size, sizeof(float));
  courant_Nap    = (float *) calloc(table_size, sizeof(float));
  courant_Cab    = (float *) calloc(table_size, sizeof(float));
  courant_Ih     = (float *) calloc(table_size, sizeof(float));
  Ca             = (float *) calloc(table_size, sizeof(float));
  le_temps       = (float *) calloc(table_size, sizeof(float));
  courant_Ca     = (float *) calloc(table_size, sizeof(float));
#ifdef ADD_CURRENT
  
  /*--------   To add a current copy, modify and adapt   -------*/   
  
  courant_New    = (float *) calloc(table_size, sizeof(float));
#endif
  valeur_m       = (float *) calloc(table_size, sizeof(float));
  valeur_h       = (float *) calloc(table_size, sizeof(float));
  synaptique     = (float *) calloc(table_size, sizeof(float));
  les_spikes     = (float *) calloc(table_size, sizeof(float));
  les_intervalles =  (float *) calloc(table_size, sizeof(float));
  l_histogramme = (float *) calloc(table_size, sizeof(float));
  le_seuil = (float *) calloc(table_size, sizeof(float));
  
  for (i = 0; i < table_size; i++)
    le_temps[i] = (float)i * time_step;
  
  /*	
     tab_transitoire = (SYNAP *) calloc(nb_connexions, sizeof(SYNAP));	
     tab_syn = (SYNAP *) calloc(nb_connexions, sizeof(SYNAP));
     tab_type_value = (int *) calloc(nb_connexions, sizeof(int));	
     tab_type_ponderation = (int *) calloc(nb_connexions, sizeof(int));	
     */
  
  nb_connexions = 0;
  if (tab_syn != NULL)
    free(tab_syn);
  if (tab_transitoire != NULL)
    free(tab_transitoire);
  if (tab_type_value != NULL)
    free(tab_type_value);
  if (tab_type_ponderation != NULL)
    free(tab_type_ponderation);
  if (tab_tempo != NULL)
    free(tab_tempo);

  /*
  realloc_mem_tab_syn(nb_connexions );
  realloc_mem_tab_transitoire(nb_connexions );
  realloc_mem_tab_type_value(nb_connexions );
  realloc_mem_tab_type_ponderation(nb_connexions ); 
  realloc_mem_tab_tempo(nb_connexions ); 
  */
  /* initialisation des variables d'ouverture et de fermeture des canaux*/
  
#ifdef ADD_CURRENT
  
  /*--------   To add a current modify and adapt   -------*/   
  
  /*-------------- Check if you need to initialize 
    some values related to you new current -------------*/
  
  h_New = h_New_init = 0.;
  m_New = m_New_init = 0.;
#endif
  
  
  m_ahp = m_ahp_init = 0.;
  m_K = m_K_init = .16;
  h_Na = h_Na_init = .16;
  le_potentiel = le_potentiel_init = -60.;
  le_potentiel_E_Na_init = 55.;
  le_potentiel_E_K_init = -72.;
  m_Ca = m_Ca_init = .001;
  Ca_i = Ca_i_init = .01;
  h_A = h_A_init = .05;
  m_Nap = m_Nap_init = 0.;
  m_Cab = m_Cab_init = 0.;
  m_Ih = m_Ih_init = 0.;
  h_Cab = h_Cab_init = 0.;
  K_rest = 2.5;
  
  m_M = 1. / (1. + (exp ((E_fuite + V_Im) * A_Im)));
  
  if((Ca_i == 0.0001) || (E_fuite < -32.))
    m_C = 0.;
  else
    m_C = (250. * Ca_i * exp (E_fuite/24.)) /
      ((250. * Ca_i * exp (E_fuite/24.)) +
       (0.1 * exp (E_fuite/(-24.))));
  
  /* initialisation du tableau pour le runge_kutta */
  
  neur_param_avant[d_V] = rest_pot;
  neur_param_avant[d_m_K] = m_K;
  neur_param_avant[d_m_Ca] = m_Ca;
  neur_param_avant[d_h_A] = h_A;
  neur_param_avant[d_m_M] = m_M;
  neur_param_avant[d_m_C] = m_C;
  neur_param_avant[d_m_Ih] = m_Ih;
  neur_param_avant[d_m_Nap] = m_Nap;
  neur_param_avant[d_m_Cab] = m_Cab;
  neur_param_avant[d_h_Cab] = h_Cab;
  neur_param_avant[d_Ca_i] = Ca_i;
  neur_param_avant[d_K_ext] = K_ext;
#ifdef ADD_CURRENT
  
/*--------   To add a current modify and adapt   -------*/   
/*-------------- Check if you need to initialize 
  some values related to you new current -------------*/
  neur_param_avant[d_h_New] = h_New;
  neur_param_avant[d_m_New] = m_New;
#endif

  /* Phenomenologic parameters */

	/*
	 * Mise en place des valeurs par defauts. 
	 * Elle sont ici afin d'etre resettables
	 */
	p_rest_pot	       = -70.;	/* resting  potential du cluster	*/
	freq_spike	       = 30.;	/* Freq des spikes			*/
	freq_max             = 150.;	/* freq maxima		                */
	compose_fact	       = 2.;	/* facteur de composition 		*/
	duree_burst_min      = 50.;	/* duree min d un burst        	        */
	duree_burst_max      = 150.;	/* duree max d un burst		        */
	tau_mb_pot	       = 10.;	/* cste de temps de la mb		*/
	seuil		       = -65.;	/* firing threshold par cluster		*/
	seuil_burst	       = -55.;	/* firing threshold par cluster		*/
	pot_post_spike       = -85.;	/* Pot mb post spike			*/
	burst_post_spike     = -60.;	/* Pot mb post spike			*/
	seuil_post_spike     = 20.;	/* seuil apres un spike			*/
	tau_seuil	       = 20.;	/* cste de temps du seuil apres un spike */
	shunt_tau	       = 20.;	/* constante de temps du shunt de la mb */
	fatigue              = 0.;  /* fatigue du seuil                     */
	delta_seuil          = seuil_post_spike;   /*                      */
	rev_pot_pos 		= -10.;	/* potentiel de reversion positif */
	rev_pot_neg		 = -90.;	/* potentiel de reversion negatif */


	burst_range = duree_burst_max - duree_burst_min;  
}

/*-------------------------------------------------------
  Cette fonction permet au graphique de reprendre
  les valeurs de table = a 0
  -------------------------------------------------------*/
void reset()
{
  int  i,taille;
  
  set_defaults();	/* met les parametres a leurs valeurs par defaut */

  for (i=0;i<nb_spikes;i++)
    {
	  	tab_syn[i].t_arrivee = 0.;
      	tab_syn[i].weight = 0.;
		tab_syn[i].g_Syn = 0.;
      	tab_syn[i].transmetteur = ANY;
      	tab_syn[i].num_transm = NB_ANY;
      	tab_syn[i].rev_pot = -10.;
		tab_syn[i].tau_attack = 2.5;
		tab_syn[i].tau_decay = 10.;
		tab_syn[i].tau_a_psp = 2.5;
		tab_syn[i].tau_d_psp = 10.;
		strcpy(tab_syn[i].nom,"Any");
   }
  (*calcul_neuron)();
  (*draw_neuron)(0);
  
}

/*-------------------------------------------------------
      Ces fonctions perment de faire une reallocation
      de memoire
-------------------------------------------------------*/



void realloc_mem_tab_syn(int taille  )
{

  Arg	     wargs[10];
  int	     n;
  XmString   string1;

  if(taille==0) return;


  if(tab_syn != NULL)
    free(tab_syn);
  
  if((tab_syn = (SYNAP * )calloc(taille, sizeof(SYNAP ))) == NULL)
    {
      string1 = XmStringCreateSimple("Synapse structure allocation impossible\nTry later");	
      n = 0;
      XtSetArg(wargs[n], XmNx, 200);n++;
      XtSetArg(wargs[n], XmNy, 400);n++;
      XtSetArg(wargs[n], XmNmessageString, string1);n++;
      
      Zero_Time_Step = XmCreateWarningDialog(Form_G,
					     "zero_time_step",wargs,n);
      XmStringFree(string1);
      XtManageChild(Zero_Time_Step);
      sortie();
    }
  for (n=0;n<taille;n++)
    {
      	tab_syn[n].t_arrivee=0.;
      	tab_syn[n].weight=0.;
		tab_syn[n].g_Syn = 0.;
      	tab_syn[n].transmetteur = ANY;
      	tab_syn[n].num_transm = NB_ANY;
      	tab_syn[n].rev_pot = -10.;
		tab_syn[n].tau_attack = 2.5;
		tab_syn[n].tau_decay = 10.;
		tab_syn[n].tau_a_psp = 2.5;
		tab_syn[n].tau_d_psp = 10.;
		strcpy(tab_syn[n].nom,"Any");
    }
  
}
/* cette table est utilisee pour memoriser provisoirement des donnees */

void realloc_mem_tab_tempo(int taille )
{

  Arg	     wargs[10];
  int	     n;
  XmString   string1;

  if(taille==0) return;

  if(tab_tempo != NULL)
    free(tab_tempo);
  
  if((tab_tempo = (SYNAP * )calloc(taille, sizeof(SYNAP ))) == NULL)
    {
      string1 = XmStringCreateSimple("Synapse structure allocation impossible\nTry later");	
      n = 0;
      XtSetArg(wargs[n], XmNx, 200);n++;
      XtSetArg(wargs[n], XmNy, 400);n++;
      XtSetArg(wargs[n], XmNmessageString, string1);n++;
      
      Zero_Time_Step = XmCreateWarningDialog(Form_G,
					     "zero_time_step",wargs,n);
      XmStringFree(string1);
      XtManageChild(Zero_Time_Step);
      sortie();
    }
  for (n=0;n<taille;n++)
    {
      tab_tempo[n].t_arrivee=0.;
      tab_tempo[n].weight=0.;
	  tab_tempo[n].g_Syn = 0.;
      tab_tempo[n].transmetteur = ANY;
      tab_tempo[n].num_transm = NB_ANY;
      tab_tempo[n].rev_pot = -10.;
      tab_tempo[n].tau_attack = 2.5;
      tab_tempo[n].tau_decay = 10.;
      tab_tempo[n].tau_a_psp = 2.5;
      tab_tempo[n].tau_d_psp = 10.;
	  strcpy(tab_tempo[n].nom,"Any");
   }
}


void realloc_mem_tab_type_ponderation(int taille )
{
  Arg	     wargs[10];
  int	     n;
  XmString   string1;


  if(taille==0) return;

  if(tab_type_ponderation != NULL)
    free(tab_type_ponderation);
  
  if((tab_type_ponderation = (int * )calloc(taille, sizeof(int ))) == NULL)
    {
      string1 = XmStringCreateSimple("integer table allocation impossible\nTry later");	
      n = 0;
      XtSetArg(wargs[n], XmNx, 200);n++;
      XtSetArg(wargs[n], XmNy, 400);n++;
      XtSetArg(wargs[n], XmNmessageString, string1);n++;
      
      Zero_Time_Step = XmCreateWarningDialog(Form_G,
					     "zero_time_step",wargs,n);
      XmStringFree(string1);
      XtManageChild(Zero_Time_Step);
      sortie();
    }
 for (n=0;n<taille;n++)
   {
     tab_type_ponderation[n]=0;
     tab_type_ponderation[n]=0;
   }
}

void realloc_mem_tab_type_value(int taille )
{
  Arg	     wargs[10];
  int	     n;
  XmString   string1;

  if(taille==0) return;

  if(tab_type_value != NULL)
    free(tab_type_value);
  
  if((tab_type_value = (int * )calloc(taille, sizeof(int ))) == NULL)
    {
      string1 = XmStringCreateSimple("integer table allocation impossible\nTry later");	
      n = 0;
      XtSetArg(wargs[n], XmNx, 200);n++;
      XtSetArg(wargs[n], XmNy, 400);n++;
      XtSetArg(wargs[n], XmNmessageString, string1);n++;
      
      Zero_Time_Step = XmCreateWarningDialog(Form_G,
					     "zero_time_step",wargs,n);
      XmStringFree(string1);
      XtManageChild(Zero_Time_Step);
      sortie();
    }
  for (n=0;n<taille;n++)
    {
      tab_type_value[n]=0;
      tab_type_value[n]=0;
    }

}

void realloc_mem_tab_transitoire(int taille )
{
  Arg	     wargs[10];
  int	     n;
  XmString   string1;

  if(taille==0) return;

  if(tab_transitoire != NULL)
    free(tab_transitoire);
  
  if((tab_transitoire = (SYNAP * )calloc(taille, sizeof(SYNAP ))) == NULL)
    {
      string1 = XmStringCreateSimple("Synapse structure allocation impossible\nTry later");	
      n = 0;
      XtSetArg(wargs[n], XmNx, 200);n++;
      XtSetArg(wargs[n], XmNy, 400);n++;
      XtSetArg(wargs[n], XmNmessageString, string1);n++;
      
      Zero_Time_Step = XmCreateWarningDialog(Form_G,
					     "zero_time_step",wargs,n);
      XmStringFree(string1);
      XtManageChild(Zero_Time_Step);
      sortie();
    }
  for (n=0;n<taille;n++)
    {
      tab_transitoire[n].t_arrivee=0.;
      tab_transitoire[n].weight=0.;
	  tab_transitoire[n].g_Syn = 0.;
      tab_transitoire[n].transmetteur = ANY;
      tab_transitoire[n].num_transm = NB_ANY;
      tab_transitoire[n].rev_pot = -10.;
      tab_transitoire[n].tau_attack = 2.5;
      tab_transitoire[n].tau_decay = 10.;
      tab_transitoire[n].tau_a_psp = 2.5;
      tab_transitoire[n].tau_d_psp = 10.;
	  strcpy(tab_transitoire[n].nom,"Any");
    }
}

void realloc_mem_tab_NMDA(int taille )
{

  Arg	     wargs[10];
  int	     n;
  XmString   string1;
  
  if(taille==0) return; 

  if (tab_NMDA != NULL)
    free(tab_NMDA);
  if ((tab_NMDA = (SYNAP_NMDA * )calloc(taille, sizeof(SYNAP_NMDA ))) == NULL)
    {
      string1 = XmStringCreateSimple("NMDA structure allocation impossible\nTry later");	
      n = 0;
      XtSetArg(wargs[n], XmNx, 200);n++;
      XtSetArg(wargs[n], XmNy, 400);n++;
      XtSetArg(wargs[n], XmNmessageString, string1);n++;
      
      Zero_Time_Step = XmCreateWarningDialog(Form_G,
					     "zero_time_step",wargs,n);
      XmStringFree(string1);
      XtManageChild(Zero_Time_Step);
      sortie();
    }
  for (n=0;n<taille;n++)
    {
      tab_NMDA[n].t_arrivee=0.;
      tab_NMDA[n].weight=0.;
    }
}
/*--------------------------------------------------------

  Cette fonction permet d`afficher un message.

--------------------------------------------------------*/


void message(char *chaine)
{
  Arg	     wargs[10];
  int	     n;
  XmString   titre;

  titre = XmStringCreate (chaine, XmSTRING_DEFAULT_CHARSET); 
 		
  n = 0;
  XtSetArg(wargs[n], XmNx, 200);n++;
  XtSetArg(wargs[n], XmNy, 400);n++;
  XtSetArg(wargs[n], XmNmessageString, titre);n++;
  
  Zero_Time_Step = XmCreateWarningDialog(Form_G,
					 "zero_time_step",wargs,n);
  XmStringFree(titre );
  XtManageChild(Zero_Time_Step);
}

/*--------------------------------------------------------

  calcul des valeurs des scales de la fenetre conductance
              ( ceux de la stimulation )
--------------------------------------------------------*/

void react_val()
{
  char     buffer[256];
  XmString  titre;
  Arg   wargs[4];

  sprintf(buffer,"Start Stim in %% (%.0f ms)",(float)(debut_stim));
  titre = XmStringCreateSimple(buffer);
  XtSetArg(wargs[0],XmNtitleString, titre);
  XtSetValues(Repeat_Start_Stimulation,wargs,1);
  
  sprintf(buffer,"Stop Stim in %% (%.0f ms)",(float)(fin_stim));
  titre = XmStringCreateSimple(buffer);
  XtSetArg(wargs[0],XmNtitleString, titre);
  XtSetValues(Repeat_Stop_Stimulation,wargs,1);      

  sprintf(buffer,"Duration Stim in %% (%.0f ms)",(float)(duree_stim));
  titre = XmStringCreateSimple(buffer);
  XtSetArg(wargs[0],XmNtitleString, titre);
  XtSetValues(Repeat_Stimulation_Duration,wargs,1);

}

void reactualise_time_stim(int i)
{
  
  Arg   wargs[4];

  switch (i)
    {
    case 1:  /* appelee par callback_debut_stim  */  
      {
	if (flag_button_fixed_duration_stim == 0) duree_stim = fin_stim-debut_stim;
	else 
	  {
	    XtSetArg(wargs[0],XmNmaximum, (duree_simul-duree_stim)*100/duree_simul);
	    if (Repeat_Start_Stimulation) XtSetValues(Repeat_Start_Stimulation,wargs,1);
	  }
	XtSetArg(wargs[0], XmNvalue,duree_stim*100/duree_simul);
	if (Repeat_Stimulation_Duration) XtSetValues(Repeat_Stimulation_Duration,wargs,1);

	XtSetArg(wargs[0],XmNminimum, debut_stim*100/duree_simul);
	if (Repeat_Stop_Stimulation) XtSetValues(Repeat_Stop_Stimulation,wargs,1);

	if (flag_button_fixed_duration_stim == 1)
	  {
	    fin_stim = debut_stim+duree_stim;
	    XtSetArg(wargs[0],XmNvalue, fin_stim*100/duree_simul);
	    if (Repeat_Stop_Stimulation) XtSetValues(Repeat_Stop_Stimulation,wargs,1);
	  }

	XtSetArg(wargs[0],XmNvalue, debut_stim*100/duree_simul);
        if (Repeat_Start_Stimulation) XtSetValues(Repeat_Start_Stimulation,wargs,1);

	XtSetArg(wargs[0], XmNmaximum,(duree_simul-debut_stim)*100/duree_simul);
	if (Repeat_Stimulation_Duration) XtSetValues(Repeat_Stimulation_Duration,wargs,1);
	react_val();
	break;}

    case 2: /* appelee par callback_fin_stim  */  
      {
	if (flag_button_fixed_duration_stim == 0) duree_stim = fin_stim-debut_stim;
	else 
	  {
	    XtSetArg(wargs[0],XmNminimum, (duree_stim)*100/duree_simul);
	    if (Repeat_Stop_Stimulation) XtSetValues(Repeat_Stop_Stimulation,wargs,1);
	  }
	XtSetArg(wargs[0], XmNvalue,duree_stim*100/duree_simul);
	if (Repeat_Stimulation_Duration) XtSetValues(Repeat_Stimulation_Duration,wargs,1);

	if (flag_button_fixed_duration_stim == 1)
	  {
	    debut_stim = fin_stim-duree_stim;
	    XtSetArg(wargs[0],XmNvalue, debut_stim*100/duree_simul);
	    if (Repeat_Start_Stimulation) XtSetValues(Repeat_Start_Stimulation,wargs,1);
	  }

	XtSetArg(wargs[0],XmNvalue, fin_stim*100/duree_simul);
	if (Repeat_Stop_Stimulation) XtSetValues(Repeat_Stop_Stimulation,wargs,1);

	XtSetArg(wargs[0],XmNmaximum, fin_stim*100/duree_simul);
	if (Repeat_Start_Stimulation) XtSetValues(Repeat_Start_Stimulation,wargs,1);
	react_val();
	  break;}

    case 3: /* appelee par callback_duree_stim  */  
      {
	if ((debut_stim+duree_stim)>duree_simul)
	  {
	    fin_stim = duree_simul;
	    debut_stim = duree_simul-duree_stim;
	    XtSetArg(wargs[0],XmNvalue, fin_stim*100/duree_simul);
	    if (Repeat_Stop_Stimulation) XtSetValues(Repeat_Stop_Stimulation,wargs,1); 

	    XtSetArg(wargs[0], XmNvalue,debut_stim*100/duree_simul);
	    if (Repeat_Start_Stimulation) XtSetValues(Repeat_Start_Stimulation,wargs,1);
	  }
	else
	  {
	    fin_stim = debut_stim+duree_stim;
	    XtSetArg(wargs[0],XmNvalue, debut_stim*100/duree_simul);
	    if (Repeat_Start_Stimulation) XtSetValues(Repeat_Start_Stimulation,wargs,1); 

	    XtSetArg(wargs[0], XmNvalue,fin_stim*100/duree_simul);
	    if (Repeat_Stop_Stimulation) XtSetValues(Repeat_Stop_Stimulation,wargs,1);
	  };

	react_val();
	break;}

    case 4: /* appelee par callback_duree_simul  */  
      {
	debut_stim = debut_stim * duree_simul/old_duree_simul;
	fin_stim   = fin_stim   * duree_simul/old_duree_simul;
	duree_stim = duree_stim * duree_simul/old_duree_simul;

	XtSetArg(wargs[0],XmNmaximum, (duree_simul-debut_stim)*100/duree_simul);
	if (Repeat_Stimulation_Duration) XtSetValues(Repeat_Stimulation_Duration,wargs,1);
	
	react_val();
	break;}
 
    }
  
     
}
/*-----------------------------------------------------------------
 *      r e a d N e u r o n
 *---------------------------------------------------------------*/
/* permet la lecture d'un fichier contenant les parametres d'un
   neurone, et la mise a jour des valeurs des Widgets DeXInput */
   
void readNeuron (FILE *file)
{
	Arg	Darg[5];
	char    buffer[80], parametre[50], value[30];
	int x, i;
	int saved_integration;
	int saved_model;
	Widget  n_id;
	XmString string;

	set_defaults();

#if DEBUG
	printf("AVANT: Model type : %d\n",model_type);
#endif

     if (model_type == MICHAELIS_MENTON_MODEL ||
	 model_type == HH_SIMPLE_MODEL)
     {
#if DEBUG
	printf("Conductance: Model type : %d\n",model_type);
#endif
	while (fgets(buffer,80,file))
	{
		sscanf(buffer, "%s %s", parametre, value);

		if (!strcmp (parametre, "diametre:"))	/* rem: le diametre doit etre lu en premier */
		{
			sscanf(value,"%f",&diametre);
			if (flag_simulation)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) diametre);
				XtSetValues(DeXInput_Diametre, Darg, 1);
			}
			surface = PI * 1e-8 * diametre * diametre;			
		} 
		if (!strcmp (parametre, "Integration:"))
		{
		  if (!strcmp (value, "Exponentielle"))
		  {
			saved_integration = EXPONENTIELLE;
		  }
		  if (!strcmp (value, "Runge-Kutta"))
		  {
			saved_integration = RUNGE_KUTTA;
		  }
		  if (!strcmp (value, "Runge-Kutta_variable_step"))
		  {

			saved_integration = RUNGE_KUTTA_VARIABLE_STEP;
		  }
		  if (!strcmp (value, "Euler"))
		  {

			saved_integration = EULER;
		  }
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
		  if (!strcmp (value, "Int_Method"))
		  {

			saved_integration = INT_METHOD;
		  }

#endif
		}
		if (!strcmp (parametre, "Model_Type:"))
		{
		  if (!strcmp (value, "Michaelis_Menton"))
		  {
		    saved_model = model_type = MICHAELIS_MENTON_MODEL;
		  }
		  if (!strcmp (value, "Hodgkin_Huxley"))
		  {
		    saved_model = model_type = HH_SIMPLE_MODEL;
		  }
#if 0
		  if (!strcmp (value, "Hodgkin_Huxley_with_pump"))
		  {
		    saved_model = model_type = HH_PUMP_MODEL;
		  }
#endif

#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new model */
		  if (!strcmp (value, "new_model"))
		  {
		    saved_model = model_type = NEW_MODEL;
		  }

#endif
		}


		if (!strcmp (parametre, "TimeStep:")) 
		{
			sscanf(value,"%f",&time_step);
			if (time_step < .0001)
			  time_step = .0001;
			if (flag_conductance)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (time_step * 10000.));
				XtSetValues(Repeat_Time_Step, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "TauDecayCa:"))
		{
			sscanf(value,"%f",&tau_decay_Ca);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (tau_decay_Ca * 100.));
				XtSetValues(DeXInput_Tau_Cai_D, Darg, 1);
			} 
		}

		if (!strcmp (parametre, "E_fuite:"))
		{
			sscanf(value,"%f",&E_fuite);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (E_fuite * 100.));
				XtSetValues(DeXInput_E_Leak, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "Temp:"))
		{
			sscanf(value,"%f",&Temp);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (Temp * 100.));
				XtSetValues(DeXInput_Temp, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "Na_ext:"))
		{
			sscanf(value,"%f",&Na_ext);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (Na_ext * 100.));
				XtSetValues(DeXInput_Na_ext, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "Na_int:"))
		{
			sscanf(value,"%f",&Na_int);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (Na_int * 100.));
				XtSetValues(DeXInput_Na_int, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "K_ext:"))
		{
			sscanf(value,"%f",&K_ext);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (K_ext * 100.));
				XtSetValues(DeXInput_K_ext, Darg, 1);
			} 
		}
		
		if (!strcmp (parametre, "K_int:"))
		{
			sscanf(value,"%f",&K_int);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (K_int * 100.));
				XtSetValues(DeXInput_K_int, Darg, 1);
			}
		}
		if (!strcmp (parametre, "Cl_ext:"))
		{
			sscanf(value,"%f",&Cl_ext);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (Cl_ext * 100.));
				XtSetValues(DeXInput_Cl_ext, Darg, 1);
			} 
		}
		
		if (!strcmp (parametre, "Cl_int:"))
		{
			sscanf(value,"%f",&Cl_int);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (Cl_int * 100.));
				XtSetValues(DeXInput_Cl_int, Darg, 1);
			}
		}
#ifdef ADD_CURRENT
/*--------   To add a current modify and check   -------*/   

		if (!strcmp (parametre, "E_New:"))
		{
			sscanf(value,"%f",&E_New);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (E_New * 100.));
				XtSetValues(DeXInput_E_New, Darg, 1);
			}
		}

#endif
		if (!strcmp (parametre, "E_Ca:"))
		{
			sscanf(value,"%f",&E_Ca);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (E_Ca *100.));
				XtSetValues(DeXInput_E_Ca, Darg, 1);
			} 
		}
/*
		if (!strcmp (parametre, "E_H:"))
		{
			sscanf(value,"%f",&E_H);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (E_H *100.));
				XtSetValues(DeXInput_E_H, Darg, 1);
			} 
		}
*/
		if (!strcmp (parametre, "PosReversalPot:"))
		{
			sscanf(value,"%f",&rev_pot_pos);
			if(flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (rev_pot_pos * 100.));
				XtSetValues(DeXInput_Pos_Rev_Pot, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "NegReversalPot:"))
		{
			sscanf(value,"%f",&rev_pot_neg);
			if(flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (rev_pot_neg * 100.));
				XtSetValues(DeXInput_Neg_Rev_Pot, Darg, 1);
			} 
		}

		if (!strcmp (parametre, "spike_slope:"))
		{
			sscanf(value,"%f",&spike_slope);
			if (flag_equilibrium)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (spike_slope * 100.));
				XtSetValues(DeXInput_Spike_Detect, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "E_Cl:"))
			sscanf(value,"%f",&E_Cl);

		if (!strcmp (parametre, "g_K:"))
		{
			sscanf(value,"%f",&g_K);
		}
		if (!strcmp (parametre, "g_Na:"))
		{
			sscanf(value,"%f",&g_Na);
		}
		if (!strcmp (parametre, "g_Ca:"))
		{
			sscanf(value,"%f",&g_Ca);
		}
		if (!strcmp (parametre, "g_Nap:"))
		{
			sscanf(value,"%f",&g_Nap);
		}
		if (!strcmp (parametre, "g_Cab:"))
		{
			sscanf(value,"%f",&g_Cab);
		}
		if (!strcmp (parametre, "g_Cl:"))
			sscanf(value,"%f",&g_Cl);

		if (!strcmp (parametre, "g_A:"))
		{
			sscanf(value,"%f",&g_A);
		}
		if (!strcmp (parametre, "g_M:"))
		{
			sscanf(value,"%f",&g_M);
		}
		if (!strcmp (parametre, "g_C:"))
		{
			sscanf(value,"%f",&g_C);
		}
		if (!strcmp (parametre, "g_ahp:"))
		{
			sscanf(value,"%f",&g_ahp);
		}
		if (!strcmp (parametre, "g_H:"))
		{
			sscanf(value,"%f",&g_H);
		}
#ifdef ADD_CURRENT

/*--------   To add a current modify and adapt   -------*/   

		if (!strcmp (parametre, "g_New:"))
		{
			sscanf(value,"%f",&g_New);
		}
#endif
		if (!strcmp (parametre, "g_fuite:"))
		{
			sscanf(value,"%f",&g_fuite);
		}
		if (!strcmp (parametre, "g_fuite_Na:"))
		{
			sscanf(value,"%f",&g_fuite_Na);
		}
		if (!strcmp (parametre, "g_fuite_K:"))
		{
			sscanf(value,"%f",&g_fuite_K);
		}
		if (!strcmp (parametre, "g_Syn_pos:"))
		{
			sscanf(value,"%f",&g_Syn_pos);
		}
		if (!strcmp (parametre, "g_Syn_neg:"))
		{
			sscanf(value,"%f",&g_Syn_neg);
		}
		if (!strcmp (parametre, "capacite:"))
		{
			sscanf(value,"%f",&capacite);
		}
		if (!strcmp (parametre, "input_fact:"))
		{
			sscanf(value,"%f",&input_fact);
			if (flag_conductance)
			{
				XtSetArg(Darg[0], DeXNvalue, (long) (input_fact * 100.));
				XtSetValues(DeXInput_Input_Crt, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "tau_attack_epsp:"))
		{
			sscanf(value,"%f",&tau_attack_epsp);
			if (flag_PSP)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (tau_attack_epsp * 100.));
				XtSetValues(DeXInput_Tau_EPSP_A, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "tau_decay_epsp:"))
		{
			sscanf(value,"%f",&tau_decay_epsp);
			if (flag_PSP)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (tau_decay_epsp * 100.));
				XtSetValues(DeXInput_Tau_EPSP_D, Darg, 1);
			} 
		}

		if (!strcmp (parametre, "tau_attack_ipsp:"))
		{
			sscanf(value,"%f",&tau_attack_ipsp);
			if (flag_PSP)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (tau_attack_ipsp * 100.));
				XtSetValues(DeXInput_Tau_IPSP_A, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "tau_decay_ipsp:"))
		{
			sscanf(value,"%f",&tau_decay_ipsp);
			if (flag_PSP)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (tau_decay_ipsp * 100.));
				XtSetValues(DeXInput_Tau_IPSP_D, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "NoiseMean:"))
		{
			sscanf(value,"%f",&backgrd_noise_m);
			if (flag_PSP)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (backgrd_noise_m * 100.));
				XtSetValues(DeXInput_Bckg_Noise_Mean, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "NoiseSd:"))
		{
			sscanf(value,"%f",&backgrd_noise_sd);
			if (flag_PSP)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (backgrd_noise_sd * 100.));
				XtSetValues(DeXInput_Bckg_Noise_Sd, Darg, 1);
			} 
		}

		if (!strcmp (parametre, "Ca_i:"))
			sscanf(value,"%f",&Ca_i);


		if (!strcmp (parametre, "magnesium:"))
		{
			sscanf(value,"%f",&magnesium);
			if (flag_NMDA)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (magnesium * 100.));
				XtSetValues(DeXInput_Magnesium, Darg, 1);
			} 
		} 
		if (!strcmp (parametre, "g_NMDA:"))
		{
			sscanf(value,"%f",&g_NMDA);
			if (flag_NMDA)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (g_NMDA * 100.));
				XtSetValues(DeXInput_G_NMDA, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "rev_pot_NMDA:"))
		{
			sscanf(value,"%f",&rev_pot_NMDA);
			if (flag_NMDA)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (rev_pot_NMDA * 100.));
				XtSetValues(DeXInput_E_NMDA, Darg, 1);
			} 
		} 
		if (!strcmp (parametre, "eta_NMDA:"))
		{
			sscanf(value,"%f",&eta_NMDA);
			if (flag_NMDA)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (eta_NMDA * 100.));
				XtSetValues(DeXInput_Eta_NMDA, Darg, 1);
			} 
		}
		if (!strcmp (parametre, "gamma_NMDA:"))
		{
			sscanf(value,"%f",&gamma_NMDA);
			if (flag_NMDA)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (gamma_NMDA * 100.));
				XtSetValues(DeXInput_Gamma_NMDA, Darg, 1);
			} 
		} 
		if (!strcmp (parametre, "tau_attack_NMDA:"))
		{
			sscanf(value,"%f",&tau_attack_NMDA);
			if (flag_NMDA)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (tau_attack_NMDA * 100.));
				XtSetValues(DeXInput_Tau_NMDA_A, Darg, 1);
			} 
		} 
		if (!strcmp (parametre, "tau_decay_NMDA:"))
		{
			sscanf(value,"%f",&tau_decay_NMDA);
			if (flag_NMDA)
			{
				XtSetArg(Darg[0], DeXNvalue, (int) (tau_decay_NMDA * 100.));
				XtSetValues(DeXInput_Tau_NMDA_D, Darg, 1);
			} 
		} 

		if (!strcmp(parametre, "Ca_Influx:"))	
			sscanf(value,"%f",&(Ca_Influx));

		if (!strcmp(parametre, "Ca_Removal:"))  
			sscanf(value,"%f",&(Ca_Removal));

		if (!strcmp(parametre, "Ca_Kd:"))  
			sscanf(value,"%f",&(Ca_Kd));

		if (!strcmp(parametre, "K_Ca_Kd:"))  
			sscanf(value,"%f",&(K_Ca_Kd));

		if (!strcmp(parametre, "lambda_Ik:"))  /* Constante dependant de la temperature */
			sscanf(value,"%f",&(lambda_Ik));

		if (!strcmp(parametre, "lambda_Ic:"))  /* Constante dependant de la temperature */
			sscanf(value,"%f",&(lambda_Ic));

		if (!strcmp(parametre, "lambda_Im:"))  /* Constante dependant de la temperature */
			sscanf(value,"%f",&(lambda_Im));

		if (!strcmp(parametre, "V_Na:")) /* V 1/2 pour le Na */
			sscanf(value,"%f",&(V_Na));
			
		if (!strcmp(parametre, "A_Na:")) /* coeff a pour le Na */
			sscanf(value,"%f",&(A_Na));
			
		if (!strcmp(parametre, "Pow_Na:")) /* Exposant pour le Na */
			sscanf(value,"%f",&(Pow_Na));
			
		if (!strcmp(parametre, "V_K:")) /* V 1/2 pour la K */
			sscanf(value,"%f",&(V_K));
			
		if (!strcmp(parametre, "A_K:")) /* coeff a pour le K */
			sscanf(value,"%f",&(A_K));
			
		if (!strcmp(parametre, "Pow_K:")) /* Exposant pour le K */
			sscanf(value,"%f",&(Pow_K));
			
		if (!strcmp(parametre, "V_Ca:")) /* V 1/2 pour la Ca */
			sscanf(value,"%f",&(V_Ca));
			
		if (!strcmp(parametre, "A_Ca:")) /* coeff a pour le Ca */
			sscanf(value,"%f",&(A_Ca));
			
		if (!strcmp(parametre, "Pow_Ca:")) /* Exposant pour le Ca */
			sscanf(value,"%f",&(Pow_Ca));
			
		if (!strcmp(parametre, "Tau_Ca:")) /* Cste de temps pour le Ca */
			sscanf(value,"%f",&(Tau_Ca));
			
#ifdef ADD_CURRENT

/*--------   To add a current modify and adapt   -------*/   

		if (!strcmp(parametre, "V_INew_A:")) /* V 1/2 pour INew activation */
			sscanf(value,"%f",&(V_INew_A));
			
		if (!strcmp(parametre, "A_INew_A:")) /* coeff a pour INew activation */
			sscanf(value,"%f",&(A_INew_A));
			
		if (!strcmp(parametre, "Pow_INew_A:")) /* Exposant pour INew activation */
			sscanf(value,"%f",&(Pow_INew_A));
			
		if (!strcmp(parametre, "Tau_INew_A:")) /* Cste de temps pour INew inactivation */
			sscanf(value,"%f",&(Tau_INew_A));

		if (!strcmp(parametre, "V_INew_B:")) /* V 1/2 pour INew inactivation */
			sscanf(value,"%f",&(V_INew_B));
			
		if (!strcmp(parametre, "A_INew_B:")) /* coeff a pour INew inactivation */
			sscanf(value,"%f",&(A_INew_B));
			
		if (!strcmp(parametre, "Pow_INew_B:")) /* Exposant pour INew inactivation */
			sscanf(value,"%f",&(Pow_INew_B));
			
		if (!strcmp(parametre, "Tau_INew_B:")) /* Cste de temps pour INew inactivation */
			sscanf(value,"%f",&(Tau_INew_B));

		if (!strcmp(parametre, "lambda_INew:"))  /* Constante dependant de la temperature */
			sscanf(value,"%f",&(lambda_INew));

#endif
		if (!strcmp(parametre, "V_Ia_A:")) /* V 1/2 pour Ia activation */
			sscanf(value,"%f",&(V_Ia_A));
			
		if (!strcmp(parametre, "A_Ia_A:")) /* coeff a pour Ia activation */
			sscanf(value,"%f",&(A_Ia_A));
			
		if (!strcmp(parametre, "Pow_Ia_A:")) /* Exposant pour Ia activation */
			sscanf(value,"%f",&(Pow_Ia_A));
			
		if (!strcmp(parametre, "V_Ia_B:")) /* V 1/2 pour Ia inactivation */
			sscanf(value,"%f",&(V_Ia_B));
			
		if (!strcmp(parametre, "A_Ia_B:")) /* coeff a pour Ia inactivation */
			sscanf(value,"%f",&(A_Ia_B));
			
		if (!strcmp(parametre, "Pow_Ia_B:")) /* Exposant pour Ia inactivation */
			sscanf(value,"%f",&(Pow_Ia_B));
			
		if (!strcmp(parametre, "Tau_Ia_B:")) /* Cste de temps pour Ia inactivation */
			sscanf(value,"%f",&(Tau_Ia_B));

		if (!strcmp(parametre, "V_Ic:")) /* V 1/2 pour Ia inactivation */
			sscanf(value,"%f",&(V_Ic));
			
		if (!strcmp(parametre, "A_Ic:")) /* coeff a pour Ia inactivation */
			sscanf(value,"%f",&(A_Ic));
			
		if (!strcmp(parametre, "V_Im:")) /* V 1/2 pour Ia inactivation */
			sscanf(value,"%f",&(V_Im));
			
		if (!strcmp(parametre, "A_Im:")) /* coeff a pour Ia inactivation */
			sscanf(value,"%f",&(A_Im));

		if (!strcmp(parametre, "V_Inap:")) /* V 1/2 pour Inap inactivation */
			sscanf(value,"%f",&(V_Inap));
			
		if (!strcmp(parametre, "A_Inap:")) /* coeff a pour Inap inactivation */
			sscanf(value,"%f",&(A_Inap));

		if (!strcmp(parametre, "Vm_Icab:")) /* V 1/2 pour Icab activation */
			sscanf(value,"%f",&(Vm_Icab));
			
		if (!strcmp(parametre, "Am_Icab:")) /* coeff a pour Icab activation */
			sscanf(value,"%f",&(Am_Icab));

		if (!strcmp(parametre, "Pow_m_cab:")) /* exposant pour Icab activation */
			sscanf(value,"%f",&(Pow_m_cab));

		if (!strcmp(parametre, "Vh_Icab:")) /* V 1/2 pour Icab inactivation */
			sscanf(value,"%f",&(Vh_Icab));
			
		if (!strcmp(parametre, "Ah_Icab:")) /* coeff a pour Icab inactivation */
			sscanf(value,"%f",&(Ah_Icab));

		if (!strcmp(parametre, "lambda_Inap:"))  /* Constante dependant de la temperature */
			sscanf(value,"%f",&(lambda_Inap));

		if (!strcmp(parametre, "lambda_Icab:"))  /* Constante dependant de la temperature */
			sscanf(value,"%f",&(lambda_Icab));

		if (!strcmp(parametre, "Tau_m_Cab:")) /* Cste de temps pour Ia inactivation */
			sscanf(value,"%f",&(tau_m_cab));

		if (!strcmp(parametre, "K_rest:")) /* * Potatium au repos */
			sscanf(value,"%f",&(K_rest));

		if (!strcmp(parametre, "V_Ih:")) /* V 1/2 pour Ih inactivation */
			sscanf(value,"%f",&(V_Ih));
			
		if (!strcmp(parametre, "A_Ih:")) /* coeff a pour Ih inactivation */
			sscanf(value,"%f",&(A_Ih));
			
		if (!strcmp(parametre, "lambda_Ih:"))  /* Constante dependant de la temperature */
			sscanf(value,"%f",&(lambda_Ih));

		if (!strcmp(parametre, "A_INa_A:"))
		        sscanf(value,"%f",&(A_INa_A));
		if (!strcmp(parametre, "A_INa_B:"))
			 sscanf(value,"%f",&(A_INa_B));
		if (!strcmp(parametre, "Tau_INa_A:"))
			 sscanf(value,"%f",&(Tau_INa_A));
		if (!strcmp(parametre, "Tau_INa_B:"))
			 sscanf(value,"%f",&(Tau_INa_B));
		if (!strcmp(parametre, "Pow_INa_A:"))
			 sscanf(value,"%f",&(Pow_INa_A));
		if (!strcmp(parametre, "Pow_INa_B:"))
			 sscanf(value,"%f",&(Pow_INa_B));
		if (!strcmp(parametre, "V_INa_A:"))
			 sscanf(value,"%f",&(V_INa_A));
		if (!strcmp(parametre, "V_INa_B:"))
			 sscanf(value,"%f",&(V_INa_B));
		

		/*  Initialisations */

		if (!strcmp(parametre, "m_ahp_init:"))
			sscanf(value,"%f",&(m_ahp_init));
		if (!strcmp(parametre, "m_K_init:"))
			sscanf(value,"%f",&(m_K_init));
		if (!strcmp(parametre, "le_potentiel_init:"))
			sscanf(value,"%f",&(le_potentiel_init));

		if (!strcmp(parametre, "le_potentiel_E_Na_init:"))
			sscanf(value,"%f",&(le_potentiel_E_Na_init));
		if (!strcmp(parametre, "le_potentiel_E_K_init:"))
			sscanf(value,"%f",&(le_potentiel_E_K_init));


		if (!strcmp(parametre, "m_Ca_init:"))
			sscanf(value,"%f",&(m_Ca_init));
		if (!strcmp(parametre, "Ca_i_init:"))
			sscanf(value,"%f",&(Ca_i_init));
		if (!strcmp(parametre, "h_A_init:"))
			sscanf(value,"%f",&(h_A_init));
		if (!strcmp(parametre, "h_Na_init:"))
			sscanf(value,"%f",&(h_Na_init));
		if (!strcmp(parametre, "m_Nap_init:"))
			sscanf(value,"%f",&(m_Nap_init));
		if (!strcmp(parametre, "m_Cab_init:"))
			sscanf(value,"%f",&(m_Cab_init));
		if (!strcmp(parametre, "m_Ih_init:"))
			sscanf(value,"%f",&(m_Ih_init));
		if (!strcmp(parametre, "h_Cab_init:"))
			sscanf(value,"%f",&(h_Cab_init));
#ifdef ADD_CURRENT

/*--------   To add a current modify and adapt   -------*/   

		if (!strcmp(parametre, "m_INew_init:"))
			sscanf(value,"%f",&(m_INew_init));
		if (!strcmp(parametre, "h_INew_init:"))
			sscanf(value,"%f",&(h_INew_init));

#endif
		if (!strcmp(parametre, "Nb_receptors:"))
		{
		        sscanf(value,"%d",&(nb_receptors));

			for (i= 0; i < nb_receptors; i++)
			{
			  fgets(buffer,80,file);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_tau_attack:"))
			     sscanf(value,"%f",&(Receptors[i]).tau_attack);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_tau_decay:"))
			     sscanf(value,"%f",&(Receptors[i]).tau_decay);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_g_Syn:"))
			     sscanf(value,"%f",&(Receptors[i]).g_Syn);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_rev_pot:"))
			     sscanf(value,"%f",&(Receptors[i]).rev_pot);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_transmittor:"))
			     sscanf(value,"%d",&(Receptors[i]).transmetteur);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_num_transm:"))
			     sscanf(value,"%d",&(Receptors[i]).num_transm);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_nom:"))
			     sscanf(value,"%s",&(Receptors[i]).nom);

			}
		}
		if (!strcmp(parametre, "Axone_transmittor:"))
			sscanf(value,"%d",&(neurotransmitor));

	}

	/* Update of selection buttons */


		sprintf(buffer,"G Na : %.3f",g_Na);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton1,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G Na pers: %.3f",g_Nap);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton2,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G K: %.3f",g_K);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton3,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G K for Ia: %.3f",g_A);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton4,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G K for Im: %.3f",g_M);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton5,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G K for Ic: %.3f",g_C);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton6,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G K for Ih: %.3f",g_H);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton23,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G K for Iahp: %.3f",g_ahp);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton7,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,False,NULL);

		sprintf(buffer,"G Ca HVA: %.3f",g_Ca);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton8,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G Ca LVA: %.3f",g_Cab);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton9,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G Leak: %.3f",g_fuite);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton10,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,False,NULL);

		sprintf(buffer,"G NMDA: %.3f",g_NMDA);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton11,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G Na Leak: %.3f",g_fuite_Na);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton24,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G K Leak: %.3f",g_fuite_K);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton24,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

#if 0
		sprintf(buffer,"G Syn EPSP: %.3f",g_Syn_pos);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton21,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

		sprintf(buffer,"G Syn IPSP: %.3f",g_Syn_neg);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton22,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

#endif
#ifdef ADD_CURRENT

/*--------   To add a current modify and adapt   -------*/   

		sprintf(buffer,"G INew: %.3f",g_New);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton24,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);

#endif

	if (saved_integration != integration_type)
	{
	  switch(saved_integration)
	  {
	  case EXPONENTIELLE:
	    DispMessageDialog(top_levelG,
			      "The neuron you just loaded was saved using\nthe EXPONENTIAL integration method",
			      "WARNING",XmDIALOG_MESSAGE);
	    break;
	  case RUNGE_KUTTA:
	    DispMessageDialog(top_levelG,
			      "The neuron you just loaded was saved using\nthe RUNGE-KUTTA integration method",
			      "WARNING",XmDIALOG_MESSAGE);
	    break;
	  case EULER:
	    DispMessageDialog(top_levelG,
			      "The neuron you just loaded was saved using\nthe EULER integration method",
			      "WARNING",XmDIALOG_MESSAGE);
	    break;
	  case RUNGE_KUTTA_VARIABLE_STEP:
	    DispMessageDialog(top_levelG,
			      "The neuron you just loaded was saved using\nthe RUNGE-KUTTA VARIABLE STEP integration method",
			      "WARNING",XmDIALOG_MESSAGE);
	    break;
	  }
	}

	if ( saved_model != model_type)
	{
	  switch(saved_model)
	  {
	  case MICHAELIS_MENTON_MODEL:
	    DispMessageDialog(top_levelG,
			      "The neuron you just loaded was saved using\ntheMICHAELIS-MENTON model",
			      "WARNING",XmDIALOG_MESSAGE);
	    break;
	  case HH_SIMPLE_MODEL:
	    DispMessageDialog(top_levelG,
			      "The neuron you just loaded was saved using\nthe HODGKIN-HUXLEY model",
			      "WARNING",XmDIALOG_MESSAGE);
	    break;
	  case HH_PUMP_MODEL:
	    DispMessageDialog(top_levelG,
			      "The neuron you just loaded was saved using\nthe PUMP model",
			      "WARNING",XmDIALOG_MESSAGE);
	    break;
	  }
	}
     }
     if (model_type == XNBC_MODEL ||
	 model_type == LEAKY_INTEG_MODEL||
	 model_type == COND_BURST_MODEL)
     {
#if DEBUG
	printf("Phenom: Model type : %d\n",model_type);
#endif
	while(fgets(buffer,80,file))
	{
		sscanf(buffer,"%s %s",parametre,value);

		if (!strcmp(parametre,"ModelType:"))	/* resting  potential	*/
		{
		    if (value[0] == 'B')
		    {
			  model_type = COND_BURST_MODEL;
		    }
		    if (value[0] == 'L')
		    {
			  model_type = LEAKY_INTEG_MODEL;
		    }
		    if (value[0] == 'P')
		    {
			  model_type = XNBC_MODEL;
		    }
		}
		if (!strcmp(parametre,"RestPotential:"))	/* resting  potential	*/
			sscanf(value,"%f",&p_rest_pot);
		if (!strcmp(parametre,"SpikeFrequency:"))	/* Pot mb post spike */
			sscanf(value,"%f",&freq_spike);
		if (!strcmp(parametre,"MaxSpikeFrequency:"))	/* cste de temps de la mb */
			sscanf(value,"%f",&freq_max);
		if (!strcmp(parametre,"ComposeFact:"))		/* firing threshold par cluster */
			sscanf(value,"%f",&compose_fact);
		if (!strcmp(parametre,"MinBurstDuration:"))		/* seuil apres un spike */
			sscanf(value,"%f",&duree_burst_min);
		if (!strcmp(parametre,"MaxBurstDuration:"))		/* Potentiel d'equilibre du potassium */
			sscanf(value,"%f",&duree_burst_max);
		if (!strcmp(parametre,"ModelType:"))		/* Potentiel d'equilibre du sodium */
			sscanf(value,"%c",&model_type);
		if (!strcmp(parametre,"Threshold:"))		/* seuil normal  */
			sscanf(value,"%f",&seuil);
		if (!strcmp(parametre,"ThresholdBurst:"))      	/* seuil burst  */
			sscanf(value,"%f",&seuil_burst);
		if (!strcmp(parametre,"NoiseMean:"))	/* Bruit de fond (moyenne) */
			sscanf(value,"%f",&backgrd_noise_m);
		if (!strcmp(parametre,"NoiseSd:"))	/* Bruit de fond (sd) */
			sscanf(value,"%f",&backgrd_noise_sd);
		if (!strcmp(parametre,"NoiseFilter:"))	/* Filtrage du bruit */
			sscanf(value,"%d",&filter_noise);
		if (!strcmp(parametre,"Capacity:"))	/* Capacite */
			sscanf(value,"%f",&capacite);
		if (!strcmp(parametre,"TimeStep:"))	/* TimeStep */
			sscanf(value,"%f",&time_step);
		if (!strcmp(parametre,"PostSpikePotential:"))	/* Pot mb post spike */
			sscanf(value,"%f",&pot_post_spike);
		if (!strcmp(parametre,"Adaptation:"))		/* seuil apres un spike */
			sscanf(value,"%f",&seuil_post_spike);
		if (!strcmp(parametre,"E_K:"))		/* Potentiel d'equilibre du potassium */
			sscanf(value,"%f",&E_K);
		if (!strcmp(parametre,"E_Na:"))		/* Potentiel d'equilibre du sodium */
			sscanf(value,"%f",&E_Na);
		if (!strcmp(parametre,"PosReversalPot:"))	/* Reversal Potential positif (pour epsp) */
			sscanf(value,"%f",&rev_pot_pos);
		if (!strcmp(parametre,"NegReversalPot:"))	/* Resersal Potential negatif (pour ipsp) */
			sscanf(value,"%f",&rev_pot_neg);
		if (!strcmp(parametre,"TimeCsteThreshold:"))	/* cste de temps du seuil apres un spike */
			sscanf(value,"%f",&tau_seuil);
		if (!strcmp(parametre,"TimeCsteMbPot:"))	/* cste de temps de la mb */
			sscanf(value,"%f",&tau_mb_pot);
		if (!strcmp(parametre,"EpspAttack:"))	/* conste de temps de montee */
			sscanf(value,"%f",&tau_attack_epsp);
		if (!strcmp(parametre,"EpspDecay:"))	/* conste de temps de descente */
			sscanf(value,"%f",&tau_decay_epsp);
		if (!strcmp(parametre,"IpspAttack:"))	/* conste de temps de montee */
			sscanf(value,"%f",&tau_attack_ipsp);
		if (!strcmp(parametre,"IpspDecay:"))	/* conste de temps de descente */
			sscanf(value,"%f",&tau_decay_ipsp);
		if (!strcmp(parametre,"BurstPostSpike:"))	/* conste de temps de descente */
			sscanf(value,"%f",&burst_post_spike);
		if (!strcmp(parametre,"MembraneShunt:"))/* constante de temps du shunt de la mb */
			sscanf(value,"%f",&shunt_tau);
		if (!strcmp(parametre,"FilterResistance:"))	/* time cste of the filter */
			sscanf(value,"%f",&resistance);
		if (!strcmp(parametre,"Fatigue:"))	/* fatigue du seuil */
			sscanf(value,"%f",&fatigue);
		if (!strcmp(parametre,"LessFatigue:"))	/* fatigue du seuil */
			sscanf(value,"%d",&less_fatigue);

		if (!strcmp(parametre, "Nb_receptors:"))
		{
		        sscanf(value,"%d",&(nb_receptors));

			for (i= 0; i < nb_receptors; i++)
			{
			  fgets(buffer,80,file);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_tau_attack:"))
			     sscanf(value,"%f",&(Receptors[i]).tau_attack);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_tau_decay:"))
			     sscanf(value,"%f",&(Receptors[i]).tau_decay);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_tau_a_psp:"))
			     sscanf(value,"%f",&(Receptors[i]).tau_a_psp);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_tau_d_psp:"))
			     sscanf(value,"%f",&(Receptors[i]).tau_d_psp);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_g_Syn:"))
			     sscanf(value,"%f",&(Receptors[i]).g_Syn);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_rev_pot:"))
			     sscanf(value,"%f",&(Receptors[i]).rev_pot);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_transmittor:"))
			     sscanf(value,"%d",&(Receptors[i]).transmetteur);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_num_transm:"))
			     sscanf(value,"%d",&(Receptors[i]).num_transm);

			  fgets(buffer,80,file);
			  sscanf(buffer, "%s %s", parametre, value);
			  if (!strcmp(parametre, "Receptor_nom:"))
			     sscanf(value,"%s",&(Receptors[i]).nom);
			}
		}
		if (!strcmp(parametre, "Axone_transmittor:"))
			sscanf(value,"%d",&(neurotransmitor));
	} /* fin du while */

	
	burst_range = duree_burst_max - duree_burst_min; 

	/* Update of selection buttons */

	/* Les radioBoxes */

	sprintf(buffer,"Resting potential: %.2f mV",p_rest_pot);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton1,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Firing threshold: %.2f mV",seuil);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton2,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Postspike potential: %.2f mV",pot_post_spike);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton3,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Postspike threshold: %.2f mV",seuil_post_spike);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton4,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Threshold fatigue: %.2f mV",fatigue);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton5,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Membrane time cste: %.2f ms",tau_mb_pot);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton6,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Threshold time cste: %.2f ms",tau_seuil);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton7,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Shunt time cste: %.2f ms",shunt_tau);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton8,XmNlabelString,string,NULL);
	XmStringFree(string);


	/* now the cond burster parameters */

	sprintf(buffer,"Burst threshold: %.2f mV",seuil_burst);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton9,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Postspike burst pot: %.2f mV",burst_post_spike);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton10,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Min burst duration: %.2f ms",duree_burst_min);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton11,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Max burst duration: %.2f ms",duree_burst_max);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton12,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Spike frequency: %.2f sp/s",freq_spike);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton13,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Max frequency: %.0f sp/s",freq_max);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton14,XmNlabelString,string,NULL);
	XmStringFree(string);

	sprintf(buffer,"Composition factor: %.0f",compose_fact);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton15,XmNlabelString,string,NULL);
	XmStringFree(string);

     }
     realloc_for_graphs();
     (*calcul_neuron)();
     (*draw_neuron)(0);
}

/*-----------------------------------------------------------------
 *      r e a d N e u r o n T m s
 *---------------------------------------------------------------*/
/* permet la lecture d'un fichier contenant les -------- d'un
   neurone, et la mise a jour des valeurs des Widgets DeXInput */

void readTmsInput (FILE *file)
  {
    Arg	    wargs[5];
    char    buffer[80], temps[50], type[30];
    int     n,j,k,type_trouve,number_of_type,max;
	
    XmString titre;

/*---------- calcul de l`espace memoire -----------*/
    max=1;
    for (k=0 ; k<nb_connexions ; k++)
      {
	if ((p_tms = fopen(nom_fichier_tms_input, "r")) == NULL)
	  {
	    sprintf(buffer,"ouverture du fichier %s impossible\n", nom_fichier_tms_input);
	    titre = XmStringCreateSimple(buffer);
	    n = 0;
	    XtSetArg(wargs[n], XmNx, 200);n++;
	      XtSetArg(wargs[n], XmNy, 400);n++;
	    XtSetArg(wargs[n], XmNmessageString, titre);n++;
	    
	    Zero_Time_Step_Tms = XmCreateWarningDialog(Form_G,
						       "zero_time_step_tms",wargs,n);
	    XmStringFree(titre);
	    XtManageChild(Zero_Time_Step_Tms);
	    return;
	    }
	number_of_type=0;
	  do
	    {
	      fgets(buffer,80,p_tms);
	      sscanf(buffer, "%s %s", temps, type);
	      j=atoi(type);
	      if (j==tab_type_value[k] ) {number_of_type++;}
	    }
	  while ( !feof(p_tms) );
	/*---- le max du type est trouve ----*/
	if (max<number_of_type) max=number_of_type;
	fclose(p_tms);
      } /* fin du for avec k */
    
    /*----- le max d`entre les types est trouve -----*/

    /*-------- allocation de la memoire --------*/
    realloc_mem_tab_syn(nb_connexions*max );
    realloc_mem_tab_transitoire(nb_connexions*max );
    realloc_mem_tab_tempo(nb_connexions*max );
    /* ----------- remplir le tableau -----------------*/
    number_of_event=0;
    for (k=0 ; k<nb_connexions ; k++)
      {
	if ((p_tms = fopen(nom_fichier_tms_input, "r")) == NULL)
	  {
	    sprintf(buffer,"ouverture du fichier %s impossible\n", nom_fichier_tms_input);
	    titre = XmStringCreateSimple(buffer);
	    n = 0;
	    XtSetArg(wargs[n], XmNx, 200);n++;
	    XtSetArg(wargs[n], XmNy, 400);n++;
	    XtSetArg(wargs[n], XmNmessageString, titre);n++;
	    Zero_Time_Step_Tms = XmCreateWarningDialog(Form_G,
						       "zero_time_step_tms",wargs,n);
	    XmStringFree(titre);
	    XtManageChild(Zero_Time_Step_Tms);
	    return;
	    }
	type_trouve=0;
	do
	    {
	      fgets(buffer,80,p_tms);
	      sscanf(buffer, "%s %s", temps, type);
	      if (atoi(type)==tab_type_value[k])
		{
		  tab_syn[number_of_event].t_arrivee = atof(temps);
		  tab_syn[number_of_event].weight = tab_type_ponderation[k];
		  number_of_event++;
		  type_trouve=1;
		}
	    }
	  while ( !feof(p_tms) );
	if (!type_trouve)
	  {
	   sprintf(buffer1,"%d PSP # No event! # ", (int)(k+1));
	   XtSetArg(wargs[0], DeXNlabelString, buffer1);n++;
	   XtSetValues(DeXInput_Type_Buttons[k],wargs,1);
	  }
	else
	  {
	   sprintf(buffer1,"%d PSP type of event", (int)(k+1));
	   XtSetArg(wargs[0], DeXNlabelString, buffer1);n++;
	   XtSetValues(DeXInput_Type_Buttons[k],wargs,1);    
	  }
      } /* fin du for avec k */
    /* ------- fin du remplissage ------ */
  }


/*----------------------------------------------------------------
 *      w r i t e N e u r o n T m s
 *--------------------------------------------------------------*/
 
/* sauvegarde des spikes detectees d'un neurone dans le fichier file */
void writeTmsOutput (FILE *file)
{
  int i;
  if (flag_Tms_Output)
    {
      for (i=1;i<table_size;i++)
	{
	  if (*(les_spikes +i)==1)
	    {
	      fprintf(p_tms,"%.3f 1\n",i * time_step);		
	    }
	}
      
    }
}


void	save_currentstms()
{
	int	i;

	char	* pc,
		buffer[80],
		file_currents[60];

	FILE	*p_currents;

	strcpy(file_currents,nom_fichier_tms_output);
	if (pc = strrchr(file_currents,'.'))
	{
		*pc = 0;
	} /* fin du if */
	strcat(file_currents,".tms");

	if ((p_currents = fopen(file_currents,"w")) == NULL)
	{
		printf("%s file impossible to open\n",file_currents);
		return;
	} /* fin du if */
	
	writeTmsOutput(p_currents);
	fclose(p_currents);

}


/*----------------------------------------------------------------
 *      w r i t e N e u r o n
 *--------------------------------------------------------------*/
 
/* sauvegarde des parametres d'un neurone dans le fichier file */

void writeNeuron( FILE	*file)
 /* rem : le diametre doit etre ecrit en premier : la surface doit etre
    calculee en premier lors de la lecture, pour pouvoir mettre a jour
    correctement les valeurs des Widgets de conductance			*/
{
        int i;

     if (model_type == MICHAELIS_MENTON_MODEL ||
	 model_type == HH_SIMPLE_MODEL)
     {

        surface = 4 * PI * (0.5 * diametre * 1e-4) * (0.5 * diametre * 1e-4);
	fprintf (file, "diametre: %15.14f\n", diametre);
	fprintf (file, "TauDecayCa: %15.14f\n", tau_decay_Ca);
	fprintf (file, "spike_slope: %15.3f\n", spike_slope);
	fprintf (file, "TimeStep: %15.14f\n", time_step);

	switch(integration_type)
	{
	       case EXPONENTIELLE :
		       	fprintf (file, "Integration: Exponentielle\n");
		       	break;
	       case RUNGE_KUTTA :
		       	fprintf (file, "Integration: Runge-Kutta\n");
		       	break;
	       case RUNGE_KUTTA_VARIABLE_STEP :
		       	fprintf (file, "Integration: Runge-Kutta_variable_step\n");
		       	break;
	       case EULER :
		       	fprintf (file, "Integration: Euler\n");
		       	break;
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
	       case INT_METHOD :
		       	fprintf (file, "Integration: Int_method\n");
		       	break;
#endif
	}
	switch(model_type)
	{
	       case MICHAELIS_MENTON_MODEL :
		       	fprintf (file, "Model_Type: Michaelis_Menton\n");
		       	break;
	       case HH_SIMPLE_MODEL :
		       	fprintf (file, "Model_Type: Hodgkin_Huxley\n");
		       	break;
	       case HH_PUMP_MODEL :
		       	fprintf (file, "Model_Type: Hodgkin_Huxley_with_pump\n");
		       	break;
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new model */
	       case NEW_MODEL :
		       	fprintf (file, "Model_Type: new_model\n");
		       	break;
#endif
	}

	fprintf (file, "Temp: %15.14f\n", Temp);
	fprintf (file, "Na_ext: %15.14f\n", Na_ext);
	fprintf (file, "Na_int: %15.14f\n", Na_int);
	fprintf (file, "K_ext: %15.14f\n", K_ext);
	fprintf (file, "K_int: %15.14f\n", K_int);
	fprintf (file, "K_rest: %15.10f\n", K_rest);
	fprintf (file, "Cl_ext: %15.14f\n", Cl_ext);
	fprintf (file, "Cl_int: %15.14f\n", Cl_int);


	fprintf (file, "E_Ca: %15.14f\n", E_Ca);
	fprintf (file, "E_Cl: %15.14f\n", E_Cl);
/*
	fprintf (file, "E_H: %15.14f\n", E_H);
*/
	fprintf (file, "PosReversalPot: %15.14f\n", rev_pot_pos);
	fprintf (file, "NegReversalPot: %15.14f\n", rev_pot_neg);
	fprintf (file, "E_fuite: %15.14f\n", E_fuite);
	fprintf (file, "g_Na: %15.14f\n", g_Na);
	fprintf (file, "g_K: %15.14f\n", g_K);
	fprintf (file, "g_Ca: %15.14f\n", g_Ca);
	fprintf (file, "g_Cl: %15.14f\n", g_Cl);
	fprintf (file, "g_A: %15.14f\n", g_A);
	fprintf (file, "g_M: %15.14f\n", g_M);
	fprintf (file, "g_C: %15.14f\n", g_C);
	fprintf (file, "g_ahp: %15.14f\n", g_ahp);
	fprintf (file, "g_Nap: %15.14f\n", g_Nap);
	fprintf (file, "g_Cab: %15.14f\n", g_Cab);
	fprintf (file, "g_H: %15.14f\n", g_H);
	fprintf (file, "g_fuite: %15.14f\n", g_fuite);
	fprintf (file, "g_fuite_Na: %15.14f\n", g_fuite_Na);
	fprintf (file, "g_fuite_K: %15.14f\n", g_fuite_K);
	fprintf (file, "g_Syn_pos: %15.14f\n", g_Syn_pos);
	fprintf (file, "g_Syn_neg: %15.14f\n", g_Syn_neg);
	fprintf (file, "capacite: %15.14f\n", capacite);

	fprintf (file, "input_fact: %15.14f\n", input_fact);
	fprintf (file, "tau_attack_epsp: %15.14f\n",tau_attack_epsp);
	fprintf (file, "tau_decay_epsp: %15.14f\n",tau_decay_epsp);
	fprintf (file, "tau_attack_ipsp: %15.14f\n",tau_attack_ipsp);
	fprintf (file, "tau_decay_ipsp: %15.14f\n",tau_decay_ipsp);
	fprintf (file, "Ca_i: %15.14f\n", Ca_i);

	fprintf (file, "NoiseMean: %15.14f\n", 	backgrd_noise_m);
	fprintf (file, "NoiseSd: %15.14f\n", 	backgrd_noise_sd);
	fprintf (file, "magnesium: %15.14f\n", magnesium);
	fprintf (file, "g_NMDA: %15.14f\n", g_NMDA);
	fprintf (file, "rev_pot_NMDA: %15.14f\n", rev_pot_NMDA);
	fprintf (file, "eta_NMDA: %15.14f\n", eta_NMDA);
	fprintf (file, "gamma_NMDA: %15.14f\n", gamma_NMDA);
	fprintf (file, "tau_attack_NMDA: %15.14f\n", tau_attack_NMDA);
	fprintf (file, "tau_decay_NMDA: %15.14f\n", tau_decay_NMDA);

	fprintf (file, "Ca_Influx: %15.10f\n", Ca_Influx);
	fprintf (file, "Ca_Removal: %15.10f\n", Ca_Removal);
	fprintf (file, "Ca_Kd: %15.10f\n", Ca_Kd);
	fprintf (file, "K_Ca_Kd: %15.10f\n", K_Ca_Kd);
	fprintf (file, "lambda_Ik: %15.10f\n", lambda_Ik);
	fprintf (file, "V_Na: %15.10f\n", V_Na);
	fprintf (file, "A_Na: %15.10f\n", A_Na);
	fprintf (file, "Pow_Na: %15.10f\n", Pow_Na);
	fprintf (file, "V_K: %15.10f\n", V_K);
	fprintf (file, "A_K: %15.10f\n", A_K);
	fprintf (file, "Pow_K: %15.10f\n", Pow_K);
	fprintf (file, "V_Ca: %15.10f\n", V_Ca);
	fprintf (file, "A_Ca: %15.10f\n", A_Ca);
	fprintf (file, "Pow_Ca: %15.10f\n", Pow_Ca);
	fprintf (file, "Tau_Ca: %15.10f\n", Tau_Ca);

	fprintf (file, "V_Ia_A: %15.10f\n", V_Ia_A);
	fprintf (file, "A_Ia_A: %15.10f\n", A_Ia_A);
	fprintf (file, "Pow_Ia_A: %15.10f\n", Pow_Ia_A);
	fprintf (file, "V_Ia_B: %15.10f\n", V_Ia_B);
	fprintf (file, "A_Ia_B: %15.10f\n", A_Ia_B);
	fprintf (file, "Pow_Ia_B: %15.10f\n", Pow_Ia_B);
	fprintf (file, "Tau_Ia_B: %15.10f\n", Tau_Ia_B);

	fprintf (file, "V_Ic: %15.10f\n", V_Ic);
	fprintf (file, "A_Ic: %15.10f\n", A_Ic);
	fprintf (file, "lambda_Ic: %15.10f\n", lambda_Ic);

	fprintf (file, "V_Im: %15.10f\n", V_Im);
	fprintf (file, "A_Im: %15.10f\n", A_Im);
	fprintf (file, "lambda_Im: %15.10f\n", lambda_Im);

	fprintf (file, "V_Inap: %15.10f\n", V_Inap);
	fprintf (file, "A_Inap: %15.10f\n", A_Inap);
	fprintf (file, "lambda_Inap: %15.10f\n", lambda_Inap);

	fprintf (file, "Vm_Icab: %15.10f\n", Vm_Icab);
	fprintf (file, "Am_Icab: %15.10f\n", Am_Icab);
	fprintf (file, "Pow_m_cab: %15.10f\n", Pow_m_cab);
	fprintf (file, "lambda_Icab: %15.10f\n", lambda_Icab);
	fprintf (file, "Tau_m_Cab: %15.10f\n", tau_m_cab);

	fprintf (file, "Vh_Icab: %15.10f\n", Vh_Icab);
	fprintf (file, "Ah_Icab: %15.10f\n", Ah_Icab);

	fprintf (file, "V_Ih: %15.10f\n", V_Ih);
	fprintf (file, "A_Ih: %15.10f\n", A_Ih);
	fprintf (file, "lambda_Ih: %15.10f\n", lambda_Ih);

	fprintf (file, "V_INa_A: %15.10f\n", V_INa_A);
	fprintf (file, "A_INa_A: %15.10f\n", A_INa_A);
	fprintf (file, "Pow_INa_A: %15.10f\n", Pow_INa_A);
	fprintf (file, "Tau_INa_A: %15.10f\n", Tau_INa_A);
	fprintf (file, "V_INa_B: %15.10f\n", V_INa_B);
	fprintf (file, "A_INa_B: %15.10f\n", A_INa_B);
	fprintf (file, "Pow_INa_B: %15.10f\n", Pow_INa_B);
	fprintf (file, "Tau_INa_B: %15.10f\n", Tau_INa_B);

	fprintf (file, "m_ahp_init: %15.10f\n",m_ahp_init);
	fprintf (file, "m_K_init: %15.10f\n", m_K_init);
	fprintf (file, "le_potentiel_init: %15.10f\n", le_potentiel_init);
	
	fprintf (file, "le_potentiel_E_Na_init: %15.10f\n", le_potentiel_E_Na_init);
	fprintf (file, "le_potentiel_E_K_init: %15.10f\n", le_potentiel_E_K_init);
	
	
	fprintf (file, "m_Ca_init: %15.10f\n", m_Ca_init);
	fprintf (file, "Ca_i_init: %15.10f\n", Ca_i_init);
	fprintf (file, "h_A_init: %15.10f\n", h_A_init);
	fprintf (file, "h_Na_init: %15.10f\n", h_Na_init);
	fprintf (file, "m_Nap_init: %15.10f\n", m_Nap_init);
	fprintf (file, "m_Cab_init: %15.10f\n", m_Cab_init);
	fprintf (file, "m_Ih_init: %15.10f\n", m_Ih_init);
	fprintf (file, "h_Cab_init: %15.10f\n", h_Cab_init);

#ifdef ADD_CURRENT

/*--------   To add a current modify and adapt   -------*/   
	fprintf (file, "%f\n",g_New);
	fprintf (file, "%f\n",E_New);
	fprintf (file, "%f\n",V_INew_A);
	fprintf (file, "%f\n",A_INew_A);
	fprintf (file, "%f\n",Pow_INew_A);
	fprintf (file, "%f\n",Tau_INew_A);
	fprintf (file, "%f\n",V_INew_B);
	fprintf (file, "%f\n",A_INew_B);
	fprintf (file, "%f\n",Pow_INew_B);
	fprintf (file, "%f\n",Tau_INew_B);
	fprintf (file, "%f\n",lambda_INew);
	fprintf (file, "%f\n",m_INew_init);
	fprintf (file, "%f\n",h_INew_init);
#endif
	fprintf (file, "Axone_transmittor: %d\n",neurotransmitor);
	fprintf (file, "Nb_receptors: %d\n",nb_receptors);

	for (i= 0; i < nb_receptors; i++)
	{
	  fprintf (file, "#Receptor %d\n",i);
	  fprintf (file, "Receptor_tau_attack: %15.10f\n",Receptors[i].tau_attack);
	  fprintf (file, "Receptor_tau_decay: %15.10f\n",Receptors[i].tau_decay);
	  fprintf (file, "Receptor_tau_a_psp: %15.10f\n",Receptors[i].tau_a_psp);
	  fprintf (file, "Receptor_tau_d_ps: %15.10f\n",Receptors[i].tau_d_psp);
	  fprintf (file, "Receptor_g_Syn: %15.10f\n",Receptors[i].g_Syn);
	  fprintf (file, "Receptor_rev_pot: %15.10f\n",Receptors[i].rev_pot);
	  fprintf (file, "Receptor_transmittor: %d\n",Receptors[i].transmetteur);
	  fprintf (file, "Receptor_num_transm: %d\n",Receptors[i].num_transm);
	  fprintf (file, "Receptor_nom: %s\n",Receptors[i].nom);
	}
     }
     if (model_type == XNBC_MODEL ||
	 model_type == LEAKY_INTEG_MODEL ||
	 model_type == COND_BURST_MODEL)
     {
        if (model_type == COND_BURST_MODEL)
		fprintf(file,"ModelType: B\n");
        if (model_type == LEAKY_INTEG_MODEL)
		fprintf(file,"ModelType: L\n");
        if (model_type == XNBC_MODEL)
	        fprintf(file,"ModelType: P\n");
       	fprintf(file,"RestPotential: %.4f\n",p_rest_pot);
        if (model_type == COND_BURST_MODEL)
	{
		fprintf(file,"FreqSpike: %.4f\n",freq_spike);
		fprintf(file,"FreqMax: %.4f\n",freq_max);
		fprintf(file,"ComposeFact: %.4f\n",compose_fact);
		fprintf(file,"DureeBurstMin: %.4f\n",duree_burst_min);
		fprintf(file,"DureeBurstMax: %.4f\n",duree_burst_max);
		fprintf(file,"ThresholdBurst: %.4f\n",seuil_burst);
		fprintf(file,"BurstPostSpike: %.4f\n",burst_post_spike);
	}
	fprintf(file,"TimeCsteMbPot: %.4f\n",tau_mb_pot);
	fprintf(file,"Threshold: %.4f\n",seuil);
	fprintf(file,"NoiseMean: %.4f\n",backgrd_noise_m);
	fprintf(file,"NoiseSd: %.4f\n",backgrd_noise_sd);
	fprintf(file,"NoiseFilter: %d\n",filter_noise);
	fprintf(file,"Capacity: %.10f\n",capacite);
	fprintf(file,"TimeStep: %.3f\n",time_step);
	fprintf(file,"PostSpikePotential: %.4f\n",pot_post_spike);
	fprintf(file,"Adaptation: %.4f\n",seuil_post_spike);
	fprintf(file,"E_K: %.4f\n",E_K);
	fprintf(file,"E_Na: %.4f\n",E_Na);
	fprintf(file,"PosReversalPot: %.4f\n",rev_pot_pos);
	fprintf(file,"NegReversalPot: %.4f\n",rev_pot_neg);
	fprintf(file,"TimeCsteThreshold: %.4f\n",tau_seuil);
	if (model_type == XNBC_MODEL ||
	    model_type == COND_BURST_MODEL)
	{
	  fprintf(file,"EpspAttack: %.4f\n",tau_attack_epsp);
	  fprintf(file,"EpspDecay: %.4f\n",tau_decay_epsp);
	  fprintf(file,"IpspAttack: %.4f\n",tau_attack_ipsp);
	  fprintf(file,"IpspDecay: %.4f\n",tau_decay_ipsp);
	  fprintf(file,"MembraneShunt: %.4f\n",shunt_tau);
	}
	fprintf(file,"FilterResistance: %.3f\n",resistance);
	fprintf(file,"Fatigue: %.3f\n",fatigue);
	fprintf(file,"LessFatigue: %d\n",less_fatigue);
	fprintf (file, "Axone_transmittor: %d\n",neurotransmitor);
	fprintf (file, "Nb_receptors: %d\n",nb_receptors);
	for (i= 0; i < nb_receptors; i++)
	{
	  fprintf (file, "#Receptor %d\n",i);
	  fprintf (file, "Receptor_tau_attack: %15.10f\n",Receptors[i].tau_attack);
	  fprintf (file, "Receptor_tau_decay: %15.10f\n",Receptors[i].tau_decay);
	  fprintf (file, "Receptor_g_Syn: %15.10f\n",Receptors[i].g_Syn);
	  fprintf (file, "Receptor_rev_pot: %15.10f\n",Receptors[i].rev_pot);
	  fprintf (file, "Receptor_transmittor: %d\n",Receptors[i].transmetteur);
	  fprintf (file, "Receptor_num_transm: %d\n",Receptors[i].num_transm);
	  fprintf (file, "Receptor_nom: %s\n",Receptors[i].nom);
	}
     }

     file_saved = TRUE;
}




/*--------------------------------------------------------------------
 *      p l o t _ p o t _ c o n d u c t
 *------------------------------------------------------------------*/
/* plot_pot permet de creer un fichier PostScript pour les potentiels
  et les courants */

#include	"G_reference.h"
#include	<plot_ps.h>

void	plot_pot_conduct()
{
	int	i,
		duree_simul_in_step;
		
	float	x_scale,
		y_scale,
		upper_x,
		lower_x;

	float	* pot,
		* ramp,
		* temps,
		* sodium,
		* potassium,
		* potassium_c,
		* calcium,
		* conc_calcium,
		* potassium_a,
		* potassium_m,
		* potassium_ahp,
		* calcium_bas,
		* potassium_h,
#ifdef ADD_CURRENT

/*--------   To add a current modify and adapt   -------*/   
		* new,
#endif
		* na_prolong;

	char	* pc,
		buffer[80],
		file_ps[256];

	extern	REFERENCE	ref1, ref2, ref3;

	duree_simul_in_step = (int)((float)duree_simul / time_step);
	table_size = (int) ((float)(duree_simul + 2) / time_step) + 2;

	pot           = (float *) calloc (table_size, sizeof (float));
	ramp          = (float *) calloc (table_size, sizeof (float));
	temps         = (float *) calloc (table_size, sizeof (float));
	sodium        = (float *) calloc (table_size, sizeof (float));
	potassium     = (float *) calloc (table_size, sizeof (float));
	potassium_c   = (float *) calloc (table_size, sizeof (float));
	calcium       = (float *) calloc (table_size, sizeof (float));
	conc_calcium  = (float *) calloc (table_size, sizeof (float));
	potassium_a   = (float *) calloc (table_size, sizeof (float));
	potassium_m   = (float *) calloc (table_size, sizeof (float));
	potassium_ahp = (float *) calloc (table_size, sizeof (float));
	potassium_h   = (float *) calloc (table_size, sizeof (float));
	calcium_bas   = (float *) calloc (table_size, sizeof (float));
	na_prolong    = (float *) calloc (table_size, sizeof (float));
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/   
	new = (float *) calloc (table_size, sizeof (float));
#endif

	for ( i = 1; i < duree_simul_in_step; i++)
	{
		* ( temps + i)         = (float)i;
		* ( pot + i)           = * ( potentiel + i)    - ref1.lower_y;
		* ( ramp + i)          = * ( ramp_input + i)   - ref1.lower_y;
		* ( potassium + i)     = * ( courant_K + i)    - ref2.lower_y;
		* ( sodium + i)        = * ( courant_Na + i)   - ref2.lower_y;
		* ( potassium_c + i)   = * ( courant_Ic + i)   - ref2.lower_y;
		* ( potassium_ahp + i) = * ( courant_Iahp + i) - ref2.lower_y;
		* ( na_prolong + i)    = * ( courant_Nap + i)  - ref2.lower_y;
		* ( calcium_bas + i)   = * ( courant_Cab + i)  - ref3.lower_y;
		* ( potassium_a + i)   = * ( courant_Ia + i)   - ref3.lower_y;
		* ( potassium_m + i)   = * ( courant_Im + i)   - ref3.lower_y;
		* ( potassium_h + i)   = * ( courant_Ih + i)   - ref3.lower_y;
		* ( calcium + i)       = * ( courant_Ca + i)   - ref3.lower_y;
		* ( conc_calcium + i)  = * ( Ca + i)           - ref3.lower_y;
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/   

		* ( new + i)           = * ( cou rant_INew + i )  - ref3.lower_y;
#endif
	} /* fin du for */

	strcpy(file_ps,nom_fichier_neuron);
	if (pc = strrchr(file_ps,'.'))
	{
		*pc = 0;
	} /* fin du if */
	strcat(file_ps,"_G_unit.ps");

	ps_iniplot(file_ps,30.);
	ps_scale (0.85,0.85);
/*	ps_queue_name ("postscript"); */

/*------ e c r i t u r e   d e s   v a l e u r s  ------------------ */


	ps_writeah (16., 4, "Na_ext(m.moles/l): ", 0.3);
	sprintf(buffer, "%.2f",Na_ext);
	ps_writeah (20., 4, buffer, 0.3);

	ps_writeah (1.5, 3.5, "Na_int(m.moles/l): ", 0.3);
	sprintf(buffer, "%.2f",Na_int);
	ps_writeah (4.5, 3.5, buffer, 0.3);

	ps_writeah (6., 3.5, "K_ext(m.moles/l): ", 0.3);
	sprintf(buffer, "%.2f",K_ext);
	ps_writeah (9.5, 3.5, buffer, 0.3);

	ps_writeah (11., 3.5, "K_int(m.moles/l): ", 0.3);
	sprintf(buffer, "%.2f",K_int);
	ps_writeah (14.5, 3.5, buffer, 0.3);

	ps_writeah (16., 3.5, "Temperature(Deg C): ", 0.3);
	sprintf(buffer, "%.2f",Temp);
	ps_writeah (20., 3.5, buffer, 0.3);




	ps_writeah (1.5, 3., "Rest Pot (mV): ", 0.3);
	sprintf(buffer, "%.0f", rest_pot);
	ps_writeah (4.5, 3.,buffer, 0.3);

	ps_writeah (6., 3., "Mb Capa. (uF/cm2): ", 0.3);
	sprintf(buffer, "%.2f",capacite);
	ps_writeah (9.5, 3.,buffer, 0.3);

	ps_writeah (11., 3., "Input Crt (uA/cm2): ", 0.3);
	sprintf(buffer, "%.2f",input_fact);
	ps_writeah (14.5, 3.,buffer, 0.3);

	ps_writeah (16., 3., "Step (ms): ", 0.3);
	sprintf(buffer, "%.3f",time_step);
	ps_writeah (20., 3., buffer, 0.3);

	ps_writeah (1.5, 2.5, "E_Na (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_Na);
	ps_writeah (4.5, 2.5, buffer, 0.3);

	ps_writeah (6., 2.5, "E_Ca (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_Ca);
	ps_writeah (9.5, 2.5, buffer, 0.3);

	ps_writeah (11., 2.5, "E_K (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_K);
	ps_writeah (14.5, 2.5, buffer, 0.3);

	ps_writeah (16., 2.5, "E_fuite (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_fuite);
	ps_writeah (20., 2.5, buffer, 0.3);

	ps_writeah (1.5, 2., "g_Na (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f", g_Na);
	ps_writeah (4.5, 2., buffer, 0.3);

	ps_writeah (6., 2., "g_Ca (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_Ca);
	ps_writeah (9.5, 2., buffer, 0.3);

	ps_writeah (11., 2., "g_fuite (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_fuite);
	ps_writeah (14.5, 2., buffer, 0.3);

	ps_writeah (16., 2., "g_Syn_pos (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_Syn_pos);
	ps_writeah (20., 2., buffer, 0.3);

	ps_writeah (1.5, 1.5, "g_K (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_K);
	ps_writeah (4.5, 1.5, buffer, 0.3);

	ps_writeah (6., 1.5, "g_Ka (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_A);
	ps_writeah (9.5, 1.5, buffer, 0.3);

	ps_writeah (11., 1.5, "g_Km (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_M);
	ps_writeah (14.5, 1.5, buffer, 0.3);

	ps_writeah (16., 1.5, "g_Kahp (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_ahp);
	ps_writeah (20., 1.5, buffer, 0.3);

	ps_writeah (1.5, 1., "g_Kc (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_C);
	ps_writeah (4.5, 1., buffer, 0.3);

	ps_writeah (6., 1., "g_NMDA (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_NMDA);
	ps_writeah (9.5, 1., buffer, 0.3);

	ps_writeah (11., 1., "Mg (mM): ", 0.3);
	sprintf(buffer, "%.2f",magnesium);
	ps_writeah (14.5, 1., buffer, 0.3);

	ps_writeah (16., 1., "E_Mg (mV): ", 0.3);
	sprintf(buffer, "%.2f",rev_pot_NMDA);
	ps_writeah (20., 1., buffer, 0.3);

	ps_writeah (1.5, .5, "g_Na_P (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_Nap);
	ps_writeah (4.5, .5, buffer, 0.3);

	ps_writeah (6., .5, "g_Ca_LVA (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_Cab);
	ps_writeah (9.5, .5, buffer, 0.3);

	ps_writeah (11., .5, "E_H (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_H);
	ps_writeah (14.5, .5, buffer, 0.3);

	ps_writeah (16., .5, "g_H (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_H);
	ps_writeah (20., .5, buffer, 0.3);

	ps_writeah (11., 2., "g_fuite_Na (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_fuite_Na);
	ps_writeah (14.5, 2., buffer, 0.3);

	ps_writeah (11., 2., "g_fuite_K (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_fuite_K);
	ps_writeah (14.5, 2., buffer, 0.3);


#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/

/*--------   Adapt the position of the writing    -------*/

	ps_writeah (1.5, .0, "g_New (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_H);
	ps_writeah (4.5, .0, buffer, 0.3);

#endif
/*-- t r a c e  d e s  c o u r a n t s  C a   I a   I m   I a h p --*/

	ps_origin(4.,4.7,0.,0.);

	x_scale = 14./((ref3.upper_x - ref3.lower_x) / time_step);
	y_scale = 6./(ref3.upper_y - ref3.lower_y);

	ps_echel(x_scale,y_scale,0.,0.,1.,0.);


	ps_writeah(3.5, 6.5,"Evolution of I_Ca_HVA, I_Ca_LVA, I_A, I_m and[ Ca++]",
		   .4);

	ps_font("Times-Roman",.3);

	lower_x = ref3.lower_x / time_step;
	upper_x = ref3.upper_x / time_step;

	ps_movea(0.,0.);
	ps_user();

	ps_pen(0);
	ps_set_rgb_color (1., 0.54, 1.); /* mauve */
	ps_movea(0.,0.);
	ps_polyline(temps,calcium,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 6.5, "I_Ca_HVA", 0.3);

	ps_set_rgb_color (0., 0.84, 1.); /* turquoise */
	ps_movea(0.,0.);
	ps_polyline(temps,calcium_bas,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 6.5, "I_Ca_LVA", 0.3);

	ps_set_rgb_color (0.,0.84,0.); /* vert */
	ps_movea(0.,0.);
	ps_polyline(temps,potassium_a,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 6., "I_A", 0.3);

	ps_set_rgb_color (0.77, 0., 1.); /* violet */
	ps_movea(0.,0.);
	ps_polyline(temps,potassium_m,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 5., "I_M", 0.3);

	ps_set_rgb_color (0., 0., 1.); /* bleu */
	ps_movea(0.,0.);
	ps_polyline(temps,conc_calcium,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 4.5, "[Ca++]", 0.3);

	ps_set_rgb_color (1., 0., 0.); /* rouge */
	ps_movea(0.,0.);
	ps_polyline(temps,potassium_h,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 4., "I_h", 0.3);

	ps_set_rgb_color(0.,0.,0.); /* noir */

	x_scale = 14./(ref3.upper_x - ref3.lower_x);
	ps_echel(x_scale,y_scale,0.,0.,1.,0.);
	ps_movea(0.,0.);
	ps_ticked_axes(ref3.lower_x,ref3.lower_y,
		       ref3.lower_x,ref3.upper_x,
		       ref3.lower_x,ref3.upper_x,
		       ref3.lower_y,ref3.upper_y,
		       ref3.lower_y,ref3.upper_y,
		       0.1," Time (ms)","%.3f"," I (uA/cm2)","%.1f",0.3,0);

	
/*-----  t r a c e   d e s   c o u r a n t s  N a   K  e t  I c -----*/

	ps_origin(0., 8.5,0.,0.);

	x_scale = 14./((ref2.upper_x - ref2.lower_x) / time_step);
	y_scale = 6./(ref2.upper_y - ref2.lower_y);

	ps_echel(x_scale,y_scale,0.,0.,1.,0.);

	ps_set_rgb_color(0.,0.,0.); /* noir */
	
	ps_writeah(3.5, 6.5,"Evolution of I_Na, I_K, I_C",.4);

	ps_font("Times-Roman",.3);

	ps_movea(0.,0.);

	lower_x = ref2.lower_x / time_step;
	upper_x = ref2.upper_x / time_step;


	ps_user();
	ps_pen(0);

	ps_set_rgb_color (1.,0.,0.); /* rouge */
	ps_movea(0.,0.);
	ps_polyline(temps,sodium,duree_simul_in_step,FALSE,0,0.);
	ps_writeah(13.5,6.5,"I_Na",0.3);

	ps_set_rgb_color (0.,0.,1.); /* bleu */
	ps_movea(0.,0.);
	ps_polyline(temps,potassium,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 6., "I_K", 0.3);

	ps_set_rgb_color (0.68,1.,0.19); /* jaune */
	ps_movea(0.,0.);
	ps_polyline(temps,potassium_c,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 5.5, "I_C", 0.3);

	ps_set_rgb_color (0., 0.84, 1.); /* turquoise */
	ps_movea(0.,0.);
	ps_polyline(temps,potassium_ahp,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 5.5, "I_ahp", 0.3);

	ps_set_rgb_color (0.,0.84,0.); /* vert */
	ps_movea(0.,0.);
	ps_polyline(temps,na_prolong,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 5.5, "I_Na_pers", 0.3);

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/   
	ps_set_rgb_color (0.77,0.,1.); /* violet */
	ps_movea(0.,0.);
	ps_polyline(temps,new,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 5.8, "I_New", 0.3);

#endif

	ps_set_rgb_color(0.,0.,0.); /* noir */

	x_scale = 14./(ref2.upper_x - ref2.lower_x);
	ps_echel(x_scale,y_scale,0.,0.,1.,0.);
	ps_movea(0.,0.);
	ps_ticked_axes(ref2.lower_x,ref2.lower_y,
		       ref2.lower_x,ref2.upper_x,
		       ref2.lower_x,ref2.upper_x,
		       ref2.lower_y,ref2.upper_y,
		       ref2.lower_y,ref2.upper_y,
		       0.1," Time (ms)","%.3f"," I (uA/cm2)","%.1f",0.3,0);

/*---- t r a c e  d u  p o t e n ti e l  e t  d e  l ' i n p u t ----*/

	ps_origin(0.,8.5,0.,0.);

	x_scale = 14./((ref1.upper_x - ref1.lower_x) / time_step);
	y_scale = 6./(ref1.upper_y - ref1.lower_y);

	ps_echel(x_scale,y_scale,0.,0.,1.,0.);

	ps_set_rgb_color (0.,0.,0.); /* noir */

	ps_writeah(3.5,7.5,"Evolution of Membrane Potential",.4);

	ps_font("Times-Roman",.3);

	lower_x = ref1.lower_x / time_step;
	upper_x = ref1.upper_x / time_step;

	ps_movea(0.,0.);
	ps_user();
	ps_pen(0);

	ps_movea(0.,0.);
/*	ps_line_width (2.);*/
	ps_polyline(temps,pot,duree_simul_in_step,FALSE,0,0.);
	ps_writeah(13.5, 6.5, "Membrane Potential", 0.3);

	ps_set_rgb_color (0.,0.84,1.); /* turqoise */
	ps_movea(0.,0.);
	ps_polyline(temps,ramp,duree_simul_in_step,FALSE,0,0.);
	ps_writeah(13.5, 6., "Input current", 0.3);

	ps_set_rgb_color (1.,0.,0.); /* rouge */
	ps_movea(0.,0.);
	ps_line_width(2.);
	ps_movea(lower_x, rev_pot_pos - ref1.lower_y);
	ps_drawa(upper_x,  rev_pot_pos - ref1.lower_y);
	ps_line_width(1.);
	ps_writeah(13.5, 5.5, "Pos Rev Potential", 0.3);

	ps_set_rgb_color (0.,0.,1.); /* bleu */
	ps_movea(0.,0.);
	ps_line_width(2.);
	ps_movea(lower_x, rev_pot_neg - ref1.lower_y);
	ps_drawa(upper_x,  rev_pot_neg - ref1.lower_y);
	ps_line_width(1.);
	ps_writeah(13.5, 5., "Neg Rev Potential", 0.3);
	
	ps_pen(0);
	x_scale = 14./(ref1.upper_x - ref1.lower_x);
	ps_echel(x_scale,y_scale,0.,0.,1.,0.);
	ps_movea(0.,0.);
	ps_ticked_axes(ref1.lower_x,ref1.lower_y,
		       ref1.lower_x,ref1.upper_x,
		       ref1.lower_x,ref1.upper_x,
		       ref1.lower_y,ref1.upper_y,
		       ref1.lower_y,ref1.upper_y,
		       0.1," Time (ms)","%.3f"," V (mV)","%.1f",0.3,0);

	ps_endplot(file_ps,keep);

	free (pot);
	free (ramp);
	free (temps);
	free (sodium);
	free (na_prolong);
	free (potassium);
	free (potassium_c);
	free (calcium);
	free (calcium_bas);
	free (conc_calcium);
	free (potassium_a);
	free (potassium_m);
	free (potassium_h);
	free (potassium_ahp);
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/   
	free (new);
#endif


} /* fin du plot_pot_conduct */



/*--------------------------------------------------------------------
 *      p l o t _ p o t _ p h e n o m
 *------------------------------------------------------------------*/
/* plot_pot permet de creer un fichier PostScript pour les potentiels */

void	plot_pot_phenom()
{
	int	i,
		duree_simul_in_step;
		
	float	x_scale,
		y_scale,
		upper_x,
		lower_x;

	float	* pot,
		* ramp,
		* temps,
		* un_seuil,
		* un_histog,
		* un_isi;
#ifdef ADD_CURRENT

/*--------   To add a current modify and adapt   -------*/   
	float	* new;
#endif

	char	* pc,
		buffer[80],
		file_ps[256];

	extern	REFERENCE	ref1, ref2, ref3;

	duree_simul_in_step = (int)((float)duree_simul / time_step);
	table_size = (int) ((float)(duree_simul + 2) / time_step) + 2;

	temps         = (float *) calloc (table_size, sizeof (float));
	pot           = (float *) calloc (table_size, sizeof (float));
	ramp          = (float *) calloc (table_size, sizeof (float));
	un_seuil      = (float *) calloc (table_size, sizeof (float));
	un_histog     = (float *) calloc (table_size, sizeof (float));
	un_isi        = (float *) calloc (table_size, sizeof (float));
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/   
	new = (float *) calloc (table_size, sizeof (float));
#endif

	for ( i = 1; i < duree_simul_in_step; i++)
	{
		* ( temps + i)         = (float)i;
		* ( pot + i)           = * ( potentiel + i)    - ref1.lower_y;
		* ( ramp + i)          = * ( ramp_input + i)   - ref1.lower_y;
		* ( un_seuil + i)      = * ( le_seuil + i)    - ref1.lower_y;
		* ( un_histog + i)     = * ( l_histogramme + i)   - ref3.lower_y;
		* ( un_isi + i)        = * ( les_intervalles + i)   - ref2.lower_y;
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/   

		* ( new + i)           = * ( cou rant_INew + i )  - ref3.lower_y;
#endif
	} /* fin du for */

	strcpy(file_ps,nom_fichier_neuron);
	if (pc = strrchr(file_ps,'.'))
	{
		*pc = 0;
	} /* fin du if */
	strcat(file_ps,"_phenom_unit.ps");

	ps_iniplot(file_ps,30.);
	ps_scale (0.85,0.85);
/*	ps_queue_name ("postscript"); */

/*------ e c r i t u r e   d e s   v a l e u r s  ------------------ */



	ps_writeah (1.5, 3., "Rest Pot (mV): ", 0.3);
	sprintf(buffer, "%.0f", p_rest_pot);
	ps_writeah (4.5, 3.,buffer, 0.3);

	ps_writeah (6., 3., "Threshold. (mV): ", 0.3);
	sprintf(buffer, "%.2f",seuil);
	ps_writeah (9.5, 3.,buffer, 0.3);

	ps_writeah (11., 3., "Input Crt (uA/cm2): ", 0.3);
	sprintf(buffer, "%.2f",input_fact);
	ps_writeah (14.5, 3.,buffer, 0.3);

	ps_writeah (16., 3., "Step (ms): ", 0.3);
	sprintf(buffer, "%.3f",time_step);
	ps_writeah (20., 3., buffer, 0.3);

	ps_writeah (1.5, 2.5, "E_Na (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_Na);
	ps_writeah (4.5, 2.5, buffer, 0.3);

	ps_writeah (11., 2.5, "E_K (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_K);
	ps_writeah (14.5, 2.5, buffer, 0.3);


#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/

/*--------   Adapt the position of the writing    -------*/

	ps_writeah (1.5, .0, "g_New (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_H);
	ps_writeah (4.5, .0, buffer, 0.3);

#endif
/*-- t r a c e  d e s  I S I --*/

	ps_origin(4.,4.7,0.,0.);

	x_scale = 14./((ref3.upper_x - ref3.lower_x) / time_step);
	y_scale = 6./(ref3.upper_y - ref3.lower_y);

	ps_echel(x_scale,y_scale,0.,0.,1.,0.);


	ps_writeah(3.5, 6.5,"Evolution of Inter Spike Intervals",
		   .4);

	ps_font("Times-Roman",.3);

	lower_x = ref3.lower_x / time_step;
	upper_x = ref3.upper_x / time_step;

	ps_movea(0.,0.);
	ps_user();

	ps_pen(0);
	ps_set_rgb_color (1., 1., 1.); /* blanc */
	ps_movea(0.,0.);
	ps_polydots(temps,un_isi,duree_simul_in_step,10,0.1);
	ps_writeah (13.5, 6.5, "Inter Spike Intervals", 0.3);


	ps_set_rgb_color(0.,0.,0.); /* noir */

	x_scale = 14./(ref3.upper_x - ref3.lower_x);
	ps_echel(x_scale,y_scale,0.,0.,1.,0.);
	ps_movea(0.,0.);
	ps_ticked_axes(ref3.lower_x,ref3.lower_y,
		       ref3.lower_x,ref3.upper_x,
		       ref3.lower_x,ref3.upper_x,
		       ref3.lower_y,ref3.upper_y,
		       ref3.lower_y,ref3.upper_y,
		       0.1," Time (ms)","%.3f"," ISI (ms)","%.1f",0.3,0);

	
/*-----  t r a c e   d e s   Histogramme -----*/

	ps_origin(0., 8.5,0.,0.);

	x_scale = 14./((ref2.upper_x - ref2.lower_x) / time_step);
	y_scale = 6./(ref2.upper_y - ref2.lower_y);

	ps_echel(x_scale,y_scale,0.,0.,1.,0.);

	ps_set_rgb_color(0.,0.,0.); /* noir */
	
	ps_writeah(3.5, 6.5,"Evolution of Inter Spike Intervals",.4);

	ps_font("Times-Roman",.3);

	ps_movea(0.,0.);

	lower_x = ref2.lower_x / time_step;
	upper_x = ref2.upper_x / time_step;


	ps_user();
	ps_pen(0);

	ps_set_rgb_color (1.,0.,0.); /* rouge */
	ps_movea(0.,0.);
	ps_polyline(temps,un_histog,duree_simul_in_step,FALSE,0,0.);
	ps_writeah(13.5,6.5,"ISI (ms)",0.3);

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/   
	ps_set_rgb_color (1.,0.,0.); /* rouge */
	ps_movea(0.,0.);
	ps_polyline(temps,new,duree_simul_in_step,FALSE,0,0.);
	ps_writeah (13.5, 5.8, "I_New", 0.3);

#endif

	ps_set_rgb_color(0.,0.,0.); /* noir */

	x_scale = 14./(ref2.upper_x - ref2.lower_x);
	ps_echel(x_scale,y_scale,0.,0.,1.,0.);
	ps_movea(0.,0.);
	ps_ticked_axes(ref2.lower_x,ref2.lower_y,
		       ref2.lower_x,ref2.upper_x,
		       ref2.lower_x,ref2.upper_x,
		       ref2.lower_y,ref2.upper_y,
		       ref2.lower_y,ref2.upper_y,
		       0.1," Time (ms)","%.3f"," F (Hz)","%.1f",0.3,0);

/*---- t r a c e  d u  p o t e n ti e l  e t  d e  l ' i n p u t ----*/

	ps_origin(0.,8.5,0.,0.);

	x_scale = 14./((ref1.upper_x - ref1.lower_x) / time_step);
	y_scale = 6./(ref1.upper_y - ref1.lower_y);

	ps_echel(x_scale,y_scale,0.,0.,1.,0.);

	ps_set_rgb_color (0.,0.,0.); /* noir */

	ps_writeah(3.5,7.5,"Evolution of Membrane Potential",.4);

	ps_font("Times-Roman",.3);

	lower_x = ref1.lower_x / time_step;
	upper_x = ref1.upper_x / time_step;

	ps_movea(0.,0.);
	ps_user();

	ps_pen(0);
	ps_set_rgb_color (0.,0.84,1.); /* turqoise */
	ps_movea(0.,0.);
	ps_polyline(temps,ramp,duree_simul_in_step,FALSE,0,0.);
	ps_writeah(13.5, 6., "Input current", 0.3);

	ps_pen(0);
	ps_set_rgb_color (0.,1.,0.); /* vert */
	ps_movea(0.,0.);
	ps_polyline(temps,un_seuil,duree_simul_in_step,FALSE,0,0.);
	ps_writeah(13.5, 5.5, "Threshold", 0.3);

	ps_pen(0);
	ps_set_rgb_color (1.,0.,0.); /* rouge */
	ps_movea(0.,0.);
	ps_line_width(1.);
	ps_movea(lower_x, rev_pot_pos - ref1.lower_y);
	ps_drawa(upper_x,  rev_pot_pos - ref1.lower_y);
	ps_line_width(1.);
	ps_writeah(13.5, 5.0, "Pos Rev Potential", 0.3);

	ps_pen(0);
	ps_set_rgb_color (0.,0.,1.); /* bleu */
	ps_movea(0.,0.);
	ps_line_width(1.);
	ps_movea(lower_x, rev_pot_neg - ref1.lower_y);
	ps_drawa(upper_x,  rev_pot_neg - ref1.lower_y);
	ps_line_width(1.);
	ps_writeah(13.5, 4.5, "Neg Rev Potential", 0.3);
	
	ps_pen(0);
	ps_movea(0.,0.);
/*	ps_line_width (2.);*/
	ps_polyline(temps,pot,duree_simul_in_step,FALSE,0,0.);
	ps_writeah(13.5, 6.5, "Membrane Potential", 0.3);

	ps_pen(0);
	x_scale = 14./(ref1.upper_x - ref1.lower_x);
	ps_echel(x_scale,y_scale,0.,0.,1.,0.);
	ps_movea(0.,0.);
	ps_ticked_axes(ref1.lower_x,ref1.lower_y,
		       ref1.lower_x,ref1.upper_x,
		       ref1.lower_x,ref1.upper_x,
		       ref1.lower_y,ref1.upper_y,
		       ref1.lower_y,ref1.upper_y,
		       0.1," Time (ms)","%.3f"," V (mV)","%.1f",0.3,0);

	ps_endplot(file_ps,keep);

	free (pot);
	free (ramp);
	free (temps);
	free (un_seuil);
	free (un_isi);
	free (un_histog);

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/   
	free (new);
#endif


} /* fin du plot_pot_phenom */



/*--------------------------------------------------------------------
 *      s a v e _ m b _ p o t
 *------------------------------------------------------------------*/
/* save_mb_pot permet de creer un fichier avec le potentiel de mb */

void	save_mb_pot()
{
	int	i,
		duree_simul_in_step;

	float	* pot,
		* temps;

	char	* pc,
		buffer[80],
		file_mb_pot[60];

	FILE	*p_mb_pot;

	strcpy(file_mb_pot,nom_fichier_neuron);
	if (pc = strrchr(file_mb_pot,'.'))
	{
		*pc = 0;
	} /* fin du if */
	strcat(file_mb_pot,"_G_unit.pmb");

	if ((p_mb_pot = fopen(file_mb_pot,"w")) == NULL)
	{
		printf("%s file impossible to open\n",file_mb_pot);
		return;
	} /* fin du if */

	duree_simul_in_step = duree_simul * (int)(1./time_step);

	pot   = (float *) calloc (duree_simul_in_step, sizeof (float));
	temps = (float *) calloc (duree_simul_in_step, sizeof (float));

	for ( i = 1; i < duree_simul_in_step; i++)
	{
		* (temps +i) = (float)i * time_step;
		* (pot +i) = * (potentiel +i);
	} /* fin du for */

	for ( i = 1; i < duree_simul_in_step; i++)
	{
		fprintf(p_mb_pot,"%.4f	%.2f\n",temps[i],pot[i]);
	} /* fin du for */
	fclose(p_mb_pot);
	free(pot);
	free(temps);
}
/****************************************/

/*--------------------------------------------------------------------
 *      s a v e _ c u r r e n t s
 *------------------------------------------------------------------*/
/* save_curents permet de creer un fichier avec les courants */

void	save_currents()
{
	int	i,
		duree_simul_in_step;

	float	* current_K,
		* current_Na,
		* current_Ia,
		* current_Im,
		* current_Iahp,
		* current_Ic,
		* current_Ca,
		* current_Nap,
		* current_Cab,
		* current_Ih,
		* conc_Ca,
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/   
		* current_INew,
#endif
		* temps;

	char	* pc,
		buffer[80],
		file_currents[60];

	FILE	*p_currents;

	strcpy(file_currents,nom_fichier_neuron);
	if (pc = strrchr(file_currents,'.'))
	{
		*pc = 0;
	} /* fin du if */
	strcat(file_currents,"_G_unit.crt");

	if ((p_currents = fopen(file_currents,"w")) == NULL)
	{
		printf("%s file impossible to open\n",file_currents);
		return;
	} /* fin du if */

	duree_simul_in_step = duree_simul * (int)(1./time_step);
	table_size          = (int) ((float)(duree_simul + 2) / time_step) + 2;

	temps = (float *) calloc (table_size, sizeof (float));
	if ((current_K = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
	if ((current_Na = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
	if ((current_Ia = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
	if ((current_Im = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
	if ((current_Iahp = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
	if ((current_Ic = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
	if ((current_Ca = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
	if ((current_Nap = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
	if ((current_Cab = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
	if ((current_Ih = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
	if ((conc_Ca = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/   
	if ((current_INew = (float *) calloc (table_size, sizeof (float))) == NULL)
	{
		printf("Not enough memory to save currents, sorry...\n");
		return;
	} /* fin du if */
#endif

	for ( i = 1; i < duree_simul_in_step; i++)
	{
		* ( temps + i )         = (float)i * time_step;
		* ( current_K + i )     = * ( courant_K + i );
		* ( current_Na + i )    = * ( courant_Na + i ) ;
		* ( current_Ia + i )    = * ( courant_Ia + i ) ;
		* ( current_Im + i )    = * ( courant_Im + i ) ;
		* ( current_Iahp + i )  = * ( courant_Iahp + i ) ;
		* ( current_Ic + i )    = * ( courant_Ic + i ) ;
		* ( current_Ca + i )    = * ( courant_Ca + i ) ;
		* ( current_Nap + i )   = * ( courant_Nap + i ) ;
		* ( current_Cab + i )   = * ( courant_Cab + i ) ;
		* ( current_Ih + i )    = * ( courant_Ih + i ) ;
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/   
		* ( current_INew + i )  = * ( courant_INew + i ) ;
#endif
		* ( conc_Ca + i )       = * ( Ca + i ) ;
	} /* fin du for */

#ifdef ADD_CURRENT

/*--------   To add a current add the title in the following fprintf  
  and replace the original fprintf by this one -------*/   
	fprintf(p_currents,"     t\t\t   K\t   Na\t   Ia\t   Im\t   Iahp\t   Ic\t   ICa\t   INap\t   ICab\t   INew\t   [Ca]\n");

#endif

	fprintf(p_currents,"     t\t\t   K\t   Na\t   Ia\t   Im\t   Iahp\t   Ic\t   ICa\t   INap\t   ICab\t   [Ca]\n");
	for ( i = 1; i < duree_simul_in_step; i++)
	{
#ifdef ADD_CURRENT

/*--------   To add a current add the t%7.3f\t in the following fprintf  
  and replace the original fprintf by this one -------*/   
		fprintf(p_currents,"%10.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\tt%7.3f\t%7.3f\t%7.3f\n",

#endif
		fprintf(p_currents,"%10.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\t%7.3f\n",
			temps[i],
			current_K[i],
			current_Na[i],
			current_Ia[i],
			current_Im[i],
			current_Iahp[i],
			current_Ic[i],
			current_Ca[i],
			current_Nap[i],
			current_Cab[i],
			current_Ih[i],
#ifdef ADD_CURRENT

/*--------   To add a current copy, add and adaapt  -------*/   
			current_INew[i],
#endif

			conc_Ca[i]);
	} /* fin du for */
	fclose(p_currents);
	free(current_K);
	free(current_Na);
	free(current_Ia);
	free(current_Im);
	free(current_Iahp);
	free(current_Ic);
	free(current_Ca);
	free(current_Nap);
	free(current_Cab);
	free(current_Ih);
#ifdef ADD_CURRENT

/*--------   To add a current copy, add and adaapt  -------*/   
	free(current_INew);
#endif
	free(conc_Ca);
	free(temps);
}



/****************************************/
/*--------------------------------------------------------------------
 *      p r i n t _ X Y _ g r a p h
 *------------------------------------------------------------------*/
/* plot_pot permet de creer un fichier PostScript pour les potentiels
  et les courants */

extern	REFERENCE	refXY;
extern	char	X_legend[],
		Y_legend[];

void	print_XY_graph(void)
{
	int	i,
		duree_simul_in_step;
		
	float	x_scale,
		y_scale,
		upper_x,
		lower_x,
		*X_values,
		*Y_values;

	char	* pc,
		buffer[80],
		zero_x[10],
		zero_y[10],
		file_ps[256];

			
	duree_simul_in_step = (int)((float)duree_simul/time_step);

	X_values = (float *) calloc (duree_simul_in_step, sizeof (float));
	Y_values = (float *) calloc (duree_simul_in_step, sizeof (float));

	for ( i = 1; i < duree_simul_in_step; i++)
	{
		* (X_values +i) = * (X_graph +i) - refXY.lower_x;
		* (Y_values +i) = * (Y_graph +i) - refXY.lower_y;
	} /* fin du for */

	strcpy(file_ps,nom_fichier_neuron);
	if (pc = strrchr(file_ps,'.'))
	{
		*pc = 0;
	} /* fin du if */
	strcat(file_ps,"_G_unit_XY.ps");

	ps_iniplot(file_ps,30.);

/*	ps_queue_name ("postscript"); */

/*------ e c r i t u r e   d e s   v a l e u r s  ------------------ */

	ps_scale (.8,.8);

	ps_writeah (16., 4., "Na_ext (m.moles/l): ", 0.3);
	sprintf(buffer, "%.2f",Na_ext);
	ps_writeah (20., 4., buffer, 0.3);
	
	ps_writeah (1.5, 3.5, "Na_int (m.moles/l): ", 0.3);
	sprintf(buffer, "%.2f",Na_int);
	ps_writeah (4.5, 3.5, buffer, 0.3);
	
	ps_writeah (6., 3.5, "K_ext (m.moles/l): ", 0.3);
	sprintf(buffer, "%.2f",K_ext);
	ps_writeah (9.5, 3.5, buffer, 0.3);
	
	ps_writeah (11., 3.5, "K_int (m.moles/l): ", 0.3);
	sprintf(buffer, "%.2f",K_int);
	ps_writeah (14.5, 3.5, buffer, 0.3);
	
	ps_writeah (16., 3.5, "Temperature (Deg C): ", 0.3);
	sprintf(buffer, "%.2f",Temp);
	ps_writeah (20., 3.5, buffer, 0.3);


	ps_writeah (1.5, 3., "Rest Pot (mV): ", 0.3);
	sprintf(buffer, "%.0f", rest_pot);
	ps_writeah (4.5, 3.,buffer, 0.3);

	ps_writeah (6., 3., "Mb Capa. (uF/cm2): ", 0.3);
	sprintf(buffer, "%.2f",capacite);
	ps_writeah (9.5, 3.,buffer, 0.3);

	ps_writeah (11., 3., "Input Crt (uA/cm2): ", 0.3);
	sprintf(buffer, "%.2f",input_fact);
	ps_writeah (14.5, 3.,buffer, 0.3);

	ps_writeah (16., 3., "Step (ms): ", 0.3);
	sprintf(buffer, "%.3f",time_step);
	ps_writeah (20., 3., buffer, 0.3);

	ps_writeah (1.5, 2.5, "E_Na (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_Na);
	ps_writeah (4.5, 2.5, buffer, 0.3);

	ps_writeah (6., 2.5, "E_Ca (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_Ca);
	ps_writeah (9.5, 2.5, buffer, 0.3);

	ps_writeah (11., 2.5, "E_K (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_K);
	ps_writeah (14.5, 2.5, buffer, 0.3);

	ps_writeah (16., 2.5, "E_fuite (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_fuite);
	ps_writeah (20., 2.5, buffer, 0.3);

	ps_writeah (1.5, 2., "g_Na (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f", g_Na);
	ps_writeah (4.5, 2., buffer, 0.3);

	ps_writeah (6., 2., "g_Ca (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_Ca);
	ps_writeah (9.5, 2., buffer, 0.3);

	ps_writeah (11., 2., "g_fuite (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_fuite);
	ps_writeah (14.5, 2., buffer, 0.3);

	ps_writeah (16., 2., "g_Syn_pos (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_Syn_pos);
	ps_writeah (20., 2., buffer, 0.3);

	ps_writeah (1.5, 1.5, "g_K (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_K);
	ps_writeah (4.5, 1.5, buffer, 0.3);

	ps_writeah (6., 1.5, "g_Ka (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_A);
	ps_writeah (9.5, 1.5, buffer, 0.3);

	ps_writeah (11., 1.5, "g_Km (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_M);
	ps_writeah (14.5, 1.5, buffer, 0.3);

	ps_writeah (16., 1.5, "g_Kahp (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_ahp);
	ps_writeah (20., 1.5, buffer, 0.3);

	ps_writeah (1.5, 1., "g_Kc (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_C);
	ps_writeah (4.5, 1., buffer, 0.3);

	ps_writeah (6., 1., "g_NMDA (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_NMDA);
	ps_writeah (9.5, 1., buffer, 0.3);

	ps_writeah (11., 1., "Mg (mM): ", 0.3);
	sprintf(buffer, "%.2f",magnesium);
	ps_writeah (14.5, 1., buffer, 0.3);

	ps_writeah (16., 1., "E_Mg (mV): ", 0.3);
	sprintf(buffer, "%.2f",rev_pot_NMDA);
	ps_writeah (20., 1., buffer, 0.3);

	ps_writeah (1.5, .5, "g_Na_P (mS/cm2): ", 0.3);
	sprintf(buffer, "%.3f",g_Nap);
	ps_writeah (4.5, .5, buffer, 0.3);

	ps_writeah (6., .5, "g_Ca_LVA (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_Cab);
	ps_writeah (9.5, .5, buffer, 0.3);

	ps_writeah (11., .5, "E_H (mV): ", 0.3);
	sprintf(buffer, "%.2f",E_H);
	ps_writeah (14.5, .5, buffer, 0.3);

	ps_writeah (16., .5, "g_H (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_H);
	ps_writeah (20., .5, buffer, 0.3);

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/

/*--------   Adapt the position of the writing    -------*/

	ps_writeah (1.5, .0, "g_New (mS/cm2): ", 0.3);
	sprintf(buffer, "%.2f",g_H);
	ps_writeah (4.5, .0, buffer, 0.3);

#endif
/*-- t r a c e  XY  graphe XY --*/

	ps_origin(2.,4.7,0.,0.);

	ps_scale (1.25, 1.25);

	x_scale = (10.* XY_graph_scale)/(refXY.upper_x - refXY.lower_x);
	y_scale = 10./(refXY.upper_y - refXY.lower_y);

	ps_echel(x_scale,y_scale,0.,0.,1.,0.);

	ps_font("Times-Roman",.3);

	lower_x = refXY.lower_x / time_step;
	upper_x = refXY.upper_x / time_step;

	ps_movea(0.,0.);
	ps_user();

	ps_pen(0);
	ps_set_rgb_color (1., 0., 0.); /* rouge */

	if (XY_graph_scale > 1.5)
	{
		ps_origin(16.,1.0,0.,0.);
		ps_rotate(90);
	} /* fin du if */

	ps_movea(0.,0.);
	ps_polyline(X_values,Y_values,duree_simul_in_step,FALSE,0,0.);
	ps_set_rgb_color(0.,0.,0.); /* noir */

	ps_movea(0.,0.);
	sprintf(zero_x,"%%.%df",refXY.decimals_x);
	sprintf(zero_y,"%%.%df",refXY.decimals_y);
	ps_ticked_axes(refXY.lower_x,refXY.lower_y,
		       refXY.lower_x,refXY.upper_x,
		       refXY.lower_x,refXY.upper_x,
		       refXY.lower_y,refXY.upper_y,
		       refXY.lower_y,refXY.upper_y,
		       0.1,X_legend,zero_x,Y_legend,zero_y,0.3,0);

	
	ps_endplot(file_ps,keep);

	free (X_values);
	free (Y_values);
} /* fin du plot_pot */
/****************************************/
/*--------------------------------------------------------------------
 *      p r i n t _ M _ H _ T A U _ g r a p h
 *------------------------------------------------------------------*/
/* plot_pot permet de creer un fichier PostScript pour les potentiels
  et les courants */

extern	REFERENCE	refM_H_TAU;
extern	char	V_legend[],
		M_legend[];

void	print_M_H_TAU_graph(void)
{
	int	i,
		duree_simul_in_step;
		
	float	x_scale,
		y_scale,
		upper_x,
		upper_y,
		lower_x,
		lower_y,
		X_volt[PLOT_SIZE];

	char	* pc,
		buffer[80],
		zero_x[10],
		zero_y[10],
		titre[80],
		file_ps[256];


	strcpy(file_ps,nom_fichier_neuron);
	if (pc = strrchr(file_ps,'.'))
	{
		*pc = 0;
	} /* fin du if */
	strcat(file_ps,"_G_unit_activ.ps");

	ps_iniplot(file_ps,30.);

/*	ps_queue_name ("postscript"); */

/*------ e c r i t u r e   d e s   v a l e u r s  ------------------ */


	if(set_g_Na)
	{
		strcpy(titre,"Na ");
	} /* fin du if */
	if(set_g_Nap)
	{
		strcpy(titre,"Na persistant");
	} /* fin du if */
	if(set_g_K)
	{
		strcpy(titre,"K");
	} /* fin du if */
	if(set_g_A)
	{
		strcpy(titre,"K for I_A current");
	} /* fin du if */
	if(set_g_M)
	{
		strcpy(titre,"K for I_M current");
	} /* fin du if */
	if(set_g_C)
	{
		strcpy(titre,"K for I_C");
	} /* fin du if */
	if(set_g_H)
	{
		strcpy(titre,"K for I_H");
	} /* fin du if */
	if(set_g_ahp)
	{
		strcpy(titre,"K for I_ahp");
	} /* fin du if */
	if(set_g_Ca)
	{
		strcpy(titre,"Ca HVA");
	} /* fin du if */
	if(set_g_Cab)
	{
		strcpy(titre,"Ca LVA");
	} /* fin du if */

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/

	if(set_g_New)
	{
		strcpy(titre,"New");
	} /* fin du if */

#endif

	ps_writeah (10., .5, titre, 0.5);

/*-- t r a c e  du  graphe de gauche --*/

	for (i = 0; i < PLOT_SIZE; i++)
	{
		X_volt[i] = voltage[i] + 100.;
	} /* fin du for */

	ps_origin(2.,3.,0.,0.);

	x_scale = (5./(refM_H_TAU.upper_x - refM_H_TAU.lower_x));
	y_scale = 10.;
	ps_echel(x_scale,y_scale,0.,0.,1.,0.);

	ps_font("Times-Roman",.3);

	lower_x = refM_H_TAU.lower_x;
	upper_x = refM_H_TAU.upper_x;

	ps_movea(0.,0.);
	ps_user();

	ps_pen(0);

	lower_y = 0.;
	upper_y = activ[0];
	for (i = 0; i < PLOT_SIZE; i++)
	{
		if (activ[i] > upper_y)
			upper_y = activ[i];
	} /* fin du for */
	if (upper_y)
	{
		y_scale = 10./upper_y;
		ps_echel(x_scale,y_scale,0.,0.,1.,0.);
		ps_set_rgb_color (1., 0., 0.); /* rouge */
		ps_polyline(X_volt,activ,PLOT_SIZE,FALSE,0,0.);
	} /* fin du if */
	else
		ps_writeah (2.5, 6., "No activation", 0.3);

	lower_y = 0.;
	upper_y = inactiv[0];
	for (i = 0; i < PLOT_SIZE; i++)
	{
		if (inactiv[i] > upper_y)
			upper_y = inactiv[i];
	} /* fin du for */
	if (upper_y)
	{
		y_scale = 10./upper_y;
		ps_echel(x_scale,y_scale,0.,0.,1.,0.);
		ps_set_rgb_color (0., 0., 1.); /* bleu */
		ps_polyline(X_volt,inactiv,PLOT_SIZE,FALSE,0,0.);
	} /* fin du if */
	else
		ps_writeah (2.5, 5., "No inactivation", 0.3);

	lower_y = 0.;
	upper_y = coeff_G[0];
	for (i = 0; i < PLOT_SIZE; i++)
	{
		if (coeff_G[i] > upper_y)
			upper_y = coeff_G[i];
	} /* fin du for */
	if (upper_y)
	{
		y_scale = 10./upper_y;
		ps_echel(x_scale,y_scale,0.,0.,1.,0.);
		ps_set_rgb_color (.5, 0., .5); /* mauve */
		ps_polyline(X_volt,coeff_G,PLOT_SIZE,FALSE,0,0.);
	} /* fin du if */
	else
		ps_writeah (2.5, 4., "Coeff. not volt. dep.", 0.3);
		
	ps_set_rgb_color(0.,0.,0.); /* noir */

	y_scale = 10.;
	ps_echel(x_scale,y_scale,0.,0.,1.,0.);

	ps_movea(0.,0.);
	sprintf(zero_x,"%%.%df",refM_H_TAU.decimals_x);
	sprintf(zero_y,"%%.%df",refM_H_TAU.decimals_y);
	ps_ticked_axes(refM_H_TAU.lower_x,0.,
		       refM_H_TAU.lower_x,refM_H_TAU.upper_x+1.,
		       refM_H_TAU.lower_x,refM_H_TAU.upper_x+1.,
		       0., 1.05,
		       0., 1.05,
		       0.1,V_legend,zero_x,"m,h",zero_y,0.3,0);

/*-- t r a c e  du  graphe du milieu --*/

	ps_origin(6.,0.,0.,0.);
	ps_movea(0.,0.);
	ps_user();
	sprintf(zero_x,"%%.%df",refM_H_TAU.decimals_x);
	sprintf(zero_y,"%%.%df",refM_H_TAU.decimals_y);
	ps_ticked_axes(refM_H_TAU.lower_x,0.,
		       refM_H_TAU.lower_x,refM_H_TAU.upper_x+1.,
		       refM_H_TAU.lower_x,refM_H_TAU.upper_x+1.,
		       0., 1.05,
		       0., 1.05,
		       0.1,V_legend,zero_x,"tau_m,m",zero_y,0.3,0);
	ps_movea(0.,0.);

	ps_pen(0);

	lower_y = 0.;
	upper_y = activ[0];
	for (i = 0; i < PLOT_SIZE; i++)
	{
		if (activ[i] > upper_y)
			upper_y = activ[i];
	} /* fin du for */
	if (upper_y)
	{
		y_scale = 10./upper_y;
		ps_echel(x_scale,y_scale,0.,0.,1.,0.);
		ps_set_rgb_color (1., 0., 0.); /* rouge */
		ps_polyline(X_volt,activ,PLOT_SIZE,FALSE,0,0.);
	} /* fin du if */
	else
		ps_writeah (2.5, 6., "No activation", 0.3);

	lower_y = 0.;
	upper_y = tau_activ[0];
	for (i = 0; i < PLOT_SIZE; i++)
	{
		if (tau_activ[i] > upper_y)
			upper_y = tau_activ[i];
	} /* fin du for */
	if (upper_y)
	{
		y_scale = 10./upper_y;
		ps_echel(x_scale,y_scale,0.,0.,1.,0.);
		ps_set_rgb_color (0., 1., 0.); /* vert */
		ps_polyline(X_volt,tau_activ,PLOT_SIZE,FALSE,0,0.);
	} /* fin du if */
	else
		ps_writeah (2.5, 5., "No tau activation", 0.3);


	ps_set_rgb_color(0.,0.,0.); /* noir */


/*-- t r a c e  du  graphe de droite --*/

	ps_origin(6.,0.,0.,0.);
	ps_movea(0.,0.);

	y_scale = 10.;
	ps_echel(x_scale,y_scale,0.,0.,1.,0.);

	ps_user();
	ps_set_rgb_color(0.,0.,0.); /* noir */

	sprintf(zero_x,"%%.%df",refM_H_TAU.decimals_x);
	sprintf(zero_y,"%%.%df",refM_H_TAU.decimals_y);
	ps_ticked_axes(refM_H_TAU.lower_x,0.,
		       refM_H_TAU.lower_x,refM_H_TAU.upper_x+1.,
		       refM_H_TAU.lower_x,refM_H_TAU.upper_x+1.,
		       0., 1.05,
		       0., 1.05,
		       0.1,V_legend,zero_x,"tau_h,h",zero_y,0.3,0);

	ps_movea(0.,0.);

	ps_pen(0);
	lower_y = 0.;
	upper_y = inactiv[0];
	for (i = 0; i < PLOT_SIZE; i++)
	{
		if (inactiv[i] > upper_y)
			upper_y = inactiv[i];
	} /* fin du for */
	if (upper_y)
	{
		y_scale = 10./upper_y;
		ps_echel(x_scale,y_scale,0.,0.,1.,0.);
		ps_set_rgb_color (0., 0., 1.); /* bleu */
		ps_polyline(X_volt,inactiv,PLOT_SIZE,FALSE,0,0.);
	} /* fin du if */
	else
		ps_writeah (2.5, 6., "No inactivation", 0.3);

	upper_y = tau_inactiv[0];
	for (i = 0; i < PLOT_SIZE; i++)
	{
		if (tau_inactiv[i] > upper_y)
			upper_y = tau_inactiv[i];
	} /* fin du for */
	if (upper_y)
	{
		y_scale = 10./upper_y;
		ps_echel(x_scale,y_scale,0.,0.,1.,0.);
		ps_set_rgb_color (0., 1., 0.); /* vert */
		ps_polyline(X_volt,tau_inactiv,PLOT_SIZE,FALSE,0,0.);
	} /* fin du if */
	else
		ps_writeah (2.5, 5., "No tau inactivation", 0.3);
	
	ps_endplot(file_ps,keep);

} /* fin du plot_pot */



/*-----------------------------------------------------------------------------

  Reorganisation des tableaux pour que tous les buttons soient visualisables 

-----------------------------------------------------------------------------*/




void trier_tab ()
{

  int	i,position=-1;
	
  SYNAP   tampon, premier;
/*  float   premier_mere=0.;*/

  premier.t_arrivee=0.;
  premier.weight=0.;


  if (taille_tab_syn == 1) return;
  for (i=taille_tab_syn-1;i>=0;i--)
    {
   
      if (tab_syn[i].weight!=0)
	{
	  premier.t_arrivee=tab_syn[i].t_arrivee;
	  premier.weight=tab_syn[i].weight;
	  position=i;
	}
      
    } /* fin de recherche du premier syn non nul */

  if (position==-1) 
    {
      return;   /* pas de solution car tous sont nul */
    }

  for (i=0;i<taille_tab_syn;i++)
    {
      if (premier.t_arrivee>tab_syn[i].t_arrivee && tab_syn[i].weight!=0)
	{
	  premier.t_arrivee=tab_syn[i].t_arrivee;
	  premier.weight=tab_syn[i].weight;
	  position=i;
	}
      
    }
  /* ici on a trouve le premier */

  /* rangement de la table */

  tab_syn[position].t_arrivee=tab_syn[taille_tab_syn-1].t_arrivee;
  tab_syn[position].weight=tab_syn[taille_tab_syn-1].weight;
  
  tab_syn[taille_tab_syn-1].t_arrivee=premier.t_arrivee;
  tab_syn[taille_tab_syn-1].weight=premier.weight;
  /* on echange les place entre le premier(/temps) et 
     le dernier (/la table). */
 
}










