#define DEBUG_V8 0

#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- 13  modifications in this file -------------*/

#endif

#define ESSAI_BURST	0

#ifndef R
#	define R 8.2320819112627         /* constante des gaz parfaits */
#endif
#ifndef Z
#	define Z 1.                      /* valence des ions Na+ et K+ */
#endif
#ifndef F
#	define F 9.648456e4              /* constante de Faraday en C/mole */
#endif

#ifndef PL_Cl
#	define PL_Cl 	   1.1e-9         /* m/s (=1.1e-7 cm/s)                */
#endif
#ifndef PL_Na
#	define PL_Na      5.0e-10         /* m/s (=5.0e-8 cm/s)                */
#endif
#ifndef PL_K
#	define PL_K       1.8e-8          /* m/s (=1.8e-6 cm/s)                */
#endif
#ifndef Jbar_p_Na
#	define Jbar_p_Na  6.0e-6   
#endif
#ifndef Km
#	define Km          13.4            /* mM (=13.4 mol/m^3)                */
#endif


#define z_l         3.5             
#define z_r         4.0
#define elec        1.6021892e-19
#define K           1.380662e-23
#define alpha_l     0.3
#define alpha_r     0.2
#define Vl          (-53.0e-3)
#define Vr          (-56.0e-3)
#define nu_l        0.0
#define nu_r        0.5

#define p_inf(nu_p,ez_peVmVpokT)                \
((nu_p) + (1.0-(nu_p))/(1.0+(ez_peVmVpokT)))

#define tau_p(taubar_p,ea_pz_peVmVpokT,ez_peVmVpokT,alpha_p) \
(Qp((alpha_p))*(taubar_p)/         \
 ((ea_pz_peVmVpokT)+(ea_pz_peVmVpokT)/(ez_peVmVpokT)))

#define Qp(alpha_p) (oma_poa_p=(1.0-(alpha_p))/alpha_p, \
           pow(oma_poa_p,(alpha_p))+pow(oma_poa_p,(alpha_p-1.0)))



/* --------------------------------------------------------------------------------------
			G_EQUATIONS.C
   ------------------------------------------------------------------------------------*/
#include <stdlib.h>
#include<stdio.h>
#include<math.h>

#undef	MAIN
#include "G_neuron.h"

#include "G_synap.h"

#ifndef TRUE
#define	TRUE	1
#endif


#ifndef FALSE
#define FALSE	0
#endif

#define	SPIKE		1
#define	DEBUT_INP_CUR	20.
#define	FIN_INP_CUR	150

#define M1 259200
#define IA1 7141
#define IC1 54773
#define RM1 (1.0/M1)
#define M2 134456
#define IA2 8121
#define IC2 28411
#define RM2 (1.0/M2)
#define M3 243000
#define IA3 4561
#define IC3 51349

#ifndef M_E
#	define M_E 2.7182818284590452354
#endif 





static	float	I_total;
void	update_expon(int);
void	update_r_k(int);
float	ran1(int *);		
float	gasdev(int *);
void	nrerror(char *); 
void    reactualise_E_Na_K(void );

/*--------------------------------------------------------------------
 *     u p d a t e _ e x p o n
 *------------------------------------------------------------------*/
 
void update_expon(int nb_it)
{
  register i, j, k, nb_r;       /* indices */

  int	set;
  
  double AComCieo1me,    /* parametre intervenant dans les calculs */
         eVFoRT,         /* parametre intervenant dans les calculs */
         emVFoRT,        /* parametre intervenant dans les calculs */
         AVF2oRT,        /* parametre intervenant dans les calculs */
         FoRT,           /* parametre intervenant dans les calculs */
         F2oRT,          /* parametre intervenant dans les calculs */ 
         temp, 
         ez_peVmVpoKT,
         ea_pz_peVmVpoKT,
         oma_poa_p;


  float gasdev(int *),

       
        t_i,            /* temps passe */
        noise = 0.,     /* background noise     */
        sum_inputs,      /* pour la somme des inputs */

        tau_m_Na,       /* cste de temps de l'activation
       			des canaux Na  */
       	m_1_Na,         /* facteur intervenant dans le calcul
       			de m_Na*/
       	alpha_m_Na,     /* facteur intervenant dans le calcul
      			de m_Na et tau_m_Na */
       	beta_m_Na,      /* facteur intervenant dans le calcul
       			de m_Na et tau_m_Na */
       	tau_h_Na,       /* cste de temps d'inactivation des
       			canaux Na */
       	h_1_Na,         /* facteur intervenant dans le calcul
       			de h_na */
       	alpha_h_Na,     /* facteur intervenant dans le calcul
       			de h_Na et tau_h_Na */
       	beta_h_Na,      /* facteur intervenant dans le calcul
       			de m_Na et tau_h_Na */
       	tau_m_Ca,       /* cste de temps d'activation des
       			canaux Ca */
       	m_1_Ca,         /* facteur intervenant dans le calcul
       			de m_Ca */
       	tau_m_K,        /* cste de temps de l'activation
       			des canaux K */
       	m_1_K,          /* facteur intervenant dans le calcul
       			de m_K */
       	alpha_m_K,      /* facteur intervenant dans le calcul
       			de tau_m_K */
       	beta_m_K,       /* facteur intervenant dans le calcul
       			de tau_m_K */
       	alpha_m1_K,     /* facteur intervenant dans le calcul
       			de m1_k */
       	beta_m1_K,      /* facteur intervenant dans le calcul
       			de m1_k */
       	tau_h_K,        /* cste de temps d'inactivation des
       			canaux K */
       	h_1_K,          /* facteur intervenant dans le calcul
       			de h_K */
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt   -------*/

       	tau_m_New = 1.,  /* cste de temps d'activation des
       			canaux K pour le courant INew */
       	m_1_New,          /* facteur intervenant dans le  calcul
       			de m_New */
       	tau_h_New,        /* cste de temps d'inactivation des
       			canaux K pour le courant INew */
       	h_1_New,          /* facteur intervenant dans le calcul
       			de h_New */
#endif



       	tau_m_A =1.38,  /* cste de temps d'activation des
       			canaux K pour le courant Ia */
       	m_1_A,          /* facteur intervenant dans le  calcul
       			de m_A */
       	tau_h_A,        /* cste de temps d'inactivation des
       			canaux K pour le courant Ia */
       	h_1_A,          /* facteur intervenant dans le calcul
       			de h_A */
       	alpha_m_Im,     /* facteur intervenant dans le calcul
       			de tau_m_Im */
       	beta_m_Im,     /* facteur intervenant dans le calcul
       			de tau_m_Im */
       	tau_m_M,        /* cste de temps d'activation des
       			canaux k pour le courant Im */
       	m_1_M,          /* facteur intervenant dan le calcul
       			de m_M */
       	tau_m_C,        /* cste de temps d'activation des
       			canaux K dependants du calcium et
       			du voltage */
       	m_1_C,          /* facteur permettant de calculer m_C */
       	alpha_m_Ic,     /* permet le calcul de tau_m_C et m_1_C
       			en tenant compte de Ca et du voltage*/
       	beta_m_Ic,      /* permet le calcul de tau_m_C et m_1_C
       			en tenant compte du voltage*/

      	tau_m_nap,        /* cste de temps d'activation des
       			canaux K dependants du calcium et
       			du voltage */
       	m_1_Nap,          /* facteur permettant de calculer m_Nap */
       	alpha_m_Inap,     /* permet le calcul de tau_m_nap et m_1_Nap
       			en tenant compte du voltage*/
       	beta_m_Inap,      /* permet le calcul de tau_m_nap et m_1_Nap
       			en tenant compte du voltage*/

       	tau_h_cab,        /* cste de temps d'activation des
       			canaux K dependants du calcium et
       			du voltage */
       	m_1_Cab,          /* facteur permettant de calculer m_Cab */
       	h_1_Cab,          /* facteur permettant de calculer m_Cab */
       	alpha_h_Icab,     /* permet le calcul de tau_h_Cab et h_1_Cab
       			en tenant compte de Ca et du voltage*/
       	beta_h_Icab,      /* permet le calcul de tau_h_Cab et h_1_Cab
       			en tenant compte du voltage*/
       	alpha_m_Icab,     /* permet le calcul de tau_m_Cab et m_1_Cab
       			en tenant compte de Ca et du voltage*/
       	beta_m_Icab,      /* permet le calcul de tau_m_Cab et m_1_Cab
       			en tenant compte du voltage*/

       	tau_m_Ih,	/* cste de temps d'activation des
       			canaux pour le courant Ih */
       	m_1_Ih,		/* facteur permettant de calculer m_Ih */
       	alpha_m_Ih,	/* permet le calcul de tau_m_Ih et m_1_Ih
       			en tenant compte du voltage*/
       	beta_m_Ih,	/* permet le calcul de tau_m_Ih et m_1_Ih
       			en tenant compte du voltage*/
       	tau_m_ahp,      /* cste de temps d'activation des canaux
       			K pour le courant Iahp */
       	m_1_ahp,        /* facteur intervenant dans le calcul
       			de m_ahp */
       	f1_Ca,          /* permet le calcul de tau_m_ahp
       			et m_1_ahp en tenant compte de [Ca]*/
       	b1 =2.5,        /* permet le calcul de tau_m_ahp
       			et m_1_ahp */

       	soma_avant,	/* pour calculer la pente */
       	delta_potentiel,/* cgt local de potentiel */
       	delta_clamp_current,/* variation de courant pour maintenir V const */
       	decay,		/* variable intermediaire */
       	curr_time,	/* variable intermediaire */
       	tau_a_epsp,	/* variables intermediaires: tau en pas d'iteration */
       	tau_d_epsp,
       	tau_a_ipsp,
       	tau_d_ipsp,
       			/* variables locales pour NMDA */

       	coeff_NMDA,	/* intermediaire de calcul */
       	radius,		/* rayon de la cellule */
       	t_NMDA;		/* temps actuel en ms */

       t_NMDA = (float)nb_it * time_step;

       t_i = (float)nb_it;

       soma_avant = le_potentiel;

  /******************************************************************/
  /*----  Calcul de la conductance au K pour le courant
          de rectification retardee                     ------------*/
  /******************************************************************/

  if (model_type==MICHAELIS_MENTON_MODEL || model_type==HH_SIMPLE_MODEL )
  {
      /****      variable d'activation des canaux K         ****/
      alpha_m_K =  exp(A_K * (le_potentiel - V_K));
      beta_m_K = exp(-A_K * (le_potentiel - V_K));
      tau_m_K = (1. / ( lambda_Ik * (alpha_m_K + beta_m_K)));
      m_1_K = alpha_m_K / ( alpha_m_K + beta_m_K);
      decay = (exp (-time_step / tau_m_K));
      m_K = m_K * (decay) + m_1_K * (1. - decay);
      
      /****         Conductance et courant K                 ****/
      if (drug_TEA) 
		I_K = G_K = 0.;
      else
	  {
	  	G_K = g_K * pow(m_K,Pow_K);
	  	I_K = G_K * (le_potentiel - E_K);
	  }
#if DEBUG
      printf("K  -> m_K: %f A_K: %f V_K: %f I_K: %f\n",m_K,  A_K, V_K, I_K);
#endif
    }

/*---------------------------------------------------------------*/ 

  if (model_type==HH_PUMP_MODEL)
  { 
      FoRT = F/(R*(Temp+273.15));
      F2oRT = F*FoRT;
      eVFoRT  = exp(le_potentiel*0.001*FoRT);
      emVFoRT = exp(-le_potentiel*0.001*FoRT);
      AVF2oRT = surface*le_potentiel*0.001*F2oRT;
      AComCieo1me = AVF2oRT*(K_ext - K_int*eVFoRT)/(1.0 - eVFoRT);

      /****      variable d'activation des canaux K         ****/
      alpha_m_K =  exp(A_K * (le_potentiel - V_K));
      beta_m_K = exp(-A_K * (le_potentiel - V_K));
      tau_m_K = (1. / ( lambda_Ik * (alpha_m_K + beta_m_K)));
      m_1_K = alpha_m_K / ( alpha_m_K + beta_m_K);
      decay = (exp (-time_step / tau_m_K));
      m_K = m_K * decay +  m_1_K * (1. - decay);
      
      /****         Conductance et courant K                 ****/
      temp = z_r*elec*(le_potentiel*0.001-Vr)/(K*(Temp+273.15));
      ez_peVmVpoKT = exp(temp);
      ea_pz_peVmVpoKT = exp(alpha_r*temp);

      decay = (-time_step / tau_p(taubar_r,ea_pz_peVmVpoKT,ez_peVmVpoKT,alpha_r) );
      param_r = param_r*decay + p_inf(nu_r,ez_peVmVpoKT)*( 1. - decay );


      if (drug_TEA) 
		G_K = I_K = 0.;
      else 
	  {
	  	G_K =  I_K / (le_potentiel - E_K); 
	  	I_K  = (float ) (P_bar_K*m_K*m_K*param_r*AComCieo1me);
	  }
    }

  
  /******************************************************************/
  /*---------     calcul de la conductance au Na     ---------------*/
  /******************************************************************/
  
  if (model_type==MICHAELIS_MENTON_MODEL)
  {
      /****      variable d'activation des canaux Na          ****/
      m_1_Na = 1. / (1. + (exp ( -2.0 * A_Na * (le_potentiel - V_Na))));
      
      /****        Conductance et Courant Na                ****/ 
      if (drug_TTX) 
	     I_Na = G_Na = 0.;
      else
      {
	    	G_Na = g_Na * pow(m_1_Na,Pow_Na) * (1.0 - m_Na) ;
	    	I_Na = G_Na * (le_potentiel - E_Na);
      }
    }
     /*---------------------------------------------------------------*/
    	if (model_type==HH_SIMPLE_MODEL)
    	{
      /****      variable d'activation des canaux Na          ****/
      		m_1_Na = 1. /(1. + exp (-2.0 * A_INa_A * (le_potentiel - V_INa_A)));

      /****    variable d'inactivation des canaux Na         ****/
      		h_1_Na = 1. /(1. + exp (-2.0 * A_INa_B * (le_potentiel - V_INa_B)));
      		decay = exp ( -time_step / Tau_INa_B);
      		h_Na = h_Na * decay + h_1_Na * (1. - decay);
  
      /****        Conductance et Courant Na                ****/ 
      		if (drug_TTX) 
      			I_Na =G_Na = 0.;
      		else
 			{
	    		G_Na = g_Na * pow(m_1_Na,Pow_INa_A) * pow(h_Na,Pow_INa_B) ;
	    		I_Na = G_Na * (le_potentiel - E_Na);
			}
  		}
  /*---------------------------------------------------------------*/ 

  if (model_type==HH_PUMP_MODEL)
  {
      FoRT = F/(R*(Temp+273.15));
      F2oRT = F*FoRT;
      eVFoRT  = exp(le_potentiel*0.001*FoRT);
      emVFoRT = exp(-le_potentiel*0.001*FoRT);
      AVF2oRT = surface*le_potentiel*0.001*F2oRT;
      AComCieo1me = AVF2oRT*(Na_ext - Na_int*eVFoRT)/(1.0 - eVFoRT);

      /****    variable d'activation des canaux Na             ****/
      m_1_Na = 1. /(1. + exp (-2.0 * A_INa_A * (le_potentiel - V_INa_A)));
      
      /****    variable d'inactivation des canaux Na          ****/
      h_1_Na = 1. /(1. + exp (-2.0 * A_INa_B * (le_potentiel - V_INa_B)));
      decay = exp ( -time_step / Tau_INa_B);
      h_Na = h_Na * decay + h_1_Na * (1. - decay);
      
      /****       Conductance et Courant Na                ****/
      temp = z_l*elec*(le_potentiel*0.001-Vl)/(K*(Temp+273.15));
      ez_peVmVpoKT = exp(temp);
      ea_pz_peVmVpoKT = exp(alpha_l*temp);

      decay = (-time_step / tau_p(taubar_l,ea_pz_peVmVpoKT,ez_peVmVpoKT,alpha_l) );
      param_l = param_l*decay + p_inf(nu_l,ez_peVmVpoKT)*( 1. - decay );

      if (drug_TTX) 
		G_Na = I_Na = 0.;
      else
      {
	  	I_Na = P_bar_Na*m_1_Na*m_1_Na*h_Na*param_l*AComCieo1me;
	  	G_Na = I_Na / (le_potentiel - E_Na); 
      }
  }

/***************************************************************/
/*--- calcul de la conductance pour le courant de pump I_P ----*/
/***************************************************************/

  if (model_type==MICHAELIS_MENTON_MODEL || model_type==HH_SIMPLE_MODEL )
    {
      I_P=G_P=0.;
    }

/*---------------------------------------------------------------*/ 

  if (model_type==HH_PUMP_MODEL)
    {
      I_P = (surface*F/3.) * ( Jbar_p_Na/( (1. + Km/Na_int)*(1. + Km/Na_int)*(1. + Km/Na_int)  ));
      G_P = I_P / (le_potentiel - E_Na); 
    }


#if DEBUG
  printf("I_Na= %f\n",I_Na);
  
  printf("Na -> V: %f A: %f V: %f I: %f\n",le_potentiel,  A_Na, V_Na, I_Na);
  printf("Na -> G_Na: %f g_Na: %f m_1_Na: %f\n",G_Na, g_Na, m_1_Na);
#endif



/*******************************************************************/
/*--- calcul de la conductance au calcium pour le courant I_Ca ----*/
/*******************************************************************/

  if (model_type==MICHAELIS_MENTON_MODEL || 
      model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )  
	{
	  /****      variable d'activation des canaux Ca         ****/
	  m_1_Ca = 1. / (1. + (exp (-2.0 * A_Ca * (le_potentiel - V_Ca))));
	  
	  decay = exp(-time_step/ Tau_Ca);
	  m_Ca = m_Ca * decay + m_1_Ca * ( 1. - decay);
	  
	  /****      variable d'inactivation des canaux Ca      ****/
	  h_Ca =  Ca_Kd / (Ca_Kd + Ca_i);
	  
	  /****      Conductance et courant Ca                 ****/
	  G_Ca = g_Ca * pow(m_Ca,Pow_Ca) * h_Ca ;
	  I_Ca = G_Ca * (le_potentiel - E_Ca); 
	  
	  
	  /*--- calcul de la concentration en calcium intracellulaire ---- */
	  
	  /* in reality, CA_i steady_state (g/f) = Kp(-Ica)/(-R)   */
	  /* where dy/dt = y*f + g */
	  m_1_Ca = Ca_Influx * (I_Ca) / (Ca_Removal);
	  decay = exp (time_step * (-Ca_Removal));
	  Ca_i = Ca_i * decay + m_1_Ca * ( decay - 1.0);
	  
#if DEBUG
	  printf("I_Ca: %f, Ca_i  -> %f\n",I_Ca, Ca_i);
#endif
	}
      /*---------------------------------------------------------------*/ 


/***************************************************************/
/*---   calcul de la conductance du courant ahp          ------*/
/***************************************************************/
  if (model_type==MICHAELIS_MENTON_MODEL || 
      model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )  
    {
      /****      variable d'activation des canaux Kahp  ****/

      m_ahp = Ca_i / ( Ca_i + K_Ca_Kd);
  
      /****      Conductance et courant                  ****/
      G_ahp = g_ahp * m_ahp ;
      I_ahp = G_ahp * (le_potentiel - E_K);
    }
/*---------------------------------------------------------------*/ 




#ifdef ADD_CURRENT
      /*--------   To add a current copy, modify and adapt   -------*/
      /*--- ATTENTION: Modify the equation. It is only for place holding --*/
      
      /*--- calcul de la conductance  pour le courant INew   -----------*/

      /****    variable d'activation des canaux New            ****/
      m_1_New = 1. /(1. + exp (-2.0 * A_INew_A * (le_potentiel - V_INew_A)));
  
      /****    variable d'inactivation des canaux New         ****/
      h_1_New = 1. /(1. + exp (-2.0 * A_INew_B * (le_potentiel - V_INew_B)));
  
      h_New = h_New * (decay = exp ( -time_step / Tau_INew_B)) +
              h_1_New * (1. - decay);
  
      /****       Conductance et Courant Ka                ****/
      G_New = g_New * pow(m_1_New,Pow_INew_A) * pow(h_New,Pow_INew_B) ;
      I_New = G_New * (le_potentiel - E_New);
  
#endif



 



  /********************************************************************/
  /*--- calcul de la conductance au k pour le courant Ia   -----------*/
  /********************************************************************/
  if (model_type==MICHAELIS_MENTON_MODEL || 
      model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )  
    {
      /****    variable d'activation des canaux Ka            ****/
      m_A = 1. /(1. + exp (-2.0 * A_Ia_A * (le_potentiel - V_Ia_A)));
      
      /****    variable d'inactivation des canaux Ka         ****/
      h_1_A = 1. /(1. + exp (-2.0 * A_Ia_B * (le_potentiel - V_Ia_B)));
      decay = exp ( -time_step / Tau_Ia_B);
      h_A = h_A * decay + h_1_A * (1. - decay);
  
      /****       Conductance et Courant Ka                ****/
      G_A = g_A * pow(m_A,Pow_Ia_A) * pow(h_A,Pow_Ia_B) ;
      I_A = G_A * (le_potentiel - E_K);
    }
  /*---------------------------------------------------------------*/ 



  /***************************************************************/
  /*---  calcul de la conductance au K pour le courant Im  ------*/
  /***************************************************************/

  if (model_type==MICHAELIS_MENTON_MODEL || 
      model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )
    {
      /****    variable d'activation des canaux Km        ****/
      alpha_m_Im =  exp(A_Im*(le_potentiel - V_Im));
      beta_m_Im = exp(-A_Im*(le_potentiel - V_Im));
      tau_m_M = (1. / (lambda_Im * (alpha_m_Im + beta_m_Im)));
      m_1_M = alpha_m_Im / ( alpha_m_Im + beta_m_Im);
  
#if DEBUG
      printf("m_M: %f tau_m_M: %f m_1_M: %f\n",
	     m_M, tau_m_M, m_1_M);
#endif
      decay = exp (-time_step / tau_m_M );
      m_M = m_M * decay + m_1_M * (1. - decay);
  
      /****        Conductance et courant Km             ****/
      G_M = g_M * m_M ;
      I_M = G_M * (le_potentiel - E_K);
    }
  /*---------------------------------------------------------------*/ 
 

  /******************************************************/    
  /*---   calcul de la conductance du courant Ic  ------*/
  /*  using by default V_Ic = -90                       */
  /*                   A_Ic = 0.05                      */
  /*                   lambda_Ic = 5                    */
  /* gives approximately same result as Methods 
                                   in neuronal modeling */
  /******************************************************/    

  if (model_type==MICHAELIS_MENTON_MODEL || 
      model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )
    {
      /****      variable d'activation des canaux Kc    ****/
      alpha_m_Ic = Ca_i * exp (A_Ic * (le_potentiel - V_Ic));
      beta_m_Ic  = exp (-A_Ic * (le_potentiel - V_Ic));
      m_1_C      = alpha_m_Ic / (alpha_m_Ic + beta_m_Ic);
      tau_m_C = 1./ (lambda_Ic * (alpha_m_Ic + beta_m_Ic));
      decay   = exp(-time_step/tau_m_C);
      m_C     = m_C * decay + m_1_C * (1. - decay );
  
      /****      Conductance et courant Kc              ****/
      G_C = g_C * m_C ;
      if (drug_TEA)	G_C = 0.;
      I_C = G_C * (le_potentiel - E_K);
    }

     
  /***************************************************/
  /*----  calcul de la conductance et du courant de 
          la rectification entrante au K+ (Ih)  -----*/
  /***************************************************/
  
  if (model_type==MICHAELIS_MENTON_MODEL || 
      model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )
    {
      /* default values:  (following Huguenard and McCormick 1993)
	 V_Ih = -75.0  A_Ih = -0.09  lambda = 0.0005  E_K= calcul*/
      
      /****    variable d'activation des canaux Ih        ****/
      alpha_m_Ih = exp(A_Ih * (le_potentiel - V_Ih));
      beta_m_Ih  = exp(-A_Ih * (le_potentiel - V_Ih));
      tau_m_Ih = (1. / (lambda_Ih * (alpha_m_Ih + beta_m_Ih)));
      m_1_Ih = alpha_m_Ih / ( alpha_m_Ih + beta_m_Ih);
      decay = exp (-time_step / tau_m_Ih);
      m_Ih  = m_Ih * decay + m_1_Ih * (1. - decay);
  
      /****        Conductance et courant Ih             ****/
      G_H = g_H * m_Ih ;
      if (drug_TEA)	G_H = 0;
      I_H = G_H * (le_potentiel - E_K);
    }
  /*---------------------------------------------------------------*/ 

  /**************************************************************/
  /*---  calcul de E_K car accumulation de K              ------*/
  /* d(Ko)/dt = IK_total/(Vperi*F) - (Ko - Krest)/(tauK-diff)   */
  /* from Methods in Neural modeling eds Koch and Segev pg. 115 */
  /* Krest = 2.5 mM, tauK-diff = 7msec                          */
  /* require radius of cell, in um                              */
  /* assumes extracellular space is 70nm radius                 */
  /**************************************************************/

  /*	radius = (diametre/2.);
	decay = exp(-time_step/7.);
        K_ext = K_ext * decay +
	7. * (((I_K + I_A + I_M + I_C + I_ahp)
	* (3.11e-10*pow(radius,2.0))/ 
	(pow(radius+0.07,3.0)-pow(radius,3.0)))
	+ (K_rest/7.)) * (1. - decay);
	
        E_K = 25.* (float) log(K_ext/140.);

  */
  
  reactualise_E_Na_K();
  
#if DEBUG
  printf(" %f\t, K_ext:%2.12f\t,E_K:%f\n",t_i, K_ext, E_K);
#endif
  


  /*****************************************************************************/
  /*---  calcul de la conductance au Na persistant pour le courant INap  ------*/
  
  /* default values:  V_Inap = -56.0  A_Inap = 0.07  lambda = 0.1  */
  /*****************************************************************************/
      
  if (model_type==MICHAELIS_MENTON_MODEL || 
      model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )
    {
      /****    variable d'activation des canaux Na p        ****/
      alpha_m_Inap =  exp(A_Inap * (le_potentiel - V_Inap));
      beta_m_Inap = exp(-A_Inap * (le_potentiel - V_Inap));
      tau_m_nap = (1. / (lambda_Inap * (alpha_m_Inap + beta_m_Inap)));
      m_1_Nap = alpha_m_Inap / ( alpha_m_Inap + beta_m_Inap);
      decay = exp (-time_step / tau_m_nap);
      m_Nap = m_Nap * decay +
              m_1_Nap * (1. - decay);
      
      /****        Conductance et courant Km             ****/
      G_Nap = g_Nap * m_Nap ;
      I_Nap = G_Nap * (le_potentiel - E_Na);
    }
  /*---------------------------------------------------------------*/ 

  /***************************************************************************/
  /*--- calcul de la conductance au Ca LVA pour le courant Icab   -----------*/
  
  /* default values:  Vm_Icab = -45.0  Am_Icab = 0.1  tau_m_Cab = 10.0 */
  /*   Vh_Icab = -70.0  Ah_Icab = 0.1  lambda_Icab = 0.005  */
  /***************************************************************************/
      
  if (model_type==MICHAELIS_MENTON_MODEL || 
      model_type==HH_SIMPLE_MODEL || model_type==HH_PUMP_MODEL )
    {

      /****    variable d'activation des canaux Ca_b            ****/
      alpha_m_Icab =  exp(Am_Icab * (le_potentiel - Vm_Icab));
      beta_m_Icab = exp(-Am_Icab * (le_potentiel - Vm_Icab));
      m_1_Cab = alpha_m_Icab / ( alpha_m_Icab + beta_m_Icab);
  
      /****    variable d'inactivation des canaux Cab         ****/
      alpha_h_Icab =  exp(-Ah_Icab * (le_potentiel - Vh_Icab));
      beta_h_Icab = exp(Ah_Icab * (le_potentiel - Vh_Icab));
      h_1_Cab = alpha_h_Icab / ( alpha_h_Icab + beta_h_Icab);
      tau_h_cab = (1. / (lambda_Icab));
      decay = exp ( -time_step / tau_m_cab);
      m_Cab = m_Cab * decay + m_1_Cab * (1. - decay);
      decay = exp ( -time_step / tau_h_cab);
      h_Cab = h_Cab * decay + h_1_Cab * (1. - decay);

      /****       Conductance et Courant Ka                ****/
      G_Cab = g_Cab *  pow(m_Cab,Pow_m_cab) * h_Cab ;
      I_Cab = G_Cab * (le_potentiel - E_Ca);
    }
  /*---------------------------------------------------------------*/ 
     
  /***********************************************************/
  /*--- calcul du courant de fuite                      -----*/
  /***********************************************************/
  if (model_type==MICHAELIS_MENTON_MODEL || model_type== HH_SIMPLE_MODEL )
    {
      I_fuite = g_fuite * (le_potentiel  - E_fuite);
      I_fuite_Na = g_fuite_Na * (le_potentiel  - E_Na);
      I_fuite_K = g_fuite_K * (le_potentiel  - E_K);

    }
  /*---------------------------------------------------------------*/ 
#if 0
  if (model_type==HH_PUMP_MODEL )
    {
      I_LNa = PL_Na*AVF2oRT ;
      I_LNa = I_LNa * (Na_ext - Na_int*eVFoRT ) ;
      I_LNa = I_LNa / (  1.   -        eVFoRT ) ;
      
      I_LK = PL_K*AVF2oRT ;
      I_LK = I_LK * (K_ext - K_int*eVFoRT ) ;
      I_LK = I_LK / (  1.   -      eVFoRT ) ;
      
      I_LCl = PL_Cl*AVF2oRT ;
      I_LCl = I_LCl * (Cl_ext - Cl_int*eVFoRT ) ;
      I_LCl = I_LCl / (  1.   -        eVFoRT ) ;
  }
#endif


  /***********************************************************/
  /*--- calcul de la conductance du courant synaptique   ----*/
  /***********************************************************/


/*
  I_Syn_pos = 0.;
*/  
  sum_inputs = 0.;
  
/*
#if DEBUG_V8
  for (nb_r = 0; nb_r < nb_receptors; nb_r++)
  {
    printf("1 - Recp %d: %d (%d) (%s)\n", nb_r, Receptors[nb_r].transmetteur, Receptors[nb_r].num_transm, Receptors[nb_r].nom);
  }
#endif
*/
  for (j = 0; j < nb_spikes; j++)
  {
      if (tab_syn[j].num_transm == NO_TRANSMISSION)
	  {
      	continue;
	  }
      curr_time = tab_syn[j].t_arrivee / time_step;
	  tab_syn[j].G_syn = 0.;
      if (t_i < curr_time)
      {
	  	tab_syn[j].syn = 0.;
      }
      else
      {
		if (tab_syn[j].weight) /* le poids ne sert pas a definir E ou I, c'est le rev_pot qui le fait */
    	{
        		   if ( t_i < (curr_time + tab_syn[j].tau_a_psp) && t_i > curr_time)
        		   {
        		     	sum_inputs += (t_i - curr_time) / tab_syn[j].tau_a_psp *
        		                  exp(((curr_time - t_i) / tab_syn[j].tau_a_psp) + 1.);
        		   }
        		   if ( t_i >= (curr_time + tab_syn[j].tau_a_psp))
        		   {
        		     	sum_inputs += (t_i - curr_time + tab_syn[j].tau_d_psp - tab_syn[j].tau_a_psp)
        		                  / tab_syn[j].tau_d_psp *
        		                  exp(((curr_time - t_i - tab_syn[j].tau_d_psp + tab_syn[j].tau_a_psp)
        				       / tab_syn[j].tau_d_psp) + 1.);
        		   }
        		   tab_syn[j].syn = tab_syn[j].g_Syn * sum_inputs;
        		   tab_syn[j].G_syn += (tab_syn[j].weight * tab_syn[j].syn);

#if DEBUG_V8
        		   printf("3 - it %d (synapse %d [%s]): weight : %f, G_syn : %f, potentiel: %f, rev_pot: %f, dif(e-rev) : %f\n", 
				   		nb_it, j, nb_r, 
    			   		tab_syn[j].nom, tab_syn[j].weight, tab_syn[j].G_syn, le_potentiel, tab_syn[j].rev_pot,
    			   		(le_potentiel - tab_syn[j].rev_pot));
#endif		   
    	  } /* fin du if */
      } /* fin du else */
  } /* fin du for */



  /*************************************************************/
  /*---	calcul des courants de bruit	          ---------*/ 
  /*************************************************************/
  
  
  if (backgrd_noise_sd)
  {
      
      set = (int)time(0) & 077;
      noise = gasdev(&set);
      noise *= backgrd_noise_sd;
      noise += backgrd_noise_m;
  } /* fin du if */
  else
  	  noise = backgrd_noise_m;
  

/*------------------------ calcul de la conductance au NMDA --------------------------------*/
  
  G_NMDA = 0.;
  if (nb_connexions_NMDA > 0)
  {
      coeff_NMDA = g_NMDA / (1. + eta_NMDA * magnesium * exp(- gamma_NMDA
							     * le_potentiel));
      for (j = 0; j < nb_connexions_NMDA; j++)
	  {
	  	if (tab_NMDA[j].t_arrivee <= t_NMDA)
	    	G_NMDA += coeff_NMDA * tab_NMDA[j].weight
	              *(exp((tab_NMDA[j].t_arrivee - t_NMDA)/tau_attack_NMDA)
		    	  - exp((tab_NMDA[j].t_arrivee - t_NMDA)/tau_decay_NMDA));
	  } 
   } 
	

/***************************************************************************/
	switch (model_type)
	{
	  case MICHAELIS_MENTON_MODEL:
	      GL_Na=GL_K=GL_Cl=0.;
	      break;
	  case HH_SIMPLE_MODEL:
	      GL_Na=GL_K=GL_Cl=0.;
	      break;    
	  case HH_PUMP_MODEL:
	      g_fuite=0.;
	      break;
	}
/***************************************************************************/


/*--- Calcul du potentiel  de mb                         ------- */

#ifdef ADD_CURRENT
/*--------   To add a current copy, modify, adapt and replace the g_tot line by this new   -------*/
  g_tot = G_K + G_Na + G_A +  G_Ca + G_ahp + G_C + G_M + G_Nap + G_Cab + G_H + g_fuite + g_fuite_Na + g_fuite_K
          + G_Syn_pos + G_NMDA + G_New;
#endif
  g_tot = G_K + G_Na + G_A +  G_Ca + G_ahp + G_C + G_M + G_Nap + G_Cab + G_H + g_fuite + g_fuite_Na + g_fuite_K
		  + G_NMDA + GL_Na + GL_K + GL_Cl;
  for (j = 0; j < nb_spikes; j++)
  {
    	g_tot +=  tab_syn[j].G_syn;
  }


  if (g_tot == 0.) g_tot = 0.0000000001;

  /* on ne tient pas compte de la surface, car elle serai au numerateur et au denominateur */

  decay_mb_pot = exp ((-(g_tot) * time_step / capacite));

  /* mais la on n'y coupe pas... */

  g_tot = g_tot * surface_normalisee;
  
  if (voltage_clamp)
    {
      	delta_potentiel = (
			  (G_K + G_ahp + G_C + G_A + G_M) * E_K
			  + (G_Na * E_Na) + (G_Ca * E_Ca)
			  + (G_Nap * E_Na) + (G_Cab * E_Ca)
			  + (G_H * E_K)
#ifdef ADD_CURRENT
			  /*--------   To add a current copy, modify, adapt   -------*/
			  + (G_New * E_New)
#endif
			  + (g_fuite * E_fuite)

			  + (GL_Na * E_Na)
			  + (GL_K * E_K)
			  + (GL_Cl * E_Cl )
/*			  
			  + (G_Syn_pos * rev_pot_pos)
*/
			  + (G_NMDA * rev_pot_NMDA));
  		for (j = 0; j < nb_spikes; j++)
  		{
    		delta_potentiel += (tab_syn[j].G_syn * (le_potentiel - tab_syn[j].rev_pot));
  		}
		delta_potentiel /= g_tot;
	    delta_potentiel *= (1. - decay_mb_pot);
        delta_clamp_current = g_tot * delta_potentiel;
      
        le_potentiel = clamp_pot + input_voltage;
        courant_tot = courant_tot + delta_clamp_current;  
    } /* fin du if */
  else
    {
      delta_potentiel = 
			  (G_K + G_ahp + G_C + G_A + G_M) * E_K
			  + (G_Na * E_Na) + (G_Ca * E_Ca)
			  + (G_Nap * E_Na) + (G_Cab * E_Ca)
			  + (G_H * E_K)
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify, adapt   -------*/
			  + (G_New * E_New)
#endif
			  + (g_fuite * E_fuite)
			  + (g_fuite_Na * E_Na)
			  + (g_fuite_K * E_K)

			  + (GL_Na * E_Na)
			  + (GL_K * E_K)
			  + (GL_Cl * E_K)
/*			
			  + (G_Syn_pos * rev_pot_pos)
*/
			  + (G_NMDA * rev_pot_NMDA)
			  + input_current;
  		for (j = 0; j < nb_spikes; j++)
  		{
    		delta_potentiel += (tab_syn[j].G_syn * tab_syn[j].rev_pot);
  		}
		delta_potentiel /= g_tot;
	    delta_potentiel *= (1. - decay_mb_pot);
	    delta_potentiel += noise;
        le_potentiel = le_potentiel * decay_mb_pot + delta_potentiel;
        courant_tot = (g_tot * le_potentiel);
    } /* fin du else */

/*---  ca decharge ou pas?                              -------*/


  /*
   * ca decharge ou pas? Critere de pente du signal.
   */
  if ((le_potentiel - soma_avant >= spike_slope)
      && !spike_en_cours)
    {				/* on a un spike */
      la_spike = 1.;
      spike_en_cours = TRUE;
    } /* fin du if */
  else			/* pas de spike */
    {
      la_spike = 0.;
    } /* fin du else */
  
  if (spike_en_cours && (le_potentiel - soma_avant < 0))
    {
      spike_en_cours = FALSE;
    } /* fin du if */
  
#if DEBUG_RK2
  printf("Iteration: %f\n",t_i);
  printf("K  -> m_1_K: %f m_K: %f I_K: %f tau_m_K: %f\n",m_1_K, m_K,
	 I_K, tau_m_K);
  printf("Na -> m_1_Na: %f I_Na: %f\n",m_1_Na, I_Na);
  printf("V  -> %f\n",le_potentiel);
#endif


} /* fin du update_expon */


/*
 * generateur de nb aleatoires uniforme (recipes in C)
 */



float ran1(int *idum)
{
  static int ix1,ix2,ix3;
  static float r[98];
  float temp;
  static int iff=0;
  int j;
  void nrerror();

  if (*idum < 0 || iff == 0) 
    {
      iff=1;
      ix1=(IC1-(*idum)) % M1;
      ix1=(IA1*ix1+IC1) % M1;
      ix2=ix1 % M2;
      ix1=(IA1*ix1+IC1) % M1;
      ix3=ix1 % M3;
      for (j=1;j<=97;j++) 
	{
	  ix1=(IA1*ix1+IC1) % M1;
	  ix2=(IA2*ix2+IC2) % M2;
	  r[j]=(ix1+ix2*RM2)*RM1;
	}
      *idum=1;
    }
  ix1=(IA1*ix1+IC1) % M1;
  ix2=(IA2*ix2+IC2) % M2;
  ix3=(IA3*ix3+IC3) % M3;
  j=1 + ((97*ix3)/M3);
  if (j > 97 || j < 1)
    {
      printf("J = %d -> ", j);
      nrerror("RAN1: This cannot happen.");
    } /* fin du if */
  temp=r[j];
  r[j]=(ix1+ix2*RM2)*RM1;
  return temp;
}
       

/*
 * generateur de nb aleatoires a distribution gaussienne  (recipes in C)
 */

float gasdev(int *idum)
{
  static int iset=0;
  static float gset;
  float fac,r,v1,v2;
  float ran1();
  
  if (iset == 0)
    {
      do 
	{
	  v1=2.0*ran1(idum)-1.0;
	  v2=2.0*ran1(idum)-1.0;
	  r=v1*v1+v2*v2;
	} while (r >= 1.0);
      fac= sqrt(-2.0* log(r)/r);
      gset=v1*fac;
      iset=1;
      return v2*fac;
    } 
  else 
    {
      iset=0;
      return gset;
    }
}
void nrerror(char *error_text)
{
  
  fprintf(stderr,"Numerical Recipes run-time error...\n");
  fprintf(stderr,"%s\n",error_text);
  fprintf(stderr,"...now exiting to system...\n");
  exit(1);
}

void courbes_m_h(void)
{

  float	volt;
  
  register i, j, k;       /* indices */
  
  float alpha_m_Na,     /* facteur intervenant dans le calcul
			   de m_Na et tau_m_Na */
        beta_m_Na,      /* facteur intervenant dans le calcul
			   de m_Na et tau_m_Na */
       	alpha_h_Na,     /* facteur intervenant dans le calcul
			   de h_Na et tau_h_Na */
       	beta_h_Na,      /* facteur intervenant dans le calcul
			   de m_Na et tau_h_Na */
       	alpha_m_K,      /* facteur intervenant dans le calcul
			   de tau_m_K */
       	beta_m_K,       /* facteur intervenant dans le calcul
			   de tau_m_K */
       	alpha_m1_K,     /* facteur intervenant dans le calcul
			   de m1_k */
       	beta_m1_K,      /* facteur intervenant dans le calcul
			   de m1_k */
       	alpha_m_Im,     /* facteur intervenant dans le calcul
			   de tau_m_Im */
       	beta_m_Im,     /* facteur intervenant dans le calcul
			  de tau_m_Im */
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify, adapt   -------*/
       	alpha_m_INew,     /* permet le calcul de tau_m_C et m_1_C
			     en tenant compte de Ca et du voltage*/
       	beta_m_INew,      /* permet le calcul de tau_m_C et m_1_C
			     en tenant compte du voltage*/
#endif
       	alpha_m_Ic,       /* permet le calcul de tau_m_C et m_1_C
			     en tenant compte de Ca et du voltage*/
       	beta_m_Ic,        /* permet le calcul de tau_m_C et m_1_C
			     en tenant compte du voltage*/
       	alpha_m_Inap,     /* permet le calcul de tau_m_nap et m_1_Nap
			     en tenant compte du voltage*/
      	beta_m_Inap,        /* permet le calcul de tau_m_nap et m_1_Nap
			     en tenant compte du voltage*/
       	alpha_h_Icab,     /* permet le calcul de tau_h_Cab et h_1_Cab
			     en tenant compte de Ca et du voltage*/
       	beta_h_Icab,      /* permet le calcul de tau_h_Cab et h_1_Cab
			     en tenant compte du voltage*/
       	alpha_m_Icab,     /* permet le calcul de tau_m_Cab et m_1_Cab
			     en tenant compte de Ca et du voltage*/
       	beta_m_Icab,      /* permet le calcul de tau_m_Cab et m_1_Cab
			     en tenant compte du voltage*/
       	alpha_m_Ih,    	  /* permet le calcul de tau_m_Ih et m_1_Ih
			     en tenant compte du voltage*/
       	beta_m_Ih;	  /* permet le calcul de tau_m_Ih et m_1_Ih
			     en tenant compte du voltage*/


  i = 0;
  for (volt = -100.; volt <= 100.; volt += 10., i++)
    {
      voltage[i] = volt;
      
      /* Na */
      if (set_g_Na)
	{
	  if (model_type==MICHAELIS_MENTON_MODEL)	
	    {	  
	      /****      variable d'activation des canaux Na          ****/
	      activ[i] = 1. / (1. + (exp ( -2.0 * A_Na * (volt - V_Na))));
	      tau_activ[i] = 0.;
	      
	      /****      variable d'inactivation des canaux Na          ****/
	      inactiv[i] = 0.;
	      tau_inactiv[i] = 0.;
	      alpha_m_K =  exp(A_K * (volt - V_K));
	      beta_m_K = exp(-A_K * (volt - V_K));
	      coeff_G[i] = pow(activ[i],Pow_Na)
		           * (1.0 - (alpha_m_K / ( alpha_m_K + beta_m_K)));
	    }
	  if (model_type==HH_SIMPLE_MODEL)	
	    {
	      /****      variable d'activation des canaux Na          ****/
	      activ[i] = 1. / (1. + (exp ( -2.0 * A_INa_A * (volt - V_INa_A))));
	      tau_activ[i] = 0.;

	      /****      variable d'inactivation des canaux Na          ****/
	      inactiv[i] = 1. / (1. + (exp ( -2.0 * A_INa_B * (volt - V_INa_B))));
	      tau_inactiv[i] = 0.;
	      alpha_m_K =  exp(A_K * (volt - V_K));
	      beta_m_K = exp(-A_K * (volt - V_K));
	      coeff_G[i] = pow(activ[i],Pow_INa_A)
		           * (1.0 - (alpha_m_K / ( alpha_m_K + beta_m_K)));
	    }
#if 0
	  if (model_type==HH_PUMP_MODEL)	
	    {
	      /****      variable d'activation des canaux Na          ****/
	      activ[i] = 1. / (1. + (exp ( -2.0 * A_INa_A * (volt - V_INa_A))));
	      tau_activ[i] = 0.;

	      /****      variable d'inactivation des canaux Na          ****/
	      inactiv[i] = 1. / (1. + (exp ( -2.0 * A_INa_B * (volt - V_INa_B))));
	      tau_inactiv[i] = 0.;
	      alpha_m_K =  exp(A_K * (volt - V_K));
	      beta_m_K = exp(-A_K * (volt - V_K));
	      coeff_G[i] = pow(activ[i],Pow_INa_A)
	      * (1.0 - (alpha_m_K / ( alpha_m_K + beta_m_K)));
	    }
#endif
	} /* fin du if */
      
      /* K */
      if (set_g_K)
	{
	  /****      variable d'activation des canaux K         ****/
	  alpha_m_K =  exp(A_K * (volt - V_K));
	  beta_m_K = exp(-A_K * (volt - V_K));
	  activ[i] = alpha_m_K / ( alpha_m_K + beta_m_K);
	  tau_activ[i] = (1. / ( lambda_Ik * (alpha_m_K + beta_m_K)));

	  /****      variable d'inactivation des canaux K      ****/
	  inactiv[i] = 0.;
	  tau_inactiv[i] = 0.;
	  
	  coeff_G[i] = pow(activ[i],Pow_K);
	  
	} /* fin du if */
      
      /* Ca */
      if (set_g_Ca)
	{
	  /****      variable d'activation des canaux Ca         ****/
	  activ[i] = 1. / (1. + (exp (-2.0 * A_Ca * (volt - V_Ca))));
	  tau_activ[i] = 0.;
	  
	  /****      variable d'inactivation des canaux Ca      ****/
	  inactiv[i] =  Ca_Kd / (Ca_Kd + Ca_i);
	  tau_inactiv[i] = 0.;
	  coeff_G[i] =  pow(inactiv[i],Pow_Ca) * inactiv[i];
	  
	} /* fin du if */
      
      /* Iahp */
      if (set_g_ahp)
	{
	  /****      variable d'activation des canaux Kahp  ****/
	  activ[i] = Ca_i / ( Ca_i + K_Ca_Kd);
	  tau_activ[i] = 0.;
	  inactiv[i] = 0.;
	  tau_inactiv[i] = 0.;
	  coeff_G[i] =  activ[i];
	  
	} /* fin du if */
      
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify, adapt   -------*/
/*---------    Modify accordingly the equations   ---------*/

      /* I New */
      if (set_g_New)
	{
	  /****    variable d'activation des canaux New            ****/
	  activ[i] = 1. /(1. + exp (-2.0 * A_INew_A * (volt - V_INew_A)));
	  tau_activ[i] = 0.;
	  
	  /****    variable d'inactivation des canaux New         ****/
	  inactiv[i] = 1. /(1. + exp (-2.0 * A_INew_B * (volt - V_INew_B)));
	  tau_inactiv[i] = 0.;
	  coeff_G[i] =  pow(activ[i],Pow_INew_A) * pow(tau_inactiv[i],Pow_INew_B);
	  
	} /* fin du if */
      
#endif
      /* Ia */
      if (set_g_A)
	{
	  /****    variable d'activation des canaux Ka            ****/
	  activ[i] = 1. /(1. + exp (-2.0 * A_Ia_A * (volt - V_Ia_A)));
	  tau_activ[i] = 0.;
	 
	  /****    variable d'inactivation des canaux Ka         ****/
	  inactiv[i] = 1. /(1. + exp (-2.0 * A_Ia_B * (volt - V_Ia_B)));
	  tau_inactiv[i] = 0.;
	  coeff_G[i] =  pow(activ[i],Pow_Ia_A) * pow(tau_inactiv[i],Pow_Ia_B);
	 
	} /* fin du if */
      
      /* Im */
      if (set_g_M)
	{
	  /****    variable d'activation des canaux Km        ****/
	  alpha_m_Im =  exp(A_Im*(volt - V_Im));
	  beta_m_Im = exp(-A_Im*(volt - V_Im));
	  activ[i] = alpha_m_Im / ( alpha_m_Im + beta_m_Im);
	  tau_activ[i] = (1. / (lambda_Im * (alpha_m_Im + beta_m_Im)));

	  /****    variable d'inactivation des canaux Km        ****/
	  inactiv[i] = 0.;
	  tau_inactiv[i] = 0.;
	  coeff_G[i] =  activ[i];
	 
	} /* fin du if */
      
      /* Ic */
      if (set_g_C)
	{
	  /****      variable d'activation des canaux Kc    ****/
	  alpha_m_Ic = Ca_i * exp (A_Ic * (volt - V_Ic));
	  beta_m_Ic = exp (-A_Ic * (volt - V_Ic));
	  activ[i] = alpha_m_Ic / (alpha_m_Ic + beta_m_Ic);
	  tau_activ[i] = 1./ (lambda_Ic * (alpha_m_Ic + beta_m_Ic));

	  /****      variable d'inactivation des canaux Kc    ****/
	  inactiv[i] = 0.;
	  tau_inactiv[i] = 0.;
	  coeff_G[i] =  activ[i];
	 
	} /* fin du if */
      
      /* Ih */
      if (set_g_H)
	{
	  /****    variable d'activation des canaux Ih        ****/
	  alpha_m_Ih =  exp(A_Ih * (volt - V_Ih));
	  beta_m_Ih = exp(-A_Ih * (volt - V_Ih));
	  activ[i] = alpha_m_Ih / ( alpha_m_Ih + beta_m_Ih);
	  tau_activ[i] = (1. / (lambda_Ih * (alpha_m_Ih + beta_m_Ih)));

	  /****    variable d'inactivation des canaux Ih        ****/
	  inactiv[i] = 0.;
	  tau_inactiv[i] = 0.;
	  coeff_G[i] = activ[i];
	 
	} /* fin du if */
	  
      /* INap */
      if (set_g_Nap)
	{
	  /****    variable d'activation des canaux Na p        ****/
	  alpha_m_Inap =  exp(A_Inap * (volt - V_Inap));
	  beta_m_Inap = exp(-A_Inap * (volt - V_Inap));
	  activ[i] = alpha_m_Inap / ( alpha_m_Inap + beta_m_Inap);
	  tau_activ[i] = (1. / (lambda_Inap * (alpha_m_Inap + beta_m_Inap)));

	  /****    variable d'inactivation des canaux Na p        ****/
	  inactiv[i] = 0.;
	  tau_inactiv[i] = 0.;
	  coeff_G[i] =  activ[i];
	 
	} /* fin du if */
      
      /* Icab */
      if (set_g_Cab)
	{
	  /****    variable d'activation des canaux Ca_b            ****/
	  alpha_m_Icab =  exp(Am_Icab * (volt - Vm_Icab));
	  beta_m_Icab = exp(-Am_Icab * (volt - Vm_Icab));
	  activ[i] = alpha_m_Icab / ( alpha_m_Icab + beta_m_Icab);
	  tau_activ[i] = 0.;

	  /****    variable d'inactivation des canaux Cab         ****/
	  alpha_h_Icab =  exp(-Ah_Icab * (volt - Vh_Icab));
	  beta_h_Icab = exp(Ah_Icab * (volt - Vh_Icab));
	  inactiv[i] = alpha_h_Icab / ( alpha_h_Icab + beta_h_Icab);
	  tau_inactiv[i] = (1. / (lambda_Icab));
	  coeff_G[i] =  pow(activ[i],Pow_m_cab) * inactiv[i];
	 
	} /* fin du if */
      if (set_g_fuite || set_g_fuite_Na || set_g_fuite_K || set_g_NMDA || set_g_Syn_pos || set_g_Syn_neg)
	{
	  activ[i] = tau_activ[i] = inactiv[i] = tau_inactiv[i] = coeff_G[i] = 0.;
	} /* fin du if */
      
    } /* fin du for */
  
} /* fin du void */


/*
 * derive(float t_i, float *valeurs, float *val_derivee)
 *
 * fonction pour calculer la derivee des differentes equations
 *
 * Les valeurs sont rangees dans l'ordre suivant:
 *
 		V
 		m_K
 		m_Ca
 		h_A
 		m-M
 		m_C
 		m_H
 		m_Nap
 		m_Cab
 		h_Cab
 		Ca_i
 		K_ext
 *
 */

void	 derive(float t_i, float *valeurs, float *val_derivee)
{
  
  int	j, set, nb_r, nb_it;

  double temp,                   /* parametre intervenant dans les calculs */
	 ez_peVmVpoKT,           /* parametre intervenant dans les calculs */
         ea_pz_peVmVpoKT,        /* parametre intervenant dans les calculs */
         oma_poa_p,              /* parametre intervenant dans les calculs */
         ez_pz_peVmVpoKT,        /* parametre intervenant dans les calculs */
         FoRT,                   /* parametre intervenant dans les calculs */
         F2oRT,                  /* parametre intervenant dans les calculs */
         eVFoRT,                 /* parametre intervenant dans les calculs */
         emVFoRT,                /* parametre intervenant dans les calculs */
         AVF2oRT,                /* parametre intervenant dans les calculs */
         AComCieo1me;            /* parametre intervenant dans les calculs */

  float gasdev(int *),
		soma_avant,
        delta_potentiel,
        delta_clamp_current,
		sum_inputs,
       	sum_i_pos,		/* pour la somme des inputs */
       	sum_i_neg,		/* pour la somme des inputs */
        tau_m_Na,               /* cste de temps de l'activation
				   des canaux Na  */
       	m_1_Na,                 /* facteur intervenant dans le calcul
				   de m_Na*/
       	h_1_Na,         /* facteur intervenant dans le calcul
       			de h_na */
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify, adapt   -------*/
/*---------    Modify accordingly with the equations   ---------*/

       	m_1_New,         /* facteur intervenant dans le calcul
			    de m_New*/
       	tau_m_Mew,       /* cste de temps d'activation des
			    canaux New */
       	alpha_m_New,     /* facteur intervenant dans le calcul
			    de m_New et tau_m_New */
       	beta_m_New,      /* facteur intervenant dans le calcul
			    de m_New et tau_m_New */
       	tau_h_New,       /* cste de temps d'inactivation des
			    canaux New */
       	h_1_New,         /* facteur intervenant dans le calcul
			    de h_New */
       	alpha_h_New,     /* facteur intervenant dans le calcul
			    de h_New et tau_h_New */
       	beta_h_New,      /* facteur intervenant dans le calcul
			    de m_New et tau_h_New */
#endif
       	m_1_Ca,         /* facteur intervenant dans le calcul
			   de m_Ca */
       	tau_m_K,        /* cste de temps de l'activation
			   des canaux K */
       	m_1_K,          /* facteur intervenant dans le calcul
			   de m_K */
       	alpha_m_K,      /* facteur intervenant dans le calcul
			   de tau_m_K */
       	beta_m_K,       /* facteur intervenant dans le calcul
			   de tau_m_K */
       	m_1_A,          /* facteur intervenant dans le  calcul
			   de m_A */
       	h_1_A,          /* facteur intervenant dans le calcul
			   de h_A */
       	alpha_m_Im,     /* facteur intervenant dans le calcul
			   de tau_m_Im */
       	beta_m_Im,     /* facteur intervenant dans le calcul
			  de tau_m_Im */
       	tau_m_M,        /* cste de temps d'activation des
			   canaux k pour le courant Im */
       	m_1_M,          /* facteur intervenant dan le calcul
			   de m_M */
       	tau_m_C,        /* cste de temps d'activation des
			   canaux K dependants du calcium et
			   du voltage */
        m_1_C,          /* facteur permettant de calculer m_C */
       	alpha_m_Ic,     /* permet le calcul de tau_m_C et m_1_C
			   en tenant compte de Ca et du voltage*/
       	beta_m_Ic,      /* permet le calcul de tau_m_C et m_1_C
			   en tenant compte du voltage*/
       
	tau_m_nap,        /* cste de temps d'activation des
			     canaux K dependants du calcium et
			     du voltage */
       	m_1_Nap,          /* facteur permettant de calculer m_Nap */
       	alpha_m_Inap,     /* permet le calcul de tau_m_nap et m_1_Nap
			     en tenant compte du voltage*/
        beta_m_Inap,      /* permet le calcul de tau_m_nap et m_1_Nap
			     en tenant compte du voltage*/

       	tau_h_cab,        /* cste de temps d`activation des
			     canaux K dependants du calcium et
			     du voltage */
       	m_1_Cab,          /* facteur permettant de calculer m_Cab */
       	h_1_Cab,          /* facteur permettant de calculer m_Cab */
       	alpha_h_Icab,     /* permet le calcul de tau_h_Cab et h_1_Cab
			     en tenant compte de Ca et du voltage*/
       	beta_h_Icab,      /* permet le calcul de tau_h_Cab et h_1_Cab
			     en tenant compte du voltage*/
       	alpha_m_Icab,     /* permet le calcul de tau_m_Cab et m_1_Cab
			     en tenant compte de Ca et du voltage*/
       	beta_m_Icab,      /* permet le calcul de tau_m_Cab et m_1_Cab
			     en tenant compte du voltage*/

       	tau_m_Ih,	/* cste de temps d'activation des
			   canaux pour le courant Ih */
       	m_1_Ih,		/* facteur permettant de calculer m_Ih */
       	alpha_m_Ih,	/* permet le calcul de tau_m_Ih et m_1_Ih
			   en tenant compte du voltage*/
        beta_m_Ih,	/* permet le calcul de tau_m_Ih et m_1_Ih
			   en tenant compte du voltage*/

       	m_1_ahp,        /* facteur intervenant dans le calcul
			   de m_ahp */
       	decay,		/* variable intermediaire */
       	curr_time,	/* variable intermediaire */
       	tau_a_epsp,	/* variables intermediaires: tau en pas d'iteration */
       	tau_d_epsp,
       	tau_a_ipsp,
       	tau_d_ipsp,
       			/* variables locales pour NMDA */

       	coeff_NMDA,	/* intermediaire de calcul */
       	radius,		/* rayon de la cellule */
       	t_NMDA;		/* temps actuel en ms */

  	t_NMDA = t_i * time_step;
  

    soma_avant = le_potentiel;

  /**********************************************************/  
  /****         Conductance et courant K                 ****/
  /**********************************************************/  

  if (model_type==MICHAELIS_MENTON_MODEL || model_type==HH_SIMPLE_MODEL )
    {
      if (drug_TEA)
	{
	  G_K = I_K = 0.;
	} /* fin du if */
      else
	{
	  G_K = g_K * pow(valeurs[d_m_K],Pow_K);
	  I_K = G_K * (valeurs[d_V] - E_K);
	} /* fin du else */
    }
  /*--------------------------------------------------------*/  
  if (model_type==HH_PUMP_MODEL )
    {
      FoRT = F/(R*(Temp+273.15));
      F2oRT = F*FoRT;
      eVFoRT = exp(valeurs[d_V]*0.001*FoRT);
      emVFoRT = exp(-valeurs[d_V]*0.001*FoRT);
      AVF2oRT = surface*valeurs[d_V]*0.001*F2oRT;
      AComCieo1me = AVF2oRT*(K_ext - K_int*eVFoRT)/(1.0 - eVFoRT);      
      
      /****         Conductance et courant K                 ****/
      if (drug_TEA) 
		G_K = I_K = 0.;
      else
		{
		  I_K  = (float)P_bar_K*valeurs[d_m_K]*valeurs[d_m_K]*valeurs[d_r]*AComCieo1me;
		  G_K =  I_K / (valeurs[d_V] - E_K); 
		}      
    }

/*******************************************************************/  
/*-------     calcul de la conductance au Na     ------------------*/
/*******************************************************************/  


  if (model_type==MICHAELIS_MENTON_MODEL )
    {
      if (drug_TTX) 
	G_Na = I_Na = 0.;
      else
	{
	  /****      variable d'activation des canaux Na          ****/
	  m_1_Na = 1. / (1. + (exp ( -2.0 * A_Na * (valeurs[d_V] - V_Na))));
	  
	  /****        Conductance et Courant Na                ****/ 
	  G_Na = g_Na * pow(m_1_Na,Pow_Na)  * (1.0 - valeurs[d_m_K])   ; 
	  I_Na = G_Na * (valeurs[d_V] - E_Na);
	  
	} /* fin du else */
    }
  /*--------------------------------------------------------*/  
  if (model_type== HH_SIMPLE_MODEL )
    {
      if (drug_TTX) 
	I_Na =G_Na = 0.;
      else
	{
	  /****      variable d'activation des canaux Na          ****/
	  m_1_Na = 1. /(1. + exp (-2.0 * A_INa_A * (valeurs[d_V] - V_INa_A)));
	  
	  /****        Conductance et Courant Na                ****/ 
	  G_Na = g_Na * pow(m_1_Na,Pow_INa_A) * pow(valeurs[d_h_Na],Pow_INa_B) ;
	  I_Na = G_Na * (le_potentiel - E_Na);       
	} /* fin du else */
    }
  /*--------------------------------------------------------*/  
  if (model_type==HH_PUMP_MODEL)
    {
      FoRT = F/(R*(Temp+273.15));
      F2oRT = F*FoRT;
      eVFoRT  = exp(valeurs[d_V]*0.001*FoRT);
      emVFoRT = exp(-valeurs[d_V]*0.001*FoRT);
      AVF2oRT = surface*valeurs[d_V]*0.001*F2oRT;
      AComCieo1me = AVF2oRT*(Na_ext - Na_int*eVFoRT)/(1.0 - eVFoRT);
  
      /****       Conductance et Courant Na                ****/
      if (drug_TTX) 
	G_Na = I_Na = 0.;
      else
	{
	  I_Na = (float )P_bar_Na*valeurs[d_m_Na]*valeurs[d_m_Na]*valeurs[d_h_Na]*valeurs[d_l]*AComCieo1me;
	  G_Na = I_Na / (valeurs[d_V] - E_Na); 
	}
    }

  /*******************************************************************/  
  /*--- calcul de la conductance au calcium pour le courant I_Ca ----*/
  /*******************************************************************/  


  /****      variable d'inactivation des canaux Ca      ****/
  h_Ca =  Ca_Kd / (Ca_Kd + valeurs[d_Ca_i]);
  
  /****      Conductance et courant Ca                 ****/
  G_Ca = g_Ca * pow(valeurs[d_m_Ca],Pow_Ca) * h_Ca ;
  I_Ca = G_Ca * (valeurs[d_V] - E_Ca); 
  

	
  /***************************************************************/  
  /*---   calcul de la conductance du courant ahp          ------*/
  /***************************************************************/  


  if (drug_TEA) G_ahp = I_ahp = 0.;
  else
    {
      /****      variable d'activation des canaux Kahp  ****/
      m_1_ahp = valeurs[d_Ca_i] / ( valeurs[d_Ca_i] + K_Ca_Kd);
      
      /****      Conductance et courant                  ****/
      G_ahp = g_ahp * m_1_ahp ;
      I_ahp = G_ahp * (valeurs[d_V] - E_K);
    }
  

  /***************************************************************/  
  /*--- calcul de la conductance au k pour le courant Ia   ------*/
  /***************************************************************/  


  /****    variable d'activation des canaux Ka            ****/
  m_1_A = 1. /(1. + exp (-2.0 * A_Ia_A * (valeurs[d_V] - V_Ia_A)));
  
  /****       Conductance et Courant Ka                ****/
  G_A = g_A * pow(m_1_A,Pow_Ia_A) * pow(valeurs[d_h_A],Pow_Ia_B) ;
  I_A = G_A * (valeurs[d_V] - E_K);
	


  /***************************************************************/  
  /*---  calcul de la conductance au K pour le courant Im  ------*/
  /***************************************************************/  


  /****        Conductance et courant Km             ****/
  G_M = g_M * valeurs[d_m_M] ;
  I_M = G_M * (valeurs[d_V] - E_K);



  /**************************************************************/  
  /*---   calcul de la conductance du courant Ic          ------*/
  /**************************************************************/  


  /****      Conductance et courant Kc              ****/
  if (drug_TEA)
	G_C = I_C = 0.;
  else
    {
      G_C = g_C * valeurs[d_m_C] ;
      I_C = G_C * (valeurs[d_V] - E_K);
    } /* fin du else */




  /******************************************************************/  
  /*---  calcul de la conductance et du courant de la rectification 
                                         entrante au K+ (Ih)  ------*/
  /******************************************************************/

  
  if (drug_TEA)
	G_H = 0;
  else
    {
      /****        Conductance et courant Ih             ****/
      G_H = g_H * valeurs[d_m_Ih] ;
      I_H = G_H * (valeurs[d_V] - E_K);
    } /* fin du else */



  
  /**************************************************************/  
  /*---  calcul de la conductance au Na persistant 
                                    pour le courant INap  ------*/
  /**************************************************************/  


  /****        Conductance et courant Km             ****/
  G_Nap = g_Nap * valeurs[d_m_Nap] ;
  I_Nap = G_Nap * (valeurs[d_V] - E_Na);



  /*****************************************************************/  
  /*--- calcul de la conductance au Ca LVA pour le courant Icab ---*/
  /*****************************************************************/  


  /****       Conductance et Courant Ka                ****/
  G_Cab = g_Cab *  pow(valeurs[d_m_Cab],Pow_m_cab) * valeurs[d_h_Cab] ;
  I_Cab = G_Cab * (valeurs[d_V] - E_Ca);

#ifdef ADD_CURRENT
/*--------   To add a current copy, modify, adapt   -------*/

/*--- calcul de la conductance  pour le courant INew   -----------*/

  /****    variable d'activation des canaux New            ****/
  m_1_New = 1. /(1. + exp (-2.0 * A_INew_A * (valeurs[d_V] - V_INew_A)));

  /****       Conductance et Courant INew                ****/
  G_New = g_New * pow(m_1_A,Pow_INew_A) * pow(valeurs[d_h_New],Pow_INew_B) ;
  I_New = G_New * (valeurs[d_V] - E_New);
#endif


  /***********************************************************/  
  /*--- calcul du courant de fuite                      -----*/
  /***********************************************************/  


  if (model_type==MICHAELIS_MENTON_MODEL || model_type== HH_SIMPLE_MODEL)
    {
      I_fuite = g_fuite * (valeurs[d_V]  - E_fuite);
      I_fuite_Na = g_fuite_Na * (valeurs[d_V]  - E_Na);
      I_fuite_K = g_fuite_K * (valeurs[d_V]  - E_K);
    }
  /*---------------------------------------------------------*/
  if (model_type==HH_PUMP_MODEL)
    {
      I_LNa = PL_Na*AVF2oRT ;
      I_LNa = I_LNa * (Na_ext - Na_int*eVFoRT ) ;
      I_LNa = I_LNa / (  1.   -        eVFoRT ) ;
      
      I_LK = PL_K*AVF2oRT ;
      I_LK = I_LK * (K_ext - K_int*eVFoRT ) ;
      I_LK = I_LK / (  1.   -      eVFoRT ) ;
      
      I_LCl = PL_Cl*AVF2oRT ;
      I_LCl = I_LCl * (Cl_ext - Cl_int*eVFoRT ) ;
      I_LCl = I_LCl / (  1.   -        eVFoRT ) ;
    }

  /***********************************************************/
  /*--- calcul de la conductance du courant synaptique   ----*/
  /***********************************************************/


/*
  I_Syn_pos = 0.;
*/  
  sum_inputs = 0.;
  
/*
#if DEBUG_V8
  for (nb_r = 0; nb_r < nb_receptors; nb_r++)
  {
    printf("1 - Recp %d: %d (%d) (%s)\n", nb_r, Receptors[nb_r].transmetteur, Receptors[nb_r].num_transm, Receptors[nb_r].nom);
  }
#endif
*/
  for (j = 0; j < nb_spikes; j++)
  {
      if (tab_syn[j].num_transm == NO_TRANSMISSION)
	  {
      	continue;
	  }
      curr_time = tab_syn[j].t_arrivee / time_step;
	  tab_syn[j].G_syn = 0.;
      if (t_i < curr_time)
      {
	  	tab_syn[j].syn = 0.;
      }
      else
      {
		if (tab_syn[j].weight) /* le poids ne sert pas a definir E ou I, c'est le rev_pot qui le fait */
    	{
        		   if ( t_i < (curr_time + tab_syn[j].tau_a_psp) && t_i > curr_time)
        		   {
        		     	sum_inputs += (t_i - curr_time) / tab_syn[j].tau_a_psp *
        		                  exp(((curr_time - t_i) / tab_syn[j].tau_a_psp) + 1.);
        		   }
        		   if ( t_i >= (curr_time + tab_syn[j].tau_a_psp))
        		   {
        		     	sum_inputs += (t_i - curr_time + tab_syn[j].tau_d_psp - tab_syn[j].tau_a_psp)
        		                  / tab_syn[j].tau_d_psp *
        		                  exp(((curr_time - t_i - tab_syn[j].tau_d_psp + tab_syn[j].tau_a_psp)
        				       / tab_syn[j].tau_d_psp) + 1.);
        		   }
        		   tab_syn[j].syn = tab_syn[j].g_Syn * sum_inputs;
        		   tab_syn[j].G_syn += (tab_syn[j].weight * tab_syn[j].syn);	   
    	  } /* fin du if */
      } /* fin du else */
  } /* fin du for */


  /******************************************************/  
  /*-------- calcul de la conductance au NMDA ----------*/
  /******************************************************/  


  G_NMDA = I_NMDA = 0.;
  
  if (nb_connexions_NMDA > 0)
  {
      coeff_NMDA = g_NMDA / (1. + eta_NMDA * magnesium * exp(- gamma_NMDA
							     * valeurs[d_V]));
      for (j = 0; j < nb_connexions_NMDA; j++)
	  {
	  		if (tab_NMDA[j].t_arrivee <= t_NMDA)
	    			G_NMDA += coeff_NMDA * tab_NMDA[j].weight
	              	*(exp((tab_NMDA[j].t_arrivee - t_NMDA)/tau_attack_NMDA)
		      		- exp((tab_NMDA[j].t_arrivee - t_NMDA)/tau_decay_NMDA));
	  } 
      I_NMDA = G_NMDA * (valeurs[d_V] - rev_pot_NMDA);
  } 
  

/***************************************************************************/
  switch (model_type)
  {
    case MICHAELIS_MENTON_MODEL:
    {
      GL_Na = GL_K = GL_Cl = 0;
      break;
    }
    case HH_SIMPLE_MODEL:
    {
      GL_Na = GL_K = GL_Cl = 0;
      break;    
    }
    case HH_PUMP_MODEL:
    {
      g_fuite = 0;
      break;
    }
  }
/***************************************************************************/

	
  /******************************************************/  
  /*--------------   Conductance totale   --------------*/
  /******************************************************/  


#ifdef VOLTAGE_CLAMP_RK

/* make a core... */

  g_tot = G_K + G_Na + G_A +  G_Ca + G_ahp + G_C + G_M + G_Nap + G_Cab + G_H + g_fuite + g_fuite_Na + g_fuite_K 
          + G_Syn_pos - G_Syn_neg + G_NMDA + GL_Na + GL_K + GL_Cl;

  if (g_tot == 0.) g_tot = 0.0000000001;

  decay_mb_pot = exp (-(g_tot) * time_step / capacite);

  g_tot = g_tot * surface_normalisee;
  
  
  if (voltage_clamp)
  {
      delta_potentiel = ((
			  (G_K + G_ahp + G_C + G_A + G_M) * E_K
			  + (G_Na * E_Na) + (G_Ca * E_Ca)
			  + (G_Nap * E_Na) + (G_Cab * E_Ca)
			  + (G_H * E_K)
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify, adapt   -------*/
			  + (G_New * E_New)
#endif
			  + (g_fuite * E_fuite)
			  + (g_fuite_Na * E_Na)
			  + (g_fuite_K * E_K)

			  + (GL_Na * E_Na)
			  + (GL_K * E_K)    /*  /     */
			  + (GL_Cl * E_K )  /* <===== que prendre a la place de E_K */
	                                    /*  \     */
/*
A REVOIR AVEC LES REV POT INDIVIDUELS
			  + (G_Syn_pos * rev_pot_pos)
			  + (G_Syn_neg * rev_pot_neg)
			  + (G_NMDA * rev_pot_NMDA)
*/
			 ) / (g_tot))
	                  * (1. - decay_mb_pot);
      delta_clamp_current = g_tot * delta_potentiel;
      
      le_potentiel = clamp_pot + input_voltage;
      I_total = courant_tot + delta_clamp_current;  
  } /* fin du if */
  else
  {
      delta_potentiel = ((
			  (G_K + G_ahp + G_C + G_A + G_M) * E_K
			  + (G_Na * E_Na) + (G_Ca * E_Ca)
			  + (G_Nap * E_Na) + (G_Cab * E_Ca)
			  + (G_H * E_K)
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify, adapt   -------*/
			  + (G_New * E_New)
#endif
			  + (g_fuite * E_fuite)
			  + (g_fuite_Na * E_Na)
			  + (g_fuite_K * E_K)
		
			  + (GL_Na * E_Na)
			  + (GL_K * E_K)    /*  /     */
			  + (GL_Cl * E_K )  /* <===== que prendre a la place de E_K */
	                                    /*  \     */
/*
A REVOIR AVEC LES REV POT INDIVIDUELS
			  + (G_Syn_pos * rev_pot_pos)
			  + (G_Syn_neg * rev_pot_neg)
			  + (G_NMDA * rev_pot_NMDA)
*/
			  + input_current)
			  / (g_tot))
	                  * (1. - decay_mb_pot)
	                  + backgrd_noise_m;
      le_potentiel = le_potentiel * decay_mb_pot + delta_potentiel;
      I_total = g_tot * le_potentiel;
    } /* fin du else */
  
#else

/************************************************************************/  
/* Calcul du courant total on a un signe moins, 
            car on prend (lepot - pot_equil) et non (pot_equil - lepot) */
/************************************************************************/  

  if (voltage_clamp)
  {
	  I_total = -(I_fuite + I_fuite_Na + I_fuite_K + I_K + I_Na + I_Ca + I_ahp + I_A + I_M + I_C + I_H + I_Nap + I_Cab + I_LNa +
	      I_LK + I_LCl +

#ifdef ADD_CURRENT
/*--------   To add a current copy, modify, adapt -------*/
	      I_New +
#endif
	     I_NMDA) + input_current + backgrd_noise_m;

	  	for (j = 0; j < nb_spikes; j++)
	  	{
	    	I_total += tab_syn[j].G_syn;
	  	}
      	
		delta_clamp_current = (I_total/soma_avant) * clamp_pot;
      
      	I_total = I_total + delta_clamp_current;  
  }
  else
  {
	  I_total = -(I_fuite + I_fuite_Na + I_fuite_K + I_K + I_Na + I_Ca + I_ahp + I_A + I_M + I_C + I_H + I_Nap + I_Cab + I_LNa +
	      I_LK + I_LCl +

#ifdef ADD_CURRENT
/*--------   To add a current copy, modify, adapt -------*/
	      I_New +
#endif
	     I_NMDA) + input_current + backgrd_noise_m;

	  	for (j = 0; j < nb_spikes; j++)
	  	{
	    	I_total += tab_syn[j].G_syn;
	  	}	
  }

#endif 

/************************************************************************/  
/************* C A L C U L   D E S   D E R I V E E S ********************/  
/************************************************************************/  	
  /*
   * Calcul de la derivee de l a l'instant t_i
   */
  /* dl/dt */
  temp = z_l*elec*(valeurs[d_V]*0.001-Vl)/(K*(Temp+273.15));
  ez_peVmVpoKT = exp(temp);
  ea_pz_peVmVpoKT = exp(alpha_l*temp);
  val_derivee[d_l] = (p_inf(nu_l,ez_peVmVpoKT)-valeurs[d_l])/
                     tau_p(taubar_l,ea_pz_peVmVpoKT,ez_peVmVpoKT,alpha_l);

  /*
   * Calcul de la derivee de r a l'instant t_i
   */
  /* dr/dt */
  temp = z_r*elec*(valeurs[d_V]*0.001-Vr)/(K*(Temp+273.15));
  ez_peVmVpoKT = exp(temp);
  ea_pz_peVmVpoKT = exp(alpha_r*temp);
  val_derivee[d_r] = (p_inf(nu_r,ez_peVmVpoKT)-valeurs[d_r])/
                     tau_p(taubar_r,ea_pz_peVmVpoKT,ez_peVmVpoKT,alpha_r);

  /*
   * Calcul de la derivee du potentiel a l'instant t_i
   */
  val_derivee[d_V] = I_total / capacite;
  
  /*
   * Calcul de la derivee de m_K a l'instant t_i
   */
  /****      variable d'activation des canaux K        ****/
  alpha_m_K =  exp(A_K * (valeurs[d_V] - V_K));
  beta_m_K = exp(-A_K * (valeurs[d_V] - V_K));
  tau_m_K = (1. / ( lambda_Ik * (alpha_m_K + beta_m_K)));
  m_1_K = alpha_m_K / ( alpha_m_K + beta_m_K);
  val_derivee[d_m_K] = (m_1_K - valeurs[d_m_K] ) / tau_m_K;
  
  /*
   * Calcul de la derivee de m_Ca a l'instant t_i
   */
  /****      variable d'activation des canaux Ca         ****/
  m_1_Ca = 1. / (1. + (exp (-2.0 * A_Ca * (valeurs[d_V] - V_Ca))));
  val_derivee[d_m_Ca] = (m_1_Ca - valeurs[d_m_Ca]) / Tau_Ca;

 /*
   * Calcul de la derivee de h_Na a l'instant t_i
   */
  /****    variable d'inactivation des canaux Na         ****/
  h_1_Na = 1. /(1. + exp (-2.0 * A_INa_B * (valeurs[d_V] - V_INa_B)));
  val_derivee[d_h_Na] = (h_1_Na - valeurs[d_h_Na]) / Tau_INa_B;


  /*
   * Calcul de la derivee de h_A a l'instant t_i
   */
  /****    variable d'inactivation des canaux Ka         ****/
  h_1_A = 1. /(1. + exp (-2.0 * A_Ia_B * (valeurs[d_V] - V_Ia_B)));
  val_derivee[d_h_A] = (h_1_A - valeurs[d_h_A]) / Tau_Ia_B;

  /*
   * Calcul de la derivee de m_Na a l'instant t_i
   */
  /****      variable d'activation des canaux Na         ****/
  m_1_Na = 1. / (1. + (exp (-2.0 * A_INa_A * (valeurs[d_V] - V_INa_A))));
  val_derivee[d_m_Na] = (m_1_Na - valeurs[d_m_Na]) / Tau_INa_A;

  /*
   * Calcul de la derivee de h_Na a l'instant t_i
   */
  /****    variable d'inactivation des canaux Na         ****/
  h_1_Na = 1. /(1. + exp (-2.0 * A_INa_B * (valeurs[d_V] - V_INa_B)));
  val_derivee[d_h_Na] = (h_1_Na - valeurs[d_h_Na]) / Tau_INa_B;



#ifdef ADD_CURRENT
  /*--------   To add a current copy, modify, adapt  -------*/
  /*-----------       Adapt for the New current   ----------*/
  
  /*
   * Calcul de la derivee de h_New a l'instant t_i
   */
  /****    variable d'activation des canaux Km        ****/
  alpha_m_INew =  exp(A_INew*(valeurs[d_V] - V_INew));
  beta_m_INew = exp(-A_INew*(valeurs[d_V] - V_INew));
  tau_m_New = (1. / (lambda_INew * (alpha_m_INew + beta_m_INew)));
  m_1_New = alpha_m_INew / ( alpha_m_INew + beta_m_INew);
  val_derivee[d_m_New] = (m_1_Mew - valeurs[d_m_New]) / tau_m_New;
  
  /****    variable d'inactivation des canaux New         ****/
  h_1_New = 1. /(1. + exp (-2.0 * A_INew_B * (valeurs[d_V] - V_INew_B)));
  val_derivee[d_h_New] = (h_1_New - valeurs[d_h_New]) / Tau_INew_B;
#endif

  /*
   * Calcul de la derivee de m_M a l'instant t_i
   */
  /****    variable d'activation des canaux Km        ****/
  alpha_m_Im =  exp(A_Im*(valeurs[d_V] - V_Im));
  beta_m_Im = exp(-A_Im*(valeurs[d_V] - V_Im));
  tau_m_M = (1. / (lambda_Im * (alpha_m_Im + beta_m_Im)));
  m_1_M = alpha_m_Im / ( alpha_m_Im + beta_m_Im);
  val_derivee[d_m_M] = (m_1_M - valeurs[d_m_M]) / tau_m_M;

  /*
   * Calcul de la derivee de m_C a l'instant t_i
   */
  /****      variable d'activation des canaux Kc    ****/
  alpha_m_Ic = Ca_i * exp (A_Ic * (valeurs[d_V] - V_Ic));
  beta_m_Ic = exp (-A_Ic * (valeurs[d_V] - V_Ic));
  m_1_C = alpha_m_Ic / (alpha_m_Ic + beta_m_Ic);
  tau_m_C = 1./ (lambda_Ic * (alpha_m_Ic + beta_m_Ic));
  val_derivee[d_m_C] = (m_1_C - valeurs[d_m_C]) / tau_m_C;

  /*
   * Calcul de la derivee de m_Ih a l'instant t_i
   */
  /****    variable d'activation des canaux Ih        ****/
  alpha_m_Ih =  exp(A_Ih * (valeurs[d_V] - V_Ih));
  beta_m_Ih = exp(-A_Ih * (valeurs[d_V] - V_Ih));
  tau_m_Ih = (1. / (lambda_Ih * (alpha_m_Ih + beta_m_Ih)));
  m_1_Ih = alpha_m_Ih / ( alpha_m_Ih + beta_m_Ih);
  val_derivee[d_m_Ih] = (m_1_Ih - valeurs[d_m_Ih]) / tau_m_Ih;

  /*
   * Calcul de la derivee de m_INap a l'instant t_i
   */
  /****    variable d'activation des canaux Na p        ****/
  alpha_m_Inap =  exp(A_Inap * (valeurs[d_V] - V_Inap));
  beta_m_Inap = exp(-A_Inap * (valeurs[d_V] - V_Inap));
  tau_m_nap = (1. / (lambda_Inap * (alpha_m_Inap + beta_m_Inap)));
  m_1_Nap = alpha_m_Inap / ( alpha_m_Inap + beta_m_Inap);
  val_derivee[d_m_Nap] = (m_1_Nap - valeurs[d_m_Nap])/ tau_m_nap;

  /*
   * Calcul de la derivee de m_Cab a l'instant t_i
   */
  /****    variable d'activation des canaux Ca_b            ****/
  alpha_m_Icab =  exp(Am_Icab * (valeurs[d_V] - Vm_Icab));
  beta_m_Icab = exp(-Am_Icab * (valeurs[d_V] - Vm_Icab));
  m_1_Cab = alpha_m_Icab / ( alpha_m_Icab + beta_m_Icab);
  val_derivee[d_m_Cab] = (m_1_Cab - valeurs[d_m_Cab]) / tau_m_cab;
  
  /*
   * Calcul de la derivee de h_Cab a l'instant t_i
   */
  /****    variable d'inactivation des canaux Cab         ****/
  alpha_h_Icab =  exp(-Ah_Icab * (valeurs[d_V] - Vh_Icab));
  beta_h_Icab = exp(Ah_Icab * (valeurs[d_V] - Vh_Icab));
  h_1_Cab = alpha_h_Icab / ( alpha_h_Icab + beta_h_Icab);
  tau_h_cab = (1. / (lambda_Icab));
  val_derivee[d_h_Cab] = (h_1_Cab - valeurs[d_h_Cab]) / tau_h_cab;

  /*
   * Calcul de la derivee de Ca_i a l'instant t_i
   */
  /* in reality, CA_i steady_state (g/f) = Kp(-Ica)/(-R)   */
  /* where dy/dt = y*f + g */
  val_derivee[d_Ca_i] = (-Ca_Removal) * valeurs[d_Ca_i] + Ca_Influx * I_Ca;

  /*
   * Calcul de la derivee de K_ext a l'instant t_i
   */
  /*---  calcul de E_K car accumulation de K             ------*/
  /* d(Ko)/dt = IK_total/(Vperi*F) - (Ko - Krest)/(tauK-diff)   */
  /* from Methods in Neural modeling eds Koch and Segev pg. 115 */
  /* Krest = 2.5 mM, tauK-diff = 7msec                          */
  /* require radius of cell, in um                              */
  /* assumes extracellular space is 70nm radius                 */
  
#ifdef ADD_CURRENT
  /*---------- May be you have to modify this also... ----------*/
  /*------ if your current is depending of K_ext ---------------*/

#endif
 
  reactualise_E_Na_K();

 
  radius = (diametre/2.);
  val_derivee[d_K_ext] = (I_K + I_A + I_M + I_C + I_ahp) 
                         * (3.11e-10*pow(radius,2.0))/ 
			 (pow(radius+0.07,3.0)-pow(radius,3.0))
		         - ((valeurs[d_K_ext] - K_rest)/7.);

  /*
     
     val_derivee[d_K_int] = (I_K + I_A + I_M + I_C + I_ahp) 
     * (3.11e-10*pow(radius,2.0))/ 
     (pow(radius+0.07,3.0)-pow(radius,3.0))
     - ((valeurs[d_K_int] - K_rest)/7.);
     
     
     
     val_derivee[d_Na_ext] = (I_Na + I_A + I_M + I_C + I_ahp) 
     * (3.11e-10*pow(radius,2.0))/ 
     (pow(radius+0.07,3.0)-pow(radius,3.0))
     - ((valeurs[d_Na_ext] - K_rest)/7.);
     
     
     
     val_derivee[d_Na_int] = (I_Na + I_A + I_M + I_C + I_ahp) 
     * (3.11e-10*pow(radius,2.0))/ 
     (pow(radius+0.07,3.0)-pow(radius,3.0))
     - ((valeurs[d_Na_int] - K_rest)/7.);
     
     */



#ifdef DEBUG_RK 
  printf("g_tot: %f \tI_total: %f \tnoise: %f \tinput: %f\n",
	 g_tot, I_total, noise, input_current);
  printf("I_fuite %f \nI_K  %f \nI_Na  %f \nI_Ca  %f \nI_ahp  %f \nI_A  %f \nI_M  %f \nI_C  %f \nI_H  %f \nI_Nap  %f \nI_Cab  %f \nI_Syn_pos  %f \nI_Syn_neg  %f \nI_NMDA %f \n",
	 I_fuite , I_K , I_Na , I_Ca , I_ahp , I_A , I_M , I_C , I_H , I_Nap , I_Cab ,
	 I_Syn_pos , I_Syn_neg , I_NMDA);

#endif 
#if DEBUG_RK2
  printf("Iteration: %f\n",t_i);
  printf("K  -> m_1_K: %f m_K: %f (d_mK: %f) I_K: %f tau_m_K: %f\n",m_1_K, valeurs[d_m_K], 
	 val_derivee[d_m_K], I_K, tau_m_K);
  printf("Na -> m_1_Na: %f I_Na: %f\n",m_1_Na, I_Na);
  printf("V  -> %f\n",valeurs[d_V]);
#endif

} /* fin du derive */

/********************** Euler *******************************/

/*--------------------------------------------------------------------
 *     u p d a t e _ e u l e r
 *------------------------------------------------------------------*/
 
void update_euler(int nb_it)
{
  register i, j, k;                    /* indices */
  int           set;                   /* pour le random */
  
  void  euler(float *, float *, int, float, float, float *);
  void	derive(float, float *, float *);
  
  float  	t_i,                   /* temps passe */
                soma_avant,	       /* pour calculer la pente */
		delta_potentiel,       /* chgt local de potentiel */
		delta_clamp_current;   /* variation de courant pour maintenir V const */

  float	        val_derivee[NB_EQUA_DIFF];

  t_i = (float)nb_it;

  soma_avant = neur_param_avant[d_V];
  derive(t_i, neur_param_avant, val_derivee);
  euler(neur_param_avant, val_derivee, NB_EQUA_DIFF, t_i, time_step, neur_param_apres);

#ifdef DEBUG_EULER

  printf("\n%d: ",nb_it);
  for (i = 0; i < NB_EQUA_DIFF; i++)
    {
      printf("\t%d: \t%f \t-> %f \t-> %f\n", i, 
	     neur_param_avant[i],
	     val_derivee[i],
	     neur_param_apres[i]);
    } /* fin du for */
#endif
  
  for (i = 0; i < NB_EQUA_DIFF; i++)
    {
      neur_param_avant[i] = neur_param_apres[i];
    } /* fin du for */
  
/*---------------------------	Bruit	   ---------------------------------*/

  if (backgrd_noise_sd)
    {
      set = (int)time(0) & 077;
      noise = gasdev(&set);
      noise *= backgrd_noise_sd;
      le_potentiel =  neur_param_apres[d_V] + (noise / capacite);
      neur_param_avant[d_V] = le_potentiel;
    } /* fin du if */
  else
    le_potentiel =  neur_param_apres[d_V];


  
/*---  ca decharge ou pas?                              -------*/
  
	/*
	 * ca decharge ou pas? Critere de pente du signal.
	 */
  if ((le_potentiel - soma_avant >= spike_slope)
      && !spike_en_cours)
    {				/* on a un spike */
      la_spike = 1.;
      spike_en_cours = TRUE;
    } /* fin du if */
  else			/* pas de spike */
    {
      la_spike = 0.;
    } /* fin du else */
  
  if (spike_en_cours && (le_potentiel - soma_avant < 0))
    {
      spike_en_cours = FALSE;
    } /* fin du if */
  
#ifdef DEBUG_EULER
  printf("V= %f\n", le_potentiel);
#endif


} /* fin du update_euler */

/*
 * Euler 
 */
void euler(float *y, float *dydx, int n, float x, float h, float *yout)
{
  int	i;

  for (i = 0; i < n; i++)
    yout[i] = y[i]+h*dydx[i];
}

/********************** Runge Kutta *******************************/

/*--------------------------------------------------------------------
 *     u p d a t e _ r _ k 
 *------------------------------------------------------------------*/
 
void update_r_k(int nb_it)
{
  register i, j, k;              /* indices */
  int           set;                   /* pour le random */
  
  void  rk4(float *, float *, int, float, float, float *);
  void	derive(float, float *, float *);
  
  float  	t_i,                   /* temps passe */
                soma_avant,	       /* pour calculer la pente */
		delta_potentiel,       /* chgt local de potentiel */
		delta_clamp_current;   /* variation de courant pour maintenir V const */

  float	        val_derivee[NB_EQUA_DIFF];

  t_i = (float)nb_it;

  soma_avant = neur_param_avant[d_V];
  derive(t_i, neur_param_avant, val_derivee);
  rk4(neur_param_avant, val_derivee, NB_EQUA_DIFF, t_i, time_step, neur_param_apres);

#ifdef DEBUG_RK3

  printf("\n%d: ",nb_it);
  for (i = 0; i < NB_EQUA_DIFF; i++)
    {
      printf("\t%d: \t%f \t-> %f \t-> %f\n", i, 
	     neur_param_avant[i],
	     val_derivee[i],
	     neur_param_apres[i]);
    } /* fin du for */
#endif
  
  for (i = 0; i < NB_EQUA_DIFF; i++)
    {
      neur_param_avant[i] = neur_param_apres[i];
    } /* fin du for */
  
/*---------------------------	Bruit	   ---------------------------------*/

  if (backgrd_noise_sd)
    {
      set = (int)time(0) & 077;
      noise = gasdev(&set);
      noise *= backgrd_noise_sd;
      noise += backgrd_noise_m;
      le_potentiel =  neur_param_apres[d_V] + (noise / capacite);
      neur_param_avant[d_V] = le_potentiel;
    } /* fin du if */
  else
      le_potentiel =  neur_param_apres[d_V];


/*---  ca decharge ou pas?                              -------*/
  
	/*
	 * ca decharge ou pas? Critere de pente du signal.
	 */
  if ((le_potentiel - soma_avant >= spike_slope)
      && !spike_en_cours)
    {				/* on a un spike */
      la_spike = 1.;
      spike_en_cours = TRUE;
    } /* fin du if */
  else			/* pas de spike */
    {
      la_spike = 0.;
    } /* fin du else */
  
  if (spike_en_cours && (le_potentiel - soma_avant < 0))
    {
      spike_en_cours = FALSE;
    } /* fin du if */
  
#ifdef DEBUG_RK
  printf("V= %f\n", le_potentiel);
#endif


} /* fin du update_r_k */

/*
 * RK4 Runge Kutta (from Recipes in C)
 */
void rk4(float *y, float *dydx, int n, float x, float h, float *yout)
{
  int	i;
  float	xh, hh, h6,
      	dym[NB_EQUA_DIFF],
       	dyt[NB_EQUA_DIFF],
       	yt[NB_EQUA_DIFF];
  void	derive(float, float *, float *);

  hh=h*0.5;
  h6=h/6.0;
  xh=x+hh;
  for (i = 0; i < n; i++)
    yt[i] = y[i]+hh*dydx[i];
  derive(xh,yt,dyt);
  for (i = 0; i < n; i++)
    yt[i] = y[i]+hh*dyt[i];
  derive(xh,yt,dym);
  for (i = 0; i < n; i++)
    {
      yt[i] = y[i]+h*dym[i];
      dym[i] += dyt[i];
    }
  derive(x+h,yt,dyt);
  for (i = 0; i < n; i++)
    yout[i] = y[i]+h6*(dydx[i]+dyt[i]+2.0*dym[i]);
}
#if 1
void update_r_k_v_s(int nb_it)
{

}
#endif
 
#if 0
/************** Runge Kutta Variable Step ************************/

/*--------------------------------------------------------------------
 *     u p d a t e _ r _ k _ v _ s
 *------------------------------------------------------------------*/

void update_r_k_v_s(int nb_it)
{
  register i, j, k;              /* indices */
  
  void  rkqc(float *, float *, int, float, float, float *);
  void	derive(float, float *, float *);
  
  float  	t_i,                   /* temps passe */
                soma_avant,	       /* pour calculer la pente */
		delta_potentiel,       /* chgt local de potentiel */
		delta_clamp_current;   /* variation de courant pour maintenir V const */

  float	        val_derivee[NB_EQUA_DIFF];
  float         hdid, hnext;

  t_i = (float)nb_it;

  soma_avant = neur_param_avant[d_V];
  derive(t_i, neur_param_avant, val_derivee);
  rkqc(neur_param_avant, val_derivee, NB_EQUA_DIFF, &t_i, time_step, 
       1.e-3, neur_param_apres, &hdid, &hnext, derive);

#ifdef DEBUG_RK3

  printf("\n%d: ",nb_it);
  for (i = 0; i < NB_EQUA_DIFF; i++)
    {
      printf("\t%d: \t%f \t-> %f \t-> %f\n", i, 
	     neur_param_avant[i],
	     val_derivee[i],
	     neur_param_apres[i]);
    } /* fin du for */
#endif
  
  le_potentiel =  neur_param_avant[d_V];
  
/*---  ca decharge ou pas?                              -------*/
  
	/*
	 * ca decharge ou pas? Critere de pente du signal.
	 */
  if ((le_potentiel - soma_avant >= spike_slope)
      && !spike_en_cours)
    {				/* on a un spike */
      la_spike = 1.;
      spike_en_cours = TRUE;
    } /* fin du if */
  else			/* pas de spike */
    {
      la_spike = 0.;
    } /* fin du else */
  
  if (spike_en_cours && (le_potentiel - soma_avant < 0))
    {
      spike_en_cours = FALSE;
    } /* fin du if */
  
#ifdef DEBUG_RK
  printf("V= %f\n", le_potentiel);
#endif


} /* fin du update_r_k_v_s */

/*
 * RKQS Runge Kutta a pas variable (from Recipes in C)
 */
#include <math.h>
#define NRANSI
#include "nrutil.h"
#define SAFETY 0.9
#define PGROW -0.2
#define PSHRNK -0.25
#define ERRCON 1.89e-4

void rkqs(float y[], float dydx[], int n, float *x, float htry, float eps,
	float yscal[], float *hdid, float *hnext,
	void (*derivs)(float, float [], float []))
{
	void rkck(float y[], float dydx[], int n, float x, float h,
		float yout[], float yerr[], void (*derivs)(float, float [], float []));
	int i;
	float errmax,h,htemp,xnew,*yerr,*ytemp;

	yerr=vector(1,n);
	ytemp=vector(1,n);
	h=htry;
	for (;;) {
		rkck(y,dydx,n,*x,h,ytemp,yerr,derivs);
		errmax=0.0;
		for (i=1;i<=n;i++) errmax=FMAX(errmax,fabs(yerr[i]/yscal[i]));
		errmax /= eps;
		if (errmax > 1.0) {
			htemp=SAFETY*h*pow(errmax,PSHRNK);
			h=(h >= 0.0 ? FMAX(htemp,0.1*h) : FMIN(htemp,0.1*h));
			xnew=(*x)+h;
			if (xnew == *x) nrerror("stepsize underflow in rkqs");
			continue;
		} else {
			if (errmax > ERRCON) *hnext=SAFETY*h*pow(errmax,PGROW);
			else *hnext=5.0*h;
			*x += (*hdid=h);
			for (i=1;i<=n;i++) y[i]=ytemp[i];
			break;
		}
	}
	free_vector(ytemp,1,n);
	free_vector(yerr,1,n);
}
#undef SAFETY
#undef PGROW
#undef PSHRNK
#undef ERRCON
#undef NRANSI
/* (C) Copr. 1986-92 Numerical Recipes Software A. */


/*
 * RKCK Runge Kutta a pas variable (from Recipes in C)
 */
#define NRANSI
#include "nrutil.h"

void rkck(float y[], float dydx[], int n, float x, float h, float yout[],
	float yerr[], void (*derivs)(float, float [], float []))
{
	int i;
	static float a2=0.2,a3=0.3,a4=0.6,a5=1.0,a6=0.875,b21=0.2,
		b31=3.0/40.0,b32=9.0/40.0,b41=0.3,b42 = -0.9,b43=1.2,
		b51 = -11.0/54.0, b52=2.5,b53 = -70.0/27.0,b54=35.0/27.0,
		b61=1631.0/55296.0,b62=175.0/512.0,b63=575.0/13824.0,
		b64=44275.0/110592.0,b65=253.0/4096.0,c1=37.0/378.0,
		c3=250.0/621.0,c4=125.0/594.0,c6=512.0/1771.0,
		dc5 = -277.00/14336.0;
	float dc1=c1-2825.0/27648.0,dc3=c3-18575.0/48384.0,
		dc4=c4-13525.0/55296.0,dc6=c6-0.25;
	float *ak2,*ak3,*ak4,*ak5,*ak6,*ytemp;

	ak2=vector(1,n);
	ak3=vector(1,n);
	ak4=vector(1,n);
	ak5=vector(1,n);
	ak6=vector(1,n);
	ytemp=vector(1,n);
	for (i=1;i<=n;i++)
		ytemp[i]=y[i]+b21*h*dydx[i];
	(*derivs)(x+a2*h,ytemp,ak2);
	for (i=1;i<=n;i++)
		ytemp[i]=y[i]+h*(b31*dydx[i]+b32*ak2[i]);
	(*derivs)(x+a3*h,ytemp,ak3);
	for (i=1;i<=n;i++)
		ytemp[i]=y[i]+h*(b41*dydx[i]+b42*ak2[i]+b43*ak3[i]);
	(*derivs)(x+a4*h,ytemp,ak4);
	for (i=1;i<=n;i++)
		ytemp[i]=y[i]+h*(b51*dydx[i]+b52*ak2[i]+b53*ak3[i]+b54*ak4[i]);
	(*derivs)(x+a5*h,ytemp,ak5);
	for (i=1;i<=n;i++)
		ytemp[i]=y[i]+h*(b61*dydx[i]+b62*ak2[i]+b63*ak3[i]+b64*ak4[i]+b65*ak5[i]);
	(*derivs)(x+a6*h,ytemp,ak6);
	for (i=1;i<=n;i++)
		yout[i]=y[i]+h*(c1*dydx[i]+c3*ak3[i]+c4*ak4[i]+c6*ak6[i]);
	for (i=1;i<=n;i++)
		yerr[i]=h*(dc1*dydx[i]+dc3*ak3[i]+dc4*ak4[i]+dc5*ak5[i]+dc6*ak6[i]);
	free_vector(ytemp,1,n);
	free_vector(ak6,1,n);
	free_vector(ak5,1,n);
	free_vector(ak4,1,n);
	free_vector(ak3,1,n);
	free_vector(ak2,1,n);
}
#undef NRANSI
/* (C) Copr. 1986-92 Numerical Recipes Software A. */

#endif

#ifdef ADD_INTEGRATION_METHOD
/* Copy this and adpat to the new method */

/********************** Int Method *******************************/

/*--------------------------------------------------------------------
 *     u p d a t e _ i n t _ m e t h o d
 *------------------------------------------------------------------*/
 
void update_int_method(int nb_it)
{
  register i, j, k;              /* indices */
  
  void  int_method(float *, float *, int, float, float, float *);
  void	derive(float, float *, float *);
  
  float  	t_i,                   /* temps passe */
                soma_avant,	       /* pour calculer la pente */
		delta_potentiel,       /* chgt local de potentiel */
		delta_clamp_current;   /* variation de courant pour maintenir V const */

  float	        val_derivee[NB_EQUA_DIFF];

  t_i = (float)nb_it;

  soma_avant = neur_param_avant[d_V];
  derive(t_i, neur_param_avant, val_derivee);
  int_method(neur_param_avant, val_derivee, NB_EQUA_DIFF, t_i, time_step, neur_param_apres);

#ifdef DEBUG_RK3

  printf("\n%d: ",nb_it);
  for (i = 0; i < NB_EQUA_DIFF; i++)
    {
      printf("\t%d: \t%f \t-> %f \t-> %f\n", i, 
	     neur_param_avant[i],
	     val_derivee[i],
	     neur_param_apres[i]);
    } /* fin du for */
#endif
  
  for (i = 0; i < NB_EQUA_DIFF; i++)
    {
      neur_param_avant[i] = neur_param_apres[i];
    } /* fin du for */
  
  le_potentiel =  neur_param_apres[d_V];
  
/*---  ca decharge ou pas?                              -------*/
  
	/*
	 * ca decharge ou pas? Critere de pente du signal.
	 */
  if ((le_potentiel - soma_avant >= spike_slope)
      && !spike_en_cours)
    {				/* on a un spike */
      la_spike = 1.;
      spike_en_cours = TRUE;
    } /* fin du if */
  else			/* pas de spike */
    {
      la_spike = 0.;
    } /* fin du else */
  
  if (spike_en_cours && (le_potentiel - soma_avant < 0))
    {
      spike_en_cours = FALSE;
    } /* fin du if */
  
#ifdef DEBUG_RK
  printf("V= %f\n", le_potentiel);
#endif


} /* fin du update_int_method */

/*
 * Int method
 */
void int_method(float *y, float *dydx, int n, float x, float h, float *yout)
{
  int	i;

  for (i = 0; i < n; i++)
    yout[i] = y[i]+h*dydx[i];
}

#endif

/*
   void  reactualise_E_Na_K(float *valeurs)
   
   {
   E_K  = 1000.* (float)((float)(R*(Temp+273.15)/(Z*F)) *
   (float)(log(valeurs[d_K_ext] /valeurs[d_K_int] )));
   
   E_Na = 1000.* (float)((float)(R*(Temp+273.15)/(Z*F)) *
   (float)(log(valeurs[d_Na_ext]/valeurs[d_Na_int])));
   
   }
*/

void  reactualise_E_Na_K()
{
  
  E_K  = 1000.* (float)((float)(R*(Temp+273.15)/(Z*F)) *
			(float)(log(K_ext /K_int )));
  
  E_Na = 1000.* (float)((float)(R*(Temp+273.15)/(Z*F)) *
			(float)(log(Na_ext/Na_int)));

   E_Cl = 1000.* (float)((float)(R*(Temp+273.15)/(Z*F)) *
			(float)(log(Cl_ext/Cl_int)));

/*
  E_Goldman  = 1000.* (float)((float)(R*(Temp+273.15)/(Z*F)) *
			(float)(log((K_ext + (0.01 * Na_ext))/(K_int + (0.01 * Na_int)))));
  */
  
  E_Goldman  = 1000.* (float)((float)(R*(Temp+273.15)/(Z*F)) *
			(float)(log(((PL_K * K_ext) + (PL_Na * (0.01 * Na_ext)) + (PL_Cl * Cl_int))/((PL_K * K_int) + (PL_Na * (0.01 * Na_int)) + (PL_Cl * Cl_ext)))));

  E_fuite = E_Goldman;
}



void update_phenom(int nb_it)
{
#if DEBUG
  printf("in update_phenom\n");
#endif

} 



