#define DEBUG_V8 0

#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- 7 modifications in this file -------------*/

#endif
/* --------------------------------------------------------------------------------------
			G_FICH_CALLBACKS.C
   ------------------------------------------------------------------------------------*/

#include<stdio.h>
#include<string.h>

#undef MAIN
#include "G_neuron.h"

#include "G_interface.h"
#include "G_synap.h"
#include "G_reference.h"
#include "find_files.h"

extern	Pixmap  equa_pix;
extern	GC      eq_gc;
extern	unsigned int equa_width, equa_height;
extern	REFERENCE	refM_H_TAU;

extern  int current_recept;

extern	float   reference1_max, reference1_min,
		reference2_max_p, reference2_min_p,
		reference3_max_p, reference3_min_p,
		reference2_max_g, reference2_min_g,
		reference3_max_g, reference3_min_g;

extern	char	V_legend[50],
		M_legend[50];
/*
extern  void reactualise_E_Na_K(float*);
*/
extern  void reactualise_E_Na_K();
extern  void reactualise_time_stim(int );

#ifndef PI
#	define	PI	3.14159265
#endif



/***********************************************************/
/* Change dynamic_change value				   */
/***********************************************************/
XtCallbackProc DynamicChange (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
  int  i;
 
  if (flag_simulation && flag_button && !flag_Tms_Input)
    {
       if (!static_update)
	{
	  for (i = 0 ; i< nb_connexions ; i++)
	    { XtAddCallback(Scale_Buttons[i], XmNdragCallback, 
			    (XtPointer)callback_psp_time, (XtPointer)i);}
	}
      else
	{ 
	  for (i = 0 ; i< nb_connexions ; i++)
	    { XtRemoveCallback(Scale_Buttons[i], XmNdragCallback, 
			       (XtPointer)callback_psp_time, (XtPointer)i);}
	}
      
      (*calcul_neuron)();
      (*draw_neuron)(0);
    }
}

void realloc_for_graphs()
{
	int	i;

	if (potentiel != NULL)
	{
		free(potentiel);
		free(le_temps);
		free(ramp_input);
		free(courant_global);
		free(courant_K);
		free(courant_Na);
		free(courant_Ia);
		free(courant_Im);
		free(courant_Iahp);
		free(courant_Ic);
		free(courant_Ih);
		free(courant_Nap);
		free(courant_Cab);
		free(potentiel_E_Na);
		free(potentiel_E_K);
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
		free(courant_INew);

#endif
		free(Ca);
		free(courant_Ca);
		free(synaptique);
		free(les_spikes);
		free(le_seuil);
		free(les_intervalles);
		free(l_histogramme);
	}

	table_size     = (int) ((float) (duree_simul +2) / time_step) + 2;
	potentiel      = (float *) calloc(table_size, sizeof(float));
	ramp_input     = (float *) calloc(table_size, sizeof(float));
	courant_global = (float *) calloc(table_size, sizeof(float));
	courant_K      = (float *) calloc(table_size, sizeof(float));
	courant_Na     = (float *) calloc(table_size, sizeof(float));
	courant_Ia     = (float *) calloc(table_size, sizeof(float));
	courant_Im     = (float *) calloc(table_size, sizeof(float));
	courant_Ih     = (float *) calloc(table_size, sizeof(float));
	courant_Iahp   = (float *) calloc(table_size, sizeof(float));
	courant_Ic     = (float *) calloc(table_size, sizeof(float));
	courant_Nap    = (float *) calloc(table_size, sizeof(float));
	courant_Cab    = (float *) calloc(table_size, sizeof(float));
	potentiel_E_Na = (float *) calloc(table_size, sizeof(float));
	potentiel_E_K  = (float *) calloc(table_size, sizeof(float));

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	courant_Cab    = (float *) calloc(table_size, sizeof(float));
#endif
	Ca             = (float *) calloc(table_size, sizeof(float));
	courant_Ca     = (float *) calloc(table_size, sizeof(float));
	le_temps       = (float *) calloc(table_size, sizeof(float));
	valeur_m       = (float *) calloc(table_size, sizeof(float));
	valeur_h       = (float *) calloc(table_size, sizeof(float));
	synaptique     = (float *) calloc(table_size, sizeof(float));
	les_spikes     = (float *) calloc(table_size, sizeof(float));
        les_intervalles =  (float *) calloc(table_size, sizeof(float));
	l_histogramme = (float *) calloc(table_size, sizeof(float));
	le_seuil = (float *) calloc(table_size, sizeof(float));

	for (i = 0; i < table_size; i++)
		le_temps[i] = (float)i * time_step;
} 

/*----------------------------------------------------------------
	callbacks associes aux Widgets de G_neuron6.c
  --------------------------------------------------------------*/

void fermeture_Conductance(Widget w, XtPointer c1, XtPointer c2)
{
	flag_conductance = 0;
}

void fermeture_Inputs(Widget w, XtPointer c1, XtPointer c2)
{
	flag_Inputs = 0;
}

void fermeture_Phenom(Widget w, XtPointer c1, XtPointer c2)
{
	flag_Phenom = 0;
}

void fermeture_PSP(Widget w, XtPointer c1, XtPointer c2)
{
	flag_PSP = 0;
}

void fermeture_recurrent(Widget w, XtPointer c1, XtPointer c2)
{
	flag_recurrentEPSP = 0;
}

void fermeture_NMDA(Widget w, XtPointer c1, XtPointer c2)
{
	flag_NMDA = 0;
}

void fermeture_Equilibrium(Widget w, XtPointer c1, XtPointer c2)
{
	flag_equilibrium = 0;
}

void fermeture_Activ(Widget w, XtPointer c1, XtPointer c2)
{
	flag_activ = 0;
}

void fermeture_Init(Widget w, XtPointer c1, XtPointer c2)
{
	flag_init = 0;
}

void fermeture_Simulation(Widget w, XtPointer c1, XtPointer c2)
{
	flag_simulation = 0;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}

void fermeture_Echelles(Widget w, XtPointer c1, XtPointer c2)
{
	flag_echelles = 0;
	(*calcul_neuron)();
	(*draw_neuron)(0);
	
}
/*---------------------------------------------------------------

  cette fonction est teste si on est en mode fichier tms ou non,
  puis alloue la memoire necessaire dans le cas considere.

  pour (flag_TmsInput=1)   -> fichier tms en entree

       - creation d`un tableau "tab_type_value" de taille nb_connexions
	 qui contient la liste des types d`evenement a lire dans le fichier tms.

       - creation d`un tableau "tab_type_ponderation" de taille nb_connexions
         qui contient la liste des poids a affecter a chaque type du 1er tableau

       - remplissage des 2 tableaux (tab_type_value et tab_type_ponderation ) 
         avec des valeurs arbitraires

	 tab_type_value      : 1 2 3 4 5 6 etc...     
	 
	 tab_type_ponderation: 0 0 0 0 0 0 etc...


  pour (flag_TmsInput=0)   -> pas de fichier tms en entree

       - creation d`un tableau "tab_syn" de taille nb_connexions
         qui contiendra la liste des buttons (temps d`arrivee et poids).


  Cette fonction active le programme "fabrique_form_simulation()" et 
  place le flag_button=1 pour la creation des widgets a l`interieur de
  la Frame de la fenetre de simulation.


---------------------------------------------------------------*/

void callback_nombre_connexions(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	Arg	warg,
		wargs[10];
	int	n,k;
	XmString	string1;
	    
 	n = (cbs->value);
	if (n <= 0  ) return;
	if (n != nb_connexions)
	{
	    nb_connexions = n;
	    taille_tab_syn = nb_connexions;

	    /*-------- allocation de la memoire ---------*/
	    if (!flag_Tms_Input)
	      {
			realloc_mem_tab_transitoire(nb_connexions );
			realloc_mem_tab_syn(nb_connexions );
			realloc_mem_tab_tempo(nb_connexions );
	      }
	    else
	      {
			realloc_mem_tab_type_value(nb_connexions );
			realloc_mem_tab_type_ponderation(nb_connexions );
		/* remplissage du tableau tab_type_value avec des valeurs arbitraires */
			for (k=0;k<nb_connexions;k++)
		  	{
		    	tab_type_value[k]=k+1;
		    	tab_type_ponderation[k]=0.;
		  	}
	      }
	  }
	/*--------- recreation de la fenetre de simulation ------------*/
	flag_button = 1; 
	XtDestroyWidget(Top_Level_Simul);
	flag_simulation=0;
	fabrique_form_simulation();
}

/*---------------------------------------------------------

  Cette fonction permet de charger a valeur du poids controle
  par la widget qui appelle cette meme fonction.

  la valeur du poid est affecter: 

      - soit directement a un button quand on ne travaille pas avec un fichier 
        tms en entree (flag_Tms_Input=0)

      - soit au tableau "tab_ponderation". Un programme "readTmsInput()" va alors
        faire correspondre les poids et les type des tableaux tab_type_ponderation et
	tab_type_value, aux buttons qui existent dans le fichier tms d`entree.
 
---------------------------------------------------------*/

void callback_psp_weight(Widget w, XtPointer num, DeXinputCallbackStruct *cbs)
{
  int  i, j = 0;
  Arg  wargs[2];


  i = (int)num;

    for ( j = 0; j < nb_connexions; j++)
    {
      /*      if (DeXInput_Buttons[j] == XtParent( XtParent(XtParent(w)))) */
      if (DeXInput_Buttons[j] == (w))
      {
		i = j;
		break;
      }
#if DEBUG_V8
      printf("callback_psp_weight: w: %x DeXInput_Buttons[%d] %x  i: %d\n",w, j, DeXInput_Buttons[j], i);
/*
      printf("1Parent(w): %x \n",XtParent(w));
      printf("2Parent.Parent(w): %x \n", XtParent(XtParent(w)));
      printf("3Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(w))));
      printf("4Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(w)))));
      printf("5Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(w))))));
      printf("6Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w)))))));
      printf("7Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w))))))));
      printf("8Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w)))))))));
*/
#endif
    }

#if DEBUG_V8
  printf("callback_psp_weight: weight i: %d\n",i);
#endif

  if (!flag_Tms_Input)
  {
      tab_transitoire[i].weight = (float) abs(cbs->value) / 100.;

      taille_tab_syn = nb_connexions;

      tab_syn[i].weight = tab_transitoire[i].weight;

      /* 
      for (j = 0; j < nb_connexions; j++)
      {
		tab_syn[j].weight = tab_transitoire[j].weight;
		tab_syn[j].t_arrivee = tab_transitoire[j].t_arrivee;
      }
      */

  }
  else 
  {
      tab_type_ponderation[i] = (float) cbs->value / 100.;
      readTmsInput();

      taille_tab_syn = number_of_event;

  }
#if DEBUG_V8
  printf("callback_psp_weight: nb synapases : %d tab_syn[%d].weight i: %f\n",taille_tab_syn, i, tab_syn[i].weight);
#endif


  (*calcul_neuron)();
  (*draw_neuron)(0);
}

/*---------------------------------------------------------

  Cette fonction permet de lire le temps affecte par un scale
  a un button cette valeur (en %) est alors convertie en ms
  et placee directement dans le tableau "tab_syn".

  cette fonction n`est appelee que quand on n`utilise pas de 
  fichier tms en entree.

---------------------------------------------------------*/

void callback_psp_time(Widget w,  XtPointer num,  XmScaleCallbackStruct *cbs)
{
  int  i, j = 0;
  Arg  wargs[2];
  XmString  titre;


  i = (int)num;

    for ( j = 0; j < nb_connexions; j++)
    {
      if (Scale_Buttons[j] == w)
	  {
		i = j;
		break;
	  }
#if DEBUG
      printf("w: %x Row_Collumn_Un_Button[%d] %x  i: %d\n",w, j, Row_Collumn_Un_Button[j], i);
/*
      printf("Parent(w): %x \n",XtParent(w));
      printf("Parent.Parent(w): %x \n", XtParent(XtParent(w)));
      printf("Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(w))));
*/
#endif
    }

#if DEBUG_V8
  printf("time i: %d\n",i);
#endif
  tab_transitoire[i].t_arrivee = (float)(cbs->value)*duree_simul/100.;

  if (tab_transitoire[i].t_arrivee == 0.)
    tab_transitoire[i].t_arrivee = 0.0000001;

  sprintf(buffer,"%d Time arrival in %%  (%.2fms)", (int)(i+1), (float)tab_transitoire[i].t_arrivee);
  titre = XmStringCreate (buffer, XmSTRING_DEFAULT_CHARSET); 
  XtSetArg(wargs[0],XmNtitleString, titre);
  XtSetValues(Scale_Buttons[i],wargs,1);      

  taille_tab_syn = nb_connexions;

  tab_syn[i].t_arrivee = tab_transitoire[i].t_arrivee;

  /*
  for (j = 0; j < nb_connexions; j++)
  {
    tab_syn[j].weight = tab_transitoire[j].weight;
    tab_syn[j].t_arrivee = tab_transitoire[j].t_arrivee;
  }
  */

  (*calcul_neuron)();
  (*draw_neuron)(0);
}


/*---------------------------------------------------------

  Cette fonction permet de lire le temps affecte par un scale
  a un button cette valeur (en %) est alors convertie en ms
  et placee directement dans le tableau "tab_syn".

  cette fonction n`est appelee que quand on n`utilise pas de 
  fichier tms en entree.

---------------------------------------------------------*/

void callback_input_transmitor(Widget w,   int item_nb)
{
    int i = 0; 
	
	int	nb_r, j;


    for ( j = 0; j < nb_connexions; j++)
    {
      if (Row_Collumn_Un_Button[j] == XtParent( XtParent(XtParent(XtParent(w)))))
	  {
		i = j;
		break;
	  }
		

#if DEBUG_V8
      printf("w: %x Row_Collumn_Un_Button[%d] %x  i: %d\n",w, j, Row_Collumn_Un_Button[j], i);
/*
      printf("1Parent(w): %x \n",XtParent(w));
      printf("2Parent.Parent(w): %x \n", XtParent(XtParent(w)));
      printf("3Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(w))));
      printf("4Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(w)))));
      printf("5Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(w))))));
      printf("6Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w)))))));
      printf("7Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w))))))));
      printf("8Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w)))))))));
      printf("9Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w))))))))));
      printf("10Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w)))))))))));
      printf("11Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w))))))))))));
*/
#endif
    }
#if DEBUG_V8
    printf("callback_input_transmitor: transm. i: %d\n",i);
#endif

    switch (item_nb)
    {
        case 0:
		  tab_syn[i].transmetteur  = NO_TRANSMISSION;
		  tab_syn[i].num_transm  = NB_NO_TRANSMISSION;
		  break;
        case 1:
			tab_syn[i].transmetteur = ANY;
		  	tab_syn[i].num_transm = NB_ANY;
	 		break;
        default:
	   		tab_syn[i].transmetteur = transmetteur[item_nb];
	   		tab_syn[i].num_transm = item_nb;
    }
    for (nb_r = 0; nb_r < nb_receptors; nb_r++)
    {
    	if (tab_syn[i].num_transm == Receptors[nb_r].num_transm)
		{
			tab_syn[i].g_Syn = Receptors[nb_r].g_Syn;
			tab_syn[i].rev_pot = Receptors[nb_r].rev_pot;
			tab_syn[i].tau_attack = Receptors[nb_r].tau_attack;
			tab_syn[i].tau_decay = Receptors[nb_r].tau_decay;
			tab_syn[i].tau_a_psp = Receptors[nb_r].tau_a_psp;
			tab_syn[i].tau_d_psp = Receptors[nb_r].tau_d_psp;
			strcpy(tab_syn[i].nom,Receptors[nb_r].nom);
		}
    }
#if DEBUG_V8
    printf("callback_input_transmitor: tab_syn[%d].num_transm:  %d, rev_pot: %f (%s)\n",
		i,tab_syn[i].num_transm, tab_syn[i].rev_pot,tab_syn[i].nom);
#endif

  (*calcul_neuron)();
  (*draw_neuron)(0);

}
/*---------------------------------------------------------

  Cette fonction permet de lire le type affecte par un DeXinput.
  Le programme "readTmsInput()" est alors appele et va reactualiser
  les valeurs du tableau "tab_syn".
  
  cette fonction n`est appelee que quand on utilise  un 
  fichier tms en entree.

---------------------------------------------------------*/

void callback_psp_type(Widget w,  XtPointer num,  DeXinputCallbackStruct *cbs)
{
  int       n,i,k,valeur_deja_prise;
  Arg       wargs[5];
  XmString  string1;
  XmString	string2;
  char      buffer[100];
	
  valeur_deja_prise=0;

  i = (int)num;

  if ((cbs->value)>0)
  {
      k=0;
      do
	  {
	  	if ( (k!=i) && (tab_type_value[k]==(cbs->value))) valeur_deja_prise=1;
	  	k++;
	  } while( (k<nb_connexions) && (valeur_deja_prise==0) );

      if (!valeur_deja_prise)
	  {
	  	tab_type_value[i]= (int)(cbs->value);

	  	readTmsInput();

	  	taille_tab_syn = number_of_event;

	  	(*calcul_neuron)();
	  	(*draw_neuron)(0);
	  }
      else 
	  {
    	  sprintf(buffer,"Selection of two equal type of event ( no %d  and %d)\n",k,i+1);
    	  string1 = XmStringCreateSimple(buffer);
    	  string2 = XmStringCreateSimple("Selection problem!");
    
    	  n = 0;
    	  XtSetArg(wargs[n], XmNx, 200);n++;
    	  XtSetArg(wargs[n], XmNy, 400);n++;
    	  XtSetArg(wargs[n], XmNmessageString, string1);n++;
    	  XtSetArg(wargs[n], XmNdialogTitle, string2);n++;
    	  
    	  Zero_Time_Step = XmCreateWarningDialog(Form_G,
    						 "zero_time_step",wargs,n);
    	  XmStringFree(string1);
    	  XtManageChild(Zero_Time_Step);
	}
  } 
}


/*---------------------------------------------------------

  Cette fonction permet de lire le fichier tms d`entree et
  d`en tirer la liste des differents types d`evenement qu`il 
  contient.

  cette fonction n`est appelee que quand on n`utilise pas de 
  fichier tms en entree.

---------------------------------------------------------*/

void callback_listing(Widget w, XtPointer c1, XtPointer c2)
{
 int       n,i,nb_ligne,nb_event_compte,taille;
 Arg       wargs[5];
 XmString  string1;
 XmString	string2;
 char      listing[30],listing1[30],buffer[80],temps[50],type[30]; 
 Widget    Message;

 listing[0]='\0';
 listing1[0]='\0';
/*-------- test d`ouverture du fichier -------*/

 if ((p_tms = fopen(nom_fichier_tms_input, "r")) == NULL)
   {
     sprintf(buffer,"ouverture du fichier %s impossible\n", nom_fichier_tms_input);
     string1 = XmStringCreateSimple(buffer);
     string2 = XmStringCreateSimple("File problem!");

     n = 0;
     XtSetArg(wargs[n], XmNx, 200);n++;
     XtSetArg(wargs[n], XmNy, 400);n++;
     XtSetArg(wargs[n], XmNmessageString, string1);n++;
     XtSetArg(wargs[n], XmNdialogTitle, string2);n++;

     Zero_Time_Step_Tms = XmCreateWarningDialog(Form_G,
						"zero_time_step_tms",wargs,n);
     XmStringFree(string1);
     XtManageChild(Zero_Time_Step_Tms);
     return;
   }
 nb_ligne=0;
 do
   {
     fgets(buffer,80,p_tms);
     sscanf(buffer, "%s %s", temps, type);
     nb_ligne++; 
   }
 while ( !feof(p_tms) );

 /*------on a trouve le nombre de ligne du fichier -------*/
 fclose(p_tms);

 i=0;
 do
   {
     p_tms = fopen(nom_fichier_tms_input, "r");
     nb_event_compte=0;
     do
       {
	 fgets(buffer,80,p_tms);
	 sscanf(buffer, "%s %s", temps, type);
	 if (atoi(type)==i) nb_event_compte++;
       } while ( !feof(p_tms) );
     fclose(p_tms);
     
     nb_ligne=nb_ligne-nb_event_compte;
   
     if (nb_event_compte!=0)
       {
	 sprintf(buffer,"%d, ",i);
	 strcat(listing,buffer);
	 if (i==0) return;   /* le type 0 n`existe normalement pas donc on sort */ 
       }
     i++;
    
   } while (nb_ligne>0);
 

 taille=(strlen(listing)-5);
 if (taille>0)
   {
     strncpy(listing1,listing,taille);
     sprintf(buffer," et %d.",i-1);
     strcat(listing1,buffer);
   }
 else  
   {
     strncpy(listing1,listing,taille+3);
     sprintf(buffer,".");
     strcat(listing1,buffer);
   }
 /*------ le listing est fabrique ------*/

 string1 = XmStringCreateSimple(listing1);
 n = 0;
 XtSetArg(wargs[n], XmNx, 200);n++;
 XtSetArg(wargs[n], XmNy, 400);n++;
 XtSetArg(wargs[n], XmNmessageString, string1);n++;
 Message = XmCreateMessageDialog(Form_G,"Listing of type event",wargs,n);
 XmStringFree(string1);
 XtManageChild(Message);
 
}

/* Fonction de gestion des recepteurs */

void callback_toggle_transmitor(Widget w, XtPointer num, XtPointer c2)
{
        int i, j;
	
	i = 0;

    for ( j = 0; j < nb_receptors; j++)
    {
#if DEBUG_V8
		printf("Col_un_Recep[%d]: %x\n",j,Col_un_Recep[j]);
#endif
      if (Col_un_Recep[j] == XtParent(XtParent(XtParent(XtParent(w)))))
			i = j;
    }

    current_recept = i;

    Receptors[current_recept].transmetteur = transmetteur[(int)num];
    Receptors[current_recept].num_transm = (int)num;
    strcpy(Receptors[current_recept].nom, transmitor_names[(int)num]);

#if DEBUG_V8
    printf("callback_toggle_transmitor: current recept : %d, transmetteur = %d, num_transm = %d, nom = %s \n",current_recept, 
		Receptors[current_recept].transmetteur, Receptors[current_recept].num_transm, Receptors[current_recept].nom);
/*
      printf("1Parent(w): %x \n",XtParent(w));
      printf("2Parent.Parent(w): %x \n", XtParent(XtParent(w)));
      printf("3Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(w))));
      printf("4Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(w)))));
      printf("5Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(w))))));
      printf("6Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w)))))));
      printf("7Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w))))))));
      printf("8Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w)))))))));
      printf("9Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w))))))))));
      printf("10Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w)))))))))));
      printf("11Parent.Parent.Parent(w): %x \n", XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(XtParent(w))))))))))));
*/
#endif

}

void callback_receptor_rev_pot(Widget w, XtPointer num, DeXinputCallbackStruct *cbs )
{
        int i;
	
		i = (int)num;
        Receptors[i].rev_pot = (float)cbs->value * 0.01;
}

void callback_receptor_amplitude(Widget w, XtPointer num, DeXinputCallbackStruct *cbs )
{
        int i;
	
		i = (int)num;
        Receptors[i].g_Syn = (float)cbs->value * 0.001;
}

void callback_receptor_tau_decay(Widget w, XtPointer num, DeXinputCallbackStruct *cbs )
{
        int i;
	
		i = (int)num;
        Receptors[i].tau_decay = (float)cbs->value * 0.01;
}

void callback_receptor_tau_attack(Widget w, XtPointer num, DeXinputCallbackStruct *cbs )
{
        int i;
	
		i = (int)num;
        Receptors[i].tau_attack = (float)cbs->value * 0.01;
}

void callback_nb_receptors(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs )
{
	int	n;
	    
 	n = (cbs->value);
	if (n <= 0  ) return;
	if (n > NB_MAX_RECEPTORS)
	{
	    nb_receptors = NB_MAX_RECEPTORS;
	}
	else
	{
	    nb_receptors = n;
	}
	/*--------- recreation de la fenetre de simulation ------------*/

	if (Top_Level_Receptors)
	{
	  XtDestroyWidget(Top_Level_Receptors);
	  flag_receptors = 0;
	}
	fabrique_Receptors(); 
}  

void callback_close_Receptors(Widget w, XtPointer c1, XtPointer c2)
{
	if (Top_Level_Receptors)
	{
	  XtDestroyWidget(Top_Level_Receptors);
	  flag_receptors = 0;
	}
}

void callback_sortie(Widget w, XtPointer c1, XtPointer c2)
{
        sortie();
}

void fermeture_XY(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_XY);
	flag_XY = 0;
}

void fermeture_M_H_TAU(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_M_H_TAU);
	flag_M_H_TAU = 0;
}

void fermeture_RB(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_RB);
	flag_RB = 0;
}

void fermeture_DB(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_DB);
	flag_DB = 0;
}

void fermeture_transmitors(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_Transmitors);
	flag_transmitors = 0;
}

/*-------------- Changement de l`echelle --------------------*/

void callback_Graphe1min(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
       reference1_min = (float) (cbs->value);

       (*calcul_neuron)();
       (*draw_neuron)(0);
}

void callback_Graphe1max(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
       reference1_max = (float) (cbs->value);

       (*calcul_neuron)();
       (*draw_neuron)(0);
}

void callback_Graphe2min(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  if (flag_phenom)
       reference2_min_p = (float) (cbs->value);
  else
       reference2_min_g = (float) (cbs->value);

       (*calcul_neuron)();
       (*draw_neuron)(0);
}

void callback_Graphe2max(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  if (flag_phenom)
       reference2_max_p = (float) (cbs->value);
  else
       reference2_max_g = (float) (cbs->value);

       (*calcul_neuron)();
       (*draw_neuron)(0);
}

void callback_Graphe3min(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  if (flag_phenom)
       reference3_min_p = (float) (cbs->value);
  else
       reference3_min_g = (float) (cbs->value);

       (*calcul_neuron)();
       (*draw_neuron)(0);
}

void callback_Graphe3max(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{       
  if (flag_phenom)
       reference3_max_p = (float) (cbs->value);
  else
       reference3_max_g = (float) (cbs->value);

       (*calcul_neuron)();
       (*draw_neuron)(0);
}

/****************************************/
void callback_fixed_duration_stim(Widget w, XtPointer c1, XtPointer c2)
{
  Arg	    wargs[10];
  XmString  string1,string2;
  int       n;



  flag_button_fixed_duration_stim = !flag_button_fixed_duration_stim;

  if(flag_button_fixed_duration_stim )	
    /* si flag = 1 : la duree de stimulation est fixe */
    {
      XtSetSensitive(Repeat_Stimulation_Duration,False);
      string1 = XmStringCreateSimple("Variable Duration Stim");       
    }
  else
    {
      XtSetSensitive(Repeat_Stimulation_Duration,True);
      string1 = XmStringCreateSimple(" Fixed Duration Stim  ");       
    }                                 
  n=0;
  XtSetArg(wargs[n], XmNlabelString, string1); n++;
  XtSetArg(wargs[n], XmNrecomputeSize, False );n++;
  XtSetValues(EDFixedDurationStim_pushButton, wargs, n);
  XmStringFree(string1);
}

/****************************************/
void callback_duree_simul(Widget w, int no, DeXinputCallbackStruct *cbs)
{
	Arg	wargs[20];
	float	old_time_step;
	int	n, i;
	XmString	string1;
	XmString	string2;

	old_time_step = time_step;
	if (no == 0)
	  {
	    old_duree_simul = duree_simul;
	    duree_simul = (float) cbs->value;
	    reactualise_time_stim(4);
	  }
	else
	{
		time_step = (float) (cbs->value) / 10000.;
		if (integration_type == RUNGE_KUTTA)
		{
		  if (time_step > 0.025)
		  {
		    string1 = XmStringCreateSimple("For Runge-Kutta method, time step <= 0.025\nSwitched to manual Update...");
		    string2 = XmStringCreateSimple("Wrong time step!");

		    n = 0;
		    XtSetArg(wargs[n], XmNx, 200);n++;
		    XtSetArg(wargs[n], XmNy, 400);n++;
		    XtSetArg(wargs[n], XmNmessageString, string1);n++;
		    XtSetArg(wargs[n], XmNdialogTitle, string2);n++;

		    Zero_Time_Step = XmCreateWarningDialog(top_levelG,
							   "zero_time_step",wargs,n);
		    XmStringFree(string1);
		    XtManageChild(Zero_Time_Step);

		    flag_no_update = True;
		    XtVaSetValues(update_pushButton,XmNsensitive,True,NULL);
		    XtVaSetValues(update_toggleButton,XmNpositionIndex,2,NULL);

		    XtSetArg(wargs[0], DeXNvalue, 250L);
		    XtSetValues(Repeat_Time_Step, wargs, 1);
		    time_step = 0.025;
		  }
		}
		if (integration_type == EULER)
		{
		  if (time_step > 0.01)
		  {
		    string1 = XmStringCreateSimple("For Euler method, time step <= 0.01\nSwitched to manual Update...");
		    string2 = XmStringCreateSimple("Wrong time step!");

		    n = 0;
		    XtSetArg(wargs[n], XmNx, 200);n++;
		    XtSetArg(wargs[n], XmNy, 400);n++;
		    XtSetArg(wargs[n], XmNmessageString, string1);n++;
		    XtSetArg(wargs[n], XmNdialogTitle, string2);n++;

		    Zero_Time_Step = XmCreateWarningDialog(top_levelG,
							   "zero_time_step",wargs,n);
		    XmStringFree(string1);
		    XtManageChild(Zero_Time_Step);

		    flag_no_update = True;
		    XtVaSetValues(update_pushButton,XmNsensitive,True,NULL);
		    XtVaSetValues(update_toggleButton,XmNpositionIndex,2,NULL);

		    XtSetArg(wargs[0], DeXNvalue, 100L);
		    XtSetValues(Repeat_Time_Step, wargs, 1);
		    time_step = 0.01;
		  }
		}
#ifdef ADD_METHOD
/* May be your new method has constraints of time step
   Copy and adapt
*/
		if (integration_type == INT_METHOD)
		{
		  if (time_step > 0.025)
		  {
		    string1 = XmStringCreateSimple("For Int_Method method, time step <= 0.025\nSwitched to manual Update...");
		    string2 = XmStringCreateSimple("Wrong time step!");

		    n = 0;
		    XtSetArg(wargs[n], XmNx, 200);n++;
		    XtSetArg(wargs[n], XmNy, 400);n++;
		    XtSetArg(wargs[n], XmNmessageString, string1);n++;
		    XtSetArg(wargs[n], XmNdialogTitle, string2);n++;

		    Zero_Time_Step = XmCreateWarningDialog(top_levelG,
							   "zero_time_step",wargs,n);
		    XmStringFree(string1);
		    XtManageChild(Zero_Time_Step);

		    flag_no_update = True;
		    XtVaSetValues(update_pushButton,XmNsensitive,True,NULL);
		    XtVaSetValues(update_toggleButton,XmNpositionIndex,2,NULL);

		    XtSetArg(wargs[0], DeXNvalue, 250L);
		    XtSetValues(Repeat_Time_Step, wargs, 1);
		    time_step = 0.025;
		  }
		}
#endif
	}
		    
	if (time_step <= 0.)
	{
		string1 = XmStringCreateSimple("Illegal Time Step. Reset to last legal value");
		string2 = XmStringCreateSimple("Wrong time step!");
	
		n = 0;
		XtSetArg(wargs[n], XmNx, 200);n++;
		XtSetArg(wargs[n], XmNy, 400);n++;
		XtSetArg(wargs[n], XmNmessageString, string1);n++;
		XtSetArg(wargs[n], XmNdialogTitle, string2);n++;

		Zero_Time_Step = XmCreateWarningDialog(top_levelG,
						       "zero_time_step",wargs,n);
		XmStringFree(string1);
		XtManageChild(Zero_Time_Step);

		XtSetArg(wargs[0], DeXNvalue, (int) (old_time_step * 10000.));
		XtSetValues(Repeat_Time_Step, wargs, 1);
		time_step = old_time_step;
		return;
	} /* fin du if */
	
	if (Top_Level_XY)
	{
		flag_XY = 0;
		XtDestroyWidget(Top_Level_XY);
	} /* fin du if */
	if (Top_Level_RB)
	{
		flag_RB = 0;
		XtDestroyWidget(Top_Level_RB);
	} /* fin du if */
	realloc_for_graphs();
	(*calcul_neuron)();
	(*draw_neuron)(0);
	XtSetArg(wargs[0], DeXNvalue, (int) (time_step * 10000.));
	if (DeXInput_Time_Step) XtSetValues(DeXInput_Time_Step, wargs, 1);
	if (Repeat_Time_Step) XtSetValues(Repeat_Time_Step, wargs, 1);
}

void callback_debut_stim(Widget w, XtPointer c1, XmScaleCallbackStruct *cbs)
{
	Arg     wargs[2];
	debut_stim = (float) ((cbs->value)*duree_simul/100);
	reactualise_time_stim(1);
	realloc_for_graphs();
	(*calcul_neuron)();
	(*draw_neuron)(0);
}

void callback_fin_stim(Widget w, XtPointer c1, XmScaleCallbackStruct *cbs)
{
	Arg     wargs[2];
	fin_stim = (float) ((cbs->value)*duree_simul/100);
	reactualise_time_stim(2);
	realloc_for_graphs();
	(*calcul_neuron)();
	(*draw_neuron)(0);
} 

void callback_duree_stim(Widget w, XtPointer c1, XmScaleCallbackStruct *cbs)
{   
	Arg     wargs[2];
	duree_stim = (float) ((cbs->value)*duree_simul/100);
	reactualise_time_stim(3);
	if (Top_Level_XY)
	{
		flag_XY = 0;
		XtDestroyWidget(Top_Level_XY);
	} /* fin du if */
	if (Top_Level_RB)
	{
		flag_RB = 0;
		XtDestroyWidget(Top_Level_RB);
	} /* fin du if */
	realloc_for_graphs();
	(*calcul_neuron)();
	(*draw_neuron)(0);
} 

void expose_resize_CB(Widget w, int data, XmAnyCallbackStruct *cbs)
{
	(*draw_neuron)(data);
} 

void expose_resize_XY(Widget w, int data, XmAnyCallbackStruct *cbs)
{
	draw_X_Y_graph();
} 

void expose_resize_M_H_TAU(Widget w, int data, XmAnyCallbackStruct *cbs)
{
	courbes_m_h();
	draw_M_H_TAU_graph();
} 

/* ------------- Conductance ------------*/

void callback_input_crt(Widget w, XtPointer c1, DeXdDialCallbackStruct *cbs)
{
	input_fact = (float) (cbs->value) * 0.001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}

void callback_g_NMDA(Widget w, XtPointer c1, DeXdDialCallbackStruct *cbs)
{
	XmString	string;
	
/*	g_NMDA = (float) (cbs->value)* 1e-11;*/
	g_NMDA = (float) (cbs->value) * .01;
	sprintf(buffer,"G NMDA: %.3f",g_NMDA);
	string = XmStringCreateSimple(buffer);
	XtVaSetValues(toggleButton11,XmNlabelString,string,NULL);
	(*calcul_neuron)();
	(*draw_neuron)(0);
} 

void callback_magnesium(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	magnesium = (float) (cbs->value)/100.;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}

void callback_mb_capacity(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	capacite = (float) (cbs->value) / 10000.;
	if (capacite <= 0.)
		capacite = 0.000001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}

void callback_conductances(Widget w, XtPointer c1, DeXdDialCallbackStruct *cbs)
{
	XmString	string;
/*
	printf("dans callback_conductances avec %d\n",cbs->value);
*/

       	if(set_g_Na)
	{
		g_Na = (float) (cbs->value) * .01;
		sprintf(buffer,"G Na : %.3f",g_Na);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton1,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
	if(set_g_Nap)
	{
		g_Nap = (float) (cbs->value) * .001;
		sprintf(buffer,"G Na pers: %.3f",g_Nap);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton2,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
	if(set_g_K)
	{
		g_K = (float) (cbs->value) * .01;
		sprintf(buffer,"G K: %.3f",g_K);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton3,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
	if(set_g_A)
	{
		g_A = (float) (cbs->value) * .001;
		sprintf(buffer,"G K for Ia: %.3f",g_A);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton4,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
	if(set_g_M)
	{
		g_M = (float) (cbs->value) * .01;
		sprintf(buffer,"G K for Im: %.3f",g_M);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton5,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
	if(set_g_C)
	{
		g_C = (float) (cbs->value) * .01;
		sprintf(buffer,"G K for Ic: %.3f",g_C);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton6,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
	if(set_g_H)
	{
		g_H = (float) (cbs->value) * .01;
		sprintf(buffer,"G K for Ih: %.3f",g_H);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton23,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
	if(set_g_ahp)
	{
		g_ahp = (float) (cbs->value) * .01;
		sprintf(buffer,"G K for Iahp: %.3f",g_ahp);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton7,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,False,NULL);
	} /* fin du if */
	if(set_g_Ca)
	{
		g_Ca = (float) (cbs->value) * .01;
		sprintf(buffer,"G Ca HVA: %.3f",g_Ca);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton8,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
	if(set_g_Cab)
	{
		g_Cab = (float) (cbs->value) * .01;
		sprintf(buffer,"G Ca LVA: %.3f",g_Cab);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton9,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/

	if(set_g_New)
	{
		g_New = (float) (cbs->value) * .01;
		sprintf(buffer,"G New: %.3f",g_New);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton23,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
#endif
	if(set_g_fuite)
	{
		g_fuite = (float) (cbs->value) * .01;
		sprintf(buffer,"G Leak: %.3f",g_fuite);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton10,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,False,NULL);
	} /* fin du if */
	if(set_g_fuite_Na)
	{
		g_fuite_Na = (float) (cbs->value) * .01;
		sprintf(buffer,"G Na Leak: %.3f",g_fuite_Na);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton24,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,False,NULL);
	} /* fin du if */
	if(set_g_fuite_K)
	{
		g_fuite_K = (float) (cbs->value) * .01;
		sprintf(buffer,"G K Leak: %.3f",g_fuite_K);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton25,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,False,NULL);
	} /* fin du if */
	if(set_g_NMDA)
	{
		g_NMDA = (float) (cbs->value) * .01;
		sprintf(buffer,"G NMDA: %.3f",g_NMDA);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton11,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
	if (set_g_Syn_pos)
	{
		g_Syn_pos = (float) (cbs->value) * .01;
		sprintf(buffer,"G Syn EPSP: %.3f",g_Syn_pos);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton21,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */
	if(set_g_Syn_neg)
	{
		g_Syn_neg = (float) (cbs->value) * .01;
		sprintf(buffer,"G Syn IPSP: %.3f",g_Syn_neg);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton22,XmNlabelString,string,NULL);
		XtVaSetValues(param_pushButton,XmNsensitive,True,NULL);
	} /* fin du if */

	XmStringFree(string);
	(*calcul_neuron)();
	(*draw_neuron)(0);
}

void callback_Phenoms(Widget w, XtPointer c1, DeXdDialCallbackStruct *cbs)
{
	XmString	string;
/*
	printf("dans callback_Phenoms avec %d\n",cbs->value);
*/

       	if(set_p_p_rest_pot)
	{
		p_rest_pot = (float) (cbs->value) * .01;
		sprintf(buffer,"Resting potential: %.2f mV",p_rest_pot);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton1,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_seuil)
	{
		seuil = (float) (cbs->value) * .01;
		sprintf(buffer,"Firing threshold: %.2f mV",seuil);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton2,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_pot_post_spike)
	{
		pot_post_spike = (float) (cbs->value) * .01;
		sprintf(buffer,"Postspike potential: %.2f mV",pot_post_spike);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton3,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_seuil_post_spike)
	{
		seuil_post_spike = (float) (cbs->value) * .01;
		sprintf(buffer,"Postspike threshold: %.2f mV",seuil_post_spike);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton4,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_fatigue)
	{
		fatigue = (float) (cbs->value) * .01;
		sprintf(buffer,"Threshold fatigue: %.2f mV",fatigue);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton5,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_tau_mb_pot)
	{
		tau_mb_pot = (float) (cbs->value) * .01;
		sprintf(buffer,"Membrane time cste: %.2f ms",tau_mb_pot);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton6,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_tau_seuil)
	{
		tau_seuil = (float) (cbs->value) * .01;
		sprintf(buffer,"Threshold time cste: %.2f ms",tau_seuil);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton7,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_shunt_tau)
	{
		shunt_tau = (float) (cbs->value) * .01;
		sprintf(buffer,"Shunt time cste: %.2f ms",shunt_tau);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton8,XmNlabelString,string,NULL);
	} /* fin du if */

	/* now the cond burster parameters */

	if(set_p_seuil_burst)
	{
		seuil_burst = (float) (cbs->value) * .01;
		sprintf(buffer,"Burst threshold: %.2f mV",seuil_burst);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton9,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_burst_post_spike)
	{
		burst_post_spike = (float) (cbs->value) * .01;
		sprintf(buffer,"Postspike burst pot: %.2f mV",burst_post_spike);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton10,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_duree_burst_min)
	{
		duree_burst_min = (float) (cbs->value) * .01;
		sprintf(buffer,"Min burst duration: %.2f ms",duree_burst_min);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton11,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_duree_burst_max)
	{
		duree_burst_max = (float) (cbs->value) * .01;
		sprintf(buffer,"Max burst duration: %.2f ms",duree_burst_max);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton12,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_freq_spike)
	{
	        freq_spike = (float) (cbs->value);
		sprintf(buffer,"Spike frequency: %.0f sp/s",freq_spike);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton13,XmNlabelString,string,NULL);
	} /* fin du if */
	if(set_p_freq_max)
	{
		freq_max = (float) (cbs->value);
		sprintf(buffer,"Max frequency: %.0f sp/s",freq_max);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton14,XmNlabelString,string,NULL);
	} /* fin du if */
	if (set_p_compose_fact)
	{
		compose_fact = (float) (cbs->value) * .01;
		sprintf(buffer,"Composition factor: %.2f",compose_fact);
		string = XmStringCreateSimple(buffer);
		XtVaSetValues(toggleButton15,XmNlabelString,string,NULL);
	} /* fin du if */

	XmStringFree(string);
	(*calcul_neuron)();
	(*draw_neuron)(0);
}

void callback_update(Widget w, XtPointer c1, XtPointer c2)
{
	flag_no_update = False;
	(*calcul_neuron)();
	(*draw_neuron)(0);
	flag_no_update = True;
} 

void callback_toggle_update(Widget w, XtPointer c1, XtPointer c2)
{
	switch ( (int)c1 )
	{
		case 0:
			flag_no_update = False;
			XtVaSetValues(update_pushButton,XmNsensitive,False,NULL);
			break;
		case 1:
			flag_no_update = True;
			XtVaSetValues(update_pushButton,XmNsensitive,True,NULL);
			break;
	} /* fin du switch */
} 

void callback_toggle_integration(Widget w, XtPointer c1, XtPointer c2)
{
        XmString string1;
	XmString	string2;
	int      n;
	Arg     wargs[5];

	switch ( (int)c1 )
	{
		case 0:
			update_neurone =  update_expon;
			integration_type = EXPONENTIELLE;
			break;
		case 1:
			update_neurone =  update_euler;
			integration_type = EULER;
			break;
		case 2:
			update_neurone =  update_r_k;
			integration_type = RUNGE_KUTTA;
			break;
		case 3:
			update_neurone =  update_r_k_v_s;
			integration_type = RUNGE_KUTTA_VARIABLE_STEP;
			break;
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
		case 4:
			update_neurone =  update_int_method;
			integration_type = INT_METHOD;
			break;
#endif


	}

	if (integration_type == RUNGE_KUTTA)
	{
	  if (time_step > 0.025)
	  {
	    string1 = XmStringCreateSimple("For Runge-Kutta method, time step <= 0.025\nSwitched to manual Update...");
	    string2 = XmStringCreateSimple("Wrong time step!");

	    n = 0;
	    XtSetArg(wargs[n], XmNx, 200);n++;
	    XtSetArg(wargs[n], XmNy, 400);n++;
	    XtSetArg(wargs[n], XmNmessageString, string1);n++;
	    XtSetArg(wargs[n], XmNdialogTitle, string2);n++;

	    Zero_Time_Step = XmCreateWarningDialog(top_levelG,
						   "zero_time_step",wargs,n);
	    XmStringFree(string1);
	    XtManageChild(Zero_Time_Step);

	    flag_no_update = True;
	    XtVaSetValues(update_pushButton,XmNsensitive,True,NULL);
	    XtVaSetValues(update_toggleButton,XmNpositionIndex,2,NULL);
	    

	    XtSetArg(wargs[0], DeXNvalue, 250L);
	    XtSetValues(Repeat_Time_Step, wargs, 1);
	    time_step = 0.025;
       	    realloc_for_graphs();
	  }
	}
	if (integration_type == EULER)
	{
	  if (time_step > 0.01)
	  {
	    string1 = XmStringCreateSimple("For Euler method, time step <= 0.01\nSwitched to manual Update...");
       	    string2 = XmStringCreateSimple("Wrong time step!");

	    n = 0;
	    XtSetArg(wargs[n], XmNx, 200);n++;
	    XtSetArg(wargs[n], XmNy, 400);n++;
	    XtSetArg(wargs[n], XmNmessageString, string1);n++;
	    XtSetArg(wargs[n], XmNdialogTitle, string2);n++;

	    Zero_Time_Step = XmCreateWarningDialog(top_levelG,
						   "zero_time_step",wargs,n);
	    XmStringFree(string1);
	    XtManageChild(Zero_Time_Step);


	    flag_no_update = True;
	    XtVaSetValues(update_pushButton,XmNsensitive,True,NULL);
	    XtVaSetValues(update_toggleButton,XmNpositionIndex,2,NULL); 

	    XtSetArg(wargs[0], DeXNvalue, 100L);
	    XtSetValues(Repeat_Time_Step, wargs, 1);
	    time_step = 0.01;
       	    realloc_for_graphs();
	  }
	}
#ifdef ADD_METHOD
/* May be your new method has constraints of time step
Copy and adapt
*/
	if (integration_type == INT_METHOD)
	{
	  if (time_step > 0.025)
	  {
	    string1 = XmStringCreateSimple("For Int_Method method, time step <= 0.025\nSwitched to manual Update...");
	    string2 = XmStringCreateSimple("Wrong time step!");

	    n = 0;
	    XtSetArg(wargs[n], XmNx, 200);n++;
	    XtSetArg(wargs[n], XmNy, 400);n++;
	    XtSetArg(wargs[n], XmNmessageString, string1);n++;
	    XtSetArg(wargs[n], XmNdialogTitle, string2);n++;

	    Zero_Time_Step = XmCreateWarningDialog(top_levelG,
						   "zero_time_step",wargs,n);
	    XmStringFree(string1);
	    XtManageChild(Zero_Time_Step);

	    flag_no_update = True;
	    XtVaSetValues(update_pushButton,XmNsensitive,True,NULL);
	    XtVaSetValues(update_toggleButton,XmNpositionIndex,2,NULL);

	    XtSetArg(wargs[0], DeXNvalue, 250L);
	    XtSetValues(Repeat_Time_Step, wargs, 1);
	    time_step = 0.025;
       	    realloc_for_graphs();
	  }
	}
#endif

	(*calcul_neuron)();
	(*draw_neuron)(0);
}
 
void callback_toggle_noise(Widget w, XtPointer c1, XtPointer c2)
{
        XmString string1;
	XmString	string2;
	int      n;
	Arg     wargs[5];

	switch ( (int)c1 )
	{
		case 0:
			filter_noise =  FALSE;
			break;
		case 1:
			filter_noise =  TRUE;

			v_plus = (rev_pot_pos - p_rest_pot);
			v_moins = (rev_pot_neg - p_rest_pot);
			A = (1./ v_plus) - (1. / v_moins);
			v_rap = v_plus / v_moins;

			filter_a = exp(-time_step /  (backgrd_noise_resistance * capacite));
			filter_b = 1./ capacite;

			break;
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
		case 2:
			filter_noise =  2;
			break;
#endif
	}

	(*calcul_neuron)();
	(*draw_neuron)(0);
}

void callback_toggle_plot(Widget w, XtPointer c1, XtPointer c2)
{

	switch ( (int)c1 )
	{
		case 0:
			plot_type = CRT_CRT;
			break;
		case 1:
			plot_type = ISI_RATE;
			break;
		case 2:
			plot_type = CRT_ISI;
			break;
		case 3:
			plot_type = CRT_RATE;
			break;
	}

	(*calcul_neuron)();
	(*draw_neuron)(0);
}

void callback_model_hh(Widget w, XtPointer c1, XtPointer c2)
{
  XmString string1;
  int      n;
  Arg     wargs[5];

#if DEBUG
  printf("calback_model: %d\n\tTop_Level_Conductance: %d\n\tTop_Level_Phenom: %d\n",
	 c1, Top_Level_Conductance, Top_Level_Phenom);
#endif

	if (Top_Level_Phenom)
	{
	  XtDestroyWidget(Top_Level_Phenom);
	  Top_Level_Phenom = 0;
	  flag_Phenom = 0;
	}
	flag_phenom = 0;
	switch ( (int) c1)
	{
	    case 0:
	    {
	      model_type = HH_SIMPLE_MODEL;
	      strcpy(model_name,"Hodgkin-Huxley");
	      fabrique_scrolled_window_conductance();
	      break;
	    }
	    case 1:
	      {
		model_type = MICHAELIS_MENTON_MODEL;
		strcpy(model_name,"Michaelis-Menton");
	      }
	      break;
#ifdef ADD_A_MODEL
	/* Adapt here with the new method */
	   case 3:
	   {
	     model_type = NEW_MODEL;
	     break;
	   }
#endif

	}
#if DEBUG
	printf("Conduct: Model type set to: %d\n",model_type);
#endif
	fabrique_scrolled_window_conductance();
	/* reposition windows */

  if (flag_horizontal)
    toggle_representation(HORIZONTAL);
  else
    toggle_representation(VERTICAL);

  if (flag_conductance)
  {
	switch ( integration_type )
	{
		case EXPONENTIELLE: 
			update_neurone =  update_expon;
			break;
		case EULER:
			update_neurone =  update_euler;
			break;
		case RUNGE_KUTTA:
			update_neurone =  update_r_k;
			break;
		case RUNGE_KUTTA_VARIABLE_STEP:
			update_neurone =  update_r_k_v_s;
			break;
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
		case INT_METHOD:
			update_neurone =  update_int_method;
			break;
#endif
	}
  }
  else
  {
    /*        update_neurone =  update_phenom; */
	plot_type = ISI_RATE;

  }


  sprintf(buffer,"Conductance models [%s]",model_name);
  XtVaSetValues(Top_Level_Conductance,XmNtitle,buffer,NULL);

  calcul_neuron = calcul_neuron_conduct; 
  draw_neuron =  draw_neuron_conduct;

  (*calcul_neuron)();
  (*draw_neuron)(0);
  
  if (flag_activ)
    {
      if (flag_equation)
	{
	  XtDestroyWidget(Top_Level_Equation);
	  flag_equation = 0;
	}
      if (flag_activ)
	{
	  XtDestroyWidget(Top_Level_Activ);
	  flag_activ = 0;
	}
      
    }
 
}

void callback_model_phenom(Widget w, XtPointer c1, XtPointer c2)
{
  XmString string1;
  int      n;
  Arg     wargs[5];

#if DEBUG
  printf("calback_model: %d\n\tTop_Level_Conductance: %d\n\tTop_Level_Phenom: %d\n",
	 c1, Top_Level_Conductance, Top_Level_Phenom);
#endif

  if (Top_Level_Conductance)
    {
      XtDestroyWidget(Top_Level_Conductance);
      Top_Level_Conductance = 0;
      flag_conductance = 0;
    }
  flag_phenom = 1;
  fabrique_scrolled_window_phenom();

  switch ( (int) c1)
    {
    case 0:
      {
	model_type = XNBC_MODEL;
	strcpy(model_name,"XNBC");

	XtVaSetValues(toggleButton8,XmNsensitive,True,NULL);
	XtVaSetValues(toggleButton9,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton10,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton11,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton12,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton13,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton14,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton15,XmNsensitive,False,NULL);
	update_neurone = update_xnbc;
	break;
      }
    case 1:
      {
	model_type = LEAKY_INTEG_MODEL;
	strcpy(model_name,"Leaky integrator");

	XtVaSetValues(toggleButton8,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton9,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton10,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton11,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton12,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton13,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton14,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton15,XmNsensitive,False,NULL);
	update_neurone = update_leaky;
	break;
      }
    case 2:
      {
	model_type = COND_BURST_MODEL;
	strcpy(model_name,"Conditional burster");

	XtVaSetValues(toggleButton8,XmNsensitive,True,NULL);
	XtVaSetValues(toggleButton9,XmNsensitive,True,NULL);
	XtVaSetValues(toggleButton10,XmNsensitive,True,NULL);
	XtVaSetValues(toggleButton11,XmNsensitive,True,NULL);
	XtVaSetValues(toggleButton12,XmNsensitive,True,NULL);
	XtVaSetValues(toggleButton13,XmNsensitive,True,NULL);
	XtVaSetValues(toggleButton14,XmNsensitive,True,NULL);
	XtVaSetValues(toggleButton15,XmNsensitive,True,NULL);
	update_neurone = update_cond;
	break;
      }

#ifdef ADD_A_MODEL
      /* Adapt here with the new method */
    case 3:
      {
	model_type = NEW_MODEL;
	XtVaSetValues(toggleButton15,XmNsensitive,True,NULL);
	/* .... */
	update_neurone = update_NEW_MODEL;
	break;
      }
#endif

    }
#if DEBUG
	printf("Phenom: Model type set to: %d\n",model_type);
#endif

  /* reposition windows */

  if (flag_horizontal)
    toggle_representation(HORIZONTAL);
  else
    toggle_representation(VERTICAL);

  /*    update_neurone =  update_phenom; */
  plot_type = ISI_RATE;

  sprintf(buffer,"Phenomenologic models [%s]",model_name);
  XtVaSetValues(Top_Level_Phenom,XmNtitle,buffer,NULL);

  sprintf(buffer,"%s model values",model_name);
  string1 = XmStringCreateSimple(buffer);	
  XtVaSetValues(label_Phenoms,XmNlabelString,string1,NULL);

  calcul_neuron = calcul_neuron_phenom; 
  draw_neuron =  draw_neuron_phenom;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  
  if (flag_activ)
    {
      if (flag_equation)
	{
	  XtDestroyWidget(Top_Level_Equation);
	  flag_equation = 0;
	}
      if (flag_activ)
	{
	  XtDestroyWidget(Top_Level_Activ);
	  flag_activ = 0;
	}
      
    }
 
}

/* ------------- PSP ------------*/
void callback_E_Na(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	E_Na = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_E_K(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	E_K = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_tau_EPSP_a(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	tau_attack_epsp = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
} 
void callback_tau_EPSP_d(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	tau_decay_epsp = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_tau_IPSP_a(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	tau_attack_ipsp = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_tau_IPSP_d(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	tau_decay_ipsp = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_bckg_noise_mean(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	backgrd_noise_m = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_bckg_noise_sd(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	backgrd_noise_sd = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_bckg_noise_resistance(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	backgrd_noise_resistance = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
/* ------------- NMDA ------------*/
void callback_tau_nmda_a(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	tau_attack_NMDA = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_tau_nmda_d(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	tau_decay_NMDA = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_eta_nmda(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	eta_NMDA = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_gamma_nmda(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	gamma_NMDA = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
/* ------------- Equilibrium ------------*/
void callback_Temp(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
        XmString  string;
	Temp = (float) (cbs->value) * .01;

	reactualise_E_Na_K();

	sprintf(buffer,"ENa: %4.2fmV EK: %4.2fmV Em: %5.2fmV ",E_Na,E_K,E_Goldman);
       	string = XmStringCreateSimple(buffer);
	XtVaSetValues(DeXOutput_Res_E_Na_K,XmNlabelString,string,NULL);
       	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_Na_ext(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
    XmString  string;
	Na_ext = (float) (cbs->value) * .01;

	reactualise_E_Na_K();

	sprintf(buffer,"ENa: %4.2fmV EK: %4.2fmV Em: %5.2fmV ",E_Na,E_K,E_Goldman);
    string = XmStringCreateSimple(buffer);
	XtVaSetValues(DeXOutput_Res_E_Na_K,XmNlabelString,string,NULL);
    (*calcul_neuron)();
	(*draw_neuron)(0);
	
}
void callback_Na_int(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	XmString  string;
	Na_int = (float) (cbs->value) * .01;

	reactualise_E_Na_K();

	sprintf(buffer,"ENa: %4.2fmV EK: %4.2fmV Em: %5.2fmV ",E_Na,E_K,E_Goldman);
       	string = XmStringCreateSimple(buffer);
	XtVaSetValues(DeXOutput_Res_E_Na_K,XmNlabelString,string,NULL);
       	(*calcul_neuron)();
	(*draw_neuron)(0);

}
void callback_K_ext(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	XmString  string;
	
	K_ext = (float) (cbs->value) * .01;
	
	reactualise_E_Na_K();

	sprintf(buffer,"ENa: %4.2fmV EK: %4.2fmV Em: %5.2fmV ",E_Na,E_K,E_Goldman);
       	string = XmStringCreateSimple(buffer);
	XtVaSetValues(DeXOutput_Res_E_Na_K,XmNlabelString,string,NULL);
       	(*calcul_neuron)();
	(*draw_neuron)(0);

}
void callback_K_int(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	XmString  string;
	K_int = (float) (cbs->value) * .01;

	reactualise_E_Na_K();

	sprintf(buffer,"ENa: %4.2fmV EK: %4.2fmV Em: %5.2fmV ",E_Na,E_K,E_Goldman);
       	string = XmStringCreateSimple(buffer);
	XtVaSetValues(DeXOutput_Res_E_Na_K,XmNlabelString,string,NULL);
       	(*calcul_neuron)();
	(*draw_neuron)(0);

}
void callback_Cl_ext(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	XmString  string;
	
	Cl_ext = (float) (cbs->value) * .01;
	
	reactualise_E_Na_K();

	sprintf(buffer,"ENa: %4.2fmV EK: %4.2fmV Em: %5.2fmV ",E_Na,E_K,E_Goldman);
       	string = XmStringCreateSimple(buffer);
	XtVaSetValues(DeXOutput_Res_E_Na_K,XmNlabelString,string,NULL);
       	(*calcul_neuron)();
	(*draw_neuron)(0);

}
void callback_Cl_int(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	XmString  string;
	Cl_int = (float) (cbs->value) * .01;

	reactualise_E_Na_K();

	sprintf(buffer,"ENa: %4.2fmV EK: %4.2fmV Em: %5.2fmV ",E_Na,E_K,E_Goldman);
       	string = XmStringCreateSimple(buffer);
	XtVaSetValues(DeXOutput_Res_E_Na_K,XmNlabelString,string,NULL);
       	(*calcul_neuron)();
	(*draw_neuron)(0);

}
/*
void callback_E_H(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	E_H = (float) (cbs->value) * .01;
	(*calcul_neuron)();
       	(*draw_neuron)(0);
}
*/
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/

void callback_E_New(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	E_New = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
#endif
void callback_E_Ca(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	E_Ca = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_Ca_Influx(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	Ca_Influx = (float) (cbs->value) * .00001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_Ca_Removal(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	Ca_Removal = (float) (cbs->value) * .001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_Ca_Kd(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	Ca_Kd = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_K_Ca_Kd(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	K_Ca_Kd = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_Tau_Cai_D(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	tau_decay_Ca = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_E_Leak(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	E_fuite = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_E_NMDA(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	rev_pot_NMDA = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}

/* ------------- Initilizations ------------*/
void callback_m_ahp(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	m_ahp_init = (float) (cbs->value) * .01;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_m_K(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	m_K_init = (float) (cbs->value) * .001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_m_Ih(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	m_Ih_init = (float) (cbs->value) * .001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_m_Ca(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	m_Ca_init = (float) (cbs->value) * .0001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_Ca_i(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	Ca_i_init = (float) (cbs->value) * .001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_h_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	h_A_init = (float) (cbs->value) * .001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_le_pot(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	le_potentiel_init = (float) (cbs->value) * .1;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_m_Cab(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	m_Cab_init = (float) (cbs->value) * .001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_h_Cab(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	h_Cab_init = (float) (cbs->value) * .001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_m_Nap(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	m_Nap_init = (float) (cbs->value) * .001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
/*-------------- but may be you ddon not need it -------------*/
void callback_h_New(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	h_New_init = (float) (cbs->value) * .001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_m_New(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	m_New_init = (float) (cbs->value) * .001;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
#endif

/* ------------- Activation ------------*/
void expose_equa_text(Widget w, XtPointer c1, XmDrawingAreaCallbackStruct *cbs)
{
	static GC gc;
	Dimension	largeur, hauteur;

	if (!gc)
	{
		gc = XCreateGC(XtDisplay(Equa_text), XtWindow(Equa_text), 0, 0);
		XSetForeground(XtDisplay(Equa_text), gc, BlackPixelOfScreen(XtScreen(Equa_text)));
		XSetBackground(XtDisplay(Equa_text), gc, WhitePixelOfScreen(XtScreen(Equa_text)));
	} /* fin du if */

	XtVaGetValues(Top_Level_Equation,
		      XmNwidth, &largeur,
		      XmNheight, &hauteur,
		      NULL);
		      
	XClearWindow(XtDisplay(Equa_text), XtWindow(Equa_text));

	if (DefaultDepthOfScreen(XtScreen(Equa_text)) > 1 )
		XCopyPlane(XtDisplay(Equa_text), equa_pix, XtWindow(Equa_text),
			   gc,
			   0, 0,
			   equa_width, equa_height,
			   (largeur/2 - equa_width/2),
			   (hauteur/2 - equa_height/2), 1L);
	else
		XCopyArea(XtDisplay(Equa_text), equa_pix, XtWindow(Equa_text),
			   gc,
			   0, 0,
			   equa_width, equa_height,
			   (largeur/2 - equa_width/2),
			   (hauteur/2 - equa_height/2));

/*	XFreePixmap(equa_pix);*/
}

void callback_Equation_Activ(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	browse_manual(XNBC_CBM_EQ);
}

#if 0

void callback_Equation_Activ(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	char	equa_file[256];

#if DEBUG
	printf("dans callback_Equation_Activ avec %d\n",cbs->value);
#endif

	strcat(equa_file,help_dir);

	if(set_g_Na)
	{
		strcat(equa_file,"equa_Na.xbm");
	} /* fin du if */
	if(set_g_Nap)
	{
		strcat(equa_file,"equa_Nap.xbm");
	} /* fin du if */
	if(set_g_K)
	{
		strcat(equa_file,"equa_K.xbm");
	} /* fin du if */
	if(set_g_A)
	{
		strcat(equa_file,"equa_A.xbm");
	} /* fin du if */
	if(set_g_M)
	{
		strcat(equa_file,"equa_M.xbm");
	} /* fin du if */
	if(set_g_C)
	{
		strcat(equa_file,"equa_C.xbm");
	} /* fin du if */
	if(set_g_H)
	{
		strcat(equa_file,"equa_H.xbm");
	} /* fin du if */
	if(set_g_ahp)
	{
		strcat(equa_file,"equa_ahp.xbm");
	} /* fin du if */
	if(set_g_Ca)
	{
		strcat(equa_file,"equa_Cahva.xbm");
	} /* fin du if */
	if(set_g_Cab)
	{
		strcat(equa_file,"equa_Calva.xbm");
	} /* fin du if */
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
/* prepare a file equa_New.xbm (for example using xv) from a LaTeX file */
/* compile the LaTeX, obtain a dvi file, with dvips, obtain a PostScript file, */
/* visualize it with ghostview, and grab it using xv. Save as a xbm file */ 
  
	if(set_g_New)
	{
		strcat(equa_file,"equa_New.xbm");
	} /* fin du if */
#endif
	if(set_g_NMDA)
	{
		strcat(equa_file,"equa_NMDA.xbm");
	} /* fin du if */
	if (set_g_Syn_pos)
	{
		strcat(equa_file,"equa_Syn_pos.xbm");
	} /* fin du if */
	if(set_g_Syn_neg)
	{
		strcat(equa_file,"equa_Syn_neg.xbm");
	} /* fin du if */

	fabrique_equa_text(equa_file);
	
}
void fermeture_equa_text(Widget w, XtPointer c1, XtPointer c2)
{
	if (flag_equation)
		XtDestroyWidget(Top_Level_Equation);
	flag_equation = 0;
}
#endif

void callback_Vide(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
	return;
}

void callback_V_Na_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
   if (model_type==MICHAELIS_MENTON_MODEL)	
     {
       V_Na = (float) (cbs->value) * .1;
     }
   if (model_type==HH_SIMPLE_MODEL)	  
     {
       V_INa_A = (float) (cbs->value) * .1;
     }
   
   if (model_type==HH_PUMP_MODEL)	
     {
     
     }

   (*calcul_neuron)();
   (*draw_neuron)(0);
   courbes_m_h();
   draw_M_H_TAU_graph();
}
void callback_V_Na_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
   if (model_type==MICHAELIS_MENTON_MODEL)	
     {
       V_Na = (float) (cbs->value) * .1;
     }
   if (model_type==HH_SIMPLE_MODEL)	  
     {
       V_INa_B = (float) (cbs->value) * .1;
     }
   
   if (model_type==HH_PUMP_MODEL)	
     {
     
     }

   (*calcul_neuron)();
   (*draw_neuron)(0);
   courbes_m_h();
   draw_M_H_TAU_graph();
}
void callback_A_Na_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
   if (model_type==MICHAELIS_MENTON_MODEL)	
     {
       A_Na = (float) (cbs->value) * .001;
     }
   if (model_type==HH_SIMPLE_MODEL)	  
     {
       A_INa_A = (float) (cbs->value) * .001;
     }
   
   if (model_type==HH_PUMP_MODEL)	
     {
     
     }

   (*calcul_neuron)();
   (*draw_neuron)(0);
   courbes_m_h();
   draw_M_H_TAU_graph();
}
void callback_A_Na_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
   if (model_type==MICHAELIS_MENTON_MODEL)	
     {
       A_Na = (float) (cbs->value) * .001;
     }
   if (model_type==HH_SIMPLE_MODEL)	  
     {
       A_INa_B = (float) (cbs->value) * .001;
     }
   
   if (model_type==HH_PUMP_MODEL)	
     {
     
     }

   (*calcul_neuron)();
   (*draw_neuron)(0);
   courbes_m_h();
   draw_M_H_TAU_graph();
}
void callback_Pow_Na_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
   if (model_type==MICHAELIS_MENTON_MODEL)	
     {
       Pow_Na = (float) (cbs->value);
     }
   if (model_type==HH_SIMPLE_MODEL)	  
     {
       Pow_INa_A = (float) (cbs->value);
     }
   
   if (model_type==HH_PUMP_MODEL)	
     {
     
     }

   (*calcul_neuron)();
   (*draw_neuron)(0);
   courbes_m_h();
   draw_M_H_TAU_graph();
}
void callback_Pow_Na_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
   if (model_type==MICHAELIS_MENTON_MODEL)	
     {
       Pow_Na = (float) (cbs->value);
     }
   if (model_type==HH_SIMPLE_MODEL)	  
     {
       Pow_INa_B = (float) (cbs->value);
     }
   
   if (model_type==HH_PUMP_MODEL)	
     {
     
     }

   (*calcul_neuron)();
   (*draw_neuron)(0);
   courbes_m_h();
   draw_M_H_TAU_graph();
}

void callback_Tau_Na_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{

  Tau_INa_B = (float) (cbs->value);
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}

void callback_Tau_Na_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{

  Tau_INa_A = (float) (cbs->value);
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}




void callback_V_K_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  V_K = (float) (cbs->value) * .1;
  
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_A_K_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  A_K = (float) (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Pow_K_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Pow_K = (float) (cbs->value);
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}




void callback_V_Ca_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  V_Ca = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_A_Ca_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  A_Ca = (float) (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Pow_Ca_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Pow_Ca = (float) (cbs->value);
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Tau_Ca_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Tau_Ca = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}




void callback_V_Ia_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  V_Ia_A = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_A_Ia_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  A_Ia_A = (float) (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Pow_Ia_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Pow_Ia_A = (float) (cbs->value);
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_V_Ia_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  V_Ia_B = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_A_Ia_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  A_Ia_B = (float) (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Pow_Ia_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Pow_Ia_B = (float) (cbs->value);
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Tau_Ia_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{

  Tau_Ia_B = (float) (cbs->value);
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
void callback_V_INew_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  V_INew_A = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_A_INew_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  A_INew_A = (float) (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Pow_INew_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Pow_INew_A = (float) (cbs->value);
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_V_INew_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  V_INew_B = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_A_INew_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  A_INew_B = (float) (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Pow_INew_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Pow_INew_B = (float) (cbs->value);
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Tau_INew_B(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Tau_INew_B = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Tau_INew_Lambda(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Tau_INew_Lambda = (float) (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
/*--------   End of ADD_CURRENT   -------*/
#endif

void callback_V_Ic_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  V_Ic = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_A_Ic_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  A_Ic = (float) (cbs->value) * .01;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_V_Im_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  V_Im = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_A_Im_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  A_Im = (float) (cbs->value) * .01;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_V_Ih_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  V_Ih = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_A_Ih_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  A_Ih = (float) (cbs->value) * .01;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Lambda_Ik_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  lambda_Ik = (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Lambda_Ic_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  lambda_Ic = (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Lambda_Im_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  lambda_Im = (cbs->value) * .0001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Lambda_Ih_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  lambda_Ih = (cbs->value) * .0001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_V_Inap_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  V_Inap = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_A_Inap_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  A_Inap = (float) (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Lambda_Inap_A(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  lambda_Inap = (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Vm_Icab(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Vm_Icab = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Am_Icab(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Am_Icab = (float) (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Pow_m_cab(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Pow_m_cab = (float) (cbs->value);
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Tau_m_cab(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  tau_m_cab = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Vh_Icab(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Vh_Icab = (float) (cbs->value) * .1;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Ah_Icab(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  Ah_Icab = (float) (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Lambda_m_Icab(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  lambda_Icab = (cbs->value) * .0001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}
void callback_Lambda_h_Icab(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  lambda_Icab = (cbs->value) * .0001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
  courbes_m_h();
  draw_M_H_TAU_graph();
}

/* ------------- Equilibrium ------------*/
void callback_Pos_Rev_Pot(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  rev_pot_pos = (float) (cbs->value) * .01;
  (*calcul_neuron)();
  (*draw_neuron)(0);
}
void callback_Neg_Rev_Pot(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  rev_pot_neg = (float) (cbs->value) * .01;
  (*calcul_neuron)();
  (*draw_neuron)(0);
}
void callback_Spike_Detect(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  spike_slope = (float) (cbs->value) * .01;
  (*calcul_neuron)();
  (*draw_neuron)(0);
}
void callback_K_rest(Widget w, XtPointer c1, DeXinputCallbackStruct *cbs)
{
  K_rest = (float) (cbs->value) * .001;
  (*calcul_neuron)();
  (*draw_neuron)(0);
}
/* ------------- NMDA ------------*/
void callback_Nb_NMDA(Widget w, XtPointer c, DeXinputCallbackStruct *cbs)
{
  int	n,i;
  Arg	warg,
  wargs[10];
  XmString	string1;
  
  n = cbs->value;
  if (n <= 0  ) return;
  
  if (n != nb_connexions_NMDA)
    {
      nb_connexions_NMDA = n;
      
      /*-------- allocation de la memoire ---------*/
      realloc_mem_tab_NMDA( nb_connexions_NMDA, 0 );
      
      for (i = 0; i < nb_connexions_NMDA; i++)
	{
	  tab_NMDA[i].weight = tab_NMDA[n].t_arrivee = 0;
	}
      
      (*calcul_neuron)();
      (*draw_neuron)(0);
    }
  
  flag_button_NMDA = 1; 
  XtDestroyWidget(Top_Level_NMDA);
  flag_NMDA=0;
  
  fabrique_form_NMDA();
} 

void callback_Weight_NMDA(Widget w, XtPointer num, DeXinputCallbackStruct *cbs)
{
  int  i;
  Arg  wargs[2];
  
  i= (int)num;

  if ((cbs->value) <= 0)
		return;
  
  tab_NMDA[i].weight = (float) (cbs->value) / 100.;
  sprintf(buffer1,"%d connection Weight (%.2fmv)", (int)(i+1), (float)tab_NMDA[i].weight);
  XtSetArg(wargs[0],XmNlabelString, buffer1);
  XtSetValues(DeXInput_Buttons_NMDA[i],wargs,1);      
  
  (*calcul_neuron)();
  (*draw_neuron)(0);
} 

void callback_Time_NMDA(Widget w, XtPointer num, XmScaleCallbackStruct *cbs)
{
  int  i;
  Arg  wargs[2];
  XmString  titre;
  
  i = (int)num;
  
  tab_NMDA[i].t_arrivee = (float ) (cbs->value)*duree_simul/100.;
  
  sprintf(buffer,"%d Time arrival in %%  (%.2fms)", (int)(i+1), (float)tab_NMDA[i].t_arrivee);
  titre = XmStringCreate (buffer, XmSTRING_DEFAULT_CHARSET); 
  
  XtSetArg(wargs[0],XmNtitleString, titre);
  XtSetValues(Scale_Buttons_NMDA[i],wargs,1);      
 
  (*calcul_neuron)();
  (*draw_neuron)(0);
}

void callback_diametre(Widget w, XtPointer c, DeXinputCallbackStruct *cbs)
{
	float	surface_avant;
	
	surface_avant = 4. * PI * (0.5 * 20. * 1e-4) * (0.5 * 20. * 1e-4);
	if ((cbs->value) <= 0)
		return;
	diametre = (float) (cbs->value);
	surface = 4. * PI * (0.5 * diametre * 1e-4) * (0.5 * diametre * 1e-4);
	surface_normalisee = surface / surface_avant;
/*
	capacite = capacite * surface / surface_avant;
	g_Na = g_Na * surface / surface_avant;
	g_Ca = g_Ca * surface / surface_avant;
	g_A = g_A * surface / surface_avant;
	g_ahp = g_ahp * surface / surface_avant;
	g_K = g_K * surface / surface_avant;
	g_M = g_M * surface / surface_avant;
	g_C = g_C * surface / surface_avant;
	g_fuite = g_fuite * surface / surface_avant;
*/
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_holding_potential(Widget w, XtPointer c, DeXinputCallbackStruct *cbs)
{
	clamp_pot = (float) (cbs->value) / 100.;
	(*calcul_neuron)();
	(*draw_neuron)(0);
} 
void callback_command_potential(Widget w, XtPointer c, DeXinputCallbackStruct *cbs)
{
	input_volt = (float) (cbs->value) / 100.;
	(*calcul_neuron)();
	(*draw_neuron)(0);
}
void callback_clamp(Widget w, int n, XmToggleButtonCallbackStruct *cbs)
{
	if (n == 0)
		voltage_clamp = FALSE;
	else
		voltage_clamp = TRUE;
	(*calcul_neuron)();
	(*draw_neuron)(0);
} 


void callback_activ(Widget w, XtPointer c1, XtPointer c2)
{

  if (set_g_NMDA)
    fabrique_form_NMDA();
  else if (set_g_Syn_neg || set_g_Syn_pos)
    fabrique_scrolled_window_PSP();
  else
    fabrique_scrolled_window_activ();
}
/*--------------recurrent window -------------------*/

void callback_Delai_recurrent(Widget w, XtPointer c, DeXinputCallbackStruct *cbs)
{
  int  j;
 
  delai_recurrence = (float) (cbs->value) / 100.;

  if (!flag_Tms_Input) 
    {
      taille_tab_syn = nb_connexions;
      for (j=0;j<nb_connexions;j++)
	{
	  tab_syn[j].weight = tab_transitoire[j].weight;
	  tab_syn[j].t_arrivee = tab_transitoire[j].t_arrivee;
	}
    }
  else 
    {
      readTmsInput();     
      taille_tab_syn = number_of_event;
      printf("taille_tab_syn:%d\n",taille_tab_syn);     
    }

  (*calcul_neuron)();
  (*draw_neuron)(0);
} 

void callback_Ponderation_recurrent(Widget w, XtPointer c, DeXinputCallbackStruct *cbs)
{
  int  j;
 
  ponderation_recurrence = (float) (cbs->value) / 100.;

  if (!flag_Tms_Input) 
    {
      taille_tab_syn = nb_connexions;
      for (j=0;j<nb_connexions;j++)
	{
	  tab_syn[j].weight = tab_transitoire[j].weight;
	  tab_syn[j].t_arrivee = tab_transitoire[j].t_arrivee;
	}
    }
  else 
    {
      readTmsInput();      
      taille_tab_syn = number_of_event;
      printf("taille_tab_syn:%d\n",taille_tab_syn);     
    }

  (*calcul_neuron)();
  (*draw_neuron)(0);
} 

/*--------------------- L E S  C L O S E S ------------------------*/

void callback_close_recurrent(Widget w, XtPointer c1, XtPointer c2)
{
  XtDestroyWidget(Top_Level_recurrent);
  flag_recurrentEPSP = 0;
}

void callback_close(Widget w, XtPointer c1, XtPointer c2)
{
  XtDestroyWidget(Top_Level_Simul);
  flag_simulation = 0;
  flag_button = 0;
}
void callback_close_NMDA(Widget w, XtPointer c1, XtPointer c2)
{
	if (flag_equation)
	{
		XtDestroyWidget(Top_Level_Equation);
		flag_equation = 0;
	} /* fin du if */
	XtDestroyWidget(Top_Level_NMDA);
	flag_NMDA = set_g_NMDA = 0;
}

void callback_close_PSP(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_PSP);
	flag_PSP = 0;
}

void callback_close_Equilibrium(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_Equilibrium);
	flag_equilibrium = 0;
}

void callback_close_Transmitors(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_Transmitors);
	flag_transmitors = 0;
}

void callback_close_Echelles(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_Echelles);
	flag_echelles = 0;
}

void callback_close_Activ(Widget w, XtPointer c1, XtPointer c2)
{
	if (flag_equation)
	{
		XtDestroyWidget(Top_Level_Equation);
		flag_equation = 0;
	}
	if (flag_activ)
	{
		XtDestroyWidget(Top_Level_Activ);
		flag_activ = 0;
	}
}

void callback_close_Init(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_Init);
	flag_init = 0;
}

void callback_close_XY(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_XY);
	flag_XY = 0;
}

void callback_close_M_H_TAU(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_M_H_TAU);
	flag_M_H_TAU = 0;
}

void callback_close_RB(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_RB);
	flag_RB = 0;
}

void callback_close_DB(Widget w, XtPointer c1, XtPointer c2)
{
	XtDestroyWidget(Top_Level_DB);
	flag_DB = 0;
}

void callback_print_M_H_TAU(Widget w, XtPointer c1, XtPointer c2)
{
	print_M_H_TAU_graph();
}

void callback_print_XY(Widget w, XtPointer c1, XtPointer c2)
{
	print_XY_graph();
}

void callback_draw_RB(Widget w, XtPointer c1, XtPointer c2)
{
	draw_X_Y_graph();
}

void callback_draw_Curves(Widget w, XtPointer c1, XtPointer c2)
{
	courbes_m_h();
	draw_M_H_TAU_graph();
} /* fin du void */

void echo_file(Widget w, char *chaine, XmFileSelectionBoxCallbackStruct *cbs)
/* renvoie le nom du fichier selectionne avec la
   FileSelectionBox dans la chaine de caracteres chaine */
{
	char	*pc,
		buffer[256];
	int	n;
	Arg	wargs[10];
	XmString	string1;
	XmString	string2;
	
	if (!XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &chaine))
		return;

#if 0
	if (!chaine[0])
	{
		strcpy(chaine,"G_neuron");
	} /* fin du if */
	
	if (pc = strrchr(chaine,'.'))
	{
		*pc = 0;	/* supprime l'extension */
	} /* fin du if */
	
	strcat(chaine,".G_unit");
#endif

	strcpy(nom_fichier_neuron, chaine);
	
	switch(choix_file)
	{
		case 0:
			if ((p_neur = fopen(nom_fichier_neuron, "r")) == NULL)
			{
				sprintf(buffer,"ouverture du fichier %s impossible\n", nom_fichier_neuron);
				string1 = XmStringCreateSimple(buffer);
				string2 = XmStringCreateSimple("File problem!");

				n = 0;
				XtSetArg(wargs[n], XmNx, 200);n++;
				XtSetArg(wargs[n], XmNy, 400);n++;
				XtSetArg(wargs[n], XmNmessageString, string1);n++;
				XtSetArg(wargs[n], XmNdialogTitle, string2);n++;
				
				Zero_Time_Step = XmCreateWarningDialog(Form_G,
								       "zero_time_step",wargs,n);
				XmStringFree(string1);
				XtManageChild(Zero_Time_Step);
				return;
			}
			readNeuron(p_neur);
			fclose(p_neur);
			break;

		case 1:
			break;

		case 2:
			if ((p_neur = fopen(nom_fichier_neuron, "w")) == NULL)
			{
				sprintf(buffer,"ouverture du fichier %s impossible\n", nom_fichier_neuron);
				string1 = XmStringCreateSimple(buffer);
				string2 = XmStringCreateSimple("File problem!");

				n = 0;
				XtSetArg(wargs[n], XmNx, 200);n++;
				XtSetArg(wargs[n], XmNy, 400);n++;
				XtSetArg(wargs[n], XmNmessageString, string1);n++;
				XtSetArg(wargs[n], XmNdialogTitle, string2);n++;				

				Zero_Time_Step = XmCreateWarningDialog(Form_G,
								       "zero_time_step",wargs,n);
				XmStringFree(string1);
				XtManageChild(Zero_Time_Step);
				return;
			}
			writeNeuron(p_neur);
			fclose(p_neur);
			break;

		case 3:
			break;
		case 4:
			break;
	} 
} 





void echo_file_tms_out(Widget w, char *chaine, XmFileSelectionBoxCallbackStruct *cbs)
/* renvoie le nom du fichier selectionne avec la
   FileSelectionBox dans la chaine de caracteres chaine */
{
	char	*pc,
		buffer[256];
	int	n;
	Arg	wargs[10];
	XmString	string1;
	XmString	string2;
	
	if (!XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &chaine))
		return;

	if (!chaine[0])
	{
		strcpy(chaine,"G_neuron");
	} /* fin du if */
	if (pc = strrchr(chaine,'.'))
	{
		*pc = 0;	/* supprime l'extension */
	} /* fin du if */

	strcat(chaine,".tms");
	strcpy(nom_fichier_tms_output, chaine);
	flag_OutputFile=1;
	if (flag_InputFile && !strcmp(nom_fichier_tms_output,nom_fichier_tms_input))
	  {
	    sprintf(buffer,"warning, InputFile is equal to OutputFile!");
	    string1 = XmStringCreateSimple(buffer);
	    string2 = XmStringCreateSimple("File problem!");

	    n = 0;
	    XtSetArg(wargs[n], XmNx, 200);n++;
	    XtSetArg(wargs[n], XmNy, 400);n++;
	    XtSetArg(wargs[n], XmNdialogTitle, string2);n++;
	    XtSetArg(wargs[n], XmNmessageString, string1);n++;
	    
	    Zero_Time_Step_Tms = XmCreateWarningDialog(Form_G,
						       "zero_time_step_tms",wargs,n);
	    XmStringFree(string1);
	    XtManageChild(Zero_Time_Step_Tms);
	    return;
	  }
	
	if ((p_tms = fopen(nom_fichier_tms_output, "w")) == NULL)
	  {
	    sprintf(buffer,"ouverture du fichier %s impossible\n", nom_fichier_tms_output);
	    string1 = XmStringCreateSimple(buffer);
	    string2 = XmStringCreateSimple("File problem!");

	    n = 0;
	    XtSetArg(wargs[n], XmNx, 200);n++;
	    XtSetArg(wargs[n], XmNy, 400);n++;
	    XtSetArg(wargs[n], XmNmessageString, string1);n++;
	    XtSetArg(wargs[n], XmNdialogTitle, string2);n++;
	    
	    Zero_Time_Step_Tms = XmCreateWarningDialog(Form_G,
						       "zero_time_step_tms",wargs,n);
	    XmStringFree(string1);
	    XtManageChild(Zero_Time_Step_Tms);
	    return;
	  }
	writeTmsOutput(p_tms);
	fclose(p_tms);
	flag_OutputSelectionBox=0;
} 

void echo_file_tms_in(Widget w, char *chaine, XmFileSelectionBoxCallbackStruct *cbs)
/* renvoie le nom du fichier selectionne avec la
   FileSelectionBox dans la chaine de caracteres chaine */
{
	char	*pc,
		buffer[256];
	int	n;
	Arg	wargs[10];
	XmString	string1;
	XmString	string2;
	
	if (!XmStringGetLtoR(cbs->value, XmSTRING_DEFAULT_CHARSET, &chaine))
		return;

	if (!chaine[0])
	{
		strcpy(chaine,"G_neuron");
	} /* fin du if */
	if (pc = strrchr(chaine,'.'))
	{
		*pc = 0;	/* supprime l'extension */
	} /* fin du if */

	strcat(chaine,".tms");

	strcpy(nom_fichier_tms_input, chaine);
	flag_InputFile=1;
	if (flag_OutputFile && !strcmp(nom_fichier_tms_output,nom_fichier_tms_input))
	  {
	    sprintf(buffer,"warning, InputFile is equal to OutputFile!");
	    string1 = XmStringCreateSimple(buffer);
	    string2 = XmStringCreateSimple("File problem!");

	    n = 0;
	    XtSetArg(wargs[n], XmNx, 200);n++;
	    XtSetArg(wargs[n], XmNy, 400);n++;
	    XtSetArg(wargs[n], XmNmessageString, string1);n++;
	    XtSetArg(wargs[n], XmNdialogTitle, string2);n++;
	    
	    Zero_Time_Step_Tms = XmCreateWarningDialog(Form_G,
						       "zero_time_step_tms",wargs,n);
	    XmStringFree(string1);
	    XtManageChild(Zero_Time_Step_Tms);
	    return;
	  }

	if ((p_tms = fopen(nom_fichier_tms_input, "r")) == NULL)
	  {
	    printf("(nom_fichier: %s \t->%d\n",nom_fichier_tms_input,p_tms);

	    sprintf(buffer,"ouverture du fichier %s impossible\n", nom_fichier_tms_input);
	    string1 = XmStringCreateSimple(buffer);
	    string2 = XmStringCreateSimple("File problem!");

	    n = 0;
	    XtSetArg(wargs[n], XmNx, 200);n++;
	    XtSetArg(wargs[n], XmNy, 400);n++;
	    XtSetArg(wargs[n], XmNmessageString, string1);n++;
	    XtSetArg(wargs[n], XmNdialogTitle, string2);n++;
	    
	    Zero_Time_Step_Tms = XmCreateErrorDialog(Form_G,"zero_time_step_tms",wargs,n);
	    XmStringFree(string1);
	    XtManageChild(Zero_Time_Step_Tms);
	    return;

	  }

	fclose(p_tms);

	flag_InputSelectionBox=0;	

	fabrique_form_simulation();
	
} 




void retour_TTX(Widget w, XtPointer c1, XtPointer c2)
{
	switch ( (int)c1 )
	{
		case 0:
			drug_TTX = False;
			break;
		case 1:
			drug_TTX = True;
			break;
	} /* fin du switch */
	(*calcul_neuron)();
	(*draw_neuron)(0);
} 
void retour_TEA(Widget w, XtPointer c1, XtPointer c2)
{
	switch ( (int) c1)
	{
		case 0:
			drug_TEA = False;
			break;
		case 1:
			drug_TEA = True;
			break;
	} /* fin du switch */
	(*calcul_neuron)();
	(*draw_neuron)(0);
} 


