/*
 *  G_interface2.c
 *  second part of the interface
 */

#undef MAIN


#include "G_neuron.h"
#include "G_interface.h"
#include "G_reference.h"
#include "G_synap.h"

XmString  result;
int       n;
Arg       wargs[10];

Pixmap	equa_bits, equa_pix;
GC	eq_gc;
unsigned int equa_width, equa_height;

int current_recept;	

REFERENCE  ref1,ref2,ref3;


void fabrique_scrolled_window_equilibrium();
void fabrique_scrolled_window_init();
void fabrique_form_simulation();
void fabrique_form_recurrent_window();
void fabrique_drawing_areas();
void fabrique_XY_area();
void fabrique_radio_box_XY();
void fabrique_drugs_box();
void fabrique_equa_text();
void fabrique_M_H_TAU_area();
void fabrique_Echelles();
extern void reactualise_E_Na_K();


#define	DIAL_WIDTH	230
#define	DIAL_HEIGHT	270




/*--------------------------------------------------------*/
void fabrique_scrolled_window_init()
/*--------------------------------------------------------*/
# if 0
			Top_Level_Init
				|
			Scrolled_Window_Init
				|
			Row_Column_Init
				|
			Widgets DeXInput:
			DeXInput_m_ahp
			DeXInput_m_K
			DeXInput_le_pot
			DeXInput_m_Ca
			DeXInput_Ca_i
			DeXInput_h_A
			Close_Init
# endif
{
	int		n;
	Arg		wargs[20];
	XmString	string1;
	

	if(flag_init != 0)
	{
		XtPopup(Top_Level_Init,XtGrabNone);
		return;
	} 


	/*---------- toplevel pour les potentiels d'equilibre ----------*/


	Top_Level_Init = XtCreateApplicationShell("topainit",
							 topLevelShellWidgetClass,
							 wargs,
							 0);
	XtVaSetValues(Top_Level_Init,
		      XmNtitle, "Initialization of Parameters",
		      XmNx, 430,
		      XmNy, 430,
		      NULL);
	
	/*---- scrolledwindow pour les potentiels d'equilibre ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNwidth,  650);n++;
	XtSetArg(wargs[n], XmNheight, 450);n++;
	XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
	Scrolled_Window_Init = XtCreateManagedWidget("scrolledinit",
							    xmScrolledWindowWidgetClass,
							    Top_Level_Init,
							    wargs, n);
							   
	/* PushButton de fermeture */
	string1 = XmStringCreateSimple("Close");	

	n = 0;
	XtSetArg(wargs[n], XmNx, 260);n++;
	XtSetArg(wargs[n], XmNy, 390);n++;
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNwidth, 100); n++;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_CENTER); n++;
	Close_Init = XtCreateManagedWidget("close_Init",
						  xmPushButtonWidgetClass,
						  Scrolled_Window_Init,
						  wargs, n);
	XmStringFree(string1);

	XtAddCallback(Close_Init, XmNactivateCallback, (XtPointer)callback_close_Init, NULL);

	/*---- container pour les widgets des potentiels d'equilibre ----*/
	n = 0;
	XtSetArg(wargs[n], XmNnumColumns, 4);n++;
	XtSetArg(wargs[n], XmNorientation, XmHORIZONTAL);n++;
	XtSetArg(wargs[n], XmNborderWidth, 0);n++;
	XtSetArg(wargs[n], XmNpacking, XmPACK_COLUMN);n++;
	Row_Collumn_Init = XtCreateManagedWidget("rcInit",
							xmRowColumnWidgetClass,
							Scrolled_Window_Init,
							wargs, n);

	/*---- widgets DeXInput ----*/

	/* 1 m ahp */
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;	
	XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0);n++;
	XtSetArg(wargs[n], DeXNvalue, (int) (m_ahp * 100));n++;
	XtSetArg(wargs[n], DeXNlabelString, "m Iahp");n++;
	DeXInput_m_ahp = XtCreateManagedWidget("mahp",
					       DeXinputWidgetClass,
					       Row_Collumn_Init,
					       wargs, n);
	XtAddCallback(DeXInput_m_ahp, DeXNokCallback, (XtPointer)callback_m_ahp, NULL);
	
	/* 2 m K */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 3);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 160);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (m_K * 1000));
	XtSetArg(wargs[n-1], DeXNlabelString, "m K");
	DeXInput_m_K = XtCreateManagedWidget("mk",
					      DeXinputWidgetClass,
					      Row_Collumn_Init,
					      wargs, n);
	XtAddCallback(DeXInput_m_K, DeXNokCallback, (XtPointer)callback_m_K, NULL);
	
	/* 3 m Ca */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 4);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 10);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (m_Ca * 10000));
	XtSetArg(wargs[n-1], DeXNlabelString, "m Ca");
	DeXInput_m_Ca = XtCreateManagedWidget("mca",
					      DeXinputWidgetClass,
					      Row_Collumn_Init,
					      wargs, n);
	XtAddCallback(DeXInput_m_Ca, DeXNokCallback, (XtPointer)callback_m_Ca, NULL);
		
	/* 4 Ca_i  */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 3);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 10);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (Ca_i * 1000));
	XtSetArg(wargs[n-1], DeXNlabelString, "Ca i");
	DeXInput_Ca_i = XtCreateManagedWidget("cai",
						     DeXinputWidgetClass,
						     Row_Collumn_Init,
						     wargs, n);
	XtAddCallback(DeXInput_Ca_i, DeXNokCallback, (XtPointer)callback_Ca_i, NULL);
	
	/* 5 h A  */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 3);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 50);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (h_A * 1000));
	XtSetArg(wargs[n-1], DeXNlabelString, "h A");
	DeXInput_h_A = XtCreateManagedWidget("ha",
						     DeXinputWidgetClass,
						     Row_Collumn_Init,
						     wargs, n);
	XtAddCallback(DeXInput_h_A, DeXNokCallback, (XtPointer)callback_h_A, NULL);
	
	/* 6 le_potentiel */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 1);
	XtSetArg(wargs[n-3], DeXNdefaultValue, -600);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (le_potentiel * 10));
	XtSetArg(wargs[n-1], DeXNlabelString, "Mb Potential");
	DeXInput_le_pot = XtCreateManagedWidget("lepotentiel",
					      DeXinputWidgetClass,
					      Row_Collumn_Init,
					      wargs, n);
	XtAddCallback(DeXInput_le_pot, DeXNokCallback, (XtPointer)callback_le_pot, NULL);
	
	/* 7 m Nap */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 3);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 0);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (m_Nap * 1000));
	XtSetArg(wargs[n-1], DeXNlabelString, "m Na pers");
	DeXInput_m_Nap = XtCreateManagedWidget("mnap",
						     DeXinputWidgetClass,
						     Row_Collumn_Init,
						     wargs, n);
	XtAddCallback(DeXInput_m_Nap, DeXNokCallback, (XtPointer)callback_m_Nap, NULL);
	
	/* 8 m Cab */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 3);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 0);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (m_Cab * 1000));
	XtSetArg(wargs[n-1], DeXNlabelString, "m Ca LVA");
	DeXInput_m_Cab = XtCreateManagedWidget("mcab",
						     DeXinputWidgetClass,
						     Row_Collumn_Init,
						     wargs, n);
	XtAddCallback(DeXInput_m_Cab, DeXNokCallback, (XtPointer)callback_m_Cab, NULL);

	/* 9 h Cab */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 3);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 0);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (h_Cab * 1000));
	XtSetArg(wargs[n-1], DeXNlabelString, "h Ca LVA");
	DeXInput_h_Cab = XtCreateManagedWidget("hcab",
						     DeXinputWidgetClass,
						     Row_Collumn_Init,
						     wargs, n);
	XtAddCallback(DeXInput_h_Cab, DeXNokCallback, (XtPointer)callback_h_Cab, NULL);
	
	/* 10 h Mb Capacity */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 4);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 10000L);
	XtSetArg(wargs[n-2], DeXNvalue, (long) (capacite * 10000));
	XtSetArg(wargs[n-1], DeXNlabelString, "Mb Capacity (uF/cm2)");
	DeXInput_mb_Capacity = XtCreateManagedWidget("cm",
						     DeXinputWidgetClass,
						     Row_Collumn_Init,
						     wargs, n);
	XtAddCallback(DeXInput_mb_Capacity, DeXNokCallback, (XtPointer)callback_mb_capacity, NULL);
	
	/* 1 m h */
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 3);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0);n++;
	XtSetArg(wargs[n], DeXNvalue, (int) (m_Ih * 1000));n++;
	XtSetArg(wargs[n], DeXNlabelString, "m Ih");n++;
	DeXInput_m_Ih = XtCreateManagedWidget("mih",
					       DeXinputWidgetClass,
					       Row_Collumn_Init,
					       wargs, n);
	XtAddCallback(DeXInput_m_Ih, DeXNokCallback, (XtPointer)callback_m_Ih, NULL);

#if 0	
		/* 12 K_ext */
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 400);n++;
	XtSetArg(wargs[n], DeXNvalue, (int) (K_ext * 100));n++;
	XtSetArg(wargs[n], DeXNlabelString, "[K] extracellular (mM)");n++;
	DeXInput_K_ext = XtCreateManagedWidget("Kext",
					       DeXinputWidgetClass,
					       Row_Collumn_Init,
					       wargs, n);
	XtAddCallback(DeXInput_K_ext, DeXNokCallback, (XtPointer)callback_K_ext, NULL);
#endif

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/

	/* 5 m New  */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 3);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 50);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (m_New * 1000));
	XtSetArg(wargs[n-1], DeXNlabelString, "m New");
	DeXInput_m_New = XtCreateManagedWidget("mNew",
						     DeXinputWidgetClass,
						     Row_Collumn_Init,
						     wargs, n);
	XtAddCallback(DeXInput_m_New, DeXNokCallback, (XtPointer)callback_m_New, NULL);

	/* 5 h New  */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 3);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 50);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (h_New * 1000));
	XtSetArg(wargs[n-1], DeXNlabelString, "h New");
	DeXInput_h_New = XtCreateManagedWidget("hNew",
						     DeXinputWidgetClass,
						     Row_Collumn_Init,
						     wargs, n);
	XtAddCallback(DeXInput_h_New, DeXNokCallback, (XtPointer)callback_h_New, NULL);
#endif

	XtAddCallback(Top_Level_Init, XmNdestroyCallback, fermeture_Init, NULL);
	
	XtManageChild(Scrolled_Window_Init);
	XtRealizeWidget(Top_Level_Init);
	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_Init), palette);

	flag_init = 1;
}

/*--------------------------------------------------------*/
	void fabrique_scrolled_window_equilibrium()
/*--------------------------------------------------------*/
# if 0
			Top_Level_Equilibrium
				|
			Scrolled_Window_Equilibrium
				|
			Row_Column_Equilibrium
				|
			Widgets DeXInput:
                        DeXInput_Temp
                        DeXInput_Na_ext
                        DeXInput_Na_int
                        DeXInput_K_ext
                        DeXInput_K_int
                        DeXInput_Cl_ext
                        DeXInput_Cl_int
/*-----------------------------------------------------------*/

			DeXInput_E_Ca
			DeXInput_E_H
			DeXInput_Tau_Cai_D
			DeXInput_E_Leak
			DeXInput_Pos_Rev_Pot
			DeXInput_Neg_Rev_Pot
			DeXInput_Spike_Detect
			DeXInput_Ca_Influx
			DeXInput_Ca_Removal
			DeXInput_Ca_Kd
			DeXInput_K_Ca_Kd
			DeXInput_Ca_Kc
			Close_Equilibrium
# endif
{
	int		n;
	Arg		wargs[20];
	XmString	string1;
	

	if(flag_equilibrium != 0)
	{
		XtPopup(Top_Level_Equilibrium,XtGrabNone);
		return;
	} 


	/*---------- toplevel pour les potentiels d'equilibre ----------*/


	Top_Level_Equilibrium = XtCreateApplicationShell("topequilibrium",
							 topLevelShellWidgetClass,
							 wargs,
							 0);
	XtVaSetValues(Top_Level_Equilibrium,
		      XmNtitle, "Equilibrium Parameters",
		      XmNx, 700,
		      XmNy, 555,
		      NULL);
	
	/*---- scrolledwindow pour les potentiels d'equilibre ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNwidth, 555);n++;
	XtSetArg(wargs[n], XmNheight, 840);n++;
	XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
	Scrolled_Window_Equilibrium = XtCreateManagedWidget("scrolledequilibrium",
							    xmScrolledWindowWidgetClass,
							    Top_Level_Equilibrium,
							    wargs, n);
							   
	/* PushButton de fermeture */
	string1 = XmStringCreateSimple("Close");	

	n = 0;
	XtSetArg(wargs[n], XmNx, 200);n++;
	XtSetArg(wargs[n], XmNy, 780);n++;
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNwidth, 100); n++;
	XtSetArg(wargs[n], XmNlabelString, string1); n++;
	XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_CENTER); n++;
	Close_Equilibrium = XtCreateManagedWidget("close_Equilibrium",
						  xmPushButtonWidgetClass,
						  Scrolled_Window_Equilibrium,
						  wargs, n);
	XmStringFree(string1);

	XtAddCallback(Close_Equilibrium, XmNactivateCallback, (XtPointer)callback_close_Equilibrium, NULL);

	/*---- container pour les widgets des potentiels d'equilibre ----*/
	n = 0;
	XtSetArg(wargs[n], XmNnumColumns, 2);n++;
	XtSetArg(wargs[n], XmNorientation, XmVERTICAL);n++;
	XtSetArg(wargs[n], XmNborderWidth, 0);n++;
	XtSetArg(wargs[n], XmNpacking, XmPACK_COLUMN);n++;
	Row_Collumn_Equilibrium = XtCreateManagedWidget("rcEquilibrium",
							xmRowColumnWidgetClass,
							Scrolled_Window_Equilibrium,
							wargs, n);

	/*---- widgets DeXInput ----*/
	
	/* 1 Temperature  */
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNwidth,250);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 2000);n++;
	XtSetArg(wargs[n], DeXNvalue, (int) (Temp * 100));n++;
	XtSetArg(wargs[n], DeXNlabelString, "Temperature (DegC)");n++;
	DeXInput_Temp = XtCreateManagedWidget("Temp",
					       DeXinputWidgetClass,
					       Row_Collumn_Equilibrium,
					       wargs, n);
	XtAddCallback(DeXInput_Temp, DeXNokCallback, (XtPointer)callback_Temp, NULL);
	
	
	
	/*   Na ext */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 14000);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (Na_ext * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "[Na]ext (mmol/l)");
	DeXInput_Na_ext = XtCreateManagedWidget("naext",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_Na_ext, DeXNokCallback, (XtPointer)callback_Na_ext, NULL);
	
	/* 2 K ext */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 500);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (K_ext * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "[K]ext (mmol/l)");
	DeXInput_K_ext = XtCreateManagedWidget("kext",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_K_ext, DeXNokCallback, (XtPointer)callback_K_ext, NULL);
	
	/*   Cl  ext */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 12500);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (Cl_ext * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "[Cl]ext (mmol/l)");
	DeXInput_Cl_ext = XtCreateManagedWidget("clext",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_Na_ext, DeXNokCallback, (XtPointer)callback_Cl_ext, NULL);
	
	
	/* 3 E Ca */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 12400);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (E_Ca * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "E Ca (mV)");
	DeXInput_E_Ca = XtCreateManagedWidget("eca",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_E_Ca, DeXNokCallback, (XtPointer)callback_E_Ca, NULL);

	/* 3bis E H */
/*
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, -4300);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (E_H * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "E H (mV)");
	DeXInput_E_H = XtCreateManagedWidget("eh",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_E_H, DeXNokCallback, (XtPointer)callback_E_H, NULL);
*/	

	/* 4 Ca Influx*/
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 5);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 15);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (Ca_Influx * 100000));
	XtSetArg(wargs[n-1], DeXNlabelString, "Ca Influx (uM/ms)");
	DeXInput_Ca_Influx = XtCreateManagedWidget("cainflux",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_Ca_Influx, DeXNokCallback, (XtPointer)callback_Ca_Influx, NULL);
	
	
	/* 5 Ca Kd*/
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 100);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (Ca_Kd * 100 ));
	XtSetArg(wargs[n-1], DeXNlabelString, "Ca Kd (uM)");
	DeXInput_Ca_Kd = XtCreateManagedWidget("cakd",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_Ca_Kd, DeXNokCallback, (XtPointer)callback_Ca_Kd, NULL);
		
	
	/* 6' K Ca Kd*/
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 50);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (K_Ca_Kd * 100 ));
	XtSetArg(wargs[n-1], DeXNlabelString, "Ca Kd for Ik(uM)");
	DeXInput_K_Ca_Kd = XtCreateManagedWidget("kcakd",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_K_Ca_Kd, DeXNokCallback, (XtPointer)callback_K_Ca_Kd, NULL);
	
	/*  Affichage du resultat de E Na et E K */

	   reactualise_E_Na_K();
		       
	   sprintf(buffer,"ENa: %4.2fmV EK: %4.2fmV Em: %5.2fmV ",E_Na,E_K,E_Goldman);
       result = XmStringCreateSimple(buffer);
       XtSetArg(wargs[n-1], DeXNlabelString,result);
       DeXOutput_Res_E_Na_K = XtCreateManagedWidget("resenak",
					      xmLabelWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
       XmStringFree(result);
	
	
	/* 3 Na int */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 1400);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (Na_int * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "[Na]int (mmol/l)");
	DeXInput_Na_int = XtCreateManagedWidget("naint",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_Na_int, DeXNokCallback, (XtPointer)callback_Na_int, NULL);


	/* 3 K int */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 14000);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (K_int * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "[K]int (mmol/l)");
	DeXInput_K_int = XtCreateManagedWidget("kint",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_K_int, DeXNokCallback, (XtPointer)callback_K_int, NULL);


	/* 3 Cl int */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue,900);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (Cl_int * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "[Cl]int (mmol/l)");
	DeXInput_Cl_int = XtCreateManagedWidget("clint",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_K_int, DeXNokCallback, (XtPointer)callback_Cl_int, NULL);

	
	/* 9 K rest */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 3);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 2500);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (K_rest * 1000));
	XtSetArg(wargs[n-1], DeXNlabelString, "[K] Rest  (mM)");
	DeXInput_K_rest = XtCreateManagedWidget("krest",
					     DeXinputWidgetClass,
					     Row_Collumn_Equilibrium,
					     wargs, n);
	XtAddCallback(DeXInput_K_rest, DeXNokCallback, (XtPointer)callback_K_rest, NULL);

	/* 10 E Leak */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, -5000);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (E_fuite * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "E Cl (mV)");
	DeXInput_E_Leak = XtCreateManagedWidget("eleak",
						DeXinputWidgetClass,
						Row_Collumn_Equilibrium,
						wargs, n);
	XtAddCallback(DeXInput_E_Leak, DeXNokCallback, (XtPointer)callback_E_Leak, NULL);

	/* 11 Ca Removal*/
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 3);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 5);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (Ca_Removal * 1000));
	XtSetArg(wargs[n-1], DeXNlabelString, "Ca Removal (uM/ms)");
	DeXInput_Ca_Removal = XtCreateManagedWidget("caremoval",
					      DeXinputWidgetClass,
					      Row_Collumn_Equilibrium,
					      wargs, n);
	XtAddCallback(DeXInput_Ca_Removal, DeXNokCallback, (XtPointer)callback_Ca_Removal, NULL);
#if 0
	/* 12 Tau Cai d */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 2000);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (tau_decay_Ca * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "Tau Ca i Decay (ms)");
	DeXInput_Tau_Cai_D = XtCreateManagedWidget("taucaid",
						   DeXinputWidgetClass,
						   Row_Collumn_Equilibrium,
						   wargs, n);
	XtAddCallback(DeXInput_Tau_Cai_D, DeXNokCallback, (XtPointer)callback_Tau_Cai_D, NULL);
#endif
	/* 13 Spike Detect */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, 2000);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (spike_slope * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "Spike Detect (mV/ms)");
	DeXInput_Spike_Detect = XtCreateManagedWidget("spikedetect",
						      DeXinputWidgetClass,
						      Row_Collumn_Equilibrium,
						      wargs, n);
	XtAddCallback(DeXInput_Spike_Detect, DeXNokCallback, (XtPointer)callback_Spike_Detect, NULL);						      
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	/*  E New */
	XtSetArg(wargs[n-4], DeXNdecimalPoint, 2);
	XtSetArg(wargs[n-3], DeXNdefaultValue, -7200);
	XtSetArg(wargs[n-2], DeXNvalue, (int) (E_New * 100));
	XtSetArg(wargs[n-1], DeXNlabelString, "E New  (mV)");
	DeXInput_E_New = XtCreateManagedWidget("eNew",
					     DeXinputWidgetClass,
					     Row_Collumn_Equilibrium,
					     wargs, n);
	XtAddCallback(DeXInput_E_New, DeXNokCallback, (XtPointer)callback_E_New, NULL);
#endif

	XtAddCallback(Top_Level_Equilibrium, XmNdestroyCallback, fermeture_Equilibrium, NULL);
	
	XtManageChild(Scrolled_Window_Equilibrium);
	XtRealizeWidget(Top_Level_Equilibrium);
	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_Equilibrium), palette);

	flag_equilibrium = 1;
}

/*------------------------------------------*/
	void fabrique_form_simulation()
/*------------------------------------------*/
# if 0
				   (top_level_simul)
					|
				Dialog_Shell_Simulation
				Form_Simulation	(FormDialog)
					|
				Label_Simulation
				DeXInput_Duree_Simulation
				
				Separator_Simulation
				Label_Stimulation
				DeXInput_Start_Stimulation
				DeXInput_Stimulation_Duration
				Separator_Stimulation
				Label_Clamp
				Radio_Box_Clamp-----------------
				Separator_Clamp			|
				Label_PSP			Toggle_Button_Current
				DeXInput_Number                 Toggle_Button_Voltage
				       |
                                frame_SP
                                Scrolled_Window_Button 
                                Row_Collumn_Button
                                 
                                  ( et une suite de widget )
                                       |
                                Separator_Diametre
				DeXInput_Diametre
				Push_Button_Close
# endif
{
	int		n,i,j,taille,debut, numero_transm, ii;
	Arg		wargs[20];
	XmString	string1, st1,st2,st3;
	String          bufferString;
	char            buffer[30],buffer1[30],titre[256];

	if(flag_simulation)
	{
		XtPopup(Top_Level_Simul,XtGrabNone);
		return;
	} 

	flag_simulation = 1;
	/*---------- toplevel pour les potentiels d'equilibre ----------*/


	Top_Level_Simul = XtCreateApplicationShell("topsimul",
							 topLevelShellWidgetClass,
							 wargs,
							 0);

	
	XtVaSetValues(Top_Level_Simul,
		      XmNtitle, "Experiment and Input PSP Parameters",
		      XmNx, 605,
		      XmNy, 700,
		      NULL);

	
	/*---- form pour les parametres de simulation ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, 700);n++;
	XtSetArg(wargs[n], XmNwidth, 605);n++;
	XtSetArg(wargs[n], XmNfractionBase, 100);n++;
	Form_Simulation = XtCreateManagedWidget("formSimulation",
						xmFormWidgetClass,
						Top_Level_Simul,
						wargs, n);
	XtAddCallback(Form_Simulation, XmNunmapCallback, fermeture_Simulation, NULL);


	/* label clamp */
	string1 = XmStringCreateSimple("Clamp Experiment");	
	n = 0;
	XtSetArg(wargs[n], XmNlabelString, string1);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNleftOffset, 10);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	Label_Clamp = XtCreateManagedWidget("lblclamp",
					    xmLabelGadgetClass,
					    Form_Simulation,
					    wargs, n);
	XmStringFree(string1);	
	
	/* radiobox clamp et ses togglebuttons*/

	n = 0;
	XtSetArg(wargs[n], XmNwidth, 25);n++;
	XtSetArg(wargs[n], XmNheight, 25);n++;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNisHomogeneous, FALSE);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 0);n++;
	XtSetArg(wargs[n], XmNtopWidget, Label_Clamp);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNrightPosition, 98);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNradioAlwaysOne, TRUE);n++;
	XtSetArg(wargs[n], XmNorientation, XmHORIZONTAL);n++;
	XtSetArg(wargs[n], XmNpacking, XmPACK_TIGHT);n++;
	XtSetArg(wargs[n], XmNresizeHeight, TRUE);n++;
	XtSetArg(wargs[n], XmNresizeWidth, TRUE);n++;
	XtSetArg(wargs[n], XmNresizable, TRUE);n++;
	XtSetArg(wargs[n], XmNradioBehavior, TRUE);n++;
	XtSetArg(wargs[n], XmNentryAlignment, XmALIGNMENT_CENTER);n++;
	Radio_Box_Clamp = XmCreateRadioBox(Form_Simulation,
					   "radioboxclamp",
						 wargs, n);
						 
	string1 = XmStringCreateSimple("Current Clamp");	
	n = 0;
	XtSetArg(wargs[n], XmNx, 71);n++;
	XtSetArg(wargs[n], XmNy, 13);n++;
	XtSetArg(wargs[n], XmNset, abs(voltage_clamp-1));n++;
	XtSetArg(wargs[n], XmNlabelString, string1);n++;
	Toggle_Button_Current = XtCreateManagedWidget("tgbcurrent",
						      xmToggleButtonGadgetClass,
						      Radio_Box_Clamp,
						      wargs, n);
	XtAddCallback(Toggle_Button_Current, XmNvalueChangedCallback, (XtPointer)callback_clamp, 
		      (XtPointer)0);
	XmStringFree(string1);
	
	string1 = XmStringCreateSimple("Voltage Clamp");	
	n = 0;
	XtSetArg(wargs[n], XmNx, 245);n++;
	XtSetArg(wargs[n], XmNy, 13);n++;
	XtSetArg(wargs[n], XmNset, voltage_clamp);n++;
	XtSetArg(wargs[n], XmNlabelString, string1);n++;
	Toggle_Button_Voltage = XtCreateManagedWidget("tgbvoltage",
						      xmToggleButtonGadgetClass,
						      Radio_Box_Clamp,
						      wargs, n);
	XtAddCallback(Toggle_Button_Voltage, XmNvalueChangedCallback, (XtPointer)callback_clamp, 
		      (XtPointer)1);						  
	XmStringFree(string1);

	/* separator clamp */
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 16);n++;
	XtSetArg(wargs[n], XmNheight, 16);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNleftOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 15);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNrightOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopWidget, Radio_Box_Clamp);n++;
	Separator_Clamp = XtCreateManagedWidget("separatorclamp",
						xmSeparatorGadgetClass,
						Form_Simulation,
						wargs, n);

	/* label PSP */

	string1 = XmStringCreateSimple("EPSP and IPSP inputs");	
	n = 0;
	XtSetArg(wargs[n], XmNlabelString, string1);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNtopWidget, Separator_Clamp);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNrightPosition, 49);n++;
	Label_PSP = XtCreateManagedWidget("lblPSP",
					    xmLabelGadgetClass,
					    Form_Simulation,
					    wargs, n);
	XmStringFree(string1);	


	/* DeXinput PSP_Number */

	if (flag_Tms_Input) sprintf(buffer,"Number of events");
	else sprintf(buffer,"Synaptic Boutons Number");
	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNleftPosition,2);n++;
	XtSetArg(wargs[n], XmNrightPosition, 49);n++;
	XtSetArg(wargs[n], XmNtopOffset, 0);n++;
	XtSetArg(wargs[n], XmNtopWidget, Label_PSP);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0);n++;
	XtSetArg(wargs[n], DeXNvalue, nb_connexions);n++;
	XtSetArg(wargs[n], DeXNlabelString, buffer);n++;
	DeXInput_PSP_Number = XtCreateManagedWidget("pspnumber",
						   DeXinputWidgetClass,
						   Form_Simulation,
						   wargs, n);
	
	XtAddCallback(DeXInput_PSP_Number, DeXNokCallback, (XtPointer)callback_nombre_connexions, NULL);

	register_widget_CB(DeXInput_PSP_Number, 
			   (XtPointer)ID_DeXInput_PSP_Number, NULL);
	create_event_CB(DeXInput_PSP_Number, 
			(XtPointer)ID_DeXInput_PSP_Number, NULL);						     
	

	if (flag_Tms_Input)
	  {
	    /* label nom de fichier */

	    string1 = XmStringCreateSimple("tms file name:");	
	    n = 0;
	    XtSetArg(wargs[n], XmNlabelString, string1);n++;
	    XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	    XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	    XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	    XtSetArg(wargs[n], XmNtopWidget, Separator_Clamp);n++;
	    XtSetArg(wargs[n], XmNleftPosition, 51);n++;
	    XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	    XtSetArg(wargs[n], XmNrightPosition, 98);n++;
	    tms_File_Name = XtCreateManagedWidget("tmsfilename",
						  xmLabelGadgetClass,
						  Form_Simulation,
						  wargs, n);
	    XmStringFree(string1);	
	    
	    /* le nom du fichier */
	    
	    taille = sizeof(titre);
	    for (i = 0; i < taille; i++) 
	      titre[i]='\0';
	    
	    
	    taille = strlen(nom_fichier_tms_input);
	    i = taille;
	    do
	    {
	      i--;
	    } while (nom_fichier_tms_input[i]!='/');
	    debut = i;
	    j = 0;
	    for (i = debut+1; i < taille; i++)
	    {
	      titre[j] = nom_fichier_tms_input[i];
	      j++;
	    }
	    
	    sprintf(buffer1,"%s",titre);
	    string1 = XmStringCreate (buffer1, XmSTRING_DEFAULT_CHARSET); 	
	    n = 0;
	    XtSetArg(wargs[n], XmNlabelString, string1);n++;
	    XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	    XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	    XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	    XtSetArg(wargs[n], XmNtopWidget, tms_File_Name);n++;
	    XtSetArg(wargs[n], XmNleftPosition, 51);n++;
	    XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	    XtSetArg(wargs[n], XmNrightPosition, 98);n++;
	    Name = XtCreateManagedWidget("name",
					 xmLabelGadgetClass,
					 Form_Simulation,
					 wargs, n);
	    XmStringFree(string1);	
	    	    
	    string1 = XmStringCreateSimple("type event listing");	
	    
	    n = 0;
	    XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	    XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	    XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	    
	    XtSetArg(wargs[n], XmNtopWidget, Label_PSP);n++;
	    XtSetArg(wargs[n], XmNleftPosition,51);n++;
	    XtSetArg(wargs[n], XmNrightPosition, 96);n++;
	    
	    XtSetArg(wargs[n], XmNtopOffset, 40);n++;
	    XtSetArg(wargs[n], XmNleftOffset, 40);n++;
	    XtSetArg(wargs[n], XmNwidth, 200);n++;
	    XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 0); n++;
	    XtSetArg(wargs[n], XmNlabelString, string1);n++;
	    Push_Button_Listing = XtCreateManagedWidget("pushbuttonlisting",
						      xmPushButtonWidgetClass,
						      Form_Simulation,
						      wargs, n);
	    XmStringFree(string1);
	    
	    XtAddCallback(Push_Button_Listing, XmNactivateCallback, (XtPointer)callback_listing, NULL);
	  
	    register_widget_CB(Push_Button_Listing, 
			   (XtPointer)ID_Push_Button_Listing, NULL);
	    create_event_CB(Push_Button_Listing, 
			(XtPointer)ID_Push_Button_Listing, NULL);	

	  }	


	/************************************/
	
	n = 0;
	XtSetArg(wargs[n], XmNshadowType, XmSHADOW_IN); n++;
	XtSetArg(wargs[n], XmNheight, 320); n++; 
	XtSetArg(wargs[n], XmNtopOffset, 10); n++;
	XtSetArg(wargs[n], XmNleftOffset, 6); n++;
	XtSetArg(wargs[n], XmNrightOffset, 6); n++;
	
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_PSP_Number);n++;
	frame_SP = XmCreateFrame(Form_Simulation,"frameSP",wargs,n);
	XtManageChild(frame_SP);

	
	/*---- scrolledwindow pour la RowColumn----*/

	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, 320);n++;
	XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
	Scrolled_Window_Button = XtCreateManagedWidget("button",
						       xmScrolledWindowWidgetClass,
						       frame_SP,
						       wargs, n);

	/*---- container pour les widgets de boutons synaptiques ----*/
	
	n = 0;
	XtSetArg(wargs[n], XmNnumColumns, 1);n++;
	XtSetArg(wargs[n], XmNorientation, XmHORIZONTAL);n++;
	XtSetArg(wargs[n], XmNborderWidth, 0);n++;
	XtSetArg(wargs[n], XmNpacking, XmPACK_COLUMN);n++;
	Row_Collumn_Button = XtCreateManagedWidget("rcButton",
						   xmRowColumnWidgetClass,
						   Scrolled_Window_Button,
						   wargs, n);

	/* creation des n scales et des DeXinputs pour les boutons */
	/* ou creation des DeXinputs si on utilise les fichiers tms */ 
	    
	if (flag_button)
	{

	 	    /* les scales (ou les dexinputs si tms) */
	    for (i = 0 ; i < nb_connexions ; i++) 
	    {
	      /*---- container pour les widgets de un bouton synaptique ----*/
	
	      n = 0;
	      sprintf(buffer,"rcunbutton%d", (int)(i)); 
	      XtSetArg(wargs[n], XmNnumColumns, 3);n++;
	      XtSetArg(wargs[n], XmNorientation, XmHORIZONTAL);n++;
	      XtSetArg(wargs[n], XmNborderWidth, 2);n++;
	      XtSetArg(wargs[n], XmNpacking, XmPACK_COLUMN);n++;
	      Row_Collumn_Un_Button[i] = XtCreateManagedWidget(buffer,
							 xmRowColumnWidgetClass,
							 Row_Collumn_Button,
							 wargs, n);

	      if (!flag_Tms_Input)
	      {
		    sprintf(buffer,"scalebutton%d", (int)(i)); 
		    sprintf(buffer1," Bouton %d Time arrival in %%  ", (int )(i+1) );
		    string1 = XmStringCreate (buffer1, XmSTRING_DEFAULT_CHARSET); 
		    Scale_Buttons[i] =
		      xs_create_scale_button(Row_Collumn_Un_Button[i],buffer, string1 );
		    XmStringFree (string1);
		    
		    XtAddCallback (Scale_Buttons[i], XmNvalueChangedCallback, 
				   (XtPointer)callback_psp_time,
				   (XtPointer)i); 
		/*	       	DynamicChange (NULL, NULL, NULL); */
	      }
	      else
	      {
		    sprintf(buffer,"dexinputtypebutton%d", (int)(i));
		    sprintf(buffer1,"Bouton %d: PSP type of event", (int)(i+1));
		    DeXInput_Type_Buttons[i] =
		      xs_create_dexinput_button(Row_Collumn_Un_Button[i], buffer, buffer1, 150,
						0, (i+1), (i+1));
		    
		    XtAddCallback(DeXInput_Type_Buttons[i], DeXNokCallback, 
				  (XtPointer)callback_psp_type, 
				  (XtPointer)i);
	      }
		
	    /* les Dexinput pour le poids */

		sprintf(buffer,"dexinputbutton%d", (int)(i));
		sprintf(buffer1,"Bouton %d: PSP Weight ", (int)(i+1));
		DeXInput_Buttons[i] =
		  xs_create_dexinput_button(Row_Collumn_Un_Button[i], buffer, buffer1, 150, 2, 0, 0 );
		
		XtAddCallback(DeXInput_Buttons[i], DeXNokCallback, 
			      (XtPointer)callback_psp_weight, 
			      (XtPointer)i);

	    /* les options menus pour le neurotransmetteur */

		sprintf(buffer,"optionbutton%d", (int)(i));
		sprintf(buffer1," Bouton %d: Transmitter ", (int)(i+1));
		bufferString = buffer;
		string1 = XmStringCreateSimple (buffer1);
		Input_Transmitor[i] = XmVaCreateSimpleOptionMenu(Row_Collumn_Un_Button[i],buffer1,
		string1, 'I',  
                tab_syn[i].num_transm, 
		/* NULL, NULL, 0, */
		(XtPointer)callback_input_transmitor,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[0]), '0', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[1]), 'A', NULL, NULL,
		XmVaSEPARATOR,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[2]), '2', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[3]), '3', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[4]), '5', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[5]), '6', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[6]), '7', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[7]), '8', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[8]), '9', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[9]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[10]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[11]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[12]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[13]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[14]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[15]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[16]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[17]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[18]), 'T', NULL, NULL,
#ifdef ADD_NEW_TRANSMITOR
/* Adapt here with the new method */
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[19]), 'T', NULL, NULL,
#endif

		XmNorientation, XmVERTICAL,
		NULL);

		XtManageChild(Input_Transmitor[i]);
	    }
	    XtManageChild(Scrolled_Window_Button);
	    
	} /* fin du if(flag_button) */
	  
	XtManageChild(frame_SP);  
	
	/************************************/

	/* separateur diametre */
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 16);n++;
	XtSetArg(wargs[n], XmNheight, 16);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNleftOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNrightOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopWidget,frame_SP );n++;
	Separator_Diametre = XtCreateManagedWidget("separatordiametre",
						   xmSeparatorGadgetClass,
						   Form_Simulation,
						   wargs, n);

	/* DeXInput Diametre */
	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 0);n++;
	XtSetArg(wargs[n], XmNtopWidget, Separator_Diametre);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNrightPosition, 49);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 20);n++;
	XtSetArg(wargs[n], DeXNvalue, (int) diametre);n++;
	XtSetArg(wargs[n], DeXNlabelString, "Cell Diameter (micro m)");n++;
	DeXInput_Diametre = XtCreateManagedWidget("celldiameter",
						  DeXinputWidgetClass,
						  Form_Simulation,
						  wargs, n);
	XtAddCallback(DeXInput_Diametre, DeXNokCallback, (XtPointer)callback_diametre, NULL);

	register_widget_CB(DeXInput_Diametre, 
			   (XtPointer)ID_DeXInput_Diametre, NULL);
	create_event_CB(DeXInput_Diametre, 
			(XtPointer)ID_DeXInput_Diametre, NULL);	

	/* PushButton de fermeture */

	string1 = XmStringCreateSimple("Close");	

	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 40);n++;
	XtSetArg(wargs[n], XmNtopWidget, Separator_Diametre);n++;
	XtSetArg(wargs[n], XmNwidth, 100);n++;
	XtSetArg(wargs[n], XmNleftPosition, 61);n++;
	XtSetArg(wargs[n], XmNrightPosition, 88);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNlabelString, string1);n++;
	Push_Button_Close = XtCreateManagedWidget("celldiameter",
						  xmPushButtonWidgetClass,
						  Form_Simulation,
						  wargs, n);
	XmStringFree(string1);

	XtAddCallback(Push_Button_Close, XmNactivateCallback, (XtPointer)callback_close, NULL);
					   
	XtManageChild(Radio_Box_Clamp);
	XtManageChild(DeXInput_PSP_Number);
	XtManageChild(Form_Simulation);
	XtRealizeWidget(Top_Level_Simul);
	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_Simul), palette);

	XtMoveWidget(Top_Level_Simul, 650, 250);

	
}

/*------------------------------------------*/
	void fabrique_Receptors()
/*------------------------------------------*/
# if 0
				   (top_level_receptor)
					|
				Dialog_Shell_Receptor
				Form_Receptor	(FormDialog)
					|
				Label_Receptor
				DeXInput_Duree_Simulation
				
				Separator_Simulation
				Label_Stimulation
				DeXInput_Start_Stimulation
				DeXInput_Stimulation_Duration
				Separator_Stimulation
				Label_Clamp
				Radio_Box_Clamp-----------------
				Separator_Clamp			|
				Label_PSP			Toggle_Button_Current
				DeXInput_Number                 Toggle_Button_Voltage
				       |
                                frame_SP
                                Scrolled_Window_Button 
                                Row_Collumn_Button
                                 
                                  ( et une suite de widget )
                                       |
                                Separator_Diametre
				DeXInput_Diametre
				Push_Button_Close
# endif
{
	int		n, i, width, numero_transm, ii;
	Arg		wargs[20];
	Widget          Label_Nb_Recept;
	Widget          DeXInput_Recep_Number;
	Widget          Label_Recep_Number[NB_MAX_RECEPTORS];
	XmString	string1;
	String          bufferString;
	char            buffer[30], buffer1[30], titre[256];

	if(flag_receptors)
	{
		XtPopup(Top_Level_Receptors,XtGrabNone);
		return;
	} 

	flag_receptors = 1;

	/*---------- toplevel pour les potentiels d'equilibre ----------*/

	Top_Level_Receptors = XtCreateApplicationShell("toprecep",
							 topLevelShellWidgetClass,
							 wargs,
							 0);
	width = nb_receptors * 211;
	if (width >  screen_width)
	  width =  screen_width;

	XtVaSetValues(Top_Level_Receptors,
		      XmNtitle, "Receptor Parameters",
		      XmNx, 0,
		      XmNy, 100,
		      XmNwidth, width,
		      XmNheight, 650,
		      NULL);

	
	/*---- form pour les parametres des recepteurs ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, 400);n++;
	XtSetArg(wargs[n], XmNwidth, width);n++;
	XtSetArg(wargs[n], XmNfractionBase, 100);n++;
	Form_Receptor = XtCreateManagedWidget("formReceptor",
						xmFormWidgetClass,
						Top_Level_Receptors,
						wargs, n);
	XtAddCallback(Form_Receptor, XmNunmapCallback,  (XtPointer)callback_close_Receptors, NULL);


	/* DeXinput PSP_Number */

	sprintf(buffer,"Number of receptors");
	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_NONE);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNtopOffset, 0);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 1);n++;
	XtSetArg(wargs[n], DeXNvalue, nb_receptors);n++;
	XtSetArg(wargs[n], DeXNlabelString, buffer);n++;
	DeXInput_Recep_Number = XtCreateManagedWidget("recepnumber",
						   DeXinputWidgetClass,
						   Form_Receptor,
						   wargs, n);
	
	XtAddCallback(DeXInput_Recep_Number, DeXNokCallback, (XtPointer)callback_nb_receptors, NULL);

	register_widget_CB(DeXInput_Recep_Number, 
			   (XtPointer)ID_DeXInput_Recep_Number, NULL);
	create_event_CB(DeXInput_Recep_Number, 
			(XtPointer)ID_DeXInput_Recep_Number, NULL);						     
	

	/************************************/
	
	n = 0;
	XtSetArg(wargs[n], XmNshadowType, XmSHADOW_IN); n++;
	XtSetArg(wargs[n], XmNheight, 400); n++; 
	XtSetArg(wargs[n], XmNtopOffset, 10); n++;
	XtSetArg(wargs[n], XmNleftOffset, 6); n++;
	XtSetArg(wargs[n], XmNrightOffset, 6); n++;
	
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Recep_Number);n++;
	frame_Recep = XmCreateFrame(Form_Receptor,"frameRecep",wargs,n);
	XtManageChild(frame_Recep);

	
	/*---- scrolledwindow pour la RowColumn----*/

	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight, 650);n++;
	XtSetArg(wargs[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	XtSetArg(wargs[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED);n++;
	Scrolled_Window_Recep = XtCreateManagedWidget("recep",
						       xmScrolledWindowWidgetClass,
						       frame_Recep,
						       wargs, n);

	/*---- container pour les widgets de conductance ----*/
	
	n = 0;
	XtSetArg(wargs[n], XmNnumColumns, nb_receptors);n++;
	XtSetArg(wargs[n], XmNorientation, XmVERTICAL);n++;
	XtSetArg(wargs[n], XmNborderWidth, 0);n++;
	XtSetArg(wargs[n], XmNpacking, XmPACK_COLUMN);n++;
	Row_Collumn_Recep = XtCreateManagedWidget("recepButton",
						   xmRowColumnWidgetClass,
						   Scrolled_Window_Recep,
						   wargs, n);

	/* creation des n scales et des DeXinputs pour les boutons */
	/* ou creation des DeXinputs si on utilise les fichiers tms */ 

	
	for (i = 0 ; i < nb_receptors ; i++) 
	{

	  /*---- container pour les widgets de conductance ----*/
	
	      n = 0;
	      XtSetArg(wargs[n], XmNnumColumns, 6);n++;
	      XtSetArg(wargs[n], XmNorientation, XmHORIZONTAL);n++;
	      XtSetArg(wargs[n], XmNborderWidth, 2);n++;
	      XtSetArg(wargs[n], XmNpacking, XmPACK_COLUMN);n++;
	      Col_un_Recep[i] = XtCreateManagedWidget("ColRecep",
						   xmRowColumnWidgetClass,
						   Row_Collumn_Recep,
						   wargs, n);

	    /* label */

	    sprintf(buffer1,"Receptor %d", i+1); 
	    string1 = XmStringCreateSimple(buffer1);	
	    n = 0;
	    XtSetArg(wargs[n], XmNlabelString, string1);n++;
	    XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	    XtSetArg(wargs[n], XmNleftPosition, 20);n++;
	    XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM);n++;
	    XtSetArg(wargs[n], XmNtopOffset, 0);n++;
	    XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_NONE);n++;
	    Label_Recep_Number[i] = XtCreateManagedWidget("lnbrecep",
							   xmLabelGadgetClass,
							   Col_un_Recep[i],
							   wargs, n);
	    XmStringFree(string1);	

	    sprintf(buffer,"recep_ta%d", i); 
	    Receptor_Tau_attack[i] =
	      xs_create_dexinput_button(Col_un_Recep[i], buffer, "Tau attack (ms)", 180,
					2, 250, 250);
	    
	    XtAddCallback (Receptor_Tau_attack[i], DeXNokCallback, 
			   (XtPointer)callback_receptor_tau_attack,
			   (XtPointer)i); 

	    sprintf(buffer,"recep_td%d", i); 
	    Receptor_Tau_decay[i] =
	      xs_create_dexinput_button(Col_un_Recep[i],buffer, "Tau decay (ms)", 180,
					2, 1000, 1000);
		    
	    XtAddCallback (Receptor_Tau_decay[i], DeXNokCallback, 
			   (XtPointer)callback_receptor_tau_decay,
			   (XtPointer)i); 

	    sprintf(buffer,"recep_amp%d", i); 
	    Receptor_Amplitude[i] =
	      xs_create_dexinput_button(Col_un_Recep[i],buffer, "G synaptique (mS/cm2)", 180,
					3, 500, 500);
		    
	    XtAddCallback (Receptor_Amplitude[i], DeXNokCallback, 
				   (XtPointer)callback_receptor_amplitude,
				   (XtPointer)i);

	    sprintf(buffer,"recep_rev_pot%d", i); 
	    Receptor_Rev_pot[i] =
	      xs_create_dexinput_button(Col_un_Recep[i],buffer, "Reversal pot. (mV)", 180,
					2, -1000, -1000);
		    
	    XtAddCallback (Receptor_Rev_pot[i], DeXNokCallback, 
				   (XtPointer)callback_receptor_rev_pot,
				   (XtPointer)i);

	    sprintf(buffer,"recep_transm%d", i); 
	    sprintf(buffer1,"Transmitter", (int )(i+1) );
	    string1 = XmStringCreate (buffer1, XmSTRING_DEFAULT_CHARSET);

	    bufferString = buffer;
	    Receptor_Transmitor[i] = XmVaCreateSimpleOptionMenu(Col_un_Recep[i],
		bufferString,
								NULL,NULL,
								Receptors[i].num_transm,
								/*		string1, 'I', 
										Receptors[i].num_transm, 
								*/
		(XtPointer)callback_toggle_transmitor,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[0]), '0', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[1]), 'A', NULL, NULL,
		XmVaSEPARATOR,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[2]), '2', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[3]), '3', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[4]), '5', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[5]), '6', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[6]), '7', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[7]), '8', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[8]), '9', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[9]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[10]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[11]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[12]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[13]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[14]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[15]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[16]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[17]), 'T', NULL, NULL,
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[18]), 'T', NULL, NULL,
#ifdef ADD_NEW_TRANSMITOR
/* Adapt here with the new method */
		XmVaPUSHBUTTON, XmStringCreateSimple(transmitor_names[19]), 'T', NULL, NULL,
#endif
		XmNorientation, XmVERTICAL,
		NULL);
	    register_widget_CB(Receptor_Transmitor[i], (XtPointer)ID_Receptor_Transmitor, NULL);
	    create_event_CB(Receptor_Transmitor[i], (XtPointer)ID_Receptor_Transmitor, NULL);

	    XtManageChild(Receptor_Tau_attack[i]);
	    XtManageChild(Receptor_Tau_decay[i]);
	    XtManageChild(Receptor_Amplitude[i]);
	    XtManageChild(Receptor_Rev_pot[i]);
	    XtManageChild(Receptor_Transmitor[i]);

	    XmStringFree (string1);
	    /*
	    XtAddCallback (Receptor_Transmitor[i], XmNentryCallback, 
				   (XtPointer)callback_entry_transmitor,
				   (XtPointer)i);
	    */


	}

	XtManageChild(Scrolled_Window_Recep);
	  
	XtManageChild(frame_Recep);  
	
	/************************************/

	/* PushButton de fermeture */

	string1 = XmStringCreateSimple("Close");	

	n = 0;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNrightPosition, 80);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_NONE);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNtopOffset, 40);n++;
	XtSetArg(wargs[n], XmNwidth, 100);n++;
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNlabelString, string1);n++;
	Push_Recep_Close = XtCreateManagedWidget("closerecpt",
						  xmPushButtonWidgetClass,
						  Form_Receptor,
						  wargs, n);
	XmStringFree(string1);

	XtAddCallback(Push_Recep_Close, XmNactivateCallback, (XtPointer)callback_close_Receptors, NULL);
					   
	XtManageChild(DeXInput_Recep_Number);
	XtManageChild(Form_Receptor);
	XtRealizeWidget(Top_Level_Receptors);

	for (i = 0 ; i < nb_receptors ; i++) 
	{
	    XtVaSetValues(Receptor_Tau_attack[i], DeXNvalue, (int)(Receptors[i].tau_attack * 100),NULL,NULL);
	    XtVaSetValues(Receptor_Tau_decay[i], DeXNvalue, (int)(Receptors[i].tau_decay * 100),NULL,NULL);
	    XtVaSetValues(Receptor_Amplitude[i], DeXNvalue, (int)(Receptors[i].g_Syn * 1000),NULL,NULL);
	    XtVaSetValues(Receptor_Rev_pot[i], DeXNvalue, (int)(Receptors[i].rev_pot * 100),NULL,NULL);
	}

	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_Receptors), palette);

	XtMoveWidget(Top_Level_Receptors, 0, 100);
	
}

/*------------------------------------------*/
	void fabrique_Echelles()
/*------------------------------------------*/
# if 0
				   (top_level_simul)
					|
				Dialog_Shell_Echelles
				Form_Echelles	(FormDialog)
					|
				Label_Echelles
                                DeXInput_Graphe1min
                                DeXInput_Graphe1max
	                        DeXInput_Graphe2min
	                        DeXInput_Graphe2max
       	                        DeXInput_Graphe3min
	                        DeXInput_Graphe3max
                                Separator_Graphe1
				Close_Echelles
				
# endif
{
	int		n;
	Arg		wargs[20];
	XmString	string1;

	if(flag_echelles!= 0)
	{
		XtPopup(Top_Level_Echelles,XtGrabNone);
		return;
	} 


	/*---------- toplevel pour les echelles ----------*/


	Top_Level_Echelles = XtCreateApplicationShell("topechelles",
							 topLevelShellWidgetClass,
							 wargs,
							 0);
	XtVaSetValues(Top_Level_Echelles,
		      XmNtitle, "y scales adjustment",
		      XmNx, 350,
		      XmNy, 420,
		      NULL);

	/*---- form pour les parametres de l`echelles ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight,350);n++;
	XtSetArg(wargs[n], XmNwidth,420 );n++;
	XtSetArg(wargs[n], XmNfractionBase,100);n++;
	Form_Echelles = XtCreateManagedWidget("formEchelles",
						xmFormWidgetClass,
						Top_Level_Echelles,
						wargs, n);
	XtAddCallback(Form_Echelles, XmNunmapCallback, fermeture_Echelles, NULL);



	/* DexInput Graphe1max,Graphe1min */
	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNrightPosition, 49);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 61.);n++;
	XtSetArg(wargs[n], DeXNvalue, ref1.upper_y);n++;
	XtSetArg(wargs[n], DeXNlabelString, "max value Graph 1");n++;
	DeXInput_Graphe1max = XtCreateManagedWidget("graphe1max",
						     DeXinputWidgetClass,
						     Form_Echelles,
						     wargs, n);
	XtAddCallback(DeXInput_Graphe1max, DeXNokCallback, (XtPointer)callback_Graphe1max, NULL);

	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNleftWidget, DeXInput_Graphe1max);n++;
       	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 51);n++;
	XtSetArg(wargs[n], XmNrightPosition, 98);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, -100.);n++;
	XtSetArg(wargs[n], DeXNvalue, ref1.lower_y);n++;
	XtSetArg(wargs[n], DeXNlabelString, "min value Graph 1");n++;
	DeXInput_Graphe1min = XtCreateManagedWidget("graphe1min",
						    DeXinputWidgetClass,
						    Form_Echelles,
						    wargs, n);
	XtAddCallback(DeXInput_Graphe1min, DeXNokCallback, (XtPointer)callback_Graphe1min, NULL);

	
	/* DeXInput Graphe2max,Graph2min */
	
	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Graphe1max);n++;
       	XtSetArg(wargs[n], XmNtopOffset, 0);n++;
	XtSetArg(wargs[n], XmNleftOffset, 0);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNrightPosition, 49);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0);n++;
	if (flag_conductance)
	  {
	    XtSetArg(wargs[n], DeXNdefaultValue, 20.);n++;
	  }
	else
	  {
	    XtSetArg(wargs[n], DeXNdefaultValue, 50.);n++;
	  }
	XtSetArg(wargs[n], DeXNvalue, ref2.upper_y);n++;
	XtSetArg(wargs[n], DeXNlabelString, "max value Graph 2");n++;
	DeXInput_Graphe2max = XtCreateManagedWidget("graphe2max",
						     DeXinputWidgetClass,
						     Form_Echelles,
						     wargs, n);
	XtAddCallback(DeXInput_Graphe2max, DeXNokCallback, (XtPointer)callback_Graphe2max, NULL);

	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Graphe2max);n++;
       	XtSetArg(wargs[n], XmNtopOffset, -86);n++;
       	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 51);n++;
	XtSetArg(wargs[n], XmNrightPosition, 98);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0);n++;
	if (flag_conductance)
	  {
	    XtSetArg(wargs[n], DeXNdefaultValue, -40.);n++;
	  }
	else
	  {
	    XtSetArg(wargs[n], DeXNdefaultValue, 0.);n++;
	  }
	XtSetArg(wargs[n], DeXNvalue, ref2.lower_y);n++;
	XtSetArg(wargs[n], DeXNlabelString, "min value Graph 2");n++;
	DeXInput_Graphe2min = XtCreateManagedWidget("graphe2min",
						    DeXinputWidgetClass,
						    Form_Echelles,
						    wargs, n);
	XtAddCallback(DeXInput_Graphe2min, DeXNokCallback, (XtPointer)callback_Graphe2min, NULL);

	
	
	/* DeXInput Graphe3max,Graph3min */

	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Graphe2max);n++;
       	XtSetArg(wargs[n], XmNtopOffset, 0);n++;
	XtSetArg(wargs[n], XmNleftOffset, 0);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNrightPosition, 49);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0);n++;
	if (flag_conductance)
	  {
	    XtSetArg(wargs[n], DeXNdefaultValue, 5.);n++;
	  }
	else
	  {
	    XtSetArg(wargs[n], DeXNdefaultValue, 50.);n++;
	  }
	XtSetArg(wargs[n], DeXNvalue, ref3.upper_y);n++;
	XtSetArg(wargs[n], DeXNlabelString, "max value Graph 3");n++;
	DeXInput_Graphe3max = XtCreateManagedWidget("graphe3max",
						     DeXinputWidgetClass,
						     Form_Echelles,
						     wargs, n);
	XtAddCallback(DeXInput_Graphe3max, DeXNokCallback, (XtPointer)callback_Graphe3max, NULL);

	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Graphe3max);n++;
       	XtSetArg(wargs[n], XmNtopOffset, -86);n++;
       	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 51);n++;
	XtSetArg(wargs[n], XmNrightPosition, 98);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 0);n++;
	if (flag_conductance)
	  {
	    XtSetArg(wargs[n], DeXNdefaultValue, -5.);n++;
	  }
	else
	  {
	    XtSetArg(wargs[n], DeXNdefaultValue, 50.);n++;
	  }
	XtSetArg(wargs[n], DeXNvalue, ref3.lower_y);n++;
	XtSetArg(wargs[n], DeXNlabelString, "min value Graph 3");n++;
	DeXInput_Graphe3min = XtCreateManagedWidget("graphe3min",
						    DeXinputWidgetClass,
						    Form_Echelles,
						    wargs, n);
	XtAddCallback(DeXInput_Graphe3min, DeXNokCallback, (XtPointer)callback_Graphe3min, NULL);

	

	/* separateur  */
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 16);n++;
	XtSetArg(wargs[n], XmNheight, 16);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNleftOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNrightOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Graphe3min);n++;
	Separator_Graphe1 = XtCreateManagedWidget("separatorgraphe1",
						   xmSeparatorGadgetClass,
						   Form_Echelles,
						   wargs, n);



	/* PushButton de fermeture */

	string1 = XmStringCreateSimple("Close");	

	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNtopWidget, Separator_Graphe1);n++;
	XtSetArg(wargs[n], XmNwidth, 100);n++;
	XtSetArg(wargs[n], XmNleftPosition, 40);n++;
	XtSetArg(wargs[n], XmNrightPosition, 60);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNlabelString, string1);n++;
	XtSetArg(wargs[n], XmNtopWidget, Separator_Graphe1);n++;
	Close_Echelles = XtCreateManagedWidget("closeechelles",
						  xmPushButtonWidgetClass,
						  Form_Echelles,
						  wargs, n);
	XmStringFree(string1);

	XtAddCallback(Close_Echelles, XmNactivateCallback, (XtPointer)callback_close_Echelles, NULL);
	
	XtManageChild(Form_Echelles);
	XtRealizeWidget(Top_Level_Echelles);
	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_Echelles), palette);

	XtMoveWidget(Top_Level_Echelles, 200, 0);
	flag_echelles = 1;

	XtMoveWidget(Top_Level_Echelles, 100, 100);
}

/*------------------------------------------*/
	void fabrique_Transmitors()
/*------------------------------------------*/
# if 0
				   (top_level_simul)
					|
				Dialog_Shell_Transmitors
				Form_Transmitors	(FormDialog)
					|
				Label_Transmitors
                                Separator_Transmitors_1
                                Separator_Transmitors
				Close_Transmitors
				
# endif
{
	int		n, i;
	Arg		wargs[20];
	XmString	string1;

	if (flag_transmitors)
	{
		XtPopup(Top_Level_Transmitors,XtGrabNone);
		return;
	} 


	/*---------- toplevel pour les Transmitors ----------*/


	Top_Level_Transmitors = XtCreateApplicationShell("topTransmitors",
							 topLevelShellWidgetClass,
							 wargs,
							 0);
	XtVaSetValues(Top_Level_Transmitors,
		      XmNtitle, "Transmitors",
		      XmNx, 100,
		      XmNy, 100,
		      NULL);

	/*---- form pour les parametres des Transmiteurs ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight,800);n++;
	XtSetArg(wargs[n], XmNwidth,230 );n++;
	XtSetArg(wargs[n], XmNfractionBase,100);n++;
	Form_Transmitors = XtCreateManagedWidget("formTransmitors",
						xmFormWidgetClass,
						Top_Level_Transmitors,
						wargs, n);
	XtAddCallback(Form_Transmitors, XmNunmapCallback, fermeture_transmitors, NULL);


	for (i = 0; i < 2; i++)
	{
	  string1 = XmStringCreateSimple(transmitor_names[i]);

	  n = 0;
	  XtSetArg(wargs[n], XmNlabelString, string1); n++;
	  XtSetArg(wargs[n], XmNwidth, 142); n++;
	  XtSetArg(wargs[n], XmNheight, 33); n++;
	  XtSetArg(wargs[n], XmNy, 35 * i); n++;
	  toggleButton_Transm[i] = XtCreateWidget("toggleButton_TR",
					   xmToggleButtonWidgetClass,
					   Form_Transmitors,
					   wargs,
					   n);
	  XtManageChild(toggleButton_Transm[i]);

	  XmStringFree(string1);

	}

	
	/* separateur  */
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 16);n++;
	XtSetArg(wargs[n], XmNheight, 16);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNleftOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNrightOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopWidget,toggleButton_Transm[1]);n++;
	Separator_Transmitors_1 = XtCreateManagedWidget("separatortransm",
						   xmSeparatorGadgetClass,
						   Form_Transmitors,
						   wargs, n);

	for (i = 2; i < NB_TRANSMITORS; i++)
	{
	  string1 = XmStringCreateSimple(transmitor_names[i]);

	  n = 0;
	  XtSetArg(wargs[n], XmNlabelString, string1); n++;
	  XtSetArg(wargs[n], XmNwidth, 142); n++;
	  XtSetArg(wargs[n], XmNheight, 33); n++;
	  XtSetArg(wargs[n], XmNy, ((35 * i)+16)); n++;
	  toggleButton_Transm[i] = XtCreateWidget("toggleButton_TR",
					   xmToggleButtonWidgetClass,
					   Form_Transmitors,
					   wargs,
					   n);
	  XtManageChild(toggleButton_Transm[i]);

	  XmStringFree(string1);

	}

	
	/* separateur  */
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 16);n++;
	XtSetArg(wargs[n], XmNheight, 16);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNleftOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNrightOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopWidget,toggleButton_Transm[(NB_TRANSMITORS - 1)]);n++;
	Separator_Transmitors = XtCreateManagedWidget("separatortransm",
						   xmSeparatorGadgetClass,
						   Form_Transmitors,
						   wargs, n);



	/* PushButton de fermeture */

	string1 = XmStringCreateSimple("Close");

	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNtopWidget, Separator_Transmitors);n++;
	XtSetArg(wargs[n], XmNwidth, 100);n++;
	XtSetArg(wargs[n], XmNleftPosition, 30);n++;
	XtSetArg(wargs[n], XmNrightPosition, 70);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNlabelString, string1);n++;
	Close_Transmitors = XtCreateManagedWidget("closeTransmitors",
						  xmPushButtonWidgetClass,
						  Form_Transmitors,
						  wargs, n);
	XmStringFree(string1);

	XtAddCallback(Close_Transmitors, XmNactivateCallback, (XtPointer)callback_close_Transmitors, NULL);
	
	XtManageChild(Form_Transmitors);
	XtRealizeWidget(Top_Level_Transmitors);
	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_Transmitors), palette);

	for (i = 0; i < NB_TRANSMITORS; i++)
	{
	  XtAddCallback(toggleButton_Transm[i], XmNvalueChangedCallback, (XtPointer)retour_transmitors, (XtPointer)i);
	}	
	flag_transmitors = 1;

	XtMoveWidget(Top_Level_Transmitors, 100, 100);

	switch (neurotransmitor)
	{
	  case ANY:
	    XmToggleButtonSetState (toggleButton_Transm[0], False, False);
	    XmToggleButtonSetState (toggleButton_Transm[1], True, False);
	    for ( i = 2; i < NB_TRANSMITORS; i ++)
	    {
	      XmToggleButtonSetState (toggleButton_Transm[i], False, False);
	    }
	    break;
	  case NO_TRANSMISSION:
	    XmToggleButtonSetState (toggleButton_Transm[0], True, False);
	    XmToggleButtonSetState (toggleButton_Transm[1], False, False);
	    for ( i = 2; i < NB_TRANSMITORS; i ++)
	    {
	      XmToggleButtonSetState (toggleButton_Transm[i], False, False);
	    }
	    break;
	  default:
	    XmToggleButtonSetState (toggleButton_Transm[0], False, False);
	    XmToggleButtonSetState (toggleButton_Transm[1], False, False);
	    for ( i = 2; i < NB_TRANSMITORS; i ++)
	    {
	      if (neurotransmitor & transmetteur[i])
	      {
		XmToggleButtonSetState (toggleButton_Transm[i], True, False);
	      }
	      else
	      {
		XmToggleButtonSetState (toggleButton_Transm[i], False, False);
	      }
	    }
	}
}


/*------------------------------------------*/
	void fabrique_form_recurrent_window()
/*------------------------------------------*/
# if 0
				   (top_level_recurrent)
					|
				Dialog_Shell_recurrent
				Form_recurrent	(FormDialog)
					|
				Label_recurrent
                                DeXInput_Delai_recurrent
                                DeXInput_ponderation_recurrent
                                Separator_recurrent
				Close_Echelles
				
# endif
{
	int		n;
	Arg		wargs[20];
	XmString	string1;

	if(flag_recurrentEPSP!= 0)
	{
		XtPopup(Top_Level_recurrent,XtGrabNone);
		return;
	} 


	/*---------- toplevel pour les echelles ----------*/


	Top_Level_recurrent = XtCreateApplicationShell("toprecurrent",
							 topLevelShellWidgetClass,
							 wargs,
							 0);
	XtVaSetValues(Top_Level_recurrent,
		      XmNtitle, "Recurrent EPSP parameters",
		      XmNx, 200,
		      XmNy, 270,
		      NULL);

	/*---- form pour les parametres de la recurrence ----*/
	n = 0;
	XtSetArg(wargs[n], XmNborderWidth, 1);n++;
	XtSetArg(wargs[n], XmNheight,270);n++;
	XtSetArg(wargs[n], XmNwidth,200 );n++;
	XtSetArg(wargs[n], XmNfractionBase,100);n++;
	Form_recurrent = XtCreateManagedWidget("formrecurrent",
						xmFormWidgetClass,
						Top_Level_recurrent,
						wargs, n);
	XtAddCallback(Form_recurrent, XmNunmapCallback, fermeture_recurrent, NULL);



	/* DexInput  */
	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopWidget, Form_recurrent);n++;
	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNrightPosition, 98);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0.);n++;
	XtSetArg(wargs[n], DeXNvalue, delai_recurrence*100);n++;
	XtSetArg(wargs[n], DeXNlabelString, "Delay");n++;
	DeXInput_Delai_recurrent = XtCreateManagedWidget("delairecurrent",
							 DeXinputWidgetClass,
							 Form_recurrent,
							 wargs, n);
	XtAddCallback(DeXInput_Delai_recurrent, DeXNokCallback, 
		      (XtPointer)callback_Delai_recurrent, NULL);

	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Delai_recurrent);n++;
       	XtSetArg(wargs[n], XmNtopOffset, 0);n++;
       	XtSetArg(wargs[n], XmNwidth, 200);n++;
	XtSetArg(wargs[n], XmNleftPosition, 2);n++;
	XtSetArg(wargs[n], XmNrightPosition, 98);n++;
	XtSetArg(wargs[n], DeXNdecimalPoint, 2);n++;
	XtSetArg(wargs[n], DeXNdefaultValue, 0.);n++;
	XtSetArg(wargs[n], DeXNvalue, ponderation_recurrence*100);n++;
	XtSetArg(wargs[n], DeXNlabelString, "EPSP weight");n++;
	DeXInput_Ponderation_recurrent = XtCreateManagedWidget("ponderationrecurrent",
						    DeXinputWidgetClass,
						    Form_recurrent,
						    wargs, n);
	XtAddCallback(DeXInput_Ponderation_recurrent, DeXNokCallback, 
		      (XtPointer)callback_Ponderation_recurrent, NULL);

	
	
	

	/* separateur  */
	n = 0;
	XtSetArg(wargs[n], XmNwidth, 16);n++;
	XtSetArg(wargs[n], XmNheight, 16);n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNleftOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM);n++;
	XtSetArg(wargs[n], XmNrightOffset, 1);n++;
	XtSetArg(wargs[n], XmNtopWidget, DeXInput_Ponderation_recurrent);n++;
	Separator_recurrent = XtCreateManagedWidget("separatorrecurrent",
						   xmSeparatorGadgetClass,
						   Form_recurrent,
						   wargs, n);



	/* PushButton de fermeture */

	string1 = XmStringCreateSimple("Close");	

	n = 0;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNtopOffset, 10);n++;
	XtSetArg(wargs[n], XmNtopWidget, Separator_recurrent);n++;
	XtSetArg(wargs[n], XmNwidth, 100);n++;
	XtSetArg(wargs[n], XmNleftPosition, 20);n++;
	XtSetArg(wargs[n], XmNrightPosition, 80);n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_POSITION);n++;
	XtSetArg(wargs[n], XmNdefaultButtonShadowThickness, 2); n++;
	XtSetArg(wargs[n], XmNlabelString, string1);n++;
	Close_recurrent = XtCreateManagedWidget("closeechelles",
						  xmPushButtonWidgetClass,
						  Form_recurrent,
						  wargs, n);
	XmStringFree(string1);

	XtAddCallback(Close_recurrent, XmNactivateCallback, (XtPointer)callback_close_recurrent, NULL);
	
	XtManageChild(Form_recurrent);
	XtRealizeWidget(Top_Level_recurrent);
	if (colormap)
		XSetWindowColormap(disp, XtWindow(Top_Level_recurrent), palette);


	flag_recurrentEPSP = 1;

	XtMoveWidget(Top_Level_recurrent, 700, 50);
}





/*----------------------------------------*/
	void fabrique_drawing_areas()
/*----------------------------------------*/
{
# if 0
			   (top_levelG)		(cf G_neuron4.c)
				|
			     (Form_G)
				|
			    Drawing_A1
			    Drawing_A2
			    Drawing_A3
# endif

	Drawing_A1 = XtVaCreateManagedWidget("drawinga1",
					     xmDrawingAreaWidgetClass,
					     Form_G,
					     XmNbackground, WhitePixel(disp, screen),
					     XmNtopAttachment, XmATTACH_FORM,
					     XmNtopOffset, 50,
					     XmNrightAttachment, XmATTACH_FORM,
					     XmNrightOffset, 1,
					     XmNleftAttachment, XmATTACH_FORM,
					     XmNleftOffset, 1,
					     XmNbottomAttachment, XmATTACH_POSITION,
					     XmNbottomPosition, 40,
					     NULL);
					     
	Drawing_A2 = XtVaCreateManagedWidget("drawinga2",
					     xmDrawingAreaWidgetClass,
					     Form_G,
					     XmNbackground, WhitePixel(disp, screen),
					     XmNtopAttachment, XmATTACH_WIDGET,
					     XmNtopWidget, Drawing_A1,
					     XmNtopOffset, 10,
					     XmNrightAttachment, XmATTACH_FORM,
					     XmNrightOffset, 1,
					     XmNleftAttachment, XmATTACH_FORM,
					     XmNleftOffset, 1,
					     XmNbottomAttachment, XmATTACH_POSITION,
					     XmNbottomPosition, 68,
					     NULL);

	Drawing_A3 = XtVaCreateManagedWidget("drawinga3",
					     xmDrawingAreaWidgetClass,
					     Form_G,
					     XmNbackground, WhitePixel(disp, screen),
					     XmNtopAttachment, XmATTACH_WIDGET,
					     XmNtopWidget, Drawing_A2,
					     XmNtopOffset, 10,
					     XmNrightAttachment, XmATTACH_FORM,
					     XmNrightOffset, 1,
					     XmNleftAttachment, XmATTACH_FORM,
					     XmNleftOffset, 1,
					     XmNbottomAttachment, XmATTACH_POSITION,
					     XmNbottomPosition, 96,
					     NULL);
	HelpLabel = XtVaCreateManagedWidget("HelpLabel",
					     xmLabelWidgetClass,
					     Form_G,
					     XmNshadowThickness, 2,
					     XmNtopAttachment, XmATTACH_WIDGET,
					     XmNtopWidget, Drawing_A3,
					     XmNtopOffset, 10,
					     XmNrightAttachment, XmATTACH_FORM,
					     XmNrightOffset, 1,
					     XmNleftAttachment, XmATTACH_FORM,
					     XmNleftOffset, 1,
					     XmNbottomAttachment, XmATTACH_FORM,
					     XmNbottomOffset, 1,
					     NULL);

	XtAddCallback(Drawing_A1, XmNresizeCallback, (XtPointer)expose_resize_CB, (XtPointer)1);
	XtAddCallback(Drawing_A1, XmNexposeCallback, (XtPointer)expose_resize_CB, (XtPointer)1);
	XtAddCallback(Drawing_A2, XmNresizeCallback, (XtPointer)expose_resize_CB, (XtPointer)2);
	XtAddCallback(Drawing_A2, XmNexposeCallback, (XtPointer)expose_resize_CB, (XtPointer)2);
	XtAddCallback(Drawing_A3, XmNresizeCallback, (XtPointer)expose_resize_CB, (XtPointer)3);
	XtAddCallback(Drawing_A3, XmNexposeCallback, (XtPointer)expose_resize_CB, (XtPointer)3);
}
/*----------------------------------------*/
	void fabrique_XY_area()
/*----------------------------------------*/
{
# if 0
			   (Top_Level_XY)		(cf G_neuron4.c)
				|
			     (Form_XY)
				|
			    Drawing_XY
			    close_XY
# endif
	int		n;
	Arg		wargs[20];
	XmString	string1;

	if(flag_XY != 0)
	{
		XtPopup(Top_Level_XY,XtGrabNone);
		return;
	} 

	/*---------- toplevel pour la fenetre de graphe XY ----------*/


	Top_Level_XY = XtCreateApplicationShell("topdrawXY",
						 topLevelShellWidgetClass,
						 wargs,
						 0);

	XtVaSetValues(Top_Level_XY,
		      XmNtitle, "X-Y plot",
		      XmNx, 530,
		      XmNy, 200,
		      XmNheight, 500,
		      XmNwidth, 500,
		      NULL);

		/*---- form pour le plot XY ----*/
	n = 0;
	XtSetArg(wargs[n], XmNresizePolicy, XmRESIZE_GROW); n++;
	XtSetArg(wargs[n], XmNx, 100); n++;
	XtSetArg(wargs[n], XmNy, 200); n++;
	XtSetArg(wargs[n], XmNwidth, 500); n++;
	XtSetArg(wargs[n], XmNheight, 441); n++;
	Form_XY = XtCreateManagedWidget("formXY",
					xmFormWidgetClass,
					Top_Level_XY,
					wargs, n);

	n = 0;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_POSITION); n++;
	XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNtopPosition, 79); n++;
	XtSetArg(wargs[n], XmNtopOffset, 0); n++;
	XtSetArg(wargs[n], XmNbottomOffset, 97); n++;
	XtSetArg(wargs[n], XmNleftOffset, 0); n++;
	XtSetArg(wargs[n], XmNrightOffset, 0); n++;
	XtSetArg(wargs[n], XmNx, 0); n++;
	XtSetArg(wargs[n], XmNy, 348); n++;
	XtSetArg(wargs[n], XmNheight, 1); n++;
	Separator_XY = XtCreateWidget("separator_XY",
		xmSeparatorWidgetClass,
		Form_XY,
		wargs,
		n);
	XtManageChild(Separator_XY);

	/* PushButton de fermeture */

	string1 = XmStringCreateSimple("Close");	

	n = 0;
	XtSetArg(wargs[n], XmNlabelString, string1); n++; 
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_NONE); n++;
	XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_NONE); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNbottomOffset, 22); n++;
	XtSetArg(wargs[n], XmNrightOffset, 70); n++;
	XtSetArg(wargs[n], XmNx, 610); n++;
	XtSetArg(wargs[n], XmNy, 371); n++;
	XtSetArg(wargs[n], XmNwidth, 133); n++;
	XtSetArg(wargs[n], XmNheight, 48); n++;
	Push_Button_Close_XY = XtCreateWidget("pushButton_close_XY",
		xmPushButtonWidgetClass,
		Form_XY,
		wargs,
		n);
	XtManageChild(Push_Button_Close_XY);
	XmStringFree(string1);

	/* PushButton d'impression */

	string1 = XmStringCreateSimple("Print");	

	n = 0;
	XtSetArg(wargs[n], XmNlabelString, string1); n++; 
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_NONE); n++;
	XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNbottomOffset, 22); n++;
	XtSetArg(wargs[n], XmNleftOffset, 70); n++;
	XtSetArg(wargs[n], XmNx, 70); n++;
	XtSetArg(wargs[n], XmNy, 369); n++;
	XtSetArg(wargs[n], XmNwidth, 133); n++;
	XtSetArg(wargs[n], XmNheight, 50); n++;
	Push_Button_Print_XY = XtCreateWidget("pushButton_print_XY",
		xmPushButtonWidgetClass,
		Form_XY,
		wargs,
		n);
	XtManageChild(Push_Button_Print_XY);
	XmStringFree(string1);

	/* Drawing Area */
	
	n = 0;
	XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION); n++;
	XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg(wargs[n], XmNleftPosition, 0); n++;
	XtSetArg(wargs[n], XmNtopOffset, 0); n++;
	XtSetArg(wargs[n], XmNbottomOffset, 11); n++;
	XtSetArg(wargs[n], XmNrightOffset, 0); n++;
	XtSetArg(wargs[n], XmNx, 0); n++;
	XtSetArg(wargs[n], XmNy, 0); n++;
	XtSetArg(wargs[n], XmNwidth, 813); n++;
	XtSetArg(wargs[n], XmNheight, 337); n++;
	XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(wargs[n], XmNbottomWidget, Separator_XY); n++;
	Drawing_XY = XtCreateWidget("drawing_XY",
		xmDrawingAreaWidgetClass,
		Form_XY,
		wargs,
		n);
	XtManageChild(Drawing_XY);

	XtRealizeWidget(Top_Level_XY);


	XtAddCallback(Push_Button_Close_XY, XmNactivateCallback, (XtPointer)callback_close_XY, NULL);
	XtAddCallback(Push_Button_Print_XY, XmNactivateCallback, (XtPointer)callback_print_XY, NULL);


	XtAddCallback(Top_Level_XY, XmNdestroyCallback,(XtPointer) fermeture_XY, NULL);

	XtAddCallback(Form_XY, XmNunmapCallback, (XtPointer)fermeture_XY, NULL);

	XtAddCallback(Drawing_XY, XmNresizeCallback,(XtPointer) expose_resize_XY, NULL);
	XtAddCallback(Drawing_XY, XmNexposeCallback,(XtPointer) expose_resize_XY, NULL);

	if (colormap)
		XSetWindowColormap(disp, XtWindow(XtParent(Form_XY)), palette);
	
        flag_XY = 1;

}


/*----------------------------------------------------------------*/
	void fabrique_radio_box_XY()
/*----------------------------------------------------------------*/
{
	int		argcnt = 0,
			i,
			j;

	Arg		args[20];
	
	XmString	string,
			string1,
			string2,
			string3,
			string4,
			string5,
			string6,
			string7,
			string8,
			string9,
			string10,
			string11,
			string12,
			string13,
			string14,
			string15;
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	XmString        string16;
#endif



	Widget	form_RB;
	Widget	labelX1;
	Widget	radioBox2;
	Widget	toggleButtonX20;
	Widget	toggleButtonX21;
	Widget	toggleButtonX22;
	Widget	toggleButtonX23;
	Widget	toggleButtonX24;
	Widget	toggleButtonX25;
	Widget	toggleButtonX26;
	Widget	toggleButtonX27;
	Widget	toggleButtonX28;
	Widget	toggleButtonX29;
	Widget	toggleButtonX40;
	Widget	toggleButtonX41;
	Widget	toggleButtonX42;
	Widget	toggleButtonX43;
	Widget	toggleButtonX44;
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt   -------*/
	Widget	toggleButtonX45;
#endif
	
	Widget	labelY1;
	Widget	radioBox4;
	Widget	toggleButtonX30;
	Widget	toggleButtonX31;
	Widget	toggleButtonX32;
	Widget	toggleButtonX33;
	Widget	toggleButtonX34;
	Widget	toggleButtonX35;
	Widget	toggleButtonX36;
	Widget	toggleButtonX37;
	Widget	toggleButtonX38;
	Widget	toggleButtonX39;
	Widget	toggleButtonX50;
	Widget	toggleButtonX51;
	Widget	toggleButtonX52;
	Widget	toggleButtonX53;
	Widget	toggleButtonX54;
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt   -------*/
	Widget	toggleButtonX55;
#endif

	Widget	pushButton_Close_RB;
	Widget	pushButton_Draw_RB;
	Widget	separator;

	string1 = XmStringCreateSimple("Time");
	string2 = XmStringCreateSimple("Mb. Potential");
	string3 = XmStringCreateSimple("Na Current");
	string4 = XmStringCreateSimple("Na pers Current");
	string5 = XmStringCreateSimple("K Current");
	string6 = XmStringCreateSimple("Ia Current");
	string7 = XmStringCreateSimple("Im Current");
	string8 = XmStringCreateSimple("Iahp Current");
	string9 = XmStringCreateSimple("Ic Current");
	string10 = XmStringCreateSimple("Ca HVA Current");
	string11 = XmStringCreateSimple("Ca LVA Current");
	string12 = XmStringCreateSimple("[Ca]");
	string13 = XmStringCreateSimple("Ih Current");
	string14 = XmStringCreateSimple("Activation m");
	string15 = XmStringCreateSimple("Inactivation h");
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt   -------*/
	string16 = XmStringCreateSimple("INew Current");

#endif


	if(flag_RB != 0)
	{
		XtPopup(Top_Level_RB,XtGrabNone);
		return;
	} 



	XtInitializeWidgetClass(xmSeparatorWidgetClass);
	XtInitializeWidgetClass(xmPushButtonWidgetClass);
	XtInitializeWidgetClass(xmToggleButtonWidgetClass);
	XtInitializeWidgetClass(xmLabelWidgetClass);
	XtInitializeWidgetClass(xmFormWidgetClass);
	XtInitializeWidgetClass(xmRowColumnWidgetClass);
	XtInitializeWidgetClass(topLevelShellWidgetClass);

	/*---------- toplevel pour la fenetre de graphe XY ----------*/


	Top_Level_RB = XtCreateApplicationShell("topradiobox",
						 topLevelShellWidgetClass,
						 args,
						 0);
	XtVaSetValues(Top_Level_RB,
		      XmNtitle, "Axis choice",
		      XmNx, 100,
		      XmNy, 200,
		      XmNheight, 670,
		      XmNwidth, 350,
		      NULL);

		/*---- form pour le plot XY ----*/

	argcnt = 0;
/*	XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++; */
	XtSetArg(args[argcnt], XmNx, 71); argcnt++;
	XtSetArg(args[argcnt], XmNy, 83); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 350); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 500); argcnt++;
	form_RB = XtCreateWidget("form_RB",
		xmFormWidgetClass,
		Top_Level_RB,
		args,
		argcnt);
	XtManageChild(form_RB);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
	XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
	XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
	XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
/*	XtSetArg(args[argcnt], XmNbottomWidget, pushButton_Close_RB); argcnt++;*/
	XtSetArg(args[argcnt], XmNbottomOffset, 50); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
	separator = XtCreateWidget("separator",
		xmSeparatorWidgetClass,
		form_RB,
		args,
		argcnt);
	XtManageChild(separator);

	string = XmStringCreateSimple("Close");
	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString,string); argcnt++;
	XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
	XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
	XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
	XtSetArg(args[argcnt], XmNrightOffset, 40); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 100); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
	pushButton_Close_RB = XtCreateWidget("pushButton1",
		xmPushButtonWidgetClass,
		form_RB,
		args,
		argcnt);
	XtManageChild(pushButton_Close_RB);
	XmStringFree(string);	

	string = XmStringCreateSimple("Draw");
	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString,string); argcnt++;
	XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
	XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
	XtSetArg(args[argcnt], XmNleftOffset, 40); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 100); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
	pushButton_Draw_RB = XtCreateWidget("pushButton",
		xmPushButtonWidgetClass,
		form_RB,
		args,
		argcnt);
	XtManageChild(pushButton_Draw_RB);
	XmStringFree(string);	

	/* Radiobox des Y  (a droite) */

	argcnt = 0;
	XtSetArg(args[argcnt], XmNpacking, XmPACK_COLUMN); argcnt++;
	XtSetArg(args[argcnt], XmNradioAlwaysOne, True); argcnt++;
	XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
	XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
	XtSetArg(args[argcnt], XmNnumColumns, 1); argcnt++;
	XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNtopOffset, 50); argcnt++;
	XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
	XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
	XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 148); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 363); argcnt++;
	radioBox4 = XtCreateWidget("radioBox4",
		xmRowColumnWidgetClass,
		form_RB,
		args,
		argcnt);
	XtManageChild(radioBox4);

	string = XmStringCreateSimple("Y Axis");
	argcnt = 0;
	XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_CENTER); argcnt++;
	XtSetArg(args[argcnt], XmNlabelString,string); argcnt++;
	XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
	XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
	XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNrightOffset, 26); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 160); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 40); argcnt++;
	labelX1 = XtCreateWidget("labelX1",
		xmLabelWidgetClass,
		form_RB,
		args,
		argcnt);
	XtManageChild(labelX1);
	XmStringFree(string);	

	argcnt = 0;
	XtSetArg(args[argcnt], XmNpacking, XmPACK_COLUMN); argcnt++;
	XtSetArg(args[argcnt], XmNradioAlwaysOne, True); argcnt++;
	XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
	XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
	XtSetArg(args[argcnt], XmNnumColumns, 1); argcnt++;
	XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
	XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
	XtSetArg(args[argcnt], XmNtopOffset, 50); argcnt++;
	XtSetArg(args[argcnt], XmNleftOffset, 30); argcnt++;
	XtSetArg(args[argcnt], XmNx, 30); argcnt++;
	XtSetArg(args[argcnt], XmNy, 50); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 148); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 363); argcnt++;
	radioBox2 = XtCreateWidget("radioBox2",
		xmRowColumnWidgetClass,
		form_RB,
		args,
		argcnt);
	XtManageChild(radioBox2);

	string = XmStringCreateSimple("X Axis");
	argcnt = 0;
	XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
	XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
	XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
	XtSetArg(args[argcnt], XmNlabelString, string); argcnt++;
	XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
	XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
	XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
	XtSetArg(args[argcnt], XmNleftOffset, 32); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 160); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 40); argcnt++;
	labelY1 = XtCreateWidget("labelY1",
		xmLabelWidgetClass,
		form_RB,
		args,
		argcnt);
	XtManageChild(labelY1);
	XmStringFree(string);	


	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string1); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX20 = XtCreateWidget("toggleButtonX20",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX20);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string2); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX21 = XtCreateWidget("toggleButtonX21",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX21);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string3); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX22 = XtCreateWidget("toggleButtonX22",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX22);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string4); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX23 = XtCreateWidget("toggleButtonX23",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX23);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string5); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX24 = XtCreateWidget("toggleButtonX24",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX24);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string6);  argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX25 = XtCreateWidget("toggleButtonX25",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX25);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string7);  argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX26 = XtCreateWidget("toggleButtonX26",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX26);


	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string8); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX27 = XtCreateWidget("toggleButtonX27",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX27);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string9); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX28 = XtCreateWidget("toggleButtonX28",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX28);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string10); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX29 = XtCreateWidget("toggleButtonX29",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX29);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string11); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX40 = XtCreateWidget("toggleButtonX40",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX40);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string12); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX41 = XtCreateWidget("toggleButtonX41",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX41);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string13); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX42 = XtCreateWidget("toggleButtonX42",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX42);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string14); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX43 = XtCreateWidget("toggleButtonX43",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX43);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string15); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX44 = XtCreateWidget("toggleButtonX44",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX44);

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string14); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX45 = XtCreateWidget("toggleButtonX45",
		xmToggleButtonWidgetClass,
		radioBox2,
		args,
		argcnt);
	XtManageChild(toggleButtonX45);
#endif

	/*-----Y axis----*/

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string1); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX30 = XtCreateWidget("toggleButtonX30",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX30);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string2); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX31 = XtCreateWidget("toggleButtonX31",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX31);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string3); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX32 = XtCreateWidget("toggleButtonX32",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX32);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string4); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX33 = XtCreateWidget("toggleButtonX33",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX33);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string5); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX34 = XtCreateWidget("toggleButtonX34",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX34);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string6); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX35 = XtCreateWidget("toggleButtonX35",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX35);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string7); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX36 = XtCreateWidget("toggleButtonX36",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX36);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string8); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX37 = XtCreateWidget("toggleButtonX37",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX37);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string9); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX38 = XtCreateWidget("toggleButtonX38",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX38);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string10); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX39 = XtCreateWidget("toggleButtonX39",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX39);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string11); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX50 = XtCreateWidget("toggleButtonX50",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX50);
	
	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string12); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX51 = XtCreateWidget("toggleButtonX51",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX51);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string13); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX52 = XtCreateWidget("toggleButtonX52",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX52);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string14); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX53 = XtCreateWidget("toggleButtonX52",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX53);

	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string15); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX54 = XtCreateWidget("toggleButtonX52",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX54);

#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	argcnt = 0;
	XtSetArg(args[argcnt], XmNlabelString, string14); argcnt++;
	XtSetArg(args[argcnt], XmNwidth, 142); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	toggleButtonX55 = XtCreateWidget("toggleButtonX55",
		xmToggleButtonWidgetClass,
		radioBox4,
		args,
		argcnt);
	XtManageChild(toggleButtonX55);

#endif


	XmStringFree(string1);
	XmStringFree(string2);
	XmStringFree(string3);
	XmStringFree(string4);
	XmStringFree(string5);
	XmStringFree(string6);
	XmStringFree(string7);
	XmStringFree(string8);
	XmStringFree(string9);
	XmStringFree(string10);
	XmStringFree(string11);
	XmStringFree(string12);
	XmStringFree(string13);
	XmStringFree(string14);
	XmStringFree(string15);
#ifdef ADD_CURRENT

/*--------   To add a current copy, modify and adapt   -------*/
	XmStringFree(string16);
#endif

	XtRealizeWidget(Top_Level_RB);

	if (set_g_Na || set_g_Nap || set_g_K || set_g_M || set_g_A || set_g_C || set_g_ahp || set_g_H ||
	    set_g_Ca || set_g_Cab)
	{
	  XtSetSensitive(toggleButtonX43, True);
	  XtSetSensitive(toggleButtonX44, True);
	  XtSetSensitive(toggleButtonX53, True);
	  XtSetSensitive(toggleButtonX54, True);
	}
	else
	{
	  XtSetSensitive(toggleButtonX43, False);
	  XtSetSensitive(toggleButtonX44, False);
	  XtSetSensitive(toggleButtonX53, False);
	  XtSetSensitive(toggleButtonX54, False);
	}

	XtAddCallback(toggleButtonX20, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)0);
	XtAddCallback(toggleButtonX21, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)1);
	XtAddCallback(toggleButtonX22, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)2);
	XtAddCallback(toggleButtonX23, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)3);
	XtAddCallback(toggleButtonX24, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)4);
	XtAddCallback(toggleButtonX25, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)5);
	XtAddCallback(toggleButtonX26, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)6);
	XtAddCallback(toggleButtonX27, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)7);
	XtAddCallback(toggleButtonX28, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)8);
	XtAddCallback(toggleButtonX29, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)9);
	XtAddCallback(toggleButtonX40, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)10);
	XtAddCallback(toggleButtonX41, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)11);
	XtAddCallback(toggleButtonX42, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)12);
	XtAddCallback(toggleButtonX43, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)13);
	XtAddCallback(toggleButtonX44, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)14);
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt   -------*/
	XtAddCallback(toggleButtonX42, XmNvalueChangedCallback, (XtPointer)retour_X_graphs, (XtPointer)15);
#endif

	XtAddCallback(toggleButtonX30, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)0);
	XtAddCallback(toggleButtonX31, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)1);
	XtAddCallback(toggleButtonX32, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)2);
	XtAddCallback(toggleButtonX33, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)3);
	XtAddCallback(toggleButtonX34, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)4);
	XtAddCallback(toggleButtonX35, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)5);
	XtAddCallback(toggleButtonX36, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)6);
	XtAddCallback(toggleButtonX37, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)7);
	XtAddCallback(toggleButtonX38, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)8);
	XtAddCallback(toggleButtonX39, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)9);
	XtAddCallback(toggleButtonX50, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)10);
	XtAddCallback(toggleButtonX51, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)11);
	XtAddCallback(toggleButtonX52, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)12);
	XtAddCallback(toggleButtonX53, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)13);
	XtAddCallback(toggleButtonX54, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)14);
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt   -------*/
	XtAddCallback(toggleButtonX52, XmNvalueChangedCallback, (XtPointer)retour_Y_graphs, (XtPointer)15);
#endif

	XtAddCallback(pushButton_Close_RB, XmNactivateCallback, (XtPointer)callback_close_RB, NULL);
	XtAddCallback(pushButton_Draw_RB, XmNactivateCallback, (XtPointer)callback_draw_RB, NULL);

	XtAddCallback(Top_Level_RB, XmNdestroyCallback, fermeture_RB, NULL);
	XtAddCallback(form_RB, XmNunmapCallback, fermeture_RB, NULL);

	if (colormap)
		XSetWindowColormap(disp, XtWindow(XtParent(form_RB)), palette);


	flag_RB = 1;
}
/*----------------------------------------------------------------*/
	void fabrique_drugs_box()
/*----------------------------------------------------------------*/
{
	int		argcnt = 0,
			i,
			j;

	Arg		args[20];
	
	XmString	string,
			string1,
			string2,
			string3;

#if DEBUG
	printf("fabrique_drug_box: %d\n",flag_DB);
#endif

	if(flag_DB != 0)
	{
		XtPopup(Top_Level_DB,XtGrabNone);
		return;
	} 


	/*---------- toplevel pour la fenetre des drogues ----------*/


	Top_Level_DB = XtCreateApplicationShell("topdrugbox",
						 topLevelShellWidgetClass,
						 args,
						 0);
	XtVaSetValues(Top_Level_DB,
		      XmNtitle, "Drugs choice",
		      XmNx, 500,
		      XmNy, 200,
		      XmNheight, 248,
		      XmNwidth, 200,
		      NULL);

		/*---- form pour les drogues ----*/

    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 300); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 248); argcnt++;
    form_DB = XtCreateWidget("formD",
		xmFormWidgetClass,
		Top_Level_DB,
		args,
		argcnt);
    XtManageChild(form_DB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 60); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 40); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 40); argcnt++;
    XtSetArg(args[argcnt], XmNrowColumnType, XmWORK_AREA); argcnt++;
    XtSetArg(args[argcnt], XmNx, 40); argcnt++;
    XtSetArg(args[argcnt], XmNy, 60); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 201); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 75); argcnt++;
    rowColumn_DB = XtCreateWidget("rowColumn",
		xmRowColumnWidgetClass,
		form_DB,
		args,
		argcnt);
    XtManageChild(rowColumn_DB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 140); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 140); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 280); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    separator_DB = XtCreateWidget("separatorD",
		xmSeparatorWidgetClass,
		form_DB,
		args,
		argcnt);
    XtManageChild(separator_DB);

    string = XmStringCreateSimple("Close");
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, string); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 26); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 50); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 50); argcnt++;
    XtSetArg(args[argcnt], XmNx, 50); argcnt++;
    XtSetArg(args[argcnt], XmNy, 177); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 179); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 45); argcnt++;
    pushButton_Close_DB = XtCreateWidget("pushButtoncloseDB",
		xmPushButtonWidgetClass,
		form_DB,
		args,
		argcnt);
    XtManageChild(pushButton_Close_DB);
    XmStringFree(string);	

    string = XmStringCreateSimple("Drugs");
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_CENTER); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, string); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 60); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 60); argcnt++;
    XtSetArg(args[argcnt], XmNx, 60); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 160); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 40); argcnt++;
    labelX_DB = XtCreateWidget("labelXD",
		xmLabelWidgetClass,
		form_DB,
		args,
		argcnt);
    XtManageChild(labelX_DB);
    XmStringFree(string);	


	string1 = XmStringCreateSimple("TTX "); 
	string2 = XmStringCreateSimple("No"); 
	string3 = XmStringCreateSimple("Yes"); 
	pushButtonTTX = XmVaCreateSimpleOptionMenu(rowColumn_DB,
		"TTX_OM",
		string1, 'X', 0, (XtPointer)retour_TTX,
		XmVaPUSHBUTTON, string2, 'Y', NULL, NULL,
		XmVaPUSHBUTTON, string3, 'N', NULL, NULL,
		NULL);
	XtManageChild(pushButtonTTX);
	
	argcnt = 0;
	XtSetArg(args[argcnt], XmNwidth, 200); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	XtSetValues(pushButtonTTX,args,argcnt);
	XmStringFree(string1);
	XmStringFree(string2);
	XmStringFree(string3);

	string1 = XmStringCreateSimple("TEA "); 
	string2 = XmStringCreateSimple("No"); 
	string3 = XmStringCreateSimple("Yes"); 
	pushButtonTEA = XmVaCreateSimpleOptionMenu(rowColumn_DB,
		"TEA_OM",
		string1, 'A', 0, (XtPointer)retour_TEA,
		XmVaPUSHBUTTON, string2, 'Y', NULL, NULL,
		XmVaPUSHBUTTON, string3, 'N', NULL, NULL,
		NULL);
	XtManageChild(pushButtonTEA);
	
	argcnt = 0;
	XtSetArg(args[argcnt], XmNwidth, 200); argcnt++;
	XtSetArg(args[argcnt], XmNheight, 33); argcnt++;
	XtSetValues(pushButtonTEA,args,argcnt);
	XmStringFree(string1);
	XmStringFree(string2);
	XmStringFree(string3);

	XtRealizeWidget(Top_Level_DB);

	XtAddCallback(pushButton_Close_DB, XmNactivateCallback, (XtPointer)callback_close_DB, NULL);

	XtAddCallback(Top_Level_DB, XmNdestroyCallback,(XtPointer)fermeture_DB, NULL);

	XtAddCallback(form_DB, XmNunmapCallback, (XtPointer)fermeture_DB, NULL);

	if (colormap)
		XSetWindowColormap(disp, XtWindow(XtParent(form_DB)), palette);


	flag_DB = 1;
}

#if 0

#include "equa_no_equa.xbm"

/*----------------------------------------------------------------*/
	void fabrique_equa_text(char *xbm_file)
/*----------------------------------------------------------------*/
{

	Pixmap	equa_bits;
	GC	eq_gc;
/*
	unsigned int equa_width, equa_height;
*/
	Pixel	fg, bg;
	FILE	*fp;
	
	XmString	string;
	Arg		args[20];
	int	status, i;
	int	hexa;
	int	hot_x, hot_y;
	int		ac = 0;
	char	*data_bits;
	Widget   scrolledWindow;
	Widget   form;
	Widget   equa_scrolledWindow;
	
    
#if DEBUG
	printf("fabrique_equation_text: %d\n",flag_equation);
#endif

	if(flag_equation)
	{
		XtPopup(Top_Level_Equation,XtGrabNone);
		return;
	} 



	/*---------- toplevel pour la fenetre des drogues ----------*/


	Top_Level_Equation = XtCreateApplicationShell("topequation",
						 topLevelShellWidgetClass,
						 args,
						 0);
	XtVaSetValues(Top_Level_Equation,
		      XmNtitle, "Equation for the selected current",
		      XmNx, 0,
		      XmNy, 0,
		      XmNheight, 500,
		      XmNwidth, 751,
		      NULL);

	/*
	 * Register the converters for the widgets.
	 */
	XtInitializeWidgetClass(xmScrolledWindowWidgetClass);
	XtInitializeWidgetClass(xmFormWidgetClass);
	XtInitializeWidgetClass(xmPushButtonWidgetClass);
	XtInitializeWidgetClass(xmTextWidgetClass);
	

	ac = 0;
	XtSetArg(args[ac], XmNscrollingPolicy, XmAUTOMATIC); ac++;
	XtSetArg(args[ac], XmNx, 0); ac++;
	XtSetArg(args[ac], XmNy, 0); ac++;
	XtSetArg(args[ac], XmNwidth, 751); ac++;
	XtSetArg(args[ac], XmNheight, 520); ac++;
	scrolledWindow = XmCreateScrolledWindow(Top_Level_Equation,
		"scrolledWindow",
		args, 
		ac);
	XtManageChild(scrolledWindow);
	
	ac = 0;
/*	XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;*/
	XtSetArg(args[ac], XmNwidth, 740); ac++;
	XtSetArg(args[ac], XmNheight, 490); ac++;
	form = XmCreateForm(scrolledWindow,
		"form",
		args, 
		ac);
	XtManageChild(form);
	
	string = XmStringCreateSimple("Close");
	ac = 0;
	XtSetArg(args[ac], XmNlabelString, string); ac++;
	XtSetArg(args[ac], XmNx, 250); ac++;
	XtSetArg(args[ac], XmNy, 450); ac++;
	XtSetArg(args[ac], XmNwidth, 260); ac++;
	XtSetArg(args[ac], XmNheight, 38); ac++;
	Equa_close = XmCreatePushButton(form,
		"equa_close",
		args, 
		ac);
	XtManageChild(Equa_close);
	XmStringFree(string);

	ac = 0;
	XtSetArg(args[ac], XmNscrollingPolicy, XmAPPLICATION_DEFINED); ac++;
	XtSetArg(args[ac], XmNx, 10); ac++;
	XtSetArg(args[ac], XmNy, 0); ac++;
	XtSetArg(args[ac], XmNwidth, 730); ac++;
	XtSetArg(args[ac], XmNheight, 415); ac++;
	equa_scrolledWindow = XmCreateScrolledWindow(form,
		"equa_scrolledWindow",
		args, 
		ac);
	XtManageChild(equa_scrolledWindow);

	ac = 0;
	XtSetArg(args[ac], XmNwidth, 500); ac++;
	XtSetArg(args[ac], XmNheight, 400); ac++;
	Equa_text = XmCreateDrawingArea( equa_scrolledWindow,
		"equa_text",
		args, 
		ac);
	XtManageChild(Equa_text);


	ac = 0;
	XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
	XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
	XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(args[ac], XmNtopWidget, equa_scrolledWindow); ac++;
	XtSetArg(args[ac], XmNbottomOffset, 30); ac++;
	XtSetArg(args[ac], XmNleftOffset, 250); ac++;
	XtSetArg(args[ac], XmNrightOffset, 250); ac++;
	XtSetValues(Equa_close, args, ac);
	
	ac = 0;
	XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
	XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
	XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
	XtSetArg(args[ac], XmNtopOffset, 0); ac++;
	XtSetArg(args[ac], XmNbottomOffset, 75); ac++;
	XtSetArg(args[ac], XmNleftOffset, 10); ac++;
	XtSetArg(args[ac], XmNrightOffset, 0); ac++;
	XtSetValues(equa_scrolledWindow, args, ac);

	XtAddCallback(Equa_close, XmNactivateCallback,(XtPointer) fermeture_equa_text, NULL);
	XtAddCallback(Equa_text, XmNexposeCallback,(XtPointer) expose_equa_text, NULL);
/*	XtAddCallback(Equa_text, XmNresizeCallback,(XtPointer) expose_equa_text, NULL);*/

	XtRealizeWidget(Top_Level_Equation);

	XtVaGetValues(Equa_text, XmNforeground, &fg, XmNbackground, &bg, NULL);


	if ((status = XReadBitmapFile(XtDisplay(Equa_text),
				       XtWindow(Equa_text),
				       xbm_file, &equa_width, &equa_height,
				       &equa_bits,
				       &hot_x, &hot_y)) != BitmapSuccess)
	{
#if DEBUG
		fprintf(stderr, "Error reading file %s (status = %d)\n",xbm_file,status);
#endif		
		equa_pix  = XCreatePixmapFromBitmapData(XtDisplay(Equa_text),
							XtWindow(Equa_text),
							equa_no_equa_bits,
							equa_no_equa_width, equa_no_equa_height,
							fg, bg,
							DefaultDepth(XtDisplay(Equa_text), DefaultScreen(XtDisplay(Equa_text))));

		equa_width = equa_no_equa_width;
		equa_height = equa_no_equa_height;
		eq_gc = DefaultGC(XtDisplay(Equa_text), DefaultScreen(XtDisplay(Equa_text))); 
	} /* fin du if */
	else
	{
#if DEBUG
		fprintf(stderr, "File %s OK\n",xbm_file);
#endif		
		equa_pix = XCreatePixmap(XtDisplay(Equa_text), XtWindow(Equa_text), equa_width, equa_height,1);

		eq_gc = XCreateGC(XtDisplay(Equa_text), equa_pix, 0, 0);

		XSetForeground(XtDisplay(Equa_text),eq_gc, 0);

		XCopyArea(XtDisplay(Equa_text), equa_bits, equa_pix,
			   eq_gc,
			   0, 0,
			   equa_width, equa_height,
			   0, 0);

		if (equa_bits) XFreePixmap(XtDisplay(Equa_text), equa_bits);

	} /* fin du else */

	ac = 0;
	XtSetArg(args[ac],XmNx, 0); ac++;
	XtSetArg(args[ac],XmNy, 0); ac++;
	XtSetValues(Top_Level_Equation, args, ac);

	XFlush(XtDisplay(Equa_text));
	flag_equation = 1;
}
#endif
