
#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- 8 modifications in this file -------------*/

#endif

/* -------------------------------------------------------------------------------------------------- 
 *		G _ N E U R O N . H                           
/* -------------------------------------------------------------------------------------------------- */

/* declaration des variables globales concernant le neurone */

#include <stdlib.h>
#include <stdio.h>

#ifdef MAIN
#	define	CLASS
#else
#	define	CLASS	extern
#endif

#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt  -------*/
/*---------- Think to increase the version number -----------*/

#endif

#define VERSION "V9.5"

#define PLOT_SIZE	          21

#define EXPONENTIELLE             1
#define RUNGE_KUTTA               2
#define RUNGE_KUTTA_VARIABLE_STEP 3
#define EULER                     4
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
#define INT_METHOD                5
#endif

#define MICHAELIS_MENTON_MODEL    1
#define HH_SIMPLE_MODEL           2
#define HH_PUMP_MODEL             3
#define XNBC_MODEL		  4
#define LEAKY_INTEG_MODEL	  5
#define COND_BURST_MODEL	  6

#ifdef ADD_A_MODEL
/* Adapt here with the new method */
#define NEW_MODEL                 7
#endif

#define CRT_CRT                   0
#define ISI_RATE                  1
#define CRT_ISI                   2
#define CRT_RATE                  3

#define MAX_RECURRENCE            5

#define NB_MAX_RECEPTORS          5

#define MAX_SHUNT                 100

#define HORIZONTAL                0
#define VERTICAL                  1

#define i_taubar_l  1700.0e-3
#define i_taubar_r  2000.0e-3

CLASS
double   taubar_l,
         taubar_r;


CLASS
int    * tab_type_value,       /* pointer sur une liste de type d`evenement pour la lecture de fichiers tms */   
       * tab_type_ponderation; /* pointer sur une liste de poids des evenement pour la lecture de fichiers tms */

CLASS
float	

    * potentiel_E_Na,
    * potentiel_E_K,
    * potentiel,
	* ramp_input,
    * le_seuil,
	* courant_global,
	* courant_K,
	* courant_Na,
	* courant_Ia,
	* courant_Im,
	* courant_Ih,
	* courant_Ca,
	* courant_Iahp,
	* courant_Ic,
	* courant_Nap,
	* courant_Cab,
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt  -------*/
	* courant_New,
#endif
	* Ca,
	* X_graph,
	* Y_graph,
	* V_graph,
	* M_graph,
	* le_temps,
	* valeur_m,
	* valeur_h,
	* synaptique,
	* les_spikes,
        * les_intervalles,
        * l_histogramme,
	activ[PLOT_SIZE],
	tau_activ[PLOT_SIZE],
	inactiv[PLOT_SIZE],
	tau_inactiv[PLOT_SIZE],
	coeff_G[PLOT_SIZE],
	voltage[PLOT_SIZE];

CLASS
int	neurotransmitor;

CLASS
int     nb_receptors;

CLASS
float	
        param_l,                /* parametre pour le calcul de INa avec le model HH PUMP */   
        param_r,                /* parametre pour le calcul de IK avec le model HH PUMP  */   

        delai_recurrence,       /* parametre de delai pour la recurrence */
        ponderation_recurrence, /* parametre de ponderation pour la recurrence */ 

        rest_pot,	/* resting potential du cluster */
	decay_mb_pot,	/* decroissance du pot de mb */
	g_tot,		/* Conductance totale de la mb */
	input_current,	/* injection de courant */
	input_volt,	/* injection de potentiel */
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt  -------*/
	g_New,		/* conductance New */
	G_New,		/* conductance totale du courant New */
	I_New,		/* Fast New Current*/
	m_New,		/* variable d'ouverture des canaux New */
	h_New,		/* variable de fermeture des canaux New */
	tau_New,	/* cste de temps de g_New */
	E_New,		/* Potentiel d'equilibre du New */
#endif
	g_Na,		/* conductance Na */
	G_Na,		/* conductance totale du courant sodique */
	I_Na,		/* Fast Sodium Current*/
	m_Na,		/* variable d'ouverture des canaux Na */
	h_Na,		/* variable de fermeture des canaux Na */
	tau_Na,		/* cste de temps de g_Na */
	g_K,		/* conductance K */
	G_K,		/* conductance totale de la rectification
				retardee*/
	I_K,		/* courant K de la rectification retardee */
	m_K,		/* variable d'ouverture des canaux K */
	h_K,		/* variable de fermeture des canaux K*/
	tau_K,		/* cste de temps de g_K */
        Temp,           /* Temperature durant la simulation */
        Na_ext,         /* concentration extracellulaire de sodium */
        Na_int,         /* concentration intracellulaire de sodium */
        K_ext,          /* concentration extracellulaire de potassium */
        K_int,          /* concentration intracellulaire de potassium */
        Cl_ext,         /* concentration extracellulaire de Clore */
        Cl_int,         /* concentration intracellulaire de Clore */
	Ca_i,	        /* concentration en calcium intracellulaire */
	g_Ca,		/* conductance Ca */
	G_Ca,		/* conductance totale du courant calcique */
	I_Ca,		/* Fast Calcium Current*/
	m_Ca,		/* variable d'ouverture des canaux Ca */
	h_Ca ,		/* variable de fermeture des canaux Ca */
	tau_Ca,		/* cste de temps de g_Ca */
	tau_decay_Ca,	/* cste de temps de  l'absorption du Ca
				intra cellulaire */
	g_Cl,		/* conductance Cl */
	G_Cl,		/* conductance totale du courant Chlore */
	I_Cl,		/* courant Cl */
	m_Cl,		/* variable d'ouverture des canaux Cl */
	h_Cl,		/* variable de fermeture des canaux Cl */
	tau_Cl,		/* cste de temps de g_Cl */
	g_A,		/* conductance K pour le courant Ia */
	G_A,		/* conductance totale de K pour le
			courant Ia */
	I_A,		/* courant Ia*/
	m_A,		/* variable d'ouverture des canaux K pour le
			courant Ia */
	h_A,		/* variable de fermeture des canaux K pour le
			courant Ia */
	tau_A,		/* cste de temps de g_A */
	g_M,		/* conductance k pour le courant Im */
	G_M,		/* conducatnce totale de K pour le courant Im */
	I_M,		/* courant Im non inactivable*/
	m_M,		/* variable d'ouverture des canaux k pour le
			courant Im */
	tau_M,		/* cste de temps de g_M */
	g_C,		/* conductance K pour le courant Ic */
	G_C,		/* courant k calcium dependant non inactivable */
	m_C,		/* variable d'ouverture des canaux k pour le
			courant Ic */
	tau_C,		/* cste de temps de g_C */
	I_C,		/* courant K calcium et voltage dependant non
			inactivable*/
	g_H,		/* conductance K pour le courant Ih */
	G_H,		/* courant k rectification entrante Ih */
	m_Ih,		/* variable d'ouverture des canaux k pour le
			courant Ic */
	tau_Ih,		/* cste de temps de g_C */
	I_H,		/* courant K calcium et voltage dependant non
			inactivable*/
	g_ahp,		/* conductance k pour le courant Iahp */
	G_ahp,		/* conductance totale du K pour le courant Iahp */
	I_ahp,		/* courant K calcium dependant
			voltage independant*/
	m_ahp,		/* variable d'ouverture des canaux k pour le
			courant Iahp */
	tau_ahp,	/* cste de temps de g_ahp */
	g_Nap,		/* conductance Na persistant */
	G_Nap,		/* conductance totale du courant sodique persistant */
	I_Nap,		/* Persistant Sodium Current*/
	m_Nap,		/* variable d'ouverture des canaux Na persistants */

	g_Cab,		/* conductance Ca LVA */
	G_Cab,		/* conductance totale du courant Ca LVA */
	I_Cab,		/* Ca LVA Current*/
	m_Cab,		/* variable d'ouverture des canaux Ca LVA */
	h_Cab,		/* variable de fermeture des canaux Ca LVA */

	g_fuite,	/* conductance du courant de fuite*/
	G_fuite,	/* conductance totale pour le courant de fuite */
	I_fuite,	/* courant de fuite */

        P_bar_Na,       /* permeabilite pour Na */
        P_bar_K,        /* permeabilite pour K */
        I_P,            /* courant de pompe */
        G_P,            /* conductance totale pour le courant de pompe */

        I_LNa,          /* courant de fuite pour Na */
        I_LK,           /* courant de fuite pour K  */
        I_LCl,          /* courant de fuite pour Cl */
	
        GL_Na,          /* conductance totale pour le courant de fuite en sodium */          
        GL_K,           /* conductance totale pour le courant de fuite en potassium */
        GL_Cl,          /* conductance totale pour le courant de fuite en chlore */
        g_Syn_pos,	/* conductance du courant synaptique*/
	g_Syn_neg,	/* conductance du courant synaptique*/
	G_Syn_pos,		/* conductance totale pour le
			courant synaptique */
	G_Syn_neg,		/* conductance totale pour le
			courant synaptique */
	I_Syn_pos,		/* courant synaptique */
	I_Syn_neg,		/* courant synaptique */
	
	

    E_K,		/* Potentiel d'equilibre du potassium */
	K_rest,		/* Concentration de K au repos */
	E_Na,		/* Potentiel d'equilibre du sodium */
	E_Cl,		/* Potentiel d'equilibre du chlore */
	E_Ca,		/* Potentiel d'equilibre du calcium */
	E_H,		/* Potentiel d'equilibre du courant H */
	E_Goldman,	/* Potentiel de repos calcul avec l'equation de Goldman */
	Ca_Influx,	/* Vitesse d'entree du calcium */
	Ca_Removal,	/* Vitesse de sortie du calcium */
	Ca_Kd,		/* Constante de dissociation du calcium */
	K_Ca_Kd,	/* Constante de dissociation du calcium pour l'activation de I_K */
	lambda_Ik,	/* Parametre de controle de Tau maximal pout K */
	lambda_Im,	/* Parametre de controle de Tau maximal pout Im */
	lambda_Ic,	/* Parametre de controle de Tau maximal pout Ic */
	lambda_Ih,	/* Parametre de controle de Tau maximal pout Ih */
	lambda_Inap,	/* Parametre de controle de Tau maximal pout Inap */
	lambda_Icab,	/* Parametre de controle de Tau maximal pout Icab */
	tau_m_cab,	/* Tau de l'activation de ICab */

	g_fuite_Na,		/* conductance fuite_Na */
	I_fuite_Na,		/* Fast fuite_Na Current*/

	g_fuite_K,		/* conductance fuite_K */
	I_fuite_K,		/* Fast fuite_K Current*/

	E_fuite,	/* Potentiel d'equilibre du aux
			courants de fuite */
	E_Syn_pos,		/* Potentiel d'equilibre du
			courant synaptique */
	E_Syn_neg,		/* Potentiel d'equilibre du
			courant synaptique */
	courant_tot,	/* courant total traversant la mb */
	rev_pot_pos,	/* potentiel de reversion positif */
	rev_pot_neg,	/* potentiel de reversion negatif */
	input_fact,	/* stimulation additionelle           */
        input_current,  /* son effet en courant               */
        input_voltage,  /* son effet en voltage               */
	time_step,      /* duree d'un pas d'echantillonnage   */
	tau_attack_epsp,	/* constante de temps de montee du pps */
	tau_decay_epsp,	/* constante de temps de descente du pps */
	tau_attack_ipsp,	/* constante de temps de montee du pps */
	tau_decay_ipsp,	/* constante de temps de descente du pps */
	backgrd_noise_m,	/* moyenne du bruit de fond */
	backgrd_noise_sd,	/* sd du bruit de fond */
	backgrd_noise_resistance,	/* la resistance pour le filtre Kohn du bruit de fond */
        noise,                  /* le bruit instantane */
	spike_slope,		/* pente de detection des spikes */
	clamp_pot,	/* potentiel de clamp */

			/*
			 * variable globales pour la sigmoide
			 * d'activation/inactivation
			 */

	V_Na,		/* V 1/2 pour la Na */
	A_Na,		/* coeff a pour le Na */
	Pow_Na,		/* Exposant pour le Na */
	V_K,		/* V 1/2 pour la K */
	A_K,		/* coeff a pour le K */
	Pow_K,		/* Exposant pour le K */
	V_Ca,		/* V 1/2 pour la Ca */
	A_Ca,		/* coeff a pour le Ca */
	Pow_Ca,		/* Exposant pour le Ca */
	Tau_Ca,		/* Cste de temps pour le Ca */
	V_Ia_A,		/* V 1/2 pour Ia activation */
	A_Ia_A,		/* coeff a pour Ia activation */
	Pow_Ia_A,	/* Exposant pour Ia activation */
	V_Ia_B,		/* V 1/2 pour Ia inactivation */
	A_Ia_B,		/* coeff a pour Ia inactivation */
	Pow_Ia_B,	/* Exposant pour Ia inactivation */
	Tau_Ia_B,	/* Cste de temps pour Ia inactivation */
	V_Im,		/* V 1/2 pour Im  (potentiel du point d'inflexion) */
	A_Im,		/* coeff a pour Im (pente de la sigmoide) */
	V_Ic,		/* V 1/2 pour Ic (potentiel du point d'inflexion) */
	A_Ic,		/* coeff a pour Ic (pente de la sigmoide) */
	V_Inap,		/* V 1/2 pour INap (potentiel du point d'inflexion) */
	A_Inap,		/* coeff a pour INap (pente de la sigmoide) */
	Pow_m_cab,	/* Exposant pour ICab activation */
	Vm_Icab,	/* V 1/2 pour INap (potentiel du point d'inflexion) */
	Am_Icab,	/* coeff a pour INap (pente de la sigmoide) */
	Vh_Icab,	/* V 1/2 pour Icab (potentiel du point d'inflexion) */
	Ah_Icab,	/* coeff a pour Icab (pente de la sigmoide) */
	V_Ih,		/* V 1/2 pour Ih (potentiel du point d'inflexion) */
	A_Ih,		/* coeff a pour Ih (pente de la sigmoide) */

#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt  -------*/
	V_INew_A,	/* V 1/2 pour INew activation */
	A_INew_A,	/* coeff a pour INew activation */
	Pow_INew_A,	/* Exposant pour INew activation */
	V_INew_B,	/* V 1/2 pour INew inactivation */
	A_INew_B,	/* coeff a pour INew inactivation */
	Pow_INew_B,	/* Exposant pour INew inactivation */
	Tau_INew_B,	/* Cste de temps pour INew inactivation */
	lambda_INew,	/* Parametre de controle de Tau maximal pour New */
#endif
        JpNa,           /* Capacite max de la pompe Na+ */
	V_INa_A,	/* V 1/2 pour INa activation */
	A_INa_A,	/* coeff a pour INa activation */
	Pow_INa_A,	/* Exposant pour INa activation */
	V_INa_B,	/* V 1/2 pour INa inactivation */
	A_INa_B,	/* coeff a pour INa inactivation */
	Pow_INa_B,	/* Exposant pour INa inactivation */
	Tau_INa_B,	/* Cste de temps pour INa inactivation */
        Tau_INa_A,      /* Cste de temps pour INa activation */
	lambda_INa,	/* Parametre de controle de Tau maximal pour Na */



			/* variables globales pour le NMDA */
			
	g_NMDA,		/* conductance NMDA */
	G_NMDA,		/* conductance totale NMDA */
	I_NMDA,		/* Courant NMDA	*/
	tau_attack_NMDA,/* constante de temps 1 */
	tau_decay_NMDA,	/* constante de temps 2 */
	eta_NMDA,	/* coefficient liant la conductance des canaux
			   sensibles au NMDA a la concentration en magnesium */
	gamma_NMDA,	/* coefficient de dependance au voltage des canaux NMDA */
	magnesium,	/* concentration en Mg++ extracellulaire */
	rev_pot_NMDA;	/* potentiel d'inversion du courant NMDA */

CLASS
float	Ca_i_init,	/* Valeurs initiales */
	m_ahp_init,
	m_K_init,
        h_Na_init,
	m_Nap_init,
	le_potentiel_init,
	le_potentiel_E_Na_init,
	le_potentiel_E_K_init,
	m_Ca_init,
	m_Ih_init,
	m_Cab_init,
	h_Cab_init,
	h_A_init,
        param_l_init,
        param_r_init,

#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt  -------*/
	m_New_init,
	h_New_init,
#endif
        diametre,	/* diametre de la cellule en microm */
	surface_normalisee,	/* surface de la cellule en cm2 */
	surface ;	/* surface de la cellule en cm2 */

CLASS
int	nb_connexions_NMDA,	/* nbre de connections */
	no_NMDA,        	/* n de connection */
	number_of_event,       /* nombre de spikes lue dans un fichier tms */
        nb_detected_spikes,      /* nombre de spikes detecte apres calcul */     
        nb_detected_spikes_old,  /* ancien nombre de spikes detecte apres calcul */    
        nb_spikes,               /* nombre de spikes dans la table */
        taille_tab_syn;

CLASS
short  	spike,		  /* flag */
	spike_en_cours,	  /* flag */
        integration_type, /* type d'integration (flag) */
        model_type,       /* type de model demande (flag) */
	voltage_clamp,	  /* on veut du voltage clamp */
	voltage_impose;	  /* on est arrive a la valeur voulue	*/

CLASS
char	f_neur[256],      /* nom du fichier nouveau */
	f_neur_old[256],  /* nom du fichier ancien*/
	buffer[256],      /* buffer de lecture */
        buffer1[256],
	help_dir[256],	  /* help directory */
        project_directory[256], /* comme c'est dit! */
        model_name[100],  /* name of the model type */
	choix_file;

CLASS
FILE	*p_neur,          /* pointeur sur fichier ancien puis nouveau   */
        *p_tms;



CLASS
float 	le_potentiel,	/* en fait le soma */
        le_potentiel_E_Na,
        le_potentiel_E_K, 
	la_spike,	/* pour dessiner la detection de spike */
        resistance,     /* pour le bruit a la kohn */
	capacite;	/*capacite de la cellule en farads*/

CLASS
char	
        flag_affiche,
        flag_button,
        flag_button_NMDA,
        static_update,
        superimpose,
	draw_currents,
        recurrentEPSP,
        flag_recurrentEPSP,
        flag_OutputFile,
        flag_InputFile,
        flag_OutputSelectionBox,
        flag_InputSelectionBox,
        flag_Tms_Input,
        flag_Tms_Output,
        flag_spike_detect,
        flag_spike_visible,
        flag_horizontal,
        flag_phenom,
        flag_button_fixed_duration_stim,
        flag_PSP,
	flag_NMDA,
	flag_Inputs,
	flag_conductance,
	flag_Phenom,
	flag_activ,
	flag_init,
	flag_equilibrium,
	flag_simulation,
        flag_echelles,
        flag_transmitors,
        flag_receptors,
	flag_no_update,
	flag_drugs,
	flag_equation,
	flag_RB,
	flag_DB,
	flag_XY,
	flag_M_H_TAU,
        filter_noise,
        less_fatigue,
        plot_type,
	set_g_Na,
	set_g_Nap,
	set_g_K,
	set_g_C,
	set_g_M,
	set_g_A,
	set_g_ahp,
	set_g_Ca,
	set_g_Cab,
	set_g_H,
	set_g_fuite,
	set_g_NMDA,
	set_g_Syn_pos,
	set_g_Syn_neg,
	set_capacite,
	set_g_fuite_Na,
	set_g_fuite_K,
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt  -------*/
	set_g_New,
#endif
	set_p_p_rest_pot,
	set_p_pot_post_spike,
	set_p_seuil,
	set_p_seuil_post_spike,
	set_p_tau_seuil,
	set_p_shunt_tau,
	set_p_burst_post_spike,
	set_p_tau_mb_pot,
	set_p_freq_spike,
	set_p_freq_max,
	set_p_compose_fact,
	set_p_duree_burst_min,
	set_p_duree_burst_max,
	set_p_seuil_burst,
	set_p_fatigue,
        keep;

/* The phenomenologic models */

CLASS   float p_rest_pot;              /* pot de repos */
CLASS   float pot_post_spike;          /* pot mb post spike */
CLASS   float tau_mb_pot;              /* mb time constant */
CLASS   float i_tau_mb_pot;            /* 1/mb time constant */
CLASS   float seuil;                   /* seuil de declenchement des spikes normaux */
CLASS   float seuil_post_spike;        /* post spike firing threshold */
CLASS   float tau_seuil;               /* firing threshold time constant post spike */
CLASS   float i_tau_seuil;             /* 1/firing threshold time constant post spike */
CLASS   float overshoot;               /* post spike overshoot (rest - post_spike) */
CLASS   float shunt_values[MAX_SHUNT];
CLASS   float shunt_tau;              /* mb shunt time constant */
CLASS   float burst_post_spike;       /* pot mb post spike pendant le burst */
CLASS   float burst_overshoot;        /* post spike overshoot (seuil_burst - burst_post_spike) */
CLASS   float freq_spike;             /* frequence intra burst de base (spk/s) */
CLASS   float freq_max;               /* frequence max si plusieurs inouts (spk/s) */
CLASS   float compose_fact;           /* facteur de composition des bursts */
CLASS   float duree_burst_min;        /* duree min des bursts (ms) */
CLASS   float duree_burst_max;        /* duree max des bursts (ms) */
CLASS   float burst_range;            /* duree max-min des bursts (ms) */
CLASS   float seuil_burst;            /* seuil de declenchement des burst */
CLASS   float decharge_lag;
CLASS   float soma_post_spike;
CLASS   float seuil_peak;
CLASS   float delta_seuil;
CLASS   float center_noise;

CLASS   float K_rev_p;
CLASS   float K_rev_n;
CLASS   float fatigue;

CLASS   float threshold; 
CLASS   float soma; 
CLASS   float v_plus;
CLASS   float v_moins;
CLASS   float v_rap;
CLASS   float A;
CLASS   float filter_a;
CLASS   float filter_b;

CLASS   int frequence;
CLASS   int in_burst;
CLASS   int   spike_suivante;         /* moment de la prochaine spike */
CLASS   int   sablier[50];            /* le temps qui reste a chaque burst */
CLASS   int   nb_sabliers;            /* nombre de sabliers (nb de bursts imbriques) */

CLASS			
char	drug_TTX,	/* les drogues */
	drug_TEA;
	

CLASS
int	old_duree_simul,/* duree de la simulation en ms (le coup d`avant)*/
        duree_simul,	/* duree de la simulation en ms */
	fin_stim,       /* fin de la stimulation en ms */
	debut_stim,	/* debut de la stimulation en ms */
        duree_stim,	/* duree de la stimulation en ms */
	table_size,	/* taille des tableaux de valeurs */
        nb,
	nb_connexions;	/* nombre de connexions recues par
			le neurone */
     
CLASS
int	no_connexion;

CLASS
char	nom_fichier_neuron[256],
        nom_fichier_tms_input[256],
        nom_fichier_tms_output[256];

CLASS
int	colormap;

#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt  -------*/
/*----------- Set #define NB_EQUA_DIFF at 1 or 2 more -----------*/ 
#define NB_EQUA_DIFF	18
#endif

#define NB_EQUA_DIFF	16

#define	d_V	        0
#define	d_m_K	        1
#define	d_m_Ca	        2
#define	d_h_A	        3
#define	d_m_M	        4
#define	d_m_C   	5
#define	d_m_Ih  	6
#define	d_m_Nap 	7
#define	d_m_Cab 	8
#define	d_h_Cab 	9
#define	d_Ca_i  	10
#define	d_K_ext 	11
#define	d_l     	12
#define	d_r     	13
#define	d_h_Na     	14
#define	d_m_Na     	15
#ifdef ADD_CURRENT
/*--------   To add a current copy, modify and adapt  -------*/
#define	d_m_New 	16
#define	d_h_New 	17

#endif

CLASS
float	neur_param_avant[NB_EQUA_DIFF],
	neur_param_apres[NB_EQUA_DIFF];

CLASS
void    (*update_neurone)(int),
        update_expon(int),
        update_r_k(int),
        update_r_k_v_s(int),
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
        update_int_method(int),
#endif
        update_euler(int),
        update_xnbc(int),
        update_leaky(int),
        update_cond(int);

CLASS
void    (*calcul_neuron)(void),
        calcul_neuron_conduct(void),
        calcul_neuron_phenom(void);

CLASS
void    (*draw_neuron)(int),
        draw_neuron_conduct(int),
        draw_neuron_phenom(int);

CLASS
void    toggle_representation(int);


CLASS
int     w_x_0, w_y_0, /* X and Y position of the left windows */
        w_x_1, w_y_v1, w_y_h1, /* X and Y position of the ritght windows */
        file_saved,
        file_tms_saved,
        filename_given;
	
#include "G_receptor.h"

CLASS
RECEPTOR Receptors[NB_MAX_RECEPTORS];











