#define DEBUG 0
/* 
 *SCIENCE ACTIVE is to have a window less hightin order to left space for an additional window to give exercise
*/
#define SCIENCE_ACTIVE 0

#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- 3 modifications in this file -------------*/

#endif

/* --------------------------------------------------------------------------------------
			G_NEURON8.C

			V8.11 26 nov 1999 JFV:     Modification of time step warning boxes
			V8.12 30 nov 1999 JFV:     Change of warning panel titles.
			V8.13  2 dec 1999 JFV:      pannel not disapearing under linux. Fixed
			V8.14  3 dec 1999 JFV:      Receptor disapearing under linux. Fixed
			V8.16  7 jun 2000 JFV:      Old PSP parameters kept for compatibility

			V9.0   25 aug 2000 JFV:     Merging of P_neuron and G_neuron
			V9.1   20 mar 2001 JFV:     Continuing...
			V9.2   27 mar 2001 JFV:     Continuing...
			V9.2   28 mar 2001 JFV:     Continuing...
			V9.3   31 aug 2001 JFV:     If called as G_neuronP, starts in P mode
			V9.4   28 aug 2005 JFV:     port to cygwin
			V9.5   31 jan 2006 JFV:     Corrections de bugs (ipsps) + adjonction E_Goldman
   ------------------------------------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define MAIN
#  include "G_neuron.h"
#  include "G_interface.h"
#  include "G_reference.h"
#  include "G_synap.h"
#  include "G_ref_icon.h"
#  include "G_main.h" 
#  include "find_files.h"
#undef MAIN

char	X_legend[50],
	Y_legend[50];

char	V_legend[50],
	M_legend[50];


void sortie();
void retour_file(Widget, int);
void retour_parameters(Widget, int);
void retour_transmitors(Widget, int);
void retour_graphs(Widget, int);
void retour_analysis(Widget, int);
void retour_options(Widget, int);
void retour_pullright1_options(Widget, int);
void retour_pullright2_options(Widget, int);

void retour_integration(Widget, int);
void retour_drugs(Widget, int);
void fabrique_drugs_box();
void selection_fichier();
void selection_fichier_tms();

REFERENCE	ref1,
		ref2,
		ref3,
		refXY,
		refM_H_TAU;

float   	reference1_max, reference1_min,
		reference2_max_p, reference2_min_p,
		reference3_max_p, reference3_min_p,
		reference2_max_g, reference2_min_g,
		reference3_max_g, reference3_min_g;

int	NOIR = 99,
	ROUGE = 100,
	BLEU = 101,
	VERT = 102,
	VIOLET = 103,
	MAUVE = 104,
	TURQ = 105,
	JAUNE = 106,
	BLANC = 107;

int	debug,
        keep_ps = 0;
/*------------------------------------------------------------------------------
				MAIN
  ----------------------------------------------------------------------------*/
/*
                            top_levelG  (cf G_neuron4.c)
				|
	--------------------- Form_G -------------------
        |                       |                       |
   Drawing_A1                   Row_Column_Menu         Push_Button_Drugs
   Drawing_A2                   |                        |
   Drawing_A3             Menu_Bar_Main			TTX
(fabrique_drawing_areas())      |			TEA
				|
				|
                -----------------------------------------------------------------------
                |                               |                          |          |
                File                            Parameters            Constants      Graphs
                  - Read Neuron                   - Conductance         - Initial     - X
                  - Write Back Neuron             - PSP                 - act/des     - Y
                  - Save Neuron As                - NMDA                              - Draw
                  - Plot Potential                - Equilibrium 
                  - Save potential		  - Activation	
		  - Save Currents		  - Simulation
		  - Quit                          - Echelles
*/

/*---------------------------------------------*/						          
main(int argc, char *argv[])
/*---------------------------------------------*/
{
  Visual        *visual;
  Arg 		args[256];
  Cardinal 	argcnt;
  int		n = 0,
                i,
                j;
  XtAppContext context;
  
  Arg		wargs[20];
  
  
  XmString	string1,
            string2,
			string3,
			string4,
			string5,
			string6,
			string7,
			string8,
			string9,
			string10;
			
  char		s[256],
	        file[256],
		savefile_name[256],
		*pt,
		*help;
  
  /* initialisation des parametres */

  nb_spikes = nb_connexions = taille_tab_syn = 0;
  nb_detected_spikes_old = 0;
  surface_normalisee = 1.;
  draw_currents = True;
  neurotransmitor = ANY;
  nb_receptors = 2; /* un epsp et un ipsp */
  filter_noise = 0;
  plot_type= CRT_CRT;

  /* arguments analysis */
  
  keep = 'd';	/* Normally, spool and delete */
  file_saved = TRUE;
#if SCIENCE_ACTIVE
  strcpy(savefile_name,"Gneuron.G_unit");
  filename_given = TRUE;
#else
  savefile_name[0] = '\0';
  filename_given = FALSE;
#endif
  flag_horizontal = FALSE;
  flag_phenom = FALSE;
  flag_spike_detect = 1;
  


  
  for (i = 1; i < argc; i++)
  {
      switch(argv[i][0])
      {
		case '-':
		  switch(argv[i][1])
		  {
		    case 'h':
		      printf("usage: G_neuron [-h] [-v] [-k] [-P] [-H] [file_in]\n");
		      printf("switches:\n");
		      printf("\t -h to print this.\n");
		      printf("\t -v for debug mode.\n");
		      printf("\t -k keep the PostScript file.\n");
		      printf("\t -P Phenomenologic model (or called using G_neuronP)\ n");
		      printf("\t -H Horizontal mode (or called using G_neuronH or G_neuronPH)\n");
		      printf("\t -V Vertical mode\n");
		      printf("\t input_file file (*.[G|P|B|L]_unit).\n");
		      exit(0);
		    case 'v':
		      debug = True;
		      break;
		    case 'P':
		      flag_phenom = TRUE;
		      model_type = XNBC_MODEL;
		      break;
		    case 'G':
		      flag_phenom = FALSE;
		      model_type = HH_SIMPLE_MODEL;
		      break;
		    case 'H':
		      flag_horizontal = TRUE;
		      break;
		    case 'V':
		      flag_horizontal = FALSE;
		      break;
		    case 'k':
		      keep_ps = True;
		      keep = 's';	/* spool and keep the PS file */
		      break;
		    default:
		      printf("\007Illegal switch\n");
		      exit(0);
		  } /* fin du switch */
		  break;
		default:
		  strcpy(savefile_name,argv[i]);
		  filename_given = TRUE;
		} /* fin du switch */
    } /* fin du for */
    if (debug)
		fprintf(stderr,"%s %s %s\n",argv[0], argv[1], argv[2]);

	strcpy(buffer,argv[0]);
  pt = buffer;
#if DEBUG
  printf("G_neuron 1a:\tCall name : %s\n",
	 pt);
#endif
  
#ifndef __CYGWIN__

  pt = strrchr(buffer,'/');
  

pt++;  /* pour eliminer le / si il existe */



  if (!strcmp((pt),"G_neuronP"))
  {
    flag_phenom = TRUE;
    model_type = XNBC_MODEL;
  }
  if (!strcmp((pt),"G_neuronPH"))
  {
    flag_phenom = TRUE;
    flag_horizontal = TRUE;
    model_type = XNBC_MODEL;
  }
  if (!strcmp((pt),"G_neuronH"))
  {
    flag_horizontal = TRUE;
    model_type = XNBC_MODEL;
  }

#endif
#if ! SCIENCE_ACTIVE
  strcpy(project_directory,get_dir_name());
  strcpy(savefile_name,get_simulation_name());
  filename_given = TRUE;
  
  if (filename_given)
    {
      if (pt = strrchr(savefile_name,'.'))
	{
	  *pt = 0;	/* supprime l'extension */
	}
      strcat(savefile_name,".G_unit");
    } /* fin du if */
#endif

#if DEBUG
  printf("G_neuron 2 :\tProject directory: %s\n\t\tFile: %s\n",
	 project_directory,savefile_name);
#endif
  
  flag_equation = False;
  help_dir[0] = '/';
  if (help = getenv("XNBC_HELP_DIR"))
    {
      strcpy(help_dir,help);
      strcat(help_dir,"G_neuron");
    } /* fin du if */
  else
    {
      if (debug)
		fprintf(stderr,"XNBC_HELP_DIR not defined. Using /usr/local/bin/xnbc.bin/V9/help/G_neuron/\n");
      strcpy(help_dir,"/usr/local/bin/xnbc.bin/V9/help/G_neuron/");
    } /* fin du if */

  if (!(getenv("PRINT_PLOT_PS")))
    {
      if (debug)
		fprintf(stderr,"\007PRINT_PLOT_PS not defined\nUsing a standard way on the postscript queue\n");
    }

  ref1.identificateur = 1;
  ref2.identificateur = 2;
  ref3.identificateur = 3;
  p_neur = NULL;
  if (filename_given)
    strcpy(nom_fichier_neuron, savefile_name);
  else
    strcpy(nom_fichier_neuron, "Gneuron.G_unit");
  
  backgrd_noise_resistance = 5.;

  set_defaults();	/* met les parametres a leurs valeurs par defaut */
  
  clamp_pot = rest_pot;
  input_fact = 0.;
  X_graph = le_temps;
  Y_graph = potentiel;
  integration_type = EXPONENTIELLE;
  update_neurone = update_expon;
  calcul_neuron = calcul_neuron_conduct;
  draw_neuron =  draw_neuron_conduct;
  
  sprintf(buffer,"G_neuron %s: %s",VERSION, savefile_name);
  
  /*-------------- initialisation du toolkit --------------*/
  
  top_levelG = XtInitialize(argv[0], "G_neuron",  NULL, 0, &argc, argv);
  
  /*
   * Install the tearOffModel resource converter.
   */
  
  XtVaSetValues(top_levelG,
		XmNx, 0,
		XmNy, 20,
		XtNtitle, buffer,
		NULL);
  
  disp = XtDisplay(top_levelG);
  root_window = DefaultRootWindow(disp);
  ref1.window = (Window) NULL;
  ref2.window = (Window) NULL;
  ref3.window = (Window) NULL;
  refXY.window = (Window) NULL;
  refM_H_TAU.window = (Window) NULL;

  screen_width = DisplayWidth(disp, DefaultScreen(disp));
  screen_height = DisplayHeight(disp, DefaultScreen(disp)) - 10;

  visual = DefaultVisual(disp, DefaultScreen(disp));
  switch(visual->class)
    {
    case GrayScale	:
    case PseudoColor: cree_palette();
      colormap = TRUE;
      break;
    case DirectColor:	
    case TrueColor: couleurs();
      break;
    case StaticColor:	
    case StaticGray:	
      break;
    } 

  wait_cursor = XCreateFontCursor(disp, XC_watch);
  

  if (!(getenv("PRINT_PLOT_PS")))
    {
      strcpy(buffer,"PRINT_PLOT_PS not defined\nUsing a standard way on the postscript queue");
      if (debug)
      DispMessageDialog(top_levelG, buffer,"WARNING",XmDIALOG_MESSAGE);
    }


  /* Form_G */
  Form_G = XtVaCreateManagedWidget("formg",
				   xmFormWidgetClass,
				   top_levelG,
				   XmNx, 0,
				   XmNy, 20,
				   XmNwidth, (Dimension)(.46 * (screen_width - 20)),
#if SCIENCE_ACTIVE
				   XmNheight, (Dimension)((screen_height - 120) * .75),
#else
				   XmNheight, (Dimension)(screen_height - 120),
#endif
				   XmNfractionBase, 100,
				   NULL);							 
  
  /* container du menu */
  Row_Column_Menu = XtVaCreateManagedWidget("rowcolumnmenu",
					    xmRowColumnWidgetClass,
					    Form_G,
					    XmNheight, 40,
					    XmNtopAttachment, XmATTACH_FORM,
					    XmNtopOffset, 1,
					    XmNleftAttachment, XmATTACH_FORM,
					    XmNleftOffset, 1,
					    XmNrightAttachment, XmATTACH_POSITION,
					    XmNrightPosition, 80,
					    NULL);
  
  /*---- barre de menu ----*/
  string1 = XmStringCreateSimple("Files");
  string2 = XmStringCreateSimple("Param");
  string3 = XmStringCreateSimple("Models");
  string4 = XmStringCreateSimple("Graphs");
  string5 = XmStringCreateSimple("Analysis");
  string6 = XmStringCreateSimple("Options");
  string7 = XmStringCreateSimple("Help");
  Menu_Bar_Main = XmVaCreateSimpleMenuBar(Row_Column_Menu,
					  "menubarmain",
					  XmVaCASCADEBUTTON, string1, 'F',
					  XmVaCASCADEBUTTON, string2, 'P',
					  XmVaCASCADEBUTTON, string3, 'M',
					  XmVaCASCADEBUTTON, string4, 'G',
					  XmVaCASCADEBUTTON, string5, 'A',
					  XmVaCASCADEBUTTON, string6, 'O',
					  XmVaCASCADEBUTTON, string7, 'H',
					  NULL);
  XmStringFree(string1);
  XmStringFree(string2);
  XmStringFree(string3);
  XmStringFree(string4);
  XmStringFree(string5);
  XmStringFree(string6);
  XmStringFree(string7);
  
  /* bouton Drugs */
  string1 = XmStringCreateSimple("Drugs");
  n = 0;
  XtSetArg(wargs[n], XmNborderWidth, 1);n++;
  XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM);n++;
  XtSetArg(wargs[n], XmNtopOffset, 5);n++;
  XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM);n++;
  XtSetArg(wargs[n], XmNrightOffset, 5);n++;
  XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_POSITION);n++;
  XtSetArg(wargs[n], XmNleftPosition, 81);n++;
  XtSetArg(wargs[n], XmNlabelString, string1);n++;
  Push_Button_Calcul = XtCreateManagedWidget("OK",
					     xmPushButtonWidgetClass,
					     Form_G,
					     wargs,n);
  XtAddCallback(Push_Button_Calcul, XmNactivateCallback, fabrique_drugs_box, NULL);
  XmStringFree(string1);
  
  /*---- menu File ----*/
  string1 = XmStringCreateSimple("Read Neuron...");
  string2 = XmStringCreateSimple("Write Back Neuron");
  string3 = XmStringCreateSimple("Save Neuron As...");
  string4 = XmStringCreateSimple("Print Potential");
  string5 = XmStringCreateSimple("Save Mb potential");
  string6 = XmStringCreateSimple("Save Currents");
  string7 = XmStringCreateSimple("Read Input Tms File...");
  string8 = XmStringCreateSimple("Write Output Tms File...");
  string9 = XmStringCreateSimple("Quit");
  Cascade_File = XmVaCreateSimplePulldownMenu(Menu_Bar_Main,
					      "cascadefile",
					      0,
					      (XtPointer)retour_file,
					      XmVaPUSHBUTTON, string1, 'R', NULL, NULL,
					      XmVaPUSHBUTTON, string2, 'W', NULL, NULL,
					      XmVaPUSHBUTTON, string3, 'S', NULL, NULL,
					      XmVaPUSHBUTTON, string4, 'P', NULL, NULL,
					      XmVaPUSHBUTTON, string5, 'M', NULL, NULL,
					      XmVaPUSHBUTTON, string6, 'C', NULL, NULL,
					      XmVaPUSHBUTTON, string7, 'O', NULL, NULL,
					      XmVaPUSHBUTTON, string8, 'I', NULL, NULL,
					      XmVaPUSHBUTTON, string9, 'Q', NULL, NULL,
					      NULL);
  XmStringFree(string1);
  XmStringFree(string2);
  XmStringFree(string3);
  XmStringFree(string4);
  XmStringFree(string5);
  XmStringFree(string6);
  XmStringFree(string7);
  XmStringFree(string8);
  XmStringFree(string9);
  
  /*---- menu parameters ----*/
  string2 = XmStringCreateSimple("PSP & Experiment...");
  string1 = XmStringCreateSimple("Conductances...");
  string3 = XmStringCreateSimple("Noise & clamping...");
  if (!flag_phenom)
  {
	string4 = XmStringCreateSimple("Equil. pot & sp. det...");
	string5 = XmStringCreateSimple("Initializations...");
	string6 = XmStringCreateSimple("NMDA...");
  }
  else
  {
	string4 = XmStringCreateSimple("Not available");
	string5 = XmStringCreateSimple("for model");
	string6 = XmStringCreateSimple("phenomenologic");
  }

  string7 = XmStringCreateSimple("Scales...");
  string8 = XmStringCreateSimple("Transmitters..."); 
  string9 = XmStringCreateSimple("Receptors...");
  string10 = XmStringCreateSimple("Reset all to defaults");
  Cascade_Parameters = XmVaCreateSimplePulldownMenu(Menu_Bar_Main,
						    "cascadeparameters",
						    1,
						    (XtPointer)retour_parameters,
						    XmVaPUSHBUTTON, string2, 'P', NULL, NULL,
						    XmVaPUSHBUTTON, string1, 'C', NULL, NULL,
						    XmVaPUSHBUTTON, string3, 'o', NULL, NULL,
						    XmVaPUSHBUTTON, string4, 'E', NULL, NULL,
						    XmVaPUSHBUTTON, string5, 'I', NULL, NULL,
						    XmVaPUSHBUTTON, string6, 'N', NULL, NULL,
						    XmVaPUSHBUTTON, string7, 'S', NULL, NULL,
 						    XmVaPUSHBUTTON, string8, 'T', NULL, NULL, 
						    XmVaPUSHBUTTON, string9, 'R', NULL, NULL,
						    XmVaPUSHBUTTON, string10, 'D', NULL, NULL,
						    NULL);
  XmStringFree(string1);
  XmStringFree(string2);
  XmStringFree(string3);
  XmStringFree(string4);
  XmStringFree(string5);
  XmStringFree(string6);
  XmStringFree(string7);
  XmStringFree(string8); 
  XmStringFree(string9);
  XmStringFree(string10);

  /*---- menu models ----*/
  string1 = XmStringCreateSimple("Hodgkin-Huxley type"); 
  string2 = XmStringCreateSimple("Phenomenologic type"); 
  Cascade_Models = XmVaCreateSimplePulldownMenu(Menu_Bar_Main,
						"casmodel",
						2,
						NULL,
						XmVaCASCADEBUTTON, string1, 'H',             /* 0 */
						XmVaSEPARATOR,
						XmVaCASCADEBUTTON, string2, 'P',             /* 1 */
						NULL);
  XmStringFree(string1);
  XmStringFree(string2);

  /*---- sub menu HH ----*/
  string1 = XmStringCreateSimple("Hodgkin-Huxley"); 
  string2 = XmStringCreateSimple("Michaelis-Menton"); 
  Cascade_Models_HH = XmVaCreateSimplePulldownMenu(Cascade_Models,
						   "casmodelhh",
						   0,
						   (XtPointer)callback_model_hh,
						   XmVaPUSHBUTTON, string1, 'H', NULL, NULL,
						   XmVaPUSHBUTTON, string2, 'M', NULL, NULL,
						   NULL);
  XmStringFree(string1);
  XmStringFree(string2);

  /*---- sub menu Phenom ----*/
  string1 = XmStringCreateSimple("XNBC phenomenologic"); 
  string2 = XmStringCreateSimple("Leaky integrator"); 
  string3 = XmStringCreateSimple("Conditional burster"); 
  Cascade_Models_Phenom = XmVaCreateSimplePulldownMenu(Cascade_Models,
						       "casmodelphen",
						       1,
						       (XtPointer)callback_model_phenom,
						       XmVaPUSHBUTTON, string1, 'X', NULL, NULL,
						       XmVaPUSHBUTTON, string2, 'L', NULL, NULL,
						       XmVaPUSHBUTTON, string3, 'B', NULL, NULL,
						       NULL);
  XmStringFree(string1);
  XmStringFree(string2);
  XmStringFree(string3);

  /*---- menu graphs ----*/
  string1 = XmStringCreateSimple("Axis choice...");
  string2 = XmStringCreateSimple("Draw");
  Cascade_Graphs = XmVaCreateSimplePulldownMenu(Menu_Bar_Main,
						"cascadegraph",
						3,
						(XtPointer)retour_graphs,
						XmVaPUSHBUTTON, string1, 'A', NULL, NULL,
						XmVaPUSHBUTTON, string2, 'D', NULL, NULL, 
						NULL);
  XmStringFree(string1);
  XmStringFree(string2);
  
  /*---- menu analysis ----*/

  string1 = XmStringCreateSimple("Xtms...");
  Cascade_Analysis = XmVaCreateSimplePulldownMenu(Menu_Bar_Main,
						  "cascadeanalysis",
						  4,
						  (XtPointer)retour_analysis,
						  XmVaPUSHBUTTON, string1, 'X', NULL, NULL,
						  NULL);
  XmStringFree(string1);
  
  
  /*---- menu options ----*/
  
  string1 = XmStringCreateSimple("Spike Detection...");
  string2 = XmStringCreateSimple("Static Update");
  string3 = XmStringCreateSimple("Superimpose");
  string7 = XmStringCreateSimple("Don't draw currents");
  string4 = XmStringCreateSimple("tms Input");
  string5 = XmStringCreateSimple("tms Output");
  string6 = XmStringCreateSimple("Recurrent PSP");
  string8 = XmStringCreateSimple("Horizontal view");

  Cascade_Options = XmVaCreateSimplePulldownMenu(Menu_Bar_Main,
						 "cascadeoptions",
						 5,
						 (XtPointer)retour_options,
						 XmVaCASCADEBUTTON, string1, 'S',             /* 0 */
						 XmVaTOGGLEBUTTON, string2, 'U', NULL, NULL,  /* 1 */
						 XmVaTOGGLEBUTTON, string3, 'p', NULL, NULL,  /* 2 */
						 XmVaTOGGLEBUTTON, string7, 'd', NULL, NULL,  /* 3 */
						 XmVaSEPARATOR, 
						 XmVaTOGGLEBUTTON, string4, 'I', NULL, NULL,  /* 4 */
						 XmVaTOGGLEBUTTON, string5, 'O', NULL, NULL,  /* 5 */   
						 XmVaSEPARATOR,
						 XmVaCASCADEBUTTON, string6, 'R',             /* 6 */
						 XmVaSEPARATOR,
						 XmVaTOGGLEBUTTON, string8, 'H', NULL, NULL,  /* 7 */
						 NULL);
  
  XmStringFree(string1);
  XmStringFree(string2);
  XmStringFree(string3);
  XmStringFree(string4);
  XmStringFree(string5);
  XmStringFree(string6);
  XmStringFree(string7);
  XmStringFree(string8);
  
  /*---- creation du pullright pour SpikeDetect ----*/

  string1 = XmStringCreateSimple("Enabled/Visible");
  string2 = XmStringCreateSimple("Enabled/Invisible");
  string3 = XmStringCreateSimple("Disabled");

  pullright1 = XmVaCreateSimplePulldownMenu(Cascade_Options, 
					    "pullright1",
					    0,
					    (XtPointer)retour_pullright1_options,
					    XmVaRADIOBUTTON, string1, 'V', NULL, NULL,
					    XmVaRADIOBUTTON, string2, 'I', NULL, NULL,
					    XmVaRADIOBUTTON, string3, 'D', NULL, NULL,
					    XmNradioBehavior, True,
					    XmNradioAlwaysOne, True,
					    NULL);

  XmStringFree(string1);
  XmStringFree(string2);
  XmStringFree(string3);

  string1 = XmStringCreateSimple("Enable");
  string2 = XmStringCreateSimple("Disable");

  pullright2 = XmVaCreateSimplePulldownMenu(Cascade_Options, 
					    "pullright2",
					    8,
					    (XtPointer)retour_pullright2_options,
					    XmVaRADIOBUTTON, string1, 'I', NULL, NULL,
					    XmVaRADIOBUTTON, string2, 'D', NULL, NULL,
					    XmNradioBehavior, True,
					    XmNradioAlwaysOne, True,
					    NULL);

  XmStringFree(string1);
  XmStringFree(string2);

  /*---- menu Help ----*/
  string1 = XmStringCreateSimple("About G_neuron");
  string2 = XmStringCreateSimple("Help on Topics...");
  string3 = XmStringCreateSimple("Browse Manual");
  Cascade_Help = XmVaCreateSimplePulldownMenu(Menu_Bar_Main,
					      "cascadehelp",
					      6,
					      (XtPointer)retour_help,
					      XmVaPUSHBUTTON, string1, 'A', NULL, NULL,
					      XmVaPUSHBUTTON, string2, 'O', NULL, NULL, 
					      XmVaPUSHBUTTON, string3, 'B', NULL, NULL, 
					      NULL);
  XmStringFree(string1);
  XmStringFree(string2);
  XmStringFree(string3);
  
  /*****************************************/
  
  XtManageChild(Menu_Bar_Main);
  XtRealizeWidget(top_levelG);

  /* window coordinates  */

  w_x_0 = 0;
  w_y_0 = 30;
  w_x_1 = (int)((.46 * (screen_width - 20)) + 26);
  w_y_h1 = (int)(((screen_height)/2) + 44);
  w_y_v1 = (int)(screen_height - ((screen_height - 120)/2) - 64);

#if DEBUG
  printf("Windows X and Y: %d %d %d %d %d \n",
	 w_x_0,
	 w_y_0,
	 w_x_1,
	 w_y_h1,
	 w_y_v1);
#endif

  fabrique_drawing_areas();

  if (colormap)
    XSetWindowColormap(disp, XtWindow(top_levelG), palette);


  if (flag_phenom)
  {
	model_type = XNBC_MODEL;
	strcpy(model_name,"XNBC");
	if (Top_Level_Conductance)
	{
	  XtDestroyWidget(Top_Level_Conductance);
	  Top_Level_Conductance = 0;
	  flag_conductance = 0;
	}
	fabrique_scrolled_window_phenom();
	
	XtVaSetValues(toggleButton8,XmNsensitive,True,NULL);
	XtVaSetValues(toggleButton9,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton10,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton11,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton12,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton13,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton14,XmNsensitive,False,NULL);
	XtVaSetValues(toggleButton15,XmNsensitive,False,NULL);

	sprintf(buffer,"Phenomenologic models [%s]",model_name);
	XtVaSetValues(Top_Level_Phenom,XmNtitle,buffer,NULL);
	
	update_neurone = update_xnbc;
	plot_type = ISI_RATE;

	calcul_neuron = calcul_neuron_phenom; 
	draw_neuron =  draw_neuron_phenom;
  }
  else
  {
	model_type = HH_SIMPLE_MODEL;
	strcpy(model_name,"Hodgkin-Huxley");
	if (Top_Level_Phenom)
	{
	  XtDestroyWidget(Top_Level_Phenom);
	  Top_Level_Phenom = 0;
	  flag_Phenom = 0;
	}
	fabrique_scrolled_window_conductance();

	sprintf(buffer,"Conductance models [%s]",model_name);
	XtVaSetValues(Top_Level_Conductance,XmNtitle,buffer,NULL);

	switch ( integration_type )
	{
		case EXPONENTIELLE: 
			update_neurone =  update_expon;
			break;
		case EULER:
			update_neurone =  update_euler;
			break;
		case RUNGE_KUTTA:
			update_neurone =  update_r_k;
			break;
		case RUNGE_KUTTA_VARIABLE_STEP:
			update_neurone =  update_r_k_v_s;
			break;
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new method */
		case INT_METHOD:
			update_neurone =  update_int_method;
			break;
#endif
	}

	calcul_neuron = calcul_neuron_conduct; 
	draw_neuron =  draw_neuron_conduct;
    }

  fabrique_scrolled_window_inputs();

  /* Repositionning of windows in vertical mode */
  
  if (flag_horizontal)
      toggle_representation(HORIZONTAL);

  else
      toggle_representation(VERTICAL);

  set_defaults();	/* met les parametres a leurs valeurs par defaut */
  
  /* Lecture du fichier s'il y a lieu */
  
  if (filename_given)
    {
      if ((p_neur = fopen(nom_fichier_neuron, "r")) == NULL)
	{
	  sprintf(buffer,"\007File %s impossible to open\n", nom_fichier_neuron);
	  string1 = XmStringCreateSimple(buffer);
	  string2 = XmStringCreateSimple("Neuron file not found");
	  n = 0;
	  XtSetArg(wargs[n], XmNx, 200);n++;
	  XtSetArg(wargs[n], XmNy, 400);n++;
	  XtSetArg(wargs[n], XmNheight, 200);n++;
	  XtSetArg(wargs[n], XmNwidth, 300);n++;
	  XtSetArg(wargs[n], XmNmessageString, string1);n++;
	  XtSetArg(wargs[n], XmNdialogTitle, string2);n++;

	  Zero_Time_Step = XmCreateWarningDialog(top_levelG,
						 "zero_time_step",wargs,n);
	  XmStringFree(string1);
	  XmStringFree(string2);
	  XtManageChild(Zero_Time_Step);

	}
      else
	{
	  readNeuron(p_neur);
	  fclose(p_neur);
	}
    }
	(*calcul_neuron)();
	(*draw_neuron)(0);

    XtMainLoop();
  
}

/*---------------------------------------------------------*/
void retour_file(Widget w, int item_nb)
/*---------------------------------------------------------*/
{
  char	s[256];
  
  strcpy(s,"**");
  switch(item_nb)
  {
    case 0:
      choix_file = 0;
      selection_fichier();
      sprintf(buffer,"G_neuron %s: %s",VERSION,nom_fichier_neuron );
      XtVaSetValues(top_levelG,XmNtitle,buffer,NULL);
      break;
    case 1:
      choix_file = 2;
      if (!filename_given)
		selection_fichier();
      if ((p_neur = fopen(nom_fichier_neuron, "w")) == NULL)
		selection_fichier();
      writeNeuron(p_neur);
      fclose(p_neur);
      sprintf(buffer,"G_neuron %s: %s",VERSION,nom_fichier_neuron );
      XtVaSetValues(top_levelG,XmNtitle,buffer,NULL);
      break;
    case 2:
      choix_file = 2;
      selection_fichier();
      sprintf(buffer,"G_neuron %s: %s",VERSION,nom_fichier_neuron );
      XtVaSetValues(top_levelG,XmNtitle,buffer,NULL);
      break;
    case 3:
      choix_file = 3;
      switch (model_type)
      {
		case MICHAELIS_MENTON_MODEL:
        case HH_SIMPLE_MODEL:
			plot_pot_conduct();
			break;
        case XNBC_MODEL:
        case LEAKY_INTEG_MODEL:
        case COND_BURST_MODEL:
			plot_pot_phenom();
      }
      break;
    case 4:
      choix_file = 4;
      save_mb_pot();
      break;
    case 5:
      choix_file = 4;
      save_currents();
      break;
    case 6:
      choix_file = 5;
      if (flag_Tms_Input) 
	  {
		callback_close(NULL, NULL, NULL);
		selection_fichier_tms();
	  }
      break;
    case 7:
      choix_file = 6;
      if (flag_Tms_Output)
		selection_fichier_tms();
      break;
    case 8:
#if ! SCIENCE_ACTIVE
	  if (!file_saved)
	  {
		  strcpy(buffer,"File not saved\nAre you still OK to quit?");
		  DispMessageDialog(top_levelG, buffer,"WARNING",0);
	  }
      else
#endif
	      sortie();
	}
}

/*----------------------------------------------------------------*/
void retour_parameters(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{

  switch(item_nb)
    {
    case 0:
      fabrique_form_simulation();
      break;
    case 1:
      fabrique_scrolled_window_conductance();
      break;
    case 2:
      fabrique_scrolled_window_PSP();
      break;
    case 3:
		if (!flag_phenom)
			fabrique_scrolled_window_equilibrium();
      break;
    case 4:
		if (!flag_phenom)
			fabrique_scrolled_window_init();
      break;
    case 5:
		if (!flag_phenom)
			fabrique_form_NMDA();
      break;
    case 6:
      fabrique_Echelles();
      break;
    case 7:
	
      fabrique_Transmitors();

      break;
    case 8:
      fabrique_Receptors();
      break;
     case 9:
      set_defaults();
/*
      fabrique_form_simulation();
      fabrique_scrolled_window_conductance();
*/
      break;
   }
}

/*----------------------------------------------------------------*/
void retour_transmitors(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{
    int i;

    switch (item_nb)
    {
        case 0:
		  neurotransmitor = NO_TRANSMISSION;
		  break;
        case 1:
		  neurotransmitor = ANY;
		  break;
        default:
		  neurotransmitor += transmetteur[item_nb];
    }
    switch (neurotransmitor)
    {
      case ANY:
		XmToggleButtonSetState (toggleButton_Transm[0], False, False);
		XmToggleButtonSetState (toggleButton_Transm[1], True, False);
		for ( i = 2; i < NB_TRANSMITORS; i ++)
		{
		    XmToggleButtonSetState (toggleButton_Transm[i], False, False);
		}
		break;
      case NO_TRANSMISSION:
		XmToggleButtonSetState (toggleButton_Transm[0], True, False);
		XmToggleButtonSetState (toggleButton_Transm[1], False, False);
		for ( i = 2; i < NB_TRANSMITORS; i ++)
		{
		    XmToggleButtonSetState (toggleButton_Transm[i], False, False);
		}
		break;
      default:
		XmToggleButtonSetState (toggleButton_Transm[0], False, False);
		XmToggleButtonSetState (toggleButton_Transm[1], False, False);
		for ( i = 2; i < NB_TRANSMITORS; i ++)
		{
		    if (neurotransmitor & transmetteur[i])
		    {
		      XmToggleButtonSetState (toggleButton_Transm[i], True, False);
		    }
		    else
		    {
		      XmToggleButtonSetState (toggleButton_Transm[i], False, False);
		    }
		}	
    }
}

/*----------------------------------------------------------------*/
	void retour_analysis(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{
  char	name_appli[256],
        buffer1[256],buffer[256],bin_directory[256];

  char	*nbc_V9_bin;
	switch(item_nb)
	{
	case 0:
	  {
	    nbc_V9_bin = getenv("XNBC_BIN_DIR_TOOLS");
	    if(nbc_V9_bin)
	      {
		strcpy(bin_directory,nbc_V9_bin);
	      }
	    else
	      {
		strcpy(bin_directory,"/usr/local/bin/xnbc.bin/V9");
		fprintf(stderr,"XNBC_BIN_DIR_TOOLS not defined, using %s\n",
			bin_directory);
	      }
	    sprintf(buffer,"%s/%s", project_directory, nom_fichier_tms_output);
	    strcpy(name_appli,bin_directory);
	    strcat(name_appli,"/");
	    strcat(name_appli,"xtms");
	    sprintf(buffer1,"%s %s&", name_appli, buffer);
	    fprintf(stderr,"%s\n",buffer1);
	    system(buffer1);  
	    break;
	  }
	  
	} 
}

/*----------------------------------------------------------------*/
void retour_options(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{
  char	s[256];
  strcpy(s,"**");
  
  switch(item_nb)
    {
    case 0:
      {
	/* see retour_pullright1_options() */
	break;
      }
    case 1:
      {
	static_update =! static_update;
	DynamicChange (NULL, NULL, NULL);
	break;
      }
    case 2:
      {
	superimpose =! superimpose;
	break;
      }
    case 3:
      {
	draw_currents =! draw_currents;
	break;
      }
    case 4:
      {
	flag_Tms_Input =! flag_Tms_Input;
	if (flag_simulation)
	  {
	    callback_close(NULL, NULL, NULL);
	  }
	if (!flag_Tms_Input)  
	  {
	    flag_InputFile=0;
	    nb_connexions=0;
	  }
	else
	  {
	    choix_file = 5;
	    selection_fichier_tms();
	  }
	break;
      }
    case 5:
      {
	flag_Tms_Output=!flag_Tms_Output;
	if (!flag_Tms_Output) flag_OutputFile=0;
	else
	  {
	    choix_file = 6;
	    selection_fichier_tms();
	  } 	 
	break;
      }
    case 6:
      {
	/* see retour_pullright2_options() */
	break;
      }
    case 7:
      {
	if (flag_horizontal)        /* we go to vertical */
	  toggle_representation(VERTICAL);
	else                       /* we go to horizonat; */
	  toggle_representation(HORIZONTAL);
      }
    }
}


/*----------------------------------------------------------------*/
void retour_pullright1_options(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{
  
  switch(item_nb)
    {
    case 0:  /* Visible */
      {
	flag_spike_detect = 1;
	flag_spike_visible = 1;
	if (flag_equilibrium) XtSetSensitive(DeXInput_Spike_Detect,True);
	if (recurrentEPSP) fabrique_form_recurrent_window();
	break;
      }
    case 1:  /* Invisible */
      {
	flag_spike_detect = 1;
	flag_spike_visible = 0;
	if (flag_equilibrium)  XtSetSensitive(DeXInput_Spike_Detect,True);
	if (recurrentEPSP) fabrique_form_recurrent_window();
	break;
      }
    case 2:  /* Disable */
      {
	flag_spike_detect = 0;
	flag_spike_visible = 0;
	if (flag_equilibrium)  XtSetSensitive(DeXInput_Spike_Detect,False);
	
	recurrentEPSP=0;
	if (flag_recurrentEPSP)
	  {
	    XtDestroyWidget(Top_Level_recurrent);
	    flag_recurrentEPSP = 0;
	  }

	break;
      }

    }
  
  (*calcul_neuron)();
  (*draw_neuron)(0);
	
}

/*----------------------------------------------------------------*/
void retour_pullright2_options(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{
  char	buffer[256];
 	
  flag_affiche=!flag_affiche;

  switch(item_nb)
    {
    case 0:  /* Enable */
      {
	recurrentEPSP=1;
	if (flag_spike_detect) fabrique_form_recurrent_window();
	else 
	  {
	    if (flag_affiche==1)
	      {
		sprintf(buffer,"the spike detection is not activate!");
		message(buffer );
	      }
	  }
	break;
      }
    case 1:  /* Disable */
      {
	recurrentEPSP=0;
	if (flag_recurrentEPSP)
	  {
	    XtDestroyWidget(Top_Level_recurrent);
	    flag_recurrentEPSP = 0;
	  }
	break;
      }
    }
}

/*----------------------------------------------------------------*/
void retour_help(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{
  switch(item_nb)
    {
    case 0:
      sprintf(buffer,"G_neuron %s\nJ-F Vibert, University Paris 6\nESIM INSERM U707",VERSION);
      DispMessageDialog (top_levelG,
			 buffer,
			 "About G_neuron...",
			 1);
      break;
    case 1:
      MainDisplayHelpCB(w, NULL, (XtPointer)item_nb);
      break;
    case 2:
      browse_manual(XNBC_G_NEURON);
      break;
    }
}

/*----------------------------------------------------------------*/
void retour_graphs(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{
  switch(item_nb)
    {
    case 0:
      fabrique_radio_box_XY();
      break;
    case 1:
      fabrique_XY_area();
      break;
    } 
}
/*----------------------------------------------------------------*/
void retour_X_graphs(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{
  switch(item_nb)
    {
    case 0:
      X_graph = le_temps;
      strcpy(X_legend,"Time (ms)");
      refXY.decimals_x = 0; 
      break;
    case 1:
      X_graph = potentiel;
      strcpy(X_legend,"Mb Pot. (mV)");
      refXY.decimals_x = 0; 
      break;
    case 2:
      X_graph = courant_Na;
      strcpy(X_legend,"I_Na (uA/cm2)");
      refXY.decimals_x = 1; 
      break;
    case 3:
      X_graph = courant_Nap;
      strcpy(X_legend,"I_Na Pers. (uA/cm2)");
      refXY.decimals_x = 2; 
      break;
    case 4:
      X_graph = courant_K;
      strcpy(X_legend,"I_K (uA/cm2)");
      refXY.decimals_x = 1; 
      break;
    case 5:
      X_graph = courant_Ia;
      strcpy(X_legend,"Ia (uA/cm2)");
      refXY.decimals_x = 2; 
      break;
    case 6:
      X_graph = courant_Im;
      strcpy(X_legend,"Im (uA/cm2)");
      refXY.decimals_x = 2; 
      break;
    case 7:
      X_graph = courant_Iahp;
      strcpy(X_legend,"Iahp (uA/cm2)");
      refXY.decimals_x = 2; 
      break;
    case 8:
      X_graph = courant_Ic;
      strcpy(X_legend,"Ic (uA/cm2)");
      refXY.decimals_x = 1; 
      break;
    case 9:
      X_graph = courant_Ca;
      strcpy(X_legend,"I_Ca HVA (uA/cm2)");
      refXY.decimals_x = 2; 
      break;
    case 10:
      X_graph = courant_Cab;
      strcpy(X_legend,"I_Ca LVA (uA/cm2)");
      refXY.decimals_x = 2; 
      break;
    case 11:
      X_graph = Ca;
      strcpy(X_legend,"[Ca]");
      refXY.decimals_x = 2; 
      break;
    case 12:
      X_graph = courant_Ih;
      strcpy(X_legend,"Ih (uA/cm2)");
      refXY.decimals_x = 2; 
      break;
    case 13:
      X_graph = valeur_m;
      strcpy(X_legend,"Activation m");
      refXY.decimals_x = 2; 
      break;
    case 14:
      X_graph = valeur_h;
      strcpy(X_legend,"Inactivation h");
      refXY.decimals_x = 2; 
      break;


#ifdef ADD_CURRENT
/*--------   To add a current copy this and adapt   -------*/   
    case 15:
      X_graph = courant_Inew;
      strcpy(X_legend,"Inew (uA/cm2)");
      refXY.decimals_x = 2; 
      break;
#endif
    } 
}
/*----------------------------------------------------------------*/
void retour_Y_graphs(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{
  switch(item_nb)
    {
    case 0:
      Y_graph = le_temps;
      strcpy(Y_legend,"Time (ms)");
      refXY.decimals_y = 0; 
      break;
    case 1:
      Y_graph = potentiel;
      strcpy(Y_legend,"Mb Pot. (mV)");
      refXY.decimals_y = 0; 
      break;
    case 2:
      Y_graph = courant_Na;
      strcpy(Y_legend,"I_Na  (uA/cm2)");
      refXY.decimals_y = 1; 
      break;
    case 3:
      Y_graph = courant_Nap;
      strcpy(Y_legend,"I_Na Pers. (uA/cm2)");
      refXY.decimals_y = 2; 
      break;
    case 4:
      Y_graph = courant_K;
      strcpy(Y_legend,"I_K (uA/cm2)");
      refXY.decimals_y = 1; 
      break;
    case 5:
      Y_graph = courant_Ia;
      strcpy(Y_legend,"Ia (uA/cm2)");
      refXY.decimals_y = 2; 
      break;
    case 6:
      Y_graph = courant_Im;
      strcpy(Y_legend,"Im (uA/cm2)");
      refXY.decimals_y = 2; 
      break;
    case 7:
      Y_graph = courant_Iahp;
      strcpy(Y_legend,"Iahp (uA/cm2)");
      refXY.decimals_y = 2; 
      break;
    case 8:
      Y_graph = courant_Ic;
      strcpy(Y_legend,"Ic (uA/cm2)");
      refXY.decimals_y = 1; 
      break;
    case 9:
      Y_graph = courant_Ca;
      strcpy(Y_legend,"I_Ca HVA (uA/cm2)");
      refXY.decimals_y = 2; 
      break;
    case 10:
      Y_graph = courant_Cab;
      strcpy(Y_legend,"I_Ca LVA (uA/cm2)");
      refXY.decimals_y = 2; 
      break;
    case 11:
      Y_graph = Ca;
      strcpy(Y_legend,"[Ca]");
      refXY.decimals_y = 2; 
      break;
    case 12:
      Y_graph = courant_Ih;
      strcpy(Y_legend,"Ih (uA/cm2)");
      refXY.decimals_y = 2; 
      break;
    case 13:
      Y_graph = valeur_m;
      strcpy(Y_legend,"Activation m");
      refXY.decimals_y = 2; 
      break;
    case 14:
      Y_graph = valeur_h;
      strcpy(Y_legend,"Inactivation h");
      refXY.decimals_y = 2; 
      break;

#ifdef ADD_CURRENT
/*--------   To add a current copy this and adapt   -------*/   
    case 13:
      Y_graph = courant_Inew;
      strcpy(Y_legend,"Inew (uA/cm2)");
      refXY.decimals_y = 2; 
      break;
#endif
    } 
}
/*----------------------------------------------------------------*/
void retour_conductances(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{
  Arg	wargs[20];
  XmString	xmstring;
  int	n;
  
  n = 0;
  set_g_Na = set_g_Nap = set_g_K = set_g_M = set_g_A = set_g_C = set_g_ahp = set_g_H =
    set_g_Ca = set_g_Cab = set_g_fuite = set_g_NMDA = set_g_Syn_pos = set_g_Syn_neg = 
    set_g_fuite_Na = set_g_fuite_K = False;
  
  switch(item_nb)
    {
    case 1:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 100000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 12000L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_Na * 100 )); n++;
      xmstring = XmStringCreateSimple("G Na (mS/cm2)");
      set_g_Na = True;
      break;
    case 2:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 5000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 3); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_Nap * 1000)); n++;
      xmstring = XmStringCreateSimple("G Na pers (mS/cm2)");
      set_g_Nap = True;
      break;
    case 3:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L);  n++;
      XtSetArg(wargs[n], DeXNmaximum, 25000L);  n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2);  n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 3600L);  n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_K * 100 ));  n++;
      xmstring = XmStringCreateSimple("G K (mS/cm2)");
      set_g_K = True;
      break;
    case 4:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 10000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 3); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_A * 1000)); n++;
      xmstring = XmStringCreateSimple("G K for Ia (mS/cm2)");
      set_g_A = True;
      break;
    case 5:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 1000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_M * 100)); n++;
      xmstring = XmStringCreateSimple("G K for Im (mS/cm2)");
      set_g_M = True;
      break;
    case 6:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 50000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_C * 100)); n++;
      xmstring = XmStringCreateSimple("G K for Ic (mS/cm2)");
      set_g_C = True;
      break;
    case 7:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 10000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_ahp * 100)); n++;
      xmstring = XmStringCreateSimple("G K for Iahp (mS/cm2)");
      set_g_ahp = True;
      break;
    case 8:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 50000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 100L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_Ca * 100)); n++;
      xmstring = XmStringCreateSimple("G Ca HVA (mS/cm2)");
      set_g_Ca = True;
      break;
    case 9:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 5000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_Cab * 100)); n++;
      xmstring = XmStringCreateSimple("G Ca LVA (mS/cm2)");
      set_g_Cab = True;
      break;
    case 10:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      if (integration_type == EXPONENTIELLE)
	{
	  XtSetArg(wargs[n], DeXNminimum, 0L); n++;
	}
      if (integration_type == RUNGE_KUTTA)
	{
	  XtSetArg(wargs[n], DeXNminimum, 0L); n++;
	}
      XtSetArg(wargs[n], DeXNmaximum, 5000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 30L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_fuite * 100)); n++;
      xmstring = XmStringCreateSimple("G Leak (mS/cm2)");
      set_g_fuite = True;
      break;
    case 11:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 500L); n++;
      XtSetArg(wargs[n], DeXNturnStep,50L); n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_NMDA * 100)); n++;
      xmstring = XmStringCreateSimple("G NMDA (mS/cm2)");
      set_g_NMDA = True;
      break;
    case 21:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 100L); n++;
      XtSetArg(wargs[n], DeXNturnStep,10L); n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_Syn_pos * 100)); n++;
      xmstring = XmStringCreateSimple("G Syn EPSP (mS/cm2)");
      set_g_Syn_pos = True;
      break;
    case 22:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L);  n++;
      XtSetArg(wargs[n], DeXNmaximum, 100L);  n++;
      XtSetArg(wargs[n], DeXNturnStep,10L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2);  n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L);  n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_Syn_neg * 100));  n++;
      xmstring = XmStringCreateSimple("G Syn IPSP (mS/cm2)"); 
      set_g_Syn_neg = True;
      break;
    case 23:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 1000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_H * 100)); n++;
      xmstring = XmStringCreateSimple("G K for Ih (mS/cm2)");
      set_g_H = True;
      break;
    case 24:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 1000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_fuite_Na * 100)); n++;
      xmstring = XmStringCreateSimple("G Na Leak (mS/cm2)");
      set_g_fuite_Na = True;
      break;
    case 25:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 1000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_fuite_K * 100)); n++;
      xmstring = XmStringCreateSimple("G K Leak (mS/cm2)");
      set_g_fuite_K = True;
      break;
#ifdef ADD_CURRENT
      /*--------   To add a current copy this and adapt   -------*/   
    case 26:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 1000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (g_new * 100)); n++;
      xmstring = XmStringCreateSimple("G New for Inew (mS/cm2)");
      set_g_New = True;
      break;
#endif
    } 
  XtSetValues(Dial_Conductances,wargs,n);
  XtVaSetValues(label_selection,XmNlabelString,xmstring,NULL);
  XmStringFree(xmstring);
  
  if (flag_activ)
    {
      XtDestroyWidget(Top_Level_Activ);
      flag_activ = 0;
    } /* fin du if */
}

/*----------------------------------------------------------------*/
void retour_Phenoms(Widget w, int item_nb)
/*----------------------------------------------------------------*/
{
  Arg	wargs[20];
  XmString	xmstring;
  int	n;
  
  n = 0;

    set_p_p_rest_pot = 
    set_p_pot_post_spike = 
    set_p_seuil = 
    set_p_seuil_post_spike = 
    set_p_tau_seuil = 
    set_p_shunt_tau = 
    set_p_burst_post_spike = 
    set_p_tau_mb_pot = 
    set_p_freq_spike = 
    set_p_freq_max = 
    set_p_compose_fact = 
    set_p_duree_burst_min = 
    set_p_duree_burst_max = 
    set_p_seuil_burst = 
    set_p_fatigue = False;
  
  switch(item_nb)
    {
    case 1:

      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, -10000L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 0L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, -7000L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (p_rest_pot * 100.)); n++;

      xmstring = XmStringCreateSimple("Resting potential (mV)");
      set_p_p_rest_pot = True;
      break;
    case 2:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, -10000L);  n++;
      XtSetArg(wargs[n], DeXNmaximum, 0L);  n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2);  n++;
      XtSetArg(wargs[n], DeXNdefaultValue, -6500L);  n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (seuil * 100 ));  n++;
      xmstring = XmStringCreateSimple("Firing threshold (mV)");
      set_p_seuil = True;
      break;
    case 3:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, -15000L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 0L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, -8500L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (pot_post_spike * 100)); n++;
      xmstring = XmStringCreateSimple("Post spike potential (mV)");
      set_p_pot_post_spike = True;
      break;
    case 4:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 10000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 2000L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (seuil_post_spike * 100)); n++;
      xmstring = XmStringCreateSimple("Postspike threshold (mV)");
      set_p_seuil_post_spike = True;
      break;
    case 5:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 1000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 0L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (fatigue * 100)); n++;
      xmstring = XmStringCreateSimple("Threshold fatigue (mS/cm2)");
      set_p_fatigue = True;
      break;
    case 6:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 50000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 100L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (tau_mb_pot * 100)); n++;
      xmstring = XmStringCreateSimple("Membrane time cste (ms)");
      set_p_tau_mb_pot = True;
      break;
    case 7:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 30000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 2000L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (tau_seuil * 100)); n++;
      xmstring = XmStringCreateSimple("Threshold time cste (ms)");
      set_p_tau_seuil = True;
      break;
    case 8:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 30000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 20L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (shunt_tau * 100)); n++;
      xmstring = XmStringCreateSimple("Shunt time cste (ms)");
      set_p_shunt_tau = True;
      break;

      /* Conditional burster */

    case 9:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, -10000L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 0L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, -5500L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (seuil_burst * 100)); n++;
      xmstring = XmStringCreateSimple("Burst threshold");
      set_p_seuil_burst = True;
      break;
    case 10:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, -10000L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 0L); n++;
      XtSetArg(wargs[n], DeXNturnStep,1000L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, -6000L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (burst_post_spike * 100)); n++;
      xmstring = XmStringCreateSimple("Threshold after a burst (mV)");
      set_p_burst_post_spike = True;
      break;
    case 11:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 50000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L); n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 5000L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (duree_burst_min * 100)); n++;
      xmstring = XmStringCreateSimple("Min burst duration (ms)");
      set_p_duree_burst_min = True;
      break;
    case 12:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L);  n++;
      XtSetArg(wargs[n], DeXNmaximum, 100000L);  n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2);  n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 15000L);  n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (duree_burst_max * 100)); n++;
      xmstring = XmStringCreateSimple("Max burst duration (ms)");
      set_p_duree_burst_max = True;
      break;
    case 13:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 500L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 0); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 30L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (freq_spike)); n++;
      xmstring = XmStringCreateSimple("Spike frequency (sp/s)");
      set_p_freq_spike = True;
      break;
    case 14:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 5000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,100L);  n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 0); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 150L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (freq_max)); n++;
      xmstring = XmStringCreateSimple("Maximal frequency (sp/s)");
      set_p_freq_max = True;
      break;
    case 15:
      XtSetArg(wargs[n], DeXNincrement, 1L); n++;
      XtSetArg(wargs[n], DeXNminimum, 0L); n++;
      XtSetArg(wargs[n], DeXNmaximum, 2000L); n++;
      XtSetArg(wargs[n], DeXNturnStep,50L); n++;
      XtSetArg(wargs[n], DeXNdecimalPoint, 2); n++;
      XtSetArg(wargs[n], DeXNdefaultValue, 200L); n++;
      XtSetArg(wargs[n], DeXNvalue, (long) (compose_fact * 100)); n++;
      xmstring = XmStringCreateSimple("Composition factor");
      set_p_compose_fact = True;
      break;
  } 


  XtSetValues(Dial_Phenoms,wargs,n);

  XtVaSetValues(label_p_selection,XmNlabelString,xmstring,NULL);

  XmStringFree(xmstring);

  if (flag_activ)
    {
      XtDestroyWidget(Top_Level_Activ);
      flag_activ = 0;
    } /* fin du if */
}

extern Pixmap equa_pix;
extern GC	eq_gc;

/*---------------------------*/
void sortie()
/*---------------------------*/
{
  if(ref1.gc)
    XFreeGC(disp, ref1.gc);
  if(ref2.gc)
    XFreeGC(disp, ref2.gc);
  if(ref3.gc)
    XFreeGC(disp, ref3.gc);
  if(refXY.gc)
    XFreeGC(disp, refXY.gc);
  if(eq_gc)
    XFreeGC(disp, eq_gc);
  XCloseDisplay(disp);
  if (tab_syn != NULL)
    free(tab_syn);
  if (tab_NMDA != NULL)
    free(tab_NMDA);
  if (potentiel != NULL)
    {
      free(potentiel);
      free(le_temps);
      free(ramp_input);
      free(courant_global);
      free(courant_K);
      free(courant_Na);
      free(courant_Ia);
      free(courant_Im);
      free(courant_Iahp);
      free(courant_Ic);
      free(courant_Ih);
      free(Ca);
      free(courant_Ca);
      free(courant_Nap);
      free(courant_Cab);
      free(valeur_m);
      free(valeur_h);
      free(synaptique);
      free(les_spikes);
      free(le_seuil);
      free(les_intervalles);
      free(l_histogramme);
    }
  XFreeCursor(disp, wait_cursor);
  exit(0);
}

/*-------------------------------------*/
void selection_fichier()
/*-------------------------------------*/
/*
 * rem: le nom du fichier selectionne est place dans la chaine de caracteres
 * nom_fichier_neuron (cf G_neuron.h) par le callback echo_file (cf
 * G_fich_callbacks)
 */
{
  Widget	dialog;
  XmString	string1, string2;
  Arg		wargs[20];
  int		n = 0;

  switch (model_type)
  {
      case MICHAELIS_MENTON_MODEL:
      case HH_SIMPLE_MODEL:
	  string1 = XmStringCreateSimple("*.G_unit");
	  break;
      case XNBC_MODEL:
	  string1 = XmStringCreateSimple("*.P_unit");
	  break;
      case LEAKY_INTEG_MODEL:
	  string1 = XmStringCreateSimple("*.L_unit");
	  break;
      case COND_BURST_MODEL:
	  string1 = XmStringCreateSimple("*.B_unit");
	  break;
  }

  string2 = XmStringCreateSimple(project_directory);
  XtSetArg(wargs[n], XmNautoUnmanage, TRUE);n++;
  XtSetArg(wargs[n], XmNdirMask, string1);n++;
  XtSetArg(wargs[n], XmNdirectory, string2);n++;
  XtSetArg(wargs[n], XmNdialogType, XmDIALOG_FILE_SELECTION);n++;
  dialog = XmCreateFileSelectionDialog(top_levelG,
				       "file",
				       wargs,
				       n);
  XtManageChild(dialog);
  XtAddCallback(dialog, XmNokCallback, (XtPointer)echo_file, nom_fichier_neuron);
  XSetWindowColormap(disp, XtWindow(XtParent(dialog)), palette);
  XmStringFree(string1);	
  XmStringFree(string2);	
} 


/*-------------------------------------*/
void selection_fichier_tms()
/*-------------------------------------*/
/*
 * rem: le nom du fichier selectionne est place dans la chaine de caracteres
 * nom_fichier_neuron_tms (cf G_neuron.h) par le callback echo_file_tms (cf
 * G_fich_callbacks)
 */
{
  Widget	dialogTmsIn,dialogTmsOut;
  XmString	string1, string2;
  Arg		wargs[20];
  int		n = 0;
  switch (choix_file)
    {
    case 5:
      {
	reset();

	XtSetArg(wargs[n], XtNtitle,"Tms Input");n++;
	string1 = XmStringCreateSimple("*.tms");
	string2 = XmStringCreateSimple(project_directory);
	XtSetArg(wargs[n], XmNautoUnmanage, TRUE);n++;
	XtSetArg(wargs[n], XmNdirMask, string1);n++;
	XtSetArg(wargs[n], XmNdirectory, string2);n++;
	XtSetArg(wargs[n], XmNdialogType, XmDIALOG_FILE_SELECTION);n++;

	
	dialogTmsIn = XmCreateFileSelectionDialog(top_levelG,
						  "filetmsin",
						  wargs,
						  n);
	XtManageChild(dialogTmsIn);
	flag_InputSelectionBox=1;
	XtAddCallback(dialogTmsIn, XmNokCallback, 
		      (XtPointer)echo_file_tms_in, nom_fichier_tms_input);
	XSetWindowColormap(disp, XtWindow(XtParent(dialogTmsIn)), palette);
	XmStringFree(string1);	
	XmStringFree(string2);	
	
	
	break;
      }
    case 6:
      {
	XtSetArg(wargs[n], XtNtitle,"Tms Output");n++;
	string1 = XmStringCreateSimple("*.tms");
	string2 = XmStringCreateSimple(project_directory);
	XtSetArg(wargs[n], XmNautoUnmanage, TRUE);n++;
	XtSetArg(wargs[n], XmNdirMask, string1);n++;
	XtSetArg(wargs[n], XmNdirectory, string2);n++;
	XtSetArg(wargs[n], XmNdialogType, XmDIALOG_FILE_SELECTION);n++;
	dialogTmsOut = XmCreateFileSelectionDialog(top_levelG,
						   "filetmsout",
						   wargs,
						   n);
	XtManageChild(dialogTmsOut);
	flag_OutputSelectionBox=1;
	XtAddCallback(dialogTmsOut, XmNokCallback, 
		      (XtPointer)echo_file_tms_out, nom_fichier_tms_output);
	XSetWindowColormap(disp, XtWindow(XtParent(dialogTmsOut)), palette);
	XmStringFree(string1);	
	XmStringFree(string2);	
	      break;
      }
    }
  
} 

void toggle_representation(int direction)
{

  /* How they are defined....

     w_x_0 = 0;
     w_y_0 = 30;
     w_x_1 = ((int)(.46 * (screen_width - 20)) + 26);
     w_y_h1 = (int)(((screen_height)/2) + 44);
     w_y_v1 = (int)(screen_height - ((screen_height - 120)/2) - 64);

  */

  if (direction == VERTICAL)        /* we go to vertical */
  {
      XMoveResizeWindow(disp, XtWindow(top_levelG), 
			w_x_0, w_y_0,
#if SCIENCE_ACTIVE
			(int)(.46 * (screen_width - 20) + 20), (int)((screen_height - 94)*.75));
#else
			(int)(.46 * (screen_width - 20) + 20), (int)(screen_height - 94));
#endif

      XMoveResizeWindow(disp, XtWindow(Top_Level_Inputs), 
			w_x_1, w_y_0,
			(int)(.46 * (screen_width - 20)), (int)((screen_height - 120)/2));

      if (flag_conductance)
      {
		XMoveResizeWindow(disp, XtWindow(Top_Level_Conductance), 
			  w_x_1, w_y_v1,
			  (int)(.46 * (screen_width - 20)), ((int)(screen_height - 120)/2));
      }
      else
      {
		XMoveResizeWindow(disp, XtWindow(Top_Level_Phenom), 
			  w_x_1, w_y_v1,
			  (int)(.46 * (screen_width - 20)), (int)((screen_height - 120)/2));
      }
      flag_horizontal = 0;
  }
  else                       /* we go to horizontal; */
  {
      XMoveResizeWindow(disp, XtWindow(top_levelG), 
			w_x_0, w_y_0,
			screen_width, (int)((screen_height - 30)/2));
      XMoveResizeWindow(disp, XtWindow(Top_Level_Inputs), 
			w_x_0, w_y_h1,
			((int)(.46 * (screen_width - 20)) + 20), (int)((screen_height - 120)/2));
      if (flag_conductance)
      {
		XMoveResizeWindow(disp, XtWindow(Top_Level_Conductance), 
			  w_x_1, w_y_h1,
#if SCIENCE_ACTIVE
			  ((int)(.35 * (screen_width - 20)) + 20), (int)((screen_height - 120)/2));
#else
			  ((int)(.46 * (screen_width - 20)) + 20), (int)((screen_height - 120)/2));
#endif
      }
      else
      {
		XMoveResizeWindow(disp, XtWindow(Top_Level_Phenom), 
			  w_x_1, w_y_h1,
#if SCIENCE_ACTIVE
			  ((int)(.35 * (screen_width - 20)) + 20), (int)((screen_height - 120)/2));
#else
			  ((int)(.46 * (screen_width - 20)) + 20), (int)((screen_height - 120)/2));

#endif
      }
      flag_horizontal = 1;
  }
}







