#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- no modification in this file -------------*/

#endif
/*------------------------------------------------------------
 *	G _ O N _ L I N E _ H E L P . C
 *-----------------------------------------------------------*/
/*
    Implemente l'aide en ligne dans G_neuron6 
    JF Vibert
    30 aout 1996
*/

#include <stdlib.h>
#include <stdio.h>

#include "G_neuron.h"
#include "G_interface.h"   

#include <Xm/CascadeB.h>


/*******************************************************************************
	Function to register widgets for help on line
*******************************************************************************/
void
register_widget_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	int message = (int)(unsigned long)client;

	widget_array[message] = w;	
}

/*******************************************************************************
	Function to add event handler for help on line
*******************************************************************************/
void
create_event_CB(w, client_data, call_data)
 Widget w;
 XtPointer client_data;
 XtPointer call_data;
{
    int message = (int)(unsigned long)client_data;
    
    XtAddEventHandler(w,EnterWindowMask,FALSE,(XtEventHandler)fill_HelpLabel,(XtPointer)message);
    XtAddEventHandler(w,LeaveWindowMask,FALSE,(XtEventHandler)status_HelpLabel,(XtPointer)message);
}

/*******************************************************************************
	Function for filling label info help on line
*******************************************************************************/
void fill_HelpLabel(Widget w,int message, XEvent *evt)
{
	XmString string;

	switch(message)
	{
	       case ID_Repeat_Stop_Stimulation:
			string = XmStringCreateLocalized(
			"Stop to inject a current at this moment (ms)");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
	       case ID_Repeat_Simulation_Duration:
			string = XmStringCreateLocalized(
			"Give here the simulation duration in ms");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_Repeat_Time_Step:
			string = XmStringCreateLocalized(
			"Give here the time step in ms");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
	        case ID_Repeat_Start_Stimulation:
			string = XmStringCreateLocalized(
			"Start to inject a current at this moment (ms)");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
	        case ID_Repeat_Stimulation_Duration:
			string = XmStringCreateLocalized(
			"Stop the current injection after this duration (ms)");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_DeXInput_Input_Crt:
			string = XmStringCreateLocalized(
			"Adjust the intensity of the stimulation current (see Help for dial use)");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;			
		case ID_Dial_Conductances:
			string = XmStringCreateLocalized(
			"Adjust the mean conductance of the selected current (see Help for dial use)");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_param_pushButton:
			string = XmStringCreateLocalized(
			"Press to adjust the parameters of the selected current");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_update_pushButton:
			string = XmStringCreateLocalized(
			"Compute and draw using the new values");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_update_toggleButton:
			string = XmStringCreateLocalized(
			"Select between automatic or manual recomputation");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_integration_toggleButton:
			string = XmStringCreateLocalized(
			"Select an integration method");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_radioBox:
			string = XmStringCreateLocalized(
			"Double click one of the button to select a current");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_radioBox1:
			string = XmStringCreateLocalized(
			"Double click one of the button to select a PSP");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_EDFixedDurationStim_pushButton:
			string = XmStringCreateLocalized(
			"Press to fixe the value of the stimulation duration time");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_DeXInput_PSP_Number:
			string = XmStringCreateLocalized(
			"Give here the number of button");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_Push_Button_Listing:
			string = XmStringCreateLocalized(
			"Press to have the file`s event type list");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_DeXInput_Diametre:
			string = XmStringCreateLocalized(
			"Give here the cell`s diameter in micro m");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_model_toggleButton:		     
			string = XmStringCreateLocalized(
			"Select between Michaelis-Menton, H-H simple or H-H pump model");
			XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;

		default:
			break;
	}
	
}

/*******************************************************************************
	Function for displaying a status in the label info
*******************************************************************************/
void status_HelpLabel(Widget w, int message, XEvent *evt)
{
	XmString string;
	
	string = XmStringCreateLocalized("On line help available here...");
	XtVaSetValues(HelpLabel,XmNlabelString,string,NULL);
	XmStringFree(string);	
	
}	

static char current_help_file[256];

/*
************************************************************************************
*
*	Function:
*		MainDisplayHelpCB (Flag)
*	Description:
*		fills the Topic menu with items available.
*
*	Inputs:
*
*	Revision:
*		june the 20th of 1996
*
*************************************************************************************
*/

void MainDisplayHelpCB (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/
	static Widget	helpMain_Form;
/*
**	Code
*/

	if (!helpMain_Form)
	{
		helpMain_Form = (Widget)CreatehelpMain_Form (top_levelG);
		MainDispHelpText (widget, (XtPointer) 0, call_data);
	}
	XtManageChild (helpMain_Form);
}
/*
************************************************************************************
*
*	Function:
*		MainDispHelpText (widget, client_data, call_data)
*	Description:
*		create, the first time, the Topic menu's items
*		fills the Topic menu with items available.
*
*	Inputs:
*		int	client_data	the help item number
*
*	Revision:
*		june the 20th of 1996		
*
*************************************************************************************
*/
void MainDispHelpText (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/	
	FILE		*fp;
	char		*pt;
	char		file_name[256];
	XmString	string;
	char		buffer[256];
	static		char **help_files;
	static		char **topics;
	Widget		w;
	static		int nb_items;
	char		*text;
	int		i;
	long		l;
	int		HelpNumber;
/*
**	Code
*/
#ifdef __CYGWIN__
#	define SEP_DIR "\\"
#	define CR 2
#else
#	define SEP_DIR "/"
#	define CR 1
#endif

	HelpNumber = (int) client_data;

	XtInitializeWidgetClass(xmPushButtonWidgetClass);

	current_help_file[0] = 0;

	if(HelpNumber == -1)
	{
		for(i=0 ; i<nb_items ; i++)
		{
			free(help_files[i]);
			free(topics[i]);
		}
		free(help_files);
		free(topics);
		return;
	}
	
	if(!nb_items)
	{
		strcpy(file_name,help_dir);
		strcat(file_name,SEP_DIR);
		strcat(file_name,"G_neuron_hlprc");
		strcpy(current_help_file,file_name);

		if(!(fp = fopen(file_name,"r")))
		{
			sprintf(buffer,"Sorry, file %s not found...",file_name);
			DispMessageDialog (top_levelG,
					   buffer,
					   "Error : No help available!",
					   XmDIALOG_ERROR);
			return;
		}
		
		nb_items = 0;
		
		while(fgets(buffer,255,fp))
		{	
			pt = strrchr(buffer,':');
			if(!pt)
				continue;
			nb_items++;
			*pt = '\0';
			pt += 2;
			if(nb_items == 1)
			{
				help_files = (char **)calloc(1,nb_items*sizeof(char *));
				topics = (char **)calloc(1,nb_items*sizeof(char *));
				topics[nb_items - 1] = (char *)calloc(1,(strlen(buffer)+1)*sizeof(char));
				strcpy(topics[nb_items - 1],buffer);
				help_files[nb_items - 1] = (char *)calloc(1,(strlen(pt)+1)*sizeof(char));
				strcpy(help_files[nb_items - 1],pt);
				help_files[nb_items - 1][strlen(pt)- CR ] = '\0';
			}
			else
			{
				help_files = (char **)realloc(help_files,nb_items*sizeof(char *));
				topics = (char **)realloc(topics,nb_items*sizeof(char *));
				topics[nb_items - 1] = (char *)calloc(1,(strlen(buffer)+1)*sizeof(char));
				strcpy(topics[nb_items - 1],buffer);
				help_files[nb_items - 1] = (char *)calloc(1,(strlen(pt)+1)*sizeof(char));
				strcpy(help_files[nb_items - 1],pt);
				help_files[nb_items - 1][strlen(pt)- CR ] = '\0';
			}	
		}
		
		for(i=0 ; i<nb_items ; i++)
		{
			string = XmStringCreateLocalized(topics[i]);
			w = XtVaCreateWidget(topics[i],
					     xmPushButtonWidgetClass,
					     helpTopic_PulldownMenu,
					     NULL);
			XtAddCallback(w, XmNactivateCallback, (XtPointer)MainDispHelpText, (XtPointer)(i+1));
			XtManageChild(w);
			XmStringFree(string);
		}
		HelpNumber = 1;	
	}
	
	strcpy(file_name,help_dir);
	strcat(file_name,SEP_DIR);
	strcat(file_name,help_files[HelpNumber-1]);
	strcpy(current_help_file,file_name);
	if(!(fp = fopen(file_name,"r")))
	{
		sprintf(buffer,"Sorry, file %s not found...",file_name);
		DispMessageDialog (top_levelG,
				   buffer,
				   "Error : Topic not available!",
				   XmDIALOG_ERROR);
		return;
	}
	
	fseek(fp, 0L, SEEK_END);
	l = ftell(fp)+1;
	if (!(text = (char *)calloc(1,l*sizeof(char))))
	{
		sprintf(buffer,"Sorry, not possible to load the help on %s...",file_name);
		DispMessageDialog (top_levelG,
				   buffer,
				   "Error : Not enough memory!",
				   XmDIALOG_ERROR);
		return;
	} /* fin du if */
	fseek(fp, 0L, SEEK_SET);
	fread(text, l*sizeof(char), 1, fp);
	text[l-1] = '\0';
	
	XmTextSetString (help_Text, text);
	
	string = XmStringCreateLocalized(topics[HelpNumber-1]);
	XtVaSetValues(helpTopic_Label,
		      XmNlabelString, string,
		      NULL);
	XmStringFree(string);	
	
	free(text);
}

/*
**************************************************************
*
*	Function:
*		DispMessageDialog (Parent, TexteToDisplay, TitleOfDialog, TypeOfDialog)
*	Description:
*		Display a Message Box
*
*	Inputs arguments:
*		Widget		TheParent	:	Widget parent of the MessageBox
*		char*		TextToDisplay	:	...
*		char*		TitleOfDialog	:	...
*		unsigned char	TypeOfDialog	:	...
*		
*	Revision:
*		june the 18th of 1996
*
****************************************************************
*/
void DispMessageDialog (Widget TheParent,char *TextToDisplay, char *TitleOfDialog,unsigned char TypeOfDialog)
{
/*
**	Variables
*/
	XmString	StringText,
			StringTitle;
	Arg		args[3];
	int		n;
/*
**	Code
*/
	n = 0;
	
	StringText = XmStringCreateLtoR (TextToDisplay, XmFONTLIST_DEFAULT_TAG);
	StringTitle = XmStringCreateLocalized (TitleOfDialog);
	
	if (TheMessageBox)
	{
                XtDestroyWidget(TheMessageBox);
	}
	XtSetArg (args[n], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL); n++;
      	TheMessageBox = XmCreateMessageDialog (TheParent, "TheMessageBox", args, n);
       	if (TypeOfDialog == 1)
		XtUnmanageChild (XmMessageBoxGetChild (TheMessageBox, XmDIALOG_CANCEL_BUTTON));
	XtUnmanageChild (XmMessageBoxGetChild (TheMessageBox, XmDIALOG_HELP_BUTTON));

	XtVaSetValues (TheMessageBox,
		       XmNdialogType,XmDIALOG_MESSAGE ,
		       XmNmessageString, StringText,
#ifndef linux
		       XmNdialogTitle, StringTitle,
#endif
		       NULL);
	XmStringFree (StringText);
	XmStringFree (StringTitle);
	if (TypeOfDialog == 0)
	         XtAddCallback(TheMessageBox,XmNokCallback, (XtPointer)callback_sortie, NULL);
	XtManageChild (TheMessageBox);
	XtPopup (XtParent(TheMessageBox), XtGrabNone);
}


/*
 * Create the help_form hierarchy of widgets.
 */
Widget
CreatehelpMain_Form(parent)
Widget parent;
{
    Arg      args[256];
    Cardinal ac=0;
    XmString StringLabel;
    Widget   help_DialogShell;
    Widget   helpMain_Form;
    Widget   help_MenuBar;
    Widget   helpTopic_CascadeButton;
    Widget   helpPrint_PushButton;
    Widget   helpDismiss_PushButton;
    Widget   help_ScrolledWindow;
/*		see global variables
    Widget   helpTopic_PulldownMenu;
    Widget   helpTopic_Label;
    Widget   help_Text;
*/
    
    /*
     * Register the converters for the widgets.
     */
     
    XtInitializeWidgetClass(xmDialogShellWidgetClass);
    XtInitializeWidgetClass(xmFormWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmCascadeButtonWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    XtInitializeWidgetClass(xmLabelWidgetClass);
    XtInitializeWidgetClass(xmScrolledWindowWidgetClass);
/*
XtInitializeWidgetClass(xmTextWidgetClass);
*/    
    ac = 0;
    XtSetArg(args[ac], XmNtitle, "Help On Topics"); ac++;
    XtSetArg(args[ac], XmNminWidth, 371); ac++;
    XtSetArg(args[ac], XmNminHeight, 165); ac++;
    XtSetArg(args[ac], XmNx, 508); ac++;
    XtSetArg(args[ac], XmNy, 217); ac++;
    XtSetArg(args[ac], XmNwidth, 536); ac++;
    XtSetArg(args[ac], XmNheight, 548); ac++;
    help_DialogShell = XtCreatePopupShell("help_DialogShell",
        xmDialogShellWidgetClass,
        parent,
        args, 
        ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
    XtSetArg(args[ac], XmNx, 508); ac++;
    XtSetArg(args[ac], XmNy, 217); ac++;
    XtSetArg(args[ac], XmNwidth, 536); ac++;
    XtSetArg(args[ac], XmNheight, 548); ac++;
    helpMain_Form = XmCreateForm(help_DialogShell,
        "helpMain_Form",
        args, 
        ac);
    
     /* create the icon */
/*     
    XtVaSetValues(XtParent(helpMain_Form),XtNiconPixmap,pixicon,NULL);   
*/    
    ac = 0;
    XtSetArg(args[ac], XmNx, 2); ac++;
    XtSetArg(args[ac], XmNy, 2); ac++;
    XtSetArg(args[ac], XmNwidth, 532); ac++;
    XtSetArg(args[ac], XmNheight, 39); ac++;
    help_MenuBar = XmCreateMenuBar(helpMain_Form,
        "help_MenuBar",
        args, 
        ac);
    XtManageChild(help_MenuBar);
    
    StringLabel = XmStringCreateLocalized("Print");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, StringLabel); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'P'); ac++;
    XtSetArg(args[ac], XmNx, 440); ac++;
    XtSetArg(args[ac], XmNy, 508); ac++;
    XtSetArg(args[ac], XmNwidth, 60); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    helpPrint_PushButton = XmCreatePushButton(helpMain_Form,
        "helpPrint_PushButton",
        args, 
        ac);
    XtAddCallback(helpPrint_PushButton, XmNactivateCallback, (XtPointer)PrintHelpText, NULL);

    XtManageChild(helpPrint_PushButton);
    XmStringFree(StringLabel);
    
    StringLabel = XmStringCreateLocalized("Topics");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, StringLabel); ac++; 
    XtSetArg(args[ac], XmNmnemonic, 'T'); ac++;
    XtSetArg(args[ac], XmNx, 5); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 60); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    helpTopic_CascadeButton = XmCreateCascadeButton(help_MenuBar,
        "helpTopic_CascadeButton",
        args, 
        ac);
    XtManageChild(helpTopic_CascadeButton);
    XmStringFree(StringLabel);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 515); ac++;
    XtSetArg(args[ac], XmNy, 253); ac++;
    XtSetArg(args[ac], XmNwidth, 109); ac++;
    XtSetArg(args[ac], XmNheight, 33); ac++;
    helpTopic_PulldownMenu = XmCreatePulldownMenu(XtParent(helpTopic_CascadeButton),
        "pulldownMenu",
        args, 
        ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, helpTopic_PulldownMenu); ac++;
    XtSetValues(helpTopic_CascadeButton, args, ac);

    StringLabel = XmStringCreateLocalized("Help on G_neuron ");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, StringLabel); ac++;
    XtSetArg(args[ac], XmNx, 2); ac++;
    XtSetArg(args[ac], XmNy, 43); ac++;
    XtSetArg(args[ac], XmNwidth, 532); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    helpTopic_Label = XmCreateLabel(helpMain_Form,
        "helpTopic_Label",
        args, 
        ac);
    XtManageChild(helpTopic_Label);
    XmStringFree(StringLabel);
   
    StringLabel = XmStringCreateLocalized("Dismiss");
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, StringLabel); ac++;
    XtSetArg(args[ac], XmNx, 150); ac++;
    XtSetArg(args[ac], XmNy, 508); ac++;
    XtSetArg(args[ac], XmNwidth, 236); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    helpDismiss_PushButton = XmCreatePushButton(helpMain_Form,
        "helpDismiss_PushButton",
        args, 
        ac);
    XtManageChild(helpDismiss_PushButton);
    XmStringFree(StringLabel);
    
    ac = 0;
    XtSetArg(args[ac], XmNscrollingPolicy, XmAUTOMATIC); ac++;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 75); ac++;
    XtSetArg(args[ac], XmNwidth, 532); ac++;
    XtSetArg(args[ac], XmNheight, 421); ac++;
    help_ScrolledWindow = XmCreateScrolledWindow(helpMain_Form,
        "help_ScrolledWindow",
        args, 
        ac);
    XtManageChild(help_ScrolledWindow);
    
    ac = 0;
    XtSetArg(args[ac], XmNeditMode, XmMULTI_LINE_EDIT); ac++;
    XtSetArg(args[ac], XmNeditable, False); ac++;
    XtSetArg(args[ac], XmNcursorPositionVisible, False); ac++;
    XtSetArg(args[ac], XmNcolumns, 160); ac++;
    XtSetArg(args[ac], XmNrows, 1); ac++;
    help_Text = (Widget) XmCreateText(help_ScrolledWindow,
			     "help_Text",
			     args, 
			     ac);
    XtManageChild(help_Text);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomWidget, helpTopic_Label); ac++;
    XtSetArg(args[ac], XmNtopOffset, 2); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 2); ac++;
    XtSetArg(args[ac], XmNleftOffset, 2); ac++;
    XtSetArg(args[ac], XmNrightOffset, 2); ac++;
    XtSetValues(help_MenuBar, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomWidget, help_ScrolledWindow); ac++;
    XtSetArg(args[ac], XmNtopOffset, 0); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 4); ac++;
    XtSetArg(args[ac], XmNrightOffset, 2); ac++;
    XtSetArg(args[ac], XmNleftOffset, 2); ac++;
    XtSetValues(helpTopic_Label, args, ac);
    

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftWidget,helpDismiss_PushButton); ac++;
    XtSetArg(args[ac], XmNrightOffset, 50); ac++;
    XtSetValues(helpPrint_PushButton, args, ac);
  
     ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
/*    XtSetArg(args[ac], XmNrightWidget,helpPrint_PushButton ); ac++; */
    XtSetArg(args[ac], XmNbottomOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftOffset, 50); ac++;
    XtSetValues(helpDismiss_PushButton, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopOffset, 75); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 52); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 4); ac++;
    XtSetValues(help_ScrolledWindow, args, ac);
    
    return( helpMain_Form );
}

void PrintHelpText(Widget w, XtPointer rien, XtPointer Rien)
{
   char *print_command;
   char ligne[250];

   print_command = getenv("PRINT_PLOT_PS");
#if 1
   if (print_command)
       sprintf(ligne,"%s %s",print_command,current_help_file);	  
    else
       sprintf(ligne,"lpr -Ppostscript %s",current_help_file);
#endif
#if 0
    if (print_command)
       sprintf(ligne,"%s %s",print_command,current_help_file);	  
    else
       sprintf(ligne,"PRINT /QUEUE=PS %s /DELETE",current_help_file);     
#endif
   printf("%s \n",ligne); 
   system(ligne);
 MainDisplayHelpCB (w, NULL, NULL);
}

 











