#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- no modification in this file -------------*/

#endif
#define DEBUG 0
/*--------------------------------------------------------------------
 *              G _ P L O T _ E Q U A . C
 *
 *			d r a w _ M _ H _ T A U _ g r a p h
 *------------------------------------------------------------------*/
/* fonction qui permet de dessiner sur l'aire determinee par ref,
avec la couleur "couleur", les valeurs contenues dans "tableau" */

#include "G_neuron.h"
#include "G_interface.h"
#include "G_reference.h"

#undef MAIN

#include "G_synap.h"
#include "G_dessin.h"


#ifndef TRUE
#	define TRUE	1
#endif

#ifndef FALSE
#	define FALSE	0
#endif

#define UP_OFFSET	15
#define BOTTOM_OFFSET	30

#define	GAUCHE	0
#define	CENTRE	1
#define	DROITE	2

#define	ACT	0
#define	INACT	1
#define	TAU	2
#define COEFF_G 3

extern int NOIR,
	   ROUGE,
	   BLEU,
	   VERT,
	   VIOLET,
	   MAUVE,
	   TURQ,
	   JAUNE,
	   BLANC;

extern	Display		*disp;

extern	REFERENCE	refM_H_TAU;

extern float	*V_graph,
		*M_graph;

extern	char	V_legend[20],
		M_legend[20];

float		M_H_TAU_graph_scale;
static	int	draw_debut;

void draw_M_H_TAU_graph(void)
{
	int	i;
	char	buffer[255];
	float	X_max, X_min,
		Y_max, Y_min;

#if DEBUG
	printf("draw_M_H_TAU_graph\n");
#endif
	
#if 0
	if(flag_M_H_TAU)
	{
		XtPopup(Top_Level_M_H_TAU,XtGrabNone);
	}
	else
	{
		fabrique_M_H_TAU_area();
		flag_M_H_TAU = 1;
	} /* fin du else */
#endif
	if(flag_activ)
	{
		XtPopup(Top_Level_Activ,XtGrabNone);
	}
	else
	{
		fabrique_scrolled_window_activ();
		flag_activ = 1;
	} /* fin du else */


#if DEBUG
	printf("draw_M_H_TAU_graph: Top_Level_M_H_TAU made\n");
#endif

	V_graph = voltage;
	strcpy(V_legend,"mV");
	refM_H_TAU.decimals_x = 0; 
	X_min = X_max = V_graph[0];
	Y_min = 0.;
	for (i = 1; i < PLOT_SIZE; i++)
	{
		if(V_graph[i] > X_max)
			X_max = V_graph[i];
		else
			if(V_graph[i] < X_min)
				X_min = V_graph[i];
	} /* fin du for */
	
	draw_debut = True;

	/*
	* Activation m
	*/

	M_graph = activ;
	strcpy(M_legend,"m");
	refM_H_TAU.decimals_y = 2; 

	Y_max = M_graph[0];
	for (i = 1; i < PLOT_SIZE; i++)
	{
		if(M_graph[i] > Y_max)
			Y_max = M_graph[i];
	} /* fin du for */
	if (Y_max < .5)
		Y_max = 0;
	else
		Y_max = 1.;


#if DEBUG
	sprintf(buffer,"X_min: %f X_max: %f Y_min: %f Y_max: %f\n",
	       X_min, X_max, Y_min, Y_max);
	XtWarning(buffer);
#endif
	sprintf(buffer,"%s = f(%s)",M_legend,V_legend);

	if (draw_M_H_TAU_reference(buffer,V_legend, M_legend,
			  X_min, X_max, Y_min, Y_max, GAUCHE, ACT))
	{
		dessine_M_H_TAU(GAUCHE,ACT);
	}

	/*
	 * Inactivation h
	 */
	 
	M_graph = inactiv;
	strcpy(M_legend,"h");
	refM_H_TAU.decimals_y = 2; 
 
	Y_max = M_graph[0];
	for (i = 1; i < PLOT_SIZE; i++)
	{
		if(M_graph[i] > Y_max)
			Y_max = M_graph[i];
	} /* fin du for */
	if (Y_max < .5)
		Y_max = 0;
	else
		Y_max = 1.;

#if DEBUG
	sprintf(buffer,"X_min: %f X_max: %f Y_min: %f Y_max: %f\n",
	       X_min, X_max, Y_min, Y_max);
	XtWarning(buffer);
#endif
	sprintf(buffer,"%s = f(%s)",M_legend,V_legend);

	if (draw_M_H_TAU_reference(buffer,V_legend, M_legend,
			  X_min, X_max, Y_min, Y_max, GAUCHE, INACT))
	{
		dessine_M_H_TAU(GAUCHE,INACT);
	}

	/*
	* Coefficent multiplicateur de g_x
	*/

	M_graph = coeff_G;
	strcpy(M_legend,"Coeff G");
	refM_H_TAU.decimals_y = 2; 

	Y_max = M_graph[0];
	for (i = 1; i < PLOT_SIZE; i++)
	{
		if(M_graph[i] > Y_max)
			Y_max = M_graph[i];
	} /* fin du for */

#if DEBUG
	sprintf(buffer,"X_min: %f X_max: %f Y_min: %f Y_max: %f\n",
	       X_min, X_max, Y_min, Y_max);
	XtWarning(buffer);
#endif
	sprintf(buffer,"%s = f(%s)",M_legend,V_legend);

	if (draw_M_H_TAU_reference(buffer,V_legend, M_legend,
			  X_min, X_max, Y_min, Y_max, GAUCHE, COEFF_G))
	{
		dessine_M_H_TAU(GAUCHE,COEFF_G);
	}

	/*
	* Tau Activation m
	*/

	M_graph = tau_activ;
	strcpy(M_legend,"Tau m");
	refM_H_TAU.decimals_y = 2; 

	Y_min = 0.;
	Y_max = M_graph[0];
	for (i = 1; i < PLOT_SIZE; i++)
	{
		if(M_graph[i] > Y_max)
			Y_max = M_graph[i];
	} /* fin du for */

#if DEBUG
	sprintf(buffer,"X_min: %f X_max: %f Y_min: %f Y_max: %f\n",
	       X_min, X_max, Y_min, Y_max);
	XtWarning(buffer);
#endif
	sprintf(buffer,"%s = f(%s)",M_legend,V_legend);

	if (draw_M_H_TAU_reference(buffer,V_legend, M_legend,
			  X_min, X_max, Y_min, Y_max, CENTRE, TAU))
	{
		dessine_M_H_TAU(CENTRE,TAU);
	}

	/*
	 * Activation
	 */
	 
	M_graph = activ;
	strcpy(M_legend,"m");
	refM_H_TAU.decimals_y = 2; 
 
	Y_max = M_graph[0];
	for (i = 1; i < PLOT_SIZE; i++)
	{
		if(M_graph[i] > Y_max)
			Y_max = M_graph[i];
	} /* fin du for */
	if (Y_max < .5)
		Y_max = 0;
	else
		Y_max = 1.;

#if DEBUG
	sprintf(buffer,"X_min: %f X_max: %f Y_min: %f Y_max: %f\n",
	       X_min, X_max, Y_min, Y_max);
	XtWarning(buffer);
#endif
	sprintf(buffer,"%s = f(%s)",M_legend,V_legend);

	if (draw_M_H_TAU_reference(buffer,V_legend, M_legend,
			  X_min, X_max, Y_min, Y_max, CENTRE, ACT))
	{
		dessine_M_H_TAU(CENTRE, ACT);
	}

	/*
	 * Tau Inactivation
	 */
	 
	M_graph = tau_inactiv;
	strcpy(M_legend,"Tau h");
	refM_H_TAU.decimals_y = 2; 
 
	Y_max = M_graph[0];
	for (i = 1; i < PLOT_SIZE; i++)
	{
		if(M_graph[i] > Y_max)
			Y_max = M_graph[i];
	} /* fin du for */

#if DEBUG
	sprintf(buffer,"X_min: %f X_max: %f Y_min: %f Y_max: %f\n",
	       X_min, X_max, Y_min, Y_max);
	XtWarning(buffer);
#endif
	sprintf(buffer,"%s = f(%s)",M_legend,V_legend);

	if (draw_M_H_TAU_reference(buffer,V_legend, M_legend,
			  X_min, X_max, Y_min, Y_max, DROITE, TAU))
	{
		dessine_M_H_TAU(DROITE, TAU);
	}
	
	/*
	 * Inactivation
	 */
	 
	M_graph = inactiv;
	strcpy(M_legend,"h");
	refM_H_TAU.decimals_y = 2; 
 
	Y_max = M_graph[0];
	for (i = 1; i < PLOT_SIZE; i++)
	{
		if(M_graph[i] > Y_max)
			Y_max = M_graph[i];
	} /* fin du for */
	if (Y_max < .5)
		Y_max = 0;
	else
		Y_max = 1.;

#if DEBUG
	sprintf(buffer,"X_min: %f X_max: %f Y_min: %f Y_max: %f\n",
	       X_min, X_max, Y_min, Y_max);
	XtWarning(buffer);
#endif
	sprintf(buffer,"%s = f(%s)",M_legend,V_legend);

	if (draw_M_H_TAU_reference(buffer,V_legend, M_legend,
			  X_min, X_max, Y_min, Y_max, DROITE, INACT))
	{
		dessine_M_H_TAU(DROITE, INACT);
	}
}



/*----------------------------------------------------------------
 *	d r a w _ r e f e r e n c e
 *--------------------------------------------------------------*/

int	draw_M_H_TAU_reference (char *titre, char *X_leg, char *Y_leg,
			   float X_min, float X_max,
			   float Y_min, float Y_max, int position, int courbe)
{
	int	win_height, win_width, win_util,
		left_offset, right_offset;
	XWindowAttributes	win_attr;
	float	a, b, c, A, B, x, y;
	int	px, py, px_before, py_before;
	int	first_px = TRUE, first_py = TRUE;
	char	number[10];
	char	legende[40];
	int	nchar;

	disp = XtDisplay(Top_Level_Activ);

	refM_H_TAU.window = XtWindow (Drawing_M_H_TAU);

	if (!refM_H_TAU.gc)
		refM_H_TAU.gc = XCreateGC (disp, root_window,
					     0, NULL);
	refM_H_TAU.lower_x = X_min;
	refM_H_TAU.upper_x = X_max;
	refM_H_TAU.grad_x = (X_max-X_min)/10.;
	refM_H_TAU.lower_y = Y_min;
	refM_H_TAU.upper_y = Y_max;
	if ( courbe == COEFF_G)
		refM_H_TAU.grad_y = (Y_max-Y_min)/5.;
	else
		refM_H_TAU.grad_y = (Y_max-Y_min)/10.;
	refM_H_TAU.identificateur = 1;
	
	if (!refM_H_TAU.window || !refM_H_TAU.gc)
	{
		return FALSE;
	}

	XSetBackground(disp, refM_H_TAU.gc, BLANC );

	XSetForeground(disp, refM_H_TAU.gc, NOIR );
	
	XGetWindowAttributes (disp, refM_H_TAU.window, &win_attr);
	win_height = (int) win_attr.height;
	win_width  = (int) win_attr.width;
	win_util = win_width/3;

	/* pour le print par plot_ps */
	M_H_TAU_graph_scale = (float)(win_util)/(float)(win_height);

	left_offset = 50 + (win_util * position);
	right_offset = (win_util + (win_util * position)) - 15 ;

/*--- Blanchissage de la window ---------------------------------*/

	if (draw_debut)
	{
		XClearArea (disp, refM_H_TAU.window, 0, 0,
			    win_width - 1, win_height - 1, False);
		
		if (win_height < BOTTOM_OFFSET + UP_OFFSET + 20 ||
		    win_width < (win_util * 3))
		{
			return FALSE;
		}
		draw_debut = False;
	} /* fin du if */

/*--- Equations de changement de repere -------------------------*/
/* permet de definir des coordonnees absolues des valeurs min et max
de chaque axe par rapport au systeme de coordonnees de la fenetre   */

	a = refM_H_TAU.lower_x + left_offset;
	b = refM_H_TAU.upper_x + left_offset;

	if ((c = (a - b)) == 0.)
	{
		XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
			    ((int)(win_util/2) + left_offset),
			    (int)(win_height/2),
			    "X min = X max: no graph possible",32);
		return FALSE;
	}

	A = (float) left_offset;
	B = (float) right_offset;
	
	refM_H_TAU.A_x = (A - B) / c;
	refM_H_TAU.B_x = (a * B - b * A) / c;

	a = refM_H_TAU.upper_y;
	b = refM_H_TAU.lower_y;
	A = (float) UP_OFFSET;
	B = (float) win_height - (float) BOTTOM_OFFSET;
	

	if ((c = (a - b)) == 0.)
	{
		switch(courbe)
		{
			case ACT:
				XSetForeground(disp, refM_H_TAU.gc, ROUGE );
				XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
					    (left_offset + (win_util/5)),
					    ((int)(win_height/2) + 20),
					    "No activation",13);
				XSetForeground(disp, refM_H_TAU.gc, NOIR );
				break;
			case INACT:
				
				XSetForeground(disp, refM_H_TAU.gc, BLEU );
				XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
					    (left_offset + (win_util/5)),
					    ((int)(win_height/2) + 5),
					    "No inactivation",15);
				XSetForeground(disp, refM_H_TAU.gc, NOIR );
				break;
			case COEFF_G:
				
				XSetForeground(disp, refM_H_TAU.gc, MAUVE );
				XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
					    (left_offset + (win_util/5)),
					    ((int)(win_height/2) - 5),
					    "Coeff. not volt. dependant",26);
				XSetForeground(disp, refM_H_TAU.gc, NOIR );
				break;
			case TAU:
				
				XSetForeground(disp, refM_H_TAU.gc, VERT );
				XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
					    (left_offset + (win_util/5)),
					    ((int)(win_height/2) - 20),
					    "No time cste",12);
				XSetForeground(disp, refM_H_TAU.gc, NOIR );
		} /* fin du switch */
		return FALSE;
	}

	refM_H_TAU.A_y = (A - B) / c;
	refM_H_TAU.B_y = (a * B - b * A) / c;

/*--- Trace de l'axe vertical ----------------------------------*/

	if (courbe == TAU || (position == GAUCHE && courbe == COEFF_G))
		XDrawLine (disp, refM_H_TAU.window, refM_H_TAU.gc,
			   (left_offset + win_util - 65),
			   UP_OFFSET,
			   (left_offset + win_util - 65),
			   win_height - BOTTOM_OFFSET);
	else
		XDrawLine (disp, refM_H_TAU.window, refM_H_TAU.gc,
			   left_offset,
			   UP_OFFSET,
			   left_offset,
			   win_height - BOTTOM_OFFSET);

/*--- Trace de l'axe horizontal --------------------------------*/
	
	XDrawLine (disp, refM_H_TAU.window, refM_H_TAU.gc,
	    left_offset,
	    win_height - BOTTOM_OFFSET,
	    right_offset,
	    win_height - BOTTOM_OFFSET);

/*--- Trace des graduations horizontales -----------------------*/

	x = refM_H_TAU.lower_x + left_offset;
	y = refM_H_TAU.lower_y;
	py = (int) floor (refM_H_TAU.A_y * y + refM_H_TAU.B_y + 0.5);

	px_before = (int) floor (refM_H_TAU.A_x * x + refM_H_TAU.B_x + 0.5);

	do
	{
		px = (int) floor (refM_H_TAU.A_x * x + refM_H_TAU.B_x + 0.5);

		if ((px - px_before) > 35 || first_px)
		/* pour que les chiffres correspondant aux
		graduations ne se chevauchent pas */
		{
			px_before = px;
			first_px = FALSE;
		
			switch (refM_H_TAU.decimals_x)
			{
				case 0:
					sprintf (number, "%5.0f", x - left_offset);
					break;
				case 1:
					sprintf (number, "%5.1f", x - left_offset);
					break;
				case 2:
				default:
					sprintf (number, "%5.2f", x - left_offset);
					break;
			}

			XDrawLine (disp, refM_H_TAU.window, refM_H_TAU.gc,
				   px, py, px, py + 6);
			XDrawString (disp, refM_H_TAU.window, refM_H_TAU.gc,
				     px - 15, py + 20, number, 5);
		}
		else
		{
			XDrawLine (disp, refM_H_TAU.window, refM_H_TAU.gc,
				   px, py, px, py + 3);
		}
		
		x += refM_H_TAU.grad_x;
		
	} while (x <= refM_H_TAU.upper_x + left_offset);

/*--- Trace des graduations verticales ----------------------------*/


	if (courbe == TAU || (position == GAUCHE && courbe == COEFF_G))
	{
		x = refM_H_TAU.lower_x + right_offset;
		a = refM_H_TAU.lower_x + right_offset;
		b = refM_H_TAU.upper_x + right_offset;

		if ((c = (a - b)) == 0.)
		{
			XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
				    ((int)(win_util/2) + left_offset),
				    (int)(win_height/2),
				    "X min = X max: no graph possible",32);
			return FALSE;
		}

		A = (float) left_offset;
		B = (float) right_offset;
		px = (int) floor (((A - B)/c) * x + ((a * B - b * A) / c) + 0.5) + win_util - 65;
	}
	else
	{
		x = refM_H_TAU.lower_x + left_offset;
		px = (int) floor (refM_H_TAU.A_x * x + refM_H_TAU.B_x + 0.5);
	} /* fin du else */
	y = refM_H_TAU.lower_y;

	py_before = (int) floor (refM_H_TAU.A_y * y + refM_H_TAU.B_y + 0.5);

	do
	{
		py = (int) floor (refM_H_TAU.A_y * y + refM_H_TAU.B_y + 0.5);
		
		if ((py_before - py) > 10 || first_py)
		{
			py_before = py;
			first_py = FALSE;
		
			switch (refM_H_TAU.decimals_y)
			{
				case 0:
					sprintf (number, "%5.0f", y);
					break;
				case 1:
					sprintf (number, "%5.1f", y);
					break;
				case 2:
				default:
					sprintf (number, "%5.2f", y);
					break;
			}

			XDrawLine (disp, refM_H_TAU.window, refM_H_TAU.gc, px,
				   py, px - 6, py);
			XDrawString (disp, refM_H_TAU.window, refM_H_TAU.gc,
				     px - 40, py + 5, number, 5);
		}
		else
		{
			XDrawLine (disp, refM_H_TAU.window, refM_H_TAU.gc,
				   px, py, px - 3, py);
		}
		
		y += refM_H_TAU.grad_y;
		
	} while (y <= refM_H_TAU.upper_y);



/*---	trace des legendes --------------------------------------*/


	XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
			    right_offset - 100,
			    win_height - (BOTTOM_OFFSET + 5),
			    X_leg,strlen(X_leg));
	if (courbe == TAU)
	{
		XSetForeground(disp, refM_H_TAU.gc, VERT);
		XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
			    (left_offset + win_util - 100),
			    (UP_OFFSET + 20),
			    Y_leg,strlen(Y_leg));
		XSetForeground(disp, refM_H_TAU.gc, NOIR);
		
	} /* fin du if */
	else
	{
		switch(courbe)
		{
			case ACT:
				XSetForeground(disp, refM_H_TAU.gc, ROUGE );
				XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
					    (left_offset + 20),
					    (UP_OFFSET + 20),
					    Y_leg,strlen(Y_leg));
				XSetForeground(disp, refM_H_TAU.gc, NOIR);
				break;
			case INACT:
				XSetForeground(disp, refM_H_TAU.gc, BLEU );
				if (position == GAUCHE)
					XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
						    (left_offset + 30),
						    (UP_OFFSET + 20),
						    Y_leg,strlen(Y_leg));
				else
					XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
						    (left_offset + 5),
						    (UP_OFFSET + 20),
						    Y_leg,strlen(Y_leg));
				
				XSetForeground(disp, refM_H_TAU.gc, NOIR);
				break;
			case COEFF_G:
				XSetForeground(disp, refM_H_TAU.gc, MAUVE );
				XDrawString(disp, refM_H_TAU.window, refM_H_TAU.gc,
					    (right_offset - 20),
					    (UP_OFFSET + 20),
					    Y_leg,strlen(Y_leg));
				XSetForeground(disp, refM_H_TAU.gc, NOIR);
				break;
		}
		
	} /* fin du else */

	return TRUE;
}



/*--------------------------------------------------------------------
 *			d e s s i n e _ M _ H _ T A U
 *------------------------------------------------------------------*/
/* fonction qui permet de dessiner sur l'aire determinee par ref,
avec la couleur "couleur", les valeurs contenues dans "tableau */

void    dessine_M_H_TAU (int position, int courbe)
{	
	float   x1, y1, x2, y2;
	int     i,j,
		left_offset;
	int			win_width, win_util;
	XWindowAttributes	win_attr;


	XGetWindowAttributes (disp, refM_H_TAU.window, &win_attr);
	win_width  = (int) win_attr.width;
	win_util = win_width/3;

	switch(courbe)
	{
		case ACT:
			XSetForeground (disp, refM_H_TAU.gc, ROUGE);
			break;
		case INACT:
			XSetForeground (disp, refM_H_TAU.gc, BLEU);
			break;
		case TAU:
			XSetForeground (disp, refM_H_TAU.gc, VERT);
			break;
		case COEFF_G:
			XSetForeground (disp, refM_H_TAU.gc, MAUVE);
	} /* fin du switch */

	left_offset = 0 ;
	left_offset = 50 + (win_util * position); 

	x1 = V_graph[0] + left_offset;
	y1 = M_graph[0];
	for (i = 1; i < PLOT_SIZE; i++)
	{
		x2 = *(V_graph + i) + left_offset;
		y2 = *(M_graph + i);
		draw_segment (disp, &refM_H_TAU, x1, y1, x2, y2);
		x1 = x2;
		y1 = y2;
	}

}
