
/*
 * Les neurotransmetteurs sont representes par des flags soit 64 bits
 * differents et donc 62 valeurs possibles
 * la valeur 0 represente: pas de transmission
 * Si plusieurs trasmetteurs sont laches, on les met individuellement.
 */

#ifdef MAIN
#	define	CLASS
#else
#	define	CLASS	extern
#endif


#define	NO_TRANSMISSION	0
#define	ANY	        1
#define	ACETYLCHOLINE	2
#define	ADRENALINE	4
#define	NORADRENALINE	8
#define	SEROTONINE	16
#define	GABA_A		32
#define	GLYCINE		64
#define	GLUTAMATE	128
#define	DOPAMINE	256
#define HISTAMINE	512
#define	SUBST_P		1024
#define	ENKEPHALIN	2048
#define	ENDORPHIN	4096
#define	ELECTROTONIC	8192
#define	PEPTIDE		16384
#define	YOURS		32768
#define MODULATOR_1	65536
#define	MODULATOR_2	131072
#define	GABA_B      	262144



#define NB_NO_TRANSMISSION	0
#define NB_ANY	                1
#define NB_ACETYLCHOLINE	2
#define NB_ADRENALINE	        3
#define NB_NORADRENALINE	4
#define NB_SEROTONINE	        5
#define NB_GABA_A		6
#define NB_GABA_B		7
#define NB_GLYCINE		8
#define NB_GLUTAMATE	        9
#define NB_DOPAMINE	        10
#define NB_HISTAMINE	        11
#define NB_SUBST_P		12
#define NB_ENKEPHALIN	13
#define NB_ENDORPHIN	14
#define NB_ELECTROTONIC	15
#define NB_PEPTIDE	16
#define NB_YOURS	17
#define NB_MODULATOR_1	18
#define NB_MODULATOR_2	19

#define	NB_TRANSMITORS	20

typedef	struct	Receptor
{
	float	rev_pot;
	float	tau_attack;
	float	tau_decay;
	float	tau_a_psp;
	float	tau_d_psp;
	float	g_Syn;
	int		transmetteur;
    int     num_transm;
    char    nom[20];
} RECEPTOR;

CLASS
char	*transmitor_names[NB_TRANSMITORS]
#ifdef MAIN
	= {
		"No Transmission",
		"Any",
		"Acetylcholine",
		"Adrenaline",
		"Noradrenaline",
		"Serotonine",
		"GABA A",
		"GABA B",
		"Glycine",
		"Glutamate",
		"Dopamine",
		"HISTAMINE",
		"Subst P",
		"Enkephalin",
		"Endorphin",
		"Electrotonic",
		"Peptide",
		"Yours...",
		"Modulator 1",
		"Modulator 2"
	} /* fin du **transmitor_names */
#endif
;

CLASS
int	transmetteur[NB_TRANSMITORS]
#ifdef MAIN
	= {
		NO_TRANSMISSION,
		ANY,
		ACETYLCHOLINE,
		ADRENALINE,
		NORADRENALINE,
		SEROTONINE,
		GABA_A,
		GABA_B,
		GLYCINE,
		GLUTAMATE,
		DOPAMINE,
		HISTAMINE,
		SUBST_P,
		ENKEPHALIN,
		ENDORPHIN,
		ELECTROTONIC,
		PEPTIDE,
		YOURS,
		MODULATOR_1,
		MODULATOR_2
	} /* fin du transmitteur */
#endif
;

