#ifdef ADD_CURRENT

/*--------   To add a current you have to perform   -------*/   

/*-------------- 1 modification in this file -------------*/

#endif
/*----------------------------------------------------------------
 *	R E F E R E N C E . C
 *--------------------------------------------------------------*/

/* trace des reperes, des legendes, des courbes au niveau des
   aires de dessin						*/
   
#include <stdio.h>
#include <math.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "G_reference.h"
#include "G_neuron.h"

#ifndef	TRUE
#	define TRUE	1
#endif

#ifndef FALSE
#	define FALSE	0
#endif

#define	LEFT_OFFSET	50
#define UP_OFFSET	15
#define BOTTOM_OFFSET	30
#define RIGHT_OFFSET	15

extern int NOIR,
	   ROUGE,
	   BLEU,
	   VERT,
	   VIOLET,
	   MAUVE,
	   TURQ,
	   JAUNE;

/*----------------------------------------------------------------
 *	d r a w _ r e f e r e n c e
 *--------------------------------------------------------------*/

int	draw_reference (disp, ref)
Display		*disp;
REFERENCE	*ref;

{
	int			win_height, win_width;
	XWindowAttributes	win_attr;
	float	a, b, A, B, x, y;
	int	px, py, px_before, py_before;
	int	first_px = TRUE, first_py = TRUE;
	char	number[10];
	char	legende[40];
	int	nchar;

	if (!ref->window || !ref->gc)
	{
		return FALSE;
	}

	XSetForeground(disp, ref->gc, NOIR );
	
	XGetWindowAttributes (disp, ref->window, &win_attr);
	win_height = (int) win_attr.height;
	win_width  = (int) win_attr.width;

/*--- Blanchissage de la window ---------------------------------*/
	if (!superimpose)
	  {
	    XClearArea (disp, ref->window, 0, 0,
			win_width - 1, win_height - 1, False);
	  }
	if (win_height < BOTTOM_OFFSET + UP_OFFSET + 20 ||
	    win_width < LEFT_OFFSET + RIGHT_OFFSET + 30)
	{
		return FALSE;
	}

/*--- Equations de changement de repere -------------------------*/
/* permet de definir des coordonnees absolues des valeurs min et max
de chaque axe par rapport au systeme de coordonnees de la fenetre   */

	a = ref->lower_x;
	b = ref->upper_x;
	A = (float) LEFT_OFFSET;
	B = (float) win_width - (float) RIGHT_OFFSET;
	
	ref->A_x = (A - B) / (a - b);
	ref->B_x = (a * B - b * A) / (a - b);

	a = ref->upper_y;
	b = ref->lower_y;
	A = (float) UP_OFFSET;
	B = (float) win_height - (float) BOTTOM_OFFSET;
	
	ref->A_y = (A - B) / (a - b);
	ref->B_y = (a * B - b * A) / (a - b);

/*--- Trace de l'axe vertical ----------------------------------*/
	
	XDrawLine (disp, ref->window, ref->gc,
	    LEFT_OFFSET,
	    UP_OFFSET,
	    LEFT_OFFSET,
	    win_height - BOTTOM_OFFSET);

/*--- Trace de l'axe horizontal --------------------------------*/
	
	XDrawLine (disp, ref->window, ref->gc,
	    LEFT_OFFSET,
	    win_height - BOTTOM_OFFSET,
	    win_width - RIGHT_OFFSET,
	    win_height - BOTTOM_OFFSET);

/*--- Trace des graduations horizontales -----------------------*/

	x = ref->lower_x;
	y = ref->lower_y;
	py = (int) floor (ref->A_y * y + ref->B_y + 0.5);

	do
	{
		px = (int) floor (ref->A_x * x + ref->B_x + 0.5);

		if ((px - px_before) > 35 || first_px)
		/* pour que les chiffres correspondant aux
		graduations ne se chevauchent pas */
		{
			px_before = px;
			first_px = FALSE;
		
			switch (ref->decimals_x)
			{
				case 0:
					sprintf (number, "%5.0f", x);
					break;
				case 1:
					sprintf (number, "%5.1f", x);
					break;
				case 2:
				default:
					sprintf (number, "%5.2f", x);
					break;
			}

			XDrawLine (disp, ref->window, ref->gc,
				   px, py, px,py + 6);
			XDrawString (disp, ref->window, ref->gc,
				     px - 15, py + 20, number, 5);
		}
		else
		{
			XDrawLine (disp, ref->window, ref->gc,
				   px, py, px, py + 3);
		}
		
		x += ref->grad_x;
		
	} while (x <= ref->upper_x);

/*--- Trace des graduations verticales ----------------------------*/

	x = ref->lower_x;
	y = ref->lower_y;
	px = (int) floor (ref->A_x * x + ref->B_x + 0.5);

	do
	{
		py = (int) floor (ref->A_y * y + ref->B_y + 0.5);
		
		if ((py_before - py) > 10 || first_py)
		{
			py_before = py;
			first_py = FALSE;
		
			switch (ref->decimals_y)
			{
				case 0:
					sprintf (number, "%5.0f", y);
					break;
				case 1:
					sprintf (number, "%5.1f", y);
					break;
				case 2:
				default:
					sprintf (number, "%5.2f", y);
					break;
			}

			XDrawLine (disp, ref->window, ref->gc, px,
				   py, px - 6, py);
			XDrawString (disp, ref->window, ref->gc,
				     px - 40, py + 5, number, 5);
		}
		else
		{
			XDrawLine (disp, ref->window, ref->gc,
				   px, py,px - 3, py);
		}
		
		y += ref->grad_y;
		
	} while (y <= ref->upper_y);



/*---	trace des legendes --------------------------------------*/
        if (flag_phenom)
	{
	    switch(ref->identificateur)
	    {
		    case 1: XDrawString(disp, ref->window, ref->gc,
						win_width -150,30,
						"mb potential (mV)",17);
			    /*    changement de couleur du
				    contexte graphique      */
			    XSetForeground(disp, ref->gc,TURQ);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -150,40,
						"input voltage (mV)",18);

			    XSetForeground(disp, ref->gc,ROUGE);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -150,50,
						"E Na (mV) ",10);

			    XSetForeground(disp, ref->gc,BLEU);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -150,60,
						"E K (mV) ",9);

			    XSetForeground(disp, ref->gc,VIOLET);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -150,70,
						"threshold (mV)",14);
			    break;


		    case 2: XSetForeground(disp, ref->gc,ROUGE);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -150,30,
						"Interspike Interval (ms)",24);
			    break;

		    case 3: XSetForeground(disp, ref->gc,MAUVE);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -150,30,
						"Interspike Interval (ms)",24);
#ifdef ADD_CURRENT
    /*--------   To add a current copy, modify and adapt   -------*/

			    XSetForeground(disp, ref->gc,BLEU);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -150,80,
						"New",3);
#endif


		    default: break;
	    }
	}
	else
	{
	    switch(ref->identificateur)
	    {
		    case 1:
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,30,
						"mb potential (mV) ",18);
			    /*    changement de couleur du
				    contexte graphique      */
			    XSetForeground(disp, ref->gc,TURQ);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,40,
						"input current (uA) ",19);

			    XSetForeground(disp, ref->gc,ROUGE);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,50,
						"E Na (mV) ",10);

			    XSetForeground(disp, ref->gc,BLEU);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,60,
						"E K (mV) ",9);

			    XSetForeground(disp, ref->gc,VIOLET);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,70,
						"spike detected ",15);
			    break;


		    case 2:	XSetForeground(disp, ref->gc,ROUGE);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,30,
						"current Na(uA/cm2) ",15);

			    XSetForeground(disp, ref->gc,BLEU);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,40,
						"current K(uA/cm2) ",14);

			    XSetForeground(disp, ref->gc,JAUNE);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,50,
						"current Ic(uA/cm2) ",15);

			    XSetForeground(disp, ref->gc,VERT);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,60,
						"current Iahp(uA/cm2) ",17);

			    XSetForeground(disp, ref->gc,TURQ);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,70,
						"current INa pers(uA/cm2) ",21);
			    break;


		    case 3: XSetForeground(disp, ref->gc,VERT);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,30,
						"current Ia(uA/cm2) ",15);

			    XSetForeground(disp, ref->gc,VIOLET);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,40,
						"current Im(uA/cm2) ",15);

			    XSetForeground(disp, ref->gc,MAUVE);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,50,
						"current Ca HVA(uA/cm2) ",19);


			    XSetForeground(disp, ref->gc,ROUGE);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,60,
						"current Ca LVA(uA/cm2) ",19);


			    XSetForeground(disp, ref->gc,TURQ);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,70,
						"[Ca] ",5);
#ifdef ADD_CURRENT
    /*--------   To add a current copy, modify and adapt   -------*/

			    XSetForeground(disp, ref->gc,BLEU);
			    XDrawString(disp, ref->window, ref->gc,
						win_width -97,80,
						"New ",4);
#endif

		    default: break;
	    }

	}
	
	return TRUE;
}

/*------------------------------------------------------------------
 *	d r a w _ s e g m e n t
 *----------------------------------------------------------------*/
/* trace du trait reliant les points (x1,y1) et (x2,y2)
	dans le repere ref qui fait partie du display disp     */

void	draw_segment (disp, ref, x1, y1, x2, y2)
Display		*disp;
REFERENCE	*ref;
float		x1, y1, x2, y2;
{
	int	px1, py1, px2, py2;

	if (!ref->window)
	{
		return;
	}

	px1 = (int) floor (ref->A_x * x1 + ref->B_x + 0.5);
	py1 = (int) floor (ref->A_y * y1 + ref->B_y + 0.5);

	px2 = (int) floor (ref->A_x * x2 + ref->B_x + 0.5);
	py2 = (int) floor (ref->A_y * y2 + ref->B_y + 0.5);

	XDrawLine (disp, ref->window, ref->gc, px1, py1, px2, py2);
}
