#define	VMS	0
#define OSF	0
#define	UNIX	0
#ifdef	vms
#	define VMS	1
#endif
#ifdef __unix
#	if !UNIX
#		undef OSF
#		define OSF 	1
#	endif
#endif
#ifdef	__ultrix
#	undef UNIX
#       define UNIX 	1
#endif
#ifdef	__osf__
#	undef OSF
#	define OSF 	1
#endif
#ifdef	__hpux
#	undef OSF
#	define OSF 	1
#endif
#ifdef __CYGWIN__
#	define UNIX	1
#endif
#ifdef linux
#	define UNIX	1
#endif
/*
*       C H O O S E _ F I L E . C
*
*       Unix and VMS version
*
*       Function to choose a file in a directory with the arrow keys
*       from a list on the screen.
*
*       char    *choose_file(path,pattern,file)
*       char    *path,          // the path or search directory 
*               *pattern,       // a part of the required file name, an
*                                  extension or legal pattern under VMS
*               *file;          // the returned selected name 
*
*       It returns a pointer on the beginning of the selected file name.
*
*       28 fevrier 1991
*
*	Changes in setcbreak in order to be able to compile on Sys V systems
*
*	11 aout 1997
*
*	Increase the allowed size of file names
*
*	7 octobre 1998
*
*	Prise en compte des particularotes de HP-UX
*
*	Auteur: Dr J-F VIBERT
*		Laboratoire de Physiologie
*		CHU Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is in any way usable for commercial purpose.
*
*/



#include<stdio.h>
#include<askval.h>
#include<string.h>

#ifdef HAVE_CONFIG_H
#  include <config_xnbc.h>
#  if STDC_HEADERS
#	include <stdlib.h>
#  endif
#  if HAVE_SYS_DIR_H
#	include <sys/dir.h>
	static	DIR *direc;
	static	struct direct *dp;
#	define	DIRENT direct
#  endif
#  if HAVE_DIRENT_H
#	include <dirent.h>
	static	DIR *direc;
	static	struct dirent *dp;
#	define	DIRENT dirent
#  endif
#else
#  if UNIX
#	include <sys/dir.h>
	static	DIR *direc;
	static	struct direct *dp;
#	define	DIRENT direct
#  endif
#  if OSF
#	include <dirent.h>
	static	DIR *direc;
	static	struct dirent *dp;
#	define	DIRENT dirent
#  endif
#endif


#if VMS
#	include <ssdef.h>
#	include <iodef.h>
#	include <descrip.h>
#	include <ttdef.h>
#	include <tt2def.h>
#	include <rmsdef.h>
#	include <descrip.h>

	int ttchannel;
#	define	GETCH	getchar_vms
#else
#	include <termio.h>
#	include <sys/types.h>
#	define	GETCH	getchar
#endif


#define MAX_FILE	100
#define NAME_LENGTH	256
#define SELECT		13
#define PAGE_UP		'Q'
#define	PAGE_DOWN	'R'


static	char tab_nom[MAX_FILE][NAME_LENGTH],
	rep,
	*isinstr();

static ordonne_tab(int);
static cls();
static affiche();
static void restore();
static curseur();
static getm1();
static void setcbreak();

#if VMS
char	*pos,
	getchar_vms();
#endif

char *choose_file(chemin,extension,fichier)
char	*chemin,
	*extension,
	*fichier;
{
	int flag,i,j;
	char	buffer[256];

#if UNIX || OSF
	i = 0;
	if ((direc = opendir(chemin)) != NULL)
	{
		for (dp = (struct DIRENT *)readdir(direc); dp != NULL; dp = readdir(direc))
		{
			if (isinstr(dp->d_name,extension) || extension[0] == '*')
			{
				if (i >= MAX_FILE)
				{
					puts("\007Too much files, the list is not complete, sorry\n");
					break;
				} /* fin du if */
				strcpy(tab_nom[i],dp->d_name);
				i++;
			} /* fin du if */
		}
		ordonne_tab(i-1);
		i = affiche(tab_nom,i);
		cls();
		strcpy(fichier,tab_nom[i]);
		closedir(direc);
		return(fichier);
	}
	else	printf(" \007Directory can't be read..");
	return(0);
#endif
#if VMS
	char	d_name[256];

	$DESCRIPTOR(le_fichier,buffer);
	$DESCRIPTOR(desc_name,d_name);
	long	unsigned	context=0,
				status_rms;
	strcpy(buffer,"[");
	strcat(buffer,chemin);
	strcat(buffer,"]");
	strcat(buffer,extension);
	le_fichier.dsc$w_length = strlen(buffer);
	i = 0;
	while(1)
	{
		status_rms = LIB$FIND_FILE(&le_fichier,&desc_name,&context);
		if (status_rms == RMS$_NMF) break;
		if (isinstr(d_name,extension) || extension[0] == '*')
		{
			if (i >= MAX_FILE)
			{
				puts("\007Too much files, the list is not complete, sorry\n");
				break;
			} /* fin du if */

			pos = strchr(d_name,']');
			strcpy(d_name,pos+1);
			pos = strchr(d_name,';');
			*pos = 0;
			strcpy(tab_nom[i],d_name);
			i++;
		} /* fin du if */
	}
	ordonne_tab(i-1);
	i = affiche(tab_nom,i);
	cls();
	strcpy(fichier,tab_nom[i]);
	return(fichier);
#endif
}
	
static ordonne_tab(int indice)
{
	char nomfich[256];
	int i,j,fl ;
	for(i = 0;i < indice; i++)
	{
		j=i+1;
		while(j <= indice)
		{
			if(strcmp(tab_nom[i],tab_nom[j]) > 0)
			{
				strcpy(nomfich,tab_nom[i]);
				strcpy(tab_nom[i],tab_nom[j]);
				strcpy(tab_nom[j],nomfich);
				j=i+1;
			}
			else j++;
		}
	} 
}

static affiche(tableau,ind)
int ind;
char tableau[MAX_FILE][NAME_LENGTH];
{
	
	int i,im,i1,v,h;
	cls();
	curseur(2,50);
	puts("\033[1mUsage:\033[m\n");
	curseur(3,52);
	puts("\033[1mto choose a file:\033[m");
	curseur(4,53);
	puts("\033[7m Up \033[m and \033[7m Down arrow \033[m keys\n");
	curseur(5,52);
	puts("\033[1mto page the directory:\033[m\n");
	curseur(6,53);
	puts("\033[7mPrev \033[m and \033[7m Next Screen \033[m keys\n");
	curseur(7,53);
	puts("or \033[7m PF2 \033[m and \033[7m PF3 \033[m keys\n");
	curseur(8,52);
	puts("\033[1mto select the choosen file:\033[m\n");
	curseur(9,53);
	puts("\033[7mSelect \033[m or \033[7m Return \033[m keys\n");

	i=0;
	
	v=4;
	h=3;
	curseur(v,h);
	while(i<ind && v <= 22)
	{
		printf("%s",tableau[i]);	
		v++;
		curseur(v,h);
		i++;
	}
	v=4;
	h=3;
	curseur(v,h);
	i1=0;
	im=1;
	printf("\033[7m%s\033[0m",tableau[i1]);
	while(im == 1)
	{
		getm1();
		switch(rep)
		{
			case SELECT:	im=0;
					cls();
					return(i1);
					break;
						
			case 'B': 	/*deplacement vers le bas */

					curseur(v,h);
					printf("%s",tableau[i1]);
					i1++;
					if(i1>ind-1)
					{
						i1=0;
						v=4;
						cls();
						i=0;
						curseur(v,h);
						while(i<ind && v <= 22)
						{
							printf("%s",tableau[i]);	
							v++;
							curseur(v,h);
							i++;
						}
						v=4;
					}
					else 
					{
						v=v+1;
						if( (v % 23)==0) 
						{
							cls();
							v=4;
							i1=i;
							curseur(v,h);
							while(i<ind && (v % 23) !=0 )
							{
								printf("%s",tableau[i]);	
								v++;
								curseur(v,h);
								i++;
							}
						curseur(4,h);
						printf("\033[7m%s\033[0m",tableau[i1]);
						/*i=i1;*/	
						v=4;
					}
				}
					
				curseur(v,h);
				printf("\033[7m%s\033[0m",tableau[i1]);
				break;
					
		
			case 'A':	curseur(v,h);
					printf("%s",tableau[i1]);
					i1--;
					v--;
					
					if(i1 >= 0)
					{
						if(v < 4)
						{
							cls();
							i1 = i1-18;
							i=i1;
							v=4;
							curseur(v,h);
							while(i < ind && (v % 22) !=0)
							{
								printf("%s",tableau[i]);	
								v++;
								curseur(v,h);
								i++;
							}
							v=22;
							i1=i;
						}
					}
					else
					{
						v++;	
						i1++;
					} 
					curseur(v,h);
					printf("\033[7m%s\033[0m",tableau[i1]);
					break;
						
						
			case	PAGE_DOWN :	/* page down	PF2 */
					cls();
					i1 = i1 + 19;
					if(i1 > ind - 1)
					{
						i=0;
						v=4;
						h=3;
						curseur(v,h);
						while(i<ind && v <= 22)
						{
							printf("%s",tableau[i]);	
							v++;
							curseur(v,h);
							i++;
						}
						v=4;
						h=3;
						curseur(v,h);
						i1=0;
						im=1;
						printf("\033[7m%s\033[0m",tableau[i1]);	
					}
					else
					{ 
						v=4;
						i1=i;
						curseur(v,h);
						while(i<ind && (v % 23) !=0 )
						{
							printf("%s",tableau[i]);	
							v++;
							curseur(v,h);
							i++;
						}
						curseur(4,h);
						printf("\033[7m%s\033[0m",tableau[i1]);
						v=4;
					}
					break; 
		
			case	PAGE_UP :	/* page up	PF3 */
					cls();
					i=i1;
					while(v > 4)
					{
						i1--;
						i--;
						v--;	
					} 
					i1 = i1 - 19;
					if(i1 >= 0)
					{
						i = i - 19;
						v=4;
						curseur(v,h);
						while(i<ind && (v % 23) !=0 )
						{
							printf("%s",tableau[i]);	
							v++;
							curseur(v,h);
							i++;
						}
						curseur(4,h);
						printf("\033[7m%s\033[0m",tableau[i1]);
						v=4;	
					} 
					else
					{
						i=0;
						v=4;
						h=3;
						curseur(v,h);
						while( i < ind && v <= 22 )
						{
							printf("%s",tableau[i]);	
							v++;
							curseur(v,h);
							i++;
						}
						v=4;
						h=3;
						curseur(v,h);
						i1=0;
						im=1;
						printf("\033[7m%s\033[0m",tableau[i1]);	
					}
					break;
		
			default	:	
					break;
		}
 
	}
		 
} 
/*.........................................................................*/
static cls ()
{
	puts("\033[2J");
}
/*.........................................................................*/
static curseur(v,h)
 int v,h;
{
	printf("\033[%d;%dH",v,h);
}
/*.........................................................................*/      
static getm1()
{
	int i,j;
	
	void setcbreak(), restore();
	
	setcbreak();
	rep = GETCH();

	if(rep == '\033') 
	{
		rep = GETCH();
		if(rep == '[')
			rep = GETCH();
		if (rep == '4')
		{
			rep = GETCH();
			if (rep == '~') rep = SELECT;
		} /* fin du if */
		if (rep == '5')
		{
			rep = GETCH();
			if (rep == '~') rep = PAGE_UP;
		} /* fin du if */
		if (rep == '6')
		{
			rep = GETCH();
			if (rep == '~') rep = PAGE_DOWN;
		} /* fin du if */
	}
	restore();        
}	
#if UNIX || OSF
/*.........................................................................*/

static	struct termio tbuf; 
static	struct termio otbuf; /* old values */

static void setcbreak()
{

	
	if(ioctl(0,TCGETA, (char *) &otbuf) == -1)
	{
		printf("choose_file: Impossible to get the terminal characteristics\n");
		printf("You probably redirect the stdin... (not allowed)\n");
		exit(1);
	}

	tbuf = otbuf;
	tbuf.c_lflag &= ~(ECHO | ECHOK | ECHONL | ICANON);
	tbuf.c_oflag &= ~(OPOST);
	tbuf.c_iflag &= ~(INLCR | IGNCR | ICRNL);
	tbuf.c_cc[VMIN] = 1;
	tbuf.c_cc[VTIME] = 1;

	if (ioctl(0,TCSETAW,&tbuf) == -1)
	{
		printf("choose_file: Impossible to put the terminal in CBREAK mode\n");
		exit(1);
	}
	
}
/*.........................................................................*/
static void restore()
{

	if (ioctl(0,TCSETAW,&otbuf) == -1)
		printf("Impossible to restore the terminal characteristics\n");
		
}

#endif
/*.........................................................................*/
/*
*	ISINSTR() regarde si une sous chaine est dans une chaine
*/
static char *isinstr(string,substring)
char	*string,	/* La chaine  incluante */
	*substring;	/* la sous chaine incluse */
{
	int     diff_len,
                sub_len;
	
        sub_len = strlen(substring);
	diff_len = strlen(string) - sub_len;
	
        if (diff_len < 0) return(0); /* souschaine trop grande */

        diff_len++;  /* pour aller jusqu'au bout (poteaux et intervalles) */	
        while (diff_len--)
	{
		if(!strncmp(string,substring,sub_len)) return (string);
		string++;
	}
	return(0);
}

#if VMS
int cooked[3];

void setcbreak()
{
	int status;
	short iosb[4];
	int ttchar[3];
	$DESCRIPTOR(ttdesc,"TT:");

	status = sys$assign (
		 &ttdesc, 
		 &ttchannel, 
		 0 , 
      		 0 );
	if (status != SS$_NORMAL)
	{
		fprintf(stderr,"%%Erreur %d sur ASSIGN TT:\n",status);
		exit(status);
	}
	status = sys$qiow (
		 0 , 
		 ttchannel, 
		 IO$_SENSEMODE, 
		 iosb , 
		 0 ,  
		 0 ,   
		 cooked , 
		 12 , 
		 0 , 
		 0 , 
		 0 , 
		 0 );
	if (status == SS$_NORMAL)
		status = iosb[0];
	if (status != SS$_NORMAL)
	{
		fprintf(stderr,"%%Erreur %d sur QIO SENSEMODE\n",status);
		exit(status);
	}
        ttchar[0] = cooked[0];
        ttchar[1] = cooked[1] | TT$M_NOECHO;
        ttchar[2] = cooked[2] | TT2$M_PASTHRU;
    	status = sys$qiow (
		 0 , 
		 ttchannel, 
		 IO$_SETMODE, 
		 iosb , 
		 0 , 
		 0 , 
		 ttchar , 
		 12 , 
		 0 , 
		 0 , 
		 0 , 
		 0 );
	
	if (status == SS$_NORMAL)
		status = iosb[0];
	if (status != SS$_NORMAL)
	{
		fprintf(stderr,"%%Erreur %d sur QIO SETMODE\n",status);
		exit(status);
	}
}
void restore()
{
	int status;
	short iosb[4];

	curseur(24,1);
    	status = sys$qiow (
		 0 , 
		 ttchannel, 
		 IO$_SETMODE, 
		 iosb , 
		 0 , 
		 0 , 
		 cooked , 
		 12 , 
		 0 , 
		 0 , 
		 0 , 
		 0 );
	
	if (status == SS$_NORMAL)
		status = iosb[0];
	if (status != SS$_NORMAL)
	{
		fprintf(stderr,"%%Erreur %d sur QIO SETMODE\n",status);
		exit(status);
	}
	status = sys$dassgn(ttchannel);
}

char getchar_vms()
{
	char c;
	short iosb[4];
	int status;

	status = sys$qiow (
		 0 , 
		 ttchannel, 
		 IO$_READVBLK, 
		 iosb , 
		 0 , 
		 0 , 
		 &c , 
		 1 , 
		 0 , 
		 0 , 
		 0 , 
		 0 );
	if (c == 3 || c == 25)
	{
		restore();
		exit(1);
	}
 	return(c);
}
#endif
