/*****************************************************************************
*                              HEADER MODULE                              
******************************************************************************
* APPLICATION  : MENU	                                             
* NAME         : MENU_variability.h	                                             
* GOAL         : This module have the same functionnality of MENU_constante.h
		 module. Nevertheless, this module groupes all the constantes
		 with a distinct definition according to the makefile
		 option.
		 When the makefile is running, we must precise if we compile
		 the code with keeping the trace of the running.
		 So, we must precise the value of the MODE_TRACE variable.
		 MODE_TRACE can be DEBUG  xor NONE .
		 
  NOTE		 We have two possibilities to set the value of the MODE_TRACE
 		 variable :
		 
		 - either we precise the value on the line command
		 shell during the compile phase. In this case, we must
		 delete the line in this module where the value of the
		 MODE_TRACE variable is setted. The syntax of the line
		 comman shell would be 
		 make -f MENU_makefile -DMODE_TRACE=DEBUG  ....
		 if you want a trace during execution.
		 
		 -either we set the value of the MODE_TRACE variable in this
		 module by inserted the line
		 #define MODE_TRACE DEBUG at the end of this module if you want
		 a trace during execution..
		 Note that it is the best method, since in the first method
		 it is not trivial to precise on a line command shell
		 all options of compile.                            
******************************************************************************
* AUTHOR       : Marc TISSERANT                                             
* DATE WRITTEN : 1995, March	
* TESTS        : level 0 - no specific tests tool is used for the development.	
* REVIEWER     : ...	
* MODIFICATION : none	
******************************************************************************
* COPYRIGHT    : Copyright Dr J-F VIBERT
*		 Laboratoire de Biomathematiques
*		 URBB B3E INSERM U263
*		 Faculte de Medecine Saint-Antoine
*		 27 rue Chaligny
*		 75571 Paris cedex 12
*	         FRANCE
*	         
*                e-mail vibert@b3e.jussieu.fr
*
*                All rights reserved
*	         Access limited to authorized persons	
*	         This software was developped only for resarch purpose
*	         and is not, in any way, usable for commercial purpose.
*****************************************************************************/

				/*** used to allow for each module of the
				application to include this module .h without
				redefinition or not declaration of the 
				constantes defined in this current module 
				when the compilator and editor work ***/
				
#ifndef MENU_variability	/*** ifndef 01 ***/
#define MENU_variability


/*****************************************************************************
*                       INCLUDE LIBRARY                                     
*****************************************************************************/

/*****************************************************************************
*                       INCLUDE SOURCE MODULE                               
*****************************************************************************/

/*****************************************************************************
*                       DEFINE SECTION                               
*****************************************************************************/



/*****************************************************************************
*                             MACROS DEFINITION
*****************************************************************************/

/********************************************* definition of MACRO_TRACE  ***/

/*** if the makefile precise that the mode of the compilation is the DEBUG mode
the macro MACRO_TRACE is physically replaced by the printf routine, otherwise
if the DEBUG mode is NONE the macro MACRO_TRACE is physically replaced by
no code. This method is used to get a code for tests execution and a code
for running whithout to operate modifications in the implementation. ***/

/*** note that this macro is not prefixed by the name of the module where it
is defined. 
The macro MACRO_TRACE is implemented according to the value of the
MODE_TRACE variable. Note, that this variable and its value are not prefixed
by the name of the module because they are used on the command line shell 
and/or the makefile. ***/

#define DEBUG                   0
#define NONE	                1
					/*** according conveviance ***/
#define MODE_TRACE		NONE    /*** DEBUG ***/ 

#if (MODE_TRACE==DEBUG)		/*** if 0101 ***/
#define MACRO_TRACE(format_and_arguments) printf format_and_arguments;
#elif (MODE_TRACE==NONE)
#define MACRO_TRACE(format_and_arguments)
#endif				/*** endif 0101 ***/

#endif				/*** endif 01 ***/

/*****************************************************************************
*                       END OF THE MODULE                               
*****************************************************************************/
