/*****************************************************************************
*                              CONTROL PANEL                              
******************************************************************************
* APPLICATION  : XNBC Control panel	                                             
* NAME         : cp_callback.c	                                             
* GOAL         : This module propose to the user the different tools used by
*                the nbc application. This proposition is presented into the
*                screen thanks to a visual representation via the X motif   
*                interface. The goal of this module is also to take into    
*                account the choices of the user, so to run and manage the  
*                tools chosen by the user.                                  
******************************************************************************
* AUTHOR       : Jean-Francois VIBERT and Marc TISSERANT                                             
* DATE WRITTEN : 1995, March	
* TESTS        : level 0 - no specific tests tool is used for the development.	
* REVIEWER     : JF Vib******************************************************************************
* APPLICATION  : MENU	                                             
* NAME         : MENU_MAIN.c	                                             
* GOAL         : This module propose to the user the different tools used by
*                the nbc application. This proposition is presented into the
*                screen thanks to a visual representation via the X motif   
* ******************************************************************************
* APPLICATION  : MENU	                                             
* NAME         : MENU_MAIN.c	                                             
* GOAL         : This module propose to the user the different tools used by
*                the nbc application. This proposition is presented into the
*                screen thanks to a visual representation via the X motif   
* ert	
* MODIFICATION : adapted to find_files on dec 1997	
*              : V8.24  (gnuplot menu) by JFV 24 mar 1999
*              : V8.25  (Lesstif compatibility + menu raster) 
*                                                       by JFV 16 juillet 1999
*	       : V8.26  (Option menu for editors+gnu configure distribution) 
*							by JFV 14 sept 1999
*	       : V8.27  (Important modifications in nbc_x and the control
*			panel allows to run several tools simutaneously)
*							by JFV 29 nov 1999
*              : V8.27-1 Virtual menu disappeared under Linux. Fixed
*                                                       by JFV 3 dec 1999
*
*              : V8.27-2 Keep button put in option menu + bug correction 
*                        in printer definition          by JFV 4 dec 1999
*              : V8.27-3 Virtual button Linux revealed bug correction 
*							by JFV 25 july 2000
*              gtk_widget_hide(dialog_message);
  : V8.27-4 All printf set to verbose mode ti fit with Cygwin
*                                                       by JFV 14 august 2001
*              : V8-27-5 If .xnbcrc not existing and not creatable, still go on 
*                                                       by JFV 16 august 2001 
*              : V9.0 beta Version 9
*                                                       by JFV 30 august 2001
*              : Control Panel V9 with glade            by JFV 5 sept 2001
******************************************************************************
* COPYRIGHT    : Copyright Dr J-F VIBERT
*		 Laboratoire de Biomathematiques
*		 ex URBB B3E INSERM U263
*                ESI B3E INSERM U444
*		 Faculte de Medecine Saint-Antoine
*		 27 rue Chaligny
*		 75571 Paris cedex 12
*	         FRANCE
*	         
*                e-mail vibert@u444.jussieu.fr
*
*                All rights reserved
*                Distributed under the GPL
*	         This software was developped only for resarch purpose.
*****************************************************************************/


#ifdef HAVE_CONFIG_H
#  include <config_xnbc.h>
#endif

#include <signal.h>		/*** to use signal routines ***/
#include <stdio.h> 		/***  stdandard   ***/
#include <sys/stat.h> 		/*** for struct stat_sbuf    ***/
#include <stdlib.h> 		/***  for exit   ***/
#include <sys/wait.h> 		/***  for wait   ***/
#include <unistd.h> 		/***  for acess   ***/
#include <string.h>
#include <sys/types.h>
#include <fcntl.h>

#include "MENU_constante.h"	/*** ctes definition of the application ***/
#include "find_files.h"         /*** header pour .xnbcrc                ***/

#include <gtk/gtk.h>

#include "cp_callbacks.h"
#include "cp_interface.h"
#include "support.h"

extern void     MENU_LIB_error();
extern void     MENU_get_files(char *);
extern void     MENU_LIB_deinit_alloc();
extern void     MENU_MNGT_PROCESS_spawn();
extern void     show_message(char *);

extern char *xnbc_bin_dir;	
extern char *xnbc_bin_ref_xterm;
extern char *xnbc_bin_ref_psviewer;
extern char *current_path;
extern char *current_experiment;
extern char *home_pathg;
extern char *strtext;

extern int errno;	
extern int errno;	
extern int on_garde;
extern int flag_xterm;
extern int indice_tool;
extern int current_net_editor;
extern int flag_fsb;
extern int mode_verbose;
extern int code_help_context;
extern int nb_max_recent;

extern char recent_exp[20][256];
extern char file_name_cprc[256];
extern char cmd_lpr[256];
extern char xnbcrc_dir[256];

extern GtkWidget *main_window;
extern GtkWidget *about_window;
extern GtkWidget *fileselection_exp;
extern GtkWidget *dialog_current;
extern GtkWidget *dialog_help_current;
extern GtkWidget *dialog_previous;
extern GtkWidget *dialog_printer;
extern GtkWidget *fileselection_new;
extern GtkWidget *dialog_message;
extern GtkWidget *dialog_virtual;

static char prg[256];

gchar *text_selection;

void
on_current2_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *current;
  
  current = lookup_widget(GTK_WIDGET(dialog_current),"label_current_2");
  
  sprintf(prg,"\n\
       Directory name:  %s\n\n\
       Project name:    %s\n\
       Simulation name: %s\n\
       Network name:    %s\n",
	  get_dir_name(),
	  get_project_name(),
	  get_simulation_name(),
	  get_network_name());
  gtk_label_set_text(GTK_LABEL(current),prg);
  gtk_widget_show (dialog_current);
}


void
on_new_activate                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{  
  char home[256];


  strcpy(home,getenv("HOME"));
  strcat(home,"/");
  gtk_file_selection_set_filename((GtkFileSelection *)fileselection_new,home);
  gtk_file_selection_hide_fileop_buttons((GtkFileSelection *)fileselection_new);

  gtk_widget_show (fileselection_new);

}


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  char file_name[256];
  char *pt;
  char home[256];


  strcpy(home,getenv("HOME"));
  strcat(home,"/");
  gtk_file_selection_set_filename((GtkFileSelection *)fileselection_exp,home);

  /*  gtk_widget_hide(fileselection_exp->file_list); */
  gtk_file_selection_hide_fileop_buttons((GtkFileSelection *)fileselection_exp);
  gtk_widget_show (fileselection_exp);

  sprintf(file_name,"%s%s\n",current_path,current_experiment);
  put_dir_name(file_name,file_name);
  strcpy(xnbcrc_dir,file_name);
  sprintf(file_name,"%s%s/%s\n",current_path,current_experiment,current_experiment);
  pt = strrchr(file_name,'_');
  *pt = 0;
  put_project_name(xnbcrc_dir,file_name);
  put_network_name(xnbcrc_dir,file_name);
  put_simulation_name(xnbcrc_dir,file_name);

}


void
on_recent_experiments1_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *gtkliste;
  int i;

 
  gtkliste = lookup_widget(GTK_WIDGET(dialog_previous),"list_recent");

  for (i = 0; i < nb_max_recent; i ++)
    {
      gchar *label[1];

      if (recent_exp[i])
	{
	  /* printf("%d %s\n",i+1,recent_exp[i]); */
	  label[0] = g_strdup(recent_exp[i]);
	  /* printf("%s\n",label[0]); */
	  gtk_clist_append(GTK_CLIST(gtkliste), label);
	  g_free(label[0]);
	}
    }

  gtk_widget_show (dialog_previous);

}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

  FILE *fpt_cprc;
  FILE *p_rc;
  int i;
  char buffer[256];
  char fichier[256];
  char exp[256];

  MENU_LIB_deinit_alloc();

  gtk_widget_destroy(main_window);
  gtk_widget_destroy(about_window);
  gtk_widget_destroy(fileselection_exp);
  gtk_widget_destroy(dialog_current);
  gtk_widget_destroy(dialog_help_current);
  gtk_widget_destroy(dialog_previous);
  gtk_widget_destroy(dialog_printer);
  gtk_widget_destroy(fileselection_new);
  gtk_widget_destroy(dialog_message);

  if ((fpt_cprc=fopen(file_name_cprc,"w")) == NULL)
    {
      printf("\n\nImpossible to create a ~/.xnbc_cprc file (%s)\nYour options and old files will not be memorized\n", file_name_cprc);
    } /* fin du if */
  else
    {
      fprintf(fpt_cprc,"cmd_lpr: %s\n",cmd_lpr);
      fprintf(fpt_cprc,"keep_PS: %d *\n",on_garde);
      fprintf(fpt_cprc,"mode_verbose: %d *\n",mode_verbose);
      fprintf(fpt_cprc,"nb_max_recent: %d *\n",nb_max_recent);
      
      /* Now the experiments recently opened */
      sprintf(buffer,"%s",current_experiment);
      fprintf(fpt_cprc,"experiment: %s *\n",buffer);
      for (i = 0; i < nb_max_recent-1; i++)
	{
	     if (strcmp(recent_exp[i],current_experiment))
	       fprintf(fpt_cprc,"experiment: %s *\n",recent_exp[i]);
	}
      fclose(fpt_cprc);
    }


    put_current_experiment(current_experiment);

    exit(0);
}


void
on_global_activity_print1_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  char path_prg[255];	/*** the path followed by the name of the tool ***/

  MACRO_TRACE(("---> start  : MENU_CB_GRAPHICS_menu_graph\n"))			        
  sprintf(path_prg,"%s%s",xnbc_bin_dir,TOOL_GRAPH );
  MENU_MNGT_PROCESS_spawn (1 ,path_prg,INDICE_GRAPH);
  MACRO_TRACE(("---> end    : MENU_CB_GRAPHICS_menu_graph\n"))

}


void
on_global_activity_view1_activate      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  char path_prg[255];	/*** the path followed by the name of the tool ***/

  MACRO_TRACE(("---> start  : MENU_CB_GRAPHICS_menu_xgraph\n"))			        
  sprintf(path_prg,"%s%s",xnbc_bin_dir,TOOL_XGRAPH );
  MENU_MNGT_PROCESS_spawn (1 ,path_prg,INDICE_XGRAPH);
  MACRO_TRACE(("---> end    : MENU_CB_GRAPHICS_menu_xgraph\n"))

}


void
on_intracellular_recording1_activate   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  char path_prg[255];	/*** the path followed by the name of the tool ***/

  MACRO_TRACE(("---> start  : MENU_CB_GRAPHICS_menu_pmb\n"))
  sprintf(path_prg,"%s%s",xnbc_bin_dir,TOOL_PMB );
  MENU_MNGT_PROCESS_spawn (1 ,path_prg,INDICE_PMB);  
  MACRO_TRACE(("---> end    : MENU_CB_GRAPHICS_menu_pmb\n"))

}


void
on_membrane_potential_3d1_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  char path_prg[255];		/*** the path followed by the name of the tool ***/

  MACRO_TRACE(("---> start  : MENU_CB_GRAPHICS_menu_3d\n"))
  sprintf(path_prg,"%s%s",xnbc_bin_dir,TOOL_3D );
  MENU_MNGT_PROCESS_spawn (1,path_prg,INDICE_3D);
  MACRO_TRACE(("---> end    : MENU_CB_GRAPHICS_menu_3d\n"))

}


void
on_view_postscript_files1_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  MACRO_TRACE(("---> start  : MENU_CB_GRAPHICS_menu_ps\n"))
  MENU_MNGT_PROCESS_spawn (2,xnbc_bin_ref_psviewer,INDICE_PSVIEWER);
  MACRO_TRACE(("---> end    : MENU_CB_GRAPHICS_menu_ps\n"))

}


void
on_gnuplot1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  char path_prg[255];	/*** the path followed by the name of the tool ***/
  char *home_gnu;

  MACRO_TRACE(("---> start  : MENU_CB_GRAPHICS_menu_gnuplot\n"))			        
  
    if ((home_gnu=getenv("XNBC_BIN_GNUPLOT")))
    {
      sprintf(path_prg,"%s",home_gnu);

      MENU_MNGT_PROCESS_spawn (4,path_prg,INDICE_GNUPLOT);
    }
  MACRO_TRACE(("---> end    : MENU_CB_GRAPHICS_menu_gnuplot\n"))

}


void
on_raster_viewer1_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  char path_prg[255];	/*** the path followed by the name of the tool ***/
  char *home_raster;

  MACRO_TRACE(("---> start  : MENU_CB_GRAPHICS_menu_raster\n"))			        
  
    if ((home_raster=getenv("XNBC_BIN_RASTER")))
    {
      sprintf(path_prg,"%s/%s",home_raster,TOOL_RASTER);
      MENU_MNGT_PROCESS_spawn (3,path_prg,INDICE_RASTER);
    }
  MACRO_TRACE(("---> end    : MENU_CB_GRAPHICS_menu_raster\n"))

}

void on_btn_printer_cancel_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{  
  gtk_widget_hide(dialog_printer);
}
  
char cmd_print[256];

void on_btn_printer_OK_clicked    (GtkButton       *button,
				    gpointer         user_data)
{  
       GtkWidget *texte;
       char *value;
       char buffer[256];

       texte = lookup_widget(GTK_WIDGET(dialog_printer),"entry_printer");
       value = gtk_editable_get_chars(GTK_EDITABLE(texte),0,-1);
       strcpy(cmd_lpr,value);
       sprintf (cmd_print, "PRINT_PLOT_PS=%s ", value);
       
       putenv(cmd_print);
       
       gtk_widget_hide(dialog_printer);

       if (mode_verbose)
	 {
	   sprintf(buffer,"Printer command:  \"%s\"\n",cmd_lpr);
	   show_message(buffer);
	 }
}


void
on_printer_to_use1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
       GtkWidget *texte;

       texte = lookup_widget(GTK_WIDGET(dialog_printer),"entry_printer");
       gtk_entry_set_text(GTK_ENTRY(texte),cmd_lpr);
       gtk_widget_show (dialog_printer);
  
}


void
on_keep_postscript_files1_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  MACRO_TRACE(("---> start  : MENU_CB_STATION_button_keep_ps\n"))
  if (on_garde==1)
     on_garde=0;
  else
     on_garde=1;
  MACRO_TRACE(("on_garde=%d\n",on_garde))

}


void
on_on_control_panel1_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  MACRO_TRACE(("---> start  : MENU_CB_HELP_menu_panel\n"))

  browse_manual(XNBC_CONTROL_PANEL);

  MACRO_TRACE(("---> end    : MENU_CB_HELP_menu_panel\n"))

}


void
on_about_xnbc1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

  gtk_widget_show (about_window);

}


void
on_manual_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
	browse_manual(XNBC_FULL_MANUAL);
}


void
on_P_neuron_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  flag_xterm=0;
  gtk_widget_hide(dialog_message);
  sprintf(prg,"%s%s",xnbc_bin_dir,TOOL_P_NEURON_EDITOR);
  indice_tool=INDICE_P_NEURON_EDITOR;
  MENU_MNGT_PROCESS_spawn (flag_xterm,prg,indice_tool);

}


void
on_V_neuron_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *liste;

  MENU_get_files(".tms");

  if (*(strtext))
    {
      liste = lookup_widget(GTK_WIDGET(dialog_virtual),"virtual_text");
      gtk_label_set_text(GTK_LABEL(liste),strtext);
    }

  gtk_widget_show(dialog_virtual);
}


void
on_Drug_edit_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  flag_xterm=0;
  sprintf(prg,"%s%s",xnbc_bin_dir,TOOL_DRUG_EDITOR);
  indice_tool=INDICE_EXPERT_SYSTEM;
  MENU_MNGT_PROCESS_spawn (flag_xterm,prg,indice_tool);
}


void
on_G_neuron_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  flag_xterm=0;
  sprintf(prg,"%s%s",xnbc_bin_dir,TOOL_G_NEURON_EDITOR);
  indice_tool=INDICE_G_NEURON_EDITOR;
  MENU_MNGT_PROCESS_spawn (flag_xterm,prg,indice_tool);

}


void
on_link_edit_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  flag_xterm=0;
  sprintf(prg,"%s%s",xnbc_bin_dir,TOOL_S_LINK_EDIT);
  indice_tool=INDICE_S_LINK_EDIT;
  MENU_MNGT_PROCESS_spawn (flag_xterm,prg,indice_tool);
}


void
on_full_edit_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  flag_xterm=0;
  sprintf(prg,"%s%s",xnbc_bin_dir,TOOL_F_NETW_EDIT);
  indice_tool=INDICE_F_NETW_EDIT;
  MENU_MNGT_PROCESS_spawn (flag_xterm,prg,indice_tool);
}


void
on_simulator_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  flag_xterm=0;
  sprintf(prg,"%s%s",xnbc_bin_dir,TOOL_X_SIMULATOR);
  indice_tool=INDICE_X_SIMULATOR;
  MENU_MNGT_PROCESS_spawn (flag_xterm,prg,indice_tool);
}


void
on_visu_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
  sprintf(prg,"%s%s",xnbc_bin_dir,TOOL_VISUALIZATION);
  indice_tool=INDICE_VISUALIZATION;
  MENU_MNGT_PROCESS_spawn (flag_xterm,prg,indice_tool);

}


void
on_xtms_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
  flag_xterm=0;
  sprintf(prg,"%s%s",xnbc_bin_dir,TOOL_XTMS);
  indice_tool=INDICE_XTMS;
  MENU_MNGT_PROCESS_spawn (flag_xterm,prg,indice_tool);

}


void
on_xcaa_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{
  flag_xterm=0;
  sprintf(prg,"%s%s",xnbc_bin_dir,TOOL_XCAA);
  indice_tool=INDICE_XCAA;
  MENU_MNGT_PROCESS_spawn (flag_xterm,prg,indice_tool);
}


void
on_spanake_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  char path_prg[255];	/*** the path followed by the name of the tool ***/
  char *home_raster;

  MACRO_TRACE(("---> start  : MENU_CB_GRAPHICS_menu_raster\n"))			        
  
    if ((home_raster = getenv("XNBC_BIN_RASTER")))
    {
      sprintf(path_prg,"%s/%s",home_raster,TOOL_RASTER);
      MENU_MNGT_PROCESS_spawn (3,path_prg,INDICE_RASTER);
    }
  MACRO_TRACE(("---> end    : MENU_CB_GRAPHICS_menu_raster\n"))

}


void
on_close_dialog1_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(about_window);
}


void
on_btn_close_current_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (dialog_current);
}


void
on_btn_help_close_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (dialog_help_current);

}


void
on_verbose_mode1_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    mode_verbose = !mode_verbose;
}

char current_selection[256];

void
on_btn_recent_OK_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  char file_name[256];
  char *pt;

  strcpy(current_selection,text_selection);

  sprintf(file_name,"%s\n",current_selection);
  strcpy(xnbcrc_dir,current_selection);
  put_dir_name(xnbcrc_dir,file_name);
  /*  sprintf(file_name,"%s/%s\n",current_selection,current_experiment);*/
  pt = strrchr(file_name,'_');
  *pt = 0;
  put_project_name(xnbcrc_dir,file_name);
  put_network_name(xnbcrc_dir,file_name);
  put_simulation_name(xnbcrc_dir,file_name);

  sprintf(prg,"%s    V%s     -     Experiment : %s",TITLE_APPLICATION,VERSION,current_experiment);
  gtk_window_set_title(GTK_WINDOW(main_window),prg);

  gtk_widget_hide (dialog_previous);

}


void
on_Cancel_recent_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide (dialog_previous);

}

void
on_btn_ok_filesel_open_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
  struct stat s_buf;
  char *text;
  char *pt;
  char *lettre;
  int code;
  int i;
  char experiment[255];
  char path[255];
  char buffer[256];
  char file_name[256];
 
  text = (char *)gtk_file_selection_get_filename((GtkFileSelection *)fileselection_new);

  code=1;
  i = strlen(text);
  if ((*(text+i-1))=='/') *(text+i-1)='\0';
  if (code==1)
    { 
      if (strcmp(text,"")==0) code=(-1); 
    }
  
  if (code==1)
    { 
      if (strcmp(text,"/")==0) code=(-2); 
    }
  if (code==1)  
    { /*** verif le .nbc ***/
             /**** extract the current_path ***/
             i=1;
             lettre=text+strlen(text)-i;
             while((*lettre!='/') &&(i<=strlen(text))) 
	       {
                  i++;
                  lettre=text+strlen(text)-i;
	       }
             strncpy(path,text,strlen(text)-i+1);
             *(path+ strlen(text)-i+1)='\0';
             strcpy(experiment,text+strlen(text)-i+1);
             lettre=experiment;
             i=strlen(lettre)-1;
             while( (*(lettre+i)!='_')&&(i>0) )
	       {
                  i--;
	       }
             lettre=lettre+i;
             if (strcmp(lettre,"_xnbc")!=0)
	       {
		 strcat(experiment,"_xnbc"); strcat(text,"_xnbc");
	       } 
    }
  if (code==1)
    {
		s_buf.st_mode =0;
		stat(text,&s_buf);
		if ((s_buf.st_mode & S_IFMT) != S_IFDIR)
		  code=(-3); 
    } 

      switch(code)
    {
	case  1: strcpy(current_experiment,experiment);
		 strcpy(current_path,path);
		 break;
	case -1: 
		 show_message("The directory specification is not valid !\nThe name must be not null.");
		 break;
	case -2: 
		 show_message("The directory specification is not valid !\nThe name must be distinct from the root.");
		 break;
	case -3: 
		 show_message("The directory specification is not valid !\nThis directory does not exist.");
		 break;
    }                            

  sprintf(file_name,"%s%s\n",current_path,current_experiment);
  strcpy(xnbcrc_dir,file_name);
  put_dir_name(xnbcrc_dir,file_name);
  sprintf(file_name,"%s%s/%s\n",current_path,current_experiment,current_experiment);
  pt = strrchr(file_name,'_');
  *pt = 0;
  put_project_name(xnbcrc_dir,file_name);
  put_network_name(xnbcrc_dir,file_name);
  put_simulation_name(xnbcrc_dir,file_name);
  MACRO_TRACE(("---> start  : MENU_CB_EXPERIMENT_menu_new\n"))

  gtk_widget_hide(fileselection_exp);

  sprintf(buffer,"%s    V%s     -     Experiment : %s",TITLE_APPLICATION,VERSION,current_experiment);
  gtk_window_set_title(GTK_WINDOW(main_window),buffer);


  put_current_experiment(current_experiment);
  strcpy(current_experiment,get_current_experiment());
  printf("Current experiment : %s\n",current_experiment);


}


void
on_btn_help_current_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_show(dialog_help_current);

}

void
on_btn_ok_filesel_new_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  struct stat s_buf;
  struct stat s_buf1;
  char *text;
  char *pt;
  char *lettre;
  int code;
  int i;
  char experiment[255];
  char path[255];
  char buffer[256];
  char file_name[256];
  char exp[256];
 
    text = (char *)gtk_file_selection_get_filename((GtkFileSelection *)fileselection_new);

    strcpy(buffer,text);
    strcpy(current_path,dirname(buffer));
    strcat(current_path,"/");
    
    printf("on_btn_ok_filesel_new_clicked : %s %s\n",text, current_path);
    

    code = 1;
    i = strlen(text);
    if ((*(text+i-1))=='/') *(text+i-1)='\0';
    if (code==1)
    { 
      if (strcmp(text,"")==0) code=(-1); 
    }
  
    if (code==1)
    { 
      if (strcmp(text,"/")==0) code=(-2); 
    }
    if (code==1)  
    { /*** verif le _xnbc ***/
             /**** extract the current_path ***/
             i=1;
             lettre=text+strlen(text)-i;
             while((*lettre!='/') &&(i<=strlen(text))) 
	       {
                  i++;
                  lettre=text+strlen(text)-i;
	       }
             strncpy(path,text,strlen(text)-i+1);
             *(path+ strlen(text)-i+1)='\0';
             strcpy(experiment,text+strlen(text)-i+1);
             lettre=experiment;
             i=strlen(lettre)-1;
             while( (*(lettre+i)!='_')&&(i>0) )
	       {
                  i--;
	       }
             lettre=lettre+i;
             if (strcmp(lettre,"_xnbc")!=0)
	       {
		 strcat(experiment,"_xnbc"); strcat(text,"_xnbc");
	       } 

    }
    if (code==1)
    {
		 strcpy(buffer,path);
		 *(buffer+strlen(path)-1)='\0';
		 s_buf.st_mode =0;
		 stat(buffer,&s_buf);
		 if ((s_buf.st_mode & S_IFMT) != S_IFDIR) code=(-4);
		 s_buf1.st_mode =0;
		 stat(text,&s_buf1);
		 if ((s_buf1.st_mode & S_IFMT) == S_IFDIR) code=(-5);

		 if (code==1) 
		   { /*** creation du directory ***/
		     if (mkdir(text,0755) < 0) 
		       code=(-6);
		   } 
    } 

    switch(code)
    {
	case  1: strcpy(current_experiment,experiment);
		 strcpy(current_path,path);
		 break;
	case -1: 
		 show_message("The directory specification is not valid !\nThe name must be not null.");
		 return;
	case -2: 
		 show_message("The directory specification is not valid !\nThe name must be distinct from the root.");
		 return;
	case -3: 
		 show_message("The directory specification is not valid !\nThis directory does not exist.");
		 return;
	case -4: 
		 show_message("The directory specification is not valid !\nThe path directory does not exist.");
		 return;
	case -5: 
		 show_message("The directory specification is not valid !\nThis directory already exists.");
		 return;
	case -6: 
		 show_message("The directory specification is valid !\nbut its creation is impossible...");
		 return;
    }                            
/*
    printf("on_btn_ok_filesel_new_clicked : %s %s %s\n",text, current_path, current_experiment);
*/
    sprintf(file_name,"%s%s/",current_path,current_experiment);
    strcpy(xnbcrc_dir,file_name);
    /*
    printf("on_btn_ok_filesel_new_clicked : file_name %s\n",file_name);
    */
    put_dir_name(xnbcrc_dir,file_name);
    sprintf(file_name,"%s%s",file_name,current_experiment);
    pt = strrchr(file_name,'_');
    *pt = 0;
    /*
    put_project_name(xnbcrc_dir,file_name);
    put_network_name(xnbcrc_dir,file_name);
    put_simulation_name(xnbcrc_dir,file_name);
    */   
    gtk_widget_hide(fileselection_new);

    sprintf(buffer,"%s    V%s     -     Experiment : %s",TITLE_APPLICATION,VERSION,file_name);
    gtk_window_set_title(GTK_WINDOW(main_window),buffer);
    save_xnbcrc(xnbcrc_dir,file_name,file_name,file_name,xnbcrc_dir);
    put_current_experiment(xnbcrc_dir);
    strcpy(current_experiment,get_current_experiment());
    printf("Current experiment : %s\n",current_experiment);

}


void
on_btn_filesel_new_cancel_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(fileselection_new);
}

void
on_btn_filesel_open_cancel_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(fileselection_exp);
}


void
on_btn_close_message_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(dialog_message);
}


void
on_virtual_help_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  show_message("The list gives the files containing\n\
the spiking time of neurons.\n\
These files are those used by the xtms program\n\
These files are created by the simulation programs\n\
or coming from actual experiments to make hybrid simulations.\n\
These files have the .tms extension.");
}


void
on_virtual_close_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(dialog_virtual);
}


void
on_spinbutton1_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
  GtkWidget *spinbutton1;

  spinbutton1 = lookup_widget(GTK_WIDGET(dialog_previous),"spinbutton1");
  nb_max_recent = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbutton1));
}



void
on_list_recent_select_row              (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  
  gtk_clist_get_text(GTK_CLIST(clist),row,column,&text_selection);
  /* printf("C: %d, L: %d, %s\n",column,row,text_selection); */
}

