/*
  callbacks_editor.c
*/

#include "drug_definition.h"

#include "drug_editor.h"
#include "find_files.h"

#define  DRUG_DEBUG  0



/*
 * Macros to make code look nicer between ANSI and K&R.
 */
#ifndef ARGLIST
#if (NeedFunctionPrototypes == 0)
#define PROTOTYPE(p)	()
#define ARGLIST(p)	p
#define ARG(a, b)	a b;
#define GRA(a, b)	a b;
#define UARG(a, b)      a b;
#define GRAU(a, b)      a b;
#else
#define PROTOTYPE(p)	p
#define ARGLIST(p)	(
#define ARG(a, b)	a b,
#define GRA(a, b)	a b)
#ifdef __cplusplus
#define UARG(a, b)      a,
#define GRAU(a, b)      a)
#else
#define UARG(a, b)      a b,
#define GRAU(a, b)      a b)
#endif
#endif
#endif



Widget		BxFindTopShell PROTOTYPE((Widget));
WidgetList	BxWidgetIdsFromNames PROTOTYPE((Widget, char*, char*));


void INIT_MEMORY()
{
char  mes[80];

  if(str_list_drugs) 
    free(str_list_drugs);

  if(matrice_I)
      free(matrice_I);

  if ((str_list_drugs = ( XmStringTable )XtMalloc(sizeof(XmString)  ))==NULL)
    {
      sprintf(mes,"Impossible Allocation ...\n");
      message_error(mes,"ATTENTION");
    }
  
  if(( matrice_I = (MATRICE*)malloc(sizeof(MATRICE) )) == NULL)
    {
      sprintf(mes,"Impossible Allocation ...\n");
      message_error(mes,"ATTENTION");
    }
  
  nbr_char = 0 ;

}

void 
exit_editor()
{
  int i,j, reponse;
  char mes[80];


  if(flag_modif)
    {
      sprintf(mes,"File don`t save!...\nDo you really want to exit? ...\n");
      reponse = (int )message_question(mes,"QUESTION");
      
#if DRUG_DEBUG
      printf("reponse: %d\n",reponse);
#endif
    }
  else
    {
      reponse= YES_ANSWER;
    }

  if(reponse==YES_ANSWER)
    {
/*
      printf("exiting...\n\r");
*/
      if(str_list_currents) 
	free(str_list_currents);

      
      if(str_list_drugs) 
	free(str_list_drugs);
      
      if(char_list_drugs) 
	free(char_list_drugs);
      
      if(matrice_I)
	free(matrice_I);

      exit(0);
    }
  
#if DRUG_DEBUG
  printf("Fin de exit\n");
#endif
}


/* 
   Ce programme permet de charger la matrice des courants.
*/


void MAKE_MASK_TABLE(int i, char valeur[100] )
{
int k;

#if DRUG_DEBUG
  printf("valeur=%s\n", valeur);
#endif
  if (!strcmp(valeur,"I_Na")) 
    matrice_I[i].tab[I_Na-1] = 1;
  
  if (!strcmp(valeur,"I_K")) 
    matrice_I[i].tab[I_K-1] = 1;
  
  if (!strcmp(valeur,"I_Ca")) 
    matrice_I[i].tab[I_Ca-1] = 1;
  
  if (!strcmp(valeur,"I_Cl")) 
    matrice_I[i].tab[I_Cl-1] = 1;
  
  if (!strcmp(valeur,"I_A")) 
    matrice_I[i].tab[I_A-1] = 1;
  
  if (!strcmp(valeur,"I_M")) 
    matrice_I[i].tab[I_M-1] = 1;
  
  if (!strcmp(valeur,"I_C")) 
    matrice_I[i].tab[I_C-1] = 1;
  
  if (!strcmp(valeur,"I_H")) 
    matrice_I[i].tab[I_H-1] = 1;
  
  if (!strcmp(valeur,"I_ahp")) 
    matrice_I[i].tab[I_ahp-1] = 1;
  
  if (!strcmp(valeur,"I_Nap")) 
    matrice_I[i].tab[I_Nap-1] = 1;
  
  if (!strcmp(valeur,"I_Cal")) 
    matrice_I[i].tab[I_Cal-1] = 1;
  
  if (!strcmp(valeur,"I_fuite")) 
    matrice_I[i].tab[I_fuite-1] = 1;
  
  if (!strcmp(valeur,"I_P")) 
    matrice_I[i].tab[I_P-1] = 1;

  if (!strcmp(valeur,"I_fuite_Na")) 
    matrice_I[i].tab[I_fuite_Na-1] = 1;

	if (!strcmp(valeur,"I_fuite_K")) 
    matrice_I[i].tab[I_fuite_K-1] = 1;
	
#if DRUG_DEBUG
  /* visu du masque */
  printf("masque des courants[%d]\n",i); 
  for (k=0 ; k<NBR_CURRENTS ; k++)
   {
     printf("  %d",matrice_I[i].tab[k]);
   }  
  printf("\n");

#endif  
}

void browse_help()
{
  browse_manual(XNBC_DRUG_EDITOR);
}

int 
charger_le_fichier(char f_drug[256], int choix)
{
  int nbr_courant, numero, i,j,k;
  char buffer[80], tampon[30];
  char mes[80];
#if DRUG_DEBUG
  printf("choix: %d\n", choix);
#endif

  switch (choix)
    {
/************************ Lecture d`un fichier *****************************/
/************************ Ouverture d`un fichier **************************/
    case READ_ONLY:
    case OPEN:
      {
	nombre_de_drogue = 0;

#if DRUG_DEBUG
	printf("f_drug:%s\n",f_drug);
#endif
	if (!(p_drug = fopen (f_drug,"r")))
	  {
	    printf("\007Can't open %s...",f_drug);
	    return 0;
	  }
#if DRUG_DEBUG
	printf("lecture du nbre de drogues dans le fichier\n");
	/* il y a autant de ligne que de drogues */
#endif
	while(fgets(buffer,80,p_drug))
	  {
	    nombre_de_drogue++;
	  }
	fclose(p_drug);
#if DRUG_DEBUG
	printf("Nbr Drogue:%d\n",nombre_de_drogue);
#endif

	
	if (!nombre_de_drogue) return 0;
	/* allocation de la memoire */

	if ((str_list_drugs = ( XmStringTable )XtRealloc((char *)str_list_drugs ,(sizeof(XmString) * nombre_de_drogue )))==NULL)
	  {
	    sprintf(mes,"Impossible Allocation ...\n");
	    message_error(mes,"ATTENTION");
	  }

	if(( matrice_I = (MATRICE*)realloc(matrice_I,
					   sizeof(MATRICE) * (nombre_de_drogue+1))) == NULL)
	  {
	    sprintf(mes,"Impossible Allocation ...\n");
	    message_error(mes,"ATTENTION");
	  }

	/*initialisation de la matrice*/
	for (i=0 ; i<nombre_de_drogue ; i++)
	  for (j=0 ; j<NBR_CURRENTS ; j++)
	    matrice_I[i].tab[j] = 0;

	/* relire le fichier pour en tirer les infos */ 
	/* il y a autant d`espaces que de courant */

#if DRUG_DEBUG
	printf("lecture des drogues dans le fichier\n");
#endif
	if (!(p_drug = fopen (f_drug,"r")))
	  {
	    printf("\007Can't open %s...",f_drug);
	    return 0;
	  }
	numero = -1;
	
	while(fgets(buffer,80,p_drug))
	  {
	    i =0;
	    while(buffer[i]!=':') /* lire le nom de la drogue */
	      {
		tampon[i] = buffer[i++];
	      }
	    tampon[i] = '\0';
	    
	    /*c`est un nom de Drogue, il faut la lettre dans la liste */
	    numero++;


#if DRUG_DEBUG
	    printf("allocation de char_list: %d\n",nbr_char);
#endif	    
	    if(!nbr_char)
	      {
		/* premiere allocation */
		nbr_char = i+1;

		if ((char_list_drugs = ( char* )malloc( sizeof(char) * nbr_char ))==NULL)
		  {
		    sprintf(mes,"Impossible Allocation ...\n");
		    message_error(mes,"ATTENTION");
		  }

	      }
	    else
	      {
		nbr_char = nbr_char + i+1;

		if ((char_list_drugs = ( char* )realloc(char_list_drugs , sizeof(char) * nbr_char ))==NULL)
		  {
		    sprintf(mes,"Impossible Allocation ...\n");
		    message_error(mes,"ATTENTION");
		  }

	      }
#if DRUG_DEBUG
	    printf("une autre drogue %d: %s\n", numero, tampon );
#endif
	    XmListAddItem(list1,XmStringCreateSimple(tampon),numero+1);

	    k =0;
	    for( j=nbr_char-i-1 ; j<nbr_char-1 ; j++)
	      {
		char_list_drugs[j] = tampon[ k++ ];
#if DRUG_DEBUG
		printf("char[%d]:%c\n",j,char_list_drugs[j]);
#endif
	      }
	    char_list_drugs[nbr_char-1] = '\n';


	    /* lire le nombre de courant ( on compte le nombre d`espaces ) */
	    nbr_courant = 0;

	    for (i=0 ; i<strlen(buffer)-1 ; i++ )
	      {
		if (buffer[i]==' ' && buffer[i+1]!='\n') nbr_courant++;
	      }
#if DRUG_DEBUG
	    printf("\tnbr_courant:%d\n",nbr_courant);
#endif
	    j = 0;
	    for (i=0; i<nbr_courant ; i++)
	      {
		while( buffer[j]!=' ') /* on recherche un espace */
		  {
		    j++;
		  }
#if DRUG_DEBUG
		printf("il y a un espace en %d\n",j);
#endif
		j++;
		k = 0;
		while(buffer[j]!='\n' && buffer[j]!=' ')
		  {
		    tampon[k++] = buffer[j++];
		  }
		tampon[k] = '\0';
		/* le nom du courant est trouve */
		MAKE_MASK_TABLE( numero, tampon );
	      }
	    
	  }

	fclose(p_drug);

#if DRUG_DEBUG
	printf("apres je retourne 1\n");
#endif
	
	break;
      }
/************************ Creation d`un nouveau fichier **************************/

    case NEW:
      {
	nombre_de_drogue = 0;      
      }
    case SAVE_AS:  
      {
	if (!(p_drug = fopen (f_drug,"w")))
	  {
	    sprintf("mes,\007Can't open %s...\n",f_drug);
	    message_error(mes,"ERROR AT OPENING");
	    return 0;
	  }
	  	
	fclose(p_drug);
	
	break;
      }

    } /* fin du switch */


  return 1;
}

/*******************************************************************

  Cette fonction permet la conversion d`une chaine XmString 
  en chaine Char.

*******************************************************************/
#if 1
char *extract_normal_string(cs)
XmString cs;
{

  XmStringContext context;
  XmStringCharSet charset;
  XmStringDirection direction;
  Boolean separator;
  static char *primitive_string;

  XmStringInitContext (&context,cs);
  XmStringGetNextSegment (context,&primitive_string,
			  &charset,&direction,&separator);
  XmStringFreeContext (context);
  return ((char *) primitive_string);
}
#endif
#if 0
char *extract_normal_string(composee)
XmString composee;
{
  caddr_t           contexte;
  char              *texte;
  XmStringCharSet   jeu;
  XmStringDirection dir;
  Boolean           sep;
  char              *tampon = NULL;
  int               fin = FALSE;

  XmStringInitContext (&contexte, composee);
  while (!fin)
    {
      if (XmStringGetNextSegment(contexte, &texte, &jeu,
				 &dir, &sep))
	{
	  if (sep) /* On arrete au premier separateur. */
	    fin = TRUE;

	  if (tampon)
	    {
	      tampon = XtRealloc(tampon,strlen(tampon) + strlen(texte) +2);
	      strcat(tampon,texte);
	    }
	  else
	    {
	      tampon = (char*)XtMalloc(strlen(texte) + 1);
	      strcpy(tampon, texte);
	    }

	  XtFree(texte);
	}
      else
	fin = TRUE;
    }

  XmStringFreeContext(contexte);

  return tampon;

}

#endif




/*******************************************************************

  Cette fonction permet d`ouvrir une boite de selection de fichier
  et de recuperer le pointer.

*******************************************************************/

void 
selection_fichier(int choix )
{
	Widget		dialog;
	XmString	string1, string2;
	Arg		wargs[20];
	int		n = 0;
	char	        *home;

	if(flag_file_selection_box) return;

	home = getenv("XNBC_DRUG_DIR");
	if (home == NULL)
	  home = getenv("HOME");

	string1 = XmStringCreateSimple("*.drug");
	string2 = XmStringCreateSimple(home);
	XtSetArg(wargs[n], XmNautoUnmanage, TRUE);n++;
	XtSetArg(wargs[n], XmNdirMask, string1);n++;
	XtSetArg(wargs[n], XmNdirectory, string2);n++;
	XtSetArg(wargs[n], XmNdialogType, XmDIALOG_FILE_SELECTION);n++;
	dialog = XmCreateFileSelectionDialog(form,
					     "file",
					     wargs,
					     n);
	XtManageChild(dialog);

	XtAddCallback(dialog, XmNokCallback, (XtPointer)OK_file_selection_Proc,(XtPointer) choix);
	XtAddCallback(dialog, XmNcancelCallback, (XtPointer)CANCEL_file_selection_Proc,(XtPointer) choix);
	XtAddCallback(dialog, XmNhelpCallback, (XtPointer)HELP_file_selection_Proc,(XtPointer) choix);

	XmStringFree(string1);	
	XmStringFree(string2);	

	flag_file_selection_box = 1;
} 

void
create_drug_file(int choix)
{
  int i, j, k, l,reponse;
  char     buffer[100];
  char     mes[80];
  
  if (!nombre_de_drogue)
    {
      sprintf(mes,"\007No data to save!...\n");
      message_error(mes,"WARNING");
      return;
    }
  if (!(p_drug = fopen (f_drug,"w")))
    {
      if (choix==SAVE)
	{
	  sprintf(mes,"File Name don`t exist!... \nDo you want to create it now?...\n");
	  reponse = (int )message_question(mes,"QUESTION");
	  if(reponse==YES_ANSWER)
	    {
	      flag_mode = SAVE; 
	      selection_fichier(SAVE);
	      XtSetSensitive(pushButton2,True);
	      XtSetSensitive(pushButton1,True);
	      XtSetSensitive(pushButton,True);
	      XtSetSensitive(text,True);
	    }
	  return;
	}
      else
	{
	  sprintf(mes,"\007Can't open %s...\n",f_drug);
	  message_error(mes,"WARNING");
	  return ;
	}
    }
  
#if DRUG_DEBUG
  printf("\ndans %s \t de 0 a %d\n", p_drug, nombre_de_drogue);
#endif
  j = 0;
  for ( i=0 ; i<nombre_de_drogue ; i++)
    {
      k = 0;
      while(char_list_drugs[j]!='\n')
	{
	  buffer[k++] = char_list_drugs[j++];
	  buffer[k] = '\0';
	}
      j++;
      if(!buffer) 
	{
	  printf("informations incompletes!...\n");
	  return;
	}
      strcat(buffer,": ");
      
#if DRUG_DEBUG
      printf("chaine1: %s    i:%d  j:%d\n",buffer,i,j);
#endif
      
      for ( l=0 ; l<NBR_CURRENTS ; l++)
	{
	  switch(l)
	    {
	    case (I_Na-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_Na ");
	      break;
	    case (I_K-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_K ");
	      break;
	    case (I_Ca-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_Ca ");
	      break;
	    case (I_Cl-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_Cl ");
	      break;
	    case (I_A-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_A ");
	      break;
	    case (I_M-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_M ");
	      break;
	    case (I_C-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_C ");
	      break;
	    case (I_H-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_H ");
	      break;
	    case (I_ahp-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_ahp ");
	      break;
	    case (I_Nap-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_Nap ");
	      break;
	    case (I_Cal-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_Cal ");
	      break;
	    case (I_P-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_P ");
	      break;
	    case (I_fuite-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_fuite ");
	      break;
	    case (I_fuite_Na-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_fuite_Na ");
	      break;
	    case (I_fuite_K-1):
	      if (matrice_I[i].tab[l]==1)
		strcat(buffer,"I_fuite_K ");
	      break;
	    }
	}
      
#if DRUG_DEBUG
      printf("chaine2: %s    i:%d  j:%d\n",buffer,i,j);
#endif
      fprintf(p_drug,"%s\n",buffer);
    }
  fclose(p_drug);

  flag_modif = 0;
}


/*******************************************************************


*******************************************************************/



/*******************************************************************

  Cette fonction permet de gerer les callbacks de l`application

*******************************************************************/
void
action_OK_CB(w, client_data, call_data )
     Widget w;
     int client_data;
     XmAnyCallbackStruct *call_data;
{
#if DRUG_DEBUG
  printf("ACTION_OK_CB -> %d\n",client_data);
#endif

	switch (client_data)
	{
	case ID_QuestionD_mb:
	  flag_reponse = YES_ANSWER;
#if DRUG_DEBUG
	  printf("YES_ANSWER\n");
#endif
	  break;
	case ID_ErrorD_mb:
	  flag_reponse = OK_ANSWER;
#if DRUG_DEBUG
	  printf("OK_ANSWER\n");
#endif
	  break;
	}

}

void
action_CANCEL_CB(w, client_data, call_data )
     Widget w;
     int client_data;
     XmAnyCallbackStruct *call_data;
{
#if DRUG_DEBUG
  printf("action_CANCEL_CB-> %d\n",client_data);
#endif

  switch (client_data)
    {
    case ID_QuestionD_mb:
      {
	flag_reponse = NO_ANSWER;
#if DRUG_DEBUG
	printf("NO_ANSWER\n");
#endif
	break;
      }
    }


}



void
OK_file_selection_Proc(w, client_data, call_data )
     Widget w;
     int client_data;
     XtPointer *call_data;
{
	char	*textstr,
		*pc,
	        mes[80],
		*extract_normal_string();

	XmSelectionBoxCallbackStruct *acs=(XmSelectionBoxCallbackStruct*)call_data;
#if 0	        
	int choix = (int)client_data;
#endif
	textstr = extract_normal_string (acs->value);
#if DRUG_DEBUG
	printf("%d on recupere %s\n",(int )client_data,textstr);
#endif
	if (pc = strrchr(textstr,'.'))
	{
		*pc = 0;
	} /* fin du if */

	strcat(textstr,".drug");
	
	strcpy (f_drug, textstr);
#if DRUG_DEBUG	
	printf("faire charger_le_fichier();\n");
#endif
	if(!charger_le_fichier(f_drug,(int )client_data))
	  {
	    sprintf(mes,"File contains no data ...\n");
	    message_error(mes,"WARNING");
	  }

	flag_file_selection_box = 0;

	if((int )client_data==SAVE_AS)
	  {
#if DRUG_DEBUG
	    printf("SAVE AS creer le fichier\n");
#endif
	    create_drug_file(SAVE_AS);
	  }

	if((int )client_data==SAVE)
	  {
#if DRUG_DEBUG
	    printf("SAVE creer le fichier\n");
#endif
	    create_drug_file(SAVE);
	  }


} /* fin du OK_file_selection_Proc */

void
CANCEL_file_selection_Proc(w, client_data, call_data )
     Widget w;
     int client_data;
     XtPointer *call_data;
{
    XmSelectionBoxCallbackStruct *acs=(XmSelectionBoxCallbackStruct*)call_data;

  flag_file_selection_box = 0;
}

void
HELP_file_selection_Proc(w, client_data, call_data )
     Widget w;
     int client_data;
     XtPointer *call_data;
{
    XmSelectionBoxCallbackStruct *acs=(XmSelectionBoxCallbackStruct*)call_data;
}
void
action_CB(w, client_data, call_data)
     Widget w;
     XtPointer *client_data;
     XtPointer *call_data;
{
  char     *Drug_file_Selection;
  char     mask[10];
  int      i, j, k, l;
  int      position;
  char     *STRING;
  XmString tampon;
  char     *extract_normal_string();
  char     mes[80];
  XmListCallbackStruct *Liste_tampon=(XmListCallbackStruct*)call_data;

  XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call_data;

  int message = (int)(unsigned long)client_data;
  
  switch(message)
    {
    case ID_boutton_menu_new:
      {
#if DRUG_DEBUG
	printf("ID_boutton_menu_new:\n");
#endif
	flag_mode = NEW; 
	selection_fichier(NEW);
	XtSetSensitive(pushButton2,True);
	XtSetSensitive(pushButton1,True);
	XtSetSensitive(pushButton,True);
	XtSetSensitive(text,True);

	XmListDeleteAllItems(list1);
	XmListDeselectAllItems(list2);
	XmTextSetString(text,NULL);

	INIT_MEMORY();

	break;
      }
    case ID_boutton_menu_open:
      {
#if DRUG_DEBUG
	printf("ID_boutton_menu_open:\n");
#endif
	flag_mode = OPEN; 
	selection_fichier(OPEN);
	XtSetSensitive(pushButton2,True);
	XtSetSensitive(pushButton1,True);
	XtSetSensitive(pushButton,True);
	XtSetSensitive(text,True);

	XmListDeleteAllItems(list1);
	XmListDeselectAllItems(list2);
	XmTextSetString(text,NULL);

	INIT_MEMORY();

	break;
      }
    case ID_boutton_menu_read:
      {
#if DRUG_DEBUG
	printf("ID_boutton_menu_read:\n");
#endif
	flag_mode = READ_ONLY; 
	selection_fichier(READ_ONLY);
	XtSetSensitive(pushButton2,False);
	XtSetSensitive(pushButton1,False);
	XtSetSensitive(pushButton,False);
	XtSetSensitive(text,False);

	XmListDeleteAllItems(list1);
	XmListDeselectAllItems(list2);
	XmTextSetString(text,NULL);

	INIT_MEMORY();

	break;
      }
    case ID_boutton_menu_exit:
      {
#if DRUG_DEBUG
	printf("ID_boutton_menu_exit:\n");
#endif
	exit_editor();
#if DRUG_DEBUG
	printf("apres exit_editor\n");
#endif
	break;
      }
    case ID_boutton_add:
      {
#if DRUG_DEBUG
	printf("ID_boutton_add:\n");
#endif
	if(flag_mode == READ_ONLY) return;

	flag_modif = 1;

	if( (STRING = XmTextGetString(text)))
	  {
	    if(STRING[0]=='\0') return;

	    /* elimination des espaces */
	    i=0;
	    while(STRING[i]==' ') {i++;}
	    j=0;
	    while(STRING[j]!='\0')
	      {
		STRING[j] = STRING[j+i];
		j++;
	      }
	    STRING[j] = '\0';


	    nombre_de_drogue++;

	    if((str_list_drugs = ( XmStringTable )XtRealloc((char *)str_list_drugs , 
							    sizeof(XmString) * nombre_de_drogue ))==NULL)
	      {
		sprintf(mes,"Impossible Allocation ...\n");
		message_error(mes,"ATTENTION");
		exit_editor();		
	      }

	    nbr_char = nbr_char + j + 1;
#if DRUG_DEBUG
	    printf("realloc char_list %d\n",nbr_char);
#endif

	    if((char_list_drugs = (char*)realloc(char_list_drugs , sizeof(char) * nbr_char ))==NULL)
	      {
		sprintf(mes,"Impossible Allocation ...\n");
		message_error(mes,"ATTENTION");
		exit_editor();		
	      }

#if DRUG_DEBUG
	    printf("nb: %d une autre drogue: %s\n", nombre_de_drogue, STRING);
#endif

	    XmListAddItem(list1, XmStringCreateSimple(STRING), nombre_de_drogue );

	    k =0;
	    for( i=nbr_char-j-1 ; i<nbr_char-1 ; i++)
	      {
		char_list_drugs[i] = STRING[ k++ ];
#if DRUG_DEBUG
		printf("char[%d]:%c\n",i,char_list_drugs[i]);
#endif
	      }
	    char_list_drugs[nbr_char-1] = '\n';


	    /* allocation de la matrice des courants */
#if DRUG_DEBUG
	    printf("alloc de %d*%d\n",nombre_de_drogue,NBR_CURRENTS);
#endif
	    if(( matrice_I = (MATRICE*)realloc(matrice_I, sizeof(MATRICE)*(nombre_de_drogue+1))) == NULL)
	      {
		sprintf(mes,"Impossible Allocation ...\n");
		message_error(mes,"ATTENTION");
		exit_editor();
	      }

	    /*initialisation de la derniere ligne */
	    for( i=0; i<NBR_CURRENTS ; i++)
	      {
		matrice_I[nombre_de_drogue-1].tab[i] = 0;
	      }
#if DRUG_DEBUG
	    for( i=0; i<NBR_CURRENTS ; i++)
	      {
		printf("%d  ",matrice_I[nombre_de_drogue-1].tab[i]);
	      }
	    printf("\n");
#endif
	    XtFree(STRING);
	  }
	break;
      }
    case ID_boutton_save:
      {
	if(flag_mode == READ_ONLY) return;

	create_drug_file(SAVE);
#if DRUG_DEBUG
	printf("ID_boutton_save:\n");
#endif

	break;
      }
    case ID_boutton_saveas:
      {
	if(flag_mode == READ_ONLY) return;

	flag_mode = SAVE_AS;
	selection_fichier(SAVE_AS);
	XtSetSensitive(pushButton2,True);
	XtSetSensitive(pushButton1,True);
	XtSetSensitive(pushButton,True);
	XtSetSensitive(text,True);

#if DRUG_DEBUG
	printf("ID_boutton_save as:\n");
#endif
	break;
      }
#if 0
    case ID_nom_de_drogue:
      {
#if DRUG_DEBUG
	printf("ID_nom_de_drogue:\n");
#endif
	break;
      }
#endif
    case ID_liste_des_drogues:
      {
	if(numero_de_la_drogue == Liste_tampon->item_position)
	  {

	    if(flag_mode == READ_ONLY)
	      {
		XmListSelectPos(list1,Liste_tampon->item_position,False);
		return;
	      }

	    flag_modif = 1;

	    XmListDeletePos(list1,numero_de_la_drogue);
	    
	    /* ecraser les donnees de la drogue */
	    position = (Liste_tampon->item_position-1);
	    
	    for( i=position ; i<(nombre_de_drogue-1) ; i++ )
	      {
		for( j=0 ; j<NBR_CURRENTS ; j++)
		  matrice_I[i].tab[j] = matrice_I[i+1].tab[j]; 
	      }
	    nombre_de_drogue--;
	    if(( matrice_I = (MATRICE*)realloc(matrice_I, sizeof(MATRICE)*(nombre_de_drogue+1))) == NULL)
	      {
#if DRUG_DEBUG
		printf("nbr: %d \n",nombre_de_drogue);
#endif
		sprintf(mes,"Impossible Allocation ...\n");
		message_error(mes,"ATTENTION");
		exit_editor();
	      }	      
	    numero_de_la_drogue = 0;
	  }
	else
	  {
	    numero_de_la_drogue = Liste_tampon->item_position;
	    XmListDeselectAllItems(list2);
	    /* relire la matrice pour reselectionner les bons courants */
	    for( i=0 ; i<NBR_CURRENTS ; i++)
	      {
		if (matrice_I[numero_de_la_drogue-1].tab[i]==1) XmListSelectPos(list2,i+1,False);
	      }

#if DRUG_DEBUG
	    printf("liste_char\n");

	    for ( i=0 ; i<nbr_char ; i++)
	      {
	        printf("%c",char_list_drugs[i]);
	      }
	    printf("\n");
#endif

	  }
#if DRUG_DEBUG
	printf("ID_liste_des_drogues: numero %d\n",numero_de_la_drogue);

	for( j=0; j<NBR_CURRENTS; j++)
	  {
	    printf("%d\t",matrice_I[numero_de_la_drogue-1].tab[j]);
	  }
	printf("\n");
#endif
	
	if(numero_de_la_drogue)
	  XtSetSensitive(list2, True);
	else
	  XtSetSensitive(list2, False);
	break;


      }
    case ID_liste_des_courants:
      {
	numero_du_courant = Liste_tampon->item_position;
	if(flag_mode == READ_ONLY)
	  {
	    XmListSelectPos(list2,numero_du_courant,False);
	    return;
	  }
#if DRUG_DEBUG
	printf("ID_liste_des_courants:\n");
#endif
	
	flag_modif = 1;

	if(matrice_I[numero_de_la_drogue-1].tab[numero_du_courant-1] == 1)
	  {
	    matrice_I[numero_de_la_drogue-1].tab[numero_du_courant-1] = 0;
	  }
	else
	  {
	    matrice_I[numero_de_la_drogue-1].tab[numero_du_courant-1] = 1;
	  }
#if DRUG_DEBUG	
	/* visualisation */
	for( i=0; i<nombre_de_drogue; i++)
	  {
	    printf("ligne:  %d\t",i);
	    for( j=0; j<NBR_CURRENTS; j++)
	      {
		printf("%d\t",matrice_I[i].tab[j]);
	      }
	    printf("\n");
	  }
#endif
	break;
      }

    }

}










