/*
 creation_editor.c 
*/

#include "drug_definition.h"
#include "drug_editor.h"
#include "find_files.h"

#define  DRUG_DEBUG 0


/*
 * Globally included information.
 */


/*
 * Convenience functions from utilities file.
 */
extern void RegisterBxConverters();
/* extern XtPointer CONVERT(); */
extern XtPointer DOUBLE();
extern XtPointer SINGLE();
extern void MENU_POST();
extern Pixmap XPM_PIXMAP();
extern void SET_BACKGROUND_COLOR();

/*
 * Create the form hierarchy of widgets.
 */
void
Createform(Widget w)
{
    int      i,j;
    Arg      args[20];
    Cardinal ac=0;
    Boolean  argok=False;
    Widget   label2;
    Widget   label1;
    Widget   label_help_1;
    Widget   label_help_2;
    Widget   label;
    Widget   pushButton6;
    Widget   pushButton5;
    Widget   pushButton4;
    Widget   pushButton3;
    Widget   menuBar;
    Widget   cascadeButton;
    Widget   pulldownMenu;
    XmString tampon;

    /*
     * Register the converters for the widgets.
     */

    RegisterBxConverters(XtWidgetToApplicationContext(w)); 
    
    XtInitializeWidgetClass(xmFormWidgetClass);
    XtInitializeWidgetClass(xmScrolledWindowWidgetClass);
    XtInitializeWidgetClass(xmListWidgetClass);
    XtInitializeWidgetClass(xmLabelWidgetClass);
    XtInitializeWidgetClass(xmTextWidgetClass);
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmCascadeButtonWidgetClass);

    ac = 0;
    XtSetArg(args[ac], XmNscrollingPolicy, XmAUTOMATIC); ac++;
    XtSetArg(args[ac], XmNwidth, 581); ac++;
    XtSetArg(args[ac], XmNheight, 34); ac++;
    parent = XmCreateScrolledWindow(w,
				    "parent",
				    args, 
				    ac);
    XtManageChild(parent);

    ac = 0;
    XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
    form = XmCreateForm(parent,
			"form",
			args, 
			ac);

    XtManageChild(form);



    ac = 0;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 0); ac++;
    XtSetArg(args[ac], XmNwidth, 600); ac++;
    XtSetArg(args[ac], XmNheight, 34); ac++;
    menuBar = XmCreateMenuBar(form,
			      "MenuBar",
			      args, 
			      ac);
    XtManageChild(menuBar);
    
    ac = 0;
    tampon = XmStringCreateSimple("File");

    XtSetArg(args[ac], XmNlabelString, tampon ); ac++;

    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftOffset, 10); ac++;
    XtSetArg(args[ac], XmNx, 5); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 114); ac++;
    XtSetArg(args[ac], XmNheight, 24); ac++;
    cascadeButton = XmCreateCascadeButton(menuBar,
					  "FileCascadeButton",
					  args, 
					  ac);
    XtManageChild(cascadeButton);

    XmStringFree(tampon);

    ac = 0;
    XtSetArg(args[ac], XmNx, 395); ac++;
    XtSetArg(args[ac], XmNy, 327); ac++;
    XtSetArg(args[ac], XmNwidth, 91); ac++;
    XtSetArg(args[ac], XmNheight, 28); ac++;
    pulldownMenu = XmCreatePulldownMenu(XtParent(cascadeButton),
					"pulldownMenu",
					args, 
					ac);
    


    ac = 0;
    tampon = XmStringCreateSimple("New");

    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    pushButton3 = XmCreatePushButton(pulldownMenu,
				     "pushButton3",
				     args, 
				     ac);
    XtAddCallback(pushButton3,XmNactivateCallback,(XtPointer)action_CB,
		  (XtPointer)ID_boutton_menu_new);
    XtManageChild(pushButton3);
    XmStringFree(tampon);
    
    ac = 0;
    tampon = XmStringCreateSimple("Open to modify");
    
    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    pushButton4 = XmCreatePushButton(pulldownMenu,
				     "pushButton4",
				     args, 
				     ac);
    XtAddCallback(pushButton4,XmNactivateCallback,(XtPointer)action_CB,
		  (XtPointer)ID_boutton_menu_open);
    XtManageChild(pushButton4);
    XmStringFree(tampon);


    ac = 0;
    tampon = XmStringCreateSimple("Open to visualize");

    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    pushButton5 = XmCreatePushButton(pulldownMenu,
				     "pushButton5",
				     args, 
				     ac);
    XtAddCallback(pushButton5,XmNactivateCallback,(XtPointer)action_CB,
		  (XtPointer)ID_boutton_menu_read);
    XtManageChild(pushButton5);
    XmStringFree(tampon);

    ac = 0;
    tampon = XmStringCreateSimple("Save As");
    
    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    pushButton2 = XmCreatePushButton(pulldownMenu,
				     "pushButton2",
				     args, 
				     ac);
    XtAddCallback(pushButton2,XmNactivateCallback,(XtPointer)action_CB,
		  (XtPointer)ID_boutton_saveas);
    XtManageChild(pushButton2);
    XmStringFree(tampon);

    ac = 0;
    tampon = XmStringCreateSimple("Save");

    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    pushButton1 = XmCreatePushButton(pulldownMenu,
				     "pushButton1",
				     args, 
				     ac);
    XtAddCallback(pushButton1,XmNactivateCallback,(XtPointer)action_CB,
		  (XtPointer)ID_boutton_save);
    XtManageChild(pushButton1);
    XmStringFree(tampon);

    ac = 0;
    tampon = XmStringCreateSimple("Exit");
    
    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    pushButton6 = XmCreatePushButton(pulldownMenu,
				     "pushButton6",
				     args, 
				     ac);
    XtAddCallback(pushButton6,XmNactivateCallback,(XtPointer)action_CB,
		  (XtPointer)ID_boutton_menu_exit);
    XtManageChild(pushButton6);
    XmStringFree(tampon);

    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, pulldownMenu); ac++;
    XtSetValues(cascadeButton, args, ac);
    
    
    ac = 0;
    tampon = XmStringCreateSimple("Help");


    XtSetArg(args[ac], XmNlabelString, tampon ); ac++;
    helpButton = XmCreateCascadeButton(menuBar,
					  "Help",
					  args, 
					  ac);

    XtAddCallback(helpButton,XmNactivateCallback,(XtPointer)browse_help, NULL);

    XtManageChild(helpButton);

    XmStringFree(tampon);

    ac = 0;
    XtSetArg(args[ac], XmNmenuHelpWidget, helpButton); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(menuBar, args, ac);
 


    ac = 0;
    XtSetArg(args[ac], XmNx, 200); ac++;
    XtSetArg(args[ac], XmNy, 90); ac++;
    XtSetArg(args[ac], XmNwidth, 123); ac++;
    XtSetArg(args[ac], XmNheight, 200); ac++;
    XtSetArg(args[ac], XmNlistSizePolicy, XmCONSTANT); ac++;
    XtSetArg(args[ac], XmNselectionPolicy, XmSINGLE_SELECT); ac++;
    list1 = XmCreateScrolledList(form,
				 "list1",
				 args, 
				 ac);

    XtVaSetValues(list1,
		  XmNitems, str_list_drugs,
		  XmNitemCount, 0,
		  XmNvisibleItemCount, 11,
		  NULL);

    XtAddCallback(list1,XmNsingleSelectionCallback,(XtPointer)action_CB,
		  (XtPointer)ID_liste_des_drogues);
    
    XtManageChild(list1);
    
    ac = 0;    
    tampon = XmStringCreateSimple("List of currents");

    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    XtSetArg(args[ac], XmNx, 360); ac++;
    XtSetArg(args[ac], XmNy, 10); ac++;
    XtSetArg(args[ac], XmNwidth, 130); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    label2 = XmCreateLabel(form,
			   "label2",
			   args, 
			   ac);
    XtManageChild(label2);
    XmStringFree(tampon);

    ac = 0;
    tampon = XmStringCreateSimple("List of Drugs");

    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    XtSetArg(args[ac], XmNx, 210); ac++;
    XtSetArg(args[ac], XmNy, 10); ac++;
    XtSetArg(args[ac], XmNwidth, 122); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    label1 = XmCreateLabel(form,
			   "label1",
			   args, 
			   ac);
    XtManageChild(label1);
    XmStringFree(tampon);

    ac = 0;
    tampon = XmStringCreateSimple("Enter drug name, press add, select it, select currents it inactivates");

    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 400); ac++;
    XtSetArg(args[ac], XmNwidth, 600); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    label_help_1 = XmCreateLabel(form,
			   "label_help_1",
			   args, 
			   ac);
    XtManageChild(label_help_1);
    XmStringFree(tampon);

    ac = 0;
    tampon = XmStringCreateSimple("To remove drug or current click on it when selected");

    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 450); ac++;
    XtSetArg(args[ac], XmNwidth, 600); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    label_help_2 = XmCreateLabel(form,
			   "label_help_2",
			   args, 
			   ac);
    XtManageChild(label_help_2);
    XmStringFree(tampon);




    if((str_list_currents = ( XmStringTable )XtMalloc(sizeof(XmString) *  NBR_CURRENTS ))==NULL)
       {
	 printf("Allocation Impossible\n");
	 exit_editor();
       }
    str_list_currents[0]  =  XmStringCreateSimple("Na current");
    str_list_currents[1]  =  XmStringCreateSimple("K current");
    str_list_currents[2]  =  XmStringCreateSimple("Ca current");
    str_list_currents[3]  =  XmStringCreateSimple("Cl current");
    str_list_currents[4]  =  XmStringCreateSimple("A current");
    str_list_currents[5]  =  XmStringCreateSimple("M current");
    str_list_currents[6]  =  XmStringCreateSimple("C current");
    str_list_currents[7]  =  XmStringCreateSimple("H current");
    str_list_currents[8]  =  XmStringCreateSimple("ahp current");
    str_list_currents[9]  =  XmStringCreateSimple("Nap current");
    str_list_currents[10] =  XmStringCreateSimple("Cal current");
    str_list_currents[11] =  XmStringCreateSimple("P current");
    str_list_currents[12] =  XmStringCreateSimple("leak current");

    ac = 0;
    XtSetArg(args[ac], XmNx, 360); ac++;
    XtSetArg(args[ac], XmNy, 90); ac++;
    XtSetArg(args[ac], XmNwidth, 131); ac++;
    XtSetArg(args[ac], XmNheight, 200); ac++;
    XtSetArg(args[ac], XmNlistSizePolicy, XmCONSTANT); ac++;
    XtSetArg(args[ac], XmNselectionPolicy, XmMULTIPLE_SELECT); ac++;
    list2 = XmCreateScrolledList(form,
				 "list2",
				 args, 
				 ac);
    XtVaSetValues(list2,
		  XmNitems, str_list_currents,
		  XmNitemCount, 13,
		  XmNvisibleItemCount, 11,
		  NULL);

    XtAddCallback(list2,XmNmultipleSelectionCallback,(XtPointer)action_CB,
		  (XtPointer)ID_liste_des_courants);


    XtManageChild(list2);
    
    XtSetSensitive(list2, False);

    ac = 0;
    XtSetArg(args[ac], XmNx, 15); ac++;
    XtSetArg(args[ac], XmNy, 50); ac++;
    XtSetArg(args[ac], XmNwidth, 130); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    text = XmCreateText(form,
			"text",
			args, 
			ac);
    XtManageChild(text);
    
    ac = 0;
    tampon = XmStringCreateSimple("Enter Drug Name");

    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    XtSetArg(args[ac], XmNy, 10); ac++;
    XtSetArg(args[ac], XmNwidth, 140); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    label = XmCreateLabel(form,
			  "label",
			  args, 
			  ac);
    XtManageChild(label);
    XmStringFree(tampon);

    
    ac = 0;
    tampon = XmStringCreateSimple("Add");

    XtSetArg(args[ac], XmNlabelString, tampon);ac++;
    XtSetArg(args[ac], XmNx, 10); ac++;
    XtSetArg(args[ac], XmNy, 130); ac++;
    XtSetArg(args[ac], XmNwidth, 135); ac++;
    XtSetArg(args[ac], XmNheight, 40); ac++;
    pushButton = XmCreatePushButton(form,
				    "pushButton",
				    args, 
				    ac);
    XtAddCallback(pushButton,XmNactivateCallback,(XtPointer)action_CB,
		  (XtPointer)ID_boutton_add);
    XtManageChild(pushButton);
    XmStringFree(tampon);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNtopWidget, label1); ac++;
    XtSetArg(args[ac], XmNtopOffset, 10); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetValues(list1, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET ); ac++;
    XtSetArg(args[ac], XmNtopWidget, menuBar ); ac++;
    XtSetArg(args[ac], XmNleftWidget, label1); ac++;
    XtSetArg(args[ac], XmNtopOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftOffset, 28); ac++;
    XtSetValues(label2, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET ); ac++;
    XtSetArg(args[ac], XmNtopWidget, menuBar ); ac++;
    XtSetArg(args[ac], XmNleftWidget, label); ac++;
    XtSetArg(args[ac], XmNtopOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftOffset, 60); ac++;
    XtSetArg(args[ac], XmNrightOffset, 0); ac++;
    XtSetValues(label1, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNtopWidget, label2); ac++;
    XtSetArg(args[ac], XmNleftWidget, list1); ac++;
    XtSetArg(args[ac], XmNtopOffset, 50); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 37); ac++;
    XtSetValues(list2, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopWidget, label); ac++;
    XtSetArg(args[ac], XmNtopOffset, 10); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 15); ac++;
    XtSetValues(text, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET ); ac++;
    XtSetArg(args[ac], XmNtopWidget, menuBar ); ac++;
    XtSetArg(args[ac], XmNtopOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftOffset, 10); ac++;
    XtSetValues(label, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopWidget, text); ac++;
    XtSetArg(args[ac], XmNtopOffset, 40); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 10); ac++;
    XtSetValues(pushButton, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopWidget, pushButton); ac++;
    XtSetArg(args[ac], XmNtopOffset, 180); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetValues(label_help_1, args, ac);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNtopWidget, pushButton); ac++;
    XtSetArg(args[ac], XmNtopOffset, 220); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 0); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetValues(label_help_2, args, ac);

    XtSetKeyboardFocus(text,None);

}



/*----------------------------------------------------------------------------
 *	D I S P L A Y _ Q U E S T I O N
 *--------------------------------------------------------------------------*/

int
message_question ( msg,title)
char	*msg;
char    *title;
{
	XmString  xm_string, yes, no;
	Arg	  wargs[20];
	int       n;   
	Display		*disp = XtDisplay (form);

/*--- Question Dialog ------------------------------------------------------*/

	yes = XmStringCreateSimple ("Yes");
	no = XmStringCreateSimple ("No");
	xm_string = XmStringCreateLtoR (msg, XmSTRING_DEFAULT_CHARSET);

	n=0;
	XtSetArg(wargs[n], XmNmessageString, xm_string);n++;
	XtSetArg(wargs[n], XmNtitle, title );n++;
	question_dialog = XmCreateQuestionDialog (form,
						  "question_dialog", 
						  wargs, 
						  n);

	XtVaSetValues (question_dialog,
	    XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL,
	    XmNokLabelString, yes,
	    XmNcancelLabelString, no,
	    NULL);
	XtUnmanageChild ( XmMessageBoxGetChild (question_dialog, XmDIALOG_HELP_BUTTON));

	XtAddCallback (question_dialog, XmNokCallback, (XtPointer)action_OK_CB,
	    (XtPointer)ID_QuestionD_mb);

	XtAddCallback (question_dialog, XmNcancelCallback,(XtPointer)action_CANCEL_CB, 
		       (XtPointer)ID_QuestionD_mb);

	XmStringFree (yes);
	XmStringFree (no);
	XmStringFree (xm_string);

/*--- Remplissage de la fenetre --------------------------------------------*/


	if (XtIsManaged (question_dialog))
	{
		XtUnmanageChild (question_dialog);
	}

	XtManageChild (question_dialog);

/*--- Boucle d'evenements --------------------------------------------------*/

	flag_reponse= NULL_ANSWER;

#if DRUG_DEBUG
	printf("avant la reponse\n");
#endif
	while (	flag_reponse==NULL_ANSWER )
	{
		XtAppProcessEvent(app_context, XtIMAll);
		XSync (disp, False);	
	}
#if DRUG_DEBUG
	printf("apres la reponse\n");
#endif

	XtUnmanageChild (question_dialog);
	XSync (disp, False);
	XmUpdateDisplay (question_dialog);	

/*--- Sortie ---------------------------------------------------------------*/

	XtDestroyWidget (question_dialog);
	
	if (flag_reponse==YES_ANSWER)
	  {
#if DRUG_DEBUG
	    printf("return YES_ANSWER\n");
#endif
	    return(YES_ANSWER);
	  }
        if (flag_reponse==NO_ANSWER)
	  {
#if DRUG_DEBUG
	    printf("return NO_ANSWER\n");
#endif
	    return(NO_ANSWER);
	  }
#if DRUG_DEBUG
	    printf("return NULL_ANSWER\n");
#endif
	return (NULL_ANSWER);
      }

/*----------------------------------------------------------------------------
 *	D I S P L A Y _ E R R O R
 *--------------------------------------------------------------------------*/

int
message_error (msg, title)
char	*msg;
char    *title;
{
	XmString  xm_string;
	Arg	  wargs[20];
	int       n;
	Display		*disp = XtDisplay (form);


/*--- Error Dialog ---------------------------------------------------------*/

	xm_string = XmStringCreateLtoR (msg, XmSTRING_DEFAULT_CHARSET);

	n=0;
	XtSetArg(wargs[n], XmNmessageString, xm_string);n++;
	XtSetArg(wargs[n], XmNtitle, title );n++;
	XtSetArg(wargs[n], XmNdialogType, XmDIALOG_FULL_APPLICATION_MODAL );n++;
	error_dialog  = XmCreateErrorDialog (form,
					     "error_dialog", 
					     wargs, 
					     n);


	XtUnmanageChild (
	    XmMessageBoxGetChild (error_dialog, XmDIALOG_CANCEL_BUTTON));
	XtUnmanageChild (
	    XmMessageBoxGetChild (error_dialog, XmDIALOG_HELP_BUTTON));

	XtAddCallback (error_dialog, XmNokCallback, (XtPointer)action_OK_CB, 
	(XtPointer)(unsigned long)ID_ErrorD_mb);


	
	XtManageChild (error_dialog);

	XmStringFree (xm_string);

/*--- Boucle d'evenements --------------------------------------------------*/

	flag_reponse = NULL_ANSWER;

	while (flag_reponse==NULL_ANSWER )
	{
		XtAppProcessEvent(app_context, XtIMAll);
		XSync (disp, False);	
	}
	
	XtUnmanageChild (error_dialog);
	XSync (disp, False);
	XmUpdateDisplay (error_dialog);	

/*--- Sortie ---------------------------------------------------------------*/

	XtDestroyWidget (error_dialog);

	if (flag_reponse==OK_ANSWER)
	{
		return(OK_ANSWER);
	}

	return (NULL_ANSWER);

}

