/*
 *
 *   D R U G _ E D I T O R
 *
 *   Editeur de drogue pour xnbc (nbc_x et G_neuron)
 *
 *   Version initiale ecrite par Guy Sempe
 *
 *   V0    Version initiale (GS)                30 aout 1997
 *   V1    help ajoute en bas de fenetre (JFV)   6 oct 1997
 *   V2    bouton browse manual ajoute (JFV)	11 aout 1998
 *   V2.1    correction bug apparu sous linux (JFV)	12 aout 1998
 *   V2.2    lecture systematique du fichier Default.drug (JFV)	23 sept 1999
  *   V23    prise en compte des courants de fuite Na et K (JFV)	19 juin 2006
*
 *               Dr J-F VIBERT
 *               B3E ESI INSERM U444 UMR-S 707
 *               CHU Saint-Antoine
 *               27 rue Chaligny
 *               75571 Paris cedex 12
 *               France
 *
 *       Copyright Dr JF Vibert
 *
 *       All rights reserved
 *       Access limited to authorized persons
 *       This software was developped only for research purpose
 *       and is not, in any way usable for commercial purpose.
 */



#include "drug_definition.h"


#define MAIN 
#include "drug_editor.h"
#undef MAIN
/*
 * Globally included information.
 */


/*
 * Headers for classes used in this program
 */

/*
 * Convenience functions from utilities file.
 */
extern void RegisterBxConverters();
extern XtPointer CONVERT();
extern XtPointer DOUBLE();
extern XtPointer SINGLE();
extern void MENU_POST();
extern Pixmap XPM_PIXMAP();
extern void SET_BACKGROUND_COLOR();


/* Begin user code block <globals> */
/* End user code block <globals> */

/*
 * Change this line via the Output Application Names Dialog.
 */



int main(argc, argv)
 int argc;
 char **argv;
{
    Arg          args[256];
    Cardinal     ac;
    Boolean      argok=False;
    char         buffer[256];

    
    XtToolkitInitialize();

    app_context = XtCreateApplicationContext();


    if ((the_display = XtOpenDisplay (app_context, NULL, argv[1], "XMclient",
				      NULL, 0, &argc, argv)) == NULL)
    {
	printf ("\n%s:  Can't open display\n", argv[0]);
        exit(1);
    }
    

    ac = 0;
    XtSetArg(args[ac], XmNtitle, BX_APP_NAME); ac++;
    XtSetArg(args[ac], XmNiconName,BX_APP_NAME ); ac++;
    XtSetArg(args[ac], XmNx, 47); ac++;
    XtSetArg(args[ac], XmNy, 393); ac++;
    XtSetArg(args[ac], XmNwidth, 604); ac++;
    XtSetArg(args[ac], XmNheight, 500); ac++;

    if ((topLevelShell = XtAppCreateShell("app_context", "Drug_Editor",
					  applicationShellWidgetClass,
					  the_display, args, ac )) == NULL)
      {
	printf ("\nIt's impossible to create Shell...\n");
        exit(1);
      }

    XtRealizeWidget(topLevelShell);

    Createform((Widget)topLevelShell);

    XtSetKeyboardFocus(text,None);

	if (getenv("XNBC_DRUG_DIR"))
	{
		strcpy(buffer,getenv("XNBC_DRUG_DIR"));
		strcat(buffer,"/Default.drug");
		charger_le_fichier(buffer,READ_ONLY);
	} /* fin du if */

    XtAppMainLoop(app_context);
    
    /*
     * A return value even though XtAppMainLoop never ends. 
     */
     return(0); 
}
