/*******************************************************************
*
*			 E C R A N . C
*
*	Fichier de fonctions de la gestion d'ecran VT100 / VT2xx
*
*		J-F VIBERT      23-MAR-1987 12:58:13 
*	Portage ULTRIX
*		J-F VIBERT	10 mars 1988
*		
*	Auteur: Dr J-F VIBERT et Ch. PASTORET
*		Laboratoire de Physiologie
*		CHU Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for research purpose
*	and is in any way usable for commercial purpose.
*
*	Modifie par J-F Vibert les
*		 13-MAY-1987 11:59:49 
*		par Ch Pastoret
*		 NOV-87
*
*********************************************************************/
#ifdef DOCUMENTATION

title	ECRAN	Gestion d ecran
index		Gestion d ecran


Synopsis

	.nf
	#include <ecran.h>
	.f

Description

Files


See also


Diagnostics

Authors

	Dr Jean-Francois VIBERT
	Christian PASTORET
	.s
	CHU Saint_Antoine PARIS

Bugs/deficiencies


#endif

#include <stdio.h>
#include <ecran.h>

/************************ C A R A C T E R E S ************************/


dblew(chain)
char  *chain ;
{	printf("%s%s",DBLEW,chain);
	putchar('\n');
	puts(SINGLEW);
}	

			/****** caracteres en double-largeur ******/
		             /****** et double-hauteur ******/
				    /* Haut et Bas */

dblehw(chain)
char  *chain ;
{	int  s ;
	s=strlen(chain) ;
	printf("%s%s",DBLEH,chain);
	cursB(s);cursD(1);
	printf("%s%s",DBLEB,chain);
}

/****************************** E C R A N **********************************/

		/******	CLS() efface tout l'ecran ******/

cls()
{
	puts(CLRAS);
}
		/******	CLS_DOWN() efface l'ecran de la position courante au bas ******/

cls_down()
{
	puts(CLS);
}

/******************* B L I N K / R E V E R S E / N O R M A L *****************/


		/******	s_bold() passe en surbrillant ******/

s_bold()
{
	puts(BOLD);
}
		/******	s_blink() passe en clignotant ******/

s_blink()
{
	puts(BLINK);
}
		/******	s_underline() passe en souligne ******/

s_underline()
{
	puts(UNDERLINE);
}

		/******	s_reverse() passe en reverse video ******/

s_reverse()
{
	puts(REVERSE);
}
		/******	s_normal() revient en normal ******/

s_normal()
{
	puts(NORMAL);
}

/************************ C U R S E U R ********************************/

		/***** home ******/

home()
{
	puts(HOME);
}

		/******	curseur() positionne le curseur ******/

curseur(ligne,colonne)
int	ligne,
	colonne;
{
	printf("\033[%d;%dH",ligne,colonne);
}
		/******	SAVE_CURS() sauvegarde la position du curseur ******/

save_curs()
{
	puts("\0337");
}
		/******	REST_CURS() sauvegarde la position du curseur ******/

rest_curs()
{
	puts("\0338");
}

		/****** cursUP() ; cursD()   DEPLACEMENT DU CURSEUR ******/
		/****** cursF() ;cursB()     HAUT;BAS;AVANT;ARRIERE ******/
cursUP(haut)
int    haut ;
{	
	printf("\033[%dA",haut);
}
cursD(bas)
int    bas ;
{	
	printf("\033[%dB",bas);
}
cursF(avant)
int    avant ;
{	
	printf("\033[%dC",avant);
}
cursB(arriere)
int    arriere ;
{	
	printf("\033[%dD",arriere);
}

/*************************** S T A T U S ********************************/

		/******* STATUS() genere une ligne de status ******/

status(st_msg)
char *st_msg;
{
	save_curs();
	curseur(24,11);
	printf("%s",st_msg);
	rest_curs();
}
		/******	CLR_STATUS() efface le message de status ******/

clr_status()
{
	register i;

	save_curs();
	curseur(24,11);
	for (i = 0; i<59; i++) putchar(' ');	/* efface jusqu'a l'indication buzzer */
	rest_curs();
}	
/************************* S C R O L L I N G ****************************/

		/******	SCROLL() definit la scrolling region ******/

scroll(haut,bas)
int haut, bas;
{
	printf("\033[%d;%dr",haut,bas);
}

		/******* CLR_SCROLL() efface la scrolling region ******/

clr_scroll()
{
	puts("\033[18M");
}

/*********************** D E L E T I O N S **************************/


/************** L I G N E S  H O R I Z.  &  V E R T I C A L E S **********/

			/****** ligne horizontale ******/

lineh(longueur)
int   longueur ;
{
	int i ;
	GRAPH ;
	for (i=1;i<=longueur;i++)
		putchar('q');
	NOGRAPH ;		
	
}

		/****** trait vertical ******/

linev(hauteur)
int   hauteur ;
{
	int i ;
	GRAPH ;
	for (i=1;i<=hauteur;i++)
		{ putchar('x');cursBD ;}
	NOGRAPH ;
}
		/****** ligne horizontale de caracteres graphiques ******/

linehg(letter,longueur)
char  letter  ;
int   longueur ;
{
	int i ;
	GRAPH ;
	for (i=1;i<=longueur;i++)
		putchar(letter);
	NOGRAPH ;
}
		/****** trait vertical de caracteres graphiques ******/
			
linevg(letter,hauteur)
char   letter ;
int  hauteur ;
{
	int i ;
	GRAPH ;
	for (i=1;i<=hauteur;i++)
		{ putchar(letter);cursBD ;}
	NOGRAPH ;
}
		
/*************************** C A D R E ***********************************/

cadre(largeur,hauteur)
int   largeur,hauteur;
{	int i ,a ,b ;
	a=largeur-1;
	b=hauteur-1;

	GRAPH ;
	putchar('l');
	for(i=1;i<a;i++) putchar('q'); 
	putchar('k');

	if (largeur>=80)
		{ cursD(1);putchar('x');}
	else
	 	cursBD;

	for(i=1;i<b;i++) 
		{ if(largeur>=80)
			{ putchar('x');cursD(1);}
		  else
			{ putchar('x');cursBD;}
		}
	putchar('j');
	if(largeur>=80)
		{ cursB(1);putchar('q');}

	for(i=1;i<a;i++) 
		{  cursB(2);putchar('q');}
	cursB(2);
	putchar('m');
	for(i=1;i<b;i++) 
		{  cursB(1);cursUP(1);putchar('x');}
	NOGRAPH;
}


