/*----------------------------------------------------------------------------
 *	C L U S T E R . H
 *--------------------------------------------------------------------------*/

/*
*
*	Author: Patrick GLANDAZ
*		Laboratoire de Biomathematiques
*		URBB B3E INSERM U263
*		Faculte de Medecine Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*       Modifications: Denis LAMBOLEZ (Feb 1993)
*                      Laboratoire de Biomathematiques
*                      URBB B3E INSERM U263
*                      Faculte de Medecine Saint-Antoine
*                      27 rue Chaligny
*                      75571 Paris cedex 12
*                               France
*
*
*	Copyright Dr JF Vibert, July 1992 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is not, in any way, usable for commercial purpose.
*
*/

#define		k_MainW_lew			1
#define		k_ScrolledW_lew			2
#define		k_DrawingA_Work_Area_lew	3

#define		k_PushBG_SaveAs_lew		7
#define		k_PushBG_Save_lew		8
#define		k_PushBG_Open_lew		9
#define		k_PushBG_New_lew		10
#define		k_PushBG_Exit_lew		11

#define		k_PushBG_CopyCl_lew		14
#define		k_PushBG_NewCl_lew		15
#define		k_PushBG_DeleteCl_lew		16
#define		k_PushBG_ModifyCl_lew		17
#define		k_PushBG_SwapCl_lew		18
#define		k_PushBG_MoveCl_lew		19

#define		k_PushBG_NewLi_lew		21
#define		k_PushBG_DeleteLi_lew		22
#define		k_PushBG_ModifyLi_lew		23

#define		k_PushBG_Automatic_lew		24
#define		k_PushBG_Manual_lew		25

#define		k_PushBG_CreateBOTH_lew		26
#define		k_PushBG_CreateCNX_lew		27
#define		k_PushBG_CreateANAT_lew		28

#define		k_PushBG_OnContext_lew		29
#define		k_PushBG_OnWindow_lew		30

#define 	ID_help_form			31
#define		ID_help_text			32
#define		ID_topic_pulldownMenu		33
#define		ID_topic_label			34

#define		k_max_widget_le			50

#define		MAX_WIDGETS_LE		(k_max_widget_le + 1)

#define		GC_BLANC			0
#define		GC_NOIR			1
#define		GC_NOIR2			2

#define		MAX_GC			10

#ifndef		PI
#	define	PI			3.1415926535
#endif
#define		CLUSTER_FORM_WIDTH	150
#define		CLUSTER_FORM_HEIGHT	150
#define		CLUSTER_OFFSET		2
#define		CLUSTER_BORDER_WIDTH	2

#define		_FULL_EXCITATION_	0
#define		_FULL_INHIBITION_	1
#define		_FULL_RANDOMIZED_	2
#define		_FULL_NOT_CONNECTED_	4
#define		_PART_EXCITATION_       5
#define		_PART_INHIBITION_	6
#define		_PART_RANDOMIZED_	7
#define		_FULLY_CONNECTED_	8
#define		_PART_SEND_             9
#define		_PART_RECEIVE_	        10
#define		_PART_AVERAGE_	        11

/*----- Liste des actions --------------------------------------------------*/

#define		NO_ACTION			0
#define		DELETE_CLUSTER_ACTION		1
#define		MODIFY_CLUSTER_ACTION		2
#define		COPY_CLUSTER_ACTION		3
#define		SWAP_CLUSTER_ACTION1		4
#define		SWAP_CLUSTER_ACTION2		5
#define		MOVE_CLUSTER_ACTION1		14
#define		MOVE_CLUSTER_ACTION2		15
#define		NEW_LINK_ACTION1			6
#define		NEW_LINK_ACTION2			7
#define		DELETE_LINK_ACTION1		8
#define		DELETE_LINK_ACTION2		9
#define		MODIFY_LINK_ACTION1		10
#define		MODIFY_LINK_ACTION2		11
#define		SAVE_FILE_ACTION			12
#define		SAVE_AS_FILE_ACTION		13

#define		AUTOMATIC			1
#define		MANUAL				2

/*----- C L U S T E R . C --------------------------------------------------*/

void		exit_link_editor (void);
void		le_create_proc ();
void		le_activate_proc ();
void		le_expose_proc ();

void		new_clust_wid (void);
void		copy_clust_wid (int);
void		delete_clust_wid (int);
void		modify_clust_wid (int);
void		swap_clust_wid (int, int);
int		alloc_new_clust_wid (void);
int		search_clust_wid (char *);
int             get_nb_neurons(int);
void		decorate_clust_wid (int);
void		replace_clust_wids (void);
void		activate_no_proc ();
void		activate_name_proc ();
void		set_placement_mode (char *);
void		press_button_proc ();
void		move_button_proc ();
void		release_button_proc ();

int		new_link_para (int, int);
int		delete_link_para (int, int);
int		modify_link_para (int, int);
int		alloc_new_link_para (int, int);
int		search_link_para (int, int);
void		redraw_link_paras ();
void		calculate_link_coord (int);
int		inter_segment (DB_POINT, DB_POINT, DB_POINT, DB_POINT, DB_POINT *);

void		save_file ();
void		save_as_file ();
void		open_file (void);
void		new_file ();
int		confirm_save_file (Widget);
void		full_save_file (char *);
void		read_save_file ();

void		create_both_files (void);
void		create_cnx_file (char *);
void		create_anat_file (char *);
void		one_connection (int, short *, short *, int, int);

#ifdef MAIN
#	define CLASS
#else
#	define CLASS	extern
#endif

CLASS	Widget 	help_form,
		help_text,
		topic_pulldownMenu,
		topic_label;

CLASS	char	help_directory[256];
CLASS	char	savefile_name[256];
CLASS 	char	current_directory[256];
CLASS	char	project_directory[256];

