/*----------------------------------------------------------------------------
 *	D I A L O G _ I N P U T S . H
 *--------------------------------------------------------------------------*/

/*
*
*	Author: Patrick GLANDAZ
*		Laboratoire de Biomathematiques
*		URBB B3E INSERM U263
*		Faculte de Medecine Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert, July 1992 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is not, in any way, usable for commercial purpose.
*
*/

#define		k_TextF_AxoneMean_leil		1
#define		k_TextF_AxoneSd_leil		2
#define		k_TextF_BornMin_leil		3
#define		k_TextF_BornMax_leil		4
#define		k_PushBG_Ok_leil		5
#define		k_PushBG_Cancel_leil		6
#define		k_PushBG_Help_leil		7
#define		k_LabelG_ClustToClust_leil	8
#define		k_ToggleBG_Excit_leil		9	
#define		k_ToggleBG_Inhib_leil		10
#define		k_ToggleBG_Random_leil		11
#define		k_PushBG_Apply_leil		61

  

/*-----------------------------------------------------------*/

#define		k_FormD_InputCluster_leic	15
#define		k_PushBG_Ok_leic		16
#define		k_PushBG_Cancel_leic		17
#define		k_PushBG_Help_leic		18
#define		k_TextF_PositionH_leic		19
#define		k_TextF_PositionL_leic		20
#define		k_TextF_PositionAP_leic		21
#define		k_TextF_ClusterName_leic	22
#define		k_PushBG_NeuronFile_leic	23
#define		k_TextF_NeuronFile_leic		24
#define		k_TextF_NbNeurons_leic		25
#define		k_TextF_DeltaAP_leic		26
#define		k_TextF_DeltaL_leic		27
#define		k_TextF_DeltaH_leic		28
#define		k_ToggleBG_Ellipsoid_leic	29
#define		k_ToggleBG_Brick_leic		30

/*------- Definitions propres a matrix.c ----------------------*/
#define		k_PushBG_Details_leil		31
#define		k_Draw_Matrix_leil		32
#define		k_Window_Grid			33
#define 		k_PushBG_Matrix_leil	34
#define 		k_ToggleBG_Matrix_excit	35
#define 		k_ToggleBG_Matrix_inhib	36
#define 		k_ToggleBG_Matrix_manual 37
#define    		k_PushBG_Matrix_record	38
#define    		k_PushBG_Matrix_stop	39
#define   		k_PushBG_Matrix_place	40
#define   		k_PushBG_Matrix_repeat	41
#define   		k_PushBG_Matrix_clear	42
#define   		k_PushBG_Matrix_Connect	43
#define		k_PushBG_Select_file		44
#define		k_PushBG_Ok_file		45
#define		k_PushBG_Cancel_action		46
#define 	k_Label_Matrix_HoLine		47
#define		k_label_current_mode		48
#define 	k_ToggleBG_Matrix_nocon		49

#define		k_PushB_G_unit			50
#define 	k_PushB_P_unit			51
#define		k_PushB_virtual			52
#define		k_PushB_B_unit			58
#define		k_PushB_L_unit			59
#define		k_toggleB_no_auto		60

#if ADD_NEW_MODEL
/***************** TO ADD A MODEL COPY AND ADAPT **************/
#define         k_PushB_X_unit			62
/***********************       STOP     ***********************/
#endif

#define		k_toggleB_send			53
#define		k_toggleB_receive		54
#define		k_toggleB_average		55
#define		k_textF_K_connections		56
#define		k_toggleB_full_connections	57

/**************************** TO ADD A MODEL *******************/
/**************** VERIFY THAT THIS STAYS TRUE, ADAPT ***********/

#define		k_max_widgets			62

/***********************       STOP     ***********************/


#define		DI_MAX_WIDGETS			(k_max_widgets+1)

#define		NOTHING_ANSWERED		1
#define		OK_ANSWER			2
#define		CANCEL_ANSWER			3
#define		YES_ANSWER			4
#define		NO_ANSWER			5

void		di_create_proc ();
void		di_ok_proc ();
void		di_cancel_proc ();
void		di_help_proc ();

void		init_dialog_inputs (Widget);
void		exit_dialog_inputs (void);
void		display_help(int);
void		deconnect(int);
void 		di_help_on_line();
void 		di_clear_help_on_line();
void 		di_create_help();
void		clear_label_help();
void		fill_label_help();
void		display_coordinates();

LINK_PARAMETERS	*display_inputlink (LINK_PARAMETERS *, int, int);
static void		full_link_inputs ();
static void		default_link_inputs (int, int);
static int		verify_link_inputs (void);

CLUSTER_WIDGET	*display_inputcluster (CLUSTER_WIDGET *);
void		 select_neuron_file ();
static void	 full_cluster_inputs ();
static void	 default_cluster_inputs (void);
static int	 verify_cluster_inputs (void);

extern int      Display_Matrice(Widget, Widget);
