/*----------------------------------------------------------------------------
 *	T Y P E D E F S . H
 *--------------------------------------------------------------------------*/

/*
*
*	Author: Patrick GLANDAZ
*		Laboratoire de Biomathematiques
*		URBB B3E INSERM U263
*		Faculte de Medecine Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert, July 1992 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is not, in any way, usable for commercial purpose.
*
*/

typedef struct
{
	Widget	form,
		no,
		name,
		position;
	int	px,
		py,
		px_manual,
		py_manual,
		yet_placed,
		center_px,
		center_py,
		numero,
		nb_neurons,
		first_neuron,
		last_neuron,
		no_auto,
		position_H,
		position_L,
		position_AP,
		delta_H,
		delta_L,
		delta_AP;
	char	*neuron_file;
	char	ch_name[20],
		shape;
} CLUSTER_WIDGET;

typedef struct
{
	float	K_connections;	/* nb moyen de connexions */
	int	cluster1,
		cluster2,

		begin_px,	/*  Coordonnees de la liaison  */
		begin_py,
		end_px,
		end_py,

		inhib_px1,	/*  Coord du bouton inhibiteur  */
		inhib_py1,
		inhib_px2,
		inhib_py2,

		excit_px,	/*  Coord du bouton excitateur  */
		excit_py,

		axone_mean,
		axone_sd,
		born_min,
		born_max,
		deconnect;
	char	inter_cluster;
} LINK_PARAMETERS;

typedef struct 
{
	double	x,
		y;
} DB_POINT;

typedef struct
{
	short	*axone_length,
		*synaptic_knobs;
} NEURON_CONNECTIONS;

typedef struct
{
	float	H,
		L,
		AP;
} NEURON_ANATOMY;

typedef struct
{
	int vide;
} LINK_NEURON;

typedef struct
{
	int vide;
} LINK_DRAWING;

