#define _MEMSPY_ 0
#define DEBUG 0
#define DEBUG_LEVIEL 0

/*----------------------------------------------------------------------------
 *	L I N K _ E D I T O R . C
 *
 *      previously called (up to V5)
 *
 *	C L U S T E R _ L I N K . C
 *--------------------------------------------------------------------------*/

/*
*
*	Author: Patrick GLANDAZ
*		Laboratoire de Biomathematiques
*		URBB B3E INSERM U263
*		Faculte de Medecine Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Modifications:
*
*		V1:	Patrick GLANDAZ	Avril-juillet 1992
*				version initiale from scratch
*		V2:	Yann HERRY	Juin 1993
*				Editeur de connex3935ions
*		V2.1:	Denis LAMBOLEZ  Juin-Juillet 1993
*				Correction de bugs
*		V3:	Stephane RIMBAUD	Avril 1995
*				Correction de bugs + neurones ronds + ...
*		V4.0:	Jean-Francois VIBERT	Janvier 1996
*				Compatibilite nbc_x V8
*		V4.1:	Jean-Francois VIBERT    Fevrier 1996
*				Possibilite de deconnexions
*		V4.2:	Jean-Francois VIBERT    Avril 1996
*				XNBC_UID_DIR ajoute pour les uid
*		V4.3:	Jean-Francois VIBERT    Juillet 1996
*				Correction de la path des noms de fichier
*		V4.4:	Jean-Francois VIBERT    Novembre 1996
*				Correction du directory des noms de fichier
*		V4.5:	Jean-Francois VIBERT    Decembre 1996
*				Correction des fichiers .wgt et .len
*		V4.6:	Jean-Francois VIBERT    Fevrier 1997
*				Connexions moyennes en flottant
*               V4.7    Jean-Francois VIBERT    Fevrier 1997
*                               Lecture du project directory dans .nbcrc
*               V4.8    Jean-Francois VIBERT    25 aout 1997
*                               Lecture du nom de lnk filed dans .xnbclnkrc
*               V4.9    Jean-Francois VIBERT    1 sept 1997
*                               Gestion des noms de fichier dans .xnbcrc
*		V4.10	Jean-Francois VIBERT	22 dec 1997
*				OpenHierarchyPerDisplay pour Lesstiff
*		V5.0	Jean-Francois VIBERT	8 jan 1998
*				Ajout de no autoconnections
*				Ajout du help
*				Remplacement de cluster par nucleus
*		V5.1	Jean-Francois VIBERT    28 jan 1998
*				Ajout du manuel html en ligne
*		V5.2	Jean-Francois VIBERT    19 jan 1999
*				Sauvegarde des connexions partielles
*		V5.3	Jean-Francois VIBERT    22 jan 1999
*				Sauvegarde des connexions partielles (suite)
*		V5.4	Jean-Francois VIBERT    23 jan 1999
*				Bouton apply pour les liens
*		V5.5	Jean-Francois VIBERT    22 mar 1999
*				Relecture du fichier de connexion si existe
*               V5.6	Jean-Francois VIBERT    26 avr 1999
*				Problem si 1 seul meuron: pas de connexion possible
*
*		V6.0	Jean-Francois VIBERT    16 juillet 1999
*				Supression de UIL pour pouvoir etre compile avec LessTif
*		V6.1	Jean-Francois VIBERT    21 juillet 1999
*				Correction de bugs sur le sauvetage suite a conversion LessTif
*		V6.2	Jean-Francois VIBERT    6 octobre 1999
*				Nouvel emplacement des binaires
*               V6.3    Jean-Francois VIBERT    11 janvier 2000
*                               Automatic suppresion of links if 
*                               the nb of neurons is changed in a nucleus
*               V6.4    Jean-Francois VIBERT    11 fevrier 2000
*                               Name of the edited file in the window title
*               V6.5    Jean-Francois VIBERT    13 septembre 2001
*                               Adaptation a Windws: lecture de .ntw au lieu de .lnk 
*               V6.6    Jean-Francois VIBERT    15 novembre 2001
*                               Adaptation a Windws: lnk was saved while .ntw was read! (bug) Fixed
*
*	Copyright Dr JF Vibert, July 1992 
*       Licence GPL
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is not, in any way, usable for commercial purpose.
*
*/
#define VERSION	"V6.5"

#ifdef	DOCUMENTATION
title	LINK_EDIT 	A tool to create biologicals neurals networks.

synopsis

	link_edit [-h] [-v] [-k] [filename]

description

	This tool is also accessible from the xnbc menu : Applications->Link Editor.

	This tool is used to create {\em .len}, { \em .wgt}, {\em .anat} and {\em .ntw} files:

	- {\em .len} file contains the connexion matrix lenghts (used by other tools as NBC),

	- {\em .wgt} file contains the connexion matrix weights (used by other tools as NBC),

	- {\em .anat} file contains the network anatomy (not used in this version),

	- {\em .ntw} file contains severals parameters for the link editor itself.

	The program behavior can be modified using the following switches :

	{\tt -h} Help

	{\tt -v} Verbose mode

	{\tt -k} Keep PostScript file (not implemented, for compatibility reasons)

	\centerline{\bf Remark :} 
	In the xnbc version a dialog box prompts you to select another
	display (or to keep the default one) just after activation of 
	the {\bf Applications->Visualisation} menu.

description of the user s interface

	{\bf Menu File} 

	- Save : save all files ({\em .cnx}, {\em .anat}, {\em .ntw}) of the current network.

	- Save As : idem, but you can give another file name.

	- Open : open an existing {\em .ntw} file to modify the network.

	- New : create a new network ({\em noname.ntw} by default).

	- Exit : exit link_edit.

	{\bf Menu Cluster}

	- New : create a new cluster for the current network.

	- Copy : duplicate an existing cluster (same parameters).

	- Delete : delete an existing cluster. 

	- Modify : modify an existing cluster.

	- Swap : swap two existing clusters (in automatic placement only).

	- Move : move an existing cluster (in manual placement only).

	{\bf Menu Link}

	- New : create a new link between two existing clusters or to an
	existing cluster on itself.

	- Delete : delete an existing link. 

	- Modify : modify an existing link.

	{\bf Menu Placement}

	- Automatic : automatic placement of clusters in the window.

	- Manual : manual placement of clusters in the window.

	
	\centerline{{\bf Remarks}}
	1. These two menus are exclusive. A star after the menu indicates which one
	is selected.

	2. Placement in the window doesn t reflect anatomic coordinates of
	the cluster. It s just to allow a good organization of clusters in
	the window. 

	3. In the automatic mode, clusters are placed on a circle in the
	order of their creation. In the manual mode, clusters can be
	manually positionned using the mouse, in a way that reflects the network structure.

	{\bf Menu Help}

	- On Context : 		      Not yet implemented.

	- On Window  : 		      Not yet implemented.

description of a cluster

	A cluster is represented by a square with two buttons and informations.

	{\bf Informations}

	- Horsley-Clarke coordinates of the center of the cluster.

	- IntraClust indicates if the cluster is self-connected. In the case
	of a self-connexion, the sign of the connexion ( - means Inhibitrice
	connexion, + means Exitatrice connexion) is indicated, else there is
	a zero.

	{\bf Buttons}

	- Button with the number of the cluster is used to select the
	cluster for different actions (modify it, swap with an other
	cluster, create link, ect... see bellow).

	- Button with the name of the cluster is used to see or modify
	cluster parameters. This button activates Cluster Parameters dialog
	box (see bellow).


	\centerline{{\bf Remarks}}
	In manual placement mode, to move a
	cluster, click in the cluster, maintain the button, drag the cluster
	to the wanted location then realese the button. The network is
	redrawn.

description of a link

	A link is represented by a line from the first cluster to the
	second. A link is like a nerve.  It contains all axons of first
	cluster neurons.  A symbol indicates which cluster of the twice is
	the reciever. This symbol indicates too the kind of coonexion:

	- A point represent an exitatrice connexion.

	- A bar represent an inhibitrice connexion.

	- A bar plus a point represent an random connexion. Some synapses
	are exitatrices, other are inhibitrices.

description of the Cluster Parameters dialog box

	This box appears with different actions:

	- with a click on the button with the name of the cluster,

	- when select the {\bf Cluster->New} menu,

	- when select the {\bf Cluster->Modify} menu.

	This box allows to enter parameters of a cluster (a new one or an existing one):

	- Name of the cluster: enter a symbolic name in the text field
	(default name is {\bf Name_{\tt number of the cluster}}.

	- Neuron file: select a {\em .unit} file to defined neurons
	parameters. Enter the file name in the text field or click on the
	{\em S} button to choose a file in a file selection box.

	- Number of neurons: enter in the text field the number of neurons
	for the cluster.

	- Anatomic location: Horsley-Clarke coordinates of the cluster. In
	the left column enter location of the center of the cluster, and in
	the right column enter size of the global envelope of the cluster.

	- Anatomic shape: choose the shape of the global envelope of the
	cluster. These choice are exclusive.

	Click on Ok to create or modify the cluster or on Cancel to cancel
	creation or modification.

description of the Link Parameters dialog box

	This box appears with different actions:

	- when select the {\bf Link->New} menu,

	- when select the {\bf Link->Delete} menu.

	- when select the {\bf Link->Modify} menu.

	In each case, after have select the menu, click on the button with
	the number of the first cluster then click on the button with the
	number of the second cluster. First and second cluster can be the
	same in the case of a self-connexion.

	This box allows to enter parameters of a link (a new one or an existing one):

	- Axon length: enter mean value and standard deviation of axons
	length (Gaussian repartition).

	- Synaptic knobs number: reflects the wieght of connexions. Enter
	the minimum and the maximum values (Gaussian repartition).

	- Connexion type: choose the type of connexion: Excitatrice,
	Inhibitrice, Random ( Excitatrice + Inhibitrice with a random
	repartition) or manual. These choice are exclusive.

	In the case of manual connexion type, connexions neuron to neuron
	can be set by clicking on the {\em Details} button (see known bugs).

	Click on Ok to create or modify the Link or on Cancel to cancel
	creation or modification.

how it works

	- Open an existing {em .ntw} file or create a new one.

	- Create a new cluster or modify an existing one.


	\centerline{{\bf Remark}}
	To select a cluster click on the button
	with its number.

	- Set cluster placement: to swap two cluster in automatic mode,
	select {\bf Cluster->Swap} menu then select two clusters. In manual
	placement mode drag cluster to the wanted location.

	- Create a new link or modify an existing one.

	- Save files

known bugs

	Help is available only at the first call, then the list of topics stays silent.
	
authors

	Patrick Glandaz, Yann Herry, Denis Lambolez, Stephane Rimbaud, Jean-Francois Vibert

	CHU Saint-Antoine

	Please reports all remarks to {\em e-mail : vibert@b3e.jussieu.fr}

#endif

#include "le_vms_or_unix.h"
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <dirent.h>

#ifdef	UNIX
#	include <unistd.h>
#endif

/*
 * Motif required Headers
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/StringDefs.h>

#include <Xm/MwmUtil.h>
#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/LabelG.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/DialogS.h>
#include <Xm/Text.h>
#include <Xm/ToggleB.h>
#include <Xm/DrawingA.h>

#if (XmVersion >= 1002)
#   include <Xm/RepType.h>
#endif

#include <Mrm/MrmAppl.h>

#include "find_files.h"

#define MAIN
#include "le_typedefs.h"
#include "cluster_link.h"
#include "le_messbox.h"
#include "dialog_inputs.h"
#include "put_extension.h"
#include "le_strdup.h"
#include "linked_icon.h"
#include "le_alea.h"

#include "le_avl.h"
#include "matrix.h"

#undef	MAIN

/*
 * Common constant and pixmap declarations.
 */
#include "defs-c.h"

#define BX_APP_CLASS ""

/*
 * Convenience functions from utilities file.
 */
extern void RegisterBxConverters(XtAppContext);
extern XtPointer CONVERT(Widget, char *, char *, int, Boolean *);
extern XtPointer DOUBLE(double);
extern XtPointer SINGLE(float);
extern void MENU_POST(Widget, XtPointer, XEvent *, Boolean *);
extern Pixmap XPM_PIXMAP(Widget, char**);
extern void SET_BACKGROUND_COLOR(Widget, ArgList, Cardinal*, Pixel);

#if _MEMSPY_
#include "/u/sa2/boussard/MEMORY/memspy.h"
#endif

void create_file_name(char *full_name,char *name);

/*--- ----------------------------------------------------------*/

ARBRE_AVL     	LIENS 	= NULL;      	/* ARBRE CONTENANT TOUS LES LIENS */
struct NOEUD 	*Find_noeud;		/* NOEUD DE TRAVAIL COURANT       */

	Display	*the_display_le = (Display *)NULL;
static	Window	work_area_window = (Window)NULL;
static	GC	gc_gris,gc_blanc, gc_noir, gc_noir2,gc_vert;

	Widget	toplevel_shell_le = (Widget)NULL;
	Widget   topLevelShell;
	/*
	Widget          openConnect;
	*/

static	Widget	widget_array_le[MAX_WIDGETS_LE];

static	XtIntervalId	expose_interval_id = 0;

	LINK_PARAMETERS	*link_para = (LINK_PARAMETERS *)NULL;
	CLUSTER_WIDGET	*clust_wid = (CLUSTER_WIDGET *)NULL;

	int		nb_clusters_in_array = 0;
	int		max_link_para = 0;
        int             current_cluster;

static	double		rayon_cercle_clusters;

/*--- --------------------------------------------------------*/
static	int		action;
static	int		workArea_width, workArea_height;
static	int		placement_mode = AUTOMATIC;
static	int		cluster_px1, cluster_py1;
static	int		x_root1, y_root1;
static	int		cluster_moved;
static	int		file_named;
static	int		file_modified;
static	int		add_clust_wid = 10;
static	int		max_clust_wid = 0;
static	int		ordre_clust_wid[100];
static	int		cluster_to_swap;
static	int		add_link_para = 10;
static	int		nb_links_in_array = 0;
static	int		new_link_cluster1;
static	int		new_link_cluster2;
static	int		delete_link_cluster1;
static	int		modify_link_cluster1;
static	int		modify_link_cluster2;
static  int	        save_V7 = False;
static	Widget		parent;
static	Widget		le_parent;

static	Pixmap		icon_bitmap;

#if 0
static	MrmHierarchy	hierarchy_le;
static	MrmType		mrmtype_le;

static	char		*uidfiles_vec_le[] =
			{
				"link_editor_v8.uid",
			};
static	int		uidfiles_num_le = (sizeof (uidfiles_vec_le) /
			    sizeof (uidfiles_vec_le[0]) );

static char *uid_file_names[1];       /* Mrm.hierachy dynamic file list. */
static char uid_names[1][256];

static	MrmRegisterArg	registerarg_vec_le[] =
			{
				{"le_create_proc", (XtPointer) le_create_proc},
				{"le_activate_proc", (XtPointer) le_activate_proc},
				{"le_expose_proc", (XtPointer) le_expose_proc}
			};

static	int		registerarg_num_le  = (sizeof (registerarg_vec_le) /
			    sizeof (registerarg_vec_le[0]) );
#endif
/*--- -----------------------------------------------------*/


XtAppContext app_context; /*application context for linked*/
Cursor working_cursor;

unsigned long	black_pixel, white_pixel,grey_pixel,green_pixel;

int	debug,
	keep_ps;


void    redraw_link_paras_CB(XtPointer client_data,XtIntervalId *id);
void	init_directories(void);
void	update_directories(char *);
FILE    *fdbg;

/*----------------------------------------------------------------------------
 *	I N I T _ L I N K _ E D I T O R
 *--------------------------------------------------------------------------*/

int	main (int argc, char *argv[])
/*
int	argc;
char		*argv[];
*/
{	
        FILE    *p_rc;
	Window		root_window;
	Window		wm_window;


	Widget   le_parent;

	Widget   mainW_lew;


	XmString	xm_string1, xm_string2;
	Arg arglist[1], args[256];
	Colormap		color_map;
	XColor 		color, rgb;
	Cardinal     ac;
	int		i, n;
	int		default_screen;
	int     file_given = FALSE;
	char	title[256];
	char	*pt,
	        *home,
		*nbc_V8_help,
		file[256],
		pj[256],
		dir[256],
		char_pointer[256],
	        buffer[256],
		*uid_root;

/*
Initialize the Mrm, the Motif and DEC toolkits, create the application context,
open and initialize the display and create the toplevel shell
*/

	XtToolkitInitialize();
	
#if DEBUG
	for(i=0;i<argc;i++)
		printf("\n%deme argument: <%s>\n",i+1,argv[i]);
#endif

    
	
	le_parent = XtVaAppInitialize ( &app_context, BX_APP_CLASS, NULL, 0, 
#ifndef XlibSpecificationRelease
				     (Cardinal *) &argc, 
#else
#if (XlibSpecificationRelease>=5)
				     &argc, 
#else
				     (Cardinal *) &argc, 
#endif
#endif
				     argv, NULL, 
				     NULL );
    
	RegisterBxConverters(app_context);
#if (XmVersion >= 1002) 
	XmRepTypeInstallTearOffModelConverter();
#endif
    

    /* arguments analysis */

	for (i = 1; i < argc; i++)
	{
		switch(argv[i][0])
		{
			case '-':
				switch(argv[i][1])
				{
					case 'h':
						printf("usage: link_edit [-h] [-v] [-k] [file_in]\n");
						printf("switches:\n");
						printf("\t1) -h to print this.\n");
						printf("\t2) -v for debug mode.\n");
						printf("\t3) -k keep the PostScript file.\n");
						printf("\t4) input_file file (*.ntw): without extension is assumed as *.ntw.\n");
						exit(0);
					case 'v':
						debug = True;
						fdbg = stderr;
						break;
					case 'k':
						keep_ps = True;
						break;
					default:
						printf("\007Illegal switch\n");
						exit(0);
				} /* fin du switch */
			default:
				strcpy(savefile_name,argv[i]);
				file_given = TRUE;
		} /* fin du switch */
	} /* fin du for */
#if DEBUG
	if (file_given)
	  printf("File: %s\n", savefile_name);
#endif

	nbc_V8_help = getenv("XNBC_HELP_DIR");
	if(nbc_V8_help)
	{
		strcpy(help_directory,nbc_V8_help);
		strcat(help_directory,"/link_edit");
	}
	else
	{
		strcpy(help_directory,"/usr/local/bin/xnbc.bin/V8/help");
		fprintf(stderr,"XNBC_HELP_DIR not defined, using %s\n",
			help_directory);
		strcat(help_directory,"/link_edit");
	}

	strcpy(savefile_name,get_lnk_name());
	if (savefile_name)
		file_given = TRUE;
	else
		file_given = FALSE;
#if DEBUG_LEVIEL
	printf("Fin de la lecture de help directory\n");
#endif

	if((the_display_le = XOpenDisplay(NULL)) == NULL)
	{
		printf("FATAL ERROR : Can't open default display for the Link Editor (%s)\n",argv[0]);
		exit(0);
	}

#if DEBUG_LEVIEL
	printf("Display ouvert\n");
#endif

	XtDisplayInitialize(app_context, the_display_le, "Link_Editor",
	                    NULL, NULL, 0, &argc, argv);
	ac = 0;
	XtSetArg(args[ac], XmNx, 130); ac++;
	XtSetArg(args[ac], XmNy, 100); ac++;
	XtSetArg(args[ac], XmNallowShellResize, True);  ac++;
	toplevel_shell_le = XtAppCreateShell("Link_Editor", "Link_Editor",
	    applicationShellWidgetClass, the_display_le, args, ac);

#if DEBUG_LEVIEL
	printf("Display initialise\n");
#endif
	
/*--- Ressources du TopLevelShell ------------------------------------------*/

	default_screen = DefaultScreen (the_display_le);
	root_window = DefaultRootWindow (the_display_le);

	icon_bitmap  = XCreateBitmapFromData (the_display_le, root_window,
	    icon_bits, icon_width, icon_height);
	
#if DEBUG_LEVIEL
	printf("Root window OK\n");
#endif


	for (i = 0; i < MAX_WIDGETS_LE; i++)
	{
		widget_array_le[i] = (Widget)NULL;
	}
	

/*--- Creation des contextes graphiques ------------------------------------*/

#if DEBUG_LEVIEL
	printf("Main window faite\n");
#endif
	
	
	black_pixel = BlackPixel (the_display_le, default_screen);
	white_pixel = WhitePixel (the_display_le, default_screen);
	color_map = DefaultColormapOfScreen(DefaultScreenOfDisplay(the_display_le));
	XAllocNamedColor(the_display_le, color_map, "gainsboro", &color, &rgb);
      	grey_pixel = color.pixel;
	
	XAllocNamedColor(the_display_le, color_map, "aquamarine", &color, &rgb);
      	green_pixel = color.pixel;

#if DEBUG_LEVIEL
	printf("Allocation des couleurs OK\n");
#endif

	gc_blanc = XCreateGC (the_display_le, root_window, 0, NULL);
	XSetForeground (the_display_le, gc_blanc, white_pixel);
	XSetBackground (the_display_le, gc_blanc, black_pixel);

	gc_noir = XCreateGC (the_display_le, root_window, 0, NULL);
	XSetForeground (the_display_le, gc_noir, black_pixel);
	XSetBackground (the_display_le, gc_noir, white_pixel);
	XSetLineAttributes(the_display_le,gc_noir,2,LineSolid,
		CapRound,JoinRound);

	gc_gris = XCreateGC (the_display_le, root_window, 0, NULL);
	XSetForeground (the_display_le, gc_gris, grey_pixel);
	XSetBackground (the_display_le, gc_gris, white_pixel);
	
	gc_vert = XCreateGC (the_display_le, root_window, 0, NULL);
	XSetForeground (the_display_le, gc_vert, green_pixel);
	XSetBackground (the_display_le, gc_vert, white_pixel);
	
	gc_noir2 = XCreateGC (the_display_le, root_window, 0, NULL);
	XSetForeground (the_display_le, gc_noir2, black_pixel);
	XSetBackground (the_display_le, gc_noir2, white_pixel);
	XSetLineAttributes (the_display_le, gc_noir2, 2, LineSolid,
	    CapButt, JoinRound);

#if DEBUG_LEVIEL
	printf("Graphic contexts OK\n");
#endif
/*--- Allocation des tableaux ----------------------------------------------*/

	clust_wid = (CLUSTER_WIDGET *) XtCalloc (add_clust_wid + 1,
	    sizeof (CLUSTER_WIDGET));
	max_clust_wid += add_clust_wid;
	nb_clusters_in_array = 0;

	link_para = (LINK_PARAMETERS *) XtCalloc (add_link_para + 1,
	    sizeof (LINK_PARAMETERS));
	max_link_para += add_link_para;
	nb_links_in_array = 0;
	
	file_named = FALSE;
	file_modified = FALSE;

#if DEBUG_LEVIEL
	printf("Allocation des tableaux OK\n");
#endif

    /* Begin user code block <create_topLevelShell> */
    /* End user code block <create_topLevelShell> */
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 130); ac++;
    XtSetArg(args[ac], XmNy, 100); ac++;
    XtSetArg(args[ac], XmNwidth, 700); ac++;
    XtSetArg(args[ac], XmNheight, 500); ac++;
    topLevelShell = XtCreatePopupShell("topLevelShell",
        topLevelShellWidgetClass,
        toplevel_shell_le,
        args, 
        ac);
    mainW_lew = (Widget)CreatemainW_lew(toplevel_shell_le/*topLevelShell*/);
    widget_array_le[k_MainW_lew] = mainW_lew;
    XtManageChild(mainW_lew);
    XtPopup(XtParent(mainW_lew), XtGrabNone);
    
/*--- Initialisations ------------------------------------------------------*/

	action = NO_ACTION;

	init_dialog_inputs (topLevelShell);
	/*
	init_dialog_inputs (parent);
	*/
	if (!XtIsManaged (widget_array_le[k_MainW_lew]))
	{
		XtManageChild (widget_array_le[k_MainW_lew]);
	}

	XtRealizeWidget (toplevel_shell_le);

	work_area_window = XtWindow (widget_array_le[k_DrawingA_Work_Area_lew]);

	parent = widget_array_le[k_MainW_lew];
	parent = topLevelShell;

#if DEBUG_LEVIEL
	printf("Initialisations et realization OK\n");
#endif
/*--- Valeur par defaut du mode de placement -------------------------------*/

	set_placement_mode ("AUTOMATIC_MODE");
	
	working_cursor = XCreateFontCursor(the_display_le,150);
	/* 150 c'est l'id du curseur "montre" */

	strcpy(current_directory,get_dir_name());
	strcpy(project_directory,get_project_name());
#if DEBUG_LEVIEL
	printf("main1: current directory: %s\n",current_directory);
#endif

	if (!file_given)
	{
	  pt = strrchr(savefile_name,'/');

	  if (pt)
	  {
	    ++pt;
	    strcpy(savefile_name,pt);
	  }

	  init_directories();
	  update_directories(savefile_name);
	}	

	if(!*savefile_name)
	{
		sprintf(title,"XNBC Link Editor %s: noname",VERSION);
		strcat(project_directory,"/noname");
#if DEBUG_LEVIEL
		printf("window title: %s\n",title);
		printf("project directory: %s\n",project_directory);
#endif
	    		XtVaSetValues (toplevel_shell_le,
	    		XtNtitle, title,
	    		XtNiconPixmap, icon_bitmap,
	    		XtNiconName, "XNBC Link Editor",
	    		NULL);
		XtVaSetValues(widget_array_le[k_PushBG_Save_lew],
			XmNsensitive,False,NULL);
	}
	else
	{
		XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
			working_cursor);

		XtVaSetValues (topLevelShell,
	    		XtNiconPixmap, icon_bitmap,
	    		XtNiconName, "XNBC Link Editor",
	    		NULL);
#if DEBUG
		printf("Link_edit2:\tFile name: %s\n",
		       savefile_name);
#endif
		sprintf(title,"XNBC Link Editor %s: %s",VERSION,savefile_name);

		read_save_file (savefile_name);

		XtVaSetValues (toplevel_shell_le,
			       XtNtitle, title,
			       XtNiconPixmap, icon_bitmap,
			       XtNiconName, "XNBC Link Editor",
			       NULL);

	    
		XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
			0);
	}
#if DEBUG_LEVIEL
       	printf("current directory: %s\n",current_directory);
       	printf("project directory: %s\n",project_directory);
#endif
#if DEBUG_LEVIEL
	printf("Fin du tt du nom de fichier %s\n",savefile_name);
#endif

	XSetWindowBackground(the_display_le,XtWindow(widget_array_le[k_DrawingA_Work_Area_lew]),
		white_pixel);

#if DEBUG_LEVIEL
	printf("Background OK\n");
#endif

	XClearWindow(the_display_le,XtWindow(widget_array_le[k_DrawingA_Work_Area_lew]));

#if DEBUG_LEVIEL
	printf("Clear window OK\n");
#endif

#if DEBUG
	printf("Link_edit1:\tCurrent directory: %s\n\t\tProject directory: %s\n\t\tFile name: %s\n",
	       current_directory,
	       project_directory,
	       savefile_name);
#endif

	XtAppMainLoop (app_context);
}

/*----------------------------------------------------------------------------
 *	E X I T _ L I N K _ E D I T O R
 *--------------------------------------------------------------------------*/

void	exit_link_editor ()
{
	int i,j;

	if (widget_array_le[k_MainW_lew])
	{
		XtUnmanageChild (widget_array_le[k_MainW_lew]);
		XtDestroyWidget (widget_array_le[k_MainW_lew]);
	} /* fin du if */
	widget_array_le[k_MainW_lew] = (Widget) NULL;

	XtDestroyWidget (toplevel_shell_le);
	toplevel_shell_le = (Widget) NULL;

	work_area_window = (Window) NULL;
	
	if(LIENS)
	{
		clear_avl(&LIENS); 
		LIENS = NULL;
	}
	
	for(i=0; i<nb_clusters_in_array ; i++)
	{
		if(clust_wid[ordre_clust_wid[i]].neuron_file)
			free(clust_wid[ordre_clust_wid[i]].neuron_file);	
	}
	if (clust_wid)
		XtFree ((char *)clust_wid);
	max_clust_wid = 0;

	if (link_para)
		XtFree ((char *)link_para);
	max_link_para = 0;

	if (expose_interval_id)
	{
		XtRemoveTimeOut (expose_interval_id);
	}

	exit_dialog_inputs ();
	
	XFreeGC(the_display_le,gc_noir);
	XFreeGC(the_display_le,gc_noir2);
	XFreeGC(the_display_le,gc_gris);
	XFreeGC(the_display_le,gc_blanc);
	XFreeGC(the_display_le,gc_vert);
	
#if _MEMSPY_
	memspy_scan();
	memspy_status();
#endif

	display_help(-1);
	
	exit (0);

}

/*----------------------------------------------------------------------------
 *	L E _ C R E A T E _ P R O C
 *--------------------------------------------------------------------------*/
 
void le_create_proc (Widget w, XtPointer tag, XtPointer reason)
/*
Widget	w;
int	*tag;
unsigned long	*reason;
*/
{
	int	widget_num = (int)tag;
	widget_array_le[widget_num] = w;
} 

/*----------------------------------------------------------------------------
 *	L E _ A C T I V A T E _ P R O C
 *--------------------------------------------------------------------------*/

void le_activate_proc (Widget w, XtPointer tag, XtPointer reason)
/*
Widget	w;
int	*tag;
unsigned long	*reason;
*/
{
	int	widget_num = (int)tag;
	static	int	new_cluster;
	char title[256];

	switch (widget_num)
	{
		case k_PushBG_SaveAs_lew:
			action = NO_ACTION;
			save_as_file ();
			sprintf(title,"XNBC Link Editor %s: %s",VERSION,savefile_name);
			XtVaSetValues (toplevel_shell_le,
				       XtNtitle, title,
				       NULL);
			break;
		case k_PushBG_Save_lew:
			action = NO_ACTION;
			/*save_file ();*/
			break;
		case k_PushBG_New_lew:
			action = NO_ACTION;
			confirm_save_file (parent);
			XFillRectangle (the_display_le,
	    		XtWindow (widget_array_le[k_DrawingA_Work_Area_lew]),
	    		gc_blanc, 0, 0,
	    		workArea_width, workArea_height);
			new_file ();
			if(LIENS)
			{
				clear_avl(&LIENS); 
				LIENS = NULL;
			}
			break;
		case k_PushBG_Open_lew:
			action = NO_ACTION;
			confirm_save_file (parent);
			XFillRectangle (the_display_le,
	    		XtWindow (widget_array_le[k_DrawingA_Work_Area_lew]),
	    		gc_blanc, 0, 0,
	    		workArea_width, workArea_height);
			open_file ();
			break;
		case k_PushBG_Exit_lew:
			action = NO_ACTION;
			confirm_save_file (parent);
			if(LIENS)
			{
				clear_avl(&LIENS); 
				LIENS = NULL;
			}
			exit_link_editor ();
			break;
			
		case k_PushBG_CopyCl_lew:
			action = COPY_CLUSTER_ACTION;
			break;
		case k_PushBG_NewCl_lew:
			action = NO_ACTION;
			new_clust_wid ();
			XFillRectangle (the_display_le,
	    		XtWindow (widget_array_le[k_DrawingA_Work_Area_lew]),
	    		gc_blanc, 0, 0,
	    		workArea_width, workArea_height);
			replace_clust_wids ();
			break;
		case k_PushBG_DeleteCl_lew:
			action = DELETE_CLUSTER_ACTION;
			break;
		case k_PushBG_ModifyCl_lew:
			action = MODIFY_CLUSTER_ACTION;
			break;
		case k_PushBG_SwapCl_lew:
			action = SWAP_CLUSTER_ACTION1;
			break;
		case k_PushBG_MoveCl_lew:
			action = MOVE_CLUSTER_ACTION1;
			break;
			
		case k_PushBG_NewLi_lew:
			action = NEW_LINK_ACTION1;
			break;
		case k_PushBG_DeleteLi_lew:
			action = DELETE_LINK_ACTION1;
			break;
		case k_PushBG_ModifyLi_lew:
			action = MODIFY_LINK_ACTION1;
			break;
			
		case k_PushBG_Automatic_lew:
			XFillRectangle (the_display_le,
	    		XtWindow (widget_array_le[k_DrawingA_Work_Area_lew]),
	    		gc_blanc, 0, 0,
	    		workArea_width, workArea_height);
			if(XmToggleButtonGetState(widget_array_le[k_PushBG_Automatic_lew]))
				set_placement_mode ("AUTOMATIC_MODE");
			break;
		case k_PushBG_Manual_lew:
			XFillRectangle (the_display_le,
	    		XtWindow (widget_array_le[k_DrawingA_Work_Area_lew]),
	    		gc_blanc, 0, 0,
	    		workArea_width, workArea_height);
			if(XmToggleButtonGetState(widget_array_le[k_PushBG_Manual_lew]))
				set_placement_mode ("MANUAL_MODE");
			break;

		case k_PushBG_CreateBOTH_lew:
			create_both_files ();
			break;
		case k_PushBG_CreateCNX_lew:
			create_cnx_file((char *)NULL);
			break;	
		
		case k_PushBG_CreateANAT_lew:
			create_anat_file ((char *)NULL);
			break;
		
		case k_PushBG_OnContext_lew:
			Createhelp_form(w);
			action = NO_ACTION;
			break;
			
		case k_PushBG_OnWindow_lew:
			browse_manual(XNBC_LINK_EDIT);
			action = NO_ACTION;
			break;

		default:
			printf ("Appel de le_activate_proc avec un argument non-valide.\n");
			break;
	} /* fin du switch */
}

/*----------------------------------------------------------------------------
 *	L E _ E X P O S E _ P R O C
 *--------------------------------------------------------------------------*/

void le_expose_proc (Widget w, XtPointer tag, XtPointer reason)
/*
Widget	w;
int	*tag;

*/
{
	int	widget_num = (int)tag;
	int i,j;


	switch (widget_num)
	{
		case k_DrawingA_Work_Area_lew:
		
			for (i = 1; i <= nb_clusters_in_array; i++)
			{
			j = ordre_clust_wid[i];
			
			
			if (XtIsManaged (clust_wid[j].form))
			{
				
				if(clust_wid[j].nb_neurons==1)
				{
					
					XDrawArc(the_display_le,XtWindow(clust_wid[j].form),
						gc_noir,1,1,CLUSTER_FORM_WIDTH-2,CLUSTER_FORM_HEIGHT-2,
						0*64,360*64);
					XFillArc(the_display_le,XtWindow(clust_wid[j].form),
						gc_gris,2,2,CLUSTER_FORM_WIDTH-4,CLUSTER_FORM_HEIGHT-4,
						0*64,360*64);
					XtVaSetValues(clust_wid[j].position,XmNbackground,
						grey_pixel,NULL);
							
				}
				else
				{
					XDrawRectangle(the_display_le,XtWindow(clust_wid[j].form),
						gc_noir,1,1,CLUSTER_FORM_WIDTH-2,CLUSTER_FORM_HEIGHT-2);
					XFillRectangle(	the_display_le,XtWindow(clust_wid[j].form),
						gc_vert,2,2,CLUSTER_FORM_WIDTH-4,CLUSTER_FORM_HEIGHT-4);
				   	XtVaSetValues(clust_wid[j].position,XmNbackground,
						green_pixel,NULL);
						
				}	
			}
			}
			if (action == MOVE_CLUSTER_ACTION2)
			{
				return;
			}
		
			if (expose_interval_id)
			{
				XtRemoveTimeOut (expose_interval_id);
			}
			expose_interval_id = XtAppAddTimeOut (app_context, 1, 
				(XtTimerCallbackProc)redraw_link_paras_CB, NULL);
			break;
		default :
			printf ("Appel de expose_proc avec un argument non_valide.\n");
			break;
	}
}

/****************************************************************************
 *									    *
 *	G E S T I O N   D E S   C L U S T E R S				    *
 *									    *
 ****************************************************************************/

/*----------------------------------------------------------------------------
 *	N E W _ C L U S T _ W I D
 *--------------------------------------------------------------------------*/

void	new_clust_wid ()
{
	CLUSTER_WIDGET	*struct_cluster_link;
	int		no_cluster;
	XmString	xm_string;
	char		char_buffer[256];

	struct_cluster_link = display_inputcluster ((CLUSTER_WIDGET *)NULL);

	if (struct_cluster_link)
	{
		no_cluster = alloc_new_clust_wid ();
		
		strcpy (clust_wid[no_cluster].ch_name, struct_cluster_link->ch_name);
		clust_wid[no_cluster].neuron_file = struct_cluster_link->neuron_file;
		
		clust_wid[no_cluster].nb_neurons = struct_cluster_link->nb_neurons;
		clust_wid[no_cluster].position_H = struct_cluster_link->position_H;
		clust_wid[no_cluster].position_L = struct_cluster_link->position_L;
		clust_wid[no_cluster].position_AP = struct_cluster_link->position_AP;
		clust_wid[no_cluster].delta_H = struct_cluster_link->delta_H;
		clust_wid[no_cluster].delta_L = struct_cluster_link->delta_L;
		clust_wid[no_cluster].delta_AP = struct_cluster_link->delta_AP;
		clust_wid[no_cluster].shape = struct_cluster_link->shape;
		clust_wid[no_cluster].no_auto = struct_cluster_link->no_auto;
		
		decorate_clust_wid (no_cluster);
		file_modified = TRUE;
	}
	current_cluster = no_cluster;
}

/*----------------------------------------------------------------------------
 *	C O P Y _ C L U S T _ W I D
 *--------------------------------------------------------------------------*/

void	copy_clust_wid (no_cluster)
int	no_cluster;
{
	char	char_buffer[256];
	char	*name;
	int	new_cluster, new_link, no_link;
	int	i, error;

	action = NO_ACTION;

	do
	{
		error = FALSE;
		name = display_prompt (parent,
		    "Input a new name :", clust_wid[no_cluster].ch_name);
		if (name == (char *) NULL) return;

		sprintf (char_buffer, "%.10s", name); /* Tronque */
		strcpy (name, char_buffer);
		for (i = 0; i <= 10; i++)	/* Vire les blancs */
		{
			if (name[i] == ' ') name[i] = '\0';
		}

		if (search_clust_wid (name))
		{
			sprintf (char_buffer,
			    "The name %s\nis already used. Input another one.",
			    name);
			display_error (parent, char_buffer);
			error = TRUE;
		}
	} while (error);

	new_cluster = alloc_new_clust_wid ();

	strcpy (clust_wid[new_cluster].ch_name, name);
	clust_wid[new_cluster].nb_neurons =
	    clust_wid[no_cluster].nb_neurons;
	clust_wid[new_cluster].position_H =
	    clust_wid[no_cluster].position_H;
	clust_wid[new_cluster].position_L =
	    clust_wid[no_cluster].position_L;
	clust_wid[new_cluster].position_AP =
	    clust_wid[no_cluster].position_AP;
	clust_wid[new_cluster].delta_H =
	    clust_wid[no_cluster].delta_H;
	clust_wid[new_cluster].delta_L =
	    clust_wid[no_cluster].delta_L;
	clust_wid[new_cluster].delta_AP =
	    clust_wid[no_cluster].delta_AP;
	clust_wid[new_cluster].shape =
	    clust_wid[no_cluster].shape;
	clust_wid[new_cluster].no_auto =
	    clust_wid[no_cluster].no_auto;
	clust_wid[new_cluster].neuron_file =
	    str_dup (clust_wid[no_cluster].neuron_file);

	if (no_link = search_link_para (no_cluster, no_cluster))
	{
		new_link = alloc_new_link_para (new_cluster, new_cluster);
		link_para[new_link].axone_mean = link_para[no_link].axone_mean;
		link_para[new_link].axone_sd = link_para[no_link].axone_sd;
		link_para[new_link].born_min = link_para[no_link].born_min;
		link_para[new_link].born_max = link_para[no_link].born_max;
		link_para[new_link].K_connections = link_para[no_link].K_connections;
		link_para[new_link].deconnect = link_para[no_link].deconnect;
		link_para[new_link].inter_cluster = link_para[no_link].inter_cluster;
	}

	action = NO_ACTION;
	
	decorate_clust_wid (new_cluster);
	file_modified = TRUE;
}

/*----------------------------------------------------------------------------
 *	D E L E T E _ C L U S T _ W I D
 *--------------------------------------------------------------------------*/

void	delete_clust_wid (no_clust)
int	no_clust;
{
	int	i, yes_or_no;
	int	found = FALSE;
	char	char_buffer[100];

	action = NO_ACTION;

/*--- Demande confirmation -------------------------------------------------*/

	sprintf (char_buffer,
	    "Do you really want to destroy\nthe cluster %s ?",
	    clust_wid[no_clust].ch_name);

	yes_or_no = display_question (parent, char_buffer);
	if (yes_or_no == YES_ANSWER)
	{

/*--- Detruit le cluster ---------------------------------------------------*/
	
		XtDestroyWidget (clust_wid[no_clust].form);

		clust_wid[no_clust].form = (Widget) NULL;
		clust_wid[no_clust].no = (Widget) NULL;
		clust_wid[no_clust].name = (Widget) NULL;
		clust_wid[no_clust].position = (Widget) NULL;

		free (clust_wid[no_clust].neuron_file);
		clust_wid[no_clust].neuron_file = (char *)NULL;

/*--- Decale tout le tableau donnant l'ordre d'affichage -------------------*/

		for (i = 1; i < nb_clusters_in_array; i++)
		{
			if (!found && ordre_clust_wid[i] == no_clust)
			{
				found = TRUE;
			}
			if (found)
			{
				ordre_clust_wid[i] = ordre_clust_wid[i+1];
			}
		}

		ordre_clust_wid[nb_clusters_in_array] = 0;
		nb_clusters_in_array--;

/*--- Detruit les liaisons reliees a ce cluster ----------------------------*/

		for (i = 1; i <= max_link_para; i++)
		{
			if (link_para[i].cluster1 == no_clust ||
			    link_para[i].cluster2 == no_clust)
			{
				sup_avl(link_para[i].cluster1,link_para[i].cluster2);
				link_para[i].cluster1 = 0;
				link_para[i].cluster2 = 0;
				nb_links_in_array--;
			}
		}

		file_modified = TRUE;
	}
}

/*----------------------------------------------------------------------------
 *	M O D I F Y _ C L U S T _ W I D
 *--------------------------------------------------------------------------*/

void	modify_clust_wid (no_cluster)
int	no_cluster;
{
	CLUSTER_WIDGET	*struct_cluster_link;

	struct_cluster_link = display_inputcluster (&(clust_wid[no_cluster]) );

	if (struct_cluster_link)
	{
		strcpy (clust_wid[no_cluster].ch_name, struct_cluster_link->ch_name);
		clust_wid[no_cluster].neuron_file = struct_cluster_link->neuron_file;
		
		clust_wid[no_cluster].nb_neurons = struct_cluster_link->nb_neurons;
		clust_wid[no_cluster].position_H = struct_cluster_link->position_H;
		clust_wid[no_cluster].position_L = struct_cluster_link->position_L;
		clust_wid[no_cluster].position_AP = struct_cluster_link->position_AP;
		clust_wid[no_cluster].delta_H = struct_cluster_link->delta_H;
		clust_wid[no_cluster].delta_L = struct_cluster_link->delta_L;
		clust_wid[no_cluster].delta_AP = struct_cluster_link->delta_AP;
		clust_wid[no_cluster].shape = struct_cluster_link->shape;
		clust_wid[no_cluster].no_auto = struct_cluster_link->no_auto;
		
		decorate_clust_wid (no_cluster);
		XFillRectangle(	the_display_le,XtWindow(clust_wid[no_cluster].form),
						gc_blanc,0,0,CLUSTER_FORM_WIDTH,CLUSTER_FORM_HEIGHT);
		file_modified = TRUE;
	}
	current_cluster = no_cluster;
}

/*----------------------------------------------------------------------------
 *	S W A P _ C L U S T _ W I D
 *--------------------------------------------------------------------------*/

void	swap_clust_wid (clust1, clust2)
int	clust1, clust2;
{
	int		i;
	int		ordre_clust1, ordre_clust2;

	action = NO_ACTION;

	if (clust1 == clust2) return;

	for (i = 1; i <= nb_clusters_in_array; i++)
	{
		if (ordre_clust_wid[i] == clust1)
		{
			ordre_clust1 = i;
		}
		else if (ordre_clust_wid[i] == clust2)
		{
			ordre_clust2 = i;
		}
	}

	ordre_clust_wid[ordre_clust1] = clust2;
	ordre_clust_wid[ordre_clust2] = clust1;

	file_modified = TRUE;
}

/*----------------------------------------------------------------------------
 *	A L L O C _ N E W _ C L U S T _ W I D
 *--------------------------------------------------------------------------*/

int	alloc_new_clust_wid ()
{
	int		i;
	char		char_buffer[50];
	XmString	buffer_xmstring;
	int		no_cluster = 0;
	char		found = FALSE;

/*=== Recherche d'une structure CLUSTER_WIDGET libre =======================*/
	
	while (!found && no_cluster < max_clust_wid)
	{
		no_cluster++;
		if (clust_wid[no_cluster].form == (Widget) NULL)
		{
			nb_clusters_in_array++;
			found = TRUE;
		}
	}

	if (!found)
	{
		clust_wid = (CLUSTER_WIDGET *) XtRealloc ((char *)clust_wid,
			(max_clust_wid + add_clust_wid + 1) *
			sizeof (CLUSTER_WIDGET));
			
		for (i = 1; i <= add_clust_wid; i++)
		{
			clust_wid[max_clust_wid + i].form = (Widget) NULL;
			clust_wid[max_clust_wid + i].no = (Widget) NULL;
			clust_wid[max_clust_wid + i].name = (Widget) NULL;
			clust_wid[max_clust_wid + i].position = (Widget) NULL;
		}

		no_cluster = max_clust_wid + 1;
		max_clust_wid += add_clust_wid;
		nb_clusters_in_array++;
		
	}

	ordre_clust_wid[nb_clusters_in_array] = no_cluster;

/*=== Remplissage des champs de cette structure ============================*/

/*--- Cluster Form ---------------------------------------------------------*/

	sprintf (char_buffer, "cluster_form_%d", no_cluster);

	clust_wid[no_cluster].form = 
	    XtVaCreateWidget (char_buffer,
	    xmDrawingAreaWidgetClass, widget_array_le[k_DrawingA_Work_Area_lew],
	    XmNwidth, CLUSTER_FORM_WIDTH,
	    XmNheight, CLUSTER_FORM_HEIGHT,
	    XmNborderWidth, 0,
	    XmNrecomputeSize, False,
	    NULL);


	
	

/*--- Cluster Numero -------------------------------------------------------*/

	sprintf (char_buffer, "cluster_no_%d", no_cluster);

	clust_wid[no_cluster].no =
	    XtVaCreateManagedWidget (char_buffer,
	    xmPushButtonWidgetClass, clust_wid[no_cluster].form,
	    XmNx, 7*CLUSTER_OFFSET,
	    XmNy, 19*CLUSTER_OFFSET,
	    XmNborderWidth, 0,
	    XmNwidth, 35,
	    XmNheight,35,
	    XmNrecomputeSize, False,
	    NULL);

	XtAddCallback (clust_wid[no_cluster].no,
	    XmNactivateCallback, activate_no_proc, 
	    (XtPointer)(unsigned long)no_cluster);

/*--- Cluster Name ---------------------------------------------------------*/

	sprintf (char_buffer, "cluster_name_%d", no_cluster);

	clust_wid[no_cluster].name =
	    XtVaCreateManagedWidget (char_buffer,
	    xmPushButtonWidgetClass, clust_wid[no_cluster].form,
	    XmNx,11*CLUSTER_OFFSET+35,   
	    XmNy, 19*CLUSTER_OFFSET,
	    XmNborderWidth, 0,
	    XmNwidth,80,
	    XmNheight,35,
	    XmNrecomputeSize, False,
	    NULL);

	XtAddCallback (clust_wid[no_cluster].name,
	    XmNactivateCallback, activate_name_proc, 
	    (XtPointer)(unsigned long)no_cluster);

/*--- Cluster Position -----------------------------------------------------*/

	sprintf (char_buffer, "cluster_position_%d", no_cluster);

	/* Ne pas enlever cette initialisation de XmNlabelString :elle
	   determine la hauteur du LabelGadget, qui ne se resize pas */

	buffer_xmstring = XmStringCreateLtoR (
	    "\nIntraLink = ?",
	    XmSTRING_DEFAULT_CHARSET);

	clust_wid[no_cluster].position =
	    XtVaCreateManagedWidget (char_buffer,
	    xmLabelWidgetClass, clust_wid[no_cluster].form,
	    XmNlabelString, buffer_xmstring,
	    XmNx, 10*CLUSTER_OFFSET,
	    XmNy, 21*CLUSTER_OFFSET+35,
	    XmNborderWidth, 0,
	    XmNrecomputeSize, False,
	    NULL);

	XmStringFree (buffer_xmstring);

	XtAddEventHandler (clust_wid[no_cluster].form,
	    ButtonPressMask, FALSE, press_button_proc, 
	    (XtPointer)(unsigned long)no_cluster);

	XtAddEventHandler (clust_wid[no_cluster].form,
	    ButtonMotionMask, FALSE, move_button_proc, 
	    (XtPointer)(unsigned long)no_cluster);

	XtAddEventHandler (clust_wid[no_cluster].form,
	    ButtonReleaseMask, FALSE, release_button_proc, 
	    (XtPointer)(unsigned long)no_cluster);
	
	XtAddEventHandler (clust_wid[no_cluster].position,
	    ButtonPressMask, FALSE, press_button_proc, 
	    (XtPointer)(unsigned long)no_cluster);

	XtAddEventHandler (clust_wid[no_cluster].position,
	    ButtonMotionMask, FALSE, move_button_proc, 
	    (XtPointer)(unsigned long)no_cluster);

	XtAddEventHandler (clust_wid[no_cluster].position,
	    ButtonReleaseMask, FALSE, release_button_proc, 
	    (XtPointer)(unsigned long)no_cluster);

	clust_wid[no_cluster].numero = no_cluster;
	clust_wid[no_cluster].neuron_file = (char *)NULL;
	clust_wid[no_cluster].px = 0;
	clust_wid[no_cluster].py = 0;
	clust_wid[no_cluster].px_manual = 0;
	clust_wid[no_cluster].py_manual = 0;
	clust_wid[no_cluster].yet_placed = FALSE;
	clust_wid[no_cluster].no_auto = TRUE;
	
	current_cluster = no_cluster;

	return no_cluster;
}

/*----------------------------------------------------------------------------
 *	S E A R C H _ C L U S T _ W I D
 *--------------------------------------------------------------------------*/

int	search_clust_wid (cluster_name)
char	*cluster_name;
{
	int	i;

	for (i = 1; i <= nb_clusters_in_array; i++)
	{
		if (!strcmp (cluster_name,
		    clust_wid[ordre_clust_wid[i]].ch_name))
		{
			return ordre_clust_wid[i];
		}
	}
	return 0;
}

/*----------------------------------------------------------------------------
 *	G E T _ N B _ N E U R O N S
 *--------------------------------------------------------------------------*/

int	get_nb_neurons (int numero)
{
	int	i;


	for (i = 1; i <= nb_clusters_in_array; i++)
	{
		if (clust_wid[ordre_clust_wid[i]].numero == numero)
		{
			return clust_wid[numero].nb_neurons;
		}
	}
	return 0;
}

/*----------------------------------------------------------------------------
 *	D E C O R A T E _ C L U S T _ W I D
 *--------------------------------------------------------------------------*/

void	decorate_clust_wid (no_clust)
int	no_clust;
{
	char		char_buffer[256];
	XmString	xm_string;
	int		no_link;
	char		interclust = '0';

	sprintf (char_buffer, "%d", no_clust);
	xm_string = XmStringCreateSimple (char_buffer);
	XtVaSetValues (clust_wid[no_clust].no,
	    XmNlabelString, xm_string,
	    NULL);
	XmStringFree (xm_string);

	xm_string = XmStringCreateSimple (clust_wid[no_clust].ch_name);
	XtVaSetValues (clust_wid[no_clust].name,
	    XmNlabelString, xm_string,
	    NULL);
	XmStringFree (xm_string);

	if (no_link = search_link_para (no_clust, no_clust))
	{
		interclust = link_para[no_link].inter_cluster;
	}

	if(clust_wid[no_clust].nb_neurons==1)
	{
	sprintf (char_buffer, "IntraLink = %c\n%s",
	    interclust, ((clust_wid[no_clust].no_auto)?"No Autocnx.":"Autocnx"));
	xm_string = XmStringCreateLtoR (char_buffer,
	    XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues (clust_wid[no_clust].position,
	    XmNlabelString, xm_string,
	    XmNheight, 40,
	    NULL);
	}
	else
	{
	sprintf (char_buffer, "%d Neurons\nIntraLink = %c\n%s",
	    clust_wid[no_clust].nb_neurons,interclust,
	    ((clust_wid[no_clust].no_auto)?"No Autocnx.":"Autocnx"));
	xm_string = XmStringCreateLtoR (char_buffer,
	    XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues (clust_wid[no_clust].position,
	    XmNlabelString, xm_string,
	    XmNheight, 60,
	    NULL);
	}
	XmStringFree (xm_string);
}

/*----------------------------------------------------------------------------
 *	R E P L A C E _ C L U S T _ W I D S
 *--------------------------------------------------------------------------*/

void	replace_clust_wids ()
{
	int	i, j;
	int	px, py, px_max, py_max;

	double	rayon_clust_wid;
	double	angle_clusters;
	double	sin_angle_2;

/*=== Cas particulier du placement manuel ==================================*/

	if (placement_mode == MANUAL)
	{
		px = 10; py = 10;
		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			j = ordre_clust_wid[i];
			if (!clust_wid[j].yet_placed)
			{
				clust_wid[j].px = px;
				clust_wid[j].py = py;
				px += 40;
			}
			else
			{
				clust_wid[j].px = clust_wid[j].px_manual;
				clust_wid[j].py = clust_wid[j].py_manual;
			}
			clust_wid[j].center_px = clust_wid[j].px + CLUSTER_FORM_WIDTH / 2;
			clust_wid[j].center_py = clust_wid[j].py + CLUSTER_FORM_HEIGHT / 2;
		}
	
		px_max = 0; py_max = 0;
		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			j = ordre_clust_wid[i];
			if (clust_wid[j].px > px_max) px_max = clust_wid[j].px;
			if (clust_wid[j].py > py_max) py_max = clust_wid[j].py;
		}

		workArea_width  = px_max + 2 * CLUSTER_FORM_WIDTH;
		workArea_height = py_max + 2 * CLUSTER_FORM_HEIGHT;
		XtVaSetValues (widget_array_le[k_DrawingA_Work_Area_lew],
		    XmNwidth, (Dimension) workArea_width,
		    XmNheight, (Dimension) workArea_height,
		    NULL);

		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			j = ordre_clust_wid[i];
			XtVaSetValues (clust_wid[j].form,
			    XmNx, (Position) clust_wid[j].px,
			    XmNy, (Position) clust_wid[j].py,
			    NULL);
			
			if (!XtIsManaged (clust_wid[j].form))
			{
				XtManageChild (clust_wid[j].form);
				XSetWindowBackground(the_display_le,XtWindow(clust_wid[j].form ),
					white_pixel);
				XtVaSetValues(clust_wid[j].no,XmNbackground,white_pixel,NULL);
				XtVaSetValues(clust_wid[j].name,XmNbackground,white_pixel,NULL);
				XClearWindow(the_display_le,XtWindow(clust_wid[j].form ));
				XClearWindow(the_display_le,XtWindow(clust_wid[j].no));
				XClearWindow(the_display_le,XtWindow(clust_wid[j].name));		
				if(clust_wid[j].nb_neurons==1)
				{
					
					XDrawArc(the_display_le,XtWindow(clust_wid[j].form),
						gc_noir,1,1,CLUSTER_FORM_WIDTH-2,CLUSTER_FORM_HEIGHT-2,
						0*64,360*64);
						
					XFillArc(the_display_le,XtWindow(clust_wid[j].form),
						gc_gris,2,2,CLUSTER_FORM_WIDTH-4,CLUSTER_FORM_HEIGHT-4,
						0*64,360*64);
					XtVaSetValues(clust_wid[j].position,XmNbackground,
						grey_pixel,NULL);
					XClearWindow(the_display_le,XtWindow(clust_wid[j].position));	
				}
				else
				{
					XDrawRectangle(the_display_le,XtWindow(clust_wid[j].form),
						gc_noir,1,1,CLUSTER_FORM_WIDTH-2,CLUSTER_FORM_HEIGHT-2);
					XFillRectangle(	the_display_le,XtWindow(clust_wid[j].form),
						gc_vert,2,2,CLUSTER_FORM_WIDTH-4,CLUSTER_FORM_HEIGHT-4);
					XtVaSetValues(clust_wid[j].position,XmNbackground,
						green_pixel,NULL);
					XClearWindow(the_display_le,XtWindow(clust_wid[j].position));
				}
				
				
			}
		}
		calculate_link_coord (0);
		return;
	}

/*=== Cas particulier d'aucun cluster widget ===============================*/

	if (nb_clusters_in_array == 0) return;

/*=== Cas particulier d'un seul cluster widget =============================*/

	if (nb_clusters_in_array == 1)
	{
		i = ordre_clust_wid[1];
	
		if (XtIsManaged (clust_wid[i].form))
		{
			XtUnmanageChild (clust_wid[i].form);
		}

		XtVaSetValues (widget_array_le[k_DrawingA_Work_Area_lew],
		    XmNwidth, CLUSTER_FORM_WIDTH + 300,
		    XmNheight, CLUSTER_FORM_HEIGHT + 300,
		    NULL);

		if (placement_mode == AUTOMATIC)
		{
			XtVaSetValues (clust_wid[i].form,
			    XmNx, 100,
			    XmNy, 100,
			    NULL);
		}
		
		XtManageChild (clust_wid[i].form);
		
		j = i;
		
		XSetWindowBackground(the_display_le,XtWindow(clust_wid[j].form ),
					white_pixel);
		XtVaSetValues(clust_wid[j].no,XmNbackground,white_pixel,NULL);
		XtVaSetValues(clust_wid[j].name,XmNbackground,white_pixel,NULL);
		XClearWindow(the_display_le,XtWindow(clust_wid[j].form ));
		XClearWindow(the_display_le,XtWindow(clust_wid[j].no));
		XClearWindow(the_display_le,XtWindow(clust_wid[j].name));		
		if(clust_wid[j].nb_neurons==1)
		{

			XDrawArc(the_display_le,XtWindow(clust_wid[j].form),
				gc_noir,1,1,CLUSTER_FORM_WIDTH-2,CLUSTER_FORM_HEIGHT-2,
				0*64,360*64);

			XFillArc(the_display_le,XtWindow(clust_wid[j].form),
				gc_gris,2,2,CLUSTER_FORM_WIDTH-4,CLUSTER_FORM_HEIGHT-4,
				0*64,360*64);
			XtVaSetValues(clust_wid[j].position,XmNbackground,
				grey_pixel,NULL);
			XClearWindow(the_display_le,XtWindow(clust_wid[j].position));	
		}
		else
		{
			XDrawRectangle(the_display_le,XtWindow(clust_wid[j].form),
				gc_noir,1,1,CLUSTER_FORM_WIDTH-2,CLUSTER_FORM_HEIGHT-2);
			XFillRectangle(	the_display_le,XtWindow(clust_wid[j].form),
				gc_vert,2,2,CLUSTER_FORM_WIDTH-4,CLUSTER_FORM_HEIGHT-4);
			XtVaSetValues(clust_wid[j].position,XmNbackground,
				green_pixel,NULL);
			XClearWindow(the_display_le,XtWindow(clust_wid[j].position));
		}

		return;
	}

/*--- Calcule les nouveaux parametres du dessin ----------------------------*/ 

	angle_clusters = 2. * (double) PI / (double) nb_clusters_in_array;

	rayon_clust_wid = 0.5 * sqrt ((double) CLUSTER_FORM_WIDTH *
	    (double) CLUSTER_FORM_WIDTH + (double) CLUSTER_FORM_HEIGHT *
	    (double) CLUSTER_FORM_HEIGHT);

	sin_angle_2 = sin (angle_clusters / 2.);

	rayon_cercle_clusters = (rayon_clust_wid + 10.)
	    / (2. * sin_angle_2 * sin_angle_2);

	if (sin_angle_2 * rayon_cercle_clusters < rayon_clust_wid)
	{
		rayon_cercle_clusters = (rayon_clust_wid + 10.)
		    / sin_angle_2;
	}

	workArea_height = (int) (2. * rayon_cercle_clusters +
	    CLUSTER_FORM_HEIGHT + 100.);
	workArea_width = (int) floor ((double) workArea_height * 1.1 + 0.5);

/*--- Unmanage tous les clusters widgets -----------------------------------*/

	for (i = 1; i <= nb_clusters_in_array; i++)
	{
		j = ordre_clust_wid[i];
	
		if (XtIsManaged (clust_wid[j].form))
		{
			XtUnmanageChild (clust_wid[j].form);
		}
	}

/*--- Modifie les ressources liees a l'emplacement des clusters widgets ----*/

	XtVaSetValues (widget_array_le[k_DrawingA_Work_Area_lew],
	    XmNwidth, (Dimension) workArea_width,
	    XmNheight, (Dimension) workArea_height,
	    NULL);

	j = 0;
	for (i = 1; i <= nb_clusters_in_array; i++)
	{
		px = (int) floor ((double) workArea_width / 2. +
		    rayon_cercle_clusters *
		    sin ((double) j * angle_clusters) -
		    (double) CLUSTER_FORM_WIDTH / 2. + 0.5);

		py = (int) floor ((double) workArea_height / 2. -
		    rayon_cercle_clusters *
		    cos ((double) j * angle_clusters) -
		    (double) CLUSTER_FORM_HEIGHT / 2. + 0.5);

		clust_wid[ordre_clust_wid[i]].px = px;
		clust_wid[ordre_clust_wid[i]].py = py;

		clust_wid[ordre_clust_wid[i]].center_px = px +
		    CLUSTER_FORM_WIDTH / 2;
		clust_wid[ordre_clust_wid[i]].center_py = py +
		    CLUSTER_FORM_HEIGHT / 2;

		XtVaSetValues (clust_wid[ordre_clust_wid[i]].form,
		    XmNx, (Position) px,
		    XmNy, (Position) py,
		    NULL);
		j++;
	}

	calculate_link_coord (0);

/*--- Remanage tous les clusters widgets -----------------------------------*/

	for (i = 1; i <= nb_clusters_in_array; i++)
	{
		j = ordre_clust_wid[i];
		XtManageChild (clust_wid[ordre_clust_wid[i]].form);
		
		XSetWindowBackground(the_display_le,XtWindow(clust_wid[j].form ),
					white_pixel);
		XtVaSetValues(clust_wid[j].no,XmNbackground,white_pixel,NULL);
		XtVaSetValues(clust_wid[j].name,XmNbackground,white_pixel,NULL);
		XClearWindow(the_display_le,XtWindow(clust_wid[j].form ));
		XClearWindow(the_display_le,XtWindow(clust_wid[j].no));
		XClearWindow(the_display_le,XtWindow(clust_wid[j].name));		
		if(clust_wid[j].nb_neurons==1)
		{

			XDrawArc(the_display_le,XtWindow(clust_wid[j].form),
				gc_noir,1,1,CLUSTER_FORM_WIDTH-2,CLUSTER_FORM_HEIGHT-2,
				0*64,360*64);

			XFillArc(the_display_le,XtWindow(clust_wid[j].form),
				gc_gris,2,2,CLUSTER_FORM_WIDTH-4,CLUSTER_FORM_HEIGHT-4,
				0*64,360*64);
			XtVaSetValues(clust_wid[j].position,XmNbackground,
				grey_pixel,NULL);
			XClearWindow(the_display_le,XtWindow(clust_wid[j].position));	
		}
		else
		{
			XDrawRectangle(the_display_le,XtWindow(clust_wid[j].form),
				gc_noir,1,1,CLUSTER_FORM_WIDTH-2,CLUSTER_FORM_HEIGHT-2);
			XFillRectangle(	the_display_le,XtWindow(clust_wid[j].form),
				gc_vert,2,2,CLUSTER_FORM_WIDTH-4,CLUSTER_FORM_HEIGHT-4);
			XtVaSetValues(clust_wid[j].position,XmNbackground,
				green_pixel,NULL);
			XClearWindow(the_display_le,XtWindow(clust_wid[j].position));
		}
	}
}

/*----------------------------------------------------------------------------
 *	A C T I V A T E _ N O _ P R O C
 *--------------------------------------------------------------------------*/

void	activate_no_proc (w, no_clust, reason)
Widget	w;
int	no_clust;
XmAnyCallbackStruct	*reason;
{
	int		new_cluster;
	int nb_neur_clust1, nb_neur_clust2;

	switch (action)
	{
		case DELETE_CLUSTER_ACTION:
			delete_clust_wid (no_clust);
			replace_clust_wids ();
			action = NO_ACTION;
			break;

		case MODIFY_CLUSTER_ACTION:
			modify_clust_wid (no_clust);
			action = NO_ACTION;
			break;

		case COPY_CLUSTER_ACTION:
			copy_clust_wid (no_clust);
			replace_clust_wids ();
			action = NO_ACTION;

		case SWAP_CLUSTER_ACTION1:
			cluster_to_swap = no_clust;
			action = SWAP_CLUSTER_ACTION2;
			break;

		case SWAP_CLUSTER_ACTION2:
			swap_clust_wid (cluster_to_swap, no_clust);
			replace_clust_wids ();
			action = NO_ACTION;
			break;

		case NEW_LINK_ACTION1:
			new_link_cluster1 = no_clust;
			action = NEW_LINK_ACTION2;
			break;
			
		case NEW_LINK_ACTION2:
			nb_neur_clust1 = clust_wid[new_link_cluster1].nb_neurons;
			nb_neur_clust2 = clust_wid[no_clust].nb_neurons;

			Notify_Matrix(new_link_cluster1, no_clust, nb_neur_clust1, nb_neur_clust2);
			new_link_para (new_link_cluster1, no_clust);
			break;
			
		case DELETE_LINK_ACTION1:
			delete_link_cluster1 = no_clust;
			action = DELETE_LINK_ACTION2;
			break;
			
		case DELETE_LINK_ACTION2:
			sup_avl(delete_link_cluster1, no_clust);
			delete_link_para (delete_link_cluster1, no_clust);
			redraw_link_paras(1);	
			break;
			
		case MODIFY_LINK_ACTION1:
			modify_link_cluster1 = no_clust;
			action = MODIFY_LINK_ACTION2;
			break;
			
		case MODIFY_LINK_ACTION2:
			nb_neur_clust1 = clust_wid[modify_link_cluster1].nb_neurons;
			nb_neur_clust2 = clust_wid[no_clust].nb_neurons;

			Notify_Matrix(modify_link_cluster1, no_clust, nb_neur_clust1, nb_neur_clust2);
			modify_link_para (modify_link_cluster1, no_clust);
			redraw_link_paras(1);	
			break;
			
		default:
			break;
	}
	current_cluster = no_clust;

}

/*----------------------------------------------------------------------------
 *	A C T I V A T E _ N A M E _ P R O C
 *--------------------------------------------------------------------------*/

void	activate_name_proc (w, no_clust, reason)
Widget	w;
int	no_clust;
XmAnyCallbackStruct	*reason;
{
	int		i;
	char		*name, char_buffer[256];
	XmString	xm_string;
	int		error;

	if (action != NO_ACTION)
	{
		/*  Afficher un message d'erreur  */
		return;
	}
	
	modify_clust_wid (no_clust);
}

/*----------------------------------------------------------------------------
 *	S E T _ P L A C E M E N T _ M O D E
 *--------------------------------------------------------------------------*/

void	set_placement_mode (mode)
char	*mode;
{
	XmString	xm_string;

	if (!strcmp (mode, "AUTOMATIC_MODE"))
	{
		placement_mode = AUTOMATIC;
		xm_string = XmStringCreateSimple ("Automatic *");
		XtVaSetValues (widget_array_le[k_PushBG_Automatic_lew],
		    XmNlabelString, xm_string,
		    NULL);
		XmStringFree (xm_string);
		
		xm_string = XmStringCreateSimple ("Manual     ");
		XtVaSetValues (widget_array_le[k_PushBG_Manual_lew],
		    XmNlabelString, xm_string,
		    NULL);
		XmStringFree (xm_string);
		
		XtSetSensitive (widget_array_le[k_PushBG_SwapCl_lew], True);
		XtSetSensitive (widget_array_le[k_PushBG_MoveCl_lew], False);

		replace_clust_wids ();
	}
	else if (!strcmp (mode, "MANUAL_MODE"))
	{
		placement_mode = MANUAL;
		xm_string = XmStringCreateSimple ("Automatic  ");
		XtVaSetValues (widget_array_le[k_PushBG_Automatic_lew],
		    XmNlabelString, xm_string,
		    NULL);
		XmStringFree (xm_string);
		
		xm_string = XmStringCreateSimple ("Manual    *");
		XtVaSetValues (widget_array_le[k_PushBG_Manual_lew],
		    XmNlabelString, xm_string,
		    NULL);
		XmStringFree (xm_string);
		
		XtSetSensitive (widget_array_le[k_PushBG_SwapCl_lew], False);
		XtSetSensitive (widget_array_le[k_PushBG_MoveCl_lew], True);

		replace_clust_wids ();
}
	else
	{
		printf ("Appel de set_placement_mode avec un mauvais argument\n");
	}
}

/*----------------------------------------------------------------------------
 *	P R E S S _ B U T T O N _ P R O C
 *--------------------------------------------------------------------------*/

void	press_button_proc (w, no_cluster, evt)
Widget	w;
int	no_cluster;
XEvent	*evt;
{
	Position	px1, py1;

	if (action != MOVE_CLUSTER_ACTION1 &&
	    !(action == NO_ACTION && placement_mode == MANUAL))
	{
		return;
	}

	XtVaGetValues (clust_wid[no_cluster].form,
	    XmNx, &px1,
	    XmNy, &py1,
	    NULL);

	clust_wid[no_cluster].px = (int) px1;
	clust_wid[no_cluster].py = (int) py1;
	clust_wid[no_cluster].px_manual = (int) px1;
	clust_wid[no_cluster].py_manual = (int) py1;

	x_root1 = evt->xbutton.x_root;
	y_root1 = evt->xbutton.y_root;
	cluster_px1 = (int) px1;
	cluster_py1 = (int) py1;
	
	action = MOVE_CLUSTER_ACTION2;
}

/*----------------------------------------------------------------------------
 *	M O V E _ B U T T O N _ P R O C	  
 *--------------------------------------------------------------------------*/

void	move_button_proc (w, no_cluster, evt)
Widget		w;
int		no_cluster;
XEvent		*evt;
{
	int	new_x, new_y;
	Position	px1, py1;
	static XtIntervalId redraw_interval_id=0;
	
	if (action != MOVE_CLUSTER_ACTION2)
	{
		return;
	}

	new_x = cluster_px1 + (evt->xmotion.x_root - x_root1);
	new_y = cluster_py1 + (evt->xmotion.y_root - y_root1);

	if ((workArea_width - new_x - CLUSTER_FORM_WIDTH) < 50)
	{
		workArea_width += 100;
		XtVaSetValues (widget_array_le[k_DrawingA_Work_Area_lew],
		    XmNwidth, (Dimension) workArea_width,
		    NULL);
	}

	if ((workArea_height - new_y - CLUSTER_FORM_HEIGHT) < 50)
	{
		workArea_height += 100;
		XtVaSetValues (widget_array_le[k_DrawingA_Work_Area_lew],
		    XmNheight, (Dimension) workArea_height,
		    NULL);
	}

	XtVaSetValues (clust_wid[no_cluster].form,
	    XmNx, (Position) new_x,
	    XmNy, (Position) new_y,
	    NULL);

	clust_wid[no_cluster].px = new_x;
	clust_wid[no_cluster].py = new_y;
	
	if (action != MOVE_CLUSTER_ACTION2)
	{
		return;
	}

	XtVaGetValues (clust_wid[no_cluster].form,
	    XmNx, &px1,
	    XmNy, &py1,
	    NULL);

	clust_wid[no_cluster].px = (int) px1; 
	clust_wid[no_cluster].py = (int) py1;
	clust_wid[no_cluster].px_manual = (int) px1; 
	clust_wid[no_cluster].py_manual = (int) py1;
	clust_wid[no_cluster].yet_placed = TRUE;

	clust_wid[no_cluster].center_px = (int) px1 + CLUSTER_FORM_WIDTH / 2;
	clust_wid[no_cluster].center_py = (int) py1 + CLUSTER_FORM_HEIGHT / 2;

	calculate_link_coord (0);
	

	if (redraw_interval_id)
			{
				XtRemoveTimeOut (redraw_interval_id);
			}
	redraw_interval_id = XtAppAddTimeOut (app_context, 150, 
		(XtTimerCallbackProc)redraw_link_paras_CB, (XtPointer)(unsigned long)1);
	action = MOVE_CLUSTER_ACTION2;
	
	current_cluster = no_cluster;
}

/*----------------------------------------------------------------------------
 *	R E L E A S E _ B U T T O N _ P R O C
 *--------------------------------------------------------------------------*/

void	release_button_proc (w, no_cluster, evt)
Widget	w;
int	no_cluster;
XEvent	*evt;
{
	Position	px1, py1;

	if (action != MOVE_CLUSTER_ACTION2)
	{
		return;
	}

	XtVaGetValues (clust_wid[no_cluster].form,
	    XmNx, &px1,
	    XmNy, &py1,
	    NULL);

	clust_wid[no_cluster].px = (int) px1; 
	clust_wid[no_cluster].py = (int) py1;
	clust_wid[no_cluster].px_manual = (int) px1; 
	clust_wid[no_cluster].py_manual = (int) py1;
	clust_wid[no_cluster].yet_placed = TRUE;

	clust_wid[no_cluster].center_px = (int) px1 + CLUSTER_FORM_WIDTH / 2;
	clust_wid[no_cluster].center_py = (int) py1 + CLUSTER_FORM_HEIGHT / 2;

	calculate_link_coord (0);
	redraw_link_paras (1);

	file_modified = TRUE;
	action = NO_ACTION;
}

/****************************************************************************
 *									    *
 *	G E S T I O N   D E S   L I A I S O N S				    *
 *									    *
 ****************************************************************************/

/*----------------------------------------------------------------------------
 *	N E W _ L I N K _ P A R A
 *--------------------------------------------------------------------------*/

int	new_link_para (no_cluster1, no_cluster2)
int	no_cluster1, no_cluster2;
{
	char		buffer_char[35];
	XmString	xm_string;
	LINK_PARAMETERS *struct_link_para;
	int		no_link;

	action = NO_ACTION;

/*--- Verifie si la liaison n'existe pas deja ------------------------------*/

	if (search_link_para (no_cluster1, no_cluster2))
	{
		display_error (parent,
		    "This link already exists.");
		return(1);
	}

	struct_link_para = display_inputlink ((LINK_PARAMETERS *)NULL,
	    no_cluster1, no_cluster2);

	if (struct_link_para)
	{
		no_link = alloc_new_link_para (no_cluster1, no_cluster2);
	
		link_para[no_link].axone_mean = struct_link_para->axone_mean;
		link_para[no_link].axone_sd = struct_link_para->axone_sd;
		link_para[no_link].born_min = struct_link_para->born_min;
		link_para[no_link].born_max = struct_link_para->born_max;		
		link_para[no_link].deconnect = struct_link_para->deconnect;		
		link_para[no_link].K_connections = struct_link_para->K_connections;		
		link_para[no_link].inter_cluster = struct_link_para->inter_cluster;

		if (no_cluster1 == no_cluster2)
		{
			decorate_clust_wid (no_cluster1);
		}
		else
		{
			calculate_link_coord (no_link);
		}
	}
	return(0);
}

/*----------------------------------------------------------------------------
 *	 D E L E T E _ L I N K _ P A R A
 *--------------------------------------------------------------------------*/

int	delete_link_para (no_clust1, no_clust2)
int	no_clust1, no_clust2;
{
	char	char_buffer[100];
	int	no_link = search_link_para (no_clust1, no_clust2);
	int	no_cluster = 0;
	int	yes_or_no;

	action = NO_ACTION;

/*--- Verifie si la liaison existe deja ------------------------------------*/

	if (!no_link)
	{
		display_error (parent,
		    "This link doesn't exist yet. Try another one.");
		return(1);
	}

/*--- Demande confirmation -------------------------------------------------*/

	sprintf (char_buffer,
	    "Are you sure to want to delete the link\nfrom cluster %d to cluster %d ?",
	    no_clust1, no_clust2);

	yes_or_no = display_question (parent, char_buffer);

	if (yes_or_no == NO_ANSWER)
	{
		return(1);
	}

/*--- Efface ---------------------------------------------------------------*/

	if (link_para[no_link].cluster1 == link_para[no_link].cluster2)
	{
		no_cluster = link_para[no_link].cluster1;
	}

	link_para[no_link].cluster1 = 0;
	link_para[no_link].cluster2 = 0;
	nb_links_in_array--;
	
	if (no_cluster)
	{
		decorate_clust_wid (no_cluster);
	}
	
	file_modified = TRUE;
	return(0);
}

/*----------------------------------------------------------------------------
 *	 D E L E T E _ L I N K _ P A R A _ S I L E N T
 *--------------------------------------------------------------------------*/

int	delete_link_para_silent (no_clust1, no_clust2)
int	no_clust1, no_clust2;
{
	char	char_buffer[100];
	int	no_link = search_link_para (no_clust1, no_clust2);
	int	no_cluster = 0;
	int	yes_or_no;

	action = NO_ACTION;

/*--- Verifie si la liaison existe deja ------------------------------------*/

	if (!no_link)
	{
		display_error (parent,
		    "This link doesn't exist yet. Try another one.");
		return(1);
	}

#if DEBUG
/*--- Demande confirmation -------------------------------------------------*/

	sprintf (char_buffer,
	    "Are you sure to want to delete the link\nfrom cluster %d to cluster %d ?",
	    no_clust1, no_clust2);

	yes_or_no = display_question (parent, char_buffer);

	if (yes_or_no == NO_ANSWER)
	{
		return(1);
	}
#endif
/*--- Efface ---------------------------------------------------------------*/

	if (link_para[no_link].cluster1 == link_para[no_link].cluster2)
	{
		no_cluster = link_para[no_link].cluster1;
	}

	link_para[no_link].cluster1 = 0;
	link_para[no_link].cluster2 = 0;
	nb_links_in_array--;
	
	if (no_cluster)
	{
		decorate_clust_wid (no_cluster);
	}
	
	file_modified = TRUE;
	return(0);
}

/*----------------------------------------------------------------------------
 *	M O D I F Y _ L I N K _ P A R A
 *--------------------------------------------------------------------------*/

int	modify_link_para (no_cluster1, no_cluster2)
int	no_cluster1, no_cluster2;
{
	char	char_buffer[50];
	int	no_link = search_link_para (no_cluster1, no_cluster2);

	LINK_PARAMETERS *struct_link_para;

	action = NO_ACTION;

/*--- Verifie si la liaison existe deja ------------------------------------*/

	if (!no_link)
	{
		display_error (parent,
		    "This link doesn't exist yet. Try another one.");
		return(1);
	}
	
	struct_link_para = display_inputlink (&link_para[no_link],
	    no_cluster1, no_cluster2);

	if (struct_link_para)
	{
		link_para[no_link].axone_mean = struct_link_para->axone_mean;
		link_para[no_link].axone_sd = struct_link_para->axone_sd;
		link_para[no_link].born_min = struct_link_para->born_min;
		link_para[no_link].born_max = struct_link_para->born_max;		
		link_para[no_link].deconnect = struct_link_para->deconnect;		
		link_para[no_link].K_connections = struct_link_para->K_connections;		
		link_para[no_link].inter_cluster = struct_link_para->inter_cluster;

		if (no_cluster1 == no_cluster2)
		{
			decorate_clust_wid (no_cluster1);
		}
	}

	file_modified = TRUE;
	return(0);
}

/*----------------------------------------------------------------------------
 *	A L L O C _ N E W _ L I N K _ P A R A
 *--------------------------------------------------------------------------*/

int	alloc_new_link_para (no_cluster1, no_cluster2)
int	no_cluster1, no_cluster2;
{
	char	found = FALSE;
	int	i, no_link = 0;

/*--- Recherche d'une structure LINK_PARAMETERS libre ----------------------*/

	while (!found && no_link < max_link_para)
	{
		no_link++;
		if (link_para[no_link].cluster1 == 0)
		{
			found = TRUE;
		}
	}

	if (!found)
	{
		link_para = (LINK_PARAMETERS *) XtRealloc ((char *)link_para,
			(max_link_para + add_link_para + 1) *
			sizeof (LINK_PARAMETERS));
			
		for (i = 1; i <= add_link_para; i++)
		{

			link_para[max_link_para + i].cluster1 = 0;
			link_para[max_link_para + i].cluster2 = 0;
		}

		no_link = max_link_para + 1;
		max_link_para += add_link_para;
	}

	link_para[no_link].cluster1 = no_cluster1;
	link_para[no_link].cluster2 = no_cluster2;

	nb_links_in_array++;
	return no_link;
}

/*----------------------------------------------------------------------------
 *	S E A R C H _ L I N K _ P A R A
 *--------------------------------------------------------------------------*/

int	search_link_para (no_clust1, no_clust2)
int	no_clust1, no_clust2;
{
	int	i;

	for (i = 1; i <= max_link_para; i++)
	{
		if (link_para[i].cluster1 == no_clust1 &&
		    link_para[i].cluster2 == no_clust2)
		{
			return i;
		}
	}

	return 0;
}




/*----------------------------------------------------------------------------
 *	R E D R A W _ L I N K _ P A R A S
 *--------------------------------------------------------------------------*/

void redraw_link_paras_CB(XtPointer client_data,XtIntervalId *id)
{
	int message = (int)(unsigned long)client_data;

	redraw_link_paras(message);
}

void	redraw_link_paras (int flag)
{
	unsigned int	largeur, hauteur;
	int		i;

	if(flag)
		XFillRectangle (the_display_le,
	    		XtWindow (widget_array_le[k_DrawingA_Work_Area_lew]),
	    		gc_blanc, 0, 0,
	    		workArea_width, workArea_height);

	for (i = 1; i <= max_link_para; i++)
	{
		if (link_para[i].cluster1 != 0 &&
		    link_para[i].cluster1 != link_para[i].cluster2)
		{
			XDrawLine (the_display_le,
			    work_area_window,
			    gc_noir2,
			    link_para[i].begin_px,
			    link_para[i].begin_py,
			    link_para[i].end_px,
			    link_para[i].end_py);
			    
			if (link_para[i].inter_cluster != '+' && 
			    ( link_para[i].begin_px != link_para[i].end_px ||
	 		      link_para[i].begin_py != link_para[i].end_py ))
			{
				XDrawLine (the_display_le,
				    work_area_window,
				    gc_noir2,
				    link_para[i].inhib_px1,
				    link_para[i].inhib_py1,
				    link_para[i].inhib_px2,
				    link_para[i].inhib_py2);	
			}
			
			if (link_para[i].inter_cluster != '-' && 
			    ( link_para[i].begin_px != link_para[i].end_px ||
	 		      link_para[i].begin_py != link_para[i].end_py ))
			{
				XFillArc (the_display_le,
				    work_area_window,
				    gc_noir2,
				    link_para[i].excit_px - 5,
				    link_para[i].excit_py - 5,
				    10, 10, 0, 360 * 64);
			}			
		}
	}

	expose_interval_id = 0;
} 

/*---------------------------------------------------------------------------
 *	C A L C U L A T E _ L I N K _ C O O R D
 *-------------------------------------------------------------------------*/

void	calculate_link_coord (no_link)
int	no_link;
{
	double		rayon_clust_wid;
	double		ecartement, inhib, excit;
	double		x1_x2, y1_y2;
	DB_POINT	P1, P2, P1a, P2a, C1, C2, C3, C4, RP;
	double		dist_1_2;
	int		no_cluster1, no_cluster2;
	int		found = FALSE;

/*--- Si l'argument est nul, recalcule tout ------------------------------*/

	if (no_link == 0)
	{
		int	i;
		for (i = 1; i <= max_link_para; i++)
		{
			if (link_para[i].cluster1 != 0)
			{
				calculate_link_coord (i);
			}
		}
		return;
	}

/*--- Cas normal ---------------------------------------------------------*/

	no_cluster1 = link_para[no_link].cluster1;
	no_cluster2 = link_para[no_link].cluster2;

	if (no_cluster1 == no_cluster2) return;

	P1.x = (double) clust_wid[no_cluster1].center_px;
	P1.y = (double) clust_wid[no_cluster1].center_py;
	P2.x = (double) clust_wid[no_cluster2].center_px;
	P2.y = (double) clust_wid[no_cluster2].center_py;

	x1_x2 = P1.x - P2.x;
	y1_y2 = P1.y - P2.y;
	dist_1_2 = sqrt (x1_x2 * x1_x2 + y1_y2 * y1_y2);

		/* Ecart entre 2 links : 16 pixels */
	ecartement = 8. / dist_1_2;

	P1a.x = P1.x - y1_y2 * ecartement;
	P1a.y = P1.y + x1_x2 * ecartement;
	P2a.x = P2.x - y1_y2 * ecartement;
	P2a.y = P2.y + x1_x2 * ecartement;

		/* 4 sommets ecartes du cluster : 
		   (links a 8 pixels autour de chaque cluster) */
	C1.x = P2.x + (double) CLUSTER_FORM_WIDTH  / 2. + 8.;
	C1.y = P2.y + (double) CLUSTER_FORM_HEIGHT / 2. + 8.;
	C2.x = C1.x;
	C2.y = P2.y - (double) CLUSTER_FORM_HEIGHT / 2. - 8.;
	C3.x = P2.x - (double) CLUSTER_FORM_WIDTH  / 2. - 8.;
	C3.y = C2.y;
	C4.x = C3.x;
	C4.y = C1.y;

	found = inter_segment (P1a, P2a, C1, C2, &RP);

	if (!found)
	{
		found = inter_segment (P1a, P2a, C2, C3, &RP);
	}
	if (!found)
	{
		found = inter_segment (P1a, P2a, C3, C4, &RP);
	}
	if (!found)
	{
		found = inter_segment (P1a, P2a, C4, C1, &RP);
	}

	link_para[no_link].begin_px  = (int) floor (P1a.x + 0.5);
	link_para[no_link].begin_py  = (int) floor (P1a.y + 0.5);

	if (found)
	{
		link_para[no_link].end_px = (int) floor (RP.x + 0.5);
		link_para[no_link].end_py = (int) floor (RP.y + 0.5);
	}
	else
	{
		link_para[no_link].end_px = link_para[no_link].begin_px;
		link_para[no_link].end_py = link_para[no_link].begin_py;
		RP.x = RP.y = 0.;
	}

		/* Largeur d'un synapse inhibiteur : 12 pixels */
	inhib = 6. / dist_1_2;
	
	link_para[no_link].inhib_px1 = (int) floor (RP.x - y1_y2 * inhib + 0.5);
	link_para[no_link].inhib_py1 = (int) floor (RP.y + x1_x2 * inhib + 0.5);
	link_para[no_link].inhib_px2 = (int) floor (RP.x + y1_y2 * inhib + 0.5);
	link_para[no_link].inhib_py2 = (int) floor (RP.y - x1_x2 * inhib + 0.5);

		/* Largeur (diametre) d'un synapse excitateur : 10 pixels */
	excit = (5. + 1.) / dist_1_2;

	link_para[no_link].excit_px  = (int) floor (RP.x + x1_x2 * excit + 0.5);
	link_para[no_link].excit_py  = (int) floor (RP.y + y1_y2 * excit + 0.5);
}

/*----------------------------------------------------------------------------
 *	I N T E R _ S E G M E N T
 *--------------------------------------------------------------------------*/

int	inter_segment (P1a, P2a, P1b, P2b, RP)
DB_POINT	P1a, P2a, P1b, P2b, *RP;
{
	double	delta, lambda_A, lambda_B;

	delta = (P2a.x - P1a.x) * (P1b.y - P2b.y) 
	      - (P2a.y - P1a.y) * (P1b.x - P2b.x);

	if (fabs (delta) < 1.e-10) 
	{
		return FALSE;	
	}

	lambda_A = ( (P1b.x - P1a.x) * (P1b.y - P2b.y) 
	           - (P1b.y - P1a.y) * (P1b.x - P2b.x) ) / delta;

	lambda_B = ( (P2a.x - P1a.x) * (P1b.y - P1a.y) 
	           - (P2a.y - P1a.y) * (P1b.x - P1a.x) ) / delta;

	if (lambda_A <= 0. || lambda_A > 1. || lambda_B <= 0. || lambda_B > 1.)
	{
		return FALSE;
	}

	RP->x = P1a.x + (P2a.x - P1a.x) * lambda_A;
	RP->y = P1a.y + (P2a.y - P1a.y) * lambda_A;

	return TRUE;
}

/****************************************************************************
 *									    *
 *	G E S T I O N   D E S   F I C H I E R S				    *
 *									    *
 *	D E   C O N F I G U R A T I O N					    *
 *									    *
 ****************************************************************************/
/*******************************************************************************
	Function for initializing global directory variables
*******************************************************************************/
void init_directories(void)
{
	FILE	*p_rc;
	char	*home;
	char	*nbc_V8_bin;
	char	*nbc_V8_help;
	char	buffer[256];

	strcpy(project_directory,get_dir_name());
	strcpy(current_directory,"./");
#if 0
	home = getenv("HOME");
	if(home)
	{
		strcpy(buffer,home);
		strcat(buffer,"/.nbcrc");

		if (p_rc = fopen(buffer,"r"))
		{
			fscanf(p_rc,"%s",project_directory);
			strcpy(current_directory,project_directory);
			strcpy(buffer,project_directory);
			fclose(p_rc);
		} /* fin du if */
		else
		{
			strcpy(current_directory,home);
			strcpy(project_directory,home);
			sprintf(buffer,"%s/noname_nbc",home);
			if(!dir_exists(buffer))
			{
				sprintf(buffer,"mkdir %s/noname_nbc",home);
				system(buffer);
			}
			strcpy(project_directory,home);
			strcat(project_directory,"/noname_nbc");
		} /* fin du else */

		strcpy(buffer,home);
		strcat(buffer,"/.xnbclnkrc");

		if (p_rc = fopen(buffer,"r"))
		{
			fscanf(p_rc,"%s",lnk_file);
			fclose(p_rc);
		} /* fin du if */
	}
	else
	{
		strcpy(current_directory,".");
		strcpy(project_directory,".");
		sprintf(buffer,"%s/noname_nbc",".");
		if(!dir_exists(buffer))
		{
			sprintf(buffer,"mkdir %s/noname_nbc",".");
			system(buffer);
		}
		strcpy(project_directory,".");
		strcat(project_directory,"/noname_nbc");
	}
#endif

	nbc_V8_help = getenv("XNBC_HELP_DIR");
	if(nbc_V8_help)
	{
		strcpy(help_directory,nbc_V8_help);
		strcat(help_directory,"/link_edit");
	}
	else
	{
		strcpy(help_directory,"/usr/local/bin/xnbc.bin/V8/help");
#if DEBUG
		fprintf(stderr,"XNBC_HELP_DIR not defined, using %s\n",
			help_directory);
#endif
		strcat(help_directory,"/link_edit");
	}
}
/*******************************************************************************
	Function for updating directories
*******************************************************************************/
void update_directories(char *full_name)
{
	char *pt;
	char buffer[256];
	char tmp[256];
	char ext[10];
	
	strcpy(buffer,full_name);
	
	if((pt = strrchr(buffer,'.'))!=NULL)
	{
			strcpy(ext,pt);
			*pt='\0';
	}
	else
		*ext = '\0';
			
	if((pt = strrchr(buffer,'/'))!= NULL)
	{
		*pt = '\0';
		pt++;
		strcpy(project_directory,buffer);
		if(!strstr(project_directory,"_nbc"))
		{
			sprintf(tmp,"%s%s",pt,ext);
			if(!file_exists(tmp,buffer))
			{
				strcat(project_directory,"/");
				strcat(project_directory,pt);
				strcat(project_directory,"_nbc");
			}
		}
		if(!dir_exists(project_directory))
		{
			sprintf(tmp,"mkdir %s",project_directory);
			system(tmp);
		}
		
	}
	else
	{
		strcpy(project_directory,current_directory);
		if(!strstr(project_directory,"_nbc"))
		{
			sprintf(tmp,"%s%s",buffer,ext);
			if(!file_exists(tmp,current_directory))
			{
				strcat(project_directory,"/");
				strcat(project_directory,buffer);
				strcat(project_directory,"_nbc");
			}
		}
		if(!dir_exists(project_directory))
		{
			sprintf(tmp,"mkdir %s",project_directory);
			system(tmp);
		}
		
	}

}

#include <sys/types.h>
#include <dirent.h>

/*******************************************************************************
	Function for searching for a file in the specified directory
*******************************************************************************/
int file_exists(char *file_name,char *dir_name)
{
	int len;
	struct dirent *dp;
	DIR *dir_pointer;

	len = strlen(file_name);
	dir_pointer = opendir(dir_name);
	if(!dir_pointer)
		return False;
	for (dp = readdir(dir_pointer); dp != NULL; dp = readdir(dir_pointer))
	{
	       if (strlen(dp->d_name) == len && !strcmp(dp->d_name, file_name))
	       {
	               closedir(dir_pointer);
	               return True;
	       }
	} /* fin du for */
	closedir(dir_pointer);
	return False;

}
/*******************************************************************************
	Function for testing if directory exists
*******************************************************************************/
int dir_exists(char *dir_name)
{
	DIR *dir_pointer;

	dir_pointer = opendir(dir_name);
	if(!dir_pointer)
		return False;
	closedir(dir_pointer);
	return True;	
}

/*----------------------------------------------------------------------------
 *	S A V E _ F I L E 
 *--------------------------------------------------------------------------*/

void	save_file ()
{
	char		char_buffer[256];
	char		*char_pointer;
	char		name[255];
	char *pt;

/*	full_save_file (lnk_name);*/
			

	strcpy(savefile_name,get_lnk_name());
	char_pointer = strrchr(savefile_name,'.');
	*char_pointer = 0;	/* on enleve le.ntw, car on veut le nom de base */
	file_named = True;	
	
	create_both_files();
	
	XClearWindow(the_display_le,XtWindow(widget_array_le[k_MainW_lew]));
	redraw_link_paras(1);	
}

/*----------------------------------------------------------------------------
 *	S A V E _ A S _ F I L E 
 *--------------------------------------------------------------------------*/

void	save_as_file ()
{
	char	*char_pointer;
	int	i,j;
	char	*pt;
	char	mask[256];
	char 	dir[256],
		pj[256],
		file[256];
	
	
	strcpy(mask,get_dir_name());
	strcat(mask,"/*.ntw");

	char_pointer = NULL;
	char_pointer = display_fileselect (parent,
	    0, mask, 
	    "Type the new name of the file:", project_directory);

	if (!char_pointer) return;

	strcpy(savefile_name,char_pointer);
	file_named = True;	
	
	create_both_files();
	
	XClearWindow(the_display_le,XtWindow(widget_array_le[k_MainW_lew]));
	redraw_link_paras(1);	

}

/*--------------------------------------------------------------------------*
 *	O P E N _ F I L E						    *
 *--------------------------------------------------------------------------*/

void	open_file ()
{
	char	*char_pointer;
	char 	*pt;
	char	mask[256];
	char	dir[256],
		pj[256],
		file[256];

	strcpy(mask,get_dir_name());
	strcat(mask,"/*.ntw");

	char_pointer = NULL;
	strcpy(project_directory,get_dir_name());
	while(!char_pointer || !strstr(char_pointer,".ntw"))
	{
		char_pointer = display_fileselect (parent,
						   0, mask, "Select the file to be opened :", project_directory);
		if(!char_pointer)	
			break;
	}
	if (!char_pointer) return;
	
	XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
		working_cursor);
		
	if(LIENS)
	{
		clear_avl(&LIENS); 
		LIENS = NULL;
	}
	
	strcpy(project_directory,get_dir_name());
/*
	strcpy(current_directory,dir);
*/		

#if DEBUG
	printf("open_file: %s\n", char_pointer);
#endif
	strcpy(savefile_name,char_pointer);

	read_save_file (savefile_name);	
}

/*----------------------------------------------------------------------------
 *	N E W _ F I L E
 *--------------------------------------------------------------------------*/

void	new_file ()
{
	int	i, j, yes_or_no = NO_ANSWER;
	char	title[256];

	for (i = 1; i <= nb_clusters_in_array; i++)
	{
		j = ordre_clust_wid[i];
		XtDestroyWidget (clust_wid[j].form);
		clust_wid[j].form = (Widget) NULL;
		free (clust_wid[j].neuron_file);
		clust_wid[j].neuron_file = (char *)NULL;
	}
	nb_clusters_in_array = 0;

	for (i = 1; i <= max_link_para; i++)
	{
		link_para[i].cluster1 = 0;
		link_para[i].cluster2 = 0;
	}
	nb_links_in_array = 0;
		
	sprintf(title,"XNBC Link Editor %s: noname",VERSION);
	XtVaSetValues (topLevelShell,
	    XtNtitle, title,
	    NULL);
	
	strcpy(current_directory,getenv("HOME"));
	strcpy(project_directory,current_directory);
	strcat(project_directory,"/noname");
	*savefile_name = '\0';
		
	file_named = FALSE;
	file_modified = FALSE;
	XtVaSetValues(widget_array_le[k_PushBG_Save_lew],
	XmNsensitive,False,NULL);
}

/*----------------------------------------------------------------------------
 *	C O N F I R M _ S A V E _ F I L E
 *--------------------------------------------------------------------------*/

int	confirm_save_file (Widget le_parent)
{
	char	*char_pointer;
	char	char_buffer[256];
	int	yes_or_no;

	if (file_modified)
	{
		yes_or_no = display_question (le_parent,
		    "Do you want to save this file ?");
	}
	else
		return FALSE;
	
	if (yes_or_no == YES_ANSWER)
	{
		create_both_files ();
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

/*----------------------------------------------------------------------------
 *	F U L L _ S A V E _ F I L E
 *--------------------------------------------------------------------------*/

void	full_save_file (file_name)
char	*file_name;
{
	int	i, j, k, total_neurons = 0, ordre, nb_link;
	char *pt;
	char cmd[255];
	char dir[255];
	FILE	*file_p;

	file_p = fopen (file_name, "w");
	if(!file_p)
	{
		sprintf(cmd,"Sorry, can't write %s !",file_name);
		display_error(widget_array_le[k_MainW_lew],cmd);
	}
	if(save_V7)
	{
		fprintf (file_p, "TypeOfFile: LinkConfigurationFile\n");

		fprintf (file_p, "NumberOfClusters: %d\n", nb_clusters_in_array); 

		if (placement_mode == AUTOMATIC)
		{
			fprintf (file_p, "PlacementMode: AUTOMATIC_MODE\n");
		}
		else
		{
			fprintf (file_p, "PlacementMode: MANUAL_MODE\n");
			fprintf (file_p, "WorkAreaWidth: %d\n", workArea_width);
			fprintf (file_p, "WorkAreaHeight: %d\n", workArea_height);
		}

		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			j = ordre_clust_wid [i];
			fprintf (file_p, "BeginCluster: *\n");
			fprintf (file_p, "ClusterName: %s\n", clust_wid[j].ch_name);
			fprintf (file_p, "ClusterPxManual: %d\n", clust_wid[j].px_manual);
			fprintf (file_p, "ClusterPyManual: %d\n", clust_wid[j].py_manual);
			fprintf (file_p, "YetPlaced: %d\n", clust_wid[j].yet_placed);
			fprintf (file_p, "PositionH: %d\n", clust_wid[j].position_H);
			fprintf (file_p, "DeltaH: %d\n", clust_wid[j].delta_H);
			fprintf (file_p, "PositionL: %d\n", clust_wid[j].position_L);
			fprintf (file_p, "DeltaL: %d\n", clust_wid[j].delta_L);
			fprintf (file_p, "PositionAP: %d\n", clust_wid[j].position_AP);
			fprintf (file_p, "DeltaAP: %d\n", clust_wid[j].delta_AP);
			fprintf (file_p, "NbNeurons: %d\n", clust_wid[j].nb_neurons);		
			fprintf (file_p, "NeuronFile: %s\n", clust_wid[j].neuron_file);

			if (clust_wid[j].shape == (char)NULL)
			{
				fprintf  (file_p, "ClusterShape: e\n");
			}
			else
			{
				fprintf (file_p, "ClusterShape: %c\n", clust_wid[j].shape);
			}
			
			fprintf (file_p, "EndCluster: *\n");
		}

		for (i = 1; i <= max_link_para; i++)
		{
			if (link_para[i].cluster1 != 0)
			{
				fprintf (file_p, "BeginLink: *\n");
				fprintf (file_p, "Cluster1: %s\n",
				    clust_wid[link_para[i].cluster1].ch_name);
				fprintf (file_p, "Cluster2: %s\n",
				    clust_wid[link_para[i].cluster2].ch_name);
				fprintf (file_p, "AxoneMean: %d\n",
				    link_para[i].axone_mean);
				fprintf (file_p, "AxoneSd: %d\n",
				    link_para[i].axone_sd);
				fprintf (file_p, "BornMin: %d\n",
				    link_para[i].born_min);
				fprintf (file_p, "BornMax: %d\n",
				    link_para[i].born_max);
				fprintf (file_p, "InterCluster: %c\n",
				    link_para[i].inter_cluster);
				fprintf (file_p, "EndLink: *\n");
			}
		}
	} /* fin du if */
	else
	{
/*--- Decomptage des neurones ----------------------------------------------*/

		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			ordre = ordre_clust_wid[i];
			clust_wid[ordre].first_neuron = total_neurons;
			total_neurons += clust_wid[ordre].nb_neurons;
			clust_wid[ordre].last_neuron = total_neurons - 1;
		}
		nb_link = 0;
		for (i = 1; i <= max_link_para; i++)
		{
			if (link_para[i].cluster1 != 0)
				nb_link++;
		}

		fprintf (file_p, "TypeOfFile: LinkConfigurationFileVer2\n");
		fprintf (file_p, "Creator: SimpleEditor\n");

		if (placement_mode == AUTOMATIC)
		{
			fprintf (file_p, "PlacementMode: AUTOMATIC_MODE\n");
		}
		else
		{
			fprintf (file_p, "PlacementMode: MANUAL_MODE\n");
			fprintf (file_p, "WorkAreaWidth: %d\n", workArea_width);
			fprintf (file_p, "WorkAreaHeight: %d\n", workArea_height);
		}

		/* lnk file header */

		fprintf(file_p, "NumberOfNucleus: %d\n", nb_clusters_in_array);
		
		fprintf(file_p, "NumberOfInterNucleusLink: %d\n", nb_link);
		
		fprintf(file_p, "TotalNeuronsInNetwork: %d\n", total_neurons);


		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			j = ordre_clust_wid [i];
			nb_link = 0;
			for (k = 1; k <= max_link_para; k++)
			{
				if (link_para[k].cluster1 == j)
					nb_link++;
			}
			fprintf (file_p, "BeginNucleus: *\n");
			fprintf (file_p, "NucleusName: %s\n", clust_wid[j].ch_name);
			fprintf (file_p, "NucleusId: %d\n", j);
			fprintf (file_p, "NumberOfClusters: 1\n");
			fprintf (file_p, "NumberOfInterClusterLink: %d\n", nb_link);
			fprintf (file_p, "TotalNeuronsInNucleus: %d\n", clust_wid[j].nb_neurons);
			fprintf (file_p, "NucleusPositionH: 0\n");
			fprintf (file_p, "NucleusDeltaH: 10\n");
			fprintf (file_p, "NucleusPositionL: 0\n");
			fprintf (file_p, "NucleusDeltaL: 10\n");
			fprintf (file_p, "NucleusPositionAP: 0\n");
			fprintf (file_p, "NucleusDeltaAP: 10\n");

			fprintf (file_p, "BeginCluster: *\n");
			fprintf (file_p, "ClusterName: %s\n", clust_wid[j].ch_name);
			fprintf (file_p, "ClusterId: %d\n", j);
			fprintf (file_p, "ClusterPxManual: %d\n", clust_wid[j].px_manual);
			fprintf (file_p, "ClusterPyManual: %d\n", clust_wid[j].py_manual);
			fprintf (file_p, "YetPlaced: %d\n", clust_wid[j].yet_placed);
			fprintf (file_p, "PositionH: %d\n", clust_wid[j].position_H);
			fprintf (file_p, "DeltaH: %d\n", ((clust_wid[j].delta_H)?clust_wid[j].delta_H:10));
			fprintf (file_p, "PositionL: %d\n", clust_wid[j].position_L);
			fprintf (file_p, "DeltaL: %d\n", ((clust_wid[j].delta_L)?clust_wid[j].delta_L:10));;
			fprintf (file_p, "PositionAP: %d\n", clust_wid[j].position_AP);
			fprintf (file_p, "DeltaAP: %d\n", ((clust_wid[j].delta_AP)?clust_wid[j].delta_AP:10));
			fprintf (file_p, "NoAuto: %d\n", clust_wid[j].no_auto);
			fprintf (file_p, "NbNeurons: %d\n", clust_wid[j].nb_neurons);
			fprintf (file_p, "NeuronFile: %s\n", clust_wid[j].neuron_file);

			if (clust_wid[j].shape == (char)NULL)
			{
				fprintf  (file_p, "ClusterShape: e\n");
			}
			else
			{
				fprintf (file_p, "ClusterShape: %c\n", clust_wid[j].shape);
			}
			fprintf (file_p, "EndCluster: *\n");

			for (k = 1; k <= max_link_para; k++)
			{
				if (link_para[k].cluster1 == j)
				{
					fprintf (file_p, "BeginLink: *\n");
					fprintf (file_p, "Cluster1: %d\n",clust_wid[link_para[j].cluster1].numero);
					fprintf (file_p, "Cluster2: %d\n",clust_wid[link_para[j].cluster2].numero);
					fprintf (file_p, "AxoneMean: %d\n",
					    link_para[j].axone_mean);
					fprintf (file_p, "AxoneSd: %d\n",
					    link_para[j].axone_sd);
					fprintf (file_p, "BornMin: %d\n",
					    link_para[j].born_min);
					fprintf (file_p, "BornMax: %d\n",
					    link_para[j].born_max);
					fprintf (file_p, "Connectivity: %f\n",
					    link_para[j].K_connections);
					switch(link_para[j].deconnect)
					{
						case _FULLY_CONNECTED_:
							fprintf (file_p, "PType: %d\n",_FULLY_CONNECTED_); break;
						case _PART_SEND_:
							fprintf (file_p, "PType: %d\n",_PART_SEND_); break;
						case _PART_RECEIVE_:
							fprintf (file_p, "PType: %d\n",_PART_RECEIVE_); break;
						case _PART_AVERAGE_:
							fprintf (file_p, "PType: %d\n",_PART_AVERAGE_);
					} /* fin du switch */
					switch(link_para[j].inter_cluster)
					{
						case '0':
							fprintf (file_p, "Type: %d\n",_FULL_NOT_CONNECTED_); break;
						case '+':
							fprintf (file_p, "Type: %d\n",_FULL_EXCITATION_); break;
						case '-':
							fprintf (file_p, "Type: %d\n",_FULL_INHIBITION_); break;
						case 'r':
							fprintf (file_p, "Type: %d\n",_FULL_RANDOMIZED_); break;
						case 'm':
							fprintf (file_p, "Type: %d\n",_PART_RANDOMIZED_);
					} /* fin du switch */
					fprintf (file_p, "Nmda: 0\n");
					fprintf (file_p, "EndLink: *\n");
				}
			}
			fprintf (file_p, "EndNucleus: *\n");
		}

		for (i = 1; i <= max_link_para; i++)
		{
			if (link_para[i].cluster1)
			{
				fprintf (file_p, "BeginLinkInterNucleus: *\n");
				fprintf (file_p, "Nucleus1: %d\n", clust_wid[link_para[i].cluster1].numero);
				fprintf (file_p, "Nucleus2: %d\n", clust_wid[link_para[i].cluster2].numero);
				fprintf (file_p, "INAxoneMean: %d\n",
				    link_para[i].axone_mean);
				fprintf (file_p, "INAxoneSd: %d\n",
				    link_para[i].axone_sd);
				fprintf (file_p, "INBornMin: %d\n",
				    link_para[i].born_min);
				fprintf (file_p, "INBornMax: %d\n",
				    link_para[i].born_max);
				fprintf (file_p, "INConnectivity: %f\n",
					 link_para[i].K_connections);
				switch(link_para[i].deconnect)
				{
				        case _FULLY_CONNECTED_:
					  fprintf (file_p, "INPType: %d\n",_FULLY_CONNECTED_); break;
				        case _PART_SEND_:
					  fprintf (file_p, "INPType: %d\n",_PART_SEND_); break;
				        case _PART_RECEIVE_:
					  fprintf (file_p, "INPType: %d\n",_PART_RECEIVE_); break;
				        case _PART_AVERAGE_:
					  fprintf (file_p, "INPType: %d\n",_PART_AVERAGE_);
				} /* fin du switch */
				switch(link_para[i].inter_cluster)
				{
					case '0':
						fprintf (file_p, "INInterCluster: %d\n",_FULL_NOT_CONNECTED_);
						fprintf (file_p, "INType: %d\n",_FULL_NOT_CONNECTED_); break;
					case '+':
						fprintf (file_p, "INInterCluster: %d\n",_FULL_EXCITATION_);
						fprintf (file_p, "INType: %d\n",_FULL_EXCITATION_); break;
					case '-':
						fprintf (file_p, "INInterCluster: %d\n",_FULL_INHIBITION_);
						fprintf (file_p, "INType: %d\n",_FULL_INHIBITION_); break;
					case 'r':
						fprintf (file_p, "INInterCluster: %d\n",_FULL_RANDOMIZED_);
						fprintf (file_p, "INType: %d\n",_FULL_RANDOMIZED_); break;
					case 'm':
						fprintf (file_p, "INInterCluster: %d\n",_PART_RANDOMIZED_);
						fprintf (file_p, "INType: %d\n",_PART_RANDOMIZED_);
				} /* fin du switch */
				fprintf (file_p, "INNmda: 0\n");
				fprintf (file_p, "EndLinkInterNucleus: *\n");
			}
		}
	} /* fin du else */
	fclose (file_p);

	file_modified = FALSE;
}

/*----------------------------------------------------------------------------
 *	R E A D _ S A V E _ F I L E
 *--------------------------------------------------------------------------*/

void	read_save_file (char *file_name)
{
	int		i, j, new_cluster, no_link, clust1, clust2;
	FILE		*file_p ;
	char		*pt,tmp[255],char_buffer[1000], *cnx_name;
	char		parametre[256], value[256];
	XmString	xm_string;
	char 		cmd[256];
/*	char		file_name[256]; */
	int             project;
	int 		file;
	int		inter;
	

/* test si le repertoire "project" existe */

	
	project = (opendir(project_directory) == NULL);
#if DEBUG
	printf("project_directory: %s\n",project_directory);
#endif
	if(file_name)
	{
#if 0
		sprintf(cmd,"%s/%s.ntw",current_directory,savefile_name);
#endif
#if DEBUG
		printf("Read_save_file 1: %s\n",savefile_name);
#endif
		file = !(file_p = fopen(file_name,"r"));
		if(file)
		{
			XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
				      0);
			sprintf(char_buffer,
				"Sorry, both directory %s and\n file %s\n do not exist !",
				project_directory,savefile_name);
			display_error(widget_array_le[k_MainW_lew],char_buffer);
				
			strcpy(current_directory,getenv("HOME"));
			strcpy(project_directory,current_directory);
			strcat(project_directory,"/noname");
			*savefile_name = '\0';
			sprintf(char_buffer,"XNBC Link Editor %s: noname",VERSION);
			XtVaSetValues (topLevelShell,
	    		XtNtitle, char_buffer,
	    		NULL);
		    XtVaSetValues(widget_array_le[k_PushBG_Save_lew],
				XmNsensitive,False,NULL);
			return;
			
		}
		else
		{
#if 0
			sprintf(char_buffer,"%s/%s.ntw",current_directory,savefile_name);
			strcpy(file_name,char_buffer);
#endif
			sprintf(char_buffer,"XNBC Link Editor %s: %s", VERSION, file_name);
			XtVaSetValues (topLevelShell,
	    		XtNtitle,char_buffer ,
	    		NULL);
			XtVaSetValues(widget_array_le[k_PushBG_Save_lew],
				XmNsensitive,True,NULL);
		}
	}
	else
	{
#if DEBUG
		printf("Read_save_file 2: %s/%s.ntw\n",project_directory,savefile_name);
#endif
		sprintf(cmd,"%s/%s.ntw",project_directory,savefile_name);

		file = !(file_p = fopen(cmd,"r"));
		if(file)
		{
			XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
				      0);
			sprintf(char_buffer,
				"Creating new network...");
			display_message(widget_array_le[k_MainW_lew],char_buffer);
			sprintf(char_buffer,"XNBC Link Editor %s: %s", VERSION, savefile_name);
			XtVaSetValues (topLevelShell,
				       XtNtitle,char_buffer ,
				       NULL);
		    XtVaSetValues(widget_array_le[k_PushBG_Save_lew],
				XmNsensitive,True,NULL);
			file_named = TRUE;
			return;
			
		}
		else
		{
			sprintf(char_buffer,"%s/%s.ntw",project_directory,savefile_name);
			strcpy(file_name,char_buffer);
			sprintf(char_buffer,"XNBC Link Editor %s: %s", VERSION, savefile_name);
			XtVaSetValues (topLevelShell,
	    		XtNtitle,char_buffer ,
				       NULL);
			XtVaSetValues(widget_array_le[k_PushBG_Save_lew],
				XmNsensitive,True,NULL);
		}
	}

/*--- Verifie la validite du fichier ---------------------------------------*/

	if (!file_p)
	{
		display_message (parent,
		    "I can't open this file. I am sorry.");
		    
		strcpy(	current_directory,getenv("HOME"));
		strcpy(project_directory,current_directory);
		strcat(project_directory,"/noname");
		*savefile_name = '\0';
		sprintf(char_buffer,"XNBC Link Editor %s: noname",VERSION);
		XtVaSetValues (topLevelShell,
			       XtNtitle, char_buffer,
			       NULL);
		XtVaSetValues(widget_array_le[k_PushBG_Save_lew],
			      XmNsensitive,False,NULL);
		return;
	}
	else
	{
		file_named = TRUE;
	}
	fgets (char_buffer, 100, file_p);
	sscanf (char_buffer, "%s %s", parametre, value);


	if (strcmp (parametre, "TypeOfFile:") ||
	    strcmp (value, "LinkConfigurationFileVer2"))
	{
		display_message (parent,
		    "This is not a link configuration file.");
		return;
	}
	/* Check if it comes from link_edit or network_editor */
	fgets (char_buffer, 100, file_p);
	sscanf (char_buffer, "%s %s", parametre, value);
	if (strcmp (parametre, "Creator:"))
	{
		display_message (parent,
		    "This is not a link configuration file.");
		return;
	}
	else
	if (!strcmp (value, "FullEditor"))
	{
		display_message (parent,
		    "WARNING: This link file was created by the full featured editor.\n You will loose details...");
	} /* fin du if */
	else if (strcmp (value, "SimpleEditor"))
	{
		display_message (parent,
		    "Unknown Creator...I try nevertheless!.");
	} /* fin du else */
	/*---NumberOfClusters ---*/
	fgets (char_buffer, 100, file_p);
	sscanf (char_buffer, "%s %s", parametre, value);

/*--- Vide les tableaux ----------------------------------------------------*/

	if(nb_clusters_in_array)
	{
		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			j = ordre_clust_wid[i];
			XtDestroyWidget (clust_wid[j].form);
			clust_wid[j].form = (Widget) NULL;
			free (clust_wid[j].neuron_file);
			clust_wid[j].neuron_file = (char *)NULL;
		}
		nb_clusters_in_array = 0;
	}

	if(max_link_para)
	{
		for (i = 1; i <= max_link_para; i++)
		{
			link_para[i].cluster1 = 0;
			link_para[i].cluster2 = 0;
		}
		nb_links_in_array = 0;
	}

/*--- Lit le fichier ------------------------------------------------------*/

	while (fgets (char_buffer, 100, file_p))
	{
		sscanf (char_buffer, "%s %s", parametre, value);

/*--- Cluster Widgets -----------------------------------------------------*/

		if (!strcmp (parametre, "PlacementMode:"))
		{
			set_placement_mode (value);
			if(!strcmp(value,"MANUAL_MODE"))
				XmToggleButtonSetState(widget_array_le[k_PushBG_Manual_lew],True,True);
			else if(!strcmp(value,"AUTOMATIC_MODE"))
				XmToggleButtonSetState(widget_array_le[k_PushBG_Automatic_lew],True,True);
		}
		else if (!strcmp (parametre, "WorkAreaWidth:"))
		{
			sscanf (value, "%d", &workArea_width);
		}
		else if (!strcmp (parametre, "WorkAreaHeight:"))
		{
			sscanf (value, "%d", &workArea_height);
		}
		else if (!strcmp (parametre, "BeginNucleus:"))
		{
			new_cluster = alloc_new_clust_wid ();
		}
		else if (!strcmp (parametre, "NucleusName:"))
		{
			sscanf (value, "%s", clust_wid[new_cluster].ch_name);
		}
		else if (!strcmp (parametre, "ClusterPxManual:"))
		{
			sscanf (value, "%d", &(clust_wid[new_cluster].px_manual));
		}
		else if (!strcmp (parametre, "ClusterPyManual:"))
		{
			sscanf (value, "%d", &(clust_wid[new_cluster].py_manual));
		}
		else if (!strcmp (parametre, "YetPlaced:"))
		{
			sscanf (value, "%d", &(clust_wid[new_cluster].yet_placed));
		}
		else if (!strcmp (parametre, "PositionH:"))
		{
			sscanf (value, "%d", &(clust_wid[new_cluster].position_H));
		}
		else if (!strcmp (parametre, "DeltaH:"))
		{
			sscanf (value, "%d", &(clust_wid[new_cluster].delta_H));
		}
		else if (!strcmp (parametre, "NoAuto:"))
		{
			sscanf (value, "%d", &(clust_wid[new_cluster].no_auto));
		}
		else if (!strcmp (parametre, "PositionL:"))
		{
			sscanf (value, "%d", &(clust_wid[new_cluster].position_L));
		}
		else if (!strcmp (parametre, "DeltaL:"))
		{
			sscanf (value, "%d", &(clust_wid[new_cluster].delta_L));
		}
		else if (!strcmp (parametre, "PositionAP:"))
		{
			sscanf (value, "%d", &(clust_wid[new_cluster].position_AP));
		}
		else if (!strcmp (parametre, "DeltaAP:"))
		{
			sscanf (value, "%d", &(clust_wid[new_cluster].delta_AP));
		}
		else if (!strcmp (parametre, "TotalNeuronsInNucleus:"))
		{
			sscanf (value, "%d", &(clust_wid[new_cluster].nb_neurons));
		}
		else if (!strcmp (parametre, "NeuronFile:"))
		{
			clust_wid[new_cluster].neuron_file = str_dup (value);
		}
		else if (!strcmp (parametre, "ClusterShape:"))
		{
			sscanf (value, "%c", &(clust_wid[new_cluster].shape));
		}
		else if (!strcmp (parametre, "EndCluster:"))
		{
			/* Nothing yet */
		}

/*--- Link Parameters ------------------------------------------------------*/

		else if (!strcmp (parametre, "BeginLinkInterNucleus:"))
		{
			no_link = alloc_new_link_para (0, 0);
		}
		else if (!strcmp (parametre, "Nucleus1:"))
		{
			sscanf (value, "%d", &(link_para[no_link].cluster1));
		}
		else if (!strcmp (parametre, "Nucleus2:"))
		{
			sscanf (value, "%d", &(link_para[no_link].cluster2));
		}
		else if (!strcmp (parametre, "INAxoneMean:"))
		{
			sscanf (value, "%d", &(link_para[no_link].axone_mean));
		}
		else if (!strcmp (parametre, "INAxoneSd:"))
		{
			sscanf (value, "%d", &(link_para[no_link].axone_sd));
		}
		else if (!strcmp (parametre, "INBornMin:"))
		{
			sscanf (value, "%d", &(link_para[no_link].born_min));
		}
		else if (!strcmp (parametre, "INBornMax:"))
		{
			sscanf (value, "%d", &(link_para[no_link].born_max));
		}
		else if (!strcmp (parametre, "INConnectivity:"))
		{
			sscanf (value, "%f", &(link_para[no_link].K_connections));
		}
		else if (!strcmp (parametre, "INPType:"))
		{
			sscanf (value, "%d", &inter);
			switch(inter)
			{
				case _FULLY_CONNECTED_:
					link_para[no_link].deconnect = _FULLY_CONNECTED_; break;
				case _PART_SEND_:
					link_para[no_link].deconnect =  _PART_SEND_; break;
				case _PART_RECEIVE_:
					link_para[no_link].deconnect =  _PART_RECEIVE_; break;
				case _PART_AVERAGE_:
					link_para[no_link].deconnect =  _PART_AVERAGE_;
			} /* fin du switch */
		}
		else if (!strcmp (parametre, "INInterCluster:"))
		{
			sscanf (value, "%d", &inter);
			switch(inter)
			{
				case _FULL_NOT_CONNECTED_:
					link_para[no_link].inter_cluster = '0'; break;
				case _FULL_EXCITATION_:
					link_para[no_link].inter_cluster = '+'; break;
				case _FULL_INHIBITION_:
					link_para[no_link].inter_cluster = '-'; break;
				case _FULL_RANDOMIZED_:
					link_para[no_link].inter_cluster = 'r'; break;
				case _PART_RANDOMIZED_:
					link_para[no_link].inter_cluster = 'm';
			} /* fin du switch */

			/*---- LECTURE DU FICHIER LNK POUR GESTION MATRIX ---*/

				clust1 = link_para[no_link].cluster1;
				clust2 = link_para[no_link].cluster2;
				Notify_Matrix( clust1, clust2, 
				      clust_wid[clust1].nb_neurons,
				      clust_wid[clust2].nb_neurons);

				if (link_para[no_link].inter_cluster == 'm')      
					Notify_AVL(MANUEL);
				else if (link_para[no_link].inter_cluster == 'r')
					Notify_AVL(ALEAT);
				else if (link_para[no_link].inter_cluster == '+')
					Notify_AVL(EXCIT);
				else if (link_para[no_link].inter_cluster == '-')
					Notify_AVL(INHIB);
		}


		else if (!strcmp (parametre, "EndLink:"))
		{
			/* Nothing yet */
		}
	} /* fin du while */


	fclose (file_p);

	if (placement_mode == MANUAL)
	{
		
		XtVaSetValues (widget_array_le[k_DrawingA_Work_Area_lew],
		    XmNwidth, (Dimension) workArea_width,
		    XmNheight, (Dimension) workArea_height,
		    NULL);
	}

	for (i = 1; i <= nb_clusters_in_array; i++)
	{
		j = ordre_clust_wid[i];
		clust_wid[j].center_px = clust_wid[j].px
		    + CLUSTER_FORM_WIDTH / 2;
		clust_wid[j].center_py = clust_wid[j].py
		    + CLUSTER_FORM_HEIGHT / 2;
		decorate_clust_wid (j);
	}

	file_modified = FALSE;
	replace_clust_wids ();

	/* lecture de la matrice precedente */

	if (save_V7)
	{
		cnx_name = put_extension (file_name, "cnx");	

		if (!read_cnx(cnx_name))
		{
			XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
				      0);
			display_message (parent,
				    "I can't open the cnx file. I am sorry.");
		}
		free(cnx_name);
	} /* fin du if */
	else
	{

		if (!read_cnx(file_name))
		{
			XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
				      0);
			display_message (parent,
				    "I can't open the wgt or the len file.\nBe sure to redefine all intra and inter nuclei links.");
		}
	} /* fin du if */
		
	XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
		      0);


}

/****************************************************************************
 *									    *
 *	G E S T I O N   D E S   F I C H I E R S   D E   C O N N E X I O N   *
 *									    *
 ****************************************************************************/

/*----------------------------------------------------------------------------
 *	C R E A T E _ B O T H _ F I L E S
 *--------------------------------------------------------------------------*/

void	create_both_files ()
{
	char	*char_pointer, *cnx_name, *anat_name, *lnk_name,
		*len_name, *wgt_name, *clu_name;
	char	char_buffer[1024];
	char 	*pt;
	char    *home;
	char 	dir[256],pj[256],file[256];
	int	status,	yes_or_no;
	int 	project;
	char 	cmd[256];
	char 	file_name[256];
	FILE    *p_rc;
	
	if (!nb_links_in_array)
	{
		yes_or_no = display_question (parent, "ATTENTION: You did not define links.\nYou still save?");
		if (yes_or_no == NO_ANSWER)
			return;
	}

	if(!file_named)
		return;

	strcpy(file_name,savefile_name);
	
	
	cnx_name = put_extension (file_name, "cnx");
	anat_name = put_extension (file_name, "anat");
	lnk_name = put_extension (file_name, "ntw");
	len_name = put_extension (file_name, "len");
	wgt_name = put_extension (file_name, "wgt");			
	clu_name = put_extension (file_name, "clu");			
	
	sprintf (char_buffer, "Do you agree to use\n%s\n%s\n%s\n%s  and \n%s ?",
		 lnk_name, len_name, wgt_name, anat_name, clu_name);
	
	yes_or_no = display_question (parent, char_buffer);

	if (yes_or_no == YES_ANSWER)
	{
		XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
		working_cursor);
		XSync(the_display_le,True);
	
		create_cnx_file (file_name);
		create_anat_file (anat_name);
		full_save_file(lnk_name);
		
		file_named = True;
		
		XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
		None);
		

		if (cnx_name) free (cnx_name);
		if (anat_name) free (anat_name);
		if (len_name) free(len_name);
		if (wgt_name) free(wgt_name);
		if (clu_name) free(clu_name); 
		status = put_network_name(get_dir_name(),lnk_name);
#if DEBUG
		printf("status %d, lnk_name: %s\n",status, lnk_name);
#endif
		if (lnk_name) free (lnk_name);
	}
	else if (yes_or_no == NO_ANSWER)
	{
		if (cnx_name) free (cnx_name);
		if (anat_name) free (anat_name);
		if (lnk_name) free(lnk_name);
		if (len_name) free(len_name);
		if (wgt_name) free(wgt_name);
		if (clu_name) free(clu_name);
	
		char_pointer = display_fileselect (parent,
						   3, "*.ntw", 
						   "Input the network name :", NULL);
		
		if (!char_pointer) return;
		
		XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
			working_cursor);
			
		pt = strrchr(char_pointer,'/');
		if(pt)
		{
			strcpy(file,pt+1);
			*pt = '\0';
			strcpy(pj,char_pointer);
		}
		else
		{
			strcpy(file,char_pointer);
			strcpy(pj,".");
		}	
		pt = strrchr(file,'.');
		if(pt)
			*pt = '\0';
		strcpy(savefile_name,file);
		
		strcpy(dir,pj);
		if(strstr(pj,savefile_name))
		{
			pt = strrchr(dir,'/');
			if(pt)
				*pt = '\0';
		}	
/*	
		strcpy(project_directory,pj);
		strcpy(current_directory,dir);
*/	
		
		project = (opendir(project_directory)== 0);	
		if(project)
		{
			
			sprintf(char_buffer,"%s/%s.ntw",current_directory,savefile_name);
			strcpy(file_name,char_buffer);
		}
		else
		{
			sprintf(char_buffer,"%s/%s.ntw",project_directory,savefile_name);
			strcpy(file_name,char_buffer);
		}
	
	
	
		cnx_name = put_extension (file_name, "cnx");
		anat_name = put_extension (file_name, "anat");
		lnk_name = put_extension (file_name, "lnk");
		len_name = put_extension (file_name, "len");			
		wgt_name = put_extension (file_name, "wgt");			
		clu_name = put_extension (file_name, "clu");			
	
		
		XSync(the_display_le,True);
		
		create_cnx_file (file_name);
		if (cnx_name) free (cnx_name);
		if (len_name) free (len_name);
		if (wgt_name) free (wgt_name);
		if (clu_name) free(clu_name);
		
		create_anat_file (anat_name);
		if (anat_name) free (anat_name);

		
		full_save_file (lnk_name);
		put_network_name(get_dir_name(),lnk_name);
		if (lnk_name) free (lnk_name);
		
		XDefineCursor(the_display_le,XtWindow(widget_array_le[k_MainW_lew]),
			None);
		
		sprintf(char_buffer,"XNBC Link Editor %s: %s", VERSION, savefile_name);
			XtVaSetValues (topLevelShell,
		    	XtNtitle,char_buffer ,
		    	NULL);
		    	
		XtVaSetValues(widget_array_le[k_PushBG_Save_lew],
			XmNsensitive,True,NULL);
				
		file_named = True;
	}
}

/*----------------------------------------------------------------------------
 *	C R E A T E _ A N A T _ F I L E
 *--------------------------------------------------------------------------*/

void	create_anat_file (file)
char	*file;
{
	NEURON_ANATOMY	*anatomy;
	struct	les_neur
	{
		short	neuron_id;
		short	cluster_id;
	} *les_neurones;

	int	set = (int) time (0) & 077;
	int	i, j, ij, k = 0, ordre, total_neurons = 0;
	int	enough = TRUE;
	int	cont;
	int	yes_or_no;
	short one;
	float	a, b, c, H, L, AP;
	FILE	*file_p;
	char	char_buffer[256];
	char dir[255];
	char *pt;
	char cmd[255];
	char *file_name;


/*--- Ouverture du fichier -------------------------------------------------*/

	if (!file)
	{
		file_name = display_fileselect (parent, 5, "*.anat",
		    "Input the name of the anatomy file :", NULL);

		if (!file_name) return;
		file_name = put_extension (file_name, "anat");
		file_p = fopen (file_name, "w");
		free(file_name);
	}
	else
		file_p = fopen (file, "w");
	
	if(!file_p)
	{
		display_error(parent,"Sorry, can't create anatomy file...");
		return;
	}
	

/*--- Decomptage des neurones ----------------------------------------------*/

	total_neurons = 0;
	for (i = 1; i <= nb_clusters_in_array; i++)
	{
		ordre = ordre_clust_wid[i];
		clust_wid[ordre].first_neuron = total_neurons;
		total_neurons += clust_wid[ordre].nb_neurons;
		clust_wid[ordre].last_neuron = total_neurons - 1;
	}

	les_neurones = (struct les_neur *)calloc(total_neurons,sizeof (struct les_neur));
	j = 0;
	for (i = 1; i <= nb_clusters_in_array; i++)
	{
		ordre = ordre_clust_wid[i];
		for (ij = 1; ij <= clust_wid[ordre].nb_neurons; ij++)
		{
			les_neurones[j].neuron_id = (short)j+1;
			les_neurones[j].cluster_id = (short)ordre;
			j++;
		}
	}

/*--- Allocation de memoire ------------------------------------------------*/

	if ( !(anatomy = (NEURON_ANATOMY *) calloc (total_neurons,
	    sizeof (NEURON_ANATOMY))) )
	{
		display_message (parent, "Not enough memory. Try later.");
		enough = FALSE;
	}

/*--- Remplissage du tableau -----------------------------------------------*/

	if (enough)
	{
		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			ordre = ordre_clust_wid[i];
			a = (float) clust_wid[ordre].delta_H / 2.;
			b = (float) clust_wid[ordre].delta_L / 2.;
			c = (float) clust_wid[ordre].delta_AP / 2.;

			for (j = 1; j <= clust_wid[ordre].nb_neurons; j++)
			{
				cont = TRUE;
				do
				{
					H = (2. * ran1 (&set) - 1.);
					L = (2. * ran1 (&set) - 1.);
					AP = (2. * ran1 (&set) - 1.);
					if (clust_wid[ordre].shape == 'e')
					{
						cont = ((H * H + L * L + AP * AP) > 1.);
					}
					else
					{
						cont = FALSE;
					}
				} while (cont);

				anatomy[k].H = a * H +
				    (float) clust_wid[ordre].position_H;
				anatomy[k].L = b * L +
				    (float) clust_wid[ordre].position_L;
				anatomy[k].AP = c * AP +
				    (float) clust_wid[ordre].position_AP;
				k++;
			}
		}

/*--- Ecriture du fichier --------------------------------------------------*/

		if (save_V7)
		{
			fwrite ((short *)&nb_clusters_in_array, sizeof(short), 1, file_p);

			for (i = 1; i <= nb_clusters_in_array; i++)
			{
				fwrite ((short *)&(clust_wid[ordre_clust_wid[i]].nb_neurons),
				    sizeof(short), 1, file_p);
			}

			for (i = 0; i < total_neurons; i++)
			{
				fwrite (&(anatomy[i]), sizeof (NEURON_ANATOMY), 1, file_p);
			}
		}
		else
		{
			
			/* The semantic of the .anat file is quite simple:
					<short>	number of nucleus (here = cluster) in network
					<short> number of neurons in nucleus 1
					<short> number of neurons in nucleus 2
					....
				then for each neuron:	
					<NEURON_ANATOMY> -> float x 3: H , L , AP 	(12 bytes)
			*/
			/* nb de noyaux */
			one = (short)nb_clusters_in_array;
			fwrite (&one, sizeof(short), 1, file_p);
			/* nb de neurones dans ces noyaux */
			for (ij = 1; ij <= nb_clusters_in_array; ij++)
			{
				one = (short)(clust_wid[ordre_clust_wid[ij]].nb_neurons);
				fwrite (&one, sizeof(short), 1, file_p);
			}
			for (i = 0; i < total_neurons; i++)
			{
				/* l'identite du neurone */
				one = les_neurones[i].neuron_id;
				fwrite(&one,sizeof(short),1,file_p);
				one = les_neurones[i].cluster_id;
				fwrite(&one,sizeof(short),1,file_p);
				fwrite (&(anatomy[i]), sizeof (NEURON_ANATOMY), 1, file_p);
			}
		
		} /* fin du else */
	}
	fclose(file_p);

/*--- Liberation de la memoire ---------------------------------------------*/

	if (anatomy)
	{
		free (anatomy);
	}
	if (les_neurones)
	{
		free (les_neurones);
	}
}

/*----------------------------------------------------------------------------
 *	C R E A T E _ C N X _ F I L E
 *--------------------------------------------------------------------------*/

void	create_cnx_file (file)
char	*file;
{
	NEURON_CONNECTIONS	*connect = (NEURON_CONNECTIONS *)NULL;
	struct	les_neur
	{
		short	neuron_id;
		short	cluster_id;
	} *les_neurones;

	int		i, j, ij, k, jk, ordre, total_neurons = 0;
	int		clust1, first1, last1, clust2, first2, last2;
	int		enough = TRUE;
	int 		Cle, Compt, Type, OnOff, Etat;
	int		yes_or_no;
	float		length;
	FILE		*file_p;
	char		char_buffer[256];
	short		axone, knobs;
	short		one, nb_cnx, nb_neurons_nuc;
	char cmd[255];
	char dir[255];
	char *pt;
	char *file_name;


/*--- Decomptage des neurones ----------------------------------------------*/

	total_neurons = 0;
	for (i = 1; i <= nb_clusters_in_array; i++)
	{
		ordre = ordre_clust_wid[i];
		clust_wid[ordre].first_neuron = total_neurons;
		total_neurons += clust_wid[ordre].nb_neurons;
		clust_wid[ordre].last_neuron = total_neurons - 1;
#if DEBUG
		printf("Cluster %d: %d %d\n", ordre,
		       clust_wid[ordre].first_neuron,
		       clust_wid[ordre].last_neuron);
#endif
	}
/*--- Allocation de memoire ------------------------------------------------*/

	if ( !(les_neurones = (struct les_neur *)calloc(total_neurons,sizeof (struct les_neur))))
	{
		display_message (parent, "Not enough memory. Try later.");
		enough = FALSE;
	}

	if ( !(connect = (NEURON_CONNECTIONS *) calloc (total_neurons,
	    sizeof (NEURON_CONNECTIONS))) )
	{
		display_message (parent, "Not enough memory. Try later.");
		enough = FALSE;
	}

	for (i = 0; i < total_neurons; i++)
	{
		if ( !(connect[i].axone_length = (short *) calloc (total_neurons,
		    sizeof (short))) )
		{
			display_message (parent, "Not enough memory. Try later.");
			enough = FALSE;
		}
		
		if ( !(connect[i].synaptic_knobs = (short *) calloc (total_neurons,
		    sizeof (short))) )
		{
			display_message (parent, "Not enough memory. Try later.");
			enough = FALSE;
		}
	}

/*--- Remplissage des tableaux ---------------------------------------------*/
	
	if (enough)
	{
		j = 0;
		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			ordre = ordre_clust_wid[i];
			for (ij = 1; ij <= clust_wid[ordre].nb_neurons; ij++)
			{
				les_neurones[j].neuron_id = (short)j+1;
				les_neurones[j].cluster_id = (short)ordre;
#if DEBUG
				printf("Neurone %d: %d %d\n", j,
				       les_neurones[j].neuron_id,
				       les_neurones[j].cluster_id);
#endif
				j++;
			}
		}
		for (i = 1; i <= max_link_para; i++)
		{
			if (clust1 = link_para[i].cluster1)
			{
				first1 = clust_wid[clust1].first_neuron;
				last1 = clust_wid[clust1].last_neuron;

				clust2 = link_para[i].cluster2;
				first2 = clust_wid[clust2].first_neuron;
				last2 = clust_wid[clust2].last_neuron;
				
				Cle = Create_Cle(clust1,clust2);				
				Find_noeud = search_listeD(Cle, &LIENS);
				Compt =0;
				for (j = first1; j <= last1; j++)
				{
					for (k = first2; k <= last2; k++)
					{
						if (Find_noeud != NULL)
						{
							Type    = Find_noeud->elem.Type;
							OnOff = Find_noeud->elem.Matrix[Compt].OnOff;
							Etat = Find_noeud->elem.Matrix[Compt].Etat;
						}
						else 
						{
							OnOff = 1;
							Type =0;
							Etat = 0;
						}	
						if (OnOff)
						{
							
							one_connection (i, &axone, &knobs, Type, Etat);
							(connect[j].axone_length)[k] = axone;
							(connect[j].synaptic_knobs)[k] = knobs;
						}
						else
						{
							(connect[j].axone_length)[k]    = 0;
							(connect[j].synaptic_knobs)[k] = 0;							
						}
						Compt++;
					}
				}
			}
		}

#if DEBUG
		printf("matrice OK, on va l'ecrire...\n");
#endif
/*--- Ecriture du fichier --------------------------------------------------*/

/*------------------------------------------------------------------------*
	    The semantic of the len ver2 file is as it follows:

			    -it's made of decimal short integers (except the length, a float)
			    -first token is the number of nucleus in the network      1 short
			    -then, for each nucleus,follows its number of neurons     nb_nucl * 1 short
			    -at this point starts the connections area:
				    for each nucleus,
					    for each neuron, are sequentially specified
					    - neuron id                                      1 short
						    - cluster id                             1 short
						    - number of neurons connected to the specified  
							    neuron (in fact, the number of connections) nb_con * 1 short
						    - for each target neuron is specified:
							    -the target id                              1 short
							    -the axone length in ms                     1 float

*-------------------------------------------------------------------------*/
		/*--- Ouverture du fichier len ---------------------------------------------*/

		if (!file)
		{
			file_name = display_fileselect (parent, 5, "*.len",
			    "Input the name of the axon length file :", NULL);

			if (!file_name) return;
			file_name = put_extension (file_name, "len");
		}
		else
		{
			file_name = put_extension (file, "len");
		} /* fin du else */
		file_p = fopen (file_name, "w");
		free(file_name);

		if(!file_p)
		{
			display_error(parent,"Sorry, can't create axon length file...");
			return;
		}
		/* nb de noyaux */
		one = (short)nb_clusters_in_array;
		fwrite (&one, sizeof(short), 1, file_p);
		/* nb de neurones dans ces noyaux */
		for (ij = 1; ij <= nb_clusters_in_array; ij++)
		{
			one = (short)(clust_wid[ordre_clust_wid[ij]].nb_neurons);
			fwrite (&one, sizeof(short), 1, file_p);
		}

		/* pour chaque noyau */
		j = 0;
		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			ordre = ordre_clust_wid[i];
			/* pour chaque neurone */
			for (ij = clust_wid[ordre].first_neuron; ij <= clust_wid[ordre].last_neuron; ij++)
			{
				/* l'identite du neurone */
				one = les_neurones[ij].neuron_id;
				fwrite(&one,sizeof(short),1,file_p);
				one = les_neurones[ij].cluster_id;
				fwrite(&one,sizeof(short),1,file_p);
				nb_cnx = 0;
				for (jk = 0; jk < total_neurons; jk++)
				{
					if (connect[ij].axone_length[jk])
						nb_cnx++;
				}
				/* le nb de connexions */
				fwrite (&nb_cnx, sizeof(short), 1, file_p);
				for (jk = 0; jk < total_neurons; jk++)
				{
					if (connect[ij].axone_length[jk])
					{
						one = (short)(jk+1);
						/* a quoi il est connecte et la longueur */
						fwrite (&one, sizeof(short), 1, file_p);
						length = (float)connect[ij].axone_length[jk];
						fwrite (&length, sizeof(float), 1, file_p);
					} /* fin du if */
				}
			}
		}
		if (file_p) fclose(file_p);
#if DEBUG
		printf("matrice des longueurs OK, ecrite...\n");
#endif
		

/*------------------------------------------------------------------------*
	The semantic of the wgt ver2 file is as it follows:

			-it's made of decimal short integers
			-first token is the number of nucleus in the network
			-then, for each nucleus,follows its number of neurons
			-at this point starts the connections area:
				for each nucleus,
					for each neuron, are sequentially specified
						- neuron id
						- cluster id 
						- number of neurons connected to the specified
							neuron (in fact, the number of connections)
						- for each target neuron is specified:
							-the target id
							-the nmda flag
							-the synaptic weight (nb knobs),that's 
								algebric (can be positive or negative)


*-------------------------------------------------------------------------*/
		/*--- Ouverture du fichier wgt ---------------------------------------------*/


		if (!file)
		{
			file_name = display_fileselect (parent, 5, "*.wgt",
			    "Input the name of the weight file :", NULL);

			if (!file_name) return;
			file_name = put_extension (file_name, "wgt");
		}
		else
		{
			file_name = put_extension (file, "wgt");
		} /* fin du else */
		file_p = fopen (file_name, "w");
		free(file_name);

		if(!file_p)
		{
			display_error(parent,"Sorry, can't create weight file...");
			return;
		}
		/* nb de noyaux */
		one = (short)nb_clusters_in_array;
		fwrite (&one, sizeof(short), 1, file_p);
		/* nb de neurones dans ces noyaux */
		for (ij = 1; ij <= nb_clusters_in_array; ij++)
		{
			one = (short)(clust_wid[ordre_clust_wid[ij]].nb_neurons);
			fwrite (&one, sizeof(short), 1, file_p);
		}

		/* pour chaque noyau */
		j = 0;
		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			ordre = ordre_clust_wid[i];
			nb_neurons_nuc = clust_wid[ordre].nb_neurons;
			/* pour chaque neurone */
			for (ij = clust_wid[ordre].first_neuron; ij <= clust_wid[ordre].last_neuron; ij++)
			{
				/* l'identite du neurone */
				one = les_neurones[ij].neuron_id;
				fwrite(&one,sizeof(short),1,file_p);
				one = les_neurones[ij].cluster_id;
				fwrite(&one,sizeof(short),1,file_p);
				nb_cnx = 0;
				for (jk = 0; jk < total_neurons; jk++)
				{
					if (connect[ij].axone_length[jk])
						nb_cnx++;
				}
				if (debug)
					fprintf(fdbg, "Neurone %d: %d connexions:\n", ij+1, nb_cnx);
				/* le nb de connexions */
				fwrite (&nb_cnx, sizeof(short), 1, file_p);
				for (jk = 0; jk < total_neurons; jk++)
				{
					if (connect[ij].axone_length[jk])
					{
						if (debug)
							fprintf(fdbg, "\tto neuron %d: axon: %d, weight: %d\n",
							       jk+1, connect[ij].axone_length[jk],
							       connect[ij].synaptic_knobs[jk]);
						one = (short)jk+1;
						/* a quoi il est connecte et la longueur */
						fwrite (&one, sizeof(short), 1, file_p);
						one = 0;		/* pas de NMDA */
						fwrite (&one, sizeof(short), 1, file_p);
						/*
						 * Si pas d'autoconnexions, 
						 * on met un poids de 0
						 */
						if (clust_wid[ordre].no_auto && (ij == jk))
							connect[ij].synaptic_knobs[jk] = 0;
						fwrite (&(connect[ij].synaptic_knobs[jk]),
							sizeof(short), 1, file_p);
					} /* fin du if */
				}
			}
		}
		if (file_p) fclose(file_p);
#if DEBUG
		printf("matrice des poids OK, ecrite...\n");
#endif
/*------------------------------------------------------------------------*
	The semantic of the clu ver2 file is as it follows:

			-it lists the neuron file names and the corresponding clusters
			full_filename : list of cluster ids
			full_filename : list of cluster ids
			....


*-------------------------------------------------------------------------*/
		/*--- Ouverture du fichier clu ---------------------------------------------*/

		if (!file)
		{
			file_name = display_fileselect (parent, 5, "*.clu",
			    "Input the name of the clusters file :", NULL);

			if (!file_name) return;
			file_name = put_extension (file_name, "clu");
		}
		else
		{
			file_name = put_extension (file, "clu");
		} /* fin du else */
		file_p = fopen (file_name, "w");
		free(file_name);

		if(!file_p)
		{
			display_error(parent,"Sorry, can't create the clusters file...");
			return;
		}
#if DEBUG
		printf("fichier clu, ouvert...\nnb de cluster in array: %d\n",nb_clusters_in_array);
#endif
 
		char_buffer[0] = '\0';
		for (i = 1; i <= nb_clusters_in_array; i++)
		{
			ordre = ordre_clust_wid[i];

			if (strcmp(clust_wid[ordre].neuron_file,char_buffer))
			{
				if (i == 1)
				{
					fprintf(file_p,"%s : %d ",
						clust_wid[ordre].neuron_file, ordre);
				} /* fin du if */
				else
				{
					fprintf(file_p,"\n%s : %d ",
						clust_wid[ordre].neuron_file, ordre);
				} /* fin du else */
				strcpy(char_buffer,clust_wid[ordre].neuron_file);
			} /* fin du if */
			else
			{
				fprintf(file_p,"%d ", ordre);
			} /* fin du else */
		}
		fprintf(file_p,"\n");
		if (file_p) fclose(file_p);
	} /* fin du else */

#if DEBUG
		printf("fichier clu OK, ecrit...\n");
#endif

/*--- Liberation de la memoire ---------------------------------------------*/

	if (connect)
	{
		for (i = 0; i < total_neurons; i++)
		{
			if (connect[i].axone_length)
			{
				free (connect[i].axone_length);
			}
			if (connect[i].synaptic_knobs)
			{
				free (connect[i].synaptic_knobs);
			}
		}
		free (connect);
	}
	if (les_neurones)
	{
		free (les_neurones);
	}
}
	
/*----------------------------------------------------------------------------
 *	O N E _ C O N N E C T I O N
 *--------------------------------------------------------------------------*/

void	one_connection (int i, short *axone, short *knobs, int type, int etat)
{
	int	set = (int) time (0) & 077;
	float	float_buffer;
 
	float_buffer = gasdev(&set) * (float)link_para[i].axone_sd +
	    (float)link_para[i].axone_mean;

	*axone = (short) floor ((double) float_buffer + 0.5);

	float_buffer = (float) link_para[i].born_min + ran1 (&set) 
	    * ((float) link_para[i].born_max - (float) link_para[i].born_min);

	*knobs = (short) floor ((double) float_buffer + 0.5);

	if (type == MANUEL)
	{
		if (etat == EXCIT) return;  else *knobs = -(*knobs);
	}
	else
	{
		if (link_para[i].inter_cluster == '+')
		{
			return;
		}
		else if (link_para[i].inter_cluster == '-')
		{
			*knobs = -(*knobs);
			return;
		}
		else if ((link_para[i].inter_cluster == 'r') 
			||(link_para[i].inter_cluster == 'a'))
		{
			if (ran1 (&set) < 0.5)
			{
				*knobs = -(*knobs);
			}
			return;
		}
	}
}
/*--- End of file ---*/

