#define _MEMSPY_ 0

/*----------------------------------------------------------------------------
 *	M E S S A G E _ B O X E S . C
 *--------------------------------------------------------------------------*/

/*
*
*	Author: Patrick GLANDAZ
*		Laboratoire de Biomathematiques
*		URBB B3E INSERM U263
*		Faculte de Medecine Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert, July 1992 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is not, in any way, usable for commercial purpose.
*
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
/*
 * MOTIF include files needed for widget creation.
 */
#include <Xm/XmP.h>
#include <Xm/Xm.h>
#include <Xm/ArrowB.h>
#include <Xm/TextF.h>
#include <Xm/Separator.h>
#include <Xm/CascadeB.h>
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>
#include <Xm/Label.h>
#include <Xm/List.h>
#include <Xm/Text.h>
#include <Xm/DrawingA.h>
#include <Xm/Frame.h>
#include <Xm/PanedW.h>
#include <Xm/Scale.h>
#include <Xm/MainW.h>
#include <Xm/ScrolledW.h>
#include <Xm/Form.h>
#include <Xm/MessageB.h>
#include <Xm/FileSB.h>
#include <Xm/SelectioB.h>
#include <Xm/BulletinB.h>
#include <Xm/RowColumn.h>
#include <Xm/RowColumn.h>
#include <Xm/DialogS.h>
#include <Xm/MenuShell.h>
#include <Xm/SeparatoG.h>
#include <Xm/PushBG.h>
#include <Xm/LabelG.h>


#include "le_vms_or_unix.h"
#include "le_messbox.h"
#include "le_strdup.h"
#include "le_typedefs.h"
#include "cluster_link.h"

#if _MEMSPY_
#include "/u/sa2/boussard/MEMORY/memspy.h"
#endif

#define	   WAITING_ANSWER_ACTION	1
#define	   ANSWER_RECEIVED_ACTION	2
#define	   NO_WAITING_ACTION		3

static	char	prompt_value[64];
static	char	fileselect_value[256];
static	int	action_mb;
static	int	answer_mb;
static	char	dir_tab[NB_DIR_TAB][256];
static	int	first_fileselect = TRUE;

static	Widget	message_dialog = (Widget)NULL;
static	Widget	prompt_dialog = (Widget)NULL;
static	Widget	error_dialog = (Widget)NULL;
static	Widget	question_dialog = (Widget)NULL;
static	Widget	fileselect_dialog = (Widget)NULL;

extern XtAppContext app_context;

void	mb_ok_proc (Widget, XtPointer, XmAnyCallbackStruct *);
void	mb_cancel_proc (Widget, XtPointer, XmAnyCallbackStruct *);


/*----------------------------------------------------------------------------
 *	D I S P L A Y _ M E S S A G E
 *--------------------------------------------------------------------------*/

int	display_message (Widget caller, char *msg)
/*
Widget	caller;
char	*msg;
*/
{
	XmString	xm_string;
	Display		*disp = XtDisplay (caller);

/*--- Message Dialog -------------------------------------------------------*/

	message_dialog = XmCreateMessageDialog (caller,
	    "message_dialog", NULL, 0);
	XtVaSetValues (message_dialog,
	    XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL,
	    NULL);
	XtUnmanageChild (
	    XmMessageBoxGetChild (message_dialog, XmDIALOG_CANCEL_BUTTON));
	XtUnmanageChild (
	    XmMessageBoxGetChild (message_dialog, XmDIALOG_HELP_BUTTON));
	XtAddCallback (message_dialog, XmNokCallback,(XtPointer)mb_ok_proc,
	(XtPointer)(unsigned long) k_MessageD_mb);

/*--- Remplissage de la fenetre --------------------------------------------*/

	xm_string = XmStringCreateLtoR (msg, XmSTRING_DEFAULT_CHARSET);

	XtVaSetValues(XtParent(message_dialog),XmNtitle,"Message",NULL);
		
	XtVaSetValues (message_dialog,
	    XmNmessageString, xm_string,
	    XmNx, 150,
	    XmNy, 200,
	    NULL);

	XtManageChild (message_dialog);
	XmStringFree (xm_string);

/*--- Boucle d'evenements --------------------------------------------------*/

	action_mb = WAITING_ANSWER_ACTION;
	
	while (action_mb != ANSWER_RECEIVED_ACTION)
	{
		XtAppProcessEvent(app_context, XtIMAll);
		XSync (disp, False);
	}
	
	XtUnmanageChild (message_dialog);
	XSync (disp, False);
	XmUpdateDisplay (message_dialog);

	action_mb = NO_WAITING_ACTION;
	XtDestroyWidget (message_dialog);
	return	answer_mb;
}

/*----------------------------------------------------------------------------
 *	D I S P L A Y _ Q U E S T I O N
 *--------------------------------------------------------------------------*/

int	display_question (Widget caller, char *msg)
/*
Widget	caller;
char	*msg;
*/
{
	XmString	xm_string, yes, no;
	Display		*disp = XtDisplay (caller);

/*--- Question Dialog ------------------------------------------------------*/

	yes = XmStringCreateSimple ("Yes");
	no = XmStringCreateSimple ("No");

	question_dialog = XmCreateQuestionDialog (caller,
	    "question_dialog", NULL, 0);
	XtVaSetValues (question_dialog,
	    XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL,
	    XmNokLabelString, yes,
	    XmNcancelLabelString, no,
	    NULL);
	XtUnmanageChild (
	    XmMessageBoxGetChild (question_dialog, XmDIALOG_HELP_BUTTON));
	XtAddCallback (question_dialog, XmNokCallback, (XtPointer)mb_ok_proc,
	    (XtPointer)(unsigned long)k_QuestionD_mb);
	XtAddCallback (question_dialog, XmNcancelCallback,
	    (XtPointer)mb_cancel_proc, (XtPointer)(unsigned long)k_QuestionD_mb);

	XmStringFree (yes);
	XmStringFree (no);

/*--- Remplissage de la fenetre --------------------------------------------*/

	xm_string = XmStringCreateLtoR (msg, XmSTRING_DEFAULT_CHARSET);

	if (XtIsManaged (question_dialog))
	{
		XtUnmanageChild (question_dialog);
	}

	XtVaSetValues (question_dialog,
	    XmNmessageString, xm_string,
	    XmNx, 200,
	    XmNy, 250,
	    NULL);
	XmStringFree (xm_string);

	XtVaSetValues(XtParent(question_dialog),XmNtitle,"question",NULL);
	
	XtManageChild (question_dialog);

/*--- Boucle d'evenements --------------------------------------------------*/

	action_mb = WAITING_ANSWER_ACTION;
	while (action_mb != ANSWER_RECEIVED_ACTION)
	{
		XtAppProcessEvent(app_context, XtIMAll);
		XSync (disp, False);	
	}
	
	XtUnmanageChild (question_dialog);
	XSync (disp, False);
	XmUpdateDisplay (question_dialog);	

/*--- Sortie ---------------------------------------------------------------*/

	action_mb = NO_WAITING_ACTION;
	XtDestroyWidget (question_dialog);

	if (answer_mb == OK_ANSWER)
	{
		return YES_ANSWER;
	}
	else if (answer_mb == CANCEL_ANSWER)
	{
		return NO_ANSWER;
	}
	return YES_ANSWER;
}

/*----------------------------------------------------------------------------
 *	D I S P L A Y _ E R R O R
 *--------------------------------------------------------------------------*/

int	display_error (Widget caller, char *msg)
/*
Widget	caller;
char	*msg;
*/
{
	XmString	xm_string;
	Display		*disp = XtDisplay (caller);

/*--- Error Dialog ---------------------------------------------------------*/

	error_dialog = XmCreateErrorDialog (caller,
	    "error_dialog", NULL, 0);
	XtVaSetValues (error_dialog,
	    XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL,
	    NULL);
	XtUnmanageChild (
	    XmMessageBoxGetChild (error_dialog, XmDIALOG_CANCEL_BUTTON));
	XtUnmanageChild (
	    XmMessageBoxGetChild (error_dialog, XmDIALOG_HELP_BUTTON));
	XtAddCallback (error_dialog, XmNokCallback, (XtPointer)mb_ok_proc, 
	(XtPointer)(unsigned long)k_ErrorD_mb);

/*--- Remplissage de la fenetre --------------------------------------------*/

	xm_string = XmStringCreateLtoR (msg, XmSTRING_DEFAULT_CHARSET);

	XtVaSetValues (error_dialog,
	    XmNmessageString, xm_string,
	    XmNx, 250,
	    XmNy, 200,
	    NULL);
	    
        XtVaSetValues(XtParent(error_dialog),XmNtitle,"Error",NULL);
	
	XtManageChild (error_dialog);
	XmStringFree (xm_string);

/*--- Boucle d'evenements --------------------------------------------------*/

	action_mb = WAITING_ANSWER_ACTION;
	
	while (action_mb != ANSWER_RECEIVED_ACTION)
	{
		XtAppProcessEvent(app_context, XtIMAll);
		XSync (disp, False);
	}
	
	XtUnmanageChild (error_dialog);
	XSync (disp, False);
	XmUpdateDisplay (error_dialog);

	action_mb = NO_WAITING_ACTION;
	XtDestroyWidget (error_dialog);
	return	answer_mb;
}

/*----------------------------------------------------------------------------
 *	D I S P L A Y _ P R O M P T
 *--------------------------------------------------------------------------*/

char	*display_prompt (Widget caller, char *msg, char *defaut)
/*
Widget	caller;
char	*msg, *defaut;
*/
{
	XmString	xm_string;
	char		vide[2];
	Display		*disp = XtDisplay (caller);

/*--- Prompt Dialog --------------------------------------------------------*/

	prompt_dialog = XmCreatePromptDialog (caller,
	    "prompt_dialog", NULL, 0);
	XtVaSetValues (prompt_dialog,
	    XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL,
	    NULL);
	XtUnmanageChild (
	    XmSelectionBoxGetChild (prompt_dialog, XmDIALOG_HELP_BUTTON));
	XtAddCallback (prompt_dialog, XmNokCallback,
	    (XtPointer)mb_ok_proc,(XtPointer)(unsigned long) k_PromptD_mb);
	XtAddCallback (prompt_dialog, XmNcancelCallback,
	    (XtPointer)mb_cancel_proc, (XtPointer)(unsigned long)k_PromptD_mb);

/*--- Remplissage de la fenetre --------------------------------------------*/

	sprintf	(vide, "");

	xm_string = XmStringCreateLtoR (msg, XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues (prompt_dialog,
	    XmNselectionLabelString, xm_string,
	    XmNx, 200,
	    XmNy, 150,
	    NULL);

	XmStringFree (xm_string);
	if (!defaut)
	{
		defaut = vide;
	}
	xm_string = XmStringCreateLtoR (defaut, XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues (prompt_dialog,
	    XmNtextString, xm_string,
	    NULL);


	XtManageChild (prompt_dialog);
	XmStringFree (xm_string);

/*--- Boucle d'evenements --------------------------------------------------*/

	action_mb = WAITING_ANSWER_ACTION;
	
	while (action_mb != ANSWER_RECEIVED_ACTION)
	{
		XtAppProcessEvent(app_context, XtIMAll);
		XSync (disp, False);
	}
	
	XtUnmanageChild (prompt_dialog);
	XSync (disp, False);
	XmUpdateDisplay (prompt_dialog);

/*--- Sortie ---------------------------------------------------------------*/

	action_mb = NO_WAITING_ACTION;
	XtDestroyWidget (prompt_dialog);
	
	if (answer_mb == CANCEL_ANSWER)
	{
		return (char *) NULL;
	}
	else if (answer_mb == OK_ANSWER)
	{
		return prompt_value;
	}
	return (char *) NULL;
}

/*----------------------------------------------------------------------------
 *	D I S P L A Y _ F I L E S E L E C T
 *--------------------------------------------------------------------------*/

char	*display_fileselect (Widget caller, int numero, char *dirmask, char *msg, char *directory)
/*
Widget	caller;
int	numero;
char	*dirmask, *msg, *directory;
*/
{
	XmString	xm_string1, xm_string2, xm_string3, xm_string4;
	char		*slash_position;
	Display		*disp = XtDisplay (caller);
	static char	dir[255];
	char *pt;
	Arg		args[15];
	int		i, n = 0;
	
/*--- Fileselect Dialog ----------------------------------------------------*/

	if (first_fileselect)
	{
		for (i = 0; i < NB_DIR_TAB; i++)
		{
#ifdef	UNIX
			strcpy(dir_tab[i], "./");
#elif	VMS
			strcpy(dir_tab[i], "[]");
#endif
		}
		first_fileselect = FALSE;
	}

/*--- Remplissage de la fenetre --------------------------------------------*/

	xm_string1 = XmStringCreateSimple ("File Selection");
	xm_string2 = XmStringCreateSimple (dirmask);
	xm_string3 = XmStringCreateLtoR (msg, XmSTRING_DEFAULT_CHARSET);


	if (numero == 0)
	{
		xm_string4 = XmStringCreateSimple (directory);
	}
	else
	{
		xm_string4 = XmStringCreateSimple (dir_tab[numero]);
	}


	XtSetArg (args[n], XmNdialogTitle, xm_string1); n++;
	XtSetArg (args[n], XmNpattern, xm_string2); n++;
	XtSetArg (args[n], XmNselectionLabelString, xm_string3); n++;
	XtSetArg (args[n], XmNdirMask, xm_string4); n++;
	XtSetArg (args[n], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL); n++;
	XtSetArg (args[n], XmNdefaultPosition, False); n++;
	XtSetArg (args[n], XmNautoUnmanage, False); n++;
	XtSetArg (args[n], XmNresizePolicy, XmRESIZE_GROW); n++;
	XtSetArg (args[n], XmNwidth, 400); n++;
	XtSetArg (args[n], XmNheight, 500); n++;
	XtSetArg (args[n], XmNx, 200); n++;
	XtSetArg (args[n], XmNy, 120); n++;

	fileselect_dialog = XmCreateFileSelectionDialog (caller,
	    "fileselect_dialog", args, n);
	    
	XtUnmanageChild (XmSelectionBoxGetChild (
	    fileselect_dialog, XmDIALOG_HELP_BUTTON));
	XtAddCallback (fileselect_dialog, XmNokCallback,
	    (XtPointer)mb_ok_proc, (XtPointer)(unsigned long)k_FileSelectD_mb);
	XtAddCallback (fileselect_dialog, XmNcancelCallback,
	    (XtPointer)mb_cancel_proc, (XtPointer)(unsigned long)k_FileSelectD_mb);

	
	XtVaSetValues(XtParent(fileselect_dialog),XmNtitle,"file selection",NULL);

	XtManageChild (fileselect_dialog);
	
	XmStringFree (xm_string1);	
	XmStringFree (xm_string2);	
	XmStringFree (xm_string3);	
	XmStringFree (xm_string4);	

/*--- Boucle d'evenements --------------------------------------------------*/

	action_mb = WAITING_ANSWER_ACTION;
	
	while (action_mb != ANSWER_RECEIVED_ACTION)
	{
		XtAppProcessEvent(app_context, XtIMAll);
		XSync (disp, False);
	}

	XtUnmanageChild (fileselect_dialog);
	XSync (disp, False);
	XmUpdateDisplay (fileselect_dialog);

/*--- Sortie ---------------------------------------------------------------*/

	action_mb = NO_WAITING_ACTION;
	XtDestroyWidget (fileselect_dialog);

	if (answer_mb == CANCEL_ANSWER)
	{
		return (char *) NULL;
	}
	else if (answer_mb == OK_ANSWER)
	{
		if (!strlen (fileselect_value))
		{
			return (char *)NULL;
		}
		if (numero != 0)
		{
			strcpy(dir,fileselect_value);
			strcpy(dir_tab[numero], dir);
#ifdef	UNIX
			slash_position = strrchr (dir_tab[numero], '/');
#elif	VMS
			slash_position = strrchr (dir_tab[numero], ']');
#endif
			*(++slash_position) = '\0';
			
		}
		return fileselect_value;
	}	
	return (char *)NULL;
}

/*----------------------------------------------------------------------------
 *	M B _ O K _ P R O C
 *--------------------------------------------------------------------------*/

void	mb_ok_proc (Widget w, XtPointer tag, XmAnyCallbackStruct *reason)
/*
Widget	w;
int	tag;
XmAnyCallbackStruct *reason;
*/
{
	char	*value;

	answer_mb = OK_ANSWER;

	switch ((int)tag)
	{
		case k_QuestionD_mb:
			action_mb = ANSWER_RECEIVED_ACTION;
			break;
		case k_ErrorD_mb:
			action_mb = ANSWER_RECEIVED_ACTION;
			break;
		case k_PromptD_mb:
			XmStringGetLtoR (
			   ((XmSelectionBoxCallbackStruct *) reason)->value,
			   XmSTRING_DEFAULT_CHARSET, &value);
			sprintf (prompt_value, "%s", value);
			XtFree (value);
			action_mb = ANSWER_RECEIVED_ACTION;
			break;
		case k_MessageD_mb:
			action_mb = ANSWER_RECEIVED_ACTION;
			break;
		case k_FileSelectD_mb:
			XmStringGetLtoR (
			    ((XmFileSelectionBoxCallbackStruct *) reason)->value,
			    XmSTRING_DEFAULT_CHARSET, &value);
			sprintf (fileselect_value, "%s", value);
			XtFree (value);
			action_mb = ANSWER_RECEIVED_ACTION;
			break;
		default:
			break;
	}
}

/*----------------------------------------------------------------------------
 *	M B _ C A N C E L _ P R O C
 *--------------------------------------------------------------------------*/

void	mb_cancel_proc (Widget w, XtPointer tag, XmAnyCallbackStruct *reason)
/*
Widget	w;
int	tag;
XmAnyCallbackStruct *reason;
*/
{
	answer_mb = CANCEL_ANSWER;

	switch ((int)tag)
	{
		case k_QuestionD_mb:
			action_mb = ANSWER_RECEIVED_ACTION;
			break;
		case k_PromptD_mb:
			action_mb = ANSWER_RECEIVED_ACTION;
			break;
		case k_FileSelectD_mb:
			action_mb = ANSWER_RECEIVED_ACTION;
			break;
		default:
			break;
	}
}

/*----------------------------------------------------------------------------
 *	M B _ C A N C E L _ P R O C
 *--------------------------------------------------------------------------*/

/*
 * Create the help_form hierarchy of widgets.
 */
void Createhelp_form(parent)
Widget parent;
{
    Arg      args[256];
    XmString	string;
    Cardinal ac=0;
    Boolean  argok=False;
    Widget   menuBar;
    Widget   topic_cascadeButton;
    Widget   pulldownMenu;
    Widget   pushButton;
    Widget   dismiss_pushButton;
    Widget   scrolledWindow;
    Widget   help_shell;

#if DEBUG
	printf("In Createhelp_form\n");
#endif

    XtInitializeWidgetClass(xmDialogShellWidgetClass);
    XtInitializeWidgetClass(xmFormWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmCascadeButtonWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    XtInitializeWidgetClass(xmLabelWidgetClass);
    XtInitializeWidgetClass(xmScrolledWindowWidgetClass);
    XtInitializeWidgetClass(xmTextWidgetClass);
    
    ac = 0;
    XtSetArg(args[ac], XmNtitle, "Help On Context"); ac++;
    XtSetArg(args[ac], XmNminWidth, 371); ac++;
    XtSetArg(args[ac], XmNminHeight, 165); ac++;
    XtSetArg(args[ac], XmNx, 508); ac++;
    XtSetArg(args[ac], XmNy, 217); ac++;
    XtSetArg(args[ac], XmNwidth, 636); ac++;
    XtSetArg(args[ac], XmNheight, 548); ac++;
    help_shell = XtCreatePopupShell("help_shell",
        xmDialogShellWidgetClass,
        parent,
        args, 
        ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNresizePolicy, XmRESIZE_GROW); ac++;
    XtSetArg(args[ac], XmNx, 508); ac++;
    XtSetArg(args[ac], XmNy, 217); ac++;
    XtSetArg(args[ac], XmNwidth, 636); ac++;
    XtSetArg(args[ac], XmNheight, 548); ac++;
    help_form = XmCreateForm(help_shell,
        "help_form",
        args, 
        ac);
    XtManageChild(help_form);
    
#if 0    
     /* create the icon */
	pixicon  = XCreateBitmapFromData (the_display, DefaultRootWindow(the_display),
	    icon_bits, icon_width, icon_height);
	XtVaSetValues(XtParent(help_form),XtNiconPixmap,pixicon,NULL);
#endif   
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 2); ac++;
    XtSetArg(args[ac], XmNy, 2); ac++;
    XtSetArg(args[ac], XmNwidth, 532); ac++;
    XtSetArg(args[ac], XmNheight, 39); ac++;
    menuBar = XmCreateMenuBar(help_form,
        "helpMenuBar",
        args, 
        ac);
    XtManageChild(menuBar);

    string = XmStringCreateLtoR("Topics",XmSTRING_DEFAULT_CHARSET);
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, string); ac++;
    XtSetArg(args[ac], XmNmnemonic, 'T'); ac++;
    XtSetArg(args[ac], XmNx, 5); ac++;
    XtSetArg(args[ac], XmNy, 5); ac++;
    XtSetArg(args[ac], XmNwidth, 60); ac++;
    XtSetArg(args[ac], XmNheight, 29); ac++;
    topic_cascadeButton = XmCreateCascadeButton(menuBar,
        "topic_cascadeButton",
        args, 
        ac);
    XtManageChild(topic_cascadeButton);
    XmStringFree(string);
    
    ac = 0;
    XtSetArg(args[ac], XmNx, 515); ac++;
    XtSetArg(args[ac], XmNy, 253); ac++;
    XtSetArg(args[ac], XmNwidth, 109); ac++;
    XtSetArg(args[ac], XmNheight, 33); ac++;
    topic_pulldownMenu = XmCreatePulldownMenu(XtParent(topic_cascadeButton),
        "pulldownMenu",
        args, 
        ac);

    
    ac = 0;
    XtSetArg(args[ac], XmNsubMenuId, topic_pulldownMenu); ac++;
    XtSetValues(topic_cascadeButton, args, ac);

    string = XmStringCreateLtoR("help on XNBC Simple Network Editor",XmSTRING_DEFAULT_CHARSET);
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, string); ac++;
    XtSetArg(args[ac], XmNx, 2); ac++;
    XtSetArg(args[ac], XmNy, 43); ac++;
    XtSetArg(args[ac], XmNwidth, 532); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    topic_label = XmCreateLabel(help_form,
        "topic_label",
        args, 
        ac);
    XtManageChild(topic_label);
    XmStringFree(string);
    
    string = XmStringCreateLtoR("Dismiss",XmSTRING_DEFAULT_CHARSET);
    ac = 0;
    XtSetArg(args[ac], XmNlabelString, string); ac++;
    XtSetArg(args[ac], XmNx, 150); ac++;
    XtSetArg(args[ac], XmNy, 508); ac++;
    XtSetArg(args[ac], XmNwidth, 236); ac++;
    XtSetArg(args[ac], XmNheight, 30); ac++;
    dismiss_pushButton = XmCreatePushButton(help_form,
        "dismiss_pushButton",
        args, 
        ac);
    XtManageChild(dismiss_pushButton);
    
    ac = 0;
    XtSetArg(args[ac], XmNscrollingPolicy, XmAUTOMATIC); ac++;
    XtSetArg(args[ac], XmNx, 0); ac++;
    XtSetArg(args[ac], XmNy, 75); ac++;
    XtSetArg(args[ac], XmNwidth, 532); ac++;
    XtSetArg(args[ac], XmNheight, 421); ac++;
    scrolledWindow = XmCreateScrolledWindow(help_form,
        "scrolledWindow",
        args, 
        ac);
    XtManageChild(scrolledWindow);
    
    ac = 0;
    XtSetArg(args[ac], XmNeditMode, XmMULTI_LINE_EDIT); ac++;
    XtSetArg(args[ac], XmNeditable, False); ac++;
    XtSetArg(args[ac], XmNcursorPositionVisible, False); ac++;
    XtSetArg(args[ac], XmNcolumns, 160); ac++;
    XtSetArg(args[ac], XmNrows, 1); ac++;
    help_text = XmCreateText(scrolledWindow,
        "help_text",
        args, 
        ac);
    XtManageChild(help_text);

    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomWidget, topic_label); ac++;
    XtSetArg(args[ac], XmNtopOffset, 2); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 2); ac++;
    XtSetArg(args[ac], XmNleftOffset, 2); ac++;
    XtSetArg(args[ac], XmNrightOffset, 2); ac++;
    XtSetValues(menuBar, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomWidget, scrolledWindow); ac++;
    XtSetArg(args[ac], XmNtopOffset, 0); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 4); ac++;
    XtSetArg(args[ac], XmNleftOffset, 2); ac++;
    XtSetArg(args[ac], XmNrightOffset, 2); ac++;
    XtSetValues(topic_label, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_NONE); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftWidget, scrolledWindow); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 10); ac++;
    XtSetArg(args[ac], XmNleftOffset, 150); ac++;
    XtSetArg(args[ac], XmNrightOffset, 150); ac++;
    XtSetValues(dismiss_pushButton, args, ac);
    
    ac = 0;
    XtSetArg(args[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(args[ac], XmNtopOffset, 75); ac++;
    XtSetArg(args[ac], XmNbottomOffset, 52); ac++;
    XtSetArg(args[ac], XmNleftOffset, 0); ac++;
    XtSetArg(args[ac], XmNrightOffset, 4); ac++;
    XtSetValues(scrolledWindow, args, ac);

    XtRealizeWidget(help_shell);

    display_help(1);
	
    XtMapWidget(help_shell);

}


