/*
*       Neuro_Bio_Clusters_Simulator
*
*       NEURONE.H
*
*       Header file pour le simulateur de reseaux neuronaux a haute
*       plausibilite biologique.
*
*
*	Auteur: Dr J-F VIBERT
*		Laboratoire de Physiologie
*		CHU Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is in any way usable for commercial purpose.
*
*/
		
#ifdef MAIN
#	define CLASS
#else
#	define CLASS	extern
#endif

CLASS
struct neuron
{
	float	threshold,		/* seuil instantane */
		seuil_peak,		/* seuil maximum post spike */
		soma,			/* voltage du soma en mV */
		decharge_lag,		/* depuis combien de temps ca a decharge */
		delta_seuil,		/* seuil apres un spike - seuil absolu (evite des calculs) */
		soma_post_spike,	/* soma apres un spike  pour calculer l'expon. decroissante */
		inp_max[MAX_MEM],	/* queue des tailles des inputs */
		HC_ap,			/* Coordonnes Horsley-Clark Antero-Posterieure */
		HC_lat,			/* Coordonnes Horsley-Clark Laterale */
		HC_vert;		/* Coordonnes Horsley-Clark Verticale */
		
	struct cluster	*its_cluster;	/* pointeur d'heritage */

	int	t_next_i;		/* time of the next input */
	short	*connexions,		/* nb de connexions ([NB_NEUR]) */
		*axone_length,		/* longueur de chaque connexion ([NB_NEUR) */
		*next_spike,		/* indice dans la queue de la spike suivante ([NB_NEUR) */
		spike_time[MAX_SPK],	/* queue de spikes sur l'axone */
		tete,			/* tete de queue */
		queue,			/* fin de queue */
		inp_t[MAX_MEM],		/* queue des temps des inputs */
		head,			/* tete de queue */
		tail,			/* fin de queue */
		t_last_i;		/* fin de queue */

	char	mon_cluster[15];	/* le nom du cluster a qui il appartient */
} **neuron;				/* dimension ([NB_NEUR]) */

