#ifndef _CALLBACKS_SIMU_
#define _CALLBACKS_SIMU_

#define DRUG_DEBUG 0

#include "creation-simu.h"

Widget		BxFindTopShell PROTOTYPE((Widget));
WidgetList	BxWidgetIdsFromNames PROTOTYPE((Widget, char*, char*));

/* ARGSUSED */
void register_widget_CB(Widget w, XtPointer client, XtPointer call)
{
	int message = (int)(unsigned long)client;

	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	widget_array[message] = w;
	
}

void start_alive_CB(Widget w, XtPointer client, XtPointer call)
{
  if (XmToggleButtonGetState(widget_array[ID_toggleB_make_alive]))
  {
      current_nucleus->alive = 'y';
      XtSetSensitive(widget_array[ID_label_prob_spike],True);
      XtSetSensitive(widget_array[ID_textF_prob_spike],True);
      XtSetSensitive(widget_array[ID_label_old_last_spike],True);
      XtSetSensitive(widget_array[ID_textF_old_last_spike],True);
      XtSetSensitive(widget_array[ID_label_recent_last_spike],True);
      XtSetSensitive(widget_array[ID_textF_recent_last_spike],True);
      XtSetSensitive(widget_array[ID_label_low_mb_pot],True);
      XtSetSensitive(widget_array[ID_textF_low_mb_pot],True);
      XtSetSensitive(widget_array[ID_label_up_mb_pot],True);
      XtSetSensitive(widget_array[ID_textF_up_mb_pot],True);
  }
  else
  {
      current_nucleus->alive = 'n';
      XtSetSensitive(widget_array[ID_label_prob_spike],False);
      XtSetSensitive(widget_array[ID_textF_prob_spike],False);
      XtSetSensitive(widget_array[ID_label_old_last_spike],False);
      XtSetSensitive(widget_array[ID_textF_old_last_spike],False);
      XtSetSensitive(widget_array[ID_label_recent_last_spike],False);
      XtSetSensitive(widget_array[ID_textF_recent_last_spike],False);
      XtSetSensitive(widget_array[ID_label_low_mb_pot],False);
      XtSetSensitive(widget_array[ID_textF_low_mb_pot],False);
      XtSetSensitive(widget_array[ID_label_up_mb_pot],False);
      XtSetSensitive(widget_array[ID_textF_up_mb_pot],False);
  }

}

void start_hebb_CB(Widget w, XtPointer client, XtPointer call)
{
  if (XmToggleButtonGetState(widget_array[ID_toggleB_weight_fluct]))
  {
      XtSetSensitive(widget_array[ID_label_learning_factor],True);
      XtSetSensitive(widget_array[ID_textF_hebb_factor],True);
  }
  else
  {
      XtSetSensitive(widget_array[ID_label_learning_factor],False);
      XtSetSensitive(widget_array[ID_textF_hebb_factor],False);
  }
}

void
create_event_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
    XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call_data;
    int message = (int)(unsigned long)client_data;
    
    switch(message)
    {
		case ID_pushB_ok_clu:
		case ID_pushB_apply_clu:
		case ID_pushB_cancel_clu:
		case ID_pushB_help_clu:
    	case ID_option_stim_nucl:   	
      	case ID_pushB_ok_nucl:
    	case ID_pushB_apply_nucl:
    	case ID_pushB_cancel_nucl:
    	case ID_pushB_help_nucl: 
	        break;

        case ID_toggleB_nucl_input_drug:
        case ID_toggleB_nucl_input_No_drug:
       	case ID_pushB_new:
    	case ID_pushB_continue:
    	case ID_pushB_load_simulation:
    	case ID_pushB_save_simulation:
    	case ID_pushB_save_state:
    	case ID_pushB_close:
    	case ID_pushB_exit:
#if ADD_NEW_MODEL
/***************** TO ADD A MODEL COPY AND ADAPT **************/
    	case ID_pushB_X_neuron:
/***********************       STOP     ***********************/
#endif
		case ID_pushB_L_neuron:
		case ID_pushB_B_neuron:
	   	case ID_pushB_P_neuron:
		case ID_pushB_G_neuron:
		case ID_pushB_Create_Drug_File:
		case ID_pushB_link_edit:
		case ID_pushB_network_editor:
		case ID_toggleB_display:
		case ID_toggle_dot:
		case ID_toggle_global:
		case ID_pushB_it_count:
		case ID_pushB_watch_sampling:
		case ID_pushB_save_pmb:
		case ID_pushB_visu:
		case ID_pushB_xtms:
		case ID_pushB_xcaa:
		case ID_pushB_first_stop:
		case ID_pushB_last_stop:
		case ID_pushB_time_step:
		case ID_pushB_spike_duration:
		case ID_pushB_interrupt:
		case ID_pushB_run_simulation:
		case ID_pushB_help_on_window:
		case ID_pushB_help_on_topic:
		case ID_pushB_help_browse:
		case ID_pushB_display_connecting_weights:
		case ID_pushB_display_transmission_delays:
		case ID_pushB_display_nmda_sensibity:
		case ID_pushB_repartition:
		case ID_cascadeB_clusters:
		case ID_cascadeB_nucleus:
		case ID_pushB_Update:
		case ID_pushB_sim_default:
		case ID_pushB_display_info:
		case ID_pushB_stop_main:
		case ID_text_stop_main:
		case ID_pushB_STIM:
		case ID_pushB_START_ALL:
		case ID_pushB_STOP_ALL:
		case ID_pushB_set_all_stim:
		case ID_pushB_clear_all_stim:
		case ID_pushB_close_stim:
		case ID_pushB_tms_f:
		case ID_pushB_pmb_f:
		case ID_pushB_sim_f:
		case ID_pushB_abe_f:
		case ID_pushB_gnp_f:
		case ID_pushB_use_ntr:
		        XtAddEventHandler(w,EnterWindowMask,FALSE,(XtEventHandler)fill_label_info,(XtPointer)message);
			XtAddEventHandler(w,LeaveWindowMask,FALSE,(XtEventHandler)status_label_info,(XtPointer)message);	     
    		break;
    		
		default:
			break;
    }
    
    
}


void
help_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
	char buffer[256];
	
    XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call_data;
    
    int message = (int)(unsigned long)client_data;

    sprintf(buffer,"This Tool is the XNBC Simulator version %s for XNBC V%s %s\n",
	    NBC_X_VERSION, VERSION);

    switch(message)
    {
	    case ID_pushB_help_on_window:
	    	display_message(widget_array[ID_sim_mainW],buffer,"Help On Window");
			return;
	    case ID_pushB_help_browse:
		browse_manual(XNBC_NBC_X);
		return;
			
	    case ID_pushB_help_nucl:
	    case ID_pushB_help_on_topic:
	    case ID_pushB_help_clu: 
		  
		    if(!XtIsManaged(widget_array[ID_help_form]))
				XtManageChild(widget_array[ID_help_form]);
			else
				XtPopup(XtParent(widget_array[ID_help_form]),XtGrabNone);
			break;
		
		default:
	
			display_help(message);	
			break;
	}
    
}

void
resize_graph(Widget w, XtPointer client_data, XtPointer call_data)
{

  XtVaGetValues(widget_array[ID_graph_form],XmNwidth,&graph_area_width,NULL);
  XtVaSetValues(graph_area,XmNwidth,graph_area_width,NULL);
  /*
  printf("witdh : %d\n",graph_area_width);
  */
}

void
nucl_para_activate_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
    char     *Drug_file_Selection;
    char     mask[NBR_CRT];
    char     buffer[256];
    char     Tampon[256], Name_of_File_Drug[256];
    int      ac, i, j, k, l, deja_dans_liste = 0;
    XmString xmstring;
    Arg      args[20];
    XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call_data;
    
    int message = (int)(unsigned long)client_data;
    XmListCallbackStruct *Liste_tampon;

    
    switch(message)
    {
       case ID_toggleB_nucl_input_drug:
	        current_nucleus->drug_enabled = True;
		break;

       case ID_toggleB_nucl_input_No_drug:
	        current_nucleus->drug_enabled = False;
		break;

        case ID_Buttom_drug_File_Selection:
                strcpy(mask,"*.drug");
		sprintf(buffer,"Choose a new neuron file for drug:");
		Drug_file_Selection = display_fileselect(widget_array[ID_form_cluster_general],0,mask,buffer,get_dir_name());

		if ( Drug_file_Selection == NULL ) 
		  return; /* on a fait un Cancel */
		
		/* prendre seulement le nom pour l`afficher */

		j = 0;
		for ( i=strlen(Drug_file_Selection) ; i>=0 ; i--)
		  {
		    if ( Drug_file_Selection[i]!='/')
		      {
			Tampon[j] = Drug_file_Selection[i];
			j++;
		     }
		    else 
		      {
			if (i==strlen(Drug_file_Selection)) 
			  {
#if DRUG_DEBUG
			    printf("pas de choix, ne rien faire\n");
#endif
			    xmstring = XmStringCreateLocalized("No File Selection\n");
			    XtSetArg(args[0], XmNlabelString, xmstring); 
			    XtSetValues(label_resultat_of_File_Name_Buttom, args, 1);
			    XmStringFree(xmstring);
			    
			    return; /* pas de fichier selectionne */
			  }
			Tampon[j] = '\0';
			/* retourner la chaine */
			for ( k=0; k<j ; k++)
			  {
			    Name_of_File_Drug[k] = Tampon[j-1-k];
			  }		


			/* AFFICHER le nom du fichier de drogue utilise */

			xmstring = XmStringCreateLocalized(Name_of_File_Drug);

			XtSetArg(args[0], XmNlabelString, xmstring); 
			XtSetValues(label_resultat_of_File_Name_Buttom, args, 1);

			XmStringFree(xmstring);
#if DRUG_DEBUG
			printf("apres %s\n",Name_of_File_Drug);
#endif

			/* We destroy the existing widgets */

			for(i = 0 ; i < nbr_drug ; i++)
			{
			  XtDestroyWidget(drug_toggle_w[i]);
			}
			XtFree((char *)drug_toggle_w);
			
			READ_DRUG_FILE(Drug_file_Selection);

			/* We rebuild the widgets */

			drug_toggle_w = (Widget *) XtCalloc(1, nbr_drug * sizeof(Widget));

			for(i = 0 ; i < nbr_drug ; i++)
			{
			    /* La colonne de toggle boutons pour les drogues */

			    ac = 0;
			    XtSetArg(args[ac], XmNlabelString, str_list_drug[i]); ac++;
			    XtSetArg(args[ac], XmNsensitive, True);ac++;    
			    XtSetArg(args[ac], XmNx, 0);ac++;    
			    XtSetArg(args[ac], XmNy, (i * 35));ac++;    
			    drug_toggle_w[i] = XmCreateToggleButton(form_drugs,
								    "drug_pb",
								    args, 
								    ac);
      
			    XtAddCallback(drug_toggle_w[i],XmNdisarmCallback,drug_activate_CB,
					  (XtPointer)(i));
      
			    XtManageChild(drug_toggle_w[i]);
			}

			break;
		      }
		  }
                break;
        case ID_pushB_ok_nucl:
                /* ferme seulement la fenetre */
    		current_nucleus = NULL;
    		if(XtIsManaged(widget_array[ID_form_nucleus_parameters]))
    			XtUnmanageChild(widget_array[ID_form_nucleus_parameters]);
    		break;
    	case ID_pushB_apply_nucl:
   		if(apply_nucleus_changes())
    			return;
    		modify_nucleus(current_nucleus->number - 1);
    		break;
    	case ID_pushB_cancel_nucl:
    		current_nucleus = NULL;
    		if(XtIsManaged(widget_array[ID_form_nucleus_parameters]))
    			XtUnmanageChild(widget_array[ID_form_nucleus_parameters]);
    		break;
    		
    	default:
    		break;
    
    }
    
}


void
option_stim_nucl_CB(Widget w, XtPointer client_data, XtPointer call_data)
{

  /* First unmanage all */

	if(XtIsManaged(widget_array[ID_form_nucl_para_input]))
	   XtUnmanageChild(widget_array[ID_form_nucl_para_input]);
	if(XtIsManaged(widget_array[ID_form_nucl_para_other]))
	   XtUnmanageChild(widget_array[ID_form_nucl_para_other]);
	if(XtIsManaged(widget_array[ID_form_nucl_para_noise]))
	   XtUnmanageChild(widget_array[ID_form_nucl_para_noise]);
	if(XtIsManaged(widget_array[ID_form_nucl_modulation]))
	   XtUnmanageChild(widget_array[ID_form_nucl_modulation]);
	if(XtIsManaged(widget_array[ID_form_nucl_drug]))
	   XtUnmanageChild(widget_array[ID_form_nucl_drug]);

	switch((int)client_data)
	{
	
		case 0:
			if(!XtIsManaged(widget_array[ID_form_nucl_para_input]))
				XtManageChild(widget_array[ID_form_nucl_para_input]);
			init_nucleus_changes(ID_form_nucl_para_input);	
			break;

		case 1:
			if(!XtIsManaged(widget_array[ID_form_nucl_para_noise]))
				XtManageChild(widget_array[ID_form_nucl_para_noise]);
			init_nucleus_changes(ID_form_nucl_para_noise);
			break;

		case 2:
			if(!XtIsManaged(widget_array[ID_form_nucl_modulation]))
				XtManageChild(widget_array[ID_form_nucl_modulation]);
			init_nucleus_changes(ID_form_nucl_modulation);
			break;

	        case 3:
			if(!XtIsManaged(widget_array[ID_form_nucl_drug]))
				XtManageChild(widget_array[ID_form_nucl_drug]);
			init_nucleus_changes(ID_form_nucl_drug);	
			break;

		case 4:
			if(!XtIsManaged(widget_array[ID_form_nucl_para_other]))
				XtManageChild(widget_array[ID_form_nucl_para_other]);
			init_nucleus_changes(ID_form_nucl_para_other);	
			break;
	}

}

void
stim_noise_activate_CB(w, client_data, call_data)
{
    XmString le_label;

    flag_stim_still = !flag_stim_still;
    if (stim_noise_f[client_data])
    {
        le_label = XmStringCreateLocalized("Start Noise");
    	XtVaSetValues(stim_noise_w[client_data],XmNlabelString,le_label,NULL);
	XtVaSetValues(stim_noise_w[client_data],
		      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
		      NULL);
	XtVaSetValues(widget_array[ID_pushB_STIM],
		      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
			  NULL);
	if (simu->output_abe_f)
	{
	  fprintf(abe_fp,"\'Stop noise on nucleus %d\'\n", client_data+1);
	  fprintf(abe_fp,"BE,%d,%ld\n", client_data+1, simu->nb_it - previous_event);
	}
	previous_event = simu->nb_it;
    }
    else
    {
        le_label = XmStringCreateLocalized("Stop Noise");
    	XtVaSetValues(stim_noise_w[client_data],XmNlabelString,le_label,NULL);
	XtVaSetValues(stim_noise_w[client_data],
		      XtVaTypedArg, XmNbackground, XmRString, "orange", 7,
		    NULL);
	XtVaSetValues(widget_array[ID_pushB_STIM],
		      XtVaTypedArg, XmNbackground, XmRString, "Orange", 8,
		      NULL);
	if (simu->output_abe_f)
	{
	  fprintf(abe_fp,"\'Start noise on nucleus %d\'\n", client_data+1);
	  fprintf(abe_fp,"BB,%d,%ld\n", client_data+1, simu->nb_it+1 - previous_event);
	}
	previous_event = simu->nb_it+1;
    }
    XmStringFree(le_label);
    stim_noise_f[client_data] = !stim_noise_f[client_data];
    return;
}

void
stim_pulse_activate_CB(w, client_data, call_data)
{
    XmString le_label;

    flag_stim_still = !flag_stim_still;
    if (stim_pulse_f[client_data])
    {
        le_label = XmStringCreateLocalized("Start Pulses");
    	XtVaSetValues(stim_pulse_w[client_data],XmNlabelString,le_label,NULL);
	XtVaSetValues(stim_pulse_w[client_data],
		      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
		      NULL);
	XtVaSetValues(widget_array[ID_pushB_STIM],
		      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
			  NULL);
      if (simu->output_abe_f)
      {
	fprintf(abe_fp,"\'Stop the pulse train on nucleus %d\'\n", client_data+1);
	fprintf(abe_fp,"AE,%d,%ld\n", client_data+1, simu->nb_it - previous_event);
      }
      previous_event = simu->nb_it;
      sim_nucleus[client_data]->pulse_up = (unsigned long)(sim_nucleus[client_data]->modul_phase * simu->time_step)+1;
      sim_nucleus[client_data]->pulse_down = (unsigned long)(sim_nucleus[client_data]->modul_period * simu->time_step)+1;
      sim_nucleus[client_data]->pulses_restants = sim_nucleus[client_data]->nb_pulses;
#if DEBUG
	printf("Pulse on %d at %lu\n", client_data+1, simu->nb_it);
#endif
    }
    else
    {
        le_label = XmStringCreateLocalized("Stop Pulses");
    	XtVaSetValues(stim_pulse_w[client_data],XmNlabelString,le_label,NULL);
	XtVaSetValues(stim_pulse_w[client_data],
		      XtVaTypedArg, XmNbackground, XmRString, "Orange", 7,
		      NULL);
	XtVaSetValues(widget_array[ID_pushB_STIM],
		      XtVaTypedArg, XmNbackground, XmRString, "Orange", 7,
		      NULL);
	if (simu->output_abe_f)
	{
	  fprintf(abe_fp,"\'Start a pulse train on nucleus %d\'\n", client_data+1);
	  fprintf(abe_fp,"AB,%d,%ld\n", client_data+1, simu->nb_it - previous_event);
	}
	previous_event = simu->nb_it;
    }
    XmStringFree(le_label);
    stim_pulse_f[client_data] = !stim_pulse_f[client_data];
    return;
}

void
stim_modul_activate_CB(w, client_data, call_data)
{
    XmString le_label;

    flag_stim_still = !flag_stim_still;

    if (stim_modul_f[client_data])
    {
      if (sim_nucleus[client_data]->modul_type == 'p')
      {
	le_label = XmStringCreateLocalized("Send Pulses");
    	XtVaSetValues(stim_modul_w[client_data],XmNlabelString,le_label,NULL);
	XtVaSetValues(stim_modul_w[client_data],
		    XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
		    NULL);
	XtVaSetValues(widget_array[ID_pushB_STIM],
		      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
			  NULL);
	sim_nucleus[client_data]->pulse_up = (unsigned long)(sim_nucleus[client_data]->modul_phase * simu->time_step)+1;
	sim_nucleus[client_data]->pulse_down = (unsigned long)(sim_nucleus[client_data]->modul_period * simu->time_step)+1;
	sim_nucleus[client_data]->pulses_restants = sim_nucleus[client_data]->nb_pulses;
#if DEBUG
	printf("Pulse on %d at %lu\n", client_data+1, simu->nb_it);
#endif
      }
      else
      {
        le_label = XmStringCreateLocalized("Start Modul.");
    	XtVaSetValues(stim_modul_w[client_data],XmNlabelString,le_label,NULL);
	XtVaSetValues(stim_modul_w[client_data],
		    XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
		    NULL);
	XtVaSetValues(widget_array[ID_pushB_STIM],
		      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
			  NULL);
      }
      if (simu->output_abe_f)
      {
	fprintf(abe_fp,"\'Stop the modulated stimulus on nucleus %d\'\n", client_data+1);
	fprintf(abe_fp,"CE,%d,%ld\n", client_data+1, simu->nb_it - previous_event);
      }
      previous_event = simu->nb_it;
    }
    else
    {
      if (sim_nucleus[client_data]->modul_type == 'p')
      {
        le_label = XmStringCreateLocalized("Stop Pulses");
    	XtVaSetValues(stim_modul_w[client_data],XmNlabelString,le_label,NULL);
	XtVaSetValues(stim_modul_w[client_data],
		    XtVaTypedArg, XmNbackground, XmRString, "Orange", 7,
		    NULL);
#if DEBUG
	printf("Pulse on %d at %lu\n", client_data+1, simu->nb_it);
#endif
      }
      else
      {
        le_label = XmStringCreateLocalized("Stop Modul.");
    	XtVaSetValues(stim_modul_w[client_data],XmNlabelString,le_label,NULL);
	XtVaSetValues(stim_modul_w[client_data],
		    XtVaTypedArg, XmNbackground, XmRString, "Orange", 7,
		    NULL);
	XtVaSetValues(widget_array[ID_pushB_STIM],
		      XtVaTypedArg, XmNbackground, XmRString, "Orange", 7,
		      NULL);
      }
      if (simu->output_abe_f)
      {
	fprintf(abe_fp,"\'Start a modulated stimulus on nucleus %d\'\n", client_data+1);
	fprintf(abe_fp,"CB,%d,%ld\n", client_data+1, simu->nb_it - previous_event);
      }
      previous_event = simu->nb_it;
    }
    XmStringFree(le_label);
    stim_modul_f[client_data] = !stim_modul_f[client_data];
    return;
}


void
stim_drug_activate_CB(w, client_data, call_data)
{
    XmString le_label;

    flag_stim_still = !flag_stim_still;
    if (stim_drug_f[client_data])
    {
        le_label = XmStringCreateLocalized("Inject Drug");
    	XtVaSetValues(stim_drug_w[client_data],XmNlabelString,le_label,NULL);
	XtVaSetValues(stim_drug_w[client_data],
		    XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
		    NULL);
	XtVaSetValues(widget_array[ID_pushB_STIM],
		      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
			  NULL);
      if (simu->output_abe_f)
      {
	fprintf(abe_fp,"\'Stop the drug injection in nucleus %d\'\n", client_data+1);
	fprintf(abe_fp,"DE,%d,%ld\n", client_data+1, simu->nb_it - previous_event);
      }
      previous_event = simu->nb_it;
    }
    else
    {
        le_label = XmStringCreateLocalized("Stop Drug");
    	XtVaSetValues(stim_drug_w[client_data],XmNlabelString,le_label,NULL);
	XtVaSetValues(stim_drug_w[client_data],
		    XtVaTypedArg, XmNbackground, XmRString, "orange", 7,
		    NULL);
	XtVaSetValues(widget_array[ID_pushB_STIM],
		      XtVaTypedArg, XmNbackground, XmRString, "Orange", 7,
		      NULL);
      if (simu->output_abe_f)
      {
	fprintf(abe_fp,"\'Start a drug injection in nucleus %d\'\n", client_data+1);
	fprintf(abe_fp,"DB,%d,%ld\n", client_data+1, simu->nb_it - previous_event);
      }
      previous_event = simu->nb_it;
    }
    XmStringFree(le_label);
    stim_drug_f[client_data] = !stim_drug_f[client_data];
    return;
}

void
stim_set_all_CB(w, client_data, call_data)
{
    XmString le_label;
    int i;

    flag_stim_still = True;
    for (i = 0; i < simu->nb_nucleus; i++)
    {
      if ( XtIsSensitive(stim_noise_w[i]))
      {
	    if (!stim_noise_f[i])
	    {
		le_label = XmStringCreateLocalized("Stop Noise");
		XtVaSetValues(stim_noise_w[i],XmNlabelString,le_label,NULL);
		XtVaSetValues(stim_noise_w[i],
			      XtVaTypedArg, XmNbackground, XmRString, "orange", 7,
			    NULL);
		if (simu->output_abe_f)
		{
		  fprintf(abe_fp,"\'Start noise on nucleus %d\'\n", i+1);
		  fprintf(abe_fp,"BB,%d,%ld\n", i+1, simu->nb_it+1 - previous_event);
		}
		previous_event = simu->nb_it+1;
	    }
	    XmStringFree(le_label);
	    stim_noise_f[i] = True;
	    XtVaSetValues(widget_array[ID_pushB_STIM],
			  XtVaTypedArg, XmNbackground, XmRString, "Orange", 8,
			  NULL);

      }
      if ( XtIsSensitive(stim_pulse_w[i]))
      {
	    if (!stim_pulse_f[i])
	    {
			le_label = XmStringCreateLocalized("Stop Pulses");
			XtVaSetValues(stim_pulse_w[i],XmNlabelString,le_label,NULL);
			XtVaSetValues(stim_pulse_w[i],
				      XtVaTypedArg, XmNbackground, XmRString, "orange", 7,
				      NULL);
			if (simu->output_abe_f)
			{
			  fprintf(abe_fp,"\'Start a pulse train on nucleus %d\'\n", i+1);
			  fprintf(abe_fp,"AB,%d,%ld\n", i+1, simu->nb_it - previous_event);
			}
			previous_event = simu->nb_it;
	    }
	    XmStringFree(le_label);
	    stim_pulse_f[i] = True;
	    XtVaSetValues(widget_array[ID_pushB_STIM],
			  XtVaTypedArg, XmNbackground, XmRString, "Orange", 8,
			  NULL);
      }
      if ( XtIsSensitive(stim_modul_w[i]))
      {	
	    if (!stim_modul_f[i])
	    {
			le_label = XmStringCreateLocalized("Stop Modul.");
			XtVaSetValues(stim_modul_w[i],XmNlabelString,le_label,NULL);
			XtVaSetValues(stim_modul_w[i],
				    XtVaTypedArg, XmNbackground, XmRString, "orange", 7,
				    NULL);
			if (simu->output_abe_f)
			{
			  fprintf(abe_fp,"\'Start a modulated stimulus on nucleus %d\'\n", i+1);
			  fprintf(abe_fp,"CB,%d,%ld\n", i+1, simu->nb_it - previous_event);
			}
			previous_event = simu->nb_it;
	    }
	    XmStringFree(le_label);
	    stim_modul_f[i] = True;
	    XtVaSetValues(widget_array[ID_pushB_STIM],
			  XtVaTypedArg, XmNbackground, XmRString, "Orange", 8,
			  NULL);
      }
      if ( XtIsSensitive(stim_drug_w[i]))
      {
	    if (!stim_drug_f[i])
	    {
			le_label = XmStringCreateLocalized("Stop Drug");
			XtVaSetValues(stim_drug_w[i],XmNlabelString,le_label,NULL);
			XtVaSetValues(stim_drug_w[i],
				    XtVaTypedArg, XmNbackground, XmRString, "orange", 7,
				    NULL);
			if (simu->output_abe_f)
			{
			  fprintf(abe_fp,"\'Start a drug injection in nucleus %d\'\n", i+1);
			  fprintf(abe_fp,"DB,%d,%ld\n", i+1, simu->nb_it - previous_event);
			}
			previous_event = simu->nb_it;
	    }
	    XmStringFree(le_label);
	    stim_drug_f[i] = True;
	    XtVaSetValues(widget_array[ID_pushB_STIM],
			  XtVaTypedArg, XmNbackground, XmRString, "Orange", 8,
			  NULL);
      }
    }
    XtVaSetValues(widget_array[ID_pushB_START_ALL], 
		  XmNsensitive,False,
		  NULL);
    XtVaSetValues(widget_array[ID_pushB_STOP_ALL], 
		  XmNsensitive,True,
		  NULL);
    return;
}

void
stim_clear_all_CB(w, client_data, call_data)
{
    XmString le_label;
    int i;

    flag_stim_still = False;
    for (i = 0; i < simu->nb_nucleus; i++)
    {
      if ( XtIsSensitive(stim_noise_w[i]))
      {
	    if (stim_noise_f[i])
	    {
			le_label = XmStringCreateLocalized("Start Noise");
			XtVaSetValues(stim_noise_w[i],XmNlabelString,le_label,NULL);
			XtVaSetValues(stim_noise_w[i],
				      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
				      NULL);
			if (simu->output_abe_f)
			{
			  fprintf(abe_fp,"\'Stop noise on nucleus %d\'\n", i+1);
			  fprintf(abe_fp,"BE,%d,%ld\n", i+1, simu->nb_it - previous_event);
			}
			previous_event = simu->nb_it;
	    }
	    XmStringFree(le_label);
	    stim_noise_f[i] = False;
	    XtVaSetValues(widget_array[ID_pushB_STIM],
			  XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
			  NULL);
      }
      if ( XtIsSensitive(stim_pulse_w[i]))
      {
	    if (stim_pulse_f[i])
	    {
			le_label = XmStringCreateLocalized("Start Pulses");
			XtVaSetValues(stim_pulse_w[i],XmNlabelString,le_label,NULL);
			XtVaSetValues(stim_pulse_w[i],
				      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
				      NULL);
			if (simu->output_abe_f)
			{
			  fprintf(abe_fp,"\'Stop the pulse train on nucleus %d\'\n", i+1);
			  fprintf(abe_fp,"AE,%d,%ld\n", i+1, simu->nb_it - previous_event);
			}
			previous_event = simu->nb_it;
	    }
	    XmStringFree(le_label);
	    stim_pulse_f[i] = False;
	    XtVaSetValues(widget_array[ID_pushB_STIM],
			  XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
			  NULL);
      }
      if ( XtIsSensitive(stim_modul_w[i]))
      {	
	    if (stim_modul_f[i])
	    {
			le_label = XmStringCreateLocalized("Start Modul.");
			XtVaSetValues(stim_modul_w[i],XmNlabelString,le_label,NULL);
			XtVaSetValues(stim_modul_w[i],
				    XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
				    NULL);
			if (simu->output_abe_f)
			{
			  fprintf(abe_fp,"\'Stop the modulated stimulus on nucleus %d\'\n", i+1);
			  fprintf(abe_fp,"CE,%d,%ld\n", i+1, simu->nb_it - previous_event);
			}
			previous_event = simu->nb_it;
	    }
	    XmStringFree(le_label);
	    stim_modul_f[i] = False;
	    XtVaSetValues(widget_array[ID_pushB_STIM],
			  XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
			  NULL);
      }
      if ( XtIsSensitive(stim_drug_w[i]))
      {
	    if (stim_drug_f[i])
	    {
			le_label = XmStringCreateLocalized("Inject Drug");
			XtVaSetValues(stim_drug_w[i],XmNlabelString,le_label,NULL);
			XtVaSetValues(stim_drug_w[i],
				    XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
				    NULL);
			if (simu->output_abe_f)
			{
			  fprintf(abe_fp,"\'Stop the drug injection in nucleus %d\'\n", i+1);
			  fprintf(abe_fp,"DE,%d,%ld\n", i+1, simu->nb_it - previous_event);
			}
			previous_event = simu->nb_it;
	    }
	    XmStringFree(le_label);
	    stim_drug_f[i] = False;
	    XtVaSetValues(widget_array[ID_pushB_STIM],
			  XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
			  NULL);
      }
    }
    XtVaSetValues(widget_array[ID_pushB_START_ALL], 
		  XmNsensitive,True,
		  NULL);

    XtVaSetValues(widget_array[ID_pushB_STOP_ALL], 
		  XmNsensitive,False,
		  NULL);

    return;
}

void
stim_close_CB(w, client_data, call_data)
{
    if(XtIsManaged(form_stimulation))
      XtUnmanageChild(form_stimulation);
    else
      return;

    XtVaSetValues(widget_array[ID_pushB_STIM], 
		  XmNsensitive,True,
		  NULL);

    if (flag_stim_still)
      XtVaSetValues(widget_array[ID_pushB_STIM],
		    XtVaTypedArg, XmNbackground, XmRString, "orange", 7,
		    NULL);
    else
      XtVaSetValues(widget_array[ID_pushB_STIM],
		    XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
		    NULL);
}

void
sim_next_stop_CB(w, client_data, call_data)
{
  float float_value;
  unsigned long l_value;
  char buffer[256];
  char value[60];
  char unit[30];
  char *valeur;
  char *pt;
  
  valeur = XmTextFieldGetString(widget_array[ID_text_stop_main]);
  sscanf(valeur,"%s %s",value,unit);

  if(pt = strrchr(value,'.'))
  {
    sscanf(value,"%f",&float_value);
    if(tolower(*unit) == 'i')
    {
      sprintf(buffer,"Sorry, float value (%f) isn't compatible with iteration...", float_value);
      display_error(widget_array[ID_sim_mainW],buffer,"Bad Unit !");
      return;
    }
    else if(tolower(*unit) != 'm')
    {
      sprintf(buffer,"Is this float value in ms ?");
      if(display_question(widget_array[ID_sim_mainW],buffer,
			  "Unit Confirmation")== NO_ANSWER)
      {
		sprintf(buffer,"Sorry, float value is only compatible with ms...");
		display_error(widget_array[ID_sim_mainW],buffer,"Bad Unit !");
		return;
	  }
    }
    else if(((unsigned long)nintf(float_value/simu->time_step) < simu->nb_it ) 
	     ||(float_value > simu->end_at_ms))
    {
      sprintf(buffer,"Sorry, %.3f is out of range...",float_value);
      display_error(widget_array[ID_sim_mainW],buffer,"Bad Value !");
      return;
    }
    simu->stop_at_ms = (float)float_value;
    simu->next_stop = (unsigned long)nintf(simu->stop_at_ms / simu->time_step);

#if 0
    sprintf(buffer,"\nSimulation next stop changed: %.3f ms <=> %lu iterations.",
	    simu->stop_at_ms,simu->next_stop);
    _output(buffer);
#endif
  }
  else
  {
    sscanf(value,"%lu",&l_value);
    if(tolower(*unit) == 'm')
    {
      sprintf(buffer,"Sorry, integer value (%d) isn't compatible with ms...", l_value);
      display_error(widget_array[ID_sim_mainW],buffer,"Bad Unit !");
      return;
    }
    else if(tolower(*unit) != 'i')
    {
      sprintf(buffer,"Is this integer value in iteration ?");
      if(display_question(widget_array[ID_sim_mainW],buffer,
			  "Unit Confirmation")== NO_ANSWER)
      {
		sprintf(buffer,"Sorry, integer value is only compatible with iteration...");
		display_error(widget_array[ID_sim_mainW],buffer,"Bad Unit !");
		return;
      }
    }
    if((l_value < simu->nb_it) ||(l_value > simu->last_it))
    {
      sprintf(buffer,"Sorry, %lu is out of range...\nModify the last stop value to continue",l_value);
      display_error(widget_array[ID_sim_mainW],buffer,"Bad Value !");
      return;
    }
    simu->next_stop = l_value;
    simu->stop_at_ms = (float)(simu->next_stop * simu->time_step);
#if 0
    sprintf(buffer,"\nSimulation next stop changed: %.3f ms <=> %lu iterations.",
	    simu->stop_at_ms,simu->next_stop);
    _output(buffer);
#endif
  }
}

void
drug_activate_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
    int i;
    int j;
    Boolean state;
    Arg wargs[5];

    i = (int)client_data;

    XtSetArg(wargs[0],XmNset,&state);
    XtGetValues(w,wargs,1);

    current_nucleus->drogue[i] = state;

#if DRUG_DEBUG
    printf("set current_nucleus->drogue[%d]: %d\n", i, current_nucleus->drogue[i]);
#endif
    for(j = 0 ; j < NBR_CRT; j++)
    {
		if (table_of_drug_mask[i][j])
		{
		    current_nucleus->crt[j] = state;
		    XtSetArg(wargs[0],XmNset,state);
		    XtSetValues(crt_toggle_w[j], wargs, 1);
#if DRUG_DEBUG
		    printf("set current_nucleus->crt[%d]: %d\n", j, current_nucleus->crt[j]);
#endif
		}
    }

#if DRUG_DEBUG
	printf("Drug activation\nn = %d\n", current_nucleus->number - 1);
	printf("i = %d\nstate %d\n",i,state);
#endif
}


void
crt_disactivate_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
    int i;
    Boolean state;
    Arg wargs[5];

    i = (int)client_data;

    XtSetArg(wargs[0],XmNset,&state);
    XtGetValues(w,wargs,1);

    current_nucleus->crt[i] = state;

#if DRUG_DEBUG
	printf("Current activation\nn = %d\n", current_nucleus->number-1);
	printf("i = %d\nstate %d\n",i,state);
#endif
}


void
sim_activate_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
    XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call_data;
    int message = (int)(unsigned long)client_data;
    char mask[10];
    char buffer[256];
    char *pt;
    int n;
    Boolean	argok;
    FILE *fp;
    int i;
    char tmp[_BUFFER_SIZE_];

 	if(message >= MAX_REGITERED_WIDGETS)  
 	{
 	
 		if(running)
 			return;
 		n = message - MAX_REGITERED_WIDGETS;
 		if(n < simu->nb_nucleus)
 		{
 			modify_nucleus(n);
 		}
 		else if(n - simu->nb_nucleus < 	simu->nb_clusters)
 		{
 			modify_cluster(n - simu->nb_nucleus);
 		}
 		else
 		{
 			/* problem !*/
 		}
 		return;
 	} 
 	
 	if(running && (message != ID_pushB_interrupt))
 		return;
 
    switch(message)
    {
    
    
    	case ID_pushB_new:
	        simu->nb_it = 0;
#if 0
		XtSetSensitive(widget_array[ID_pushB_time_step],True);
		XtSetSensitive(widget_array[ID_pushB_spike_duration],True);
#endif
    	case ID_pushB_continue:
    		if(message == ID_pushB_new)
    		{
    			strcpy(mask,"*.ntw");
    			strcpy(buffer,"Choose a network file:");
    		}
    		else if(message == ID_pushB_continue)
    		{
    			strcpy(mask,"*.neur");
    			strcpy(buffer,"Choose a neuron states file:");
    		}

		pt = display_fileselect(widget_array[ID_sim_mainW],
					0,mask,buffer,get_dir_name());
			
		if(!pt)
		        return;
		else
		{
		        strcpy(input_file,pt);
			if(pt = strrchr(input_file,'.'))
			{
			        strcpy(pt,&mask[1]);
			}
			else
			{
			        strcat(input_file,&mask[1]);
			}
		}
		XtSetSensitive(widget_array[ID_pushB_save_state],True);
		XtSetSensitive(widget_array[ID_cascadeB_analyses],False);
    		status("Loading...");
    		XFlush(the_display);
    		if(!load_simulator())
		{
    			init_simulation();
			simu->saved = FALSE;
		} /* fin du if */
    		else
    			status("No Loaded Network (*.ntw)");
    			
    		break;
    	
    	case ID_pushB_load_simulation:
#if 0
    			strcpy(mask,"*.x_def");
#endif
	        strcpy(mask,"*.x_sim");
		strcpy(buffer,"Choose a simulation parameters file:");

		pt = display_fileselect(widget_array[ID_sim_mainW],
					0,mask,buffer,get_dir_name());
			
		if(!pt)
		        return;
		else
		{
		        strcpy(input_file,pt);
			if(pt = strrchr(input_file,'.'))
			{
			        strcpy(pt,&mask[1]);
			}
			else
			{
			        strcat(input_file,&mask[1]);
			}
		}
#if 0
		if(read_x_def_file(pt))
#endif
		if(!read_x_sim_file(input_file))
		{
			sprintf(buffer,"Sorry, can't read %s \n(inexisting or insufficient privilege ?)...",
				input_file);
			display_error(widget_array[ID_sim_mainW],buffer,"Read Error !");
			return;
		}
		else
		{
			sprintf(buffer,"Reading %s.", input_file);
			status(buffer);
			XFlush(the_display);
			return;
		}
    		break;
    	

    	case ID_pushB_save_simulation:
#if 0
    		strcpy(mask,"*.x_def");
#endif
    		strcpy(mask,"*.x_sim");
    		sprintf(buffer,"Choose a simulation parameters file name:");
    		pt = display_fileselect(widget_array[ID_sim_mainW],0,mask,buffer,
						get_dir_name());
		if(!pt)
			return;
		if(!strstr(pt,".x_sim"))
		{
		        strcpy(input_file,pt);
			if(pt = strrchr(input_file,'.'))
			{
			        strcpy(pt,&mask[1]);
			}
			else
			{
			        strcat(input_file,&mask[1]);
			}
		}
		create_nucleus_file();
#if 0
		if(create_x_def_file(pt))
#endif
		if(!create_x_sim_file(input_file))
		{
			sprintf(buffer,"Sorry, can't create %s \n(disk quota exceeded or insufficient privilege ?)...",
				input_file);
			display_error(widget_array[ID_sim_mainW],buffer,"Write Error !");
			return;
		}
		else
		{
			sprintf(buffer,"Wrote %s.",
				input_file);
#if MESSAGES
			display_message(widget_array[ID_sim_mainW],buffer,"Done...");
#endif
			_output(buffer);
			return;
		}
			
    		break;
    	
    	case ID_pushB_save_state:
    		if(XtIsManaged(widget_array[ID_form_cluster_parameters]))
    		{
    			XtUnmanageChild(widget_array[ID_form_cluster_parameters]);
    		}
    		if(XtIsManaged(widget_array[ID_form_nucleus_parameters]))
    		{
    			XtUnmanageChild(widget_array[ID_form_nucleus_parameters]);
    		}
    		
    		if(display_question(widget_array[ID_sim_mainW],
    			"Do you really want to save and close current simulation?",
    			"Confirmation needed...") == NO_ANSWER)
    			return;

		if (!simu->saved)
		{
#if BUFFERIZE_AND_FLUSH
			if(pmb_buffer)
			{
				fp = fopen(simu->pmb_name,"w");
				if(pmb_tmpfp)
				{
					rewind(pmb_tmpfp);
					while(fread(tmp,1,_BUFFER_SIZE_,pmb_tmpfp))
					{
						fwrite(tmp,1,_BUFFER_SIZE_,fp);
					}
					fclose(pmb_tmpfp);
				}
				fwrite(pmb_buffer,1,pmb_buf_size,fp);
				fclose(fp);
				free(pmb_buffer);
				pmb_buffer = NULL;
			}
			if(tms_buffer)
			{
				fp = fopen(simu->tms_name,"w");
				if(tms_tmpfp)
				{
					rewind(tms_tmpfp);
					while(fread(tmp,1,_BUFFER_SIZE_,tms_tmpfp))
					{
						fwrite(tmp,1,_BUFFER_SIZE_,fp);
					}
					fclose(tms_tmpfp);
				}
				fwrite(tms_buffer,1,tms_buf_size,fp);
				fclose(fp);
				free(tms_buffer);
				tms_buffer = NULL;
			}
			if(sim_buffer)
			{
				fp = fopen(simu->sim_name,"w");
				fprintf(fp,"%s\n",sim_buffer);
				for(i=0 ; i<simu->nb_nucleus ; i++)
				{
					fprintf(fp,"%s\n",activity_buffers[i]);
					free(activity_buffers[i]);
					activity_buffers[i] = NULL;
				}
				fclose(fp);
				free(sim_buffer);
				sim_buffer = NULL;
			}
#else
			if (pmb_fp)
			{
			        fclose(pmb_fp);
				pmb_fp = NULL;
			}
			if (gnp_fp)
			{
			        fclose(gnp_fp);
				gnp_fp = NULL;
			}
			if (tms_fp)
			{
			        fclose(tms_fp);
				tms_fp = NULL;
			}
			if (abe_fp)
			{
			        fprintf(abe_fp,"0,2,%lu\n0,FFFF,0\n\n",simu->nb_it - previous_event);
			        fclose(abe_fp);
				abe_fp = NULL;
			}
			if (sim_fp)
			{
			        fclose(sim_fp);
				rearrange_sim_file();
				sim_fp = NULL;
			}
#endif
#if OLD_VISU
			create_cnx_for_visu(simu->cnx_name);
#endif				
			if(mod_buffer)
			{
				fp = fopen(simu->mod_name,"w");
				fprintf(fp,"%s",mod_buffer);
				fclose(fp);
				free(mod_buffer);
				mod_buffer = NULL;
			}
			else
			{
				fp = fopen(simu->mod_name,"w");
				fclose(fp);
			}
			simu->saved = TRUE;
		}
		sprintf(buffer,"End of simulation. Files saved. Analyzes possible.");
		_output(buffer);
       		status("Simulation completed and saved");
		XtSetSensitive(widget_array[ID_pushB_save_state],False);
		XtSetSensitive(widget_array[ID_cascadeB_analyses],True);
		XtVaSetValues(widget_array[ID_pushB_STOP],
			      XmNlabelString, CONVERT(widget_array[ID_pushB_STOP], "RUN", XmRXmString, 0, &argok),
			      XmNsensitive,False,
			      XtVaTypedArg, XmNbackground, XmRString, "white", 6,
			      NULL);

    		break;
    	
    	
	case ID_pushB_close:
    		
    		if(XtIsManaged(widget_array[ID_form_cluster_parameters]))
    		{
    			XtUnmanageChild(widget_array[ID_form_cluster_parameters]);
    		}
    		if(XtIsManaged(widget_array[ID_form_nucleus_parameters]))
    		{
    			XtUnmanageChild(widget_array[ID_form_nucleus_parameters]);
    		}
    		
    		if(display_question(widget_array[ID_sim_mainW],
    			"Do you really want to save current simulation and exit?",
    			"Confirmation needed...") == NO_ANSWER)
    			return;

		if (!simu->saved)
		{
#if BUFFERIZE_AND_FLUSH
			if(pmb_buffer)
			{
				fp = fopen(simu->pmb_name,"w");
				if(pmb_tmpfp)
				{
					rewind(pmb_tmpfp);
					while(fread(tmp,1,_BUFFER_SIZE_,pmb_tmpfp))
					{
						fwrite(tmp,1,_BUFFER_SIZE_,fp);
					}
					fclose(pmb_tmpfp);
				}
				fwrite(pmb_buffer,1,pmb_buf_size,fp);
				fclose(fp);
				free(pmb_buffer);
				pmb_buffer = NULL;
			}
			if(tms_buffer)
			{
				fp = fopen(simu->tms_name,"w");
				if(tms_tmpfp)
				{
					rewind(tms_tmpfp);
					while(fread(tmp,1,_BUFFER_SIZE_,tms_tmpfp))
					{
						fwrite(tmp,1,_BUFFER_SIZE_,fp);
					}
					fclose(tms_tmpfp);
				}
				fwrite(tms_buffer,1,tms_buf_size,fp);
				fclose(fp);
				free(tms_buffer);
				tms_buffer = NULL;
			}
			if(sim_buffer)
			{
				fp = fopen(simu->sim_name,"w");
				fprintf(fp,"%s\n",sim_buffer);
				for(i=0 ; i<simu->nb_nucleus ; i++)
				{
					fprintf(fp,"%s\n",activity_buffers[i]);
					free(activity_buffers[i]);
					activity_buffers[i] = NULL;
				}
				fclose(fp);
				free(sim_buffer);
				sim_buffer = NULL;
			}
#else
			if (pmb_fp)
			{
			        fclose(pmb_fp);
				pmb_fp = NULL;
			}
			if (gnp_fp)
			{
			        fclose(gnp_fp);
				gnp_fp = NULL;
			}
			if (tms_fp)
			{
			        fclose(tms_fp);
				tms_fp = NULL;
			}
			if (abe_fp)
			{
			        if (simu->output_abe_f)
				  fprintf(abe_fp,"0,2,%lu\n0,FFFF,0\n\n",simu->nb_it - previous_event);
			        fclose(abe_fp);
				abe_fp = NULL;
			}
			if (sim_fp)
			{
			        fclose(sim_fp);
				if (simu->output_sim_f)
				  rearrange_sim_file();
				sim_fp = NULL;
			}
#endif
#if OLD_VISU			
			create_cnx_for_visu(simu->cnx_name);
#endif				
			if(mod_buffer)
			{
				fp = fopen(simu->mod_name,"w");
				fprintf(fp,"%s",mod_buffer);
				fclose(fp);
				free(mod_buffer);
				mod_buffer = NULL;
			}
			else
			{
				fp = fopen(simu->mod_name,"w");
				fclose(fp);
			}

			create_nucleus_file();
			simu->saved = TRUE;
		} /* fin du if */
		
    		exit_simulator(False);
    		break;
    	
    	case ID_pushB_exit:
    		exit_simulator(False);
    		break;

        case ID_pushB_sim_default:
	        _output("\nBack to default simulation parameters:");
	        default_sim_values();
		sprintf(buffer,"\ntime step: %.3f ms, spike duration: %.3f ms, mb pot saved each %.3f ms, activity watch each %.3f ms\n",
			simu->time_step, simu->spike_width, simu->nb_step_save_ms, simu->nb_step_watch_ms);
		_output(buffer);
		break;

#if ADD_NEW_MODEL
/***************** TO ADD A MODEL COPY AND ADAPT **************/
	case ID_pushB_X_neuron:
		MENU_WIN_DIALOG_create_message(w,"Loading the XXM neuron editor\nPlease wait...");
		sprintf(buffer,"%s/%s", project_directory, simu->name);
		launch_application("X_neuron",ID_pushB_X_neuron,buffer);
		break;
/***********************       STOP     ***********************/
#endif
	case ID_pushB_L_neuron:
		MENU_WIN_DIALOG_create_message(w,"Loading the LIM neuron editor\nPlease wait...");
		sprintf(buffer,"%s/%s", project_directory, simu->name);
		launch_application("P_neuron -l ",ID_pushB_L_neuron,buffer);
		break;
	case ID_pushB_B_neuron:
		MENU_WIN_DIALOG_create_message(w,"Loading the BUM neuron editor\nPlease wait...");
		sprintf(buffer,"%s/%s", project_directory, simu->name);
		launch_application("P_neuron -b ",ID_pushB_B_neuron,buffer);
		break;
	case ID_pushB_P_neuron:
		MENU_WIN_DIALOG_create_message(w,"Loading the PUM neuron editor\nPlease wait...");
		sprintf(buffer,"%s/%s", project_directory, simu->name);
		launch_application("P_neuron -p ",ID_pushB_P_neuron,buffer);
		break;
	case ID_pushB_G_neuron:
		MENU_WIN_DIALOG_create_message(w,"Loading the CBM neuron editor\nPlease wait...");
		sprintf(buffer,"%s/%s", project_directory, simu->name);
		launch_application("G_neuron",ID_pushB_G_neuron,buffer);
		break;
	case ID_pushB_network_editor:
		MENU_WIN_DIALOG_create_message(w,"Loading the full featured network editor\nPlease wait...");
		sprintf(buffer,"%s/%s", project_directory, simu->name);
		launch_application("network_editor",ID_pushB_network_editor,buffer);
		break;
	case ID_pushB_link_edit:
		MENU_WIN_DIALOG_create_message(w,"Loading the simple network editor\nPlease wait...");
		sprintf(buffer,"%s/%s", project_directory, simu->name);
		launch_application("link_edit",ID_pushB_link_edit,buffer);
		break;
	case ID_pushB_visu:
		MENU_WIN_DIALOG_create_message(w,"Loading the visualization tool\nPlease wait...");
		sprintf(buffer,"%s/%s", project_directory, simu->name);
		launch_application("visu_nbc",ID_pushB_visu,buffer);
		break;
	case ID_pushB_xtms:
		MENU_WIN_DIALOG_create_message(w,"Loading the time series analysis tool\nPlease wait...");
		sprintf(buffer,"%s/%s", project_directory, simu->name);
		launch_application("xtms",ID_pushB_xtms,buffer);
		break;
	case ID_pushB_xcaa:
		MENU_WIN_DIALOG_create_message(w,"Loading the nucleus activity analysis tool\nPlease wait...");
		sprintf(buffer,"%s/%s", project_directory, simu->name);
		launch_application("xcaa",ID_pushB_xcaa,buffer);
		break;
	case ID_pushB_tms_f:
	        simu->output_tms_f = XmToggleButtonGetState(w);
		break;
	case ID_pushB_abe_f:
	        simu->output_abe_f = XmToggleButtonGetState(w);
		break;
	case ID_pushB_sim_f:
	        simu->output_sim_f = XmToggleButtonGetState(w);
		break;
	case ID_pushB_pmb_f:
	        simu->output_pmb_f = XmToggleButtonGetState(w);
		break;
	case ID_pushB_gnp_f:
	        simu->output_gnp_f = XmToggleButtonGetState(w);
		break;
        case ID_pushB_Create_Drug_File:    
#if DRUG_DEBUG
                printf("creation d`une drogue\n");
#endif
		MENU_WIN_DIALOG_create_message(w,"Loading the drug file editor tool\nPlease wait...");
		launch_application("drug_file_editor",ID_pushB_Create_Drug_File," ");
                break;

	case ID_toggleB_display:
	        simu->watch_sim = XmToggleButtonGetState(w);
		if (simu->watch_sim)
		{
		  form_graph = (Widget)Createform_graph(AppShell);

		  XtManageChild(widget_array[ID_graph_form]);

		  XMoveWindow(the_display, XtWindow(form_graph),300,330);

		  the_drawable = XtWindow(graph_area);

		  if (gc_black)
		    XFreeGC(the_display,gc_black);
		  if (gc_white)
		    XFreeGC(the_display,gc_white);
		  if (gc_dot)
		    XFreeGC(the_display,gc_dot);
		  if (gc_red)
		    XFreeGC(the_display,gc_red);

		  gc_black = XCreateGC(the_display, the_drawable, 0, NULL);
		  XSetForeground(the_display,gc_black, BlackPixelOfScreen(DefaultScreenOfDisplay(the_display)));
		  XSetBackground(the_display,gc_black, WhitePixelOfScreen(DefaultScreenOfDisplay(the_display)));

		  gc_white = XCreateGC(the_display, the_drawable, 0, NULL);
		  XSetForeground(the_display,gc_white, WhitePixelOfScreen(DefaultScreenOfDisplay(the_display)));

		  gc_red = XCreateGC(the_display, the_drawable, 0, NULL);
		  XSetForeground(the_display,gc_red,BlackPixelOfScreen(DefaultScreenOfDisplay(the_display)) );
		  XSetLineAttributes(the_display,gc_red,5,LineSolid,CapButt,JoinMiter);

		  gc_dot = XCreateGC(the_display, the_drawable, 0, NULL);
		  XSetForeground(the_display,gc_dot, BlackPixelOfScreen(DefaultScreenOfDisplay(the_display)));
		  XSetBackground(the_display,gc_dot, WhitePixelOfScreen(DefaultScreenOfDisplay(the_display)));
		  XSetLineAttributes(the_display,gc_dot,2,LineSolid,CapRound,JoinRound);

		  XmToggleButtonSetState(widget_array[ID_toggle_dot],simu->look_at_dot_display,False);	        
		  XmToggleButtonSetState(widget_array[ID_toggle_global],simu->look_at_glob_act,False);
		}
		else
		{
		  XDestroyWindow(the_display,XtWindow(widget_array[ID_graph_shell]));
		}		  
		break;

	case ID_toggle_dot:
		simu->look_at_dot_display = XmToggleButtonGetState(w);
		XmToggleButtonSetState(widget_array[ID_toggle_dot],simu->look_at_dot_display,False);	        
		XmToggleButtonSetState(widget_array[ID_toggle_global],simu->look_at_glob_act,False);

		if (simu->look_at_dot_display || simu->look_at_glob_act)
		  simu->watch_sim = TRUE;
		else
		  simu->watch_sim = FALSE;
		break;

	case ID_toggle_global:
		simu->look_at_glob_act =  XmToggleButtonGetState(w);
		XmToggleButtonSetState(widget_array[ID_toggle_dot],simu->look_at_dot_display,False);	        
		XmToggleButtonSetState(widget_array[ID_toggle_global],simu->look_at_glob_act,False);

		if (simu->look_at_dot_display || simu->look_at_glob_act)
		  simu->watch_sim = TRUE;
		else
		  simu->watch_sim = FALSE;
		break;
		
        case ID_pushB_dismiss_graph:
		simu->watch_sim = FALSE;
		XmToggleButtonSetState(widget_array[ID_toggleB_display],simu->watch_sim,False);
		XDestroyWindow(the_display,XtWindow(widget_array[ID_graph_shell]));
		break;
		
	case ID_pushB_it_count:
		change_simu_parameter(message);
		break;

        case ID_pushB_watch_sampling: 
		simu->watch_sim = TRUE;
		change_simu_parameter(message);
		break;

	case ID_pushB_save_pmb:
	case ID_pushB_first_stop:
    	case ID_pushB_last_stop:
    	case ID_pushB_time_step:
    	case ID_pushB_spike_duration:
    		change_simu_parameter(message);
    		break;
    	
    	case ID_pushB_interrupt:
         	if(running && simu->nb_neurons)   /* Red state, wait to stop */
    		{
    			stop_simulation();
			XtVaSetValues(widget_array[ID_pushB_STOP],
				    XmNlabelString, CONVERT(widget_array[ID_pushB_STOP], "RUN", XmRXmString, 0, &argok),
				    XmNsensitive,True,
				    XtVaTypedArg, XmNbackground, XmRString, "green", 6,
				    NULL);
			XtRemoveCallback(widget_array[ID_pushB_STOP],XmNactivateCallback,sim_activate_CB,
				(XtPointer)ID_pushB_interrupt);
			XtAddCallback(widget_array[ID_pushB_STOP],XmNactivateCallback,sim_activate_CB,
				(XtPointer)ID_pushB_run_simulation);
    		}
    		else
    		{
    			sprintf(buffer,"This function is only used while simulation is running...");
    			display_error(widget_array[ID_sim_mainW],buffer,"Nothing to Interrupt !");
    			return;
    		}
    		break;
    	case ID_pushB_run_simulation:
	        
	        if(!stopped && !running && simu->nb_neurons) /* Green state, wait to start  at the beginning */
    		{
    			create_prm_file_for_graph(simu->prm_name);
    			configure_neurons(True);
			sim_next_stop_CB(NULL,NULL,NULL);
    			simulate();
			XtVaSetValues(widget_array[ID_pushB_STOP],
				    XmNlabelString, CONVERT(widget_array[ID_pushB_STOP], "STOP", XmRXmString, 0, &argok),
				    XmNsensitive,True,
				    XtVaTypedArg, XmNbackground, XmRString, "red", 4,
				    NULL);
			XtRemoveCallback(widget_array[ID_pushB_STOP],XmNactivateCallback,sim_activate_CB,
				(XtPointer)ID_pushB_run_simulation);
			XtAddCallback(widget_array[ID_pushB_STOP],XmNactivateCallback,sim_activate_CB,
				(XtPointer)ID_pushB_interrupt);
    		}
    		else if(!running && simu->nb_neurons)        /* Green state, wait to start */
    		{
			sim_next_stop_CB(NULL,NULL,NULL);
    			simulate();
			XtVaSetValues(widget_array[ID_pushB_STOP],
				    XmNlabelString, CONVERT(widget_array[ID_pushB_STOP], "STOP", XmRXmString, 0, &argok),
				    XmNsensitive,True,
				    XtVaTypedArg, XmNbackground, XmRString, "red", 4,
				    NULL);
			XtRemoveCallback(widget_array[ID_pushB_STOP],XmNactivateCallback,sim_activate_CB,
				(XtPointer)ID_pushB_run_simulation);
			XtAddCallback(widget_array[ID_pushB_STOP],XmNactivateCallback,sim_activate_CB,
				(XtPointer)ID_pushB_interrupt);
    		}
    		else if(running)
    		{
    			return;
    		}
    		else
    		{
    			sprintf(buffer,"Simulator is empty. Please Load and configure network first...");
    			display_error(widget_array[ID_sim_mainW],buffer,"Nothing to Simulate !");
    			return;
    		}
    		break;
        case ID_pushB_STIM:
	        if (form_stimulation)
			{
			  if(XtIsManaged(form_stimulation))
			  {
			    XtUnmanageChild(form_stimulation);
			  }
			  else
			  {
			    XtManageChild(form_stimulation);
			    XMoveWindow(XtDisplay(form_stimulation), XtWindow(form_stimulation), 0, 330);
			  }
			}
			else
			{
			  return;
			}
			if (flag_stim_still)
			  XtVaSetValues(widget_array[ID_pushB_STIM],
					XtVaTypedArg, XmNbackground, XmRString, "orange", 7,
					NULL);
			else
			  XtVaSetValues(widget_array[ID_pushB_STIM],
					XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
					NULL);
			XtVaSetValues(widget_array[ID_pushB_STIM], 
				      XmNsensitive,False,
				      NULL);
			break;
    	case ID_pushB_display_connecting_weights:
    		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				working_cursor);
    		display_connecting_weights();
    		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				0);
    		break;
    	case ID_pushB_display_transmission_delays:
    		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				working_cursor);
    		display_delays();
    		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				0);
    		break;
    	case ID_pushB_display_nmda_sensibity:
    		
    		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				working_cursor);
    		display_nmda();
    		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				0);
    		break;
    	case ID_pushB_repartition:
    		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				working_cursor);
    		display_repartition();
    		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				0);
    		break;
    	case ID_pushB_Update:

	        strcpy(mask,"*.ntw");
			strcpy(buffer,"Choose a new network file:");
			pt = display_fileselect(widget_array[ID_sim_mainW],
						0,mask,buffer,get_dir_name());
			if(!pt)
			{
			    strcpy(status_info,"Network not changed");
			    status(status_info);
			    return;
			}
			else
			{
			        strcpy(input_file,pt);
				if(pt = strrchr(input_file,'.'))
				{
				        strcpy(pt,&mask[1]);
				}
				else
				{
				        strcat(input_file,&mask[1]);
				}
			}
			if(!(*input_file))
			{
			    strcpy(status_info,"Network not changed");
			    status(status_info);
			}
			else
			 {
    		    sprintf(buffer,"Reloading %s",input_file);
				status(buffer);
				XFlush(the_display);
				if(reload_network(input_file))
				{
					sprintf(buffer,"%s not loaded (network unchanged)",input_file);
					status(buffer);
				}
			}
			break;
    	default:
    		break;
    }
}


void
clu_para_activate_CB(Widget w, XtPointer client_data, XtPointer call_data)
{
    XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call_data;
    void show_values(void);
	
    int message = (int)(unsigned long)client_data;
    int i, j;
    
    switch(message)
    {
    	case ID_pushB_ok_clu:
    		if(apply_cluster_changes())
				return;
    		current_cluster = NULL;
    		if(XtIsManaged(widget_array[ID_form_cluster_parameters]))
				XtUnmanageChild(widget_array[ID_form_cluster_parameters]);
    		break;
    	case ID_pushB_apply_clu:
    		if(apply_cluster_changes())
				return;
    		modify_cluster(current_cluster->number - 1);
    		break;
    	case ID_pushB_cancel_clu:
    		current_cluster = NULL;
    		if(XtIsManaged(widget_array[ID_form_cluster_parameters]))
				XtUnmanageChild(widget_array[ID_form_cluster_parameters]);
    		break;    	
    	case ID_pushB_file_select:
    		change_cluster_type();
    		apply_cluster_changes();
    		break;
    	case ID_pushB_use_ntr:
			if (simu->use_ntr)
			{
				simu->use_ntr = FALSE;
				reload_network(get_lnk_name());
			}
			else
			{
				simu->use_ntr = TRUE;
				for (j = 0; j < simu->nb_neurons; j++) 
				{
					for (i = 0; i < simu->nb_neurons; i++) 
					{
						if (sim_neurons[j]->connections[i] < 0)
							 sim_neurons[j]->connections[i]*= -1;
					}
				}
			}
    		break;
		case ID_pushB_reload:
			reload_cluster_type();
			apply_cluster_changes();
	    	break;
		case ID_pushB_display_info:
			show_values();
	    	if(XtIsManaged(widget_array[ID_form_cluster_parameters]))
				XtUnmanageChild(widget_array[ID_form_cluster_parameters]);
			break;
    	default:
    		break;
    
    }
}

/*
 * Launch_application allow to run an application during the simulation
 */

#include <unistd.h>             /*** for exec fork ***/
#include <string.h>

void	
launch_application(char *application, int ID_widget, char *file)
{
	char	name_appli[256],
		buffer[256];

	strcpy(name_appli,bin_directory);
	strcat(name_appli,"/");
	strcat(name_appli,application);

	sprintf(buffer,"%s %s&", name_appli, file);

#if 0
	if (execlp(application,"-k",buffer,NULL) == -1)
	{
		sprintf(buffer,"Impossible to load %s.\nSorry...",
			application);
		display_error(widget_array[ID_widget],buffer,"Done...");
	} /* fin du if */
#endif
	fprintf(stderr,"%s\n",buffer);
	system(buffer);

}

 
/*****************************************************************************
*                              HEADER FUNCTION                              
******************************************************************************
* NAME	       : MENU_WIN_DIALOG_create_message	
* GOAL         : 	
******************************************************************************
* AUTHOR       : Marc TISSERANT                                             
* DATE WRITTEN : 1995, March	
* TESTS        : level 0 - no specific tests tool is used for the development.	
* REVIEWER     : ...	
* MODIFICATION : none	
******************************************************************************
* SCOPE        : global to the application	
* INPUT        : parent : the widget created by this funciton is linked to the
*                widget parent. 	
* OUTPUT       : none	
* RETURN       : none
*****************************************************************************/

void MENU_WIN_DIALOG_create_message(Widget parent,char *msg)
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    XmString	xmstr[32];
    Widget	dialogShell;
    Widget	dialog_help;
    extern	XtAppContext	app_context;
    Arg	wargs[2];
    int x,y;    
    void MENU_WIN_DIALOG_pause(XtPointer ,XtIntervalId *);
    
    XtSetArg(wargs[0],XtNx,&x);
    XtSetArg(wargs[1],XtNy,&y);
    XtGetValues(parent,wargs,2);

    XtInitializeWidgetClass(xmDialogShellWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, x+250); argcnt++;
    XtSetArg(args[argcnt], XmNy, y+250); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 350); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 200); argcnt++;
    dialogShell = XtCreatePopupShell("dialogShell",
		xmDialogShellWidgetClass,
		parent,
		args,
		argcnt);

    XtInitializeWidgetClass(xmMessageBoxWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNborderWidth, 0); argcnt++;
    XtSetArg(args[argcnt], XmNbackground, CONVERT(parent,"#a2a2dfdffefe", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNborderColor, CONVERT(parent,"#00000000d7d7", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNforeground, CONVERT(parent,"#000", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 7); argcnt++;
    XtSetArg(args[argcnt], XmNtopShadowColor, CONVERT(parent,"#8282c5c5dcdc", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNbottomShadowColor, CONVERT(parent,"#2e2e7b7b8c8c", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNdialogTitle, (xmstr[0]=XmStringCreateLtoR(
		"INFORMATION", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNmessageAlignment,XmALIGNMENT_CENTER ); argcnt++;
    XtSetArg(args[argcnt], XmNmessageString, (xmstr[1]=XmStringCreateLtoR(
    msg, XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 350); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 50); argcnt++;
    XtSetArg (args[argcnt],XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL); argcnt++; 
    XtSetArg(args[argcnt], XmNdialogType, XmDIALOG_WORKING); argcnt++;
    dialog_help = XtCreateWidget("dialog_help",
		xmMessageBoxWidgetClass,
		dialogShell,
		args,
		argcnt);
    XmStringFree( xmstr[0] );
    XmStringFree( xmstr[1] );
    XtUnmanageChild ( XmMessageBoxGetChild (dialog_help, XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild ( XmMessageBoxGetChild (dialog_help, XmDIALOG_HELP_BUTTON));    
    XtUnmanageChild ( XmMessageBoxGetChild (dialog_help, XmDIALOG_OK_BUTTON));    
    XtManageChild(dialog_help);   
    XtPopup(XtParent(dialog_help),XtGrabNone);
    XtAppAddTimeOut(app_context,10000,MENU_WIN_DIALOG_pause,(XtPointer)dialog_help);
}


/*****************************************************************************
*                              HEADER FUNCTION                              
******************************************************************************
* NAME	       : MENU_WIN_DIALOG_pause	
* GOAL         : 	
******************************************************************************
* AUTHOR       : Marc TISSERANT                                             
* DATE WRITTEN : 1995, March	
* TESTS        : level 0 - no specific tests tool is used for the development.	
* REVIEWER     : ...	
* MODIFICATION : none	
******************************************************************************
* SCOPE        : local	
* INPUT        : . 	
* OUTPUT       : none	
* RETURN       : none
*****************************************************************************/
/*ARGSUSED*/
void MENU_WIN_DIALOG_pause(XtPointer  client,XtIntervalId *id)
{
	XtPopdown(XtParent(client));
}

#endif
