#ifndef creation_simu_H
#define creation_simu_H

#define NBC_X_DEBUG	0
#define BUFFERIZE_AND_FLUSH 0

#define MAJ_VERSION 9
#define NBC_X_VERSION "12.4"

#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#if (XmVersion >= 1002)
#   include <Xm/RepType.h>
#endif
#include <Xm/MwmUtil.h>
#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/MwmUtil.h>
#include <Xm/Form.h>
#include <Xm/Separator.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/Label.h>
#include <Xm/ToggleB.h>
#include <Xm/List.h>
#include <Xm/RowColumn.h>
#include <Xm/MainW.h>
#include <Xm/CascadeB.h>
#include <Xm/ScrolledW.h>
#include <Xm/Text.h>
#include <Xm/MessageB.h>
#include <Xm/Frame.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "nbc_icon.h"
#include "cstes_nbc_x.h"
#include "G_receptor.h"
#include "G_synap.h"
#include "sim_types.h"
#include "x_messbox.h"
#include <sys/types.h>
#include <dirent.h>
#include "find_files.h"

#ifdef HAVE_CONFIG_H

#  include <config_xnbc.h>

#  if ! HAVE_NINT
#     if HAVE_RINT
#	  define nintf	rint
#     elif HAVE_CEIL
#		define nintf  ceil
#	endif
#  endif
#else
#  define VERSION NBC_X_VERSION
#  ifdef linux
#      define	nintf	rint
#  endif
#  ifdef ultrix
#      define	nintf	rint
#  endif
#  ifdef sun
#	define	nintf	ceil
#  endif
#  ifdef __hpux
#       define  nintf   ceil
#  endif
#endif

#ifndef _MAIN_
#define GLOBAL
#else
#define GLOBAL extern
#endif

#define ID_form_nucleus_parameters		0
#define ID_pushB_ok_nucl			1
#define ID_pushB_apply_nucl			2
#define ID_pushB_cancel_nucl			3
#define ID_pushB_help_nucl			4
#define ID_form_nucl_para_other			5
#define ID_textF_hebb_factor			6
#define ID_toggleB_weight_fluct			7
#define ID_toggleB_make_alive			8
#define ID_form_nucl_modulation			9
#define ID_textF_nucl_modul_phase		10
#define ID_textF_nucl_modul_amp			11
#define ID_textF_nucl_modul_period		12
#define ID_toggleB_nucl_modul_none		13
#define ID_toggleB_nucl_modul_sin		14
#define ID_toggleB_nucl_modul_triangle		15
#define ID_toggleB_nucl_modul_rect		16
#define ID_form_nucl_para_noise			17
#define ID_toggleB_nucl_noise_none		18
#define ID_toggleB_nucl_noise_active		19
#define ID_textF_nucl_noise_sd			20
#define ID_textF_nucl_noise_m			21
#define ID_form_nucl_para_input			22
#define ID_toggleB_nucl_input_excit		23
#define ID_toggleB_nucl_input_inhib		24
#define ID_textF_input_scale_factor		25
#define ID_textF_input_sd			26
#define ID_textF_input_period_m			27
#define ID_toggleB_nucl_input_none		28
#define ID_toggleB_nucl_input_reg		29
#define ID_toggleB_nucl_input_gauss		30
#define ID_toggleB_nucl_input_poisson		31
#define ID_toggleB_nucl_input_gamma		32
#define ID_sim_mainW				33
#define ID_pushB_new				34
#define ID_pushB_continue			35
#define ID_pushB_load_simulation		36
#define ID_pushB_save_simulation		37
#define ID_pushB_exit				38
#define ID_pulldownM_nucleus			39
#define ID_pulldownM_clusters			40
#define ID_pushB_first_stop			41
#define ID_pushB_last_stop			42
#define ID_pushB_time_step			43
#define ID_pushB_spike_duration			44
#define ID_pushB_interrupt			45
#define ID_pushB_run_simulation			46
#define ID_pushB_help_on_window			47
#define ID_pushB_help_on_topic			48
#define ID_pushB_display_connecting_weights	49
#define ID_pushB_display_transmission_delays	50
#define ID_pushB_display_nmda_sensibity		51
#define ID_pushB_repartition			52
#define ID_text_simulator			53
#define ID_label_info				54
#define ID_form_cluster_parameters		55
#define ID_pushB_ok_clu				56
#define ID_pushB_apply_clu			57
#define ID_pushB_cancel_clu			58
#define ID_pushB_help_clu			59
#define ID_form_cluster_general			60
#define ID_textF_clu_noise_sd			61
#define ID_textF_clu_noise_m			62
#define ID_toggleB_clu_noise_none		63
#define ID_toggleB_clu_noise_active		64
#define ID_label_clu_nb_neurons			65
#define ID_pushB_file_select			66
#define ID_textF_cluster_file_name		67
#define ID_help_form				68
#define ID_topic_pulldownMenu			69
#define ID_help_text				70
#define ID_topic_label				71
#define ID_cascadeB_nucleus			72
#define ID_pushB_nucleus_none			73
#define ID_pushB_cluster_none			74
#define ID_cascadeB_clusters			75
#define ID_pushB_save_state			76
#define ID_pushB_close				77
#define ID_pushB_P_neuron			78
#define ID_pushB_G_neuron			79
#define ID_pushB_link_edit			80
#define ID_pushB_network_editor			81
#define ID_pushB_visu				82
#define ID_pushB_xtms				83
#define ID_pushB_xcaa				84
#define ID_pushB_STOP				85
#define ID_pushB_RUN				86
#define ID_toggleB_display			87
#define ID_toggleB_glob_act			88
#define ID_pushB_it_count			89
#define ID_pushB_watch_sampling			90
#define ID_pushB_save_pmb			91
#define ID_form_iterations			92
#define ID_label_iterations			93
#define ID_toggleB_clu_noise_filter		94
#define ID_cascadeB_analyses    	        95
#define ID_pushB_B_neuron			96
#define ID_pushB_reload				97
#define ID_pushB_Update 			98
#define ID_pushB_display_info          		99

#define ID_form_nucl_drug               	100
#define ID_toggleB_nucl_input_drug      	101
#define ID_toggleB_nucl_input_No_drug   	102
#define ID_Buttom_drug_File_Selection   	103
#define ID_label_resultat_of_File_Name_Buttom   104
#define ID_list_drug                    	105
#define ID_selection_list_drug          	106
#define ID_pushB_L_neuron      			107
#define ID_pushB_Create_Drug_File       	108
#define ID_pushB_help_browse			109
#define ID_pushB_sim_default            	110
#define ID_pushB_silent                 	111
#define ID_pushB_STIM                   	112
#define ID_form_stim_control			113
#define ID_rowcol_stim                  	114
#define ID_label_name_stim              	115
#define ID_pushB_noise_stim             	116
#define ID_pushB_pulse_stim             	117
#define ID_pushB_modul_stim             	118
#define ID_pushB_close_stim             	119
#define ID_pushB_set_all_stim           	120
#define ID_pushB_clear_all_stim         	121
#define ID_text_stop_main               	122
#define ID_pushB_stop_main              	123
#define ID_pushB_kill                   	124

#define ID_pushB_tms_f				125
#define ID_pushB_abe_f				126
#define ID_pushB_sim_f				127
#define ID_pushB_pmb_f				128
#define ID_pushB_gnp_f				129
#define ID_cascadeB_outputs			130
#define ID_toggleB_nucl_modul_pulse		131
#define ID_textF_nucl_modul_nb	        	132

#define ID_pushB_START_ALL              	133
#define ID_pushB_STOP_ALL               	134
#define ID_option_stim_nucl    			135

#define ID_nucleus_pulldownMenu         	136
#define ID_graph_area                   	137
#define ID_graph_form                   	138
#define ID_toggle_dot                   	139
#define ID_toggle_global                	140
#define ID_pushB_dismiss_graph          	141
#define ID_scrolledWindowGraph          	142
#define ID_graph_shell                  	143

#define ID_textF_prob_spike             	144
#define ID_textF_old_last_spike         	145
#define ID_textF_recent_last_spike      	146

#define ID_label_prob_spike             	147
#define ID_label_old_last_spike         	148
#define ID_label_recent_last_spike      	149
#define ID_label_learning_factor		150

#define ID_label_up_mb_pot             		151
#define ID_textF_up_mb_pot      		152
#define ID_label_low_mb_pot	        	153
#define ID_textF_low_mb_pot			154
#define ID_pushB_use_ntr			155
 
#if ADD_NEW_MODEL
/***************** TO ADD A MODEL COPY AND ADAPT **************/
#define ID_pushB_X_neuron      			156
/***********************       STOP     ***********************/
#endif

/**************************** TO ADD A MODEL *******************/
/**************** VERIFY THAT THIS STAYS TRUE, ADAPT ***********/

#define NB_REGISTERED_WIDGETS           	155
#define MAX_REGITERED_WIDGETS           	156


GLOBAL char maj_version[256];
GLOBAL CLU *clu_index;
GLOBAL SIMULATION *simu;
GLOBAL NUCLEUS** sim_nucleus;
GLOBAL CLUSTER** sim_clusters;
GLOBAL NEURON** sim_neurons;
GLOBAL NUCLEUS* current_nucleus;
GLOBAL CLUSTER* current_cluster;
GLOBAL XtAppContext	app_context;
GLOBAL Widget	AppShell;
GLOBAL Widget   nucleus_parameters;
GLOBAL Widget   form_nucleus_parameters;
GLOBAL Widget   xnbc_simulator;
GLOBAL Widget   sim_mainW;
GLOBAL Widget   cluster_parameters;
GLOBAL Widget   form_cluster_parameters;
GLOBAL Widget   form_help;
GLOBAL Widget   form_stimulation;
GLOBAL Widget   stim_rowColumn;
GLOBAL Widget   form_graph;
GLOBAL Widget   graph_area;
GLOBAL Widget   *stim_label_w;
GLOBAL Widget   *stim_noise_w;
GLOBAL Widget   *stim_pulse_w;
GLOBAL Widget   *stim_modul_w;
GLOBAL Widget   *stim_drug_w;
GLOBAL Widget   *drug_toggle_w;
GLOBAL Widget   *crt_toggle_w;
GLOBAL Widget widget_array[MAX_REGITERED_WIDGETS];
GLOBAL Pixmap pixicon;
GLOBAL Colormap the_colormap;
GLOBAL Colormap palette;
GLOBAL Display *the_display;
GLOBAL char status_info[256];
GLOBAL char working_directory[256];
GLOBAL char project_directory[256];
GLOBAL char project_name[256];
GLOBAL char help_directory[256];	
GLOBAL char bin_directory[256];	
GLOBAL char input_file[256];
GLOBAL char output_file[256];
GLOBAL Boolean   *stim_noise_f;
GLOBAL Boolean   *stim_pulse_f;
GLOBAL Boolean   *stim_modul_f;
GLOBAL Boolean   *stim_drug_f;
GLOBAL Boolean	log_file;

GLOBAL char           *drug_file;
GLOBAL char           **drug_list,**drug_list_select;
GLOBAL XmStringTable  str_list_drug, str_list_drug_select, str_list_crt;
GLOBAL Widget         label_resultat_of_File_Name_Buttom;
GLOBAL Widget         List_drug;
GLOBAL Widget         form_drugs;
GLOBAL Widget         rc_drugs;
GLOBAL Widget         List_drug_Selected;
GLOBAL Widget         Buttom_drug_File_Selection;
GLOBAL Widget         radioBoxDrug;
GLOBAL int            *table_of_number_selection;
GLOBAL int            number_of_selection;
 
GLOBAL FILE *fdbg;
GLOBAL int debug;
GLOBAL int colormap;
GLOBAL int batch;
GLOBAL Widget *nucl_w;
GLOBAL Widget *clu_w;
GLOBAL Cursor working_cursor;
GLOBAL int detail;
GLOBAL int running;
GLOBAL int stopped;
GLOBAL int flag_stim_still;
GLOBAL char *text_buffer;
GLOBAL char **activity_buffers;
GLOBAL char *mod_buffer;
GLOBAL XtWorkProcId background_running;
GLOBAL XtWorkProcId background_displaying;
GLOBAL float lambda_poisson;
GLOBAL long unsigned previous_event;
GLOBAL long seed;   /* seed et set are for gasdev and ran1 */
GLOBAL long set;

GLOBAL GC gc_black;
GLOBAL GC gc_white;
GLOBAL GC gc_red;
GLOBAL GC gc_dot;
GLOBAL Drawable the_drawable;
GLOBAL int graph_area_width;

GLOBAL int NOIR;
GLOBAL int ROUGE;
GLOBAL int BLEU;
GLOBAL int VERT;
GLOBAL int VIOLET;
GLOBAL int MAUVE;
GLOBAL int TURQ;
GLOBAL int JAUNE;
GLOBAL int BLANC;


#if BUFERIZE_AND_FLUSH
GLOBAL char *tms_buffer;
GLOBAL FILE *tms_tmpfp;
GLOBAL unsigned long tms_size;
GLOBAL unsigned long tms_buf_size;
GLOBAL char *pmb_buffer;
GLOBAL FILE *pmb_tmpfp;
GLOBAL unsigned long pmb_size;
GLOBAL unsigned long pmb_buf_size;
GLOBAL char *sim_buffer;
#else
GLOBAL FILE *pmb_fp;
GLOBAL FILE *tms_fp;
GLOBAL FILE *sim_fp;
GLOBAL FILE *abe_fp;
GLOBAL FILE *mod_fp;
GLOBAL FILE *gnp_fp;
#endif
GLOBAL FILE *log_fp;

/*
 *	Macros
 */
/*
 * Macros to make code look nicer between ANSI and K&R.
 */
 
#define _BUFFER_SIZE_ (10000*sizeof(char))
 
#ifndef ARGLIST
#if (NeedFunctionPrototypes == 0)
#define PROTOTYPE(p)	()
#define ARGLIST(p)	p
#define ARG(a, b)	a b;
#define GRA(a, b)	a b;
#define UARG(a, b)      a b;
#define GRAU(a, b)      a b;
#else
#define PROTOTYPE(p)	p
#define ARGLIST(p)	(
#define ARG(a, b)	a b,
#define GRA(a, b)	a b)
#ifdef __cplusplus
#define UARG(a, b)      a,
#define GRAU(a, b)      a)
#else
#define UARG(a, b)      a b,
#define GRAU(a, b)      a b)
#endif
#endif
#endif
#define BX_APP_CLASS "XNBC"
#define BX_APP_NAME "XNBC Simulator"


GLOBAL int **table_of_drug_mask;
GLOBAL int nbr_drug;
GLOBAL float R_temp_ZF;
GLOBAL float sum_inputs;
	

/*
 * Structure d`un masque pour les courants inhibes par les drogues.
 */


#define  drug_Na     0
#define  drug_K      1
#define  drug_Ca     2
#define  drug_Cl     3
#define  drug_A      4
#define  drug_M      5
#define  drug_C      6
#define  drug_H      7
#define  drug_ahp    8
#define  drug_Nap    9
#define  drug_Cab    10
#define  drug_P      11
#define  drug_fuite  12
#define  drug_fuite_Na  13
#define  drug_fuite_K  14

#define  NBR_CRT 15


/* Nom des courants */
/* NON UTILISE

#define  I_Na_name     "I Na"
#define  I_K_name     "I K"
#define  I_Ca_name    "I Ca"
#define  I_Cl_name    "I Cl"
#define  I_A_name     "I A"
#define  I_M_name     "I M"
#define  I_C_name     "I C"
#define  I_H_name     "I H"
#define  I_ahp_name   "I ahp"
#define  I_Nap_name   "I Nap"
#define  I_Cab_name    "I Cab"
#define  I_P_name      "I P"
#define  I_fuite_name  "I leak"
#define  I_fuite_Na_name  "I leak Na"
#define  I_fuite_K_name  "I leak K"

*/

/*
 * Convenience functions from utilities file.
 */
extern void RegisterBxConverters();
extern XtPointer CONVERT();
extern XtPointer DOUBLE();
extern XtPointer SINGLE();
extern void MENU_POST();
extern Pixmap XPM_PIXMAP();
extern void SET_BACKGROUND_COLOR();

/*
 *	Callbacks prototypes
 */
 
void register_widget_CB();
void create_event_CB();
void sim_activate_CB();
void help_CB();
void nucl_para_activate_CB();
void clu_para_activate_CB();
void stimulation_CB();
void stim_noise_activate_CB();
void stim_pulse_activate_CB();
void stim_modul_activate_CB();
void stim_drug_activate_CB();
void stim_close_CB();
void stim_set_all_CB();
void stim_clear_all_CB();
void stim_start_all_CB();
void sim_next_stop_CB();
void start_alive_CB(Widget, XtPointer, XtPointer);
void start_hebb_CB(Widget, XtPointer, XtPointer);
void drug_activate_CB(Widget, XtPointer, XtPointer); 
void crt_disactivate_CB(Widget, XtPointer, XtPointer); 
void option_stim_nucl_CB(Widget, XtPointer, XtPointer); 

/*
 *	User functions prototypes
 */
 
void status_label_info();
void fill_label_info();
void clear_network();
void exit_simulator();
int load_simulator();
void init_simulation();
void launch_batch_simulation();
void status();
void _output();
void init_directories(void);
void update_directories(char *full_name);
int file_exists(char *file_name,char *dir_name);
int dir_exists(char *dir_name);
void display_nmda();
void display_connecting_weights();
void display_delays();
void display_repartition();
void modify_cluster();
void modify_nucleus();
int apply_nucleus_changes();
void init_nucleus_changes();
int apply_cluster_changes();
void init_cluster_changes();
char *bufferize();
char *data_bufferize();
char *bufferize_and_flush();
void change_cluster_type();
void change_simu_parameter();
void simulate();
void stop_simulation();
void configure_neurons();
Boolean run_simulation();
Boolean display_simulation();
void display_help(int flag);
void launch_application(char *, int, char *);
void MENU_WIN_DIALOG_create_message(Widget, char *);
void default_sim_values(void);
void drug_mask(int);
void resize_graph(Widget, XtPointer, XtPointer);

/*
 * Files management functions prototypes
 */


#if 0
int create_x_def_file();
int read_x_def_file();
#endif

int create_nucleus_file(void);
int create_x_sim_file(char *);
int read_x_sim_file(char *);
int create_neur_file();
int read_neur_file();
int read_lnk_file();
int read_clu_unit();
int read_unit_P_file();
int read_unit_V_file();
int read_unit_G_file();
CLUSTER *identify_cluster();
int which_neuron();

/*
 * Computing functions
 */

void update_V_res(int);
void update_G_res_use_ntr_simple(int);
void update_G_res_no_ntr_simple(int);
void update_G_res_use_ntr_full(int);
void update_G_res_no_ntr_full(int);
void update_P_res(int);
void update_B_res(int);
void update_L_res(int);

#if ADD_NEW_MODEL
/***************** TO ADD A MODEL COPY AND ADAPT **************/
void update_X_res(int);
/***********************       STOP     ***********************/
#endif

void hebb_learn();
float suminputs(float *ip_tc, float *im_tc, float * i_amp,
		       unsigned long * i_time, short head, short tail);
float suminputs_G(float *ip_tc, float *im_tc, float * i_amp,
		       unsigned long * i_time, short head, short tail);
float sum_NMDA(float coeff_NMDA, float t, float ip_tc, float im_tc, float * i_amp,
		       unsigned long * i_time, short head, short tail);
unsigned long GetInpInterval(int i_neur);
void init_inp_interval(int k_nucl);

/*
 *	Utilities functions for computing
 */

float ran1(long *idum);
float gasdev(long *idum);
void nrerror(char *error_text);
float exponential(float beta);
int initgamma(float alph, float bet);
double f_gamma(void);
float	f_poisson(float);
void	init_poisson(void);
float N(float mu, float sigma);
int arrondi(float f);
float modulation(NUCLEUS *);
void reactualise_E_Na_K(CBM*);
void reactualise_E_Na_K_simple(CBM*);

#endif






