#ifndef _SIM_FUNCTIONS_1_
#define _SIM_FUNCTIONS_1_

#include "creation-simu.h"
#include "sim_init.h"

/*******************************************************************************
	Function for filling label info help on line
*******************************************************************************/
void fill_label_info(Widget w,int message, XEvent *evt)
{
	XmString string;
	Widget label_info = widget_array[ID_label_info];
	switch(message)
	{
		case ID_pushB_new:
			string = XmStringCreateLocalized(
			"Open a new network (*.ntw) and begin a new simulation...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_continue:
			string = XmStringCreateLocalized(
			"Continue an old saved simulation (*.neur)...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_load_simulation:
			string = XmStringCreateLocalized(
			"Begin a new simulation with old saved parameters (*.x_def)...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
		case ID_pushB_save_simulation:
			string = XmStringCreateLocalized(
			"Save parameters of the simulation (*.x_def)...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_save_state:
			string = XmStringCreateLocalized(
			"Save current simulation files (*.prm,*.mod,*.sim,*.tms,*.pmb)...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;			
		case ID_pushB_close:
			string = XmStringCreateLocalized(
			"Close current simulation (and save if not yet done)...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_exit:
			string = XmStringCreateLocalized(
			"Exit the XNBC Simulator without saving...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_P_neuron:
			string = XmStringCreateLocalized(
			"Create or modify a Phenomenologic Model neuron...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
#if ADD_NEW_MODEL
/***************** TO ADD A MODEL COPY AND ADAPT **************/
		case ID_pushB_X_neuron:
			string = XmStringCreateLocalized(
			"Create or modify a XX New Model neuron...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;

/***********************       STOP     ***********************/
#endif
		case ID_pushB_L_neuron:
			string = XmStringCreateLocalized(
			"Create or modify a Leaky Integrator Model neuron...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;

		case ID_pushB_B_neuron:
			string = XmStringCreateLocalized(
			"Create or modify a Burster Unit Model neuron...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_G_neuron:
			string = XmStringCreateLocalized(
			"Create or modify a Conductance Based Model neuron...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
	        case ID_pushB_Create_Drug_File:
			string = XmStringCreateLocalized(
			"Create or modify a drug file...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_link_edit:
			string = XmStringCreateLocalized(
			"Create or modify a neural network using the simple editor...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_network_editor:
			string = XmStringCreateLocalized(
			"Create or modify a neural network using the full featured editor...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_toggle_dot:
			string = XmStringCreateLocalized(
			"Visualize a dot display during the simulation...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_toggle_global:
			string = XmStringCreateLocalized(
			"Visualize the global activity during the simulation...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_it_count:
			string = XmStringCreateLocalized(
			"Visualize the iteration number during the simulation...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_watch_sampling:
			string = XmStringCreateLocalized(
			"Visualize the millisecond number during the simulation...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_silent:
			string = XmStringCreateLocalized(
			"Run silenciously (nothing is shown to accelerate...)");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_save_pmb:
			string = XmStringCreateLocalized(
			"Choose the interval between membrane potential saving in .pmb file...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_visu:
			string = XmStringCreateLocalized(
			"Visualize the network and neuron behavior...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_xtms:
			string = XmStringCreateLocalized(
			"Time series analysis of individual neuron activity...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_xcaa:
			string = XmStringCreateLocalized(
			"Analysis of nuclei global activity...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_first_stop:
			string = XmStringCreateLocalized(
			"Change first simulation stop parameter...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_last_stop:
			string = XmStringCreateLocalized(
			"Change last simulation stop parameter...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
		case ID_pushB_time_step:
			string = XmStringCreateLocalized(
			"Change time step parameter...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
		case ID_pushB_spike_duration:
			string = XmStringCreateLocalized(
			"Change spike duration parameter...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_interrupt:
			string = XmStringCreateLocalized(
			"Interrupt simulation while running...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_run_simulation:
			string = XmStringCreateLocalized(
			"Run simulation until next stop or interruption request...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
		case ID_pushB_STIM:
			string = XmStringCreateLocalized(
			"Displays the stimulation control panel (Blue: no stim. on; Orange: at least one stim. on)");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_START_ALL:
			string = XmStringCreateLocalized(
			"Starts all stimulations and drugs simultaneously");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_STOP_ALL:
			string = XmStringCreateLocalized(
			"Stops all running stimulations and drugs");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
	        case ID_pushB_close_stim:
			string = XmStringCreateLocalized(
			"Closes the stimulation control panel...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
	        case ID_pushB_set_all_stim:
			string = XmStringCreateLocalized(
			"Starts all available stimulations.");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
	        case ID_pushB_clear_all_stim:
			string = XmStringCreateLocalized(
			"Stops all available stimulations.");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
	        case ID_pushB_stop_main:
			string = XmStringCreateLocalized(
			"Validates the value at right for the next stop.");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
	        case ID_text_stop_main:
			string = XmStringCreateLocalized(
			"Type here when to stop (fff.ff m for ms; dddd i for iterations).");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
		case ID_pushB_help_on_window:
			string = XmStringCreateLocalized(
			"Get help on window...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
		case ID_pushB_help_on_topic:
			string = XmStringCreateLocalized(
			"Topic oriented help...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_help_browse:
			string = XmStringCreateLocalized(
			"Browse the full xnbc manual...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_display_connecting_weights:
			string = XmStringCreateLocalized(
			"Display connecting weights matrix in the output text...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_display_transmission_delays:
			string = XmStringCreateLocalized(
			"Display transmission delays matrix in the output text...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
		case ID_pushB_display_nmda_sensibity:
			string = XmStringCreateLocalized(
			"Display nmda and glutamate interaction matrix...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_repartition:
			string = XmStringCreateLocalized(
			"Display nucleus neuron repartition by clusters...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;	
		case ID_cascadeB_nucleus:
			string = XmStringCreateLocalized(
			"Change nucleus simulation parameters...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_cascadeB_clusters:
			string = XmStringCreateLocalized(
			"Change clusters simulation parameters...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_use_ntr:
			string = XmStringCreateLocalized(
			"Toggle the use or not of neurotransimtors (if yes, only the connection weight is kept, not its sign)...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_Update:
			string = XmStringCreateLocalized(
			"Modify the connection pattern by reading a new network file...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_sim_default:
			string = XmStringCreateLocalized(
			"Back to default parameters for the simulation...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_display_info:
			string = XmStringCreateLocalized(
			"Display information about the selected cluster...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_toggleB_nucl_input_No_drug:
			string = XmStringCreateLocalized(
			"Disable drug injection possibility...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_toggleB_nucl_input_drug:
			string = XmStringCreateLocalized(
			"Enable drug injection possibility...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_list_drug:
			string = XmStringCreateLocalized(
			"Select here the drug to inject...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_selection_list_drug:
			string = XmStringCreateLocalized(
			"You can also selectively inhibit a current...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_tms_f:
			string = XmStringCreateLocalized(
			"Toggle the tms file creation (for time series analysis)...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_pmb_f:
			string = XmStringCreateLocalized(
			"Toggle the pmb file creation (intra cellular recordings)...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_sim_f:
			string = XmStringCreateLocalized(
			"Toggle the sim file creation (global activity)...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_abe_f:
			string = XmStringCreateLocalized(
			"Toggle the abe file creation (for spanake)...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;
		case ID_pushB_gnp_f:
			string = XmStringCreateLocalized(
			"Toggle the gnp file creation (for gnuplot)...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);
			break;

		default:
			break;
	}
	
}

/*******************************************************************************
	Function for displaying a status in the label info
*******************************************************************************/
void status_label_info(Widget w,int message, XEvent *evt)
{
	XmString string;
	Widget label_info = widget_array[ID_label_info];
	
	string = XmStringCreateLocalized(status_info);
	XtVaSetValues(label_info,XmNlabelString,string,NULL);
	XmStringFree(string);	
	
}	
/*******************************************************************************
	Function for exiting simulator
*******************************************************************************/
void exit_simulator(int force)
{
	int i;
	char *home;
	char buffer[256];
	
	if(!force)
	{
		if (simu->started && !simu->saved)
		{
			if(display_question(widget_array[ID_sim_mainW],
					    "Do you really want to exit WITHOUT SAVING ?",
					    "Confirmation needed...") 
			   == NO_ANSWER)
				return;
		} /* fin du if */
	}
	home = getenv("HOME");
	if(home)
	{
	    strcpy(buffer,home);
	    strcat(buffer,"/.nbc_xrc");
	}
	else
	  strcpy(buffer,"./.nbc_xrc");

	create_x_sim_file(buffer);

	clear_network();
	free(simu);
	if(!batch && pixicon)
	{
		XFreePixmap(the_display,pixicon);
		pixicon = 0;
	}
	
#if BUFFERIZE_AND_FLUSH
	if(tms_buffer)
	{
		free(tms_buffer);
		tms_buffer = NULL;
		if(tms_tmpfp)
		{
			fclose(tms_tmpfp);
			tms_tmpfp = NULL;
		}
	}
	if(pmb_buffer)
	{
		free(pmb_buffer);
		pmb_buffer = NULL;
		if(pmb_tmpfp)
		{
			fclose(pmb_tmpfp);
			pmb_tmpfp = NULL;
		}
	}
	if(sim_buffer)
	{
		for(i=0 ; i<simu->nb_nucleus ; i++)
		{
			
			free(activity_buffers[i]);
			activity_buffers[i] = NULL;
		}
		
		free(sim_buffer);
		sim_buffer = NULL;
	}
#else
	if (pmb_fp)
	{
		fclose(pmb_fp);
		pmb_fp = NULL;
	}
	if (tms_fp)
	{
		fclose(tms_fp);
		tms_fp = NULL;
	}
	if (gnp_fp)
	{
	        fclose(gnp_fp);
		gnp_fp = NULL;
	}
	if (sim_fp)
	{
		fclose(sim_fp);
		/*
		rearrange_sim_file();
		*/
		sim_fp = NULL;
	}
#endif
	if (abe_fp)
	{
	        fclose(abe_fp);
		abe_fp = NULL;
	}
	if(mod_buffer)
	{
		free(mod_buffer);
		mod_buffer = NULL;
	}

	if(str_list_drug)
	  {
	    XtFree((char *)str_list_drug);
	    str_list_drug = NULL;
	  }
	
	if(str_list_drug_select)
	  {
	    XtFree((char *)str_list_drug_select);
	    str_list_drug_select = NULL;
	  }

	if(table_of_drug_mask)
	  {
	    for( i = 0 ; i< nbr_drug ; i++)
	      {
		free(table_of_drug_mask[i]);
	      }
	    free(table_of_drug_mask);
	    table_of_drug_mask = NULL;
	  }


	if(table_of_number_selection)
	{
		free(table_of_number_selection);
		table_of_number_selection = NULL;
	}
    


	if(!batch)
		display_help(-1);
	
	if(!batch)
		XtDestroyWidget(AppShell);
#if NBC_X_DEBUG
	if((debug) && (fdbg != stderr))
		fclose(fdbg);
#endif		
	
	if (log_file)
	{
		fprintf(log_fp,"End of simulation\n");
	        fclose(log_fp);
		log_fp = NULL;
	}

	exit(0);

}
/*******************************************************************************
	Function for clearing network simulation data
*******************************************************************************/
void clear_network(void)
{
	int i,j;
	NEURON *neuron_tmp;
	NUCLEUS *nucleus_tmp;
	CLUSTER *cluster_tmp;
	char buffer[256];
	
	running = stopped = False;
	
	if(!batch)
		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				working_cursor);
	
	if(sim_neurons)
	{
		for(i=0 ; i<simu->nb_neurons ; i++)
		{
			neuron_tmp = sim_neurons[i];
			if(!neuron_tmp)
				continue;
			if(neuron_tmp->neuron_data)
			{
				free(neuron_tmp->neuron_data);
				neuron_tmp->neuron_data = NULL;
			}
			if(neuron_tmp->axone_length)
			{
				free(neuron_tmp->axone_length);
				neuron_tmp->axone_length = NULL;
			}
			if(neuron_tmp->axone_step)
			{
				free(neuron_tmp->axone_step);
				neuron_tmp->axone_step = NULL;
			}
			if(neuron_tmp->connections)
			{
				free(neuron_tmp->connections);
				neuron_tmp->connections = NULL;
			}
			if(neuron_tmp->next_spike)
			{
				free(neuron_tmp->next_spike);
				neuron_tmp->next_spike = NULL;
			}
			if(neuron_tmp->targets)
			{
				free(neuron_tmp->targets);
				neuron_tmp->targets = NULL;
			}
			if(neuron_tmp->nmda)
			{
				free(neuron_tmp->nmda);
				neuron_tmp->nmda = NULL;
			}
			free(neuron_tmp);
			sim_neurons[i] = NULL;
		}
		free(sim_neurons);
		sim_neurons = NULL;
	}

	if(sim_nucleus)
	{
		for(i=0 ; i<simu->nb_nucleus ; i++)
		{
			nucleus_tmp = sim_nucleus[i];
			if(!nucleus_tmp)
				continue;
			if(nucleus_tmp->neuron_array)
			{
				free(nucleus_tmp->neuron_array);
				nucleus_tmp->neuron_array = NULL;
			}
			if(nucleus_tmp->cluster_array)
			{
				free(nucleus_tmp->cluster_array);
				nucleus_tmp->cluster_array = NULL;
			}
			free(sim_nucleus[i]);
			sim_nucleus[i] = NULL;
		}
		free(sim_nucleus);
		sim_nucleus = NULL;	
	}

	if(sim_clusters)
	{
		for(i=0 ; i<simu->nb_clusters ; i++)
		{
			cluster_tmp = sim_clusters[i];
			if(!cluster_tmp)
				continue;
			if(cluster_tmp->model == 'V')
			{
				if(cluster_tmp->clu_data)
				{
					if(((VIRTUAL *)cluster_tmp->clu_data)->fp_tms)
					{
						fclose(((VIRTUAL *)cluster_tmp->clu_data)->fp_tms);
						((VIRTUAL *)cluster_tmp->clu_data)->fp_tms = NULL;
					}
					free(cluster_tmp->clu_data);
					cluster_tmp->clu_data = NULL;
				}
			}
			else if(cluster_tmp->clu_data)
			{
				free(cluster_tmp->clu_data);
				cluster_tmp->clu_data = NULL;
			}
			if(cluster_tmp->neuron_array)
			{
				free(cluster_tmp->neuron_array);
				cluster_tmp->neuron_array = NULL;
			}
			if(cluster_tmp->nucleus_array)
			{
				free(cluster_tmp->nucleus_array);
				cluster_tmp->nucleus_array = NULL;
			}
			free(sim_clusters[i]);
			sim_clusters[i] = NULL;
		}
		free(sim_clusters);
		sim_clusters = NULL;
	}

	if(nucl_w)
	{
		for(i=0 ; i<simu->nb_nucleus ; i++)
		{
			if(nucl_w[i])
			{
				XtDestroyWidget(nucl_w[i]);
				nucl_w[i] = (Widget)NULL;
			}

		}
		XtFree((XtPointer)nucl_w);
		nucl_w = (Widget *)NULL;
	}
	if(clu_w)
	{
		for(i=0 ; i<simu->nb_clusters ; i++)
		{
			if(clu_w[i])
			{
				XtDestroyWidget(clu_w[i]);
				clu_w[i] =(Widget)NULL;
			}

		}
		XtFree((XtPointer)clu_w);
		clu_w = (Widget *)NULL;

	}
	
	if(!batch)
	{
		XtManageChild(widget_array[ID_pushB_nucleus_none]);
		XtManageChild(widget_array[ID_pushB_cluster_none]);
		
		XtSetSensitive(widget_array[ID_pushB_new],True);
		XtSetSensitive(widget_array[ID_pushB_continue],True);
		XtSetSensitive(widget_array[ID_pushB_load_simulation],True);
		XtSetSensitive(widget_array[ID_pushB_save_state],False);
		XtSetSensitive(widget_array[ID_pushB_save_simulation],False);
		XtSetSensitive(widget_array[ID_pushB_close],False);
		XtSetSensitive(widget_array[ID_pushB_time_step],True);
		XtSetSensitive(widget_array[ID_pushB_spike_duration],True);
		
		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				0);
		
		sprintf(buffer,"\n\nAll simulation name, parameters and network have been cleared.");
		_output(buffer);
		sprintf(buffer,"Simulator is empty.");
		_output(buffer);
	}

#if BUFFERIZE_AND_FLUSH
	if(activity_buffers)
	{
		free(activity_buffers);
		activity_buffers = NULL;
	}
#endif	
	free(simu);
	simu = (SIMULATION *)calloc(1,sizeof(SIMULATION));
	simu->started = False;

}


/*******************************************************************************
	Function for loading the simulator with .neur or .ntw file
*******************************************************************************/
int load_simulator(void)
{
	char buffer[256];
	char *pt;
	char ext[10];
	char path[256];
	
	
	if(!*input_file)
	{
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],
			"Sorry, can't load simulator...","Nothing to Load !");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
		
	}
	
	/* now find out what type of file it is */
	
	strcpy(buffer,input_file);

	if(pt = strrchr(buffer,'.'))
	{
		strcpy(ext,pt);
		*pt = '\0';
	}
	else
		*ext = '\0';
		
	if(pt = strrchr(buffer,'/'))
	{
		*pt = '\0';
		pt++;
		strcpy(project_name,pt);
		if(*buffer == '~')
		{
			strcpy(path,working_directory);
			strcat(path,&buffer[1]);
		}
		else
			strcpy(path,buffer);
	}
	else
	{
		strcpy(project_name,buffer);
		strcpy(path,working_directory);
	}

	if( !*ext || !strcmp(ext,".ntw"))
	{
		
		/* loading network */
	        if(!*ext)
	           strcpy(ext,".ntw");
	
		sprintf(buffer,"%s/%s%s",path,project_name,ext);
		update_directories(buffer);
		sprintf(buffer,"%s%s",project_name,ext);
		if(!file_exists(buffer,project_directory))
		{
			sprintf(buffer,"File %s/%s%s doesn't exits...",project_directory,
				project_name,ext);
			if(!batch)
			{
				display_error(widget_array[ID_sim_mainW],buffer,
					"Network not available !");
				init_directories();
				*project_name = '\0';
				return -1;
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
				exit_simulator(True);
			}
		}
		sprintf(buffer,"\n\nLoading %s/%s%s...\n",project_directory,project_name,ext);
		if(!batch)
		{
			_output(buffer);
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);			
		}
		
		if(!batch && debug)
		{
			sprintf(buffer,"Do you accept to skip individual neuron description at read time ?");
			if(display_question(widget_array[ID_sim_mainW],buffer,"Read Option") ==
				YES_ANSWER)
				detail = False;
			else
				detail = True;
		}
		sprintf(buffer,"%s/%s%s",project_directory,project_name,ext);
		if(!batch)
			XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				working_cursor);
		if(read_lnk_file(buffer))
		{
			sprintf(buffer,"Error occured while reading %s/%s%s...",
				project_directory,project_name,ext);
			if(!batch)
			{
				XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
					0);
				display_error(widget_array[ID_sim_mainW],buffer,
					"Read Error !");
				init_directories();
				*project_name = '\0';
				status("No Loaded Network (*.ntw)");
				return -1;
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
				exit_simulator(True);
			}
		}
		if(!batch)
			status("Ready: configure and run simulation.");
			
		simu->parameters_loaded = False;
		if(!batch)
			XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
					0);
		
	}
	else if(!strcmp(ext,".neur"))
	{
		
		/* loading neuron state file */
		
		sprintf(buffer,"%s/%s%s",path,project_name,ext);
		update_directories(buffer);
		sprintf(buffer,"%s%s",project_name,ext);
		if(!file_exists(buffer,project_directory))
		{
			sprintf(buffer,"File %s/%s%s doesn't exits...",project_directory,
				project_name,ext);
			if(!batch)
			{
				display_error(widget_array[ID_sim_mainW],buffer,
				"Neuron States not available !");
				init_directories();
				*project_name = '\0';
				return -1;
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
				exit_simulator(True);
			}
		}
		sprintf(buffer,"\n\nLoading %s/%s%s...\n",project_directory,project_name,ext);
		if(!batch)
		{
			_output(buffer);
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
		}

		if(!batch && debug)
		{
			sprintf(buffer,"Do you accept to skip individual neuron description at read time ?");
			if(display_question(widget_array[ID_sim_mainW],buffer,"Read Option") ==
				YES_ANSWER)
				detail = False;
			else
				detail = True;
		}
		sprintf(buffer,"%s/%s%s",project_directory,project_name,ext);
		if(!batch)
			XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				working_cursor);
		

		if(read_neur_file(buffer))
		{
			sprintf(buffer,"Error occured while reading %s/%s%s...",
				project_directory,project_name,ext);
			if(!batch)
			{
				
				XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
					0);
				display_error(widget_array[ID_sim_mainW],buffer,
				"Read Error !");
				init_directories();
				*project_name = '\0';
				status("No Loaded Network (*.ntw)");
				return -1;
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
				exit_simulator(True);
			}
		}
		if(!batch)
			status("Ready: configure and run simulation.");
			
		simu->parameters_loaded = True;
		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
					0);
	}
	else
	{
		sprintf(buffer,"File %s/%s%s as an invalid extension...",path,project_name,ext);
		display_error(widget_array[ID_sim_mainW],buffer,
				"Invalid File Name !");
		*project_name = '\0';
		return -1;
	}
	
	return 0;
	
}


/*******************************************************************************
	Function for loading the simulator with a new .len and .wgt file
*******************************************************************************/
int reload_network(char *lnk_name)
{
	FILE *fp_wgt;
	FILE *fp_len;
	char *pt;
	char *out_buf;
	char ext[10];
	char path[256];
	char without_ext_name[256];
	char dir[256];
	int i,j,k,m,p;
	char buffer[256];
	char unit_name[256];
	char field[256];
	char value[256];
	char mask[10];
	float float_value;
	int	num;
	int new_nucleus;
	int counter;
	short short_value;

	out_buf = NULL;
	
	/* first verify if all lnk clu len anat wgt exist or not */ 


	strcpy(buffer,lnk_name);

	if(pt = strrchr(buffer,'.'))
	{
		*pt='\0';
	}
	if(pt = strrchr(buffer,'/'))
	{
		*pt = '\0';
		pt++;
		strcpy(without_ext_name,pt);
		strcpy(dir,buffer);
	}
	else
	{
		strcpy(without_ext_name,buffer);
		strcpy(dir,project_directory);
	}
	
	sprintf(buffer,"%s.ntw",without_ext_name);
	
	if(!*lnk_name)
	{
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],
			"Sorry, can't load new network...","Nothing to Load !");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
		
	}
	

	/* loading network */

	sprintf(buffer,"\nLoading new network %s...\n",lnk_name);
	if(!batch)
	{
		_output(buffer);
	}
	else
	{
		strcat(buffer,"\n");
		fprintf(stderr,buffer);			
	}

	/****/
	
	
	/*--------------------reading wgt-------------------*/
	
	sprintf(buffer,"%s/%s.wgt",dir,without_ext_name);
	fp_wgt = fopen (buffer, "r");
	
	/* testing file pointer , in case of failure -> return -1*/
	
	if(!fp_wgt)
	{
	
		sprintf(buffer,"Can't open %s/%s.wgt...new network unreadable.",dir,without_ext_name);
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],buffer,"Access Error");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
	}
	
	fread(&short_value,1,sizeof(short),fp_wgt);
	if(short_value != simu->nb_nucleus)
	{
		sprintf(buffer,"Wrong number of nucleus specified in %s/%s.wgt",dir,without_ext_name);
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
			clear_network();
			status("No Loaded Network (*.ntw)");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
	}
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		fread(&short_value,1,sizeof(short),fp_wgt);
		if(short_value != (short)sim_nucleus[i]->nucleus_size)
		{
			sprintf(buffer,"Wrong number of neurons for nucleus %d specified in %s/%s.wgt",
				i+1,dir,without_ext_name);
			if(!batch)
			{
				display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
				clear_network();
				status("No Loaded Network (*.ntw)");
				return -1;
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
				exit_simulator(True);
			}
		}
	}

	
	/* NOW CONNECTIONS AND NMDA */
	
	/* for each neuron, neuron's id,its cluster's id (network editor's id here unused)
		, number of connected neurons */
	/* then for each connection: target neuron's id, nmda flag, synaptic weight */ 


	for(i=0 ; i<simu->nb_neurons ; i++)
	{
		fread(&short_value,1,sizeof(short),fp_wgt);
		sim_neurons[i]->id = short_value;
		fread(&short_value,1,sizeof(short),fp_wgt);
		/* unused */
		fread(&short_value,1,sizeof(short),fp_wgt);
		sim_neurons[i]->connected_neurons = short_value;
		if(!short_value)
			continue;
		sim_neurons[i]->targets = (short *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(short));
		sim_neurons[i]->connections = (short *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(short));
		sim_neurons[i]->nmda = (short *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(short));
		sim_neurons[i]->next_spike = (short *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(short));
		sim_neurons[i]->axone_length = (float *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(float));
		sim_neurons[i]->axone_step = (unsigned long *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(unsigned long));
			
		for(j=0 ; j<sim_neurons[i]->connected_neurons ; j++)
		{
			fread(&short_value,1,sizeof(short),fp_wgt);
			sim_neurons[i]->targets[j] = short_value;
			fread(&short_value,1,sizeof(short),fp_wgt);
			sim_neurons[i]->nmda[j] = short_value;
			fread(&short_value,1,sizeof(short),fp_wgt);
			if (simu->use_ntr)
				sim_neurons[i]->connections[j] = abs(short_value);
			else
				sim_neurons[i]->connections[j] = short_value;
		} 	
				
	}
	fclose(fp_wgt);
	
#if DEBUG_FILES
	sprintf(buffer,"%s/%s.wgt",dir,without_ext_name);
	fprintf(stderr,"%s file successfuly read\n",buffer);
#endif
	
	/*-----------------reading len----------------------*/
	
	sprintf(buffer,"%s/%s.len",dir,without_ext_name);
	fp_len = fopen (buffer, "r");
	
	/* testing file pointer , in case of failure -> return -1*/
	
	if(!fp_len)
	{
	
		sprintf(buffer,"Can't open %s/%s.len...network unreadable.",dir,without_ext_name);
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],buffer,"Access Error");
			clear_network();
			status("No Loaded Network (*.ntw)");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
	}
	
	fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
	fprintf(stderr,"nb nucleus: %d \n",short_value);
#endif
	if(short_value != simu->nb_nucleus)
	{
		sprintf(buffer,"Wrong number of nucleus specified in %s/%s.len",dir,without_ext_name);
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
			clear_network();
			status("No Loaded Network (*.ntw)");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
	}
#if DEBUG_FILES
	fprintf(stderr,"%s file phase 1 successfuly read\n",buffer);
#endif
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
		fprintf(stderr,"nb neurons nucl %d: %d \n",i+1, short_value);
#endif
		if(short_value != (short)sim_nucleus[i]->nucleus_size)
		{
			sprintf(buffer,"Wrong number of neurons for nucleus %d specified in %s/%s.len",
				i+1,dir,without_ext_name);
			if(!batch)
			{
				display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
				clear_network();
				status("No Loaded Network (*.ntw)");
				return -1;
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
				exit_simulator(True);
			}
		}
		
	}
#if DEBUG_FILES
	fprintf(stderr,"%s file phase 2 successfuly read\n",buffer);
#endif

	
	/* NOW AXONE LENGTHS */
	
	/* for each neuron, neuron's id,its cluster's id (network editor's id here unused)
		, number of connected neurons */
	/* then for each connection: target neuron's id, axone length */ 


	for(i=0 ; i<simu->nb_neurons ; i++)
	{
#if DEBUG_FILES
		fprintf(stderr,"Reading neuron %d\n",i+1);
#endif
		sim_neurons[i]->number = i+1;
		fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
		fprintf(stderr,"neuron  %d: id: %d \n",i+1, short_value);
#endif
		sim_neurons[i]->id = short_value;
		fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
		fprintf(stderr,"neuron  %d: cluster id: %d \n",i+1, short_value);
#endif
		/* unused */
		fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
		fprintf(stderr,"neuron  %d: nb_connected: %d \n",i+1, short_value);
#endif
		if(sim_neurons[i]->connected_neurons != short_value)
		{
#if DEBUG_FILES
			fprintf(stderr,"neuron %d: %d connected neurons\n",i+1,sim_neurons[i]->connected_neurons);
#endif
			sprintf(buffer,"Wrong number of connected neurons for neuron %d specified in %s/%s.len",
				i+1,dir,without_ext_name);
			if(!batch)
			{
				display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
				clear_network();
				status("No Loaded Network (*.ntw)");
				return -1;
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
				exit_simulator(True);
			}
		
		}
		if(!short_value)
		{
			sprintf(buffer,"neuron %ld: id %ld, nucleus %s, cluster %s, %ld connections.\n",
				sim_neurons[i]->number,
				sim_neurons[i]->id,
				sim_neurons[i]->its_nucleus->name,
				sim_neurons[i]->its_cluster->file_name,
				sim_neurons[i]->connected_neurons);
#if DEBUG_FILES
			fprintf(stderr,"%s",buffer);
#endif
			if(!batch && detail)
				out_buf = bufferize(out_buf,buffer);
			else if(detail)
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
			}
		}	
#if DEBUG_FILES
		fprintf(stderr,"%s file phase 3 successfuly read\n",buffer);
#endif
		for(j=0 ; j<sim_neurons[i]->connected_neurons ; j++)
		{
#if DEBUG_FILES
			fprintf(stderr,"Reading connection %d to %d\n",i, j);
#endif

			fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
			fprintf(stderr,"neuron  %d to %d: target: %d \n",i+1, j+1, short_value);
#endif
			if(sim_neurons[i]->targets[j] != short_value)
			{
				sprintf(buffer,"Wrong target id for target %d of neuron %d specified in %s/%s.len",
					j+1,i+1,dir,without_ext_name);
#if DEBUG_FILES
				fprintf(stderr,"%s\n",buffer);
				fprintf(stderr,"Target should be %d\n", sim_neurons[i]->targets[j]); 
#endif
				if(!batch)
				{
					display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
					clear_network();
					status("No Loaded Network (*.ntw)");
					return -1;
				}
				else
				{
					strcat(buffer,"\n");
					fprintf(stderr,buffer);
					exit_simulator(True);
				}
					
			}
			fread(&float_value,1,sizeof(float),fp_len);
#if DEBUG_FILES
			fprintf(stderr,"neuron  %d to %d: length: %f \n",i+1, j+1, float_value);
#endif
			sim_neurons[i]->axone_length[j] = float_value;
#if DEBUG_FILES
			fprintf(stderr,"%s file phase 4 OK\n",buffer);
#endif
		
		}
#if DEBUG_FILES
		fprintf(stderr,"%s file phase 4 successfuly read\n",buffer);
#endif
		sprintf(buffer,"neuron %ld: id %ld, nucleus %s, cluster %s, %ld connections.\n",
				sim_neurons[i]->number,
				sim_neurons[i]->id,
				sim_neurons[i]->its_nucleus->name,
				sim_neurons[i]->its_cluster->file_name,
				sim_neurons[i]->connected_neurons);
		if(!batch && detail)
			out_buf = bufferize(out_buf,buffer);
		else if(detail)
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
		}
	}
	if(!batch && detail)
	{
		_output(out_buf);
		free(out_buf);
	}
	fclose(fp_len);

	/****/
	if(!batch)
		status("Ready: run simulation.");

	if(!batch)
		XDefineCursor(the_display,XtWindow(widget_array[ID_sim_mainW]),
				0);
	
	return 0;
	
}


/*******************************************************************************
	Function for batching simulation
*******************************************************************************/
void launch_batch_simulation(void)
{

    FILE *fp;
    char tmp[_BUFFER_SIZE_];
    int i;
	
    if(!load_simulator())
      init_simulation();
    else
    {
    	exit_simulator(True);
    }
    
    create_prm_file_for_graph(simu->prm_name);
    configure_neurons(True);
    
    while(simu->nb_it != simu->last_it)
    {
    	running = True;
    	run_simulation(&running);
    	if(!running)
    	{
    		fprintf(stderr,text_buffer);
    		free(text_buffer);
    		text_buffer = NULL;
    		running = True;
    	}
    }
    if ((pmb_fp = fopen(simu->pmb_name,"w")) == NULL)
      {
	printf("\007Impossible to open %s\n",simu->pmb_name);
      }
    
    if ((tms_fp = fopen(simu->tms_name,"w")) == NULL)
      {
	printf("\007Impossible to open %s\n",simu->tms_name);
      }
    
    if ((gnp_fp = fopen(simu->gnp_name,"w")) == NULL)
      {
	printf("\007Impossible to open %s\n",simu->gnp_name);
      }
    
    if ((sim_fp = fopen(simu->sim_name,"w")) == NULL)
      {
	printf("\007Impossible to open %s\n",simu->sim_name);
      }
    if ((abe_fp = fopen(simu->abe_name,"w")) == NULL)
      {
	printf("\007Impossible to open %s\n",simu->abe_name);
      }
    else
      start_abe_file();
#if OLD_VISU
    create_cnx_for_visu(simu->cnx_name);
#endif
    if(mod_buffer)
    {
    	if ((fp = fopen(simu->mod_name,"w")) == NULL)
	{
	    printf("\007Impossible to open %s\n",simu->mod_name);
	}
	else
	{
	  fprintf(fp,"%s",mod_buffer);
	  fclose(fp);
	  free(mod_buffer);
	  mod_buffer = NULL;
	}
    }
    else
    {
    	if ((fp = fopen(simu->mod_name,"w")) == NULL)
	{
	    printf("\007Impossible to open %s\n",simu->mod_name);
	}
	else
	  fclose(fp);
    }
    fprintf(stderr,"\nSimulation from file %s to outputs %s finished.\nBye.\n",
	 		input_file,output_file);
    exit_simulator(True);

}
/*******************************************************************************
	Function for displaying simulator status
*******************************************************************************/
void status(char *tmp)
{
	XmString string;
	
	strcpy(status_info,tmp);
	string = XmStringCreateLocalized(tmp);
	XtVaSetValues(widget_array[ID_label_info],XmNlabelString,string,NULL);
	XmStringFree(string);

}
/*******************************************************************************
	Function for displaying simulator status line in the text area
*******************************************************************************/
void _output(char *tmp)
{
	char *pt;
	static XmTextPosition wpr_position = 0;
	
	if(!wpr_position)
	{
		wpr_position = XmTextGetLastPosition(widget_array[ID_text_simulator]);
		XmTextInsert(widget_array[ID_text_simulator],wpr_position,"\n\n");
		wpr_position += strlen("\n\n");
	}
	pt = (char *)calloc(1,(strlen(tmp)+strlen("\n")+1)*sizeof(char));
	strcpy(pt,tmp);
	strcat(pt,"\n");
	
	XmTextInsert(widget_array[ID_text_simulator],wpr_position,pt);
	wpr_position += strlen(pt);
	XtVaSetValues(widget_array[ID_text_simulator],XmNcursorPosition,wpr_position,NULL);
	XmTextShowPosition(widget_array[ID_text_simulator],
		wpr_position);
		
	free(pt);
	/*
	 * Ecriture de la log file
	 */
	if (log_file)
	{
		fprintf(log_fp,"%s\n",tmp);
	}
}
/*******************************************************************************
	Function for initializing global directory variables
*******************************************************************************/
void init_directories(void)
{
	FILE	*p_rc;
	char	*home;
	char    *pt;
	char	*nbc_VMAJ_bin;
	char	*nbc_VMAJ_help;
	char	buffer[256];

	strcpy(buffer,get_simulation_name());
	
	strcpy(project_directory,get_dir_name());

	nbc_VMAJ_bin = getenv("XNBC_BIN_DIR_TOOLS");
	if(nbc_VMAJ_bin)
	{
		strcpy(bin_directory,nbc_VMAJ_bin);
	}
	else
	{
		sprintf(bin_directory,"/usr/local/bin/xnbc.bin/V%d",MAJ_VERSION);
		fprintf(stderr,"XNBC_BIN_DIR_TOOLS not defined, using %s\n",
			bin_directory);
	}
	nbc_VMAJ_help = getenv("XNBC_HELP_DIR");
	if(nbc_VMAJ_help)
	{
		strcpy(help_directory,nbc_VMAJ_help);
		strcat(help_directory,"/nbc_x");
	}
	else
	{
		sprintf(help_directory,"/usr/local/bin/xnbc.bin/V%d/help",MAJ_VERSION);
		fprintf(stderr,"XNBC_HELP_DIR not defined, using %s\n",
			help_directory);
		strcat(help_directory,"/nbc_x");
	}
}
/*******************************************************************************
	Function for updating directories
*******************************************************************************/
void update_directories(char *full_name)
{
	char *pt;
	char buffer[256];
	char tmp[256];
	char ext[10];
	
	strcpy(buffer,full_name);
	
	if((pt = strrchr(buffer,'.'))!=NULL)
	{
			strcpy(ext,pt);
			*pt='\0';
	}
	else
		*ext = '\0';
			
	if((pt = strrchr(buffer,'/'))!= NULL)
	{
		*pt = '\0';
		pt++;
		strcpy(project_directory,buffer);
		if(!strstr(project_directory,"_nbc"))
		{
			sprintf(tmp,"%s%s",pt,ext);
			if(!file_exists(tmp,buffer))
			{
				strcat(project_directory,"/");
				strcat(project_directory,pt);
				strcat(project_directory,"_nbc");
			}
		}
		if(!dir_exists(project_directory))
		{
			sprintf(tmp,"mkdir %s",project_directory);
			system(tmp);
		}
		
	}
	else
	{
		strcpy(project_directory,working_directory);
		if(!strstr(project_directory,"_nbc"))
		{
			sprintf(tmp,"%s%s",buffer,ext);
			if(!file_exists(tmp,working_directory))
			{
				strcat(project_directory,"/");
				strcat(project_directory,buffer);
				strcat(project_directory,"_nbc");
			}
		}
		if(!dir_exists(project_directory))
		{
			sprintf(tmp,"mkdir %s",project_directory);
			system(tmp);
		}
		
	}

}

#include <sys/types.h>
#include <dirent.h>

/*******************************************************************************
	Function for searching for a file in the specified directory
*******************************************************************************/
int file_exists(char *file_name,char *dir_name)
{
	int len;
	struct dirent *dp;
	DIR *dir_pointer;

	len = strlen(file_name);
	dir_pointer = opendir(dir_name);
	if(!dir_pointer)
	{
		return False;
	}
	for (dp = readdir(dir_pointer); dp != NULL; dp = readdir(dir_pointer))
	{
	       if (strlen(dp->d_name) == len && !strcmp(dp->d_name, file_name))
	       {
	               closedir(dir_pointer);
	               return True;
	       }
	} /* fin du for */
	closedir(dir_pointer);
	return False;

}
/*******************************************************************************
	Function for testing if directory exists
*******************************************************************************/
int dir_exists(char *dir_name)
{
	DIR *dir_pointer;

	dir_pointer = opendir(dir_name);
	if(!dir_pointer)
		return False;
	closedir(dir_pointer);
	return True;	
}
/*******************************************************************************
	Function for initializing the simulation after network load
*******************************************************************************/
void init_simulation()
{
	char *pt;
	int i;
	int answer;
	Arg      args[256];
	Cardinal ac=0;
	Boolean  argok=False;
	char buffer[256];
	XmString xmstring;

	if(*output_file)
	{
		strcpy(buffer,output_file);
		if(pt = strrchr(buffer,'.'))
			*pt = '\0';
		if(pt = strrchr(buffer,'/'))
		{
			pt++;
			strcpy(output_file,pt);
		}
		else
			strcpy(output_file,buffer);
		
	}
	
		
	sprintf(buffer,"Network %s ready for simulation.",project_name);
	if(!batch)
	{
		status(buffer);
	}
	else
	{
		strcat(buffer,"\n");
		fprintf(stderr,buffer);
	}

        sprintf(buffer,"%s/",project_directory);
	put_dir_name(get_dir_name(),buffer);
        sprintf(buffer,"%s/%s",project_directory,project_name);
	put_project_name(get_dir_name(),buffer);

	if(!simu->parameters_loaded)
	{
		simu->stop_at_ms = (float)simu->next_stop;
		simu->next_stop = (unsigned long)nintf(simu->stop_at_ms / simu->time_step);

		simu->end_at_ms = (float)simu->last_it;
		simu->last_it = (unsigned long)nintf(simu->end_at_ms / simu->time_step);

		simu->nb_next_it = simu->next_stop;

		simu->nb_step_spk = (unsigned long)nintf(simu->spike_width / simu->time_step);
		simu->nb_step_save_it = (unsigned long)nintf((float)simu->nb_step_save_ms / simu->time_step);
		simu->nb_step_watch_it = (unsigned long)nintf((float)simu->nb_step_watch_ms / simu->time_step);
		simu->count_show_it = (unsigned long)nintf((float)simu->count_show_ms / simu->time_step);
		
	}

	if(!batch)
	{
		do
		{
		    sprintf(buffer,"Do you want to change the simulation name (now %s)?",project_name);
		    if((*output_file) && (display_question(widget_array[ID_sim_mainW],buffer,
			    "Confirmation needed...") == NO_ANSWER))

		    {
			    sprintf(simu->prm_name,"%s/%s.prm",project_directory,project_name);
			    sprintf(simu->sim_name,"%s/%s.sim",project_directory,project_name);
			    sprintf(simu->mod_name,"%s/%s.mod",project_directory,project_name);
			    sprintf(simu->pmb_name,"%s/%s.pmb",project_directory,project_name);
			    sprintf(simu->gnp_name,"%s/%s.gnp",project_directory,project_name);
			    sprintf(simu->cnx_name,"%s/%s.cnx",project_directory,project_name);
			    sprintf(simu->tms_name,"%s/%s.tms",project_directory,project_name);
			    sprintf(simu->abe_name,"%s/%s.abe",project_directory,project_name);
			    strcpy(simu->name,project_name);

		    }
		    else
		    {
			    pt = display_prompt(widget_array[ID_sim_mainW],
				    "Choose a simulation name:",project_name,"Simulation Name");
			    if(!pt)
			    {
			      sim_activate_CB(NULL, ID_pushB_new, NULL);
			      return;
			    }
			    else
				    strcpy(simu->name,pt);

			    sprintf(simu->prm_name,"%s/%s.prm",project_directory,simu->name);
			    sprintf(simu->sim_name,"%s/%s.sim",project_directory,simu->name);
			    sprintf(simu->pmb_name,"%s/%s.pmb",project_directory,simu->name);
			    sprintf(simu->gnp_name,"%s/%s.gnp",project_directory,simu->name);
			    sprintf(simu->cnx_name,"%s/%s.cnx",project_directory,simu->name);
			    sprintf(simu->tms_name,"%s/%s.tms",project_directory,simu->name);
			    sprintf(simu->abe_name,"%s/%s.abe",project_directory,simu->name);
			    sprintf(simu->mod_name,"%s/%s.mod",project_directory,simu->name);			
		    }
		    answer = NO_ANSWER;
		    sprintf(buffer,"%s.sim",simu->name);
		    if (file_exists(buffer,project_directory))
		    {
		      sprintf(buffer,"The simulation file %s already exists...\n\
Do you want to overwrite it?\n\
ALERT: You will loose the previous simulation by answering [Yes]!\n\
[Quit] will completely quit the simulator in order to run it again with new values",simu->name);
		      answer = display_question_no(widget_array[ID_sim_mainW],buffer,
			    "WARNING: this file already exists...");
		      if (answer == NO_ANSWER)
			break;
		    }
		}while (answer == YES_ANSWER);

		sprintf(buffer,"XNBC V%s Simulator V%s: %s",VERSION,NBC_X_VERSION,simu->name);
		XtVaSetValues(AppShell,XmNtitle,buffer,NULL);
		/*
		XtSetSensitive(widget_array[ID_pushB_new],False);
		*/
		XtSetSensitive(widget_array[ID_pushB_continue],False);
		XtSetSensitive(widget_array[ID_pushB_load_simulation],True);
		XtSetSensitive(widget_array[ID_pushB_save_simulation],True);
		XtSetSensitive(widget_array[ID_pushB_save_state],True);
		XtSetSensitive(widget_array[ID_pushB_close],True);
		
		XtUnmanageChild(widget_array[ID_pushB_nucleus_none]);
		XtUnmanageChild(widget_array[ID_pushB_cluster_none]);
		for(i=0 ; i<simu->nb_nucleus ; i++)
		{
			ac = 0;
			XtSetArg(args[ac], XmNlabelString, 
				CONVERT(XtParent(widget_array[ID_pushB_nucleus_none]), sim_nucleus[i]->name, 
				XmRXmString, 0, &argok)); if (argok) ac++;
			XtSetArg(args[ac], XmNsensitive, True);ac++;    
			nucl_w[i] = XmCreatePushButton(widget_array[ID_pulldownM_nucleus],
				sim_nucleus[i]->name,
				args, 
				ac);
				
			XtAddCallback(nucl_w[i],XmNactivateCallback,sim_activate_CB,
				(XtPointer)(MAX_REGITERED_WIDGETS+i));
			
			XtManageChild(nucl_w[i]);
		}
		for(i=0 ; i<simu->nb_clusters ; i++)
		{
			ac = 0;
			sprintf(buffer,"%s (%s)",sim_clusters[i]->name,sim_clusters[i]->file_name);
			XtSetArg(args[ac], XmNlabelString, 
				CONVERT(XtParent(widget_array[ID_pushB_cluster_none]), buffer, 
				XmRXmString, 0, &argok)); if (argok) ac++;
			XtSetArg(args[ac], XmNsensitive,True );ac++;    
			clu_w[i] = XmCreatePushButton(widget_array[ID_pulldownM_clusters],
				sim_clusters[i]->name,
				args, 
				ac);
				
			XtAddCallback(clu_w[i],XmNactivateCallback,sim_activate_CB,
				(XtPointer)(MAX_REGITERED_WIDGETS+simu->nb_nucleus+i));
			
			XtManageChild(clu_w[i]);
		}

		/* the widgets */

		stim_label_w = (Widget *) XtCalloc(1, simu->nb_nucleus * sizeof(Widget));
		stim_noise_w = (Widget *) XtCalloc(1, simu->nb_nucleus * sizeof(Widget));
		stim_pulse_w = (Widget *) XtCalloc(1, simu->nb_nucleus * sizeof(Widget));
		stim_modul_w = (Widget *) XtCalloc(1, simu->nb_nucleus * sizeof(Widget));
		stim_drug_w = (Widget *) XtCalloc(1, simu->nb_nucleus * sizeof(Widget));

		/* the corresponding flags
		 * This flag indicates if it is stimulating or not 
		 */

		stim_noise_f = (Boolean *) calloc(1, simu->nb_nucleus * sizeof(Boolean));
		stim_pulse_f = (Boolean *) calloc(1, simu->nb_nucleus * sizeof(Boolean));
		stim_modul_f = (Boolean *) calloc(1, simu->nb_nucleus * sizeof(Boolean));
		stim_drug_f = (Boolean *) calloc(1, simu->nb_nucleus * sizeof(Boolean));

		form_stimulation = (Widget)Createform_stimulation(AppShell);

		for(i=0 ; i < simu->nb_nucleus ; i++)
		{
			/* La ligne de boutons pour la stimumation des nuclei */

			/* le nom */
			ac = 0;
			XtSetArg(args[ac], XmNlabelString, 
				CONVERT(XtParent(widget_array[ID_pushB_nucleus_none]), sim_nucleus[i]->name, 
				XmRXmString, 0, &argok)); if (argok) ac++;
			stim_label_w[i] = XmCreateLabel(widget_array[ID_rowcol_stim],
				sim_nucleus[i]->name,
				args,
				ac);
				
			XtManageChild(stim_label_w[i]);

			xmstring = XmStringCreateLocalized("Start Noise");

			/* le bruit */

			ac = 0;
			XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
			XtSetArg(args[ac], XmNsensitive, True);ac++;    
			stim_noise_w[i] = XmCreatePushButton(widget_array[ID_rowcol_stim],
				sim_nucleus[i]->name,
				args, 
				ac);
				
			XtAddCallback(stim_noise_w[i],XmNactivateCallback,stim_noise_activate_CB,
				(XtPointer)(i));
			
			XtManageChild(stim_noise_w[i]);
			XmStringFree(xmstring);	
			XtVaSetValues(stim_noise_w[i],
				      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
				      NULL);
			if (sim_nucleus[i]->backgrd_noise_m || sim_nucleus[i]->backgrd_noise_sd)
			{
			  XtSetSensitive(stim_noise_w[i], True);
			}
			else
			{
			  XtSetSensitive(stim_noise_w[i], False);
			}
			stim_noise_f[i] = False;

			/* les pulses */
			xmstring = XmStringCreateLocalized("Start Pulses");

			ac = 0;
			XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
			XtSetArg(args[ac], XmNsensitive, True);ac++;    
			stim_pulse_w[i] = XmCreatePushButton(widget_array[ID_rowcol_stim],
				sim_nucleus[i]->name,
				args, 
				ac);
				
			XtAddCallback(stim_pulse_w[i],XmNactivateCallback,stim_pulse_activate_CB,
				(XtPointer)(i));
			
			XtManageChild(stim_pulse_w[i]);
			XmStringFree(xmstring);	
			XtVaSetValues(stim_pulse_w[i],
				      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
				      NULL);
			if (sim_nucleus[i]->input_mean)
			{
			  XtSetSensitive(stim_pulse_w[i], True);
			}
			else
			{
			  XtSetSensitive(stim_pulse_w[i], False);
			}
			stim_pulse_f[i] = False;

			/* la modulation */
			if (sim_nucleus[i]->modul_type == 'p')
			  xmstring = XmStringCreateLocalized("Give pulse.");
			else
			  xmstring = XmStringCreateLocalized("Start Modul.");

			ac = 0;
			XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
			XtSetArg(args[ac], XmNsensitive, True);ac++;    
			stim_modul_w[i] = XmCreatePushButton(widget_array[ID_rowcol_stim],
				sim_nucleus[i]->name,
				args, 
				ac);
				
			XtAddCallback(stim_modul_w[i],XmNactivateCallback,stim_modul_activate_CB,
				(XtPointer)(i));
			
			XtManageChild(stim_modul_w[i]);
			XmStringFree(xmstring);	
			XtVaSetValues(stim_modul_w[i],
				      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
				      NULL);
			if (sim_nucleus[i]->modul_period && sim_nucleus[i]->modul_amp )
			{
			  XtSetSensitive(stim_modul_w[i], True);
			}
			else
			{
			  XtSetSensitive(stim_modul_w[i], False);
			}
			stim_modul_f[i] = False;

			/* les drogues */
			xmstring = XmStringCreateLocalized("Inject Drug");

			ac = 0;
			XtSetArg(args[ac], XmNlabelString, xmstring); ac++;
			XtSetArg(args[ac], XmNsensitive, True);ac++;    
			stim_drug_w[i] = XmCreatePushButton(widget_array[ID_rowcol_stim],
				sim_nucleus[i]->name,
				args, 
				ac);
				
			XtAddCallback(stim_drug_w[i],XmNactivateCallback,stim_drug_activate_CB,
				(XtPointer)(i));
			
			XtManageChild(stim_drug_w[i]);
			XmStringFree(xmstring);	
			XtVaSetValues(stim_drug_w[i],
				      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
				      NULL);
			XtSetSensitive(stim_drug_w[i], False);

			stim_drug_f[i] = False;
		}
		log_file = TRUE;
		sprintf(buffer,"%s/%s.log",project_directory,simu->name);
		if ((log_fp = fopen(buffer,"w")) == NULL)
		{
	  		printf("\007Impossible to open the log file: %s\nNo log will be produced !\n",buffer);
			log_file = FALSE;
		}


		sprintf(buffer,"Current simulation parameters:\n");
		_output(buffer);
		
		sprintf(buffer,"\tTime Step = %.2f ms (%.3f it/ms)",simu->time_step, (1./simu->time_step));
		_output(buffer);
		sprintf(buffer,"\tSpike Duration = %.2f ms (%lu it)",simu->spike_width, simu->nb_step_spk);
		_output(buffer);
		sprintf(buffer,"\tNext Stop = %.2f ms (%lu it)",simu->stop_at_ms, simu->next_stop);
		_output(buffer);
		sprintf(buffer,"\tLast Stop = %.2f ms (%lu it)",simu->end_at_ms, simu->last_it);
		_output(buffer);


		sprintf(buffer,"\nSimulation %s from project %s initialized...ready to run.\n",
			simu->name,project_name);
		_output(buffer);

		XtVaSetValues(widget_array[ID_pushB_STIM], 
			      XmNsensitive,True,
			      NULL);

		XtVaSetValues(widget_array[ID_pushB_STIM],
			      XtVaTypedArg, XmNbackground, XmRString, "SkyBlue", 8,
			      NULL);

		XtVaSetValues(widget_array[ID_pushB_START_ALL], 
			      XmNsensitive,True,
			      NULL);

	}
	else if(*output_file)
	{
		strcpy(simu->name,output_file);
		sprintf(simu->prm_name,"%s/%s.prm",project_directory,output_file);
		sprintf(simu->sim_name,"%s/%s.sim",project_directory,output_file);
		sprintf(simu->pmb_name,"%s/%s.pmb",project_directory,output_file);
		sprintf(simu->gnp_name,"%s/%s.gnp",project_directory,output_file);
		sprintf(simu->cnx_name,"%s/%s.cnx",project_directory,output_file);
		sprintf(simu->tms_name,"%s/%s.tms",project_directory,output_file);
		sprintf(simu->abe_name,"%s/%s.abe",project_directory,output_file);
		sprintf(simu->mod_name,"%s/%s.mod",project_directory,output_file);
	}
	else
	{
		strcpy(simu->name,project_name);
		sprintf(simu->prm_name,"%s/%s.prm",project_directory,project_name);
		sprintf(simu->sim_name,"%s/%s.sim",project_directory,project_name);
		sprintf(simu->pmb_name,"%s/%s.pmb",project_directory,project_name);
		sprintf(simu->gnp_name,"%s/%s.gnp",project_directory,project_name);
		sprintf(simu->cnx_name,"%s/%s.cnx",project_directory,project_name);
		sprintf(simu->tms_name,"%s/%s.tms",project_directory,project_name);
		sprintf(simu->abe_name,"%s/%s.abe",project_directory,project_name);
		sprintf(simu->mod_name,"%s/%s.mod",project_directory,project_name);
	}

	if (!batch)
	{
	        sprintf(buffer,"\n\aNow is your last chance to modify the time step (%.3f ms)\n   and/or the spike duration (%.3f ms)\n",
			simu->time_step, simu->spike_width);
		_output(buffer);
	
		XtVaSetValues(widget_array[ID_pushB_STOP],
			      XmNlabelString, CONVERT(widget_array[ID_pushB_STOP], "RUN", XmRXmString, 0, &argok),
			      XmNsensitive,True,
			      XtVaTypedArg, XmNbackground, XmRString, "green", 6,
			      NULL);
		if (!(simu->output_sim_f || simu->output_pmb_f || 
		      simu->output_tms_f || simu->output_abe_f || 
		      simu->output_gnp_f))
		{
		      sprintf(buffer,"No output file will be produced!!...\n\
You can do this, and enable an output during the simulation\n\
This is only a reminder for absent-minded people...!");
		      answer = display_message(widget_array[ID_sim_mainW],buffer,
			    "WARNING: no output file will be produced...");
		}
		else
		{
		      sprintf(buffer,"The following output files will be produced...\n\
%s %s %s %s %s\n\
this is only a reminder for absent-minded people...!",
			      (simu->output_sim_f)?".sim; ":"",
			      (simu->output_pmb_f)?".pmb; ":"",
			      (simu->output_tms_f)?".tms; ":"",
			      (simu->output_abe_f)?".abe; ":"",
			      (simu->output_gnp_f)?".gnp; ":"");
#if MESSAGES
		      answer = display_message(widget_array[ID_sim_mainW],buffer,
			    "WARNING: output files produced...");
#endif
		      _output(buffer);
		}
	}

        sprintf(buffer,"%s/%s",project_directory,simu->name);
	put_simulation_name(get_dir_name(),buffer);


      if ((pmb_fp = fopen(simu->pmb_name,"w")) == NULL)
	{
	  printf("\007Impossible to open %s\n",simu->pmb_name);
	}
      if ((gnp_fp = fopen(simu->gnp_name,"w")) == NULL)
	{
	  printf("\007Impossible to open %s\n",simu->gnp_name);
	}
      if ((tms_fp = fopen(simu->tms_name,"w")) == NULL)
	{
	  printf("\007Impossible to open %s\n",simu->tms_name);
	}
      if ((sim_fp = fopen(simu->sim_name,"w")) == NULL)
	{
	  printf("\007Impossible to open %s\n",simu->sim_name);
	}
      if ((abe_fp = fopen(simu->abe_name,"w")) == NULL)
	{
	  printf("\007Impossible to open %s\n",simu->abe_name);
	}
      else
	  start_abe_file();
      if ((mod_fp = fopen(simu->mod_name,"w")) == NULL)
	{
	    printf("\007Impossible to open %s\n",simu->mod_name);
	}

	
}
/*******************************************************************************
	Function for displaying connecting weights
*******************************************************************************/
void display_connecting_weights(void)
{
	NEURON *neuron_src;
	NEURON *neuron_tgt;
	char buffer[256];
	char *line;
	int i,j,k;
	int knobs;
	char *pt;
	char *out_buf;
	
	if(!simu->nb_neurons)
	{
		sprintf(buffer,"The simulator is empty...");
		display_error(widget_array[ID_sim_mainW],buffer,"Nothing to Display !");
		return;
	}
	
	out_buf = NULL;
	
	
	sprintf(buffer,"--------------------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	sprintf(buffer,"\tCONNECTING WEIGHTS");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	sprintf(buffer,"--------------------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	
	sprintf(buffer,"             ");
	while(strlen(buffer)!=8)
	{
		buffer[strlen(buffer)-1] = '\0';
	}
	line = (char *)calloc(1,(strlen(buffer)+1)*sizeof(char));
	strcpy(line,buffer);
	for(i=0 ; i<simu->nb_neurons ; i++)
	{
		sprintf(buffer,"%3ld           ",sim_neurons[i]->id);
		while(strlen(buffer)!=(abs(sim_neurons[i]->id)>9 ? 8:9))
		{
			buffer[strlen(buffer)-1] = '\0';
		}
		pt = (char *)calloc(1,(strlen(buffer)+strlen(line)+1)*sizeof(char));
		strcpy(pt,line);
		strcat(pt,buffer);
		free(line);
		line = pt;
		
			
	}
	out_buf = bufferize(out_buf,line);
	out_buf = bufferize(out_buf,"\n");
	free(line);
	line = NULL;
	
	for(i=0 ; i<simu->nb_neurons ; i++)
	{
		neuron_src = sim_neurons[i];
		sprintf(buffer,"%3ld:          ",neuron_src->id);
		while(strlen(buffer)!=7)
		{
			buffer[strlen(buffer)-1] = '\0';
		}
		line = (char *)calloc(1,(10*simu->nb_neurons)*sizeof(char));
		strcpy(line,buffer);
		for(j=0 ; j<simu->nb_neurons ; j++)
		{
			neuron_tgt = sim_neurons[j];
			knobs = 0;
			for(k=0 ; k<neuron_src->connected_neurons ;k++)
			{
				if(neuron_tgt == sim_neurons[which_neuron(neuron_src->targets[k])])
				{
					knobs = neuron_src->connections[k];
				}	
			}
			
			sprintf(buffer,"%+-4d              ",knobs);
			while(strlen(buffer)!=(abs(knobs)>9 ? 7:8))
			{
				buffer[strlen(buffer)-1] = '\0';
			} 
			
			strcat(line,buffer);
			
		}
		out_buf = bufferize(out_buf,line);
		out_buf = bufferize(out_buf,"\n");
		free(line);
		
	}
	sprintf(buffer,"--------------------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	_output(out_buf);
	free(out_buf);

	
}
/*******************************************************************************
	Function for displaying delays
*******************************************************************************/
void display_delays(void)
{
	NEURON *neuron_src;
	NEURON *neuron_tgt;
	char buffer[256];
	char *line;
	int i,j,k;
	float delay;
	char *pt;
	char *out_buf;
	
	if(!simu->nb_neurons)
	{
		sprintf(buffer,"The simulator is empty...");
		display_error(widget_array[ID_sim_mainW],buffer,"Nothing to Display !");
		return;
	}
	out_buf = NULL;
	
	
	
	sprintf(buffer,"--------------------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	sprintf(buffer,"\tTRANSMISSION DELAYS");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	sprintf(buffer,"--------------------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	
	sprintf(buffer,"             ");
	while(strlen(buffer)!=8)
	{
		buffer[strlen(buffer)-1] = '\0';
	}
	line = (char *)calloc(1,(strlen(buffer)+1)*sizeof(char));
	strcpy(line,buffer);
	for(i=0 ; i<simu->nb_neurons ; i++)
	{
		sprintf(buffer,"%3ld           ",sim_neurons[i]->id);
		while(strlen(buffer)!=(abs(sim_neurons[i]->id)>9 ? 8:9))
		{
			buffer[strlen(buffer)-1] = '\0';
		}
		pt = (char *)calloc(1,(strlen(buffer)+strlen(line)+1)*sizeof(char));
		strcpy(pt,line);
		strcat(pt,buffer);
		free(line);
		line = pt;
		
			
	}
	out_buf = bufferize(out_buf,line);
	out_buf = bufferize(out_buf,"\n");
	free(line);
	line = NULL;
	
	for(i=0 ; i<simu->nb_neurons ; i++)
	{
		neuron_src = sim_neurons[i];
		sprintf(buffer,"%3ld:          ",neuron_src->id);
		while(strlen(buffer)!=7)
		{
			buffer[strlen(buffer)-1] = '\0';
		}
		line = (char *)calloc(1,(10*simu->nb_neurons)*sizeof(char));
		strcpy(line,buffer);
		for(j=0 ; j<simu->nb_neurons ; j++)
		{
			neuron_tgt = sim_neurons[j];
			delay = 0.;
			for(k=0 ; k<neuron_src->connected_neurons ;k++)
			{
				if(neuron_tgt == sim_neurons[which_neuron(neuron_src->targets[k])])
				{
					delay = neuron_src->axone_length[k];
				}	
			}
			
			sprintf(buffer,"%.3f              ",delay);
			while(strlen(buffer)!=8)
			{
				buffer[strlen(buffer)-1] = '\0';
			} 
			
			strcat(line,buffer);
			
		}
		out_buf = bufferize(out_buf,line);
		out_buf = bufferize(out_buf,"\n");
		free(line);
		
	}
	sprintf(buffer,"--------------------------------------------------------------------------------------------------------------");
	
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");

	_output(out_buf);
	free(out_buf);

	
}
	

/*******************************************************************************
	Function for displaying nmda
*******************************************************************************/
void display_nmda(void)
{
	NEURON *neuron_src;
	NEURON *neuron_tgt;
	char buffer[256];
	char *line;
	int i,j,k;
	int nmda;
	char *pt;
	char *out_buf;
	
	if(!simu->nb_neurons)
	{
		sprintf(buffer,"The simulator is empty...");
		display_error(widget_array[ID_sim_mainW],buffer,"Nothing to Display !");
		return;
	}
	
	out_buf = NULL;	
	
	
	sprintf(buffer,"--------------------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	sprintf(buffer,"\tNMDA AND GLUTAMATE INTERACTIONS");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	sprintf(buffer,"--------------------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	
	sprintf(buffer,"             ");
	while(strlen(buffer)!=8)
	{
		buffer[strlen(buffer)-1] = '\0';
	}
	line = (char *)calloc(1,(strlen(buffer)+1)*sizeof(char));
	strcpy(line,buffer);
	for(i=0 ; i<simu->nb_neurons ; i++)
	{
		sprintf(buffer,"%3ld           ",sim_neurons[i]->id);
		while(strlen(buffer)!=(abs(sim_neurons[i]->id)>9 ? 8:9))
		{
			buffer[strlen(buffer)-1] = '\0';
		}
		pt = (char *)calloc(1,(strlen(buffer)+strlen(line)+1)*sizeof(char));
		strcpy(pt,line);
		strcat(pt,buffer);
		free(line);
		line = pt;
		
			
	}
	out_buf = bufferize(out_buf,line);
	out_buf = bufferize(out_buf,"\n");
	
	free(line);
	line = NULL;
	
	for(i=0 ; i<simu->nb_neurons ; i++)
	{
		neuron_src = sim_neurons[i];
		sprintf(buffer,"%3ld:          ",neuron_src->id);
		while(strlen(buffer)!=7)
		{
			buffer[strlen(buffer)-1] = '\0';
		}
		line = (char *)calloc(1,(10*simu->nb_neurons)*sizeof(char));
		strcpy(line,buffer);
		for(j=0 ; j<simu->nb_neurons ; j++)
		{
			neuron_tgt = sim_neurons[j];
			nmda = 0;
			for(k=0 ; k<neuron_src->connected_neurons ;k++)
			{
				if(neuron_tgt == sim_neurons[which_neuron(neuron_src->targets[k])])
				{
					nmda = neuron_src->nmda[k]&&neuron_src->its_cluster->glutamate;
				}	
			}
			
			sprintf(buffer,"%d              ",nmda);
			while(strlen(buffer)!=8)
			{
				buffer[strlen(buffer)-1] = '\0';
			} 
			
			strcat(line,buffer);
			
		}
		out_buf = bufferize(out_buf,line);
		out_buf = bufferize(out_buf,"\n");
		
		free(line);
		
	}
	sprintf(buffer,"--------------------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");

	_output(out_buf);
	free(out_buf);

	
}
/*******************************************************************************
	Function for displaying repartition
*******************************************************************************/
void display_repartition(void)
{
	int i,j,k;
	int counter;
	char buffer[256];
	NUCLEUS *nucleus_tmp;
	CLUSTER *cluster_tmp;
	char *out_buf;
	
	if(!simu->nb_neurons)
	{
		sprintf(buffer,"The simulator is empty...");
		display_error(widget_array[ID_sim_mainW],buffer,"Nothing to Display !");
		return;
	}
	
	out_buf = NULL;
	
	
	sprintf(buffer,"----------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	sprintf(buffer,"TOTAL NEURONS IN NETWORK: %d.",simu->nb_neurons);
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	sprintf(buffer,"TOTAL NUCLEUS IN NETWORK: %d.",simu->nb_nucleus);
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	sprintf(buffer,"TOTAL CLUSTERS IN NETWORK: %d.",simu->nb_clusters);
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	sprintf(buffer,"----------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	
	sprintf(buffer,"Network Repartition: nucleus decomposition.\n");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		nucleus_tmp = sim_nucleus[i];
		sprintf(buffer,"Composition of %s:  ",nucleus_tmp->name);
		out_buf = bufferize(out_buf,buffer);
		out_buf = bufferize(out_buf,"\n");
		for(j=0 ; j<nucleus_tmp->nb_clusters ; j++)
		{
			cluster_tmp = nucleus_tmp->cluster_array[j];
			if(!cluster_tmp)
				continue;
			counter = 0;
			for(k=0 ; k<cluster_tmp->cluster_size ; k++)
			{
				if(cluster_tmp->neuron_array[k]->its_nucleus == nucleus_tmp)
					counter++;
			}
			sprintf(buffer,"\t- %d neurons from type %s ",counter,cluster_tmp->file_name);
			out_buf = bufferize(out_buf,buffer);
			out_buf = bufferize(out_buf,"\n");
			
		}
		sprintf(buffer,"\t- TOTAL: %d neurons.\n",nucleus_tmp->nucleus_size);
		out_buf = bufferize(out_buf,buffer);
		out_buf = bufferize(out_buf,"\n");
	}
	
	sprintf(buffer,"----------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	sprintf(buffer,"Network Repartition: cluster decomposition.\n");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	
	for(i=0 ; i<simu->nb_clusters ; i++)
	{
		cluster_tmp = sim_clusters[i];
		sprintf(buffer,"Localisation of neurons from type %s:  ",cluster_tmp->file_name);
		out_buf = bufferize(out_buf,buffer);
		out_buf = bufferize(out_buf,"\n");
		for(j=0 ; j<cluster_tmp->nb_nucleus ; j++)
		{
			nucleus_tmp = cluster_tmp->nucleus_array[j];
			if(!nucleus_tmp)
				continue;
			counter = 0;
			for(k=0 ; k<nucleus_tmp->nucleus_size ; k++)
			{
				if(nucleus_tmp->neuron_array[k]->its_cluster == cluster_tmp)
					counter++;
			}
			sprintf(buffer,"\t- %d neurons in %s  ",counter,nucleus_tmp->name);
			out_buf = bufferize(out_buf,buffer);
			out_buf = bufferize(out_buf,"\n");
		
			
		}
		sprintf(buffer,"\t- TOTAL: %d neurons.\n",cluster_tmp->cluster_size);
		out_buf = bufferize(out_buf,buffer);
		out_buf = bufferize(out_buf,"\n");
	}
	sprintf(buffer,"----------------------------------------------------------------------------------------------------");
	out_buf = bufferize(out_buf,buffer);
	out_buf = bufferize(out_buf,"\n");
	
	_output(out_buf);
	free(out_buf);
	
	
}

/*******************************************************************************
	Function for modifying nucleus simulation parameters
*******************************************************************************/
void modify_nucleus(int number)
{
	NUCLEUS *nucleus_tmp;
	static int last_modif = 0;
	static int last_nb = 0;
	char buffer[256];
	
	nucleus_tmp = sim_nucleus[number];


	if(!nucleus_tmp)
	{
		fprintf(stderr,"Bad nucleus in modify nucleus !!!\n");
		exit(-1);
	}
	else
		current_nucleus = nucleus_tmp;
	
	if(number != last_nb)
	{
		if(last_modif && XtIsManaged(widget_array[last_modif]))
				XtUnmanageChild(widget_array[last_modif]);
		last_modif = 0;
	}
	switch(last_modif)
	{
	
		case 0:
		case ID_form_nucl_para_other:
	                if(XtIsManaged(widget_array[ID_form_nucl_para_other]))
				XtUnmanageChild(widget_array[ID_form_nucl_para_other]);
			if(!XtIsManaged(widget_array[ID_form_nucl_para_input]))
				XtManageChild(widget_array[ID_form_nucl_para_input]);
			init_nucleus_changes(ID_form_nucl_para_input);
			last_modif = ID_form_nucl_para_input;
			break;

		case ID_form_nucl_para_input:
			if(XtIsManaged(widget_array[ID_form_nucl_para_input]))
				XtUnmanageChild(widget_array[ID_form_nucl_para_input]);
			if(!XtIsManaged(widget_array[ID_form_nucl_para_noise]))
				XtManageChild(widget_array[ID_form_nucl_para_noise]);
			init_nucleus_changes(ID_form_nucl_para_noise);	
			last_modif = ID_form_nucl_para_noise;
			break;

		case ID_form_nucl_para_noise:
			if(XtIsManaged(widget_array[ID_form_nucl_para_noise]))
				XtUnmanageChild(widget_array[ID_form_nucl_para_noise]);
			if(!XtIsManaged(widget_array[ID_form_nucl_modulation]))
				XtManageChild(widget_array[ID_form_nucl_modulation]);
			init_nucleus_changes(ID_form_nucl_modulation);
			last_modif = ID_form_nucl_modulation;
			break;

		case ID_form_nucl_modulation:
			if(XtIsManaged(widget_array[ID_form_nucl_modulation]))
				XtUnmanageChild(widget_array[ID_form_nucl_modulation]);
			if(!XtIsManaged(widget_array[ID_form_nucl_drug]))
				XtManageChild(widget_array[ID_form_nucl_drug]);
			init_nucleus_changes(ID_form_nucl_drug);	
			last_modif = ID_form_nucl_drug;
			break;

		case ID_form_nucl_drug:
			if(XtIsManaged(widget_array[ID_form_nucl_drug]))
				XtUnmanageChild(widget_array[ID_form_nucl_drug]);
			if(!XtIsManaged(widget_array[ID_form_nucl_para_other]))
				XtManageChild(widget_array[ID_form_nucl_para_other]);
			init_nucleus_changes(ID_form_nucl_para_other);	
			last_modif = ID_form_nucl_para_other;
			break;


		default:
			break;	
	
	}

	sprintf(buffer,"Simulation Parameters for %s (size %ld)",nucleus_tmp->name,
		nucleus_tmp->nucleus_size);
	XtVaSetValues(XtParent(widget_array[ID_form_nucleus_parameters]),XmNtitle,buffer,NULL);

	if(!XtIsManaged(widget_array[ID_form_nucleus_parameters]))
		XtManageChild(widget_array[ID_form_nucleus_parameters]);
	else
		XtPopup(XtParent(widget_array[ID_form_nucleus_parameters]),XtGrabNone);

	last_nb = number;


}
/*******************************************************************************
	Function for initializing nucleus changes
*******************************************************************************/
void init_nucleus_changes(int w_id)
{
	
	char buffer[256];
	int i;
	
	if(!current_nucleus)
	{
		fprintf(stderr,"Bad nucleus in init nucleus changes !!!\n");
		exit(-1);
	}
	
	switch(w_id)
	{
	
		case ID_form_nucl_para_other:
			if(current_nucleus->alive == 'y')
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_make_alive],True,True);
				XtSetSensitive(widget_array[ID_label_prob_spike],True);
				XtSetSensitive(widget_array[ID_textF_prob_spike],True);
				XtSetSensitive(widget_array[ID_label_old_last_spike],True);
				XtSetSensitive(widget_array[ID_textF_old_last_spike],True);
				XtSetSensitive(widget_array[ID_label_recent_last_spike],True);
				XtSetSensitive(widget_array[ID_textF_recent_last_spike],True);
			}
			else
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_make_alive],False,True);
				current_nucleus->alive = 'n';
				XtSetSensitive(widget_array[ID_label_prob_spike],False);
				XtSetSensitive(widget_array[ID_textF_prob_spike],False);
				XtSetSensitive(widget_array[ID_label_old_last_spike],False);
				XtSetSensitive(widget_array[ID_textF_old_last_spike],False);
				XtSetSensitive(widget_array[ID_label_recent_last_spike],False);
				XtSetSensitive(widget_array[ID_textF_recent_last_spike],False);
			}
			if(current_nucleus->law == 'h')
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_weight_fluct],True,True);
				XtSetSensitive(widget_array[ID_label_learning_factor],True);
				XtSetSensitive(widget_array[ID_textF_hebb_factor],True);
			}
			else
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_weight_fluct],False,True);
				XtSetSensitive(widget_array[ID_label_learning_factor],False);
				XtSetSensitive(widget_array[ID_textF_hebb_factor],False);
			}
			XmTextFieldRemove(widget_array[ID_textF_hebb_factor]);
			sprintf(buffer,"%.2f",current_nucleus->hebb);
			XmTextReplace(widget_array[ID_textF_hebb_factor],0,
			XmTextGetLastPosition(widget_array[ID_textF_hebb_factor]),
				buffer);

			XmTextFieldRemove(widget_array[ID_textF_prob_spike]);
			sprintf(buffer,"%d",current_nucleus->prob_spike);
			XmTextReplace(widget_array[ID_textF_prob_spike],0,
			XmTextGetLastPosition(widget_array[ID_textF_prob_spike]),
				buffer);

			XmTextFieldRemove(widget_array[ID_textF_old_last_spike]);
			sprintf(buffer,"%d",current_nucleus->old_last_spike);
			XmTextReplace(widget_array[ID_textF_old_last_spike],0,
			XmTextGetLastPosition(widget_array[ID_textF_old_last_spike]),
				buffer);

			XmTextFieldRemove(widget_array[ID_textF_recent_last_spike]);
			sprintf(buffer,"%d",current_nucleus->recent_last_spike);
			XmTextReplace(widget_array[ID_textF_recent_last_spike],0,
			XmTextGetLastPosition(widget_array[ID_textF_recent_last_spike]),
				buffer);

			XmTextFieldRemove(widget_array[ID_textF_low_mb_pot]);
			sprintf(buffer,"%.2f",current_nucleus->low_mb_pot);
			XmTextReplace(widget_array[ID_textF_low_mb_pot],0,
			XmTextGetLastPosition(widget_array[ID_textF_low_mb_pot]),
				buffer);

			XmTextFieldRemove(widget_array[ID_textF_up_mb_pot]);
			sprintf(buffer,"%.2f",current_nucleus->up_mb_pot);
			XmTextReplace(widget_array[ID_textF_up_mb_pot],0,
			XmTextGetLastPosition(widget_array[ID_textF_up_mb_pot]),
				buffer);
			break;
			
		case ID_form_nucl_modulation:
			if(current_nucleus->modul_type == 's')
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_modul_sin],True,True);
			}
			else if(current_nucleus->modul_type == 't')
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_modul_triangle],True,True);
			}
			else if(current_nucleus->modul_type == 'r')
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_modul_rect],True,True);
			}
			else if(current_nucleus->modul_type == 'p')
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_modul_pulse],True,True);
			}
			else
			{
				current_nucleus->modul_type = 0;
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_modul_none],True,True);
			}
			
			XmTextFieldRemove(widget_array[ID_textF_nucl_modul_phase]);
			sprintf(buffer,"%.2f",current_nucleus->modul_phase);
			XmTextReplace(widget_array[ID_textF_nucl_modul_phase],0,
			XmTextGetLastPosition(widget_array[ID_textF_nucl_modul_phase]),
				buffer);
			
			XmTextFieldRemove(widget_array[ID_textF_nucl_modul_amp]);
			sprintf(buffer,"%.2f",current_nucleus->modul_amp);
			XmTextReplace(widget_array[ID_textF_nucl_modul_amp],0,
			XmTextGetLastPosition(widget_array[ID_textF_nucl_modul_amp]),
				buffer);
				
			XmTextFieldRemove(widget_array[ID_textF_nucl_modul_period]);
			sprintf(buffer,"%.2f",current_nucleus->modul_period);
			XmTextReplace(widget_array[ID_textF_nucl_modul_period],0,
			XmTextGetLastPosition(widget_array[ID_textF_nucl_modul_period]),
				buffer);
			
			XmTextFieldRemove(widget_array[ID_textF_nucl_modul_nb]);
			sprintf(buffer,"%d",current_nucleus->nb_pulses);
			XmTextReplace(widget_array[ID_textF_nucl_modul_nb],0,
			XmTextGetLastPosition(widget_array[ID_textF_nucl_modul_nb]),
				buffer);
			
			break;
			
			
		case ID_form_nucl_para_noise:
			if(current_nucleus->noise_active)
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_noise_active],True,True);
			}
			else
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_noise_none],True,True);
			}
			XmTextFieldRemove(widget_array[ID_textF_nucl_noise_m]);
			sprintf(buffer,"%.2f",current_nucleus->backgrd_noise_m);
			XmTextReplace(widget_array[ID_textF_nucl_noise_m],0,
			XmTextGetLastPosition(widget_array[ID_textF_nucl_noise_m]),
				buffer);
			
			XmTextFieldRemove(widget_array[ID_textF_nucl_noise_sd]);
			sprintf(buffer,"%.2f",current_nucleus->backgrd_noise_sd);
			XmTextReplace(widget_array[ID_textF_nucl_noise_sd],0,
			XmTextGetLastPosition(widget_array[ID_textF_nucl_noise_sd]),
				buffer);
			break;
		
		case ID_form_nucl_para_input:
			if(current_nucleus->input_type == 'r')
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_input_reg],True,True);
			}
			else if(current_nucleus->input_type == 'n')
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_input_gauss],True,True);
				XtSetSensitive(stim_pulse_w[(current_nucleus->number - 1)], True);
			}
			else if(current_nucleus->input_type == 'g')
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_input_gamma],True,True);
				XtSetSensitive(stim_pulse_w[(current_nucleus->number - 1)], True);
			}
			else if(current_nucleus->input_type == 'p')
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_input_poisson],True,True);
				XtSetSensitive(stim_pulse_w[(current_nucleus->number - 1)], True);
			}
			else if(current_nucleus->input_type == 0)
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_input_none],True,True);
				XtSetSensitive(stim_pulse_w[(current_nucleus->number - 1)], False);
			}
			if(current_nucleus->inhib)
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_input_inhib],True,True);
			}
			else
			{
			        XmToggleButtonSetState(widget_array[ID_toggleB_nucl_input_excit],True,True);
			}
			
			XmTextFieldRemove(widget_array[ID_textF_input_period_m]);
			sprintf(buffer,"%.2f",current_nucleus->input_mean);
			XmTextReplace(widget_array[ID_textF_input_period_m],0,
			XmTextGetLastPosition(widget_array[ID_textF_input_period_m]),
				buffer);
			
			XmTextFieldRemove(widget_array[ID_textF_input_sd]);
			sprintf(buffer,"%.2f",current_nucleus->input_sd);
			XmTextReplace(widget_array[ID_textF_input_sd],0,
			XmTextGetLastPosition(widget_array[ID_textF_input_sd]),
				buffer);
				
			XmTextFieldRemove(widget_array[ID_textF_input_scale_factor]);
			sprintf(buffer,"%.2f",current_nucleus->scale_f);
			XmTextReplace(widget_array[ID_textF_input_scale_factor],0,
			XmTextGetLastPosition(widget_array[ID_textF_input_scale_factor]),
				buffer);
				
			break;
		
		case ID_form_nucl_drug:
			if(current_nucleus->drug_enabled)
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_input_drug],True,True);
			}
			else
			{
				XmToggleButtonSetState(widget_array[ID_toggleB_nucl_input_No_drug],True,True);
			}

			for(i = 0 ; i < nbr_drug; i++ )
			{
			      if (current_nucleus->drogue[i])
			      {
				  XmToggleButtonSetState(drug_toggle_w[i],True,False);
			      }
			      else
			      {
				  XmToggleButtonSetState(drug_toggle_w[i],False,False);
			      }
			}
			for(i = 0 ; i < NBR_CRT; i++ )
			{
			      if (current_nucleus->crt[i])
			      {
				  XmToggleButtonSetState(crt_toggle_w[i],True,False);
			      }
			      else
			      {
				  XmToggleButtonSetState(crt_toggle_w[i],False,False);
			      }
			}

			break;
		
		default:
			break;
	
	}
	

}

#endif
