
/*******************************************************************************
	Function for one BUM cluster iteration computation
*******************************************************************************/
void update_B_res(int pos)
{

	int	i,j, k, l, n, d_l;      /* indices divers */

	float	K_epsp,			/* constantes pour le calcul de reversion */
		K_ipsp,
		K_noise,
	        duree,
		delta_ipsp,		
		delta_epsp,
	        delta,
	        seuil_increase,
		epsp, ipsp,		
		somme_psp,		/* epsp et ipsp venant des
					 * autres neurones et leur somme
					 */
		net_input,		/* somme de ce qui arrive (intermediaire) */
		clu_noise = 0.;		/* cluster background noise */	

	float nucl_noise = 0.;
	float noise = 0.;
	char buffer[256];

	BUM *clu_bum;
	BUM_DYNAMIC *bum_dyn;
	
	if((pos<0) || (pos>=simu->nb_neurons))
	{
		fprintf(stderr,"i is out of range in update_P_res!!!!\n");
		exit(-1);
	}
	i = pos;

	ipsp = epsp = somme_psp = 0.;


	/*
	 * on est encore pendant le spike precedent, on ne fait rien
	 */

	if (sim_neurons[i]->spike)
	{
#if NBC_X_DEBUG
	  fprintf(fdbg,"neuron %lu still in spike.\n",sim_neurons[i]->id);
#endif
		sim_neurons[i]->spike--;
		return;
	} 
	
	k = (sim_neurons[i]->its_cluster->number)-1;
	n = (sim_neurons[i]->its_nucleus->number)-1;
	clu_bum = (BUM *)sim_neurons[i]->its_cluster->clu_data;
	bum_dyn = (BUM_DYNAMIC *)sim_neurons[i]->neuron_data;
	

	/* Gestion du sablier */
	
	for (l = 0; l < bum_dyn->nb_sabliers; l++)
	{
	   bum_dyn->sablier[l]--;
	   if (!bum_dyn->sablier[l])
	   {
	       bum_dyn->in_burst = FALSE;
	       /* 
		*  si le sablier est vide, on l'enleve en avancant les
                *  autres d un cran 
		*/
	       for (j = l+1; j <bum_dyn->nb_sabliers; j++)
	       {
		  bum_dyn->sablier[j-1] = bum_dyn->sablier[j];
	       }
	       bum_dyn->nb_sabliers--;
	       bum_dyn->frequence = (clu_bum->freq_b_spike * (clu_bum->compose_fact * bum_dyn->nb_sabliers));
	       if (bum_dyn->frequence > clu_bum->freq_max)
		  bum_dyn->frequence = clu_bum->freq_max;
	       if (bum_dyn->frequence)
	          bum_dyn->periode = (1000./ bum_dyn->frequence);
	       else
	          bum_dyn->periode = 1000000000.;
	       l--;
	   }
	}

       	/* noise computation (methode de Andre Fabio Kohn (USP, San Paolo, Bresil) */
	/*
                  filter_a = exp(-time_step / (resistance * capacite));
		  filter_b = 1./capacite;
		  center_noise = center_noise * filter_a + filter_b * white_noise; 
		  noise = center_noise + backgrd_noise_m;
	 */

	if (clu_bum->noise_active)
	{
		clu_noise = gasdev(&seed);
		clu_noise *= clu_bum->backgrd_n_sd;
		if (clu_bum->filter_noise)
		{
		  bum_dyn->center_noise = bum_dyn->center_noise 
		                          * exp(-(simu->time_step) / (clu_bum->res_capa)) 
					  + clu_bum->i_capacite * clu_noise; 
		  clu_noise =  bum_dyn->center_noise + clu_bum->backgrd_noise_m;
		}
		else
		  clu_noise += clu_bum->backgrd_noise_m;		
	} 
	else	
		clu_noise = 0.;
	
	if(stim_noise_f[n] && sim_nucleus[n]->noise_active)
	{
		nucl_noise = gasdev(&seed);
		nucl_noise *= sim_nucleus[n]->backgrd_n_sd;
		nucl_noise += sim_nucleus[n]->backgrd_noise_m;		
	} 
	else	
		nucl_noise = 0.;
		
	if (stim_modul_f[n])
	{
	  nucl_noise += sim_nucleus[n]->modul_value;
	}

	noise = clu_noise + nucl_noise;
	
#if NBC_X_DEBUG

      	fprintf(fdbg,"Noise for neuron %lu: total %f, nucl %f, clu %f\n",
			sim_neurons[i]->id,noise,nucl_noise,clu_noise);
#endif

	/*
	 *	intra somatic potential
	 */

	if (bum_dyn->in_burst)
	{
	    bum_dyn->soma = (clu_bum->burst_overshoot
		    * exp((-sim_neurons[i]->decharge_lag) 
		    * clu_bum->i_tau_mb_pot)) 
		    + (bum_dyn->soma_post_spike - clu_bum->burst_overshoot); 

#if NBC_X_DEBUG
            fprintf(fdbg,"Intra somatic potential for neuron %lu:  %f\n",
			    sim_neurons[i]->id,bum_dyn->soma);
#endif
	}
	else
	{
	    bum_dyn->soma = (clu_bum->overshoot
		    * exp((-sim_neurons[i]->decharge_lag) 
		    * clu_bum->i_tau_mb_pot)) 
		    + (bum_dyn->soma_post_spike - clu_bum->overshoot); 

#if NBC_X_DEBUG
       	    fprintf(fdbg,"Intra somatic potential for neuron %lu:  %f\n",
			    sim_neurons[i]->id,bum_dyn->soma);
#endif
	}
	/*
	 *  Inputs from other neurons
	 */
	epsp = ipsp = 0.;
	delta_epsp = clu_bum->rev_pot_pos - bum_dyn->soma;
	delta_ipsp = clu_bum->rev_pot_neg - bum_dyn->soma;

	for (j = 0; j < simu->nb_neurons; j++) 
	{
		for(l = 0 ; l < sim_neurons[j]->connected_neurons ; l++)
		{
			if((sim_neurons[j]->targets[l] == sim_neurons[i]->id) &&
			  (sim_neurons[j]->connections[l]))
			{
				if ((simu->nb_it - sim_neurons[j]->spike_time[sim_neurons[j]->next_spike[l]]) ==
				  sim_neurons[j]->axone_step[l]) 
				{
					if (sim_neurons[j]->connections[l] > 0)
						epsp += clu_bum->epsp * sim_neurons[j]->connections[l];
					else
						ipsp += clu_bum->ipsp * sim_neurons[j]->connections[l];
					
					sim_neurons[j]->next_spike[l] = 
						(sim_neurons[j]->next_spike[l] + 1) % MAX_SPK;
						
#if NBC_X_DEBUG
					if (sim_neurons[j]->connections[l] > 0)
					{
						fprintf(fdbg,"Epsp contribution from neuron %lu to neuron %lu:  %f( new epsp:%f)\n",
							sim_neurons[j]->id,sim_neurons[i]->id,
							clu_bum->epsp * sim_neurons[j]->connections[l],epsp);
					}
					if (sim_neurons[j]->connections[l] < 0)
					{
						fprintf(fdbg,"Ipsp contribution from neuron %lu to neuron %lu:  %f( new ipsp:%f)\n",
							sim_neurons[j]->id,sim_neurons[i]->id,
							clu_bum->ipsp * sim_neurons[j]->connections[l],ipsp);
					}
#endif
				} 
					
			} 
		}
	} 
	
	
	/*
	 *	Is it time for input?
	 */
	if (sim_nucleus[n]->input_type 
		&& (simu->nb_it >= sim_neurons[i]->t_next_i))
	{
		  if (stim_pulse_f[n])
		  {
		  }
		  else
		  {
			if (!sim_nucleus[n]->inhib)
			{
				epsp += (clu_bum->epsp  * 
					sim_nucleus[n]->scale_f);
#if NBC_X_DEBUG
				fprintf(fdbg,"Input epsp contribution to neuron %lu:  %f( new epsp:%f)\n",
					sim_neurons[i]->id,
					clu_bum->epsp * sim_nucleus[n]->scale_f,epsp);

#endif
			} 
			else
			{
				ipsp += -(clu_bum->ipsp  * 
					sim_nucleus[n]->scale_f);
#if NBC_X_DEBUG
				fprintf(fdbg,"Input ipsp contribution to neuron %lu:  -%f( new ipsp:%f)\n",
					sim_neurons[i]->id,
					clu_bum->ipsp * sim_nucleus[n]->scale_f,ipsp);
#endif
			}
		  }

		/*
		 * stimulation (last and next)
		 */
		
		sim_neurons[i]->t_last_i = sim_neurons[i]->t_next_i;
		sim_neurons[i]->t_next_i += GetInpInterval(i);
		
		/*
		 * Sauvegarde de la serie temporelle
		 *    Save time of input 
		 * (valeur negative = external input)
		 */
#if BUFFERIZE_AND_FLUSH		
		sprintf(buffer,"%.3f -%d\n", simu->time_ms, sim_nucleus[n]->id);
		tms_buffer = bufferize_and_flush(tms_buffer,buffer,&tms_buf_size,
			strlen(buffer),&tms_tmpfp);
		tms_size += strlen(buffer);
#else
		if (simu->output_tms_f)
		  fprintf(tms_fp,"%.3f -%d\n", simu->time_ms, sim_nucleus[n]->id);
		if (simu->output_abe_f)
		  fprintf(abe_fp,"A,%d,%lu\n", n+1, simu->nb_it - previous_event);
		previous_event = simu->nb_it;
#endif
	}

	/* Implementation du Reversal Potential (V 4.4) */

	/*
	 *	Le prb des sommes de PSP est plus delicat que celui 
	 * d'un seul PSP. Nous avons estime qu'il faut d'abord faire 
	 * la somme de tout ce qui est + (epsp) et - (ipsp), 
	 * separement, puis de calculer son facteur de dependance par 
	 * rapport au rev pot.
	 * On estime que plus on se rapproche du reversal potential,
	 * moins l'effet d'un PSP est important donc, cela depend de
	 * (soma - rev_pot). Si on est au pot de mb, le facteur
	 * multiplicateur est 1, et si on est au rev pot il est 0.
	 * Donc, le PSP sera multiplie par un facteur qui devient
	 * lineairement de plus en plus petit au fur et a mesure
	 * que l'on se rapporche du Rev pot (V4.10):
	 *   K_rev_[pn] = 1 / (Pot_repos - reversal)
	 *   K_[ei]psp = (soma - reversal) * K_rev_[pn]
	 *   [ei]psp *= K_[ei]psp   
	 */
	/* On ne se lance dans les calculs que s'il y a lieu */

	if (epsp)
	{
		/* K_rev_p doit etre positif dans un cas naturel */
		
		K_epsp = delta_epsp * clu_bum->K_rev_p;
		epsp *= K_epsp;
		
#if NBC_X_DEBUG
		fprintf(fdbg,"Final epsp due to K_epsp for neuron %lu:  %f(K_epsp :%f)\n",
			sim_neurons[i]->id,
			epsp,K_epsp);
#endif

	} 
	if (ipsp)
	{
		/* K_rev_n doit etre negatif dans un cas naturel */

		K_ipsp = delta_ipsp * clu_bum->K_rev_n;
		ipsp *= K_ipsp;
		
#if NBC_X_DEBUG
		fprintf(fdbg,"Final ipsp due to K_ipsp for neuron %lu:  %f(K_ipsp :%f)\n",
			sim_neurons[i]->id,
			ipsp,K_ipsp);
#endif
	} 
	if (epsp || ipsp)
	{
		/*
		 * Afin de ne pas depasser les pot de reversion, on
		 * doit verifier que ce que l'on met dans la file
		 * d'attente n'es pas plu grand que la difference
		 * entre le soma et le rev pot.  Ca pose pas mal de
		 * problemes tordus de signes....
		 */
		
		somme_psp = epsp + ipsp;
		if (somme_psp > delta_epsp)
			somme_psp = delta_epsp;
		if (somme_psp < delta_ipsp)
			somme_psp = delta_ipsp;
#if NBC_X_DEBUG
		fprintf(fdbg,"\to Somme PSP for neuron %lu:  %f\n",
			sim_neurons[i]->id,
			somme_psp);
#endif

       		/*
		 * on met le resultat epsp+ipsp dans la file d'attente
		 * temporelle
		 */
		
		sim_neurons[i]->inp_t[sim_neurons[i]->tail] = simu->nb_it;		
		bum_dyn->inp_max_pos[sim_neurons[i]->tail] = somme_psp;

		if ( (somme_psp + bum_dyn->soma) >= clu_bum->seuil_burst)
		{
		  duree = ran1(&set) * clu_bum->burst_range;
		  bum_dyn->sablier[bum_dyn->nb_sabliers] = (clu_bum->duree_b_min + duree);
		  bum_dyn->nb_sabliers++;
		  bum_dyn->in_burst = TRUE;
#if DEBUG_BURST
		  printf("ran1: %f (%f range)\n",ran1(&set),clu_bum->burst_range);
		  printf("Duree: %f ms (%d it) nb_sabliers: %d\n",duree,bum_dyn->sablier[bum_dyn->nb_sabliers-1], bum_dyn->nb_sabliers);
#endif
		  if (bum_dyn->frequence < clu_bum->freq_max)
		  {
		      bum_dyn->frequence = (clu_bum->compose_fact * bum_dyn->nb_sabliers) * clu_bum->freq_b_spike;
		      if (bum_dyn->frequence > clu_bum->freq_max)
			 bum_dyn->frequence = clu_bum->freq_max;
		  }
		  if (bum_dyn->frequence)
		  {
		         bum_dyn->spike_suivante = simu->nb_it;
			 bum_dyn->periode = (1000./ bum_dyn->frequence);
		  }

#if DEBUG_BURST
		  printf("iter: %d (spike suivante: %d)\n", simu->nb_it, bum_dyn->spike_suivante);
#endif
		}

		if (somme_psp > 0.0)
		{
			bum_dyn->inp_ta[sim_neurons[i]->tail] = clu_bum->tau_a_epsp;
			bum_dyn->inp_td[sim_neurons[i]->tail] = clu_bum->tau_d_epsp;
		}
		else if (somme_psp < 0.0)
		{
		        if (bum_dyn->nb_sabliers)
			{
			      bum_dyn->frequence = (clu_bum->compose_fact * bum_dyn->nb_sabliers-1) * clu_bum->freq_b_spike;
			      if (bum_dyn->frequence <= 0.)
			      {
				   bum_dyn->frequence = 0.;
				   bum_dyn->nb_sabliers--;
				   bum_dyn->in_burst = FALSE;
			      }
			      else
				   bum_dyn->periode = (1000./ bum_dyn->frequence);
			}
			bum_dyn->inp_ta[sim_neurons[i]->tail] = clu_bum->tau_a_ipsp;
			bum_dyn->inp_td[sim_neurons[i]->tail] = clu_bum->tau_d_ipsp;
		}

		sim_neurons[i]->tail = (sim_neurons[i]->tail + 1) % MAX_MEM;
		if (sim_neurons[i]->tail == sim_neurons[i]->head)
			sim_neurons[i]->head = (sim_neurons[i]->head + 1) % MAX_MEM;
	} 
	else
		somme_psp = 0.0;

	/*
	 * Le probleme du bruit: le bruit est lui aussi multiplie par
	 * le facteur positif s'il est positif (il a la valeur d'un
	 * epsp) et par le facteur negatif sinon (si 0 il est
	 * considere comme positif)
	 */
	
	if (noise)
	{
		K_noise = (noise > 0.)? 
			delta_epsp * clu_bum->K_rev_p:
			delta_ipsp * clu_bum->K_rev_n;
		noise *= K_noise;
		
#if NBC_X_DEBUG
		fprintf(fdbg,"Noise modification due to K_noise for neuron %lu:  %f(K_noise: %f)\n",
			sim_neurons[i]->id,
			noise,K_noise);
#endif
	} 
     			
	net_input =  suminputs(bum_dyn->inp_ta, bum_dyn->inp_td,
				   bum_dyn->inp_max_pos,
				   sim_neurons[i]->inp_t,
				   sim_neurons[i]->head,
				   sim_neurons[i]->tail) + noise;
#if NBC_X_DEBUG
	fprintf(fdbg,"\to NET INPUT for neuron %lu:  %f\n",
		sim_neurons[i]->id,
		net_input);
#endif

	/*
	* Maintenant on peut calculer le soma
	* Calcul du voltage intra somatique
	* et tenir compte du shunt de la mb qui varie en f(t)
	*/

	if (clu_bum->shunt_i_tau && sim_neurons[i]->decharge_lag)
	        bum_dyn->soma += (net_input *
				  (1. - exp(-(sim_neurons[i]->decharge_lag)/clu_bum->shunt_i_tau)));
	else
		bum_dyn->soma += net_input;

#if NBC_X_DEBUG
	fprintf(fdbg,"\t SOMA for neuron %lu:  %f\n",
		sim_neurons[i]->id,
		bum_dyn->soma);
#endif

/*
*		 necessaire, a cause du bruit rajoute qui peut depasser
*/
	if (bum_dyn->soma > clu_bum->rev_pot_pos)
		bum_dyn->soma = clu_bum->rev_pot_pos; 
	if (bum_dyn->soma <clu_bum ->rev_pot_neg)
		bum_dyn->soma = clu_bum->rev_pot_neg;

#if 0	        
	/*
	 * ca decharge ou pas?
	 */

	if (bum_dyn->in_burst)     /* on est dans un burst */
	{
	      bum_dyn->soma -= clu_bum->seuil_burst;
	      bum_dyn->soma = clu_bum->b_v_plus * 
			       (exp(clu_bum->b_A * bum_dyn->soma) - 1.) 
				/ (exp(clu_bum->b_A * bum_dyn->soma) - clu_bum->b_v_rap);
	      bum_dyn->soma += clu_bum->seuil_burst;

	      if (simu->nb_it == bum_dyn->spike_suivante )
	      {
		    sim_neurons[i]->new_state = SPIKE;
		    sim_neurons[i]->decharge_lag = 0.;
		    sim_neurons[i]->spike = sim_neurons[i]->its_cluster->spike_duration;
		    bum_dyn->soma_post_spike = /* bum_dyn->soma + clu_bum->burst_overshoot; */
		    bum_dyn->soma = clu_bum->burst_post_spike;

		    if (bum_dyn->frequence)
		      bum_dyn->spike_suivante = simu->nb_it + (int)((1000./ bum_dyn->frequence) / simu->time_step);
	      }
	      else
	      {
		    sim_neurons[i]->new_state = REPOS;
		    sim_neurons[i]->decharge_lag += 1.;
	      }
	}
	else                         /* on est hors burst */
        {
	      /*
	       * Calcul du seuil de decharge
	       */
	      bum_dyn->threshold =   bum_dyn->delta_seuil 
				* exp((-bum_dyn->decharge_lag) 
				* clu_bum->i_tau_seuil)
				+ clu_bum->seuil;

    
    	      bum_dyn->soma -= clu_bum->rest_pot;
	      bum_dyn->soma = clu_bum->b_v_plus * 
			       (exp(clu_bum->b_A * bum_dyn->soma) - 1.) 
				/ (exp(clu_bum->b_A * bum_dyn->soma) - clu_bum->b_v_rap);
	      bum_dyn->soma += clu_bum->rest_pot;

	      if (bum_dyn->soma >= bum_dyn->threshold)
	      {				/* on a un spike */
		    sim_neurons[i]->new_state = SPIKE;
		    sim_neurons[i]->decharge_lag = 1.;
		    sim_neurons[i]->spike = sim_neurons[i]->its_cluster->spike_duration;
#if DEBUG_UPDT_1
		    printf("soma avt spike: %f\n",
			   bum_dyn->soma);
#endif
		    bum_dyn->soma_post_spike = /* bum_dyn->soma + clu_bum->overshoot; */
		    bum_dyn->soma = clu_bum->pot_post_spike;

		    /* calcul de la valeur absolue du seuil apres ce spike (seuil_peak) */

		    if (clu_bum->less_fatigue)
		    {
		      delta = (bum_dyn->seuil_peak - bum_dyn->threshold);
		      seuil_increase = (clu_bum->seuil_post_spike - delta)* clu_bum->fatigue + delta;
		    }
		    else
		    {
		      seuil_increase = clu_bum->seuil_post_spike * 
		                     (clu_bum->fatigue * (bum_dyn->threshold - clu_bum->seuil) + 1.);
		    }
		    bum_dyn->seuil_peak = seuil_increase + bum_dyn->threshold;
		    bum_dyn->delta_seuil = bum_dyn->seuil_peak - clu_bum->seuil;
#if DEBUG_BURST
		    printf("SPIKE: iter: %d (spike suivante: %d)\n", nb_it, bum_dyn->spike_suivante);
#endif
	      } /* fin du if */
	      else			/* pas de spike */
	      {
		    sim_neurons[i]->new_state = REPOS;
		    sim_neurons[i]->decharge_lag += 1.;
	      } /* fin du else */
	}
#endif
	/*
	 * ca decharge ou pas?
	 */
	if (bum_dyn->in_burst)
	{
	        bum_dyn->soma -= clu_bum->seuil_burst;
	        bum_dyn->soma = clu_bum->b_v_plus * 
		                (exp(clu_bum->b_A * bum_dyn->soma) - 1.) 
				/ (exp(clu_bum->b_A * bum_dyn->soma) - clu_bum->b_v_rap);
	        bum_dyn->soma += clu_bum->seuil_burst;
	    
		if (simu->nb_it == bum_dyn->spike_suivante )
		{				/* on a un spike */
			sim_neurons[i]->new_state = SPIKE;
			sim_neurons[i]->decharge_lag = 1.;
			sim_neurons[i]->spike = sim_neurons[i]->its_cluster->spike_duration;

    			/*
			 * Pendant le burst on reste a la valeur de repos (on pourrait redescendre
			 * au niveau post spike... a voir)
			 * le burst est augmente de frequence si le pot repasse au dessu du
			 * seuil des bursts
			 */

			bum_dyn->soma = bum_dyn->soma_post_spike = clu_bum->burst_post_spike; 

			if (bum_dyn->frequence)
			      bum_dyn->spike_suivante = simu->nb_it + bum_dyn->periode;
			/*
			 * Mise a jour de la file d'attente et waited_spike:
			 * la date d'emission du premier spike a venir
			 * est en tete de file d'attente. Il a donc decharge
			 * depuis (maintenant  - date d'emission)
			 */
			/* le spike est ajoute a la file de ceux qui sont deja sur l'axone */

			sim_neurons[i]->spike_time[sim_neurons[i]->queue] = simu->nb_it;
			sim_neurons[i]->queue = (sim_neurons[i]->queue + 1) % MAX_SPK;
			if (sim_neurons[i]->queue == sim_neurons[i]->tete)
				sim_neurons[i]->tete = (sim_neurons[i]->tete + 1) % MAX_SPK;

			    /*
			     * sauvegarde de la serie temporelle
			     *    Save time of spike 
			     */
#if BUFFERIZE_AND_FLUSH
			sprintf(buffer,"%.3f %lu\n",simu->time_ms,sim_neurons[i]->id);
			tms_buffer = bufferize_and_flush(tms_buffer,buffer,&tms_buf_size,
							 strlen(buffer),&tms_tmpfp);
			tms_size += strlen(buffer);
#else
			if (simu->output_tms_f)
			  fprintf(tms_fp,"%.3f %lu\n",simu->time_ms,sim_neurons[i]->id);
			if (simu->output_abe_f)
			  fprintf(abe_fp,"%d,%lu,%lu\n", n+1, sim_neurons[i]->id, simu->nb_it - previous_event);
			previous_event = simu->nb_it;
#endif
	        }
		else
		{
			sim_neurons[i]->new_state = REPOS;
			sim_neurons[i]->decharge_lag += 1.;
		}
	  }
	  else
	  {
		    
	          /*
	           * Calcul du seuil de decharge
	           */
	          bum_dyn->threshold = bum_dyn->delta_seuil 
		              	     * exp((-sim_neurons[i]->decharge_lag) 
		       	             * clu_bum->i_tau_seuil)
		       	             + clu_bum->seuil;

		  bum_dyn->soma -= clu_bum->rest_pot;
		  bum_dyn->soma = clu_bum->b_v_plus * 
				   (exp(clu_bum->b_A * bum_dyn->soma) - 1.) 
				    / (exp(clu_bum->b_A * bum_dyn->soma) - clu_bum->b_v_rap);
		  bum_dyn->soma += clu_bum->rest_pot;

		  if (bum_dyn->soma >= bum_dyn->threshold)
		  {				/* on a un spike */
			sim_neurons[i]->new_state = SPIKE;
			sim_neurons[i]->decharge_lag = 1.;
			sim_neurons[i]->spike = sim_neurons[i]->its_cluster->spike_duration;
#if DEBUG_UPDT_1
			printf("soma avt spike: %f\n",
			       bum_dyn->soma);
#endif
			bum_dyn->soma_post_spike = bum_dyn->soma = clu_bum->pot_post_spike;

			/* calcul de la valeur absolue du seuil apres ce spike (seuil_peak) */

			if (clu_bum->less_fatigue)
			{
			  delta = (bum_dyn->seuil_peak - bum_dyn->threshold);
			  seuil_increase = (clu_bum->seuil_post_spike - delta)* clu_bum->fatigue + delta;
			}
			else
			{
			  seuil_increase = clu_bum->seuil_post_spike * 
					 (clu_bum->fatigue * (bum_dyn->threshold - clu_bum->seuil) + 1.);
			}
			bum_dyn->seuil_peak = seuil_increase + bum_dyn->threshold;
			bum_dyn->delta_seuil = bum_dyn->seuil_peak - clu_bum->seuil;
#if DEBUG_BURST
			printf("SPIKE: iter: %d (spike suivante: %d)\n", nb_it, bum_dyn->spike_suivante);
#endif
			if (sim_nucleus[n]->law != 0)
				 (*sim_nucleus[n]->learning)(i,(sim_nucleus[n]->number - 1));

			    /*
			     * sauvegarde de la serie temporelle
			     *    Save time of spike 
			     */
#if BUFFERIZE_AND_FLUSH
			sprintf(buffer,"%.3f %lu\n",simu->time_ms,sim_neurons[i]->id);
			tms_buffer = bufferize_and_flush(tms_buffer,buffer,&tms_buf_size,
							 strlen(buffer),&tms_tmpfp);
			tms_size += strlen(buffer);
#else
			if (simu->output_tms_f)
			  fprintf(tms_fp,"%.3f %lu\n",simu->time_ms,sim_neurons[i]->id);
			if (simu->output_abe_f)
			  fprintf(abe_fp,"%d,%lu,%lu\n", n+1, sim_neurons[i]->id, simu->nb_it - previous_event);
			previous_event = simu->nb_it;
#endif
		  } /* fin du if */
		  else			/* pas de spike */
		  {
		        sim_neurons[i]->new_state = REPOS;
			sim_neurons[i]->decharge_lag += 1.;
		  } /* fin du else */
	 }
}

