/*******************************************************************************
	Function for one CBM cluster iteration computation without transmitors
*******************************************************************************/
// void update_G_res_no_ntr_full(int pos)
void update_G_res_no_ntr_full(int pos)
{

	int	i, j, k, l, n, d_l, i_r, ntrm;
	
	int	flag_psp[NB_MAX_RECEPTORS];
	float	diff_volt[NB_MAX_RECEPTORS];

	float	
		white_noise,
		t_i, 			/* Elapsed time */
		psp, epsp, ipsp, nmda,		
		net_input_pos,		/* somme de ce qui arrive positif (intermediaire) */
		net_input_neg,		/* somme de ce qui arrive negatif (intermediaire) */
		net_input_nmda,		/* somme de ce qui arrive en NMDA (intermediaire) */
		coeff_NMDA,		/* intermediaire de calcul */
		noise = 0.,		/* background noise */	
		clu_noise = 0.,		/* cluster background noise */	
		nucl_noise = 0.,	/* nucleus background noise */
		sum_i_pos,		/* pour la somme des inputs */
		sum_i_neg,		/* pour la somme des inputs */

		G_Na,		/* conductance totale du courant sodique */
		I_Na,		/* Fast Sodium Current*/
		G_K,		/* conductance totale de la rectification retardee*/
		I_K,		/* courant K de la rectification retardee */
		G_Ca,		/* conductance totale du courant calcique */
		I_Ca,		/* Fast Calcium Current*/
		G_Cl,		/* conductance totale du courant Chlore */
		I_Cl,		/* courant Cl */
		G_A,		/* conductance totale de K pour le courant Ia */
		I_A,		/* courant Ia*/
		G_M,		/* conducatnce totale de K pour le courant Im */
		I_M,		/* courant Im non inactivable*/
		G_C,		/* courant k calcium dependant non inactivable */
		I_C,		/* courant K calcium et voltage dependant non inactivable*/
		G_H,		/* courant k rectification entrante Ih */
		I_H,		/* courant K calcium et voltage dependant non inactivable*/
		G_ahp,		/* conductance totale du K pour le courant Iahp */
		I_ahp,		/* courant K calcium dependant voltage independant*/
		G_Nap,		/* conductance totale du courant sodique persistant */
		I_Nap,		/* Persistant Sodium Current*/
		G_Cab,		/* conductance totale du courant Ca LVA */
		I_Cab,		/* Ca LVA Current*/
		G_Syn_pos,	/* conductance totale pour le courant synaptique */
		G_Syn_neg,	/* conductance totale pour le courant synaptique */
		I_Syn_pos,	/* courant synaptique */
		I_Syn_neg,	/* courant synaptique */

		tau_m_Na,       /* cste de temps de l'activation des canaux Na  */
		m_1_Na,         /* facteur intervenant dans le calcul de m_Na*/
		alpha_m_Na,     /* facteur intervenant dans le calcul de m_Na et tau_m_Na */
		beta_m_Na,      /* facteur intervenant dans le calcul de m_Na et tau_m_Na */
		tau_h_Na,       /* cste de temps d'inactivation des canaux Na */
		h_1_Na,         /* facteur intervenant dans le calcul de h_na */
		alpha_h_Na,     /* facteur intervenant dans le calcul de h_Na et tau_h_Na */
		beta_h_Na,      /* facteur intervenant dans le calcul de m_Na et tau_h_Na */
		tau_m_Ca,       /* cste de temps d'activation des canaux Ca */
		m_1_Ca,         /* facteur intervenant dans le calcu de m_Ca */
		tau_m_K,        /* cste de temps de l'activation des canaux K */
		m_1_K,          /* facteur intervenant dans le calcul de m_K */
		alpha_m_K,      /* facteur intervenant dans le calcul de tau_m_K */
		beta_m_K,       /* facteur intervenant dans le calcul de tau_m_K */
		alpha_m1_K,     /* facteur intervenant dans le calcul de m1_k */
		beta_m1_K,      /* facteur intervenant dans le calcul de m1_k */
		tau_h_K,        /* cste de temps d'inactivation des canaux K */
		h_1_K,          /* facteur intervenant dans le calcul de h_K */
		tau_m_A = 1.38,  /* cste de temps d'activation des canaux K pour le courant Ia */
		m_1_A,          /* facteur intervenant dans le  calcul de m_A */
		tau_h_A,        /* cste de temps d'inactivation des canaux K pour le courant Ia */
		h_1_A,          /* facteur intervenant dans le calcul de h_A */
		alpha_m_Im,     /* facteur intervenant dans le calcul de tau_m_Im */
		beta_m_Im,     /* facteur intervenant dans le calcul de tau_m_Im */
		tau_m_M,        /* cste de temps d'activation des canaux k pour le courant Im */
		m_1_M,          /* facteur intervenant dan le calcul de m_M */
		tau_m_C,        /* cste de temps d'activation des canaux K dependants du calcium et du voltage */
		m_1_C,          /* facteur permettant de calculer m_C */
		alpha_m_Ic,     /* permet le calcul de tau_m_C et m_1_C en tenant compte de Ca et du voltage*/
		beta_m_Ic,      /* permet le calcul de tau_m_C et m_1_C en tenant compte du voltage*/

		tau_m_nap,        /* cste de temps d'activation des canaux K dependants du calcium et du voltage */
		m_1_Nap,          /* facteur permettant de calculer m_Nap */
		alpha_m_Inap,     /* permet le calcul de tau_m_nap et m_1_Nap en tenant compte du voltage*/
		beta_m_Inap,      /* permet le calcul de tau_m_nap et m_1_Nap en tenant compte du voltage*/

		tau_h_cab,        /* cste de temps d'activation des canaux K dependants du calcium et du voltage */
		m_1_Cab,          /* facteur permettant de calculer m_Cab */
		h_1_Cab,          /* facteur permettant de calculer m_Cab */
		alpha_h_Icab,     /* permet le calcul de tau_h_Cab et h_1_Cab en tenant compte de Ca et du voltage*/
		beta_h_Icab,      /* permet le calcul de tau_h_Cab et h_1_Cab en tenant compte du voltage*/
		alpha_m_Icab,     /* permet le calcul de tau_m_Cab et m_1_Cab en tenant compte de Ca et du voltage*/
		beta_m_Icab,      /* permet le calcul de tau_m_Cab et m_1_Cab en tenant compte du voltage*/

		tau_m_Ih,	/* cste de temps d'activation des canaux pour le courant Ih */
		m_1_Ih,		/* facteur permettant de calculer m_Ih */
		alpha_m_Ih,	/* permet le calcul de tau_m_Ih et m_1_Ih en tenant compte du voltage*/
		beta_m_Ih,	/* permet le calcul de tau_m_Ih et m_1_Ih en tenant compte du voltage*/

		tau_m_ahp,      /* cste de temps d'activation des canaux K pour le courant Iahp */
		m_1_ahp,        /* facteur intervenant dans le calcul de m_ahp */
		f1_Ca,          /* permet le calcul de tau_m_ahp et m_1_ahp en tenant compte de [Ca]*/
		b1 = 2.5,        /* permet le calcul de tau_m_ahp et m_1_ahp */

		soma_avant,	/* pour calculer la pente */
		input_sup,	/* voltage du a l'input supplementaire */
		delta_potentiel,/* cgt local de potentiel */
		decay,		/* variable intermediaire */
		decay_mb_pot,		/* variable intermediaire */
		curr_time;	/* variable intermediaire */

	char buffer[256];

	CBM *clu_cbm;
	CBM *clu_cnx;
	CBM_DYNAMIC *cbm_dyn;

#if DEBUG
	printf("time step: %f m (%d i)\nspike duration: %f m (%d i)\nsaved: %f m (%d i)\n",
	       simu->time_step,
	       nintf(1./simu->time_step),
	       simu->spike_width,
	       simu->nb_step_spk,
	       simu->nb_step_save_ms,
	       simu->nb_step_save_it);
#endif
	
	if((pos<0) || (pos>=simu->nb_neurons))
	{
		fprintf(stderr,"i is out of range in update_G_res_no_ntr!!!!\n");
		exit(-1);
	}
	i = pos;

	k = (sim_neurons[i]->its_cluster->number)-1;
	n = (sim_neurons[i]->its_nucleus->number)-1;
	clu_cbm = (CBM *)sim_neurons[i]->its_cluster->clu_data;
	cbm_dyn = (CBM_DYNAMIC *)sim_neurons[i]->neuron_data;

	t_i = (float)(simu->nb_it);


	soma_avant = cbm_dyn->soma;

/*
	reactualise_E_Na_K(cbm);
*/

#if DEBUG
	printf("\tentree dans pdate_G_res_no_ntr neurone %d\n*****\nIteration : %f\nsoma : %f\n",i,t_i,soma_avant);
#endif
/*************** TIRE DIRECTEMENT DE G_NEURON V7.7 ***************************/

  /******************************************************************/
  /*----  Calcul de la conductance au k pour le courant
          de rectification retardee                     ------------*/
  /******************************************************************/

  if (clu_cbm->model_type==MICHAELIS_MENTON_MODEL || clu_cbm->model_type==HH_FULL_MODEL )
  {

      /****      variable d'activation des canaux K         ****/
      alpha_m_K =  exp(clu_cbm->A_K * (cbm_dyn->soma - clu_cbm->V_K));
      beta_m_K = exp(-clu_cbm->A_K * (cbm_dyn->soma - clu_cbm->V_K));
      tau_m_K = (1. / ( clu_cbm->lambda_Ik * (alpha_m_K + beta_m_K)));
      m_1_K = alpha_m_K / ( alpha_m_K + beta_m_K);
      decay = (exp (-simu->time_step / tau_m_K));
      cbm_dyn->m_K = cbm_dyn->m_K * decay +
	    m_1_K * (1. - decay);
      
      /****         Conductance et courant K                 ****/
      if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_K]) 
	G_K = 0.;
      else
	  G_K = clu_cbm->g_K * pow(cbm_dyn->m_K,clu_cbm->Pow_K);
#if DEBUG
      printf("K  -> m_K: %f A_K: %f V_K: %f G_K = %f g_K = %f E_K = %f\n",cbm_dyn->m_K,  clu_cbm->A_K, clu_cbm->V_K, G_K, clu_cbm->g_K, clu_cbm->E_K);
#endif
  }
#if 0
/*---------------------------------------------------------------*/ 

	if (clu_cbm->model_type==HH_PUMP_MODEL)
	{ 
		FoRT = F/(R*(Temp+273.15));
		F2oRT = F*FoRT;
		eVFoRT  = exp(cbm_dyn->soma*0.001*FoRT);
		emVFoRT = exp(-cbm_dyn->soma*0.001*FoRT);
		AVF2oRT = surface*cbm_dyn->soma*0.001*F2oRT;
		AComCieo1me = AVF2oRT*(K_ext - K_int*eVFoRT)/(1.0 - eVFoRT);

		/****      variable d'activation des canaux K         ****/
		alpha_m_K =  exp(A_K * (cbm_dyn->soma - V_K));
		beta_m_K = exp(-A_K * (cbm_dyn->soma - V_K));
		tau_m_K = (1. / ( lambda_Ik * (alpha_m_K + beta_m_K)));
		m_1_K = alpha_m_K / ( alpha_m_K + beta_m_K);
		decay = (exp (-simu->time_step / tau_m_K));
		m_K = m_K * decay +
		m_1_K * (1. - decay);

		/****         Conductance et courant K                 ****/
		temp = z_r*elec*(cbm_dyn->soma*0.001-Vr)/(K*(Temp+273.15));
		ez_peVmVpoKT = exp(temp);
		ea_pz_peVmVpoKT = exp(alpha_r*temp);

		decay = (-simu->time_step / tau_p(taubar_r,ea_pz_peVmVpoKT,ez_peVmVpoKT,alpha_r) );
		param_r = param_r*decay + p_inf(nu_r,ez_peVmVpoKT)*( 1. - decay );


		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_K]) 
			G_K = I_K = 0.;
		else 
		{
			G_K =  I_K / (cbm_dyn->soma - cbm_dyn->e_K); 
			I_K  = (float ) (P_bar_K*m_K*m_K*param_r*AComCieo1me);
		}
	}
#endif
  
  /******************************************************************/
  /*---------     calcul de la conductance au Na     ---------------*/
  /******************************************************************/
  
	if (clu_cbm->model_type==MICHAELIS_MENTON_MODEL)
	{
		/****      variable d'activation des canaux Na          ****/
		m_1_Na = 1. / (1. + (exp ( -2.0 * clu_cbm->A_Na * (cbm_dyn->soma - clu_cbm->V_Na))));

		/****        Conductance et Courant Na                ****/ 
		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_Na]) 
			I_Na = G_Na = 0.;
		else
		{
			G_Na = clu_cbm->g_Na * pow(m_1_Na,clu_cbm->Pow_Na)  * (1.0 - cbm_dyn->m_K)   ; 
		}
	}
  /*---------------------------------------------------------------*/ 
	if (clu_cbm->model_type==HH_FULL_MODEL)
	{
		/****      variable d'activation des canaux Na          ****/
		m_1_Na = 1. /(1. + exp (-2.0 * clu_cbm->A_INa_A * (cbm_dyn->soma - clu_cbm->V_INa_A)));

		/****    variable d'inactivation des canaux Na         ****/
		h_1_Na = 1. /(1. + exp (-2.0 * clu_cbm->A_INa_B * (cbm_dyn->soma - clu_cbm->V_INa_B)));
		decay = exp ( -simu->time_step / clu_cbm->Tau_INa_B);
		cbm_dyn->h_Na = cbm_dyn->h_Na * decay +
		h_1_Na * (1. - decay);

		/****        Conductance et Courant Na                ****/ 
		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_Na]) 
			G_Na = 0.;
		else
			G_Na = clu_cbm->g_Na * pow(m_1_Na,clu_cbm->Pow_INa_A) * pow(cbm_dyn->h_Na,clu_cbm->Pow_INa_B) ;
	}
#if 0
  /*---------------------------------------------------------------*/ 

	if (clu_cbm->model_type==HH_PUMP_MODEL)
	{
		FoRT = F/(R*(Temp+273.15));
		F2oRT = F*FoRT;
		eVFoRT  = exp(cbm_dyn->soma*0.001*FoRT);
		emVFoRT = exp(-cbm_dyn->soma*0.001*FoRT);
		AVF2oRT = surface*cbm_dyn->soma*0.001*F2oRT;
		AComCieo1me = AVF2oRT*(Na_ext - Na_int*eVFoRT)/(1.0 - eVFoRT);

		/****    variable d'activation des canaux Na             ****/
		m_1_Na = 1. /(1. + exp (-2.0 * A_INa_A * (cbm_dyn->soma - V_INa_A)));

		/****    variable d'inactivation des canaux Na          ****/
		h_1_Na = 1. /(1. + exp (-2.0 * A_INa_B * (cbm_dyn->soma - V_INa_B)));
		decay = exp ( -simu->time_step / Tau_INa_B);
		h_Na = h_Na * decay +
		h_1_Na * (1. - decay);

		/****       Conductance et Courant Na                ****/
		temp = z_l*elec*(cbm_dyn->soma*0.001-Vl)/(K*(Temp+273.15));
		ez_peVmVpoKT = exp(temp);
		ea_pz_peVmVpoKT = exp(alpha_l*temp);

		decay = (-simu->time_step / tau_p(taubar_l,ea_pz_peVmVpoKT,ez_peVmVpoKT,alpha_l) );
		param_l = param_l*decay + p_inf(nu_l,ez_peVmVpoKT)*( 1. - decay );

		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_Na]) 
			G_Na = I_Na = 0.;
		else
		{
			I_Na = P_bar_Na*m_1_Na*m_1_Na*h_Na*param_l*AComCieo1me;
			G_Na = I_Na / (cbm_dyn->soma - cbm_dyn->e_Na); 
		}
	}

/***************************************************************/
/*--- calcul de la conductance pour le courant de pump I_P ----*/
/***************************************************************/

	if (clu_cbm->model_type==MICHAELIS_MENTON_MODEL || clu_cbm->model_type==HH_FULL_MODEL )
	{
		I_P=G_P=0;
	}

/*---------------------------------------------------------------*/ 

	if (clu_cbm->model_type==HH_PUMP_MODEL)
	{
		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_P]) 
			I_P = G_P = 0;
		else
		{
			I_P = (surface*F/3.) * ( Jbar_p_Na/( (1. + Km/Na_int)*(1. + Km/Na_int)*(1. + Km/Na_int)  ));
			G_P = I_P / (cbm_dyn->soma - cbm_dyn->e_Na); 
		}
	}

#endif

#if DEBUG
  
	printf("Na -> V: %f A: %f V: %f\n",cbm_dyn->soma,  clu_cbm->A_Na, clu_cbm->V_Na);
	printf("Na -> G_Na: %f g_Na: %f m_1_Na: %f E_Na: %f\n", G_Na, clu_cbm->g_Na, m_1_Na, clu_cbm->E_Na);
#endif



/*******************************************************************/
/*--- calcul de la conductance au calcium pour le courant I_Ca ----*/
/*******************************************************************/
	if (clu_cbm->g_Ca)
	{
		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_Ca])
			G_Ca = I_Ca = 0;
		else
		{
			/****      variable d'activation des canaux Ca         ****/
			m_1_Ca = 1. / (1. + (exp (-2.0 * clu_cbm->A_Ca * (cbm_dyn->soma - clu_cbm->V_Ca))));

			decay = exp(-simu->time_step/ clu_cbm->Tau_Ca);
			cbm_dyn->m_Ca = cbm_dyn->m_Ca * decay + m_1_Ca * ( 1. - decay);

			/****      variable d'inactivation des canaux Ca      ****/
			cbm_dyn->h_Ca =  clu_cbm->Ca_Kd / (clu_cbm->Ca_Kd + cbm_dyn->Ca_i);

			/****      Conductance et courant Ca                 ****/
			G_Ca = clu_cbm->g_Ca * pow(cbm_dyn->m_Ca,clu_cbm->Pow_Ca) * cbm_dyn->h_Ca ;
			I_Ca = G_Ca * (cbm_dyn->soma - clu_cbm->E_Ca); 
		}
	}
	else
		I_Ca = G_Ca = 0.;
	
	/*--- calcul de la concentration en calcium intracellulaire ---- */
	
	/* in reality, CA_i steady_state (g/f) = Kp(-Ica)/(-R)   */
	/* where dy/dt = y*f + g */
	
	m_1_Ca = clu_cbm->Ca_Influx * (I_Ca) / (clu_cbm->Ca_Removal);
	decay = exp (simu->time_step * (-clu_cbm->Ca_Removal));
	cbm_dyn->Ca_i = cbm_dyn->Ca_i * decay + m_1_Ca * ( decay - 1.0);
	
#if DEBUG
	printf("I_Ca: %f, Ca_i  -> %f\n",I_Ca, cbm_dyn->Ca_i);
#endif

      /*---------------------------------------------------------------*/ 


/***************************************************************/
/*---   calcul de la conductance du courant ahp          ------*/
/***************************************************************/
	if (clu_cbm->g_ahp)
	{
		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_ahp]) 
			G_ahp = 0;
		else
		{

			/****      variable d'activation des canaux Kahp  ****/
			m_1_ahp = cbm_dyn->Ca_i / ( cbm_dyn->Ca_i + clu_cbm->K_Ca_Kd);

			/****      Conductance et courant                  ****/
			G_ahp = clu_cbm->g_ahp * m_1_ahp ;
		}
	}
	else
		G_ahp = 0.;

/*---------------------------------------------------------------*/ 

#ifdef ADD_CURRENT
      /*--------   To add a current copy, modify and adapt   -------*/
      /*--- ATTENTION: Modify the equation. It is only for place holding --*/
      
      /*--- calcul de la conductance  pour le courant INew   -----------*/
	if (clu_cbm->g_New)
	{
		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_New]) 
			G_New = 0;
		else
		{
			/****    variable d'activation des canaux New            ****/
			m_1_New = 1. /(1. + exp (-2.0 * clu_cbm->A_INew_A * (cbm_dyn->soma - clu_cbm->V_INew_A)));

			/****    variable d'inactivation des canaux New         ****/
			h_1_New = 1. /(1. + exp (-2.0 * clu_cbm->A_INew_B * (cbm_dyn->soma - clu_cbm->V_INew_B)));
			decay = exp ( -simu->time_step / clu_cbm->Tau_INew_B);
			cbm_dyn->h_New = cbm_dyn->h_New * decay +
			h_1_New * (1. - decay);

			/****       Conductance et Courant Ka                ****/
			G_New = clu_cbm->g_New * pow(m_1_New,clu_cbm->Pow_INew_A) * pow(cbm_dyn->h_New,clu_cbm->Pow_INew_B) ;
		}
	}
	else
		G_New = 0.;
#endif


  /********************************************************************/
  /*--- calcul de la conductance au k pour le courant Ia   -----------*/
  /********************************************************************/
	if (clu_cbm->g_A)
	{
		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_A]) 
			G_A = 0;
		else
		{
			/****    variable d'activation des canaux Ka            ****/
			m_1_A = 1. /(1. + exp (-2.0 * clu_cbm->A_Ia_A * (cbm_dyn->soma - clu_cbm->V_Ia_A)));

			/****    variable d'inactivation des canaux Ka         ****/
			h_1_A = 1. /(1. + exp (-2.0 * clu_cbm->A_Ia_B * (cbm_dyn->soma - clu_cbm->V_Ia_B)));
			decay = exp ( -simu->time_step / clu_cbm->Tau_Ia_B);
			cbm_dyn->h_A = cbm_dyn->h_A * decay +
			h_1_A * (1. - decay);

			/****       Conductance et Courant Ka                ****/
			G_A = clu_cbm->g_A * pow(m_1_A,clu_cbm->Pow_Ia_A) * pow(cbm_dyn->h_A,clu_cbm->Pow_Ia_B) ;
		}
	}
	else
		G_A = 0.;
  /*---------------------------------------------------------------*/ 

  /***************************************************************/
  /*---  calcul de la conductance au K pour le courant Im  ------*/
  /***************************************************************/

    if (clu_cbm->g_M)
    {
	    if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_M])
			G_M = 0;
	    else
			{
			/****    variable d'activation des canaux Km        ****/
			alpha_m_Im =  exp(clu_cbm->A_Im*(cbm_dyn->soma - clu_cbm->V_Im));
			beta_m_Im = exp(-clu_cbm->A_Im*(cbm_dyn->soma - clu_cbm->V_Im));
			tau_m_M = (1. / (clu_cbm->lambda_Im * (alpha_m_Im + beta_m_Im)));
			m_1_M = alpha_m_Im / ( alpha_m_Im + beta_m_Im);

#if DEBUG
			printf("m_M: %f tau_m_M: %f m_1_M: %f\n",
			 cbm_dyn->m_M, tau_m_M, m_1_M);
#endif
			decay = exp (-simu->time_step / tau_m_M );
			cbm_dyn->m_M = cbm_dyn->m_M * decay + m_1_M * (1. - decay);

			/****        Conductance et courant Km             ****/
			G_M = clu_cbm->g_M * cbm_dyn->m_M ;
		}
    }
    else
		G_M = 0.;

  /*---------------------------------------------------------------*/ 
 

  /******************************************************/    
  /*---   calcul de la conductance du courant Ic  ------*/
  /*  using by default V_Ic = -90                       */
  /*                   A_Ic = 0.05                      */
  /*                   lambda_Ic = 5                    */
  /* gives approximately same result as Methods 
                                   in neuronal modeling */
  /******************************************************/    

	if (clu_cbm->g_C)
	{
		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_C]) 
			G_C = 0;
		else
		{
			/****      variable d'activation des canaux Kc    ****/
			alpha_m_Ic = cbm_dyn->Ca_i * exp (clu_cbm->A_Ic * (cbm_dyn->soma - clu_cbm->V_Ic));
			beta_m_Ic  = exp (-clu_cbm->A_Ic * (cbm_dyn->soma - clu_cbm->V_Ic));
			m_1_C      = alpha_m_Ic / (alpha_m_Ic + beta_m_Ic);
			tau_m_C = 1./ (clu_cbm->lambda_Ic * (alpha_m_Ic + beta_m_Ic));
			decay   = exp(-simu->time_step/tau_m_C);
			cbm_dyn->m_C = cbm_dyn->m_C * decay + m_1_C * (1. - decay );

			/****      Conductance et courant Kc              ****/

			G_C = clu_cbm->g_C * cbm_dyn->m_C ;
		}
	}
	else
		G_C = 0.;
     
	/***************************************************/
	/*----  calcul de la conductance et du courant de 
          la rectification entrante au K+ (Ih)  -----*/
	/***************************************************/
  
	if (clu_cbm->g_H)
	{
		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_H]) 
			G_H = 0.;
		else
		{
			/* default values:  (following Huguenard and McCormick 1993)
			V_Ih = -75.0  A_Ih = -0.09  lambda = 0.0005  E_H = -43.0 */

			/****    variable d'activation des canaux Ih        ****/
			alpha_m_Ih = exp(clu_cbm->A_Ih * (cbm_dyn->soma - clu_cbm->V_Ih));
			beta_m_Ih  = exp(-clu_cbm->A_Ih * (cbm_dyn->soma - clu_cbm->V_Ih));
			tau_m_Ih = (1. / (clu_cbm->lambda_Ih * (alpha_m_Ih + beta_m_Ih)));
			m_1_Ih = alpha_m_Ih / ( alpha_m_Ih + beta_m_Ih);
			decay = exp (-simu->time_step / tau_m_Ih);
			cbm_dyn->m_Ih  = cbm_dyn->m_Ih * decay + m_1_Ih * (1. - decay);

			/****        Conductance et courant Ih             ****/
			G_H = clu_cbm->g_H * cbm_dyn->m_Ih ;
		}
	}
	else
		G_H = 0.;

  /*---------------------------------------------------------------*/ 

  /**************************************************************/
  /*---  calcul de E_K car accumulation de K              ------*/
  /* d(Ko)/dt = IK_total/(Vperi*F) - (Ko - Krest)/(tauK-diff)   */
  /* from Methods in Neural modeling eds Koch and Segev pg. 115 */
  /* Krest = 2.5 mM, tauK-diff = 7msec                          */
  /* require radius of cell, in um                              */
  /* assumes extracellular space is 70nm radius                 */
  /**************************************************************/

  /*	radius = (diametre/2.);
	decay = exp(-simu->time_step/7.);
        K_ext = K_ext * decay +
	7. * (((I_K + I_A + I_M + I_C + I_ahp)
	* (3.11e-10*pow(radius,2.0))/ 
	(pow(radius+0.07,3.0)-pow(radius,3.0)))
	+ (K_rest/7.)) * (1. - decay);
	
        E_K = 25.* (float) log(K_ext/140.);

  */
  
	reactualise_E_Na_K(clu_cbm);    
  


  /*****************************************************************************/
  /*---  calcul de la conductance au Na persistant pour le courant INap  ------*/
  
  /* default values:  V_Inap = -56.0  A_Inap = 0.07  lambda = 0.1  */
  /*****************************************************************************/
      
	if (clu_cbm->g_Nap)
	{
		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_Nap]) 
			G_Nap = 0;
		else
		{      
			/****    variable d'activation des canaux Na p        ****/
			alpha_m_Inap =  exp(clu_cbm->A_Inap * (cbm_dyn->soma - clu_cbm->V_Inap));
			beta_m_Inap = exp(-clu_cbm->A_Inap * (cbm_dyn->soma - clu_cbm->V_Inap));
			tau_m_nap = (1. / (clu_cbm->lambda_Inap * (alpha_m_Inap + beta_m_Inap)));
			m_1_Nap = alpha_m_Inap / ( alpha_m_Inap + beta_m_Inap);
			decay = exp (-simu->time_step / tau_m_nap);
			cbm_dyn->m_Nap = cbm_dyn->m_Nap * decay +
			m_1_Nap * (1. - decay);

			/****        Conductance et courant Km             ****/
			G_Nap = clu_cbm->g_Nap * cbm_dyn->m_Nap ;
		}
	}
	else
		G_Nap = 0.;
  /*---------------------------------------------------------------*/ 

  /***************************************************************************/
  /*--- calcul de la conductance au Ca LVA pour le courant Icab   -----------*/
  
  /* default values:  Vm_Icab = -45.0  Am_Icab = 0.1  tau_m_Cab = 10.0 */
  /*   Vh_Icab = -70.0  Ah_Icab = 0.1  lambda_Icab = 0.005  */
  /***************************************************************************/
      
	if (clu_cbm->g_Cab)
	{
		if (stim_drug_f[n] && sim_nucleus[n]->drogue[drug_Cab]) 
			G_Cab = 0;
		else
		{
			/****    variable d'activation des canaux Ca_b            ****/
			alpha_m_Icab =  exp(clu_cbm->Am_Icab * (cbm_dyn->soma - clu_cbm->Vm_Icab));
			beta_m_Icab = exp(-clu_cbm->Am_Icab * (cbm_dyn->soma - clu_cbm->Vm_Icab));
			m_1_Cab = alpha_m_Icab / ( alpha_m_Icab + beta_m_Icab);

			/****    variable d'inactivation des canaux Cab         ****/
			alpha_h_Icab =  exp(-clu_cbm->Ah_Icab * (cbm_dyn->soma - clu_cbm->Vh_Icab));
			beta_h_Icab = exp(clu_cbm->Ah_Icab * (cbm_dyn->soma - clu_cbm->Vh_Icab));
			h_1_Cab = alpha_h_Icab / ( alpha_h_Icab + beta_h_Icab);
			tau_h_cab = (1. / (clu_cbm->lambda_Icab));
			decay = exp ( -simu->time_step / clu_cbm->tau_m_cab);
			cbm_dyn->m_Cab = cbm_dyn->m_Cab * decay + m_1_Cab * (1. - decay);
			decay = exp ( -simu->time_step / tau_h_cab);
			cbm_dyn->h_Cab = cbm_dyn->h_Cab * decay + h_1_Cab * (1. - decay);

			/****       Conductance et Courant Ka                ****/
			G_Cab = clu_cbm->g_Cab *  pow(cbm_dyn->m_Cab,clu_cbm->Pow_m_cab) * cbm_dyn->h_Cab ;
		}
	}
	else
		G_Cab = 0.;
  /*---------------------------------------------------------------*/ 
     
#if 0
	if (clu_cbm->model_type==HH_PUMP_MODEL )
	{
		I_LNa = PL_Na*AVF2oRT ;
		I_LNa = I_LNa * (Na_ext - Na_int*eVFoRT ) ;
		I_LNa = I_LNa / (  1.   -        eVFoRT ) ;

		I_LK = PL_K*AVF2oRT ;
		I_LK = I_LK * (K_ext - K_int*eVFoRT ) ;
		I_LK = I_LK / (  1.   -      eVFoRT ) ;

		I_LCl = PL_Cl*AVF2oRT ;
		I_LCl = I_LCl * (Cl_ext - Cl_int*eVFoRT ) ;
		I_LCl = I_LCl / (  1.   -        eVFoRT ) ;
	}
#endif

  /*---------------------------------------------------------------*/ 
     

	if (clu_cbm->noise_active)
	{
      		seed = (int)time(0) & 077;
		clu_noise = gasdev(&seed);
		clu_noise *= clu_cbm->backgrd_n_sd;
#if KOHN_DEBUG		
		if (clu_cbm->filter_noise)
		{
		  cbm_dyn->center_noise = cbm_dyn->center_noise * exp(-(simu->time_step) / (clu_cbm->res_capa)) 
		                          + clu_cbm->i_capacite * clu_noise; 
		  clu_noise =  cbm_dyn->center_noise + clu_cbm->backgrd_noise_m;		  
		}
		else
#endif
		 clu_noise += clu_cbm->backgrd_noise_m;
	} 
#if KOHN_DEBUG
	printf("clu_cbm->noise_active: %d, clu_cbm->filter_noise: %d\n",
	       clu_cbm->noise_active, clu_cbm->filter_noise);
	printf("cbm_dyn->center_noise: %f\nclu_cbm->res_capa: %f\nclu_cbm->i_capacite: %f\nclu_noise:%f\n*****\n",
	       cbm_dyn->center_noise, clu_cbm->res_capa,
	       clu_cbm->i_capacite, clu_noise); 
#endif
	if(stim_noise_f[n] && sim_nucleus[n]->noise_active)
	{
		nucl_noise = gasdev(&seed);
		nucl_noise *= sim_nucleus[n]->backgrd_n_sd;
		nucl_noise += sim_nucleus[n]->backgrd_noise_m;		
	} 
		
		
	if (stim_modul_f[n])
	{
	  nucl_noise += sim_nucleus[n]->modul_value;
	}

	noise = clu_noise + nucl_noise;
	
#if NBC_X_DEBUG
	if(debug)
	{
		fprintf(fdbg,"Noise for neuron %lu: total %f, nucl %f, clu %f\n",
			sim_neurons[i]->id,noise,nucl_noise,clu_noise);
	}
#endif

	/*
	 *	intra somatic potential
	 */
	 
	/*
	 *  Inputs from other neurons
	 */

  /***********************************************************/
  /*--- calcul de la conductance du courant synaptique   ----*/
  /***********************************************************/

/* 
	Si prise en compte des neurotransmetteurs 
		i est le neurone simul
		j est neurone qui le connecte
*/
/*
  I_Syn_pos = 0.;
*/  
	for (i_r = 0; i_r < clu_cbm->nb_receptors; i_r++)
	{
		clu_cbm->Receptors[i_r].G_syn = 0.;
		diff_volt[i_r] = clu_cbm->Receptors[i_r].g_Syn * (cbm_dyn->soma - clu_cbm->Receptors[i_r].rev_pot);
		flag_psp[i_r] = 0;
	}
  

#if DEBUG_V8
  for (nb_r = 0; nb_r < nb_receptors; nb_r++)
  {
    printf("1 - Recp %d: %d (%d) (%s)\n", nb_r, clu_cbm->Receptors[nb_r].transmetteur, clu_cbm->Receptors[nb_r].num_transm, clu_cbm->Receptors[nb_r].nom);
  }
#endif


/* Si NON prise en compte des neurotransmetteurs */
	/*
	 *  Inputs from other neurons
	 */
	epsp = ipsp = nmda = 0.;
			   
	for (j = 0; j < simu->nb_neurons; j++) 
	{
		for (l = 0 ; l < sim_neurons[j]->connected_neurons ; l++)
		{
			if((sim_neurons[j]->targets[l] == sim_neurons[i]->id) &&
			  (sim_neurons[j]->connections[l]))
			{
				if ((simu->nb_it - sim_neurons[j]->spike_time[sim_neurons[j]->next_spike[l]]) ==
				  sim_neurons[j]->axone_step[l]) 
				{
					if (sim_neurons[j]->connections[l] > 0)
						epsp += clu_cbm->g_Syn_pos * sim_neurons[j]->connections[l];
					else
						ipsp += clu_cbm->g_Syn_neg * sim_neurons[j]->connections[l];
					
					sim_neurons[j]->next_spike[l] = 
						(sim_neurons[j]->next_spike[l] + 1) % MAX_SPK;
						
#if NBC_X_DEBUG
					if(debug &&(sim_neurons[j]->connections[l] > 0))
					{
						fprintf(fdbg,"Epsp contribution from neuron %lu to neuron %lu:  %f( new epsp:%f)\n",
							sim_neurons[j]->id,sim_neurons[i]->id,
							clu_cbm->g_Syn_pos * sim_neurons[j]->connections[l],epsp);
					}
					if(debug &&(sim_neurons[j]->connections[l] < 0))
					{
						fprintf(fdbg,"Ipsp contribution from neuron %lu to neuron %lu:  %f( new ipsp:%f)\n",
							sim_neurons[j]->id,sim_neurons[i]->id,
							clu_cbm->g_Syn_neg * sim_neurons[j]->connections[l],ipsp);
					}
#endif
				} 
					
			} 
		}
	}

	
	/*
	 *	Is it time for input?
	 */
	if (sim_nucleus[n]->input_type && stim_pulse_f[n] 
		&& (simu->nb_it >= sim_neurons[i]->t_next_i))
	{
		if (!sim_nucleus[n]->inhib)
		{
			epsp += (clu_cbm->g_Syn_pos  * 
				sim_nucleus[n]->scale_f);
#if NBC_X_DEBUG
			if(debug)
			{
				fprintf(fdbg,"Input epsp contribution to neuron %lu:  %f( new epsp:%f)\n",
					sim_neurons[i]->id,
					clu_cbm->g_Syn_pos * sim_nucleus[n]->scale_f,epsp);
			}
#endif
		} 
		else
		{
			ipsp += -(clu_cbm->g_Syn_neg  * 
				sim_nucleus[n]->scale_f);
#if NBC_X_DEBUG
			if(debug)
			{
				fprintf(fdbg,"Input ipsp contribution to neuron %lu:  -%f( new ipsp:%f)\n",
					sim_neurons[i]->id,
					clu_cbm->g_Syn_neg * sim_nucleus[n]->scale_f,ipsp);
			}
#endif
		}

		/*
		 * stimulation (last and next)
		 */
		
		sim_neurons[i]->t_last_i = sim_neurons[i]->t_next_i;
		sim_neurons[i]->t_next_i += GetInpInterval(i);
		
		/*
		 * Sauvegarde de la serie temporelle
		 *    Save time of input 
		 * (valeur negative = external input)
		 */
		
#if BUFFERIZE_AND_FLUSH
		sprintf(buffer,"%.3f -%d\n",
			simu->time_ms, sim_nucleus[n]->id);
		tms_buffer = bufferize_and_flush(tms_buffer,buffer,&tms_buf_size,
			strlen(buffer),&tms_tmpfp);
		tms_size += strlen(buffer);
#else
		if (simu->output_tms_f)
		  fprintf(tms_fp,"%.3f -%d\n",
			  simu->time_ms, sim_nucleus[n]->id);
		if (simu->output_abe_f)
		  fprintf(abe_fp,"A,%d,%lu\n", n+1, simu->nb_it - previous_event);
		previous_event = simu->nb_it;

#endif
	}

	/*
	 * si NMDA il y a aussi du AMPA, donc il ne peut y avoir de
	 * nmda sans epsp
	 */

	net_input_pos =  suminputs(cbm_dyn->inp_ta,
				   cbm_dyn->inp_td,
				   cbm_dyn->inp_max_pos,
				   sim_neurons[i]->inp_t,
				   sim_neurons[i]->head,
				   sim_neurons[i]->tail);
#if DEBUG
	printf("net_input_pos  -> %f\n",net_input_pos);
#endif

	net_input_neg =  suminputs(cbm_dyn->inp_ta,
				   cbm_dyn->inp_td,
				   cbm_dyn->inp_max_neg,
				   sim_neurons[i]->inp_t,
				   sim_neurons[i]->head,
				   sim_neurons[i]->tail);
#if DEBUG
	printf("net_input_neg  -> %f\n",net_input_neg);
#endif
				   
	coeff_NMDA = clu_cbm->g_NMDA
			/ (1. + clu_cbm->eta_NMDA
			* clu_cbm->magnesium
			* exp( - clu_cbm->gamma_NMDA
			* cbm_dyn->soma));

	net_input_nmda = sum_NMDA(coeff_NMDA, t_i,
				   clu_cbm->tau_a_NMDA,
				   clu_cbm->tau_d_NMDA,
				   cbm_dyn->inp_nmda,
				   sim_neurons[i]->inp_t,
				   sim_neurons[i]->head,
				   sim_neurons[i]->tail);
#if DEBUG
	printf("net_input_nmda  -> %f\n",net_input_nmda);
#endif
	/*
	 * Maintenant on peut calculer le soma
	 * Calcul du voltage intra somatique realise par update_neuron()
	 */

	/*--- Calcul du potentiel  de mb                         ------- */


	cbm_dyn->g_tot = G_K + G_Na + G_A +  G_Ca + G_ahp + G_C + G_M + G_Nap + G_Cab + G_H
		+ clu_cbm->g_fuite + clu_cbm->g_fuite_Na + clu_cbm->g_fuite_K
		+ net_input_pos - net_input_neg + net_input_nmda ;
#if DEBUG
	printf("g_tot  -> %f\n",cbm_dyn->g_tot);
#endif

	decay_mb_pot = exp (-(cbm_dyn->g_tot) * simu->time_step / clu_cbm->capacite);

	cbm_dyn->g_tot = cbm_dyn->g_tot * cbm_dyn->surface_normalisee;
#if DEBUG
	printf("g_tot  1-> %f\n",cbm_dyn->g_tot);
#endif

	delta_potentiel = 
			     (
				(G_K + G_ahp + G_C + G_A + G_M + G_H + clu_cbm->g_fuite_K) * clu_cbm->E_K
			    	+ (G_Na + G_Nap + clu_cbm->g_fuite_Na) * clu_cbm->E_Na
			    	+ (G_Ca + G_Cab) * clu_cbm->E_Ca
			    	+ G_Cl * clu_cbm->E_Cl
			    	+ clu_cbm->g_fuite * clu_cbm->E_fuite
				+ net_input_pos * clu_cbm->rev_pot_pos
			    	- net_input_neg * clu_cbm->rev_pot_neg
			    	+ net_input_nmda * clu_cbm->rev_pot_NMDA
			      )
			      * cbm_dyn->surface_normalisee;
			    
	delta_potentiel /= cbm_dyn->g_tot;
	delta_potentiel *= (1. - decay_mb_pot);
	delta_potentiel +=  noise;
#if DEBUG
	printf("delta_potentiel  -> %f\ncbm_dyn->surface_normalisee %f\n,decay_mb_pot : %f",delta_potentiel,cbm_dyn->surface_normalisee,decay_mb_pot);
#endif
	
	cbm_dyn->soma = cbm_dyn->soma * decay_mb_pot + delta_potentiel;

#if DEBUG
	printf("cbm_dyn->soma   -> %f\n",cbm_dyn->soma);
#endif

	/*---  ca decharge ou pas?                              -------*/

	/*
	 * ca decharge ou pas? Critere de pente du signal.
	 */

	if (cbm_dyn->soma - soma_avant >= clu_cbm->pente_spike
	    && !sim_neurons[i]->spike_en_cours)
	{				/* on a un spike */
		sim_neurons[i]->new_state = SPIKE;

		sim_neurons[i]->decharge_lag = 0.;
	
		sim_neurons[i]->spike_en_cours = TRUE;

		/*
		 * Mise a jour de la file d'attente et waited_spike:
		 * la date d'emission du premier spike a venir
		 * est en tete de file d'attente. Il a donc decharge
		 * depuis (maintenant  - date d'emission)
		 */
		 
		/* le spike est ajoute a la file de ceux qui sont deja sur l'axone */

		sim_neurons[i]->spike_time[sim_neurons[i]->queue] = simu->nb_it;
		sim_neurons[i]->queue = (sim_neurons[i]->queue + 1) % MAX_SPK;
		if (sim_neurons[i]->queue == sim_neurons[i]->tete)
			sim_neurons[i]->tete = (sim_neurons[i]->tete + 1) % MAX_SPK;

		if (sim_nucleus[n]->law != 0)
			(*sim_nucleus[n]->learning)(i,(sim_nucleus[n]->number - 1));
		
		/*
		* sauvegarde de la serie temporelle
		*    Save time of spike 
		*/
	 
#if BUFFERIZE_AND_FLUSH
		sprintf(buffer,"%.3f %lu\n",simu->time_ms,sim_neurons[i]->id);
		tms_buffer = bufferize_and_flush(tms_buffer,buffer,&tms_buf_size,
						 strlen(buffer),&tms_tmpfp);
		tms_size += strlen(buffer);
#else
		if (simu->output_tms_f)
		  fprintf(tms_fp,"%.3f %lu\n",simu->time_ms,sim_neurons[i]->id);
		if (simu->output_abe_f)
		  fprintf(abe_fp,"%d,%lu,%lu\n", n+1, sim_neurons[i]->id, simu->nb_it - previous_event);
		previous_event = simu->nb_it;
#endif
	} /* fin du if */
	else			/* pas de spike */
	{
		sim_neurons[i]->decharge_lag += 1.;
	} /* fin du else */
	if (sim_neurons[i]->spike_en_cours && (cbm_dyn->soma - soma_avant <= 0))
	{
		sim_neurons[i]->spike_en_cours = FALSE;
	} /* fin du if */
} /* fin du update_G_res _no_tr */

