/*******************************************************************************
	Function for one virtual cluster iteration computation
*******************************************************************************/
void update_V_res(int pos)
{

	int i = pos;
	VIRTUAL *v;
	float time;
	int number;
	int cond;
	char buffer[256];
	
	/*------------------------------------------------------------------------
	GESTION CLUSTER VIRTUEL VIA FICHIER TMS
	Principe : un fichier tms est une ensemble de couple (time, # neurone).

	Ceux-ci seront introduit dans la pile des spikes, (le numero de neurone d'un
	cluster est absolue : 0...n, dans nbc6, il est relatif aux autres cluster : x...y  avec
	y - x = n -1 ) . 
	------------------------------------------------------------------------*/
	
	if (sim_neurons[i]->spike_time[sim_neurons[i]->queue] &&
	    sim_neurons[i]->spike_time[sim_neurons[i]->queue]
	     + sim_neurons[i]->its_cluster->spike_duration < simu->nb_it)
	{

		return;
	} 

	v = (VIRTUAL *)sim_neurons[i]->its_cluster->clu_data;	
	do
		cond = fscanf(v->fp_tms,"%f %d\n",&time, &number);
	while (((unsigned long)time < simu->nb_it)&&(cond != EOF));
	
	if((unsigned long)time == simu->nb_it)
	{
		while (((unsigned long)time == simu->nb_it) && (cond != EOF))
		{
			if(number == sim_neurons[i]->id)
			{
				sim_neurons[i]->new_state = SPIKE;
				break;
			}	
			cond = fscanf(v->fp_tms,"%f %d\n",&time, &number);
		
		}
			
	}
	if(sim_neurons[i]->new_state == SPIKE)
	{
		sim_neurons[i]->spike_time[sim_neurons[i]->queue] = simu->nb_it;
		sim_neurons[i]->queue = (sim_neurons[i]->queue + 1) % MAX_SPK;
		if (sim_neurons[i]->queue == sim_neurons[i]->tete)
			sim_neurons[i]->tete = (sim_neurons[i]->tete + 1) % MAX_SPK;
		
#if BUFFERIZE_AND_FLUSH
		sprintf(buffer,"%.3f %lu\n",simu->time_ms,sim_neurons[i]->id);
		tms_buffer = bufferize_and_flush(tms_buffer,buffer,&tms_buf_size,
						 strlen(buffer),&tms_tmpfp);
		tms_size += strlen(buffer);
#else
	if (simu->output_tms_f)
		fprintf(tms_fp,"%.3f %lu\n",simu->time_ms,sim_neurons[i]->id);
	if (simu->output_abe_f)
		fprintf(abe_fp,"F,%lu,%lu\n",  sim_neurons[i]->id, simu->nb_it - previous_event);
	previous_event = simu->nb_it;
#endif
	}  

	rewind(v->fp_tms);
	return;

}
