/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	THIS C SOURCE CODE FILE CONTAINS ALL THE CALLBACKS USED IN NBC 
	NETWORK EDITOR
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/ 


#ifndef _CALLBACKS_NETWORK_
#define _CALLBACKS_NETWORK_


#include <Xm/Xm.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

/* application globals include files */
#ifndef _GLOBAL_NETWORK_
#include "creation_network.h"
#endif

/* type definitions include files */
#ifndef _TYPESDEFINED_
#include "newtypes.h"
#endif

/* prototypes include files */
#ifndef _PROTOTYPES_
#include "prototypes.h"
#endif

/* dialog boxes include files */
#ifndef _MESSBOX_
#include "messbox.h"
#endif

#include "find_files.h"

/* ARGSUSED */
void
resize_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	int message = (int)(unsigned long)client;
	Nucleus_widget *nucleus_tmp;
	int i;
	
	switch(message)
	{
		
		case ID_DrawingA_net:
			XClearWindow(the_display,XtWindow(widget_array[ID_DrawingA_net]));
			for(i=0 ; i<current_network->nb_nucleus ; i++)
			{
				if(!current_network->nucleus_array)
					break;
				nucleus_tmp = current_network->nucleus_array[i];
				
				if(!nucleus_tmp)
					break;
					
				if(nucleus_tmp->form && XtIsManaged(nucleus_tmp->form))
					XClearWindow(the_display,XtWindow(nucleus_tmp->form));
			}
			break;
		
		case ID_DrawingA_nucleus_view:
			XClearWindow(the_display,XtWindow(widget_array[ID_DrawingA_nucleus_view]));
			break;		
		
		case ID_DrawingA_matrix:
			XClearWindow(the_display,XtWindow(widget_array[ID_DrawingA_matrix]));
			break;
		
		case ID_DrawingA_connection_curve:
		
		
			if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
				redraw_connection_curve();
			break;
	
		
		
		
		default:
			break;
	
	}
	
}
/* ARGSUSED */
void
popup_CB(w, item_no, call)
Widget w;
XtPointer  item_no;
XtPointer call;
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	int message = (int)(unsigned long)item_no;
	char labels[3][24]={"Frontal View Scale",
					  "Horizontal View Scale",
					  "Sagittal View Scale"};
	XmString string;
	
	switch(message)
	{
	
		case ID_ToggleB_popup_LHview:
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_popup_LHview]))	
			{
				redisplay_network();
    			force_scale(0);		
			}
			else if(XmToggleButtonGetState(widget_array[ID_ToggleB_popup_APHview]))	
			{	
				redisplay_network();
    			force_scale(2);		
			}
			break;
		case ID_ToggleB_popup_LAPview:
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_popup_LAPview]))	
			{	
				redisplay_network();
    			force_scale(1);		
			}
			break;
		case ID_ToggleB_popup_APHview:
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_popup_APHview]))	
			{	
				redisplay_network();
    			force_scale(2);		
			}
			break;
		case ID_PushB_popup_origin:
		
			redefine_origin();
			
			break;
		
		case ID_ToggleB_nucl_LHview:
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_nucl_LHview]))	
			{
				redisplay_nucleus();
    			force_nucleus_scale(0);		
			}
			else if(XmToggleButtonGetState(widget_array[ID_ToggleB_nucl_APHview]))	
			{	
				redisplay_nucleus();
    			force_nucleus_scale(2);		
			}
			break;
			
		case ID_ToggleB_nucl_LAPview:
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_nucl_LAPview]))	
			{	
				redisplay_nucleus();
    			force_nucleus_scale(1);		
			}
			break;
			
		case ID_ToggleB_nucl_APHview:
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_nucl_APHview]))	
			{	
				redisplay_nucleus();
    			force_nucleus_scale(2);		
			}
			break;
			
		case ID_PushB_nucl_origin:
		
			redefine_nucleus_origin();
			
			break;
				
		case ID_ToggleB_popup2_huge:
			network_scale[which_network_view()] = _HUGE;
			calculate_positions();
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_popup2_huge]))
				redisplay_network();
			break;	
		case ID_ToggleB_popup2_large:
			network_scale[which_network_view()] = LARGE;
			calculate_positions();
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_popup2_large]))
				redisplay_network();
			break;
		case ID_ToggleB_popup2_medium:
			network_scale[which_network_view()] = MEDIUM;
			calculate_positions();
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_popup2_medium]))
				redisplay_network();
			break;	
		case ID_ToggleB_popup2_small:
			network_scale[which_network_view()] = SMALL;
			calculate_positions();
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_popup2_small]))
				redisplay_network();
			break;
		case ID_ToggleB_popup2_tiny:
			network_scale[which_network_view()] = TINY;
			calculate_positions();
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_popup2_tiny]))
				redisplay_network();
			break;
		
		case ID_ToggleB_nucl_huge:
			nucleus_scale[which_nucleus_view()] = NUCLEUS_HUGE;
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_nucl_huge]))
				redisplay_nucleus();
			break;	
		case ID_ToggleB_nucl_large:
			nucleus_scale[which_nucleus_view()] = NUCLEUS_LARGE;
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_nucl_large]))
				redisplay_nucleus();
			break;
		case ID_ToggleB_nucl_medium:
			nucleus_scale[which_nucleus_view()] = NUCLEUS_MEDIUM;
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_nucl_medium]))
				redisplay_nucleus();
			break;	
		case ID_ToggleB_nucl_small:
			nucleus_scale[which_nucleus_view()] = NUCLEUS_SMALL;
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_nucl_small]))
				redisplay_nucleus();
			break;
		case ID_ToggleB_nucl_tiny:
			nucleus_scale[which_nucleus_view()] = NUCLEUS_TINY;
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_nucl_tiny]))
				redisplay_nucleus();
			break;
			
		default:
			break;
	
	}
	
	
}


/* ARGSUSED */
void
input_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XmDrawingAreaCallbackStruct *cbs=(XmDrawingAreaCallbackStruct*)call;
	int message = (int)(unsigned long)client;
	int pos_x,pos_y,pos_x2,pos_y2;
	static int X1,X2,Y1,Y2;
	
	
	
	switch(message)
	{
	
		case ID_DrawingA_net:
			if (cbs->event->xany.type == ButtonPress &&
        		cbs->event->xbutton.button == 3)
        	{
        		/* Position the menu where the event occurred */
    			XmMenuPosition(widget_array[ID_Popup_net],
    			 (XButtonPressedEvent *)(cbs->event));
    			XtManageChild(widget_array[ID_Popup_net]);
        	}
			break;
			
		case ID_DrawingA_nucleus_view:
			if (cbs->event->xany.type == ButtonPress &&
        		cbs->event->xbutton.button == 3)
        	{
        		/* Position the menu where the event occurred */
    			XmMenuPosition(widget_array[ID_Popup_nucleus],
    			 (XButtonPressedEvent *)(cbs->event));
    			XtManageChild(widget_array[ID_Popup_nucleus]);
        	}
			break;
		
		case ID_DrawingA_matrix:
			if (cbs->event->xany.type == ButtonPress)
        	{
        		pos_x = cbs->event->xbutton.x; 
        		pos_y = cbs->event->xbutton.y;
        		x_glb = X1 = pos_x / foot;
        		y_glb = Y1 = pos_y / foot;
        		XtAddEventHandler(widget_array[ID_DrawingA_matrix],ButtonMotionMask,
        			FALSE,select_rectangle,NULL);
        		
        	}
        	else if(cbs->event->xany.type == ButtonRelease)
        	{
        		pos_x = cbs->event->xbutton.x; 
        		pos_y = cbs->event->xbutton.y;
        		X2 = pos_x / foot;
        		Y2 = pos_y / foot;
        		modify_matrix(X1,Y1,X2,Y2);
        		XtRemoveEventHandler(widget_array[ID_DrawingA_matrix],
					XtAllEvents,True,(XtEventHandler)select_rectangle,NULL);
		
        		XClearWindow(the_display,XtWindow(widget_array[ID_DrawingA_matrix]));
    
        	}
        	
			break;
				
		default:
			break;
	
	}
	
	
}


/* ARGSUSED */
void
register_widget_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	int message = (int)(unsigned long)client;

	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	widget_array[message] = w;
	
}

/* ARGSUSED */
void
create_event_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	int message = (int)(unsigned long)client;
	
	switch(message)
	{
	
	case ID_PushB_net_file_new:
	case ID_PushB_net_file_open:
	case ID_PushB_net_file_save:
	case ID_PushB_net_file_save_as:
	case ID_PushB_net_file_exit:
	case ID_PushB_net_plot:
	
	case ID_PushB_net_nucleus_delete:
	case ID_PushB_net_nucleus_modify:
	case ID_PushB_net_neuron_copy:
	case ID_PushB_net_neuron_delete:
	case ID_PushB_net_neuron_modify:
	case ID_PushB_net_link_new:
	case ID_PushB_net_link_delete:
	case ID_PushB_net_link_modify:
	case ID_PushB_net_preferences:
	case ID_PushB_net_help_on_context:
	case ID_PushB_net_help_on_window:
	case ID_ToggleB_popup_LHview:
	case ID_ToggleB_popup_LAPview:
	case ID_ToggleB_popup_APHview:
	case ID_PushB_popup_origin:
	case ID_ToggleB_popup2_large:
	case ID_ToggleB_popup2_huge:
	case ID_ToggleB_popup2_medium:
	case ID_ToggleB_popup2_small:
	case ID_ToggleB_popup2_tiny:
	
		XtAddEventHandler(w,EnterWindowMask,FALSE,fill_label_net_info,
			(XtPointer)(unsigned long)message); 
		XtAddEventHandler(w,LeaveWindowMask,FALSE,clear_label_net_info,
			(XtPointer)(unsigned long)message);
		break;
		
	case ID_PushB_net_nucleus_new:	
	case ID_PushB_net_neuron_new:
		XtAddEventHandler(w,EnterWindowMask,FALSE,fill_label_net_info,
			(XtPointer)(unsigned long)message);
		break;
	case ID_DrawingA_net:
		XtAddEventHandler(w,PointerMotionMask,FALSE,fill_label_net_info,
			(XtPointer)(unsigned long)message); 		
		XtAddEventHandler(w,LeaveWindowMask,FALSE,clear_label_net_info,
			(XtPointer)(unsigned long)message);
		break;
	
	case ID_PushB_neuron_file_other:
		XtAddEventHandler(w,PointerMotionMask,FALSE,fill_label_net_info,
			(XtPointer)(unsigned long)message); 		
		XtAddEventHandler(w,LeaveWindowMask,FALSE,clear_label_net_info,
			(XtPointer)(unsigned long)message);
		XtAddEventHandler(w,ButtonPressMask,FALSE,select_neuron_type,
			(XtPointer)(unsigned long)message); 
		break;
		
	case ID_PushB_cluster_other_file:
	
		XtAddEventHandler(w,PointerMotionMask,FALSE,fill_label_nucl_info,
			(XtPointer)(unsigned long)message); 		
		XtAddEventHandler(w,LeaveWindowMask,FALSE,clear_label_nucl_info,
			(XtPointer)(unsigned long)message);
		XtAddEventHandler(w,ButtonPressMask,FALSE,select_neuron_type,
			(XtPointer)(unsigned long)message); 
		break;
		
	case ID_PushB_nucleus_file_new:
	case ID_FormD_Nucleus:
	case ID_PushB_nucleus_file_open:
	case ID_PushB_nucleus_file_save:
	case ID_PushB_nucleus_file_save_as:
	case ID_PushB_nucleus_plot:
	case ID_PushB_nucleus_exit:
	case ID_PushB_composition_add:
	case ID_PushB_composition_remove:
	case ID_PushB_composition_modify:
	case ID_PushB_generic_place_neurons:
	case ID_PushB_generic_create_il:
	case ID_PushB_generic_remove_il:
	case ID_PushB_generic_modify_il:
	case ID_PushB_neuron_in_nucleus_new:
	case ID_PushB_neuron_in_nucleus_dele:
	case ID_PushB_neuron_in_nucleus_modi:
	case ID_PushB_link_in_nucleus_new:
	case ID_PushB_link_in_nucleus_delete:
	case ID_PushB_link_in_nucleus_modify:
	case ID_PushB_nucleus_para_edit:
	case ID_PushB_options_nucleus_prefer:
	case ID_PushB_nucleus_help_context:
	case ID_PushB_nucleus_help_window:	
	case ID_PushBG_nucleus_ok:
	case ID_PushBG_nucleus_apply:
	case ID_PushBG_nucleus_cancel:
	case ID_PushBG_nucleus_help:
	case ID_ToggleB_nucl_large:
	case ID_ToggleB_nucl_huge:
	case ID_ToggleB_nucl_medium:
	case ID_ToggleB_nucl_small:
	case ID_ToggleB_nucl_tiny:
	case ID_ToggleB_nucl_LHview:
	case ID_ToggleB_nucl_LAPview:
	case ID_ToggleB_nucl_APHview:
	case ID_PushB_nucl_origin:
	
		XtAddEventHandler(w,EnterWindowMask,FALSE,fill_label_nucl_info,
			(XtPointer)(unsigned long)message); 
		XtAddEventHandler(w,LeaveWindowMask,FALSE,clear_label_nucl_info,
			(XtPointer)(unsigned long)message);
		break;
	
	case ID_DrawingA_nucleus_view:
	case ID_List_composition:
	
		XtAddEventHandler(w,PointerMotionMask,FALSE,fill_label_nucl_info,
			(XtPointer)(unsigned long)message); 		
		XtAddEventHandler(w,LeaveWindowMask,FALSE,clear_label_nucl_info,
			(XtPointer)(unsigned long)message);
		break;
	
	case ID_FormD_adjustement_curve:
		XtAddEventHandler(w,ResizeRedirectMask,FALSE,resize_curve,
			(XtPointer)(unsigned long)message);
		break;
		
	case ID_DrawingA_matrix:
		
		XtAddEventHandler(w,PointerMotionMask,FALSE,fill_label_matrix_info,
			(XtPointer)(unsigned long)message); 		
		XtAddEventHandler(w,LeaveWindowMask,FALSE,clear_label_matrix_info,
			(XtPointer)(unsigned long)message);
		break;	
	
	case ID_push_down:
	case ID_push_up:
	case ID_push_default:
	case ID_push_gauss:
	case ID_push_plus:
	case ID_push_minus:
	case ID_push_auto:
	case ID_PushBG_curve_ok:
	case ID_PushBG_curve_apply:
	case ID_PushBG_curve_cancel:
	case ID_PushBG_curve_help:
		XtAddEventHandler(w,EnterWindowMask,FALSE,fill_label_curve_info,
			(XtPointer)(unsigned long)message); 
		XtAddEventHandler(w,LeaveWindowMask,FALSE,clear_label_curve_info,
			(XtPointer)(unsigned long)message);
		break;
		
	default:
		break;
	
	}
}

/* ARGSUSED */
void
help_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{

	char def[255];
	char *topic;
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	int message = (int)(unsigned long)client;
	
	topic = NULL;
	switch(message)
	{
		
		case ID_PushB_nucleus_help_context:
		case ID_PushB_nucleus_help_window:
		case ID_PushBG_nucleus_help:
		case ID_PushBG_neuron_edit_help:
		case ID_PushB_matrix_help_on_context:
		case ID_PushB_matrix_help_version:
		case ID_PushBG_matrix_help:
		case ID_PushBG_link_simple_help:
		case ID_PushBG_curve_help:
		case ID_PushBG_composition_help:
		case ID_PushBG_nucleus_para_help:
		case ID_PushBG_generic_link_help:
		case ID_pushB_help:
			if(!XtIsManaged(widget_array[ID_help_form]))
				XtManageChild(widget_array[ID_help_form]);
			else
				XtPopup(XtParent(widget_array[ID_help_form]),XtGrabNone);
			XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_help_form])),
						the_colormap);
			break;
		case ID_PushB_net_help_on_context:
			browse_manual(XNBC_NETWORK_EDITOR);
			break;
		case ID_PushB_net_help_on_window:
			display_message(widget_array[ID_MainW_network],
"This Tool is the full network editor for XNBC8\nThis is only for research purpose.",
	"Help On Window");
			return;
			
			
		default:
			display_help(message);
			
			break;
	}
	
	
}

/* ARGSUSED */
void
net_activate_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	XmString string;
	Widget label_net_info = widget_array[ID_Label_net_information];
	int message = (int)(unsigned long)client;
	char buffer[255];
	
	switch(message)
	{
	case ID_PushB_nucleus_plot:
		if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_FormD_Nucleus],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_FormD_Nucleus],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}
		if(!(*current_network->name) || !current_network->nb_neurons)
		{
			display_error(widget_array[ID_FormD_Nucleus],
			"The current network is empty...","Nothing to Plot !");
			return;
		}
		sprintf(buffer,"%s/%s-%s.ps",project_directory,current_network->name,
			current_nucleus->nucleus_name);
		XmTextFieldRemove(widget_array[ID_textF_file]);
		XmTextFieldReplace(widget_array[ID_textF_file],0,
			XmTextFieldGetLastPosition(widget_array[ID_textF_file]),
				buffer);
				
		sprintf(buffer,"%s",default_queue);
		XmTextFieldRemove(widget_array[ID_textF_queue]);
		XmTextFieldReplace(widget_array[ID_textF_queue],0,
			XmTextFieldGetLastPosition(widget_array[ID_textF_queue]),
				buffer);	
				
		if(!XtIsManaged(widget_array[ID_form_plot]))
			XtManageChild(widget_array[ID_form_plot]);
		else
			XtPopup(XtParent(widget_array[ID_form_plot]),XtGrabNone);
			
		break;
		
	case ID_PushB_net_plot:
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}
		if(!(*current_network->name) || !current_network->nb_neurons)
		{
			display_error(widget_array[ID_MainW_network],
			"The current network is empty...","Nothing to Plot !");
			return;
		}
		sprintf(buffer,"%s/%s.ps",project_directory,current_network->name);
		XmTextFieldRemove(widget_array[ID_textF_file]);
		XmTextFieldReplace(widget_array[ID_textF_file],0,
			XmTextFieldGetLastPosition(widget_array[ID_textF_file]),
				buffer);
				
		sprintf(buffer,"%s",default_queue);
		XmTextFieldRemove(widget_array[ID_textF_queue]);
		XmTextFieldReplace(widget_array[ID_textF_queue],0,
			XmTextFieldGetLastPosition(widget_array[ID_textF_queue]),
				buffer);	
				
		if(!XtIsManaged(widget_array[ID_form_plot]))
			XtManageChild(widget_array[ID_form_plot]);
		else
			XtPopup(XtParent(widget_array[ID_form_plot]),XtGrabNone);
			
		break;
		
	case ID_pushB_plot_cancel:
		if(XtIsManaged(widget_array[ID_form_plot]))
			XtUnmanageChild(widget_array[ID_form_plot]);
		break;
		
	case ID_pushB_plot_ok:
		if(apply_plot())
			return;
		sprintf(buffer,"Plottings saved in %s\nand spooled to %s.",
			default_ps_file,default_queue);
		if(XtIsManaged(widget_array[ID_form_plot]))
			XtUnmanageChild(widget_array[ID_form_plot]);
		display_message(widget_array[ID_form_plot],buffer,"Done...");
			
		break;
		
	case ID_PushB_net_file_new:
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}
		clear_network();
		break;
	case ID_PushB_net_file_open:
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}
		open_network();
		break;
	case ID_PushB_net_file_save:
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}
		save_network(False);
		break;
	case ID_PushB_net_file_save_as:
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}
		save_network(True);
		break;
	case ID_PushB_net_nucleus_new:
		
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}	
		
		string = XmStringCreateLocalized(
		"Click where the new nucleus should be in the Frontal view...");
		XtVaSetValues(label_net_info,XmNlabelString,string,NULL);
		XmStringFree(string);
		
		creating = True;
		
		new_nucleus();
		
		break;
		

		
	case ID_PushB_net_nucleus_delete:
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}
		
		delete_nucleus();
		
		redisplay_network();
		
		break;
	case ID_PushB_net_nucleus_modify:
			
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}	
		modify_nucleus();
		
		break;
		
	case ID_PushB_net_neuron_new:
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}	
		string = XmStringCreateLocalized(
		"Click where the new neuron should be in the Frontal view...");
		XtVaSetValues(label_net_info,XmNlabelString,string,NULL);
		XmStringFree(string);
	
		creating = True;
			
		new_neuron();
			
		break;
	
	case ID_PushB_net_neuron_copy:
		
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}	
			
		copy_neuron();
		
		break;
		
	case ID_PushB_net_neuron_delete:
		
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}	
		
		delete_neuron();
		redisplay_network();
		
		break;
		
	case ID_PushB_net_neuron_modify:
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}	
		modify_neuron();
		
		break;
		
	case ID_PushB_net_link_new:
	
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}	
		
		if(!current_nucleus || !previous_selected_nucleus)
		{
			display_error(widget_array[ID_MainW_network],
			"Please select two nucleus to link first...","Can't do that !");
			return;
		}
		else if((current_nucleus->nb_neurons != 1) ||
			(previous_selected_nucleus->nb_neurons != 1))
		{
			
			if(!(current_link = alloc_new_link_net()))
			{
				display_error(widget_array[ID_MainW_network],
				"Sorry, this link already exists...","Nothing to create!");
				return;
			}
			
			changed = True;
			
			sprintf(buffer,"Generic Link Editor: %s to %s",
				previous_selected_nucleus->nucleus_name,
				current_nucleus->nucleus_name);
			XtVaSetValues(XtParent(widget_array[ID_FormD_generic_link_edit]),
				XmNtitle,buffer,NULL);
			
			XmTextRemove(widget_array[ID_Text_axone_mean]);
			sprintf(buffer,"%f",current_link->axone_mean);
			XmTextReplace(widget_array[ID_Text_axone_mean],0,
			XmTextGetLastPosition(widget_array[ID_Text_axone_mean]),
				buffer);
				
			XmTextRemove(widget_array[ID_Text_axone_deviation]);
			sprintf(buffer,"%f",current_link->axone_sd);
			XmTextReplace(widget_array[ID_Text_axone_deviation],0,
			XmTextGetLastPosition(widget_array[ID_Text_axone_deviation]),
				buffer);
				
			XmTextRemove(widget_array[ID_Text_max_knobs]);
			sprintf(buffer,"%d",current_link->max_knobs);
			XmTextReplace(widget_array[ID_Text_max_knobs],0,
			XmTextGetLastPosition(widget_array[ID_Text_max_knobs]),
				buffer);
				
			XmTextRemove(widget_array[ID_Text_min_knobs]);
			sprintf(buffer,"%d",current_link->min_knobs);
			XmTextReplace(widget_array[ID_Text_min_knobs],0,
			XmTextGetLastPosition(widget_array[ID_Text_min_knobs]),
				buffer);
			
			XmToggleButtonSetState(widget_array[ID_ToggleB_NMDA],
				(current_link->nmda ? True : False),True);
			
			switch(current_link->type)
			{
				case _FULL_EXCITATION_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_fully_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_all_excit],
						True,True);	
					break;
				
				case _FULL_INHIBITION_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_fully_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_all_inhib],
						True,True);
					break;
				
				case _FULL_RANDOMIZED_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_fully_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_random],
						True,True);
					break;
				
				case _PART_EXCITATION_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_partially_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_all_excit],
						True,True);
					break;
				
				case _PART_INHIBITION_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_partially_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_all_inhib],
						True,True);
					break;
				
				case _PART_RANDOMIZED_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_partially_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_random],
						True,True);
					break;
				
				default:
					break;
			}
			
			if(!XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{
				XtManageChild(widget_array[ID_FormD_generic_link_edit]);
				XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_generic_link_edit])),
						the_colormap);
			}
			else
				XtPopup(XtParent(widget_array[ID_FormD_generic_link_edit]),
					XtGrabNone);
		
		}
		else
		{
		
			if(!(current_link = alloc_new_link_net()))
			{
				display_error(widget_array[ID_MainW_network],
				"Sorry, this link already exists...","Nothing to create!");
				return;
			}
			
			sprintf(buffer,"Single Link Editor: %s to %s",
				previous_selected_nucleus->nucleus_name,
				current_nucleus->nucleus_name);
			XtVaSetValues(XtParent(widget_array[ID_FormD_link_simple]),
				XmNtitle,buffer,NULL);
				
			XmTextFieldRemove(widget_array[ID_TextF_axone_length]);
			sprintf(buffer,"%f",current_link->axone_mean);
			XmTextFieldReplace(widget_array[ID_TextF_axone_length],0,
			XmTextFieldGetLastPosition(widget_array[ID_TextF_axone_length]),
				buffer);
				
			XmTextFieldRemove(widget_array[ID_TextF_synaptic_knobs]);
			sprintf(buffer,"%d",current_link->max_knobs);
			XmTextFieldReplace(widget_array[ID_TextF_synaptic_knobs],0,
			XmTextFieldGetLastPosition(widget_array[ID_TextF_synaptic_knobs]),
				buffer);
		
			XmToggleButtonSetState(widget_array[ID_ToggleB_link_simple_NMDA],
				(current_link->nmda ? True : False),True);
			
			switch(current_link->type)
			{
				case _PART_EXCITATION_:
				case _FULL_EXCITATION_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_dialog_excit],
						True,True);
					
					break;
				
				case _FULL_INHIBITION_:
				case _PART_INHIBITION_:
					(widget_array[ID_ToggleB_dialog_inhib],
						True,True);
					break;
					
				default:
					break;
			}	
			if(!XtIsManaged(widget_array[ID_FormD_link_simple]))
			{
				XtManageChild(widget_array[ID_FormD_link_simple]);
				XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_link_simple])),
						the_colormap);
			}
			else
				XtPopup(XtParent(widget_array[ID_FormD_link_simple]),
					XtGrabNone);
					
		}
		
		creating = True;
		
		break;
		
	case ID_PushB_net_link_delete:
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}	
		if(!current_nucleus || !previous_selected_nucleus)
		{
			display_error(widget_array[ID_MainW_network],
			"Please select two nucleus to link first...","Can't do that");
			return;
		}
		current_link = search_link(previous_selected_nucleus->nucleus_id,
			current_nucleus->nucleus_id,_NETWORK_);
		
		if(!current_link)
		{
			display_error(widget_array[ID_MainW_network],
			"Sorry, this link doesn't exists...",
		"No Link to Delete !");
			return;
		}
		
		sprintf(buffer,"Do you really want to delete the link\n from %s to %s ?",
			previous_selected_nucleus->nucleus_name,current_nucleus->nucleus_name);
		if(display_question(widget_array[ID_MainW_network],
	buffer,"Confirmation needed...") == NO_ANSWER)
			return;
			
		delete_link(&current_link);
		
		redisplay_network();
		
		break;
		
	case ID_PushB_net_link_modify:
		if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous nucleus edition first...","Can't do that !");
			return;
		}
		else if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the previous neuron edition first...","Can't do that !");
			return;
		}
		else if	(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
		{	
			display_error(widget_array[ID_MainW_network],
			"Please finish the current link edition first...","Can't do that !");
			return;
		}	
		if(!current_nucleus || !previous_selected_nucleus)
		{
			display_error(widget_array[ID_MainW_network],
			"Please select two nucleus to link first...","Can't do that !");
			return;
		}
		modify_link(previous_selected_nucleus->nucleus_id,
				current_nucleus->nucleus_id,_NETWORK_);
		break;
		
	case ID_PushB_net_preferences:
		
		initialize_customizations(_NETWORK_);
		if(!XtIsManaged(widget_array[ID_form_custom]))
			XtManageChild(widget_array[ID_form_custom]);	
		break;
		
	case ID_arrowButton_on:
	case ID_arrowButton_off:
		update_customizations(message);
		break;	
	
	case ID_PushB_net_file_exit:
		if(display_question(widget_array[ID_MainW_network],
	"Do You really want to quit ?","Confirmation needed...") == YES_ANSWER)
			exit_network(w,client,call);
		break;
		
	case ID_PushB_net_save_options:	
	case ID_PushB_nucl_save_options:
		save_customizations();
		break;
	default:
		break;
	}
	
}

/* ARGSUSED */
void
nucl_activate_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	int message = (int)(unsigned long)client;
	int pos;
	XmString string;
	char buffer[255];
	int width,height;
	char *neuron_file;
	char mask[10];
	char *name;
	char *text;
	int n,nb_items;
	int *positions;
	int nb_neurons;
	XmString *all_items;
	Widget label_info = widget_array[ID_Label_nucleus_information];
	NEURON *neuron_tmp;
	
	
	switch(message)
	{
		
		case ID_PushB_options_nucleus_prefer:
			initialize_customizations(_NUCLEUS_);
			if(!XtIsManaged(widget_array[ID_form_custom]))
				XtManageChild(widget_array[ID_form_custom]);	
			break;
			
		
		case ID_pushB_ok:
			if(apply_placement())
				break;
			if(XtIsManaged(widget_array[ID_n_p_generator_form]));
				XtUnmanageChild(widget_array[ID_n_p_generator_form]);
			break;
		case ID_pushB_apply:
			if(apply_placement())
				break;
			
			break;
		
		case ID_pushB_cancel:
			if(XtIsManaged(widget_array[ID_n_p_generator_form]));
				XtUnmanageChild(widget_array[ID_n_p_generator_form]);
			break;
			
		case ID_PushB_link_in_nucleus_delete:
			
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			if(!current_neuron || !previous_selected_neuron)
			{
				display_error(widget_array[ID_FormD_Nucleus],
				"Please select two neurons to link first...","Can't do that !");
				return;
			}
			if(!search_connection(previous_selected_neuron->neuron_id,
			current_neuron->neuron_id,&pos))
			{
				display_error(widget_array[ID_FormD_Nucleus],
				"This connection doesn't exist...","No Link to Delete !");
				return;
			}
			previous_selected_neuron->connections[pos].target_id = 0;
			previous_selected_neuron->connections = 
				refresh_connections(previous_selected_neuron);
			redisplay_nucleus();
			break;
		
		case ID_PushB_link_in_nucleus_new:
			
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			if(!current_neuron || !previous_selected_neuron)
			{
				display_error(widget_array[ID_FormD_Nucleus],
				"Please select two neurons to link first...","Can't do that");
				return;
			}
			if(search_connection(previous_selected_neuron->neuron_id,
			current_neuron->neuron_id,&pos))
			{
				display_error(widget_array[ID_FormD_Nucleus],
				"This connection already exists...","No Link to Create !");
				return;
			}
			previous_selected_neuron->connections =
				 add_new_connection(previous_selected_neuron->neuron_id,
				 	current_neuron->neuron_id,&pos);
			
			if(!current_link)
			{
				current_link = alloc_new_link_net();
				current_link->source = previous_selected_neuron;
				previous_selected_neuron->extremity = True;
				current_link->target = current_neuron;
				current_neuron->extremity = True;
				current_link->type = _PART_RANDOMIZED_;
				current_nucleus->color = green;
			}
			modify_link(previous_selected_neuron->neuron_id,
					current_neuron->neuron_id,_NUCLEUS_);		
			break;
			
		case ID_PushB_link_in_nucleus_modify:
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			if(!current_neuron || !previous_selected_neuron)
			{
				display_error(widget_array[ID_FormD_Nucleus],
				"Please select two neurons to link first...","Can't do that !");
				return;
			}
			changed = False;
			modify_link(previous_selected_neuron->neuron_id,
					current_neuron->neuron_id,_NUCLEUS_);
			break;
		
		case ID_PushB_generic_create_il:
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			if(!(current_link = alloc_new_link_net()))
			{
				display_error(widget_array[ID_FormD_Nucleus],
				"Sorry, this link already exists...","Nothing to create!");
				return;
			}
			
			changed = True;
			
			sprintf(buffer,"Generic Link Editor: %s to %s",
				previous_selected_nucleus->nucleus_name,
				current_nucleus->nucleus_name);
			XtVaSetValues(XtParent(widget_array[ID_FormD_generic_link_edit]),
				XmNtitle,buffer,NULL);
			
			XmTextRemove(widget_array[ID_Text_axone_mean]);
			sprintf(buffer,"%f",current_link->axone_mean);
			XmTextReplace(widget_array[ID_Text_axone_mean],0,
			XmTextGetLastPosition(widget_array[ID_Text_axone_mean]),
				buffer);
				
			XmTextRemove(widget_array[ID_Text_axone_deviation]);
			sprintf(buffer,"%f",current_link->axone_sd);
			XmTextReplace(widget_array[ID_Text_axone_deviation],0,
			XmTextGetLastPosition(widget_array[ID_Text_axone_deviation]),
				buffer);
				
			XmTextRemove(widget_array[ID_Text_max_knobs]);
			sprintf(buffer,"%d",current_link->max_knobs);
			XmTextReplace(widget_array[ID_Text_max_knobs],0,
			XmTextGetLastPosition(widget_array[ID_Text_max_knobs]),
				buffer);
				
			XmTextRemove(widget_array[ID_Text_min_knobs]);
			sprintf(buffer,"%d",current_link->min_knobs);
			XmTextReplace(widget_array[ID_Text_min_knobs],0,
			XmTextGetLastPosition(widget_array[ID_Text_min_knobs]),
				buffer);
			
			XmToggleButtonSetState(widget_array[ID_ToggleB_NMDA],
				(current_link->nmda ? True : False),True);
			
			switch(current_link->type)
			{
				case _FULL_EXCITATION_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_fully_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_all_excit],
						True,True);	
					break;
				
				case _FULL_INHIBITION_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_fully_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_all_inhib],
						True,True);
					break;
				
				case _FULL_RANDOMIZED_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_fully_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_random],
						True,True);
					break;
				
				case _PART_EXCITATION_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_partially_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_all_excit],
						True,True);
					break;
				
				case _PART_INHIBITION_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_partially_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_all_inhib],
						True,True);
					break;
				
				case _PART_RANDOMIZED_:
					XmToggleButtonSetState(widget_array[ID_ToggleB_partially_connected],
						True,True);
					XmToggleButtonSetState(widget_array[ID_ToggleB_algo_random],
						True,True);
					break;
				
				default:
					break;
			}
			
			if(!XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{
				XtManageChild(widget_array[ID_FormD_generic_link_edit]);
				XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_generic_link_edit])),
						the_colormap);
			}
			else
				XtPopup(XtParent(widget_array[ID_FormD_generic_link_edit]),
					XtGrabNone);
					
			break;
		
		
		case ID_PushB_generic_remove_il:
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			if(!current_nucleus || !previous_selected_nucleus)
			{
				display_error(widget_array[ID_FormD_Nucleus],
				"Please select two neurons to link first...","Can't do that !");
				return;
			}
			current_link = search_link(previous_selected_nucleus->nucleus_id,
				current_nucleus->nucleus_id,_NETWORK_);
			
			if(!current_link)
			{
				display_error(widget_array[ID_FormD_Nucleus],
				"Sorry, this link doesn't exists...",
			"No Link to Remove !");
				return;
			}
			
			sprintf(buffer,"Do you really want to delete the link\n from %s to %s ?",
				previous_selected_nucleus->nucleus_name,current_nucleus->nucleus_name);
			if(display_question(widget_array[ID_FormD_Nucleus],
		buffer,"Confirmation needed...") == NO_ANSWER)
				return;
				
			delete_link(&current_link);
			current_link = NULL;
			
			redisplay_network();
			redisplay_nucleus();
			
			break;
			
		case ID_PushB_generic_modify_il:
			
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			if(!current_nucleus || !previous_selected_nucleus)
			{
				display_error(widget_array[ID_FormD_Nucleus],
				"Please select two neurons to link first...","Can't do that !");
				return;
			}
			changed = False;
			modify_link(previous_selected_nucleus->nucleus_id,
					current_nucleus->nucleus_id,_NETWORK_);
			break;
			
		case ID_PushB_neuron_in_nucleus_new:
			
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			
			string = XmStringCreateLocalized(
		"Click where the new neuron should be in the Frontal view...");
			XtVaSetValues(label_info,XmNlabelString,string,NULL);
			XmStringFree(string);	
		
			creating = True;
			
			new_neuron_in_nucleus();
			
			break;
		
		case ID_PushB_neuron_in_nucleus_modi:
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			
			modify_neuron_in_nucleus();
			break;
		
		case ID_PushB_neuron_in_nucleus_dele:
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			
			delete_neuron_in_nucleus();
			redisplay_nucleus();
			break;
		
			
		case ID_PushBG_nucleus_para_ok:
			if(apply_nucleus())
				break;
			
			current_link = search_link(current_nucleus->nucleus_id,
				current_nucleus->nucleus_id,_NETWORK_);
			
			if(XtIsManaged(widget_array[ID_FormD_nucleus_parameters]))
				XtUnmanageChild(widget_array[ID_FormD_nucleus_parameters]);
			enable_net_menu(True);
			XtAddEventHandler(current_nucleus->form,ButtonPressMask,False,
				(XtEventHandler)select_nucleus,current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,ButtonReleaseMask,False,
				(XtEventHandler)release_nucleus,current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,ButtonMotionMask,False,
				(XtEventHandler)chplace_nucleus,current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,ButtonMotionMask,False,
				(XtEventHandler)info_nucleus,current_nucleus->nucleus_id);	
			XtAddEventHandler(current_nucleus->form,EnterWindowMask,False,
				(XtEventHandler)info_nucleus,current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,LeaveWindowMask,False,
				(XtEventHandler)clear_label_net_info,
				current_nucleus->nucleus_id);
			
			redisplay_network();
			
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
			
				XtManageChild(widget_array[ID_FormD_Nucleus]);
				XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_Nucleus])),
					the_colormap);
			}
			redisplay_nucleus();			
			refresh_composition();
			
			break;
	
		case ID_PushBG_nucleus_para_apply:
			if(apply_nucleus())
				break;
			creating = False;
			
			current_link = search_link(current_nucleus->nucleus_id,
				current_nucleus->nucleus_id,_NETWORK_);
			
			redisplay_network();
			
			XtAddEventHandler(current_nucleus->form,ButtonPressMask,False,
				(XtEventHandler)select_nucleus,current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,ButtonReleaseMask,False,
				(XtEventHandler)release_nucleus,current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,ButtonMotionMask,False,
				(XtEventHandler)chplace_nucleus,current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,ButtonMotionMask,False,
				(XtEventHandler)info_nucleus,current_nucleus->nucleus_id);	
			XtAddEventHandler(current_nucleus->form,EnterWindowMask,False,
				(XtEventHandler)info_nucleus,current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,LeaveWindowMask,False,
				(XtEventHandler)clear_label_net_info,
				current_nucleus->nucleus_id);
				
			
			
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				XtManageChild(widget_array[ID_FormD_Nucleus]);
				XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_Nucleus])),
					the_colormap);
			}
			
			/* setting the nucleus drawing area its size and create the 
				corresponding pixmap */
			width = current_nucleus->work_width[which_nucleus_view()];
			height = current_nucleus->work_height[which_nucleus_view()];
			
			if(!nucleus_pixmap)
			{
				nucleus_pixmap = XCreatePixmap(the_display,
					XtWindow(widget_array[ID_DrawingA_nucleus_view]),
					width,height,
					DefaultDepth(the_display,DefaultScreen (the_display)));	
			}
			
			XtVaSetValues(widget_array[ID_DrawingA_nucleus_view],
				XmNwidth,width,XmNheight,height,NULL);
			
			XSetForeground(the_display,the_GC,white);
			XSetBackground(the_display,the_GC,black);
			XFillRectangle(the_display,nucleus_pixmap,the_GC,0,0,width,height);
			XtVaSetValues(widget_array[ID_DrawingA_nucleus_view],
				XmNbackgroundPixmap,nucleus_pixmap,NULL);	
			
			draw_nucleus_axes();
			
			XClearWindow(the_display,
				XtWindow(widget_array[ID_DrawingA_nucleus_view]));	
			
			refresh_composition();
			redisplay_nucleus();
				
			break;
			
		case ID_PushBG_nucleus_para_cancel:
			
			if(XtIsManaged(widget_array[ID_FormD_nucleus_parameters]))
				XtUnmanageChild(widget_array[ID_FormD_nucleus_parameters]);
			
			current_link = search_link(current_nucleus->nucleus_id,
				current_nucleus->nucleus_id,_NETWORK_);	
			
			if(creating)
			{
				delete_nucleus();
				creating = False;
				break;
			}
			
			enable_net_menu(True);
			XtAddEventHandler(current_nucleus->form,ButtonPressMask,False,
				(XtEventHandler)select_nucleus,(XtPointer)current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,ButtonReleaseMask,False,
				(XtEventHandler)release_nucleus,(XtPointer)current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,ButtonMotionMask,False,
				(XtEventHandler)chplace_nucleus,(XtPointer)current_nucleus->nucleus_id);	
			XtAddEventHandler(current_nucleus->form,ButtonMotionMask,False,
				(XtEventHandler)info_nucleus,current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,EnterWindowMask,False,
				(XtEventHandler)info_nucleus,(XtPointer)current_nucleus->nucleus_id);
			XtAddEventHandler(current_nucleus->form,LeaveWindowMask,False,
				(XtEventHandler)clear_label_net_info,
				(XtPointer)current_nucleus->nucleus_id);
			
			redisplay_network();
			
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus])
				&& (current_nucleus->nb_neurons==0))
			{
				pos = current_nucleus->number;
	
				if(XtIsManaged(current_nucleus->form))
						XtUnmanageChild(current_nucleus->form);
						
				XClearWindow(the_display,XtWindow(widget_array[ID_DrawingA_net]));
				
				if(pos == current_network->nb_nucleus)
				{
					current_network->nb_neurons -= 
						current_network->nucleus_array[pos-1]->nb_neurons;
					destroy_nucleus(pos);
					current_network->nb_nucleus--;
					if(!current_network->nb_nucleus)
					{
						free(current_network->nucleus_array);
						current_network->nucleus_array = NULL;
						enable_net_menu(False);						
					}
					
					return;
				}
				else
				{
					current_network->nb_neurons -= 
						current_network->nucleus_array[pos-1]->nb_neurons;
					
					destroy_nucleus(pos);
					
					current_network->
						nucleus_array[current_network->nb_nucleus-1]->number = pos;
				
					current_network->nucleus_array[pos-1] = 
						current_network->nucleus_array[current_network->nb_nucleus-1];
					
					current_network->nucleus_array[current_network->nb_nucleus-1] = NULL;
				
					current_network->nb_nucleus--;
					
					
				}	
			}
			else if(XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				refresh_composition();
				redisplay_nucleus();
			}
				
			break;
			
		case ID_PushBG_nucleus_cancel:
		case ID_PushB_nucleus_exit:
			if(display_question(widget_array[ID_FormD_Nucleus],
	"Do you really want to quit the nucleus editor ?",
	"Confirmation needed...") == NO_ANSWER)
				break;
			else if(current_nucleus->nb_neurons==0)
			{
				pos = current_nucleus->number;
						
				XClearWindow(the_display,XtWindow(widget_array[ID_DrawingA_net]));
				
				if(pos == current_network->nb_nucleus)
				{
					XtUnmanageChild(widget_array[ID_FormD_Nucleus]);
					clear_nucleus_view();
					if(current_nucleus->selected == True)
						select_nucleus(current_nucleus->form,
							current_nucleus->nucleus_id,NULL);
					current_network->nb_neurons -= 
						current_network->nucleus_array[pos-1]->nb_neurons;
					destroy_nucleus(pos);
					current_network->nb_nucleus--;
					if(!current_network->nb_nucleus)
					{
						free(current_network->nucleus_array);
						current_network->nucleus_array = NULL;
						enable_net_menu(False);
						
					}
					if(XtIsManaged(widget_array[ID_FormD_nucleus_parameters]))
						XtUnmanageChild(widget_array[ID_FormD_nucleus_parameters]);
					if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
						XtUnmanageChild(widget_array[ID_FormD_nucleus_composition]);
					if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
						XtUnmanageChild(widget_array[ID_FormD_generic_link_matrix]);
					if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
						XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);
					if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
					{
						XtUnmanageChild(widget_array[ID_FormD_generic_link_edit]);
						if(current_link)
							update_link_type(&current_link);
					}
					if(XtIsManaged(widget_array[ID_n_p_generator_form]))
						XtUnmanageChild(widget_array[ID_n_p_generator_form]);
					
					XmListDeleteAllItems(widget_array[ID_List_composition]);
					
					current_link = NULL;
					return;
				}
				else
				{
					XtUnmanageChild(widget_array[ID_FormD_Nucleus]);
					clear_nucleus_view();
					if(current_nucleus->selected == True)
						select_nucleus(current_nucleus->form,
							current_nucleus->nucleus_id,NULL);
					current_network->nb_neurons -= 
						current_network->nucleus_array[pos-1]->nb_neurons;
					
					destroy_nucleus(pos);
					
					current_network->
						nucleus_array[current_network->nb_nucleus-1]->number = pos;
				
					current_network->nucleus_array[pos-1] = 
						current_network->nucleus_array[current_network->nb_nucleus-1];
					
					current_network->nucleus_array[current_network->nb_nucleus-1] = NULL;
				
					current_network->nb_nucleus--;
					
					if(XtIsManaged(widget_array[ID_FormD_nucleus_parameters]))
						XtUnmanageChild(widget_array[ID_FormD_nucleus_parameters]);
					if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
						XtUnmanageChild(widget_array[ID_FormD_nucleus_composition]);
					if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
						XtUnmanageChild(widget_array[ID_FormD_generic_link_matrix]);
					if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
						XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);
					if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
					{
						XtUnmanageChild(widget_array[ID_FormD_generic_link_edit]);
						
						if(current_link)
							update_link_type(&current_link);
					}
					if(XtIsManaged(widget_array[ID_n_p_generator_form]))
						XtUnmanageChild(widget_array[ID_n_p_generator_form]);
					
					
					XmListDeleteAllItems(widget_array[ID_List_composition]);
					
					current_link = NULL;
				}
			}
			else
			{
				XtUnmanageChild(widget_array[ID_FormD_Nucleus]);
				clear_nucleus_view();
				select_nucleus(current_nucleus->form,current_nucleus->nucleus_id,NULL);
				
				
				if(XtIsManaged(widget_array[ID_FormD_nucleus_parameters]))
					XtUnmanageChild(widget_array[ID_FormD_nucleus_parameters]);
				if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
					XtUnmanageChild(widget_array[ID_FormD_nucleus_composition]);
				if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
					XtUnmanageChild(widget_array[ID_FormD_generic_link_matrix]);
				if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
					XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);
				if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
				{
					XtUnmanageChild(widget_array[ID_FormD_generic_link_edit]);
					
					if(current_link)
							update_link_type(&current_link);	
				}
				if(XtIsManaged(widget_array[ID_n_p_generator_form]))
						XtUnmanageChild(widget_array[ID_n_p_generator_form]);
					
			
				XmListDeleteAllItems(widget_array[ID_List_composition]);
			
				current_link = NULL;		
			}
			
			break;
		
		case ID_PushBG_nucleus_apply:
			if(XtIsManaged(widget_array[ID_FormD_nucleus_parameters]))
				nucl_activate_CB(w,ID_PushB_nucleus_para_edit,NULL);
			else
			{
				update_center();
				update_radius();
			}
			creating = False;
			generic_place_neurons(False);
			refresh_composition();
			redisplay_nucleus();
			if(current_nucleus->nb_neurons>1)
				redisplay_network();
			break;	
		
		case ID_PushB_generic_place_neurons:
			
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			
			XmTextFieldRemove(widget_array[ID_textF_L_radius]);
			sprintf(buffer,"%.2f",current_nucleus->delta_L);
			XmTextFieldReplace(widget_array[ID_textF_L_radius],0,
				XmTextGetLastPosition(widget_array[ID_textF_L_radius]),
				buffer);
			
			XmTextFieldRemove(widget_array[ID_textF_H_radius]);
			sprintf(buffer,"%.2f",current_nucleus->delta_H);
			XmTextFieldReplace(widget_array[ID_textF_H_radius],0,
				XmTextGetLastPosition(widget_array[ID_textF_H_radius]),
				buffer);
				
			XmTextFieldRemove(widget_array[ID_textF_AP_radius]);
			sprintf(buffer,"%.2f",current_nucleus->delta_AP);
			XmTextFieldReplace(widget_array[ID_textF_AP_radius],0,
				XmTextGetLastPosition(widget_array[ID_textF_AP_radius]),
				buffer);	
				
			if(!XtIsManaged(widget_array[ID_n_p_generator_form]))
				XtManageChild(widget_array[ID_n_p_generator_form]);
			else
				XtPopup(XtParent(widget_array[ID_n_p_generator_form]),XtGrabNone);
			XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_n_p_generator_form])),
						the_colormap);
			generic_place_neurons(False);
			refresh_composition();
			redisplay_nucleus();
			break;
		
		case ID_PushBG_nucleus_ok:
			creating = False;
			update_center();
			update_radius();
			redisplay_nucleus();
			if(current_nucleus->nb_neurons>1)
				redisplay_network();
			if(current_nucleus->nb_neurons==0)
			{
				pos = current_nucleus->number;
	
						
				XClearWindow(the_display,XtWindow(widget_array[ID_DrawingA_net]));
				
				if(pos == current_network->nb_nucleus)
				{	
					
					XtUnmanageChild(widget_array[ID_FormD_Nucleus]);
					clear_nucleus_view();
					if(current_nucleus->selected == True)
						select_nucleus(current_nucleus->form,
							current_nucleus->nucleus_id,NULL);
					current_network->nb_neurons -= 
						current_network->nucleus_array[pos-1]->nb_neurons;
					destroy_nucleus(pos);
					current_network->nb_nucleus--;
					if(!current_network->nb_nucleus)
					{
						free(current_network->nucleus_array);
						current_network->nucleus_array = NULL;
						enable_net_menu(False);
						
					}
					if(XtIsManaged(widget_array[ID_FormD_nucleus_parameters]))
						XtUnmanageChild(widget_array[ID_FormD_nucleus_parameters]);
					if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
						XtUnmanageChild(widget_array[ID_FormD_nucleus_composition]);
					if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
						XtUnmanageChild(widget_array[ID_FormD_generic_link_matrix]);
					if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
						XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);
					if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
					{
						XtUnmanageChild(widget_array[ID_FormD_generic_link_edit]);
						
						if(current_link)
							update_link_type(&current_link);	
					}
					if(XtIsManaged(widget_array[ID_n_p_generator_form]))
						XtUnmanageChild(widget_array[ID_n_p_generator_form]);
					
				
					XmListDeleteAllItems(widget_array[ID_List_composition]);
					
					current_link = NULL;
					return;
				}
				else
				{
					XtUnmanageChild(widget_array[ID_FormD_Nucleus]);
					clear_nucleus_view();
					if(current_nucleus->selected == True)
						select_nucleus(current_nucleus->form,
							current_nucleus->nucleus_id,NULL);
					current_network->nb_neurons -= 
						current_network->nucleus_array[pos-1]->nb_neurons;
					
					destroy_nucleus(pos);
					
					current_network->
						nucleus_array[current_network->nb_nucleus-1]->number = pos;
				
					current_network->nucleus_array[pos-1] = 
						current_network->nucleus_array[current_network->nb_nucleus-1];
					
					current_network->nucleus_array[current_network->nb_nucleus-1] = NULL;
				
					current_network->nb_nucleus--;
			
					if(XtIsManaged(widget_array[ID_FormD_nucleus_parameters]))
						XtUnmanageChild(widget_array[ID_FormD_nucleus_parameters]);
					if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
						XtUnmanageChild(widget_array[ID_FormD_nucleus_composition]);
					if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
						XtUnmanageChild(widget_array[ID_FormD_generic_link_matrix]);
					if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
						XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);
					if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
					{
						XtUnmanageChild(widget_array[ID_FormD_generic_link_edit]);
						
						if(current_link)
							update_link_type(&current_link);
					}
					if(XtIsManaged(widget_array[ID_n_p_generator_form]))
						XtUnmanageChild(widget_array[ID_n_p_generator_form]);
					
					XmListDeleteAllItems(widget_array[ID_List_composition]);

					current_link = NULL;
				}
			}
			else if(current_nucleus->nb_neurons<2)
			{
				display_message(widget_array[ID_FormD_Nucleus],
"Please note that a nucleus has 2 neurons minimum...",
"Message");	
				return;
			}
			else
			{	
				XtUnmanageChild(widget_array[ID_FormD_Nucleus]);
				clear_nucleus_view();	
				select_nucleus(current_nucleus->form,current_nucleus->nucleus_id,NULL);
					
				
				if(XtIsManaged(widget_array[ID_FormD_nucleus_parameters]))
					XtUnmanageChild(widget_array[ID_FormD_nucleus_parameters]);
				if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
					XtUnmanageChild(widget_array[ID_FormD_nucleus_composition]);
				if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
					XtUnmanageChild(widget_array[ID_FormD_generic_link_matrix]);
				if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
					XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);
				if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
				{
					XtUnmanageChild(widget_array[ID_FormD_generic_link_edit]);
					
					if(current_link)
							update_link_type(&current_link);	
				}
				if(XtIsManaged(widget_array[ID_n_p_generator_form]))
						XtUnmanageChild(widget_array[ID_n_p_generator_form]);
				
				XmListDeleteAllItems(widget_array[ID_List_composition]);
					
				current_link = NULL;
		
			}
			break;
			
		
		case ID_PushB_nucleus_para_edit:
			update_center();
			update_radius();
			redisplay_nucleus();
			sprintf(buffer,"%d neurons",current_nucleus->nb_neurons);
			string = XmStringCreateLocalized(buffer);
			XtVaSetValues(widget_array[ID_LabelG_nbneuron_in_nucleus],
				XmNlabelString,string,NULL);
			XmStringFree(string);
			
			XmTextRemove(widget_array[ID_TextF_AP_nucleusC]);
			sprintf(buffer,"%.2f",current_nucleus->AP);
			XmTextReplace(widget_array[ID_TextF_AP_nucleusC],0,
				XmTextGetLastPosition(widget_array[ID_TextF_AP_nucleusC]),
				buffer);
			XmTextRemove(widget_array[ID_TextF_AP_nucleusR]);
			sprintf(buffer,"%.2f",current_nucleus->delta_AP);
			XmTextReplace(widget_array[ID_TextF_AP_nucleusR],0,
				XmTextGetLastPosition(widget_array[ID_TextF_AP_nucleusR]),
				buffer);
				
			XmTextRemove(widget_array[ID_TextF_H_nucleusC]);
			sprintf(buffer,"%.2f",current_nucleus->H);
			XmTextReplace(widget_array[ID_TextF_H_nucleusC],0,
				XmTextGetLastPosition(widget_array[ID_TextF_H_nucleusC]),
				buffer);
			XmTextRemove(widget_array[ID_TextF_H_nucleusR]);
			sprintf(buffer,"%.2f",current_nucleus->delta_H);
			XmTextReplace(widget_array[ID_TextF_H_nucleusR],0,
				XmTextGetLastPosition(widget_array[ID_TextF_H_nucleusR]),
				buffer);	
				
			XmTextRemove(widget_array[ID_TextF_L_nucleusC]);
			sprintf(buffer,"%.2f",current_nucleus->L);
			XmTextReplace(widget_array[ID_TextF_L_nucleusC],0,
				XmTextGetLastPosition(widget_array[ID_TextF_L_nucleusC]),
				buffer);
			XmTextRemove(widget_array[ID_TextF_L_nucleusR]);
			sprintf(buffer,"%.2f",current_nucleus->delta_L);
			XmTextReplace(widget_array[ID_TextF_L_nucleusR],0,
				XmTextGetLastPosition(widget_array[ID_TextF_L_nucleusR]),
				buffer);	
			
			XmTextReplace(widget_array[ID_TextF_nucleus_name],0,
				XmTextGetLastPosition(widget_array[ID_TextF_nucleus_name]),
				current_nucleus->nucleus_name);
			
			if(!XtIsManaged(widget_array[ID_FormD_nucleus_parameters]))
			{	
				XtManageChild(widget_array[ID_FormD_nucleus_parameters]);
				XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_nucleus_parameters])),
						the_colormap);
			}
			else 
				XtPopup(XtParent(widget_array[ID_FormD_nucleus_parameters]),
					XtGrabNone);	
					
			break;	
		
		case ID_PushB_composition_add:
			
			
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			
			creating = True;
			XmTextRemove(widget_array[ID_Text_cluster_name]);
			name = get_name(&current_cluster_id,_NUCLEUS_,_CLUSTER_,0);
			sprintf(buffer,"%s",name);
			free(name);
			XmTextReplace(widget_array[ID_Text_cluster_name],0,
				XmTextGetLastPosition(widget_array[ID_Text_cluster_name]),
				buffer);
						
			XmTextFieldRemove(widget_array[ID_TextF_cluster_neuron_file]);
			sprintf(buffer,"%s",last_neuron_file);
			XmTextFieldReplace(widget_array[ID_TextF_cluster_neuron_file],0,
				XmTextGetLastPosition(widget_array[ID_TextF_cluster_neuron_file]),
				buffer);
				
			XmTextRemove(widget_array[ID_Text_nbneuron_in_cluster]);
			sprintf(buffer,"2");
			XmTextReplace(widget_array[ID_Text_nbneuron_in_cluster],0,
				XmTextGetLastPosition(widget_array[ID_Text_nbneuron_in_cluster]),
				buffer);	
				
			if(!XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				XtManageChild(widget_array[ID_FormD_nucleus_composition]);
				XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_nucleus_composition])),
						the_colormap);
			}
			else 
				XtPopup(XtParent(widget_array[ID_FormD_nucleus_composition]),
					XtGrabNone);
			break;
			
		case ID_PushB_composition_modify:
			
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			
			XmListGetSelectedPos(widget_array[ID_List_composition],&positions,&n);
			
			if(!n)
			{
				display_error(widget_array[ID_FormD_Nucleus],
				"Select one component first...","Nothing to modify !");
				return;	
			}
			XtVaGetValues(widget_array[ID_List_composition],
				XmNitemCount,&nb_items,XmNitems,&all_items,NULL); 
			string = all_items[positions[0]-1];
			XmStringGetLtoR(string,XmSTRING_DEFAULT_CHARSET,
			&text);	
			
			get_cluster_characteristics(text,&name,&neuron_file,&nb_neurons);
			
			if(nb_neurons==1)
			{
				neuron_tmp = identify_neuron(name,neuron_file);
				if(!neuron_tmp)
				{
					fprintf(stderr,"neuron not identified in identify_neuron!\n");
					exit(-1);
				}
				deselect_all_neuron();
				select_neuron(neuron_tmp->form,neuron_tmp->neuron_id,NULL);
				modify_neuron_in_nucleus();
				XmListDeletePos(widget_array[ID_List_composition],positions[0]);
				return;
			}
			
			XmListDeletePos(widget_array[ID_List_composition],positions[0]);
			XmTextRemove(widget_array[ID_Text_cluster_name]);
			sprintf(buffer,"%s",name);
			free(name);
			XmTextReplace(widget_array[ID_Text_cluster_name],0,
				XmTextGetLastPosition(widget_array[ID_Text_cluster_name]),
				buffer);
						
			XmTextFieldRemove(widget_array[ID_TextF_cluster_neuron_file]);
			sprintf(buffer,"%s",neuron_file);
			free(neuron_file);
			XmTextFieldReplace(widget_array[ID_TextF_cluster_neuron_file],0,
				XmTextGetLastPosition(widget_array[ID_TextF_cluster_neuron_file]),
				buffer);
				
			XmTextRemove(widget_array[ID_Text_nbneuron_in_cluster]);
			sprintf(buffer,"%d",nb_neurons);
			XmTextReplace(widget_array[ID_Text_nbneuron_in_cluster],0,
				XmTextGetLastPosition(widget_array[ID_Text_nbneuron_in_cluster]),
				buffer);	
				
			if(!XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				XtManageChild(widget_array[ID_FormD_nucleus_composition]);
				XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_nucleus_composition])),
						the_colormap);
			}
			else 
				XtPopup(XtParent(widget_array[ID_FormD_nucleus_composition]),
					XtGrabNone);
			break;
		
		case ID_PushB_composition_remove:
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous composition edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the previous neuron edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the generic link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_FormD_link_simple]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron to neuron link edition first...","Can't do that !");
				return;
			}
			if(XtIsManaged(widget_array[ID_n_p_generator_form]))
			{	
				display_error(widget_array[ID_FormD_Nucleus],
				"Please finish the neuron placement edition first...","Can't do that !");
				return;
			}	
			XmListGetSelectedPos(widget_array[ID_List_composition],&positions,&n);
			
			if(!n)
			{
				display_error(widget_array[ID_FormD_Nucleus],
				"Select one component first...","Nothing to delete !");
				return;	
			}
			XtVaGetValues(widget_array[ID_List_composition],
				XmNitemCount,&nb_items,XmNitems,&all_items,NULL); 
			string = all_items[positions[0]-1];
			XmStringGetLtoR(string,XmSTRING_DEFAULT_CHARSET,
			&text);	
			
			get_cluster_characteristics(text,&name,&neuron_file,&nb_neurons);
				
			sprintf(buffer,"Do you really want to delete %s of \ntype %s of size %d neurons ?",
			 name,neuron_file,nb_neurons);
			if(display_question(widget_array[ID_FormD_Nucleus],
	buffer,"Confirmation needed...") == YES_ANSWER)
			{
				delete_cluster(name,neuron_file,nb_neurons);
				redisplay_nucleus();
				XmListDeletePos(widget_array[ID_List_composition],positions[0]);
			}
			free(name);
			free(neuron_file);
			update_numbers();
			break;
		
		case ID_PushBG_composition_ok:
			if (apply_cluster())
				break;
			if (XtIsManaged(widget_array[ID_FormD_nucleus_composition]))
				XtUnmanageChild(widget_array[ID_FormD_nucleus_composition]);
			creating = False;
			generic_place_neurons(False);
			refresh_composition();
			redisplay_nucleus();
			
			break;
		case ID_PushBG_composition_apply:
			if (apply_cluster())
				break;
			creating = False;
			generic_place_neurons(False);
			refresh_composition();
			redisplay_nucleus();
			break;
			
		case ID_PushBG_composition_cancel:
			if(creating)
			{
				cancel_cluster();
				creating = False;
			}
			refresh_composition();
			if(XtIsManaged(widget_array[ID_FormD_nucleus_composition]))	
				XtUnmanageChild(widget_array[ID_FormD_nucleus_composition]);
			break;

		default:
			break;
	}
}

/* ARGSUSED */
void
neur_activate_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	char *neuron_file;
	char mask[10];
	char buffer[255];
	XmString string;
	
	int message = (int)(unsigned long)client;
	
	switch(message)
	{
		
		case ID_PushBG_neuron_edit_ok:
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				if(apply_neuron())
					break;
				creating = False;
				if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
					XtUnmanageChild(widget_array[ID_FormD_neuron_edit]);
				enable_net_menu(True);
				XtAddEventHandler(current_nucleus->form,ButtonPressMask,False,
					(XtEventHandler)select_nucleus,current_nucleus->nucleus_id);
				XtAddEventHandler(current_nucleus->form,ButtonReleaseMask,False,
					(XtEventHandler)release_nucleus,current_nucleus->nucleus_id);
				XtAddEventHandler(current_nucleus->form,ButtonMotionMask,False,
					(XtEventHandler)chplace_nucleus,current_nucleus->nucleus_id);
				XtAddEventHandler(current_nucleus->form,ButtonMotionMask,False,
					(XtEventHandler)info_nucleus,current_nucleus->nucleus_id);	
				XtAddEventHandler(current_nucleus->form,EnterWindowMask,False,
					(XtEventHandler)info_nucleus,current_nucleus->nucleus_id);
				XtAddEventHandler(current_nucleus->form,LeaveWindowMask,False,
					(XtEventHandler)clear_label_net_info,
					current_nucleus->nucleus_id);
				
				redisplay_network();
				
				select_nucleus(current_nucleus->form,current_nucleus->nucleus_id,NULL);
			}
			else
			{
				if(apply_neuron_in_nucleus())
					break;
				creating = False;
				select_neuron(current_neuron->form,current_neuron->neuron_id,NULL);
			
				if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
					XtUnmanageChild(widget_array[ID_FormD_neuron_edit]);
				
				XtAddEventHandler(current_neuron->form,ButtonPressMask,False,
					(XtEventHandler)select_neuron,current_neuron->neuron_id);
				XtAddEventHandler(current_neuron->form,ButtonReleaseMask,False,
					(XtEventHandler)release_neuron,current_neuron->neuron_id);
				XtAddEventHandler(current_neuron->form,ButtonMotionMask,False,
					(XtEventHandler)chplace_neuron,current_neuron->neuron_id);
				XtAddEventHandler(current_neuron->form,ButtonMotionMask,False,
					(XtEventHandler)info_neuron,current_neuron->neuron_id);	
				XtAddEventHandler(current_neuron->form,EnterWindowMask,False,
					(XtEventHandler)info_neuron,current_neuron->neuron_id);
				XtAddEventHandler(current_neuron->form,LeaveWindowMask,False,
					(XtEventHandler)clear_label_nucl_info,
					current_neuron->neuron_id);
			
				redisplay_nucleus();
				refresh_composition();
				
			}
			break;
		case ID_PushBG_neuron_edit_apply:
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				if(apply_neuron())
					break;
				creating = False;
				redisplay_network();
			}
			else
			{	
				if(apply_neuron_in_nucleus())
					break;
				creating = False;
				redisplay_nucleus();
				refresh_composition();
			}
			break;
			
		case ID_PushBG_neuron_edit_cancel:
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				
				if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
					XtUnmanageChild(widget_array[ID_FormD_neuron_edit]);
				if(creating)
				{
					delete_nucleus();
					creating = False;
					redisplay_network();
					break;
				}
					
				enable_net_menu(True);
				XtAddEventHandler(current_nucleus->form,ButtonPressMask,False,
					(XtEventHandler)select_nucleus,current_nucleus->nucleus_id);
				XtAddEventHandler(current_nucleus->form,ButtonReleaseMask,False,
					(XtEventHandler)release_nucleus,current_nucleus->nucleus_id);
				XtAddEventHandler(current_nucleus->form,ButtonMotionMask,False,
					(XtEventHandler)chplace_nucleus,current_nucleus->nucleus_id);
				XtAddEventHandler(current_nucleus->form,ButtonMotionMask,False,
					(XtEventHandler)info_nucleus,current_nucleus->nucleus_id);	
				XtAddEventHandler(current_nucleus->form,EnterWindowMask,False,
					(XtEventHandler)info_nucleus,current_nucleus->nucleus_id);
				XtAddEventHandler(current_nucleus->form,LeaveWindowMask,False,
					(XtEventHandler)clear_label_net_info,
					current_nucleus->nucleus_id);
				
				redisplay_network();
				
				select_nucleus(current_nucleus->form,current_nucleus->nucleus_id,NULL);
			}
			else
			{	
			
				select_neuron(current_neuron->form,current_neuron->neuron_id,NULL);
			
				if(XtIsManaged(widget_array[ID_FormD_neuron_edit]))
					XtUnmanageChild(widget_array[ID_FormD_neuron_edit]);
				
				if(creating)
				{
					delete_neuron_in_nucleus();
					creating = False;
					redisplay_nucleus();
					refresh_composition();
					break;
				}
				
				XtAddEventHandler(current_neuron->form,ButtonPressMask,False,
					(XtEventHandler)select_neuron,current_neuron->neuron_id);
				XtAddEventHandler(current_neuron->form,ButtonReleaseMask,False,
					(XtEventHandler)release_neuron,current_neuron->neuron_id);
				XtAddEventHandler(current_neuron->form,ButtonMotionMask,False,
					(XtEventHandler)chplace_neuron,current_neuron->neuron_id);
				XtAddEventHandler(current_neuron->form,ButtonMotionMask,False,
					(XtEventHandler)info_neuron,current_neuron->neuron_id);	
				XtAddEventHandler(current_neuron->form,EnterWindowMask,False,
					(XtEventHandler)info_neuron,current_neuron->neuron_id);
				XtAddEventHandler(current_neuron->form,LeaveWindowMask,False,
					(XtEventHandler)clear_label_nucl_info,
					current_neuron->neuron_id);
			
				redisplay_nucleus();
				refresh_composition();
				
			}	
			break;
		case ID_PushB_P_unit:
			if(message == ID_PushB_P_unit)
				strcpy(mask,"*.P_unit");
					
		case ID_PushB_G_unit:
			if(message == ID_PushB_G_unit)
				strcpy(mask,"*.G_unit");
				
		case ID_PushB_tms:
			if(message == ID_PushB_tms)
				strcpy(mask,"*.tms");
		
		case ID_PushB_neuron_file_other:
			if(message == ID_PushB_neuron_file_other)
				strcpy(mask,"*.*_unit");
		
			neuron_file = display_fileselect(widget_array[ID_FormD_neuron_edit],
				3,mask,"Select a neuron type file:",NULL);
			if(!neuron_file)
			{
				sprintf(buffer,
				"No neuron file was selected...");
				display_error(widget_array[ID_FormD_neuron_edit],
				buffer,"Selection canceled");
			}
			else if(!strstr(neuron_file,".P_unit") &&
				!strstr(neuron_file,".G_unit") && 
				!strstr(neuron_file,".tms") )
			{
				sprintf(buffer,
				"Sorry, can't consider %s as a neuron file...",neuron_file);
				display_error(widget_array[ID_FormD_neuron_edit],
				buffer,"Bad neuron file !");
			}	
			else
			{
				strcpy(last_neuron_file,neuron_file);
				
				string = XmStringCreateLocalized(neuron_file);
				if(!XmListItemExists(widget_array[ID_List_neuron_edit_file],
					string))
				{
					XmListAddItem(widget_array[ID_List_neuron_edit_file],string,1);
					XmListSelectPos(widget_array[ID_List_neuron_edit_file],1,True);
					XmListAddItem(widget_array[ID_List_cluster_neuron_file],string,1);
					XmListSelectPos(widget_array[ID_List_cluster_neuron_file],1,True);
				}
				else
				{
					XmListDeleteItem(widget_array[ID_List_neuron_edit_file],
						string);
					XmListAddItem(widget_array[ID_List_neuron_edit_file],string,1);
					XmListSelectPos(widget_array[ID_List_neuron_edit_file],1,True);
					
					XmListDeleteItem(widget_array[ID_List_cluster_neuron_file],
						string);
					XmListAddItem(widget_array[ID_List_cluster_neuron_file],string,1);
					XmListSelectPos(widget_array[ID_List_cluster_neuron_file],1,True);
				}
				XmListSetPos(widget_array[ID_List_neuron_edit_file],1);
				XmListSetPos(widget_array[ID_List_cluster_neuron_file],1);
				XmStringFree(string);
				XmTextFieldReplace(widget_array[ID_TextF_neuron_edit_file],0,
				XmTextGetLastPosition(widget_array[ID_TextF_neuron_edit_file]),
				last_neuron_file);
				XmTextFieldReplace(widget_array[ID_TextF_cluster_neuron_file],0,
				XmTextGetLastPosition(widget_array[ID_TextF_cluster_neuron_file]),
				last_neuron_file);
				
			}
			break;
				
		default:
			break;
	}
}

/* ARGSUSED */
void
link_activate_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	int message = (int)(unsigned long)client;
	char buffer[255];
	XmString string;
	int i;
	
	switch(message)
	{
	
		case ID_push_up:
			if(!changed)
			{
				sprintf(buffer,"Do you really want to update this link ?");
				if(display_question(widget_array[ID_FormD_adjustement_curve],
					buffer,"Confirmation needed...") == NO_ANSWER)
					return;
			}
			for(i=0 ; i<_NB_INTERPOLATING_POINTS_ ; i++)
				current_link->points[i].probability = 100.0;
			changed = True;
			update_density();
			redraw_connection_curve();
			break;
		
		case ID_push_auto:
			if(!changed)
			{
				sprintf(buffer,"Do you really want to update this link ?");
				if(display_question(widget_array[ID_FormD_adjustement_curve],
					buffer,"Confirmation needed...") == NO_ANSWER)
					return;
			}
			current_link->points[0].probability = 0.0;
			current_link->points[0].length = 1.0;
			changed = True;
			update_density();
			redraw_connection_curve();
			break;
				
		case ID_push_down:
			if(!changed)
			{
				sprintf(buffer,"Do you really want to update this link ?");
				if(display_question(widget_array[ID_FormD_adjustement_curve],
					buffer,"Confirmation needed...") == NO_ANSWER)
					return;
			}
			for(i=0 ; i<_NB_INTERPOLATING_POINTS_ ; i++)
				current_link->points[i].probability = 0.0;
			changed = True;	
			update_density();
			redraw_connection_curve();
			break;
		
		case ID_push_default:
			if(!changed)
			{
				sprintf(buffer,"Do you really want to update this link ?");
				if(display_question(widget_array[ID_FormD_adjustement_curve],
					buffer,"Confirmation needed...") == NO_ANSWER)
					return;
			}
			for(i=0 ; i<_NB_INTERPOLATING_POINTS_ ; i++)
			{
				current_link->points[i].probability = 100.0 - (2*i+1)*5.0;
				current_link->points[i].length = (2*i+1)*5.0;
			}
			changed = True;
			update_density();
			redraw_connection_curve();
			break;
		
		case ID_push_gauss:
			if(!changed)
			{
				sprintf(buffer,"Do you really want to update this link ?");
				if(display_question(widget_array[ID_FormD_adjustement_curve],
					buffer,"Confirmation needed...") == NO_ANSWER)
					return;
			}		
			calculate_gauss();
			changed = True;
			update_density();
			redraw_connection_curve();
			break;
			
		case ID_push_plus:
			if(!changed)
			{
				sprintf(buffer,"Do you really want to update this link ?");
				if(display_question(widget_array[ID_FormD_adjustement_curve],
					buffer,"Confirmation needed...") == NO_ANSWER)
					return;
			}
			for(i=0 ; i<_NB_INTERPOLATING_POINTS_ ; i++)
			{
				current_link->points[i].probability += 5.0;
				if(current_link->points[i].probability > 100.0)
					current_link->points[i].probability = 100.0;
			}
			changed = True;
			update_density();
			redraw_connection_curve();
			break;	
		case ID_push_minus:
			if(!changed)
			{
				sprintf(buffer,"Do you really want to update this link ?");
				if(display_question(widget_array[ID_FormD_adjustement_curve],
					buffer,"Confirmation needed...") == NO_ANSWER)
					return;
			}
			for(i=0 ; i<_NB_INTERPOLATING_POINTS_ ; i++)
			{
				current_link->points[i].probability -= 5.0;
				if(current_link->points[i].probability < 0.0)
					current_link->points[i].probability = 0.0;
			}
			changed = True;
			update_density();
			redraw_connection_curve();
			break;	
			
		case ID_option_rien:
			edit_mode = _REGULAR_;
			break;
			
		case ID_option_record:
			edit_mode = _RECORD_;
			nb_mem = 0;
			break;
			
		case ID_option_place:
			edit_mode = _PASTE_;
			break;
			
			
		case ID_PushBG_link_simple_ok:
		
			if(apply_neuron_to_neuron_link())
				return;
			XtUnmanageChild(widget_array[ID_FormD_link_simple]);
			creating = False;
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				deselect_all_neuron();
				redisplay_nucleus();
			}
			break;
		
		case ID_PushBG_link_simple_apply:
			if(apply_neuron_to_neuron_link())
				return;
			creating = False;
			break;
			
		case ID_PushBG_link_simple_cancel:
		
			XtUnmanageChild(widget_array[ID_FormD_link_simple]);
			if(creating)
			{
				cancel_single_link();
			}
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				deselect_all_neuron();
				redisplay_nucleus();
			}
			break;
		
		case ID_PushBG_generic_link_ok:
			XDefineCursor(the_display,XtWindow(widget_array[ID_FormD_generic_link_edit]),
				NULL);
			if(apply_generic_link())
				return;
			if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
				XtUnmanageChild(widget_array[ID_FormD_generic_link_matrix]);
			if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
				XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);
			update_link_type(&current_link);
			XtUnmanageChild(widget_array[ID_FormD_generic_link_edit]);
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}
			creating = False;
			changed = False;
			break;
			
		case ID_PushBG_generic_link_apply:
			XDefineCursor(the_display,XtWindow(widget_array[ID_FormD_generic_link_edit]),
				NULL);
			if(apply_generic_link())
				return;
			update_link_type(&current_link);
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}
			creating = False;
			changed = False;
			break;
		
		case ID_PushBG_generic_link_cancel:
			XDefineCursor(the_display,XtWindow(widget_array[ID_FormD_generic_link_edit]),
				NULL);
			if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
				XtUnmanageChild(widget_array[ID_FormD_generic_link_matrix]);
			if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
				XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);
			XtUnmanageChild(widget_array[ID_FormD_generic_link_edit]);
			if(creating)
			{
				cancel_generic_link();
			}
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}
			changed = False;
			break;
				
		case ID_PushB_genric_link_edit_connect:
			
			if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
				changed = True;
			if(XmToggleButtonGetState(widget_array[ID_ToggleB_partially_connected]))
			{
				if(apply_generic_link())
					return;
				
				XDefineCursor(the_display,XtWindow(widget_array[ID_FormD_generic_link_edit]),
					working_cursor);
				if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
				{
					deselect_all_nucleus();
					redisplay_network();
				}
				else
				{
					redisplay_nucleus();
				}
				
				memcpy(current_points,current_link->points,
						_NB_INTERPOLATING_POINTS_*sizeof(PROBA_POINT));
				
				if(!XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
				{
					XtManageChild(widget_array[ID_FormD_adjustement_curve]);
					XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_adjustement_curve])),
						the_colormap);
				}
				else
					XtPopup(XtParent(widget_array[ID_FormD_adjustement_curve]),
						XtGrabNone);
						
				redraw_connection_curve();
				
			}
			else
			{

				if(apply_generic_link())
					return;
				XDefineCursor(the_display,XtWindow(widget_array[ID_FormD_generic_link_edit]),
					working_cursor);
				if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
				{
					deselect_all_nucleus();
					redisplay_network();
				}
				else
				{
					redisplay_nucleus();
				}	
				
				if(!XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
				{
					XtManageChild(widget_array[ID_FormD_generic_link_matrix]);
					XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_generic_link_matrix])),
						the_colormap);
				}
				else
					XtPopup(XtParent(widget_array[ID_FormD_generic_link_matrix]),
						XtGrabNone);
						
				redraw_connection_matrix();

			}
			XDefineCursor(the_display,XtWindow(widget_array[ID_FormD_generic_link_edit]),
				NULL);
			break;
			
		case ID_PushBG_curve_ok:
		
			if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
				XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);
			memcpy(current_points,current_link->points,
						_NB_INTERPOLATING_POINTS_*sizeof(PROBA_POINT));
			if(apply_generic_link())
					return;
			
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}	
			
			if(!XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
			{
				XtManageChild(widget_array[ID_FormD_generic_link_matrix]);
				XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_generic_link_matrix])),
						the_colormap);
			}
			else
				XtPopup(XtParent(widget_array[ID_FormD_generic_link_matrix]),
					XtGrabNone);
			redraw_connection_matrix();
			changed = False;

			break;
			
		case ID_PushBG_curve_apply:
		
			memcpy(current_points,current_link->points,
						_NB_INTERPOLATING_POINTS_*sizeof(PROBA_POINT));
			if(apply_generic_link())
					return;
			
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}	
			
			if(!XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
			{
				XtManageChild(widget_array[ID_FormD_generic_link_matrix]);
				XSetWindowColormap(the_display, XtWindow(XtParent(widget_array[ID_FormD_generic_link_matrix])),
						the_colormap);
			}
			else
				XtPopup(XtParent(widget_array[ID_FormD_generic_link_matrix]),
					XtGrabNone);
			redraw_connection_matrix();
			changed = False;

			break;
			
		case ID_PushBG_curve_cancel:	
			memcpy(current_link->points,current_points,
						_NB_INTERPOLATING_POINTS_*sizeof(PROBA_POINT));
			if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
				XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);
			changed = False;
			break;
			
		case ID_PushBG_matrix_ok:
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}	
			if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
				XtUnmanageChild(widget_array[ID_FormD_generic_link_matrix]);
			if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
				XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);	
			break;
		case ID_PushBG_matrix_apply:
			
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}
			if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
				XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);	
			break;
			
		case ID_PushBG_matrix_cancel:
		case ID_PushB_matrix_file_close:
			
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
				XtUnmanageChild(widget_array[ID_FormD_generic_link_matrix]);
			if(XtIsManaged(widget_array[ID_FormD_adjustement_curve]))
				XtUnmanageChild(widget_array[ID_FormD_adjustement_curve]);
			break;
				
		case ID_PushB_matrix_edit_clear:
		
			current_link->type = _FULL_NOT_CONNECTED_;
			changed = True;
			create_default_generic_link();
			redraw_connection_matrix();
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}
			break;
			
		case ID_PushB_matrix_edit_randomize:
			
			current_link->type = _FULL_RANDOMIZED_;
			changed = True;
			create_default_generic_link();
			redraw_connection_matrix();
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{
				XmToggleButtonSetState(widget_array[ID_ToggleB_algo_random],True,True);
			}
			break;
					
		case ID_PushB_matrix_edit_all_excit	:
		
			current_link->type = _FULL_EXCITATION_;
			changed = True;
			create_default_generic_link();
			redraw_connection_matrix();
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{
				XmToggleButtonSetState(widget_array[ID_ToggleB_algo_all_excit],True,True);
			}
			break;
			
		case ID_PushB_matrix_edit_all_inhib	:
		
			current_link->type = _FULL_INHIBITION_;
			changed = True;
			create_default_generic_link();
			redraw_connection_matrix();
			if(!XtIsManaged(widget_array[ID_FormD_Nucleus]))
			{
				deselect_all_nucleus();
				redisplay_network();
			}
			else
			{
				redisplay_nucleus();
			}
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{
				XmToggleButtonSetState(widget_array[ID_ToggleB_algo_all_inhib],True,True);
			}
			break;	
			
		
		default:
			break;
	
	}
	
	
}

/* ARGSUSED */
void
toggle_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	int message = (int)(unsigned long)client;
	char buffer[255];
	static int n=0;
	static int last=0;
	
	switch(message)
	{
	
		case ID_ToggleB_fully_connected:
		case ID_ToggleB_partially_connected:
		case ID_ToggleB_algo_random:
		case ID_ToggleB_algo_all_excit:
		case ID_ToggleB_algo_all_inhib:
			if(XtIsManaged(widget_array[ID_FormD_generic_link_matrix]))
				return;
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{
				if(!changed)
				{
					n++;
					if(!(n%2))
					{
						sprintf(buffer,"Do you really want to update this link ?");
						if(display_question(widget_array[ID_FormD_generic_link_edit],
							buffer,"Confirmation needed...") == NO_ANSWER)
						{
							
							XmToggleButtonSetState(widget_array[last],True,False);
							XmToggleButtonSetState(widget_array[message],False,False);
							return;
						}
					}
					else
					{
						last = message;
						return;
					}
				}
				changed = True;
			}
			break;
			
		case ID_ToggleB_NMDA:
			if(XtIsManaged(widget_array[ID_FormD_generic_link_edit]))
			{
				if(!changed)
				{
					
					
					sprintf(buffer,"Do you really want to update this link ?");
					if(display_question(widget_array[ID_FormD_generic_link_edit],
						buffer,"Confirmation needed...") == NO_ANSWER)
					{
						if(XmToggleButtonGetState(widget_array[message]))
							XmToggleButtonSetState(widget_array[message],False,False);
						else
							XmToggleButtonSetState(widget_array[message],True,False);
							

						return;
					}

				}
				changed = True;
			}
			break;
		default:
			break;
	
	}	
	
	
}

/* ARGSUSED */
void
expose_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	int message = (int)(unsigned long)client;
	Nucleus_widget *nucleus_tmp;
	int i;
	
	switch(message)
	{
	
		case ID_DrawingA_net:
			XClearWindow(the_display,XtWindow(widget_array[ID_DrawingA_net]));
			
			for(i=0 ; i<current_network->nb_nucleus ; i++)
			{
				if(!current_network->nucleus_array)
					break;
				nucleus_tmp = current_network->nucleus_array[i];
				
				if(!nucleus_tmp)
					break;
				
				if(nucleus_tmp->form && XtIsManaged(nucleus_tmp->form))
					XClearWindow(the_display,XtWindow(nucleus_tmp->form));

			}
			break;
			
		case ID_DrawingA_nucleus_view:
			XClearWindow(the_display,XtWindow(widget_array[ID_DrawingA_nucleus_view]));
			break;	
		
		case ID_DrawingA_matrix:
			XClearWindow(the_display,XtWindow(widget_array[ID_DrawingA_matrix]));
			break;
		
		case ID_DrawingA_connection_curve:
			XClearWindow(the_display,XtWindow(widget_array[ID_DrawingA_connection_curve]));
			break;
		
		default:
			break;
	
	}
	
	
}

/* ARGSUSED */
void
list_selection_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XmListCallbackStruct *acs=(XmListCallbackStruct*)call;
	int message = (int)(unsigned long)client;
	char *text;
	XmString string;
	
	switch(message)
	{
	
		case ID_List_neuron_edit_file:
			if(acs->reason == XmCR_DEFAULT_ACTION)
			{
				if(!XmStringGetLtoR(acs->item,XmSTRING_DEFAULT_CHARSET,
					&text))
				{
					display_error(widget_array[ID_FormD_neuron_edit],
				"Sorry,can't convert item...","Conversion failure !");
					break;
				}
		
				XmListDeleteItem(widget_array[ID_List_neuron_edit_file],
					acs->item);
				string = XmStringCreateLocalized(text);	
				XmListAddItem(widget_array[ID_List_neuron_edit_file],string,1);
				XmStringFree(string);
				XmListSelectPos(widget_array[ID_List_neuron_edit_file],1,True);	
				XmListSetPos(widget_array[ID_List_neuron_edit_file],1);
				strcpy(last_neuron_file,text);
				XmTextFieldReplace(widget_array[ID_TextF_neuron_edit_file],0,
				XmTextGetLastPosition(widget_array[ID_TextF_neuron_edit_file]),
				last_neuron_file);
			}
			break;
		
		case ID_List_cluster_neuron_file:
			if(acs->reason == XmCR_DEFAULT_ACTION)
			{
				if(!XmStringGetLtoR(acs->item,XmSTRING_DEFAULT_CHARSET,
					&text))
				{
					display_error(widget_array[ID_FormD_nucleus_composition],
				"Sorry,can't convert item...","Conversion failure !");
					break;
				}
		
				XmListDeleteItem(widget_array[ID_List_cluster_neuron_file],
					acs->item);
				string = XmStringCreateLocalized(text);	
				XmListAddItem(widget_array[ID_List_cluster_neuron_file],string,1);
				XmStringFree(string);
				XmListSelectPos(widget_array[ID_List_cluster_neuron_file],1,True);	
				XmListSetPos(widget_array[ID_List_cluster_neuron_file],1);
				strcpy(last_neuron_file,text);
				XmTextFieldReplace(widget_array[ID_TextF_cluster_neuron_file],0,
				XmTextGetLastPosition(widget_array[ID_TextF_cluster_neuron_file]),
				last_neuron_file);
			}
			break;
		
		case ID_List_composition:
			if(acs->reason == XmCR_DEFAULT_ACTION)
			{
				nucl_activate_CB(w,ID_PushB_composition_modify,call);
			}	
			
		default:
			break;
	
	}
}

/* ARGSUSED */
void
scale_CB(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;
	int message = (int)(unsigned long)client;
	
	switch(message)
	{
	
		default:
			break;
	
	}
}





#endif
