/*
*****************************************************************************
*                                                                           *
*			creation_network.c part 1                                       * 
*                                                                           *
*                                                                           *
*         contains the following creation functions:                        *
*                                                                           *
*  o  void BxRegisterConverters() -> utility from ICS BX for                *
*           initializing  widget'classes                                    *
*                                                                           * 
*  o  Widget Createpopup_other(Widget parent) -> creation of the popup menu *
*          used when selecting other neuron type files                      *
*                                                                           *
*  o  Widget Createpopup_net(Widget parent) -> creation of the popup menu   *
*            used for selecting a particular network view                   *
*                                                                           *
*  o  Widget Createpopup_nucleus(Widget parent) -> creation of the popup    *
*              menu used for seleting a particular nucleus view             *
*	                                                                        *
*****************************************************************************					
*/







#ifndef _CREATION_NETWORK_1
#define _CREATION_NETWORK_1


/*
 * Generated by the ICS builderXcessory (BX).
 *
 *
 * Builder Xcessory 3.1.
 *
 */
/*
 * MOTIF include files needed for widget creation.
 */
#include <Xm/Xm.h>
#include <Xm/TextF.h>
#include <Xm/Separator.h>
#include <Xm/CascadeB.h>
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>
#include <Xm/Label.h>
#include <Xm/List.h>
#include <Xm/Text.h>
#include <Xm/DrawingA.h>
#include <Xm/Frame.h>
#include <Xm/PanedW.h>
#include <Xm/Scale.h>
#include <Xm/MainW.h>
#include <Xm/ScrolledW.h>
#include <Xm/Form.h>
#include <Xm/MessageB.h>
#include <Xm/FileSB.h>
#include <Xm/SelectioB.h>
#include <Xm/BulletinB.h>
#include <Xm/RowColumn.h>
#include <Xm/RowColumn.h>
#include <Xm/DialogS.h>
#include <Xm/MenuShell.h>
#include <Xm/SeparatoG.h>
#include <Xm/PushBG.h>
#include <Xm/LabelG.h>

#define DECLARE_BX_GLOBALS

/*
 * Global declarations are now stored in the header file 'creation_network.h'.
 *
 * If DECLARE_BX_GLOBALS is defined then this header file
 * declares the globals, otherwise it just externs them.
 */

/* application globals include files */
#ifndef _GLOBAL_NETWORK_
#include "creation_network.h"
#endif

/* type definitions include files */
#ifndef _TYPESDEFINED_
#include "newtypes.h"
#endif

/* prototypes include files */
#ifndef _PROTOTYPES_
#include "prototypes.h"
#endif



/*
 * Function: BxRegisterConverters()
 *     Registers all the converters for all widgets.
 */
void
BxRegisterConverters()
{
    XtInitializeWidgetClass(xmTextFieldWidgetClass);
    XtInitializeWidgetClass(xmSeparatorWidgetClass);
    XtInitializeWidgetClass(xmCascadeButtonWidgetClass);
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    XtInitializeWidgetClass(xmLabelWidgetClass);
    XtInitializeWidgetClass(xmListWidgetClass);
    XtInitializeWidgetClass(xmTextWidgetClass);
    XtInitializeWidgetClass(xmDrawingAreaWidgetClass);
    XtInitializeWidgetClass(xmFrameWidgetClass);
    XtInitializeWidgetClass(xmPanedWindowWidgetClass);
    XtInitializeWidgetClass(xmScaleWidgetClass);
    XtInitializeWidgetClass(xmMainWindowWidgetClass);
    XtInitializeWidgetClass(xmScrolledWindowWidgetClass);
    XtInitializeWidgetClass(xmFormWidgetClass);
    XtInitializeWidgetClass(xmMessageBoxWidgetClass);
    XtInitializeWidgetClass(xmFileSelectionBoxWidgetClass);
    XtInitializeWidgetClass(xmSelectionBoxWidgetClass);
    XtInitializeWidgetClass(xmBulletinBoardWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(topLevelShellWidgetClass);
    XtInitializeWidgetClass(xmDialogShellWidgetClass);
    XtInitializeWidgetClass(xmMenuShellWidgetClass);
    XtInitializeWidgetClass(xmSeparatorWidgetClass);
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    XtInitializeWidgetClass(xmLabelWidgetClass);
}

/*
 * Function: Createpopup_other()
 *			Create popup_other hierarchie of widgets
 */
Widget
Createpopup_other(parent)
Widget parent;
{
	Widget 	retval;
    Widget	popup_other;
    Widget  pushB_P_unit,pushB_G_unit,pushB_tms;
    Arg    	args[512];
    Cardinal   	argcnt;
    XmString label_P_unit,label_G_unit,label_tms;
    
    BxRegisterConverters();
    
    label_P_unit = XmStringCreateSimple("Select an other P neuron type file...");
    label_G_unit = XmStringCreateSimple("Select an other G neuron type file...");
    label_tms = XmStringCreateSimple("Select an other Virtual neuron type file...");
    
    
 	argcnt = 0;
    popup_other = XmCreateSimplePopupMenu(parent,
     "popup_other", args,argcnt);    
   	
   	pushB_P_unit = XtVaCreateManagedWidget("pushB_P_unit",xmPushButtonWidgetClass,popup_other,
   		XmNlabelString,label_P_unit,NULL);
   	register_widget_CB(pushB_P_unit, (XtPointer)ID_PushB_P_unit, (XtPointer)0);
   	create_event_CB(pushB_P_unit, (XtPointer)ID_PushB_P_unit, (XtPointer)0);
   	XtAddCallback(pushB_P_unit,XmNactivateCallback,neur_activate_CB,
   		(XtPointer)ID_PushB_P_unit);
   	
   	pushB_G_unit = XtVaCreateManagedWidget("pushB_G_unit",xmPushButtonWidgetClass,popup_other,
   		XmNlabelString,label_G_unit,NULL);
   	register_widget_CB(pushB_G_unit, (XtPointer)ID_PushB_G_unit, (XtPointer)0);
   	create_event_CB(pushB_G_unit, (XtPointer)ID_PushB_G_unit, (XtPointer)0);
   	XtAddCallback(pushB_G_unit,XmNactivateCallback,neur_activate_CB,
   		(XtPointer)ID_PushB_G_unit);
   	
   	pushB_tms = XtVaCreateManagedWidget("pushB_tms",xmPushButtonWidgetClass,popup_other,
   		XmNlabelString,label_tms,NULL);
   	register_widget_CB(pushB_tms, (XtPointer)ID_PushB_tms, (XtPointer)0);
   	create_event_CB(pushB_tms, (XtPointer)ID_PushB_tms, (XtPointer)0);
   	XtAddCallback(pushB_tms,XmNactivateCallback,neur_activate_CB,
   		(XtPointer)ID_PushB_tms);
   			
    XmStringFree(label_P_unit);
    XmStringFree(label_G_unit);
    XmStringFree(label_tms);
    
    
    register_widget_CB(popup_other, (XtPointer)ID_Popup_other, (XtPointer)0);
    
    retval = popup_other;
    return retval;
    
}

/*
 * Function: Createpopup_net()
 *			Create popup_net hierarchie of widgets
 */
Widget
Createpopup_net(parent)
Widget parent;
{
	Widget 	retval;
    Widget	popup_menu;
    Widget  togglelh,togglelap,toggleaph,pushorig,separator;
    XmString LHview,LAPview,APHview,origin;
    
    LHview = XmStringCreateSimple("Frontal View");
    LAPview = XmStringCreateSimple("Horizontal View");
    APHview = XmStringCreateSimple("Sagittal View");
    origin = XmStringCreateSimple("Origin");
    
 
    popup_menu = XmVaCreateSimplePopupMenu(parent,
     "popup", NULL,XmNradioBehavior,True,NULL);    
   	
   	togglelh=XtVaCreateManagedWidget("togglelh",xmToggleButtonWidgetClass,popup_menu,
   		XmNset,True,XmNlabelString,LHview,NULL);
   	register_widget_CB(togglelh, (XtPointer)ID_ToggleB_popup_LHview, (XtPointer)0);
   	create_event_CB(togglelh, (XtPointer)ID_ToggleB_popup_LHview, (XtPointer)0);
   	XtAddCallback(togglelh,XmNvalueChangedCallback,popup_CB,
   		(XtPointer)ID_ToggleB_popup_LHview);
   	
   	togglelap=XtVaCreateManagedWidget("togglelap",xmToggleButtonWidgetClass,popup_menu,
   		XmNlabelString,LAPview,NULL);
   	register_widget_CB(togglelap, (XtPointer)ID_ToggleB_popup_LAPview, (XtPointer)0);
   	create_event_CB(togglelap, (XtPointer)ID_ToggleB_popup_LAPview, (XtPointer)0);
    XtAddCallback(togglelap,XmNvalueChangedCallback,popup_CB,
   		(XtPointer)ID_ToggleB_popup_LAPview);
   		
    toggleaph=XtVaCreateManagedWidget("toggleaph",xmToggleButtonWidgetClass,popup_menu,
   		XmNlabelString,APHview,NULL);
   	register_widget_CB(toggleaph, (XtPointer)ID_ToggleB_popup_APHview, (XtPointer)0);
   	create_event_CB(toggleaph, (XtPointer)ID_ToggleB_popup_APHview, (XtPointer)0);
    XtAddCallback(togglelap,XmNvalueChangedCallback,popup_CB,
   		(XtPointer)ID_ToggleB_popup_APHview);
    
    separator = XtVaCreateManagedWidget("separator",xmSeparatorWidgetClass,popup_menu,
    	NULL);
    
    pushorig=XtVaCreateManagedWidget("pushorig",xmPushButtonWidgetClass,popup_menu,
   		XmNlabelString,origin,NULL);
   	register_widget_CB(pushorig, (XtPointer)ID_PushB_popup_origin, (XtPointer)0);
   	create_event_CB(pushorig, (XtPointer)ID_PushB_popup_origin, (XtPointer)0);
    XtAddCallback(pushorig,XmNactivateCallback,popup_CB,
   		(XtPointer)ID_PushB_popup_origin);
   		
    XmStringFree(LHview);
    XmStringFree(LAPview);
    XmStringFree(APHview);
    XmStringFree(origin);
    
    register_widget_CB(popup_menu, (XtPointer)ID_Popup_net, (XtPointer)0);
    
    retval = popup_menu;
    return retval;
    
}



/*
 * Function: Createpopup_nucleus()
 *			Create popup_nucleus hierarchie of widgets
 */
Widget
Createpopup_nucleus(parent)
Widget parent;
{
	Widget 	retval;
    Widget	popup_menu;
    Widget  togglelh,togglelap,toggleaph,pushorig,separator;
    XmString LHview,LAPview,APHview,origin;
    
    LHview = XmStringCreateSimple("Frontal View");
    LAPview = XmStringCreateSimple("Horizontal View");
    APHview = XmStringCreateSimple("Sagittal View");
    origin = XmStringCreateSimple("Origin");
    
 
    popup_menu = XmVaCreateSimplePopupMenu(parent,
     "popup", NULL,XmNradioBehavior,True,NULL);    
   	
   	togglelh=XtVaCreateManagedWidget("togglelh",xmToggleButtonWidgetClass,popup_menu,
   		XmNset,True,XmNlabelString,LHview,NULL);
   	register_widget_CB(togglelh, (XtPointer)ID_ToggleB_nucl_LHview, (XtPointer)0);
   	create_event_CB(togglelh, (XtPointer)ID_ToggleB_nucl_LHview, (XtPointer)0);
   	XtAddCallback(togglelh,XmNvalueChangedCallback,popup_CB,
   		(XtPointer)ID_ToggleB_nucl_LHview);
   	
   	togglelap=XtVaCreateManagedWidget("togglelap",xmToggleButtonWidgetClass,popup_menu,
   		XmNlabelString,LAPview,NULL);
   	register_widget_CB(togglelap, (XtPointer)ID_ToggleB_nucl_LAPview, (XtPointer)0);
   	create_event_CB(togglelap, (XtPointer)ID_ToggleB_nucl_LAPview, (XtPointer)0);
    XtAddCallback(togglelap,XmNvalueChangedCallback,popup_CB,
   		(XtPointer)ID_ToggleB_nucl_LAPview);
   		
    toggleaph=XtVaCreateManagedWidget("toggleaph",xmToggleButtonWidgetClass,popup_menu,
   		XmNlabelString,APHview,NULL);
   	register_widget_CB(toggleaph, (XtPointer)ID_ToggleB_nucl_APHview, (XtPointer)0);
   	create_event_CB(toggleaph, (XtPointer)ID_ToggleB_nucl_APHview, (XtPointer)0);
    XtAddCallback(togglelap,XmNvalueChangedCallback,popup_CB,
   		(XtPointer)ID_ToggleB_nucl_APHview);
    
    separator = XtVaCreateManagedWidget("separator",xmSeparatorWidgetClass,popup_menu,
    	NULL);
    
    pushorig=XtVaCreateManagedWidget("pushorig",xmPushButtonWidgetClass,popup_menu,
   		XmNlabelString,origin,NULL);
   	register_widget_CB(pushorig, (XtPointer)ID_PushB_nucl_origin, (XtPointer)0);
   	create_event_CB(pushorig, (XtPointer)ID_PushB_nucl_origin, (XtPointer)0);
    XtAddCallback(pushorig,XmNactivateCallback,popup_CB,
   		(XtPointer)ID_PushB_nucl_origin);
   		
    XmStringFree(LHview);
    XmStringFree(LAPview);
    XmStringFree(APHview);
    XmStringFree(origin);
    
    register_widget_CB(popup_menu, (XtPointer)ID_Popup_nucleus, (XtPointer)0);
    
    retval = popup_menu;
    return retval;
    
}

#endif
