/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	THIS C SOURCE CODE FILE CONTAINS THE MAIN LOOP FUNCTION 

	network_editor is the full featured network editor for XNBC.

	The first version was written by Stephane Rimbaud

	Other versions were modified by JF Vibert

	V 1.7: Modified to fit a 1024x768 screen (JFV) 12 july 2000
	V 1.8:  Adaptation a Windws: lecture de .ntw au lieu de .lnk (JFV)  13 sep 2001 
	
	This distributed under the GPL licence

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

#ifndef _NETWORK_MAIN_
#define _NETWORK_MAIN_

/*
 * Generated by the ICS builderXcessory (BX).
 *
 *
 * Builder Xcessory 3.1.
 *
 */
/*
 * MOTIF and X include files needed for widget
 * creation and toolkit initialization.
 */
#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#if (XmVersion >= 1002)
#include <Xm/RepType.h>
#endif

/* type definitions include files */
#ifndef _TYPESDEFINED_
#include "newtypes.h"
#endif

/* application globals include files */
#ifndef _GLOBAL_NETWORK_
#include "creation_network.h"
#endif

/* type definitions include files */
#ifndef _TYPESDEFINED_
#include "newtypes.h"
#endif

/* prototypes include files */
#ifndef _PROTOTYPES_
#include "prototypes.h"
#endif

#include "icon.h"

/*
 * Application name and class definition.
 */
#define BX_APP_NAME "NBC NETWORK EDITOR :"
#define BX_APP_CLASS "NBC NETWORK EDITOR :"

#include "find_files.h"

/*
 * Main Program.
 */
int main(argc, argv)
int argc;
char **argv;
{
  	Display *display;
  	Arg args[256];
  	Cardinal argcnt;
  	Boolean argok;
  	XtAppContext context;
  	char *savefile_name;
	char buffer[255];
	char *pt;
	Pixmap icon;
	int width,height,i;
	XmString string;

    XtToolkitInitialize();
    context = XtCreateApplicationContext();
    app_context = context;
    
    network_modified = False;
    keep_ps = False;
    /* initialization of the network */
	current_network=(Network *)NULL;
	init_network();
	init_directories();
	
	savefile_name = current_network->name;

    /* arguments analysis */

	for (i = 1; i < argc; i++)
	{
		switch(argv[i][0])
		{
			case '-':
				switch(argv[i][1])
				{
					case 'h':
						printf("usage: network_editor [-h] [-k] [file_in]\n");
						printf("switches:\n");
						printf("\t1) -h to print this.\n");
						printf("\t2) -k keep the PostScript file.\n");
						printf("\t3) input_file file (*.ntw): without extension is assumed as *.ntw.\n");
						exit(0);
					case 'k':
						keep_ps = True;
						break;
					default:
						printf("\007Illegal switch\n");
						exit(0);
				} /* fin du switch */
			default:
				strcpy(savefile_name,argv[i]);
		} /* fin du switch */
	} /* fin du for */

	if((display = XOpenDisplay(NULL)) == NULL)
	{
		printf("FATAL ERROR : Can't open default display for the XNBC Network Editor (%s)\n",argv[0]);
		exit(1);
	}
	else
		the_display = display;

	strcpy(savefile_name,get_network_name());

    /*
     * So converters work.
     */
    XtInitializeWidgetClass(applicationShellWidgetClass);
    /*
     * Install the tearOffModel resource converter.
     */
#if (XmVersion >= 1002)
    XmRepTypeInstallTearOffModelConverter();
#endif

    /*
     * Register special BuilderXcessory converters.
     */
    RegisterBxConverters(context);
    
    app_context = context;
    
    XtDisplayInitialize(context, display, BX_APP_NAME ,
	                    NULL, NULL, 0, &argc, argv);

    /*
     * The applicationShell is created as an unrealized
     * parent for multiple topLevelShells.  The topLevelShells
     * are created as popup children of the applicationShell.
     * This is a recommendation of Paul Asente & Ralph Swick in
     * _X_Window_System_Toolkit_ p. 677.
     */
    argcnt = 0;
    AppShell = XtAppCreateShell( BX_APP_NAME, BX_APP_CLASS,
            applicationShellWidgetClass, display, args, argcnt);
    

    FormD_generic_link_editor = CreateformD_generic_link_editor(AppShell);

    FormD_nucleus_parameters = CreateformD_nucleus_parameters(AppShell);

    FormD_nucleus_composition = CreateformD_nucleus_composition(AppShell);

    FormD_adjustement_curve = CreateformD_adjustement_curve(AppShell);

    FormD_link_simple = CreateformD_link_simple(AppShell);

    FormD_generic_link_matrix = CreateformD_generic_link_matrix(AppShell);

    FormD_neuron_edit = CreateformD_neuron_edit(AppShell);

    FormD_Nucleus = CreateformD_Nucleus(AppShell);
    
    FormD_n_p_generator = Createn_p_generator_form(AppShell);
    
    FormD_help = Createhelp_form(AppShell);
    
    FormD_plot = Createform_plot(AppShell);
    
    FormD_custom = Createform_custom(AppShell);
   
    XtInitializeWidgetClass(topLevelShellWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 223); argcnt++;
    XtSetArg(args[argcnt], XmNy, 364); argcnt++;
    sprintf(buffer,"XNBC Network Editor V%s: ",VERSION);
    toplevel = XtCreatePopupShell(buffer, 
        topLevelShellWidgetClass, AppShell, args, argcnt);

    MainW_network = CreatemainW_network(toplevel);

	Popup_net = Createpopup_net(widget_array[ID_DrawingA_net]);
	
	Popup_nucleus = Createpopup_nucleus(widget_array[ID_DrawingA_nucleus_view]);

    XtManageChild(MainW_network);
    XtPopup(XtParent(MainW_network), XtGrabNone);

	
	
	/* create GC , colormap ,alloc colors */
 	
	
	black = BlackPixel (the_display, DefaultScreen (the_display));
	white = WhitePixel (the_display, DefaultScreen (the_display));
	the_colormap = initialize_colors(the_display);
	
	green = colors[C_GREEN];
	grey = colors[C_GREY];
	blue[0] = colors[C_BLUE_0];
	blue[1] = colors[C_BLUE_1];	
	blue[2] = colors[C_BLUE_2];
	blue[3] = colors[C_BLUE_3];
	blue[4] = colors[C_BLUE_4];
	red[0] = colors[C_RED_0];
	red[1] = colors[C_RED_1];
	red[2] = colors[C_RED_2];
	red[3] = colors[C_RED_3];
	red[4] = colors[C_RED_4];
	color_view[0] = colors[C_COLOR_VIEW_0];
	color_view[1] = colors[C_COLOR_VIEW_1];
	color_view[2] = colors[C_COLOR_VIEW_2];

	the_GC = DefaultGC(	the_display,DefaultScreen (the_display));	
	
	interpolation_type = _LINEAR_;
		
	/* set the drawing area of the network at its defaults values */
	width = current_network->work_width[which_network_view()];
	height = current_network->work_height[which_network_view()];
	XtVaSetValues(widget_array[ID_DrawingA_net],
		XmNwidth,width,XmNheight,height,NULL);
	
	/* create the network pixmap */
	network_pixmap = XCreatePixmap(display,
		XtWindow(widget_array[ID_DrawingA_net]),
		width,height,
		DefaultDepth(the_display,DefaultScreen (the_display)));
	
	XSetForeground(the_display,the_GC,color_view[which_network_view()]);
	XSetBackground(the_display,the_GC,black);
	XFillRectangle(display,network_pixmap,the_GC,0,0,width,height);
	XtVaSetValues(widget_array[ID_DrawingA_net],
		XmNbackgroundPixmap,network_pixmap,XmNresizePolicy,XmRESIZE_NONE,NULL);
	
	/* draw the net axes */
	draw_net_axes();
	
	XClearWindow(display,XtWindow(widget_array[ID_DrawingA_net]));
	
	/* create the network editor icon */
	icon  = XCreateBitmapFromData (display, DefaultRootWindow(display),
	    icon_bits, icon_width, icon_height);
	XtVaSetValues(XtParent(MainW_network),XtNiconPixmap,icon,NULL);    
	
	enable_label_net = 1;
	
	working_cursor = XCreateFontCursor(display,150);
	/* 150 c'est l'id du curseur "montre" */
	
	/* neuron file list initialization */
	init_neuron_file_list();
	
	
	/* file argument */
	if(*savefile_name)
	{
		if((pt = strstr(savefile_name,".ntw"))!=NULL)
			*pt='\0';
		strcpy(working_file,savefile_name);
		strcat(working_file,".ntw");
		
		if(pt = strrchr(savefile_name,'/'))
		{	
			*pt='\0';
			pt++;
			strcpy(buffer,pt);
			strcpy(current_network->name,buffer);
		}
		strcpy(buffer,"XNBC Network Editor : ");
		strcat(buffer,current_network->name);	
		
		update_directories(working_file);
		
		XDefineCursor(the_display,XtWindow(widget_array[ID_MainW_network]),
			working_cursor);
		if(!read_network())
		{
			
			for(i=0 ; i<3 ; i++)
			{
				current_network->origin_x[i] = current_network->work_width[i]/2;
				current_network->origin_y[i] = current_network->work_height[i]/2;
			}
			enable_net_menu(True);
			XtVaSetValues(XtParent(MainW_network),XmNtitle,buffer,NULL);
			redisplay_network();
		}
		else
		{	
			enable_net_menu(False);
			XtVaSetValues(XtParent(MainW_network),XmNtitle,buffer,NULL);
		}
		XDefineCursor(the_display,XtWindow(widget_array[ID_MainW_network]),
			NULL);
	}
	else
	{
		enable_net_menu(False);
		sprintf(buffer,"XNBC Network Editor V%s: [no name]", VERSION);
		XtVaSetValues(XtParent(MainW_network),XmNtitle,
			buffer,NULL);
	}
	
	initialize_customizations(_NETWORK_);
	read_customizations();
	initialize_customizations(_NUCLEUS_);
	initialize_customizations(_NETWORK_);
	display_help(1);
	
	/* loop */
    XtAppMainLoop(context);
}


/*******************************************************************************
	Function for initializing colors for the specified display
*******************************************************************************/
Colormap initialize_colors(Display *display)
{

	Visual *visual;
	XGCValues gc_values;
	XColor current_color,color_def,color_true;
	Colormap default_cmap;
	Colormap new_cmap;
	int i;
	int need_cmap;
	
	
	
	
	visual = DefaultVisual(display,DefaultScreen(display));
	switch(visual->class)
	{
		case GrayScale:
		case DirectColor:
		case PseudoColor:
			need_cmap = True;
			break;
		case StaticColor:
		case StaticGray:
		case TrueColor:		
			need_cmap = False;
			break;
	}

	default_cmap = DefaultColormapOfScreen(DefaultScreenOfDisplay(display));
	
	for(i=0 ; i<256 ; i++)
		colors[i] = i;
	
	if(need_cmap)
	{
		if(BlackPixel(display, DefaultScreen(display)) == 0)
		{
			c_black = 0;
			c_white = 1;
		}
		else
		{
			c_black = 1;
			c_white = 0;
		}
		
		new_cmap = default_cmap;
		private = False;
		
		
		if(!XAllocNamedColor(display, new_cmap, "black", &color, &rgb))
		{
			new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
			/*Copy the default colormap in the private one*/
			for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
			{
				current_color.pixel = i;
				XQueryColor(display, default_cmap, &current_color);
				XStoreColor(display, new_cmap, &current_color);
			}
			private = True;
			XStoreNamedColor(display, new_cmap, "black", c_black, DoRed | DoGreen | DoBlue);
		
		}
		colors[c_black] = color.pixel;
		
		if(!XAllocNamedColor(display, new_cmap, "white", &color, &rgb))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}	
			XStoreNamedColor(display,new_cmap , "white", c_white, DoRed | DoGreen | DoBlue);
		}
		colors[c_white] = color.pixel;
		
		if(!XAllocNamedColor(display, new_cmap, "green", &color, &rgb))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}	
			XStoreNamedColor(display,new_cmap , "green", C_GREEN, DoRed | DoGreen | DoBlue);
		}
		colors[C_GREEN] = color.pixel;
		
		if(!XAllocNamedColor(display, new_cmap, "gainsboro", &color, &rgb))	
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}	
			XStoreNamedColor(display, new_cmap, "gainsboro", C_GREY, DoRed | DoGreen | DoBlue);
		}
		colors[C_GREY] = color.pixel;
		
		XParseColor(display, new_cmap, "#E3E3FF", &color); /*227 227 255*/
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}	
			color.pixel = C_BLUE_0;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_BLUE_0] = color.pixel;
		
		XParseColor(display, new_cmap, "#C7C7FF", &color);/* 199 199 255 */
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}	
			color.pixel = C_BLUE_1;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_BLUE_1] = color.pixel;	
		
		XParseColor(display, new_cmap, "#AAAAFF", &color);/* 170 170 255 */
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}	
			color.pixel = C_BLUE_2;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_BLUE_2] = color.pixel;
		
		XParseColor(display, new_cmap, "#7171FF", &color);/* 113 113 255 */
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}	
			color.pixel = C_BLUE_3;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_BLUE_3] = color.pixel;
		
		XParseColor(display, new_cmap, "#0000FF", &color);
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}	
			color.pixel = C_BLUE_4;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_BLUE_4] = color.pixel;
		
		XParseColor(display, new_cmap, "#FFE3E3", &color);/* 255 227 227 */
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}	
			color.pixel = C_RED_0;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_RED_0] = color.pixel;
		
		XParseColor(display, new_cmap, "#FFC7C7", &color);/* 255 199 199 */
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}
			color.pixel = C_RED_1;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_RED_1] = color.pixel;
		
		XParseColor(display, new_cmap, "#FFAAAA", &color);/* 255 170 170 */
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}
			color.pixel = C_RED_2;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_RED_2] = color.pixel;
		
		XParseColor(display, new_cmap, "#FF8E8E", &color);/* 255 142 142 */
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}
			color.pixel = C_RED_3;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_RED_3] = color.pixel;
		
		XParseColor(display, new_cmap, "#FF0000", &color);
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}
			color.pixel = C_RED_4;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_RED_4] = color.pixel;

		XParseColor(display, new_cmap, "#FFFFE0", &color);/*255 255 224*/
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}
			color.pixel = C_COLOR_VIEW_0;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_COLOR_VIEW_0] = color.pixel;
		
		XParseColor(display, new_cmap, "#E1FCF1", &color); /*225 252 241*/
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}
			color.pixel = C_COLOR_VIEW_1;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_COLOR_VIEW_1] = color.pixel;
		
		XParseColor(display, new_cmap, "#FFEBF9", &color);/*255 235 249*/
		if(!XAllocColor(display, new_cmap, &color))
		{
			if(!private)
			{
				new_cmap = XCreateColormap(display, XtWindow(toplevel), 
						  DefaultVisual(display, DefaultScreen(display)),
						   AllocAll);
				/*Copy the default colormap in the private one*/
				for(i=0; i < CellsOfScreen(DefaultScreenOfDisplay(display)); i++)
				{
					current_color.pixel = i;
					XQueryColor(display, default_cmap, &current_color);
					XStoreColor(display, new_cmap, &current_color);
				}
				private = True;
			}
			color.pixel = C_COLOR_VIEW_2;
			color.flags = (DoRed | DoGreen | DoBlue);
			XStoreColor(display, new_cmap, &color);
		}
		colors[C_COLOR_VIEW_2] = color.pixel;
		
		XSetWindowColormap(display, XtWindow(toplevel), new_cmap);

		
	}
	else
	{
		new_cmap = default_cmap;
		
		c_black = 0;
		c_white = 1;
		
		colors[c_black] = BlackPixel(display, DefaultScreen(display));
		colors[c_white] = WhitePixel(display, DefaultScreen(display));
		
		XAllocNamedColor(display, new_cmap, "green", &color, &rgb);
		colors[C_GREEN] = color.pixel;
		
		XAllocNamedColor(display,new_cmap , "gainsboro", &color, &rgb);
		colors[C_GREY]= color.pixel;
		
		XParseColor(display, new_cmap, "#E3E3FF", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_BLUE_0] = color.pixel;
		
		XParseColor(display, new_cmap, "#C7C7FF", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_BLUE_1] = color.pixel;	
		
		XParseColor(display, new_cmap, "#AAAAFF", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_BLUE_2] = color.pixel;
		
		XParseColor(display, new_cmap, "#7171FF", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_BLUE_3] = color.pixel;
		
		XParseColor(display, new_cmap, "#0000FF", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_BLUE_4] = color.pixel;
		
		XParseColor(display, new_cmap, "#FFE3E3", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_RED_0] = color.pixel;
		
		XParseColor(display, new_cmap, "#FFC7C7", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_RED_1] = color.pixel;
		
		XParseColor(display, new_cmap, "#FFAAAA", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_RED_2] = color.pixel;
		
		XParseColor(display, new_cmap, "#FF8E8E", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_RED_3] = color.pixel;
		
		XParseColor(display, new_cmap, "#FF0000", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_RED_4] = color.pixel;
		
		XParseColor(display, new_cmap, "#FFFFE0", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_COLOR_VIEW_0] = color.pixel;
		
		XParseColor(display, new_cmap, "#E1FCF1", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_COLOR_VIEW_1] = color.pixel;
		
		XParseColor(display, new_cmap, "#FFEBF9", &color);
		XAllocColor(display, new_cmap, &color);
		colors[C_COLOR_VIEW_2] = color.pixel;
	}
	
	return new_cmap;


}


/*******************************************************************************
	Function for managing and displaying the help
*******************************************************************************/
void display_help(int flag)
{
	
	int count;
	int *pos;
	FILE *fp;
	char *pt;
	char file_name[256];
	XmString string;
	char buffer[256];
	static char **help_files;
	static char **topics;
	Widget w;
	static int nb_items;
	char *text;
	int i;
	long l;
	
#ifdef __CYGWIN__
#	define SEP_DIR "\\"
#	define CR 2
#else
#	define SEP_DIR "/"
#	define CR 1
#endif

	if(flag == -1)
	{
		for(i=0 ; i<nb_items ; i++)
		{
			free(help_files[i]);
			free(topics[i]);
		}
		free(help_files);
		free(topics);
		return;
	}
	
	if(!nb_items)
	{
		strcpy(file_name,help_directory);
		strcat(file_name,SEP_DIR);
		strcat(file_name,"net_hlprc");
		
		if(!(fp = fopen(file_name,"r")))
		{
			sprintf(buffer,"Sorry, file %s not found...",file_name);
			display_error(widget_array[ID_MainW_network],buffer,
				"No Help Available !");
			return;
		}
		
		nb_items = 0;
		
		while(fgets(buffer,255,fp))
		{
			if (buffer[0] == '#')		/* commented out */
				continue;

			pt = strrchr(buffer,':');
			if(!pt)
				continue;
			nb_items++;
			*pt = '\0';
			pt += 2;
			if(nb_items == 1)
			{
				help_files = (char **)calloc(1,nb_items*sizeof(char *));
				topics = (char **)calloc(1,nb_items*sizeof(char *));
				topics[nb_items - 1] = (char *)calloc(1,(strlen(buffer)+1)*sizeof(char));
				strcpy(topics[nb_items - 1],buffer);
				help_files[nb_items - 1] = (char *)calloc(1,(strlen(pt)+1)*sizeof(char));
				strcpy(help_files[nb_items - 1],pt);
				help_files[nb_items - 1][strlen(pt)- CR] = '\0';
			}
			else
			{
				help_files = (char **)realloc(help_files,nb_items*sizeof(char *));
				topics = (char **)realloc(topics,nb_items*sizeof(char *));
				topics[nb_items - 1] = (char *)calloc(1,(strlen(buffer)+1)*sizeof(char));
				strcpy(topics[nb_items - 1],buffer);
				help_files[nb_items - 1] = (char *)calloc(1,(strlen(pt)+1)*sizeof(char));
				strcpy(help_files[nb_items - 1],pt);
				help_files[nb_items - 1][strlen(pt)- CR] = '\0';
			}	
		}
		
		for(i=0 ; i<nb_items ; i++)
		{
			string = XmStringCreateLocalized(topics[i]);
     		w = XtVaCreateWidget(topics[i],
				xmPushButtonWidgetClass,
				widget_array[ID_topic_pulldownMenu],NULL);
		
     		XtAddCallback(w, XmNactivateCallback, help_CB, (XtPointer)(i+1));
    		XtManageChild(w);
			XmStringFree(string);
		
			
		}
		flag = 1;	
		
	}
	
	
	

	strcpy(file_name,help_directory);
	strcat(file_name,SEP_DIR);
	strcat(file_name,help_files[flag-1]);
		
	if(!(fp = fopen(file_name,"r")))
	{
		sprintf(buffer,"Sorry, file %s not found...",file_name);
		display_error(widget_array[ID_help_form],buffer,
			"Topic Not Available !");
		return;
	}
	
	
	fseek(fp, 0L, SEEK_END);
	l = ftell(fp)+1;
	text = (char *)calloc(1,l*sizeof(char));
	fseek(fp, 0L, SEEK_SET);
	fread(text, l*sizeof(char), 1, fp);
	text[l-1] = '\0';
	
	XmTextSetString(widget_array[ID_help_text],text);
	
	string = XmStringCreateLocalized(topics[flag-1]);
	XtVaSetValues(widget_array[ID_topic_label],XmNlabelString,string,NULL);
	XmStringFree(string);
	
	
	free(text);		

}


#endif
