/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	THIS C HEADER FILE CONTAINS THE GENERAL DATA TYPES DEFINITIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/


#ifndef _TYPESDEFINED_
#define _TYPESDEFINED_
#include <Xm/Xm.h>



typedef struct {
		char *func;
		int offset;
		int pos;
		int set;
		} FUNC;

typedef struct
{
	float	H;
	float	L;
	float	AP;
	
} NEURON_ANATOMY;

typedef struct
{
	short target_id;
	short nmda;
	short synaptic_knobs;
	float axone_length;

} Connection;

typedef struct
{
	Widget				form;
	Pixmap				bgnd;
	unsigned long		color;
	short				neuron_id;
	short				number;
	short				selected;
	short				extremity;
	NEURON_ANATOMY		anatomy;
	short 				connected_neurons;
	Connection 			*connections;

} NEURON;


typedef struct
 {
	short 	cluster_id;
	short   number;
	short	nb_neurons;
	short	first_neuron;
	short	last_neuron;
	NEURON 	**neuron_array;
	float	H;
	float	L;
	float	AP;
	float	delta_H;
	float	delta_L;
	float	delta_AP;
	char	*neuron_file;
	char	ch_name[20];
		
} CLUSTER_WIDGET;

typedef struct
{
	float probability;
	float length;
	float density;
	float real_density;

} PROBA_POINT;

typedef struct
{
	Widget form;
	Pixmap bgnd;
	unsigned int color;

}	GRAPHIC_ITEM;

typedef struct
{
	short	source_id;
	short	target_id;
	float	axone_mean;
	float	axone_sd;
	short	min_knobs;
	short	max_knobs;
	short	nmda;
	short	type;
	short	level;
	NEURON  *source;
	NEURON  *target;
	PROBA_POINT points[10];
	short	points_placed;
	
} LINK_PARAMETERS;

typedef struct
{
	char nucleus_name[32];
	short nucleus_id;
	short number;
	short nb_clusters;
	short nb_links;
	short nb_neurons;
	short work_width[3];
	short work_height[3];
	short origin_x[3];
	short origin_y[3];
	CLUSTER_WIDGET **cluster_array;
	LINK_PARAMETERS **link_array;
	Widget form;
	Pixmap bgnd;
	unsigned long color;
	short posX[3];
	short posY[3];
	short first_neuron;
	short last_neuron;
	short selected;
	short specific;
	float H;
	float L;
	float AP;
	float delta_H;
	float delta_L;
	float delta_AP;
	
} Nucleus_widget;


typedef struct 
{
	char name[256];
	short nb_nucleus;
	short nb_links;
	short nb_neurons;
	short work_width[3];
	short work_height[3];
	short origin_x[3];
	short origin_y[3];
	Nucleus_widget **nucleus_array;
	LINK_PARAMETERS **link_array;

} Network;

#endif
