/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	THIS C HEADER FILE CONTAINS ALL THE PROTOTYPES OF THE FUNCTIONS 
	USED IN THE NBC 7.0 NETWORK EDITOR WITH A SHORT EXPLANATION FOR
	EACH PROCEDURE, WHAT AND WHERE TO FIND IT: 
		IT IS FOR DEVELOPPING PURPOSE. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

#ifndef _PROTOTYPES_
#define _PROTOTYPES_

#ifndef _TYPESDEFINED_
#include "newtypes.h"
#endif


/*
 * Shell callback procedure declarations
 */

/* %%%%source code in network_editor.c%%%% */

int main(); 				/* main loop and initializing function */

Colormap initialize_colors();
							/* Function for initializing colors for the specified
							display */

void display_help();		/* Function for managing and displaying the help */				

/* %%%%source code in callbacks_network.c%%%% */


void resize_CB();       	/* callback for all resize events */

void input_CB();			/* callback for all drawing areas input events */

void list_browse_CB();		/* callback for specific list events */

void register_widget_CB();	/* callback for IDs registration */

void create_event_CB();  	/* callback for event handlers registration */

void help_CB();				/* specific help callback */

void net_activate_CB();		/* callback for general network activation events */

void nucl_activate_CB();	/* callback for general nucleus activation events */

void neur_activate_CB();	/* callback for general neuron activation events */

void link_activate_CB();	/* callback for general link activation events */
	
void toggle_CB();			/* callback specific for all toggle buttons events */ 

void expose_CB();			/* callback for all expose events */

void list_selection_CB();	/* callback for list selection events */

void scale_CB();			/* callback for specific scale widget events */

void popup_CB();			/* callback for general popup menus events */

/*
 * Forward declaration of widget create routines,
 * usually located in the creation file.
 */
 
/* %%%%source code in creation_network-*.c%%%%% */ 

/*----------1----------------*/

void BxRegisterConverters();	/* private BuilderXcessory init. function */ 

Widget Createpopup_other();		/* creation function for the popup in the
								neuron editor */ 

Widget Createpopup_net();		/* creation function for the popup in the 
								network area */

Widget Createpopup_nucleus();	/* creation function for the popup in the 
								nucleus area */

/*----------2-----------------*/

Widget CreateformD_generic_link_editor();
								/* creation function for generic link editor */

/*----------3------------------*/

Widget CreateformD_nucleus_parameters();
								/* creation function for the nucleus parameters 
								dialog box */
								
Widget CreateformD_nucleus_composition();
								/* creation function for the nucleus composition
								dialog box */

/*----------4------------------*/

Widget CreateformD_adjustement_curve();
								/* creation function for the connectivity curve 
								dialog box */
								
Widget CreateformD_link_simple();
								/* creation function for the neuron to neuron 
								link dialog box */

/*----------5------------------*/

Widget CreateformD_generic_link_matrix();
								/* creation function for the generic link
								matrix editor */

Widget CreateformD_neuron_edit();
								/* creation function for the neuron editor */

/*----------6------------------*/

Widget CreateformD_Nucleus();	/* creation function for the nucleus editor */

/*----------7------------------*/

Widget CreatemainW_network();	/* creation function for the network editor */

/*----------8------------------*/

Widget Createhelp_form();		/* create the help on context dialog box */

Widget Createn_p_generator_form();
								/* create the neuron placement generator */                     

Widget Createform_custom();		/* create the customizations dialog box */


/*
 * Function prototypes for routines
 * located in utilities file.
 */

/* %%%%source code in bxutil.c%%%% */

extern XtPointer CONVERT();

extern void MENU_POST();

extern void RegisterBxConverters();

/* => BuilderXcessory private functions utilities */

#include "ne_alea.h"				/* random functions */ 

/*
 * User procedures
 */

/* %%%%source code in network_functions.c%%%% */ 

int exit_network();				/* Function for exiting nbc network editor */

void fill_label_net_info();		/* Function providing the help on line 
								in the main window */

void clear_label_net_info(); 	/* Function for clearing the help on 
								line label */

int clear_network();			/* Function providing a warning before
								resetting the network,and call reset_network() */

int open_network();				/* Function for opening a new network file */

int save_network();				/* Function for saving the network into 
								specific files */

int read_network();				/* Function for loading the network from 
								the different files */

int write_network();			/* Function that creates explicitly the 
								different files for saving the net */

int destroy_network();			/* Function for destroying and freeing 
								the network structure */

int reset_network();			/* Function for destroying explicitly the 
								nucleus,link and tree */

int enable_net_menu();			/* Function for activating or deactivating 
								the net menus buttons */

int init_network();				/* Function for allocating and initializing 
								the network structure */

int draw_net_axes();			/* Function that simply draws the axes	of
								the network area, using the global 
								Graphic Context	*/

int which_network_view();		/* Function that return the number of the
								current net view */

int redisplay_network();		/* Function for redisplaying the network 
								when the view changed */

int redefine_origin();			/* Function for redefining the coordinates 
								of the origin in the current view in the network */

void move_origin();				/* Function for moving network axes */

void set_new_origin();			/* Function for setting origin of the network
								axes */

void move_neuron();				/* Function for moving a dashed neuron in the
								network area */

void set_neuron();				/* Function for controling placement of a new neuron
								in the network area and then creating it */

void move_nucleus();			/* Function for moving a dashed nucleus in 
								the network area */

void set_nucleus();				/* Function for controling placement of a new nucleus
								in the network area and then creating it */

int new_neuron();				/* Function for creation of a new neuron */

int new_nucleus();				/* Function for creation of a new nucleus */

Nucleus_widget *alloc_nucleus_net();
								/* Function for allocating a nucleus in the
								network */
								
Nucleus_widget *alloc_neuron_net();
								/* Function for allocating a neuron in the 
								network (1 neuron = nucleus) */
								
char *get_name();				/* Function giving default names depending
								on the context */
								
int manage_neuron_id();			/* Function that generates a unique neuron id */

int manage_nucleus_id();		/* Function that generates a unique nucleus id */

int manage_cluster_id();		/* Function that generates a unique cluster id */

void deselect_all_nucleus();	/* Function that deselects all the selected
				 				nucleus in the network */
				 				
int nucleus_name_already_exists();
								/* Functions for verifying exiting  nucleus name or not */
								
int cluster_name_already_exists();
								/* Functions for verifying exiting  cluster name or not */
								
void update_numbers();			/* Function for updating the nucleus,clusters and 
								neurons numbers */									 				
				 				
				 				

/* %%%%source code in neuron_functions.c%%%% */

int save_neuron_file_list(); 	/* Function for saving the neuron file list */

int init_neuron_file_list();	/* Function for initializing the neuron 
								file list */

int apply_neuron();				/* Function for checking the neuron editor
			 					fields and register modifications if any */

void select_neuron_type();		/* Function for selecting the neuron type file */

void modify_neuron();			/* Function for editing and modifying a 
								selected neuron */

void copy_neuron();				/* Function for copying an existing selected 
								neuron */

void set_neuron_editor_fields_for_copy();
								/* Function for setting the neuron editor 
								fields when copying */

void delete_neuron();			/* Function for deleting an existing selected
					 			neuron */

void select_neuron();			/* Function for selecting a neuron in the nucleus 
								area */
								
NEURON *search_neuron();		/* Function for searching the neuron that 
								corresponds to the given id */
								
NEURON *get_first_selected_neuron();
								/* Function that returns the fisrt selected
								neuron */

void release_neuron();			/* Function for releasing and redrawing one 
								neuron after move */
								
void chplace_neuron();			/* Function for moving a neuron on the nucleus
 								area */
 								
void info_neuron();				/* Function for info on a neuron on the 
								nucleus area */					

int new_neuron_in_nucleus();	/* Function for creation of a new specific neuron
							 	in the current nucleus */
							 	
void move_neuron_in_nucleus();	/* 	Function for moving a dashed neuron in the 
								nucleus area */						 

void set_neuron_in_nucleus();	/* Function for controling placement of a new 
								neuron and then creating it in the nucleus area */

NEURON *alloc_new_neuron();		/* Function for allocating a new specific neuron */

int apply_neuron_in_nucleus();	/* Function for checking the neuron editor fields and register modifications
								if any , but on the nucleus level */

NEURON *identify_neuron();		/* Function for searching the neuron that corresponds 
								to the name and file */
								
void modify_neuron_in_nucleus();
								/* Function for editing and modifying a selected
								neuron in the nucleus area */

void delete_single_neuron();	/* Function for deleting a single neuron 
								structure */

void delete_neuron_in_nucleus();
								/* Function for deleting a neuron form the nucleus area */

void draw_one_network_link();	/* Function for drawing only one network link */


void draw_one_nucleus();		/* Function for redrawing one nucleus */


/* %%%%source code in nucleus_functions.c%%%% */


int apply_placement();			/* Function for apply placement in the neuron placement generator box */

void place_neurons_3D_equidistant();
								/* Function for  3D calculation of neurons equidistant placement */
								
void place_neurons_2D_equidistant();
								/* Function for  2D calculation of neurons equidistant placement */

void place_neurons_1D_equidistant();
								/* Function for  1D calculation of neurons equidistant placement */
		
void select_nucleus();			/* Function for selecting a nucleus */

void chplace_nucleus();			/* Function for moving a nucleus on the 
								network area */

void release_nucleus();			/* Function for releasing and redrawing the
					 			nucleus after one move */

void info_nucleus();			/* Function for info on a nucleus on the 
								network area */

Nucleus_widget *search_nucleus();
								/* Function for searching the nucleus that 
								corresponds to the given id */
								
CLUSTER_WIDGET *search_cluster();
								/* Function for searching the cluster that 
								corresponds to the given id */

Nucleus_widget *get_first_selected_nucleus();
								/* Function that returns the fisrt selected
								nucleus */

void destroy_nucleus();			/* Function for destroying the position 
								specified nucleus */

int apply_nucleus();			/* Function for applying nucleus parameters 
								changes	*/

int apply_cluster();			/* Function for applying generic components 
								from a nucleus composition */

void delete_nucleus();			/* Function for deleting a nucleus */

void copy_nucleus();			/* Function for copying a nucleus */

void modify_nucleus();			/* Function for modifying a nucleus */

void set_generic_menu();		/* Function for setting generic or specific
	 							menu in the nucleus editor */

void fill_label_nucl_info();	/* Function providing the help on line for 
								the nucleus editor */

void clear_label_nucl_info();	/* Function for clearing the help on line label
								in the nucleus editor */ 

int redisplay_nucleus();		/* Function for redisplaying the current 
								selected nucleus that is edited in the
								nucleus editor */

int draw_neurons();				/* Function that draws the neurons in the current
			 					nucleus area */				

void force_nucleus_scale();		/* Function that forces the nucleus scale toggles
				 				states */						

int redefine_nucleus_origin();	/* Function that redefines the nucleus origin */

int	draw_nucleus_axes();		/* Function that draws the axes in the current 
								view of the current selected nucleus */

int draw_neuron_links();		/* Function that draws the neuron links */

int which_nucleus_view();		/* Function that return the number of the current
								nucleus view */

void set_nucleus_new_origin(); 	/* Function for setting origin of the nucleus axes */

void move_nucleus_origin(); 	/* Function for moving nucleus axes */

int add_new_cluster_in_array(); /* Function for adding one new cluster in the current 
								nucleus in both specific and generic mode */
								
void get_cluster_characteristics();
								/* Function for extracting cluster characteristics
								from a component of the list nucleus composition */

void delete_cluster();			/* Function for deleting a named cluster from 
								the current nucleus */

void refresh_composition();		/* Function for scanning the composition of the
	 							current nucleus and display it in the 
	 							composition list */
	 							
void clear_nucleus_view();		/* Function for cleanning the nucleus editor
					 			drawing area */
					 			
void correct_neurons_position(Nucleus_widget *nucleus_tmp,
	float old_l,float old_h,float old_ap); 
								/* Function for applying nucleus center moves 
								on neuron positions */
								
int redraw_one_neuron();		/* Function for redrawing only one specified neuron */

int update_radius();			/* Function that calculates the radius values for the nucleus */

void deselect_all_neuron();		/* Function that deselects all the selected neurons in the nucleus */

void generic_place_neurons();	/* Function for generic 3D calculation of neurons placement */

int update_center();			/* Function that calculates the center values for the nucleus */

void cancel_cluster();			/* Function for canceling cluster when newly created */

void draw_one_connection();		/* Function for drawing only one connection in a nucleus */


/* %%%%source code in link_functions.c%%%% */

void select_rectangle(Widget w,int message, XEvent *evt);
								/* Function for drawing a selection rectangle in the connection matrix */

void calculate_gauss();			/* Function for calculating the connecting rate for each point of the 
	connection curve of the current link according to the Gauss formula */

void fill_label_curve_info();	/* Function for filling the help on line label in the connectivity scope
								editor */
								
void clear_label_curve_info();	/* Function for clearing the help on line label in the connectivity scope
								editor */
								
void update_density() ;		/* Function for updating a nucleus level  generic link */


void fill_label_matrix_info();	/* Function providing the help on line for the matrix editor */

void clear_label_matrix_info();	/* Function for clearing the help on line label in the matrix editor */

void change_connection();		/* Function for updating connection in the network 
								structures */
								
void redraw_connection();		/* Function for redrawing one connection */

void modify_matrix();			/* Function for modifying the connection matrix */

void draw_matrix();				/* Function for drawing the connection matrix of between two arrays 
								of neurons with the specified resolution */

unsigned long eval_color();		/* Function for evaluating the color of a connection according to
								the max and min values of the current link */

int err_alloc_pixmap();			/* Error handler for pixmap allocation */

float absolute_length(float L1,float H1,float AP1,float L2,float H2,float AP2);
								/* Function that calculates the absolute length in mm 
								between two 3D entities */

LINK_PARAMETERS *alloc_new_link_net();
								/* Function for allocating a LINK_PARAMETERS 
								structure in the network level a filling it 
								with default values */

LINK_PARAMETERS *alloc_new_link_in_nucleus();
								/* Function for allocating a LINK_PARAMETERS 
								structure in the nucleus level a filling it 
								with default values */


void cancel_single_link();		/* Function for canceling single link when newly 
								created */
								
void cancel_generic_link();		/* Function for canceling generic link when newly 
								created */
								
void delete_link();				/* Function for deleting a specified link */

Connection *refresh_connections();
								/* Function for updating the connections array of
								the specified neuron */

void refresh_links();			/* Function for updating the links of the whole 
								network avoiding memory holes */

void modify_link();				/* Function for modifying an existing link */

LINK_PARAMETERS *search_link();	/* Function that return the link matched
								with the specified ids on the specified level */

int apply_generic_link();		/* Function for applying a generic link */

int apply_neuron_to_neuron_link();
								/* Function for applying a single neuron
								to neuron link */

void create_default_generic_link();
								/* Function for allocating and filling with defaults value an whole
								generic link according to the current link structure */
								
LINK_PARAMETERS *add_new_link_in_nucleus();
								/* Function for adding a new link in a nucleus level */
								
void update_connections();		/* Function for updating a nucleus level  generic link */

Connection *add_new_connection();
								/* Function for adding a new connection */
								
NEURON *place_link_extremity();	/* Function for placing a network link extremity */

Connection *search_connection();
								/* Function for searching one connection */							

float interpolate_curve(float coef,LINK_PARAMETERS *link);		
								/* Function that returns an interpolated probability of connection */

float linear_interpolate(float coef,PROBA_POINT *points);		
								/* Function for linear interpolating probability */

void notify_neuron_deletion();	/* Function for notifying a specified neuron deletion in order to erase 
								connections to that particular neuron */
								
void notify_cluster_deletion();	/* Function for notifying a specified cluster deletion in order to erase
								links and connections to that cluster */
								
void notify_nucleus_deletion();	/* Function for notifying a specified nucleus deletion in order to erase
								links and connections to that nucleus */
								
void verify_extremities();		/* Function for verifying all links and update extremities */

void update_link_type();		/* Function for updating link type */

void redraw_connection_curve(); /* Function for redrawing the connection curve */

void redraw_connection_matrix();
								/* Function for redrawing the connection matrix */

void move_point();				/* Function for moving one connection curve point */

void release_point();			/* Function for releasing one connection curve point */

void info_point();				/* Function for help on line on connection curve */

void clear_info_curve();		/* Function for clearing connection curve  label info */

void draw_curve();				/* Function for drawing the connection curve */

void draw_points();				/* Function for drawing the curve points widgets */

void draw_curve_axes();			/* Function for drawing the curve axes */

void resize_curve();			/* Function for resizing connection curve */

/* %%%%source code in plot_functions.c%%%% */

void plot_one_connection(Connection *connection,int source_id,int target_id);

int apply_plot();	

int plot_current_nucleus(char *ps_file_name,char *queue_name);

int plot_neurons(void);

int plot_one_neuron(NEURON *neuron);

int	plot_nucleus_axes();

int plot_neuron_links(void);

int plot_network(char *ps_file_name,char *queue_name);

int plot_nucleus(void);

int plot_one_nucleus(Nucleus_widget *nucleus_tmp);

void plot_one_network_link(LINK_PARAMETERS *link_tmp);

int plot_network_links(void);

int plot_net_axes(void);


/*
 *	Data management functions
 */
 
/* %%%%source code in crea_lnk.c%%%% */

int create_lnk_file();			/* create from a network structure a link
								configution file format 2.0
		 						for NBC Network Editor */

/* %%%%source code in crea_wgt.c%%%% */

int create_wgt_file();			/* create a wgt file format NBC Network Editor	
 								version 2 , from the specified ver2 network 
 								structure */
 								
/* %%%%source code in crea_len.c%%%% */

int create_len_file();			/* create a cnx len format NBC Network Editor	
 								version 2 , from the specified ver2 network 
 								structure */
/* %%%%source code in crea_clu.c%%%% */	

int	create_clu_file ();			/* create an cluster list file for NBC Network 
								Editor version2 from a network structure */
							
/* %%%%source code in crea_anat.c%%%% */

int create_anat_file();			/* create an anatomy file for NBC Network 
								Editor version2 from a network structure */

/* %%%%source code in read_lnk.c%%%% */

int read_lnk_file();			/* read from a link configution file format 2.0
 								into a network struture from NBC Network Editor */

/* %%%%source code in read_wgt.c%%%% */

int read_wgt_file();			/* read a wgt file format ver2 NBC Network Editor
								and store it in the specified network ver2 
								structure */

/* %%%%source code in read_len.c%%%% */

int read_len_file();			/* read a len file format ver2 NBC Network Editor
								and store it in the specified network ver2 
								structure */
								
/* %%%%source code in read_anat.c%%%% */

int read_anat_file();			/* read a anat file format ver2 NBC Network
								Editor , and store it in the specified
								network ver2 structure */



#endif
