#define XPS_DEBUG	0
/*
*	                P  L  O  T  1  _  D  P  S
*	                ======================
*
*		   Routines de dessin sur la LN03R PostScript.
*
*	   NIVEAU 1 : Ce jeu de routine regroupe les routines de base
*		appelables par l'utilisateur de base
*
*		Mise en forme Version 2
*			Juillet 90
*		Version 3	Nouveaux noms de fonctions ps_*
*			31 juillet 90
*		Version 4
*			21 mars 91 / plot_dps V0
*		PLOT_DPS
*		Version 1.0
*			3 Avril 1991
*		Version 1.1
*			28 Mai 1991
*		Version 1.2
*			30 Oct 1991
*		PLOT_XPS
*		Version 1.0
*			3 Decembre 1992
*		Version 2.0
*			11 juillet 1994
*		Version 2.2
*			3 mai 1995
*		Version 2.5
*			9 dec 1995
*		Version 2.6 Prise en compte de PRINT_PLOT_PS
*			1 sept 1997
*               Version 2.7 Prise en compte de HAVE_CONFIG_H
*                       15 sept 1999
*               Version 2.14 implementation de ps_banner et ps_no_banner
*                       11 avril 2001
*
*	Auteur: Dr J-F VIBERT
*		Laboratoire de Physiologie
*		CHU Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is in any way usable for commercial purpose.
*
title	PLOT1	Niveau 1 des routines PLOT_XPS pour C
index		Niveau 1 des routines PLOT_XPS pour C

description

		   Routines de dessin sur la PLOT_XPS.

	NIVEAU 1 : Ce jeu de routine regroupe les routines 
		appelables par l'utilisateur


author

	Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT0_XPS, PLOT2_XPS, PLOT3_XPS et PLOT3D_XPS

newpage
*/

#include <stdio.h>

#include "plot_xps.h"

#ifdef	DOCUMENTATION


title	PS_INIPLOT	Initialize the PostScript plotter 
index		Initialize the PostScript plotter 


synopsis

	#include <plot_xps.h>

	ps_iniplot(display,la_plot_file,x_ps_xps,y_ps_xps,
	           l_cm_xps,h_cm_xps,scale,window_name)
	Display *display;       /* Pointer on Xwindow display structure
	                         * if display is already openned, else NULL
	                         */
	char *la_plot_file;     /*
	                         * File for the plot. If empty char string
	                         * no hardcopy.
	                         */
	int  x_ps_xps, y_ps_xps;/* Position X and Y of the window */
	float l_cm_xps, h_cm_xps;/*
	                         * Width and height of the window in cm
	                         * If L = H = 0., no window
	                         */
	float scale;             /* window scaling */
	char *window_name;       /* Name of the window 0 */

description

	PS_INIPLOT opens the PostScript file and/or the XWindow terminal and
	draws a frame corresponding to the flag page of a line-printer. The
	date and time of the file production, the file name and the user
	name are indicated as well as a page number. This banner is output
	on each page by ps_newpage().  It is drawn at the bottom of the page
	and is 1 cm wide. The flag banner is not drawn on the X window.
	PS_INIPLOT creates the window 0.

	If PS_INIPLOT is called from a Xwindow program, the display is
	already open and given to PS_INIPLOT. If PS_INIPLOT is called from a
	non-Xwindow program, the display argument must be set to NULL, since
	PS_INIPLOT will open the display.

	The plot_file name will contain the PostScript code of the drawing.
	No hardcopy is produced if an empty file name is given.
	
	If a NULL file name is given as the first argument, no printing is
	performed. If the width and height (in cm) of the window are both 0. cm,
	no window is opened. the scale allows to have a window for exemple
	at half size of the indicated cms. if the scale is 0.5.
	
	If a NULL window name is given, the window will be call "no Name".

author

	Dr Jean-Francois Vibert et Eric Boussard

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI


newpage
	

title	PS_ENDPLOT	Close and spools all remaining drawings
index		Close and spools all remaining drawings


synopsis
	#include <plot_xps.h>

	ps_endplot(action);
	char   action;/* Action to take about the plot file
	                    s: spool and keep
	                    d: spool and delete
	                    f: freeze (no spool) */

	ps_queue_name(nom_de_la_queue)
	char    *nom_de_la_queue; /* queue name where the plot
	                             will be sent */
description

	PS_ENDPLOT closes the PostScript file and process it according
	to the action indicated by the char argument:

		s: spool and keep

		d: spool and delete

		f: freeze (no spool)

	It acts only on the window 0.

	PS_ENDPLOT closes all remining windows and print all remaining files
	not already closed by PS_CLOSE_WINDOW.

	PS_QUEUE_NAME allows to change the name of the queue where the
	plot will be sent. It default to the name defined in plot_ps.h
	as PLOT_XPS_QUEUE_NAME.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	plopen() and plclose()

newpage

title   PS_BANNER      Put or remove a banner on each printed page
index	   Put or remove a banner on each printed page

synopsis
	#include <plot_xps.h>

	ps_banner()

	#include <plot_xps.h>

	ps_no_banner()

description

	PS_BANNER puts a banner on each printed page. 
	PS_NO_BANNER remove the banner on each printed page. 
	The banner has the page number.

        WARNING: If no banner is needed, even on the first page, 
        ps_no_banner must be called before ps_iniplot.

        the banner is written by default, except if at the building 
        time the PUT_BANNER_ON_PAGES option was set. This building flag 
        only changes the default value of the flag controlling the banner. 

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine INSERM U444 Universite Paris VI

See also



newpage

title	PS_CREATE_WINDOW	Initialize a new X Window
index		Initialize a new X Window


synopsis

	#include <plot_xps.h>

	int  ps_create_window(la_plot_file,x_ps_xps,y_ps_xps,
	                      l_cm_xps,h_cm_xps,window_name)
	char *la_plot_file;     /*
	                         * File for the plot. If empty char string
	                         * no hardcopy.
	                         */
	int  x_ps_xps, y_ps_xps;/* Position X and Y of the window */
	float l_cm_xps, h_cm_xps;/*
	                         * Width and height of the window in cm
	                         * If L = H = 0., no window
	                         */
	char *window_name;       /* Name of the window 0 */

description

	PS_CREATE_WINDOW opens a new named X window, and possibly print file
	for laser drawing. It returns the number of this new window, and -1
	if the number of possible windows is exhausted. PS_INIPLOT opens the
	window 0, the others are numbered from 1 to PS_MAX_WINDOW_NUMBER.
	
	If a NULL file name is given as the first argument, no printing is
	performed. If the width and height of the window are both 0 cm, no window is
	opened. If a NULL window name is given, the window will be call "no Name".
author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_iniplot(), ps_get_window(), ps_set_window()

newpage

title	PS_CLOSE_WINDOW	Closes a named X Window
index		Closes a named X Window


synopsis

	#include <plot_xps.h>

	int  ps_close_window(window_name,action)
	char    *window_name,	/* Name of the window */
	        action;/* Action to take about the plot file
	                        s: spool and keep
	                        d: spool and delete
	                        f: freeze (no spool) */

description

	PS_CLOSE_WINDOW  closes the PostScript file and process it according
	to the action indicated by the char argument:

		s: spool and keep

		d: spool and delete

		f: freeze (no spool)

	It closes also the named window, frees the allocated memory, and
	swaps the highest order window to the place freed by the deleted
	window. The current window is reset to 0, and the highest window
	number is decremented by 1.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_iniplot(), ps_create_window()

newpage

title	PS_USE_WINDOW	Sets current a named window
index		Set current a named window


synopsis

	#include <plot_xps.h>

	int  ps_use_window(window_name)
	char *window_name;  /* Name of the window  */

description

	PS_USE_WINDOW sets current a named X window, and returns the number of
	this current window, and -1 if this window does not exists.
author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_iniplot(), ps_get_window(), ps_create_window()

newpage

title	PS_GET_WINDOW	Gives the name and number of the current X Window
index		Gives the name and number of the current X Window


synopsis

	#include <plot_xps.h>

	int  ps_get_window(window_name)
	char *window_name;  /* Name of the window */

description


	PS_GET_WINDOW gets the current X window, and returns the number of
	this current window, and -1 if no window exists. The name of the
	current window is also returned.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_iniplot(), ps_create_window(), ps_use_window()

newpage

title	PS_NEWPAGE	Go to the next page
index		Go to the next page


synopsis
	#include <plot_xps.h>

	ps_newpage()
description

	PS_NEWPAGE go to the next page and redraws the banner with the page
	number.  In the Xwindow environment, the current window is used, the
	page is cleared, in order to get an animation possibility. The
	clearing of the page is controlled by using the ps_watch_page()
	fonction to clear the page only when either mousebutton is pressed,
	or ps_no_watch_page to get moving images (no page number nor banner
	is displayed on the X window). By default ps_watch_page is set to false. 

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_watch_page() and ps_no_watch_page()
newpage

title	PS_WATCH_PAGE	Wait before clearing a wnindow page
index		Wait before clearing a wnindow page


synopsis
	#include <plot_xps.h>

	ps_watch_page()
description

	PS_WATCH_PAGE is for the Xwindow environment. It allows to clear
	the page only when either mouse button is pressed. It has no effect
	in hard_copy only environment.
author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_newpage() and ps_no_watch_page()
newpage


title	PS_NO_WATCH_PAGE Clears a window page without waiting
index		Clears a window page without waiting


synopsis
	#include <plot_xps.h>

	ps_no_watch_page()
description

	PS_NO_WATCH_PAGE is for the Xwindow environment. It allows to clear
	the window page without waiting. It allows to get moving images.  It
	has no effect in hard_copy only environment.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_newpage() and ps_watch_page()
newpage

title	PS_IS_WATCHABLE	Says if the window waits at each page.
index		Says if the window waits at each page.


synopsis
	#include <plot_xps.h>

	int  ps_is_watchable()
description

	PS_IS_WATCHABLE returns TRUE (1) if the window wait at each newpage
	before clearing it, FALSE (0) if not.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_newpage(), ps_no_watch_page() and ps_no_watch_page()
newpage

title	PS_WATCH_PROGRESS Flushes automatically graphic events to window
index		Flushes automatically graphic events to window


synopsis
	#include <plot_xps.h>

	ps_watch_progress()
description

	PS_WATCH_PROGRESS is for the Xwindow environment. It is the
	display option by default. All graphic events are flushed to
	window. If an application is too slow, this option can be disabled
	by PS_NO_WATCH_PROGRESS. But after you will have to
	manage yourself the window displaying by using PS_FLUSH.
author

	Eric BOUSSARD

	CHU Saint-Antoine INSERM U263 Universite Paris VI

See also

	ps_no_watch_progress(), ps_is_progess_watchable() and ps_flush()
newpage


title	PS_NO_WATCH_PROGRESS Disable automatic flush option
index		Disable automatic flush option


synopsis
	#include <plot_xps.h>

	ps_no_watch_progress()
description

	PS_NO_WATCH_PAGE is for the Xwindow environment. It disable the automatic
	flush of all the graphics events. If you set this option, you have to manage
	yourself the window displaying by using PS_FLUSH. Thus your application will
	become faster because you reduce the number of graphic request.

author

	Eric BOUSSARD

	CHU Saint-Antoine INSERM U263 Universite Paris VI

See also

	ps_flush(), ps_is_progress_watchable and ps_watch_page()
newpage

title	PS_IS_PROGRESS WATCHABLE Says if the graphic flush is automatic.
index		Says if the graphic flush is automatic.


synopsis
	#include <plot_xps.h>

	int  ps_is_progress_watchable()
description

	PS_IS_WATCHABLE returns TRUE (1) if the flushing of graphic events is
	automatic, FALSE (0) if not.

author

	Eric BOUSSARD

	CHU Saint-Antoine INSERM U263 Universite Paris VI

See also

	ps_flush(), ps_no_watch_progress() and ps_watch_progress()
newpage

title	PS_FLUSH	Flushes the current drawing on the X window
index		Flushes the current drawing on the X window


synopsis
	#include <plot_xps.h>

	ps_flush()
description

	PS_flush is for the Xwindow environment only. It allows to flush
	the drwing already done, since Xwindow use a buferised algorithm to
	send drawings on the windows.  It has no effect in hard_copy only
	environment.
author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

newpage

title	PS_HIDE_WINDOW Unmap the current window
index		 Unmap the current window


synopsis
	#include <plot_xps.h>

	ps_hide_window()
	
description

	PS_HIDE_WINDOW hide the current window by unmapping it from the
	screen.  If a window is not required or already hidden, it has no effect.
	Drawings are still send on the window.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_display_window()

newpage

title	PS_DISPLAY_WINDOW Map the current window
index		 Map the current window


synopsis
	#include <plot_xps.h>

	ps_display_window()
	
description

	PS_DISPLAY_WINDOW redisplays a previously hidden window by mapping it on the
	screen.  If a window is not required or already mapped, it has no effect.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_display_window()

newpage

title	PS_TOGGLE_VISIBILITY	Map or Unmap the current  window
index		Map or Unmap the current  window


synopsis
	#include <plot_xps.h>

	int  ps_toggle_visibility()
description

	PS_TOGGLE_VISIBILITY toggles the visibility of the current window
	according to its previous state.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_hide_window() and ps_display_window()
newpage

title	PS_IS_VISIBLE	Says if the window is visible
index		Says if the window is visible


synopsis
	#include <plot_xps.h>

	int  ps_is_visible()
description

	PS_IS_VISIBLE returns TRUE (1) if the window is visible, FALSE (0) if not.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_hide_window() and ps_display_window()
newpage

title	PS_DISPLAY Sends subsequent drawings to the current window
index		Send subsequent drawings to the current window


synopsis
	#include <plot_xps.h>

	ps_display()
	
description

	PS_DISPLAY sends subsequent drawings to the current window.  It is
	normally enabled after the initialisation. If a window is not
	required, it has no effect.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_no_display()
newpage


title	PS_NO_DISPLAY Stops to sends subsequent drawings to the current window
index		Stops to sends subsequent drawings to the current window


synopsis
	#include <plot_xps.h>

	ps_no_display()
	
description

	PS_NO_DISPLAY stops to send subsequent drawings to the current window.
	If a window is not required, it has no effect.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_display()
newpage

title	PS_IS_DISPLAYING	Says if the window is displaying the drawing
index		Says if the window is displaying the drawing


synopsis
	#include <plot_xps.h>

	int  ps_is_displaying()
description

	PS_IS_DISPLAYING returns TRUE (1) if the window is isplaying the
	drawing, FALSE (0) if not.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_display() and ps_no_display()
newpage


title	PS_PRINT Enables hard_copy
index		Enables hard_copy


synopsis
	#include <plot_xps.h>

	ps_print()
description

	PS_PRINT enables hard_copy in the post_script file. If a PS file was
	given, it is normally enabled after the initialisation. If a PS file
	name was not given, it has no effect in hard_copy only environment.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_no_print()
newpage


title	PS_NO_PRINT Disables hard_copy
index		Disables hard_copy


synopsis
	#include <plot_xps.h>

	ps_no_print()
description

	PS_NO_PRINT disables hard_copy in the post_script file. If a PS file was
	given, it is normally enabled after the initialisation. If a PS file
	name was not given, it has no effect in hard_copy only environment.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_print()
newpage

title	PS_IS_PRINTING	Says if the window is printed
index		Says if the window is printed


synopsis
	#include <plot_xps.h>

	int  ps_is_printing()
description

	PS_IS_PRINTING returns TRUE (1) if the window is printing the
	drawing, FALSE (0) if not.

author

	Dr Jean-Francois Vibert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also
	ps_print() and ps_no_print()
newpage

title	PS_ORIGIN	Define new origine and move the pen
index		Define new origine and move the pen

synopsis
	#include <plot_xps.h>

	ps_origin(xf,yf,xa,ya);
	float   xf, yf, /* Absolute coordinates in cm */
	        xa, ya; /* Absolute (en cm) coordinates 
	                   of new position */

description

	PS_ORIGIN defines a new absolute origine. The pen if first moved to xf
	and yf coordinates. xa and ya corespond to the new coordinates of
	the pen.

	All coordinates are given in centimeters (also refered as PostScipt
	space).

author

	Jean-Francois VIBERT a partir de PLOT0.C de Jean-Noel Albert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT1 et PLOT2

newpage

title	PS_ECHEL 	Define scale of drawings (subject versus PostScipt units)
index		Define scale of drawings (subject versus PostScipt units)

synopsis
	#include <plot_xps.h>

	ps_echel(ex,ey,xs,ys,ca,sa);
	float   ex, ey, /* Number of cms by user unit   */
	        xs, ys, /* Absolute (en cm) coordinates 
	                                of user origine */
	        ca, sa; /* Cos and Sin of the drawing
	                               (rotation)       */
description

	PS_ECHEL Define the scale of the drawing, and its origine in the
	PostScript coordinates (relative to the last call to ps_origin). Its
	allows also rotation of the entire drawing.

		The scales must be given in centimeters by user (or subject)
	unit. They must have a value greater than 0.008 since the PostScript
	draws one centimeter using 118 steps. If not, the function returns
	FALSE.

		The coordinates of the new origine must be given in
	PostScript units, i.e. in centimeters.

		Cosinus and Sinus of the angle of the drawing relative to
	the X axis gives a rotation possibility. 
		
	\nofill
	Horizontal head up: cosa=1. sina=0.
	Horizontal head down: cosa=-1. sina=0.
	Verticalement ascending: cosa=0. sina=1.
	Verticalement descending: cosa=0. sina=-1.
	\fill

author

	Jean-Francois VIBERT a partir de PLOT0.C de Jean-Noel Albert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT1 et PLOT2

newpage

title	PS_SCALE Scale of drawings
index		 Scale of drawings

synopsis
	#include <plot_xps.h>

	ps_scale(x_scl,y_scl)
	float   x_scl,
	        y_scl;
description

	PS_SCALE set a new global  scale of the drawing, with uniform (if 
	x_scl == y_scl) or non-uniform (if x_scl != y_scl) scaling. It acts 
	on both the drawing and texts. it allows to change the proportion of
	the drawing as well as its size. To come back to the original 
	scale, ps_scale must be called with 1./x_scl and 1./y_scl.

author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT1 et PLOT2

newpage

title	PS_PEN	Change the drawing pen 
index		Change the drawing pen 

synopsis
	#include <plot_xps.h>

	ps_pen(k);
	int k;    /* pen number (0, 1 or 2) */
description

	PS_PEN selects the drawing pen. If the pen number (k) is not one of 
	0, 1 or 2, the function returns FALSE, else it returns TRUE.
	If ps_pen() is not called, the default pen is 0 (BLACK).

	\nofill
	0 gives a black
	1 gives a gray at 0.3
	2 a light gray at 0.7.
	\fill

author

	Jean-Francois VIBERT a partir de PLOT0.C de Jean-Noel Albert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT1 et PLOT2
	
newpage

title	PS_ROTATE	Allows a rotation in degres
index		Allows a rotation in degres

synopsis
	#include <plot_xps.h>

	ps_rotate(rot);
	int      rot;  /* Rotation in degres */
description

	PS_ROTATE() Allows a rotation in degres of the graph.
	
author

	Jean-Francois

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT1 et PLOT2

newpage

title	PS_FONT	Allows to change the font
index		Allows to change the font

synopsis

	#include <plot_xps.h>

	ps_font(font,hy);
	char    *font;  /* font name */
	float   hy;     /* Rotation in degres */

description

	PS_FONT allows to choose a new font as the current font. The first
	argument is the PostScript build in font name. The size of the font 
	is given in centimer by hy. It can be changed alone by ps_size().

	Legal font names are:

	\nofill
		AvanteGarde-Book
		AvanteGarde-BookOblique
		AvanteGarde-Demi
		AvanteGarde-DemiOblique
		Courier
		Courier-Bold
		Courier-Oblique
		Courier-BoldOblique
		Helvetica
		Helvetica-Bold
		Helvetica-Oblique
		Helvetica-BoldOblique
		LubalinGraph-Book
		LubalinGraph-BookOblique
		LubalinGraph-Demi
		LubalinGraph-DemiOblique
		Times-Roman
		Times-Bold
		Times-Italic
		Times-BoldItalic
		NewCenturySchlbk-Roman
		NewCenturySchlbk-Bold
		NewCenturySchlbk-Italic
		NewCenturySchlbk-BoldItalic
		Souvenir-Demi
		Souvenir-DemiItalic
		Souvenir-Light
		Souvenir-LightItalic
		Symbol
	\fill
author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT1 et PLOT2

newpage

title	PS_SIZE	Define size (in cm)  of characters 
index		Define size (in cm)  of characters 

synopsis
	#include <plot_xps.h>

	ps_size(hx);
	float   hx;    /* Size of height 
	                of characters given 
	                in centimeters */
description

	PS_SIZE defines the size of characters, given in centimeters,
	and acts on he current font choosen by ps_police().

author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT1 et PLOT2

newpage

title	PS_CHARA	Write a string in PostScipt space, stays at the end
index		Write a string in PostScipt space, stays at the end

synopsis
	#include <plot_xps.h>

	ps_chara(x,y,j,str,hy,rot);
	float   x, y;    /* x and y coordinates */
	                 /*    given in PostScipt units (cm) */ 
	int     j;       /* the "Benson" j parameter */ 
	char    *str;    /* the string to write */ 
	float   hy;      /* character height (in cm)  */
	int     rot;     /* rotation in degres */
description

	PS_CHARA writes a string at the position indicated by x,y and j, 
	with the rotation given by cosa and sina, and stays at the end
	of the string.

	PS_CHARA replicates the old Benson pcara fortran routine.

	PS_WRITE\ldots should now be used.
	
		X and Y are the coordinates of the target given in PostScipt
	units (in centimeters).
	
		These coordinates are considered as absolute (j=0 or j=1) or
	relative (j=2 or j=3) according to the value of j. 	

		During the move, the pen is up (j=0 or j=2) or down
	(j=1 or j=3) according to the value of j.

	The following constants are defined in PLOT_PS.H:

	Symbolic codes for the pen movements
	 
	\nofill
	\#define PL_AH 0		Absolu Plume Haute	
	\#define PL_AB 1		Absolu Plume Basse	
	\#define PL_RH 2		Relatif Plume Haute	
	\#define PL_RB 3		Relatif Plume Basse	

	\#define PEN_AU 0		Absolute Pen Up
	\#define PEN_AD 1		Absolute Pen Down 	
	\#define PEN_RU 2		Relative Pen Up	
	\#define PEN_RD 3		Relative Pen Down	
	\fill

	The size of characters is given in centimeters by  hy 
	(height) of the characters.

author

 	Jean-Francois VIBERT a partir de PLOT0.C de Jean-Noel Albert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	All text writing functions
 
newpage

title	PS_CHARS	Write a string in user space, stays at the end
index		Write a string in user space, stays at the end

synopsis
	#include <plot_xps.h>

	ps_chars(x,y,j,str,hy,rot);
	float   x, y;   /* x and y coordinates */
	                /*     given in user units */ 
	int     j;      /* the "Benson" j parameter */
	char    *str;   /* the string to write */ 
	float   hy;     /* character height (in cm) */ 
	int     rot;    /* rotation in degres */
description

	PS_CHARS writes a string at the position indicated by x,y and j, 
	with the rotation given in degre, and stays at the end
	of the string.

	PS_CHARS almost replicates the opld Benson pcars fortran routine.

	PS_WRITE\ldots should now be used.

	X and Y are the coordinates of the target given in user
	units (NOT in centimeters).

		These coordinates are considered as absolute (j=0 or j=1) or
	relative (j=2 or j=3) according to the value of j. 

		During the move, the pen is up (j=0 or j=2) or down
	(j=1 or j=3) according to the value of j.

	The following constants are defined in PLOT.H:
	
	Symbolic codes for the pen movements

	\nofill
	\#define PL_AH 0		Absolu Plume Haute	
	\#define PL_AB 1		Abslou Plume Basse	
	\#define PL_RH 2		Relatif Plume Haute	
	\#define PL_RB 3		Relatif Plume Basse	

	\#define PEN_AU 0		Absolute Pen Up
	\#define PEN_AD 1		Absolute Pen Down 	
	\#define PEN_RU 2		Relative Pen Up	
	\#define PEN_RD 3		Relative Pen Down	
	\fill

	The size of characters is given in centimeters by hy (height) of the
	characters.
 

author

	Jean-Francois VIBERT a partir de PLOT0.C de Jean-Noel Albert

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	All text writing functions PS_WRITE*
 

newpage

title	PS_GRAY	Define a new default gray level
index		Define a new default gray level

synopsis
	#include <plot_xps.h>

	ps_gray(gray);
	float     gray; /* gray for the subsequent drawings */
description

	PS_GRAY() defines a  new gray value for the subsequent drawings.

author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT1 et PLOT2

newpage

title	PS_SET_RGB_COLOR	Set a current RGB color
index			Set a current RGB color

synopsis
	#include <plot_xps.h>

	ps_set_rgb_color(red,green,blue);
	float     red,   /* red for the subsequent drawings */
	          green, /* green for the subsequent drawings */
	          blue;  /* blue for the subsequent drawings */
description

	PS_SET_RGB_COLOR() defines a new color value in the RGB space for
	the subsequent drawings.

	0.0 is no contribution of the corresponding color.
	
	1.0 is full contribution of the corresponding color.

	Equal values of each color gives a gray shade: all 0.0 gives black,
	all 1.0 gives white.

author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_set_hsb_color, ps_set_cmyk_color

newpage

title	PS_SET_HSB_COLOR	Set a current HSB color
index			Set a current HSB color

synopsis
	#include <plot_xps.h>

	ps_set_hsb_color(hue,saturation,brightness);
	float     hue,   /* red for the subsequent drawings */
	          saturation, /* green for the subsequent drawings */
	          brightness;  /* blue for the subsequent drawings */
description

	PS_SET_HSB_COLOR() defines a new color value in the HSB space for
	the subsequent drawings.

	For Hue: 0. or 1. is pure red, 1/3 is pure green and 2/3 is pure blue.

	For Saturation: 0. is no color (only a shade of gray), 1. is maximum
	concentration (no white light mixed)

	For Brightness: 0. is black and 1. is maximum intensity.

author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_set_rgb_color, ps_set_cmyk_color
	
newpage

title	PS_SET_CMYK_COLOR	Set a current CMYK color
index			Set a current CMYK color

synopsis
	#include <plot_xps.h>

	ps_set_cmyk_color(cyan,magenta,yellow,back)
	float     cyan,   /* cyan for the subsequent drawings */
	          magenta, /* magenta for the subsequent drawings */
	          yellow, /* yellow for the subsequent drawings */
	          black;  /* black for the subsequent drawings */
description

	PS_SET_CMYK_COLOR() defines a new color value in the CMYK space for
	the subsequent drawings.

	0.0 is no contribution of the corresponding color.
	
	1.0 is full contribution of the corresponding color.

	Equal values of each color gives a gray shade: all 0.0 gives black,
	all 1.0 gives white.

	ps_set_cmyk_color() has effect only in the printing environment. If
	in the window environement, it has no effect.
		
author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_set_rgb_color, ps_set_hsb_color
	
newpage

title	PS_GET_RGB_COLOR	Get the current RGB color
index			Get the current RGB color

synopsis
	#include <plot_xps.h>

	ps_get_rgb_color(red,green,blue);
	float     *red,   /* red for the subsequent drawings */
	          *green, /* green for the subsequent drawings */
	          *blue;  /* blue for the subsequent drawings */
description

	PS_GET_RGB_COLOR() get the current color value in the RGB space.

	0.0 is no contribution of the corresponding color.
	
	1.0 is full contribution of the corresponding color.

	Equal values of each color gives a gray shade: all 0.0 gives black,
	all 1.0 gives white.

author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_get_hsb_color, ps_get_cmyk_color

newpage

title	PS_GET_HSB_COLOR	Get the current HSB color
index			Get the current HSB color

synopsis
	#include <plot_xps.h>

	ps_get_hsb_color(hue,saturation,brightness);
	float     *hue,   /* red for the subsequent drawings */
	          *saturation, /* green for the subsequent drawings */
	          *brightness;  /* blue for the subsequent drawings */
description

	PS_GET_HSB_COLOR() gets the current  color value in the HSB space

	For Hue: 0. or 1. is pure red, 1/3 is pure green and 2/3 is pure blue.

	For Saturation: 0. is no color (only a shade of gray), 1. is maximum
	concentration (no white light mixed)

	For Brightness: 0. is black and 1. is maximum intensity.

author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_get_rgb_color, ps_get_cmyk_color
	
newpage

title	PS_GET_CMYK_COLOR	Get the current CMYK color
index			Set a current CMYK color

synopsis
	#include <plot_xps.h>

	ps_get_cmyk_color(cyan,magenta,yellow,back)
	float     *cyan,   /* cyan for the subsequent drawings */
	          *magenta, /* magenta for the subsequent drawings */
	          *yellow, /* yellow for the subsequent drawings */
	          *black;  /* black for the subsequent drawings */
description

	PS_GET_CMYK_COLOR() gets the current color value in the CMYK space.
	
	0.0 is no contribution of the corresponding color.
	
	1.0 is full contribution of the corresponding color.

	Equal values of each color gives a gray shade: all 0.0 gives black,
	all 1.0 gives white.

	ps_set_cmyk_color() has effect only in the printing environment. If
	in the window environement, it has no effect.
		
author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	ps_get_rgb_color, ps_get_hsb_color
	
newpage

title	PS_LINE_WIDTH 	Defines a new line width for the lines
index		Defines a new line width for the lines

synopsis
	#include <plot_xps.h>

	ps_line_width(width);
	float     width; /* PostScript width in picas */

description

	PS_LINE_WIDTH defines a new line width for the lines subsequently
	drawn. The width is given in PostScript units (picas).

author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT1 et PLOT2
newpage

title	PS_DASHED_LINE 	Defines a new dashed line pattern
index		Defines a new dashed line pattern

synopsis
	#include <plot_xps.h>

	ps_dashed_line(dash,gap,offset)
	float     dash,   /* pica units */
	          gap;    /* pica units */
	          offset; /* pica units */

description

	PS_DASHED_LINE  defines a new dashed line pattern for the subsequent lines
	drawn. {\tt dash} is the length of the dash, {\tt gap}  is the length of the
	gap between dashes and {\tt ofsett} is the phase of the first dash start
	relatively to the line start.  All values are given in PostScript pica units.

author

	Jean-Francois VIBERT et Eric BOUSSARD

	CHU Saint-Antoine INSERM U263 Universite Paris VI

See also

	PLOT1 et PLOT2
newpage

title	PS_SOLID_LINE 	Start the solid line pattern
index		Start the solid line pattern

synopsis
	#include <plot_xps.h>

	ps_solid_line()


description

	PS_SOLID_LINE  returns back to the solid line pattern after a call to PS_DASHED_LINE.

author

	Jean-Francois VIBERT et Eric BOUSSARD

	CHU Saint-Antoine INSERM U263 Universite Paris VI

See also

	PLOT1 et PLOT2

newpage

title	PS_ARC  Draws an arc clockwise
index		Draws an arc clockwise

synopsis
	#include <plot_xps.h>
	
	ps_arc(r,theta_1,theta_2)
	float   r;      /* radius always in cms */
	int     theta_1,/* begining angle */
	        theta_2;/* ending angle */
description

	PS_ARC Draws an arc clockwise begining at the current position, and
	coms back to the same position.  The radius must be given in cms.
	Begining and ending arcs are given in degres clockwise from the
	horizontal line.
	
author

	Jean-Francois VIBERT and Sylvain Hanneton

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI et Ecole Normale Superieure

See also
	PS_CIRCLE, PS_DISK, PS_ELLIPSE, PS_ELLIP_DISK
	
newpage

title	PS_CIRCLE	Draws an empty circle
index			Draws an empty circle

synopsis
	#include <plot_xps.h>
	
	ps_circle(r)
	float   r;   /* radius always in cms */
description

	PS_CIRCLE draws an empty circle whose the center is located at the
	current position. It comes back at the same current position.

author

	Jean-Francois VIBERT et Sylvain Hanneton

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI et Ecole Normale
	Superieure

See also

	PLOT1 et PLOT2
newpage
title	PS_DISK	Draws a filled disk
index		Draws a filled disk

synopsis
	#include <plot_xps.h>
	
	ps_disk(r,gray)
	float   r,   /* radius always in cms */
	        gray;/* shading 0-1, -1 color */
description

	PS_DISK draws an filled disk whose the center is located at the
	current position. It comes back at the same current position.  The
	shading is between 0 (black) and 1 (white).  If gray is negative,
	the disk is filled with the current color.

author

	Jean-Francois VIBERT et Sylvain Hanneton

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI et Ecole Normale
	Superieure

See also

	PLOT1 et PLOT2
 	
newpage
title	PS_ELLIPSE	Draws an empty ellipse
index			Draws an empty ellipse

synopsis
	#include <plot_xps.h>
	
	ps_ellipse(h_d,v_d)
	float   h_d,    /* horizontal diameter in cms */
	        v_d;    /* vertical diameter in cms */
description

	PS_ELLIPSE draws an empty ellipse whose the center is located at the
	current position. The parameters are the horizontal and vertical
	diameters (not radius) in cms.  It comes back at the same current
	position.

author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT1 et PLOT2
newpage
title	PS_ELLIP_DISK	Draws a filled ellipse
index			Draws a filled ellipse

synopsis
	#include <plot_xps.h>
	
	ps_ellip_disk(h_d,v_d,gray)
	float   h_d,    /* horizontal diameter in cms */
	        v_d,    /* vertical diameter in cms */
	        gray;   /* shading 0-1, -1 color */
description

	PS_ELLIP_DISK draws a filled ellipse whose the center is located at
	the current position. The parameters are the horizontal and vertical
	diameters (not radius) in cms.  It comes back at the same current
	position. The shading is between 0 (black) and 1 (white).  If gray
	is negative, the ellipse is filled with the current color.

author

	Jean-Francois VIBERT

	CHU Saint-Antoine CNRS UA1162 Universite Paris VI

See also

	PLOT1 et PLOT2
#endif


/*
*
*	PS_INIPLOT() permet d'initialiser le dessin et la 1ere fenetre.
*	Il appelle plopen() et dessine la baniere
*
*/
#if UNIX
#ifdef HAVE_CONFIG_H
/* BaCh: What is this? */
/*#	include <config_xnbc.h>*/
#	if HAVE_LIMITS_H
#		include <limits.h>
#	endif
#	if HAVE_UNISTD_H
#		include <unistd.h>
#	else
#		include <sys/utsname.h>
#	endif
#	include <sys/types.h>
#	include <time.h>
#else
#	include <limits.h>
#	include <sys/utsname.h>
#	include <sys/types.h>
#	include <time.h>
#endif
#endif

#if vms
#	include <libdef.h>
#	include <descrip.h>
#endif

int ps_iniplot(Display *display,
	       char *la_plot_file,
	       int x_ps_xps,
	       int y_ps_xps,
	       float l_cm_xps,
	       float h_cm_xps,
	       float scale,
	       char *window_name)
{
	char	proprio[256],
		moment[50],
		page[5];
	char	*p_q_n;
	int	nb_char;
	int	l_ps_xps, h_ps_xps;
	Visual *visual;
	XSetWindowAttributes att;
	XSizeHints zhints;
#if UNIX
	extern char *getlogin(void);
#if HAVE_UNISTD_H
	char sys_name[100];
	time_t tim, *p_tim;

	p_tim = &tim;
	tim = time(0);
	sprintf(moment,"%s",ctime(p_tim));
	moment[(strlen(moment)-1)] = 0;	/* enleve le '\n' final */
	gethostname(sys_name,100);
	/* changed by Bastien Chevreux (bach@mwgdna.com)
	   This fails miserably when started in a cron job, as 
	   getlogin() can return a NULL pointer

	   The canonical way for this should be getpwuid(geteuid())  
	   (NOT!!! cuserid()), but I am too lazy

	   sprintf(proprio,"%s@%s",getlogin(),sys_name);
	*/
	if (getlogin()!=NULL) {
	  sprintf(proprio,"%s@%s",getlogin(),sys_name);
	} else {
	  sprintf(proprio,"unknown@%s",sys_name);
	}

	/* Protection de la memoire vive en cas de ctrlC */
	signal(SIGINT,ps_controle_c);
#   ifndef __hpux
	signal(SIGQUIT,ps_controle_c);
#   endif
#else
#  ifndef __hpux
	struct utsname sys_name, *p_sys_name;
#  endif
	time_t tim, *p_tim;
#  ifndef __hpux
	p_sys_name = &sys_name;
#  endif
	p_tim = &tim;
	tim = time(0);
	sprintf(moment,"%s",ctime(p_tim));
	moment[(strlen(moment)-1)] = 0;	/* enleve le '\n' final */
#  ifndef __hpux
	uname(p_sys_name);
	/* changed by Bastien Chevreux (bach@mwgdna.com)
	   This fails miserably when started in a cron job, as 
	   getlogin() can return a NULL pointer

	   sprintf(proprio,"%s@%s",getlogin(),sys_name);
	*/
	if (getlogin() != NULL) {
	  sprintf(proprio,"%s@%s",getlogin(),p_sys_name->nodename);
	} else {
	  sprintf(proprio,"unknown@%s",p_sys_name->nodename);
	}
#  endif

	/* Protection de la memoire vive en cas de ctrlC */
	signal(SIGINT,ps_controle_c);
#  ifndef __hpux
	signal(SIGQUIT,ps_controle_c);
#  endif
#endif
#endif

#if vms
	$DESCRIPTOR(dscDate, "12345678901234567890123");
	/* la chaine doit faire 23 caracteres de long */
	lib$date_time(&dscDate);
	dscDate.dsc$a_pointer[17]='\0';
	/* on tronque les secondes et les centiemes */
	strcpy(moment, dscDate.dsc$a_pointer);
	strcpy(proprio, "VAX/VMS");
#endif
#if MS_DOS
	strcpy(moment,"now...");
	strcpy(proprio,"MS/DOS");
#endif

/*
 * Initialisations generales
 */
	if ((p_q_n = getenv("PRINT_PLOT_PS")) == NULL)
		strcpy(queue_name,PLOT_XPS_QUEUE_NAME);
	else
		strcpy(queue_name,p_q_n);
		

	if ((xps_dessin[0] =
	     (struct ps_dessin *)calloc(1,sizeof(struct ps_dessin))) == NULL)
	{
		fprintf(stderr,"\007PLOT_XPS: Impossible to allocate space for a new drawing\n");
		return(PS_NO_ROOM_DESSIN);
	} /* fin du if */
	ps_current_window = 0;


	xps_dessin[0]->pl_ex = xps_dessin[0]->pl_ey = PL_PAS;
	xps_dessin[0]->pl_rex = xps_dessin[0]->pl_rey = X_PAS;
	xps_dessin[0]->pl_ps_page = xps_dessin[0]->pl_cms = 1;
	xps_dessin[0]->pl_ca = 1.;
	xps_dessin[0]->pl_sa = 0.;

	nb_char = strlen(la_plot_file);
	if (nb_char)
	{
		xps_dessin[0]->ps_hard_copy = TRUE;
		if ((xps_dessin[0]->plot_file = (char *)calloc(nb_char+1,sizeof(char))) == NULL)
		{
			fprintf(stderr,"\007PLOT_XPS: No room for the name of the file %s\n",
				la_plot_file);
			xps_dessin[0]->ps_hard_copy = FALSE;
		} /* fin du if */
	} /* fin du if */
	else
		xps_dessin[0]->ps_hard_copy = FALSE;

	xps_dessin[0]->ps_xps = FALSE;

	if (xps_dessin[0]->ps_hard_copy)
	{

		strcpy(xps_dessin[0]->plot_file,la_plot_file);	/* pour pl_newpage */
		plopen(xps_dessin[0]->plot_file);
		fprintf(xps_dessin[0]->pl_spl,"%%!PS-Adobe-2.0 EPSF-1.2\n");
		fprintf(xps_dessin[0]->pl_spl,"%%PLOT_XPS V%s\n%%%%Creator: %s\n",PS_VERSION,proprio);
		fprintf(xps_dessin[0]->pl_spl,"%%%%Title: %s\n",xps_dessin[0]->plot_file);
		fprintf(xps_dessin[0]->pl_spl,"%%%%CreationDate: %s\n",moment);
		fprintf(xps_dessin[0]->pl_spl,"%%%%Pages: (atend)\n");
		fprintf(xps_dessin[0]->pl_spl,"%%%%EndComments\n");
		fprintf(xps_dessin[0]->pl_spl,"save\n");
		fprintf(xps_dessin[0]->pl_spl,"/M { moveto } bind def\n");
		fprintf(xps_dessin[0]->pl_spl,"/rM { rmoveto } bind def\n");
		fprintf(xps_dessin[0]->pl_spl,"/L { lineto } bind def\n");
		fprintf(xps_dessin[0]->pl_spl,"/rL { rlineto } bind def\n");
		fprintf(xps_dessin[0]->pl_spl,"/S { show } bind def\n");
		fprintf(xps_dessin[0]->pl_spl,"/GSG { gsave stroke grestore } bind def\n");
	
		if (ps_page_banner)
		{  
		  fprintf(xps_dessin[0]->pl_spl,"%%%%Beginning of the flag page\n");

		  /*	Le cadre de flag-page */

		  traa(0.8,0.8,PL_AH);
		  traa(19.5,0.,PL_RB);
		  traa(0.,1.,PL_RB);
		  traa(-19.5,0.,PL_RB);
		  traa(0.,-1.,PL_RB);
		  traa(18.5,0.,PL_RH);
		  traa(0.,1.,PL_RB);
	
		  traa(1.,1.15,PL_AH);

		  /* le texte de la baniere */
		  ps_font("Times-Roman",0.4);
		  ps_chara(0.,0.,PL_RH,moment,0.4,0);
		  traa(7.,1.1,PL_AH);
		  ps_font("NewCenturySchlbk-BoldItalic",0.5);
		  ps_chara(0.,0.,PL_RH,xps_dessin[0]->plot_file,0.5,0);
		  traa(14.,1.15,PL_AH);
		  ps_font("Times-Roman",0.4);
		  ps_chara(0.,0.,PL_RH,proprio,0.4,0);
		  traa(19.5,1.15,PL_AH);
		  sprintf(page,"%2d",xps_dessin[0]->pl_ps_page);
		  ps_chara(0.,0.,PL_RH,page,0.4,0);

		  traa(0.,0.,PL_AH);
		  
		  fprintf(xps_dessin[0]->pl_spl,"%%End of the flag page\n");
		}
	}
	else
	{
		fprintf(stderr,"\007PLOT_XPS: Hard Copy was not previously required\n");
		fprintf(stderr,"          No Post_script file will be produced\n");
		if (xps_dessin[ps_current_window]->ps_xps)
			fprintf(stderr,"          Only an Xwindow display will be done\n");
	} /* fin du else */

	/*
	 * Maintenant on ouvre une fenetre X s'il y a lieu
	 */
	xps_dessin[0]->ps_xps = TRUE;
	if (l_cm_xps == 0. && h_cm_xps == 0.)
		xps_dessin[0]->ps_xps = FALSE;
	else
		xps_dessin[0]->ps_xps = TRUE;
	xps_open_display = FALSE;
	if (xps_dessin[ps_current_window]->ps_xps)
	{
		ps_window_max = 0;
		if (display)
		{
			xps_display = display;
			xps_open_display = FALSE;
		}
		else
		{
			xps_display = XOpenDisplay(NULL);
			xps_open_display = TRUE;
		}
		if (xps_display)
		{
#if XPS_DEBUG
			printf("xps_display open\n");
#endif
			ps_current_window = 0;
			xps_dessin[0]->ps_auto_flush = TRUE;
			xps_dessin[0]->ps_wait_page = FALSE;
			pl_conv = (float)((DisplayWidth(xps_display,xps_screen))
				    /(((DisplayWidthMM(xps_display,xps_screen))
				      /10)))
				 / X_PAS;
			pl_conv *= scale;

			l_ps_xps = (int)(pl_conv * X_PAS * l_cm_xps);
			h_ps_xps = (int)(pl_conv * X_PAS * h_cm_xps);
			
			xps_screen = DefaultScreen(xps_display);
			visual = DefaultVisual(xps_display,xps_screen);
			switch(visual->class)
			{
				case StaticGray : type_ecran = 0; break;
				case StaticColor: type_ecran = 1; break;
				case GrayScale  : ;
				case PseudoColor: type_ecran = 2; break;
				case TrueColor  : ;
				case DirectColor: type_ecran = 3; break;
			}
			if (type_ecran == 2)
			{
				couleur();
				att.colormap = colormap;
				att.background_pixel = WhitePixel(xps_display,xps_screen);
				att.border_pixel = BlackPixel(xps_display,xps_screen);
				xps_dessin[0]->xps_window = XCreateWindow(xps_display,
							     RootWindow(xps_display,
									xps_screen),
							     x_ps_xps, y_ps_xps,
							     l_ps_xps, h_ps_xps,
							     3, /* bordure */
							     DefaultDepth(xps_display,
									  xps_screen),
							     CopyFromParent,
							     visual,
							     CWColormap|CWBackPixel|
							     CWBorderPixel,
							     &att);
			}
			else
			{
				xps_dessin[0]->xps_window = XCreateSimpleWindow(xps_display,
							     RootWindow(xps_display,
									xps_screen),
							     x_ps_xps, y_ps_xps,
							     l_ps_xps, h_ps_xps,
							     3, /* bordure */
							     BlackPixel(xps_display,
									xps_screen),
							     WhitePixel(xps_display,
									xps_screen));
				
			}
#if XPS_DEBUG
			printf("xps_window open\n");
#endif

			xps_dessin[0]->fontinfo = NULL;

			xps_dessin[0]->alpha = 0;
			
			xps_dessin[0]->width = l_ps_xps;
			xps_dessin[0]->height = h_ps_xps;
			
			xps_dessin[0]->cmt[0][0] = pl_conv;
			xps_dessin[0]->cmt[1][0] = 0.;
			xps_dessin[0]->cmt[0][1] = 0.;
			xps_dessin[0]->cmt[1][1] = -pl_conv;
			xps_dessin[0]->cmt[0][2] = 0.;
			xps_dessin[0]->cmt[1][2] = (float)xps_dessin[0]->height;

			xps_dessin[0]->xini = 0.;
			xps_dessin[0]->yini = 0.;
			xps_dessin[0]->xder = 0.;
			xps_dessin[0]->xder = 0.;

			XSelectInput(xps_display, xps_dessin[0]->xps_window,
				     ExposureMask | ButtonPressMask | KeyPressMask);

			xps_dessin[0]->xps_gc = XCreateGC(xps_display,
							  xps_dessin[0]->xps_window,
							  0,NULL);

#if XPS_DEBUG
			printf("xps_gc open\n");
#endif


			xps_dessin[0]->pixmap = XCreatePixmap(xps_display,
						 xps_dessin[0]->xps_window,
						 l_ps_xps, h_ps_xps,
						 DefaultDepth(xps_display,xps_screen));
			XSetForeground(xps_display,
				       xps_dessin[0]->xps_gc,
				       WhitePixel(xps_display,xps_screen));
			XFillRectangle(xps_display,
				       xps_dessin[0]->pixmap,
				       xps_dessin[0]->xps_gc,
				       0,0,
				       l_ps_xps, h_ps_xps);
			XSetWindowBackgroundPixmap(xps_display,
						   xps_dessin[0]->xps_window,
						   xps_dessin[0]->pixmap);
			XSetForeground(xps_display,
				       xps_dessin[0]->xps_gc,
				       BlackPixel(xps_display,xps_screen));

			xps_dessin[0]->red = 0.;
			xps_dessin[0]->green = 0.;
			xps_dessin[0]->blue = 0.;
			
			zhints.x = x_ps_xps;
			zhints.y = y_ps_xps;
			zhints.width = l_ps_xps;
			zhints.height = h_ps_xps;
			zhints.min_width = l_ps_xps;
			zhints.max_width = l_ps_xps;
			zhints.min_height = h_ps_xps;
			zhints.min_height = h_ps_xps;
			zhints.flags |= PMinSize | PMaxSize;
			XSetStandardProperties(xps_display,
					       xps_dessin[0]->xps_window,
					       window_name,window_name,
					       None,NULL,0,
					       &zhints);

			if ((xps_dessin[0]->ps_window_name =
			     (char *)calloc((strlen(window_name)+1),sizeof(char))) == NULL)
			{
				fprintf(stderr,"\007PLOT_XPS: Impossible to allocate space for the window name\n");
				return(PS_NO_ROOM_NAME);
			} /* fin du if */

			strcpy(xps_dessin[0]->ps_window_name,window_name);

			XMapWindow(xps_display, xps_dessin[0]->xps_window);
			XFlush(xps_display);

			ps_current_window = 0;
			ps_window_max++;
#if XPS_DEBUG
			printf("%d fenetre mapee (la %d)\n",ps_window_max,ps_current_window);
#endif
		} /* fin du if */
		else
		{
			xps_dessin[0]->ps_xps = FALSE;
			ps_current_window = PS_NO_WINDOW;
			ps_window_max = 0;
			fprintf(stderr,"\007PLOT_XPS: Not an Xwindow terminal or set display\n");
			if (xps_dessin[0]->ps_hard_copy)
				fprintf(stderr,"      Only a printed output will be available\n");
			else
			{
				fprintf(stderr,"      A printed output was not required\n");
				fprintf(stderr,"\007      NO IMAGE will be done!!!!\n");
			} /* fin du else */
		}
		
	} /* fin du if */
	else
	{
		fprintf(stderr,"\007PLOT_XPS: No window asked\n");
		if (xps_dessin[0]->ps_hard_copy)
			fprintf(stderr,"      Only a printed output will be available\n");
		else
		{
			fprintf(stderr,"      A printed output was not required\n");
			fprintf(stderr,"\007      NO IMAGE will be done!!!!\n");
		} /* fin du else */
	}/* fin du else */
#if XPS_DEBUG
	printf("xps_done, on attaque...\n");
#endif
	/*
	 * Mise en place pour le dessin
	 */

	ps_origin(1.,2.,0.,0.);
	ps_font("Times-Roman",0.4);

#if XPS_DEBUG
	printf("ps_origin fait\n");
#endif

	/* Initialisation de la Bounding Box aux valeurs inverses */

	xps_dessin[0]->b_b_ll_x = UR_X;
	xps_dessin[0]->b_b_ll_y = UR_Y;
	xps_dessin[0]->b_b_ur_x = LL_X;
	xps_dessin[0]->b_b_ur_y = LL_Y;

	xps_dessin[0]->ps_show = TRUE;
	return (0);
}


/*
*
*	PS_ENDPLOT() permet de terminer et spooler la laser. Il appelle plclose()
*	et spoole eventuellement en effacant toutes les fenetres non deja fermees
*	par PS_CLOSE_WINDOW
*
*/

extern void plclose();

void ps_endplot(char action)
		/* Action to take about the plot file
		 *	s: spool and keep
		 *	d: spool and delete
		 *	f: freeze (no spool)
		 */ 
{
	char ligne[512];
	int i;

	if (ps_window_max == 0)
	{
	        i = 0;
		ps_code("GSG\n");
		plclose(xps_dessin[i]->plot_file);
		if (xps_dessin[i]->ps_hard_copy)
		{
			plclose(xps_dessin[i]->plot_file);	/* fermeture du fichier */
			switch (action)
			{
				case 'd':
#if UNIX
					sprintf(ligne,"%s %s",queue_name,xps_dessin[i]->plot_file);
					system(ligne);
					sprintf(ligne,"rm %s",xps_dessin[i]->plot_file);
#endif
#if vms
					sprintf(ligne,"%s %s /DELETE",queue_name,xps_dessin[i]->plot_file);
					system(ligne);
#endif
					break;
				case 'f':
					break;
				case 's':
				default:
#if UNIX
					sprintf(ligne,"%s %s",queue_name,xps_dessin[i]->plot_file);
#endif
#if vms
					sprintf(ligne,"%s %s",queue_name,xps_dessin[i]->plot_file);
#endif
#if MS_DOS
					sprintf(ligne,"PRINT %s",xps_dessin[i]->plot_file);
#endif
					system(ligne);
			}
		}
		return;
	} /* fin du if */
	else
	{
	    for (i = 0; i < ps_window_max; i++)
	    {
    		    ps_current_window = i;
		    ps_code("GSG\n");
		    if (xps_dessin[i]->ps_hard_copy)
		      {
			plclose(xps_dessin[i]->plot_file);	/* fermeture du fichier */
			switch (action)
			  {
			  case 'd':
#if UNIX
			    sprintf(ligne,"%s %s",queue_name,xps_dessin[i]->plot_file);
						    system(ligne);
						    sprintf(ligne,"rm %s",xps_dessin[i]->plot_file);
#endif
#if vms
			    sprintf(ligne,"%s %s /DELETE",queue_name,xps_dessin[i]->plot_file);
						    system(ligne);
#endif
			   break;
			  case 'f':
			    break;
			  case 's':
			  default:
#if UNIX
			    sprintf(ligne,"%s %s",queue_name,xps_dessin[i]->plot_file);
#endif
#if vms
			    sprintf(ligne,"%s %s",queue_name,xps_dessin[i]->plot_file);
#endif
#if MS_DOS
			    sprintf(ligne,"PRINT %s",xps_dessin[i]->plot_file);
#endif
			    system(ligne);
			  }
		      }
		    if (xps_dessin[i]->ps_xps)
		      {
			XDestroyWindow(xps_display, xps_dessin[i]->xps_window);
			XFreePixmap(xps_display,xps_dessin[i]->pixmap);
		      } /* fin du if */
    		    free(xps_dessin[i]);	/* fenetre detruite */
	    } /* fin du for */
	}
	if(type_ecran == 2)
		XFreeColormap(xps_display,colormap);
	if (xps_open_display)
		XCloseDisplay(xps_display);
}


/* Write a banner on each page */
void ps_banner(void)
{
  ps_page_banner = TRUE;
}

/* Avoid the banner on each page */

void ps_no_banner(void)
{
  ps_page_banner = FALSE;
}

/*
 * PS_CONTROLE_C
 * fonction non-visible utilisateur
 * permet de sortir proprement du programme lors d'un ^C
 */

void ps_controle_c()
{
	ps_endplot('f');
	fprintf(stderr,"\n\007Program aborted   ...   See you soon!\n\n");
	exit(0);
}

/*
 * PS_QUEUE_NAME permet de changer de queue par defaut
 */

void ps_queue_name(char *nom_de_la_queue)
{

	strcpy(queue_name,nom_de_la_queue);

} /* fin du char */

/*
*
*	PS_CREATE_WINDOW() permet d'initialiser une novuelle fenetre
*
*/

int	ps_create_window(char	*la_plot_file,	/*
						 * File for the plot. Si chaine vide,
						 * pas de hardcopy.
						 */
			 int	x_ps_xps, 	/* Position X et Y de la fenetre */
			 int    y_ps_xps,
			 float	l_cm_xps,
			 float  h_cm_xps,	/*
						 * Largeur et Hauteur de la fenetre, em cm. 
						 * Si L = H = 0., pas de fenetre.
						 */
			 char	*window_name)	/* title of the X window */
{
	char	proprio[256],
		moment[50],
		page[5];
	int	nb_char;
	int	l_ps_xps, h_ps_xps;

	XSetWindowAttributes att;
	XSizeHints zhints;

#if UNIX
	extern char *getlogin(void);
#if HAVE_UNISTD_H
	char sys_name[100];
	time_t tim, *p_tim;

	p_tim = &tim;
	tim = time(0);
	sprintf(moment,"%s",ctime(p_tim));
	moment[(strlen(moment)-1)] = 0;	/* enleve le '\n' final */
	gethostname(sys_name,100);
	/* changed by Bastien Chevreux (bach@mwgdna.com)
	   This fails miserably when started in a cron job, as 
	   getlogin() can return a NULL pointer

	   sprintf(proprio,"%s@%s",getlogin(),sys_name);
	*/
	if (getlogin()!=NULL) {
	  sprintf(proprio,"%s@%s",getlogin(),sys_name);
	} else {
	  sprintf(proprio,"unknown@%s",sys_name);
	}

	/* Protection de la memoire vive en cas de ctrlC */
	signal(SIGINT,ps_controle_c);
#   ifndef __hpux
	signal(SIGQUIT,ps_controle_c);
#   endif
#else
#  ifndef __hpux
	struct utsname sys_name, *p_sys_name;
#  endif
	time_t tim, *p_tim;
#  ifndef __hpux
	p_sys_name = &sys_name;
#  endif
	p_tim = &tim;
	tim = time(0);
	sprintf(moment,"%s",ctime(p_tim));
	moment[(strlen(moment)-1)] = 0;	/* enleve le '\n' final */
#  ifndef __hpux
	uname(p_sys_name);
	/* changed by Bastien Chevreux (bach@mwgdna.com)
	   This fails miserably when started in a cron job, as 
	   getlogin() can return a NULL pointer
	*/
	if (getlogin() != NULL) {
	  sprintf(proprio,"%s@%s",getlogin(),p_sys_name->nodename);
	} else {
	  sprintf(proprio,"unknown@%s",p_sys_name->nodename);
	}
#  endif

	/* Protection de la memoire vive en cas de ctrlC */
	signal(SIGINT,ps_controle_c);
#  ifndef __hpux
	signal(SIGQUIT,ps_controle_c);
#  endif
#endif
#endif

#if vms
	$DESCRIPTOR(dscDate, "12345678901234567890123");
	/* la chaine doit faire 23 caracteres de long */
	lib$date_time(&dscDate);
	dscDate.dsc$a_pointer[17]='\0';
	/* on tronque les secondes et les centiemes */
	strcpy(moment, dscDate.dsc$a_pointer);
	strcpy(proprio, "VAX/VMS");
#endif
#if MS_DOS
	strcpy(moment,"now...");
	strcpy(proprio,"MS/DOS");
#endif

#if XPS_DEBUG
		printf("create_window: initialisation %s\n",window_name);
#endif
/*
 * Initialisations generales
 */
	if ((xps_dessin[ps_window_max] =
	     (struct ps_dessin *)calloc(1,sizeof(struct ps_dessin))) == NULL)
	{
		fprintf(stderr,"\007PLOT_XPS: Impossible to allocate space for a new drawing\n");
		return(PS_NO_ROOM_DESSIN);
	} /* fin du if */

	nb_char = strlen(la_plot_file);
	if (nb_char)
	{
		xps_dessin[ps_window_max]->ps_hard_copy = TRUE;
		if ((xps_dessin[ps_window_max]->plot_file = (char *)calloc(nb_char+1,sizeof(char)))
		    == NULL)
		{
			fprintf(stderr,"PLOT_XPS: No room for the name of the file %s\n",
				la_plot_file);
			xps_dessin[ps_window_max]->ps_hard_copy = FALSE;
		} /* fin du if */
	} /* fin du if */
	else
		xps_dessin[ps_window_max]->ps_hard_copy = FALSE;
#if 0
	if (l_cm_xps == 0. && h_cm_xps == 0.)
		xps_dessin[ps_window_max]->ps_xps = FALSE;
	else
		xps_dessin[ps_window_max]->ps_xps = TRUE;
#endif

	xps_dessin[0]->ps_xps = FALSE;
	ps_current_window = ps_window_max;
#if XPS_DEBUG
		printf("create_window: file start\n");
#endif
	
	if (xps_dessin[ps_window_max]->ps_hard_copy)
	{
		strcpy(xps_dessin[ps_window_max]->plot_file,la_plot_file);	/* pour pl_newpage */
#if XPS_DEBUG
		printf("xps_window[%d] file %s to open **\n",ps_window_max,xps_dessin[ps_window_max]->plot_file);
#endif
		plopen(xps_dessin[ps_window_max]->plot_file);
#if XPS_DEBUG
		printf("xps_window[%d] file %s * opened %ld *\n",ps_window_max,xps_dessin[ps_window_max]->plot_file,xps_dessin[ps_window_max]->pl_spl );
#endif
		fprintf(xps_dessin[ps_window_max]->pl_spl,"%%!PS-Adobe-2.0 EPSF-1.2\n");
		fprintf(xps_dessin[ps_window_max]->pl_spl,"%%PLOT_XPS V%s\n%%%%Creator: %s\n",PS_VERSION,proprio);
		fprintf(xps_dessin[ps_window_max]->pl_spl,"%%%%Title: %s\n",xps_dessin[ps_window_max]->plot_file);
		fprintf(xps_dessin[ps_window_max]->pl_spl,"%%%%CreationDate: %s\n",moment);
		fprintf(xps_dessin[ps_window_max]->pl_spl,"%%%%EndComments\n");
		fprintf(xps_dessin[ps_window_max]->pl_spl,"save\n");
		fprintf(xps_dessin[ps_window_max]->pl_spl,"/M { moveto } bind def\n");
		fprintf(xps_dessin[ps_window_max]->pl_spl,"/rM { rmoveto } bind def\n");
		fprintf(xps_dessin[ps_window_max]->pl_spl,"/L { lineto } bind def\n");
		fprintf(xps_dessin[ps_window_max]->pl_spl,"/rL { rlineto } bind def\n");
		fprintf(xps_dessin[ps_window_max]->pl_spl,"/S { show } bind def\n");
		fprintf(xps_dessin[ps_window_max]->pl_spl,"/GSG { gsave stroke grestore } bind def\n");
	
		if(ps_page_banner)
		{
		  fprintf(xps_dessin[ps_window_max]->pl_spl,"%%%%Beginning of the flag page\n");

#if XPS_DEBUG
		  printf("create_window: file start\n");
#endif
		  /*	Le cadre de flag-page */

		    traa(0.8,0.8,PL_AH);
		    traa(19.5,0.,PL_RB);
		    traa(0.,1.,PL_RB);
		    traa(-19.5,0.,PL_RB);
		    traa(0.,-1.,PL_RB);
		    traa(18.5,0.,PL_RH);
		    traa(0.,1.,PL_RB);

		    traa(1.,1.15,PL_AH);

#if XPS_DEBUG
		    printf("create_window: cadre OK\n");
#endif
		    /* le texte de la baniere */

		    ps_font("Times-Roman",0.4);
		    ps_chara(0.,0.,PL_RH,moment,0.4,0);
		    traa(7.,1.1,PL_AH);
		    ps_font("NewCenturySchlbk-BoldItalic",0.5);
		    ps_chara(0.,0.,PL_RH,xps_dessin[ps_window_max]->plot_file,0.5,0);
		    traa(14.,1.15,PL_AH);
		    ps_font("Times-Roman",0.4);
		    ps_chara(0.,0.,PL_RH,proprio,0.4,0);
		    traa(19.5,1.15,PL_AH);
		    sprintf(page,"%2d",xps_dessin[ps_window_max]->pl_ps_page);
		    ps_chara(0.,0.,PL_RH,page,0.4,0);
		    traa(0.,0.,PL_AH);

		    fprintf(xps_dessin[ps_window_max]->pl_spl,"%%End of the flag page\n");
#if XPS_DEBUG
		    printf("create_window: banner end\n");
#endif
		}
	}
	else
	{
		fprintf(stderr,"\007PLOT_XPS: Hard Copy was not previously required\n");
		fprintf(stderr,"          No Post_script file will be produced\n");
		if (!(l_cm_xps == 0. && h_cm_xps == 0.))
			fprintf(stderr,"          Only an Xwindow display will be done\n");
	} /* fin du else */
	if (l_cm_xps == 0. && h_cm_xps == 0.)
		xps_dessin[ps_window_max]->ps_xps = FALSE;
	else
		xps_dessin[ps_window_max]->ps_xps = TRUE;

	/*
	 * Maintenant on ouvre une fenetre X s'il y a lieu
	 */

	if (xps_display)
	{
		xps_dessin[ps_window_max]->ps_auto_flush = TRUE;
		xps_dessin[ps_window_max]->ps_wait_page = FALSE;
		l_ps_xps = (int)(pl_conv * X_PAS * l_cm_xps);
		h_ps_xps = (int)(pl_conv * X_PAS * h_cm_xps);
		if (type_ecran == 2)
		{
			att.colormap = colormap;
			att.background_pixel = WhitePixel(xps_display,xps_screen);
			att.border_pixel = BlackPixel(xps_display,xps_screen);
			xps_dessin[ps_window_max]->xps_window = XCreateWindow(xps_display,
						     RootWindow(xps_display,
								xps_screen),
						     x_ps_xps, y_ps_xps,
						     l_ps_xps, h_ps_xps,
						     3, /* bordure */
						     DefaultDepth(xps_display,
								  xps_screen),
						     CopyFromParent,
						     DefaultVisual(xps_display,xps_screen),
						     CWColormap|CWBackPixel|CWBorderPixel,
						     &att);
		}
		else
			xps_dessin[ps_window_max]->xps_window = XCreateSimpleWindow(xps_display,
							RootWindow(xps_display,
								   xps_screen),
							x_ps_xps, y_ps_xps,
							l_ps_xps, h_ps_xps,
							3, /* bordure */
							BlackPixel(xps_display,
								   xps_screen),
							WhitePixel(xps_display,
								   xps_screen));
#if XPS_DEBUG
		printf("xps_window[%d] open\n",ps_window_max);
#endif

		xps_dessin[ps_window_max]->fontinfo = NULL;
#if 0
		ps_font("Times-Roman",0.4);
#endif		
		xps_dessin[ps_window_max]->width = l_ps_xps;
		xps_dessin[ps_window_max]->height = h_ps_xps;
		
		xps_dessin[ps_window_max]->alpha = 0;

		xps_dessin[ps_window_max]->cmt[0][0] = pl_conv;
		xps_dessin[ps_window_max]->cmt[1][0] = 0.;
		xps_dessin[ps_window_max]->cmt[0][1] = 0.;
		xps_dessin[ps_window_max]->cmt[1][1] = -pl_conv;
		xps_dessin[ps_window_max]->cmt[0][2] = 0.;
		xps_dessin[ps_window_max]->cmt[1][2] = xps_dessin[ps_window_max]->height;

		xps_dessin[ps_window_max]->xini = 0.;
		xps_dessin[ps_window_max]->yini = 0.;
		xps_dessin[ps_window_max]->xder = 0.;
		xps_dessin[ps_window_max]->xder = 0.;
			
		XSelectInput(xps_display, xps_dessin[ps_window_max]->xps_window,
			     ExposureMask | ButtonPressMask | KeyPressMask);
		xps_dessin[ps_window_max]->xps_gc = XCreateGC(xps_display,
							      xps_dessin[ps_window_max]->xps_window,
							      0,NULL);

		xps_dessin[ps_window_max]->pixmap = XCreatePixmap(xps_display,
						     xps_dessin[ps_window_max]->xps_window,
						     l_ps_xps, h_ps_xps,
						     DefaultDepth(xps_display,xps_screen));
		XSetForeground(xps_display,
			       xps_dessin[ps_window_max]->xps_gc,
			       WhitePixel(xps_display,xps_screen));
		XFillRectangle(xps_display,
			       xps_dessin[ps_window_max]->pixmap,
			       xps_dessin[ps_window_max]->xps_gc,
			       0,0,
			       l_ps_xps, h_ps_xps);
		XSetWindowBackgroundPixmap(xps_display,
					   xps_dessin[ps_window_max]->xps_window,
					   xps_dessin[ps_window_max]->pixmap);
		XSetForeground(xps_display,
			       xps_dessin[ps_window_max]->xps_gc,
			       BlackPixel(xps_display,xps_screen));
		xps_dessin[ps_window_max]->red = 0.;
		xps_dessin[ps_window_max]->green = 0.;
		xps_dessin[ps_window_max]->blue = 0.;

		zhints.x = x_ps_xps;
		zhints.y = y_ps_xps;
		zhints.width = l_ps_xps;
		zhints.height = h_ps_xps;
		zhints.min_width = l_ps_xps;
		zhints.max_width = l_ps_xps;
		zhints.min_height = h_ps_xps;
		zhints.min_height = h_ps_xps;
		zhints.flags |= PMinSize | PMaxSize;
		XSetStandardProperties(xps_display,
				       xps_dessin[ps_window_max]->xps_window,
				       window_name,window_name,
				       None,NULL,0,
				       &zhints);
#if XPS_DEBUG
		printf("xps_gc open\n");
#endif
		if ((xps_dessin[ps_window_max]->ps_window_name =
			(char *)calloc((strlen(window_name)+1),sizeof(char))) == NULL)
		{
			fprintf(stderr,"\007PLOT_XPS: Impossible to allocate space for the window name\n");
			return(PS_NO_ROOM_NAME);
		} /* fin du if */

		strcpy(xps_dessin[ps_window_max]->ps_window_name,window_name);
		XMapWindow(xps_display, xps_dessin[ps_window_max]->xps_window);
		XFlush(xps_display);
		ps_current_window = ps_window_max;
		ps_window_max++;
		/*
		* Initialisations generales
		*/
		xps_dessin[ps_current_window]->pl_ex =
		xps_dessin[ps_current_window]->pl_ey = PL_PAS;
		xps_dessin[ps_current_window]->pl_rex =
		xps_dessin[ps_current_window]->pl_rey = X_PAS;
		xps_dessin[ps_current_window]->pl_ps_page = 1;
		xps_dessin[ps_current_window]->pl_cms = 1;
		xps_dessin[ps_current_window]->pl_ca = 1.;
		xps_dessin[ps_current_window]->pl_sa = 0.;
	
	} /* fin du if */
#if XPS_DEBUG
	printf("xps_done, on attaque...\n");
#endif
	/*
	 * Mise en place pour le dessin
	 */

	ps_origin(1.,2.,0.,0.);
	ps_echel(1.,1.,0.,0.,1.,0.);
	ps_user();
	/* Initialisation de la Bounding Box aux valeurs inverses */

	xps_dessin[ps_current_window]->b_b_ll_x = UR_X;
	xps_dessin[ps_current_window]->b_b_ll_y = UR_Y;
	xps_dessin[ps_current_window]->b_b_ur_x = LL_X;
	xps_dessin[ps_current_window]->b_b_ur_y = LL_Y;

	xps_dessin[ps_current_window]->ps_show = TRUE;
	return(ps_current_window);
}

/*
*
*	PS_CLOSE_WINDOW() permet de terminer et spooler la laser pour la  fenetre courante. 
*	il spoole eventuellement le dessin en effacant la fenetre
*
*/

void ps_close_window(char action)
		/* Action to take about the plot file
		 *	s: spool and keep
		 *	d: spool and delete
		 *	f: freeze (no spool)
		 */ 
{
	char ligne[256];

	if (xps_dessin[ps_current_window]->xps_window) /* Fenetre est toujours ouverte */
	{
		if (xps_dessin[ps_current_window]->ps_hard_copy)
		{
			plclose(xps_dessin[ps_current_window]->plot_file);	/* fermeture du fichier */
			switch (action)
			{
				case 'd':
#if UNIX
					sprintf(ligne,"lpr -P%s %s",queue_name,xps_dessin[ps_current_window]->plot_file);
					system(ligne);
					sprintf(ligne,"rm %s",xps_dessin[ps_current_window]->plot_file);
#endif
#if vms
					sprintf(ligne,"PRINT /QUEUE=%s %s /DELETE",queue_name,xps_dessin[ps_current_window]->plot_file);
					system(ligne);
#endif
					break;
				case 'f':
					break;
				case 's':
				default:
#if UNIX
					sprintf(ligne,"lpr -P%s %s",queue_name,xps_dessin[ps_current_window]->plot_file);
#endif
#if vms
					sprintf(ligne,"PRINT /QUEUE=%s %s",queue_name,xps_dessin[ps_current_window]->plot_file);
#endif
#if MS_DOS
					sprintf(ligne,"PRINT %s",xps_dessin[ps_current_window]->plot_file);
#endif
					system(ligne);
			}
		}
		if (xps_dessin[ps_current_window]->ps_xps)
		{
			XDestroyWindow(xps_display, xps_dessin[ps_current_window]->xps_window);
		} /* fin du if */
	} /* fin du if */
	ps_window_max --;
	free(xps_dessin[ps_current_window]);	/* fenetre detruite */
	xps_dessin[ps_current_window] = xps_dessin[ps_window_max];
	xps_dessin[ps_window_max] = NULL;	/* fenetre detruite */
	ps_current_window = 0;	/*
				 * faut bien mettre quelque
				 * chose qui existe surement
				 */

}

/*
*
*	PS_USE_WINDOW change la fenetre active
*
*/
int	ps_use_window(char *window_name)
{
	int	i;

	/* on cherche son numero */
	if (xps_display)
		for (i = 0; i < ps_window_max; i++)
		{
			if (strcmp(xps_dessin[i]->ps_window_name,window_name)) continue;
			ps_current_window = i;
			XRaiseWindow(xps_display,xps_dessin[i]->xps_window);
			XFlush(xps_display);
			return(i);
		} /* fin du for */
	return(PS_BAD_WINDOW);

} /* fin du ps_use_window */

/*
*
*	PS_GET_WINDOW donne la fenetre active (numero et nom)
*
*/
int	ps_get_window(char *window_name)
{

	if (xps_display)
	{
		strcpy(window_name,xps_dessin[ps_current_window]->ps_window_name);
		return(ps_current_window);
	}
	return(PS_BAD_WINDOW);

}

/*
*
*	PS_HIDE_WINDOW cache la  fenetre courante en l'unmapant
*	Les dessins continuent a etre envoyes dessus, mais on ne les voient pas.
*
*/
int ps_hide_window(void)
{

	if (xps_display)
		if (xps_dessin[ps_current_window]->ps_visible)
		{
			xps_dessin[ps_current_window]->ps_visible = FALSE;
			XUnmapWindow(xps_display, xps_dessin[ps_current_window]->xps_window);
		} /* fin du if */
	return(PS_BAD_WINDOW);

}

/*
*
*	PS_DISPLAY_WINDOW remontre  la  fenetre courante en la remapant
*
*/
int ps_display_window(void)
{

	if (xps_display)
		if (!xps_dessin[ps_current_window]->ps_visible)
		{
			xps_dessin[ps_current_window]->ps_visible = TRUE;
			XMapWindow(xps_display, xps_dessin[ps_current_window]->xps_window);
			return(1);
		} /* fin du if */
	return(PS_BAD_WINDOW);

}

/*
*
*	PS_TOGGLE_VISIBILITY rend la fenetre courante visible ou non selon son etat
*
*/
int ps_toggle_visibility(void)
{

	if (xps_display)
	{
		if (xps_dessin[ps_current_window]->ps_visible)
		{
			xps_dessin[ps_current_window]->ps_visible = FALSE;
			XUnmapWindow(xps_display, xps_dessin[ps_current_window]->xps_window);
			return(1);
		} /* fin du if */
		else
		{
			xps_dessin[ps_current_window]->ps_visible = TRUE;
			XMapWindow(xps_display, xps_dessin[ps_current_window]->xps_window);
			return(1);
		} /* fin du if */
	}
	return(PS_BAD_WINDOW);

}

/*
*
*	PS_IS_VISIBLE renvoi vrai ou faux si la fenetre ecourante est visible ou non
*
*/
int ps_is_visible(void)
{

	return (xps_dessin[ps_current_window]->ps_visible);

} /* fin du ps_no_watch_page */

/*
*
*	PS_FLUSH n'a de sens que si il y a un dessin X window.
*	Il est sans effet sinon.
*
*/
void ps_flush(void)
{

	if (xps_dessin[ps_current_window]->ps_xps)
	{
		if (!xps_display)
			return;
		else
		{
			XClearWindow(xps_display,xps_dessin[ps_current_window]->xps_window);
			XFlush(xps_display);
		}
	}

} /* fin du ps_flush */

/*
*
*	PS_WATCH_PAGE n'a de sens que si il y a un dessin X window.
*	Il est sans effet sinon.
*	il permet d'attendre a chaque page (on doit cliquer pour changer
*	de page.
*
*/
void ps_watch_page(void)
{

	xps_dessin[ps_current_window]->ps_wait_page = TRUE;

} /* fin du ps_watch_page */

/*
*
*	PS_NO_WATCH_PAGE n'a de sens que si il y a un dessin X window.
*	Il est sans effet sinon.
*	il permet de ne pas attendre a chaque page
*	(permet de faire de l'animation)
*
*/
void ps_no_watch_page(void)
{

	xps_dessin[ps_current_window]->ps_wait_page = FALSE;

} /* fin du ps_no_watch_page */

/*
*
*	PS_IS_WATCHABLE renvoi vrai ou faux si la fenetre courante s'arrete a
*	chaque page ou non 
*
*/
int ps_is_watchable(void)
{

	return (xps_dessin[ps_current_window]->ps_wait_page);

} /* fin du ps_is_watchable */

/*
*
*	PS_WATCH_PROGRESS n'a de sens que si il y a un dessin X window.
*	Il est sans effet sinon.
*	Option par defaut. Tous les evenements graphiques seront flushes.	
*
*/
void ps_watch_progress(void)
{
	xps_dessin[ps_current_window]->ps_auto_flush = TRUE;
} /* fin du ps_watch_progress */

/*
*
*	PS_NO_WATCH_PROGRESS n'a de sens que si il y a un dessin X window.
*	Il est sans effet sinon.
*	Permet de passer en mode manuel pour les flushs du graphisme.
*	
*
*/
void ps_no_watch_progress(void)
{
	xps_dessin[ps_current_window]->ps_auto_flush = FALSE;
} /* fin du ps_no_watch_progress */

/*
*
*	PS_IS_PROGRESS_WATCHABLE renvoi vrai ou faux si les flushs
*	graphiques sont automatiques ou non.
*
*/
int ps_is_progress_watchable(void)
{
	return (xps_dessin[ps_current_window]->ps_auto_flush);
} /* fin du ps_is_progress_watchable */


/*
*
*	PS_NEWPAGE permet de changer de page.
*	il redessine  la baniere et numerote les pages
*
*/

void ps_newpage(void)
{
	char proprio[256], moment[50], page[5];
	int show,xps;
	Display *display;
	unsigned long foreground;
	XGCValues values;

#if UNIX
	extern char *getlogin(void);
#if HAVE_UNISTD_H
	char sys_name[100];
	time_t tim, *p_tim;

	p_tim = &tim;
	tim = time(0);
	sprintf(moment,"%s",ctime(p_tim));
	moment[(strlen(moment)-1)] = 0;	/* enleve le '\n' final */
	gethostname(sys_name,100);
	/* changed by Bastien Chevreux (bach@mwgdna.com)
	   This fails miserably when started in a cron job, as 
	   getlogin() can return a NULL pointer

	   sprintf(proprio,"%s@%s",getlogin(),sys_name);
	*/
	if (getlogin()!=NULL) {
	  sprintf(proprio,"%s@%s",getlogin(),sys_name);
	} else {
	  sprintf(proprio,"unknown@%s",sys_name);
	}

	/* Protection de la memoire vive en cas de ctrlC */
	signal(SIGINT,ps_controle_c);
#   ifndef __hpux
	signal(SIGQUIT,ps_controle_c);
#   endif
#else
#  ifndef __hpux
	struct utsname sys_name, *p_sys_name;
#  endif
	time_t tim, *p_tim;
#  ifndef __hpux
	p_sys_name = &sys_name;
#  endif
	p_tim = &tim;
	tim = time(0);
	sprintf(moment,"%s",ctime(p_tim));
	moment[(strlen(moment)-1)] = 0;	/* enleve le '\n' final */
#  ifndef __hpux
	uname(p_sys_name);
	/* changed by Bastien Chevreux (bach@mwgdna.com)
	   This fails miserably when started in a cron job, as 
	   getlogin() can return a NULL pointer
	*/
	if (getlogin() != NULL) {
	  sprintf(proprio,"%s@%s",getlogin(),p_sys_name->nodename);
	} else {
	  sprintf(proprio,"unknown@%s",p_sys_name->nodename);
	}
#  endif

	/* Protection de la memoire vive en cas de ctrlC */
	signal(SIGINT,ps_controle_c);
#  ifndef __hpux
	signal(SIGQUIT,ps_controle_c);
#  endif
#endif
#endif

#if vms
	$DESCRIPTOR(dscDate, "12345678901234567890123");
	/* la chaine doit faire 23 caracteres de long */
	lib$date_time(&dscDate);
	dscDate.dsc$a_pointer[17]='\0';
	/* on tronque les secondes et les centiemes */
	strcpy(moment, dscDate.dsc$a_pointer);
	strcpy(proprio, "VAX/VMS");
#endif
#if MS_DOS
	strcpy(moment,"now...");
	strcpy(proprio,"MS/DOS");
#endif
#if 1
	if (xps_display)
	{
		xps_dessin[ps_current_window]->pl_ps_page++;
		if (xps_dessin[ps_current_window]->ps_xps)
		{
			XFlush(xps_display);
			if (xps_dessin[ps_current_window]->ps_wait_page)
			{
			printf("Waiting: %d/n",xps_dessin[ps_current_window]->ps_wait_page);
				for(;;)
				{
					XNextEvent(xps_display,
						   &(xps_dessin[ps_current_window]->xps_event));
					if (   (xps_dessin[ps_current_window]->xps_event.type == KeyPress)
					    || (xps_dessin[ps_current_window]->xps_event.type == ButtonPressMask))
					    break;
				}
			}
			XGetGCValues(xps_display,
				     xps_dessin[ps_current_window]->xps_gc,
				     GCForeground,
				     &values);
			foreground = values.foreground;
			XSetForeground(xps_display,xps_dessin[ps_current_window]->xps_gc,
				       WhitePixel(xps_display,xps_screen));
			XFillRectangle(xps_display,
				       xps_dessin[ps_current_window]->pixmap,
				       xps_dessin[ps_current_window]->xps_gc,
				       0,0,
				       xps_dessin[ps_current_window]->width,
				       xps_dessin[ps_current_window]->height);
			XSetWindowBackgroundPixmap(xps_display,
						   xps_dessin[ps_current_window]->xps_window,
						   xps_dessin[ps_current_window]->pixmap);
			XSetForeground(xps_display,xps_dessin[ps_current_window]->xps_gc,
				       foreground);
			XClearWindow(xps_display,xps_dessin[ps_current_window]->xps_window);
			XFlush(xps_display);

			/* Reinitialisation des variables de position */
			xps_dessin[ps_current_window]->alpha = 0;
			
			xps_dessin[ps_current_window]->cmt[0][0] = pl_conv;
			xps_dessin[ps_current_window]->cmt[1][0] = 0.;
			xps_dessin[ps_current_window]->cmt[0][1] = 0.;
			xps_dessin[ps_current_window]->cmt[1][1] = -pl_conv;
			xps_dessin[ps_current_window]->cmt[0][2] = 0.;
			xps_dessin[ps_current_window]->cmt[1][2] = (float)xps_dessin[0]->height;

			xps_dessin[ps_current_window]->xini = 0.;
			xps_dessin[ps_current_window]->yini = 0.;
			xps_dessin[ps_current_window]->xder = 0.;
			xps_dessin[ps_current_window]->xder = 0.;
		}
	}
	if (xps_dessin[ps_current_window]->ps_hard_copy)
	{
		display = xps_display;
		show = xps_dessin[ps_current_window]->ps_show;
		xps = xps_dessin[ps_current_window]->ps_xps;
		xps_display = NULL;
		xps_dessin[ps_current_window]->ps_show = FALSE;
		xps_dessin[ps_current_window]->ps_xps = FALSE;
		
		fprintf(xps_dessin[ps_current_window]->pl_spl,"showpage\n");

		if(ps_page_banner)
		{
		    fprintf(xps_dessin[ps_window_max]->pl_spl,"%%%%Beginning of the flag page\n");

		    /* Le cadre de flag-page */

		    traa(0.8,0.8,PL_AH);
		    traa(19.5,0.,PL_RB);
		    traa(0.,1.,PL_RB);
		    traa(-19.5,0.,PL_RB);
		    traa(0.,-1.,PL_RB);
		    traa(18.5,0.,PL_RH);
		    traa(0.,1.,PL_RB);

		    traa(1.,1.15,PL_AH);

		    /* le texte de la baniere */

		    ps_font("Times-Roman",0.4);
		    ps_chara(0.,0.,PL_RH,moment,0.4,0);
		    traa(7.,1.1,PL_AH);
		    ps_font("NewCenturySchlbk-BoldItalic",0.5);
		    ps_chara(0.,0.,PL_RH,xps_dessin[ps_current_window]->plot_file,0.5,0);
		    traa(14.,1.15,PL_AH);
		    ps_font("Times-Roman",0.4);
		    ps_chara(0.,0.,PL_RH,proprio,0.4,0);
		    traa(19.5,1.15,PL_AH);
		    sprintf(page,"%2d",xps_dessin[ps_current_window]->pl_ps_page);
		    ps_chara(0.,0.,PL_RH,page,0.4,0);

		    fprintf(xps_dessin[ps_window_max]->pl_spl,"%%End of the flag page\n");
#if XPS_DEBUG
		    printf("create_window: banner end\n");
#endif
		}
		traa(0.,0.,PL_AH);

		xps_display = display;
		xps_dessin[ps_current_window]->ps_show = show;
		xps_dessin[ps_current_window]->ps_xps = xps;
	} /* fin du if */

	/* Mise en place pour le dessin */

	ps_origin(1.,2.,0.,0.);
	ps_font("Times-Roman",0.4);
#endif
}

/*
*
*	PS_DISPLAY Permet d'autoriser la visualition X
*
*/
void ps_display(int window_number)
{
#if 1
	xps_dessin[window_number]->ps_show = TRUE;
#endif
} /* fin du ps_display */

/*
*
*	PS_NO_DISPLAY Permet d'inhiber la visualition X
*
*/
void ps_no_display(int window_number)
{
#if 1
	xps_dessin[window_number]->ps_show = FALSE;
#endif
} /* fin du ps_no_display */

/*
*
*	PS_IS_DISPLAYING renvoi vrai ou faux si la fenetre courante recoit un dessin ou non 
*
*/
int ps_is_displaying(void)
{
#if 1
	return (xps_dessin[ps_current_window]->ps_show);
#endif
} /* fin du ps_is_displaying */

/*
*
*	PS_PRINT Permet d'autoriser l'impression dans le fichier PS
*
*/
void ps_print(void)
{
#if 1
	if (xps_dessin[ps_current_window]->pl_spl)
		xps_dessin[0]->ps_hard_copy = TRUE;
#endif
} /* fin du ps_print */

/*
*
*	PS_NO_PRINT Permet d'inhiber l'impression dans le fichier PS
*
*/
void ps_no_print(void)
{
#if 1
	if (xps_dessin[ps_current_window]->pl_spl)
		xps_dessin[0]->ps_hard_copy = FALSE;
#endif
} /* fin du ps_no_print */

/*
*
*	PS_IS_PRINTING renvoi vrai ou faux si la fenetre courante est imprimee ou non 
*
*/
int ps_is_printing(void)
{
	return (xps_dessin[ps_current_window]->ps_hard_copy);
} /* fin du ps_is_printing */

/*
 * 	PS_ECHEL : Definition de l'Espace Sujet par rapport a l'Espace Absolu
 *
 *		(ex ,ey) : Nombre de centimetre par U.U. (multiple de 200)
 *		(xs, ys) : Coordonees ABSOLUES de l'origine SUJET
 *		(ca, sa) : Cosinus et sinus du dessin
 *	retourne TRUE si l'echelle est licite, et FALSE sinon
 */
int ps_echel(float ex, float ey, float xs, float ys, float ca, float sa)
{

	xps_dessin[ps_current_window]->pl_rex = ex * X_PAS;
	xps_dessin[ps_current_window]->pl_rey = ey * X_PAS;	/* Echelle en reel	*/
	xps_dessin[ps_current_window]->pl_ca = ca;
	xps_dessin[ps_current_window]->pl_sa = sa;		/* Rotation de l'espace Sujet	*/

	xps_dessin[ps_current_window]->pl_xs = xs * X_PAS;
	xps_dessin[ps_current_window]->pl_ys = ys * X_PAS;	/* Origine Sujet	*/
	xps_dessin[ps_current_window]->pl_ex =
		xps_dessin[ps_current_window]->pl_rex; 
	xps_dessin[ps_current_window]->pl_ey =
		xps_dessin[ps_current_window]->pl_rey;		/* Echelle entiere	*/

	if((xps_dessin[ps_current_window]->pl_rex - xps_dessin[ps_current_window]->pl_ex)
	   != 0.0 || ((xps_dessin[ps_current_window]->pl_rey -
		       xps_dessin[ps_current_window]->pl_ey) != 0.0 ) )
		return(FALSE);

	if (   xps_dessin[ps_current_window]->pl_ex == 0.
	    || xps_dessin[ps_current_window]->pl_ey == 0.) 
	{
		xps_dessin[ps_current_window]->pl_cms = TRUE;
		return(FALSE);
	}
	else
	{
		xps_dessin[ps_current_window]->pl_cms = FALSE;
		return(TRUE);
	}
}
/*
 *	PS_PEN : Selectionne la plume desiree. Le systeme ne connait que
 *		les plumes 0, 1, 2
 */
int ps_pen(int k)
{
	float	gris;

	if (k<0 || k>2) return(FALSE);
	xps_dessin[ps_current_window]->pl_plume = k;

	gris = 0.;

	switch(k)
	{
		case 0:
			gris = 0.;
			break;
		case 1:
			gris = 0.3;
			break;
		case 2:
			gris = 0.7;
	}
	
	if (xps_dessin[ps_current_window]->ps_hard_copy) fprintf(xps_dessin[ps_current_window]->pl_spl,"%3.1f setgray\n",gris);
	if (xps_dessin[ps_current_window]->ps_xps)
		PSsetgray(gris);
	return(TRUE);

}
/*
 *	PS_SCALE est une routine qui permet de definir un facteur d'echelle
 *	global en X et Y portant sur dessin et texte, X et Y peuvent etre 
 *	differents
 */
void ps_scale(float x_scl,float y_scl)
{

	if (xps_dessin[ps_current_window]->ps_hard_copy)
		fprintf(xps_dessin[ps_current_window]->pl_spl,"%.1f %.1f scale\n",x_scl,y_scl);
	if (xps_dessin[ps_current_window]->ps_xps)
		PSscale(x_scl,y_scl);

}
/*
 *	PS_SIZE est une routine qui permet de definir un facteur d'echelle
 *	pour les differentes routines travaillant sur des caracteres.
 *
 *	ATTENTION: hx  est une hauteur exprimee en
 *	centimetres.
 */
void ps_size(float hhx)
{
	float h_lettre;

	h_lettre = hhx * 37.5;	/* 37.5 = nb de pica/cm */
	if (xps_dessin[ps_current_window]->ps_hard_copy)
		fprintf(xps_dessin[ps_current_window]->pl_spl,
			"/%s findfont %d scalefont setfont\n",
			pl_police,(int)h_lettre);
	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PSfindfont(pl_police,hhx);
	} /* fin du if */
	xps_dessin[ps_current_window]->hl_crte = hhx;

}
/*
 *	PS_CHARA
 *
 *	Routine PostScipt d'ecriture d'un texte dans l'espace Absolu
 *	avec deplacement initial et precision d'un format. 
 *	Ce format replace celui precedement defini.
 *				Il n'y a pas de recalage.
 */
void ps_chara(float x, float y, int cd, char *strg, float hx, int rot)
{
	int l;
	int pas_erreur;

	pas_erreur = FALSE;

	l=strlen(strg);			/* Longueur du string		*/
	traa (x,y,cd);			/* Deplacement			*/
	if (hx != xps_dessin[ps_current_window]->hl_crte)
		ps_size(hx);
	if (rot)
	{
		if (xps_dessin[ps_current_window]->ps_hard_copy)
		{
			fprintf(xps_dessin[ps_current_window]->pl_spl,"gsave\n %d rotate\n",rot);
			pas_erreur = p_puts(strg,rot);			/* Ecriture de la chaine	*/
			fprintf(xps_dessin[ps_current_window]->pl_spl,"grestore\n");
		} /* fin du if */
	}
	else
		pas_erreur = p_puts(strg,rot);			/* Ecriture de la chaine	*/

	if (xps_dessin[ps_current_window]->ps_xps)
	{
		if (pas_erreur)
			PSshow(strg,rot);			/* Ecriture de la chaine	*/
	} /* fin du if */

}
/*
 *	PS_CHARS
 *
 *	Routine PostScipt d'ecriture d'un texte dans l'espace sujet
 *	avec deplacement initial et precision d'un format. 
 *	Ce format replace celui precedament defini.
 *				Il n'y a pas de recalage.
 */
void ps_chars(float x, float y, int cd, char *strg, float hx, int rot)
{
	int l;
	int pas_erreur;

	pas_erreur = FALSE;

	l=strlen(strg);			/* Longueur du string		*/
	tras(x,y,cd);			/* Deplacement			*/
	if (hx != xps_dessin[ps_current_window]->hl_crte)
		ps_size(hx);
	if (rot)
	{
		if (xps_dessin[ps_current_window]->ps_hard_copy)
		{
			fprintf(xps_dessin[ps_current_window]->pl_spl,"gsave\n %d rotate\n",rot);
			pas_erreur = p_puts(strg,rot);			/* Ecriture de la chaine	*/
			fprintf(xps_dessin[ps_current_window]->pl_spl,"grestore\n");
		} /* fin du if */
	}
	else	pas_erreur = p_puts(strg,rot);			/* Ecriture de la chaine	*/

	if (xps_dessin[ps_current_window]->ps_xps)
	{
		if (pas_erreur)
			PSshow(strg,rot);			/* Ecriture de la chaine	*/
	} /* fin du if */

}

/*
*
*	PS_FONT() permet de choisir une police de caracteres
*/
void ps_font(char *txt_police, float hhx)
{
	float	h_lettre;

	strcpy(pl_police,txt_police);
	h_lettre = hhx * 37.5;	/* 37.5 = nb de pica/cm */
	if (xps_dessin[ps_current_window]->ps_hard_copy)
		fprintf(xps_dessin[ps_current_window]->pl_spl,"/%s findfont %d scalefont setfont\n",
			txt_police,(int)h_lettre);

	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PSfindfont(txt_police,hhx);
	} /* fin du if */
	xps_dessin[ps_current_window]->hl_crte = hhx;

}
/*
 *	PS_ORIGIN permet de modifier l'origine Absolue, d'effectuer un
 *		deplacement et de terminer un record.
 *
 */
void ps_origin(float xf, float yf, float xa, float ya)
{

	traa (xf,yf,PL_AH);		/* Deplacement initial		*/
	if (xa < (-32767./PL_PAS) || xa > (32767./PL_PAS))
		fprintf(stderr,"PLOT_PS: ps_origin warning: XA exceeding limits\n");
	else
	if (ya < (-32767./PL_PAS) || ya > (32767./PL_PAS))
		fprintf(stderr,"PLOT_PS: ps_origin warning: YA exceeding limits\n");
	else
	{
		xps_dessin[ps_current_window]->pl_x = xa * X_PAS;	/* Redefinition de l'adresse de	*/
		xps_dessin[ps_current_window]->pl_y = ya * X_PAS;	/* la plume			*/
	}
	if (xps_dessin[ps_current_window]->ps_hard_copy)
		fprintf(xps_dessin[ps_current_window]->pl_spl,"%.1f %.1f translate\n",
			xps_dessin[ps_current_window]->ex_x,
			xps_dessin[ps_current_window]->ex_y);
	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PStranslate(xps_dessin[ps_current_window]->ex_x,
			    xps_dessin[ps_current_window]->ex_y);

		xps_dessin[ps_current_window]->xini =
		xps_dessin[ps_current_window]->xder =
			xps_dessin[ps_current_window]->pl_x;
		xps_dessin[ps_current_window]->yini =
		xps_dessin[ps_current_window]->yder =
			xps_dessin[ps_current_window]->pl_y;
	}

}
/*
*	PS_LINE_WIDTH()	permet de choisir une epaisseur de trait
*/
void ps_line_width(float largeur)
{

	if (xps_dessin[ps_current_window]->ps_hard_copy)
		fprintf(xps_dessin[ps_current_window]->pl_spl,"GSG\n%.2f setlinewidth\n",largeur);
	if (xps_dessin[ps_current_window]->ps_xps)
		PSsetlinewidth(largeur);

}
/*
*	PS_DASHED_LINE()	permet de choisir un pattern de ligne tiretee
*/
void ps_dashed_line(float dash, float gap, float offset)
{

	if (xps_dessin[ps_current_window]->ps_hard_copy)
		fprintf(xps_dessin[ps_current_window]->pl_spl,
			"[%.2f %.2f] %.2f setdash\n", dash, gap, offset);
	if (xps_dessin[ps_current_window]->ps_xps)
		PSsetdash(dash, gap, offset);

}
/*
*	PS_SOLID_LINE()	permet de choisir un pattern de ligne tiretee
*/
void ps_solid_line()
{

	if (xps_dessin[ps_current_window]->ps_hard_copy)
		fprintf(xps_dessin[ps_current_window]->pl_spl,
			"[] 0 setdash\n");
	if (xps_dessin[ps_current_window]->ps_xps)
		PSsetsolid();

}
/*
*	PS_GRAY() permet de definir le niveau de gris
*/
void ps_gray(float gris)
{

	if (gris < 0.) gris = 0.;	/* 0 --> NOIR	*/
	if (gris > 1.) gris = 1.;	/* 1 --> BLANC	*/

	if (xps_dessin[ps_current_window]->ps_hard_copy)
		fprintf(xps_dessin[ps_current_window]->pl_spl,"%f setgray\n",gris);
	if (xps_dessin[ps_current_window]->ps_xps)
		PSsetgray(gris);

}

/*
*
*	PS_SET_RGB_COLOR() definie une nouvelle couleur dans l'espace RGB
*	specifically for Xwindows and only if window created
*
*/
void ps_set_rgb_color(float red, float green, float blue)
{

	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PSsetrgbcolor(red,green,blue);
	} /* fin du if */
	if (xps_dessin[ps_current_window]->ps_hard_copy)
	  fprintf(xps_dessin[ps_current_window]->pl_spl,"%.3f %.3f %.3f setrgbcolor\n",red,green,blue);

} /* fin du ps_set_rgb_color */

/*
*
*	PS_SET_HSB_COLOR() definie une nouvelle couleur dans l'espace HSB
*	specifically for Xwindows and only if window created
*
*/
void ps_set_hsb_color(float hue, float saturation, float brightness)
{

	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PSsethsbcolor(hue,saturation,brightness);
	} /* fin du if */
	if (xps_dessin[ps_current_window]->ps_hard_copy)
	  fprintf(xps_dessin[ps_current_window]->pl_spl,"%.3f %.3f %.3f sethsbcolor\n",hue,saturation,brightness);

} /* fin du ps_set_hsb_color */

/*
*
*	PS_SET_CMYK_COLOR() definie une nouvelle couleur dans l'espace CMYK
*	specifically for color printers and only if hard copy
*/
void ps_set_cmyk_color(float cyan, float magenta, float yellow, float black)
{

	if (xps_dessin[ps_current_window]->ps_hard_copy)
	{
		PSsetcmykcolor(cyan,magenta,yellow,black);
	} /* fin du if */
	if (xps_dessin[ps_current_window]->ps_hard_copy)
	  fprintf(xps_dessin[ps_current_window]->pl_spl,"%.3f %.3f %.3f %.3f setcmykcolor\n",cyan,magenta,yellow,black);

} /* fin du ps_set_cmyk_color */


/*
*
*	PS_GET_RGB_COLOR() renvoie la couleur actuelle dans l'espace RGB
*
*/
void ps_get_rgb_color(float *red, float *green, float *blue)
{

	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PScurrentrgbcolor(red,green,blue);
	} /* fin du if */

} /* fin du ps_get_rgb_color */

/*
*
*	PS_GET_HSB_COLOR() renvoie la couleur actuelle dans l'espace HSB
*
*/
void ps_get_hsb_color(float *hue, float *saturation, float *brightness)
{

	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PScurrenthsbcolor(hue,saturation,brightness);
	} /* fin du if */

} /* fin du ps_get_hsb_color */

/*
*
*	PS_GET_CMYK_COLOR() renvoie la couleur actuelle dans l'espace CMYK
*
*/
void ps_get_cmyk_color(float *cyan, float *magenta, float *yellow, float *black)
{

	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PScurrentcmykcolor(cyan,magenta,yellow,black);
	} /* fin du if */

} /* fin du ps_get_cmyk_color */

/*
*	PS_ROTATE() permet de definir une rotation 
*/
void ps_rotate(int angle)
{

	if (xps_dessin[ps_current_window]->ps_hard_copy)
		fprintf(xps_dessin[ps_current_window]->pl_spl,"%d rotate\n",angle);
	if (xps_dessin[ps_current_window]->ps_xps)
		PSrotate(angle);

}
/*
 * ps_arc dessine un arc de cercle en absolu au point courant et y revient
 */
void ps_arc(float r, int theta_1, int theta_2)
{

	float ri;

	ri = r * X_PAS;
	if (xps_dessin[ps_current_window]->ps_hard_copy)
	{
		fprintf(xps_dessin[ps_current_window]->pl_spl,"%.1f %.1f %.1f %d %d arcn\n",
			xps_dessin[ps_current_window]->ex_x,
			xps_dessin[ps_current_window]->ex_y, ri, theta_1, theta_2);
		fprintf(xps_dessin[ps_current_window]->pl_spl,"%.1f %.1f M\n",
				xps_dessin[ps_current_window]->ex_x,
				xps_dessin[ps_current_window]->ex_y);
	} /* fin du if */
	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PSarcn(xps_dessin[ps_current_window]->ex_x,
		       xps_dessin[ps_current_window]->ex_y,
		       ri, ri,
		       (float)theta_1, (float)theta_2);
		PSmoveto(xps_dessin[ps_current_window]->ex_x,
			 xps_dessin[ps_current_window]->ex_y);
	} /* fin du if */

} /* fin du ps_arc */

/*
 * ps_circle dessine un cercle en absolu au point courant et y revient
 */
void ps_circle(float r)
{

	float ri;

	ri = r * X_PAS;
	if (xps_dessin[ps_current_window]->ps_hard_copy)
	{
		fprintf(xps_dessin[ps_current_window]->pl_spl,
			"newpath %.1f %.1f %.1f 0 360 arc stroke \n",
			xps_dessin[ps_current_window]->ex_x,
			xps_dessin[ps_current_window]->ex_y, ri);
		fprintf(xps_dessin[ps_current_window]->pl_spl,"%.1f %.1f M\n",
			xps_dessin[ps_current_window]->ex_x,
			xps_dessin[ps_current_window]->ex_y);
	} /* fin du if */
	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PSnewpath();
		PSarc(xps_dessin[ps_current_window]->ex_x,
		      xps_dessin[ps_current_window]->ex_y,
		      ri, ri, 0., 360.);
		PSmoveto(xps_dessin[ps_current_window]->ex_x,
			 xps_dessin[ps_current_window]->ex_y);
	} /* fin du if */
	xps_dessin[ps_current_window]->draw = FALSE;

} /* fin du ps_circle */
/*
 * ps_disk dessine un cercle plein en absolu au point courant et y revient
 */
void ps_disk(float r, float gray)
{

	float	ri;

	ri = r * X_PAS;
	if (gray >= 0.)	/* black */
	{
		if (gray > 1.) gray = 1.;	/* white */
		if (xps_dessin[ps_current_window]->ps_hard_copy)
		{
			fprintf(xps_dessin[ps_current_window]->pl_spl,
				"newpath %.1f %.1f %.1f 0 360 arc %f setgray fill stroke \n",
				xps_dessin[ps_current_window]->ex_x,
				xps_dessin[ps_current_window]->ex_y,
				ri, gray);
			fprintf(xps_dessin[ps_current_window]->pl_spl,"%.1f %.1f M\n",
				xps_dessin[ps_current_window]->ex_x,
				xps_dessin[ps_current_window]->ex_y);
		} /* fin du if */
	}
	else
	{
		if (xps_dessin[ps_current_window]->ps_hard_copy)
		{
			fprintf(xps_dessin[ps_current_window]->pl_spl,
				"newpath %.1f %.1f %.1f 0 360 arc fill stroke \n",
				xps_dessin[ps_current_window]->ex_x,
				xps_dessin[ps_current_window]->ex_y,
				ri);
			fprintf(xps_dessin[ps_current_window]->pl_spl,"%.1f %.1f M\n",
				xps_dessin[ps_current_window]->ex_x,
				xps_dessin[ps_current_window]->ex_y);
		} /* fin du if */
	} /* fin du else */
	
	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PSnewpath();
		if (gray >= 0.)
			PSsetgray(gray);
		PSfillarc(xps_dessin[ps_current_window]->ex_x,
			  xps_dessin[ps_current_window]->ex_y,
			  ri, ri, 0., 360.);
		PSmoveto(xps_dessin[ps_current_window]->ex_x,
			 xps_dessin[ps_current_window]->ex_y);
	} /* fin du if */
	xps_dessin[ps_current_window]->draw = FALSE;

} /* fin du ps_disk */
/*
 * ps_ellipse dessine une ellipse en absolu au point courant et y revient
 */
void ps_ellipse(float h_d, float v_d)
{

	float rx, ry;
	float	ellipse_scale;

	ellipse_scale = (h_d / v_d);
	rx = (h_d / 2.) * X_PAS;
	ry = (v_d / 2.) * X_PAS;
	if (xps_dessin[ps_current_window]->ps_hard_copy)
	{
		fprintf(xps_dessin[ps_current_window]->pl_spl,"1 %f scale\n",ellipse_scale);
		fprintf(xps_dessin[ps_current_window]->pl_spl,
			"newpath %.1f %.1f %.1f 0 360 arc stroke \n",
			xps_dessin[ps_current_window]->ex_x,
			xps_dessin[ps_current_window]->ex_y, rx);
		ellipse_scale = (v_d / h_d);
		fprintf(xps_dessin[ps_current_window]->pl_spl,"1 %f scale\n",ellipse_scale);
		fprintf(xps_dessin[ps_current_window]->pl_spl,"%.1f %.1f M\n",
			xps_dessin[ps_current_window]->ex_x,
			xps_dessin[ps_current_window]->ex_y);
	} /* fin du if */
	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PSnewpath();
		PSarc(xps_dessin[ps_current_window]->ex_x,
		      xps_dessin[ps_current_window]->ex_y,
		      rx, ry, 0., 360.);
		PSmoveto(xps_dessin[ps_current_window]->ex_x,
			 xps_dessin[ps_current_window]->ex_y);
	} /* fin du if */
	xps_dessin[ps_current_window]->draw = FALSE;

} /* fin du ps_ellipse */
/*
 * ps_ellip_disk dessine une ellipse pleine en absolu au point courant
 * et y revient
 */
void ps_ellip_disk(float h_d, float v_d, float gray)
{

	float	rx,ry;
	float	ellipse_scale;

	ellipse_scale = (h_d / v_d);
	rx = (h_d / 2.) * X_PAS;
	ry = (v_d / 2.) * X_PAS;

	if (gray >= 0.)	/* black */
	{
		if (gray > 1.) gray = 1.;	/* white */
		if (xps_dessin[ps_current_window]->ps_hard_copy)
		{
			fprintf(xps_dessin[ps_current_window]->pl_spl,"1 %f scale\n",ellipse_scale);
			fprintf(xps_dessin[ps_current_window]->pl_spl,
				"newpath %.1f %.1f %.1f 0 360 arc %f setgray fill stroke \n",
				xps_dessin[ps_current_window]->ex_x,
				xps_dessin[ps_current_window]->ex_y,
				rx, gray);
			ellipse_scale = (v_d / h_d);
			fprintf(xps_dessin[ps_current_window]->pl_spl,"1 %f scale\n",ellipse_scale);
			fprintf(xps_dessin[ps_current_window]->pl_spl,"%.1f %.1f M\n",
				xps_dessin[ps_current_window]->ex_x,
				xps_dessin[ps_current_window]->ex_y);
		} /* fin du if */
	}
	else
	{
		if (xps_dessin[ps_current_window]->ps_hard_copy)
		{
			fprintf(xps_dessin[ps_current_window]->pl_spl,"1 %f scale\n",ellipse_scale);
			fprintf(xps_dessin[ps_current_window]->pl_spl,
				"newpath %.1f %.1f %.1f 0 360 arc fill stroke \n",
				xps_dessin[ps_current_window]->ex_x,
				xps_dessin[ps_current_window]->ex_y,
				rx);
			ellipse_scale = (v_d / h_d);
			fprintf(xps_dessin[ps_current_window]->pl_spl,"1 %f scale\n",ellipse_scale);
			fprintf(xps_dessin[ps_current_window]->pl_spl,"%.1f %.1f M\n",
				xps_dessin[ps_current_window]->ex_x,
				xps_dessin[ps_current_window]->ex_y);
		} /* fin du if */
	} /* fin du else */
	if (xps_dessin[ps_current_window]->ps_xps)
	{
		PSnewpath();
		if (gray >= 0.)
			PSsetgray(gray);
		PSfillarc(xps_dessin[ps_current_window]->ex_x,
		       xps_dessin[ps_current_window]->ex_y,
		       rx, ry, 0., 360.);
		PSmoveto(xps_dessin[ps_current_window]->ex_x,
			 xps_dessin[ps_current_window]->ex_y);
	} /* fin du if */
	xps_dessin[ps_current_window]->draw = FALSE;

} /* fin du ps_ellip_disk */
