#ifndef PLOT_XPS_H
#define PLOT_XPS_H
/*
 * define here your SYSTEM and PostScript default queue name
 *
 *	ATTENTION Only one must be at 1
 */

#define	UNIX	1
#define	vms	0
#define	MS_DOS	0
#if UNIX
#	define PLOT_XPS_QUEUE_NAME	("lpr -Ppostscript")
#endif
#if vms
#	define PLOT_XPS_QUEUE_NAME	("PRINT /QUEUE=LN03_PS")
#endif

/*
 * Undefines to avoid conflicts in XLib.h that use ifdef vms
 */
#if	UNIX
#	undef	vms
#	undef	MS_DOS
#endif
#if	vms
#	undef	UNIX
#	undef	MS_DOS
#endif
#if	MS_DOS
#	undef	UNIX
#	undef	vms
#endif
/*
 *		P L O T _ X P S . H
 *
 *
 *	Fichier entete des fonctions plot_ps
 *
 *		J-F Vibert
 *
 *	Version 0 was in fact PLOT_BENSON
 *	Version 1	sometime during winter 88...
 *	Version 2	juillet 90
 *	Version 3	31 juillet 90
 *	Version 3.1	6 oct 90
 *	Version 4.0	21 mars 91 Adjonction de DPS
 *		en fait PLOT_DPS V0 au depart...
 *	Version 1.2	30 oct 91
 *	Version 1.3	28 aout 92 Choix de la queue d'impression
 *		PLOT_XPS : transformations pour ecran X
 *      Version 1.0     3 decembre 1992
 *	Version 1.6	30 nov 93
 *	version 2.0	11 juillet 1994	Passage des traces en flottant
 *		pour pouvoir descendre en dessous du 1/72 eme d'inch
 *	version 2.1	21 avril 1995	ps_dash_line et ps_solid_line
 *	version 2.2	3 mai 1995	date pour VMS
 *	version 2.4	7 nov 1995	disk et ellipses en couleur
 *	version 2.5	9 dec 1995	entete pour compatibilite Macintosh
 *	version 2.6	20 aout 1996	correction de bug de PSshow (EB)
 *	version 2.7	10 mars 1997	changement de symboles #defined pour
 *					eviter conflits possibles  (JFV)
 *	version 2.8	4 juillet 1997	chgt de PSset gray et PSsetrgbcolor
 *					pour traiter les directcolor display (JFV)
 *					sur une suggestion de
 *					Michael Lachmann <dirk@charles.stanford.edu
 *	version 2.9	11 aout 1997	Tres long noms de fichiers (JFV)
 *	version 2.10	1 sept 1999	Prise en compte de PRINT_LOT_PS (variable d'environnement) (JFV)
 *	version 2.11	6 oct 1999	Redefinition du nom hote si non defini (pb HPUX) (JFV)
 *	version 2.12	22 mars 2001	New function: ps_polydots (JFV)
 *	version 2.13	2 apr 2001	New function: ps_filled_area (JFV)
 *	version 2.14	11 apr 2001	New function: ps_banner and ps_no_banner (JFV)
 *
*	Auteur: Dr J-F VIBERT
*		Laboratoire de Physiologie
*		CHU Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is in any way usable for commercial purpose.
*
*/
#ifdef	PLOT_XPS
#	define	XPS_CLASS
#else
#	define	XPS_CLASS	extern
#endif
#define	PS_VERSION	"2.14"
/*
 *	Fichier de definition des variables utilise par le traceur
 */
#define PL_PAS	28.3464566929134 /* Il y a 28.346... pas par centimetre	*/
#define X_PAS   28.3464566929134
#define MAX_PLT	256		/* longeur string maxi			*/
#define LL_X	15.		/* lower left X de la Bounding Box	*/
#define LL_Y	72.		/* lower left Y de la Bounding Box	*/
#define UR_X	576.		/* upper right X de la Bounding Box	*/
#define UR_Y	756.		/* upper right Y de la Bounding Box	*/

#define	PS_MAX_WINDOW_NUMBER	10

#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <sys/time.h>

/*
 * PI n'est parfois pas defini....
 */

#ifndef M_PI
#	define	M_PI	3.14159265358979323846
#endif

/*
 * Pour la portion X11 
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>

#define BASE_COUL 60
#define NB_COUL   179.
#define BASE_GRIS 240
#define NB_GRIS   15.

XPS_CLASS	Display		*xps_display;	 /* un display X		   */
XPS_CLASS	int		xps_open_display;/* son flag			   */
XPS_CLASS	int		xps_screen;	 /* et son ecran		   */
XPS_CLASS	Colormap	colormap;	 /* sa colormap			   */
XPS_CLASS	int		type_ecran;	 /* son type d'ecran		   */
XPS_CLASS	float		pl_conv;	 /* facteur de conversion d'un pas */
					 /* postscript en pixels	   */ 

XPS_CLASS	struct	ps_dessin
	{
/*
 *	Fichier de travail
 */
		FILE		*pl_spl;	/* Fichier de travail		*/
		Window		xps_window;	/* fenetre pour le display X	*/
		XEvent		xps_event;	/* ce qui arrive a la fenetre	*/
		GC		xps_gc;		/* graphic context		*/
		Pixmap		pixmap;
		XFontStruct	*fontinfo;

		char	*ps_window_name;/* les noms des fenetres		*/
		char	*plot_file;	/* nom du fichier de plot		*/

		float	pl_rex;
		float	pl_rey;
		float	hl_crte;	/* hauteur des lettres courante		*/
		float	pl_X_crt;	/* Position courante de la plume en cm  */
		float	pl_Y_crt;
		/*
		 *    Espace Sujet
		 */
		float	pl_ca;		/* Rotation de l'espace Sujet		*/
		float	pl_sa;
		float	pl_xs;		/* Origine sujet en cm.			*/
		float	pl_ys;
		float	pl_ex;		/* Echelle : Nombre de pas / Unite U	*/
		float	pl_ey;
		float	pl_x;		/* Position de la plume en pas		*/
		float	pl_y;
		float	ex_x;		/* Position actuelle de la plume en pas	*/
		float	ex_y;
		float	xini;		/* parametres du path courant */
		float	yini;
		float	xder;
		float	yder;
		float	cmt[2][3];	/* Matrice de transformation courante   */
					/* des coord ps courantes en pixels     */
		float	red;		/* composantes de la couleur courante */
		float	green;
		float	blue;
			
		/*
		 *    Parametres 3D
		 */
		float	ps_3D_angle;	/* Angle de rotation autour des Y	*/
		float	ps_3D_phi;	/* Angle de rotation autour des X	*/
		float	cps_3D_angle;	/* Cos de Angle de rotation autour des Y */
		float	cps_3D_phi;	/* Cos de Angle de rotation autour des X */
		float	sps_3D_angle;	/* Sin Angle de rotation autour des Y	*/
		float	sps_3D_phi;	/* Sin Angle de rotation autour des X	*/
		float	ps_3D_dist_1;	/* distance objet-ecran */
		float	ps_3D_dist_2;	/* distance oeil-ecran */

		int	pl_byt;		/* Nombre de caracteres dans le buffer	*/
		int	pl_ps_page;	/* page courante			*/
		int	pl_plume;	/* Plume utilisee : 0			*/
		/*
		 *    Espace Absolu 
		 */
		int	pl_mode;	/* Mode de travail du traceur		*/
		int	pl_cms;		/* Flag de travail en espace cm		*/
		int	draw;		/* On est en train de tracer 		*/
		int	width;		/* largeur et hauteur de la fenetre X   */
		int	height;
		int	alpha;		/* cumul des rotations pour ecriture	*/
		int	h_font;		/* hauteur de la fonte courante		*/
			
		/*
		 *    BoundingBox
		 */
		float	b_b_ll_x;	/* bounding box lower left X		*/
		float	b_b_ll_y;	/* bounding box lower left Y		*/
		float	b_b_ur_x;	/* bounding box upper right X		*/
		float	b_b_ur_y;	/* bounding box upper right Y		*/

		/*
		 *    Flags globaux
		 */
		char	ps_show;	/* image XPS en cours de trace ou non	*/
		char	ps_visible;	/* image visible ou pas			*/ 
		char	ps_hard_copy;	/* Produire un fichier PS		*/
		char	ps_xps;		/* Produire un dessin X			*/
		char	ps_wait_page;	/* Arret a chaque page			*/
		char	ps_auto_flush;  /* Flush automatique ou manuel		*/
	} *xps_dessin[PS_MAX_WINDOW_NUMBER];
	
XPS_CLASS	int	pl_byt;		/* Nombre de caracteres dans le buffer	*/

XPS_CLASS	char	pl_buf[MAX_PLT],/* Buffer de travail			*/
		pl_police[256],	/* Police courante			*/
		queue_name[256], /* Nom de la queue d'impression	*/
/*
 * Flags globaux
 */
		ps_xps,		/* Produire une image ecran	*/
		ps_page_banner 	/* Banniere de page (default to True) 			*/
	/* Changed by BaCh (bach@mwgdna.com): 
	   I don't want banners on the pages */
	/* and then JFV with the ps_page_banner flag */

#ifdef PUT_BANNER_ON_PAGES 
#  ifdef PLOT_XPS
                = 1
#  endif
#endif                
                ;
/*
 *	Code des deplacements de la plume
 */
#define PL_AH 0			/* Absolu Plume Haute	*/
#define PL_AB 1			/* Abslou Plume Basse	*/
#define PL_RH 2			/* Relatif Plume Haute	*/
#define PL_RB 3			/* Relatif Plume Basse	*/

/*
 * couleurs
 */
#define	NOIR	0.
#define BLACK	0.
#define BLANC	1.
#define WHITE	1.

#define BOOLEAN	char
#define	FALSE	0
#define	TRUE	1


XPS_CLASS	int	ps_current_window,	/* La fenetre courrante */
		ps_window_max;		/* Le nb de fenetres ouvertes */

/*
 * Definition symbolique des Erreurs
 */

#define	PS_NO_WINDOW		(-1)
#define	PS_NO_ROOM_WINDOW	(-2)
#define	PS_NO_ROOM_GC		(-3)
#define	PS_NO_ROOM_NAME		(-4)
#define	PS_NO_ROOM_XEVENT	(-5)
#define	PS_NO_ROOM_DESSIN	(-6)
#define	PS_BAD_WINDOW		(-7)



/*
 * Prototypage des fonctions
 */

void tras(float , float , int );
void traa(float , float , int );
int p_depl(float , float , int );
int p_puts(char *, int );
void plopen(char *);
void plclose(char *);
void ps_banner(void);
void ps_no_banner(void);
int ps_iniplot(Display *, char *, int, int, float, float, float, char *);
void ps_endplot(char );
void ps_controle_c();
void ps_queue_name(char *);
int ps_create_window(char *, int , int, float, float, char *);
void ps_close_window(char );
int ps_use_window(char *);
int ps_get_window(char *);
int ps_hide_window(void);
int ps_display_window(void);
int ps_toggle_visibility(void);
int ps_is_visible(void);
void ps_flush(void);
void ps_watch_page(void);
void ps_no_watch_page(void);
int ps_is_watchable(void);
void ps_watch_progress(void);
void ps_no_watch_progress(void);
int ps_is_progress_watchable(void);
void ps_newpage(void);
void ps_display(int );
void ps_no_display(int);
int ps_is_displaying(void);
void ps_print(void);
void ps_no_print(void);
int ps_is_printing(void);
int ps_echel(float , float, float, float, float, float);
int ps_pen(int );
void ps_scale(float, float);
void ps_size(float );
void ps_chara(float, float, int , char *, float , int );
void ps_chars(float, float, int , char *, float , int );
void ps_font(char *, float);
void ps_origin(float, float, float, float);
void ps_line_width(float );
void ps_dashed_line(float, float, float);
void ps_solid_line(void);
void ps_gray(float );
void ps_set_rgb_color(float , float , float);
void ps_set_hsb_color(float , float , float );
void ps_set_cmyk_color(float , float , float , float );
void ps_get_rgb_color(float *, float *, float *);
void ps_get_hsb_color(float *, float *, float *);
void ps_get_cmyk_color(float *, float *, float *, float *);
void ps_rotate(int );
void ps_arc(float , int , int );
void ps_circle(float );
void ps_disk(float , float);
void ps_ellipse(float , float );
void ps_ellip_disk(float , float , float );
void pmovba(float , float );
void pmovsa(float , float );
void pmovbr(float , float );
void pmovsr(float , float );
void plinba(float , float );
void plinsa(float , float );
void plinbr(float , float );
void plinsr(float , float );
void ps_cms(void);
int ps_is_cms(void);
void ps_benson(void);
void ps_user(void);
int ps_where(float *, float *);
void ps_drawa(float , float );
void ps_drawr(float , float );
void ps_movea(float , float );
void ps_mover(float , float );
void ps_home(void);
void ps_polyline(float [], float [], int , int , int, float );
void ps_polydots(float [], float [], int , int, float );
void ps_closed_curve(float [], float [], int , int , int , float );
void ps_filled_area(float [], float [], int );
void ps_rectangle(float , float, float , float);
void ps_bezier(float [], float [], int , int , float );
void ps_point(int , float );
void ps_frame(float , float );
void ps_write(char *);
void ps_writea(float , float , char *, int );
void ps_writer(float , float , char *, int );
void ps_writeah(float , float , char *, float );
void ps_writeav(float , float , char *, float );
void ps_writefloatav(float , float , float , float );
void ps_writefloatah(float , float , float , float );
void ps_writeintav(float , float , int , float );
void ps_writeintah(float , float , int , float );
int ps_include(char *);
void ps_code(char *);
void ps_axes(float , float , float , float , float , float , char *, char *, float , int );
void ps_ticked_axes(float , float , float , float , float , float , float , float , float , float ,float, char *, char *, char *, char *, float , int );
void ps_X_axis(float , float , float , float , float , char *, char *, float );
void ps_Y_axis(float , float , float , float , float , char *, char *, float );
void ps_histo(int *, float , float , float , int , int );
void ps_3Dsetup(float , float , float , float , float , float , float , float , float , float , float , float , float );
void ps_3Daxes(int , int );
void ps_3Dcalcul(float , float , float , float *, float *);
void ps_3Dframe(float , float , float , float , float , float );
void ps_3Dbar(float , float , float , float , float , float , int );
void ps_3Dbox(float , float , float , float , float , float , int );
void ps_3Dclosebox(float , float , float , float , float , float );
void couleur(void);
void PSflush();
void PSlineto(float , float );
void PSrlineto(float , float );
void PSmoveto(float , float );
void PSrmoveto(float , float );
void PScurveto(float , float , float , float , float , float );
void PSshow(char *, int );
void PSfindfont(char *, float );
void PSscale(float , float );
void PSrotate(int );
void PStranslate(float , float );
void PSsetlinewidth(float );
void PSsetdash(float, float, float);
void PSsetsolid();
void PSsetgray(float );
void PSsetrgbcolor(float , float , float );
void PSsethsbcolor(float , float , float );
void PSsetcmykcolor(float , float , float , float );
void PScurrentrgbcolor(float *, float *, float *);
void PScurrenthsbcolor(float *, float *, float *);
void PScurrentcmykcolor(float *, float *, float *, float *);
void PSarcn(float , float , float , float , float , float );
void PSarc(float , float , float , float , float , float );
void PSfillarc(float , float , float , float , float , float );
void PSfill(float *, float *, int );
void PSclosepath(void);
void PSnewpath(void);

#undef XPS_CLASS
#undef PLOT_XPS_H
#endif
