/*
=============================================================================
	C L U S T E R _ V I S U . C
=============================================================================

	Author: Denis LAMBOLEZ (Feb 1993)
		Laboratoire de Biomathematiques
		URBB B3E INSERM U263
                Faculte de Medecine Saint-Antoine
                27 rue Chaligny
                75571 Paris cedex 12
			France

	Copyright Dr JF Vibert, July 1993
	All rights reserved
	Access limited to authorized persons	
	This software was developped only for research purpose
	and is not, in any way, usable for commercial purpose.

=============================================================================
	CONTENTS
=============================================================================
	- REALIZE_CLUSTER :  This function allocs memory and initializes the
			   representation.
	- COMPUTE_GEOMETRY_CLUSTER : This function computes geometricals parameters
				    for clusters and details of the cluster 
				    representation.
	- DRAW_CLUSTER : This function draws the cluster representation.
	- DRAW_NEURONS_VALUES_CLUSTER : This function draws neurons values
				       at the current iteration.
	- PRINT_CLUSTER : this function prints the cluster representation.
	- FREE_CLUSTER : This function free the cluster representation.
	- INFO_CLUSTER : This function constructs the information string for the
			cluster rpresentation.
=============================================================================
*/

#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <Xm/Text.h>
#include <Mrm/MrmAppl.h>                /* Motif Toolkit and MRM */
#include <X11/X.h>

#include "global_def_visu.h"
#include <plot_ps.h>


/*
=============================================================================
Name and dates: REALIZE_CLUSTER
---------------
	Creation : 28-06-93
	Last modification : 28-06-93

Functionnal description :
-------------------------
	This function allocs memory and initializes the cluster representation.

Inputs - Outputs :
------------------
			Name		Type		Description
Explicits inputs  :	None

Explicits outputs :	<return>	int		False => the representation can't be realized

Implicits inputs  :	NETWORK		NETWORK_DEF	the definition of the network
			DISPLAY_VISU	Display*	the display

Implicits outputs :	NETWORK		NETWORK_DEF	the definition of the network

Sides effects :	None
---------------

=============================================================================
*/
int REALIZE_CLUSTER()
{
	int i;

	for(i=0; i<NETWORK.NB_CLUSTERS; i++)
		printf("Name : %s\n\tX = %d, Y = %d\n", NETWORK.INFO_CLUSTERS[i].NAME,
		       NETWORK.INFO_CLUSTERS[i].POS_X, NETWORK.INFO_CLUSTERS[i].POS_Y);

	return(False);
}




