#define	MEMSPY	0
#define DMALLOC 0
/*
=============================================================================
	G L O B A L _ D E F _ V I S U . H
=============================================================================

	Author: Denis LAMBOLEZ (Feb 1993)
		Laboratoire de Biomathematiques
		URBB B3E INSERM U263
                Faculte de Medecine Saint-Antoine
                27 rue Chaligny
                75571 Paris cedex 12
			France

	Copyright Dr JF Vibert, July 1993
	All rights reserved
	Access limited to authorized persons	
	This software was developped only for research purpose
	and is not, in any way, usable for commercial purpose.

=============================================================================
	CONTENTS
=============================================================================

	-This file contents all declarations of constantes, globales variables
	 and procedures for Visualization application.
	-REMARK : This file must be include after all the includes files.
*/

#include <stdio.h>
#include <stdlib.h>

#define	VERSION_VISU "5.11"

#if MEMSPY
#	include "/usr/local/include/memspy.h"
#endif
#if DMALLOC
#	include <dmalloc.h>
#endif

#include "struct_visu.h"
#include <plot_ps.h>
#include "find_files.h"

#ifdef MAIN_VISU_MODULE
#	define CLASS 
#else
#	define CLASS extern
#endif

/*
-----------------------------------------------------------------------------
	Application constantes
-----------------------------------------------------------------------------
*/

/*General constantes*/
#ifndef Null
#	define Null  0
#endif
#ifndef True
#	define True  1
#endif
#ifndef False
#	define False 0
#endif

#define Lecture_Fichier      1
#define Lecture_Memoire      0



/*Widgets index*/
/*Remark: this section must corespond to value sections in UILs*/
#define k_Window_Main_Visu	    	 0
#define k_Button_Help_Main_About 	 1
#define k_Window_About		    	 2
#define k_Button_Open_File         	 3
#define k_Window_Network_Selection     	 4
#define k_Button_Ok_File_Selection  	 5
#define k_List_Printer                   6
#define k_Print_Box_Cancel		 7
#define k_Print_File_Box		 8
#define k_Window_Drawing_Area_Main 	 9
#define k_Button_Stop_Main          	 10
#define k_Button_Play_Main          	 11
#define k_Button_Pause_Main         	 12
#define k_Button_Goto_Index_Main    	 13
#define k_Button_Play_Step_Main          14
#define k_Text_Message_Main         	 15
#define k_Drawing_Area_Legend_Main  	 16
#define k_Text_Counter_Main         	 17
#define k_Label_Counter_Main	      	 18
#define k_Button_Open_Simul_Files   	 19
#define k_Toggle_Show_Details	    	 20
#define k_Scale_Bottom_Value		 21
#define k_Label_Top_Value	    	 22
#define k_Label_Bottom_Value	   	 23
#define k_Button_Refresh_Screen    	 24
#define k_Label_Middle_Value        	 25
#define k_Window_Scale_Top_Value     	 26
#define k_Scale_Top_Value           	 27
#define k_Button_Ok_Scale_Top_Value 	 28
#define k_Button_Change_Top_Value   	 29
#define k_Button_Close_Simulation    	 30
#define k_Button_Exit 		    	 31
#define k_Window_Time_Step         	 32
#define k_Button_Time_Step 	    	 33
#define k_Button_Ok_Time_Step      	 34
#define k_Scale_Time_Step           	 35
#define k_Button_Print			 36
#define k_Scrolled_Window_Main 	    	 37
#define k_Label_Spikes_Count        	 38
#define k_Text_Spikes_Count	    	 39
#define k_Toggle_Matrix_Representation   40
#define k_Toggle_Cluster_Representation  41
#define k_Toggle_Anatomic_Represent	 42
#define k_Toggle_Linear_Representation   43
#define k_Label_Nb_Neurons		 44
#define k_Label_Nb_Clusters		 45
#define k_Toggle_Global_Activity	 46
#define k_Window_Print			 47
#define k_Toggle_Both			 48
#define k_Print_Box_Ok			 49
#define k_Toggle_Print_All		 50
#define k_Toggle_Print_Part		 51
#define k_Toggle_To_Printer		 52
#define k_Toggle_To_Print_File		 53
#define k_Text_Info			 54
#define k_Button_Select_Neuron		 55
#define k_Toggle_Pmb_Representation	 56
#define k_List_Selected_Neuron		 57
#define k_Button_Unselect		 58
#define k_Window_List_Selected_Neuron	 59
#define k_Button_Close_List		 60
#define k_Button_Ok_It			 61
#define k_Scale_Number_It		 62
#define k_Window_Number_It		 63
#define k_Button_Unselect_Neuron	 64
#define k_Button_Number_Of_Iteration	 65

#define k_Button_Linear			 66
#define k_Button_Matrix		         67
#define k_Button_Global_Act	         68
#define k_Button_Membr_Pot	         69


/* liste des fenetre de type AFFICHE */

#define k_Window_Affiche_Pmb0            70
#define k_Draw_Affiche_Pmb0              71
#define k_Info_Affiche_Pmb0              72
#define k_Button_Cancel_Affiche_Pmb0     73
#define k_Button_Print_Affiche_Pmb0      74
#define k_ScrolledWindowForDraw0         75

#define k_Window_Affiche_Pmb1            76
#define k_Draw_Affiche_Pmb1              77
#define k_Info_Affiche_Pmb1              78
#define k_Button_Cancel_Affiche_Pmb1     79
#define k_Button_Print_Affiche_Pmb1      80
#define k_ScrolledWindowForDraw1         81

#define k_Window_Affiche_Pmb2            82
#define k_Draw_Affiche_Pmb2              83
#define k_Info_Affiche_Pmb2              84
#define k_Button_Cancel_Affiche_Pmb2     85
#define k_Button_Print_Affiche_Pmb2      86
#define k_ScrolledWindowForDraw2         87

#define k_Window_Affiche_Pmb3            88
#define k_Draw_Affiche_Pmb3              89
#define k_Info_Affiche_Pmb3              90
#define k_Button_Cancel_Affiche_Pmb3     91
#define k_Button_Print_Affiche_Pmb3      92
#define k_ScrolledWindowForDraw3         93

#define k_Window_Affiche_Pmb4            94
#define k_Draw_Affiche_Pmb4              95
#define k_Info_Affiche_Pmb4              96
#define k_Button_Cancel_Affiche_Pmb4     97
#define k_Button_Print_Affiche_Pmb4      98
#define k_ScrolledWindowForDraw4         99

#define k_Window_Affiche_Pmb5            100
#define k_Draw_Affiche_Pmb5              101
#define k_Info_Affiche_Pmb5              102
#define k_Button_Cancel_Affiche_Pmb5     103
#define k_Button_Print_Affiche_Pmb5      104
#define k_ScrolledWindowForDraw5         105
#define k_Window_Simul_Selection     	 106

#define k_Button_Help_Browse		 107

#define k_Button_Millisec	         108

#define k_Button_Movie	                 109
#define k_Scale_Inter_Images		 110
#define k_Window_Inter_Images		 111
#define k_Button_Ok_Inter_Images         112
#define k_Text_Start_Images		 113
#define k_Text_Inter_Images		 114
#define k_Text_Stop_Images		 115


/*Length of the WIDGET_ARRAY*/
#define NB_REGISTERED_WIDGET             118



/*Severities for Message*/
#define INFORMATIONAL 0
#define ERROR	      1

/*Index in the private colormap for general color*/
#define C_VIOLET              100
#define C_GREEN               101
#define C_RED		      102

#define C_SCALE_COLOR_OFFSET  103  /*The position at wich the color scale begin*/

#define C_RED1		      254
#define C_RED2		      255

/*Default size of a neuron square*/
#define DEFAULT_NEURON_SIZE 5

/*Simulation state*/
#define NO_SIMULATION 0
#define PAUSED        1
#define STOPPED	      2
#define RUNNING	      3
#define FOREWARD      4
#define GOTO_INDEX    5
#define SAME_STEP     6

/*R_FREE constants*/
#define ALL 0
#define SPECIAL 1

/*type of placement for cluster*/
#define MANUAL    0
#define AUTOMATIC 1

/*type of representation*/
#define MATRIX_REPRESENTATION	0
#define CLUSTER_REPRESENTATION	1
#define ANATOMIC_REPRESENTATION	2
#define LINEAR_REPRESENTATION	3
#define GA_REPRESENTATION	4
#define PMB_REPRESENTATION	5

/* events for neuron*/
#define NO_EVENT 0
#define SPIKE    1
#define SPIKE_TOP    100.

/* Macros generales */

/*this macro free the memory if the given pointer isn't Null*/
#define FREE_MEMORY(PT) if((PT) != Null) \
                                free((PT)); \
			PT = Null

/*this macro free GC if the given pointer isn't Null*/
#define FREE_GC(GC) if((GC) != Null) \
                        XFreeGC(DISPLAY_VISU, (GC)); \
			GC = Null

/*
-----------------------------------------------------------------------------
	Application callbacks
-----------------------------------------------------------------------------
*/

/*declaration in util_visu.c*/
extern void REGISTER(Widget, XtPointer, XtPointer);
extern void DESTROY_MESSAGE(Widget, XtPointer, XtPointer);

/*declaration in action_callback_visu.c*/
extern void COMMON_ACTION(Widget, XtPointer, XtPointer);
extern void CONTROL_BUTTON(Widget, XtPointer, XtPointer);
extern void SIMUL_ACTION(Widget, XtPointer, XtPointer);

/*declaration in main_visu.c*/
extern void EXIT_VISU();

/*
-----------------------------------------------------------------------------
	Application routines
-----------------------------------------------------------------------------
*/

/*declaration in util_visu.c*/
extern void MANAGE(int, char *);
extern void UNMANAGE(int);
extern void FATAL_ERROR(char *);
extern void SET_WAIT_CURSOR();
extern void UNSET_WAIT_CURSOR();
extern void SET_ELECTRODE_CURSOR();
extern void UNSET_ELECTRODE_CURSOR();
extern void DISPLAY_MESSAGE(char *, int);
extern void GET_EXPOSED_REGION(EXPOSED_REGION *);
extern void DISPLAY_RETICUL(Widget, XtPointer, XEvent *, Boolean *);
extern void UNDISPLAY_RETICUL(Widget, XtPointer, XEvent *, Boolean *);
extern void TRACK_RETICUL(Widget, XtPointer, XEvent *, Boolean *);
extern void BOUTON_ENFONCE(Widget, XtPointer, XEvent *, Boolean *);
extern void BOUTON_RELACHE(Widget, XtPointer, XEvent *, Boolean *);
extern void DEPLACEMENT(Widget, XtPointer, XEvent *, Boolean *);
extern void DESELECT_NEURON(int *, int);
extern void KEY_PRESS_RETICUL(Widget, XtPointer, XEvent *, Boolean *);
extern void KEY_RELACHE_RETICUL(Widget, XtPointer, XEvent *, Boolean *);

/*declaration in initialize_visu.c*/
extern void INIT_VISUALIZATION();
extern void INIT_ALLOC_TAB_SOURCE();

/*declaration in network_visu.c*/
extern int  CREATE_NETWORK(char *, char *);

/*declaration in simul_visu.c*/
extern int  LOAD_SIMUL(char *, char *);
extern Boolean RUN_SIMUL(XtPointer);
extern void ACTIVATE_TIMER_SIMUL(int *);
extern int UPDATE_REPRESENTATION();

/*declaration in print_visu.c*/
extern void INIT_PRINT_BOX();
extern void PRINT();
extern void GET_QUEUE_NAME(XmString);

/*
-----------------------------------------------------------------------------
	Visualization routines
-----------------------------------------------------------------------------
*/

/*declaration in matrix_visu.c*/
extern int REALIZE_MATRIX();
extern void DRAW_MATRIX();
extern void DRAW_NEURONS_VALUES_MATRIX(int);
extern void PRINT_MATRIX(int, float);
extern void FREE_MATRIX(int);
extern char *INFO_MATRIX(short, short, int *);

/*declaration in linear_visu.c*/
extern int REALIZE_LINEAR();
extern void DRAW_LINEAR();
extern void DRAW_NEURONS_VALUES_LINEAR(int);
extern void PRINT_LINEAR(int, float);
extern void FREE_LINEAR(int);
extern char *INFO_LINEAR(short, short, int *);

/*declaration in cluster_visu.c*/
extern int REALIZE_CLUSTER();
extern void DRAW_CLUSTER();
extern void DRAW_NEURONS_VALUES_CLUSTER(int);
extern void PRINT_CLUSTER(int, float);
extern void FREE_CLUSTER(int);
extern char *INFO_CLUSTER(short, short, int *);

/*declaration in ga_visu.c*/
extern int REALIZE_GA();
extern void DRAW_GA();
extern void DRAW_NEURONS_VALUES_GA(int);
extern void PRINT_GA(int, float);
extern void FREE_GA(int);
extern char *INFO_GA(short, short, int *);

/*declaration in pmb_visu.c*/
extern int REALIZE_PMB();
extern void DRAW_PMB();
extern void DRAW_NEURONS_VALUES_PMB(int);
extern void PRINT_PMB(int, float);
extern void FREE_PMB(int);
extern char *INFO_PMB(short, short, int *);

/*
-----------------------------------------------------------------------------
	Application global variables
-----------------------------------------------------------------------------
*/
#define    Nb_Tab_Max  6

CLASS Widget	       TOPLEVEL_WIDGET_VISU;	  /* Root widget ID */
CLASS Display          *DISPLAY_VISU;		  /* Display variable */
CLASS XtAppContext     APP_CONTEXT;	          /* Application context of Visualization */
CLASS Cursor	       WAIT_CURSOR;		  /*Shape for the wait cursor*/
CLASS Cursor	       ELECTRODE_CURSOR;	  /*Shape for the electrode cursor*/
CLASS Widget WIDGET_ARRAY[NB_REGISTERED_WIDGET];  /*Place to keep widgets and windows ids*/
CLASS NETWORK_DEF      NETWORK;			  /*The network definition*/
CLASS SIMUL_PARAMETERS SIMUL;			  /*The simulation definition*/
CLASS unsigned long    C_BLACK;		          /*index in the private colormate*/
CLASS unsigned long    C_WHITE;			  /*index in the private colormate*/
CLASS unsigned long    LUT[256];		  /*look up table*/
CLASS Colormap 	       CMAP_ID;			  /*The default colormap*/
CLASS RETICUL 	       RETICUL_DATA;		  /*Data for the reticul*/
CLASS XmString	       MASK;			  /* Current directory mask */
CLASS int	       COLORMAP_MODE;		  /*The colormap is present or not*/
CLASS short	       keep_ps_files;		  /* flag pour plot_ps */
CLASS char	       generic_name[256];	  /* nom generique passe en argument */
CLASS char             LOAD_FILE_NAME[256];    	  /* memorisation du fichier utilisee */
CLASS char             nom_de_printer[256];       /* nom du printer */
CLASS char             file_image[256];           /* chaine ou sera stocke le nom du fichier image animation */
CLASS char             GHOSTSCRIPT[256];          /* Where is located gs */
CLASS char             PAPERSIZE[20];             /* The papersize for gs */
CLASS int              pointer_Matrix;            /* flag representant le choix de la representation */
CLASS int              pointer_Linear;            /* flag representant le choix de la representation */
CLASS int              pointer_Pmb;               /* flag representant le choix de la representation */
CLASS int              pointer_Global;            /* flag representant le choix de la representation */

CLASS int              X_pos[Nb_Tab_Max],Y_pos[Nb_Tab_Max];         /* position du curseur pour les fenetres  */
CLASS int              *tab_source0,*tab_source1; /* pointeur du tableau des points de Pmb */
CLASS int              *tab_source2,*tab_source3; /* pointeur du tableau des points de Pmb */
CLASS int              *tab_source4,*tab_source5; /* pointeur du tableau des points de Pmb */
CLASS int              Debut[Nb_Tab_Max];         /* debut du zoom pour la fenetre */
CLASS int              Fin[Nb_Tab_Max];           /* fin du zoom pour la fenetre */
CLASS int              Init[Nb_Tab_Max];          /* valeur initiale pour la fenetre */
CLASS int              Debut_Hold[Nb_Tab_Max];    /* debut de l`ancien zoom */
CLASS int              Fin_Hold[Nb_Tab_Max];      /* fin de l`ancien zoom */
CLASS int              Rep_Zoom[Nb_Tab_Max];      /* un index pour le zoom */
CLASS int              Flag_Button_1;             /* ce Flag est a un quand Button 1 est enfonce */
CLASS int              FLAG_AFFICHE;              /* flag d'aiguillage d`impression pour 
						     les fenetre de type affiche */
CLASS int              INDEX_AFF;                 /* donne le numero de la fenetre pour l`impression */
CLASS int              Tab_Pointer_Affiche[Nb_Tab_Max];    /* pointeur de fenetres de type Affiche */
CLASS float            Taille_Dessin;
CLASS float            *Coord_X, *Coord_Y;        /* pointeurs de tables pour l`impression */
CLASS XPoint           *tableau;                  /* pointeur de table pour l`affichage */
CLASS int              Nbr_Iteration;             /* nombre d`iterations lues dans le fichier */
CLASS int              Scr_Width, Scr_Height;     /* largeur et hauteur de l'ecran */
CLASS int              num_image;                 /* numero de l'image pour animation */
CLASS int              Start_Images;              /* iteration de depart du film pour animation*/
CLASS int              Inter_Images;              /* nb d'iterations entre 2 images pour animation*/
CLASS int              Stop_Images;               /* iteration finale du film pour animation*/
CLASS int              flag_movie;                /* Flag pour la production d'un gif anime */
CLASS char             *ghostscript;          /* Where is located gs */
CLASS char             *papersize;             /* The papersize for gs */
#undef CLASS

#include <plot_ps.h>
#include "find_files.h"










