/*
**
**	interface_callbacks.c functions prototypes
**
*/


#ifdef _CAA_CALLBACK
#	define _CAA_CB_CLASS
#else
#	define _CAA_CB_CLASS extern
#endif

#ifndef _CAA_CALLBACK
#endif

#ifndef CALCFUNC_ARGS
#define CALCFUNC_ARGS

#define FCTPARA_PARANB 7	/* Nb of widget that are used to get paramters for calculs */
extern void print_file (Widget widget, XtPointer client_data, XtPointer call_data);

typedef void (*ACTIONFCT_TYPE)();

typedef struct calculsarg
{
	ACTIONFCT_TYPE	function;		/* function to be executed*/
	char		action[2];		/* name of action */
	int		cluster;		/* event selected for action */
	float		duration;
	float		teta;
	float		phi;
	float		linewidth;
	float		eye;
	Boolean		FctparaList[FCTPARA_PARANB];		/* lists that tell wich widgets are sensitive */
} CALCULSARG, *pCALCULSARG;

#endif

_CAA_CB_CLASS void caa_MainFunctionCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_MainExitButtonCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_MainPrintOnCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_MainPrintOptionCB	(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_MainPrintOnOKCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_MainDisplayHelpCB	(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_browse_help		();

_CAA_CB_CLASS void caa_OpenParametersCB		(Widget widget, XtPointer client_data, XtPointer call_data);

_CAA_CB_CLASS void caa_AxisApplyCB		(Widget widget, XtPointer client_data, XtPointer call_data);

_CAA_CB_CLASS void caa_fctparaApplyCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_fctparaComputeCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_fctparaDismissCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_fctparaSetSensitive	(Boolean *SensitifList);

_CAA_CB_CLASS void caa_RegisterCAAFileCB	(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_RegisterCancelCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_RegisterCAAScriptFileCB	(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_ParametersOKCB		(Widget widget, XtPointer Client_Data, XtPointer Call_Data);

_CAA_CB_CLASS void caa_OKPromptDialogCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_CAA_CB_CLASS void caa_openParametersCB		(Widget widget, XtPointer client_data, XtPointer call_data);

_CAA_CB_CLASS int caa_VerifyForCompute		(pCALCULSARG ArgOfFct);

_CAA_CB_CLASS void DispMessageDialog		(Widget Parent, char* Message, char* TitleOfMessage, unsigned char theType);
_CAA_CB_CLASS void DispPromptDialog		(Widget Parent, char* TheMessage, char* DefaultChoice);

/*************************** ACTIONS VARIABLES ****************/

/*** menu ***/

extern void	fft_amp			(pCALCULSARG ArgsOfFunction);
extern void	fft_phase		(pCALCULSARG ArgsOfFunction);
extern void	state_space		(pCALCULSARG ArgsOfFunction);
extern void	poincare		(pCALCULSARG ArgsOfFunction);
extern void	triDstate_space		(pCALCULSARG ArgsOfFunction);
extern void	amp_time		(pCALCULSARG ArgsOfFunction);
extern void	auto_correlation	(pCALCULSARG ArgsOfFunction);
extern void	cross_correlation	(pCALCULSARG ArgsOfFunction);

_CAA_CB_CLASS void	(*action_1[8])();

_CAA_CB_CLASS char	menu_1[8][80];

#undef _CAA_CB_CLASS
