/*
** Include file for caa_unix.c and caa_interface_callback.c
*/

#ifdef _CAA_CALLBACK
#	define _CAA_CB_CLASS
#else
#	define _CAA_CB_CLASS extern
#endif

#ifdef _CAA_MAIN
#	define _CAA_CLASS
#else
#	define _CAA_CLASS extern
#endif

#include  "plot_xps.h"
#undef VMS

#ifndef CALCFUNC_ARGS
#define CALCFUNC_ARGS
extern void print_file (Widget widget, XtPointer client_data, XtPointer call_data);

#define FCTPARA_PARANB 7  /* Nb of widget that are used to get parameters for calculs */

typedef void (*ACTIONFCT_TYPE)();
typedef struct calculsarg
{
	ACTIONFCT_TYPE	function;		/* function to be executed*/
	char		action[2];		/* name of action */
	int		duration;
	float		theta;
	float		phi;
	float		obsdist;
	float		prop;
	int		acluster;
	int		bcluster;
	Boolean		FctparaList[FCTPARA_PARANB];		/* lists that tell wich widgets are sensitive */
} CALCULSARG, *pCALCULSARG;

#endif /*CALCFUNC_ARGS*/

/* *********************** VARIABLES GLOBALES CAA ****************/

#define VERSION "XCAA v4.5"

#define MAX_DATA	50000
#define MAX_CLUSTER	10

#define LONG_X	13.
#define LONG_Y	6.

   /***********
   * Fichiers *
   ***********/
_CAA_CLASS FILE *data ;

#define POSTCRIPT_EXT ".ps"
#define FILENAME_SIZE 250

   /*********************
   * variables globales *
   *********************/

int  nb_donnees ,           /* nombre de donnees */
     duree_analyse,	    /* duree de l'analyse pour les correlations */
     cluster ,              /* numero du cluster a etudier */
     nb_options ,           /* nombre d'options d'analyse  */
     flag_dxpsview ,
     nb_data[MAX_CLUSTER],            /* rajout de donnees apres modification pour */
     rep_data;              /* lecture des donnees */
     
float depart,
      arrivee,
      debut,
      fin;

float temps_max[MAX_CLUSTER] ,      /* fin des donnees          */
      temps[MAX_DATA][MAX_CLUSTER] ,    /* temps des time-series    */
      bkg[MAX_DATA][MAX_CLUSTER],	  /* bruit supp du .sim       */
      etat[MAX_DATA][MAX_CLUSTER];     /* etat temporel du neurone */
double  double_table_1[MAX_DATA];      /* tableaux a tout faire pour les calculs */
double  double_table_2[MAX_DATA];
float   float_table[MAX_DATA];
float   float_table_pic[MAX_DATA];
int     int_table[MAX_DATA];

char	filename[250],   /* nom du fichier a lire               */
	file[250],	/* nom generique			*/
	scriptname[250], /* nom du fichier postscript en sortie */
	driver	,	/* s,f ou d: parametre de postscript   */
	vient_de_nbc ,	/* flags */
	already_printed ,
	filtre,
	inside,
	rep,
	buffer[250],
	legend_x[80],
	legend_y[80],
	ordre[60];

char	FileNameGiven;
	
int	nb_donnees ,		/* nombre de donnees */
	nb_options ,		/* nombre d'options d'analyse  */
	nb_demi_pages ,		/* nombre de demi-pages imprimees */
	pic[100] ,		/* date des pics frequentiels */
	filtered_event,		/* evenement filtre */
	cycle_marker,		/* symbolic names... */
	pre_synaptic,
	post_synaptic,
	nb_events,		/* nombre d'evenements total */
	nb_de_types;		/* le nb de types differents */
	
float	paper,			/* longueur du papier */
	depart,
	old_X_axis,		/* pour conserver la longuer si fig carree */
	long_X_axis,		/* longuer de l'axe des X en cms */
	long_Y_axis,		/* longuer de l'axe des Y en cms */
	horizontal_scale,
	vertical_scale,
	duree_cycle,
	sum_rate, sum_inter,	/* pour calculer des moyennes */
	max_interval_clip,
	min_interval_clip,	/* bornes pour le filtrage */
	arrivee;
	
/***************************** INTERFACE FUNCTIONS AND VARIABLES ***************************/


_CAA_CB_CLASS void DispMessageDialog (Widget TheParent,char *TextToDisplay, char *TitleOfDialog,unsigned char TypeOfDialog);
_CAA_CB_CLASS void DispPopupDialog (Widget TheParent,char *TextToDisplay, char *TitleOfDialog);
_CAA_CB_CLASS void caa_MainInitMenuVar();
_CAA_CB_CLASS Widget	main_Form;


/******************************** Environment directories ***********************************/

_CAA_CLASS char	project_directory[256];
_CAA_CLASS char	working_directory[256];
_CAA_CLASS char	bin_directory[256];
_CAA_CLASS char	help_directory[256];

#undef _CAA_CB_CLASS
#undef _CAA_CLASS









