/*
*
*	for descriptions see file tms_unix.c
*
*/


/*
**	STANDART INCLUDE FILES
*/

#include  <stdio.h>	/* standard I/O files */
#include  <stdlib.h>
#include  <signal.h>
#include  <string.h>
#include  <ctype.h>	/* macro et globales pour fonctions classification de
			   caracteres */
#include  <sys/types.h>
#include  <math.h>

/*
**	MOTIF INCLUDE FILES
*/
#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/MessageB.h>
#include <Xm/ToggleB.h>
#include <Xm/Text.h>
#include <Xm/SelectioB.h>
#if (XmVersion >= 1002)
#	include <Xm/RepType.h>
#endif
#include <Xm/MwmUtil.h>

/*
**	PERSONNAL INCLUDE FILES
*/

#include "tms_unix.h"

/*
**	GLOBAL VARIABLES
*/

extern Widget ThePopupBox;
extern Widget fctpara_TopLevelShell;
extern Widget axisLetter_TextField;
extern Widget arrowsPos_ToggleButton;
extern Widget arrowsQue_ToggleButton;
extern Widget arrowsZoneFreq_TextField;
extern Widget arrowsZoneSelect_ScrolledList;

/*** prototypes ***/

int freq (float *, float *, int, int);
int rate (float *, int *, float, float, float, int *, int, int);
int auto_cor(float *, int *, float, float, float, float, int *, int , int);
int interval(float *, int *, float, float, float, int *, int, int, int, int);

/*** estern functions ***/

extern void Message();
extern void Message_plotting();
extern void tourne_page();
extern void bounding_box(int);
extern void ps_line(float [], float [], int, float, float, float, float);
extern void Fin_plotting(int *, int, char *);
extern void statis_histo(float *,float *,float *,float *,float *,float *, int *, int);

/************************** TMSI **********************/


			/**********
			* CALCULS *
			**********/
			
/***************************************************************************/


   /**************************************************
   *   Frequence d'un evenement en fonction du temps *
   **************************************************/
void freqgram(pCALCULSARG ArgsOfFunction)
{
/*
**	Variables
*/
	int   i,
	      nb_event ;
	float taux[MAX_DATA],
	      mean,
	      event_temps[MAX_DATA],
	      max_y;           /* duration of a class */
	char  SomeChar[250];
/*
**	Code
*/

	sprintf (SomeChar,"I'm computing frequency for serial %d ...", ArgsOfFunction->events[DATA1]);
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );

	nb_event = freq(event_temps,taux,ArgsOfFunction->events[DATA1],nb_donnees);
	max_y = 0.;
	i = 0;
	mean = 0. ;
	while (i <= (nb_event-1) )
	{
		if (taux[i]>max_y) max_y = taux[i] ;
		mean = mean + taux[i] ;
		i++;
	} /* fin du while */

	if (nb_event > 2)
		mean = mean/(float)(nb_event) ;
	else
	{
		XtPopdown (XtParent(ThePopupBox));
		return;
	} /* fin du else */
	
	/* Trace du fichier postscript */

	Message_plotting();
	tourne_page();
	bounding_box(1);
	sprintf(buffer,"Evolution of instantaneous rate of event # %d",ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.,9.,"Number of events: ",.3);
	ps_writeintah(15.,9.,nb_event,.3);
	ps_writeah(8.,8.5,"Maximal value: ",.3);
	sprintf(buffer,"%.3f 1/s",max_y);
	ps_writeah(15.,8.5,buffer,.3);
	ps_writeah(8.,8.,"Duration: ",.3);
	sprintf(buffer,"%.3f s",arrivee-depart);
	ps_writeah(15.,8.,buffer,.3);
	ps_writeah(8.,7.5,"Mean rate: ",.3);
	sprintf(buffer,"%.3f 1/s",mean);
	ps_writeah(15.,7.5,buffer,.3);
	ps_font("Times-Roman",0.);
	ps_movea(0.,0.);
	ps_echel((long_X_axis/(arrivee-depart)),(long_Y_axis/max_y),0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(depart,0.,
		       depart,arrivee,
		       depart,arrivee,
		       0.,max_y,
		       0.,max_y,
		       0.1," Time (s)","%.3f"," Rate (1/s)","%.1f",0.3,0);

	ps_cms();
	ps_line(event_temps,taux,nb_event-1,depart,arrivee,long_X_axis,long_Y_axis);
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));
	
} /* fin du freqgram */

   /*****************************************************
   * Calcul de la frequence instantanee des evenements  *
   *****************************************************/
   
int freq(float *event_temps,
	 float *taux,
	 int event,
	 int nb_val)
{
	int	i = 0,
		indice = 0;
	float	temps_precedent = 0.;
       	float   taux_prec = 1.;
	char	SomeChar[250];
	Boolean CloseWin;
/*
**	Code
*/
	CloseWin = False;
	while (i++ <=(nb_val-1))
	{
		if ( type[i] == event)
		{
			if ((temps[i]-temps_precedent) == 0.)
			{
				sprintf (SomeChar, "Twice the same event at data %d",i);
				DispPopupDialog (fctpara_TopLevelShell,
						 SomeChar,
						 "Warning" );
				CloseWin = True;
				taux[indice] = taux_prec ;
				event_temps[indice] = temps[i] ;
			} /* fin du if */
			else
			{
				taux[indice] = 1./(temps[i] - temps_precedent) ;
				temps_precedent = temps[i] ;
				event_temps[indice] = temps[i] ;
				taux_prec = taux[indice];
			} /* fin du else */
			indice++;
		} /* fin du if */
	} /* fin du while */
	if (CloseWin)
	{
		XtPopdown (XtParent(ThePopupBox));
	}
	return(indice) ;
} /* fin du freq */

   /*********************
   **  Frequencegramme **
   *********************/

void freqhisto(pCALCULSARG ArgsOfFunction)
{
	int	i,
		histo[MAX_DATA],
		nb_max,
		max_y,
		h_max ;
	float	inter_max;
	
	char  SomeChar[250];
/*
**	Code
*/

	sprintf (SomeChar,"I'm computing histogram for serial %d ...", ArgsOfFunction->events[DATA1]);
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );

   /* entree des parametres */

	h_max = (int)((arrivee-depart)/ArgsOfFunction->binwidth) ;
	
	nb_max = rate(temps,type,depart,arrivee,ArgsOfFunction->binwidth,histo,h_max,ArgsOfFunction->events[DATA1]);	
	i = 0 ;
	max_y = 0 ;

   /* calcul du maximum */
	i = 0 ;
	while (i < h_max)
	{
		if (histo[i]>max_y) max_y = histo[i] ;
		i++ ;
	} /* fin du while */
   	
   /* Trace du fichier postscript */

	Message_plotting();
	tourne_page();
	bounding_box(1);
	sprintf(buffer,"Rate as function of running time of event # %d",ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.,9.,"Number of bins: ",.3);
	ps_writeintah(15.,9.,h_max,.3);
	ps_writeah(8.,8.5,"Maximal value: ",.3);
	ps_writeintah(15.,8.5,max_y,.3);
	ps_writeah(8.,8.,"Bin width: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->binwidth);
	ps_writeah(15.,8.,buffer,.3);	
	ps_font("Times-Roman",0.);
	
	XtPopdown (XtParent(ThePopupBox));
	sprintf (SomeChar,"I'm plotting a histogram of %d classes with a maxi of %d...\n",h_max,max_y);
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );
	inter_max = (float)(max_y) ;

	if (inter_max == 0.)
	{
		sprintf(SomeChar, "No event %d, sorry",event);
		DispMessageDialog (fctpara_TopLevelShell,
				   SomeChar,
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	} /* fin du if */
	ps_movea(0.,0.);
	ps_echel((long_X_axis/(arrivee-depart)),(long_Y_axis/inter_max),0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(depart,0.,depart,arrivee,depart,arrivee,
		       0.,inter_max,0.,inter_max,
		       0.1," Time (s)","%.3f"," Rate\n(imp/s)","%.1f",0.3,0);
	ps_cms();

/*	ps_ticked_axes(13.,6.,depart,arrivee,0.,inter_max," Time",
		       " Repons",.05,0);
*/
	ps_histo(histo,long_X_axis,long_Y_axis,ArgsOfFunction->binwidth,h_max,2);

	Fin_plotting(histo,h_max,".fre");

	XtPopdown (XtParent(ThePopupBox));
	
} /* fin du freqhisto */


   /*******************
   * Crosscorrelation *
   *******************/
void crosscorrelation(pCALCULSARG ArgsOfFunction)
{
	int	i,
		histo[MAX_DATA],
		max_y,
		nb_max,
		number,
		h_max;
	int cross_cor(float *, int *, float, float, float, float, int *, int, int, int);
	float	inter_max,
		cc_arrivee,
		cc_depart,
		real_duree;
	char	SomeChar[250];
	char	leg_x[250],
		leg_y[250];

   /* entree des parametres */

	if (!ArgsOfFunction->events[DATA1])
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "No reference event, thus no crosscorrelation histogram...",
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	} /* fin du if */

	real_duree = 2. * ArgsOfFunction->duration ;
	if ((temps_max-arrivee) < ArgsOfFunction->duration)
		cc_arrivee = temps_max - ArgsOfFunction->duration;
	else
		cc_arrivee = arrivee ;
	if ((depart - ArgsOfFunction->duration) < temps[0])
		cc_depart = depart + ArgsOfFunction->duration ;
	else
		cc_depart = depart ;
	h_max = 2 * (int)((ArgsOfFunction->duration )/ArgsOfFunction->binwidth) ;

	sprintf (SomeChar,"I'm computing crosscorrelation for serial %d ...\n",ArgsOfFunction->events[DATA1]);
	DispPopupDialog (fctpara_TopLevelShell,
				 SomeChar,
				 "Please wait." );

	nb_max = cross_cor(temps,type,cc_depart,cc_arrivee,ArgsOfFunction->binwidth,((h_max * ArgsOfFunction->binwidth) / 2),
			   histo,h_max,ArgsOfFunction->events[DATA1],ArgsOfFunction->events[DATA2]);
/*
	printf("There are %d events %d...\n",nb_max,ArgsOfFunction->events[DATA1]);
*/
	if (nb_max == 0)
	{
		sprintf (SomeChar,"No event %d, sorry",ArgsOfFunction->events[DATA1]);
		DispMessageDialog (fctpara_TopLevelShell,
				   SomeChar,
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	} /* fin du if */

	i = 0 ;
	number = 0.;
	max_y = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee) if (type[i] == ArgsOfFunction->events[DATA1] ) number++ ;

   /* calcul du maximum */
	i = 0 ;
	while (i < nb_max)
	{
		if (histo[i]>max_y) max_y = histo[i] ;
		number = number + histo[i] ;
		i++ ;
	} /* fin du while */
	if (max_y < 1) max_y = 1 ;
   	
   /* Trace du fichier postscript */
	Message_plotting();
	tourne_page();
	bounding_box(1);
	sprintf(buffer,"Crosscorrelation of reference event # %d and analyzed event # %d\n",
		ArgsOfFunction->events[DATA1],
		ArgsOfFunction->events[DATA2]);
	ps_writeah(0.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.,9.,"Number of bins: ",.3);
	ps_writeintah(15.,9.,h_max,.3);
	ps_writeah(8.,8.5,"Maximal value: ",.3);
	ps_writeintah(15.,8.5,max_y,.3);
	ps_writeah(8.,8.,"Bin width: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->binwidth);
	ps_writeah(15.,8.,buffer,.3);	
	ps_writeah(8.,7.5,"Analysis Duration: ",.3);
	sprintf(buffer,"%.3f s",real_duree);
	ps_writeah(15.,7.5,buffer,.3);	
	ps_font("Times-Roman",0.);

	XtPopdown (XtParent(ThePopupBox));
	sprintf (SomeChar,"I'm plotting a histogramm of %d classes with a maxi of %d...\n", nb_max, max_y);
	DispPopupDialog (fctpara_TopLevelShell,
				 SomeChar,
				 "Please wait." );
	inter_max = (float)(max_y) ;

	ps_movea(0.,0.);
	ps_echel((long_X_axis/(((float)(nb_max)*ArgsOfFunction->binwidth/2.)* 2.)),(long_Y_axis/(inter_max/((float)(number)*ArgsOfFunction->binwidth))),0.,0.,1.,0.);
	ps_user();

	sprintf(leg_x,"Time from reference event %d (s)", ArgsOfFunction->events[DATA1]);
	sprintf(leg_y,"Rate of event %d (imp/s)", ArgsOfFunction->events[DATA2]);

	ps_ticked_axes(-(float)(nb_max)*ArgsOfFunction->binwidth/2.,0.,
		       -(float)(nb_max)*ArgsOfFunction->binwidth/2.,(float)(nb_max)*ArgsOfFunction->binwidth/2.,
		       -(float)(nb_max)*ArgsOfFunction->binwidth/2.,0.,
		       0.,inter_max/((float)(number)*ArgsOfFunction->binwidth),
		       0.,inter_max/((float)(number)*ArgsOfFunction->binwidth),
		       0.1,leg_x,"%.3f",leg_y,"%.3f",.3,0);

	ps_ticked_axes(-(float)(nb_max)*ArgsOfFunction->binwidth/2.,0.,
		       -(float)(nb_max)*ArgsOfFunction->binwidth/2.,(float)(nb_max)*ArgsOfFunction->binwidth/2.,
		       0.,(float)(nb_max)*ArgsOfFunction->binwidth/2.,
		       0.,inter_max/((float)(number)*ArgsOfFunction->binwidth),
		       0.,inter_max/((float)(number)*ArgsOfFunction->binwidth),
		       0.1,leg_x,"%.3f",leg_y,"%.3f",.3,0);

	ps_movea((float)(nb_max)*ArgsOfFunction->binwidth/2.,0.);
	ps_cms();
	ps_drawr(0.,long_Y_axis);

	ps_movea(0.,0.) ;
	ps_histo(histo,long_X_axis,long_Y_axis,ArgsOfFunction->binwidth,nb_max,0);
	Fin_plotting(histo,nb_max,".ccr");
	XtPopdown (XtParent(ThePopupBox));
		
} /* fin du crosscorrelation */

   /********************************
   * Lissajous of cycle histogramm *
   ********************************/
void lissajous(pCALCULSARG ArgsOfFunction)
{
	float	x,y,
		x_prec,
		y_prec,
		x_ori,
		y_ori,
		kx,ky,
		max_y,
		max_x,
		min_y,
		min_x,
		fleche,
		cc_depart,
		cc_arrivee,
		duree;      /* duration of analysis  */
	    
	int	i, j, k, n,
		ev_absc[MAX_DATA],
		ev_ordo[MAX_DATA],
		nb_max_ord,
		nb_max_abs,
		max_class,
		number,
		arrows_man,
		h_max ;

	int	fleche_freq,
		num_class,
		faux,
		sgt_arrows[100];

	char		*SomeChar;
	Boolean		Selected;
	Boolean		AutoSelected;
	XmString	*ArrowsList;
	int		ArrowCount;
		
	void	trace_fleche();

   /* entree des parametres */

	old_X_axis = long_X_axis;
	if (ArgsOfFunction->square)
	{
		long_X_axis = long_Y_axis;
	}
	cycle_marker = ArgsOfFunction->cycle;

	if (!ArgsOfFunction->cycle)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "No reference event, thus no Lissajous...",
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	} /* fin du if */
	duree = ArgsOfFunction->duration / 2. ;

	Selected = XmToggleButtonGetState(arrowsQue_ToggleButton);
	if (Selected)
	{
		AutoSelected = XmToggleButtonGetState(arrowsPos_ToggleButton);
		if (AutoSelected)
		{
			SomeChar = (char*) XmTextGetString (arrowsZoneFreq_TextField);
			fleche_freq = atoi (SomeChar);
			arrows_man = FALSE;
			XtFree (SomeChar);
		}
		else
		{
			XtVaGetValues (arrowsZoneSelect_ScrolledList,
				       XmNitems, &ArrowsList,
				       XmNitemCount, &ArrowCount,
				       NULL);
			if (ArrowCount)
			{
				arrows_man = TRUE;
				for (i = 0; i < ArrowCount; i++)
				{
					XmStringGetLtoR (ArrowsList[i], XmFONTLIST_DEFAULT_TAG, &SomeChar);
					sgt_arrows[i] = atoi (SomeChar);
					XtFree (SomeChar);
				}
			}
		}
	}

	if ((temps_max-arrivee) < duree) cc_arrivee = temps_max - duree;
	else cc_arrivee = arrivee ;
	if ((depart - duree) < temps[0]) cc_depart = depart + duree ;
	else cc_depart = depart ;
	h_max = 2 * (int)(duree/ArgsOfFunction->binwidth) ;
	
	DispPopupDialog (fctpara_TopLevelShell,
			 "I'm computing Lissajous of cycle",
			 "Please wait." );
	
	n =  (int)(duree/ArgsOfFunction->binwidth) ;

	for (i = 0; i < MAX_DATA; i++)
	{
		ev_absc[i] = ev_ordo[i] = 0;
	} /* fin du for */


	i = max_class = faux = num_class = 0;
	nb_max_abs = 0 ;
	number = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i] < arrivee) 
	{
		if (type[i] == ArgsOfFunction->cycle )
		{
			number++;
			j = i ;
			while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <= arrivee ))
			{
				if (type[j] == ArgsOfFunction->events[DATA1])
				{
					num_class = (int)((temps[j]-temps[i])/ArgsOfFunction->binwidth);
					if (num_class > max_class) max_class = num_class;
					if (num_class < h_max) ev_absc[num_class]++;
					else faux++;	/* don't fit in histo */
				} /* fin du if */
				j++;	
			} /* fin du while */
		} /* fin du if */
		i++;
	} /* fin du while */

	nb_max_abs = max_class;

	i = max_class = faux = num_class = 0;
	nb_max_ord = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i] < arrivee) 
	{
		if (type[i] == ArgsOfFunction->cycle )
		{
			j = i ;
			while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <= arrivee ))
			{
				if (type[j] == ArgsOfFunction->events[DATA2])
				{
					num_class = (int)((temps[j]-temps[i])/ArgsOfFunction->binwidth);
					if (num_class > max_class) max_class = num_class;
					if (num_class < h_max) ev_ordo[num_class]++;
					else faux++;	/* don't fit in histo */
				} /* fin du if */
				j++;	
			} /* fin du while */
		} /* fin du if */
		i++;
	} /* fin du while */
	nb_max_ord = max_class;

	/*
	 * on prend le plus grand des 2, s'il ne sont pas egaux, ca veut dire
	 * qu'il y a des classes nulles a la fin de l'autre histogramme
	 */
	if (nb_max_abs > max_class) max_class = nb_max_abs;

	/*
	 * bornage
	 */
	i = 0 ;
	while ( i < nb_max_abs)
	{
		if ((float)(ev_absc[i]) > max_x) max_x = (float)( ev_absc[i]) ;
		i++ ;
	} /* fin du while */
	if (max_x < 1.) max_x = 1. ;
	i = 0 ;
	while (i < nb_max_ord)
	{
#if DEBUG
		printf("Ordonnee[%d] = %f Abscisse[%d] = %f\n",i,ev_ordo[i],i,ev_absc[i]); */
#endif
		if ( (float)(ev_ordo[i]) > max_y) max_y = (float)( ev_ordo[i]) ;
		i++ ;
	} /* fin du while */
	if (max_y < 1.) max_y = 1. ;

	max_x = max_x/((float)(number)*ArgsOfFunction->binwidth) ;
	max_y = max_y/((float)(number)*ArgsOfFunction->binwidth) ;
	min_x = 0.;
	min_y = 0.;

	if (min_y == max_y || min_x == max_x)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "Max = min, no drawing possible",
				   "Error",
				   XmDIALOG_ERROR);
		return;
	}
	
	kx = long_X_axis/(max_x - min_x) ;
	ky = long_Y_axis/(max_y - min_y) ;	
   	
   /* Trace des legendes */
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_writeah(1.,10.,"Lissajous diagram of cycle histogram: ",.4);
	ps_font("Courier",0.);
	ps_writeah(1.,9.5,"cycle event ",.3);
	ps_writeintah(7.,9.5,ArgsOfFunction->cycle,.3);
	ps_writeah(8.,7.5,"Number of bins: ",.3);
	ps_writeintah(15.,7.5,nb_max_ord,.3);
	ps_writeah(8.,9.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(15.,9.5,buffer,.3);
	ps_writeah(8.,9.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(15.,9.,buffer,.3);
	ps_writeah(8.,8.5,"Bin width: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->binwidth);
	ps_writeah(15.,8.5,buffer,.3);	
	ps_writeah(8.,8.,"Duration of Analysis: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->duration);
	ps_writeah(15.,8.,buffer,.3);
	ps_writeah(1.,9.,"X event: ",.3);
	ps_writeintah(7.,9.,ArgsOfFunction->events[DATA1],.3);	
	ps_writeah(1.,8.5,"Y event: ",.3);
	ps_writeintah(7.,8.5,ArgsOfFunction->events[DATA2],.3);		
	ps_writeah(1.,8.,"Number of cycles: ",.3);
	ps_writeintah(7.,8.,number,.3);		
	ps_font("Times-Roman",0.);

   /* trace du diagram */


	ps_movea(0.,0.);
	ps_echel(kx,ky,0.,0.,1.,0.);
	ps_user();
	for (i = 0; i < nb_de_types; i++)
	{
		if (event[i].numero == ArgsOfFunction->events[DATA1])
			sprintf(legend_x,"%s rate/s",event[i].nom);
		if (event[i].numero == ArgsOfFunction->events[DATA2])
			sprintf(legend_y,"%s rate/s",event[i].nom);
	} /* fin du for */
	ps_ticked_axes(min_x,min_y,
		       min_x,max_x,
		       min_x,max_x,
		       min_y,max_y,
		       min_y,max_y,
		       0.1,legend_x,"%.1f",legend_y,"%.1f",0.3,1);
	ps_cms();
	ps_movea(0.,0.);


	fleche = .3;
	j = 0;
	x_ori = x_prec = ( (float)(ev_absc[0])/((float)(number)*ArgsOfFunction->binwidth) - min_x) * kx ;
	y_ori = y_prec = ( (float)(ev_ordo[0])/((float)(number)*ArgsOfFunction->binwidth) - min_y) * ky ;
	ps_movea(x_ori,y_ori);

	/* parfois des pbs de bornes mal maitrise... */
	if (!ev_absc[nb_max_ord-1] && !ev_ordo[nb_max_ord-1]) nb_max_ord--;
	if (!ev_absc[0] && !ev_ordo[0])
		i = 1;
	else
		i = 0;
	k = 0;
	for (; i < nb_max_ord ; i++)
	{
/*		printf("%d : X = %d   Y = %d\n", i,  ev_absc[i],ev_ordo[i]);
*/

		x = ( (float)(ev_absc[i])/((float)(number)*ArgsOfFunction->binwidth) - min_x) * kx ;
		y = ( (float)(ev_ordo[i])/((float)(number)*ArgsOfFunction->binwidth) - min_y) * ky ;

		ps_drawa(x,y);
		if (Selected)
		{
			
			if (!arrows_man && fleche_freq && !(j%fleche_freq))
			{
				if (i) trace_fleche(x_prec,y_prec,x,y,.1);
			} /* fin du if */
			if (arrows_man && sgt_arrows[k] == i)
			{
				trace_fleche(x_prec,y_prec,x,y,.1);
				k++;
			} /* fin du if */
				
		} /* fin du if */
		ps_point(2,.1);
		ps_drawa(x,y);
		j++;
		x_prec = x;
		y_prec = y;
	} /* fin du for */
	ps_drawa(x_ori,y_ori);
	ps_point(2,.15); 
/*	ps_point(2,.1);
*/
	ps_movea(0.,0.) ;
	long_X_axis = old_X_axis;
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));

} /* fin du lissajous */

void	trace_fleche(x_prec, y_prec, x, y, base_fleche)
float	x_prec,
	y_prec,
	x,
	y,
	base_fleche;
{
	float	delta_x,	/* taille du segment */
		delta_y,
		x_base,		/* coordonnees de la base */
		y_base,
		xx[3],		/* la fleche  */
		yy[3];		


	delta_x = (x - x_prec);		/* taille du segment */
	delta_y = (y - y_prec);

	xx[0] = x - (delta_x / 3.);		/* pointe de la fleche */
	yy[0] = y - (delta_y / 3.);
	x_base = x_prec + (delta_x / 3.);	/* base de la fleche  */
	y_base = y_prec + (delta_y / 3.);

	/*
	 * Fleche verticale
	 */
	if (yy[0] == y_base)
	{
			xx[1] = xx[2] = x_base; 
			yy[1] = y_base - base_fleche;
			yy[2] = y_base + base_fleche;
	} /* fin du if */
	else
	{
		xx[1] = base_fleche /
			(sqrt(1. + (((x_base - xx[0])/(yy[0] - y_base)) *
			((x_base - xx[0])/(yy[0] - y_base))))) + x_base; 
		xx[2] = - base_fleche /
			(sqrt(1. + (((x_base - xx[0])/(yy[0] - y_base)) *
			((x_base - xx[0])/(yy[0] - y_base))))) + x_base; 
		
		yy[1] = y_base + ((x_base - xx[0])/(yy[0] - y_base)) * (xx[1] - x_base);
		yy[2] = y_base + ((x_base - xx[0])/(yy[0] - y_base)) * (xx[2] - x_base);
	} /* fin du else */
/*
	x_base = x_prec + (delta_x / 3.) + (delta_x / 6.);
	y_base = y_prec + (delta_y / 3.) + (delta_y / 6.);
*/
	ps_closed_curve(xx,yy,3,TRUE,TRUE,0.);
	ps_movea(x,y); 


} /* fin du void */


   /*******************
   * Scatter Diagram *
   *******************/
void scatter_diagram(pCALCULSARG ArgsOfFunction)
{
	int i,j,k,l,
	    spied1,
	    spied2,
	    nombre_ref,
	    nb_spied1,
	    nb_spied2,
	    actuel;
	float px,
	      py,
	      inter_spied1[1000],
	      inter_spied2[1000];

   /* Initialisation */

	cycle_marker = ArgsOfFunction->cycle;
	if (!ArgsOfFunction->cycle)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "No reference event, thus no scatter diagram...",
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	}

	i = 0;
	nombre_ref = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee) if (type[i] == ArgsOfFunction->cycle) nombre_ref++;
	
   /* calcul des dimensions */
	px = 7.5/ArgsOfFunction->duration ;

   /* Ecriture du fichier postscript */

	Message_plotting() ;
	tourne_page();
	bounding_box(1);
	ps_movea(0.,(float)(nombre_ref)*py) ;
	ps_font("Times-Roman",0.);

	ps_movea(0.,0.);
	ps_echel(px,px,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(0.,0.,
		       0.,ArgsOfFunction->duration,
		       0.,ArgsOfFunction->duration,
		       0.,ArgsOfFunction->duration,
		       0.,ArgsOfFunction->duration,
		       0.1," Time of event 1 (s)","%.3f",
		       " Time of event 2 (s)","%.3f",0.3,0);
	ps_cms();


	i = 0 ;
	actuel = 0 ;
	nb_spied1 = 0 ;
	nb_spied2 = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee) 
	{
		if (type[i] == ArgsOfFunction->cycle )
		{
			actuel++;
			nb_spied1 = 0;
			nb_spied2 = 0;
			j = i ;
			while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <=arrivee ))
			{
			if (type[j] == spied1)
				{
					nb_spied1++;
					inter_spied1[nb_spied1]=(temps[j]-temps[i]) ;
				} /* fin du if */
			if (type[j] == spied2)
				{
					nb_spied2++;
					inter_spied2[nb_spied2]=(temps[j]-temps[i]) ;
				} /* fin du if */
			j++;	
			} /* fin du while */
			
			/* plotting */
			for (k=0;k < nb_spied1;k++)
			for (l=0;l < nb_spied2;l++)
			{
				ps_movea(inter_spied1[k]*px,inter_spied2[l] * px);
				ps_point(16,.1) ;
			} /* fin du for */
		
		} /* fin du if */
	} /* fin du while */
		
	ps_movea(0.,0.) ;
	ps_writeah(0.,10.,"Scatter diagram",.4);
	ps_writeah(3.,9.,"Reference event: ",.3);
	ps_writeintah(7.3,9.,ArgsOfFunction->cycle,.3);
	ps_writeah(3.,8.5,"First spied Event: ",.3);
	ps_writeintah(7.3,8.5,spied1,.3);
	ps_writeah(3.,8.,"Snd spied Event: ",.3);
	ps_writeintah(7.3,8.,spied2,.3);		
	ps_font("Courier",0.);
	ps_writeah(8.,9.,"Number of reference events: ",.3);
	ps_writeintah(15.,9.,nombre_ref,.3);
	ps_writeah(8.,8.5,"Analysis duration: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->duration);
	ps_writeah(15.,8.5,buffer,.3);
	ps_font("Times-Roman",0.);	
	Fin_plotting(NULL,0,NULL) ;
	
	
} /* fin du Scatter */

   /*****************
   * agrandissement *
   *****************/
   
   /********************************************
   ** exp de l'espace des phases des intervals *
   ********************************************/
   
void exp_derive_inter(pCALCULSARG ArgsOfFunction)
{

    /*******************
    *    declarations  *
    *******************/
    
	int   i,
	      ref_event,
	      indice,
	      nb_max;

	float max,
	      min,
	      maxy,
	      miny,
	      precedent,
	      x,y,
	      kx,ky,
	      derivee[MAX_DATA],
	      inter[MAX_DATA];

	DispMessageDialog (fctpara_TopLevelShell,
			   "Not yet ported, use TMS, sorry...",
			   "Warning",
			   XmDIALOG_WARNING);
	return;
    /* Initialisation */
	Message("Exp(d(interval)/dt = f(interval)\n");
/*
	ref_event = askival(" Event: ",post_synaptic) ;
*/
	printf("I'm computing the map ...\n");
	max  = 0. ;
	min = 0. ;
	maxy = 0. ;
	miny = 0. ;
	i = 0 ;
	indice = 0;
	while (temps[i++] < depart ) ;
	while (type[i++] != ref_event) ;
	precedent = temps[i] ;
	i++ ;
	while (temps[i] < arrivee )
	{
		if (type[i] == ref_event)
		{
			inter[indice] = temps[i]-precedent;
			if (inter[indice]>max) max = inter[indice];
			precedent = temps[i] ;
			indice++  ;
			
		} /* fin du if */
		i++ ;
	} /* fin du while */	

	nb_max = indice ;
	for (i=1;i < nb_max;i++)
	{
		derivee[i] = exp((inter[i]-inter[i-1]) / inter[i]) ;
		if (derivee[i]>maxy) maxy = derivee[i] ; 
		if (derivee[i] < miny) miny = derivee[i] ;
	} /* fin du for */
/*
	max = askfval(" Maximal value: ",max);
	min = askfval(" Minimal value: ",min);

	maxy = askfval(" Maximal value for exp(d(I)): ",maxy);
	miny = askfval(" Minimal value for exp(d(I)): ",miny);
*/

	if (min == max || miny == maxy)
	{
		Message("Max = min, no drawing possible\n");
		return;
	} /* fin du if */


	kx = 7./(max-min) ;
	ky = 7./(maxy-miny) ;
    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;

   /* LEGENDES */
	ps_writeah(0.,9.,"Phase map of intervals (Exponential scale).",.4);
	ps_writeah(10.,9.,"Event #",.4);
	ps_writeintah(13.,9.,ref_event,.4);
	ps_font("Courier",0.);
	ps_writeah(8.3,7.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(15.,7.5,buffer,.3);			
	ps_writeah(8.3,7.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(15.,7.,buffer,.3);
	ps_font("Times-Roman",0.);


   /* trace des axes verticaux et horizontaux */

	ps_movea(0.,0.);
	ps_echel(kx,ky,0.,0.,1.,0.);
	ps_user();
	ps_font("Times-Roman",0.);		   
	ps_ticked_axes(min,miny,
		       min,max,
		       min,max,
		       miny,maxy,
		       miny,maxy,
		       0.1," Interval (s)","%.3f"," Exp(d(I)/I)","%.1f",0.3,0);
	ps_cms();

/*	ps_ticked_axes(7.,7.,min,max,miny,maxy," Interval"," exp( d(I)/I )",.1,1) ; */

   /* plotting des ps_points */
	indice = 0;
	for (i=1;i < nb_max;i++)
	{
		if ((inter[i]>min)&&(inter[i] < max)&&(derivee[i]>miny)&&(derivee[i] < maxy))
		{
		x = (inter[i]-min)*kx ;
		y = (derivee[i]-miny)*ky ;
		ps_movea(x,y) ;
		ps_point(16,.1) ;
		indice++ ;
		} /* fin du if */
	} /* fin du for */
	ps_font("Courier",0.);
	ps_writeah(8.3,8.,"Number of points: ",.3);
	ps_writeintah(15.,8.,indice,.3);			
	ps_font("Times-Roman",0.);		   
	ps_movea(0.,0.) ;
	Fin_plotting(NULL,0,NULL);

} /* fin du Derive_inter */


/**************************************************************
*
*	Collection de fonctions C pour traiter les time series.
*
*	Several arguments are common to all functions:
*
*	INPUTS
*
*		temps[]	-->	holds the time of events
*		event[]	-->	holds the event code
*		debut	-->	analysis beginning
*		fin	-->	analysis end
*		bin	-->	bin width (class duration)
*		h_max	-->	max number of classes in histo
*
*	OUTPUTS
*
*		histo[] -->	the resulting histogram
*
*	RETURN
*
*		the actual maximum indice in histo[]
*
*	Auteur: Dr J-F VIBERT
*		Laboratoire de Physiologie
*		CHU Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is in any way usable for commercial purpose.
*
*/


   /*
   *	RATE()	establishes a rate-time histogram
   *	returns the higest non zero class indice of histo[]
   */
int rate(float *time,	/* la time series elle_meme */
	 int *evenement,/* the evenements */
	 float debut,	/* start analysis */
	 float fin,	/* end analysis */
	 float bin,	/* bin width */
	 int *histo,	/* the resulting histogram */
	 int h_max,	/* max nb of classes in histo */
	 int ev_type)	/* max nb of classes in histo */
{
	register i;
	int	num_class,	/* numero de la classe */
		faux,		/* nb of not-fitting evenements */
		max_class;	/* higher number of classes */
	
	for (i =0; i < h_max; i++) histo[i] = 0;	/* intialize histo */

	i = max_class = 0;
	faux = 0;	/* count of evenements extra histogram */
	while (time[i++] < debut);	/* wait for the beginning */
	while (time[i] <= fin)		/* till the end */
	{
		if (evenement[i] == ev_type)
		{
			num_class = (int)((time[i]-debut)/bin);/* modifie */ 
			if (num_class > max_class) max_class = num_class;
			if (num_class < h_max) histo[num_class]++;
			else faux++;	/* don't fit in histo */
		}
		i++;
	}
	if (faux) fprintf(stderr,"\007%d times too large to fit in the histogram\n",faux);
	if (max_class >= h_max) max_class = h_max - 1;
	return(max_class);
}

   /*
   *	CROSS_COR()	establishes a cross correlation histogram 
   *	returns the higest non zero class indice of histo[]
   */
int cross_cor(float *time,	/* la time series elle_meme */
	      int *evenement,	/* the evenements */
	      float debut,	/* start analysis */
	      float fin,	/* end analysis */
	      float bin,	/* bin width */
	      float duree,	/* duration of the CC analysis */
	      int *histo,	/* the resulting histogram */
	      int h_max,	/* max nb of classes in histo */
	      int evenement_A,	/* the code of the analyzed evenement A of A->B */
	      int evenement_B)	/* the code of the analyzed evenement B of A->B */
{
	register i, j;
	int	num_class,	/* numero de la classe */
		faux,		/* nb of not-fitting evenements */
		max_class,	/* higher number of classes */
		med_j;		/* middle of the histogram */
	float	moment,		/* the current time */
		suivant;	/* the next time */
		
	if (debut < duree) return(-1);	/* erreur, analysis impossible */
	med_j = (int)(h_max/2)-1;		/* position of the stimulus */
	
	for (i =0; i < h_max; i++) histo[i] = 0;	/* intialize histo */

	i = max_class = 0;
	faux = 0;	/* count of evenements extra histogram */
	while (time[i++] < debut);	/* wait for the beginning */
	while ((moment = time[i]) <= fin)		/* till the end */
	{
		if (evenement[i] == evenement_A)
		{
			/* Positive side of the CC */
			for (j = i+1; time[j] < (moment + duree) ; j++)
			{
				if (evenement[j] == evenement_B)
				{
					suivant = time[j];
					num_class = (int)((suivant - moment)/bin);
					num_class += med_j;
					if (num_class > max_class ) max_class = num_class;
					if (num_class < h_max) histo[num_class]++;
					else faux++;	/* don't fit in histo */
				}
			}
			/* Negative side of the CC */
			for (j = i-1; time[j] > (moment - duree) ; j--)
			{
				if (evenement[j] == evenement_B)
				{
					suivant = time[j];
					num_class = (int)((moment - suivant)/bin);
					num_class = med_j - num_class;
					if (num_class > max_class) max_class = num_class;
					if (num_class < h_max) histo[num_class]++;
					else faux++;	/* don't fit in histo */
				}
			}
		}
		i++;
	}
	if (faux) fprintf(stderr,"\n\007%d times too large to fit in the histogram\n",faux);
	if (max_class >= h_max) max_class = h_max - 1;
	return(max_class);
}


/************************** TMS II **********************/



			/**********
			* CALCULS *
			**********/
			

   /********************************************************
   **      Frequence d'un evenement en fonction du temps  **
   ********************************************************/

void freqgram_dots(pCALCULSARG ArgsOfFunction)
{
/*
**	Variables
*/
	int i,
	    nb_event ;
	    
	float taux[MAX_DATA],
	      event_temps[MAX_DATA],
	      kx,ky,
	      mean,
	      x_point,y_point,
	      max_y;           /* duration of a class */
	char  SomeChar[250];
/*
**	Code
*/	

	sprintf (SomeChar,"I'm computing frequency for serial %d ...", ArgsOfFunction->events[DATA1]);
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );
	nb_event = freq(event_temps,taux,ArgsOfFunction->events[DATA1],nb_donnees);
	max_y = 0.;
	i = 0;
	mean = 0. ;
	while (i < nb_event )
	{
		if (taux[i]>max_y) max_y = taux[i] ;
		mean = mean + taux[i] ;
		i++;
	} /* fin du while */

	if (nb_event > 2)
		mean = mean/(float)(nb_event) ;
	else
	{
		XtPopdown (XtParent(ThePopupBox));
		return;
	} /* fin du else */

	/* Trace du fichier postscript */

	Message_plotting();
	tourne_page();
	bounding_box(1);
	sprintf(buffer,"Evolution of instantaneous rate of event # %d",ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.,9.,"Number of events: ",.3);
	ps_writeintah(15.,9.,nb_event,.3);
	ps_writeah(8.,8.5,"Maximal value: ",.3);
	sprintf(buffer,"%.3f 1/s",max_y);
	ps_writeah(15.,8.5,buffer,.3);
	ps_writeah(8.,8.,"Duration: ",.3);
	sprintf(buffer,"%.3f s",arrivee-depart);
	ps_writeah(15.,8.,buffer,.3);
	ps_writeah(8.,7.5,"Mean rate: ",.3);
	sprintf(buffer,"%.3f 1/s",mean);
	ps_writeah(15.,7.5,buffer,.3);
	ps_font("Times-Roman",0.);

	ps_movea(0.,0.);
	ps_echel((long_X_axis/(arrivee-depart)),(long_Y_axis/max_y),0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(depart,0.,depart,arrivee,depart,arrivee,
		       0.,max_y,0.,max_y,
		       0.1," Time (s)","%.3f"," Rate (1/s)","%.1f",0.3,0);
	ps_cms();

	ps_movea(0.,0.) ;
	
   /* Trace des points */
   
	kx = long_X_axis/(arrivee-depart) ;
	ky = long_Y_axis/max_y ;
	i =0 ;
	while (event_temps[i] < depart ) i++;
	while ( (i < nb_event) && (event_temps[i] < arrivee) )
	{
		x_point = (event_temps[i]-depart) * kx  ;
		y_point = taux[i] * ky ;
		ps_movea(x_point,y_point) ;
		ps_point(16,.1) ;
		i++ ;
		
	} /* fin du for */
	
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));
	
} /* fin du freqgram_dots */

   /******************
   * AUTOCORRELATION *
   ******************/

void autocorrelation(pCALCULSARG ArgsOfFunction)
{
	int	i,
		histo[MAX_DATA],
		max_y,
		nb_max,
		number,
		h_max ;
	float	inter_max,
		esph,varh,sigh,
		espv,varv,sigv,
		ac_arrivee;	
	char	SomeChar[250];

   /* entree des parametres */
	
	if ((temps_max-arrivee) < ArgsOfFunction->duration) ac_arrivee = temps_max-ArgsOfFunction->duration;
	else ac_arrivee = arrivee ;
	h_max = (int)((ArgsOfFunction->duration)/ArgsOfFunction->binwidth) ;
	nb_max = auto_cor(temps,type,depart,ac_arrivee,ArgsOfFunction->binwidth,ArgsOfFunction->duration,
			  histo,h_max,ArgsOfFunction->events[DATA1]);
	statis_histo(&esph,&varh,&sigh,&espv,&varv,&sigv,histo,h_max) ;
	i = 0 ;
	max_y = 0 ;

   /* calcul du maximum et transfert de tableau */
	i = 0 ;
	number = 0 ;
	while (i < h_max)
	{
		if (histo[i]>max_y) max_y = histo[i] ;
		number = number + histo[i] ;
		i++ ;
	} /* fin du while */
   	
   /* Trace du fichier postscript */
	Message_plotting();
	tourne_page();
	bounding_box(1);
	sprintf(buffer,"Autocorrelation histogram of event # %d",ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.,9.,"Number of classes: ",.3);
	ps_writeintah(15.,9.,nb_max,.3);
	ps_writeah(8.,8.5,"Maximal value: ",.3);
	ps_writeintah(15.,8.5,max_y,.3);
	ps_writeah(8.,8.,"Bin width: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->binwidth);
	ps_writeah(15.,8.,buffer,.3);	
	ps_writeah(8.,7.5,"Analysis Duration: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->duration);
	ps_writeah(15.,7.5,buffer,.3);	
	ps_writeah(8.,7.,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(15.,7.,buffer,.3);		
	ps_writeah(0.,9.,"Number of analysed events: ",.3);
	ps_writeintah(6.,9.,number,.3);
	ps_writeah(0.,8.5,"Mean value: ",.3);
	sprintf(buffer,"%.3f s",espv);
	ps_writeah(6.,8.5,buffer,.3);
	ps_writeah(0.,8.,"Standard Deviation: ",.3);
	sprintf(buffer,"%.3f s",sigv);
	ps_writeah(6.,8.,buffer,.3);
	ps_writeah(0.,7.5,"Coef. Variation: ",.3);
	sprintf(buffer,"%.3f s",sigv/espv);
	ps_writeah(6.,7.5,buffer,.3);	
	ps_font("Times-Roman",0.);

	sprintf (SomeChar,"I'm plotting a histogramm of %d classes with a maxi of %d...", nb_max, max_y);
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );
	inter_max = (float)(max_y) ;
	
	if (inter_max == 0)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "Max = 0, no drawing possible",
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	} /* fin du if */

	ps_movea(0.,0.);
	ps_echel((long_X_axis/ArgsOfFunction->duration),(long_Y_axis/(inter_max/((float)(number)*ArgsOfFunction->binwidth))),0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(0.,0.,
		       0.,ArgsOfFunction->duration,
		       0.,ArgsOfFunction->duration,
		       0.,inter_max/((float)(number)*ArgsOfFunction->binwidth),
		       0.,inter_max/((float)(number)*ArgsOfFunction->binwidth),
		       0.1," Time from reference event (s)","%.3f",
		       " Rate (imp/s)","%.3f",.3,0);
	ps_cms();

/*	ps_ticked_axes(long_X_axis,long_Y_axis,0.,ArgsOfFunction->duration,0.,inter_max/((float)(number)*ArgsOfFunction->binwidth)," delay"," Frequency",.05,0);*/
	ps_histo(histo,long_X_axis,long_Y_axis,ArgsOfFunction->binwidth,h_max,2);
	ps_movea(0.,0.);

	Fin_plotting(histo,h_max,".acr");
	XtPopdown (XtParent(ThePopupBox));

} /* fin du autocorrelation */

   /**********************************
   * Inter-event Histogramm *
   **********************************/
   
void inter_event_histo(pCALCULSARG ArgsOfFunction)
{
	int i,
	    histo[MAX_DATA],
	    max_y,
	    nb_max,
	    number,
	    h_max ;
	float inter_max,
	      espv,esph,
	      varv,varh,
	      sigv,sigh;

	char SomeChar[250];
	
   /* entree des parametres */

	h_max = (int)(ArgsOfFunction->duration/ArgsOfFunction->binwidth) ;
	nb_max = interval(temps,type,depart,arrivee,
			  ArgsOfFunction->binwidth,histo,h_max,nb_donnees - 1,
			  ArgsOfFunction->events[DATA1],ArgsOfFunction->order);	
	i = 0 ;
	max_y = 0 ;
	number = 0 ;
	for (i=0;i < h_max;i++) number = number+histo[i];
	statis_histo(&esph,&varh,&sigh,&espv,&varv,&sigv,histo,h_max) ;
	
   /* calcul du maximum */
	i = 0 ;
	while (i < h_max)
	{
		if (histo[i] > max_y) max_y = histo[i] ;
		i++ ;
	} /* fin du while */
	if (max_y < 1.) max_y = 1. ;
   	
   /* Trace du fichier postscript */
	Message_plotting();
	tourne_page();
	bounding_box(1);
	sprintf(buffer,"Inter_event  histogram of event # %d",ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.,9.5,"Number of classes",.3);
	ps_writeintah(15.,9.5,h_max,.3);
	ps_writeah(8.,9.,"Maximal value: ",.3);
	ps_writeintah(15.,9.,max_y,.3);
	ps_writeah(8.,8.5,"Bin width: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->binwidth);
	ps_writeah(15.,8.5,buffer,.3);	
	ps_writeah(8.,8.,"Order of histogram: ",.3);
	ps_writeintah(15.,8.,ArgsOfFunction->order,.3);
	ps_writeah(8.,7.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(15.,7.5,buffer,.3);			
	ps_writeah(8.,7.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(15.,7.,buffer,.3);
	ps_writeah(0.,9.5,"Number of intervals: ",.3);
	ps_writeintah(6.,9.5,number,.3);
	ps_writeah(0.,9.,"Expected value: ",.3);
	sprintf(buffer,"%.3f s",esph*ArgsOfFunction->binwidth);
	ps_writeah(6.,9.,buffer,.3);
	ps_writeah(0.,8.5,"Standard Deviation: ",.3);
	sprintf(buffer,"%.3f",sigh*ArgsOfFunction->binwidth);
	ps_writeah(6.,8.5,buffer,.3);
	ps_writeah(0.,8.,"Mean frequency: ",.3);
	sprintf(buffer,"%.3f s",1./(esph*ArgsOfFunction->binwidth));
	ps_writeah(6.,8.,buffer,.3);
	ps_font("Times-Roman",0.);		

	sprintf (SomeChar,"I'm plotting a histogramm of %d classes with a maxi of %d...",nb_max,max_y);
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );
	inter_max = (float)(max_y) ;
	if (inter_max == 0)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "Max = 0, no drawing possible",
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	} /* fin du if */

	ps_movea(0.,0.);
	ps_echel((long_X_axis/(float)(h_max*ArgsOfFunction->binwidth)),(long_Y_axis/(inter_max/((float)(number)))),0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(0.,0.,
		       0.,(float)(h_max*ArgsOfFunction->binwidth),
		       0.,(float)(h_max*ArgsOfFunction->binwidth),
		       0.,inter_max/((float)(number)),
		       0.,inter_max/((float)(number)),
		       0.1," Interval (s)","%.3f",
		       " Frequency","%.2f",.3,0);
	ps_cms();


/*	ps_ticked_axes(long_X_axis,long_Y_axis,0.,(float)(h_max*ArgsOfFunction->binwidth),0.,inter_max/(float)(number),
		       " Delay"," Proportion",.08,0); */
	ps_histo(histo,long_X_axis,long_Y_axis,ArgsOfFunction->binwidth,h_max,1);
	Fin_plotting(histo,h_max,".isi");
	XtPopdown (XtParent(ThePopupBox));
	
} /* fin du  */

   /**********************
   * Cartes de POINCARE  *
   **********************/

void poincare(pCALCULSARG ArgsOfFunction)
{


    /*******************
    *    declarations  *
    *******************/

	char	nom_n,
		bufferx[80];
	char	*pnom_n;
	int   i,
	      compte,
	      indice,
	      nb_max ;
	      
	float precedent,
	      x,y,
	      kx,
	      inter[MAX_DATA];
/*
**	Code
*/

    /* Initialisation */

	old_X_axis = long_X_axis;

	if (ArgsOfFunction->square)
	{
		long_X_axis = long_Y_axis;
	}

	pnom_n = (char *) XmTextGetString (axisLetter_TextField);
	nom_n = *pnom_n;

	DispPopupDialog (fctpara_TopLevelShell,
			 " I'm computing the map ...",
			 "Please wait." );
	i = 0 ;
	indice = 0 ;
	compte = 0;
	
	while (temps[i++] < depart ) ;	
	while (type[i++] != ArgsOfFunction->events[DATA1] && i < MAX_DATA) ;
	precedent = temps[i] ;
	i++;
	while (temps[i] < arrivee )
	{
		if ( type[i] == ArgsOfFunction->events[DATA1])
		{
			compte++;
			if (compte == ArgsOfFunction->order)
			{
				compte = 0;	
				inter[indice] = temps[i] - precedent ;
				indice++  ;
			} /* fin du if */
			precedent = temps[i] ;			
		} /* fin du if */
		i++ ;
	} /* fin du while */	

	nb_max = indice ;
	kx = long_X_axis/(ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) ;

    
    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"Poincare's map of intervals for event # %d",ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.3,8.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(15.,8.5,buffer,.3);			
	ps_writeah(8.3,8.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(15.,8.,buffer,.3);
	ps_writeah(8.3,7.5,"Order of the map: ",.3);
	ps_writeintah(15.,7.5,ArgsOfFunction->order,.3);	
	ps_font("Times-Roman",0.);		

   /* trace des axes verticaux et horizontaux */

	sprintf(bufferx,"Interval at %c (s)",nom_n);
	sprintf(buffer,"Interval at %c+%d (s)",nom_n,ArgsOfFunction->order);
	ps_movea(0.,0.);
	ps_echel(kx,kx,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(ArgsOfFunction->min[DATA1],ArgsOfFunction->min[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1,bufferx,"%.2f",buffer,"%.2f",0.3,1);
	ps_cms();


   /* Diagonale */
/*	ps_gray(.7); */
	ps_movea(0.,0.) ;
	ps_drawa((ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) * kx,
		 (ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) * kx);
/*	ps_gray(0.); */
   /* plotting des ps_points */
	for (i=0;i < nb_max-1;i++)
	{
		if ((inter[i] > ArgsOfFunction->min[DATA1]) &&
		    (inter[i] < ArgsOfFunction->max[DATA1]) &&
		    (inter[i+1] > ArgsOfFunction->min[DATA1]) && (inter[i+1] < ArgsOfFunction->max[DATA1]))
		{
			
		x = ( inter[i]   - ArgsOfFunction->min[DATA1] ) * kx ;
		y = ( inter[i+1] - ArgsOfFunction->min[DATA1] ) * kx ;
		ps_movea(x,y) ;
		ps_point(16,.1) ;
		
		} /* fin du if */
	} /* fin du for */
	ps_movea(0.,0.) ;
	long_X_axis = old_X_axis;
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));

} /* fin du Poincare */

void poincare_2(pCALCULSARG ArgsOfFunction)
{


    /*******************
    *    declarations  *
    *******************/
    
	int   i,
	      compte,
	      indice,
	      nb_max,
	      nb_max2;

	float precedent,
	      x,y,
	      kx,
	      kx2,
	      inter[MAX_DATA],
	      inter2[MAX_DATA];

	char	nom_n,
		buffer1[80];
	char	*pnom_n;

    /* Initialisation */

	old_X_axis = long_X_axis;
	if (ArgsOfFunction->square)
	{
		long_X_axis = long_Y_axis;
	}

	pnom_n = (char *) XmTextGetString (axisLetter_TextField);
	nom_n = *pnom_n;

	DispPopupDialog (fctpara_TopLevelShell,
			 " I'm computing the 2 maps ...",
			 "Please wait." );

	/* event 1 */
	i = 0 ;
	indice = 0 ;
	compte = 0;
	while (temps[i++] < depart ) ;

	/* cherche le 1er evenment */

	while (type[i++] != ArgsOfFunction->events[DATA1] && i < MAX_DATA) ;
	precedent = temps[i] ;
	i++;
	
	while (temps[i] < arrivee )
	{
		if ( type[i] == ArgsOfFunction->events[DATA1])
		{
			compte++;
			if (compte == ArgsOfFunction->order)
			{
				compte = 0;	
				inter[indice] = temps[i] - precedent ;
				indice++  ;
			} /* fin du if */
			precedent = temps[i] ;			
		} /* fin du if */
		i++ ;
	} /* fin du while */	

	nb_max = indice ;
	kx = long_X_axis/(ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) ;

	/* event 2 */

    	i = 0 ;
	indice = 0 ;
	compte = 0;
	while (temps[i++] < depart ) ;

	/* cherche le 1er evenement */

	while (type[i++] != ArgsOfFunction->events[DATA2] && i < MAX_DATA) ;
	precedent = temps[i] ;
	i++;
	
	while (temps[i] < arrivee )
	{
		if ( type[i] == ArgsOfFunction->events[DATA2])
		{
			compte++;
			if (compte == ArgsOfFunction->order)
			{
				compte = 0;	
				inter2[indice] = temps[i] - precedent ;
				indice++  ;
			} /* fin du if */
			precedent = temps[i] ;			
		} /* fin du if */
		i++ ;
	} /* fin du while */	

	nb_max2 = indice ;

	kx2 = long_X_axis/(ArgsOfFunction->max[DATA2] - ArgsOfFunction->min[DATA1]) ;

    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"Poincare's map of intervals for events # %d and # %d",
		ArgsOfFunction->events[DATA1],ArgsOfFunction->events[DATA2]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.3,8.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(15.,8.5,buffer,.3);			
	ps_writeah(8.3,8.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(15.,8.,buffer,.3);
	ps_writeah(8.3,7.5,"Order of the map: ",.3);
	ps_writeintah(15.,7.5,ArgsOfFunction->order,.3);	
	ps_font("Times-Roman",0.);		

   /* trace des axes verticaux et horizontaux */

	sprintf(buffer1,"Interval at %c (s)",nom_n);
	sprintf(buffer,"Interval at %c+%d (s)",nom_n,ArgsOfFunction->order);
	ps_movea(0.,0.);
	ps_echel(kx,kx,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(ArgsOfFunction->min[DATA1],ArgsOfFunction->min[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1,buffer1,"%.2f",buffer,"%.3f",0.2,1);
	ps_cms();


   /* Diagonale */
/*	ps_gray(.7); */
	ps_movea(0.,0.) ;
	ps_drawa((ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) * kx,
		 (ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) * kx);
/*	ps_gray(0.); */

   /* plotting des ps_points pour event 1*/

	for (i=0;i <= nb_max;i++)
	{
		if ((inter[i] > ArgsOfFunction->min[DATA1]) && (inter[i] < ArgsOfFunction->max[DATA1]) &&
		    (inter[i+1] > ArgsOfFunction->min[DATA1]) && (inter[i+1] < ArgsOfFunction->max[DATA1]))
		{
			x = ( inter[i]   - ArgsOfFunction->min[DATA1] ) * kx ;
			y = ( inter[i+1] - ArgsOfFunction->min[DATA1] ) * kx ;
			ps_movea(x,y) ;
			ps_point(2,.1) ;
		} /* fin du if */
	} /* fin du for */

   /* plotting des ps_points pour event 2 */

	for (i=0;i <= nb_max2;i++)
	{
		if ((inter2[i] > ArgsOfFunction->min[DATA1]) && (inter2[i] < ArgsOfFunction->max[DATA2]) &&
		    (inter2[i+1] > ArgsOfFunction->min[DATA1]) && (inter2[i+1] < ArgsOfFunction->max[DATA2]))
		{
			x = ( inter2[i]   - ArgsOfFunction->min[DATA1] )*kx2 ;
			y = ( inter2[i+1] - ArgsOfFunction->min[DATA1] )*kx2 ;
			ps_movea(x,y) ;
			ps_point(5,.07) ;
		} /* fin du if */
	} /* fin du for */
	ps_movea(0.,0.) ;
	long_X_axis = old_X_axis;
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));

} /* fin du Poincare_2 */

   /********************************
   * Carte de poincare des phases *
   ********************************/
   
void poincare_phases(pCALCULSARG ArgsOfFunction)
{


    /*******************
    *    declarations  *
    *******************/
    
	int   i,j,k,
	      indice,
	      nb_max;
	float phase[MAX_DATA],
	      temps_reference,
	      x,y, kx;

	char	nom_n,
		buffer1[80];
	char	*pnom_n;
	
    /* Initialisation */
    
	old_X_axis = long_X_axis;
	if (ArgsOfFunction->square)
	{
		long_X_axis = long_Y_axis;
	}

	pnom_n = (char *) XmTextGetString (axisLetter_TextField);
	nom_n = *pnom_n;

	DispPopupDialog (fctpara_TopLevelShell,
			 " I'm computing the map of phases...",
			 "Please wait." );
	i = 0 ;
	k = 0;
	indice = 0;
	while (temps[i++] < depart ) ;
	while (temps[i] < arrivee )
	{
		if ( type[i] == ArgsOfFunction->events[DATA1])
		{
			k = 0;
			temps_reference = temps[i];
			for (j = i+1; j < nb_donnees; j++)
			{
				if ( type[j] == ArgsOfFunction->events[DATA2])
				{
					k++;
					if (k == ArgsOfFunction->order)
					{
						phase[indice] = temps[j] - temps_reference;
						indice++;
					} /* fin du if */
				}
				if (type[j] == ArgsOfFunction->events[DATA1])
				{
					i = j - 1;	/*
							 * on saute tout ce
							 * qu'on vient de
							 * lire, mais comme i
							 * est increment on se
							 * met 1 avant
							 */
					break;
				} /* fin du if */
			} /* fin du for */
		}
		i++;
	} /* fin du while */	

	kx = long_X_axis/(ArgsOfFunction->max[DATA1]-ArgsOfFunction->min[DATA1]) ;
	nb_max = indice ;
    
    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"Poincare's map of phases between event # %d and event # %d",
		ArgsOfFunction->events[DATA1],ArgsOfFunction->events[DATA2]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.,8.,"Order of the map: ",.3);
	ps_writeintah(15.,8.,ArgsOfFunction->order,.3);
	ps_writeah(8.,7.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(15.,7.5,buffer,.3);			
	ps_writeah(8.,7.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(15.,7.,buffer,.3);
	ps_font("Times-Roman",0.);		

   /* trace des axes verticaux et horizontaux */

	sprintf(buffer1,"Phase at %c (s)",nom_n);
	sprintf(buffer,"Phase at %c+%d (s)",nom_n,ArgsOfFunction->order);
	ps_movea(0.,0.);
	ps_echel(kx,kx,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(ArgsOfFunction->min[DATA1],ArgsOfFunction->min[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1,buffer1,"%.3f",buffer,"%.3f",0.3,1);
	ps_cms();

   /* trace des axes verticaux et horizontaux */
/*	ps_ticked_axes(7.,7.,ArgsOfFunction->min[DATA1],
		       ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],
		       ArgsOfFunction->max[DATA1],
		       "phase at time n","phase at time n+1",.1,1) ; */

   /* Diagonale */

/*	ps_gray(.7); */
	ps_movea(0.,0.) ;
	ps_drawa((ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) * kx,
		 (ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) * kx);
/*	ps_gray(0.); */
   /* plotting des ps_points */
	i = 0 ;
	indice = 0 ;
	for (i=0;i < nb_max;i++)
	{
		if ((phase[i]>=ArgsOfFunction->min[DATA1]) && (phase[i] <= ArgsOfFunction->max[DATA1]) &&
		    (phase[i+1]>=ArgsOfFunction->min[DATA1]) && (phase[i+1] <= ArgsOfFunction->max[DATA1]))
		{
				
			y = phase[i+1]-ArgsOfFunction->min[DATA1] ;
			x = phase[i]-ArgsOfFunction->min[DATA1] ;
			ps_movea(x*kx,y*kx) ;
			ps_point(16,.1) ;
			
		} /* fin du if */


	} /* fin du for */
	ps_movea(0.,0.) ;
	long_X_axis = old_X_axis;
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));

} /* fin du Poincare */


void	poincare_int_cyclic(pCALCULSARG ArgsOfFunction)
{


    /*******************
    *    declarations  *
    *******************/
    
	int   i,
	      compte,
	      indice,
	      fini,
	      i_debut,
	      nb_max,
	      nb_max2,
	      nb_pts_1,
	      nb_pts_2,
	      nb_cycle;
	      
	float precedent,
	      debut_cycle,
	      x,y,
	      kx,
	      kx2,
	      offset_debut,
	      inter[MAX_DATA],
	      inter2[MAX_DATA];

	char	nom_n,
		buffer1[80];
	char	*pnom_n;

    /* Initialisation */

	old_X_axis = long_X_axis;
	if (ArgsOfFunction->square)
	{
		long_X_axis = long_Y_axis;
	}

	pnom_n = (char *) XmTextGetString (axisLetter_TextField);
	nom_n = *pnom_n;

	DispPopupDialog (fctpara_TopLevelShell,
			 " I'm computing the 2 maps ...",
			 "Please wait." );
	/* event 2 */

	if (!ArgsOfFunction->cycle)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "No cycle marker event, thus no Poincare map for cyclic events...",
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	}

	duree_cycle = ArgsOfFunction->duration;

	nb_max = nb_max2 = 0. ;

	/* event 1 */

	i = 0 ;
	indice = 0 ;
	compte = 0;
	nb_cycle = 0;
	while (temps[i++] < depart ) ;
	
	/* cherche le 1er cycle et du event1 avant */

	while (type[i++] != ArgsOfFunction->cycle && i < MAX_DATA);
	debut_cycle = temps[i] ;
	i_debut = i;
	while (--i)
	{
		if (type[i] == ArgsOfFunction->events[DATA1])
		{
			precedent = temps[i];
			break;
		} /* fin du if */
	} /* fin du while */
	i = i_debut;

	while (temps[i] < arrivee )
	{
		if ( type[i] == ArgsOfFunction->cycle)
		{
			nb_cycle++;
			inter[indice] = -1.0;
			indice++;
/*
			printf("cycle %d\n",nb_cycle);
*/
			debut_cycle = temps[i];
			fini = FALSE;
		} /* fin du if */

		if ( type[i] == ArgsOfFunction->events[DATA1])
		{
			offset_debut = temps[i] - debut_cycle;
			if (offset_debut < ArgsOfFunction->mapfrom)
			{
				precedent = temps[i] ;			
				compte = 0;
				i++;
				continue;
			} /* fin du if */
			if (offset_debut > ArgsOfFunction->mapto)
			{
				if (fini)
				{
					precedent = temps[i] ;			
					compte = 0;
					i++;
					continue;
				} /* fin du if */
				else
				{
					fini = TRUE;
				} /* fin du else */
			} /* fin du if */
			compte++;
			if (compte == ArgsOfFunction->order)
			{
				compte = 0;
				inter[indice] = temps[i] - precedent ;
				indice++  ;
				precedent = temps[i] ;			
			} /* fin du if */
		} /* fin du if */
		i++ ;
	} /* fin du while */	

	nb_max = indice ;

	kx = long_X_axis/(ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) ;

	/* event 2 */

	if (ArgsOfFunction->events[DATA2])
	{
		i = 0 ;
		indice = 0 ;
		compte = 0;
		while (temps[i++] < depart ) ;

		/* cherche le 1er cycle et du event1 avant */

		while (type[i++] != ArgsOfFunction->cycle && i < MAX_DATA);
		debut_cycle = temps[i] ;
		i_debut = i;
		while (--i)
		{
			if (type[i] == ArgsOfFunction->events[DATA2])
			{
				precedent = temps[i];
				break;
			} /* fin du if */
		} /* fin du while */
		i = i_debut;

		while (temps[i] < arrivee )
		{
			if ( type[i] == ArgsOfFunction->cycle)
			{
				nb_cycle++;
				inter[indice] = -1.0;
				indice++;
				debut_cycle = temps[i];
				fini = FALSE;
			} /* fin du if */

			if ( type[i] == ArgsOfFunction->events[DATA2])
			{
				offset_debut = temps[i] - debut_cycle;
				if (offset_debut < ArgsOfFunction->mapfrom)
				{
					precedent = temps[i] ;			
					compte = 0;
					i++;
					continue;
				} /* fin du if */
				if (offset_debut > ArgsOfFunction->mapto)
				{
					if (fini)
					{
						precedent = temps[i] ;			
						compte = 0;
						i++;
						continue;
					} /* fin du if */
					else
					{
						fini = TRUE;
					} /* fin du else */
				} /* fin du if */
				compte++;
				if (compte == ArgsOfFunction->order)
				{
					compte = 0;
					inter2[indice] = temps[i] - precedent ;
/*
					printf("%d : %f\n",indice,inter[indice]);
*/
					indice++  ;
					precedent = temps[i] ;			
				} /* fin du if */
			} /* fin du if */
			i++ ;
		} /* fin du while */	
		
		nb_max2 = indice ;

		kx2 = long_X_axis/(ArgsOfFunction->max[DATA2] - ArgsOfFunction->min[DATA2]) ;

	} /* fin du if */

    /**********************************
    *  creation du fichier postscript *
    **********************************/

	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;


   /* trace des axes verticaux et horizontaux */

	sprintf(buffer1,"Interval at %c (s)",nom_n);
	sprintf(buffer,"Interval at %c+%d (s)",nom_n,ArgsOfFunction->order);
	ps_movea(0.,0.);
	ps_echel(kx,kx,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(ArgsOfFunction->min[DATA1],ArgsOfFunction->min[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1,buffer1,"%.2f",buffer,"%.3f",0.2,1);
	ps_cms();
	ps_font("Times-Roman",0.);		


   /* Diagonale */
/*	ps_gray(.7); */
	ps_movea(0.,0.) ;
	ps_drawa((ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) * kx,
		 (ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) * kx);
/*	ps_gray(0.); */
	
   /* plotting des ps_points pour event 1*/
	nb_pts_1 = nb_pts_2 = 0;
	
	for (i=0;i <= nb_max;i++)
	{
		if (inter[i] < 0. || inter[i+1] < 0.)
			continue;
		if ((inter[i] > ArgsOfFunction->min[DATA1]) && (inter[i] < ArgsOfFunction->max[DATA1]) &&
		    (inter[i+1] > ArgsOfFunction->min[DATA1]) && (inter[i+1] < ArgsOfFunction->max[DATA1]))
		{
			x = ( inter[i]   - ArgsOfFunction->min[DATA1] )*kx ;
			y = ( inter[i+1] - ArgsOfFunction->min[DATA1] )*kx ;
			ps_movea(x,y) ;
			ps_point(2,.1) ;
			nb_pts_1++;
		} /* fin du if */
	} /* fin du for */

   /* plotting des ps_points pour event 2 */

	if (ArgsOfFunction->events[DATA2] && nb_max2)
	{
		for (i=0;i <= nb_max2;i++)
		{
			if (inter2[i] < 0. || inter2[i+1] < 0.)
				continue;
			if ((inter2[i] > ArgsOfFunction->min[DATA2]) && (inter2[i] < ArgsOfFunction->max[DATA2]) &&
			    (inter2[i+1] > ArgsOfFunction->min[DATA2]) && (inter2[i+1] < ArgsOfFunction->max[DATA2]))
			{
				x = ( inter2[i]   - ArgsOfFunction->min[DATA2] )*kx2 ;
				y = ( inter2[i+1] - ArgsOfFunction->min[DATA2] )*kx2 ;
				ps_movea(x,y) ;
				ps_point(5,.07) ;
				nb_pts_2++;
			} /* fin du if */
		} /* fin du for */
	} /* fin du if */
	ps_movea(0.,0.) ;
	long_X_axis = old_X_axis;
/*
	printf("Number of cycles: %d\n", nb_cycle);
	printf("%d event # 1\n", nb_pts_1);
	printf("%d event # 2\n", nb_pts_2);
*/
   /* LEGENDES */
	if (ArgsOfFunction->events[DATA2])
		sprintf(buffer,"Poincare's map of intervals for events # %d and # %d (post-event)",
			ArgsOfFunction->events[DATA1],ArgsOfFunction->events[DATA2]);
	else
		sprintf(buffer,"Poincare's map of intervals for events # %d (post-event)",
			ArgsOfFunction->events[DATA1]);
	
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(0.0,9.,"Number of cycles: ",.3);
	sprintf(buffer,"%d ",nb_cycle);
	ps_writeah(5.2,9.,buffer,.3);			
	ps_writeah(0.0,8.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(5.2,8.5,buffer,.3);			
	ps_writeah(0.0,8.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(5.2,8.,buffer,.3);
	ps_writeah(0.0,7.5,"Order of the map: ",.3);
	ps_writeintah(5.2,7.5,ArgsOfFunction->order,.3);	
	ps_writeah(0.0,7.,"Number of event # 1: ",.3);
	ps_writeintah(5.2,7.,nb_pts_1,.3);	
	ps_writeah(8.3,8.5,"Analysis begins: ",.3);
	sprintf(buffer,"%.3f s after cycle start",ArgsOfFunction->mapfrom);
	ps_writeah(12.5,8.5,buffer,.3);			
	ps_writeah(8.3,8.,"and ends ",.3);
	sprintf(buffer,"%.3f s after cycle start",ArgsOfFunction->mapto);
	ps_writeah(12.5,8.,buffer,.3);
	ps_writeah(8.3,7.5,"Cycle duration: ",.3);
	ps_writefloatah(12.5,7.5,duree_cycle,.3);	
	if (nb_max2)
	{
		ps_writeah(8.3,7.,"Number of event # 2: ",.3);
		ps_writeintah(15.,7.,nb_pts_2,.3);	
	} /* fin du if */
	ps_font("Times-Roman",0.);

	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));

} /* fin du poincare_int_cyclic() */


void	poincare_pha_cyclic(pCALCULSARG ArgsOfFunction)
{
#define	DEB	0


    /*******************
    *    declarations  *
    *******************/

	int	i,j,
	      compte,
	      indice,
	      i_debut,
	      fini,
	      nb_max,
	      nb_max2,
	      nb_pts_1,
	      nb_pts_2,
	      nb_cycle;
	      
	float precedent,
	      debut_cycle,
	      x,y,
	      kx,
	      offset_debut,
	      inter[MAX_DATA];

	char	nom_n,
		buffer1[80];

	char	*pnom_n;

    /* Initialisation */

	old_X_axis = long_X_axis;
	if (ArgsOfFunction->square)
	{
		long_X_axis = long_Y_axis;
	}

	pnom_n = (char *) XmTextGetString (axisLetter_TextField);
	nom_n = *pnom_n;

	DispPopupDialog (fctpara_TopLevelShell,
			 " I'm computing the 2 maps ...",
			 "Please wait." );
	/* event 2 */

	if (!ArgsOfFunction->cycle)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "No cycle marker event, thus no Poincare map for cyclic events...",
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	}

	duree_cycle = ArgsOfFunction->duration;

/*
	compute_phase(ArgsOfFunction->events[DATA1],ArgsOfFunction->events[DATA2]);

	for ( i = 0; i < nb_donnees; i++)
	{
		printf("Event %d: %f (phase: %f)\n",
			type[i], temps[i], phase_interval[i]);
	}
*/	

	nb_max = nb_max2 = 0. ;

	/* event 1 */
	i = 0 ;
	indice = 0 ;
	compte = 0;
	nb_cycle = 0;
	while (temps[i++] < depart ) ;
	
	/* cherche le 1er cycle et du event1 avant */
	while (type[i++] != ArgsOfFunction->cycle && i < MAX_DATA);
	debut_cycle = temps[i] ;
	i_debut = i;

	while (temps[i] < arrivee )
	{
		if ( type[i] == ArgsOfFunction->cycle)
		{
			nb_cycle++;
			inter[indice] = -1.0;
			indice++;
			debut_cycle = temps[i];
			fini = FALSE;
		} /* fin du if */

		if ( type[i] == ArgsOfFunction->events[DATA2])
		{
			offset_debut = temps[i] - debut_cycle;
			if (offset_debut < ArgsOfFunction->mapfrom)
			{
				compte = 0;
				i++;
				continue;
			} /* fin du if */
			if (offset_debut > ArgsOfFunction->mapto)
			{
				if (fini)
				{
					compte = 0;
					i++;
					continue;
				} /* fin du if */
				else
				{
					fini = TRUE;
				} /* fin du else */
			} /* fin du if */
			compte = 0;
			precedent = temps[i];
			for (j = i-1; j ; j--)
			{
				if ( type[j] == ArgsOfFunction->events[DATA1])
				{
					compte++;
					if (compte == ArgsOfFunction->order)
					{
						inter[indice] = precedent - temps[j];
						indice++;
						break;
					} /* fin du if */
				} /* fin du if */
			} /* fin du for */
		}
		i++;


	} /* fin du while */	

	nb_max = indice ;

	kx = long_X_axis/(ArgsOfFunction->max[DATA1]-ArgsOfFunction->min[DATA1]) ;

    /**********************************
    *  creation du fichier postscript *
    **********************************/

	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;


   /* trace des axes verticaux et horizontaux */

	sprintf(buffer1,"Phase at %c (s)",nom_n);
	sprintf(buffer,"Phase at %c+%d (s)",nom_n,ArgsOfFunction->order);
	ps_movea(0.,0.);
	ps_echel(kx,kx,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(ArgsOfFunction->min[DATA1],ArgsOfFunction->min[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1,buffer1,"%.2f",buffer,"%.3f",0.2,1);
	ps_cms();
	ps_font("Times-Roman",0.);		


   /* Diagonale */
/*	ps_gray(.7); */
	ps_movea(0.,0.) ;
	ps_drawa((ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) * kx,
		 (ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) * kx);
/*	ps_gray(0.); */
	
   /* plotting des ps_points pour event 1*/
	nb_pts_1 = nb_pts_2 = 0;
	
	for (i=0;i <= nb_max;i++)
	{
		if (inter[i] < 0. || inter[i+1] < 0.)
			continue;
		if ((inter[i] > ArgsOfFunction->min[DATA1]) && (inter[i] < ArgsOfFunction->max[DATA1]) &&
		    (inter[i+1] > ArgsOfFunction->min[DATA1]) && (inter[i+1] < ArgsOfFunction->max[DATA1]))
		{
			x = ( inter[i]   - ArgsOfFunction->min[DATA1] ) * kx ;
			y = ( inter[i+1] - ArgsOfFunction->min[DATA1] ) * kx ;
			ps_movea(x,y) ;
			ps_point(2,.1) ;
			nb_pts_1++;
		} /* fin du if */
	} /* fin du for */

	ps_movea(0.,0.) ;
	long_X_axis = old_X_axis;

/*
	printf("Number of cycles: %d\n", nb_cycle);
	printf("%d event # %d\n", nb_pts_1, ArgsOfFunction->events[DATA2]);
*/
   /* LEGENDES */

	sprintf(buffer,"Poincare's map of phase for event # %d relative to event # %d",
			ArgsOfFunction->events[DATA2], ArgsOfFunction->events[DATA1]);
	
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(0.0,9.,"Number of cycles: ",.3);
	sprintf(buffer,"%d ",nb_cycle);
	ps_writeah(5.2,9.,buffer,.3);			
	ps_writeah(0.0,8.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(5.2,8.5,buffer,.3);			
	ps_writeah(0.0,8.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(5.2,8.,buffer,.3);
	ps_writeah(0.0,7.5,"Order of the map: ",.3);
	ps_writeintah(5.2,7.5,ArgsOfFunction->order,.3);	
	ps_writeah(0.0,7.,"Number of event # 1: ",.3);
	ps_writeintah(5.2,7.,nb_pts_1,.3);	
	ps_writeah(8.3,8.5,"Analysis begins: ",.3);
	sprintf(buffer,"%.3f s after cycle start",ArgsOfFunction->mapfrom);
	ps_writeah(12.5,8.5,buffer,.3);			
	ps_writeah(8.3,8.,"and ends ",.3);
	sprintf(buffer,"%.3f s after cycle start",ArgsOfFunction->mapto);
	ps_writeah(12.5,8.,buffer,.3);
	ps_writeah(8.3,7.5,"Cycle duration: ",.3);
	ps_writefloatah(12.5,7.5,duree_cycle,.3);	
	ps_font("Times-Roman",0.);		

	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));

} /* fin du poincare_pha_cyclic() */

   /*********************************
   *  phase en fonction de l'ordre  *
   *********************************/

void phase_rank(pCALCULSARG ArgsOfFunction)
{
	
    /*******************
    *    declarations  *
    *******************/
    
	int   i,j,k,
	      indice,
	      nb_max;

	float mean,
	      phase[MAX_DATA],
	      x,y,
	      kx,ky;



    /* Initialisation */
	DispPopupDialog (fctpara_TopLevelShell,
			 " I'm computing the phases...",
			 "Please wait." );
	mean = 0.;
	i = 0 ;
	indice = 0;
	while (temps[i++] < depart ) ;
	while (temps[i] < arrivee )
	{
		if (type[i] == ArgsOfFunction->events[DATA1])
		{

			j = k = i  ;
			while ((type[k++] != ArgsOfFunction->events[DATA1]) && (k < nb_donnees)) ;
			while (j++ < k)
			{
				if (type[j] == ArgsOfFunction->events[DATA2])
				{
					phase[indice] = temps[j] - temps[i] ;
					mean = mean + phase[indice] ;
					indice++ ;
				} /* fin du if */
			} /* fin du while */
		} /* fin du if */
		i++ ;
	} /* fin du while */
	nb_max = indice ;
	ky = long_Y_axis/(ArgsOfFunction->max[DATA1]-ArgsOfFunction->min[DATA1]) ;
	kx = long_X_axis/(float)(nb_max) ;
	mean = mean/(float)(nb_max) ;
    
    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"The phase as a function of rank for event # %d relative to event # %d",
		ArgsOfFunction->events[DATA2],ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.,8.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(15.,8.5,buffer,.3);			
	ps_writeah(8.,8.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(15.,8.,buffer,.3);
	ps_writeah(8.,7.5,"Mean phase: ",.3);
	sprintf(buffer,"%.3f s",mean);
	ps_writeah(15.,7.5,buffer,.3);
	ps_font("Times-Roman",0.);		

   /* trace des axes verticaux et horizontaux */

	ps_movea(0.,0.);
	ps_echel(kx,ky,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(0.,ArgsOfFunction->min[DATA1],
		       0.,(float)(nb_max),
		       0.,(float)(nb_max),
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1," Rank","%.0f"," Phase (s)","%.3f",0.3,1);
	ps_cms();
   
/*	ps_ticked_axes(10.,6.5,0.,(float)(nb_max),ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],"   Order","  Phase",.1,1) ;*/

   /* changement d'origine */
	ps_writeah(-.5,-.5,"0",.4) ;
   /* plotting des ps_points */
	for (i=0;i < nb_max;i++)
	{
		if ((phase[i] <=ArgsOfFunction->max[DATA1])&&(phase[i]>=ArgsOfFunction->min[DATA1]))
		{
			
		y = (phase[i]-ArgsOfFunction->min[DATA1]) * ky ;
		x = (float)(i) * kx;
		ps_movea(x,y) ;
		ps_point(16,.1) ;
		} /* fin du if */
	} /* fin du for */
	ps_movea(0.,0.) ;
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));
	
} /* fin du phase */

   /**********************************
   * Interval en fonction de l'ordre *
   **********************************/
   
void interv_rank(pCALCULSARG ArgsOfFunction)
{
	
    /*******************
    *    declarations  *
    *******************/
    
	int   i,
	      indice,
	      nb_max;
	float inter[MAX_DATA],
	      mean,
	      mean2,
	      sigma,
	      precedent,
	      x,y,
	      kx,ky;



    /* Initialisation */
	DispPopupDialog (fctpara_TopLevelShell,
			 " I'm computing the intervals...",
			 "Please wait." );

	mean = 0. ;
	mean2 = 0.;
	i = 0 ;
	indice = 0;
	while (temps[i++] < depart ) ;
	while(type[i++] != ArgsOfFunction->events[DATA1] ) ;
	precedent = temps[i] ;
	i++;
	while (temps[i] < arrivee )
	{
		if (type[i] == ArgsOfFunction->events[DATA1])
		{
			inter[indice] = temps[i] - precedent ;
			precedent = temps[i] ;
			mean = mean + inter[indice] ;
			mean2 = mean2 + inter[indice] * inter[indice] ;
			indice++  ;
			
		} /* fin du if */
		i++ ;
	} /* fin du while */
	if (nb_max <= 2)
	{
		XtPopdown (XtParent(ThePopupBox));
		return;
	} /* fin du if */

	nb_max = indice ;
	ky = long_Y_axis/(ArgsOfFunction->max[DATA1]-ArgsOfFunction->min[DATA1]) ;
	kx = long_X_axis/(float)(nb_max) ;
	sigma = sqrt((mean2-((mean*mean)/nb_max))/(nb_max - 1)) ;
	mean = mean/(float)(nb_max) ;
    
    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"The interval as a function of rank for event # %d",ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);

	ps_font("Courier",0.);
	ps_writeah(8.,9.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(15.,9.5,buffer,.3);			
	ps_writeah(8.,9.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(15.,9.,buffer,.3);
	ps_writeah(8.,8.5,"Mean interval: ",.3);
	sprintf(buffer,"%.3f s",mean);
	ps_writeah(15.,7.5,buffer,.3);
	ps_writeah(0.,8.5,"Number of analyzed events: ",.3);
	ps_writeintah(6.,8.5,nb_max,.3);
	ps_writeah(0.,8.,"Standard Deviation: ",.3);
	sprintf(buffer,"%.3f",sigma);
	ps_writeah(6.,8.,buffer,.3);
	ps_writeah(0.,8.5,"Coef. Variation: ",.3);
	sprintf(buffer,"%.3f",sigma/mean);
	ps_writeah(6.,8.5,buffer,.3);	
	ps_writeah(0.,8.,"Mean frequency: ",.3);
	sprintf(buffer,"%.3f 1/s",1./mean);
	ps_writeah(6.,8.,buffer,.3);
	ps_font("Times-Roman",0.);		

   /* trace des axes verticaux et horizontaux */

	ps_movea(0.,0.);
	ps_echel(kx,ky,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(0.,ArgsOfFunction->min[DATA1],
		       0.,(float)(nb_max),
		       0.,(float)(nb_max),
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1," Rank","%.0f"," Interval (s)","%.3f",0.3,0);
	ps_cms();
   
/*	ps_ticked_axes(10.,6.5,0.,(float)(nb_max),ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],"   Order","  Interval",.1,0) ;*/

   /* changement d'origine */
	ps_writeah(-.5,-.5,"0",.4) ;

	/* plotting des ps_points */
	for (i=0;i < nb_max;i++)
	{
		if ((inter[i] <= ArgsOfFunction->max[DATA1]) && (inter[i] >= ArgsOfFunction->min[DATA1]) &&
		    (inter[i+1] >= ArgsOfFunction->min[DATA1]) && (inter[i+1] <= ArgsOfFunction->max[DATA1]))
			y = (inter[i]-ArgsOfFunction->min[DATA1]) * ky ;
		x = (float)(i+1) * kx;
		ps_movea(x,y) ;
		ps_point(16,.1) ;
	} /* fin du for */
	ps_movea(0.,0.) ;
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));

} /* fin du interval */

   /**************
   * DOT DISPLAY *
    **************/
   
void dot_display(pCALCULSARG ArgsOfFunction)
{
	int i,j,
	    nombre_ref,
	    nb_spied,
	    actuel;
	float px,
	      py;

   /* Initialisation */

	i = 0;
	nombre_ref = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee)
	{
		if (type[i] == ArgsOfFunction->events[DATA1])
			nombre_ref++;
	} /* fin du while */
	
   /* calcul des dimensions */
	py = long_Y_axis/((float)(nombre_ref)) ;
	px = long_X_axis/ArgsOfFunction->duration ;

   /* Ecriture du fichier postscript */

	Message_plotting() ;
	tourne_page();
	bounding_box(1);
   /* LEGENDES */
	sprintf(buffer,"Dot display for event # %d relative to event # %d",
		ArgsOfFunction->events[DATA2],ArgsOfFunction->events[DATA1]);
	ps_writeah(0.,10.,buffer,.4);

	ps_font("Times-Roman",0.);

	ps_movea(0.,0.) ;
	ps_echel(px,py,0.,0.,1.,0.);
	ps_user();
	for (i = 0; i < nb_de_types; i++)
	{
		if (event[i].numero == ArgsOfFunction->events[DATA1])
			sprintf(buffer,"%s",event[i].nom);
	} /* fin du for */

	ps_ticked_axes(0.,0.,
		       0.,ArgsOfFunction->duration,
		       0.,ArgsOfFunction->duration,
		       0.,(float)(nombre_ref),
		       0.,(float)(nombre_ref),
		       0.1," Delay (s)","%.3f",buffer,"%.0f",0.3,1);
	ps_cms();
   
	i = 0 ;
	actuel = 0 ;
	nb_spied = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee) 
	{
		if (type[i] == ArgsOfFunction->events[DATA1] )
		{
			actuel++;
			j = i ;
			while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <=arrivee ))
			{
			if (type[j] == ArgsOfFunction->events[DATA2])
				{
					nb_spied++;
					ps_point(16,.1) ;
/*					ps_movea((temps[j]-temps[i])*px,(float)(nombre_ref - actuel)*py) ; */
					ps_movea((temps[j]-temps[i])*px,(float)(actuel)*py) ;
				} /* fin du if */
			j++;	
			} /* fin du while */
		} /* fin du if */
	} /* fin du while */
	ps_movea(0.,0.) ;

	ps_font("Courier",0.);
	ps_writeah(8.,9.,"Number of event",.3);
	ps_writeintah(15.,9.,nombre_ref,.3);
	ps_writeah(8.,8.5,"Number of spied event: ",.3);
	ps_writeintah(15.,8.5,nb_spied,.3);
	ps_writeah(8.,8.,"Duration of analysis: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->duration);
	ps_writeah(15.,8.,buffer,.3);
	ps_writeah(8.,7.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(15.,7.5,buffer,.3);
	ps_writeah(8.,7.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(15.,7.,buffer,.3);	
	ps_font("Times-Roman",0.);	
	Fin_plotting(NULL,0,NULL) ;
	
   
} /* fin du Dot */


/**************************************************************
*
*	Collection de fonctions C pour traiter les time series.
*
*	Several arguments are common to all functions:
*
*	INPUTS
*
*		temps[]	-->	holds the time of events
*		event[]	-->	holds the event code
*		debut	-->	analysis beginning
*		fin	-->	analysis end
*		bin	-->	bin width (class duration)
*		h_max	-->	max number of classes in histo
*
*	OUTPUTS
*
*		histo[] -->	the resulting histogram
*
*	RETURN
*
*		the actual maximum indice in histo[]
*
*	Auteur: Dr J-F VIBERT
*		Laboratoire de Physiologie
*		CHU Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is in any way usable for commercial purpose.
*
*/


   /*
   *	AUTO_COR()	establishes an auto correlation histogram 
   *	returns the higest non zero class indice of histo[]
   */
int auto_cor(float *time,	/* la time series elle_meme */
	     int *evenement,	/* the evenements */
	     float debut,	/* start analysis */
	     float fin,		/* end analysis */
	     float bin,		/* bin width */
	     float duree,	/* duration of the CC analysis */
	     int *histo,	/* the resulting histogram */
	     int h_max,		/* max nb of classes in histo */
	     int evenement_A)	/* the code of the analyzed evenement A of A->A */
{
	register i, j;
	int	num_class,	/* numero de la classe */
		faux,		/* nb of not-fitting evenements */
		max_class;	/* higher number of classes */
	float	moment,		/* the current time */
		suivant;	/* the next time */
		
	
	for (i =0; i < h_max; i++) histo[i] = 0;	/* intialize histo */

	i = max_class = 0;
	faux = 0;	                  /* count of evenements extra histogram */
	while (time[i++] < debut);	  /* wait for the beginning          */
	while ((moment = time[i]) <= fin) /* till the end                    */
	{
		if (evenement[i] == evenement_A)
		{
			for (j = i+1; time[j] <= moment + duree ; j++)
			{
				if (evenement[j] == evenement_A)
				{
					suivant = time[j];
					num_class = (int)((suivant - moment)/bin);
					if (num_class > max_class ) max_class = num_class;
					if (num_class < h_max) histo[num_class]++;
					else faux++;	/* don't fit in histo */
				}
			}
		}
		i++;
	}
	if (faux) fprintf(stderr,"\007%d times too large to fit in the histogram\n",faux);
	if (max_class >= h_max) max_class = h_max - 1;
	return(max_class);
}

/*
*	INTERVAL()	establishes an inter-event histogram
*	returns the higest non zero class indice of histo[]
*/
int interval(float *temps,	/* la time series elle_meme */
	     int *event,	/* the events */
	     float debut,	/* start analysis */
	     float fin,		/* end analysis */
	     float bin,		/* bin width */
	     int *histo,	/* the resulting histogram */
	     int h_max,		/* max nb of classes in histo */
	     int i_max,		/* max indice of temps[] */
	     int ev_type,	/* the code of the analyzed event */
	     int order)		/* order of the interval histogram */
{
	register i, j;
	int	num_class,	/* numero de la classe */
		faux,		/* nb of not-fitting events */
		max_class,	/* higher number of classes */
		n_crt;		/* current order */
	float	suivant;	/* the next time */
		
	if (order == 0) order = 1;
	
	for (i =0; i < h_max; i++) histo[i] = 0;	/* intialize histo */

	i = max_class = 0;
	faux = 0;	/* count of events extra histogram */
	while (temps[i++] < debut);	/* wait for the beginning */
	while (type[i++] != ev_type) ;
	i++;
	while (temps[i] < fin)		/* till the end */
	{
		if (event[i] == ev_type)
		{
			n_crt = 0;
			for (j = i+1; j < i_max ; j++)
			{
				if (event[j] == ev_type) n_crt++;
				if (n_crt == order)
				{
					suivant = temps[j];
					break;
				}
			}
			num_class = (int)((suivant - temps[i])/bin);
			if (num_class > max_class) max_class = num_class;
			if (num_class < h_max) histo[num_class]++;
			else faux++;	/* don't fit in histo */
		}
		i++;
	}
	if (faux) fprintf(stderr,"\007%d times too large to fit in the histogram\n",faux);
	if (max_class >= h_max) max_class = h_max - 1;
	return(max_class);
}

















































































