/*
*
*	for descriptions see file tms_unix.c
*
*/


/*
**	STANDART INCLUDE FILES
*/

#include  <stdio.h>	/* standard I/O files */
#include  <stdlib.h>
#include  <signal.h>
#include  <string.h>
#include  <ctype.h>	/* macro et globales pour fonctions classification de
			   caracteres */
#include  <sys/types.h>
#include  <math.h>

/*
**	MOTIF INCLUDE FILES
*/
#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/MessageB.h>
#include <Xm/SelectioB.h>
#if (XmVersion >= 1002)
#	include <Xm/RepType.h>
#endif
#include <Xm/MwmUtil.h>

/*
**	PERSONNAL INCLUDE FILES
*/

#define _TMS_CALCULS2
#include "tms_unix.h"
#undef _TMS_CALCULS2

/*
**	GLOBAL VARIABLES
*/

extern Widget ThePopupBox;
extern Widget fctpara_TopLevelShell;

/*** prototypes ***/

/*** extern functions ***/

extern int freq (float *, float *, int, int);
extern void Message_plotting();
extern void tourne_page();
extern void bounding_box(int);
extern void Fin_plotting(int *, int, char *);
extern void Message();
extern int compute_phase(int, int);

/************************** TMS III **********************/




			/**********
			* CALCULS *
			**********/


  /************************************************
  * Frequence de deux evenements en fonction du temps *
  ************************************************/

void freqgram2(pCALCULSARG ArgsOfFunction)
{
	int i,
	    nb_event ;
	    
	float taux[MAX_DATA],
	      event_temps[MAX_DATA],
	      taux2[MAX_DATA],
	      event_temps2[MAX_DATA],
	      kx,ky,
	      x_point,y_point,
	      max_y,max_y2;

	char  SomeChar[250];
	
   /* entree des parametres */

	sprintf (SomeChar,"I'm computing frequency for serial %d ...", ArgsOfFunction->events[DATA1]);
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );
	nb_event = freq(event_temps,taux,ArgsOfFunction->events[DATA1], nb_donnees);
	max_y = 0.;
	i = 0;
	while (i <= (nb_event-1) )
	{
		if (taux[i]>max_y) max_y = taux[i] ;
		i++;
	} /* fin du while */
	if (!max_y || !(arrivee-depart)) return;
	
   /* Trace du fichier postscript */

	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_writeah(1.,10.,"Evolution of frequency:  events ",.4);
	ps_writeintah(7.8,10., ArgsOfFunction->events[DATA1],.4);
	ps_writeintah(7.8,9.5, ArgsOfFunction->events[DATA2],.4);
	ps_movea(9.5,10.) ;
	ps_point(5,.1) ;
	ps_movea(9.5,9.5) ;
	ps_point(16,.05) ;
	ps_movea(0.,0.) ;
	ps_font("Courier",0.);
	ps_writeah(8.,9.,"Number of event",.3);
	ps_writeintah(15.,9.,nb_event,.3);
	ps_writeah(8.,8.5,"*maximal value 1: ",.3);
	ps_writefloatah(15.,8.5,max_y,.3);
	ps_writeah(8.,7.5,"Length: ",.3);
	ps_writefloatah(15.,7.5,arrivee-depart,.3);
	ps_writeah(8.,7.,"*Axes ticked for first event only !",.3);	
	ps_font("Times-Roman",0.);

	ps_movea(0.,0.);
	ps_echel((long_X_axis/(arrivee-depart)),(long_Y_axis/max_y),0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(depart,0.,
		       depart,arrivee,
		       depart,arrivee,
		       0.,max_y,
		       0.,max_y,
		       0.1," Time (s)","%.2f"," Rate (1/s)","%.1f",0.3,0);
	ps_cms();

	ps_movea(0.,0.) ;
	
   /* Trace des points */
	kx = long_X_axis/(arrivee-depart) ;
	ky = long_Y_axis/max_y ;
	i =0 ;
	while (event_temps[i] < depart ) i++;
	while ( (i < nb_event) && (event_temps[i] < arrivee) )
	{
		x_point = (event_temps[i]-depart) * kx  ;
		y_point = taux[i] * ky ;
		ps_movea(x_point,y_point) ;
		ps_point(5,.1) ;
		i++ ;
		
	} /* fin du for */

   /* deuxieme evenement */
   
	XtPopdown (XtParent(ThePopupBox));
	sprintf (SomeChar,"I'm computing frequency for serial %d ...", ArgsOfFunction->events[DATA1]);
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );
	nb_event = freq(event_temps2,taux2, ArgsOfFunction->events[DATA2], nb_donnees);
	max_y2 = 0.;
	i = 0;
	while (i <= (nb_event-1) )
	{
		if (taux2[i]>max_y2) max_y2 = taux2[i] ;
		i++;
	} /* fin du while */

	if (!max_y2 || !(arrivee-depart))
	{
		XtPopdown (XtParent(ThePopupBox));
		return;
	} /* fin du if */
	ps_writeah(8.,8.," maximal value 2: ",.3);
	ps_writefloatah(15.,8.,max_y2,.3);
	
	kx = long_X_axis/(arrivee-depart) ;
	ky = long_Y_axis/max_y2 ;
	i =0 ;
	while (event_temps2[i] < depart ) i++;
	while ( (i < nb_event) && (event_temps2[i] < arrivee) )
	{
		x_point = (event_temps2[i]-depart) * kx  ;
		y_point = taux2[i] * ky ;
		ps_movea(x_point,y_point) ;
		ps_point(16,.05) ;
		i++ ;
		
	} /* fin du for */
	
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));
	
} /* fin du freqgram2 */


   /********************************************************
   * Representation des phases en fonction des intervalles *
   ********************************************************/
void phase_inter(pCALCULSARG ArgsOfFunction)
{
    /*******************
    *    declarations  *
    *******************/
    
	int   i,j,k,
	      indice,
	      nb_max,
	      nb_max_inter;
	float precedent,
	      phase[MAX_DATA],
	      inter[MAX_DATA],
	      x,y,
	      kx,ky;

    /* Initialisation */

	DispPopupDialog (fctpara_TopLevelShell,
			 " I'm computing ...\n",
			 "Please wait." );
    /* calcul des phases */
	i = 0 ;
	indice = 0;
	while (temps[i++] < depart ) ;
	while (temps[i] < arrivee )
	{
		if (type[i] == ArgsOfFunction->events[DATA1])
		{

			j = k = i  ;
			while ((type[k++] != ArgsOfFunction->events[DATA1]) && (k < nb_donnees)) ;
			while (j++ < k)
			{
				if (type[j] == ArgsOfFunction->events[DATA2])
				{
					phase[indice] = temps[j] - temps[i] ;
					indice++ ;
				} /* fin du if */
			} /* fin du while */
		} /* fin du if */
		i++ ;
	} /* fin du while */	
	ky = 7./(ArgsOfFunction->max[DATA1]-ArgsOfFunction->min[DATA1]) ;
	nb_max = indice ;
	
    /* calcul des intervalles */
	i = 0 ;
	indice = 0;
	while (temps[i++] < depart ) ;
	while (type[i++] != ArgsOfFunction->events[DATA2] ) ;
	precedent = temps[i] ;
	i++;
	while (temps[i] < arrivee )
	{
		if (type[i] == ArgsOfFunction->events[DATA2])
		{
			inter[indice] = temps[i] - precedent ;
			precedent = temps[i] ;
			indice++  ;
			
		} /* fin du if */
		i++ ;
	} /* fin du while */	

	nb_max_inter = indice ;
	kx = 7./(ArgsOfFunction->max[DATA2] - ArgsOfFunction->min[DATA2]) ;
	

    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"The phase as a function of interval for event # %d relative to event # %d",
		ArgsOfFunction->events[DATA2],ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.,7.5,"Beginning of analysis: ",.3);
	ps_writefloatah(15.,7.5,depart,.3);			
	ps_writeah(8.,7.,"End of analysis: ",.3);
	ps_writefloatah(15.,7.,arrivee,.3);
	ps_font("Times-Roman",0.);		

   /* trace des axes verticaux et horizontaux */

	ps_movea(0.,0.);
	ps_echel(kx,ky,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(ArgsOfFunction->min[DATA2],ArgsOfFunction->min[DATA1],
		       ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA2],
		       ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA2],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1," Interval (s)","%.3f"," Phase (s)","%.3f",0.3,1);
	ps_cms();
   
/*	ps_ticked_axes(7.,7.,ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA2],ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],"  Interval ","   Phase",.1,1) ;*/

   /* plotting des ps_points */
	i = 0 ;
	indice = 0 ;
	for (i=0;i < nb_max;i++)
	{
		if ((inter[i]>=ArgsOfFunction->min[DATA2])&&(inter[i] <=ArgsOfFunction->max[DATA2])&&(phase[i]>=ArgsOfFunction->min[DATA1])&&(phase[i] <=ArgsOfFunction->max[DATA1]))
		{
			
			y = phase[i]-ArgsOfFunction->min[DATA1] ;
			x = inter[i]-ArgsOfFunction->min[DATA2] ;
			ps_movea(x*kx,y*ky) ;
			ps_point(16,.1) ;
		
		} /* fin du if */
		
	} /* fin du for */
	ps_movea(0.,0.) ;
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));

} /* fin du phase_inter */

   /***************************
   * Cartes de POINCARE en 3D *
   ***************************/

void inter_3D(pCALCULSARG ArgsOfFunction)
{


    /*******************
    *    declarations  *
    *******************/
    
	int   i,
	      indice,
	      nb_max;
	float precedent,
	      x,y,z,
	      rx,ry,
	      inter[MAX_DATA];

    /* Initialisation */

	DispPopupDialog (fctpara_TopLevelShell,
			 " I'm computing the map...",
			 "Please wait." );

	i = 0 ;
	indice = 0;
	while (temps[i++] < depart ) ;
	while (type[i++]!=ArgsOfFunction->events[DATA1]) ;
	precedent = temps[i] ;
	i++;
	while (temps[i] < arrivee )
	{
		if (type[i] == ArgsOfFunction->events[DATA1])
		{
			inter[indice] = temps[i]-precedent ;
			precedent = temps[i] ;
			indice++  ;
			
		} /* fin du if */
		i++ ;
	} /* fin du while */	

	nb_max = indice ;
    
    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"3D map of intervals for event # %d",ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.3,7.5,"Beginning of analysis: ",.3);
	ps_writefloatah(15.,7.5,depart,.3);			
	ps_writeah(8.3,7.,"End of analysis: ",.3);
	ps_writefloatah(15.,7.,arrivee,.3);


   /* trace des axes */
	ps_origin(3.,3.,0.,0.);
	ps_3Dsetup(8.,8.,8.,ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],ArgsOfFunction->teta,ArgsOfFunction->phi,ArgsOfFunction->screen,ArgsOfFunction->eye) ;
	ps_3Daxes(0,0) ;
	
   /* plotting des ps_points */
	indice = 0;
	for (i=1;i < nb_max-3;i++)
	{
		if ((inter[i]>ArgsOfFunction->min[DATA1])&&(inter[i] < ArgsOfFunction->max[DATA1])&&(inter[i+1]>ArgsOfFunction->min[DATA1])&&(inter[i+1] < ArgsOfFunction->max[DATA1])&&(inter[i+2]>ArgsOfFunction->min[DATA1])&&(inter[i+2] < ArgsOfFunction->max[DATA1]))
		{
			
		x = (inter[i]-ArgsOfFunction->min[DATA1]);
		y = (inter[i+1]-ArgsOfFunction->min[DATA1]);
		z = (inter[i+2]-ArgsOfFunction->min[DATA1]);
		ps_3Dcalcul(x,y,z,&rx,&ry);
		ps_movea(rx,ry) ;
		ps_point(16,.1) ;
		indice++ ;
		} /* fin du if */
	} /* fin du for */
	ps_origin(-3.,-3.,0.,0.) ;
	ps_writeah(8.3,8.,"Number of points: ",.3);
	ps_writeintah(15.,8.,indice,.3);
	ps_font("Times-Roman",0.);		
	ps_movea(0.,0.) ;
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));

} /* fin du Poincare */

   /*************************************
   * Carte de poincare des phases en 3D *
   *************************************/
   
void phase_3D(pCALCULSARG ArgsOfFunction)
{


    /*******************
    *    declarations  *
    *******************/
    
	int   i,j,k,
	      indice,
	      nb_max;
	float phase[MAX_DATA],
	      x,y,z,
	      rx,ry;
	      
    /* Initialisation */

	i = 0 ;
	indice = 0;
	while (temps[i++] < depart ) ;
	while (temps[i] < arrivee )
	{
		if (type[i] == ArgsOfFunction->events[DATA1])
		{
			j = k = i  ;
			while ((type[k++] != ArgsOfFunction->events[DATA1]) && (k < nb_donnees)) ;
			while (j++ < k)
			{
				if (type[j] == ArgsOfFunction->events[DATA2])
				{
					phase[indice] = temps[j] - temps[i] ;
					indice++ ;
				} /* fin du if */
			} /* fin du while */
		} /* fin du if */
		i++ ;
	} /* fin du while */	
	nb_max = indice ;
    
    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"3D map of phases for event # %d relative to event # %d",ArgsOfFunction->events[DATA2],ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.,7.5,"Beginning of analysis: ",.3);
	ps_writefloatah(15.,7.5,depart,.3);			
	ps_writeah(8.,7.,"End of analysis: ",.3);
	ps_writefloatah(15.,7.,arrivee,.3);


   /* trace des axes verticaux et horizontaux */
	ps_origin(3.,3.,0.,0.) ;
	ps_3Dsetup(8.,8.,8.,ArgsOfFunction->min[DATA1],
		   ArgsOfFunction->max[DATA1],
		   ArgsOfFunction->min[DATA1],
		   ArgsOfFunction->max[DATA1],
		   ArgsOfFunction->min[DATA1],
		   ArgsOfFunction->max[DATA1],
		   ArgsOfFunction->teta,
		   ArgsOfFunction->phi,
		   ArgsOfFunction->screen,
		   ArgsOfFunction->eye) ;
	ps_3Daxes(0,0) ;

   /* plotting des ps_points */

	indice = 0 ;
	for (i=0;i < nb_max;i++)
	{
		if ((phase[i]>=ArgsOfFunction->min[DATA1]) &&
		(phase[i] <= ArgsOfFunction->max[DATA1]) &&
		(phase[i+1]>=ArgsOfFunction->min[DATA1]) &&
		(phase[i+1] <=ArgsOfFunction->max[DATA1])&&
		(phase[i+2]>=ArgsOfFunction->min[DATA1])&&
		(phase[i+2] <=ArgsOfFunction->max[DATA1]))
		{
			
		x = phase[i]-ArgsOfFunction->min[DATA1] ;
		y = phase[i+1]-ArgsOfFunction->min[DATA1] ;
		z = phase[i+2]-ArgsOfFunction->min[DATA1] ;
		ps_3Dcalcul(x,y,z,&rx,&ry) ;
		ps_movea(rx,ry) ;
		ps_point(16,.1) ;
		indice ++;
		} /* fin du if */
		
	} /* fin du for */
	
	ps_origin(-3.,-3.,0.,0.);
	ps_writeah(8.,8.,"Number of points: ",.3);
	ps_writeintah(15.,8.,indice,.3);
	ps_movea(0.,0.) ;
	ps_font("Times-Roman",0.);
	Fin_plotting(NULL,0,NULL) ;

} /* fin du Poincare */

   /*********************************
   *  phase en fonction du temps    *
   *********************************/

void phase_time(pCALCULSARG ArgsOfFunction)
{
	
    /*******************
    *    declarations  *
    *******************/
    
	int   i,j,k,
	      indice,
	      nb_max;
	float phase[MAX_DATA],
	      time[MAX_DATA],	      
	      x,y,
	      kx,ky;

    /* Initialisation */

	DispPopupDialog (fctpara_TopLevelShell,
			 " I'm computing  phases...",
			 "Please wait." );
	i = 0 ;
	indice = 0;
	while (temps[i++] < depart ) ;
	while (temps[i] < arrivee )
	{
		if (type[i] == ArgsOfFunction->events[DATA1])
		{

			j = k = i  ;
			while ((type[k++] != ArgsOfFunction->events[DATA1]) && (k < nb_donnees)) ;
			while (j++ < k)
			{
				if (type[j] == ArgsOfFunction->events[DATA2])
				{
					phase[indice] = temps[j] - temps[i] ;
					time[indice] = temps[j] ;
					indice++ ;
				} /* fin du if */
			} /* fin du while */
		} /* fin du if */
		i++ ;
	} /* fin du while */
	nb_max = indice ;
	ky = long_Y_axis/(ArgsOfFunction->max[DATA1]-ArgsOfFunction->min[DATA1]) ;
	kx = long_X_axis/(arrivee-depart) ;
    
    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"The phase as a function of time for event # %d relative to event # %d",
		ArgsOfFunction->events[DATA2],ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.,7.5,"Beginning of analysis: ",.3);
	sprintf(buffer,"%.3f s",depart);
	ps_writeah(15.,7.5,buffer,.3);			
	ps_writeah(8.,7.,"End of analysis: ",.3);
	sprintf(buffer,"%.3f s",arrivee);
	ps_writeah(15.,7.,buffer,.3);
	ps_font("Times-Roman",0.);


   /* trace des axes verticaux et horizontaux */

	ps_movea(0.,0.);
	ps_echel(kx,ky,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(depart,ArgsOfFunction->min[DATA1],
		       depart,arrivee,
		       depart,arrivee,
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1," Time (s)","%.3f"," Phase (s)","%.3f",0.3,0);
	ps_cms();
   

/*	ps_ticked_axes(10.,6.5,depart,arrivee,ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],"running time","    Phase",.1,1) ;*/

   /* plotting des ps_points */
	for (i=0;i < nb_max;i++)
	{
		if ((phase[i] <=ArgsOfFunction->max[DATA1])&&(phase[i]>=ArgsOfFunction->min[DATA1]))
		{
			
		y = (phase[i]-ArgsOfFunction->min[DATA1]) * ky ;
		x = (time[i]-depart) * kx;
		ps_movea(x,y) ;
		ps_point(16,.1) ;
		} /* fin du if */
	} /* fin du for */
	ps_movea(0.,0.) ;
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));
	
} /* fin du phase */


   /**********************************
   * Intervalle en fonction du temps *
   **********************************/
   
void interv_time(pCALCULSARG ArgsOfFunction)
{
	
    /*******************
    *    declarations  *
    *******************/
    
	int   i,
	      indice,
	      nb_max;
	float mean,
	      mean2,
	      sigma,
	      inter[MAX_DATA],
	      time[MAX_DATA],
	      x,y,
	      kx,ky;
	char  SomeChar[250];
/*
**	Code
*/

	sprintf (SomeChar,"I'm computing the intervals");
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );

    /* Initialisation */

/*
	max  = 0. ;
	min = 1000000. ;
*/
	mean = 0. ;
	mean2 = 0. ;
	sigma = 0. ;
	i = 0 ;
	indice = 0;

	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee)
	{
		if (type[i] == ArgsOfFunction->events[DATA1] )
		{
			inter[indice] = inst_interval[i];
			time[indice] = temps[i] ;
			mean = mean + inter[indice] ;
			mean2 = mean2 + (inter[indice] * inter[indice]) ;
			indice++  ;
		}/* fin du if */
	}

	nb_max = indice ;
	sigma = sqrt( (mean2-( (mean*mean)/(float)(nb_max) ) )/(nb_max - 1)) ;
	mean  = mean/(float)(nb_max) ;
	ky = long_Y_axis/(ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) ;
	kx = long_X_axis/(arrivee-depart) ;
    
    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;

   /* LEGENDES */

	sprintf(buffer,"The interval as a function of time for event # %d",ArgsOfFunction->events[DATA1]);
	ps_writeah(1.,10.,buffer,.4);

	ps_font("Courier",0.);
	ps_writeah(8.,9.,"Beginning of analysis: ",.3);
	ps_writefloatah(15.,9.,depart,.3);			
	ps_writeah(8.,8.5,"End of analysis: ",.3);
	ps_writefloatah(15.,8.5,arrivee,.3);
	ps_writeah(8.,8.,"Mean interval: ",.3);
	ps_writefloatah(15.,8.,mean,.3);
	ps_writeah(0.,9.,"Number of analysed events: ",.3);
	ps_writeintah(6.,9.,nb_max,.3);
	ps_writeah(0.,8.5,"Mean value: ",.3);
	ps_writefloatah(6.,8.5,mean,.3);
	ps_writeah(0.,8.,"Ecart-type: ",.3);
	ps_writefloatah(6.,8.,sigma,.3);
	ps_writeah(0.,7.5,"Cv: ",.3);
	ps_writefloatah(6.,7.5,sigma/mean,.3);	
	ps_writeah(0.,9.5,"mean frequency: ",.3);
	ps_writefloatah(6.,9.5,1./mean,.3);
	ps_font("Times-Roman",0.);		

   /* trace des axes verticaux et horizontaux */

	ps_movea(0.,0.);
	ps_echel(kx,ky,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(depart,ArgsOfFunction->min[DATA1],
		       depart,arrivee,
		       depart,arrivee,
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1," Time (s)","%.3f"," Interval (s)","%.3f",0.3,0);
	ps_cms();
   
/*	ps_ticked_axes(10.,6.5,depart,arrivee,ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],"running time","  Interval",.1,0) ;*/

   /* plotting des ps_points */

	for (i = 0; i < nb_max; i++)
	{
		if ((inter[i] <= ArgsOfFunction->max[DATA1]) && (inter[i] >= ArgsOfFunction->min[DATA1]))
		{
			y = (inter[i] - ArgsOfFunction->min[DATA1]) * ky ;
			x = (time[i] - depart) * kx;
			ps_movea(x,y) ;
			ps_point(16,.1) ;
		}
	} /* fin du for */
	ps_movea(0.,0.) ;
	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));

} /* fin du interval */


   /**********************************
   * Intervalle en fonction du temps (2 evenenements) 
   **********************************/
   
void interv_time2(pCALCULSARG ArgsOfFunction)
{
	
    /*******************
    *    declarations  *
    *******************/

	int   i,
	      indice,
	      nb_max;

	float mean,
	      mean2,
	      sigma,
	      inter[MAX_DATA],
	      time[MAX_DATA],
	      x,y,
	      kx,ky;

	char  SomeChar[250];

    /* Initialisation */
	
	ps_set_rgb_color(1.0,0.0,0.0); /* red   */
	sprintf (SomeChar," I'm computing the intervals for event %d...\n", ArgsOfFunction->events[DATA1]);
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );

	mean = 0. ;
	mean2 = 0. ;
	sigma = 0. ;
	i = 0 ;
	indice = 0;

	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee)
	{
		if (type[i] == ArgsOfFunction->events[DATA1] )
		{
			inter[indice] = inst_interval[i];
			time[indice] = temps[i] ;
			mean = mean + inter[indice] ;
			mean2 = mean2 + (inter[indice] * inter[indice]) ;
			indice++  ;
		}/* fin du if */
	}

	nb_max = indice ;
	sigma = sqrt( (mean2-( (mean*mean)/(float)(nb_max) ) )/(nb_max - 1)) ;
	mean  = mean/(float)(nb_max) ;
	ky = long_Y_axis/(ArgsOfFunction->max[DATA1]-ArgsOfFunction->min[DATA1]) ;
	kx = long_X_axis/(arrivee-depart) ;
    
    /**********************************
    *  creation du fichier postscript *
    **********************************/
	ps_set_rgb_color(0.0,0.0,0.0); /* black */
    
	Message_plotting();
	tourne_page();
	bounding_box(2);
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"The interval as a function of time for events # %d and # %d",
		ArgsOfFunction->events[DATA1],
		ArgsOfFunction->events[DATA2]);
	ps_writeah(1.,10.,buffer,.4);

	ps_font("Courier",0.);
	ps_writeah(8.,9.,"Beginning of analysis: ",.3);
	ps_writefloatah(15.,9.,depart,.3);			
	ps_writeah(8.,8.5,"End of analysis: ",.3);
	ps_writefloatah(15.,8.5,arrivee,.3);
	ps_writeah(8.,8.,"Mean interval: ",.3);
	ps_writefloatah(15.,8.,mean,.3);
	ps_writeah(0.,9.,"Number of analysed events: ",.3);
	ps_writeintah(6.,9.,nb_max,.3);
	ps_writeah(0.,8.5,"Mean value: ",.3);
	ps_writefloatah(6.,8.5,mean,.3);
	ps_writeah(0.,8.,"Ecart-type: ",.3);
	ps_writefloatah(6.,8.,sigma,.3);
	ps_writeah(0.,7.5,"Cv: ",.3);
	ps_writefloatah(6.,7.5,sigma/mean,.3);	
	ps_writeah(0.,9.5,"mean frequency: ",.3);
	ps_writefloatah(6.,9.5,1./mean,.3);
	ps_font("Times-Roman",0.);		

   /* trace des axes verticaux et horizontaux */

	ps_movea(0.,0.);
	ps_echel(kx,ky,0.,0.,1.,0.);
	ps_user();
	for (i = 0; i < nb_de_types; i++)
	{
		if (event[i].numero == ArgsOfFunction->events[DATA1])
			sprintf(buffer,"Interval of %s (s)",
				event[i].nom);
	} /* fin du for */

	ps_ticked_axes(depart,ArgsOfFunction->min[DATA1],
		       depart,arrivee,
		       depart,arrivee,
		       ArgsOfFunction->min[DATA1], ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1], ArgsOfFunction->max[DATA1],
		       0.1," Time (s)","%.3f",buffer,"%.3f",0.3,0);
	ps_cms();
	ps_movea(-1.,0.);
	ps_mover(0.,((ArgsOfFunction->max[DATA1] - ArgsOfFunction->min[DATA1]) * ky));
	ps_point(1,.1);
/*	ps_ticked_axes(10.,6.5,depart,
		       arrivee,ArgsOfFunction->min[DATA1],
		       ArgsOfFunction->max[DATA1],"running time","  Interval",.1,0) ;*/

   /* plotting des ps_points */
	for (i = 0; i < nb_max; i++)
	{
		if ((inter[i] <= ArgsOfFunction->max[DATA1]) && (inter[i] >= ArgsOfFunction->min[DATA1]))
		{
			y = (inter[i] - ArgsOfFunction->min[DATA1]) * ky ;
			x = (time[i] - depart) * kx;
			ps_movea(x,y) ;
			ps_point(1,.1) ;
		}
	} /* fin du for */
	ps_movea(0.,0.) ;

	ps_set_rgb_color(0.0,0.0,1.0); /* blue  */
	XtPopdown (XtParent(ThePopupBox));
	sprintf (SomeChar," I'm computing the intervals for event %d...\n", ArgsOfFunction->events[DATA2]);
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );
	mean = 0. ;
	mean2 = 0. ;
	sigma = 0. ;
	i = 0 ;
	indice = 0;

	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee)
	{
		if (type[i] == ArgsOfFunction->events[DATA2] )
		{
			inter[indice] = inst_interval[i];
			time[indice] = temps[i] ;
			mean = mean + inter[indice] ;
			mean2 = mean2 + (inter[indice] * inter[indice]) ;
			indice++  ;
		}/* fin du if */
	}

	nb_max = indice ;
	sigma = sqrt( (mean2-( (mean*mean)/(float)(nb_max) ) )/(nb_max - 1)) ;
	mean  = mean/(float)(nb_max) ;

/*
	if (!strchr("oOyY",rep)) ky = long_Y_axis/(ArgsOfFunction->max[DATA2]-ArgsOfFunction->min[DATA2]) ;
*/
	if (!ArgsOfFunction->sameyscale)
	{
		ky = long_Y_axis/(ArgsOfFunction->max[DATA2]-ArgsOfFunction->min[DATA2]) ;
	}
	ps_movea((long_X_axis+1.),0.);
	ps_user();
	ps_echel(kx,ky,0.,0.,1.,0.);
	for (i = 0; i < nb_de_types; i++)
	{
		if (event[i].numero == ArgsOfFunction->events[DATA2])
			sprintf(buffer,"Interval of %s (s)",
				event[i].nom);
	} /* fin du for */


	ps_Y_axis(ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA2],0.1,
		  ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA2],
		  buffer,"%.2f",0.3);

	ps_cms();
	ps_movea((long_X_axis+2.),0.);
	ps_mover(0.,((ArgsOfFunction->max[DATA2]-ArgsOfFunction->min[DATA2]) * ky));
	ps_point(6,.1);
	ps_movea(0.,0.);

   /* plotting des ps_points */
	for (i = 0; i < nb_max; i++)
	{
		if ((inter[i] <= ArgsOfFunction->max[DATA2]) && (inter[i] >= ArgsOfFunction->min[DATA2]))
		{
			y = (inter[i] - ArgsOfFunction->min[DATA2]) * ky ;
			x = (time[i] - depart) * kx;
			ps_movea(x,y) ;
			ps_point(6,.1) ;
		}
	} /* fin du for */
	ps_movea(0.,0.) ;
	ps_set_rgb_color(0.0,0.0,0.0); /* black */

	Fin_plotting(NULL,0,NULL);
	XtPopdown (XtParent(ThePopupBox));

} /* fin du interval 2 */

   /*****************************************
   * Espace des phases pour les intervalles *
   *****************************************/
   
void derive_inter(pCALCULSARG ArgsOfFunction)
{

    /*******************
    *    declarations  *
    *******************/
    
	int   i,
	      ref_event,
	      indice,
	      nb_max;
	      
	float max,
	      min,
	      maxy,
	      miny,
	      precedent,
	      x,y,
	      kx,ky,
	      derivee[MAX_DATA],
	      inter[MAX_DATA];

	DispMessageDialog (fctpara_TopLevelShell,
			   "Not yet ported, use TMS, sorry...",
			   "Warning",
			   XmDIALOG_WARNING);
	return;


    /* Initialisation */
	Message("d(interval)/dt = f(interval)\n");
	old_X_axis = long_X_axis;
	if (long_X_axis != long_Y_axis)
	{
		printf("\007WARNING: Axes are of different sizes (X=%.1f cm, Y=%.1f cm\n",
		       long_X_axis, long_Y_axis);
/*
		rep = askcval("Do you prefer a square ([y] or n): ",'y');
*/
		if (strchr("YyOo",rep))
		{
			long_X_axis = long_Y_axis;
			printf("\007OK: I draw a square (%.1f X %.1f cm)\n",
			       long_X_axis, long_X_axis);
		} /* fin du if */
	} /* fin du if */
/*
	ref_event = askival(" Event: ",post_synaptic) ;
*/
	printf(" I'm computing the map ...\n");
	max  = 0. ;
	min = 0. ;
	maxy = 0. ;
	miny = 0. ;
	i = 0 ;
	indice = 0;
	while (temps[i++] < depart ) ;
	while (type[i++] != ref_event) ;
	precedent = temps[i] ;
	i++;
	while (temps[i] < arrivee )
	{
		if (type[i] == ref_event)
		{
			inter[indice] = temps[i]-precedent;
			if (inter[indice]>max) max = inter[indice];
			precedent = temps[i] ;
			indice++  ;
			
		} /* fin du if */
		i++ ;
	} /* fin du while */	

	nb_max = indice ;
	for (i=1;i < nb_max;i++)
	{
		derivee[i] = (inter[i]-inter[i-1]) / inter[i] ;
		if (derivee[i]>maxy) maxy = derivee[i] ; 
		if (derivee[i] < miny) miny = derivee[i] ;
	} /* fin du for */
/*
	max = askfval(" Maximal value: ",max);
	min = askfval(" Minimal value: ",min);
*/
	if (min == max)
	{
		Message("Max = min, no drawing possible\n");
		return;
	}
	kx = long_X_axis/(max-min) ;
/*
	maxy = askfval(" Maximal value for d(interval)/dt: ",maxy);
	miny = askfval(" Minimal value for d(interval)/dt: ",miny);
*/
	if (miny == maxy)
	{
		Message("Max = min, no drawing possible\n");
		return;
	}
	ky = long_Y_axis/(maxy-miny) ;
    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"Phase map of intervals for event # %d",ref_event);
	ps_writeah(1.,10.,buffer,.4);
	ps_font("Courier",0.);
	ps_writeah(8.3,7.5,"Beginning of analysis: ",.3);
	ps_writefloatah(15.,7.5,depart,.3);			
	ps_writeah(8.3,7.,"End of analysis: ",.3);
	ps_writefloatah(15.,7.,arrivee,.3);
	ps_font("Times-Roman",0.);


   /* trace des axes verticaux et horizontaux */

	ps_movea(0.,0.);
	ps_echel(kx,ky,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(min,miny,
		       min,max,
		       min,max,
		       miny,maxy,
		       miny,maxy,
		       0.1," Interval (s)","%.3f"," d(Interval)/dt","%.3f",0.3,0);
	ps_cms();
   

/*	ps_ticked_axes(7.,7.,min,max,miny,maxy," Interval","  d(Interval)",.1,1) ; */

   /* plotting des ps_points */
	indice = 0;
	for (i=1;i < nb_max;i++)
	{
		if ((inter[i]>min)&&(inter[i] < max)&&(derivee[i]>miny)&&(derivee[i] < maxy))
		{
		x = (inter[i]-min)*kx ;
		y = (derivee[i]-miny)*ky ;
		ps_movea(x,y) ;
		ps_point(16,.1) ;
		indice++ ;
		} /* fin du if */
	} /* fin du for */
	ps_writeah(8.3,8.,"Number of points: ",.3);
	ps_writeintah(15.,8.,indice,.3);			
	ps_font("Times-Roman",0.);		   
	ps_movea(0.,0.) ;
	long_X_axis = old_X_axis;
	Fin_plotting(NULL,0,NULL);

} /* fin du Derive_inter */


   /*******************************
   * Espace des phases des phases *
   *******************************/
void derive_phase(pCALCULSARG ArgsOfFunction)
{


    /*******************
    *    declarations  *
    *******************/
    
	int   i,j,k,
	      indice,
	      event,
	      nb_max,
	      ref_event;
	float max,
	      min,
	      maxy,
	      miny,
	      phase[MAX_DATA],
	      derivee[MAX_DATA],
	      time[MAX_DATA],
	      x,y,
	      kx,ky;

	DispMessageDialog (fctpara_TopLevelShell,
			   "Not yet ported, use TMS, sorry...",
			   "Warning",
			   XmDIALOG_WARNING);
	return;



    /* Initialisation */
	Message("d(phase)/dt = f(phase)\n");
	old_X_axis = long_X_axis;
	if (long_X_axis != long_Y_axis)
	{
		printf("\007WARNING: Axes are of different sizes (X=%.1f cm, Y=%.1f cm\n",
		       long_X_axis, long_Y_axis);
/*
		rep = askcval("Do you prefer a square ([y] or n): ",'y');
*/
		if (strchr("YyOo",rep))
		{
			long_X_axis = long_Y_axis;
			printf("\007OK: I draw a square (%.1f X %.1f cm)\n",
			       long_X_axis, long_X_axis);
		} /* fin du if */
	} /* fin du if */
/*
	ref_event = askival(" Reference event: ",pre_synaptic) ;
	event = askival(" Spied event: ",post_synaptic) ;
*/
	printf(" I'm computing the map of phases...\n");
	max  = 0. ;
	min = 0. ;
	maxy = 0.;
	miny = 0. ;
	i = 0 ;
	indice = 0;
	while (temps[i++] < depart ) ;
	while (temps[i] < arrivee )
	{
		if (type[i] == ref_event)
		{

			j = k = i  ;
			while ((type[k++] != ref_event) && (k < nb_donnees)) ;
			while (j++ < k)
			{
				if (type[j] == event)
				{
					phase[indice] = temps[j] - temps[i] ;
					time[indice] = temps[j] ;
					if (phase[indice]>max) max = phase[indice] ;
					indice++ ;
				} /* fin du if */
			} /* fin du while */
		} /* fin du if */
		i++ ;
	} /* fin du while */
/*
	max = askfval(" Maximal value for the phase: ",max) ;
	min = askfval(" Minimal value for the phase: ",min) ;
*/
	if (min == max)
	{
		Message("Max = min, no drawing possible\n");
		return;
	}
	kx = 7./(max-min) ;
	nb_max = indice ;
	for (i=0;i+1 < nb_max;i++)
	{
		derivee[i] = (phase[i+1]-phase[i])/(time[i+1]-time[i]) ;
		if (derivee[i]>maxy) maxy = derivee[i] ;
		if (derivee[i] < miny) miny = derivee[i] ;
	} /* fin du for */
/*
	maxy = askfval(" Maximal value for d(phase)/dt: ",maxy) ;
	miny = askfval(" Minimal value for d(phase)/dt: ",miny) ;
*/
	ky = 7./(maxy-miny) ;
    /**********************************
    *  creation du fichier postscript *
    **********************************/
    
	Message_plotting();
	tourne_page();
	bounding_box(1);
	ps_cms() ;

   /* LEGENDES */
	sprintf(buffer,"Phase map of phases for event # %d relative to event # %d",
		event, ref_event);
	ps_font("Courier",0.);
	ps_writeah(8.,7.5,"Beginning of analysis: ",.3);
	ps_writefloatah(15.,7.5,depart,.3);			
	ps_writeah(8.,7.,"End of analysis: ",.3);
	ps_writefloatah(15.,7.,arrivee,.3);
	ps_font("Times-Roman",0.) ;

   /* trace des axes verticaux et horizontaux */

	ps_movea(0.,0.);
	ps_echel(kx,ky,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(min,miny,
		       min,max,
		       min,max,
		       miny,maxy,
		       miny,maxy,
		       0.1," Phase (s)","%.3f"," d(Phase)/dt","%.3f",0.3,0);
	ps_cms();
   
/*	ps_ticked_axes(7.,7.,min,max,miny,maxy," phase","d( phase )/dt",.1,1) ;*/


   /* plotting des ps_points */
	i = 0 ;
	indice = 0 ;
	for (i=0;i+1 < nb_max;i++)
	{
		if ((phase[i]>=min)&&(phase[i] <=max)&&(derivee[i]>=miny)&&(derivee[i] <=maxy))
		{
			
		y = derivee[i]-miny ;
		x = phase[i]-min ;
		ps_movea(x*kx,y*ky) ;
		ps_point(16,.1) ;
		indice++ ;
		} /* fin du if */
		
	} /* fin du for */
	ps_writeah(8.,8.,"Number of points: ",.3);
	ps_writeintah(15.,8.,indice,.3) ;
	ps_font("Times-Roman",0.);		
	ps_movea(0.,0.) ;
	long_X_axis = old_X_axis;	
	Fin_plotting(NULL,0,NULL);
} /* fin du derive */

   /*************************
   * Transformee de fourier *
   *************************/

void fourier_order(pCALCULSARG ArgsOfFunction)
{
	DispMessageDialog (fctpara_TopLevelShell,
			   "Not yet implemented, sorry...",
			   "Warning",
			   XmDIALOG_WARNING);
#if 0

    /*******************
    *    declarations  *
    *******************/
    
	int   interint,nb_pic,i,j,k;
	float inter,
	      max,
	      min,
	      amp[1000],
	      borne,
	      x1,y1,x,y,kx,ky;
	double sample[1000],
	       fourier[1000];
	       
	int	i,
		nb_event ;
	    
	float	taux[MAX_DATA],
		event_temps[MAX_DATA],
		max_y;           /* duration of a class */
	char	SomeChar[250];
	
   /* entree des parametres */
	sprintf (SomeChar," I'm computing fft for serial %d ...\n", ArgsOfFunction->events[DATA1]);
	DispPopupDialog (fctpara_TopLevelShell,
			 SomeChar,
			 "Please wait." );
	nb_event = freq(event_temps,taux,ArgsOfFunction->events[DATA1],nb_donnees);
	max_y = 0.;
	i = 0;
	while (i <= (nb_event-1) )
	{
		if (taux[i]>max_y) max_y = taux[i] ;
		i++;
	} /* fin du while */

    /* debut de la lecture */

	for (i=0;i <=nb_event;i++) sample[i] = taux[i] ;
	realfft(sample,nb_event+1,fourier) ;


    /*  INITIALISATIONS  */

	if ((nb_donnees % 2) != 0.) nb_donnees=nb_donnees-1 ;
	borne=nb_donnees/2. ;
	for (i=1;i <=borne;i++)
	{
		amp[i]= sqrt((fourier[2*i]*fourier[2*i])+(fourier[2*i-1]*fourier[2*i-1]))/2.;
	} /* fin du for */
	if (fourier[0] < 0.) fourier[0] = -fourier[0];
	amp[0] = fourier[0]/2.;
	amp[0] = 1.;
	for (i=1;i <=borne;i++) amp[i] = amp[i]/amp[0] ;
	j = cluster ;
	min = 0. ;
	max = 0. ;
		for(i=0;i < (borne+1);i++)
		{
			if (amp[i] > max) max=amp[i] ;
			if (amp[i] < min) min=amp[i] ;
		} /* fin du for */
	kx=10./(nb_donnees/2.);
	ky=7./(max-min);

   /* reperage des pics frequentiels */
	interint = borne ;
	nb_pic = 10 ;
	get_pic(amp,interint,pic,nb_pic);
	
    /* Trace de la transformee */

	tourne_page();
	bounding_box(1);
	Message_plotting();
	ps_writeah(0.,9.,"Transformee de Fourier: Spectre d'amplitude",.4);
	ps_ticked_axes(10.,7.,0.,nb_donnees/(2.*temps_max[cluster]),min,max,"Frequency","Amplitude",.1,0) ;
	ps_origin(0.,float_abs(min)*ky,0.,0.) ;
	ps_writeah(-.5,-.5,"0",.4) ;
	for (i=0;(i < (borne) );i++)
	{
		x = i * kx ;
		y = amp[i]*ky;
		x1 =(i+1) * kx ;
		y1 =amp[i+1]*ky ;
		ps_movea(x,y);
                ps_drawa(x1,y1);
		for (k=0;k < nb_pic;k++) if (i == pic[k])
			ps_writeintah(-.1+x,y+.2,k+1,.3);
	} /* fin du for */
	ps_origin(0.,-float_abs(min)*ky,0.,0.) ;
	ps_writeah(11.5,8.,"Pic              period        frequency",.3);
	ps_font("Courier",.3,0.);
	for (i=0;i < nb_pic;i++)
	{
		ps_writeintah(11.8,7.5-(i+1)*.4,i+1,.3) ;
		ps_writefloatah(12.5,7.5-(i+1)*.4,temps_max[cluster]/pic[i],.3) ;
		ps_writefloatah(15.,7.5-(i+1)*.4,pic[i]*(1./temps_max[cluster]),.3) ;
		
	} /* fin du for */
	ps_home();
	ps_font("NewCenturySchlbk-Roman",.3,0.);
	Fin_plotting(NULL,0,NULL);
#endif
} /* fin du fourier */


void print_data()
{
	DispMessageDialog (fctpara_TopLevelShell,
			   "Not yet implemented, sorry...",
			   "Warning",
			   XmDIALOG_WARNING);
} /* fin du option */

/*
 * ****************** Post Event rate histograms ******************
 */

void post_event_rate_hist(pCALCULSARG ArgsOfFunction)
{
	int	i,j,
		num_class,
		max_class,
		h_max,
		nombre_ref,
		histo[MAX_DATA],
		faux,
		nb_spied1,
		nb_spied2;

	char	name_spied1[30],
		name_spied2[30],
		name_ref_event[30];
	
	float	max,
		max_1,
		max_2,
		min,
		min_1,
		min_2,
		px,
		py;

	char	SomeChar[250];

   /* Initialisation */

	cycle_marker = ArgsOfFunction->cycle;
	if (!ArgsOfFunction->cycle)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "No reference event, thus no post-event histogram...",
				   "Warning",
				   XmDIALOG_WARNING);
		return;
	} /* fin du if */

	if (ArgsOfFunction->binwidth)
	{
		h_max = (int) (ArgsOfFunction->duration / ArgsOfFunction->binwidth) + 1;
	}

	for (i = 0; i < nb_de_types; i++)
	{
		if (event[i].numero == ArgsOfFunction->events[DATA1])
			strcpy(name_spied1,event[i].nom);
		if (event[i].numero == ArgsOfFunction->cycle)
			strcpy(name_ref_event,event[i].nom);
		if (ArgsOfFunction->events[DATA2] && event[i].numero == ArgsOfFunction->events[DATA2])
			strcpy(name_spied2,event[i].nom);
	} /* fin du for */

	for (i = 0; i < MAX_DATA; i++)
		histo[i] = 0;

	i = max_class = faux = num_class = 0;
	nb_spied1 = 0 ;
	nombre_ref = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i] < arrivee) 
	{
		if (type[i] == ArgsOfFunction->cycle )
		{
			nombre_ref++;
			j = i ;
			while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <= arrivee ))
			{
				if (type[j] == ArgsOfFunction->events[DATA1])
				{
					nb_spied1++;
					num_class = (int)((temps[j]-temps[i])/ArgsOfFunction->binwidth);
					if (num_class > max_class) max_class = num_class;
					if (num_class < h_max) histo[num_class]++;
					else faux++;	/* don't fit in histo */
				} /* fin du if */
				j++;	
			} /* fin du while */
		} /* fin du if */
		i++;
	} /* fin du while */

	if (max_class < h_max)
	{
		sprintf (SomeChar, "%d null classes at the end of the histogram of event %d",
			 (h_max - max_class), ArgsOfFunction->events[DATA1]);
		DispPopupDialog (fctpara_TopLevelShell,
				 SomeChar,
				 "Warning." );
	}
	max_class = h_max;

	max_1 = min_1 = 0.;
	for (i = 0; i < max_class; i++)
	{
/*		printf("Histo[%d] = %f\n",i,histo[i]);	*/
		if ((float)histo[i] > max_1) max_1 = (float)histo[i];
		if ((float)histo[i] < min_1) min_1 = (float)histo[i];
	}
	if (faux)
	{
		sprintf (SomeChar, "Event %d: %d data did not fit in the histogram\n",
			 ArgsOfFunction->events[DATA1],faux);
		XtPopdown (XtParent(ThePopupBox));
		DispPopupDialog (fctpara_TopLevelShell,
				 SomeChar,
				 "Warning." );
	}
		
	max = max_1;
	min = min_1;
	if (min == max)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "Max = min, no drawing possible",
				   "Warning",
				   XmDIALOG_ERROR);
		return;
	}

   /* calcul des echelles */
	px = long_X_axis/ArgsOfFunction->duration ;
	py = long_Y_axis/max ;

   /* Ecriture du fichier postscript */

	Message_plotting() ;
	tourne_page();
	bounding_box(2);
	ps_movea(0.,0.) ;
	ps_font("Times-Roman",0.);
	if (ArgsOfFunction->sameyscale)
		sprintf(buffer,"Rate/s");
	else
		sprintf(buffer,"%s rate/s",name_spied1);
	ps_movea(0.,0.);
	ps_echel(px,(long_Y_axis/((max / nombre_ref) / ArgsOfFunction->binwidth )),0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(0.,0.,
		       0.,ArgsOfFunction->duration,
		       0.,ArgsOfFunction->duration,
		       0.,((max / nombre_ref) / ArgsOfFunction->binwidth ),
		       0.,((max / nombre_ref) / ArgsOfFunction->binwidth ),
		       0.1," Time from reference event (s)","%.2f",
		       buffer,"%.0f",0.3,0);

	ps_echel(px,py,0.,0.,1.,0.);
	ps_movea(0.,0.);
	ps_code("2 setlinecap\n0 setlinejoin\n");
	ps_line_width((float)ArgsOfFunction->line1);
	ps_set_rgb_color(1.0,0.0,0.0); /* red   */

	ps_histo(histo,ArgsOfFunction->duration,max,ArgsOfFunction->binwidth,max_class,0);

	ps_set_rgb_color(0.0,0.0,0.0); /* black */
	ps_movea(0.,0.);
	ps_cms();
	ps_line_width(1.);
	Fin_plotting(NULL,0,NULL) ;

	/* second event s'il y a lieu */
	
	if (ArgsOfFunction->events[DATA2])
	{

		for (i = 0; i < MAX_DATA; i++)
			histo[i] = 0;
		i = max_class = faux = num_class = 0;
		nb_spied2 = 0 ;
		nombre_ref = 0 ;
		while (temps[i++] < depart) ;
		while (temps[i] < arrivee) 
		{
			if (type[i] == ArgsOfFunction->cycle )
			{
				nombre_ref++;
				j = i ;
				while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <=arrivee ))
				{
					if (type[j] == ArgsOfFunction->events[DATA2])
					{
						nb_spied2++;
						num_class = (int)((temps[j]-temps[i])/ArgsOfFunction->binwidth);
						if (num_class > max_class) max_class = num_class;
						if (num_class < h_max) histo[num_class]++;
						else faux++;	/* don't fit in histo */
					} /* fin du if */
					j++;	
				} /* fin du while */
			} /* fin du if */
			i++;
		} /* fin du while */

		if (max_class < h_max)
		{
			sprintf (SomeChar, "%d null classes at the end of the histogram of event %d",
			       (h_max - max_class), ArgsOfFunction->events[DATA2]);
			XtPopdown (XtParent(ThePopupBox));
			DispPopupDialog (fctpara_TopLevelShell,
					 SomeChar,
					 "Warning." );
		}
		max_class = h_max;
		max_2 = min_2 = 0.;
		for (i = 0; i < max_class; i++)
		{
/*			printf("Histo[%d] = %f\n",i,histo[i]); */
			if ((float)histo[i] > max_2) max_2 = (float)histo[i];
			if ((float)histo[i] < min_2) min_2 = (float)histo[i];
		}
		if (faux)
		{
			sprintf(SomeChar, "Event %d: %d data did not fit in the histogram", ArgsOfFunction->events[DATA2], faux);
			XtPopdown (XtParent(ThePopupBox));
			DispPopupDialog (fctpara_TopLevelShell,
					 SomeChar,
					 "Warning." );
		}
				
		/* calcul des echelles */

		if (ArgsOfFunction->sameyscale)
		{
			max = max_2;
			min = min_2;
		} /* fin du if */
		else
		{
			max = max_2;
			min = min_2;
			py = long_Y_axis/max ;
		} /* fin du if */

		if (min == max)
		{
			DispMessageDialog (fctpara_TopLevelShell,
					   "Max = min, no drawing possible",
					   "Warning",
					   XmDIALOG_ERROR);
			return;
		}
		/* Ecriture du fichier postscript */
		
		Message_plotting() ;
		sprintf(buffer,"%s rate/s",name_spied2);
		ps_movea((long_X_axis+1),0.);
		ps_echel(px,(long_Y_axis/((max / nombre_ref) / ArgsOfFunction->binwidth )),0.,0.,1.,0.);
		ps_user();

		if (!ArgsOfFunction->sameyscale)
			ps_Y_axis(0.,((max / nombre_ref) / ArgsOfFunction->binwidth),0.1,
				  0.,((max / nombre_ref) / ArgsOfFunction->binwidth),
				  buffer,"%.0f",0.3);
		ps_echel(px,py,0.,0.,1.,0.);
		ps_movea(0.,0.);
		ps_line_width((float)ArgsOfFunction->line2);
		ps_set_rgb_color(0.0,0.0,1.0); /* blue  */
		ps_histo(histo,ArgsOfFunction->duration,max,ArgsOfFunction->binwidth,max_class,0);
		ps_set_rgb_color(0.0,0.0,0.0); /* black */
		ps_line_width(1.);
		ps_movea(0.,0.);
		ps_cms();
	} /* fin du if */


   /* LEGENDES */

	if (ArgsOfFunction->events[DATA2])
		sprintf(buffer,"Post event histogram for %s and %s relative to %s",
			name_spied1, name_spied2, name_ref_event);
	else
		sprintf(buffer,"Post event histogram for %s relative to %s",
			name_spied1, name_ref_event);
	ps_writeah(0.,10.,buffer,.4);
	ps_font("Courier",0.);
	sprintf(buffer,"Start analysis at %.3f s  End analysis at %.3f s",
		depart,arrivee);
	ps_writeah(3.,9.5,buffer,.3);
	ps_writeah(3.,9.,event[ArgsOfFunction->cycle].nom,.3);
	ps_writeintah(7.3,9.,ArgsOfFunction->cycle,.3);
	ps_writeah(8.,9.,"Number of reference events: ",.3);
	ps_writeintah(15.,9.,nombre_ref,.3);
	ps_writeah(3.,8.5,name_spied1,.3);
	ps_line_width(4.);
	ps_movea(2.,8.5);
	ps_drawr(.5,0.);
	ps_line_width(1.);
	ps_writeintah(7.3,8.5,ArgsOfFunction->events[DATA1],.3);
	ps_writeah(8.,8.5,"Number of spied events: ",.3);
	ps_writeintah(15.,8.5,nb_spied1,.3);
	if (ArgsOfFunction->events[DATA2])
	{
		ps_writeah(3.,8.,name_spied2,.3);
		ps_line_width(1.);
		ps_movea(2.,8.);
		ps_drawr(.5,0.);
		ps_writeintah(7.3,8.,ArgsOfFunction->events[DATA2],.3);		
		ps_writeah(8.,8.,"Number of scnd spied event: ",.3);
		ps_writeintah(15.,8.,nb_spied2,.3);
	} /* fin du if */
	ps_writeah(8.,7.5,"Analysis duration: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->duration);
	ps_writeah(15.,7.5,buffer,.3);
	ps_writeah(3.,7.5,"Bin width: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->binwidth);
	ps_writeah(6.2,7.5,buffer,.3);
	ps_font("Times-Roman",0.);	
	Fin_plotting(NULL,0,NULL) ;
	XtPopdown (XtParent(ThePopupBox));

} /* fin du void */


/*
 * ****************** Post Event interval histograms ******************
 *	NON UTILISE
 */

void post_event_int_hist(pCALCULSARG ArgsOfFunction)
{
	int	i,j,
		histo[MAX_DATA],
		num_class,
		max_class,
		h_max,
/*
		spied1,
		spied2,
		ref_event,
*/
		nombre_ref,
		faux,
		nb_spied1,
		nb_spied2;

	char	rep;
	
	float	max,
		max_1,
		max_2,
		min = 0.,
/*
		bin,
*/
		px,
		py;
/*
	float	duree;
*/

   /* Initialisation */

	cycle_marker = ArgsOfFunction->cycle;
	if (!ArgsOfFunction->cycle)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "No reference event, thus no post-event histogram...",
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	} /* fin du if */

	h_max = (int)(ArgsOfFunction->duration/ArgsOfFunction->binwidth) ;
/*
	printf("The histogram will have %d bins\n",h_max); 

	spied1 = askival("First spied event: ",post_synaptic) ;
	spied2 = askival("Second spied event: ",0) ;
*/

	i = max_class = faux = 0;
	nb_spied1 = 0 ;
	nombre_ref = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i] < arrivee) 
	{
		if (type[i] == ArgsOfFunction->cycle )
		{
			nombre_ref++;
			j = i ;
			while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <= arrivee ))
			{
				if (type[j] == ArgsOfFunction->events[DATA1])
				{
					nb_spied1++;
					num_class = (int)(inst_rate[j]/ArgsOfFunction->binwidth);
					if (num_class > max_class) max_class = num_class;
					if (num_class < h_max) histo[num_class]++;
					else faux++;	/* don't fit in histo */
				} /* fin du if */
				j++;	
			} /* fin du while */
		} /* fin du if */
		i++;
	} /* fin du while */


	max_1 = 0.;
	for (i = 0; i < max_class; i++)
	{
		printf("Histo[%d] = %d\n",i,histo[i]);
		if ((float)histo[i] > max_1) max_1 = (float)histo[i];
	}

	max = max_1;
	if (min == max)
	{
		Message("Max = min, no drawing possible\n");
		return;
	}
   /* calcul des echelles */
	px = long_X_axis/ArgsOfFunction->duration ;
	py = long_Y_axis/max ;

   /* Ecriture du fichier postscript */

	Message_plotting() ;
	tourne_page();
	bounding_box(2);
	ps_movea(0.,0.) ;
	ps_font("Times-Roman",0.);

	ps_movea(0.,0.);
	ps_echel(px,py,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(0.,0.,
		       0.,ArgsOfFunction->duration,
		       0.,ArgsOfFunction->duration,
		       0,max,
		       0,max,
		       0.1," Time from reference event (s)","%.2f",
		       " Frequency of event 1","%.0f",0.3,0);

	ps_movea(0.,0.);
	ps_set_rgb_color(1.0,0.0,0.0); /* red   */
	ps_histo(histo,long_X_axis,long_Y_axis,ArgsOfFunction->binwidth,max_class,0);
	ps_set_rgb_color(0.0,0.0,0.0); /* black */
	ps_movea(0.,0.);
	ps_cms();
	Fin_plotting(NULL,0,NULL) ;

	/* second event s'il y a lieu */
	
	if (ArgsOfFunction->events[DATA2])
	{
		i = max_class = faux = 0;
		nb_spied2 = 0 ;
		nombre_ref = 0 ;
		while (temps[i++] < depart) ;
		while (temps[i] < arrivee) 
		{
			if (type[i] == ArgsOfFunction->cycle )
			{
				nombre_ref++;
				j = i ;
				while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <=arrivee ))
				{
					if (type[j] == ArgsOfFunction->events[DATA2])
					{
						nb_spied2++;
						num_class = (int)(inst_rate[j]/ArgsOfFunction->binwidth);
						if (num_class > max_class) max_class = num_class;
						if (num_class < h_max) histo[num_class]++;
						else faux++;	/* don't fit in histo */
					} /* fin du if */
					j++;	
				} /* fin du while */
			} /* fin du if */
			i++;
		} /* fin du while */

		max_2 = 0.;
		for (i = 0; i < max_class; i++)
		{
			printf("Histo[%d] = %d\n",i,histo[i]);
			if ((float)histo[i] > max_2) max_2 = (float)histo[i];
		}
			
		/* calcul des echelles */
/*
		rep = askcval("Do you need the same Y scale as for the 1srt event: ",
			      'n');
*/
		if (ArgsOfFunction->sameyscale)
			max = max_2;
		else
			max = max_1;
		if (min == max)
		{
			Message("Max = min, no drawing possible\n");
			return;
		}

		py = long_Y_axis/max ;

		/* Ecriture du fichier postscript */
		
		Message_plotting() ;
		ps_movea((long_X_axis+1.),0.);
		ps_user();
		ps_echel(px,py,0.,0.,1.,0.);

		ps_Y_axis(0.,max,0.1,
			  0.,max,
			  " Frequency of event 2","%.0f",0.3);
		ps_movea(0.,0.);
		ps_set_rgb_color(0.0,0.0,1.0); /* blue  */
		ps_histo(histo,long_X_axis,long_Y_axis,ArgsOfFunction->binwidth,max_class,0);
		ps_set_rgb_color(0.0,0.0,0.0); /* black */
		ps_movea(0.,0.);
		ps_cms();
	} /* fin du if */


   /* LEGENDES */
	ps_set_rgb_color(0.0,0.0,0.0); /* black */

	if (ArgsOfFunction->events[DATA2])
		sprintf(buffer,"Post event inst. rate histogram for events # %d and %d relative to event # %d",
			ArgsOfFunction->events[DATA1], ArgsOfFunction->events[DATA2], ArgsOfFunction->cycle);
	else
		sprintf(buffer,"Post event inst. rate histogram for event # %d relative to event # %d",
			ArgsOfFunction->events[DATA1], ArgsOfFunction->cycle);
	ps_writeah(0.,10.,buffer,.4);
	ps_font("Courier",0.);
	sprintf(buffer,"Start analysis at %.3f s  End analysis at %.3f s",
		depart,arrivee);
	ps_writeah(3.,9.5,buffer,.3);
	ps_writeah(3.,9.,"Reference event: ",.3);
	ps_writeintah(7.3,9.,ArgsOfFunction->cycle,.3);
	ps_writeah(8.,9.,"Number of reference events: ",.3);
	ps_writeintah(15.,9.,nombre_ref,.3);
	ps_writeah(3.,8.5,"Spied Event: ",.3);
	ps_movea(2.8,8.5);
	ps_point(2,.1);
	ps_writeintah(7.3,8.5,ArgsOfFunction->events[DATA1],.3);
	ps_writeah(8.,8.5,"Number of spied events: ",.3);
	ps_writeintah(15.,8.5,nb_spied1,.3);
	if (ArgsOfFunction->events[DATA2])
	{
		ps_writeah(3.,8.,"Scnd spied Event: ",.3);
		ps_movea(2.8,8.);
		ps_point(5,.07);
		ps_writeintah(7.3,8.,ArgsOfFunction->events[DATA2],.3);		
		ps_writeah(8.,8.,"Number of scnd spied event: ",.3);
		ps_writeintah(15.,8.,nb_spied2,.3);
	} /* fin du if */
	ps_writeah(8.,7.5,"Analysis duration: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->duration);
	ps_writeah(15.,7.5,buffer,.3);
	ps_writeah(3.,7.5,"Bin width: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->binwidth);
	ps_writeah(6.2,7.5,buffer,.3);
	ps_font("Times-Roman",0.);	
	Fin_plotting(NULL,0,NULL) ;
	
} /* fin du void */


/*
 * ****************** Post Event dot displays poole ******************
 */

void post_event_rate_pooled (pCALCULSARG ArgsOfFunction)
{
	int	i,j,
		nombre_ref,
		nb_spied1,
		nb_spied2;

	float	mean,
		x,
		y,
		px,
		py1,
		py2;

   /* Initialisation */
	cycle_marker = ArgsOfFunction->cycle;
	if (!ArgsOfFunction->cycle)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "No reference event, thus no post-event histogram...",
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	} /* fin du if */

	i = 0;
	mean = 0. ;
	nombre_ref = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee)
	{
		if (type[i] == ArgsOfFunction->cycle)
		{
			nombre_ref++;
		} /* fin du if */
		if (type[i] == ArgsOfFunction->events[DATA1] )
		{
			mean = mean + inst_rate[i] ;
		}/* fin du if */
	}
	mean = mean/(float)(nb_spied1) ;

	if (ArgsOfFunction->events[DATA2])
	{
		py2 = long_Y_axis / (ArgsOfFunction->max[DATA2] - ArgsOfFunction->min[DATA2]) ;
	} /* fin du if */

   /* calcul des echelles */
	px = long_X_axis/ArgsOfFunction->duration ;
	py1 = long_Y_axis/(ArgsOfFunction->max[DATA1]-ArgsOfFunction->min[DATA1]) ;

   /* Ecriture du fichier postscript */

	Message_plotting() ;
	tourne_page();
	bounding_box(2);
	ps_font("Times-Roman",0.);

	ps_movea(0.,0.);
	ps_echel(px,py1,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(0.,0.,
		       0.,ArgsOfFunction->duration,
		       0.,ArgsOfFunction->duration,
		       ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA1],
		       0.1," Time from reference event (s)","%.2f",
		       " Rate of event 1 (1/s)","%.1f",0.3,0);

	ps_cms();
	if (ArgsOfFunction->events[DATA2])
	{
		ps_movea((long_X_axis+1.),0.);
		ps_user();
		ps_echel(px,py2,0.,0.,1.,0.);

		ps_Y_axis(ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA2],0.1,
			  ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA2],
			  " Rate of event 2 (1/s)","%.1f",0.3);
		ps_movea(0.,0.);
		ps_cms();
	} /* fin du if */

	i = 0 ;
	nb_spied1 = 0 ;
	nb_spied2 = 0 ;

	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee) 
	{
		if (type[i] == ArgsOfFunction->cycle )
		{
			j = i ;
			while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <=arrivee ))
			{
				if (type[j] == ArgsOfFunction->events[DATA1])
				{
					x = (temps[j]-temps[i]);
					y = (inst_rate[j]);
					if ( y >= ArgsOfFunction->min[DATA1] && y <= ArgsOfFunction->max[DATA1] )
					{
						nb_spied1++;
						ps_movea(x*px,y*py1);
						ps_set_rgb_color(1.0,0.0,0.0); /* red */
						ps_point(2,.1) ;
					} /* fin du if */
				} /* fin du if */
				j++;	
			} /* fin du while */
		} /* fin du if */
	} /* fin du while */
		
	ps_movea(0.,0.) ;

	/* second event if any */

	if (ArgsOfFunction->events[DATA2])
	{
		i = 0 ;
		while (temps[i++] < depart) ;
		while (temps[i++] < arrivee) 
		{
			if (type[i] == ArgsOfFunction->cycle )
			{
				j = i ;
				while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <=arrivee ))
				{
					if (type[j] == ArgsOfFunction->events[DATA2])
					{
						x = (temps[j]-temps[i]);
						y = (inst_rate[j]);
						if ( y >= ArgsOfFunction->min[DATA2] && y <= ArgsOfFunction->max[DATA2] )
						{
							nb_spied2++;
							ps_movea(x*px,y*py2);
							ps_set_rgb_color(0.0,0.0,1.0); /* blue */
							ps_point(5,.07) ;
						} /* fin du if */
					} /* fin du if */
					j++;	
				} /* fin du while */
			} /* fin du if */
		} /* fin du while */
		ps_movea(0.,0.) ;
	} /* fin du if */

   /* LEGENDES */
	ps_set_rgb_color(0.0,0.0,0.0); /* black */

	if (ArgsOfFunction->events[DATA2])
		sprintf(buffer,"Pooled post event inst. rate dot display for events # %d and %d relative to event # %d",
			ArgsOfFunction->events[DATA1], ArgsOfFunction->events[DATA2], ArgsOfFunction->cycle);
	else
		sprintf(buffer,"Pooled post event inst. rate dot display for event # %d relative to event # %d",
			ArgsOfFunction->events[DATA1], ArgsOfFunction->cycle);
	ps_writeah(0.,10.,buffer,.4);
	ps_font("Courier",0.);
	sprintf(buffer,"Start analysis at %.3f s  End analysis at %.3f s",
		depart,arrivee);
	ps_writeah(3.,9.5,buffer,.3);
	ps_writeah(3.,9.,"Reference event: ",.3);
	ps_writeintah(7.3,9.,ArgsOfFunction->cycle,.3);
	ps_writeah(8.,9.,"Number of reference events: ",.3);
	ps_writeintah(15.,9.,nombre_ref,.3);
	ps_writeah(3.,8.5,"Spied Event: ",.3);
	ps_movea(2.8,8.5);
	ps_point(2,.1);
	ps_writeintah(7.3,8.5,ArgsOfFunction->events[DATA1],.3);
	ps_writeah(8.,8.5,"Number of spied events: ",.3);
	ps_writeintah(15.,8.5,nb_spied1,.3);
	if (ArgsOfFunction->events[DATA2])
	{
		ps_writeah(3.,8.,"Scnd spied Event: ",.3);
		ps_movea(2.8,8.);
		ps_point(5,.07);
		ps_writeintah(7.3,8.,ArgsOfFunction->events[DATA2],.3);		
		ps_writeah(8.,8.,"Number of scnd spied events: ",.3);
		ps_writeintah(15.,8.,nb_spied2,.3);
	} /* fin du if */
	ps_writeah(8.,7.5,"Analysis duration: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->duration);
	ps_writeah(15.,7.5,buffer,.3);
	ps_font("Times-Roman",0.);	
	Fin_plotting(NULL,0,NULL) ;
	
} /* fin du void */


void post_event_int_pooled(pCALCULSARG ArgsOfFunction)
{
	int	i,j,
		nombre_ref,
		nb_spied1,
		nb_spied2;

	float	mean,
		x,
		y,
		px,
		py1,
		py2;

   /* Initialisation */

	cycle_marker = ArgsOfFunction->cycle;
	if (!ArgsOfFunction->cycle)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "No reference event, thus no post-event histogram...",
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	} /* fin du if */

	i = 0;
	mean = 0. ;
	nombre_ref = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee)
	{
		if (type[i] == ArgsOfFunction->cycle)
		{
			nombre_ref++;
		} /* fin du if */
		if (type[i] == ArgsOfFunction->events[DATA1] )
		{
			mean = mean + inst_interval[i] ;
		}/* fin du if */
	}
	mean = mean/(float)(nb_spied1) ;

	if (ArgsOfFunction->events[DATA2])
	{
		py2 = long_Y_axis/(ArgsOfFunction->max[DATA2]-ArgsOfFunction->min[DATA2]) ;
	} /* fin du if */

   /* calcul des echelles */

	px = long_X_axis/ArgsOfFunction->duration ;
	py1 = long_Y_axis/(ArgsOfFunction->max[DATA1]-ArgsOfFunction->min[DATA1]) ;

   /* Ecriture du fichier postscript */

	Message_plotting() ;
	tourne_page();
	bounding_box(2);
	ps_font("Times-Roman",0.);

	ps_movea(0.,0.);
	ps_echel(px,py1,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(0.,0.,
		       0.,ArgsOfFunction->duration,
		       0.,ArgsOfFunction->duration,
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1," Time from reference event (s)","%.2f",
		       " Interval of event 1 (s)","%.1f",0.3,0);

	ps_cms();
	if (ArgsOfFunction->events[DATA2])
	{
		ps_movea((long_X_axis+1.),0.);
		ps_user();
		ps_echel(px,py2,0.,0.,1.,0.);

		ps_Y_axis(ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA2],0.1,
			  ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA2],
			  " Interval of event 2 (s)","%.1f",0.3);

		ps_movea(0.,0.);
		ps_cms();
	} /* fin du if */

	i = 0 ;
	nb_spied1 = 0 ;
	nb_spied2 = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee) 
	{
		if (type[i] == ArgsOfFunction->cycle )
		{
			j = i ;
			while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <=arrivee ))
			{
				if (type[j] == ArgsOfFunction->events[DATA1])
				{
					x = (temps[j]-temps[i]);
					y = (inst_interval[j]);
					if ( y >= ArgsOfFunction->min[DATA1] && y <= ArgsOfFunction->max[DATA1] )
					{
						nb_spied1++;
						ps_movea(x*px,y*py1);
						ps_set_rgb_color(1.0,0.0,0.0); /* red */
						ps_point(5,.07) ;
					} /* fin du if */
				} /* fin du if */
				j++;	
			} /* fin du while */
		} /* fin du if */
	} /* fin du while */
		
	ps_movea(0.,0.) ;

	if (ArgsOfFunction->events[DATA2])
	{
		i = 0 ;
		while (temps[i++] < depart) ;
		while (temps[i++] < arrivee) 
		{
			if (type[i] == ArgsOfFunction->cycle )
			{
				j = i ;
				while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <=arrivee ))
				{
					if (type[j] == ArgsOfFunction->events[DATA2])
					{
						x = (temps[j]-temps[i]);
						y = (inst_interval[j]);
						if ( y >= ArgsOfFunction->min[DATA2] && y <= ArgsOfFunction->max[DATA2] )
						{
							nb_spied2++;
							ps_movea(x*px,y*py2);
							ps_set_rgb_color(0.0,0.0,1.0); /* blue */
							ps_point(2,.1) ;
						} /* fin du if */
					} /* fin du if */
					j++;	
				} /* fin du while */
			} /* fin du if */
		} /* fin du while */
		ps_movea(0.,0.) ;
	} /* fin du if */

   /* LEGENDES */

	ps_set_rgb_color(0.0,0.0,0.0); /* black */

	if (ArgsOfFunction->events[DATA2])
		sprintf(buffer,"Pooled post event interval dot display for events # %d and %d relative to event # %d",
			ArgsOfFunction->events[DATA1], ArgsOfFunction->events[DATA2], ArgsOfFunction->cycle);
	else
		sprintf(buffer,"Pooled post event interval dot display for event # %d relative to event # %d",
			ArgsOfFunction->events[DATA1], ArgsOfFunction->cycle);

	ps_writeah(0.,10.,buffer,.4);
	ps_font("Courier",0.);
	sprintf(buffer,"Start analysis at %.3f s  End analysis at %.3f s",
		depart,arrivee);
	ps_writeah(3.,9.5,buffer,.3);
	ps_writeah(3.,9.,"Reference event: ",.3);
	ps_writeintah(7.3,9.,ArgsOfFunction->cycle,.3);
	ps_writeah(8.,9.,"Number of reference events: ",.3);
	ps_writeintah(15.,9.,nombre_ref,.3);
	ps_writeah(3.,8.5,"Spied Event: ",.3);
	ps_movea(2.8,8.5);
	ps_point(2,.1);
	ps_writeintah(7.3,8.5,ArgsOfFunction->events[DATA1],.3);
	ps_writeah(8.,8.5,"Number of spied events: ",.3);
	ps_writeintah(15.,8.5,nb_spied1,.3);
	if (ArgsOfFunction->events[DATA2])
	{
		ps_writeah(3.,8.,"Scnd spied Event: ",.3);
		ps_movea(2.8,8.);
		ps_point(5,.07);
		ps_writeintah(7.3,8.,ArgsOfFunction->events[DATA2],.3);		
		ps_writeah(8.,8.,"Number of scnd spied events: ",.3);
		ps_writeintah(15.,8.,nb_spied2,.3);
	} /* fin du if */
	ps_writeah(8.,7.5,"Analysis duration: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->duration);
	ps_writeah(15.,7.5,buffer,.3);
	ps_font("Times-Roman",0.);	
	Fin_plotting(NULL,0,NULL) ;
	
} /* fin du void */


void post_event_phase_pooled(pCALCULSARG ArgsOfFunction)
{
	int	i,j,
		nombre_ref,
		nb_spied1,
		nb_spied2;

	float	mean,
		x,
		y,
		px,
		py1,
		py2;

   /* Initialisation */
   
	cycle_marker = ArgsOfFunction->cycle;
	if (!ArgsOfFunction->cycle)
	{
		DispMessageDialog (fctpara_TopLevelShell,
				   "No reference event, thus no post-event histogram...",
				   "Warning",
				   XmDIALOG_INFORMATION	);
		return;
	} /* fin du if */

	i = 0;
	mean = 0. ;
	nombre_ref = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee)
	{
		if (type[i] == ArgsOfFunction->cycle)
		{
			nombre_ref++;
		} /* fin du if */
		if (type[i] == ArgsOfFunction->events[DATA1] )
		{
			mean = mean + inst_interval[i] ;
		}/* fin du if */
	}

	mean = mean/(float)(nb_spied1) ;

	if (ArgsOfFunction->events[DATA2])
	{
		compute_phase(ArgsOfFunction->events[DATA1],ArgsOfFunction->events[DATA2]);
		py2 = long_Y_axis/(ArgsOfFunction->max[DATA2] - ArgsOfFunction->min[DATA2]) ;
	} /* fin du if */

   /* calcul des echelles */
	px = long_X_axis/ArgsOfFunction->duration ;
	py1 = long_Y_axis/(ArgsOfFunction->max[DATA1]-ArgsOfFunction->min[DATA1]) ;

   /* Ecriture du fichier postscript */

	Message_plotting() ;
	tourne_page();
	bounding_box(2);
	ps_font("Times-Roman",0.);

	ps_movea(0.,0.);
	ps_echel(px,py1,0.,0.,1.,0.);
	ps_user();
	ps_ticked_axes(0.,0.,
		       0.,ArgsOfFunction->duration,
		       0.,ArgsOfFunction->duration,
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       ArgsOfFunction->min[DATA1],ArgsOfFunction->max[DATA1],
		       0.1," Time from reference event (s)","%.2f",
		       " Interval of reference (s)","%.2f",0.3,0);

	ps_cms();
	if (ArgsOfFunction->events[DATA2])
	{
		ps_movea((long_X_axis+1.),0.);
		ps_user();
		ps_echel(px,py2,0.,0.,1.,0.);

		ps_Y_axis(ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA2],0.1,
			  ArgsOfFunction->min[DATA2],ArgsOfFunction->max[DATA2],
			  " Phase of event (s)","%.2f",0.3);

		ps_movea(0.,0.);
		ps_cms();
	} /* fin du if */

	i = 0 ;
	nb_spied1 = 0 ;
	nb_spied2 = 0 ;
	while (temps[i++] < depart) ;
	while (temps[i++] < arrivee) 
	{
		if (type[i] == ArgsOfFunction->cycle )
		{
			j = i ;
			while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <=arrivee ))
			{
				if (type[j] == ArgsOfFunction->events[DATA1])
				{
					x = (temps[j]-temps[i]);
					y = (inst_interval[j]);
					if ( y >= ArgsOfFunction->min[DATA1] && y <= ArgsOfFunction->max[DATA1] )
					{
						nb_spied1++;
						ps_movea(x*px,y*py1);
						ps_set_rgb_color(1.0,0.0,0.0); /* red */
						ps_point(5,.07) ;
					} /* fin du if */
				} /* fin du if */
				j++;	
			} /* fin du while */
		} /* fin du if */
	} /* fin du while */
		
	ps_movea(0.,0.) ;

	/* second event if any */

	if (ArgsOfFunction->events[DATA2])
	{
		i = 0 ;
		while (temps[i++] < depart) ;
		while (temps[i++] < arrivee) 
		{
			if (type[i] == ArgsOfFunction->cycle )
			{
				j = i ;
				while (((temps[j]-temps[i]) <= ArgsOfFunction->duration) && (temps[j] <=arrivee ))
				{
					if (type[j] == ArgsOfFunction->events[DATA2])
					{
						x = (temps[j]-temps[i]);
						y = (phase_interval[j]);
						if ( y >= ArgsOfFunction->min[DATA2] && y <= ArgsOfFunction->max[DATA2] )
						{
							nb_spied2++;
							ps_movea(x*px,y*py2);
							ps_set_rgb_color(0.0,0.0,1.0); /* blue */
							ps_point(2,.1) ;
						} /* fin du if */
					} /* fin du if */
					j++;	
				} /* fin du while */
			} /* fin du if */
		} /* fin du while */
		ps_movea(0.,0.) ;
	} /* fin du if */

   /* LEGENDES */

	ps_set_rgb_color(0.0,0.0,0.0); /* black */

	sprintf(buffer,"Pooled post event phase dot display for events # %d and %d relative to event # %d",
			ArgsOfFunction->events[DATA1], ArgsOfFunction->events[DATA2], ArgsOfFunction->cycle);

	ps_writeah(0.,10.,buffer,.4);
	ps_font("Courier",0.);
	sprintf(buffer,"Start analysis at %.3f s  End analysis at %.3f s",
		depart,arrivee);
	ps_writeah(3.,9.5,buffer,.3);
	ps_writeah(3.,9.,"Cyclic event: ",.3);
	ps_writeintah(7.3,9.,ArgsOfFunction->cycle,.3);
	ps_writeah(8.,9.,"Number of cyclic events: ",.3);
	ps_writeintah(15.,9.,nombre_ref,.3);
	ps_writeah(3.,8.5,"Reference Event: ",.3);
	ps_movea(2.8,8.5);
	ps_point(2,.1);
	ps_writeintah(7.3,8.5,ArgsOfFunction->events[DATA1],.3);
	ps_writeah(8.,8.5,"Number of reference events: ",.3);
	ps_writeintah(15.,8.5,nb_spied1,.3);
	if (ArgsOfFunction->events[DATA2])
	{
		ps_writeah(3.,8.,"Spied Event: ",.3);
		ps_movea(2.8,8.);
		ps_point(5,.07);
		ps_writeintah(7.3,8.,ArgsOfFunction->events[DATA2],.3);		
		ps_writeah(8.,8.,"Number of spied events: ",.3);
		ps_writeintah(15.,8.,nb_spied2,.3);
	} /* fin du if */
	ps_writeah(8.,7.5,"Analysis duration: ",.3);
	sprintf(buffer,"%.3f s",ArgsOfFunction->duration);
	ps_writeah(15.,7.5,buffer,.3);
	ps_font("Times-Roman",0.);	
	Fin_plotting(NULL,0,NULL);
	
} /* fin du void */
















