/*
**
**	interface_callbacks.c functions prototypes
**
*/


#ifdef _TMS_CALLBACK
#	define _TMS_CB_CLASS
#else
#	define _TMS_CB_CLASS extern
#endif

#ifndef _TMS_CALLBACK
typedef void (*ACTIONFCT_TYPE)();
#endif

#ifndef CALCFUNC_ARGS
#define CALCFUNC_ARGS

#define COMPUTE_DATAS 3		/* Number of datas used for the compute actions */
#define DATA1 0
#define DATA2 1
#define DATA3 2

#define FCTPARA_PARANB 7	/* Nb of widget that are used to get paramters for calculs */
#define HISTOGRAM_PARANB 6
#define ARROWS_PARANB 4
#define POINCARE_PARANB 3
#define THREED_PARANB 4

typedef struct calculsarg
{
	ACTIONFCT_TYPE	function;		/* function to be executed*/
	char		action[3];		/* name of action */
	int		events[COMPUTE_DATAS];	/* events selected for action */
	float		binwidth;
	int		order;
	float		duration;
	int		cycle;
	float		max[COMPUTE_DATAS];
	float		min[COMPUTE_DATAS];
	Boolean		sameyscale;
	int		line1;
	int		line2;
	float		ymax;
	float		ymin;
	float		mapfrom;
	float		mapto;
	Boolean		square;
	int		binsnb;
	float		teta;
	float		phi;
	float		screen;
	float		eye;
	Boolean		arrowpos;
	int		*arrowlist;
	Boolean		FctparaList[FCTPARA_PARANB];		/* lists that tell wich widgets are sensitive */
	Boolean		HistogramList[HISTOGRAM_PARANB];
	Boolean		ArrowsList[ARROWS_PARANB];
	Boolean		PoincareList[POINCARE_PARANB];
	Boolean		ThreeDList[THREED_PARANB];
} CALCULSARG, *pCALCULSARG;

#endif

_TMS_CB_CLASS void tms_MainFunctionCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_MainExitButtonCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_MainPrintOnCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_MainPrintOptionCB	(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_MainDefaultsOptionCB	(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_MainStdDefaultsOptionCB	(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_MainPrintOnOKCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_MainDisplayHelpCB	(Widget widget, XtPointer client_data, XtPointer call_data);

_TMS_CB_CLASS void tms_OpenParametersCB		(Widget widget, XtPointer client_data, XtPointer call_data);

_TMS_CB_CLASS void tms_AxisApplyCB		(Widget widget, XtPointer client_data, XtPointer call_data);

_TMS_CB_CLASS void tms_fctparaApplyCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_fctparaComputeCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_fctparaDismissCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_fctparaSetSensitive	(Boolean *SensitifList);

_TMS_CB_CLASS void tms_RegisterTMSFileCB	(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_RegisterCancelCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_RegisterTMSScriptFileCB	(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_ParametersOKCB		(Widget widget, XtPointer Client_Data, XtPointer Call_Data);

_TMS_CB_CLASS void tms_OKPromptDialogCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_openParametersCB		(Widget widget, XtPointer client_data, XtPointer call_data);

_TMS_CB_CLASS void tms_change_file		(Widget widget, XtPointer client_data, XtPointer call_data);

_TMS_CB_CLASS int tms_VerifyForCompute		(pCALCULSARG ArgOfFct);
_TMS_CB_CLASS int tms_MinMaxCalcul		(pCALCULSARG FunctionArg);

_TMS_CB_CLASS void DispMessageDialog		(Widget Parent, char* Message, char* TitleOfMessage, unsigned char theType);
_TMS_CB_CLASS void DispPromptDialog		(Widget Parent, char* TheMessage, char* DefaultChoice);

_TMS_CB_CLASS void tms_histogramSetSensitive	(Boolean SensitifList[]);

_TMS_CB_CLASS void tms_arrowsSetSensitive	(Boolean SensitifList[]);
_TMS_CB_CLASS void tms_arrowsApplyCB		(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_arrowsRemoveCB		(Widget widget, XtPointer Client_Data, XtPointer Call_Data);
_TMS_CB_CLASS void tms_arrowsAddCB		(Widget widget, XtPointer Client_Data, XtPointer Call_Data);
_TMS_CB_CLASS void tms_arrowsArrowNeededCB	(Widget widget, XtPointer Client_Data, XtPointer Call_Data);
_TMS_CB_CLASS void tms_arrowsArrowAutoCB	(Widget widget, XtPointer Client_Data, XtPointer Call_Data);

_TMS_CB_CLASS void tms_poincareAxisOptionCB	(Widget widget, XtPointer client_data, XtPointer call_data);
_TMS_CB_CLASS void tms_poincareSetSensitive	(Boolean SensitifList[]);
_TMS_CB_CLASS void tms_poincareApplyCB		(Widget widget, XtPointer client_data, XtPointer call_data);

_TMS_CB_CLASS void tms_threeDSetSensitive	(Boolean SensitifList[]);

_TMS_CB_CLASS void tms_FilterApplyCB		(Widget widget, XtPointer Client_Data, XtPointer Call_Data);
_TMS_CB_CLASS void tms_FilterOKCB		(Widget widget, XtPointer Client_Data, XtPointer Call_Data);

/*************************** ACTIONS VARIABLES ****************/

/*** f(time) menu ***/

extern void	freqgram      (pCALCULSARG ArgsOfFunction);
extern void	freqgram_dots (pCALCULSARG ArgsOfFunction);
extern void	freqgram2     (pCALCULSARG ArgsOfFunction);
extern void	freqhisto     (pCALCULSARG ArgsOfFunction);
extern void	interv_time   (pCALCULSARG ArgsOfFunction);
extern void	interv_time2  (pCALCULSARG ArgsOfFunction);
extern void	phase_time    (pCALCULSARG ArgsOfFunction);
extern void	phase_inter   (pCALCULSARG ArgsOfFunction);

_TMS_CB_CLASS void	(*action_2[8])();

_TMS_CB_CLASS char	*menu_2[8];

/*** f(Rank) menu ***/

extern void	interv_rank   (pCALCULSARG ArgsOfFunction);
extern void	phase_rank    (pCALCULSARG ArgsOfFunction);
extern void	fourier_order (pCALCULSARG ArgsOfFunction);

_TMS_CB_CLASS void	(*action_3[3])();

_TMS_CB_CLASS char	*menu_3[3];

/*** Corelations menu ***/

extern void	crosscorrelation (pCALCULSARG ArgsOfFunction);
extern void	autocorrelation  (pCALCULSARG ArgsOfFunction);

_TMS_CB_CLASS void	(*action_4[2])();

_TMS_CB_CLASS char	*menu_4[2];

/*** Poincare's map menu***/

extern void	poincare            (pCALCULSARG ArgsOfFunction);
extern void	poincare_2          (pCALCULSARG ArgsOfFunction);
extern void	poincare_int_cyclic (pCALCULSARG ArgsOfFunction);
extern void	poincare_phases     (pCALCULSARG ArgsOfFunction);
extern void	poincare_pha_cyclic (pCALCULSARG ArgsOfFunction);

_TMS_CB_CLASS void	(*action_5[5])();

_TMS_CB_CLASS char	*menu_5[5];

/*** Peri analysis events menu ***/

extern void	inter_event_histo       (pCALCULSARG ArgsOfFunction);
extern void	dot_display             (pCALCULSARG ArgsOfFunction);
extern void	lissajous               (pCALCULSARG ArgsOfFunction);
extern void	scatter_diagram         (pCALCULSARG ArgsOfFunction);
extern void	post_event_rate_hist    (pCALCULSARG ArgsOfFunction);
extern void	post_event_int_pooled   (pCALCULSARG ArgsOfFunction);
extern void	post_event_rate_pooled  (pCALCULSARG ArgsOfFunction);
extern void	post_event_phase_pooled (pCALCULSARG ArgsOfFunction);

_TMS_CB_CLASS void	(*action_6[8])();

_TMS_CB_CLASS char	*menu_6[8];

/*** 3D menu ***/

extern void	inter_3D (pCALCULSARG ArgsOfFunction);
extern void	phase_3D (pCALCULSARG ArgsOfFunction);

_TMS_CB_CLASS void	(*action_7[2])();

_TMS_CB_CLASS char	*menu_7[2];

/*** Phase maps menu ***/

extern void	derive_inter     (pCALCULSARG ArgsOfFunction);
extern void	exp_derive_inter (pCALCULSARG ArgsOfFunction);
extern void	derive_phase     (pCALCULSARG ArgsOfFunction);

_TMS_CB_CLASS void	(*action_8[3])();

_TMS_CB_CLASS char	*menu_8[3];

#undef _TMS_CB_CLASS





