#define DEBUG_STIM 0
/*
*************************************************************************
*
*		TMS V?
*
*	This file contains all interface functions and callback functions
*
*
*
*
*
*
**************************************************************************
*/

/*
 * Standard includes for builtins.
 */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>

/*
**	MOTIF include files
*/
#include <X11/cursorfont.h>
#include <Xm/Xm.h>
#include <Xm/FileSB.h>
#include <Xm/MessageB.h>
#include <Xm/ToggleB.h>
#include <Xm/PushB.h>
#include <Xm/Text.h>
/*
**	Personal Motif variables
*/

#define PRINTED_EXT ".ps"              /* extension of printed files */
#define _TMS_CALLBACK
#include "tms_unix.h"
#include "tms_interface_creation.h"
#include "tms_interface_callbacks.h"
#undef _TMS_CALLBACK

/*
 * Macros to make code look nicer between ANSI and K&R.
 */
#ifndef ARGLIST
#if (NeedFunctionPrototypes == 0)
#define PROTOTYPE(p)	()
#define ARGLIST(p)	p
#define ARG(a, b)	a b;
#define GRA(a, b)	a b;
#define UARG(a, b)      a b;
#define GRAU(a, b)      a b;
#else
#define PROTOTYPE(p)	p
#define ARGLIST(p)	(
#define ARG(a, b)	a b,
#define GRA(a, b)	a b)
#ifdef __cplusplus
#define UARG(a, b)      a,
#define GRAU(a, b)      a)
#else
#define UARG(a, b)      a b,
#define GRAU(a, b)      a b)
#endif
#endif
#endif

/*
**	Global Variables
*/

extern  Boolean  FirstUse;
/*** Min and Max parameters that identify how to calcul Min and Max ***/

#define FIRST_MM 1
#define SCND_MM 2
#define THURD_MM 3
#define FORTH_MM 4
#define FITH_MM 5
#define SIXTH_MM 6
#define SEVENTH_MM 7
#define EIGHTTH_MM 8
#define NINETH_MM 9

extern Widget TheAppShell;
extern Widget main_TopLevelShell;
extern Widget parameters_TopLevelShell;
extern Widget fileSelection_TopLevelShell;
extern Widget filter_TopLevelShell;
extern Widget histogram_TopLevelShell;
extern Widget arrows_TopLevelShell;
extern Widget poincare_TopLevelShell;
extern Widget parametersOK_PushButton;
Widget fctpara_TopLevelShell;
Widget ThePopupBox;

/*** prototypes ***/

Widget		BxFindTopShell PROTOTYPE((Widget));
WidgetList	BxWidgetIdsFromNames PROTOTYPE((Widget, char*, char*));



/*** extern functions... ***/

extern void	spawn(),	/* fonctions communes */
		retour(),
		fin(),
		no_op();

extern int	spooled;
extern char	on_garde[10];
		
extern void BxSetSensitiveCB (Widget w, XtPointer client_data, XtPointer call_data);
extern void BxSetInsensitiveCB (Widget w, XtPointer client_data, XtPointer call_data);
extern void BxPopupCB (Widget w, XtPointer client_data, XtPointer call_data);
extern int compute_rate (int);
extern int compute_interval (int);
extern Widget CreatehelpMain_Form (Widget);

/*
************************************************************************************
*
*	Function:
*		tms_MainDispHelpText (widget, client_data, call_data)
*	Description:
*		create, the first time, the Topic menu's items
*		fills the Topic menu with items available.
*
*	Inputs:
*		int	client_data	the help item number
*
*	Revision:
*
*************************************************************************************
*/
tms_MainDispHelpText (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/	
	FILE		*fp;
	char		*pt;
	char		file_name[256];
	XmString	string;
	char		buffer[256];
	static		char **help_files;
	static		char **topics;
	Widget		w;
	static		int nb_items;
	char		*text;
	int		i;
	long		l;
	int		HelpNumber;
/*
**	Code
*/
#ifdef __CYGWIN__
#	define SEP_DIR "\\"
#	define CR 2
#else
#	define SEP_DIR "/"
#	define CR 1
#endif

	HelpNumber = (int) client_data;

	XtInitializeWidgetClass(xmPushButtonWidgetClass);

	if(HelpNumber == -1)
	{
		for(i=0 ; i<nb_items ; i++)
		{
			free(help_files[i]);
			free(topics[i]);
		}
		free(help_files);
		free(topics);
		return;
	}
	
	if(!nb_items)
	{
		strcpy(file_name,help_directory);
		strcat(file_name,SEP_DIR);
		strcat(file_name,"xtms_hlprc");
		
		if(!(fp = fopen(file_name,"r")))
		{
			sprintf(buffer,"Sorry, file %s not found...",file_name);
			DispMessageDialog (main_TopLevelShell,
					   buffer,
					   "Error : No help available!",
					   XmDIALOG_ERROR);
			return;
		}
		
		nb_items = 0;
		
		while(fgets(buffer,255,fp))
		{	
			pt = strrchr(buffer,':');
			if(!pt)
				continue;
			nb_items++;
			*pt = '\0';
			pt += 2;
			if(nb_items == 1)
			{
				help_files = (char **)calloc(1,nb_items*sizeof(char *));
				topics = (char **)calloc(1,nb_items*sizeof(char *));
				topics[nb_items - 1] = (char *)calloc(1,(strlen(buffer)+1)*sizeof(char));
				strcpy(topics[nb_items - 1],buffer);
				help_files[nb_items - 1] = (char *)calloc(1,(strlen(pt)+1)*sizeof(char));
				strcpy(help_files[nb_items - 1],pt);
				help_files[nb_items - 1][strlen(pt)- CR] = '\0';
			}
			else
			{
				help_files = (char **)realloc(help_files,nb_items*sizeof(char *));
				topics = (char **)realloc(topics,nb_items*sizeof(char *));
				topics[nb_items - 1] = (char *)calloc(1,(strlen(buffer)+1)*sizeof(char));
				strcpy(topics[nb_items - 1],buffer);
				help_files[nb_items - 1] = (char *)calloc(1,(strlen(pt)+1)*sizeof(char));
				strcpy(help_files[nb_items - 1],pt);
				help_files[nb_items - 1][strlen(pt)- CR] = '\0';
			}	
		}
		
		for(i=0 ; i<nb_items ; i++)
		{
			int j;

			j = i+1;
			string = XmStringCreateLocalized(topics[i]);
			w = XtVaCreateWidget(topics[i],
					     xmPushButtonWidgetClass,
					     helpTopic_PulldownMenu,
					     NULL);
			XtAddCallback(w, XmNactivateCallback, (XtPointer)tms_MainDispHelpText, (XtPointer)(j));
			XtManageChild(w);
			XmStringFree(string);
		}
		HelpNumber = 1;	
	}
	
	strcpy(file_name,help_directory);
	strcat(file_name,SEP_DIR);
	strcat(file_name,help_files[HelpNumber-1]);
		
	if(!(fp = fopen(file_name,"r")))
	{
		sprintf(buffer,"Sorry, file %s not found...",file_name);
		DispMessageDialog (main_TopLevelShell,
				   buffer,
				   "Error : Topic not available!",
				   XmDIALOG_ERROR);
		return;
	}
	
	fseek(fp, 0L, SEEK_END);
	l = ftell(fp)+1;
	if (!(text = (char *)calloc(1,l*sizeof(char))))
	{
		sprintf(buffer,"Sorry, impossible to load the help on %s...",file_name);
		DispMessageDialog (main_TopLevelShell,
				   buffer,
				   "Error : Not enough memory!",
				   XmDIALOG_ERROR);
		return;
	} /* fin du if */
	fseek(fp, 0L, SEEK_SET);
	fread(text, l*sizeof(char), 1, fp);
	text[l- 1] = '\0';
	
	XmTextSetString (help_Text, text);
	
	string = XmStringCreateLocalized(topics[HelpNumber-1]);
	XtVaSetValues(helpTopic_Label,
		      XmNlabelString, string,
		      NULL);
	XmStringFree(string);	
	
	free(text);
}

/*
************************************************************************************
*
*	Function:
*		tms_MainDisplayHelpCB (Flag)
*	Description:
*		fills the Topic menu with items available.
*
*	Inputs:
*
*	Revision:
*
*************************************************************************************
*/

void tms_MainDisplayHelpCB (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/
	static Widget	helpMain_Form;
/*
**	Code
*/

	if (!helpMain_Form)
	{
		helpMain_Form = (Widget)CreatehelpMain_Form (TheAppShell);
		tms_MainDispHelpText (widget, (XtPointer) 0, call_data);
	}
	XtManageChild (helpMain_Form);
}


/*
************************************************************************************
*
*	Function:
*		tms_VerifyForCompute (pCALCULSARG FunctionArg)
*	Description:
*		Verify selection in 'fctpara' window and register the selections
*	Inputs:
*
*	Outputs:
*		pCALCULSARG FunctionArg	:	caracteristics of the selection. only events number are
*						initialized
*	Revision:
*		may the 20 of 1996
*		june the 10 of 1996 end of design
*
*************************************************************************************
*/

int tms_VerifyForCompute (pCALCULSARG FunctionArg)
{
/*
**	Variables
*/
	char		*SomeChar;
	char		*SomeOtherChar;
	char		CharToPrint[50];
	short		Index;
	short		EventIndex;
	int		IFoundIt[COMPUTE_DATAS];
	int		SomeInt;
	int		CorrectEventsNb;
	int		TheStatus;
	float		SomeFloat;
/*
**	Code
*/
	SomeChar = NULL;
	SomeOtherChar = NULL;
	CorrectEventsNb = 0;

	/*** Tests that some events are not selected more than once***/

	for (EventIndex = 0; EventIndex < (COMPUTE_DATAS - 1); EventIndex++)
	{
		SomeOtherChar = (char *) XmTextGetString (fctparaBoardNb_TextField[EventIndex]);
		for (Index = (EventIndex + 1); Index < COMPUTE_DATAS; Index++)
		{
			SomeChar = (char *) XmTextGetString (fctparaBoardNb_TextField[Index]);
			if (!strcmp(SomeChar, SomeOtherChar))
			{
				XmTextSetString (fctparaBoardNb_TextField[Index], "");
			}
		}
	}

	/*** Tests that the event selected exist ***/
	
	for (Index = 0; Index < COMPUTE_DATAS; Index++)
	{
		IFoundIt[Index] = False;
		SomeChar = (char *) XmTextGetString (fctparaBoardNb_TextField[Index]);
		if (strcmp(SomeChar, ""))
		{
			sscanf (SomeChar, "%d", &SomeInt);
			for (EventIndex = 0; EventIndex < nb_de_types; EventIndex++)
			{
				if (SomeInt == les_types[EventIndex])
				{
					IFoundIt[Index] = les_types[EventIndex];
					CorrectEventsNb++;
				}
			}
		}
	}	
	if (!CorrectEventsNb)
	{
		return CorrectEventsNb;
	}
	else
	{
		/*** get the correct events in fctpara window ***/
		
		for (Index = 0; Index < CorrectEventsNb; Index++)
		{
			FunctionArg->events[Index] = IFoundIt[Index];
		}

		Index = COMPUTE_DATAS;
		if (FunctionArg->FctparaList[Index]) /* set order parameter */
		{
			SomeChar = (char *) XmTextGetString (fctparaOrder_TextField);
			if (!strcmp(SomeChar, ""))
			{
				sprintf (CharToPrint, "%d", user_order);
				XmTextSetString (fctparaOrder_TextField, CharToPrint);
				FunctionArg->order = atoi (CharToPrint);
			}
			else
			{
				FunctionArg->order = atoi (SomeChar);
				user_order = FunctionArg->order;
			}
		}
		Index++;
		if (FunctionArg->FctparaList[Index]) /* set cycle parameter */
		{
			SomeChar = (char *) XmTextGetString (fctparaCycle_TextField);
			if (!strcmp(SomeChar, ""))
			{
				if (FunctionArg->action[0] == 'D' ||
				    FunctionArg->action[0] == 'E')
				{
					sprintf (CharToPrint, "%d", user_cycle_marker);
					XmTextSetString (fctparaCycle_TextField, CharToPrint);
				}
				FunctionArg->cycle = atoi (CharToPrint);
				cycle_marker = user_cycle_marker;
			}
			else
			{
				FunctionArg->cycle = atoi (SomeChar);
				user_cycle_marker = FunctionArg->cycle;
				cycle_marker = user_cycle_marker;
			}
		}
		Index++;
		if (FunctionArg->FctparaList[Index]) /* set Binwidth parameter */
		{
			SomeChar = (char *) XmTextGetString (fctparaBin_TextField);
			if (!strcmp(SomeChar, ""))
			{
				if (FunctionArg->action[0] == 'A' && FunctionArg->action[1] == 'D')
				{
					FunctionArg->binwidth = user_binwidth;
					sprintf (CharToPrint, "%f", FunctionArg->binwidth);
					XmTextSetString (fctparaBin_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'C' && FunctionArg->action[1] == 'A')
				{
					FunctionArg->binwidth = user_binwidth_AC;
					sprintf (CharToPrint, "%f", FunctionArg->binwidth);
					XmTextSetString (fctparaBin_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'C' && FunctionArg->action[1] == 'B')
				{
					FunctionArg->binwidth = user_binwidth_CC;
					sprintf (CharToPrint, "%f", FunctionArg->binwidth);
					XmTextSetString (fctparaBin_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'A')
				{
					FunctionArg->binwidth = user_binwidth_IS;
					sprintf (CharToPrint, "%f", FunctionArg->binwidth);
					XmTextSetString (fctparaBin_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'C')
				{
					FunctionArg->binwidth = user_binwidth_PST;
					sprintf (CharToPrint, "%f", FunctionArg->binwidth);
					XmTextSetString (fctparaBin_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'D')
				{
					FunctionArg->binwidth = user_binwidth_PST;
					sprintf (CharToPrint, "%f", FunctionArg->binwidth);
					XmTextSetString (fctparaBin_TextField, CharToPrint);
				}
			}
			else
			{
				FunctionArg->binwidth = atof (SomeChar);
				if (FunctionArg->action[0] == 'C' && FunctionArg->action[1] == 'A')
				  {
				    user_binwidth_AC = FunctionArg->binwidth;
				  }
				else if (FunctionArg->action[0] == 'C' && FunctionArg->action[1] == 'B')
				  {
				    user_binwidth_CC = FunctionArg->binwidth;
				  }
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'A')
				  {
				     user_binwidth_IS = FunctionArg->binwidth;
				  }
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'C')
				  {
				     user_binwidth_PST = FunctionArg->binwidth;
				  }
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'D')
				  {
				     user_binwidth_PST = FunctionArg->binwidth;
				  }
				else
				  user_binwidth = FunctionArg->binwidth;
			}
		}
		Index++;
		if (FunctionArg->FctparaList[Index]) /* set duration parameter */
		{
			SomeChar = (char *) XmTextGetString (fctparaDuration_TextField);
			if (!strcmp(SomeChar, ""))
			{
				if ((FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'D') ||
				    (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'E') ||
				    (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'F') ||
				    (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'G') ||
				    (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'H'))
				{
					sprintf (CharToPrint, "%f", user_duration_PST);
					XmTextSetString (fctparaDuration_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'C' && FunctionArg->action[1] == 'A')
				{
					sprintf (CharToPrint, "%.4f",user_duration_AC);
					XmTextSetString (fctparaDuration_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'C' && FunctionArg->action[1] == 'B')
				{
					sprintf (CharToPrint, "%.4f",user_duration_CC);
					XmTextSetString (fctparaDuration_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'D' && FunctionArg->action[1] == 'C')
				{
					sprintf (CharToPrint, "%f", duree_cycle);
					XmTextSetString (fctparaDuration_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'D' && FunctionArg->action[1] == 'E')
				{
					sprintf (CharToPrint, "%f", duree_cycle);
					XmTextSetString (fctparaDuration_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'A')
				{
					sprintf (CharToPrint, "%.4f",user_duration_IS);
					XmTextSetString (fctparaDuration_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'B')
				{
					sprintf (CharToPrint, "%.4f",user_duration);
					strcpy (CharToPrint, "5.0");
					XmTextSetString (fctparaDuration_TextField, CharToPrint);
				}
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'C')
				{
					sprintf (CharToPrint, "%.4f",user_duration);

					XmTextSetString (fctparaDuration_TextField, CharToPrint);
				}
				FunctionArg->duration = atof (CharToPrint);
			}
			else
			{
				FunctionArg->duration = atof (SomeChar);
				if ((FunctionArg->action[0] == 'D' && FunctionArg->action[1] == 'C') ||
				    (FunctionArg->action[0] == 'D' && FunctionArg->action[1] == 'E'))
				{
					duree_cycle = user_duration_PST = FunctionArg->duration;
				}
				else if (FunctionArg->action[0] == 'C' && FunctionArg->action[1] == 'A')
				  {
				    user_duration_AC = FunctionArg->duration;
				  }
				else if (FunctionArg->action[0] == 'C' && FunctionArg->action[1] == 'B')
				  {
				    user_duration_CC = FunctionArg->duration;
				  }
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'A')
				  {
				     user_duration_IS = FunctionArg->duration;
				  }
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'C')
				  {
				     user_duration_PST = FunctionArg->duration;
				  }
				else if (FunctionArg->action[0] == 'E' && FunctionArg->action[1] == 'D')
				  {
				     user_duration_PST = FunctionArg->duration;
				  }
				else
				  user_duration = FunctionArg->duration;
			 
			}
		}

		/*** Get parameters in histogram window ***/

		Index = 0;
		if (FunctionArg->HistogramList[Index])	/* set line1 parameter */
		{
			SomeChar = (char *) XmTextGetString (histogramLine1_TextField);
			if (!strcmp(SomeChar, ""))
			{
				if (FunctionArg->action[0] == 'E')
				{
					sprintf (CharToPrint, "%d", 3);
					XmTextSetString (histogramLine1_TextField, CharToPrint);
				}
				FunctionArg->line1 = atoi (CharToPrint);
			}
			else
			{
				FunctionArg->line1 = atoi (SomeChar);				
			}
		}
		Index++;
		if (FunctionArg->HistogramList[Index])	/* set Bins Nb parameter */
		{
			SomeChar = (char *) XmTextGetString (histogramBinsNb_TextField);
			if (!strcmp(SomeChar, ""))
			{
				strcpy (CharToPrint,"0");
				if (FunctionArg->action[0] == 'E' && FunctionArg->binwidth != 0.)
				{
					SomeInt = (int) (FunctionArg->duration / FunctionArg->binwidth) + 1;
					sprintf (CharToPrint, "%d", SomeInt);
					XmTextSetString (histogramBinsNb_TextField, CharToPrint);
				}
				FunctionArg->binsnb = atoi (CharToPrint);
			}
			else
			{
				FunctionArg->binsnb = atoi (SomeChar);				
			}
		}
		Index++;
		if (FunctionArg->HistogramList[Index]) /* set line2 parameter */
		{
			SomeChar = (char *) XmTextGetString (histogramLine2_TextField);
			if (!strcmp(SomeChar, ""))
			{
				if (FunctionArg->action[0] == 'E')
				{
					sprintf (CharToPrint, "%d", 1);
					XmTextSetString (histogramLine2_TextField, CharToPrint);
				}
				FunctionArg->line2 = atoi (CharToPrint);
			}
			else
			{
				FunctionArg->line2 = atoi (SomeChar);
			}
		}
		Index++;
		if (FunctionArg->HistogramList[Index]) /* get Scale toggle button parameter */
		{
			FunctionArg->sameyscale = XmToggleButtonGetState(histogramScale_ToggleButton);
		}
		Index++;
		if (FunctionArg->HistogramList[Index])
		{
			SomeChar = (char *) XmTextGetString (histogramMax_TextField);
			if (!strcmp(SomeChar, ""))
			{
/*
				if (FunctionArg->action[0] == '')
				{
					sprintf (CharToPrint, "%f", );
					XmTextSetString (histogramMax_TextField, CharToPrint);
				}
				FunctionArg->ymax = atof (CharToPrint);
*/
			}
			else
			{
				FunctionArg->ymax = atof (SomeChar);
			}
		}
		Index++;
		if (FunctionArg->HistogramList[Index])
		{
			SomeChar = (char *) XmTextGetString (histogramMin_TextField);
			if (!strcmp(SomeChar, ""))
			{
/*
				if (FunctionArg->action[0] == '')
				{
					sprintf (CharToPrint, "%f", );
					XmTextSetString (histogramMin_TextField, CharToPrint);
				}
				FunctionArg->ymin = atof (CharToPrint);
*/
			}
			else
			{
				FunctionArg->ymin = atof (SomeChar);
			}
		}

		/*** Get parameters in poincare window ***/
		
		Index = 0;
		if (FunctionArg->PoincareList[Index])
		{
			SomeChar = (char *) XmTextGetString (poincareDrawFrom_TextField);
			if (!strcmp(SomeChar, ""))
			{
				if (FunctionArg->action[0] == 'D')
				{
					sprintf (CharToPrint, "%f", 0.);
					XmTextSetString (poincareDrawFrom_TextField, CharToPrint);
				}
				FunctionArg->mapfrom = atof (CharToPrint);
			}
			else
			{
				FunctionArg->mapfrom = atof (SomeChar);
			}
		}
		Index++;
		if (FunctionArg->PoincareList[Index])
		{
			SomeChar = (char *) XmTextGetString (poincareDrawTo_TextField);
			if (!strcmp(SomeChar, ""))
			{
				if (FunctionArg->action[0] == 'D')
				{
					duree_cycle = FunctionArg->duration;
					sprintf (CharToPrint, "%f", duree_cycle);
					XmTextSetString (poincareDrawTo_TextField, CharToPrint);
				}
				FunctionArg->mapto = atof (CharToPrint);

			}
			else
			{
				FunctionArg->mapto = atof (SomeChar);
			}
		}
		Index++;
		if (FunctionArg->PoincareList[Index])
		{
			FunctionArg->square = XmToggleButtonGetState(poincareAxisSize_ToggleButton);
		}

		/*** Get parameters in threeD window ***/

		Index = 0;
		if (FunctionArg->ThreeDList[Index])
		{
			SomeChar = (char *) XmTextGetString (threeDTeta_TextField);
			if (!strcmp(SomeChar, ""))
			{
				sprintf (CharToPrint, "%f", -.75);
				XmTextSetString (threeDTeta_TextField, CharToPrint);
				FunctionArg->teta = atof (CharToPrint);
			}
			else
			{
				FunctionArg->teta = atof (SomeChar);
			}
		}
		Index++;
		if (FunctionArg->ThreeDList[Index])
		{
			SomeChar = (char *) XmTextGetString (threeDPhi_TextField);
			if (!strcmp(SomeChar, ""))
			{
				sprintf (CharToPrint, "%f", .75);
				XmTextSetString (threeDPhi_TextField, CharToPrint);
				FunctionArg->phi = atof (CharToPrint);
			}
			else
			{
				FunctionArg->phi = atof (SomeChar);
			}
		}
		Index++;
		if (FunctionArg->ThreeDList[Index])
		{
			SomeChar = (char *) XmTextGetString (threeDScreen_TextField);
			if (!strcmp(SomeChar, ""))
			{
				sprintf (CharToPrint, "%f", 20.);
				XmTextSetString (threeDScreen_TextField, CharToPrint);
				FunctionArg->screen = atof (CharToPrint);
			}
			else
			{
				FunctionArg->screen = atof (SomeChar);
			}
		}
		Index++;
		if (FunctionArg->ThreeDList[Index])
		{
			SomeChar = (char *) XmTextGetString (threeDEye_TextField);
			if (!strcmp(SomeChar, ""))
			{
				sprintf (CharToPrint, "%f", 10.);
				XmTextSetString (threeDEye_TextField, CharToPrint);
				FunctionArg->eye = atof (CharToPrint);
			}
			else
			{
				FunctionArg->eye = atof (SomeChar);
			}
		}
		Index++;

		/***get parameters in arrows window ***/

		Index = 0;
		if (FunctionArg->ArrowsList[Index]) /* get Scale toggle button parameter */
		{
			FunctionArg->arrowpos = XmToggleButtonGetState(arrowsPos_ToggleButton);
		}
		Index++;
/*
		if (FunctionArg->ArrowsList[Index])
		{
		}
		Index++;
*/

		/*** modify max and min values in fctpara window if it's empty (la premiere fois) ***/

		SomeChar = (char *) XmTextGetString (fctparaBoardMax_TextField[0]);
		if (!strcmp(SomeChar, ""))
		{
		  TheStatus = tms_MinMaxCalcul (FunctionArg);

		  if (TheStatus == -1)
		  {
			return -1;
		  }
		  else if (TheStatus == -2)
		  {
			return -2;
		  }
		}
 
		/*** get more specifics parameters in fctpara window ***/

		for (Index = 0; Index < COMPUTE_DATAS; Index++)
		{
			if (FunctionArg->FctparaList[Index])
			{
				SomeChar = (char *) XmTextGetString (fctparaBoardMax_TextField[Index]);
				FunctionArg->max[Index] = atof (SomeChar);
				SomeChar = (char *) XmTextGetString (fctparaBoardMin_TextField[Index]);
				FunctionArg->min[Index] = atof (SomeChar);
			}
		}

		if (SomeChar)
		{
			XtFree (SomeChar);							
		}
		if (SomeOtherChar)
		{
			XtFree (SomeOtherChar);				
		}
		return CorrectEventsNb;
	}
}
/*
************************************************************************************
*
*	Function:
*		tms_MinMaxCalcul (FunctionArg)
*	Description:
*		calcul min and max of event selected in  fctpara window and display it
*		It use the action data (in FunctionArg) to find what kind of calcul to use. If their is
*		already a value in the coresponding fields in fctpara window, nothing
*		is done.
*
*	Inputs:
*		pCALCULSARG FunctionArg : Arguments for all calculs functions
*
*	Outputs:
*
*	Revision:
*		june the 1st of 1996
*
*************************************************************************************
*/

int tms_MinMaxCalcul (pCALCULSARG FunctionArg)
{
/*
**	Variables
*/
	int	Index;
	int	WichTurn;
	int	i,j,k;
	int	indice;
	int	compte;
	char	CharToPrint[50];
	float	phase [MAX_DATA];
	float	inter [MAX_DATA];
	float	precedent;
	int	TheTicket[3];	/*** the first cell define the first calcul, the scnd cell ...***/
	int	NbOfData;
	int	nb_cycle;
	float	debut_cycle;
	int	fini;
	float	offset_debut;
	int	i_debut;
	float	temps_reference;
/*
**	Code
*/
	precedent = 0.;
	fini = 0;

	/*** decide wich kind of calcul should be done ***/

	TheTicket[0] = 0;
	TheTicket[1] = 0;
	TheTicket[2] = 0;

	if (FunctionArg->action[0] == 'A')
	{
		/*** decide wich calcul to do the first time ***/

		if (FunctionArg->action[1] == 'E' ||
		    FunctionArg->action[1] == 'F')
		{
			TheTicket[0] = FIRST_MM;
		}
		else if (FunctionArg->action[1] == 'G' ||
		    FunctionArg->action[1] == 'H')
		{
			TheTicket[0] = SCND_MM;
		}
	
		/*** decide wich calcul to do the second time ***/
		
		if (FunctionArg->action[1] == 'F')
		{
			TheTicket[1] = FIRST_MM;
		}
		else if (FunctionArg->action[1] == 'H')
		{
			TheTicket[1] = THURD_MM;
		}
		
	}
	else if (FunctionArg->action[0] == 'B')
	{
		/*** decide wich calcul to do the first time ***/
		
		if (FunctionArg->action[1] == 'A')
		{
			TheTicket[0] = THURD_MM;
		}
		else if (FunctionArg->action[1] == 'B')
		{
			TheTicket[0] = SCND_MM;
		}
	
		/*** decide wich calcul to do the second time ***/
		
	}
#if 0	
	else if (FunctionArg->action[0] == 'C')
	{
		/*** decide wich calcul to do the first time ***/
		
		if (FunctionArg->action[1] == 'A')
		{
			TheTicket[0] = THURD_MM;
		}
		else if (FunctionArg->action[1] == 'B')
		{
			TheTicket[0] = SCND_MM;
		}
	
		/*** decide wich calcul to do the second time ***/
		
	}
#endif
	else if (FunctionArg->action[0] == 'D')
	{
		/*** decide wich calcul to do the first time ***/
		
		if (FunctionArg->action[1] == 'A' ||
		    FunctionArg->action[1] == 'B')
		{
			TheTicket[0] = FORTH_MM;
		}
		else if (FunctionArg->action[1] == 'C')
		{
			TheTicket[0] = FITH_MM;
		}
		else if (FunctionArg->action[1] == 'D')
		{
			TheTicket[0] = SIXTH_MM;
		}
		else if (FunctionArg->action[1] == 'E')
		{
			TheTicket[0] = SEVENTH_MM;
		}

		/*** decide wich calcul to do the second time ***/
		
		if (FunctionArg->action[1] == 'B')
		{
			TheTicket[1] = FORTH_MM;
		}
		else if (FunctionArg->action[1] == 'C')
		{
			TheTicket[1] = FITH_MM;
		}
		
	}
	else if (FunctionArg->action[0] == 'E')
	{
		/*** decide wich calcul to do the first time ***/
		
		if (FunctionArg->action[1] == 'E' ||
		    FunctionArg->action[1] == 'F' ||
		    FunctionArg->action[1] == 'G')
		{
			TheTicket[0] = NINETH_MM;
		}

		/*** decide wich calcul to do the second time ***/

		if (FunctionArg->action[1] == 'E' ||
		    FunctionArg->action[1] == 'F' ||
		    FunctionArg->action[1] == 'G')
		{
			TheTicket[1] = NINETH_MM;
		}
	}
	else if (FunctionArg->action[0] == 'F')
	{
		/*** decide wich calcul to do the first time ***/
		
		if (FunctionArg->action[1] == 'A')
		{
			TheTicket[0] = THURD_MM;
		}
		else if (FunctionArg->action[1] == 'B')
		{
			TheTicket[0] = SCND_MM;
		}
	}
		/*** decide wich calcul to do the second time ***/

	/*** calculs... ***/

	NbOfData = 0;
	for (Index = 0; Index < COMPUTE_DATAS; Index++)
	{
		if (FunctionArg->events[Index] != 0)
		{
			NbOfData++;
		}
	}

	for (WichTurn = 0; WichTurn < NbOfData; WichTurn++)
	{
		switch (TheTicket[WichTurn])
		{
			case FIRST_MM:
			{
				FunctionArg->min[WichTurn] = 1000000.;
				FunctionArg->max[WichTurn] = 0.;
				Index = 0;

				while (temps[Index++] < depart) ;
				while (temps[Index++] < arrivee)
				{
					if (type[Index] == FunctionArg->events[WichTurn] )
					{
						if (inst_interval[Index] > FunctionArg->max[WichTurn])
						{
							FunctionArg->max[WichTurn] = inst_interval[Index];
						}
						if (inst_interval[Index] < FunctionArg->min[WichTurn])
						{
							FunctionArg->min[WichTurn] = inst_interval[Index];
						}
					}
				}
				if (FunctionArg->min[WichTurn] == FunctionArg->max[WichTurn])
				{
					return -1;
				}
				sprintf(CharToPrint, "%f", FunctionArg->min[WichTurn]);
				XmTextSetString (fctparaBoardMin_TextField[WichTurn], CharToPrint);
				sprintf(CharToPrint, "%f", FunctionArg->max[WichTurn]);
				XmTextSetString (fctparaBoardMax_TextField[WichTurn], CharToPrint);
				break;
			}
			case SCND_MM:
			{
				FunctionArg->min[DATA1] = 0.;
				FunctionArg->max[DATA1] = 0.;
				i = 0 ;
				indice = 0;
				while (temps[i++] < depart ) ;
				while (temps[i] < arrivee )
				{
					if (type[i] == FunctionArg->events[DATA1])
					{
						j = k = i  ;
						while ((type[k++] != FunctionArg->events[DATA1]) && (k < nb_donnees)) ;
						while (j++ < k)
						{
							if (type[j] == FunctionArg->events[DATA2])
							{
								phase[indice] = temps[j] - temps[i] ;
								if (phase[indice] > FunctionArg->max[DATA1])
								{
									FunctionArg->max[DATA1] = phase[indice];
								}
								indice++ ;
							}
						}
					}
					i++ ;
				}
				if (FunctionArg->min[DATA1] == FunctionArg->max[DATA1])
				{
					return -1;
				}
				sprintf(CharToPrint, "%f", FunctionArg->min[DATA1]);
				XmTextSetString (fctparaBoardMin_TextField[DATA1], CharToPrint);
				sprintf(CharToPrint, "%f", FunctionArg->max[DATA1]);
				XmTextSetString (fctparaBoardMax_TextField[DATA1], CharToPrint);
				break;				
			}
			case THURD_MM:
			{
				FunctionArg->min[WichTurn] = 0.;
				FunctionArg->max[WichTurn] = 0.;
				i = 0 ;
				indice = 0;
				while (temps[i++] < depart ) ;
				while (type[i++] != FunctionArg->events[WichTurn] ) ;
				precedent = temps[i] ;
				i++;
				while (temps[i] < arrivee )
				{
					if (type[i] == FunctionArg->events[WichTurn])
					{
						inter[indice] = temps[i] - precedent ;
						if (inter[indice] > FunctionArg->max[WichTurn])
						{
							FunctionArg->max[WichTurn] = inter[indice];
						}
						precedent = temps[i] ;
						indice++  ;
					}
					i++ ;
				}
				if (FunctionArg->min[WichTurn] == FunctionArg->max[WichTurn])
				{
					return -1;
				}
				sprintf(CharToPrint, "%f", FunctionArg->min[WichTurn]);
				XmTextSetString (fctparaBoardMin_TextField[WichTurn], CharToPrint);
				sprintf(CharToPrint, "%f", FunctionArg->max[WichTurn]);
				XmTextSetString (fctparaBoardMax_TextField[WichTurn], CharToPrint);
				break;				
			}
			case FORTH_MM:
			{
				FunctionArg->max[WichTurn] = 0.;
				FunctionArg->min[WichTurn] = 10000.;
				i = 0;
				indice = 0;
				compte = 0;
				while (temps[i++] < depart ) ;	
				while (type[i++] != FunctionArg->events[WichTurn] && i < MAX_DATA) ;
				precedent = temps[i] ;
				i++;
				while (temps[i] < arrivee )
				{
					if ( type[i] == FunctionArg->events[WichTurn])
					{
						compte++;
						if (compte == FunctionArg->order)
						{
							compte = 0;	
							inter[indice] = temps[i] - precedent ;
							if ( inter[indice] > FunctionArg->max[WichTurn])
							{
								FunctionArg->max[WichTurn] = inter[indice];
							}
							if ( inter[indice] < FunctionArg->min[WichTurn])
							{
								FunctionArg->min[WichTurn] = inter[indice];
							}
							indice++  ;
						}
						precedent = temps[i] ;			
					}
					i++ ;
				}
				if (FunctionArg->min[WichTurn] == FunctionArg->max[WichTurn])
				{
					return -1;
				}
				sprintf(CharToPrint, "%f", FunctionArg->min[WichTurn]);
				XmTextSetString (fctparaBoardMin_TextField[WichTurn], CharToPrint);
				sprintf(CharToPrint, "%f", FunctionArg->max[WichTurn]);
				XmTextSetString (fctparaBoardMax_TextField[WichTurn], CharToPrint);
				break;
			}
			case FITH_MM:
			{
				/*** first test some value ***/

				if (FunctionArg->duration == 0. || FunctionArg->cycle == 0)
				{
					return -2;
				}

				/*** initialisation ***/

				FunctionArg->max[WichTurn] = 0.;
				FunctionArg->min[WichTurn] = 10000.;
				i = 0 ;
				indice = 0 ;
				compte = 0;
				nb_cycle = 0;
				while (temps[i++] < depart ) ;
				
				/* cherche le 1er cycle et du event1 avant */

				while (type[i++] != FunctionArg->cycle && i < MAX_DATA);
				debut_cycle = temps[i] ;
				i_debut = i;
				while (--i)
				{
					if (type[i] == FunctionArg->events[WichTurn])
					{
						precedent = temps[i];
						break;
					}
				}
				i = i_debut;

				while (temps[i] < arrivee )
				{
					if ( type[i] == FunctionArg->cycle)
					{
						nb_cycle++;
						inter[indice] = -1.0;
						indice++;
						debut_cycle = temps[i];
						fini = FALSE;
					}

					if ( type[i] == FunctionArg->events[WichTurn])
					{
						offset_debut = temps[i] - debut_cycle;
						if (offset_debut < FunctionArg->mapfrom)
						{
							precedent = temps[i] ;			
							compte = 0;
							i++;
							continue;
							}
						if (offset_debut > FunctionArg->mapto)
						{
							if (fini)
							{
								precedent = temps[i] ;			
								compte = 0;
								i++;
								continue;
							}
							else
							{
								fini = TRUE;
							}
						}
						compte++;
						if (compte == FunctionArg->order)
						{
							compte = 0;
							inter[indice] = temps[i] - precedent ;
							if ( inter[indice] > FunctionArg->max[WichTurn])
							{
								FunctionArg->max[WichTurn] = inter[indice];
							}
							if ( inter[indice] < FunctionArg->min[WichTurn])
							{
								FunctionArg->min[WichTurn] = inter[indice];
							}
							indice++  ;
							precedent = temps[i] ;			
						}
					}
					i++ ;
				}
				if (FunctionArg->min[WichTurn] == FunctionArg->max[WichTurn])
				{
					return -1;
				}
				sprintf(CharToPrint, "%f", FunctionArg->min[WichTurn]);
				XmTextSetString (fctparaBoardMin_TextField[WichTurn], CharToPrint);
				sprintf(CharToPrint, "%f", FunctionArg->max[WichTurn]);
				XmTextSetString (fctparaBoardMax_TextField[WichTurn], CharToPrint);
				break;
			}
			case SIXTH_MM:
			{
				FunctionArg->max[DATA1]  = 0. ;
				FunctionArg->min[DATA1] = 0. ;
				i = 0 ;
				k = 0;
				indice = 0;
				while (temps[i++] < depart ) ;
				while (temps[i] < arrivee )
				{
					if ( type[i] == FunctionArg->events[DATA1])
					{
						k = 0;
						temps_reference = temps[i];
						for (j = i+1; j < nb_donnees; j++)
						{
							if ( type[j] == FunctionArg->events[DATA2])
							{
								k++;
								if (k == FunctionArg->order)
								{
									phase[indice] = temps[j] - temps_reference;
									if (phase[indice] > FunctionArg->max[DATA1])
									{
										FunctionArg->max[DATA1] = phase[indice] ;
									}
									indice++;
								}
							}
							if (type[j] == FunctionArg->events[DATA1])
							{
								i = j - 1;	/*
								* on saute tout ce
								* qu'on vient de
								* lire, mais comme i
								* est increment on se
								* met 1 avant
								*/
								break;
							}
						}
					}
					i++;
				}
				if (FunctionArg->min[DATA1] == FunctionArg->max[DATA1])
				{
					return -1;
				}
				sprintf(CharToPrint, "%f", FunctionArg->min[DATA1]);
				XmTextSetString (fctparaBoardMin_TextField[DATA1], CharToPrint);
				sprintf(CharToPrint, "%f", FunctionArg->max[DATA1]);
				XmTextSetString (fctparaBoardMax_TextField[DATA1], CharToPrint);
				break;
			}
			case SEVENTH_MM:
			{
				/*** first test some value ***/

				if (FunctionArg->duration == 0. || FunctionArg->cycle == 0)
				{
					return -2;
				}

				/*** initialisation ***/

				FunctionArg->max[WichTurn] = 0.;
				FunctionArg->min[WichTurn] = 10000.;
				i = 0 ;
				indice = 0 ;
				compte = 0;
				nb_cycle = 0;
				while (temps[i++] < depart ) ;
				
				/* cherche le 1er cycle et du event1 avant */
				
				while (type[i++] != FunctionArg->cycle && i < MAX_DATA);
				debut_cycle = temps[i] ;
				i_debut = i;
				
				while (temps[i] < arrivee )
				{
					if ( type[i] == FunctionArg->cycle)
					{
						nb_cycle++;
						inter[indice] = -1.0;
						indice++;
						debut_cycle = temps[i];
						fini = FALSE;
					}

					if ( type[i] == FunctionArg->events[DATA2])
					{
						offset_debut = temps[i] - debut_cycle;
						if (offset_debut < FunctionArg->mapfrom)
						{
							compte = 0;
							i++;
							continue;
						}
						if (offset_debut > FunctionArg->mapto)
						{
							if (fini)
							{
								compte = 0;
								i++;
								continue;
							}
							else
							{
								fini = TRUE;
							}
						}
						compte = 0;
						precedent = temps[i];
						for (j = i-1; j ; j--)
						{
							if ( type[j] == FunctionArg->events[DATA1])
							{
								compte++;
								if (compte == FunctionArg->order)
								{
									inter[indice] = precedent - temps[j];
									if (inter[indice] < FunctionArg->min[DATA1])
									{
										FunctionArg->min[DATA1] = inter[indice];
									}
									if (inter[indice] > FunctionArg->max[DATA1])
									{
										FunctionArg->max[DATA1] = inter[indice];
									}
									indice++;
									break;
								}
							}
						}
					}
					i++;
				}

				if (FunctionArg->min[DATA1] == FunctionArg->max[DATA1])
				{
					return -1;
				}
				sprintf(CharToPrint, "%f", FunctionArg->min[DATA1]);
				XmTextSetString (fctparaBoardMin_TextField[DATA1], CharToPrint);
				sprintf(CharToPrint, "%f", FunctionArg->max[DATA1]);
				XmTextSetString (fctparaBoardMax_TextField[DATA1], CharToPrint);
				break;				
			}
			case EIGHTTH_MM:
			{
				if (FunctionArg->binwidth == 0.)
				{
					return -2;
				}

				

				if (FunctionArg->min[DATA1] == FunctionArg->max[DATA1])
				{
					return -1;
				}
				sprintf(CharToPrint, "%f", FunctionArg->min[DATA1]);
				XmTextSetString (fctparaBoardMin_TextField[DATA1], CharToPrint);
				sprintf(CharToPrint, "%f", FunctionArg->max[DATA1]);
				XmTextSetString (fctparaBoardMax_TextField[DATA1], CharToPrint);
				break;				
			}
			case NINETH_MM:
			{				
				i = 0;
				FunctionArg->max[WichTurn] = 0.;
				FunctionArg->min[WichTurn] = 1000000000.;
				while (temps[i++] < depart) ;
				while (temps[i++] < arrivee)
				{
					if (type[i] == FunctionArg->events[WichTurn] )
					{
						/* max test */
						if (FunctionArg->action[1] == 'E')
						{
							if (inst_interval[i] > FunctionArg->max[WichTurn])
							{
								FunctionArg->max[WichTurn] = inst_interval[i] ;
							}
						}
						else if (FunctionArg->action[1] == 'F')
						{
							if (inst_rate[i] > FunctionArg->max[WichTurn])
							{
								FunctionArg->max[WichTurn] = inst_rate[i] ;								
							}
						}
						else if (FunctionArg->action[1] == 'G')
						{
							if (phase_interval[i] > FunctionArg->max[WichTurn])
							{
								FunctionArg->max[WichTurn] = phase_interval[i] ;
							}
						}
						/* min test */
						if (FunctionArg->action[1] == 'E')
						{
							if (inst_interval[i] < FunctionArg->min[WichTurn])
							{
								FunctionArg->min[WichTurn] = inst_interval[i] ;
							}
						}
						else if (FunctionArg->action[1] == 'F')
						{
							if (inst_rate[i] < FunctionArg->min[WichTurn])
							{
								FunctionArg->min[WichTurn] = inst_rate[i] ;	
							}
						}
						else if (FunctionArg->action[1] == 'G')
						{
							if (phase_interval[i] < FunctionArg->min[WichTurn])
							{
								FunctionArg->min[WichTurn] = phase_interval[i] ;
							}
						}
					}
				}

				if (FunctionArg->min[WichTurn] == FunctionArg->max[WichTurn])
				{
					return -1;
				}
				sprintf(CharToPrint, "%f", FunctionArg->min[WichTurn]);
				XmTextSetString (fctparaBoardMin_TextField[WichTurn], CharToPrint);
				sprintf(CharToPrint, "%f", FunctionArg->max[WichTurn]);
				XmTextSetString (fctparaBoardMax_TextField[WichTurn], CharToPrint);
				break;				
			}
			default:
			{
				break;
			}
		}
	}
	return WichTurn;
}

/*
**************************************************************
*
*	Function:
*		tms_RegisterTMSFileCB (widget, client_data, call_data)
*	Description:
*		Register the file name and open the working file
*		Also create the Postscript file name
*	Inputs:
*		Widget		widget		:	the activating widget.
*		XtPointer	client_data	:	The selection of the FilsSelectionBox (the filename...)
*		XtPointer	call_data	:	the call data (unused).
*
*	Revision:
*		April the 26 of 1996
*		May the 2nd of 1996	:	End of design
*
****************************************************************
*/

void tms_RegisterTMSFileCB (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/

XmFileSelectionBoxCallbackStruct *CallStruct;
char				 *TmpFileName,
				 AMessage [FILENAME_SIZE + 20]; /* Message to display in the MessageDialog */
XmString			 CurrentPSName,
				 CurrentPSExtension;
int				 FileNameSize;
char				 *SomeChar;
/*
**	Code
*/
	TmpFileName = NULL;
	/* Initialisation */

	CallStruct = (XmFileSelectionBoxCallbackStruct *) call_data;
	AMessage[0] = '\0';

	/* Get the file name selected */

	if (!XmStringGetLtoR (CallStruct->value,
			     XmFONTLIST_DEFAULT_TAG,
			     &TmpFileName))
	{
		DispMessageDialog (widget,
				   "Unable to get the file name",
				  "Error : file not opened",
				  XmDIALOG_ERROR);
		return;
	}

	/* Test the file name */

	if (!TmpFileName[0])
	{
		DispMessageDialog (widget,
				   "Empty value for file name",
				   "Error : file not opened",
				   XmDIALOG_ERROR);

		return;
	}
	else
	{
		/* Create filename without path */

		/* Open the file */
		
		FileNameSize = strlen (TmpFileName);		
		strcpy (filename,TmpFileName);
/*
		printf("Filename: %s\n",filename);
*/
		if((data = fopen(TmpFileName,"r")) == NULL)
		{
			strcpy (AMessage, "impossible to open file ");
			strcat (AMessage, filename);
			DispMessageDialog (widget,
					   AMessage,
					   "Error : file not opened",
					   XmDIALOG_ERROR);
			return;
		}
		else

		/* File opened, ask for the postcript file name... */

		{

			/* Create postcript file name and generic name */

			strcpy (scriptname, filename);
			SomeChar = strrchr (scriptname, '.');
			*SomeChar = '\0';
			strcpy (file,scriptname);
			strcat (scriptname, PRINTED_EXT );

			fclose (data); /* File will be opened again in ParametersApplyCB callback...*/

/*
			XtUnmanageChild(widget);
*/

			/* modify the FileSelectionBox for the next call : the postcriptname */

                        CurrentPSName = XmStringCreateLocalized (scriptname);
                        CurrentPSExtension = XmStringCreate ("*.ps*",XmSTRING_DEFAULT_CHARSET);
			XtVaSetValues (widget,
                                       XmNpattern, CurrentPSExtension,
                                       XmNtextString, CurrentPSName,
				       NULL);

			XtRemoveCallback (widget, XmNokCallback,
					 tms_RegisterTMSFileCB, NULL);
                        XtAddCallback(widget, XmNokCallback, BxSetSensitiveCB,
                                      (XtPointer) "mainClose_PushButton, mainSavePS_PushButton, \n\
					mainPrint_PushButton, mainOperations_CascadeButton, \n\
					mainOptions_CascadeButton");
                        XtAddCallback(widget, XmNokCallback, BxSetInsensitiveCB,
                                      (XtPointer) 
"mainOpA_CascadeButton, \
mainOpB_CascadeButton, \
mainOpC_CascadeButton, \
mainOpD_CascadeButton, \
mainOpE_CascadeButton, \
mainOpF_CascadeButton, \
mainOpG_CascadeButton");

			XtAddCallback (widget, XmNokCallback,
				      tms_RegisterTMSScriptFileCB, NULL);
/*
			XtAddCallback (widget, XmNcancelCallback,
				      tms_RegisterCancelCB, NULL);
*/
			XtManageChild(widget);
		}
	}
	XmStringFree (CurrentPSName);
	XmStringFree (CurrentPSExtension);
	if (TmpFileName)
	{
		XtFree (TmpFileName);
	}
}


/*
**************************************************************
*
*	Function:
*		tms_RegisterCancelCB (widget, client_data, call_data)
*	Description:
*		change the FileSelectionBox's callbacks
*
*	Inputs:
*		Widget		widget:		the activating widget.
*		XtPointer	client_data:	the client_data (unused)
*		XtPointer	call_data:	the call data (unused).
*
*	Revision:
*		April the 26 of 1996
*		May the 2nd of 1996	:	End of design
*
****************************************************************
*/
void tms_RegisterCancelCB (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/
	XmString	CurrentFileName;
	XmString	CurrentFileExt;
/*
**	Code
*/
	/*** prepare the FileSelectionBox ***/

	CurrentFileName = XmStringCreateLocalized (filename);
	CurrentFileExt = XmStringCreate ("*.tms",XmSTRING_DEFAULT_CHARSET);
	XtVaSetValues (widget,
		       XmNpattern, "",
		       XmNtextString, "", NULL, NULL);
	XtVaSetValues (widget,
		       XmNpattern, CurrentFileExt,
                       XmNtextString, CurrentFileName, NULL, NULL);

	/*** replace FileSelectionBox's callbacks ***/

	XtRemoveAllCallbacks (widget, XmNokCallback);
	XtAddCallback (widget, XmNokCallback,
		       tms_RegisterTMSFileCB, NULL);
/*
	XtRemoveCallback(widget, XmNokCallback, BxSetSensitiveCB,
			 (XtPointer) "mainClose_PushButton, mainSavePS_PushButton,\n\
			mainPrint_PushButton, mainPrintOn_PushButton, mainOperations_CascadeButton, mainOptions_CascadeButton");
	XtRemoveCallback (widget, XmNokCallback,
			  tms_RegisterTMSScriptFileCB, NULL);
	XtRemoveCallback (widget, XmNcancelCallback,
			  tms_RegisterCancelCB, NULL);
*/
	XtManageChild(widget);
}
/*
**************************************************************
*
*	Function:
*		tms_RegisterTMSScriptFileCB (widget, client_data, call_data)
*	Description:
*		Register the postcript file name from the FileSelectionBox
*
*	Inputs:
*		Widget		widget:		the activating widget.
*		XtPointer	client_data:	the selection of the FileSelectionBox (the postscript file name)
*		XtPointer	call_data:	the call data (unused).
*
*       Modified global variables:
*		char*		scriptname
*
*	Revision:
*		April the 26 of 1996
*		May the 2nd of 1996	:	End of design
*
****************************************************************
*/
void tms_RegisterTMSScriptFileCB (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/

	XmFileSelectionBoxCallbackStruct *CallStruct;
	char				 *TmpScriptName;
	XmString			 CurrentFileName;
	XmString			 CurrentFileExt;

/*
**	Code
*/
	/* Initialisation */

	CallStruct = NULL;
	TmpScriptName = NULL;

	CallStruct = (XmFileSelectionBoxCallbackStruct *) call_data;

	/* Get the postscript file name from the FileSelectionBox */

	if (!XmStringGetLtoR (CallStruct->value,
			     XmFONTLIST_DEFAULT_TAG,
			     &TmpScriptName))
	{
		DispMessageDialog (widget,
				   "Unable to get the Postscript file name",
				  "Error : filename not found",
				  XmDIALOG_ERROR);
		return;
	}
/*
	printf("TmpScriptName: %s\n", TmpScriptName);
*/
	if (*(strrchr(TmpScriptName,'/')+sizeof(char)))
		strcpy(scriptname, TmpScriptName);
/*
	printf("scriptname: %s\n", scriptname);
*/
/*	XtPopdown (XtParent(widget)); */

	XtPopdown (fileSelection_TopLevelShell);
	BxPopupCB(widget,(XtPointer)"parameters_TopLevelShell",NULL);
	tms_OpenParametersCB(widget,NULL,NULL);

	/*** prepare the FileSelectionBox for next call ***/

	CurrentFileName = XmStringCreateLocalized (filename);
	CurrentFileExt = XmStringCreate ("*.tms",XmSTRING_DEFAULT_CHARSET);

	XtVaSetValues (widget,
		       XmNpattern, CurrentFileExt,
                       XmNtextString, CurrentFileName,
		       NULL);

	/*** replace FileSelectionBox callbacks ***/

	XtRemoveAllCallbacks (widget, XmNokCallback);
	XtAddCallback (widget, XmNokCallback,
		      tms_RegisterTMSFileCB, NULL);

	XmStringFree (CurrentFileName);
	XmStringFree (CurrentFileExt);
#ifndef linux
	if (CallStruct)
	{
		XtFree (CallStruct);
	}
#endif
	if (TmpScriptName)
	{
		XtFree (TmpScriptName);		
	}

}

/*
**************************************************************
*
*	Function:
*		tms_OpenParametersCB (widget, client_data, call_data)
*	Description:
*		Open the Parameters Winodw and file the textfield with filename and Postscript file name
*
*	Inputs:
*		Widget		widget:		the activating widget.
*		XtPointer	client_data:	the client data, not used
*		XtPointer	call_data:	the call data, not used
*
*	Revision:
*		May the 2nd of 1996
*		May the 10th of 1996 end of design
****************************************************************
*/
void tms_OpenParametersCB (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/
	char  TmpFileName[FILENAME_SIZE];
	char  TmpScriptName[FILENAME_SIZE];
	short Index;
/*
**	Code
*/
	/* Initialisation */

	if (strrchr(filename,'/'))
	  strcpy(TmpFileName, (strrchr(filename,'/') + sizeof(char)) );     /* + size(char) to get the name without '/' */
	else
	  strcpy(TmpFileName,filename);
	if (strrchr(scriptname,'/'))
	  strcpy(TmpScriptName, (strrchr(scriptname,'/') + sizeof(char)) );
	else
	  strcpy(TmpScriptName,scriptname); 


	XtVaSetValues (paraProcessedFile_TextField,
		       XmNvalue, TmpFileName,
		       NULL);
	XtVaSetValues (paraPostscriptFile_TextField,
		       XmNvalue, TmpScriptName,
		       NULL);
	for (Index = 0; Index < MAX_EVENT; Index++)
	{
		sprintf(buffer,"%d",Index+1);
		XtVaSetValues (eventNb_TextField[Index],
			       XmNvalue, buffer,
			       NULL);
		XtVaSetValues (eventRate_TextField[Index],
			       XmNvalue, "",
			       NULL);
		XtVaSetValues (eventUnit_TextField[Index],
			       XmNvalue, "",
			       NULL);
		XtVaSetValues (eventName_TextField[Index],
			       XmNvalue, "",
			       NULL);
		XtVaSetValues (eventInterval_TextField[Index],
			       XmNvalue, "",
			       NULL);		
	}
	XtSetSensitive( parametersOK_PushButton,False);
	XtManageChild ( paraProcessedFile_TextField );
	XtManageChild ( paraPostscriptFile_TextField );
	XtManageChild ( XtParent( paraPostscriptFile_TextField ) );
}
/*
**************************************************************
*
*	Function:
*		tms_ParametersOKCB (widget, client_data, call_data)
*	Description:
*		Register the event's nb and compute it's caracteristics from the Parameters Window
*	Inputs:
*		Widget		widget:		the activating widget.
*		XtPointer	client_data:	the client data, unused
*		XtPointer	call_data:	the call data, unused
*
*	Revision:
*		april the 26th of 1996
*		may the 20th of 1996 end of design
*
****************************************************************
*/

void tms_ParametersOKCB (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/

	Widget  TheParent;

	float	SomeFloat;
	float	temps_ms;
	float	sum_nb = 0.;

	int	PostIndex;
	int	PreIndex;

	/*** divers ***/

	int	i,j;
	int	type_int;

	short	Index, Index2;

	char    *EventTyped;
	char	AMessage[256];
	char	*EventName;
	char	*SomeChar;
	char	SprintfChar[20];
	char	ClientButton;

	Boolean *CorrectEvents;
	Boolean	valid_data;
		
	
/*
**	Code
*/
	EventTyped = NULL;
	SomeChar = NULL;
	TheParent = (Widget) client_data;
	EventTyped = NULL;
	EventName = NULL;
	valid_data = True;


	/*** empty some TextFields and initialise some global variables***/

	nb_de_types = 0;
	nb_donnees = 0;

	/*** get the events selected ***/

	if((data = fopen(filename,"r")) == NULL)
	{
/*
		printf ("RegisterTMSFileCB : Impossible to open file...\n");
*/
		strcpy (AMessage, "Impossible to open file ");
		strcat (AMessage, filename);
		DispMessageDialog (widget,
				   AMessage,
				   "Error : file not opened",
				   XmDIALOG_ERROR);
		/* XtPopdown (XtParent(widget)); */
		XtPopdown (fileSelection_TopLevelShell);
		return;
	}

	/*** Get the events references ***/

	for (j = 0; j < MAX_EVENT; j++)
	{
		EventTyped = (char *) XmTextGetString (eventNb_TextField[j]);
		if (strcmp(EventTyped,""))
		{
			if (strcmp(EventTyped,"#NF#"))
			{
				if (j > nb_de_types)
				{
					XtVaSetValues (eventNb_TextField[j],
						       XmNvalue, "",
						       NULL);
					XtVaSetValues (eventName_TextField[j],
						       XmNvalue, "",
						       NULL);
					XtVaSetValues (eventUnit_TextField[j],
						       XmNvalue, "",
						       NULL);
					XtVaSetValues (eventRate_TextField[j],
						       XmNvalue, "",
						       NULL);
					XtVaSetValues (eventInterval_TextField[j],
						       XmNvalue, "",
						       NULL);			
					XtVaSetValues (eventNb_TextField[nb_de_types],
						       XmNvalue, EventTyped,
						       NULL);					
				}
				sscanf (EventTyped, "%d",&les_types[nb_de_types]);
				nb_de_types++;
			}
		}
		if (EventTyped)
		{
			XtFree (EventTyped);								
		}
	}

	CorrectEvents = (Boolean *) calloc (nb_de_types, sizeof (Boolean));
	for (j = 0; j < nb_de_types; j++)
	{
		CorrectEvents[j] = False;
	}

	/*

	DispPopupDialog (widget,
			 "Reading input data...",
			 "Please wait." );
	 */
	XDefineCursor(XtDisplay(TheAppShell), XtWindow(XtParent(widget)), wait_cursor);
	
	j = 0;
	temps [j] = 0.;

	while( !feof(data))
	{
		fscanf(data,"%f %d\n",&temps_ms,&type_int);
/*
		if (verbose)
			printf("%f %d\n",temps_ms,type_int);
*/
		for ( i = 0; i < nb_de_types; i++)
		{
			if (type_int == les_types[i])
			{
				temps[j] = temps_ms/1000.;
				type[j] = type_int;
				j++ ;
				CorrectEvents[i] = True;
				break;
			}
		}
		if ( j >= MAX_DATA)
		{
			sprintf (AMessage, "You can only analyze %d events, split into several analyses", MAX_DATA);
			DispMessageDialog (widget,
					   AMessage,
					   "Warning",
					   XmDIALOG_INFORMATION	);
			break;
		} 
	}
	fclose(data) ;
	nb_donnees = j ;

	/*
	XtPopdown (XtParent(ThePopupBox));
	*/

	XUndefineCursor(XtDisplay(TheAppShell), XtWindow(XtParent(widget)));

	if (!nb_donnees)
	{
		/* message dialog... */
		DispMessageDialog (widget,
				   "Sorry, no matching data were found",
				   "Can't find datas",
				   XmDIALOG_INFORMATION	);
		return;
	}

	/*** Correspondance by default ***/

#if 0

	DispPopupDialog (widget,
			 "compiling for datas caracterictics...",
			 "Please wait." );
#endif

#if DEBUG_STIM
	printf("Fichier lu\n");
#endif

	PostIndex = 0;
	PreIndex = 1;
	for (i = 0; i < nb_de_types; i++)
	{
		event[i].numero = les_types[i];
		EventName = (char *) XmTextGetString (eventName_TextField[i]);
		if (event[i].numero > 0)              /* event normal */
		{
			if ( !strcmp (EventName,""))
			{
			        sprintf(event[i].nom,"Unit %d",event[i].numero);
				XtVaSetValues (eventName_TextField[i],
					       XmNvalue, event[i].nom,
					       NULL);
			}
			if (i == PostIndex && CorrectEvents[i])
			{
				post_synaptic = event[i].numero;				
			}
			else
			{ 
			    if (i == PostIndex && !CorrectEvents[i])
			    {
				PostIndex++;
				PreIndex++;
			    }
			    if (i == PreIndex && CorrectEvents[i])
			    {
				pre_synaptic = event[i].numero;				
			    }
			    else
			    { 
			        if (i == PreIndex && !CorrectEvents[i])
				{
				  PreIndex++;
				}
			    }
			}
		}
		else
		{ 
		        if (event[i].numero < 0)       /* stimulus */
			{
			  if ( !strcmp (EventName,""))
			  {
				XtVaSetValues (eventName_TextField[i],
					       XmNvalue, "Stimulation",
					       NULL);
			  }
			  cycle_marker = event[i].numero;
			}
		}
		if (EventName)
		{
			XtFree (EventName);	
		}
	}
#if DEBUG_STIM
	printf("Evenements classes\n");
#endif

	/*** Find events caracteristics ***/

	for (i = 0; i < nb_de_types; i++)
	{
		nb_events = compute_rate(les_types[i]);
		
		event[i].nombre = nb_events;
		if (nb_events == 0)
		{

			/*** Event not found ***/

			XtVaSetValues (eventNb_TextField[i],
				       XmNvalue, "#NF#",
				       NULL);
			XtVaSetValues (eventName_TextField[i],
				       XmNvalue, "",
				       NULL);
			XtVaSetValues (eventUnit_TextField[i],
				       XmNvalue, "",
				       NULL);
			XtVaSetValues (eventRate_TextField[i],
				       XmNvalue, "",
				       NULL);
			XtVaSetValues (eventInterval_TextField[i],
				       XmNvalue, "",
				       NULL);
			continue;
		}

		compute_interval(les_types[i]);

		if (i < MAX_EVENT)
		{
			sum_rate = sum_inter = sum_nb = 0.;
			for (j = 0; j < nb_donnees; j++)
			{
				if (type[j] == event[i].numero)
				{
					sum_rate += inst_rate[j] ;
					sum_inter += inst_interval[j];
					sum_nb += 1.;
				}
			}

			sprintf(SprintfChar, "%d", event[i].nombre);
			XtVaSetValues (eventUnit_TextField[i],
				       XmNvalue, SprintfChar,
				       NULL);
			if (sum_nb > 0.)
			{
			  SomeFloat = sum_rate / sum_nb;
			  sprintf(SprintfChar, "%.3f", SomeFloat);
			}
			else
			{
				strcpy(SprintfChar,"1 event");
			}
			XtVaSetValues (eventRate_TextField[i],
				       XmNvalue, SprintfChar,
				       NULL);
			if (sum_nb > 0.)
			{
			  SomeFloat = sum_inter / sum_nb;
			  sprintf(SprintfChar, "%.3f", SomeFloat);
			}
			else
			{
				strcpy(SprintfChar," only");
				/* message dialog... */
				DispMessageDialog (widget,
						   "Only one data, choose another event",
						   "Non valid event",
						   XmDIALOG_INFORMATION);
				valid_data = False;
			}
			XtVaSetValues (eventInterval_TextField[i],
				       XmNvalue, SprintfChar,
				       NULL);
		}
	}
	
	SomeChar = (char *) XmTextGetString (paraStartAna_TextField);
	if (!strcmp(SomeChar, ""))
	{
		depart = temps[0];
		sprintf(SprintfChar, "%.5f", depart);
		XtVaSetValues (paraStartAna_TextField,
			       XmNvalue, SprintfChar,
			       NULL);
	}
	else
	{
		depart = atof (SomeChar);
	}
	if (SomeChar)
	{
		XtFree (SomeChar);			
	}

	SomeChar = (char *) XmTextGetString (paraStopAna_TextField);
	if (!strcmp(SomeChar, ""))
	{
		arrivee = temps[nb_donnees - 1];
		sprintf(SprintfChar, "%.5f", arrivee);
		XtVaSetValues (paraStopAna_TextField,
			       XmNvalue, SprintfChar,
			       NULL);
	}
	else
	{
		arrivee = atof (SomeChar);
	}
	if (SomeChar)
	{
		XtFree (SomeChar);			
	}
	temps_max = temps[nb_donnees - 1] ;

	if (arrivee > temps_max) arrivee = temps_max ;
	if (depart < temps[0]) depart=temps[0] ;


	sprintf(SprintfChar, "%.5f", depart);
	XtVaSetValues (paraStartAna_TextField,
		       XmNvalue, SprintfChar,
		       NULL);

	sprintf(SprintfChar, "%.5f", arrivee);
	XtVaSetValues (paraStopAna_TextField,
		       XmNvalue, SprintfChar,
		       NULL);

	sprintf(SprintfChar, "%.5f", arrivee - depart);
	XtVaSetValues (paraDurationAna_TextField,
		       XmNvalue, SprintfChar,
		       NULL);
#if 0
	XtPopdown (XtParent(ThePopupBox));
#endif

	Index = 0;
	for (i = 0; i < nb_de_types; i++)
	{
		if (CorrectEvents[i])
		{
			Index++;
		}
	}
	free((char *)CorrectEvents);

#if DEBUG_STIM
	printf("Avant de sortir\n");
#endif

	ClientButton = (char) client_data;
	if (ClientButton == 'O')
	{
/*	
		printf("Bouton O (Index = %d)\n", Index);
*/
		if (Index == 0)
		{
			DispMessageDialog (widget,
					   "You didn't choose any data.\nPress Cancel or choose some data",
					   "No data",
					   XmDIALOG_INFORMATION	);
			return;
		}
		else
		{
			/*** Prepare the Filter Window and the variables it changes. So if the user doesn't  ***
			***	use the Filter Window, variables are set to default now.                     ***/

			for (Index = 0; Index < MAX_EVENT; Index++)
			{			
				Index2 = Index;
				XtVaGetValues (eventNb_TextField[Index],
					       XmNvalue, &SomeChar,
					       NULL);
				if (strcmp(SomeChar,"#NF#"))
				{
					XtVaSetValues (filterEventNb_TextField[Index],
						       XmNvalue, SomeChar,
						       NULL);						
				}
				else
				{
					XtVaSetValues (filterEventNb_TextField[Index],
						       XmNvalue, "",
						       NULL);						
				}
				XtVaSetValues (filterEventNbData_TextField[Index],
					       XmNvalue, "",
					       NULL);
				XtVaSetValues (filterMax_TextField[Index],
					       XmNvalue, "",
					       NULL);
				XtVaSetValues (filterMin_TextField[Index],
					       XmNvalue, "",
					       NULL);
				XtVaSetValues (filterNbDataAf_TextField[Index],
					       XmNvalue, "",
					       NULL);
				XtVaSetValues (filterNbDataBe_TextField[Index],
					       XmNvalue, "",
					       NULL);
				XmToggleButtonSetState(filterSelect_ToggleButton[Index], False, False);
				filtre = False;
			}

			/*** Prepare the Axis Window and the variables it changes. So if the user doesn't  ***
			***	use the Axis Window, variables are set to default now.                     ***/
			
			long_X_axis = LONG_X;
			long_Y_axis = LONG_Y;
			sprintf (SprintfChar, "%.3f", long_X_axis);
			XtVaSetValues (axisXLenght_TextField,
				       XmNvalue, SprintfChar,
				       NULL);
			sprintf (SprintfChar, "%.3f", long_Y_axis);
			XtVaSetValues (axisYLenght_TextField,
				       XmNvalue, SprintfChar,
				       NULL);
			/** set some default values **/

			user_post_synaptic = event[0].numero;
			user_pre_synaptic = event[1].numero;
			user_cycle_marker = event[3].numero;
			user_duration_PST = user_duration = (arrivee - depart)/100.;
			user_binwidth = user_binwidth_PST =  user_duration/50.;

			Logo_XTMS();

			/*** Close Parameters window... ***/
			/* XtPopdown ( XtParent ( XtParent( widget ) ) );*/
			XtPopdown (parameters_TopLevelShell);
		}
	}
	else
	{
		if (valid_data)
			XtSetSensitive( parametersOK_PushButton,True);
/*
		XtVaSetValues (parametersOK_PushButton, XmNshowAsDefault,True,
				       NULL);
*/		
	} /* fin du else */

}

/*
************************************************************************************
*
*	Function:
*		tms_fctparaComputeCB (widget, client_data, call_data)
*	Description:
*
*
*	Inputs:
*		Widget		widget:		the activating widget.
*		XtPointer	client_data:	The arguments of calculs funtions (type : pCALCULSARG)
*		XtPointer	call_data:	the call data, unused
*
*	Revision:
*		may the 20th of 1996
*		june the 10th of 1996 end of design
*
*************************************************************************************
*/

void tms_fctparaComputeCB (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/
	pCALCULSARG	FunctionArg;
	int		TheStatus;
/*
**	Code
*/
	FunctionArg = (pCALCULSARG) client_data;
	
	/*** Verify that datas are present and that it have been selected in Window parameters ***/

	TheStatus = tms_VerifyForCompute (FunctionArg);

	if (TheStatus > 0)
	{
		if (FirstUse)
		{
			Page_de_garde();
			FirstUse = False;
		}
		(*FunctionArg->function)(FunctionArg);
		/*** Close Computation window... ***/
		/* XtPopdown ( XtParent ( XtParent( widget ) ) ); */
		XtPopdown ( fctpara_TopLevelShell);
/*
		XRaiseWindow(XtDisplay(main_TopLevelShell),XtWindow(main_TopLevelShell));
*/
	}
	else if (TheStatus == 0)
	{
/*
		printf("Status = -0 (You didn't select any event for computations)\n");
*/
		DispMessageDialog (widget,
				   "You didn't select any event for computations.\n\
				   Or the event(s) you selected is not available.\n\
				   Please chose an event",
				   "Warning",
				   XmDIALOG_INFORMATION);
	}
	else if (TheStatus == -1)
	{
/*
		printf("Status = -1 (Max = Min)\n");
*/
		DispMessageDialog (widget,
				   "Max = Min, no drawing possible.",
				   "Warning",
				   XmDIALOG_ERROR);
	}
	else if (TheStatus == -2)
	{
/*
		printf("Status = -2 (Some parameters don't have a good value.)\n");
*/
		DispMessageDialog (widget,
				   "Some parameters don't have a good value.\n Please change your selection",
				   "Warning",
				   XmDIALOG_ERROR);
	}
}


/*
************************************************************************************
*
*	Function:
*		tms_fctparaApplyCB (widget, client_data, call_data)
*	Description:
*		Verify the events selected in fctpara window and execute the calcul funtion
*
*	Inputs:
*		Widget		widget:		the activating widget.
*		XtPointer	client_data:	the arguments of calcul functions (type : pCALCULSARG)
*		XtPointer	call_data:	the call data, unused
*
*	Revision:
*		june the 1st of 1996
*
*************************************************************************************
*/

void tms_fctparaApplyCB (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/
	pCALCULSARG	FunctionArg;
	int		TheStatus;
/*
**	Code
*/
	FunctionArg = (pCALCULSARG) client_data;

	/*** Verify that datas are present and that its have been selected in Window parameters ***/

	TheStatus = tms_VerifyForCompute (FunctionArg);

	if (TheStatus == 0)
	{
		DispMessageDialog (widget,
				   "You didn't select any event for computations.\n\
				   Or the event(s) you selected is not available.\n\
				   Please chose an event",
				   "Warning",
				   XmDIALOG_INFORMATION);
	}
	else if (TheStatus == -1)
	{
		DispMessageDialog (widget,
				   "Max = Min, no drawing possible.",
				   "Warning",
				   XmDIALOG_ERROR);
	}
	else if (TheStatus == -2)
	{
		DispMessageDialog (widget,
				   "Some parameters don't have a good value.\n Please change your selection",
				   "Warning",
				   XmDIALOG_ERROR);
	}
}
/*
************************************************************************************
*
*	Function:
*		tms_fctparaDismissCB (widget, client_data, call_data)
*	Description:
*		undisplay the fctpara window and set default caracteristics for some fctpara window widgets
*
*	Inputs:
*		Widget		widget:		the activating widget.
*		XtPointer	client_data:	the client data, unused
*		XtPointer	call_data:	the call data, unused
*
*	Revision:
*		june the 1st of 1996
*
*************************************************************************************
*/

void tms_fctparaDismissCB (Widget widget, XtPointer client_data, XtPointer call_data)
{
/*
**	Variables
*/
	XmString SomeString;
	char	 SomeChar[250];
/*
**	Code
*/
/*	XtPopdown ( XtParent(XtParent(widget)));*/

	XtPopdown ( fctpara_TopLevelShell);

	/*** remove callbacks of all parameters window exepted fctpara window ***/

	XtRemoveAllCallbacks (fctparaCompute_PushButton, XmNactivateCallback);
	XtRemoveAllCallbacks (fctparaApply_PushButton, XmNactivateCallback);
	XtRemoveAllCallbacks (histogramOK_PushButton, XmNactivateCallback);
	XtRemoveAllCallbacks (poincareOK_PushButton, XmNactivateCallback);
	XtRemoveAllCallbacks (poincareAxisSize_ToggleButton, XmNvalueChangedCallback);
	XtRemoveAllCallbacks (arrowsOK_PushButton, XmNactivateCallback);
	XtRemoveAllCallbacks (threeDOK_PushButton, XmNactivateCallback);

	/*** change default value ***/

	sprintf (SomeChar, "(%.1f X %.1f cm)", long_X_axis, long_Y_axis);
	SomeString = XmStringCreateLocalized (SomeChar);
	XtVaSetValues (poincareModified_Label[2],
		       XmNlabelString, SomeString,
		       NULL);
	XtVaSetValues (poincareAxisSize_ToggleButton,
		       XmNset, True,
		       NULL);
	XmStringFree (SomeString);
}
/*
************************************************************************************
*
*	Function:
*		tms_FctparaSetSensitive (*SensitifList[])
*	Description:
*		set sensitif or unsensitif the fctpara window's widgets refering to
*		a boolean list.
*
*	Inputs:
*		Boolean	SensitifList	:	list of sensitve state for window's widget that need so
*	Revision:
*		june the 5th of 1996
*
*************************************************************************************
*/

void tms_fctparaSetSensitive (Boolean *SensitifList)
{
/*
**	Variables
*/
	int	Index;
/*
**	Code
*/
	for (Index = 0; Index < COMPUTE_DATAS; Index++)
	{
		XtVaSetValues (fctparaBoardNb_TextField[Index],
			       XmNsensitive, SensitifList[Index],
			       NULL);		
		XtVaSetValues (fctparaBoardMin_TextField[Index],
			       XmNsensitive, SensitifList[Index],
			       NULL);		
		XtVaSetValues (fctparaBoardMax_TextField[Index],
			       XmNsensitive, SensitifList[Index],
			       NULL);		
	}
	Index = COMPUTE_DATAS;
	XtVaSetValues (fctparaOrder_TextField,
		       XmNsensitive, SensitifList[Index],
		       NULL);
	XtVaSetValues (fctparaModified_Label[Index - 3],
		       XmNsensitive, SensitifList[Index],
		       NULL);
	Index++;
	XtVaSetValues (fctparaCycle_TextField,
		       XmNsensitive, SensitifList[Index],
		       NULL);
	XtVaSetValues (fctparaModified_Label[Index - 3],
		       XmNsensitive, SensitifList[Index],
		       NULL);
	Index++;
	XtVaSetValues (fctparaBin_TextField,
		       XmNsensitive, SensitifList[Index],
		       NULL);
	XtVaSetValues (fctparaModified_Label[Index - 3],
		       XmNsensitive, SensitifList[Index],
		       NULL);
	Index++;
	XtVaSetValues (fctparaDuration_TextField,
		       XmNsensitive, SensitifList[Index],
		       NULL);
       	XtVaSetValues (fctparaModified_Label[Index - 3],
		       XmNsensitive, SensitifList[Index],
		       NULL);
}




