/*
** Include file for tms_unix.c and tms_calculs.c
*/

#ifdef _TMS_CALLBACK
#	define _TMS_CB_CLASS
#else
#	define _TMS_CB_CLASS extern
#endif

#ifdef _TMS_MAIN
#	define _TMS_CLASS
#else
#	define _TMS_CLASS extern
#endif

#include  <plot_xps.h>
#undef VMS

/************************ VARIABLES GLOBALES TMS ****************/

#define VERSION "XTMS v6.14"

_TMS_CLASS FILE *data ;

#define MAX_DATA	50000
#define MAX_EVENT	5

#define EVENT_1	("Post-synaptic")
#define EVENT_2	("Pre-synaptic")
#define EVENT_4	("Cycle marker")

#define LONG_X	13.
#define LONG_Y	6.

   /***********
   * Fichiers *
   ***********/

#define         POSTCRIPT_EXT ".ps"
#define		FILENAME_SIZE 250

   /*********************
   * variables globales *
   *********************/

typedef void (*ACTIONFCT_TYPE)();

_TMS_CLASS char	filename[FILENAME_SIZE],	/* nom du fichier a lire               */
		filepathname[FILENAME_SIZE],
		file[FILENAME_SIZE],		/* nom generique			*/
		scriptname[FILENAME_SIZE],
		scriptpathname[FILENAME_SIZE],  /* nom du fichier postscript en sortie */
		driver,				/* s,f ou d: parametre de postscript   */
		vient_de_nbc,			/* flags */
		already_printed,
		use_defaults,
		filtre,
		inside,
		rep,
		buffer[250],
		legend_x[80],
		legend_y[80],
		ordre[60];
	
_TMS_CLASS struct evenement
		{
			float	max_interval_clip;
			float	min_interval_clip;	/* bornes pour le filtrage */
			int	numero;
			int	nombre;
			char	filtre;
			char	inside;			/* flag for filter*/
			char	nom[30];
		} event[MAX_EVENT]; 

_TMS_CLASS int	nb_donnees ,		/* nombre de donnees */
		nb_options ,		/* nombre d'options d'analyse  */
		nb_demi_pages ,		/* nombre de demi-pages imprimees */
		pic[100] ,		/* date des pics frequentiels */
		filtered_event,		/* evenement filtre */
		default_order,		/* valeurs par defaut */
		default_cycle_marker,
		default_pre_synaptic,
		default_post_synaptic,
		user_order,		/* valeurs par defaut */
		user_cycle_marker,
		user_pre_synaptic,
		user_post_synaptic,
		cycle_marker,		/* symbolic names... */
		pre_synaptic,
		post_synaptic,
		les_types[MAX_EVENT],	/*
					* pour memoriser le nombre d'evenements
					* differents
					*/
		nb_events,		/* nombre d'evenements total */
		nb_de_types;		/* le nb de types differents */
	
_TMS_CLASS float paper,			/* longueur du papier */
		 depart,
		 old_X_axis,		/* pour conserver la longuer si fig carree */
		 long_X_axis,		/* longuer de l'axe des X en cms */
		 long_Y_axis,		/* longuer de l'axe des Y en cms */
		 horizontal_scale,
		 vertical_scale,
		 default_binwidth,
		 default_binwidth_AC,
		 default_binwidth_CC,
		 default_binwidth_IS,
		 default_binwidth_PST,
		 default_duration,
		 default_duration_AC,
		 default_duration_CC,
		 default_duration_IS,
		 default_duration_PST,
                                        /* user defaults (saved in .xtmsrc) */
		 user_binwidth,
		 user_binwidth_AC,
		 user_binwidth_CC,
		 user_binwidth_IS,
		 user_binwidth_PST,
		 user_duration,
		 user_duration_AC,
		 user_duration_CC,
		 user_duration_IS,
		 user_duration_PST,
		 duree_cycle,
		 sum_rate, sum_inter,	/* pour calculer des moyennes */
		 max_interval_clip,
		 min_interval_clip,	/* bornes pour le filtrage */
		 arrivee;

_TMS_CLASS float   temps_max;		/* fin des donnees		*/


_TMS_CLASS int	type[MAX_DATA];  	/* type de l'evenement */
	
_TMS_CLASS float temps[MAX_DATA],	  /* temps des time-series    */
		 inst_interval[MAX_DATA], /* temps des time-series    */
		 phase_interval[MAX_DATA],/* phases des time-series    */
		 inst_rate[MAX_DATA];	  /* temps des time-series    */

void	spawn(),	/* fonctions communes */
	retour(),
	fin(),
	no_op();
		
/************************** FONCTIONS TMS *****************/

_TMS_CLASS void	Page_de_garde(void),
		Locate(int, int),
		normal(),
		inverse(),
		menu(),
		const_menu(),
		erase(void);
_TMS_CLASS void print_file (Widget widget, XtPointer client_data, XtPointer call_data);
		
/**************************** INTERFACE FONCTIONS *******************/

_TMS_CB_CLASS void	tms_MainInitMenuVar();
_TMS_CB_CLASS Widget	main_Form;

_TMS_CLASS Cursor wait_cursor;

/**************************** DATA *************************/

#ifndef CALCFUNC_ARGS
#define CALCFUNC_ARGS

#define COMPUTE_DATAS 3		/* Number of datas used for the compute actions */
#define DATA1 0
#define DATA2 1
#define DATA3 2

#define FCTPARA_PARANB 7	/* Nb of widget that are used to get paramters for calculs */
#define HISTOGRAM_PARANB 6
#define ARROWS_PARANB 4
#define POINCARE_PARANB 3
#define THREED_PARANB 4

typedef struct calculsarg
{
	ACTIONFCT_TYPE	function;		/* function to be executed*/
	char		action[3];		/* name of action */
	int		events[COMPUTE_DATAS];	/* events selected for action */
	float		binwidth;
	int		order;
	float		duration;
	int		cycle;
	float		max[COMPUTE_DATAS];
	float		min[COMPUTE_DATAS];
	Boolean		sameyscale;
	int		line1;
	int		line2;
	float		ymax;
	float		ymin;
	float		mapfrom;
	float		mapto;
	Boolean		square;
	int		binsnb;
	float		teta;
	float		phi;
	float		screen;
	float		eye;
	Boolean		arrowpos;
	int		*arrowlist;
	Boolean		FctparaList[FCTPARA_PARANB];		/* lists that tell wich widgets are sensitive */
	Boolean		HistogramList[HISTOGRAM_PARANB];
	Boolean		ArrowsList[ARROWS_PARANB];
	Boolean		PoincareList[POINCARE_PARANB];
	Boolean		ThreeDList[THREED_PARANB];
} CALCULSARG, *pCALCULSARG;
#endif

/*********************************** INTERFACE VARIABLES ********************************/

_TMS_CB_CLASS void DispMessageDialog (Widget TheParent,char *TextToDisplay, char *TitleOfDialog,unsigned char TypeOfDialog);
_TMS_CB_CLASS void DispPopupDialog (Widget TheParent,char *TextToDisplay, char *TitleOfDialog);

#ifdef _TMS_MAIN
extern Widget Createmain_Form(Widget, Boolean);
extern Widget CreateparametersMain_Form(Widget);
extern Widget CreatefileSelectionBox(Widget);
extern Widget CreatefilterMain_Form(Widget);
extern Widget CreateaxisMain_Form(Widget);
extern Widget CreatearrowsMain_Form(Widget);
extern Widget CreatepoincareMain_Form(Widget);
extern Widget CreatehistogramMain_Form(Widget);
extern Widget CreatethreeDMain_Form(Widget);
#endif

/******************************** Environment directories ***********************************/

_TMS_CLASS char	project_directory[256];
_TMS_CLASS char	working_directory[256];
_TMS_CLASS char	bin_directory[256];
_TMS_CLASS char	help_directory[256];

#undef _TMS_CB_CLASS
#undef _TMS_CLASS




