#define SYSTEM_VMS	0
#define DEBUG		0
#define DEBUG_UPDT	0
#define DEBUG_UPDT_1	0
#define DEBUG_BURST	0
/* 
 *SCIENCE ACTIVE is to have a window less hightin order to left space for an additional window to give exercise
*/
#define SCIENCE_ACTIVE 0

/*
*
*	P_NEURON.C V5 permet de cree un neurone burster en le visualisant.
*	Il est utilise par NBC V6
*
*	Donne une sortie PostScript
*
*
*	ULTRIX 		28 janvier 91
*
*
*	Versions:	V1	V0 en partant de motifgif.c
*					(prg demo de Motif)
*
*			V2.0	Ajout du bruit		5 fevrier 93
*			V2.1	Sauvegarde du bruit	5 juin 93
*
*			V3.0	Changement des scales	3 Aout 93
*				pour harmoniser avec
*				G_neuron
*			V3.1	Print dans menu		6 Aout 93
*
*			V4.0	Nouvelles fenetres de scales
*				avec scrolled windows	30 mai 94
*			V4.1	File en P_unit
*			V4.3	Acces du nom de fichier par la ligne de commande 15 mai 1995
*			V4.4	Affichage du nom de fichier dans le titre 16 aout 95
*			V4.5	Prise en compte des decimales dans les temps 2 mai 96
*                       V4.6    Filtrage a la Andre Fabio Kohn (USP)         6 sept 1996
*                               + position de PSP en pourcentage
*                               + reglage de la duree de la simulation
*
*	Avatar: 	B-neuron V1 en partant de P_neuron V4.6      8 sept 1996
*
*                       V4.7    Ajout de la fatigue au seuil (KP + JFV)      19 sept 1996
*
*	P_neuron	V5.0	Ajout des B_units apres test sur B_neuron    23 sept 1996
*                       V5.1    Reorganisation des scales et rimpression     25 sept 1996
*                       V5.2    Second type de fatigue de seuil ajoue        30 sept 1996
*                       V5.3    Changement du default pour la fatigue         7 oct  1996      
*                       V5.4    Bug de sommation et defaut pour le drag      10 oct  1996      
*                       V5.5    Bug dans fileselection box corrige           24 oct  1996      
*                       V5.6    Bug dans toggle butt0n cond burster corrige   5 nov  1996      
*                       V5.7    Bug dans sauvetage du neurone corrige	      4 dec  1996      
*                       V5.8    Bug dans sauvetage du neurone corrige	      11 dec  1996      
*                       V5.9    Nom par defaut du fichier du neurone	      12 dec  1996      
*			V5.10   Message si pas sauve (GS)		      15 fev 1997
*			V5.11	Bug de la file des epsp corrige (JFV)	      24 fev 1997
*			V5.12	Bug corrige (JFV)			      24 mar 1997
*			V5.13	Bug nom de fichier corrige (JFV)	      7 aout 1997
*
*                       V6.0    Ajout des L_units with LIM model (KP+JFV)     18 aout 1997         
*                       V6.1    noise avec 3 decimales (KP+JFV)		      20 aout 1997         
*                       V6.2    actualisation des scales (JFV)		      21 aout 1997         
*                       V6.3    Browse manuel added (JFV)		      28 janv 1998         
*                       V6.4    Changement de extract_normal_string (JFV)     24 juin 1998         
*                       V6.5    Visualisation des equations (JFV)	      24 aout 1998         
*                       V6.6    Correction de pb fermeture de fichier (JFV)   17 sept 1998         
*                       V6.7    Je ne sais plus...                    (JFV)   1  oct 1998         
*                       V6.8    Prise en compte de Lesstif  (JFV)             11 janv 1999         
*                       V6.9    Utilisation de .xnbcrc pour retrouver         19 avril 2000
*                               les nom de fichiers (JFV)
*			V6.10	Sous Linux, pb si nom de fichier fourni.      12 sept 2000
*			V6.11	je ne sais plus...                            ? sept 2000
*			V6.12	Nom de fichier fourni trop tot...             18 dec 2003
*
*
*	Auteur: Dr J-F VIBERT
*		Laboratoire de Biomathematiques
*		ESI B3E INSERM U444
*		Faculte de Medecine Saint-Antoine
*		27 rue Chaligny
*		75571 Paris cedex 12
*			France
*
*	Copyright Dr JF Vibert 
*	All rights reserved
*	Access limited to authorized persons	
*	This software was developped only for resarch purpose
*	and is not, in any way, usable for commercial purpose.
*
*/
#ifdef DOCUMENTATION

title	P_NEURON	Phenomenological neuron model X graphic editor
index			Phenomenological neuron model X graphic editor

Synopsis

	P_neuron [-k] [-b|p|l] [-v] [filename[.B_unit]|[.P_unit]|[.L_unit]]

Description

	P_neuron is an X graphic editor for the phenomenological bursting neuron
	model of NBC. It allows to choose the neuron parameters using
	sliding scales with visual feed back control in a graphic window
	displaying the unit membrane potential during 200 ms. At 10 ms, an
	EPSP of fixed weight 1 (one synaptic knob) is simulated to show the
	individual EPSP shape, and at 40 ms, a PSP of adjustable weight and sign
	(using one of the scales) is simulated to explore  what happens
	when the weight changes (spike firing, IPSP, reversal potential
	approach).

	{\tt -v} switch gives a verbose output on stdout

	{\tt -b} switch to give a conditional burster

	{\tt -l} switch to give a normal LIM

	{\tt -p} switch to give a normal XNBC phenomenologic 

	{\tt -k} is to keep the PostScript file instead of spooling it
	
	The following vertical scales  are available:

	\nofill
	Resting Potential
	Post-spike Potential
	Firing Threshold
	Post-spike Threshold
	Burst frequency
        Max burst frequency
	Composition factor
	Noise mean
	Noise standard deviation
	\fill

	The following horizontal scales  are available:

	\nofill
	Membrane Potential Time Constant
	Minimal burst duration
	Maximal burst duration
	Threshold Time Constant
	Shunt Time Constant
	\fill


	A menu bar File allow to read, save, print the neuron, or quit
	Pneuron ({\bf File-Quit}).  The edited values are saved in a file with the
	{\tt .P_unit} extension from the {\bf File} menu bar item: {\bf File-Write Back
	Neuron} or {\bf File-Save Neuron as...}  This files can be read back by
	P_neuron ({\bf File-Read Neuron}) and NBC.  A hard copy PostScript file
	of the neuron membrane potential evolution can be obtained from the
	menu bar item {\bf File-Print}.  The output file {\bf file_in.ps} is spooled on
	the PostScript printer, and then deleted (if not {\tt -k}).

	A menu bar {\bf Parameter} item proposes the sub item {\bf Change Parameter} to
	call back the parameter windows (if they were previously closed) or
	to redraw the neuron (if any X server problem).

Files	 

	Input files: file_in.P_unit or file_in.B_unit or file_in.L_unit 

	Output files: file_in.P_unit file_in.P_unit.ps 
	              file_in.B_unit file_in.B_unit.ps 
	              file_in.L_unit file_in.L_unit.ps 

See also

	G_neuron and nbc_x
	
Diagnostics

	Self explaining diagnostics are provided on fatal errors.

Authors

	Dr Jean-Francois Vibert 

	CHU Saint-Antoine Univ. P. & M. Curie PARIS

Bugs/deficiencies

	No known bugs.
#endif


#include "P_neuron.h"
#include "find_files.h"
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <plot_ps.h>
#include <string.h>

#define VERSION	(" V6.12")

#define STRING_OFFSET   14
#define WIDTH           520
#define HEIGHT          732
#define	MAX_Y		20.
#define	MIN_Y		-100.
#define MAX_DDP		(MAX_Y - MIN_Y)
#define MAX_POINTS	50000
#define MAX_TIME	200
#define F_MAX_TIME	200.
#define SCALE_WIDTH	50
#define	TOP_MARGIN	0
#define	TOP_SPIKE	20


#define MAX_MEM		200
#define	MAX_SPK		200
#define MAX_SHUNT	100
#define MAX_BURST       20
#ifndef TRUE
#	define TRUE 	1
#endif
#ifndef FALSE
#	define FALSE	0
#endif
#define SPIKE		1
#define REPOS		0

#define InterForm_Offset	5
#define ScaleForm_Width		80
#define ScaleForm_Height	346
#define ScaleForm_FractionBase	20
#define ScaleForm_BorderWidth	1
#define Scale_RightPosition	12
#define scale_time_width	270

void fabrique_fenetreDessin();

void fabrique_fenetreParametre();

void fabrique_Echelles(void );

void fenetre_Eq ();

void fenetre_Psp ();

void browse_callback();

void equations_callback();

void DrawNeuron(Widget);

void DispMessageDialog (Widget, char *, char *,unsigned char );

Widget fabrique_label (XmString, Widget);

Widget fabrique_scale (int, int, int, int, Widget, Widget);

int   file_saved,flag_echelle=0;             /* flag */

float Max_Y=MAX_Y,Min_Y=MIN_Y,Max_DDP=MAX_DDP;
     
int dialog_up = 1;
static XtResourceList resource;

XmString	titre;

Dimension	largeur,
		hauteur,
		screen_width,
		screen_height;

Widget	ParameterDialog,
	ParameterChange,
	Scrolled_Window_Parametres,
	Row_Column_Parametres,
	TimeDialog,
	Scrolled_Window_Time,
	TimeChange,
	Time1,
   /* verticales */
	scale1,
	scale2,
	scale3,
	scale4,
	scale5,
	scale6,
	scale7,
	scale8,
	scale9,
	scale10,
	scale11,
	scale12,
	scale13,
	scale14,
	scale15,
	scale16,
	scale17,
	scale18,
	scale19,
	scale20,
	scale35,
	scale36,
   /* horizontales */
	scale21,
	scale22,
	scale23,
	scale24,
	scale25,
	scale26,
	scale27,
	scale28,
	scale29,
	scale30,
	scale31,
	scale32,
	scale33,
	scale34,

	toggle1,
        toggle2,
        toggle3, 
        toggle4;

Widget
        form_Burst_thr,
	label_Burst_thr,
	form_freq_spike,
	label_freq_spike,
	form_freq_max,
	label_freq_max,
	form_compose_fact,
	label_compose_fact,
	form_duree_burst_min,
	label_duree_burst_min,
	form_duree_burst_max,
	label_duree_burst_max,
       	form_Resistance,
       	label_Resistance,
	form_Burst_post_spike,
	label_Burst_post_spike;


GC	Draw_GC;

XGCValues	xgcv;

XPoint	*point,
	*le_soma,
	*le_seuil,
        le_epsp1[6],
        le_epsp2[6],
        le_epsp3[6],
        le_ipsp1[6],
        le_ipsp2[6],
        le_ipsp3[6];

struct  burster_clu 
{
	float rest_pot;				/* resting potential */
	float pot_post_spike;		        /* pot mb post spike */
	float burst_post_spike;		        /* pot mb post spike pendant le burst */
	float overshoot;			/* post spike overshoot (rest - post_spike) */
	float burst_overshoot;			/* post spike overshoot (seuil_burst - burst_post_spike) */
	float tau_mb_pot;			/* mb time constant */
	float i_tau_mb_pot;			/* 1/mb time constant */
	float seuil_post_spike;		        /* post spike firing threshold */
	float rev_pot_pos;			/* positive reversal potential (epsp) */
	float rev_pot_neg;			/* negative reversal potential (ipsp) */
	float tau_seuil;			/* firing threshold time constant post spike */
	float i_tau_seuil;			/* 1/firing threshold time constant post spike */
	float epsp;			       	/* epsp size */
	float ipsp;			       	/* ipsp size */
	float E_K;			       	/* potassium resting potential */
	float E_Na;			       	/* sodium resting potential */
	float freq_spike;             /* frequence intra burst de base (spk/s) */
	float freq_max;               /* frequence max si plusieurs inouts (spk/s) */    
	float compose_fact;           /* facteur de composition des bursts */
	float duree_burst_min;        /* duree min des bursts (ms) */
	float duree_burst_max;        /* duree max des bursts (ms) */
	float burst_range;            /* duree max-min des bursts (ms) */
	float seuil;                  /* seuil de declenchement des spikes normaux */
	float seuil_burst;            /* seuil de declenchement des burst */           
	float tau_attack_epsp;		/* epsp attack time constant */
	float tau_decay_epsp;		/* epsp decay time constant */
	float tau_attack_ipsp;		/* ipsp attack time constant */	
	float tau_decay_ipsp;		/* ipsp decay time constant */
	float i_tau_attack_epsp;	/* 1/epsp attack time constant */
	float i_tau_decay_epsp;		/* 1/epsp decay time constant */
	float i_tau_attack_ipsp;	/* 1/ipsp attack time constant */	
	float i_tau_decay_ipsp;		/* 1/ipsp decay time constant */
	float shunt_values[MAX_SHUNT];
	float shunt_tau;			/* mb shunt time constant */
	float K_rev_p;
	float K_rev_n;
	float epsp_sd;
	float ipsp_sd;
	float tau_a_epsp;			/* time cst in iteration steps */
	float tau_d_epsp;
	float tau_a_ipsp;
	float tau_d_ipsp;
	float capacite;
	float resistance;
	float fatigue;
	float A;                         /* pour le calcul du soma hors burst */
	float v_plus;
	float v_rap;
	float b_A;                       /* pour le calcul du soma dans les bursts */
	float b_v_plus;
	float b_v_rap;
} clu_burst;

/* le neurone simule */

struct  burster_neuron 
{
  float soma;	                 /* resting  potential du cluster	*/
  float soma_post_spike;	 /* post spike potential du neurone	*/
  float threshold;	         /* seuil du cluster	*/
  float periode;                 /* intervale inter spike (1/freq_spike) en iterations */
  float frequence;              /* sp/s du momemnt */
  float	decharge_lag;		/* depuis combien de temps ca a decharge */
  float	seuil_peak;		/* valeur haute du seuil */
  float	delta_seuil;		/* valeur haute du seuil */
  int   spike_suivante;         /* moment de la prochaine spike */
  int   sablier[MAX_BURST];     /* le temps qui reste a chaque burst */
  int   nb_sabliers;            /* nombre de sabliers (nb de bursts imbriques) */
  int	t_next_i;		/* time of the next input */
  int	*next_spike;		/* indice dans la queue de la spike suivante ([NB_NEUR) */
  int   spike_time[MAX_SPK],	/* queue de spikes sur l'axone */
	tete,			/* tete de queue */
	queue,			/* fin de queue */
	inp_t[MAX_MEM],		/* queue des temps des inputs */
	head,			/* tete de queue */
	tail,			/* fin de queue */
	t_last_i;		/* fin de queue */
  int   spike;
  int   in_burst;               /* flag */
  float inp_max_pos[MAX_MEM];	/* queue des tailles des inputs */
  float	inp_max_neg[MAX_MEM];	/* queue des tailles des inputs */
  float	inp_ta[MAX_MEM];	/* queue des tau increasing des inputs */
  float	inp_td[MAX_MEM];	/* queue des tau decreasing des inputs */
} burst_dyn;

float   sim_duration,           /* simulation duration */
	backgrd_noise_m,        /* bruit */
	backgrd_noise_sd,       /* bruit */
        input_e_fact,
        input_i_fact,
        un_epsp,
        un_ipsp,
        un_epsp1,
        un_ipsp1,
        un_epsp2,
        un_ipsp2,
        un_epsp3,
        un_ipsp3,
	v_moins,                /*	 pour le rev pot new look */
        white_noise,            /* le bruit non filtre */
        center_noise,           /* le bruit centre filtre */
        time_step;              /* pas d echantillonage */
	
short	filter_noise = FALSE,   /* bruit filtre */
        lim_type = FALSE,   /* leaky integrator model */
        bum_type = FALSE,   /* conditional burster model */
        pum_type = TRUE,   /* phenomenologic model */
        dynamic_change = FALSE, /* pour le drag_callback (mis a true en fin de main) */ 
        less_fatigue = FALSE,   /* toujours fatigue */
	spike;		        /* flag */

int	screen,
        EpspArr1 = 20,
        EpspArr2 = 40,
        EpspArr3 = 60,
        IpspArr1 = 15,
        IpspArr2 = 35,
        IpspArr3 = 55;
	
char	*usage = "usage: %s [-k] [-b] [-b] [-v] [filename[.B_unit][.P_unit][.L_unit]]\n\
\t-k keep PostScript file\n\t-v verbose\n",
        model_type = 'P',
	keep = 'd',		/* flag pour -k */
	verbose = FALSE,	/* flag bavard	*/
	f_neur [256],		/* nom du fichier nouveau	*/
	f_neur_old[256],	/* nom_du fichier ancien	*/
	shell_name[256],		/* nom de la fenetre principale	*/
	pattern[256],		/* pattern de fichier		*/
	buffer[256];		/* buffer de lecture		*/
	
FILE	*p_neur;	/*
			 * pointeur sur fichier ancien puis nouveau
			 */
int	nb_pts_dessin,	/* pour conserver le nb de points dans le dessin */
	x_origine,	/* pour le dessin ecran et PS	*/
	y_origine;

float	x_echelle,		/* pour le dessin ecran et PS	*/
	y_echelle;
float   filter_a,
        filter_b;

int	t_next_i;		/* time of the next input */
int     nb_points;              /* nb de points des dessins */

void read_P_unit(FILE *);
void set_defaults(void);

/***********************************************************/
void  Quit()
{
  printf("exiting...\n\r");
  fflush(stdout);
  
  if(le_seuil != NULL)
    free(le_seuil);
  if(le_soma != NULL)
    free(le_soma);
 
  exit(0);
}


void realloc_mem(int taille  )
{

  Arg	     wargs[10];
  int	     n;
  XmString   string1;

  if(taille==0) return;

  if(le_seuil != NULL)
    free(le_seuil);
  
  if(le_soma != NULL)
    free(le_soma);
  
  if( (le_seuil = (XPoint * )calloc(2*taille, sizeof(XPoint ))) == NULL ||
      (le_soma  = (XPoint * )calloc(2*taille, sizeof(XPoint ))) == NULL )
    {
      strcpy(buffer,"structure allocation impossible\nTry later");
      DispMessageDialog(MainWindow,buffer,"WARNING",1);
      Quit();
    }
}

void callback_sortie(Widget w, XtPointer c1, XtPointer c2)
{
  Quit();
}

/***********************************************************/
/* Quit							   */
/***********************************************************/
XtCallbackProc MenuQuit (w, client_data, call_data)
Widget   w;
XtPointer  client_data,
         call_data;
{
  if (!file_saved)
    {
      strcpy(buffer,"File not saved\nAre you still Ok to Quit?");
      DispMessageDialog(MainWindow,buffer,"WARNING",0);
    }
  else
    exit (0);
}

/***********************************************************/
/* displayed on Read file selection                        */
/***********************************************************/
XtCallbackProc ReadFiles (w, client_data, call_data)
Widget   w;
XtPointer  client_data,
         call_data;
{
  int n;
  Arg  args[5];
  XmString tcs1,tcs2;
  char	mask[256];

  n = 0;

  if (bum_type)
  {
      mask[0]='\0';
      strcpy(mask,"*.B_unit");
  }
  if (lim_type)
  {
      mask[0]='\0';
      strcpy(mask,"*.L_unit");
  }
  if (pum_type)
  {
      mask[0]='\0';
      strcpy(mask,"*.P_unit");
  }

  tcs1 = XmStringCreateLocalized (mask);
  tcs2 = XmStringCreateLocalized (pattern);

  if (verbose)
	printf("pattern: %s\nmask = %s\n",pattern,mask);

  XtSetArg(args[n], XmNdirMask, tcs2); n++; 
  XtSetArg(args[n], XmNpattern, tcs1); n++;
  XtSetArg(args[n], XmNdirectory, tcs2); n++; 

  XtSetValues(FileReadSelection,args, n);


    XtManageChild (FileReadDialog);
    XtManageChild (FileReadSelection);
}

/***********************************************************/
/* displayed on Save As file selection                     */
/***********************************************************/
XtCallbackProc SaveAsFiles (w, client_data, call_data)
Widget   w;
XtPointer  client_data,
         call_data;
{
  int n;
  Arg  args[5];
  XmString tcs1, tcs2;
  char	mask[256];

  n = 0;

  if (bum_type)
    {
      mask[0]='\0';
      strcpy(mask,"*.B_unit");
    }
  if (lim_type)
    {
      mask[0]='\0';
      strcpy(mask,"*.L_unit");
    }
  if (pum_type)
   {
      mask[0]='\0';
      strcpy(mask,"*.P_unit");
   }
  tcs1 = XmStringCreateLocalized (mask);
  tcs2 = XmStringCreateLocalized (pattern);

  if (verbose)
	printf("pattern: %s\nmask = %s\n",pattern,mask);

  XtSetArg(args[n], XmNdirMask, tcs2); n++; 
  XtSetArg(args[n], XmNpattern, tcs1); n++;
  XtSetArg(args[n], XmNdirectory, tcs2); n++; 

  XtSetValues(FileSaveAsSelection,args, n);

    XtManageChild (FileSaveAsDialog);
    XtManageChild (FileSaveAsSelection);
}
/**********************************************************/
/* displayed on Read file end                             */
/**********************************************************/
XtCallbackProc FileReadFin (w, client_data, call_data)
Widget   w;
XtPointer  client_data,
         call_data;
{
    XtUnmanageChild (FileReadDialog);
    XtUnmanageChild (FileReadSelection);
}

/**********************************************************/
/* displayed on Save file end                             */
/**********************************************************/
XtCallbackProc FileSaveFin (w, client_data, call_data)
Widget   w;
XtPointer  client_data,
         call_data;
{
    XtUnmanageChild (FileSaveAsDialog);
    XtUnmanageChild (FileSaveAsSelection);
}
/***********************************************************/
/* displayed on Read file help                             */
/***********************************************************/
XtCallbackProc ReadHelp (w, client_data, call_data)
Widget   w;
XtPointer  client_data,
         call_data;
{
	fprintf(stderr,"\007Click at the right place to get a preexisting neuron\n");
}

/***********************************************************/
/* displayed on Save file help                             */
/***********************************************************/
XtCallbackProc SaveHelp (w, client_data, call_data)
Widget   w;
XtPointer  client_data,
         call_data;
{
	fprintf(stderr,"\007Click at the right place to save your new neuron\n");

}
/***********************************************************/
/* Create and Print File PS                                */
/***********************************************************/
XtCallbackProc Create_PS (w, client_data, call_data)
Widget   w;
XtPointer  client_data,
         call_data;
{

	char	print_file[60];
	float	pos_x,
		pos_y,
		coord_x[MAX_POINTS+10],
		coord_y[MAX_POINTS+10];
	int	i;

	strcpy(print_file,f_neur);
	strcat(print_file,".ps");

	ps_iniplot(print_file,30.);

	ps_origin(2.,2.,0.,0.);

	ps_movea(0.,0.);
	ps_echel((15./sim_duration),(20./Max_DDP),0.,0.,1.,0.);
	ps_user();

	ps_ticked_axes(0.,-100.,
		       0.,sim_duration+1.,
		       0.,sim_duration,
		       Min_Y,Max_Y+1.,
		       Min_Y,Max_Y,
		       0.1," Time (ms)","%.0f"," Membrane Pot. (mV)","%.1f",0.4,1);

	/*
	 * les potentiels de reversion positif puis negatif
	 */

	ps_movea(0.,0.);
	
	/*
	 * Le seuil
	 */

	ps_line_width(1.);
	ps_movea(0.,0.);
	for (i = 0; i < nb_pts_dessin; i++)
	{
		coord_x[i] = ((float)le_seuil[i].x - (float)x_origine) / x_echelle;
		coord_y[i] = (Max_Y - ((float)le_seuil[i].y / y_echelle)) + 100.;
	}
	ps_polyline(coord_x,coord_y,nb_pts_dessin,FALSE,0,0.);


	/*
	 * Le soma
	 */

	ps_line_width(2.);
	ps_movea(0.,0.);
	for (i = 0; i < nb_pts_dessin; i++)
	{
		coord_x[i] = ((float)le_soma[i].x - (float)x_origine) / x_echelle;
		coord_y[i] = Max_Y - ((float)le_soma[i].y / y_echelle) + 100.;
	}

	ps_polyline(coord_x,coord_y,nb_pts_dessin,FALSE,0,0.);

	/* les psps */

	ps_line_width(.5);

	if (clu_burst.epsp)
	{
	    ps_movea(0.,0.);
	    for (i = 0; i < 6; i++)
	    {
		    coord_x[i] = ((float)le_epsp1[i].x - (float)x_origine) / x_echelle;
		    coord_y[i] = Max_Y - ((float)le_epsp1[i].y / y_echelle) + 100.;
	    }
	    ps_polyline(coord_x,coord_y,6,FALSE,0,0.);

	    ps_movea(0.,0.);
	    for (i = 0; i < 6; i++)
	    {
		    coord_x[i] = ((float)le_epsp2[i].x - (float)x_origine) / x_echelle;
		    coord_y[i] = Max_Y - ((float)le_epsp2[i].y / y_echelle) + 100.;
	    }
	    ps_polyline(coord_x,coord_y,6,FALSE,0,0.);

	    ps_movea(0.,0.);
	    for (i = 0; i < 6; i++)
	    {
		    coord_x[i] = ((float)le_epsp3[i].x - (float)x_origine) / x_echelle;
		    coord_y[i] = Max_Y - ((float)le_epsp3[i].y / y_echelle) + 100.;
	    }
	    ps_polyline(coord_x,coord_y,6,FALSE,0,0.);
	}
	if (clu_burst.ipsp)
	{
	    ps_movea(0.,0.);
	    for (i = 0; i < 6; i++)
	    {
		    coord_x[i] = ((float)le_ipsp1[i].x - (float)x_origine) / x_echelle;
		    coord_y[i] = Max_Y - ((float)le_ipsp1[i].y / y_echelle) + 100.;
	    }
	    ps_polyline(coord_x,coord_y,6,FALSE,0,0.);

	    ps_movea(0.,0.);
	    for (i = 0; i < 6; i++)
	    {
		    coord_x[i] = ((float)le_ipsp2[i].x - (float)x_origine) / x_echelle;
		    coord_y[i] = Max_Y - ((float)le_ipsp2[i].y / y_echelle) + 100.;
	    }
	    ps_polyline(coord_x,coord_y,6,FALSE,0,0.);

	    ps_movea(0.,0.);
	    for (i = 0; i < 6; i++)
	    {
		    coord_x[i] = ((float)le_ipsp3[i].x - (float)x_origine) / x_echelle;
		    coord_y[i] = Max_Y - ((float)le_ipsp3[i].y / y_echelle) + 100.;
	    }
	    ps_polyline(coord_x,coord_y,6,FALSE,0,0.);
	}

	
/*------ e c r i t u r e   d e s   v a l e u r s  ------------------ */

	ps_cms();
	
	sprintf(buffer, "File: %s", f_neur);
	ps_writeah (0., 26., buffer, 0.5);

	pos_x = 0.;
	pos_y = 25.;

	ps_writeah (pos_x, pos_y, "Rest potential: ", 0.3);
	sprintf(buffer, "%.0f mV", clu_burst.rest_pot);
	ps_writeah (pos_x+4., pos_y,buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "Firing frequency: ", 0.3);
	sprintf(buffer, "%.1f mV",clu_burst.freq_spike);
	ps_writeah (pos_x+4., pos_y, buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "Max Firing Freqency: ", 0.3);
	sprintf(buffer, "%.1f mV", clu_burst.freq_max);
	ps_writeah (pos_x+4., pos_y,buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "Min burst duration: ", 0.3);
	sprintf(buffer, "%.1f mV",clu_burst.duree_burst_min);
	ps_writeah (pos_x+4., pos_y, buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "Max burst duration: ", 0.3);
	sprintf(buffer, "%.2f mV", clu_burst.duree_burst_max);
	ps_writeah (pos_x+4., pos_y,buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "EPSP: ", 0.3);
	sprintf(buffer, "%.2f mV", clu_burst.epsp);
	ps_writeah (pos_x+4., pos_y,buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "IPSP: ", 0.3);
	sprintf(buffer, "%.1f mV", clu_burst.ipsp);
	ps_writeah (pos_x+4., pos_y, buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "Composition factor: ", 0.3);
	sprintf(buffer, "%.1f mV",clu_burst.compose_fact);
	ps_writeah (pos_x+4., pos_y, buffer, 0.3);

#if 0	
	pos_x += 8.;
	pos_y = 25.;
	ps_writeah (pos_x, pos_y, "Mb time cste: ", 0.3);
	sprintf(buffer, "%.2f ms",tau_mb_pot);
	ps_writeah (pos_x+4.5, pos_y, buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "Threshold time cste: ", 0.3);
	sprintf(buffer, "%.2f ms",tau_seuil);
	ps_writeah (pos_x+4.5, pos_y, buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "EPSP attack time cste: ", 0.3);
	sprintf(buffer, "%.2f ms",tau_attack_epsp);
	ps_writeah (pos_x+4.5, pos_y, buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "EPSP decay time cste: ", 0.3);
	sprintf(buffer, "%.2f ms", tau_decay_epsp);
	ps_writeah (pos_x+4.5, pos_y, buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "IPSP attack time cste: ", 0.3);
	sprintf(buffer, "%.2f ms",tau_attack_ipsp);
	ps_writeah (pos_x+4.5, pos_y, buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "IPSP decay time cste: ", 0.3);
	sprintf(buffer, "%.2f ms", tau_decay_ipsp);
	ps_writeah (pos_x+4.5, pos_y, buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "Mb shunt time cste: ", 0.3);
	sprintf(buffer, "%.3f ms",shunt_tau);
	ps_writeah (pos_x+4.5, pos_y, buffer, 0.3);
#endif
	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "Background noise (mean): ", 0.3);
	sprintf(buffer, "%.2f mV",backgrd_noise_m);
	ps_writeah (pos_x+4.5, pos_y, buffer, 0.3);

	pos_y -= .5;
	ps_writeah (pos_x, pos_y, "Background noise (sd): ", 0.3);
	sprintf(buffer, "%.2f",backgrd_noise_sd);
	ps_writeah (pos_x+4.5, pos_y, buffer, 0.3);


	ps_endplot(print_file,keep);
	
}

/***********************************************************/
/* displayed on OK file selection for Input file           */
/***********************************************************/
XtCallbackProc FileReadOK (w, client_data, callback_data)
Widget   w;
char *client_data;
XmSelectionBoxCallbackStruct *callback_data;
{
	char	textstr[256],
		*pc,
		parametre[50],
		value[30];
	void	extract_normal_string();
	Arg     args[MAX_ARGS];


	extract_normal_string (callback_data->value, textstr);

	if (pc = strchr(textstr,'.'))
	{
		*pc = 0;
	} /* fin du if */

	if (bum_type)
	  strcat(textstr,".B_unit");
	if (lim_type)
	  strcat(textstr,".L_unit");
	if (pum_type)
	  strcat(textstr,".P_unit");


	strcpy (f_neur, textstr);
	strcpy(f_neur_old,f_neur);
	strcat(f_neur_old,".bak");

	if (p_neur = fopen(f_neur,"r"))	/* Si il existe, on le sauve en .bak */
	{
		XtUnmanageChild (FileReadDialog);
		XtUnmanageChild (FileReadSelection);

		set_defaults();

		read_P_unit(p_neur);

		fclose(p_neur);
		sprintf(buffer,"P_neuron %s: %s", VERSION, f_neur);
		XtSetArg(args[0], XmNtitle, buffer); 
		XtSetValues(Shell,args,1);

		nb_points = (sim_duration / time_step) + 1;
		realloc_mem(nb_points);
		
		DrawNeuron(w);
	} /* fin du if */
	else
	{
		fprintf(stderr,"\007File %s does not exists\n",f_neur);
	} /* fin du else */
}

void read_P_unit(FILE *p_neur)
{
        char    parametre[50],
		value[50];

	while(fgets(buffer,80,p_neur))
	{
		sscanf(buffer,"%s %s",parametre,value);

		if (!strcmp(parametre,"ModelType:"))	/* resting  potential	*/
		{
		    if (value[0] == 'B')
		    {
			  bum_type = True;
			  lim_type = False;
			  pum_type = False;
		    }
		    if (value[0] == 'L')
		    {
			  bum_type = False;
			  lim_type = True;
			  pum_type = False;
		    }
		    if (value[0] == 'P')
		    {
			  bum_type = False;
			  lim_type = False;
			  pum_type = True;
		    }
		}
		if (!strcmp(parametre,"RestPotential:"))	/* resting  potential	*/
			sscanf(value,"%f",&clu_burst.rest_pot);
		if (!strcmp(parametre,"SpikeFrequency:"))	/* Pot mb post spike */
			sscanf(value,"%f",&clu_burst.freq_spike);
		if (!strcmp(parametre,"MaxSpikeFrequency:"))	/* cste de temps de la mb */
			sscanf(value,"%f",&clu_burst.freq_max);
		if (!strcmp(parametre,"ComposeFact:"))		/* firing threshold par cluster */
			sscanf(value,"%f",&clu_burst.compose_fact);
		if (!strcmp(parametre,"MinBurstDuration:"))		/* seuil apres un spike */
			sscanf(value,"%f",&clu_burst.duree_burst_min);
		if (!strcmp(parametre,"MaxBurstDuration:"))		/* Potentiel d'equilibre du potassium */
			sscanf(value,"%f",&clu_burst.duree_burst_max);
		if (!strcmp(parametre,"ModelType:"))		/* Potentiel d'equilibre du sodium */
			sscanf(value,"%c",&model_type);
		if (!strcmp(parametre,"Threshold:"))		/* seuil normal  */
			sscanf(value,"%f",&clu_burst.seuil);
		if (!strcmp(parametre,"ThresholdBurst:"))      	/* seuil burst  */
			sscanf(value,"%f",&clu_burst.seuil_burst);
		if (!strcmp(parametre,"EpspSize:"))		/* taille d'un epsp  */
			sscanf(value,"%f",&clu_burst.epsp);
		if (!strcmp(parametre,"IpspSize:"))		/* variabilite d'un epsp  */
			sscanf(value,"%f",&clu_burst.ipsp);
		if (!strcmp(parametre,"NoiseMean:"))	/* Bruit de fond (moyenne) */
			sscanf(value,"%f",&backgrd_noise_m);
		if (!strcmp(parametre,"NoiseSd:"))	/* Bruit de fond (sd) */
			sscanf(value,"%f",&backgrd_noise_sd);
		if (!strcmp(parametre,"NoiseFilter:"))	/* Filtrage du bruit */
			sscanf(value,"%d",&filter_noise);
		if (!strcmp(parametre,"Capacity:"))	/* Capacite */
			sscanf(value,"%f",&clu_burst.capacite);
		if (!strcmp(parametre,"TimeStep:"))	/* TimeStep */
			sscanf(value,"%f",&time_step);
		if (!strcmp(parametre,"PostSpikePotential:"))	/* Pot mb post spike */
			sscanf(value,"%f",&clu_burst.pot_post_spike);
		if (!strcmp(parametre,"Adaptation:"))		/* seuil apres un spike */
			sscanf(value,"%f",&clu_burst.seuil_post_spike);
		if (!strcmp(parametre,"E_K:"))		/* Potentiel d'equilibre du potassium */
			sscanf(value,"%f",&clu_burst.E_K);
		if (!strcmp(parametre,"E_Na:"))		/* Potentiel d'equilibre du sodium */
			sscanf(value,"%f",&clu_burst.E_Na);
		if (!strcmp(parametre,"PosReversalPot:"))	/* Reversal Potential positif (pour epsp) */
			sscanf(value,"%f",&clu_burst.rev_pot_pos);
		if (!strcmp(parametre,"NegReversalPot:"))	/* Resersal Potential negatif (pour ipsp) */
			sscanf(value,"%f",&clu_burst.rev_pot_neg);
		if (!strcmp(parametre,"TimeCsteThreshold:"))	/* cste de temps du seuil apres un spike */
			sscanf(value,"%f",&clu_burst.tau_seuil);
		if (!strcmp(parametre,"TimeCsteMbPot:"))	/* cste de temps de la mb */
			sscanf(value,"%f",&clu_burst.tau_mb_pot);
		if (!strcmp(parametre,"EpspSd:"))		/* variabilite d'un epsp  */
			sscanf(value,"%f",&clu_burst.epsp_sd);
		if (!strcmp(parametre,"EpspAttack:"))	/* conste de temps de montee */
			sscanf(value,"%f",&clu_burst.tau_attack_epsp);
		if (!strcmp(parametre,"EpspDecay:"))	/* conste de temps de descente */
			sscanf(value,"%f",&clu_burst.tau_decay_epsp);
		if (!strcmp(parametre,"IpspSd:"))		/* variabilite d'un ipsp  */
			sscanf(value,"%f",&clu_burst.ipsp_sd);
		if (!strcmp(parametre,"IpspAttack:"))	/* conste de temps de montee */
			sscanf(value,"%f",&clu_burst.tau_attack_ipsp);
		if (!strcmp(parametre,"IpspDecay:"))	/* conste de temps de descente */
			sscanf(value,"%f",&clu_burst.tau_decay_ipsp);
		if (!strcmp(parametre,"BurstPostSpike:"))	/* conste de temps de descente */
			sscanf(value,"%f",&clu_burst.burst_post_spike);
		if (!strcmp(parametre,"MembraneShunt:"))/* constante de temps du shunt de la mb */
			sscanf(value,"%f",&clu_burst.shunt_tau);
		if (!strcmp(parametre,"FilterResistance:"))	/* time cste of the filter */
			sscanf(value,"%f",&clu_burst.resistance);
		if (!strcmp(parametre,"Fatigue:"))	/* fatigue du seuil */
			sscanf(value,"%f",&clu_burst.fatigue);
		if (!strcmp(parametre,"LessFatigue:"))	/* fatigue du seuil */
			sscanf(value,"%d",&less_fatigue);

	} /* fin du while */

	
	clu_burst.burst_range = clu_burst.duree_burst_max - clu_burst.duree_burst_min; 
	update_scales();

}
/* Update des scales */
update_scales()
{
	Arg     args[MAX_ARGS];

		/* mise a jour des scales */

	if (bum_type)
	{
		XtSetArg(args[0], XmNvalue, (int)clu_burst.burst_post_spike); 
		XtSetValues(scale35,args,1);
		XtSetArg(args[0], XmNvalue, (int)clu_burst.freq_spike); 
		XtSetValues(scale2,args,1);
		XtSetArg(args[0], XmNvalue, (int)clu_burst.freq_max); 
		XtSetValues(scale3,args,1);
		XtSetArg(args[0], XmNvalue, (int)clu_burst.compose_fact * 100); 
		XtSetValues(scale4,args,1);
		XtSetArg(args[0], XmNvalue, (int)clu_burst.duree_burst_min * 10); 
		XtSetValues(scale5,args,1);
		XtSetArg(args[0], XmNvalue, (int)clu_burst.duree_burst_max * 10); 
		XtSetValues(scale6,args,1);
		XtSetArg(args[0], XmNvalue, (int)clu_burst.seuil_burst);
		XtSetValues(scale14,args,1);
	}
	XtSetArg(args[0], XmNvalue, (int)clu_burst.rest_pot); 
       	XtSetValues(scale1,args,1);
	XtSetArg(args[0], XmNvalue, (int)(clu_burst.epsp * 100.)); 
	XtSetValues(scale7,args,1);
	XtSetArg(args[0], XmNvalue, (int)(clu_burst.ipsp * 100.)); 
	XtSetValues(scale8,args,1);
	XtSetArg(args[0], XmNvalue, (int)clu_burst.seuil);
	XtSetValues(scale9,args,1);
	XtSetArg(args[0], XmNvalue, (int)(backgrd_noise_m * 1000.)); 
	XtSetValues(scale10,args,1);
	XtSetArg(args[0], XmNvalue, (int)(backgrd_noise_sd * 1000.)); 
	XtSetValues(scale11,args,1);

	XtSetArg(args[0], XmNvalue, (int)(time_step * 1000.)); 
	XtSetValues(scale12,args,1);
	XtSetArg(args[0], XmNvalue, (int)(clu_burst.resistance * 100.)); 
	XtSetValues(scale13,args,1);
	if (!lim_type)
	{
	  XtSetArg(args[0], XmNvalue, (int)(clu_burst.rev_pot_neg)); 
	  XtSetValues(scale15,args,1);
	  XtSetArg(args[0], XmNvalue, (int)(clu_burst.rev_pot_pos)); 
	  XtSetValues(scale16,args,1);
	}
	XtSetArg(args[0], XmNvalue, (int)(clu_burst.pot_post_spike)); 
	XtSetValues(scale17,args,1);
	XtSetArg(args[0], XmNvalue, (int)(clu_burst.seuil_post_spike)); 
	XtSetValues(scale18,args,1);

	XtSetArg(args[0], XmNvalue, (int)(clu_burst.tau_mb_pot * 10.)); 
	XtSetValues(scale22,args,1);
	XtSetArg(args[0], XmNvalue, (int)(clu_burst.tau_seuil * 10.)); 
	XtSetValues(scale29,args,1);
	if (!lim_type)
	{
	  XtSetArg(args[0], XmNvalue, (int)(clu_burst.tau_attack_epsp * 10.)); 
	  XtSetValues(scale30,args,1);
	  XtSetArg(args[0], XmNvalue, (int)(clu_burst.tau_decay_epsp * 10.)); 
	  XtSetValues(scale31,args,1);
	  XtSetArg(args[0], XmNvalue, (int)(clu_burst.tau_attack_ipsp * 10.)); 
	  XtSetValues(scale32,args,1);
	  XtSetArg(args[0], XmNvalue, (int)(clu_burst.tau_decay_ipsp * 10.)); 
	  XtSetValues(scale33,args,1);
	}
	XtSetArg(args[0], XmNvalue, (int)(clu_burst.shunt_tau * 10.)); 
	XtSetValues(scale34,args,1);

	sprintf(buffer,"P_neuron %s: %s", VERSION, f_neur);
	XtSetArg(args[0], XmNtitle, buffer); 
	XtSetValues(Shell,args,1);
}

void set_defaults(void)
{
	/*
	 * Mise en place des valeurs par defauts. 
	 * Elle sont ici afin d'etre resettables
	 */
	clu_burst.rest_pot	       = -70.;	/* resting  potential du cluster	*/
	clu_burst.freq_spike	       = 30.;	/* Freq des spikes			*/
	clu_burst.freq_max             = 150.;	/* freq maxima		                */
	clu_burst.compose_fact	       = 2.;	/* facteur de composition 		*/
	clu_burst.duree_burst_min      = 50.;	/* duree min d un burst        	        */
	clu_burst.duree_burst_max      = 150.;	/* duree max d un burst		        */
	clu_burst.tau_mb_pot	       = 10.;	/* cste de temps de la mb		*/
	clu_burst.seuil		       = -65.;	/* firing threshold par cluster		*/
	clu_burst.seuil_burst	       = -55.;	/* firing threshold par cluster		*/
	clu_burst.epsp		       = .5;	/* taille d'un epsp			*/
	clu_burst.ipsp		       = 0.;	/* taille d'un ipsp			*/
	clu_burst.capacite             = 5.;    /* capacite (pour le filtrage )         */
	clu_burst.resistance           = 5.;    /* resistance (pour le filtrage )       */
	clu_burst.pot_post_spike       = -85.;	/* Pot mb post spike			*/
	clu_burst.burst_post_spike     = -60.;	/* Pot mb post spike			*/
	clu_burst.seuil_post_spike     = 20.;	/* seuil apres un spike			*/
	clu_burst.E_K 		       = -90.;	/* Potentiel d'equilibre du potassium	*/
	clu_burst.E_Na		       = 65.;	/* Potentiel d'equilibre du sodium	*/
	clu_burst.rev_pot_pos	       = 0.;	/* Reversal Potential positif (pour epsp)*/
	clu_burst.rev_pot_neg	       = -90.;	/* Resersal Potential negatif (pour ipsp)*/
	clu_burst.tau_seuil	       = 20.;	/* cste de temps du seuil apres un spike */
	clu_burst.epsp_sd	       = 0.;	/* variabilite d'un epsp		*/
	clu_burst.tau_attack_epsp      = 2.;	/* conste de temps de montee		*/
	clu_burst.tau_decay_epsp       = 5.;	/* conste de temps de descente		*/
	clu_burst.ipsp_sd	       = 0.;	/* variabilite d'un ipsp		*/
	clu_burst.tau_attack_ipsp      = 2.;	/* conste de temps de montee		*/
	clu_burst.tau_decay_ipsp       = 5.;	/* conste de temps de descente		*/
	clu_burst.shunt_tau	       = 20.;	/* constante de temps du shunt de la mb */
	if (less_fatigue)
	  clu_burst.fatigue              = 1.;  /* fatigue du seuil                     */
	else 
	  clu_burst.fatigue              = 0.;  /* fatigue du seuil                     */
	clu_burst.capacite             = 1.;    /* capacite pour le filtre              */
	clu_burst.resistance           = 10.;   /* resistance pour le filtre            */

	input_e_fact	               = 5.;	/* nb de boutons pour avoir le spike	*/
	input_i_fact	               = 5.;	/* nb de boutons pour avoir le spike	*/

	backgrd_noise_m                = 0.;	/* bruit (moyenne)                      */
	backgrd_noise_sd               = 0.;	/* bruit (sd)                           */

	time_step = 1.;
	time_step                      = 1.;
	sim_duration                   = 500.;
	center_noise                   = 0.;

	clu_burst.burst_range = clu_burst.duree_burst_max - clu_burst.duree_burst_min; 

	nb_points = (sim_duration / time_step) + 1;
	realloc_mem(nb_points);


} /* fin du set */

/***********************************************************/
XtCallbackProc FileSaveOK (w, client_data, callback_data)
Widget   w;
char *client_data;
XmSelectionBoxCallbackStruct *callback_data;
{

	strcpy(f_neur_old, f_neur);
	strcat(f_neur_old, ".bak");
	fprintf(stderr,"\007The old version was %s\n",f_neur);
	fprintf(stderr,"\007It is kept under the name: %s\n",f_neur_old);

	sprintf(buffer,"cp %s %s",f_neur,f_neur_old);
	system(buffer);
    
	if ((p_neur = fopen(f_neur,"w")) == NULL)
	{
		fprintf(stderr,"\007Impossible to create %s. Sorry. Try the option Save as...!\n",f_neur);
	} /* fin du if */
	else
	{
		write_neuron();
		fclose(p_neur);
	} /* fin du else */
} /* fin du FileSaveOK */

/***********************************************************/
XtCallbackProc FileSaveAsOK (w, client_data, callback_data)
Widget   w;
char *client_data;
XmSelectionBoxCallbackStruct *callback_data;
{
	char	textstr[256],
		*pc;
	void	extract_normal_string();


	extract_normal_string (callback_data->value, textstr);

	if (pc = strchr(textstr,'.'))
	{
		*pc = 0;
	} /* fin du if */
	if (bum_type)
	  strcat(textstr,".B_unit");
	if (lim_type)
	  strcat(textstr,".L_unit");
	if (pum_type)
	  strcat(textstr,".P_unit");

	strcpy (f_neur, textstr);
    
	if ((p_neur = fopen(f_neur,"w")) == NULL)
	{
		fprintf(stderr,"\007Impossible to create %s. Sorry. Try an other name or directory\n",f_neur);
	} /* fin du if */
	else
	{
		XtUnmanageChild (FileSaveAsDialog);
		XtUnmanageChild (FileSaveAsSelection);
		write_neuron();
		fclose(p_neur);
	} /* fin du else */
} /* fin du FileSaveAsOK */

/***********************************************************/
/* Change parameters of neurons				   */
/***********************************************************/
XtCallbackProc ChangeParametre (w, client_data, call_data)
Widget   w;
XtPointer  client_data,
         call_data;
{
	XtManageChild(ParameterChange);
	XtManageChild(scale1);
	XtManageChild(scale2);
	XtManageChild(scale3);
	XtManageChild(scale4);
	XtManageChild(scale5);
	XtManageChild(scale6);
	XtManageChild(scale7);
	XtManageChild(scale8);
	XtManageChild(scale9);
	XtManageChild(scale10);
	XtManageChild(scale11);
	XtManageChild(scale12);
	XtManageChild(scale13);
	XtManageChild(scale14);
	XtManageChild(scale15);
	XtManageChild(scale16);
	XtManageChild(scale17);
	XtManageChild(scale18);
	XtManageChild(scale19);
	XtManageChild(scale20);
	XtManageChild(scale35);
	XtManageChild(scale36);

	XtManageChild(TimeDialog);
	XtManageChild(Time1);
	XtManageChild(scale21);
	XtManageChild(scale22);
	XtManageChild(scale23);
	XtManageChild(scale24);
	XtManageChild(scale25);
	XtManageChild(scale26);
	XtManageChild(scale27);
	XtManageChild(scale28);
	XtManageChild(scale29);
	XtManageChild(scale30);
	XtManageChild(scale31);
	XtManageChild(scale32);
	XtManageChild(scale33);
	XtManageChild(scale34);


	XtManageChild(toggle2);
	XtManageChild(toggle3);
	XtManageChild(toggle4);

	XtManageChild(Toggle4P);
	XtManageChild(Toggle4L);
	XtManageChild(Toggle4B);
}
/***********************************************************/
/* Redraw the neuron					   */
/***********************************************************/
XtCallbackProc RedrawNeuron (w, client_data, call_data)
Widget   w;
XtPointer  client_data,
         call_data;
{
	DrawNeuron(w);
}
/***********************************************************/
/* Resize the drawing window                               */
/***********************************************************/
XtCallbackProc ResizeWorkRegion (w, client_data, call_data)
Widget   w;
XtPointer  client_data,
         call_data;
{
	DrawNeuron(w);
}

/***********************************************************/
/* Change sim_duration value				   */
/***********************************************************/
XtCallbackProc NewSimDuration (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	sim_duration = cbs->value;
        nb_points = (sim_duration / time_step) + 1;
	realloc_mem(nb_points);
	DrawNeuron(w);
}

/***********************************************************/
/* Change rest_pot value				   */
/***********************************************************/
XtCallbackProc NewRestPot (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
  Arg   wargs[4];

  clu_burst.rest_pot = cbs->value;

  while (clu_burst.rest_pot==clu_burst.rev_pot_neg || 
	 clu_burst.rest_pot==clu_burst.rev_pot_pos)
    {
      if (clu_burst.rest_pot==-100)
	clu_burst.rest_pot = clu_burst.rest_pot + 1;
      else
	clu_burst.rest_pot = clu_burst.rest_pot - 1;
      
      XtSetArg(wargs[0], XmNvalue,clu_burst.rest_pot );
      XtSetValues(scale1,wargs,1);
    }	

  file_saved=FALSE;
	

  DrawNeuron(w);
}


/***********************************************************/
/* Change filter_noise value				   */
/***********************************************************/
XtCallbackProc NewNoiseFilter (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	filter_noise = !filter_noise;
	if (filter_noise)
	{
	  XtSetSensitive(scale13,True);
          XtSetSensitive(form_Resistance,True);
	  XtSetSensitive(label_Resistance,True);
	}
	else
	{
	  XtSetSensitive(scale13,False);
          XtSetSensitive(form_Resistance,False);
	  XtSetSensitive(label_Resistance,False);
	}
	DrawNeuron(w);
}
/***********************************************************/
/* Change fatigue_type value				   */
/***********************************************************/
XtCallbackProc NewFatigueTjrs (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	less_fatigue = !less_fatigue;

	DrawNeuron(w);
}
/***********************************************************/
/* Change values to defaults value			   */
/***********************************************************/
XtCallbackProc BackToDefaults (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	set_defaults();
	update_scales();

	DrawNeuron(w);
}
/***********************************************************/
/* Change model type flag and update			   */
/***********************************************************/
XtCallbackProc callback_toggle_model (w, client_data, cbs)
Widget   w;
/* XtPointer  client_data; */
int client_data;
XmScaleCallbackStruct *cbs;
{
    Arg     args[MAX_ARGS];
    XmString title;

    switch(client_data)
    {
         case 0:
	   pum_type = True;
	   lim_type = False;
	   bum_type = False;
	   XmToggleButtonSetState(Toggle4P,True,False);
	   XmToggleButtonSetState(Toggle4L,False,False);
	   XmToggleButtonSetState(Toggle4B,False,False);
	   	   
	   title = XmStringLtoRCreate ("Model [P_unit]", XmSTRING_DEFAULT_CHARSET);
	   XtSetArg(args[0], XmNlabelString, title); 
	   XtSetValues(MenuBtn4,args,1);
	   break;
         case 1:
	   pum_type = False;
	   lim_type = True;
	   bum_type = False;
	   XmToggleButtonSetState(Toggle4P,False,False);
	   XmToggleButtonSetState(Toggle4L,True,False);
	   XmToggleButtonSetState(Toggle4B,False,False);

	   title = XmStringLtoRCreate ("Model [L_unit]", XmSTRING_DEFAULT_CHARSET);
	   XtSetArg(args[0], XmNlabelString, title); 
	   XtSetValues(MenuBtn4,args,1);
	   break;
         case 2:
	   pum_type = False;
	   lim_type = False;
	   bum_type = True;
	   XmToggleButtonSetState(Toggle4P,False,False);
	   XmToggleButtonSetState(Toggle4L,False,False);
	   XmToggleButtonSetState(Toggle4B,True,False);

	   title = XmStringLtoRCreate ("Model [B_unit]", XmSTRING_DEFAULT_CHARSET);
	   XtSetArg(args[0], XmNlabelString, title); 
	   XtSetValues(MenuBtn4,args,1);
	   break;
    }

    XmStringFree(title);
	if (bum_type)
	{
	  XtSetSensitive(scale2,True);	  
	  XtSetSensitive(scale3,True);	  
	  XtSetSensitive(scale4,True);	  
	  XtSetSensitive(scale5,True);	  
	  XtSetSensitive(scale6,True);	  
	  XtSetSensitive(scale14,True);	  
	  XtSetSensitive(scale15,True);	  
	  XtSetSensitive(scale16,True);	  
	  XtSetSensitive(scale30,True);
	  XtSetSensitive(scale31,True);
	  XtSetSensitive(scale32,True);
	  XtSetSensitive(scale33,True);
	  XtSetSensitive(scale34,True);
	  XtSetSensitive(scale35,True);
          XtSetSensitive(form_Burst_thr,True);
	  XtSetSensitive(label_Burst_thr,True);
	  XtSetSensitive(form_freq_spike,True);
	  XtSetSensitive(label_freq_spike,True);
	  XtSetSensitive(form_freq_max,True);
	  XtSetSensitive(label_freq_max,True);
	  XtSetSensitive(form_compose_fact,True);
	  XtSetSensitive(label_compose_fact,True);
	  XtSetSensitive(form_duree_burst_min,True);
	  XtSetSensitive(label_duree_burst_min,True);
	  XtSetSensitive(form_duree_burst_max,True);
	  XtSetSensitive(label_duree_burst_max,True);
	  XtSetSensitive(form_Burst_post_spike,True);
	  XtSetSensitive(label_Burst_post_spike,True);
	}
	if (lim_type)
	{
	  XtSetSensitive(scale2,False);	  
	  XtSetSensitive(scale3,False);	  
	  XtSetSensitive(scale4,False);	  
	  XtSetSensitive(scale5,False);	  
	  XtSetSensitive(scale6,False);	  
	  XtSetSensitive(scale14,False);	  
	  XtSetSensitive(scale15,False);	  
	  XtSetSensitive(scale16,False);	  
	  XtSetSensitive(scale30,False);
	  XtSetSensitive(scale31,False);
	  XtSetSensitive(scale32,False);
	  XtSetSensitive(scale33,False);
	  XtSetSensitive(scale34,False);
	  XtSetSensitive(scale35,False);
          XtSetSensitive(form_Burst_thr,False);
	  XtSetSensitive(label_Burst_thr,False);
	  XtSetSensitive(form_freq_spike,False);
	  XtSetSensitive(label_freq_spike,False);
	  XtSetSensitive(form_freq_max,False);
	  XtSetSensitive(label_freq_max,False);
	  XtSetSensitive(form_compose_fact,False);
	  XtSetSensitive(label_compose_fact,False);
	  XtSetSensitive(form_duree_burst_min,False);
	  XtSetSensitive(label_duree_burst_min,False);
	  XtSetSensitive(form_duree_burst_max,False);
	  XtSetSensitive(label_duree_burst_max,False);
	  XtSetSensitive(form_Burst_post_spike,False);
	  XtSetSensitive(label_Burst_post_spike,False);
	}
	if (pum_type)
	{
	  XtSetSensitive(scale2,False);	  
	  XtSetSensitive(scale3,False);	  
	  XtSetSensitive(scale4,False);	  
	  XtSetSensitive(scale5,False);	  
	  XtSetSensitive(scale6,False);	  
	  XtSetSensitive(scale14,False);	  
	  XtSetSensitive(scale15,True);	  
	  XtSetSensitive(scale16,True);	  
	  XtSetSensitive(scale30,True);
	  XtSetSensitive(scale31,True);
	  XtSetSensitive(scale32,True);
	  XtSetSensitive(scale33,True);
	  XtSetSensitive(scale34,True);
	  XtSetSensitive(scale35,False);
          XtSetSensitive(form_Burst_thr,False);
	  XtSetSensitive(label_Burst_thr,False);
	  XtSetSensitive(form_freq_spike,False);
	  XtSetSensitive(label_freq_spike,False);
	  XtSetSensitive(form_freq_max,False);
	  XtSetSensitive(label_freq_max,False);
	  XtSetSensitive(form_compose_fact,False);
	  XtSetSensitive(label_compose_fact,False);
	  XtSetSensitive(form_duree_burst_min,False);
	  XtSetSensitive(label_duree_burst_min,False);
	  XtSetSensitive(form_duree_burst_max,False);
	  XtSetSensitive(label_duree_burst_max,False);
	  XtSetSensitive(form_Burst_post_spike,False);
	  XtSetSensitive(label_Burst_post_spike,False);
	}
	DrawNeuron(w);
}

/***********************************************************/
/* Change freq_spike value				   */
/***********************************************************/
XtCallbackProc NewFreqSpike (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
        Arg  args[5];

	clu_burst.freq_spike = cbs->value;
	XtSetArg(args[0], XmNminimum, cbs->value); 
	XtSetValues(scale3,args,1);
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change fatigue value		        		   */
/***********************************************************/
XtCallbackProc NewFatigue (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.fatigue = cbs->value/10.;
	file_saved=FALSE;

	DrawNeuron(w);
}


/***********************************************************/
/* Change seuil value	        			   */
/***********************************************************/
XtCallbackProc NewSeuil (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.seuil = cbs->value;
	file_saved=FALSE;

	DrawNeuron(w);
}
/***********************************************************/
/* Change seuil_burst value				   */
/***********************************************************/
XtCallbackProc NewSeuilBurst (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
  Arg  args[5];

	clu_burst.seuil_burst = cbs->value;
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change freq_max value				   */
/***********************************************************/
XtCallbackProc NewFreqMax (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
  Arg  args[5];

	clu_burst.freq_max = cbs->value;
	XtSetArg(args[0], XmNmaximum, cbs->value); 
	XtSetValues(scale2,args,1);
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change epsp value				           */
/***********************************************************/
XtCallbackProc NewEpsp (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.epsp = cbs->value/100.;
	file_saved=FALSE;

	DrawNeuron(w);
}


/***********************************************************/
/* Change ipsp value				           */
/***********************************************************/
XtCallbackProc NewIpsp (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.ipsp = cbs->value/100.;
	file_saved=FALSE;

	DrawNeuron(w);
}
/***********************************************************/
/* Change compose_fact value				   */
/***********************************************************/
XtCallbackProc NewComposeFact (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.compose_fact = cbs->value/100.;
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change  duree_burst_min value			   */
/***********************************************************/
XtCallbackProc NewDureeBurstMin (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
  Arg  args[5];

	clu_burst.duree_burst_min = cbs->value/10.;
	clu_burst.burst_range = clu_burst.duree_burst_max - clu_burst.duree_burst_min; 
#if DEBUG_BURST
  printf("CBDureeMin Range: %f\n", clu_burst.burst_range);
#endif

	XtSetArg(args[0], XmNminimum, cbs->value); 
	XtSetValues(scale6,args,1);
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change  duree_burst_max value			   */
/***********************************************************/
XtCallbackProc NewDureeBurstMax (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
  Arg  args[5];

	clu_burst.duree_burst_max = cbs->value/10.;
	clu_burst.burst_range = clu_burst.duree_burst_max - clu_burst.duree_burst_min; 
#if DEBUG_BURST
  printf("CBDureeMax Range: %f\n", clu_burst.burst_range);
#endif

	XtSetArg(args[0], XmNmaximum, cbs->value); 
	XtSetValues(scale5,args,1);
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change ipsp_sd value				           */
/***********************************************************/
XtCallbackProc NewIpspSd (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.ipsp_sd = cbs->value/100.;
	file_saved=FALSE;

	DrawNeuron(w);
}


/***********************************************************/
/* Change capacity value				   */
/***********************************************************/
XtCallbackProc NewResistance (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.resistance = cbs->value/100.;
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* fermeture de la fenetre Echelle			   */
/***********************************************************/
void callback_close_Echelle(Widget w, XtPointer c1, XtPointer c2)
{
  XtDestroyWidget(EchelleChange);
  flag_echelle=0;
}


/***********************************************************/
/* Change time_step value				   */
/***********************************************************/
XtCallbackProc NewTimeStep (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	time_step = cbs->value/1000.;

        nb_points = (sim_duration / time_step) + 1;
	realloc_mem(nb_points);
	DrawNeuron(w);
}


/***********************************************************/
/* Change rev_pot_pos value				   */
/***********************************************************/
XtCallbackProc NewRevPotPos (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
  Arg   wargs[4];

  clu_burst.rev_pot_pos = cbs->value;
  
  while (clu_burst.rev_pot_pos==clu_burst.rev_pot_neg || 
	 clu_burst.rev_pot_pos==clu_burst.rest_pot)
    {
    if (clu_burst.rev_pot_pos==-150)
      clu_burst.rev_pot_pos = clu_burst.rev_pot_pos + 1;
    else
      clu_burst.rev_pot_pos = clu_burst.rev_pot_pos - 1;

    XtSetArg(wargs[0], XmNvalue,clu_burst.rev_pot_pos );
    XtSetValues(scale16,wargs,1);
    }


  file_saved=FALSE;

  DrawNeuron(w);
}

/***********************************************************/
/* Change rev_pot_neg value				   */
/***********************************************************/
XtCallbackProc NewRevPotNeg (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
  Arg   wargs[4];

  clu_burst.rev_pot_neg = cbs->value;

  while (clu_burst.rev_pot_neg==clu_burst.rev_pot_pos || 
	 clu_burst.rev_pot_neg==clu_burst.rest_pot)
    {
    if (clu_burst.rev_pot_neg==-150)
      clu_burst.rev_pot_neg = clu_burst.rev_pot_neg + 1;
    else
      clu_burst.rev_pot_neg = clu_burst.rev_pot_neg -1;

    XtSetArg(wargs[0], XmNvalue,clu_burst.rev_pot_neg );
    XtSetValues(scale15,wargs,1);
    }


  file_saved=FALSE;
  
  DrawNeuron(w);
}
/***********************************************************/
/* Change input_e_fact value				   */
/***********************************************************/
XtCallbackProc NewButtonENb (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	input_e_fact = cbs->value;
	DrawNeuron(w);
}

/***********************************************************/
/* Change input_i_fact value				   */
/***********************************************************/
XtCallbackProc NewButtonINb (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	input_i_fact = cbs->value;
	DrawNeuron(w);
}

/***********************************************************/
/* Change noise mean value				   */
/***********************************************************/
XtCallbackProc NoiseMean (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	backgrd_noise_m = cbs->value/1000.;

	DrawNeuron(w);
}


/***********************************************************/
/* Change noise sd value				   */
/***********************************************************/
XtCallbackProc NoiseSd (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	backgrd_noise_sd = cbs->value/1000.;

	DrawNeuron(w);
}

/***********************************************************/
/* Change tau_mb_pot value				   */
/***********************************************************/
XtCallbackProc NewTauMbPot (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.tau_mb_pot = (float)cbs->value / 10.;
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change tau_seuil value				   */
/***********************************************************/
XtCallbackProc NewTauSeuil (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.tau_seuil = (float) cbs->value / 10.;
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change EpspsArr1 value				   */
/***********************************************************/
XtCallbackProc NewEpspArr1 (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	EpspArr1 = (float) cbs->value ;
	DrawNeuron(w);
}

/***********************************************************/
/* Change  EpspsArr2 value				   */
/***********************************************************/
XtCallbackProc NewEpspArr2 (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	 EpspArr2 = (float) cbs->value;
	DrawNeuron(w);
}

/***********************************************************/
/* Change EpspArr value			        	   */
/***********************************************************/
XtCallbackProc NewEpspArr3 (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	EpspArr3 = (float) cbs->value;
	DrawNeuron(w);
}


/***********************************************************/
/* Change IpspArr1 value				   */
/***********************************************************/
XtCallbackProc NewIpspArr1 (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	IpspArr1 = (float) cbs->value ;
	DrawNeuron(w);
}

/***********************************************************/
/* Change  IpspsArr2 value				   */
/***********************************************************/
XtCallbackProc NewIpspArr2 (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	 IpspArr2 = (float) cbs->value;
	DrawNeuron(w);
}

/***********************************************************/
/* Change IpspArr3 value				   */
/***********************************************************/
XtCallbackProc NewIpspArr3 (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	IpspArr3 = (float) cbs->value;
	DrawNeuron(w);
}

/***********************************************************/
/* Change dynamic_change value				   */
/***********************************************************/
XtCallbackProc DynamicChange (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	dynamic_change = !dynamic_change;
	if (dynamic_change)
	{
	  XtAddCallback(scale23, XmNdragCallback, (XtCallbackProc) NewEpspArr1, (XtPointer)NULL);
	  XtAddCallback(scale25, XmNdragCallback, (XtCallbackProc) NewEpspArr2, (XtPointer)NULL);
	  XtAddCallback(scale27, XmNdragCallback, (XtCallbackProc) NewEpspArr3, (XtPointer)NULL);
	  XtAddCallback(scale24, XmNdragCallback, (XtCallbackProc) NewIpspArr1, (XtPointer)NULL);
	  XtAddCallback(scale26, XmNdragCallback, (XtCallbackProc) NewIpspArr2, (XtPointer)NULL);
	  XtAddCallback(scale28, XmNdragCallback, (XtCallbackProc) NewIpspArr3, (XtPointer)NULL);	  
	}
	else
	{
	  XtRemoveCallback(scale23, XmNdragCallback, (XtCallbackProc) NewEpspArr1, (XtPointer)NULL);
	  XtRemoveCallback(scale25, XmNdragCallback, (XtCallbackProc) NewEpspArr2, (XtPointer)NULL);
	  XtRemoveCallback(scale27, XmNdragCallback, (XtCallbackProc) NewEpspArr3, (XtPointer)NULL);
	  XtRemoveCallback(scale24, XmNdragCallback, (XtCallbackProc) NewIpspArr1, (XtPointer)NULL);
	  XtRemoveCallback(scale26, XmNdragCallback, (XtCallbackProc) NewIpspArr2, (XtPointer)NULL);
	  XtRemoveCallback(scale28, XmNdragCallback, (XtCallbackProc) NewIpspArr3, (XtPointer)NULL);	  
	}
	DrawNeuron(w);
}

/***********************************************************/
/* Change pot_post_spike value				   */
/***********************************************************/
XtCallbackProc NewPotPostSpike (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.pot_post_spike = cbs->value;
	file_saved=FALSE;
	
	DrawNeuron(w);
}


/***********************************************************/
/* Change burst_post_spike value			   */
/***********************************************************/
XtCallbackProc NewBurstPostSpike (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.burst_post_spike = cbs->value;
	file_saved=FALSE;

	DrawNeuron(w);
}


/***********************************************************/
/* Change seuil_post_spike value			   */
/***********************************************************/
XtCallbackProc NewSeuilPostSpike (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.seuil_post_spike = cbs->value;
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change tau_attack_epsp value				   */
/***********************************************************/
XtCallbackProc NewTauEpspPlus (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.tau_attack_epsp = (float) cbs->value / 10.;
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change tau_decay_epsp value				   */
/***********************************************************/
XtCallbackProc NewTauEpspMoins (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.tau_decay_epsp = (float) cbs->value / 10.;
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change tau_attack_ipsp value				   */
/***********************************************************/
XtCallbackProc NewTauIpspPlus (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.tau_attack_ipsp = (float) cbs->value / 10.;
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change Max value of the scale      			   */
/***********************************************************/
void ChangeMax(w, client_data, cbs)
     Widget   w;
     XtPointer  client_data;
     XmScaleCallbackStruct *cbs;
{
  Arg   wargs[4]; 
  
  Max_Y = (float)(cbs->value);
  if (Max_Y==Min_Y) 
    {
      Max_Y++;
      XtSetArg(wargs[0], XmNvalue,Max_Y );
      XtSetValues(scaleMax,wargs,1);
    }
  XtSetArg(wargs[0], XmNmaximum,Max_Y-1 );
  XtSetValues(scaleMin,wargs,1);
  Max_DDP = Max_Y - Min_Y;
  
  DrawNeuron(w);
}
/***********************************************************/
/* Change Min value of the scale	      		   */
/***********************************************************/
void ChangeMin(w, client_data, cbs)
     Widget   w;
     XtPointer  client_data;
     XmScaleCallbackStruct *cbs;
{
  Arg   wargs[4]; 
  
  Min_Y = (float)(cbs->value);
  if (Min_Y==Max_Y) 
    {
      Min_Y--;
      XtSetArg(wargs[0], XmNvalue,Min_Y );
      XtSetValues(scaleMin,wargs,1);
    }
  XtSetArg(wargs[0], XmNminimum,Min_Y+1 );
  XtSetValues(scaleMax,wargs,1);
  Max_DDP = Max_Y - Min_Y;
  
  DrawNeuron(w);
}


/***********************************************************/
/* Change tau_decay_ipsp value				   */
/***********************************************************/
XtCallbackProc NewTauIpspMoins (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.tau_decay_ipsp = (float) cbs->value / 10.;
	file_saved=FALSE;

	DrawNeuron(w);
}

/***********************************************************/
/* Change shunt_tau value				   */
/***********************************************************/
XtCallbackProc NewShuntTau (w, client_data, cbs)
Widget   w;
XtPointer  client_data;
XmScaleCallbackStruct *cbs;
{
	clu_burst.shunt_tau = (float) cbs->value / 10.;
	file_saved=FALSE;

	DrawNeuron(w);
}


/***********************************************************/
/* Change value of Drawing Area`s Scale		       	   */
/***********************************************************/
XtCallbackProc ChangeScales (w, client_data, cbs)
     Widget   w;
     XtPointer  client_data;
     XmScaleCallbackStruct *cbs;
{
  fabrique_Echelles();
  flag_echelle=1;
  DrawNeuron(w);
}

/***********************************************************/
/*	sauvegarde physique des parametres		   */
/***********************************************************/
write_neuron()
{
        if (bum_type)
		fprintf(p_neur,"ModelType: B\n");
        if (lim_type)
		fprintf(p_neur,"ModelType: L\n");
        if (pum_type)
	        fprintf(p_neur,"ModelType: P\n");
       	fprintf(p_neur,"RestPotential: %.4f\n",clu_burst.rest_pot);
        if (bum_type)
	{
		fprintf(p_neur,"FreqSpike: %.4f\n",clu_burst.freq_spike);
		fprintf(p_neur,"FreqMax: %.4f\n",clu_burst.freq_max);
		fprintf(p_neur,"ComposeFact: %.4f\n",clu_burst.compose_fact);
		fprintf(p_neur,"DureeBurstMin: %.4f\n",clu_burst.duree_burst_min);
		fprintf(p_neur,"DureeBurstMax: %.4f\n",clu_burst.duree_burst_max);
		fprintf(p_neur,"ThresholdBurst: %.4f\n",clu_burst.seuil_burst);
		fprintf(p_neur,"BurstPostSpike: %.4f\n",clu_burst.burst_post_spike);
	}
	fprintf(p_neur,"TimeCsteMbPot: %.4f\n",clu_burst.tau_mb_pot);
	fprintf(p_neur,"Threshold: %.4f\n",clu_burst.seuil);
	fprintf(p_neur,"EpspSize: %.4f\n",clu_burst.epsp);
	fprintf(p_neur,"IpspSize: %.4f\n",clu_burst.ipsp);
	fprintf(p_neur,"NoiseMean: %.4f\n",backgrd_noise_m);
	fprintf(p_neur,"NoiseSd: %.4f\n",backgrd_noise_sd);
	fprintf(p_neur,"NoiseFilter: %d\n",filter_noise);
	fprintf(p_neur,"Capacity: %.10f\n",clu_burst.capacite);
	fprintf(p_neur,"TimeStep: %.3f\n",time_step);
	fprintf(p_neur,"PostSpikePotential: %.4f\n",clu_burst.pot_post_spike);
	fprintf(p_neur,"Adaptation: %.4f\n",clu_burst.seuil_post_spike);
	fprintf(p_neur,"E_K: %.4f\n",clu_burst.E_K);
	fprintf(p_neur,"E_Na: %.4f\n",clu_burst.E_Na);
	fprintf(p_neur,"PosReversalPot: %.4f\n",clu_burst.rev_pot_pos);
	fprintf(p_neur,"NegReversalPot: %.4f\n",clu_burst.rev_pot_neg);
	fprintf(p_neur,"TimeCsteThreshold: %.4f\n",clu_burst.tau_seuil);
	fprintf(p_neur,"EpspSd: %.4f\n",clu_burst.epsp_sd);
	if (!lim_type)
	{
	  fprintf(p_neur,"EpspAttack: %.4f\n",clu_burst.tau_attack_epsp);
	  fprintf(p_neur,"EpspDecay: %.4f\n",clu_burst.tau_decay_epsp);
	}
	fprintf(p_neur,"IpspSd: %.4f\n",clu_burst.ipsp_sd);
	if (!lim_type)
	{
	  fprintf(p_neur,"IpspAttack: %.4f\n",clu_burst.tau_attack_ipsp);
	  fprintf(p_neur,"IpspDecay: %.4f\n",clu_burst.tau_decay_ipsp);
	  fprintf(p_neur,"MembraneShunt: %.4f\n",clu_burst.shunt_tau);
	}
	fprintf(p_neur,"FilterResistance: %.3f\n",clu_burst.resistance);
	fprintf(p_neur,"Fatigue: %.3f\n",clu_burst.fatigue);
	fprintf(p_neur,"LessFatigue: %d\n",less_fatigue);

	file_saved=TRUE;
} /* fin du write_neuron */
/***********************************************************/
Widget CreateCascade (label, mnemonic, submenu, parent)
char       *label,
           mnemonic;
Widget     submenu,
           parent;

{

  Widget   widget;
  int      n;
  Arg      args[MAX_ARGS];
  XmString tcs;

  n = 0;
  tcs = XmStringLtoRCreate (label, XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[n], XmNlabelString, tcs); n++;
  XtSetArg(args[n], XmNmnemonic, mnemonic); n++;
  XtSetArg(args[n], XmNsubMenuId, submenu); n++;
  XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
  XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
  widget = XmCreateCascadeButton (parent, "cascade", args, n);
  XtManageChild(widget);
  XmStringFree(tcs);

  return (widget);
}

/***********************************************************/
Widget CreateDialogShell (parent, say, x, y)
Widget parent;
char *say;
Cardinal x, y;
{

  static   Widget   widget;
  int      n;
  Arg      args[MAX_ARGS];

  n = 0;
  XtSetArg(args[n], XmNwidth, 300); n++;
  XtSetArg(args[n], XmNheight,  300); n++;
  XtSetArg(args[n], XmNx, x); n++;
  XtSetArg(args[n], XmNy, y); n++;
  XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
  XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
  widget = XmCreateDialogShell (parent, say, args, n);

  return (widget);
}

/***********************************************************/
Widget ReadFileSelection (parent, name)
Widget parent;
char *name;
{

  static   Widget   widget;
  int      n;
  Arg      args[MAX_ARGS];

  n = 0;
  XtSetArg(args[n], XmNdefaultPosition, False); n++;
  XtSetArg(args[n], XmNwidth, 450); n++;
  XtSetArg(args[n], XmNheight, 450); n++;
  XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
  XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
  widget = XmCreateFileSelectionBox (parent, name, args, n);


  XtAddCallback (widget, XmNokCallback,  (XtCallbackProc) FileReadOK, (XtPointer)NULL);
  XtAddCallback (widget, XmNcancelCallback, (XtCallbackProc)FileReadFin, (XtPointer)NULL);
  XtAddCallback (widget, XmNhelpCallback, (XtCallbackProc)ReadHelp, (XtPointer)NULL);

  return (widget);
}
/***********************************************************/
Widget SaveAsFileSelection (parent, name)
Widget parent;
char *name;
{

  static   Widget   widget;
  int      n;
  Arg      args[MAX_ARGS];

  n = 0;
  XtSetArg(args[n], XmNdefaultPosition, False); n++;
  XtSetArg(args[n], XmNwidth, 450); n++;
  XtSetArg(args[n], XmNheight, 450); n++;
  XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
  XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
  widget = XmCreateFileSelectionBox (parent, name, args, n);


  XtAddCallback (widget, XmNokCallback, (XtCallbackProc) FileSaveAsOK, (XtPointer)NULL);
  XtAddCallback (widget, XmNcancelCallback, (XtCallbackProc)FileSaveFin, (XtPointer)NULL);
  XtAddCallback (widget, XmNhelpCallback, (XtCallbackProc)SaveHelp, (XtPointer)NULL);

  return (widget);
}

/***********************************************************/
Widget CreatePushButton (label, mnemonic, parent)
char      *label,
          mnemonic;
Widget    parent;

{

  static Widget       widget;
  int          n;
  Arg          args[MAX_ARGS];
  XmString     tcs,
               acc_text;

  n = 0;
  tcs = XmStringLtoRCreate(label, XmSTRING_DEFAULT_CHARSET);
  acc_text = XmStringLtoRCreate("^A", XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[n], XmNmnemonic, mnemonic); n++;
  XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
  XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
  /* if default, extra border */
  if (bit_flag & DEFAULT)
  {
      XtSetArg(args[n], XmNshowAsDefault, 1); n++;
  }
  /* if there is an accelerator associated with the button */
  if (bit_flag & ACCEL)
  {
      XtSetArg(args[n], XmNaccelerator, "Ctrl<Key>A"); n++;
      XtSetArg(args[n], XmNacceleratorText, acc_text);n++;
  }
  /* if the button is inactive; greyed out */
  if (bit_flag & INACTIVE)
  {
      XtSetArg(args[n], XmNsensitive, False); n++;
  }

  widget = XmCreatePushButton(parent, label, args, n);
  XtManageChild(widget);
  XmStringFree(tcs);
  if (bit_flag & ACCEL)
    XmStringFree(acc_text);
  bit_flag = BITSOFF;  

  return(widget);
}


/***************************************************************/
int  main(argc, argv)
int     argc;
char    **argv;
{
    register int           n;
    Arg		args[MAX_ARGS];
    int		i,
		num_items;
    Pixel       fg, bg;
    char	*p_c,
		parametre[50],
		value[30];

    Widget Dummy;
	
    Widget XmCreateScrolledText ();
    /* this will be the contents of the dialog selection box */
    XmString *addrstr, *GetWidgetHierarchy (), title;

    
    XtAppContext app;
    
    bum_type = FALSE;
    lim_type = FALSE;
    pum_type = TRUE;


    p_c = get_simulation_name();
    strcpy(f_neur,p_c);
    strcat(f_neur,".P_unit");
    set_defaults();
    file_saved=TRUE;

    
    strcpy(f_neur_old,f_neur);
    strcat(f_neur_old,".bak");

    MenuBar = (Widget) NULL;
    
#ifndef _HP_SOURCE_
    signal(SIGHUP,  Quit);
    signal(SIGQUIT,  Quit);
#endif
    signal(SIGINT, Quit);


    XtToolkitInitialize();

    app = XtCreateApplicationContext();

    if ((display = XtOpenDisplay (app, NULL, argv[1], "XMclient",
				  NULL, 0, &argc, argv)) == NULL)
    {
	fprintf (stderr,"\n%s:  Can't open display\n", argv[0]);
        exit(1);
    }

	if(argc > 1)
	{
		for (i = 1; i < argc; i++)
		{
			if (argv[i][0] == '?')
			{
				printf(usage,argv[0]);
				exit(1);
			}
			if (argv[i][0] == '-')
			{
				switch (tolower(argv[i][1]))
				{
					case 'h':
						printf(usage,argv[0]);
						exit(1);
					case 'k':
						keep = 'f';
						break;
					case 'v':
						verbose = TRUE;
						break;
					case 'b':
						bum_type = TRUE;
						lim_type = FALSE;
						pum_type = FALSE;
						break;
					case 'l':
						bum_type = FALSE;
						lim_type = TRUE;
						pum_type = FALSE;
						break;
					case 'p':
						bum_type = FALSE;
						lim_type = FALSE;
						pum_type = TRUE;
						break;
					default:
						printf("%s --> -%c illegal switch\n",argv[0],argv[i][1]);
						printf(usage,argv[0]);
						exit(1);
				}
			}
#if 0
			else
			{
#if 0
				strcpy (buffer, argv[i]);
#endif
				strcpy (buffer, get_simulation_name());
#if !SYSTEM_VMS
				if (bum_type)
				  sprintf(f_neur,"%s.B_unit",buffer);
				if (lim_type)
				  sprintf(f_neur,"%s.L_unit",buffer);
				if (pum_type)
				  sprintf(f_neur,"%s.P_unit",buffer);
				if (verbose) printf ("Filename of neurone = %s\n",
						     f_neur);
#if 0
				strcpy(pattern,argv[i]);
#endif
				strcpy(pattern, get_simulation_name());
#if 0
				p_c = strrchr(pattern,'/');
				if (p_c)
				{
					p_c++;
					*p_c = 0; /* supprime le nom */
				} /* fin du if */
#endif
#endif
				if (verbose) 
				  printf ("Pattern: %s\n",
						     pattern);

				strcpy(f_neur_old,f_neur);
				strcat(f_neur_old,".bak");

				if (p_neur = fopen(f_neur,"r"))	/* Si il existe, on le sauve en .bak */
				{
					set_defaults();
					read_P_unit(p_neur);
					fclose(p_neur);
				} /* fin du if */
				else
				{
					fprintf(stderr,"\007File %s does not exists\n",f_neur);
				} /* fin du else */

			} /* fin du else */
#endif
		}
			
	} /* fin du if */

	screen = DefaultScreen(display);

	screen_width = DisplayWidth(display,screen);
	screen_height = DisplayHeight(display,screen);

	largeur = (Dimension)(.42 * screen_width);
	hauteur = (Dimension)(.72 * screen_height);


        if (bum_type)
	  sprintf(buffer,"B_neuron %s: %s", VERSION, f_neur);
        if (lim_type)
	  sprintf(buffer,"L_neuron %s: %s", VERSION, f_neur);
        if (pum_type)
	  sprintf(buffer,"P_neuron %s: %s", VERSION, f_neur);

	n = 0;
	XtSetArg(args[n], XmNwidth,  largeur);  n++;
#if SCIENCE_ACTIVE
	XtSetArg(args[n], XmNheight, (Dimension)(.75 * hauteur)  );  n++;
#else
	XtSetArg(args[n], XmNheight, hauteur );  n++;
#endif
	XtSetArg(args[n], XmNallowShellResize, True);  n++;
	XtSetArg(args[n], XmNtitle, buffer);  n++;
	XtSetArg(args[n], XmNx, 0);n++;
	XtSetArg(args[n], XmNy, 0);n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
	XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	strcpy(shell_name,argv[0]);
	strcat(shell_name,VERSION);
	Shell = XtAppCreateShell(shell_name, NULL, applicationShellWidgetClass,
                              display, args, n);

	n = 0;
	XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
	XtSetArg(args[n], XmNx, 0);n++;
	XtSetArg(args[n], XmNy, 0);n++;
	MainWindow = XmCreateMainWindow(Shell, "MainWindow", args, n);
	XtManageChild(MainWindow);

	n = 0;
	XtSetArg(args[n], XmNwidth,  largeur);  n++;
	XtSetArg(args[n], XmNheight, hauteur);  n++;
	XtSetArg(args[n], XmNresizePolicy,XmRESIZE_ANY);  n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
	XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNx, 0);n++;
	XtSetArg(args[n], XmNy, 0);n++;
	WorkRegion = XmCreateDrawingArea (MainWindow, "s_text", args, n);
	XtManageChild (WorkRegion);

    
	CreateMenuBar();

	FileReadDialog = CreateDialogShell (Shell, "Select an Input File Name",300,300);
	FileReadSelection = ReadFileSelection (FileReadDialog, "Select Input File"); 
	FileSaveAsDialog = CreateDialogShell (Shell, "Select an Output File Name",300,300);
	FileSaveAsSelection = SaveAsFileSelection (FileSaveAsDialog, "Select Output File"); 

	/* Menu des parametres */


	fabrique_fenetreParametre ();
	
	/* Les temps maintenant... */

	n = 0;
	XtSetArg(args[n], XmNwidth, screen_width); n++;
	XtSetArg(args[n], XmNheight,  (Dimension)(.2 * screen_height)); n++;
	XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
	XtSetArg(args[n], XmNtitle, "Time Parameters"); n++;
	XtSetArg(args[n], XmNx, 0); n++;
	XtSetArg(args[n], XmNy, (screen_height - (Dimension)(.2 * screen_height))); n++;
/*
	TimeDialog = XtAppCreateShell("shell_temps", NULL, applicationShellWidgetClass,
                              display, args, n);
*/
	TimeDialog = XmCreateDialogShell (Shell, "Time Parameters",  args, n);
	/* creation d'une ScrolledWindow pour les parametres de temps */
	/* regle la taille d'affichage */

	n = 0;
	XtSetArg(args[n], XmNborderWidth, 1);n++;
	XtSetArg(args[n], XmNheight, (Dimension)(screen_height * .2 ));n++;
	XtSetArg(args[n], XmNwidth, (Dimension)screen_width);n++;
	XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
	XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmAUTOMATIC);n++;
	XtSetArg(args[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
	Scrolled_Window_Time = XtCreateManagedWidget("scrolledtime",
						     xmScrolledWindowWidgetClass,
						     TimeDialog,
						     args, n);

	Time1 = XtVaCreateWidget("TimeChange",xmRowColumnWidgetClass,
					   Scrolled_Window_Time,
					   XmNadjustLast, False,
                                           XmNforeground, BlackPixel(display, screen),
					   XmNbackground, WhitePixel(display, screen),
					   XmNpacking, XmPACK_COLUMN,
					   XmNnumColumns, 7,
					   XmNorientation, XmVERTICAL,
					   NULL);

	titre = XmStringLtoRCreate ("Simulation Duration (ms)", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 100); n++;
	XtSetArg(args[n], XmNmaximum, 10000); n++;
	XtSetArg(args[n], XmNdecimalPoints, 0); n++;
	XtSetArg(args[n], XmNvalue, (int)(sim_duration)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale21 = XmCreateScale(Time1,"SimDur",args,n);
	XtAddCallback(scale21, XmNvalueChangedCallback, (XtCallbackProc) NewSimDuration, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("Mb Pot Time Cste", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 1); n++;
	XtSetArg(args[n], XmNmaximum,  1000); n++;
	XtSetArg(args[n], XmNdecimalPoints, 1); n++;
	XtSetArg(args[n], XmNvalue,(int)(clu_burst.tau_mb_pot * 10.)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale22 = XmCreateScale(Time1,"TauMbPot",args,n);
	XtAddCallback(scale22, XmNvalueChangedCallback, (XtCallbackProc) NewTauMbPot, (XtPointer)NULL);


	titre = XmStringLtoRCreate ("EPSP 1 arrival in %", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 0); n++;
	XtSetArg(args[n], XmNmaximum, 100); n++;
	XtSetArg(args[n], XmNdecimalPoints, 0); n++;
	XtSetArg(args[n], XmNvalue, (int)(EpspArr1)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale23 = XmCreateScale(Time1,"EPSPArr1",args,n);
	XtAddCallback(scale23, XmNvalueChangedCallback, (XtCallbackProc) NewEpspArr1, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("IPSP 1 arrival in %", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 0); n++;
	XtSetArg(args[n], XmNmaximum, 100); n++;
	XtSetArg(args[n], XmNdecimalPoints, 0); n++;
	XtSetArg(args[n], XmNvalue, (int)(IpspArr1)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale24 = XmCreateScale(Time1,"IPSPArr1",args,n);
	XtAddCallback(scale24, XmNvalueChangedCallback, (XtCallbackProc) NewIpspArr1, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("EPSP 2 arrival in %", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 0); n++;
	XtSetArg(args[n], XmNmaximum, 100); n++;
	XtSetArg(args[n], XmNdecimalPoints, 0); n++;
	XtSetArg(args[n], XmNvalue, (int)(EpspArr2)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale25 = XmCreateScale(Time1,"EPSPArr2",args,n);
	XtAddCallback(scale25, XmNvalueChangedCallback, (XtCallbackProc) NewEpspArr2, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("IPSP 2 arrival in %", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 0); n++;
	XtSetArg(args[n], XmNmaximum, 100); n++;
	XtSetArg(args[n], XmNdecimalPoints, 0); n++;
	XtSetArg(args[n], XmNvalue, (int)(IpspArr2)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale26 = XmCreateScale(Time1,"IPSPArr2",args,n);
	XtAddCallback(scale26, XmNvalueChangedCallback, (XtCallbackProc) NewIpspArr2, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("EPSP 3 arrival in %", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 0); n++;
	XtSetArg(args[n], XmNmaximum, 100); n++;
	XtSetArg(args[n], XmNdecimalPoints, 0); n++;
	XtSetArg(args[n], XmNvalue, (int)(EpspArr3)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale27 = XmCreateScale(Time1,"EPSPArr3",args,n);
	XtAddCallback(scale27, XmNvalueChangedCallback, (XtCallbackProc) NewEpspArr3, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("IPSP 3 arrival in %", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 0); n++;
	XtSetArg(args[n], XmNmaximum, 100); n++;
	XtSetArg(args[n], XmNdecimalPoints, 0); n++;
	XtSetArg(args[n], XmNvalue, (int)(IpspArr3)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale28 = XmCreateScale(Time1,"IPSPArr3",args,n);
	XtAddCallback(scale28, XmNvalueChangedCallback, (XtCallbackProc) NewIpspArr3, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("EPSP Attack Time Cste", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 1); n++;
	XtSetArg(args[n], XmNmaximum,  1000); n++;
	XtSetArg(args[n], XmNdecimalPoints, 1); n++;
	XtSetArg(args[n], XmNvalue, (int)(clu_burst.tau_attack_epsp*10.)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale30 = XmCreateScale(Time1,"TauEpspPlus",args,n);
	XtAddCallback(scale30, XmNvalueChangedCallback, (XtCallbackProc) NewTauEpspPlus, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("EPSP Decay Time Cste", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 1); n++;
	XtSetArg(args[n], XmNmaximum,  1000); n++;
	XtSetArg(args[n], XmNdecimalPoints, 1); n++;
	XtSetArg(args[n], XmNvalue, (int)(clu_burst.tau_decay_epsp * 10.)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale31 = XmCreateScale(Time1,"TauEpspMoins",args,n);
	XtAddCallback(scale31, XmNvalueChangedCallback, (XtCallbackProc) NewTauEpspMoins, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("IPSP Attack Time Cste", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 1); n++;
	XtSetArg(args[n], XmNmaximum,  1000); n++;
	XtSetArg(args[n], XmNdecimalPoints, 1); n++;
	XtSetArg(args[n], XmNvalue, (int)(clu_burst.tau_attack_ipsp * 10.)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale32 = XmCreateScale(Time1,"TauIpspPlus",args,n);
	XtAddCallback(scale32, XmNvalueChangedCallback, (XtCallbackProc) NewTauIpspPlus, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("IPSP Decay Time Cste", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 1); n++;
	XtSetArg(args[n], XmNmaximum,  1000); n++;
	XtSetArg(args[n], XmNdecimalPoints, 1); n++;
	XtSetArg(args[n], XmNvalue, (int)(clu_burst.tau_decay_ipsp * 10.)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale33 = XmCreateScale(Time1,"TauIpspMoins",args,n);
	XtAddCallback(scale33, XmNvalueChangedCallback, (XtCallbackProc) NewTauIpspMoins, (XtPointer)NULL);


	titre = XmStringLtoRCreate ("Threshold Time Cste", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 1); n++;
	XtSetArg(args[n], XmNmaximum,  1000); n++;
	XtSetArg(args[n], XmNdecimalPoints, 1); n++;
	XtSetArg(args[n], XmNvalue, (int)(clu_burst.tau_seuil * 10.)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale29 = XmCreateScale(Time1,"TauSeuil",args,n);
	XtAddCallback(scale29, XmNvalueChangedCallback, (XtCallbackProc) NewTauSeuil, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("Shunt Time Cste", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNwidth, 310); n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg(args[n], XmNscaleWidth, scale_time_width); n++;
	XtSetArg(args[n], XmNscaleHeight, 20); n++;
	XtSetArg(args[n], XmNborderWidth, 1); n++;
	XtSetArg(args[n], XmNminimum, 1); n++;
	XtSetArg(args[n], XmNmaximum, 1000); n++;
	XtSetArg(args[n], XmNdecimalPoints, 1); n++;
	XtSetArg(args[n], XmNvalue, (int)(clu_burst.shunt_tau * 10.)); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale34 = XmCreateScale(Time1,"ShuntTau",args,n);
	XtAddCallback(scale34, XmNvalueChangedCallback, (XtCallbackProc) NewShuntTau, (XtPointer)NULL);


        XmStringFree(titre);

	/* GC pour le trait du potentiel */

	n = 0;
	XtSetArg(args[n], XmNforeground, &fg); n++;
	XtSetArg(args[n], XmNbackground, &bg); n++;
	XtGetValues(WorkRegion, args, n);

	xgcv.foreground = fg;
	xgcv.background = bg;

	Draw_GC = XtGetGC(WorkRegion,
			   GCForeground | GCBackground , &xgcv);

	XtManageChild(Scrolled_Window_Time);
#if DEBUG
	printf("Fenetre Constantes de temps  mapee\n");
#endif

	XtRealizeWidget(Shell);


	XtSetArg(args[0], XmNx, 1); 
	XtSetArg(args[1], XmNy, 1);
#if DEBUG
	printf("MainWindow: %ld\n",MainWindow);
#endif

#if 0
	XtSetValues(MainWindow,args,2);
#endif

	XtAddCallback(WorkRegion, XmNexposeCallback, (XtCallbackProc) RedrawNeuron, (XtPointer)NULL);
	XtAddCallback(WorkRegion, XmNresizeCallback, (XtCallbackProc) ResizeWorkRegion, (XtPointer)NULL);

	ChangeParametre (NULL,0,0);


    if (p_neur = fopen(f_neur,"r"))	/* Si il existe, on le sauve en .bak */
    {
	read_P_unit(p_neur);
	fclose(p_neur);
    } /* fin du if */
    else
    {
	fprintf(stderr,"\007File %s does not exists\n",f_neur);
    } /* fin du else */

    

/*
 * Parametres de dessin (scaling, etc...)
 */

	if (bum_type)
	{
	   XmToggleButtonSetState(Toggle4P,False,False);
	   XmToggleButtonSetState(Toggle4L,False,False);
	   XmToggleButtonSetState(Toggle4B,True,False);

	   title = XmStringLtoRCreate ("Model [B_unit]", XmSTRING_DEFAULT_CHARSET);
	   XtSetArg(args[0], XmNlabelString, title); 
	   XtSetValues(MenuBtn4,args,1);
	  XtSetSensitive(scale2,True);	  
	  XtSetSensitive(scale3,True);	  
	  XtSetSensitive(scale4,True);	  
	  XtSetSensitive(scale5,True);	  
	  XtSetSensitive(scale6,True);	  
	  XtSetSensitive(scale14,True);	  
	  XtSetSensitive(scale15,True);	  
	  XtSetSensitive(scale16,True);	  
	  XtSetSensitive(scale30,True);
	  XtSetSensitive(scale31,True);
	  XtSetSensitive(scale32,True);
	  XtSetSensitive(scale33,True);
	  XtSetSensitive(scale34,True);
	  XtSetSensitive(scale35,True);
          XtSetSensitive(form_Burst_thr,True);
	  XtSetSensitive(label_Burst_thr,True);
	  XtSetSensitive(form_freq_spike,True);
	  XtSetSensitive(label_freq_spike,True);
	  XtSetSensitive(form_freq_max,True);
	  XtSetSensitive(label_freq_max,True);
	  XtSetSensitive(form_compose_fact,True);
	  XtSetSensitive(label_compose_fact,True);
	  XtSetSensitive(form_duree_burst_min,True);
	  XtSetSensitive(label_duree_burst_min,True);
	  XtSetSensitive(form_duree_burst_max,True);
	  XtSetSensitive(label_duree_burst_max,True);
	  XtSetSensitive(form_Burst_post_spike,True);
	  XtSetSensitive(label_Burst_post_spike,True);
	}
	if (lim_type)
	{
	   XmToggleButtonSetState(Toggle4P,False,False);
	   XmToggleButtonSetState(Toggle4L,True,False);
	   XmToggleButtonSetState(Toggle4B,False,False);

	   title = XmStringLtoRCreate ("Model [L_unit]", XmSTRING_DEFAULT_CHARSET);
	   XtSetArg(args[0], XmNlabelString, title); 
	   XtSetValues(MenuBtn4,args,1);
	  XtSetSensitive(scale2,False);	  
	  XtSetSensitive(scale3,False);	  
	  XtSetSensitive(scale4,False);	  
	  XtSetSensitive(scale5,False);	  
	  XtSetSensitive(scale6,False);	  
	  XtSetSensitive(scale14,False);	  
	  XtSetSensitive(scale15,False);	  
	  XtSetSensitive(scale16,False);	  
	  XtSetSensitive(scale30,False);
	  XtSetSensitive(scale31,False);
	  XtSetSensitive(scale32,False);
	  XtSetSensitive(scale33,False);
	  XtSetSensitive(scale34,False);
	  XtSetSensitive(scale35,False);
          XtSetSensitive(form_Burst_thr,False);
	  XtSetSensitive(label_Burst_thr,False);
	  XtSetSensitive(form_freq_spike,False);
	  XtSetSensitive(label_freq_spike,False);
	  XtSetSensitive(form_freq_max,False);
	  XtSetSensitive(label_freq_max,False);
	  XtSetSensitive(form_compose_fact,False);
	  XtSetSensitive(label_compose_fact,False);
	  XtSetSensitive(form_duree_burst_min,False);
	  XtSetSensitive(label_duree_burst_min,False);
	  XtSetSensitive(form_duree_burst_max,False);
	  XtSetSensitive(label_duree_burst_max,False);
	  XtSetSensitive(form_Burst_post_spike,False);
	  XtSetSensitive(label_Burst_post_spike,False);
	}
	if (pum_type)
	{
	   XmToggleButtonSetState(Toggle4P,True,False);
	   XmToggleButtonSetState(Toggle4L,False,False);
	   XmToggleButtonSetState(Toggle4B,False,False);
	   	   
	   title = XmStringLtoRCreate ("Model [P_unit]", XmSTRING_DEFAULT_CHARSET);
	   XtSetArg(args[0], XmNlabelString, title); 
	   XtSetValues(MenuBtn4,args,1);
	  XtSetSensitive(scale2,False);	  
	  XtSetSensitive(scale3,False);	  
	  XtSetSensitive(scale4,False);	  
	  XtSetSensitive(scale5,False);	  
	  XtSetSensitive(scale6,False);	  
	  XtSetSensitive(scale14,False);	  
	  XtSetSensitive(scale15,True);	  
	  XtSetSensitive(scale16,True);	  
	  XtSetSensitive(scale30,True);
	  XtSetSensitive(scale31,True);
	  XtSetSensitive(scale32,True);
	  XtSetSensitive(scale33,True);
	  XtSetSensitive(scale34,True);
	  XtSetSensitive(scale35,False);
          XtSetSensitive(form_Burst_thr,False);
	  XtSetSensitive(label_Burst_thr,False);
	  XtSetSensitive(form_freq_spike,False);
	  XtSetSensitive(label_freq_spike,False);
	  XtSetSensitive(form_freq_max,False);
	  XtSetSensitive(label_freq_max,False);
	  XtSetSensitive(form_compose_fact,False);
	  XtSetSensitive(label_compose_fact,False);
	  XtSetSensitive(form_duree_burst_min,False);
	  XtSetSensitive(label_duree_burst_min,False);
	  XtSetSensitive(form_duree_burst_max,False);
	  XtSetSensitive(label_duree_burst_max,False);
	  XtSetSensitive(form_Burst_post_spike,False);
	  XtSetSensitive(label_Burst_post_spike,False);
	}

	if (filter_noise)
	{
	  XtSetSensitive(scale13,True);
          XtSetSensitive(form_Resistance,True);
	  XtSetSensitive(label_Resistance,True);
	}
	else
	{
	  XtSetSensitive(scale13,False);
          XtSetSensitive(form_Resistance,False);
	  XtSetSensitive(label_Resistance,False);
	}

#if DEBUG
	printf("Avant DynamicChange\n");
#endif

        DynamicChange (NULL, NULL, NULL);

#if DEBUG
	printf("Apres DynamicChange\n");
#endif

	XMoveWindow(display, XtWindow(Shell), 10, 30);
	XMoveResizeWindow(display, XtWindow(ParameterChange), (screen_width - (Dimension)(screen_width * .55) - 20), 30,
			  (Dimension)((screen_width * .55)+10), (Dimension)(screen_height * .72));
	XMoveResizeWindow(display, XtWindow(TimeDialog), 10, (screen_height - (Dimension)(screen_height * .2) - 20),
		    screen_width-10, (Dimension)(screen_height * .2)-10);

#if DEBUG
	printf("Avant update_scales\n");
#endif



	update_scales();

#if DEBUG
	printf("Apres update_scales\n");
	scanf("%c",&buffer[0]);
	printf("%c",buffer[0]);
#endif
	

	XtAppMainLoop(app);

}


/***********************************************************/
CreateMenuBar ()
{

    int           n;
    Arg           args[MAX_ARGS];
    XmString      titre, 
                  string1,
                  string2,
                  string3;

    /*
    **  the menubar
    */


    n = 0;
    XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
    XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;   
    XtSetArg(args[n], XmNwidth, largeur * .75);n++;   
    MenuBar = (Widget) XmCreateMenuBar ((Widget) MainWindow, "MenuBar", 
					args, n); 
    if (MenuBar == NULL) {
      printf ("null menu bar\n\r");
      exit (0);
    }
    XtManageChild(MenuBar);

    /*  create the first level pulldowns */

    n = 0;
    XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
    PullDown1 = XmCreatePulldownMenu (MenuBar, "File", args, n);
    PullDown2 = XmCreatePulldownMenu (MenuBar, "Parameters", args, n);
    PullDown3 = XmCreatePulldownMenu (MenuBar, "Options", args, n);
    PullDown4 = XmCreatePulldownMenu (MenuBar, "Model", args, n);
    PullDown5 = XmCreatePulldownMenu (MenuBar, "Help", args, n);


    /*  create cascade buttons for menubar  */

    MenuBtn1 = CreateCascade ("File", 'F', PullDown1, MenuBar);
    MenuBtn2 = CreateCascade ("Parameters", 'P', PullDown2, MenuBar);
    MenuBtn3 = CreateCascade ("Options", 'O', PullDown3, MenuBar);
    MenuBtn4 = CreateCascade ("Model", 'M', PullDown4, MenuBar);
    MenuBtn5 = CreateCascade ("Help", 'H', PullDown5, MenuBar);

    /*
    **  Menu1
    */

    Label1A = CreatePushButton ("Read Neuron",'R',PullDown1);
    XtAddCallback (Label1A, XmNactivateCallback, (XtCallbackProc) ReadFiles, (XtPointer)NULL);
    Label1B = CreatePushButton ("Write Back Neuron",'W',PullDown1);
    XtAddCallback (Label1B, XmNactivateCallback, (XtCallbackProc) FileSaveOK, (XtPointer)NULL);
    Label1C = CreatePushButton ("Save Neuron as...",'S',PullDown1);
    XtAddCallback (Label1C, XmNactivateCallback, (XtCallbackProc) SaveAsFiles, (XtPointer)NULL);
    Label1D = CreatePushButton ("Print",'P',PullDown1);
    XtAddCallback (Label1D, XmNactivateCallback, (XtCallbackProc) Create_PS, (XtPointer)NULL);
    Label1E = CreatePushButton ("Quit",'Q',PullDown1);
    XtAddCallback (Label1E, XmNactivateCallback, (XtCallbackProc) MenuQuit, (XtPointer)NULL);

    /*
    **  Menu2
    */

    Label2A = CreatePushButton ("Change Parameters",'C',PullDown2);
    XtAddCallback (Label2A, XmNactivateCallback, (XtCallbackProc) ChangeParametre, (XtPointer)NULL);
    Label2B = CreatePushButton ("Redraw Neuron",'R',PullDown2);
    XtAddCallback (Label2B, XmNactivateCallback, (XtCallbackProc) RedrawNeuron, (XtPointer)NULL);
    Label3B = CreatePushButton ("Back to defaults",'D',PullDown2);
    XtAddCallback (Label3B, XmNactivateCallback, (XtCallbackProc) BackToDefaults, (XtPointer)NULL);

    /*
    **  Menu3
    */


	titre = XmStringLtoRCreate ("Kohn colored noise", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	toggle2 = XmCreateToggleButton(PullDown3,"Kohn colored noise",args,n);
	XtAddCallback(toggle2, XmNvalueChangedCallback, (XtCallbackProc) NewNoiseFilter, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("Dynamic Update", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	toggle3 = XmCreateToggleButton(PullDown3,"Static Update",args,n);
	XtAddCallback(toggle3, XmNvalueChangedCallback, (XtCallbackProc) DynamicChange, (XtPointer)NULL);

	titre = XmStringLtoRCreate ("Less Fatigue ", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	toggle4 = XmCreateToggleButton(PullDown3,"Less Fatigue",args,n);
	XtAddCallback(toggle4, XmNvalueChangedCallback, (XtCallbackProc) NewFatigueTjrs, (XtPointer)NULL);

        XmStringFree(titre);
   
        Label3G = CreatePushButton ("Scales",'S',PullDown3);
        XtAddCallback (Label3G, XmNactivateCallback, (XtCallbackProc) ChangeScales, (XtPointer)NULL);


	/* 
	** Menu 4 
	*/

   	/* et 3 toggle Button */


	titre = XmStringLtoRCreate ("Phenomenologic", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
        Toggle4P = XmCreateToggleButton(PullDown4,"Phenomenologic",args,n);
	XtAddCallback(Toggle4P, XmNvalueChangedCallback, (XtCallbackProc)callback_toggle_model, (XtPointer)0);

        XmStringFree(titre);

	titre = XmStringLtoRCreate ("Leaky Integrator", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
        Toggle4L = XmCreateToggleButton(PullDown4,"Leaky Integrator",args,n);
	XtAddCallback(Toggle4L, XmNvalueChangedCallback, (XtCallbackProc)callback_toggle_model, (XtPointer)1);
       
        XmStringFree(titre);

	titre = XmStringLtoRCreate ("Conditional Burster", XmSTRING_DEFAULT_CHARSET);
	n = 0;
	XtSetArg(args[n], XmNtitleString, titre); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
        Toggle4B = XmCreateToggleButton(PullDown4,"Conditional Burster",args,n);
	XtAddCallback(Toggle4B, XmNvalueChangedCallback, (XtCallbackProc)callback_toggle_model, (XtPointer)2);

        XmStringFree(titre);
   
	/* 
	** Menu 5 
	*/

   	/* et 2 push Buttons */
	Label5A = CreatePushButton ("Browse Manual",'B',PullDown5);
	XtAddCallback (Label5A, XmNactivateCallback, (XtCallbackProc) browse_callback, (XtPointer)NULL);
	Label5B = CreatePushButton ("Display Equations",'E',PullDown5);
	XtAddCallback (Label5B, XmNactivateCallback, (XtCallbackProc) equations_callback, (XtPointer)NULL);

	
}

/* support routine to get normal string from XmString */
void extract_normal_string(cs, buffer_st)
XmString cs;
char *buffer_st;
{
	
  XmStringContext context;
  XmStringCharSet charset;
  XmStringDirection direction;
  Boolean separator;
  static char *primitive_string;

  XmStringInitContext (&context,cs);
  XmStringGetNextSegment (context,&primitive_string,
			  &charset,&direction,&separator);
  strcpy(buffer_st, primitive_string);
  XmStringFreeContext (context);
}

void browse_callback()
{
	browse_manual(XNBC_P_NEURON);
} /* fin du browse */

void equations_callback()
{
	if (pum_type)	/* phenomenologic model */
		browse_manual(XNBC_PUM_EQ);
	if (lim_type)	/* leaky integrator model */
		browse_manual(XNBC_LIM_EQ);
	if (bum_type)	/* conditional burster model */
		browse_manual(XNBC_BUM_EQ);
} /* fin du browse */

/******************************************************************
 *	REALISATION DE LA FENETRE PARAMETRES DE VOLTAGE                     *
 ******************************************************************/


/******************************************************************
 *      REALISATION DE LA FENETRE DE CHANGEMENT DE L`ECHELLE      *
 ******************************************************************/
void fabrique_Echelles()
{
  register int    n;
  Arg		args[MAX_ARGS];
  
  
  Widget		form_Max,
  label_Max,
  form_Min,
  label_Min,
  Close_Echelle;
  
  XmString	titre;
  
  register	i;
  
  if (flag_echelle) 
    {
      XtPopup(EchelleChange,XtGrabNone);
      return;
    } 
  /* creation d'un toplevel auquel seront rattaches tous
     les widgets crees et definition de ses parametres  */
  
  n = 0;
  XtSetArg(args[n], XmNwidth, (Dimension)(.25 * screen_width)); n++;
  XtSetArg(args[n], XmNheight, (Dimension)(.38 * screen_height)); n++;
  XtSetArg(args[n], XmNx, (screen_width - (Dimension)(.55 * screen_width))); n++;
  XtSetArg(args[n], XmNmappedWhenManaged, FALSE); n++;
  XtSetArg(args[n], XmNy, 0); n++;
  XtSetArg(args[n], XmNtitle, "Scale`s values"); n++;
  XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
  XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
  EchelleChange = XmCreateDialogShell (MainWindow, "echelle change", args, n);
  
  
  /* creation d'une ScrolledWindow pour les parametres de voltage */
  /* regle la taille de la fenetre voltage_parameters  */
  
  n = 0;
  XtSetArg(args[n], XmNborderWidth, 1);n++;
  XtSetArg(args[n], XmNwidth, (Dimension)(.25 * screen_width));n++;
  XtSetArg(args[n], XmNheight,(Dimension)(.38 * screen_height));n++;
  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmAUTOMATIC);n++;
  XtSetArg(args[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
  XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
  XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
  Scrolled_Window_Echelle = XtCreateManagedWidget("scrolledechel",
						  xmScrolledWindowWidgetClass,
						  EchelleChange,
						  args, n);
 
 /* creation d'une RowColumn qui contiendra les Forms des Scales */
  
  n = 0;
  XtSetArg(args[n], XmNwidth, (Dimension)(.55 * screen_width)); n++;
  XtSetArg(args[n], XmNheight, (Dimension)(.72 * screen_height)); n++;
  XtSetArg(args[n], XmNnumColumns, 1);n++;
  XtSetArg(args[n], XmNorientation, XmHORIZONTAL);n++;
  XtSetArg(args[n], XmNborderWidth, 0);n++;
  XtSetArg(args[n], XmNpacking, XmPACK_COLUMN);n++;
  XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
  XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
  Row_Column_Echelle = XtCreateManagedWidget("rowcolumnparametres",
						xmRowColumnWidgetClass,
						Scrolled_Window_Echelle,
						args, n);
  

  /*-------s c a l e   Max echelle ---------------------*/
  
  form_Max = XtVaCreateManagedWidget(
				     "form_Max",
				     xmFormWidgetClass, Row_Column_Echelle,
				     XmNwidth, ScaleForm_Width,
				     XmNheight, ScaleForm_Height,
				     XmNborderWidth, ScaleForm_BorderWidth,
				     XmNforeground, BlackPixel(display, screen),
				     XmNbackground, WhitePixel(display, screen),
				     NULL);
  
  titre = XmStringCreateLtoR ("Max",XmSTRING_DEFAULT_CHARSET);
 
  label_Max = fabrique_label (titre, form_Max);
  
  scaleMax = fabrique_scale ((int) Min_Y+1, 100, (int) Max_Y, 0, label_Max, form_Max);
 
  XmStringFree (titre);
  
  XtAddCallback (scaleMax, XmNvalueChangedCallback, (XtCallbackProc)
		 ChangeMax, (XtPointer)NULL);
  
  /*-------s c a l e   Min echelle ------------------*/
  
  form_Min = XtVaCreateManagedWidget(
				     "form_min",
				     xmFormWidgetClass, Row_Column_Echelle,
				     XmNwidth, ScaleForm_Width,
				     XmNheight, ScaleForm_Height,
				     XmNborderWidth, ScaleForm_BorderWidth,
				     XmNforeground, BlackPixel(display, screen),
				     XmNbackground, WhitePixel(display, screen),
				     XmNx,100,
				     NULL);
  
  titre = XmStringCreateLtoR ("Min",XmSTRING_DEFAULT_CHARSET);
  
  label_Min = fabrique_label (titre, form_Min);
  
  scaleMin = fabrique_scale (-100,(int) Max_Y-1, (int) Min_Y, 0, label_Min, form_Min);
  
  XmStringFree (titre);
  
  XtAddCallback (scaleMin, XmNvalueChangedCallback, (XtCallbackProc)
		 ChangeMin, (XtPointer)NULL);
  

  /*----------------END OF SCALES---------------------*/
  
  /* ajout d`un boutton pour fermer la fenetre */
 
  
  titre = XmStringCreateSimple("Close");	
  
  n = 0;
  XtSetArg(args[n], XmNx, 150);n++;
  XtSetArg(args[n], XmNy, 380);n++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
  XtSetArg(args[n], XmNtopWidget, scaleMin); n++;
  XtSetArg(args[n], XmNdefaultButtonShadowThickness, 2); n++;
  XtSetArg(args[n], XmNwidth, 100); n++;
  XtSetArg(args[n], XmNlabelString, titre); n++;
  XtSetArg(args[n], XmNalignment, XmALIGNMENT_CENTER); n++;
  Close_Echelle = XtCreateManagedWidget("close_Echelle",
					xmPushButtonWidgetClass,
					Row_Column_Echelle,
					args, n);
  XmStringFree(titre);
  
  XtAddCallback(Close_Echelle, XmNactivateCallback, (XtPointer)callback_close_Echelle, NULL);
  
  XtManageChild(Scrolled_Window_Parametres);
  
  XtManageChild(Row_Column_Parametres);
  
  /* activation de toutes les widgets */
  
  XtManageChild (scaleMax);
  XtManageChild (scaleMin);
  XtManageChild (Close_Echelle);
  
  /* realisation du toplevel et de tous ses descendants */
  XtRealizeWidget (EchelleChange);
  
  XMoveWindow(display,XtWindow(EchelleChange),580,30);
  XMapWindow(display,XtWindow(EchelleChange));
  
#if DEBUG
  printf("Fenetre Parametres mapee\n");
#endif
  /*
     printf("donner la nouvelle echelle: (Max  puis Min)\n");
     scanf("%f %f",&Max_Y,&Min_Y);
     printf("accisition: Max_Y:%f\tMin_Y:%f\n",Max_Y,Min_Y);
     Max_DDP = Max_Y - Min_Y;
     printf("resultat Max_DDP:%f\n",Max_DDP);
     
     */
}


/*----------------------------------------------------------------
 *	f a b r i q u e _ f e n e t r e P a r a m e t r e
 *---------------------------------------------------------------*/

void fabrique_fenetreParametre ()

{
	register int    n;
	Arg		args[MAX_ARGS];


	Widget		form_RestPotential,
			label_RestPotential,
                        form_Firing_thr,
	                label_Firing_thr,
/*                                       
                                          voir en global 
                        form_Burst_thr,
	                label_Burst_thr,
			form_freq_spike,
			label_freq_spike,
			form_freq_max,
			label_freq_max,
			form_compose_fact,
			label_compose_fact,
			form_duree_burst_min,
			label_duree_burst_min,
			form_duree_burst_max,
			label_duree_burst_max,
			form_Burst_post_spike,
			label_Burst_post_spike,
			label_Resistance,
			form_Resistance,
*/
			form_TimeStep,
			label_TimeStep,
			form_NoiseMean,
			label_NoiseMean,
			form_NoiseSd,
			label_NoiseSd,
			form_EPSP_Max,
			label_EPSP_Max,
			form_IPSP_Max,
			label_IPSP_Max,
			form_Post_spike_pot,
			label_Post_spike_pot,
			form_PostSpikeThreshold,
			label_PostSpikeThreshold,
			form_RevPotPos,
			label_RevPotPos,
			form_Weight_Epsp,
			label_Weight_Epsp,
			form_Weight_Ipsp,
			label_Weight_Ipsp,
			form_RevPotNeg,
			label_RevPotNeg,
	                form_fatigue,
	                label_fatigue;


			
	XmString	titre;
	
	register	i;

#if 0
	 ---------------------------------------
	|	   ParameterChange              |
	|		|			|
	|	   Scrolled_Window_Parametres	|
	|		|			|
	|	   Row_Column_Parametres	|
	|		|			|
	|	formes contenant les scales	|
	 ---------------------------------------
#endif

	/* creation d'un toplevel auquel seront rattaches tous
	   les widgets crees et definition de ses parametres  */

	n = 0;
	XtSetArg(args[n], XmNwidth, (Dimension)(.55 * screen_width)); n++;
	XtSetArg(args[n], XmNheight, (Dimension)(.72 * screen_height)); n++;
	XtSetArg(args[n], XmNx, (screen_width - (Dimension)(.55 * screen_width))); n++;
	XtSetArg(args[n], XmNmappedWhenManaged, FALSE); n++;
	XtSetArg(args[n], XmNy, 0); n++;
	XtSetArg(args[n], XmNtitle, "Voltage Parameters"); n++;
	XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
/*
	ParameterChange = XtAppCreateShell("shell_param", NULL, applicationShellWidgetClass,
                              display, args, n);
*/

	ParameterChange = XmCreateDialogShell (Shell, "Parameter Window", args, n);
	
	/* creation d'une ScrolledWindow pour les parametres de voltage */
	/* regle la taille de la fenetre voltage_parameters  */

	n = 0;
	XtSetArg(args[n], XmNborderWidth, 1);n++;
	XtSetArg(args[n], XmNwidth, (Dimension)(.55 * screen_width));n++;
	XtSetArg(args[n], XmNheight,(Dimension)(.72 * screen_height));n++;
	XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmAUTOMATIC);n++;
	XtSetArg(args[n], XmNscrollingPolicy, XmAUTOMATIC);n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
	Scrolled_Window_Parametres = XtCreateManagedWidget("scrolledparam",
							   xmScrolledWindowWidgetClass,
							   ParameterChange,
							   args, n);

	/* creation d'une RowColumn qui contiendra les Forms des Scales */

	n = 0;
	XtSetArg(args[n], XmNwidth, (Dimension)(.55 * screen_width)); n++;
	XtSetArg(args[n], XmNheight, (Dimension)(.72 * screen_height)); n++;
	XtSetArg(args[n], XmNnumColumns, 2);n++;
	XtSetArg(args[n], XmNorientation, XmHORIZONTAL);n++;
	XtSetArg(args[n], XmNborderWidth, 0);n++;
	XtSetArg(args[n], XmNpacking, XmPACK_COLUMN);n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;
	Row_Column_Parametres = XtCreateManagedWidget("rowcolumnparametres",
						      xmRowColumnWidgetClass,
						      Scrolled_Window_Parametres,
						      args, n);

/*-------s c a l e   Time Step ---------------------*/

	form_TimeStep = XtVaCreateManagedWidget(
			"form_Time_Step",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Time Step\n(ms)",
				    XmSTRING_DEFAULT_CHARSET);

	label_TimeStep = fabrique_label (titre, form_TimeStep);

	scale12 = fabrique_scale (1, 1000, (int)(time_step * 1000.), 3,
				  label_TimeStep,
				  form_TimeStep);

	XmStringFree (titre);

	XtAddCallback (scale12, XmNvalueChangedCallback, (XtCallbackProc)
		       NewTimeStep, (XtPointer)NULL);


/*------s c a l e  r e s t i n g   p o t e n t i a l---------------*/

	/* creation d'une forme a laquelle seront rattaches le
	label de l'echelle et l'echelle proprement dite       */
	
	form_RestPotential = XtVaCreateManagedWidget(
			"form_RestPotential",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
        		XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Resting\n Potential",
				    XmSTRING_DEFAULT_CHARSET);
	/* creation du label par appel de la fonction
	   fabrique_label decrite plus loin		       */
	label_RestPotential = fabrique_label (titre,
					      form_RestPotential);

	/* creation de l'echelle par appel de la fonction
	   fabrique_scale decrite plus loin		       */
	scale1= fabrique_scale (-100, -20, (int) clu_burst.rest_pot, 0,
				    label_RestPotential,
				    form_RestPotential);

	XmStringFree (titre);

	/* ajout d'un callback a l'echelle creee de maniere a
	   recuperer la valeur choisie par l'utilisateur       */
	XtAddCallback (scale1, XmNvalueChangedCallback, (XtCallbackProc) NewRestPot, (XtPointer)NULL);

/*-------s c a l e   Firing_thr  ------------------*/

	form_Firing_thr = XtVaCreateManagedWidget(
			"form_Firing_thr",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Firing\n Threshold",
				    XmSTRING_DEFAULT_CHARSET);

	label_Firing_thr = fabrique_label (titre,
					     form_Firing_thr);

	scale9 = fabrique_scale (-100, -20, (int)clu_burst.seuil,
				      0,label_Firing_thr,form_Firing_thr);

	XmStringFree (titre);

	XtAddCallback (scale9, XmNvalueChangedCallback, (XtCallbackProc)
		       NewSeuil, (XtPointer)NULL);


/*-------s c a l e   EPSP_Max -----------*/


	form_EPSP_Max = XtVaCreateManagedWidget(
			"form_EPSP_Max",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("EPSP\nSize",
				    XmSTRING_DEFAULT_CHARSET);

	label_EPSP_Max = fabrique_label (titre,
						 form_EPSP_Max);

	scale7 = fabrique_scale(0, 2000 , (int)(clu_burst.epsp*100.),
					      2,label_EPSP_Max,
					      form_EPSP_Max);
	XmStringFree (titre);

	XtAddCallback (scale7, XmNvalueChangedCallback, (XtCallbackProc)
		       NewEpsp, (XtPointer)NULL);

/*-------s c a l e   IPSP_Max -----------*/


	form_IPSP_Max = XtVaCreateManagedWidget(
			"form_IPSP_Max",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("IPSP\nSize",
				    XmSTRING_DEFAULT_CHARSET);

	label_IPSP_Max = fabrique_label (titre,
						 form_IPSP_Max);

	scale8 = fabrique_scale(0, 1000 , (int)(clu_burst.ipsp*100.), 2,
					      label_IPSP_Max,
					      form_IPSP_Max);

	XmStringFree (titre);

	XtAddCallback (scale8, XmNvalueChangedCallback, (XtCallbackProc)
		       NewIpsp, (XtPointer)NULL);


/*-------s c a l e   Weight EPSP ---------------------*/

	form_Weight_Epsp = XtVaCreateManagedWidget(
			"form_Weight_Epsp",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Weight\nEPSP",
				    XmSTRING_DEFAULT_CHARSET);

	label_Weight_Epsp = fabrique_label (titre, form_Weight_Epsp);

	scale19 = fabrique_scale (0, 50, 5, 0,
				  label_Weight_Epsp,
				  form_Weight_Epsp);

	XmStringFree (titre);

	XtAddCallback (scale19, XmNvalueChangedCallback, (XtCallbackProc)
		       NewButtonENb, (XtPointer)NULL);


#if 0
/*-------s c a l e   IPSP_Sd -----------*/

	form_IPSP_Sd = XtVaCreateManagedWidget(
			"form_IPSP_Sd",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("IPSP\nsd",
				    XmSTRING_DEFAULT_CHARSET);

	label_IPSP_Sd = fabrique_label (titre,
						 form_IPSP_Sd);

	scale13 = fabrique_scale(0, 100 , (int)(ipsp_sd*100.), 2,
						label_IPSP_Sd,
						form_IPSP_Sd);

	XmStringFree (titre);

	XtAddCallback (scale13, XmNvalueChangedCallback, (XtCallbackProc)
		       NewIpspSd, (XtPointer)NULL);

#endif
/*-------s c a l e   Weight IPSP ---------------------*/

	form_Weight_Ipsp = XtVaCreateManagedWidget(
			"form_Weight_Ipsp",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Weight\nIPSP",
				    XmSTRING_DEFAULT_CHARSET);

	label_Weight_Ipsp = fabrique_label (titre, form_Weight_Ipsp);

	scale20 = fabrique_scale (0, 50, 5, 0,
				  label_Weight_Ipsp,
				  form_Weight_Ipsp);

	XmStringFree (titre);

	XtAddCallback (scale20, XmNvalueChangedCallback, (XtCallbackProc)
		       NewButtonINb, (XtPointer)NULL);


/*-------s c a l e  Resistance ---------------------*/

	form_Resistance = XtVaCreateManagedWidget(
			"form_Resistance",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Filter\nResistance",
				    XmSTRING_DEFAULT_CHARSET);

	label_Resistance = fabrique_label (titre, form_Resistance);

	scale13 = fabrique_scale (1, 10000, (int)(clu_burst.resistance * 100.), 2,
				  label_Resistance,
				  form_Resistance);

	XmStringFree (titre);

	XtAddCallback (scale13, XmNvalueChangedCallback, (XtCallbackProc)
		       NewResistance, (XtPointer)NULL);

/*-------s c a l e   Freq_spike   ---------------------------*/

	form_freq_spike = XtVaCreateManagedWidget("form_freq_spike",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Spike\nFrequency",
				    XmSTRING_DEFAULT_CHARSET);

	label_freq_spike = fabrique_label (titre, form_freq_spike);

	scale2 = fabrique_scale (0, (int)clu_burst.freq_max, (int)clu_burst.freq_spike,
					 0, label_freq_spike, form_freq_spike);

	XmStringFree (titre);

	XtAddCallback (scale2, XmNvalueChangedCallback, (XtCallbackProc)
		       NewFreqSpike, (XtPointer)NULL);


/*-------s c a l e   FreqMax  ---*/


	form_freq_max = XtVaCreateManagedWidget(
			"form_freq_max",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Max\nFrequency",
				    XmSTRING_DEFAULT_CHARSET);

	label_freq_max = fabrique_label (titre,
					       form_freq_max);

	scale3 = fabrique_scale (0, 200, (int)clu_burst.freq_max, 0,
			label_freq_max, form_freq_max);

	XmStringFree (titre);


	XtAddCallback (scale3, XmNvalueChangedCallback, (XtCallbackProc)
		       NewFreqMax, (XtPointer)NULL);

		       
/*-------s c a l e   compose_fact -------------------*/

	form_compose_fact = XtVaCreateManagedWidget(
			"form_compose_fact",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Composition\nFactor",
				    XmSTRING_DEFAULT_CHARSET);

	label_compose_fact = fabrique_label (titre,
					      form_compose_fact);

	scale4 = fabrique_scale (1, 1000, (int)(clu_burst.compose_fact*100.), 2,
				  label_compose_fact,
				  form_compose_fact);
	XmStringFree (titre);

	XtAddCallback (scale4, XmNvalueChangedCallback, (XtCallbackProc)
		       NewComposeFact, (XtPointer)NULL);

/*-----------------SECONDE LIGNE DE SCALES ---------------*/

/*-------s c a l e   NoiseMean ---------------------*/



	form_NoiseMean = XtVaCreateManagedWidget(
			"form_NoiseMean",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Noise\nmean",
				    XmSTRING_DEFAULT_CHARSET);

	label_NoiseMean = fabrique_label (titre,
					      form_NoiseMean);

	scale10= fabrique_scale (-20000, 20000, (int)(backgrd_noise_m*1000.), 3,
				  label_NoiseMean,
				  form_NoiseMean);

	XmStringFree (titre);

	XtAddCallback (scale10, XmNvalueChangedCallback, (XtCallbackProc)
		       NoiseMean, (XtPointer)NULL);
		 
/*-------s c a l e   NoiseSd -------------------*/


	form_NoiseSd = XtVaCreateManagedWidget(
			"form_NoiseSd",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Noise\nsd",
				    XmSTRING_DEFAULT_CHARSET);

	label_NoiseSd = fabrique_label (titre,
					      form_NoiseSd);

	scale11= fabrique_scale (0, 10000, (int)(backgrd_noise_sd*1000.), 3,
				  label_NoiseSd,
				  form_NoiseSd);

	XmStringFree (titre);

	XtAddCallback (scale11, XmNvalueChangedCallback, (XtCallbackProc)
		       NoiseSd, (XtPointer)NULL);



/*-------s c a l e   Post_spike_pot   ---------------------------*/

	form_Post_spike_pot = XtVaCreateManagedWidget("form_Post_spike_pot",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Postspike\nPotential",
				    XmSTRING_DEFAULT_CHARSET);

	label_Post_spike_pot = fabrique_label (titre, form_Post_spike_pot);

	scale17 = fabrique_scale (-100, -20, (int)clu_burst.pot_post_spike,
					 0, label_Post_spike_pot, form_Post_spike_pot);

	XmStringFree (titre);

	XtAddCallback (scale17, XmNvalueChangedCallback, (XtCallbackProc)
		       NewPotPostSpike, (XtPointer)NULL);



/*-------s c a l e   PostSpikeThreshold  ---*/


	form_PostSpikeThreshold = XtVaCreateManagedWidget(
			"form_PostSpikeThreshold",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Postspike\nThreshold",
				    XmSTRING_DEFAULT_CHARSET);

	label_PostSpikeThreshold = fabrique_label (titre,
					       form_PostSpikeThreshold);

	scale18 = fabrique_scale (0, 100, (int)clu_burst.seuil_post_spike, 0,
			label_PostSpikeThreshold, form_PostSpikeThreshold);

	XmStringFree (titre);


	XtAddCallback (scale18, XmNvalueChangedCallback, (XtCallbackProc)
		       NewSeuilPostSpike, (XtPointer)NULL);

/*-------s c a l e   Fatigue  ---*/


	form_fatigue = XtVaCreateManagedWidget(
			"form_fatigue",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Threshold\nFatigue",
				    XmSTRING_DEFAULT_CHARSET);

	label_fatigue = fabrique_label (titre,
					       form_fatigue);

	scale36 = fabrique_scale (0, 100, (int)(clu_burst.fatigue*10.), 1,
			label_fatigue, form_fatigue);

	XmStringFree (titre);


	XtAddCallback (scale36, XmNvalueChangedCallback, (XtCallbackProc)
		       NewFatigue, (XtPointer)NULL);


/*-------s c a l e   RevPotNeg ------------------*/



	form_RevPotNeg = XtVaCreateManagedWidget(
			"form_RevPotNeg",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Negative\nRev. Pot. ",
				    XmSTRING_DEFAULT_CHARSET);

	label_RevPotNeg = fabrique_label (titre,
					      form_RevPotNeg);

	scale15 = fabrique_scale (-150, 0, (int)clu_burst.rev_pot_neg, 0,
				  label_RevPotNeg,
				  form_RevPotNeg);

	XmStringFree (titre);

	XtAddCallback (scale15, XmNvalueChangedCallback, (XtCallbackProc)
		       NewRevPotNeg, (XtPointer)NULL);
		       

/*-------s c a l e   RevPotPos ------------------*/



	form_RevPotPos = XtVaCreateManagedWidget(
			"form_RevPotPos",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Positive\nRev. Pot. ",
				    XmSTRING_DEFAULT_CHARSET);

	label_RevPotPos = fabrique_label (titre,
					      form_RevPotPos);

	scale16 = fabrique_scale (-150, 0, (int)clu_burst.rev_pot_pos, 0,
				  label_RevPotPos,
				  form_RevPotPos);

	XmStringFree (titre);

	XtAddCallback (scale16, XmNvalueChangedCallback, (XtCallbackProc)
		       NewRevPotPos, (XtPointer)NULL);
		       
/*-------s c a l e   Burst_thr  ------------------*/

	form_Burst_thr = XtVaCreateManagedWidget(
			"form_Burst_thr",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Burst\n Threshold",
				    XmSTRING_DEFAULT_CHARSET);

	label_Burst_thr = fabrique_label (titre,
					     form_Burst_thr);

	scale14 = fabrique_scale (-100, -20, (int)clu_burst.seuil_burst,
				      0,label_Burst_thr,form_Burst_thr);

	XmStringFree (titre);

	XtAddCallback (scale14, XmNvalueChangedCallback, (XtCallbackProc)
		       NewSeuilBurst, (XtPointer)NULL);

/*-------s c a l e   Burst_spike_pot   ---------------------------*/

	form_Burst_post_spike = XtVaCreateManagedWidget("form_Burst_post_spike",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Post Spike\nBurst Pot.",
				    XmSTRING_DEFAULT_CHARSET);

	label_Burst_post_spike = fabrique_label (titre, form_Burst_post_spike);

	scale35 = fabrique_scale (-100, -20, (int)clu_burst.burst_post_spike,
					 0, label_Burst_post_spike, form_Burst_post_spike);

	XmStringFree (titre);

	XtAddCallback (scale35, XmNvalueChangedCallback, (XtCallbackProc)
		       NewBurstPostSpike, (XtPointer)NULL);

/*-------s c a l e   duree_burst_min -----------*/


	form_duree_burst_min = XtVaCreateManagedWidget(
			"form_duree_burst_min",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Min Burst\nDuration",
				    XmSTRING_DEFAULT_CHARSET);

	label_duree_burst_min = fabrique_label (titre,
						 form_duree_burst_min);

	scale5 = fabrique_scale(0, (int)(clu_burst.duree_burst_max*10.), (int)(clu_burst.duree_burst_min*10.),
					      1,label_duree_burst_min,
					      form_duree_burst_min);

	XmStringFree (titre);

	XtAddCallback (scale5, XmNvalueChangedCallback, (XtCallbackProc)
		       NewDureeBurstMin, (XtPointer)NULL);

/*-------s c a l e   duree_burst_max ---------------------*/


	form_duree_burst_max = XtVaCreateManagedWidget(
			"form_duree_burst_max",
			xmFormWidgetClass, Row_Column_Parametres,
			XmNfractionBase, ScaleForm_FractionBase,
			XmNwidth, ScaleForm_Width,
			XmNheight, ScaleForm_Height,
			XmNborderWidth, ScaleForm_BorderWidth,
                        XmNforeground, BlackPixel(display, screen),
			XmNbackground, WhitePixel(display, screen),
			NULL);
			
	titre = XmStringCreateLtoR ("Max Burst\nDuration",
				    XmSTRING_DEFAULT_CHARSET);

	label_duree_burst_max = fabrique_label (titre, form_duree_burst_max);

	scale6 = fabrique_scale ((int)(clu_burst.duree_burst_min*10.), 5000, (int)(clu_burst.duree_burst_max*10.), 1,
				  label_duree_burst_max,
				  form_duree_burst_max);

	XmStringFree (titre);

	XtAddCallback (scale6, XmNvalueChangedCallback, (XtCallbackProc)
		       NewDureeBurstMax, (XtPointer)NULL);

/*----------------END OF SCALES---------------------*/

	XtManageChild(Scrolled_Window_Parametres);

	XtManageChild(Row_Column_Parametres);

	/* activation de toutes les echelles */

	XtManageChild (scale1);
	XtManageChild (scale2);
	XtManageChild (scale3);
	XtManageChild (scale4);
	XtManageChild (scale5);
	XtManageChild (scale6);
	XtManageChild (scale7);
	XtManageChild (scale8);
	XtManageChild (scale9);
	XtManageChild (scale10);
	XtManageChild (scale11);
	XtManageChild (scale12);
	XtManageChild (scale13);
	XtManageChild (scale14);
	XtManageChild (scale15);
	XtManageChild (scale16);
	XtManageChild (scale17);
	XtManageChild (scale18);
	XtManageChild (scale19);
	XtManageChild (scale20);
	XtManageChild (scale35);
	XtManageChild (scale36);

	/* realisation du toplevel et de tous ses descendants */
	XtRealizeWidget (ParameterChange);

	XMoveResizeWindow(display,XtWindow(ParameterChange),580,30, (screen_width * .55), (screen_height * .72));
	XMapWindow(display,XtWindow(ParameterChange));

#if DEBUG
	printf("Fenetre Parametres mapee\n");
#endif
/*
	donne a la fenetre mere du ParameterChange contenue dans
	   le display disp, la ColorMap palette definie dans
	   couleur.c                                          
	XSetWindowColormap (disp, XtWindow(ParameterChange), palette);
*/
}



/******************************************************************
 *	FONCTIONS UTILES				          *
 ******************************************************************/
	     
/*-----------------------------------------------------------------
 *	f a b r i q u e _ l a b e l
 *---------------------------------------------------------------*/
/* permet de creer un label ayant pour texte "nom", et pour
   pere le widget "parent"                                     */

Widget	fabrique_label (nom, parent)

XmString	nom;
Widget		parent;
{
	Widget	label;

	label = XtVaCreateManagedWidget ("label",
		xmLabelGadgetClass, parent,
		XmNlabelString, nom,
		XmNtopAttachment, XmATTACH_FORM,
		XmNtopOffset, 5,
		XmNleftAttachment, XmATTACH_FORM,
		XmNleftOffset, 5,
		XmNrightAttachment,XmATTACH_FORM,
		XmNrightOffset, 5,
		XmNborderWidth, 0,
		XmNwidth, ScaleForm_Width,
		XmNheight,50,
		NULL);

	return (label);
}

/*------------------------------------------------------------
 *	f a b r i q u e _ s c a l e
 *-----------------------------------------------------------*/

/* fabrique une echelle dont les valeurs extremales sont
   valeur_min et valeur_max;
   la valeur initiale est valeur_init;
   valeur decimale represente le nombre de decimales pour les
   valeurs de l'echelle;
   label_widget est le label auquel est rattache l'echelle;
   parent etant le widget pere                           */
   
Widget	fabrique_scale (valeur_min, valeur_max,valeur_init,
			valeur_decimale,label_widget, parent)

Widget		label_widget, parent;
int		valeur_min, valeur_max, valeur_init,
		valeur_decimale;
{
	Widget		scale;
	Arg		args[20];
	int		n;

	n = 0;
	XtSetArg(args[n], XmNwidth, 70); n++;
	XtSetArg(args[n], XmNheight, 284); n++;
	XtSetArg(args[n], XmNorientation, XmVERTICAL); n++;
	XtSetArg(args[n], XmNscaleWidth, 20); n++;
	XtSetArg(args[n], XmNscaleHeight, 284); n++;
	XtSetArg(args[n], XmNborderWidth, 0); n++;
	XtSetArg(args[n], XmNminimum, valeur_min); n++;
	XtSetArg(args[n], XmNmaximum,  valeur_max); n++;
	XtSetArg(args[n], XmNvalue, valeur_init); n++;
	XtSetArg(args[n], XmNshowValue, True); n++;
	XtSetArg(args[n], XmNbottomOffset, 5); n++;
	XtSetArg(args[n], XmNdecimalPoints, valeur_decimale); n++;
	XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
	XtSetArg(args[n], XmNtopWidget, label_widget); n++;
        XtSetArg(args[n], XmNforeground, BlackPixel(display, screen));n++;
	XtSetArg(args[n], XmNbackground, WhitePixel(display, screen));n++;

	scale = XmCreateScale(parent,"scale",args,n);
	return (scale);
} 

/*-------------------------------------------*/
void DrawNeuron(w)
/*-------------------------------------------*/

Widget	w;
{
	int	i, j, flag_break,
		n;

	float	f_i;

	Arg	args[20];

	Window	window;
	
	Display	*display;


#if DEBUG
	printf("ICI ON DESSINE!\n");
#endif
	n = 0;
	XtSetArg(args[n], XmNwidth, &largeur); n++;
	XtSetArg(args[n], XmNheight, &hauteur); n++;
	XtGetValues(MainWindow, args, n);

	/* Scaling	*/

	x_origine = SCALE_WIDTH;		/* Pour mettre l'echelle */
	y_origine = 0;
	x_echelle = (float)(largeur - SCALE_WIDTH) / sim_duration;
	y_echelle = (float)(hauteur - 35 - SCALE_WIDTH) / (float)(Max_DDP);	


#if DEBUG
	printf("ICI ON CLEAR!\n");
#endif

	display = XtDisplay(WorkRegion);
	window = XtWindow(WorkRegion);

	XClearArea(display, window,
		   0, 0, largeur, hauteur, False);
/*
		   (int)((sim_duration + SCALE_WIDTH) * x_echelle),
		   (int)((Max_DDP + SCALE_WIDTH) * y_echelle), False);
*/	

#if DEBUG
	printf("ICI ON A CLEARE!\n");
#endif
	/* Les echelles */

	XSetLineAttributes(display, Draw_GC, 
			  1, LineSolid, CapButt, JoinMiter);

	/* Echelle des potentiels */
	
	XDrawLine(display, window, Draw_GC,
		  SCALE_WIDTH - 10,0,
		  SCALE_WIDTH ,0);
	XDrawLine(display, window, Draw_GC,
		  SCALE_WIDTH ,0,
		  SCALE_WIDTH ,(int)((Max_Y - Min_Y) * y_echelle));
	XDrawLine(display, window, Draw_GC,
		  SCALE_WIDTH ,(int)((Max_Y - Min_Y) * y_echelle),
		  SCALE_WIDTH - 10,(int)((Max_Y - Min_Y) * y_echelle));

	for (f_i = Min_Y; f_i <= Max_Y; f_i += 20.)
	{
		XDrawLine(display, window, Draw_GC,
			  SCALE_WIDTH - 10,(int)((Max_Y - f_i) * y_echelle),
			  SCALE_WIDTH ,(int)((Max_Y - f_i) * y_echelle));
		sprintf(buffer,"%4.0f",f_i);
		XDrawImageString(display, window, Draw_GC,
	 			 0,(int)((Max_Y - f_i) * y_echelle),
				 buffer,4);
	} /* fin du for */

#if DEBUG
	printf("Echelle des Y OK!\n");
#endif

	/* Echelle des temps */
	
	XDrawLine(display, window, Draw_GC,
		  x_origine, (int)((Max_Y - Min_Y) * y_echelle) + 10, 
		  x_origine, (int)((Max_Y - Min_Y) * y_echelle));
	XDrawLine(display, window, Draw_GC,
		  x_origine, (int)((Max_Y - Min_Y) * y_echelle),
		  (int)(sim_duration * x_echelle) + x_origine, 
		  (int)((Max_Y - Min_Y) * y_echelle));
	XDrawLine(display, window, Draw_GC,
		  (int)(sim_duration * x_echelle) + x_origine,
		  (int)((Max_Y - Min_Y) * y_echelle),
		  (int)(sim_duration * x_echelle) + x_origine,
		  (int)((Max_Y - Min_Y) * y_echelle) + 10);

	for (f_i = 0.; f_i <= sim_duration; f_i += (sim_duration/10.))
	{
		XDrawLine(display, window, Draw_GC,
			  (int)(f_i * x_echelle) + x_origine,
			  (int)((Max_Y - Min_Y) * y_echelle),
			  (int)(f_i * x_echelle) + x_origine,
			  (int)((Max_Y - Min_Y) * y_echelle) + 10);

		sprintf(buffer,"%4.0f",f_i);
		XDrawImageString(display, window, Draw_GC,
				 (int)(f_i * x_echelle) + x_origine - 10,
				 (int)((Max_Y - Min_Y) * y_echelle) + 20,
				 buffer,4);
	} /* fin du for */
	XDrawLine(display, window, Draw_GC,
		  x_origine, (int)((Max_Y - Min_Y) * y_echelle) + 10, 
		  x_origine, (int)((Max_Y - Min_Y) * y_echelle));

#if DEBUG
	printf("Echelle des X OK!\n");
#endif

	if (!lim_type)
	{
	  /* Reverse potentials */

	  XSetLineAttributes(display, Draw_GC, 
			     5, LineSolid, CapButt, JoinRound);

	  /* positif */ 

	  XDrawLine(display, window, Draw_GC,
		    x_origine,
		    (int)((Max_Y - clu_burst.rev_pot_pos) * y_echelle),
		    (int)(sim_duration * x_echelle) + x_origine,
		    (int)((Max_Y - clu_burst.rev_pot_pos) * y_echelle));

#if DEBUG
	  printf("Reversal potential - OK!\n");
#endif
	  /* negatif */ 

	  XDrawLine(display, window, Draw_GC,
		    x_origine,
		    (int)((Max_Y - clu_burst.rev_pot_neg) * y_echelle),
		    (int)(sim_duration * x_echelle) + x_origine,
		    (int)((Max_Y - clu_burst.rev_pot_neg) * y_echelle));
#if DEBUG
	  printf("Reversal potential - OK!\n");
#endif
	}
	if (bum_type)
	{
	  /* Bursting threshold */

	  XSetLineAttributes(display, Draw_GC, 
			     2, LineSolid, CapButt, JoinRound);

	  /* positif */ 

	  XDrawLine(display, window, Draw_GC,
		    x_origine,
		    (int)((Max_Y - clu_burst.seuil_burst) * y_echelle),
		    (int)(sim_duration * x_echelle) + x_origine,
		    (int)((Max_Y - clu_burst.seuil_burst) * y_echelle));

        }
	/* Potentiel de mb */

	burst_dyn.decharge_lag = 32000.;
	burst_dyn.soma = clu_burst.rest_pot;
	burst_dyn.soma_post_spike = clu_burst.pot_post_spike;

	clu_burst.overshoot = clu_burst.pot_post_spike -  clu_burst.rest_pot;
	clu_burst.i_tau_mb_pot = 1. / clu_burst.tau_mb_pot;
	clu_burst.i_tau_seuil = 1./ clu_burst.tau_seuil;

	burst_dyn.threshold = clu_burst.seuil;
	burst_dyn.seuil_peak =  clu_burst.seuil_post_spike +  clu_burst.seuil;
	burst_dyn.delta_seuil = clu_burst.seuil_post_spike;

	burst_dyn.tail = burst_dyn.head = 0;
	burst_dyn.queue = burst_dyn.tete = 0;
	burst_dyn.spike = FALSE;


	clu_burst.v_plus = (clu_burst.rev_pot_pos - clu_burst.rest_pot);
	v_moins = (clu_burst.rev_pot_neg - clu_burst.rest_pot);
	clu_burst.A = (1./ clu_burst.v_plus) - (1. / v_moins);
	clu_burst.v_rap = clu_burst.v_plus / v_moins;

	if (bum_type)
	{	
	  clu_burst.burst_overshoot = clu_burst.burst_post_spike - clu_burst.seuil_burst;

	  clu_burst.b_v_plus = (clu_burst.rev_pot_pos - clu_burst.seuil_burst);
	  v_moins = (clu_burst.rev_pot_neg - clu_burst.seuil_burst);
	  clu_burst.b_A = (1./ clu_burst.b_v_plus) - (1. / v_moins);
	  clu_burst.b_v_rap = clu_burst.b_v_plus / v_moins;

	  for (i = 0; i < MAX_BURST; i++)
	  {
	      burst_dyn.sablier[i] = 0;
	  }
	  burst_dyn.nb_sabliers = 0;
	  burst_dyn.in_burst = FALSE;
	}

	filter_a = exp(-time_step /  (clu_burst.resistance * clu_burst.capacite));
	filter_b = 1./ clu_burst.capacite;


	for (i = 0; i < 6; i ++)
	{
	    le_epsp1[i].x =  x_origine;
	    le_epsp1[i].y =  (int)((Max_Y - burst_dyn.soma) * y_echelle) + 10 ;
	    le_epsp2[i].x =  x_origine;
	    le_epsp2[i].y =  (int)((Max_Y - burst_dyn.soma) * y_echelle) + 20 ;
	    le_epsp3[i].x =  x_origine;
	    le_epsp3[i].y =  (int)((Max_Y - burst_dyn.soma) * y_echelle) + 30 ;
	    le_ipsp1[i].x =  x_origine;
	    le_ipsp1[i].y =  (int)((Max_Y - burst_dyn.soma) * y_echelle) + 40 ;
	    le_ipsp2[i].x =  x_origine;
	    le_ipsp2[i].y =  (int)((Max_Y - burst_dyn.soma) * y_echelle) + 50 ;
	    le_ipsp3[i].x =  x_origine;
	    le_ipsp3[i].y =  (int)((Max_Y - burst_dyn.soma) * y_echelle) + 60 ;
        }
	un_epsp1 = un_epsp2 = un_epsp3 = un_ipsp1 = un_ipsp2 = un_ipsp3 = FALSE;

	j = 0;
	flag_break = 0;
	for (i = 0; i < nb_points; i++)
	{
		un_epsp = un_ipsp = 0.;
		if (i == nb_points*EpspArr1/100)
		{
		  un_epsp += clu_burst.epsp;
		  un_epsp1 = TRUE;
		}
		if (i == nb_points*EpspArr2/100)
		{
		  un_epsp += clu_burst.epsp;
		  un_epsp2 = TRUE;
		}
		if (i == nb_points*EpspArr3/100)
		{
		  un_epsp += clu_burst.epsp;
		  un_epsp3 = TRUE;
		}
		if (i == nb_points*IpspArr1/100)
		{
		  un_ipsp += clu_burst.ipsp;
		  un_ipsp1 = TRUE;
		}
		if (i == nb_points*IpspArr2/100)
		{
		  un_ipsp += clu_burst.ipsp;
		  un_ipsp2 = TRUE;
		}
		if (i == nb_points*IpspArr3/100)
		{
		  un_ipsp += clu_burst.ipsp;
		  un_ipsp3 = TRUE;
		}

		if (pum_type || bum_type)
		  update_neur(i);
		if (lim_type)
		  update_lim(i);

		f_i = (float)i*time_step;

		if (burst_dyn.spike)
		{
			le_soma[j].x = le_seuil[j].x = (f_i * x_echelle) + x_origine ;
			le_soma[j].y = le_soma[j-1].y;
			le_seuil[j].y = le_seuil[j-1].y;
			j++;

			le_soma[j].x = le_seuil[j].x = ((f_i + 0.33) * x_echelle) + x_origine ;
			le_soma[j].y = (int)((Max_Y - burst_dyn.threshold) * y_echelle) ; 
			le_seuil[j].y = (int)((Max_Y - burst_dyn.threshold) * y_echelle) ; 
			j++;

			le_soma[j].x = le_seuil[j].x = ((f_i + 0.66) * x_echelle) + x_origine ;
			le_soma[j].y = (int)((Max_Y - TOP_SPIKE) * y_echelle) ; 
			le_seuil[j].y = (int)((Max_Y - burst_dyn.threshold) * y_echelle) ; 
			
		} /* fin du if */
		else
		{
			le_soma[j].x = le_seuil[j].x = (f_i * x_echelle) + x_origine ;
			le_soma[j].y = (int)((Max_Y - burst_dyn.soma) * y_echelle) ; 
			le_seuil[j].y = (int)((Max_Y - burst_dyn.threshold) * y_echelle) ; 
			
		} /* fin du else */
		j++;
		if (j >= nb_points*2) 
		  {
		    flag_break = 1;
		    break;
		  }

		  
	} /* fin du for */

	if (flag_break) 
	  nb_pts_dessin =j-10;
	else 
	  nb_pts_dessin =j;

#if DEBUG
	  printf("nb_pts_dessin = %d\n",nb_pts_dessin);
#endif

	/**************************************/
	/*	Dessiner les points du soma   */
	/**************************************/

	XSetLineAttributes(display, Draw_GC, 
			  2, LineSolid, CapButt, JoinRound);

	for (j = 0; j < (nb_pts_dessin - 1); j++)
	  {
	    XDrawLine(display, window, Draw_GC,le_soma[j].x, le_soma[j].y, 
		                               le_soma[j+1].x, le_soma[j+1].y );
	  }

#if DEBUG
	  printf("Soma dessine!\n");
#endif

	/**************************************/
	/*	Dessiner les points du seuil  */
	/**************************************/

	XSetLineAttributes(display, Draw_GC, 
			  1, LineSolid, CapButt, JoinRound);

	for (j = 0; j < (nb_pts_dessin - 1); j++)
	  {
	    XDrawLine(display, window, Draw_GC,le_seuil[j].x, le_seuil[j].y, 
		                               le_seuil[j+1].x, le_seuil[j+1].y );
	  }

#if DEBUG
	  printf("Seuil dessine!\n");
#endif


	if (clu_burst.epsp)
	{
	  XDrawLines(display, window, Draw_GC, le_epsp1, 6, CoordModeOrigin);
	  XDrawLines(display, window, Draw_GC, le_epsp2, 6, CoordModeOrigin);
	  XDrawLines(display, window, Draw_GC, le_epsp3, 6, CoordModeOrigin);
	}
	if (clu_burst.ipsp)
	{
	  XDrawLines(display, window, Draw_GC, le_ipsp1, 6, CoordModeOrigin);
	  XDrawLines(display, window, Draw_GC, le_ipsp2, 6, CoordModeOrigin);
	  XDrawLines(display, window, Draw_GC, le_ipsp3, 6, CoordModeOrigin);
	}
#if DEBUG
	  printf("Maintenant on flush!\n");
#endif

	XFlush(display);
#if DEBUG
	  printf("Fin de draw neuron!\n");
#endif


} /* fin du DrawNeuron */


/*
 * generateur de nb aleatoires uniforme (recipes in C)
 */


#define M1 259200
#define IA1 7141
#define IC1 54773
#define RM1 (1.0/M1)
#define M2 134456
#define IA2 8121
#define IC2 28411
#define RM2 (1.0/M2)
#define M3 243000
#define IA3 4561
#define IC3 51349

float ran1(idum)
int *idum;
{
	static long ix1,ix2,ix3;
	static float r[98];
	float temp;
	static int iff=0;
	int j;
	void nrerror();

	if (*idum < 0 || iff == 0) {
		iff=1;
		ix1=(IC1-(*idum)) % M1;
		ix1=(IA1*ix1+IC1) % M1;
		ix2=ix1 % M2;
		ix1=(IA1*ix1+IC1) % M1;
		ix3=ix1 % M3;
		for (j=1;j<=97;j++) {
			ix1=(IA1*ix1+IC1) % M1;
			ix2=(IA2*ix2+IC2) % M2;
			r[j]=(ix1+ix2*RM2)*RM1;
		}
		*idum=1;
	}
	ix1=(IA1*ix1+IC1) % M1;
	ix2=(IA2*ix2+IC2) % M2;
	ix3=(IA3*ix3+IC3) % M3;
	j=1 + ((97*ix3)/M3);
	if (j > 97 || j < 1) nrerror("RAN1: This cannot happen.");
	temp=r[j];
	r[j]=(ix1+ix2*RM2)*RM1;
	return temp;
}

#undef M1
#undef IA1
#undef IC1
#undef RM1
#undef M2
#undef IA2
#undef IC2
#undef RM2
#undef M3
#undef IA3
#undef IC3
#undef M_E
#define M_E 2.7182818284590452354

/*
 * generateur de nb aleatoires a distribution gaussienne  (recipes in C)
 */

float gasdev(idum)
int *idum;
{
	static int iset=0;
	static float gset;
	float fac,r,v1,v2;
	float ran1();

	if (iset == 0){
		do {
			v1=2.0*ran1(idum)-1.0;
			v2=2.0*ran1(idum)-1.0;
			r=v1*v1+v2*v2;
		} while (r >= 1.0);
		fac= sqrt(-2.0* log(r)/r);
		gset=v1*fac;
		iset=1;
		return v2*fac;
	} else {
		iset=0;
		return gset;
	}
}
void nrerror(error_text)
char error_text[];
{

	fprintf(stderr,"Numerical Recipes run-time error...\n");
	fprintf(stderr,"%s\n",error_text);
	fprintf(stderr,"...now exiting to system...\n");
	exit(1);
}

/*******************************************************************************
	Function for Summing the inputs that are in the queues 
*******************************************************************************/
float suminputs(float *ip_tc, float *im_tc, float * i_amp,
		       int * i_time, short head, short tail, float t_nb_it)
/*
float	ip_tc:	 cste temps attack PSP
	im_tc:	 cste temps decay PSP 
float 	*i_amp:	 file d'attente des amplitudes des events
int	*i_time: file d'attente des moments de survenue des events
short	head:  tete et queue de la file d'attente 
	tail:
float   t_nb_it: nb iterations

*/
{
	short	curr_input;
	float	curr_time;
	float   delta_time;
	double	sum_i;

	/* If head == tail, the queues are empty */
	
	if (head == tail) return(0.);
	
	
	/*
	 * Loop for each input, sum their current values together
	 */
	
	sum_i = 0.0;
	for (curr_input = head; curr_input != tail; curr_input = (curr_input+1)%MAX_MEM)
	{
		curr_time = (float)i_time[curr_input];		/* moment de l'arrivee de l'input */
		delta_time = (t_nb_it - curr_time);

		if(!ip_tc[curr_input] || !im_tc[curr_input])
			continue;
		
		if ( t_nb_it < (curr_time + ip_tc[curr_input]) && t_nb_it > curr_time)
			sum_i += i_amp[curr_input] * delta_time/ip_tc[curr_input] *
				exp((-delta_time/ip_tc[curr_input])+1.);
		if ( t_nb_it >= (curr_time + ip_tc[curr_input]))
			sum_i += (i_amp[curr_input] 
				  * (delta_time + im_tc[curr_input] - ip_tc[curr_input])/im_tc[curr_input] *
				exp(((-delta_time - im_tc[curr_input] + ip_tc[curr_input])/im_tc[curr_input])+1.));

	}
	return(sum_i);
}


/*
*	UPDATE_NEUR() calcule le potentiel a un moment
*/
update_neur(nb_it)
int	nb_it;
{
	register	i, j, k;	/* indices */
	int	set, d_l;
	float	K_epsp,			/* constantes pour le calcul de reversion */
		K_ipsp,
		K_noise,
		gasdev(),
		delta_ipsp,		
		delta_epsp,		
	        duree,
		exp_x,			/* exponentielle de delta */
		t_i, 			/* Elapsed time */
		somme_psp,		/* epsp et ipsp venant des
					 * autres neurones et leur somme
					 */
		delta,			/* pot mb - rev pot */
                seuil_increase,
		net_input,		/* somme de ce qui arrive (intermediaire) */
		net_input_neg,		/* somme de ce qui arrive (intermediaire) */
		noise = 0.;		/* background noise */	
	short	nb_it_s;        	/* Current iteration in short */


	set = (int)time(0) & 077;	/* nb aleatoire */
	
	t_i = (float)nb_it;
	nb_it_s = (short)nb_it;
	net_input = somme_psp = 0.;

	if (bum_type)
	{
	    /* Gestion du sablier */

	    for (i = 0; i < burst_dyn.nb_sabliers; i++)
	    {
		   burst_dyn.sablier[i]--;
		   if (!burst_dyn.sablier[i])
		   {
		       /* 
			*  si le sablier est vide, on l'enleve en avancant les
			*  autres d un cran 
			*/
		       for (j = i+1; j < burst_dyn.nb_sabliers; j++)
		       {
			   burst_dyn.sablier[j-1] = burst_dyn.sablier[j];
		       }
		       burst_dyn.nb_sabliers--;
		       burst_dyn.frequence = (clu_burst.freq_spike * (clu_burst.compose_fact * burst_dyn.nb_sabliers));
		       if (burst_dyn.frequence > clu_burst.freq_max)
			 burst_dyn.frequence = clu_burst.freq_max;
		       i--;
		   }
	    }
	    if (!burst_dyn.nb_sabliers)
		    burst_dyn.in_burst = FALSE;
	}
	/*
	 * Calcul du voltage intra somatique
	 */
	if (backgrd_noise_sd)
	{
		white_noise = gasdev(&set);
		white_noise *= (backgrd_noise_sd * sqrt(time_step)) ;
		if (filter_noise)
		{
		  center_noise = center_noise * filter_a + filter_b * white_noise; 
		  noise = center_noise + backgrd_noise_m;
		}
		else
		  noise = white_noise + backgrd_noise_m;
	} /* fin du if */
	else	
	  noise = backgrd_noise_m;

	if (burst_dyn.in_burst)
	{
	        burst_dyn.soma = (clu_burst.burst_overshoot
				  * exp((-burst_dyn.decharge_lag)
					* time_step * clu_burst.i_tau_mb_pot))
		                 + (burst_dyn.soma_post_spike - clu_burst.burst_overshoot); 
#if DEBUG_UPDT_1
		printf("%d:  soma au depart: %f (overshoot= %f) ",
		       nb_it,burst_dyn.soma,
		       clu_burst.burst_overshoot);
		printf("soma post_spike: %f Noise: %f\n",
		       burst_dyn.soma_post_spike,noise);
#endif
		/*
		 * Calcul des inputs venant des autres cellules
		 */

		delta_epsp = clu_burst.rev_pot_pos - burst_dyn.soma;
		delta_ipsp = clu_burst.rev_pot_neg - burst_dyn.soma;
#if DEBUG_UPDT
		printf(" delta_epsp = %f  delta_ipsp = %f\n",
			delta_epsp, delta_ipsp);
#endif		       


		/* Implementation du Reversal Potential (V 4.4) */

		/*
		 *	Le prb des sommes de PSP est plus delicat que celui 
		 * d'un seul PSP. Nous avons estime qu'il faut d'abord faire 
		 * la somme de tout ce qui est + (epsp) et - (ipsp), 
		 * separement, puis de calculer son facteur de dependance par 
		 * rapport au rev pot.
		 * On estime que plus on se rapproche du reversal potential,
		 * moins l'effet d'un PSP est important donc, cela depend de
		 * (soma - rev_pot). Si on est au pot de mb, le facteur
		 * multiplicateur est 1, et si on est au rev pot il est 0.
		 * Donc, le PSP sera multiplie par un facteur qui devient
		 * lineairement de plus en plus petit au fur et a mesure
		 * que l'on se rapporche du Rev pot (V4.10):
		 *   K_rev_[pn] = 1 / (Pot_repos - reversal)
		 *   K_[ei]psp = (soma - reversal) * K_rev_[pn]
		 *   [ei]psp *= K_[ei]psp   
		 */
		/* On ne se lance dans les calculs que s'il y a lieu */



#if DEBUG_UPDT_1
		printf("%d:  soma au depart: %f (overshoot= %f) ",
		       nb_it,burst_dyn.soma,
		       clu_burst.burst_overshoot);
		printf("soma post_spike: %f Noise: %f\n",
		       burst_dyn.soma_post_spike,noise);
#endif
	}
	else
	{
	        burst_dyn.soma = (clu_burst.overshoot
				  * exp((-burst_dyn.decharge_lag)
					* time_step * clu_burst.i_tau_mb_pot)) /* deja un inverse */
		                 + (burst_dyn.soma_post_spike - clu_burst.overshoot); 
#if DEBUG_UPDT_1
		printf("%d:  soma au depart: %f (overshoot= %f) ",
		       nb_it,burst_dyn.soma,
		       clu_burst.overshoot);
		printf("soma post_spike: %f Noise: %f\n",
		       burst_dyn.soma_post_spike,noise);
#endif
		/*
		 * Calcul des inputs venant des autres cellules
		 */

		delta_epsp = clu_burst.rev_pot_pos - burst_dyn.soma;
		delta_ipsp = clu_burst.rev_pot_neg - burst_dyn.soma;
#if DEBUG_UPDT
		printf(" delta_epsp = %f  delta_ipsp = %f\n",
			delta_epsp, delta_ipsp);
#endif		       


		/* Implementation du Reversal Potential (V 4.4) */

		/*
		 *	Le prb des sommes de PSP est plus delicat que celui 
		 * d'un seul PSP. Nous avons estime qu'il faut d'abord faire 
		 * la somme de tout ce qui est + (epsp) et - (ipsp), 
		 * separement, puis de calculer son facteur de dependance par 
		 * rapport au rev pot.
		 * On estime que plus on se rapproche du reversal potential,
		 * moins l'effet d'un PSP est important donc, cela depend de
		 * (soma - rev_pot). Si on est au pot de mb, le facteur
		 * multiplicateur est 1, et si on est au rev pot il est 0.
		 * Donc, le PSP sera multiplie par un facteur qui devient
		 * lineairement de plus en plus petit au fur et a mesure
		 * que l'on se rapporche du Rev pot (V4.10):
		 *   K_rev_[pn] = 1 / (Pot_repos - reversal)
		 *   K_[ei]psp = (soma - reversal) * K_rev_[pn]
		 *   [ei]psp *= K_[ei]psp   
		 */
		/* On ne se lance dans les calculs que s'il y a lieu */



#if DEBUG_UPDT_1
		printf("%d:  soma au depart: %f (overshoot= %f) ",
		       nb_it,burst_dyn.soma,
		       burst_dyn.overshoot);
		printf("soma post_spike: %f Noise: %f\n",
		       burst_dyn.soma_post_spike,noise);
#endif
	        
	}
		/*
		 * Calcul des inputs venant des autres cellules
		 */

	un_epsp *= input_e_fact;
	un_ipsp *= input_i_fact;

	if (un_epsp || un_ipsp)
	{
		/*
		 * on met le resultat epsp+ipsp dans la file d'attente
		 * temporelle
		 */
		burst_dyn.inp_t[burst_dyn.tail] = nb_it;

		if (un_epsp)
		{
			if (bum_type && ((un_epsp + burst_dyn.soma) >= clu_burst.seuil_burst))
			{
				duree = ran1(&set)*clu_burst.burst_range;
				burst_dyn.sablier[burst_dyn.nb_sabliers] = (clu_burst.duree_burst_min + duree)/time_step;
				if (un_epsp1)
				{
				     le_epsp1[1].x = le_epsp1[0].x + (int)(t_i * x_echelle);
				     le_epsp1[1].y = le_epsp1[0].y;
				     le_epsp1[2].x = le_epsp1[1].x;
				     le_epsp1[2].y = le_epsp1[1].y - 3;
				     le_epsp1[3].x = le_epsp1[2].x + (int)((float)burst_dyn.sablier[burst_dyn.nb_sabliers] * x_echelle);
				     le_epsp1[3].y = le_epsp1[2].y;
				     le_epsp1[4].x = le_epsp1[3].x;
				     le_epsp1[4].y = le_epsp1[3].y + 3;
				     le_epsp1[5].x = le_epsp1[0].x + (int)((float)nb_points * x_echelle);
				     le_epsp1[5].y = le_epsp1[4].y;
				     un_epsp1 = FALSE;
				}
				if (un_epsp2)
				{
				     le_epsp2[1].x = le_epsp2[0].x + (int)(t_i * x_echelle);
				     le_epsp2[1].y = le_epsp2[0].y;
				     le_epsp2[2].x = le_epsp2[1].x;
				     le_epsp2[2].y = le_epsp2[1].y - 3;
				     le_epsp2[3].x = le_epsp2[2].x + (int)((float)burst_dyn.sablier[burst_dyn.nb_sabliers] * x_echelle);
				     le_epsp2[3].y = le_epsp2[2].y;
				     le_epsp2[4].x = le_epsp2[3].x;
				     le_epsp2[4].y = le_epsp2[3].y + 3;
				     le_epsp2[5].x = le_epsp2[0].x + (int)((float)nb_points * x_echelle);
				     le_epsp2[5].y = le_epsp2[4].y;
				     un_epsp2 = FALSE;
				}
				if (un_epsp3)
				{
				     le_epsp3[1].x = le_epsp3[0].x + (int)(t_i * x_echelle);
				     le_epsp3[1].y = le_epsp3[0].y;
				     le_epsp3[2].x = le_epsp3[1].x;
				     le_epsp3[2].y = le_epsp3[1].y - 3;
				     le_epsp3[3].x = le_epsp3[2].x + (int)((float)burst_dyn.sablier[burst_dyn.nb_sabliers] * x_echelle);
				     le_epsp3[3].y = le_epsp3[2].y;
				     le_epsp3[4].x = le_epsp3[3].x;
				     le_epsp3[4].y = le_epsp3[3].y + 3;
				     le_epsp3[5].x = le_epsp3[0].x + (int)((float)nb_points * x_echelle);
				     le_epsp3[5].y = le_epsp3[4].y;
				     un_epsp3 = FALSE;
				}
				burst_dyn.nb_sabliers++;
				burst_dyn.in_burst = TRUE;
#if DEBUG_BURST
				printf("ran1: %f (%f range)\n",ran1(&set),clu_burst.burst_range);
				printf("Duree: %f ms (%d it) nb_sabliers: %d\n",duree,burst_dyn.sablier[burst_dyn.nb_sabliers-1], burst_dyn.nb_sabliers);
#endif
				if (burst_dyn.frequence < clu_burst.freq_max)
				{
				      burst_dyn.frequence = (clu_burst.compose_fact * burst_dyn.nb_sabliers) * clu_burst.freq_spike;
				      if (burst_dyn.frequence > clu_burst.freq_max)
					   burst_dyn.frequence = clu_burst.freq_max;
				}
				if (burst_dyn.frequence)
				      burst_dyn.spike_suivante = nb_it;
#if DEBUG_BURST
				printf("iter: %d (spike suivante: %d)\n", nb_it, burst_dyn.spike_suivante);
#endif
			}
		}
		if (un_ipsp)
		{
			if (un_ipsp1)
			{
			     le_ipsp1[1].x = le_ipsp1[0].x + (int)(t_i * x_echelle);
			     le_ipsp1[1].y = le_ipsp1[0].y;
			     le_ipsp1[2].x = le_ipsp1[1].x;
			     le_ipsp1[2].y = le_ipsp1[1].y + 3;
			     le_ipsp1[3].x = le_ipsp1[2].x + 2;
			     le_ipsp1[3].y = le_ipsp1[2].y;
			     le_ipsp1[4].x = le_ipsp1[3].x;
			     le_ipsp1[4].y = le_ipsp1[3].y - 3;
			     le_ipsp1[5].x = le_ipsp1[0].x + (int)((float)nb_points * x_echelle);
			     le_ipsp1[5].y = le_ipsp1[4].y;
			     un_ipsp1 = FALSE;
       			}
			if (un_ipsp2)
			{
			     le_ipsp2[1].x = le_ipsp2[0].x + (int)(t_i * x_echelle);
			     le_ipsp2[1].y = le_ipsp2[0].y;
			     le_ipsp2[2].x = le_ipsp2[1].x;
			     le_ipsp2[2].y = le_ipsp2[1].y + 3;
			     le_ipsp2[3].x = le_ipsp2[2].x + 3;
			     le_ipsp2[3].y = le_ipsp2[2].y;
			     le_ipsp2[4].x = le_ipsp2[3].x;
			     le_ipsp2[4].y = le_ipsp2[3].y - 3;
			     le_ipsp2[5].x = le_ipsp2[0].x + (int)((float)nb_points * x_echelle);
			     le_ipsp2[5].y = le_ipsp2[4].y;
 			     un_ipsp2 = FALSE;
      			}
			if (un_ipsp3)
			{
			     le_ipsp3[1].x = le_ipsp3[0].x + (int)(t_i * x_echelle);
			     le_ipsp3[1].y = le_ipsp3[0].y;
			     le_ipsp3[2].x = le_ipsp3[1].x;
			     le_ipsp3[2].y = le_ipsp3[1].y + 3;
			     le_ipsp3[3].x = le_ipsp3[2].x + 3;
			     le_ipsp3[3].y = le_ipsp3[2].y;
			     le_ipsp3[4].x = le_ipsp3[3].x;
			     le_ipsp3[4].y = le_ipsp3[3].y - 3;
			     le_ipsp3[5].x = le_ipsp3[0].x + (int)((float)nb_points * x_echelle);
			     le_ipsp3[5].y = le_ipsp3[4].y;
			     un_ipsp3 = FALSE;
       			}
			if (burst_dyn.nb_sabliers)
			{
			      burst_dyn.frequence = (clu_burst.compose_fact * burst_dyn.nb_sabliers-1) * clu_burst.freq_spike;
			      if (burst_dyn.frequence < 0.)
			      {
				   burst_dyn.frequence = 0.;
				   burst_dyn.nb_sabliers--;
				   burst_dyn.in_burst = FALSE;
			      }
			}
		}
		somme_psp = un_epsp - un_ipsp;

#if DEBUG_BURST
		printf("inp_max= %f inp_t= %d\n",
		       burst_dyn.inp_max_pos[burst_dyn.tail],
		       burst_dyn.inp_t[burst_dyn.tail]);
#endif
		burst_dyn.inp_max_pos[burst_dyn.tail] = somme_psp;

		if(somme_psp > 0.0)
		{
			burst_dyn.inp_ta[burst_dyn.tail] = clu_burst.tau_attack_epsp / time_step ;
			burst_dyn.inp_td[burst_dyn.tail] = clu_burst.tau_decay_epsp / time_step ;
		}
		else if(somme_psp < 0.0)
		{
			burst_dyn.inp_ta[burst_dyn.tail] = clu_burst.tau_attack_ipsp / time_step;
			burst_dyn.inp_td[burst_dyn.tail] = clu_burst.tau_decay_ipsp / time_step;
		}

		burst_dyn.tail = (burst_dyn.tail + 1) % MAX_MEM;
		if (burst_dyn.tail == burst_dyn.head)
			burst_dyn.head = (burst_dyn.head + 1) % MAX_MEM;
	} /* fin du if */

	/*
	 * Le probleme du bruit: le bruit est lui aussi multiplie par
	 * le facteur positif s'il est positif (il a la valeur d'un
	 * epsp) et par le facteur negatif sinon (si 0 il est
	 * considere comme positif)
	 */

	net_input =  suminputs(burst_dyn.inp_ta, burst_dyn.inp_td,
				   burst_dyn.inp_max_pos,
				   burst_dyn.inp_t,
				   burst_dyn.head,
				   burst_dyn.tail, t_i) + noise;
	/*
	 * Maintenant on peut calculer le soma
	 * Calcul du voltage intra somatique
	 * et tenir compte du shunt de la mb qui varie en f(t)
	 */
	d_l = (int)(burst_dyn.decharge_lag);
	if (d_l < MAX_SHUNT / time_step)
	{
		if (clu_burst.shunt_tau / time_step < .1)
			burst_dyn.soma += net_input;
		else
			burst_dyn.soma += (net_input
					  * ( 1. - exp(-burst_dyn.decharge_lag * time_step/clu_burst.shunt_tau)));
	} /* fin du if */
	else
		burst_dyn.soma += net_input;

	/*
	 * ca decharge ou pas?
	 */

	if (burst_dyn.in_burst)     /* on est dans un burst */
	{
	      burst_dyn.soma -= clu_burst.seuil_burst;
	      burst_dyn.soma = clu_burst.b_v_plus * 
			       (exp(clu_burst.b_A * burst_dyn.soma) - 1.) 
				/ (exp(clu_burst.b_A * burst_dyn.soma) - clu_burst.b_v_rap);
	      burst_dyn.soma += clu_burst.seuil_burst;

	      if (nb_it == burst_dyn.spike_suivante )
	      {
		    burst_dyn.spike = TRUE;
		    burst_dyn.decharge_lag = 0.;
		    burst_dyn.soma_post_spike = /* burst_dyn.soma + clu_burst.burst_overshoot; */
		    burst_dyn.soma = clu_burst.burst_post_spike;

		    if (burst_dyn.frequence)
		      burst_dyn.spike_suivante = nb_it + (int)((1000./ burst_dyn.frequence) / time_step);
	      }
	      else
	      {
		    burst_dyn.spike = FALSE;
		    burst_dyn.decharge_lag += 1.;
	      }
	}
	else                         /* on est hors burst */
        {
	      /*
	       * Calcul du seuil de decharge
	       */
	      burst_dyn.threshold =   burst_dyn.delta_seuil 
				* exp((-burst_dyn.decharge_lag) 
				* time_step  * clu_burst.i_tau_seuil)
				+ clu_burst.seuil;

    
    	      burst_dyn.soma -= clu_burst.rest_pot;
	      burst_dyn.soma = clu_burst.v_plus * 
			       (exp(clu_burst.A * burst_dyn.soma) - 1.) 
				/ (exp(clu_burst.A * burst_dyn.soma) - clu_burst.v_rap);
	      burst_dyn.soma += clu_burst.rest_pot;

	      if (burst_dyn.soma >= burst_dyn.threshold)
	      {				/* on a un spike */
		    burst_dyn.spike = TRUE;
		    burst_dyn.decharge_lag = 0.;
#if DEBUG_UPDT_1
		    printf("soma avt spike: %f\n",
			   burst_dyn.soma);
#endif
		    burst_dyn.soma_post_spike = /* burst_dyn.soma + clu_burst.overshoot; */
		    burst_dyn.soma = clu_burst.pot_post_spike;

		    /*
		     * On vide la file d'attente puisque ca a decherge
		     */
		    
		    burst_dyn.tail = burst_dyn.head = 0.;


		    /* calcul de la valeur absolue du seuil apres ce spike (seuil_peak) */

		    if (less_fatigue)
		    {
		      delta = (burst_dyn.seuil_peak - burst_dyn.threshold);
		      seuil_increase = (clu_burst.seuil_post_spike - delta)* clu_burst.fatigue + delta;
		    }
		    else
		    {
		      seuil_increase = clu_burst.seuil_post_spike * 
		                     (clu_burst.fatigue * (burst_dyn.threshold - clu_burst.seuil) + 1.);
		    }
		    burst_dyn.seuil_peak = seuil_increase + burst_dyn.threshold;
		    burst_dyn.delta_seuil = burst_dyn.seuil_peak - clu_burst.seuil;
#if DEBUG_BURST
		    printf("SPIKE: iter: %d (spike suivante: %d)\n", nb_it, burst_dyn.spike_suivante);
#endif
	      } /* fin du if */
	      else			/* pas de spike */
	      {
		    burst_dyn.spike = FALSE;
		    burst_dyn.decharge_lag += 1.;
	      } /* fin du else */
	}
} /* fin du update_res */


/*
*	UPDATE_LIM() calcule le potentiel a un moment
*/
update_lim(nb_it)
int	nb_it;
{
	register	i, j, k;	/* indices */
	int	set, d_l;
	float	K_epsp,			/* constantes pour le calcul de reversion */
		K_ipsp,
		K_noise,

		gasdev(),
		delta_ipsp,		
		delta_epsp,		
	        duree,
		exp_x,			/* exponentielle de delta */
		t_i, 			/* Elapsed time */
		somme_psp,		/* epsp et ipsp venant des
					 * autres neurones et leur somme
					 */
		delta,			/* pot mb - rev pot */
                seuil_increase,
		net_input,		/* somme de ce qui arrive (intermediaire) */
		net_input_neg,		/* somme de ce qui arrive (intermediaire) */
		noise = 0.;		/* background noise */	
	short	nb_it_s;        	/* Current iteration in short */


	set = (int)time(0) & 077;	/* nb aleatoire */
	
	t_i = (float)nb_it;
	nb_it_s = (short)nb_it;
	net_input = somme_psp = 0.;

	/*
	 * Calcul du voltage intra somatique
	 */
	if (backgrd_noise_sd)
	{
		white_noise = gasdev(&set);
		white_noise *= (backgrd_noise_sd * sqrt(time_step)) ;
		if (filter_noise)
		{
		  center_noise = center_noise * filter_a + filter_b * white_noise; 
		  noise = center_noise + (backgrd_noise_m * time_step);
		}
		else
		  noise = white_noise + (backgrd_noise_m * time_step);
	} /* fin du if */
	else	
	  noise = (backgrd_noise_m * time_step);

        burst_dyn.soma = burst_dyn.soma * ( 1. - (time_step * clu_burst.i_tau_mb_pot)) + 
	                 (time_step * clu_burst.i_tau_mb_pot * clu_burst.rest_pot);

#if DEBUG_UPDT_1
	printf("%d:  soma au depart: %f ",
	       nb_it,burst_dyn.soma);
	printf("Noise: %f\n", noise);
#endif
		/*
		 * Calcul des inputs venant des autres cellules
		 */

	un_epsp *= input_e_fact;
	un_ipsp *= input_i_fact;

	somme_psp = un_epsp - un_ipsp;

	/*
	 * Le probleme du bruit: le bruit est lui aussi multiplie par
	 * le facteur positif s'il est positif (il a la valeur d'un
	 * epsp) et par le facteur negatif sinon (si 0 il est
	 * considere comme positif)
	 */

	net_input =  somme_psp + noise;

	/*
	 * Maintenant on peut calculer le soma
	 * Calcul du voltage intra somatique
	 * et tenir compte du shunt de la mb qui varie en f(t)
	 */
	d_l = (int)(burst_dyn.decharge_lag);

	burst_dyn.soma += net_input;

	/*
	 * ca decharge ou pas?
	 */

	/*
	 * Calcul du seuil de decharge
	 */
	burst_dyn.threshold =   burst_dyn.delta_seuil 
	  * exp((-burst_dyn.decharge_lag) 
		* time_step  * clu_burst.i_tau_seuil)
	  + clu_burst.seuil;

   
	if (burst_dyn.soma >= burst_dyn.threshold)
	{				/* on a un spike */
	    burst_dyn.spike = TRUE;
	    burst_dyn.decharge_lag = 0.;
#if DEBUG_UPDT_1
	    printf("soma avt spike: %f\n",
		   burst_dyn.soma);
#endif
	    burst_dyn.soma_post_spike = /* burst_dyn.soma + clu_burst.overshoot; */
	      burst_dyn.soma = clu_burst.pot_post_spike;
	    
	    /* calcul de la valeur absolue du seuil apres ce spike (seuil_peak) */

	    if (less_fatigue)
	    {
	      delta = (burst_dyn.seuil_peak - burst_dyn.threshold);
	      seuil_increase = (clu_burst.seuil_post_spike - delta)* clu_burst.fatigue + delta;
	    }
	    else
	    {
	      seuil_increase = clu_burst.seuil_post_spike * 
		(clu_burst.fatigue * (burst_dyn.threshold - clu_burst.seuil) + 1.);
	    }
	    burst_dyn.seuil_peak = seuil_increase + burst_dyn.threshold;
	    burst_dyn.delta_seuil = burst_dyn.seuil_peak - clu_burst.seuil;
#if DEBUG_BURST
	    printf("SPIKE: iter: %d (spike suivante: %d)\n", nb_it, burst_dyn.spike_suivante);
#endif
	} /* fin du if */
	else			/* pas de spike */
	{
	  burst_dyn.spike = FALSE;
	  burst_dyn.decharge_lag += 1.;
	} /* fin du else */
} /* fin du update_lim */








/*********************************************************/
/*     Fonction utile pour afficher des messages d`aide  */
/*********************************************************/

void DispMessageDialog (Widget TheParent,char *TextToDisplay, char *TitleOfDialog,unsigned char TypeOfDialog)
{
/*
**	Variables
*/
	XmString	StringText,
			StringTitle;
	Arg		args[3];
	int		n;
/*
**	Code
*/
	n = 0;
	
	StringText = XmStringCreateLtoR (TextToDisplay, XmFONTLIST_DEFAULT_TAG);
	StringTitle = XmStringCreateLocalized (TitleOfDialog);
	
	if (TheMessageBox)
	{
                XtDestroyWidget(TheMessageBox);
	}
	XtSetArg (args[n], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL); n++;
      	TheMessageBox = XmCreateMessageDialog (TheParent, "TheMessageBox", args, n);
       	if (TypeOfDialog)
		XtUnmanageChild (XmMessageBoxGetChild (TheMessageBox, XmDIALOG_CANCEL_BUTTON));
	XtUnmanageChild (XmMessageBoxGetChild (TheMessageBox, XmDIALOG_HELP_BUTTON));

	XtVaSetValues (TheMessageBox,
		       XmNdialogType,XmDIALOG_MESSAGE ,
		       XmNmessageString, StringText,
#ifndef linux
		       XmNdialogTitle, StringTitle,
#endif
		       NULL);
	XmStringFree (StringText);
	XmStringFree (StringTitle);
	XtAddCallback(TheMessageBox,XmNokCallback,(XtPointer)callback_sortie, NULL);
	XtManageChild (TheMessageBox);
	XtPopup (XtParent(TheMessageBox), XtGrabNone);
}


