#ifndef _FILES_FUNCTIONS_
#define _FILES_FUNCTIONS_
#define DEBUG_FILES	0
#define DRUG_DEBUG      0

#include "creation-simu.h"
#include "sim_init.h"

#ifndef M_PI
#  define M_PI 3.14159265358979323846
#endif

#ifndef R
#define R 8232.0819112627         /* constante des gaz parfaits (* 1000) */
#endif
#ifndef Z
#define Z 1.                      /* valence des ions Na+ et K+ */
#endif
#ifndef F
#define F 9.648456e4              /* constante de Faraday en C/mole */
#endif
#ifndef ZF
#define ZF 9.648456e4              /* constante de Faraday en C/mole */
#endif


/* Ce programme permet de verifier si l`on a selectionner un fichier adapte a la
   simulation en cours */
int verification(char *file_name)
{
  FILE *pt_file; 
  char buffer[256],
       message[256];
  int taille;

  if (file_name[0])
    taille = strlen(file_name);
  else
    return(0);

  if ((current_cluster->model) == file_name[taille-6])
    return (1);  /* OK */
  else 
    return (-1); /* erreur */
}


void show_values()
{
  CBM  *cbm;
  PUM  *pum;
  BUM  *bum;
  LIM  *lim;
#if ADD_NEW_MODEL
/*************** TO ADD A MODEL COPY THIS AND ADAPT *************/
  LIM  *xxm;
/************************ STOP **********************************/
#endif
  char parametre[50],
       value[30],
       buffer[80],
       message[256],
       file_name[256];
  int i;

#if ADD_NEW_MODEL
/*************** TO ADD A MODEL COPY THIS AND ADAPT *************/
	if (current_cluster->model == 'X')
	{

      xxm = (XXM *)current_cluster->clu_data;

      sprintf(buffer,"RestPotential: %f",(xxm->rest_pot));
      _output(buffer);
      sprintf(buffer,"SpikeFrequency: %f",(xxm->freq_spike));
      _output(buffer);
      sprintf(buffer,"MaxSpikeFrequency: %f",(xxm->freq_max));
      _output(buffer);
      sprintf(buffer,"ComposeFact: %f",(xxm->compose_fact));
      _output(buffer);
      sprintf(buffer,"MinBurstDuration: %f",(xxm->duree_burst_min));
      _output(buffer);
      sprintf(buffer,"MaxBurstDuration: %f",(xxm->duree_burst_max));
      _output(buffer);
      sprintf(buffer,"Threshold: %f",(xxm->seuil));
      _output(buffer);
      sprintf(buffer,"ThresholdBurst: %f",(xxm->seuil_burst));
      _output(buffer);
      sprintf(buffer,"EpspSize: %f",(xxm->epsp));
      _output(buffer);
      sprintf(buffer,"IpspSize: %f",(xxm->ipsp));
      _output(buffer);
      sprintf(buffer,"PostSpikePotential: %f",(xxm->pot_post_spike));
      _output(buffer);
      sprintf(buffer,"TimeCsteMbPot: %f",(xxm->tau_mb_pot));
      _output(buffer);
      sprintf(buffer,"Threshold: %f",(xxm->seuil));
      _output(buffer);
      sprintf(buffer,"Adaptation: %f",(xxm->seuil_post_spike));
      _output(buffer);
      sprintf(buffer,"E_K: %f",(xxm->E_K));
      _output(buffer);
      sprintf(buffer,"E_Na: %f",(xxm->E_Na));
      _output(buffer);
      sprintf(buffer,"PosReversalPot: %f",(xxm->rev_pot_pos));
      _output(buffer);
      sprintf(buffer,"NegReversalPot: %f",(xxm->rev_pot_neg));
      _output(buffer);
      sprintf(buffer,"TimeCsteThreshold: %f",(xxm->tau_seuil));
      _output(buffer);
      sprintf(buffer,"EpspSize: %f",(xxm->epsp));
      _output(buffer);
      sprintf(buffer,"EpspAttack: %f",(xxm->tau_attack_epsp));
      _output(buffer);
      sprintf(buffer,"EpspDecay: %f",(xxm->tau_decay_epsp));
      _output(buffer);
      sprintf(buffer,"IpspSize: %f",(xxm->ipsp));
      _output(buffer);
      sprintf(buffer,"IpspAttack: %f",(xxm->tau_attack_ipsp));
      _output(buffer);
      sprintf(buffer,"IpspDecay: %f",(xxm->tau_decay_ipsp));
      _output(buffer);
      sprintf(buffer,"MembraneShunt: %f",(xxm->shunt_tau));
      _output(buffer);
      sprintf(buffer,"NoiseMean: %f",(xxm->backgrd_noise_m));
      _output(buffer);
      sprintf(buffer,"NoiseSd: %f",(xxm->backgrd_noise_sd));
      _output(buffer);
      sprintf(buffer,"FilterResistance: %f",(xxm->resistance));
      _output(buffer);
      sprintf(buffer,"Fatigue: %f",(xxm->fatigue));
      _output(buffer);
      sprintf(buffer,"LessFatigue: %d",(xxm->less_fatigue));
      _output(buffer);

	}

/************************ STOP **********************************/
#endif
	if (current_cluster->model == 'L')
	{

      lim = (LIM *)current_cluster->clu_data;

      sprintf(buffer,"RestPotential: %f",(lim->rest_pot));
      _output(buffer);
      sprintf(buffer,"Threshold: %f",(lim->seuil));
      _output(buffer);
      sprintf(buffer,"EpspSize: %f",(lim->epsp));
      _output(buffer);
      sprintf(buffer,"IpspSize: %f",(lim->ipsp));
      _output(buffer);
      sprintf(buffer,"PostSpikePotential: %f",(lim->pot_post_spike));
      _output(buffer);
      sprintf(buffer,"TimeCsteMbPot: %f",(lim->tau_mb_pot));
      _output(buffer);
      sprintf(buffer,"Threshold: %f",(lim->seuil));
      _output(buffer);
      sprintf(buffer,"Adaptation: %f",(lim->seuil_post_spike));
      _output(buffer);
      sprintf(buffer,"TimeCsteThreshold: %f",(lim->tau_seuil));
      _output(buffer);
      sprintf(buffer,"NoiseMean: %f",(lim->backgrd_noise_m));
      _output(buffer);
      sprintf(buffer,"NoiseSd: %f",(lim->backgrd_noise_sd));
      _output(buffer);
      sprintf(buffer,"FilterResistance: %f",(lim->resistance));
      _output(buffer);
      sprintf(buffer,"Fatigue: %f",(lim->fatigue));
      _output(buffer);
      sprintf(buffer,"LessFatigue: %d",(lim->less_fatigue));
      _output(buffer);
	}

	if (current_cluster->model == 'B')
	{
      bum = (BUM *)current_cluster->clu_data;

      sprintf(buffer,"RestPotential: %f",(bum->rest_pot));
      _output(buffer);
      sprintf(buffer,"SpikeFrequency: %f",(bum->freq_spike));
      _output(buffer);
      sprintf(buffer,"MaxSpikeFrequency: %f",(bum->freq_max));
      _output(buffer);
      sprintf(buffer,"ComposeFact: %f",(bum->compose_fact));
      _output(buffer);
      sprintf(buffer,"MinBurstDuration: %f",(bum->duree_burst_min));
      _output(buffer);
      sprintf(buffer,"MaxBurstDuration: %f",(bum->duree_burst_max));
      _output(buffer);
      sprintf(buffer,"Threshold: %f",(bum->seuil));
      _output(buffer);
      sprintf(buffer,"ThresholdBurst: %f",(bum->seuil_burst));
      _output(buffer);
      sprintf(buffer,"PostSpikePotential: %f",(bum->pot_post_spike));
      _output(buffer);
      sprintf(buffer,"TimeCsteMbPot: %f",(bum->tau_mb_pot));
      _output(buffer);
      sprintf(buffer,"Threshold: %f",(bum->seuil));
      _output(buffer);
      sprintf(buffer,"Adaptation: %f",(bum->seuil_post_spike));
      _output(buffer);
      sprintf(buffer,"E_K: %f",(bum->E_K));
      _output(buffer);
      sprintf(buffer,"E_Na: %f",(bum->E_Na));
      _output(buffer);
      sprintf(buffer,"PosReversalPot: %f",(bum->rev_pot_pos));
      _output(buffer);
      sprintf(buffer,"NegReversalPot: %f",(bum->rev_pot_neg));
      _output(buffer);
      sprintf(buffer,"TimeCsteThreshold: %f",(bum->tau_seuil));
      _output(buffer);
      sprintf(buffer,"EpspSize: %f",(bum->epsp));
      _output(buffer);
      sprintf(buffer,"EpspAttack: %f",(bum->tau_attack_epsp));
      _output(buffer);
      sprintf(buffer,"EpspDecay: %f",(bum->tau_decay_epsp));
      _output(buffer);
      sprintf(buffer,"IpspSize: %f",(bum->ipsp));
      _output(buffer);
      sprintf(buffer,"IpspAttack: %f",(bum->tau_attack_ipsp));
      _output(buffer);
      sprintf(buffer,"IpspDecay: %f",(bum->tau_decay_ipsp));
      _output(buffer);
      sprintf(buffer,"MembraneShunt: %f",(bum->shunt_tau));
      _output(buffer);
      sprintf(buffer,"NoiseMean: %f",(bum->backgrd_noise_m));
      _output(buffer);
      sprintf(buffer,"NoiseSd: %f",(bum->backgrd_noise_sd));
      _output(buffer);
      sprintf(buffer,"FilterResistance: %f",(bum->resistance));
      _output(buffer);
      sprintf(buffer,"Fatigue: %f",(bum->fatigue));
      _output(buffer);
      sprintf(buffer,"LessFatigue: %d",(bum->less_fatigue));
      _output(buffer);

	}
	if (current_cluster->model == 'P')
	{
      pum = (PUM *)current_cluster->clu_data;
			
      sprintf(buffer,"RestPotential: %f",pum->rest_pot);
      _output(buffer);
      sprintf(buffer,"PostSpikePotential: %f",(pum->pot_post_spike));
      _output(buffer);
      sprintf(buffer,"TimeCsteMbPot: %f",(pum->tau_mb_pot));
      _output(buffer);
      sprintf(buffer,"Threshold: %f",(pum->seuil));
      _output(buffer);
      sprintf(buffer,"Adaptation: %f",(pum->seuil_post_spike));
      _output(buffer);
      sprintf(buffer,"E_K: %f",(pum->E_K));
      _output(buffer);
      sprintf(buffer,"E_Na: %f",(pum->E_Na));
      _output(buffer);
      sprintf(buffer,"E_Cl: %f",(pum->E_Cl));
      _output(buffer);
      sprintf(buffer,"E_Ca: %f",(pum->E_Ca));
      _output(buffer);
      sprintf(buffer,"PosReversalPot: %f",(pum->rev_pot_pos));
      _output(buffer);
      sprintf(buffer,"NegReversalPot: %f",(pum->rev_pot_neg));
      _output(buffer);
      sprintf(buffer,"TimeCsteThreshold: %f",(pum->tau_seuil));
      _output(buffer);
      sprintf(buffer,"EpspSize: %f",(pum->epsp));
      _output(buffer);
      sprintf(buffer,"EpspAttack: %f",(pum->tau_attack_epsp));
      _output(buffer);
      sprintf(buffer,"EpspDecay: %f",(pum->tau_decay_epsp));
      _output(buffer);
      sprintf(buffer,"IpspSize: %f",(pum->ipsp));
      _output(buffer);
      sprintf(buffer,"IpspAttack: %f",(pum->tau_attack_ipsp));
      _output(buffer);
      sprintf(buffer,"IpspDecay: %f",(pum->tau_decay_ipsp));
      _output(buffer);
      sprintf(buffer,"MembraneShunt: %f",(pum->shunt_tau));
      _output(buffer);
      sprintf(buffer,"NoiseMean: %f",(pum->backgrd_noise_m));
      _output(buffer);
      sprintf(buffer,"NoiseSd: %f",(pum->backgrd_noise_sd));
      _output(buffer);
      sprintf(buffer,"FilterResistance: %f",(pum->resistance));
      _output(buffer);
      sprintf(buffer,"Fatigue: %f",(pum->fatigue));
      _output(buffer);
      sprintf(buffer,"LessFatigue: %d",(pum->less_fatigue));
      _output(buffer);
	}
	if (current_cluster->model == 'G')
	{
      /* G_ neuron model */

      cbm = (CBM *)current_cluster->clu_data;

      sprintf(buffer,"diametre: %f", cbm->soma_diam_m );
      _output(buffer);
      sprintf(buffer,"Temp: %f", simu->Temp );
      _output(buffer);
      sprintf(buffer,"K_ext: %f", cbm->K_ext );
      _output(buffer);
      sprintf(buffer,"K_int: %f", cbm->K_int );
      _output(buffer);
      sprintf(buffer,"Na_ext: %f", cbm->Na_ext );
      _output(buffer);
      sprintf(buffer,"Na_int: %f", cbm->Na_int );
      _output(buffer);
      sprintf(buffer,"E_K: %f", cbm->E_K );
      _output(buffer);
      sprintf(buffer,"E_Na: %f", cbm->E_Na );
      _output(buffer);
      sprintf(buffer,"E_fuite: %f", cbm->E_fuite );
      _output(buffer);
      sprintf(buffer,"E_Ca: %f", cbm->E_Ca );
      _output(buffer);
      sprintf(buffer,"E_H: %f", cbm->E_H );
      _output(buffer);
      sprintf(buffer,"E_Cl: %f", cbm->E_Cl );
      _output(buffer);
      sprintf(buffer,"PosReversalPot: %f", cbm->rev_pot_pos );
      _output(buffer);
      sprintf(buffer,"NegReversalPot: %f", cbm->rev_pot_neg );
      _output(buffer);
      sprintf(buffer,"spike_slope: %f", cbm->spike_slope );
      _output(buffer);
      sprintf(buffer,"g_K: %f", cbm->g_K );
      _output(buffer);
      sprintf(buffer,"g_Na: %f", cbm->g_Na );
      _output(buffer);
      sprintf(buffer,"g_Nap: %f", cbm->g_Nap );
      _output(buffer);
      sprintf(buffer,"g_Ca: %f", cbm->g_Ca );
      _output(buffer);
      sprintf(buffer,"g_Cab: %f", cbm->g_Cab );
      _output(buffer);
      sprintf(buffer,"g_Cl: %f", cbm->g_Cl );
      _output(buffer);
      sprintf(buffer,"g_A: %f", cbm->g_A );
      _output(buffer);
      sprintf(buffer,"g_M: %f", cbm->g_M );
      _output(buffer);
      sprintf(buffer,"g_C: %f", cbm->g_C );
      _output(buffer);
      sprintf(buffer,"g_ahp: %f", cbm->g_ahp );
      _output(buffer);
      sprintf(buffer,"g_H: %f", cbm->g_H );
      _output(buffer);
      sprintf(buffer,"g_fuite: %f", cbm->g_fuite );
      _output(buffer);
      sprintf(buffer,"g_fuite: %f", cbm->g_fuite_Na );
      _output(buffer);
      sprintf(buffer,"g_fuite: %f", cbm->g_fuite_K );
      _output(buffer);
      sprintf(buffer,"g_Syn_pos: %f", cbm->g_Syn_pos );
      _output(buffer);
      sprintf(buffer,"g_Syn_neg: %f", cbm->g_Syn_neg );
      _output(buffer);
      sprintf(buffer,"capacite: %f", cbm->capacite );
      _output(buffer);
      sprintf(buffer,"tau_attack_epsp: %f", cbm->tau_attack_epsp );
      _output(buffer);
      sprintf(buffer,"tau_decay_epsp: %f", cbm->tau_decay_epsp );
      _output(buffer);
      sprintf(buffer,"tau_attack_ipsp: %f", cbm->tau_attack_ipsp );
      _output(buffer);
      sprintf(buffer,"tau_decay_ipsp: %f", cbm->tau_decay_ipsp );
      _output(buffer);
      sprintf(buffer,"NoiseMean: %f", cbm->backgrd_noise_m );
      _output(buffer);
      sprintf(buffer,"NoiseSd: %f", cbm->backgrd_noise_sd );
      _output(buffer);
      sprintf(buffer,"Ca_i: %f", cbm->Ca_i_init );
      _output(buffer);
      sprintf(buffer,"K_ext_init: %f", cbm->K_ext_init );
      _output(buffer);
      sprintf(buffer,"magnesium: %f", cbm->magnesium );
      _output(buffer);
      sprintf(buffer,"g_NMDA: %f", cbm->g_NMDA );
      _output(buffer);
      sprintf(buffer,"rev_pot_NMDA: %f", cbm->rev_pot_NMDA );
      _output(buffer);
      sprintf(buffer,"eta_NMDA: %f", cbm->eta_NMDA );
      _output(buffer);
      sprintf(buffer,"gamma_NMDA: %f", cbm->gamma_NMDA );
      _output(buffer);
      sprintf(buffer,"tau_attack_NMDA: %f", cbm->tau_attack_NMDA );
      _output(buffer);
      sprintf(buffer,"tau_decay_NMDA: %f", cbm->tau_decay_NMDA );
      _output(buffer);
      sprintf(buffer,"Ca_Influx: %f", cbm->Ca_Influx);
      _output(buffer);
      sprintf(buffer,"Ca_Removal: %f",(cbm->Ca_Removal));
      _output(buffer);
      sprintf(buffer,"Ca_Kd: %f",(cbm->Ca_Kd));
      _output(buffer);
      sprintf(buffer,"K_Ca_Kd: %f",(cbm->K_Ca_Kd));
      _output(buffer);
      sprintf(buffer,"lambda_Ik: %f",(cbm->lambda_Ik));
      _output(buffer);
      sprintf(buffer,"lambda_Ic: %f",(cbm->lambda_Ic));
      _output(buffer);
      sprintf(buffer,"lambda_Im: %f",(cbm->lambda_Im));
      _output(buffer);
      sprintf(buffer,"V_Na: %f",(cbm->V_Na));
      _output(buffer);
      sprintf(buffer,"A_Na: %f",(cbm->A_Na));
      _output(buffer);
      sprintf(buffer,"Pow_Na: %f",(cbm->Pow_Na));
      _output(buffer);
      sprintf(buffer,"V_K: %f",(cbm->V_K));
      _output(buffer);
      sprintf(buffer,"A_K: %f",(cbm->A_K));
      _output(buffer);
      sprintf(buffer,"Pow_K: %f",(cbm->Pow_K));
      _output(buffer);
      sprintf(buffer,"V_Ca: %f",(cbm->V_Ca));
      _output(buffer);
      sprintf(buffer,"A_Ca: %f",(cbm->A_Ca));
      _output(buffer);
      sprintf(buffer,"Pow_Ca: %f",(cbm->Pow_Ca));
      _output(buffer);
      sprintf(buffer,"Tau_Ca: %f",(cbm->Tau_Ca));
      _output(buffer);
      sprintf(buffer,"V_Ia_A: %f",(cbm->V_Ia_A));
      _output(buffer);
      sprintf(buffer,"A_Ia_A: %f",(cbm->A_Ia_A));
      _output(buffer);
      sprintf(buffer,"Pow_Ia_A: %f",(cbm->Pow_Ia_A));
      _output(buffer);
      sprintf(buffer,"V_Ia_B: %f",(cbm->V_Ia_B));
      _output(buffer);
      sprintf(buffer,"A_Ia_B: %f",(cbm->A_Ia_B));
      _output(buffer);
      sprintf(buffer,"Pow_Ia_B: %f",(cbm->Pow_Ia_B));
      _output(buffer);
      sprintf(buffer,"Tau_Ia_B: %f",(cbm->Tau_Ia_B));
      _output(buffer);
      sprintf(buffer,"V_Ic: %f",(cbm->V_Ic));
      _output(buffer);
      sprintf(buffer,"A_Ic: %f",(cbm->A_Ic));
      _output(buffer);
      sprintf(buffer,"V_Im: %f",(cbm->V_Im));
      _output(buffer);
      sprintf(buffer,"A_Im: %f",(cbm->A_Im));
      _output(buffer);
      sprintf(buffer,"V_Inap: %f",(cbm->V_Inap));
      _output(buffer);
      sprintf(buffer,"A_Inap: %f",(cbm->A_Inap));
      _output(buffer);
      sprintf(buffer,"Vm_Icab: %f",(cbm->Vm_Icab));
      _output(buffer);
      sprintf(buffer,"Am_Icab: %f",(cbm->Am_Icab));
      _output(buffer);
      sprintf(buffer,"Vh_Icab: %f",(cbm->Vh_Icab));
      _output(buffer);
      sprintf(buffer,"Ah_Icab: %f",(cbm->Ah_Icab));
      _output(buffer);
      sprintf(buffer,"lambda_Inap: %f",(cbm->lambda_Inap));
      _output(buffer);
      sprintf(buffer,"lambda_Icab: %f",(cbm->lambda_Icab));
      _output(buffer);
      sprintf(buffer,"Tau_m_Cab: %f",(cbm->tau_m_cab));
      _output(buffer);
      sprintf(buffer,"K_rest: %f",(cbm->K_rest));
      _output(buffer);
      sprintf(buffer,"V_Ih: %f",(cbm->V_Ih));
      _output(buffer);
      sprintf(buffer,"A_Ih: %f",(cbm->A_Ih));
      _output(buffer);
      sprintf(buffer,"lambda_Ih: %f",(cbm->lambda_Ih));
      _output(buffer);
      sprintf(buffer,"A_INa_A: %f",(cbm->A_INa_A));
      _output(buffer);
      sprintf(buffer,"A_INa_B: %f",(cbm->A_INa_B));
      _output(buffer);
      sprintf(buffer,"Tau_INa_A: %f",(cbm->Tau_INa_A));
      _output(buffer);
      sprintf(buffer,"Tau_INa_B: %f",(cbm->Tau_INa_B));
      _output(buffer);
      sprintf(buffer,"Pow_INa_A: %f",(cbm->Pow_INa_A));
      _output(buffer);
      sprintf(buffer,"Pow_INa_B: %f",(cbm->Pow_INa_B));
      _output(buffer);
      sprintf(buffer,"V_INa_A: %f",(cbm->V_INa_A));
      _output(buffer);
      sprintf(buffer,"V_INa_B: %f",(cbm->V_INa_B));
      _output(buffer);

			/*  Initialisations */

      sprintf(buffer,"m_ahp_init: %f",(cbm->m_ahp_init));
      _output(buffer);
      sprintf(buffer,"m_K_init: %f",(cbm->m_K_init));
      _output(buffer);
      sprintf(buffer,"m_ahp_init: %f",(cbm->m_ahp_init));
      _output(buffer);
      sprintf(buffer,"le_potentiel_init: %f",(cbm->le_potentiel_init));			
      _output(buffer);
      sprintf(buffer,"le_potentiel_E_Na_init: %f",(cbm->le_potentiel_E_Na_init));
      _output(buffer);
      sprintf(buffer,"le_potentiel_E_K_init: %f",(cbm->le_potentiel_E_K_init));
      _output(buffer);
      sprintf(buffer,"m_Ca_init: %f",(cbm->m_Ca_init));
      _output(buffer);
      sprintf(buffer,"Ca_i_init: %f",(cbm->Ca_i_init));
      _output(buffer);
      sprintf(buffer,"h_A_init: %f",(cbm->h_A_init));
      _output(buffer);
      sprintf(buffer,"h_Na_init: %f",(cbm->h_Na_init));
      _output(buffer);
      sprintf(buffer,"m_Nap_init: %f",(cbm->m_Nap_init));
      _output(buffer);
      sprintf(buffer,"m_Cab_init: %f",(cbm->m_Cab_init));
      _output(buffer);
      sprintf(buffer,"m_Ih_init: %f",(cbm->m_Ih_init));
      _output(buffer);
      sprintf(buffer,"h_Cab_init: %f",(cbm->h_Cab_init));
      _output(buffer);
/*
Axone_transmittor: 2
Nb_receptors: 2
#Receptor 0
Receptor_tau_attack:    2.5000000000
Receptor_tau_decay:   10.0000000000
Receptor_tau_a_psp:   25.0000000000
Receptor_tau_d_ps:  100.0000000000
Receptor_g_Syn:    0.0500000007
Receptor_rev_pot:  -10.0000000000
Receptor_transmittor: 2
Receptor_num_transm: 2
Receptor_nom: Acetylcholine
#Receptor 1
Receptor_tau_attack:    2.5000000000
Receptor_tau_decay:   10.0000000000
Receptor_tau_a_psp:   25.0000000000
Receptor_tau_d_ps:  100.0000000000
Receptor_g_Syn:    0.0500000007
Receptor_rev_pot:  -90.0000000000
Receptor_transmittor: 32
Receptor_num_transm: 6
Receptor_nom: GABA A
*/
		sprintf(buffer,"Axone_transmittor: %d",(cbm->neurotransmitor));
	      _output(buffer);
		sprintf(buffer,"Nb_receptors: %d",(cbm->nb_receptors));
	      _output(buffer);
		for (i= 0; i < cbm->nb_receptors; i++)
		{
			sprintf(buffer, "#Receptor %d", i);
			sprintf(buffer,"Receptor_tau_attack: %f",(cbm->Receptors[i].tau_attack));
		      _output(buffer);
			sprintf(buffer,"Receptor_tau_decay: %f",(cbm->Receptors[i].tau_decay));
		      _output(buffer);
			sprintf(buffer,"Receptor_tau_a_psp: %f",(cbm->Receptors[i].tau_a_psp));
		      _output(buffer);
			sprintf(buffer,"Receptor_tau_d_psp: %f",(cbm->Receptors[i].tau_d_psp));
		      _output(buffer);
			sprintf(buffer,"Receptor_g_Syn: %f",(cbm->Receptors[i].g_Syn));
		      _output(buffer);
			sprintf(buffer,"Receptor_rev_pot: %f",(cbm->Receptors[i].rev_pot));
		      _output(buffer);
			sprintf(buffer,"Receptor_transmittor: %d",(cbm->Receptors[i].transmetteur));
		      _output(buffer);
			sprintf(buffer,"Receptor_num_transm: %d",(cbm->Receptors[i].num_transm));
		      _output(buffer);
			sprintf(buffer,"Receptor_nom: %s",(cbm->Receptors[i].nom));
		      _output(buffer);
		}
	}

	sprintf(buffer,"\n");
	_output(buffer);
}

/*******************************************************************/
/* 
	Cette fonction a pour but de ranger les numeros de la liste
	apres la suppression de l`element passe en parametre.
*/

void SUP_DE_LA_TABLE(int element)
{
  int i,j,trouve=0;


  if(!table_of_number_selection) 
	return; /* la table n`existe pas */

  /* recherche de l`element */
	for( i=0 ; i<nbr_drug ; i++)
	{
		if(element==table_of_number_selection[i])
		{
#if DRUG_DEBUG
			printf("on en a trouvee un: %d=tablr[%d]:%d\n",element,i,table_of_number_selection[i]);trouve=1;
#endif
			for (j=i+1 ; j<nbr_drug ; j++)
			{
				table_of_number_selection[j-1] = table_of_number_selection[j];
#if DRUG_DEBUG
				printf("copie[%d]:%d\n", j-1, table_of_number_selection[j] );
#endif
			}
			break;
		}
	}

	if	(trouve == 0)
		return; /* on ne l`a pas trouve */

	number_of_selection--;
}


/* 
   Ce programme permet de fabriquer un masque pour chaque drogue.
   Une fois les drogues selectionnees, il suffira de lire les masques
   des drogues pour positionner les flagues des courants devant etre
   selectionnes.
*/


void MAKE_MASK_TABLE(int i, char valeur[100] )
{
#if DRUG_DEBUG
  printf("valeur=%s\n", valeur);
#endif
  if (!strcmp(valeur,"I_Na")) 
    table_of_drug_mask[i][drug_Na]=1;	
  
  if (!strcmp(valeur,"I_K")) 
    table_of_drug_mask[i][drug_K]=1;	
  
  if (!strcmp(valeur,"I_Ca")) 
    table_of_drug_mask[i][drug_Ca]=1;	
  
  if (!strcmp(valeur,"I_Cl")) 
    table_of_drug_mask[i][drug_Cl]=1;	
  
  if (!strcmp(valeur,"I_A")) 
    table_of_drug_mask[i][drug_A]=1;	
  
  if (!strcmp(valeur,"I_m")) 
    table_of_drug_mask[i][drug_M]=1;	
  
  if (!strcmp(valeur,"I_C")) 
    table_of_drug_mask[i][drug_C]=1;	
  
  if (!strcmp(valeur,"I_h")) 
    table_of_drug_mask[i][drug_H]=1;	
  
  if (!strcmp(valeur,"I_ahp")) 
    table_of_drug_mask[i][drug_ahp]=1;	
  
  if (!strcmp(valeur,"I_Nap")) 
    table_of_drug_mask[i][drug_Nap]=1;	
  
  if (!strcmp(valeur,"I_Cal")) 
    table_of_drug_mask[i][drug_Cab]=1;	
  
  if (!strcmp(valeur,"I_fuite")) 
    table_of_drug_mask[i][drug_fuite]=1;	
  
  if (!strcmp(valeur,"I_P")) 
    table_of_drug_mask[i][drug_P]=1;

  if (!strcmp(valeur,"I_fuite_Na")) 
    table_of_drug_mask[i][drug_fuite_Na]=1;	
  
  if (!strcmp(valeur,"I_fuite_K")) 
    table_of_drug_mask[i][drug_fuite_K]=1;	
  
	
  
  
  
  /* visu de la table */
#if DRUG_DEBUG

  printf ("          Na K  Ca Cl A  M  C  H  ahp Nap Cab P  fuite\n");
  printf ("Case %d    %d  %d  %d  %d  %d  %d  %d  %d  %d   %d   %d   %d   %d   %d   %d\n",
	  i,
	  table_of_drug_mask[i][drug_Na],
	  table_of_drug_mask[i][drug_K],
	  table_of_drug_mask[i][drug_Ca],
	  table_of_drug_mask[i][drug_Cl],
	  table_of_drug_mask[i][drug_A],
	  table_of_drug_mask[i][drug_M],
	  table_of_drug_mask[i][drug_C],
	  table_of_drug_mask[i][drug_H],
	  table_of_drug_mask[i][drug_ahp],
	  table_of_drug_mask[i][drug_Nap],
	  table_of_drug_mask[i][drug_Cab],
	  table_of_drug_mask[i][drug_P],
	  table_of_drug_mask[i][drug_fuite],
	  table_of_drug_mask[i][drug_fuite_Na],
	  table_of_drug_mask[i][drug_fuite_K]
	  );
#endif  
 
 
}





/* Ce programme permet de lire un fichier de drogue. on lit le fichier de la facon suivante:
   
   ex  TTX: I_Na
       TEA: I_K 
       autre: I_C, I_Nap
       ....

       On recherche une trame de ce type "%s ". On analyse le dernier caractere de la chaine "s".
       Si c`est ':' alors on a un nom de drogue.
       Si c`est ',  alors on a un nom de courant modifie par la drogue trouvee juste avant.

  Ce programme alloue n*2 espece memoire pour les ScrollingList de n Drogues et cree un masque 
  pour modifier les courant en consequence.

  ex:  
         I_Na | I_K | I_Ca | I_A | I_M | I_C | I_Nap | I_Cab .... 
  TTX       1 |   0 |    0 |   0 |   0 |   0 | .....
  TEA       0 |   1 |    0 |   0 |   0 |   1 | .....  

  */


int READ_DRUG_FILE( char file_name[256] )
{
  FILE      *fp;
  char      buffer[256],tampon[30];
  char      message[256];
  int       numero, nbr_courant, i, j, k, ac;
  XmString  xmstring;
  Arg       args[20];

  nbr_drug=0;


#if DRUG_DEBUG
  printf("file_name:%s\n",file_name);
#endif

  if (!(fp = fopen (file_name,"r")))
    {
      sprintf(message,"\007Can't open %s...",file_name);
      display_error(widget_array[ID_sim_mainW],message,"Access Error");
      return 0;
    }

  /* type of file */
#if DRUG_DEBUG
  printf("lecture du nbre de drogues dans le fichier\n");
  /* il y a autant de ligne que de drogues */
#endif
  while(fgets(buffer,80,fp))
  {
      nbr_drug++;
  }
#if DRUG_DEBUG
  printf("Nbr Drogue:%d\n",nbr_drug);
#endif
  if (!nbr_drug) 
  {
      if(radioBoxDrug) XtSetSensitive(radioBoxDrug, False);
      sprintf(message,"No drugs in %s...\n", file_name);
      display_error(widget_array[ID_sim_mainW],message,"Access Error");

      return 0;
  }

  if(radioBoxDrug) XtSetSensitive(radioBoxDrug, True);

  if ((table_of_number_selection = ( int *)calloc(nbr_drug, sizeof(int ) ))==NULL)
  {
      sprintf(message,"Impossible Allocation table_of_number_selection\n");
      display_error(widget_array[ID_sim_mainW],message,"Allocation Error");
      return 0;
  }


  if ((str_list_drug = ( XmStringTable )XtMalloc(sizeof(XmString) *( nbr_drug ) ))==NULL)
  {
      sprintf(message,"str_list_drug Impossible Allocation\n");
      display_error(widget_array[ID_sim_mainW],message,"Allocation Error");
      return 0;
  }


  if ((table_of_drug_mask = ( int **)calloc(nbr_drug, sizeof(int * ) ))==NULL)
  {
      sprintf(message,"table_of_drug_mask Impossible Allocation\n");
      display_error(widget_array[ID_sim_mainW],message,"Allocation Error");
      return 0;
  }

  for( i = 0 ; i < nbr_drug ; i++)
  {
      if((table_of_drug_mask[i] = (int *)calloc(NBR_CRT, sizeof(int ) ))==NULL)
      {
	  if (i>0)
	  {
	      for (j=0 ; j<i ; j++)
		free(table_of_drug_mask[j]);
	      free(table_of_drug_mask);
	  }
	  sprintf(message,"Impossible Allocation... drug_mask[%d]\n",i);
	  display_error(widget_array[ID_sim_mainW],message,"Allocation Error");
	  return 0;
      }
  }

  
  fclose(fp);

  /* relire le fichier pour en tirer les infos */
  /* il y a autant d`espaces que de courant */

#if DRUG_DEBUG
  printf("lecture des drogues dans le fichier\n");
#endif
  if (!(fp = fopen (file_name,"r")))
  {
      sprintf(message,"\007Can't open %s...",file_name);
      display_error(widget_array[ID_sim_mainW],message,"Access Error");
      return 0;
  }

  numero = -1;

  while(fgets(buffer,80,fp))
  {
      i =0;
      while(buffer[i]!=':') /* lire le nom de la drogue */
      {
	  tampon[i] = buffer[i];
	  i++;
      }
      tampon[i] = '\0';

      /*c`est un nom de Drogue, il faut la lettre dans la liste */
      numero++;
#if DRUG_DEBUG
      printf("une autre drogue %d: %s\n", numero, tampon );
#endif
      str_list_drug[numero] = XmStringCreateSimple(tampon);


      /* lire le nombre de courant ( on compte le nombre d`espaces ) */
      nbr_courant = 0;
      for (i=0 ; i<strlen(buffer)-1 ; i++ )
      {
	  if (buffer[i]==' ' && buffer[i+1]!='\n') nbr_courant++;
      }
#if DRUG_DEBUG
      printf("\tnbr_courant:%d\n",nbr_courant);
#endif
      j = 0;
      for (i=0; i<nbr_courant ; i++)
      {
	  while( buffer[j]!=' ') /* on recherche un espace */
	  {
	      j++;
	  }
#if DRUG_DEBUG
	  printf("il y a un espace en %d\n",j);
#endif
	  j++;
	  k = 0;
	  while(buffer[j]!='\n' && buffer[j]!=' ')
	  {
	      tampon[k++] = buffer[j++];
	  }
	  tampon[k] = '\0';
	  /* le nom du courant est trouve */
	  MAKE_MASK_TABLE( numero, tampon );
      }

  }

  fclose(fp);

  
  number_of_selection = 0; /* on replace le nombre de selection des drogues a zero */
#if 0
  XtVaSetValues(List_drug,
		XmNitems, str_list_drug,
		XmNitemCount, nbr_drug,
		XmNvisibleItemCount, 6,
		NULL);
#endif
#if DRUG_DEBUG
  printf("apres je retourne 1\n");
#endif

 return 1;
  
}

/*******************************************************************************
	Function for reading the neuron unit file 
*******************************************************************************/

void read_File()
{
  FILE *pt_file; 
  char parametre[50],
  value[30],
  buffer[80],
  message[256],
  file_name[256];
  
  
  strcpy(file_name,current_cluster->file_name);
  
  if (verification(file_name)==-1)
    {
      sprintf(message,"\007Invalid selection!...");
      display_error(widget_array[ID_sim_mainW],message,"Access Error");
      return ;
    }
  
  if (!(pt_file = fopen (file_name,"r")))
    {
      sprintf(message,"\007Can't open %s...",file_name);
      display_error(widget_array[ID_sim_mainW],message,"Access Error");
      return ;
    }
  
  /* type of file */
  
  
  while(fgets(buffer,80,pt_file))
    {
      sscanf(buffer,"%s %s",parametre,value);

      if (!strcmp(parametre,"Model_Type:"))		
	{
	  sprintf(buffer,"Model_Type:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"RestPotential:"))	/* resting  potential	*/
	{
	  sprintf(buffer,"RestPotential:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"SpikeFrequency:"))	/* Pot mb post spike */
	{
	  sprintf(buffer,"SpikeFrequency:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"MaxSpikeFrequency:"))	/* cste de temps de la mb */
	{
	  sprintf(buffer,"MaxSpikeFrequency:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"ComposeFact:"))		/* firing threshold par cluster */
	{
	  sprintf(buffer,"ComposeFact:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"MinBurstDuration:"))		/* seuil apres un spike */
	{
	  sprintf(buffer,"MinBurstDuration:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"MaxBurstDuration:"))      	/* Potentiel d'equilibre du potassium */
	{
	  sprintf(buffer,"MaxBurstDuration:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"Threshold:"))		/* seuil normal  */
	{
	  sprintf(buffer,"Threshold:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"ThresholdBurst:"))      	/* seuil burst  */
	{
	  sprintf(buffer,"ThresholdBurst:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"EpspSize:"))		/* taille d'un epsp  */
	{
	  sprintf(buffer,"EpspSize:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"IpspSize:"))		/* variabilite d'un epsp  */
	{
	  sprintf(buffer,"IpspSize:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"NoiseMean:"))	/* Bruit de fond (moyenne) */
	{
	  sprintf(buffer,"NoiseMean:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"NoiseSd:"))	/* Bruit de fond (sd) */
	{
	  sprintf(buffer,"NoiseSd:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"NoiseFilter:"))	/* Filtrage du bruit */
	{
	  sprintf(buffer,"NoiseFilter:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"Capacity:"))	/* Capacite */
	{
	  sprintf(buffer,"Capacity:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"Temp:"))	/* Temperature */
	{
	  sprintf(buffer,"Temp:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"TimeStep:"))	/* TimeStep */
	{
	  sprintf(buffer,"TimeStep:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"PostSpikePotential:"))	/* Pot mb post spike */
	{
	  sprintf(buffer,"PostSpikePotential:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"Adaptation:"))		/* seuil apres un spike */
	{
	  sprintf(buffer,"Adaptation:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"Na_ext:"))		/* Sodium extra cell*/
	{
	  sprintf(buffer,"Na_ext:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"K_int:"))		/* Potassium intra cell */
	{
	  sprintf(buffer,"K_int:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"Na_int:"))		/* Sodium intra cell*/
	{
	  sprintf(buffer,"Na_int:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"PosReversalPot:"))	/* Reversal Potential positif (pour epsp) */
	{
	  sprintf(buffer,"PosReversalPot:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"NegReversalPot:"))	/* Resersal Potential negatif (pour ipsp) */
	{
	  sprintf(buffer,"NegReversalPot:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"TimeCsteThreshold:"))   /* cste de temps du seuil apres un spike */
	{
	  sprintf(buffer,"TimeCsteThreshold:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"TimeCsteMbPot:"))	/* cste de temps de la mb */
	{
	  sprintf(buffer,"TimeCsteMbPot:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"EpspSd:"))		/* variabilite d'un epsp  */
	{
	  sprintf(buffer,"EpspSd:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"EpspAttack:"))	/* conste de temps de montee */
	{
	  sprintf(buffer,"EpspAttack:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"EpspDecay:"))	/* conste de temps de descente */
	{
	  sprintf(buffer,"EpspDecay:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"IpspSd:"))		/* variabilite d'un ipsp  */
	{
	  sprintf(buffer,"IpspSd:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"IpspAttack:"))	/* conste de temps de montee */
	{
	  sprintf(buffer,"IpspAttack:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"IpspDecay:"))	/* conste de temps de descente */
	{
	  sprintf(buffer,"IpspDecay:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"BurstPostSpike:"))	/* conste de temps de descente */
	{
	  sprintf(buffer,"BurstPostSpike:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"MembraneShunt:"))/* constante de temps du shunt de la mb */
	{
	  sprintf(buffer,"MembraneShunt:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"FilterResistance:"))	/* time cste of the filter */
	{
	  sprintf(buffer,"FilterResistance:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"Fatigue:"))	/* fatigue du seuil */
	{
	  sprintf(buffer,"Fatigue:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre,"LessFatigue:"))	/* fatigue du seuil */
	{
	  sprintf(buffer,"LessFatigue:  %s",value);
	  _output(buffer);
	}

      /* G_ neuron model */

      if (!strcmp (parametre, "diametre:"))	/* rem: le diametre doit etre lu en premier */
	{
	  sprintf(buffer,"diametre:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "Integration:"))
	{
	  sprintf(buffer,"Integration:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "TauDecayCa:"))
	{
	  sprintf(buffer,"TauDecayCa:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "E_fuite:"))
	{
	  sprintf(buffer,"E_fuite:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "E_Ca:"))
	{
	  sprintf(buffer,"E_Ca:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "E_H:"))
	{
	  sprintf(buffer,"E_H:  %s",value);
	  _output(buffer);
	}
       if (!strcmp (parametre, "E_K:"))
	{
	  sprintf(buffer,"E_K:  %s",value);
	  _output(buffer);
	}
       if (!strcmp (parametre, "E_Na:"))
	{
	  sprintf(buffer,"E_Na:  %s",value);
	  _output(buffer);
	}
     if (!strcmp (parametre, "spike_slope:"))
	{
	  sprintf(buffer,"spike_slope:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "E_Cl:"))
	{
	  sprintf(buffer,"E_Cl:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_K:"))
	{
	  sprintf(buffer,"g_K:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_Na:"))
	{
	  sprintf(buffer,"g_Na:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_Ca:"))
	{
	  sprintf(buffer,"g_Ca:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_Nap:"))
	{
	  sprintf(buffer,"g_Nap:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_Cab:"))
	{
	  sprintf(buffer,"g_Cab:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_Cl:"))
	{
	  sprintf(buffer,"g_Cl:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_A:"))
	{
	  sprintf(buffer,"g_A:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_M:"))
	{
	  sprintf(buffer,"g_M:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_C:"))
	{
	  sprintf(buffer,"g_C:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_ahp:"))
	{
	  sprintf(buffer,"g_ahp:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_H:"))
	{
	  sprintf(buffer,"g_H:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_fuite:"))
	{
	  sprintf(buffer,"g_fuite:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_fuite_Na:"))
	{
	  sprintf(buffer,"g_fuite_Na:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_fuite_K:"))
	{
	  sprintf(buffer,"g_fuite_K:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_Syn_pos:"))
	{
	  sprintf(buffer,"g_Syn_pos:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_Syn_neg:"))
	{
	  sprintf(buffer,"g_Syn_neg:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "capacite:"))
	{
	  sprintf(buffer,"capacite:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "input_fact:"))
	{
	  sprintf(buffer,"input_fact:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "tau_attack_epsp:"))
	{
	  sprintf(buffer,"tau_attack_epsp:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "tau_decay_epsp:"))
	{
	  sprintf(buffer,"tau_decay_epsp:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "tau_attack_ipsp:"))
	{
	  sprintf(buffer,"tau_attack_ipsp:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "tau_decay_ipsp:"))
	{
	  sprintf(buffer,"tau_decay_ipsp:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "Ca_i:"))
	{
	  sprintf(buffer,"Ca_i:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "K_ext:"))
	{
	  sprintf(buffer,"K_ext:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "magnesium:"))
	{
	  sprintf(buffer,"magnesium:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "g_NMDA:"))
	{
	  sprintf(buffer,"g_NMDA:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "rev_pot_NMDA:"))
	{
	  sprintf(buffer,"rev_pot_NMDA:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "eta_NMDA:"))
	{
	  sprintf(buffer,"eta_NMDA:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "gamma_NMDA:"))
	{
	  sprintf(buffer,"gamma_NMDA:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "tau_attack_NMDA:"))
	{
	  sprintf(buffer,"tau_attack_NMDA:  %s",value);
	  _output(buffer);
	}
      if (!strcmp (parametre, "tau_decay_NMDA:"))
	{
	  sprintf(buffer,"tau_decay_NMDA:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Ca_Influx:"))	
	{
	  sprintf(buffer,"Ca_Influx:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Ca_Removal:"))  
	{
	  sprintf(buffer,"Ca_Removal:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Ca_Kd:"))  
	{
	  sprintf(buffer,"Ca_Kd:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "K_Ca_Kd:"))  
	{
	  sprintf(buffer,"K_Ca_Kd:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "lambda_Ik:"))  /* Constante dependant de la temperature */
	{
	  sprintf(buffer,"lambda_Ik:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "lambda_Ic:"))  /* Constante dependant de la temperature */
	{
	  sprintf(buffer,"lambda_Ic:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "lambda_Im:"))  /* Constante dependant de la temperature */
	{
	  sprintf(buffer,"lambda_Im:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "V_Na:")) /* V 1/2 pour le Na */
	{
	  sprintf(buffer,"V_Na:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "A_Na:")) /* coeff a pour le Na */
	{
	  sprintf(buffer,"A_Na:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Pow_Na:")) /* Exposant pour le Na */
	{
	  sprintf(buffer,"Pow_Na:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "V_K:")) /* V 1/2 pour la K */
	{
	  sprintf(buffer,"V_K:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "A_K:")) /* coeff a pour le K */
	{
	  sprintf(buffer,"A_K:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Pow_K:")) /* Exposant pour le K */
	{
	  sprintf(buffer,"Pow_K:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "V_Ca:")) /* V 1/2 pour la Ca */
	{
	  sprintf(buffer,"V_Ca:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "A_Ca:")) /* coeff a pour le Ca */
	{
	  sprintf(buffer,"A_Ca:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Pow_Ca:")) /* Exposant pour le Ca */
	{
	  sprintf(buffer,"Pow_Ca:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Tau_Ca:")) /* Cste de temps pour le Ca */
	{
	  sprintf(buffer,"Tau_Ca:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "V_Ia_A:")) /* V 1/2 pour Ia activation */
	{
	  sprintf(buffer,"V_Ia_A:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "A_Ia_A:")) /* coeff a pour Ia activation */
	{
	  sprintf(buffer,"A_Ia_A:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Pow_Ia_A:")) /* Exposant pour Ia activation */
	{
	  sprintf(buffer,"Pow_Ia_A:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "V_Ia_B:")) /* V 1/2 pour Ia inactivation */
	{
	  sprintf(buffer,"V_Ia_B:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "A_Ia_B:")) /* coeff a pour Ia inactivation */
	{
	  sprintf(buffer,"A_Ia_B:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Pow_Ia_B:")) /* Exposant pour Ia inactivation */
	{
	  sprintf(buffer,"Pow_Ia_B:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Tau_Ia_B:")) /* Cste de temps pour Ia inactivation */
	{
	  sprintf(buffer,"Tau_Ia_B:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "V_Ic:")) /* V 1/2 pour Ia inactivation */
	{
	  sprintf(buffer,"V_Ic:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "A_Ic:")) /* coeff a pour Ia inactivation */
	{
	  sprintf(buffer,"A_Ic:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "V_Im:")) /* V 1/2 pour Ia inactivation */
	{
	  sprintf(buffer,"V_Im:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "A_Im:")) /* coeff a pour Ia inactivation */
	{
	  sprintf(buffer,"A_Im:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "V_Inap:")) /* V 1/2 pour Inap inactivation */
	{
	  sprintf(buffer,"V_Inap:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "A_Inap:")) /* coeff a pour Inap inactivation */
	{
	  sprintf(buffer,"A_Inap:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Vm_Icab:")) /* V 1/2 pour Icab activation */
	{
	  sprintf(buffer,"Vm_Icab:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Am_Icab:")) /* coeff a pour Icab activation */
	{
	  sprintf(buffer,"Am_Icab:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Pow_m_cab:")) /* exposant pour Icab activation */
	{
	  sprintf(buffer,"Pow_m_cab:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Vh_Icab:")) /* V 1/2 pour Icab inactivation */
	{
	  sprintf(buffer,"Vh_Icab:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Ah_Icab:")) /* coeff a pour Icab inactivation */
	{
	  sprintf(buffer,"Ah_Icab:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "lambda_Inap:"))  /* Constante dependant de la temperature */
	{
	  sprintf(buffer,"lambda_Inap:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "lambda_Icab:"))  /* Constante dependant de la temperature */
	{
	  sprintf(buffer,"lambda_Icab:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Tau_m_Cab:")) /* Cste de temps pour Ia inactivation */
	{
	  sprintf(buffer,"Tau_m_Cab:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "K_rest:")) /* * Potatium au repos */
	{
	  sprintf(buffer,"K_rest:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "V_Ih:")) /* V 1/2 pour Ih inactivation */
	{
	  sprintf(buffer,"V_Ih:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "A_Ih:")) /* coeff a pour Ih inactivation */
	{
	  sprintf(buffer,"A_Ih:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "lambda_Ih:"))  /* Constante dependant de la temperature */
	{
	  sprintf(buffer,"lambda_Ih:  %s",value);
	  _output(buffer);
	}
      /*  Initialisations */
      
      if (!strcmp(parametre, "m_ahp_init:"))
	{
	  sprintf(buffer,"m_ahp_init:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "m_K_init:"))
	{
	  sprintf(buffer,"m_K_init:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "m_ahp_init:"))
	{
	  sprintf(buffer,"m_ahp_init:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "le_potentiel_init:"))
	{
	  sprintf(buffer,"le_potentiel_init:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "m_Ca_init:"))
	{
	  sprintf(buffer,"m_Ca_init:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "Ca_i_init:"))
	{
	  sprintf(buffer,"Ca_i_init:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "h_A_init:"))
	{
	  sprintf(buffer,"h_A_init:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "h_Na_init:"))
	{
	  sprintf(buffer,"h_Na_init:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "m_Nap_init:"))
	{
	  sprintf(buffer,"m_Nap_init:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "m_Cab_init:"))
	{
	  sprintf(buffer,"m_Cab_init:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "m_Ih_init:"))
	{
	  sprintf(buffer,"m_Ih_init:  %s",value);
	  _output(buffer);
	}
      if (!strcmp(parametre, "h_Cab_init:"))
	{
	  sprintf(buffer,"h_Cab_init:  %s",value);
	  _output(buffer);
	}
      
      
    } /* fin du while */
  sprintf(buffer,"\n");
  _output(buffer);
  
  fclose(pt_file);
  
}


/*******************************************************************************
	Function for reading lnk file 
*******************************************************************************/
int read_lnk_file(char *lnk_name)
{
	FILE *fp_lnk;
	FILE *fp_wgt;
	FILE *fp_clu;
	FILE *fp_nucl;
	FILE *fp_len;
	FILE *fp_anat;
	char *pt;
	char without_ext_name[256];
	char dir[256];
	char *out_buf;
	int i,j,k,m,p;
	char buffer[256];
	char unit_name[256];
	short short_value;
	int	num;
	float float_value;
	char field[256];
	char value[256];
	int new_nucleus;
	char mask[10];
	int counter;
	CLUSTER *cluster_tmp;
	NUCLEUS *nucleus_tmp;
	NEURON *neuron_tmp;
	
	out_buf = NULL;
	
	/* first verify if all lnk clu len anat wgt exist or not */ 


	strcpy(buffer,lnk_name);

	if(pt = strrchr(buffer,'.'))
	{
		*pt='\0';
	}
	if(pt = strrchr(buffer,'/'))
	{
		*pt = '\0';
		pt++;
		strcpy(without_ext_name,pt);
		strcpy(dir,buffer);
	}
	else
	{
		strcpy(without_ext_name,buffer);
		strcpy(dir,project_directory);
	}
	
	sprintf(buffer,"%s.ntw",without_ext_name);
	
	if(!file_exists(buffer,dir))
	{
		if(!batch)
		{
			sprintf(buffer,"File %s/%s.ntw doesn't exist...network unreadable.",dir,without_ext_name);
			display_error(widget_array[ID_sim_mainW],buffer,"Invalid File Name !");
		}
		clear_network();
		return -1;
	}
	sprintf(simu->lnk_name,"%s/%s.ntw",dir,without_ext_name);	
	
	sprintf(buffer,"%s.clu",without_ext_name);
	
	if(!file_exists(buffer,dir))
	{	
		if(!batch)
		{
			sprintf(buffer,"File %s/%s.clu doesn't exist...network unreadable.",dir,without_ext_name);
			display_error(widget_array[ID_sim_mainW],buffer,"Invalid File Name !");
		}
		clear_network();
		return -1;
	}
	sprintf(simu->clu_name,"%s/%s.clu",dir,without_ext_name);
	
	sprintf(buffer,"%s.anat",without_ext_name);
	
	if(!file_exists(buffer,dir))
	{	
		if(!batch)
		{
			sprintf(buffer,"File %s/%s.anat doesn't exist...network unreadable.",dir,without_ext_name);
			display_error(widget_array[ID_sim_mainW],buffer,"Invalid File Name !");
		}
		clear_network();
		return -1;
	}	
	sprintf(simu->anat_name,"%s/%s.anat",dir,without_ext_name);
		
	sprintf(buffer,"%s.wgt",without_ext_name);
	
	if(!file_exists(buffer,dir))
	{	
		if(!batch)
		{
			sprintf(buffer,"File %s/%s.wgt doesn't exist...network unreadable.",dir,without_ext_name);
			display_error(widget_array[ID_sim_mainW],buffer,"Invalid File Name !");
		}
		clear_network();
		return -1;
	}
	sprintf(simu->wgt_name,"%s/%s.wgt",dir,without_ext_name);	
	
	sprintf(buffer,"%s.len",without_ext_name);
	
	if(!file_exists(buffer,dir))
	{	
		if(!batch)
		{
			sprintf(buffer,"File %s/%s.len doesn't exist...network unreadable.",dir,without_ext_name);
			display_error(widget_array[ID_sim_mainW],buffer,"Invalid File Name !");
		}
		clear_network();
		return -1;
	}
	sprintf(simu->len_name,"%s/%s.len",dir,without_ext_name);		
		
	/* okay files exist */
	
	/* reading lnk */
	
	sprintf(buffer,"%s/%s.ntw",dir,without_ext_name);

	fp_lnk = fopen (buffer, "r");
	
	/* testing file pointer , in case of failure -> return -1*/
	
	if(!fp_lnk)
	{
	
		sprintf(buffer,"Can't open %s/%s.ntw...network unreadable.",dir,without_ext_name);
		display_error(widget_array[ID_sim_mainW],buffer,"Access Error");
		return -1;
	}

	
	/* type of file */
	fgets(buffer,255,fp_lnk);
	sscanf(buffer,"%s %s",field,value);
	if(strcmp("TypeOfFile:",field))
	{
		sprintf(buffer,"File %s/%s.ntw is not a\nlink configuration file...network unreadable",
			dir,without_ext_name);
		display_error(widget_array[ID_sim_mainW],buffer,"File Type Mismatch");
		return -1;
	}
	if(strcmp("LinkConfigurationFileVer2",value))
	{
		sprintf(buffer,"File %s/%s.ntw was made\nunder bad version...network unreadable",
			dir,without_ext_name);
		display_error(widget_array[ID_sim_mainW],buffer,"File Type Mismatch");
		return -1;	
	}

	/* now let's read the lnk file */
	
	while(fgets(buffer,255,fp_lnk))
	{
		sscanf(buffer,"%s %s",field,value);
		
/*************** first testing network specs ***************************/

		if(!strcmp("NumberOfNucleus:",field))
		{
			sscanf(value,"%d",&num);
			simu->nb_nucleus = (short)num;
			sim_nucleus = (NUCLEUS **)
				calloc(1,simu->nb_nucleus*sizeof(NUCLEUS *));
				
			if(nucl_w)
			{
				for(i=0 ; i<simu->nb_nucleus ; i++)
				{
					if(nucl_w[i])
					{
						XtDestroyWidget(nucl_w[i]);
						nucl_w[i] = (Widget)NULL;
					}
					
				}
				XtFree((XtPointer)nucl_w);
				nucl_w = (Widget *)NULL;
				
			}
			nucl_w = (Widget *)XtCalloc(1,simu->nb_nucleus*sizeof(Widget));
			
			new_nucleus = 0;
			if(!batch)
			{
				sprintf(buffer,"\tFound %d nucleus in network...", simu->nb_nucleus);
				_output(buffer);
			}
			else 
			{
				sprintf(buffer,"Found %d nucleus in network...\n", simu->nb_nucleus);
				fprintf(stderr,buffer);
			}
		}
		else if(!strcmp("NumberOfInterNucleusLink:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */ 
		}
		else if(!strcmp("TotalNeuronsInNetwork:",field))
		{
			sscanf(value,"%d",&num);
			simu->nb_neurons = num;
			sim_neurons = (NEURON **)
				calloc(1,simu->nb_neurons*sizeof(NEURON *));
			for(i=0 ; i<simu->nb_neurons ; i++)
			{
				sim_neurons[i] = (NEURON *)calloc(1,sizeof(NEURON));
			}	
			if(!batch)
			{
				sprintf(buffer,"\tFound %d neurons in network...", simu->nb_neurons);
				_output(buffer);
			}
			else 
			{
				sprintf(buffer,"Found %d neurons in network...\n", simu->nb_neurons);
				fprintf(stderr,buffer);
			}
		}
		

/******************* nucleus specs *************************/

		else if(!strcmp("BeginNucleus:",field))
		{
			sim_nucleus[new_nucleus] = (NUCLEUS *)
				calloc(1,sizeof(NUCLEUS));
			sim_nucleus[new_nucleus]->number = new_nucleus+1;
				 
		}
		else if(!strcmp("NucleusName:",field))
		{
			strcpy(sim_nucleus[new_nucleus]->name,value);
		}
		else if(!strcmp("NucleusId:",field))
		{
			sscanf(value,"%d",&num);
			sim_nucleus[new_nucleus]->id = num;
		}
		else if(!strcmp("NumberOfClusters:",field))
		{
			/* unused */
			
		}
		else if(!strcmp("NumberOfInterClusterLink:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */ 
		}
		else if(!strcmp("TotalNeuronsInNucleus:",field))
		{
			sscanf(value,"%d",&num);
			sim_nucleus[new_nucleus]->nucleus_size = num;
			sim_nucleus[new_nucleus]->neuron_array = (NEURON **)
				calloc(1,num*sizeof(NEURON *));
			if(!batch)
			{
				sprintf(buffer,"\t%d nucleus: name %s , id %d , size %d...",
					 sim_nucleus[new_nucleus]->number,
					 sim_nucleus[new_nucleus]->name,
					 sim_nucleus[new_nucleus]->id,
					 sim_nucleus[new_nucleus]->nucleus_size);
				_output(buffer);
			}
			else
			{
				sprintf(buffer,"%d nucleus: name %s , id %d , size %d...\n",
					 sim_nucleus[new_nucleus]->number,
					 sim_nucleus[new_nucleus]->name,
					 sim_nucleus[new_nucleus]->id,
					 sim_nucleus[new_nucleus]->nucleus_size);
				fprintf(stderr,buffer);
			}
		}
		else if(!strcmp("NucleusPositionH:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */ 
		}
		else if(!strcmp("NucleusDeltaH:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */ 
		}
		else if(!strcmp("NucleusPositionL:",field))
		{
		   	/* field used by network editor, might be used later for
				global activity visualisation */ 
		}
		else if(!strcmp("NucleusDeltaL:",field))
		{
		  	/* field used by network editor, might be used later for
				global activity visualisation */ 
		}
		else if(!strcmp("NucleusPositionAP:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */ 
		}
		else if(!strcmp("NucleusDeltaAP:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */ 
		}
 
/**************** cluster specs ***********************************/

		else if(!strcmp("BeginCluster:",field))
		{
	
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("ClusterName:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("ClusterId:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("PositionH:",field))
		{
		 	/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("DeltaH:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("PositionL:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("DeltaL:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("PositionAP:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("DeltaAP:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("NbNeurons:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("NeuronFile:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("EndCluster:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}

/****************************** ICluster link specs *************************/

		else if(!strcmp("BeginLink:",field))
		{
			 /* field used by network editor, might be used later for
				global activity visualisation */    
		}
		else if(!strcmp("Cluster1:",field))
		{
		 	/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("Cluster2:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("AxoneMean:",field))
		{
		     /* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("AxoneSd:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("BornMin:",field))
		{
			/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("BornMax:",field))
		{
		    /* field used by network editor, might be used later for
				global activity visualisation */ 
		}
		else if(!strcmp("Type:",field))
		{
		   	/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("Nmda:",field))
		{
		    /* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("EndLink:",field))
		{
		 	/* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("EndNucleus:",field))
		{
		        new_nucleus++;
		}

/*******************INucleus link specs **********************************/

		else if(!strcmp("BeginLinkInterNucleus:",field))
		{
		         
			/* field used by network editor, might be used later for
				global activity visualisation */      
		}
		else if(!strcmp("Nucleus1:",field))
		{
		    /* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("Nucleus2:",field))
		{
		   /* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("INAxoneMean:",field))
		{
		   /* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("INAxoneSd:",field))
		{
		   /* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("INBornMin:",field))
		{
		    /* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("INBornMax:",field))
		{
		     /* field used by network editor, might be used later for
				global activity visualisation */
		}
		else if(!strcmp("INType:",field))
		{
		     /* field used by network editor, might be used later for
				global activity visualisation */ 
		}
		else if(!strcmp("INNmda:",field))
		{
		     /* field used by network editor, might be used later for
				global activity visualisation */ 
		}
		else if(!strcmp("EndLinkInterNucleus:",field))
		{
		    /* field used by network editor, might be used later for
				global activity visualisation */
		}
		
	}	/* end while , end reading lnk */
	
	fclose(fp_lnk);

	sprintf(buffer,"%s/%s.ntw",dir,without_ext_name);
#if 0
	fprintf(stderr,"%s file successfuly read\n",buffer);
#endif
	put_network_name(get_dir_name(),buffer);

	/* ------------ reading clu file---------- */
	
	sprintf(buffer,"%s/%s.clu",dir,without_ext_name);
	fp_clu = fopen (buffer, "r");
	
	/* testing file pointer , in case of failure -> return -1*/
	
	if(!fp_clu)
	{
	
		sprintf(buffer,"Can't open %s/%s.clu...network unreadable.",dir,without_ext_name);
		display_error(widget_array[ID_sim_mainW],buffer,"Access Error");
		return -1;
	}
	
	simu->nb_clusters = 0;
	while(fgets (buffer, 255, fp_clu))
	{
		
		simu->nb_clusters++;
		pt = buffer;
		i = 0;
		while(!isspace(*pt) && (i<255))
		{
			unit_name[i] = *pt;
			i++;
			pt++;
		}
		unit_name[i] = '\0';
		if(!unit_name[0])
			continue;
		if(simu->nb_clusters == 1)
		{
			clu_index = (CLU *)calloc(1,sizeof(CLU));
			clu_index->file = (char *)calloc(1,(strlen(unit_name)+1)*sizeof(char));
			strcpy(clu_index->file,unit_name);
			clu_index->nb_refs = 0;
		}	
		else
		{
			clu_index = (CLU *)realloc(clu_index,simu->nb_clusters*sizeof(CLU));
			clu_index[simu->nb_clusters-1].file = (char *)calloc(1,
				(strlen(unit_name)+1)*sizeof(char));
			strcpy(clu_index[simu->nb_clusters-1].file,unit_name);
			clu_index[simu->nb_clusters-1].nb_refs = 0;
		}
		while(*pt != ':')
			pt++;
		while(*pt != '\n')
		{
			if(isdigit(*pt))
			{
				i = 0;
				while(isdigit(*pt))
				{
					value[i] = *pt;
					pt++;
					i++;
				}
				value[i] = '\0';
				clu_index[simu->nb_clusters-1].nb_refs++;
				if(clu_index[simu->nb_clusters-1].nb_refs == 1)
				{
					clu_index[simu->nb_clusters-1].refs = (short *)calloc(1,sizeof(short));
					sscanf(value,"%d",&num);
					
					clu_index[simu->nb_clusters-1].refs[clu_index[simu->nb_clusters-1].nb_refs-1]
						= num;
				}
				else
				{
					clu_index[simu->nb_clusters-1].refs = (short *)realloc(
						clu_index[simu->nb_clusters-1].refs,clu_index[simu->nb_clusters-1].nb_refs
							*sizeof(short));
					sscanf(value,"%d",&num);
					
					clu_index[simu->nb_clusters-1].refs[clu_index[simu->nb_clusters-1].nb_refs-1] 
						= num;
				}
			}
			else
				pt++;
		}
		
	}
	
	fclose(fp_clu);

	if ((sim_clusters = (CLUSTER **)calloc(simu->nb_clusters,sizeof(CLUSTER *))) == NULL)
	{
		sprintf (buffer,"Impossible to allocate memory for clusters, try later...");
		if(!batch)
		{
			_output(buffer);
			display_error(widget_array[ID_sim_mainW],buffer,"Insufficient Memory !");
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
		}
		exit_simulator(True); /* forced exit */
		
	} /* fin du if */

	if(clu_w)
	{
		for(i=0 ; i<simu->nb_clusters ; i++)
		{
			if(clu_w[i])
			{
				XtDestroyWidget(clu_w[i]);
				clu_w[i] = (Widget)NULL;
			}

		}
		XtFree((XtPointer)clu_w);
		clu_w = (Widget *)NULL;

	}
	clu_w = (Widget *)XtCalloc(1,simu->nb_clusters*sizeof(Widget));


	for (i = 0; i < simu->nb_clusters; i++)
	{
		sprintf (buffer,"\tAllocating memory for cluster %d",i+1);
		if(!batch)
		{
			_output(buffer);
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
		}
		if ((sim_clusters[i] = (CLUSTER *)calloc(1,sizeof(CLUSTER))) == NULL)
		{
			sprintf (buffer,"Impossible to allocate memory for cluster %d",i+1);
			if(!batch)
			{
				_output(buffer);
				display_error(widget_array[ID_sim_mainW],buffer,"Insufficient Memory !");
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
			}
			exit_simulator(True); /* forced exit */
		} /* fin du if */
		
		
		sim_clusters[i]->cluster_size = 0;
		sim_clusters[i]->number = i+1;
		
		
	} /* fin du for */


	for (i = 0; i < simu->nb_clusters; i++)
	{
#if DEBUG_FILES
	        fprintf(stderr,"\t%s associated with file %s\n\tto be read...\n",
					sim_clusters[i]->name, sim_clusters[i]->file_name);
#endif
#if ADD_NEW_MODEL
/*************** TO ADD A MODEL COPY THIS AND ADAPT *************/
		if(strstr(clu_index[i].file,".X_unit"))
		{
			sim_clusters[i]->model = 'X';
			strcpy(sim_clusters[i]->file_name,clu_index[i].file);
			strcpy(mask,"*.X_unit");
			
		} else

/************************ STOP **********************************/
#endif
		if(strstr(clu_index[i].file,".L_unit"))
		{
			sim_clusters[i]->model = 'L';
			strcpy(sim_clusters[i]->file_name,clu_index[i].file);
			strcpy(mask,"*.L_unit");
			
		} else if(strstr(clu_index[i].file,".B_unit"))
		{
			sim_clusters[i]->model = 'B';
			strcpy(sim_clusters[i]->file_name,clu_index[i].file);
			strcpy(mask,"*.B_unit");
		}			
		else if(strstr(clu_index[i].file,".P_unit"))
		{
			sim_clusters[i]->model = 'P';
			strcpy(sim_clusters[i]->file_name,clu_index[i].file);
			strcpy(mask,"*.P_unit");
		}
		else if(strstr(clu_index[i].file,".G_unit"))
		{
			sim_clusters[i]->model = 'G';
			strcpy(sim_clusters[i]->file_name,clu_index[i].file);
			strcpy(mask,"*.G_unit");
		}
		else if(strstr(clu_index[i].file,".tms"))
		{
			sim_clusters[i]->model = 'V';
			strcpy(sim_clusters[i]->file_name,clu_index[i].file);
			strcpy(mask,"*.tms");
		}
		else
		{
			/* today unknown type */
			
			sim_clusters[i]->model = '?';
			strcpy(sim_clusters[i]->file_name,clu_index[i].file);
			strcpy(mask,"*.*");
		}
		sprintf(sim_clusters[i]->name,"Cluster_%d",sim_clusters[i]->number);
		
		while(read_clu_unit(sim_clusters[i]->file_name,i))
		{
			if(batch)
			{
				fprintf(stderr,"Neuron file %s doesn't exist.",sim_clusters[i]->file_name);
				exit_simulator(True);
			}
			sprintf(buffer,"Neuron file %s doesn't exist. \nDo you want to specify an other existing file ?",
				 sim_clusters[i]->file_name);
			if(display_question(widget_array[ID_sim_mainW],buffer,
				"Neuron File Recovery") == YES_ANSWER)
			{
				
				pt = NULL;
				while(!pt)
				{
					sprintf(buffer,"Choose an existing neuron file:");
					pt = display_fileselect(widget_array[ID_sim_mainW],0,mask,buffer,
						get_dir_name());
					if(!pt)
					{
						sprintf(buffer,"Network unreadable without existing neuron file.\nPlease create corresponding neuron files before to simulate.");
						if(!batch)
						{
							display_message(widget_array[ID_sim_mainW],buffer,"Information");
							clear_network();
							status("No Loaded Network (*.ntw)");
							return -1;
						}
						else
						{
							strcat(buffer,"\n");
							fprintf(stderr,buffer);
							exit_simulator(True);
						}
					}
					for(j=0 ; j<simu->nb_clusters ; j++)
					{
						if((j!=i) && !strcmp(sim_clusters[j]->file_name,pt))
						{
							if(!batch)
							{
								sprintf(buffer,"File %s alrealdy used by cluster %d...",
									pt,sim_clusters[j]->number);
								display_error(widget_array[ID_sim_mainW],buffer,"Invalid File Name !");
								
							}
							pt = NULL;
							break;
						}
					}
				}
				strcpy(sim_clusters[i]->file_name,pt);
				
				
			}
			else
			{
				sprintf(buffer,"Network unreadable without existing neuron file.\nPlease create corresponding neuron files before to simulate.");
				if(!batch)
				{
					display_message(widget_array[ID_sim_mainW],buffer,"Information");
					clear_network();
					status("No Loaded Network (*.ntw)");
					return -1;
				}
				else
				{
					strcat(buffer,"\n");
					fprintf(stderr,buffer);
					exit_simulator(True);
				}
			}
			
		}
		sprintf(buffer,"\t%s associated with file %s\n\twhich was successfully loaded.\n",
					sim_clusters[i]->name, sim_clusters[i]->file_name);
#if DEBUG_FILES
		fprintf(stderr,"\t%s associated with file %s\n\twhich was successfully loaded.\n",
					sim_clusters[i]->name, sim_clusters[i]->file_name);
#endif


		if(!batch)
			_output(buffer);
		
	} /* fin du for */

	/*------------- reading anat --------------*/
	
	sprintf(buffer,"%s/%s.anat",dir,without_ext_name);
	fp_anat = fopen (buffer, "r");
	
	/* testing file pointer , in case of failure -> return -1*/
	
	if(!fp_anat)
	{
	
		sprintf(buffer,"Can't open %s/%s.anat...network unreadable.",dir,without_ext_name);
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],buffer,"Access Error");
			clear_network();
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
	}
	
	fread(&short_value,1,sizeof(short),fp_anat);
	if(short_value != simu->nb_nucleus)
	{
		sprintf(buffer,"Wrong number of nucleus specified in %s/%s.anat",dir,without_ext_name);
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
			clear_network();
			status("No Loaded Network (*.ntw)");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
	}
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		fread(&short_value,1,sizeof(short),fp_anat);
		if(short_value != (short)sim_nucleus[i]->nucleus_size)
		{
			sprintf(buffer,"Wrong number of neurons for nucleus %d specified in %s/%s.anat",
				i+1,dir,without_ext_name);
			if(!batch)
			{
				display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
				clear_network();
				status("No Loaded Network (*.ntw)");
				return -1;
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
				exit_simulator(True);
			}
		}
	}
	
	k = 0; 
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		for(j=0 ; j<sim_nucleus[i]->nucleus_size ; j++)
		{
			sim_nucleus[i]->neuron_array[j] = sim_neurons[k];
			sim_neurons[k]->its_nucleus = sim_nucleus[i];
			
			fread(&short_value,1,sizeof(short),fp_anat);
			sim_neurons[k]->id = short_value;
			
			fread(&short_value,1,sizeof(short),fp_anat);
			if(!sim_neurons[k]->its_cluster)
				sim_neurons[k]->its_cluster = (CLUSTER *)identify_cluster((int)short_value);
			
			fread(&float_value,1,sizeof(float),fp_anat);
			sim_neurons[k]->HC_vert = float_value;
			fread(&float_value,1,sizeof(float),fp_anat);
			sim_neurons[k]->HC_lat = float_value;
			fread(&float_value,1,sizeof(float),fp_anat);
			sim_neurons[k]->HC_ap = float_value;
			k++;
			
		}
	}
	fclose(fp_anat);
#if DEBUG_FILES
	sprintf(buffer,"%s/%s.anat",dir,without_ext_name);
	fprintf(stderr,"%s file successfuly read\n",buffer);
#endif

	create_3d_anat_file();
	if(k != simu->nb_neurons)
	{	
		sprintf(buffer,"Wrong number of neurons %s/%s.anat",dir,without_ext_name);
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
			clear_network();
			status("No Loaded Network (*.ntw)");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
	}
	
	/* clusters size */
	for(i=0 ; i<simu->nb_clusters ; i++)
	{
		sim_clusters[i]->neuron_array = (NEURON **)calloc(1,
			sim_clusters[i]->cluster_size*sizeof(NEURON *));
		k = 0;
		for(j=0 ; j<simu->nb_neurons ; j++)
		{
			if(sim_neurons[j]->its_cluster == sim_clusters[i])
			{
				sim_clusters[i]->neuron_array[k] = sim_neurons[j];
				k++;
			}
		}
	}
	/* nb nucleus per cluster */
	for(i=0 ; i<simu->nb_clusters ; i++)
	{
		sim_clusters[i]->nb_nucleus = 0;
		
		for(j=0 ; j<simu->nb_nucleus ; j++)
		{
			for(k=0 ; k<sim_nucleus[j]->nucleus_size ; k++)
			{
				if(sim_nucleus[j]->neuron_array[k]->its_cluster == sim_clusters[i])
				{
					sim_clusters[i]->nb_nucleus++;
					break;
				}
			}
			
		}
	}
	/* which nucleus */
	for(i=0 ; i<simu->nb_clusters ; i++)
	{
		sim_clusters[i]->nucleus_array = (NUCLEUS **)calloc(1,
			sim_clusters[i]->nb_nucleus*sizeof(NUCLEUS *));
		m = 0;
		
		for(j=0 ; j<simu->nb_nucleus ; j++)
		{
			for(k=0 ; k<sim_nucleus[j]->nucleus_size ; k++)
			{
				if(sim_nucleus[j]->neuron_array[k]->its_cluster == sim_clusters[i])
				{
					sim_clusters[i]->nucleus_array[m] = sim_nucleus[j];
					m++;
					break;
				}
			}
			
		}
	}
	
	
	
	/*--------------------reading wgt-------------------*/
	
	sprintf(buffer,"%s/%s.wgt",dir,without_ext_name);
	fp_wgt = fopen (buffer, "r");
	
	/* testing file pointer , in case of failure -> return -1*/
	
	if(!fp_wgt)
	{
	
		sprintf(buffer,"Can't open %s/%s.wgt...network unreadable.",dir,without_ext_name);
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],buffer,"Access Error");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
	}
	
	fread(&short_value,1,sizeof(short),fp_wgt);
	if(short_value != simu->nb_nucleus)
	{
		sprintf(buffer,"Wrong number of nucleus specified in %s/%s.wgt",dir,without_ext_name);
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
			clear_network();
			status("No Loaded Network (*.ntw)");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
	}
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		fread(&short_value,1,sizeof(short),fp_wgt);
		if(short_value != (short)sim_nucleus[i]->nucleus_size)
		{
			sprintf(buffer,"Wrong number of neurons for nucleus %d specified in %s/%s.wgt",
				i+1,dir,without_ext_name);
			if(!batch)
			{
				display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
				clear_network();
				status("No Loaded Network (*.ntw)");
				return -1;
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
				exit_simulator(True);
			}
		}
	}

	
	/* NOW CONNECTIONS AND NMDA */
	
	/* for each neuron, neuron's id,its cluster's id (network editor's id here unused)
		, number of connected neurons */
	/* then for each connection: target neuron's id, nmda flag, synaptic weight */ 


	for(i=0 ; i<simu->nb_neurons ; i++)
	{
		fread(&short_value,1,sizeof(short),fp_wgt);
		sim_neurons[i]->id = short_value;
		fread(&short_value,1,sizeof(short),fp_wgt);
		/* unused */
		fread(&short_value,1,sizeof(short),fp_wgt);
		sim_neurons[i]->connected_neurons = short_value;
		if(!short_value)
			continue;
		sim_neurons[i]->targets = (short *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(short));
		sim_neurons[i]->connections = (short *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(short));
		sim_neurons[i]->nmda = (short *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(short));
		sim_neurons[i]->next_spike = (short *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(short));
		sim_neurons[i]->axone_length = (float *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(float));
		sim_neurons[i]->axone_step = (unsigned long *)calloc(1,sim_neurons[i]->connected_neurons
			*sizeof(unsigned long));
#if DEBUG_FILES
		printf("\a Files_fonctions : CONNECTION from neuron %lu (j = %d) \n",
				sim_neurons[i]->id, i);
#endif			
		for(j=0 ; j<sim_neurons[i]->connected_neurons ; j++)
		{
			fread(&short_value,1,sizeof(short),fp_wgt);
			sim_neurons[i]->targets[j] = short_value;
			fread(&short_value,1,sizeof(short),fp_wgt);
			sim_neurons[i]->nmda[j] = short_value;
			fread(&short_value,1,sizeof(short),fp_wgt);
			if (simu->use_ntr)
				sim_neurons[i]->connections[j] = abs(short_value);
			else
				sim_neurons[i]->connections[j] = short_value;
#if DEBUG_FILES
			printf("\a to neuron %lu (l %d):  %d\n",
				sim_neurons[i]->targets[j], j, sim_neurons[i]->connections[j]);
#endif			
		} 	
				
	}
	fclose(fp_wgt);
	
#if DEBUG_FILES
	sprintf(buffer,"%s/%s.wgt",dir,without_ext_name);
	fprintf(stderr,"%s file successfuly read\n",buffer);
#endif
	
	/*-----------------reading len----------------------*/
	
	sprintf(buffer,"%s/%s.len",dir,without_ext_name);
	fp_len = fopen (buffer, "r");
	
	/* testing file pointer , in case of failure -> return -1*/
	
	if(!fp_len)
	{
	
		sprintf(buffer,"Can't open %s/%s.len...network unreadable.",dir,without_ext_name);
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],buffer,"Access Error");
			clear_network();
			status("No Loaded Network (*.ntw)");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
	}
	
	fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
	fprintf(stderr,"nb nucleus: %d \n",short_value);
#endif
	if(short_value != simu->nb_nucleus)
	{
		sprintf(buffer,"Wrong number of nucleus specified in %s/%s.len",dir,without_ext_name);
		if(!batch)
		{
			display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
			clear_network();
			status("No Loaded Network (*.ntw)");
			return -1;
		}
		else
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
			exit_simulator(True);
		}
	}
#if DEBUG_FILES
	fprintf(stderr,"%s file phase 1 successfuly read\n",buffer);
#endif
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
		fprintf(stderr,"nb neurons nucl %d: %d \n",i+1, short_value);
#endif
		if(short_value != (short)sim_nucleus[i]->nucleus_size)
		{
			sprintf(buffer,"Wrong number of neurons for nucleus %d specified in %s/%s.len",
				i+1,dir,without_ext_name);
			if(!batch)
			{
				display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
				clear_network();
				status("No Loaded Network (*.ntw)");
				return -1;
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
				exit_simulator(True);
			}
		}
		
	}
#if DEBUG_FILES
	fprintf(stderr,"%s file phase 2 successfuly read\n",buffer);
#endif

	
	/* NOW AXONE LENGTHS */
	
	/* for each neuron, neuron's id,its cluster's id (network editor's id here unused)
		, number of connected neurons */
	/* then for each connection: target neuron's id, axone length */ 


	for(i=0 ; i<simu->nb_neurons ; i++)
	{
#if DEBUG_FILES
		fprintf(stderr,"Reading neuron %d\n",i+1);
#endif
		sim_neurons[i]->number = i+1;
		fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
		fprintf(stderr,"neuron  %d: id: %d \n",i+1, short_value);
#endif
		sim_neurons[i]->id = short_value;
		fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
		fprintf(stderr,"neuron  %d: cluster id: %d \n",i+1, short_value);
#endif
		/* unused */
		fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
		fprintf(stderr,"neuron  %d: nb_connected: %d \n",i+1, short_value);
#endif
		if(sim_neurons[i]->connected_neurons != short_value)
		{
#if DEBUG_FILES
			fprintf(stderr,"neuron %d: %d connected neurons\n",i+1,sim_neurons[i]->connected_neurons);
#endif
			sprintf(buffer,"Wrong number of connected neurons for neuron %d specified in %s/%s.len",
				i+1,dir,without_ext_name);
			if(!batch)
			{
				display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
				clear_network();
				status("No Loaded Network (*.ntw)");
				return -1;
			}
			else
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
				exit_simulator(True);
			}
		
		}
		if(!short_value)
		{
			sprintf(buffer,"neuron %ld: id %ld, nucleus %s, cluster %s, %ld connections.\n",
				sim_neurons[i]->number,
				sim_neurons[i]->id,
				sim_neurons[i]->its_nucleus->name,
				sim_neurons[i]->its_cluster->file_name,
				sim_neurons[i]->connected_neurons);
#if DEBUG_FILES
			fprintf(stderr,"%s",buffer);
#endif
			if(!batch && detail)
				out_buf = bufferize(out_buf,buffer);
			else if(detail)
			{
				strcat(buffer,"\n");
				fprintf(stderr,buffer);
			}
		}	
#if DEBUG_FILES
		fprintf(stderr,"%s file phase 3 successfuly read\n",buffer);
#endif
		for(j=0 ; j<sim_neurons[i]->connected_neurons ; j++)
		{
#if DEBUG_FILES
			fprintf(stderr,"Reading connection %d to %d\n",i, j);
#endif

			fread(&short_value,1,sizeof(short),fp_len);
#if DEBUG_FILES
			fprintf(stderr,"neuron  %d to %d: target: %d \n",i+1, j+1, short_value);
#endif
			if(sim_neurons[i]->targets[j] != short_value)
			{
				sprintf(buffer,"Wrong target id for target %d of neuron %d specified in %s/%s.len",
					j+1,i+1,dir,without_ext_name);
#if DEBUG_FILES
				fprintf(stderr,"%s\n",buffer);
				fprintf(stderr,"Target should be %d\n", sim_neurons[i]->targets[j]); 
#endif
				if(!batch)
				{
					display_error(widget_array[ID_sim_mainW],buffer,"Corrupted File !");
					clear_network();
					status("No Loaded Network (*.ntw)");
					return -1;
				}
				else
				{
					strcat(buffer,"\n");
					fprintf(stderr,buffer);
					exit_simulator(True);
				}
					
			}
			fread(&float_value,1,sizeof(float),fp_len);
#if DEBUG_FILES
			fprintf(stderr,"neuron  %d to %d: length: %f \n",i+1, j+1, float_value);
#endif
			sim_neurons[i]->axone_length[j] = float_value;
#if DEBUG_FILES
			fprintf(stderr,"%s file phase 4 OK\n",buffer);
#endif
		
		}
#if DEBUG_FILES
		fprintf(stderr,"%s file phase 4 successfuly read\n",buffer);
#endif
		sprintf(buffer,"neuron %ld: id %ld, nucleus %s, cluster %s, %ld connections.\n",
				sim_neurons[i]->number,
				sim_neurons[i]->id,
				sim_neurons[i]->its_nucleus->name,
				sim_neurons[i]->its_cluster->file_name,
				sim_neurons[i]->connected_neurons);
		if(!batch && detail)
			out_buf = bufferize(out_buf,buffer);
		else if(detail)
		{
			strcat(buffer,"\n");
			fprintf(stderr,buffer);
		}
	}
	if(!batch && detail)
	{
		_output(out_buf);
		free(out_buf);
	}
	fclose(fp_len);

#if DEBUG_FILES
	sprintf(buffer,"%s/%s.len",dir,without_ext_name);
	fprintf(stderr,"%s file successfuly read\n",buffer);
#endif

	/* nb cluster per nucleus */
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		nucleus_tmp = sim_nucleus[i];
		nucleus_tmp->nb_clusters = 0;
		
		for(j=0 ; j<simu->nb_clusters ; j++)
		{
			cluster_tmp = sim_clusters[j];
			
			for(k=0 ; k<cluster_tmp->cluster_size ; k++)
			{
				if(cluster_tmp->neuron_array[k]->its_nucleus == nucleus_tmp)
				{
					nucleus_tmp->nb_clusters++;
					break;	
				}	
			}
			
		}
		
		
	}
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		nucleus_tmp = sim_nucleus[i];
		nucleus_tmp->cluster_array = (CLUSTER **)calloc(1,nucleus_tmp->nb_clusters
			*sizeof(CLUSTER *));
		m = 0;
		for(j=0 ; j<simu->nb_clusters ; j++)
		{
			cluster_tmp = sim_clusters[j];
			
			for(k=0 ; k<cluster_tmp->cluster_size ; k++)
			{
				if(cluster_tmp->neuron_array[k]->its_nucleus == nucleus_tmp)
				{
					nucleus_tmp->cluster_array[m] = sim_clusters[j];
					m++;
					break;	
				}	
			}
			
		}
	}

	
	/* ------------ reading nucleus file for stimulation parameters ---------- */
	
	sprintf(buffer,"%s/%s.nucl",dir,without_ext_name);
	fp_nucl = fopen (buffer, "r");
	
	sprintf(simu->nucl_name,"%s/%s.nucl",dir,without_ext_name);	

	/* testing file pointer , in case of failure -> return -1*/
	
	if(!fp_nucl)
	{
	  if (fp_nucl = fopen (buffer, "w"))
	  {
	    sprintf(buffer,"Can't open %s/%s.nucl...  created, but stimulation parameters not initialized...",dir,without_ext_name);
	    display_message(widget_array[ID_sim_mainW],buffer,"WARNING");
	  }
	  else
	  {
	    sprintf(buffer,"Can't open nor create %s/%s.nucl...\nI must leave, sorry.\n Look at why I cannot create a small file...",dir,without_ext_name);
	    display_message(widget_array[ID_sim_mainW],buffer,"ERROR");
	    exit_simulator(False);
	  }
	}
	else
	{
#if DEBUG_FILES
	  sprintf(buffer,"%s/%s.nucl",dir,without_ext_name);
	  fprintf(stderr,"%s file successfuly read\n",buffer);
#endif
	  for (i = 0; i < simu->nb_nucleus; i++)
	  {
	    fscanf(fp_nucl,"%s %s",field,value);
	    sprintf(buffer,"\nStimuli for nucleus %s",sim_nucleus[i]->name);
	    _output(buffer);
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->input_mean));
	    if (sim_nucleus[i]->input_mean > 0.)
	    {
	      sprintf(buffer,"\tPulse train mean: %f mV",sim_nucleus[i]->input_mean);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->input_sd));
	    if (sim_nucleus[i]->input_mean > 0.)
	    {
	      sprintf(buffer,"\tPulse train sd: %f",sim_nucleus[i]->input_sd);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %c",field,&(sim_nucleus[i]->input_type));
	    if (sim_nucleus[i]->input_mean > 0.)
	    {
	      sprintf(buffer,"\tPulse train type: %c",sim_nucleus[i]->input_type);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %hd",field,&(sim_nucleus[i]->inhib));
	    if (sim_nucleus[i]->input_mean > 0.)
	    {
	      sprintf(buffer,"\tPulse train inhibitor: %d",sim_nucleus[i]->inhib);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->scale_f));
	    if (sim_nucleus[i]->input_mean > 0.)
	    {
	      sprintf(buffer,"\tPulse train weight: %f mV",sim_nucleus[i]->scale_f);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %hd",field,&(sim_nucleus[i]->noise_active));
	    if (sim_nucleus[i]->noise_active)
	    {
	      sprintf(buffer,"\tNoise activated");
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->backgrd_noise_m));
	    if (sim_nucleus[i]->backgrd_noise_m > 0.)
	    {
	      sprintf(buffer,"\tNoise (mean): %f mV",sim_nucleus[i]->backgrd_noise_m);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->backgrd_noise_sd));
	    if (sim_nucleus[i]->backgrd_noise_sd > 0.)
	    {
	      sprintf(buffer,"\tNoise (sd): %f",sim_nucleus[i]->backgrd_noise_sd);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->modul_period));
	    if (sim_nucleus[i]->modul_period > 0.)
	    {
	      sprintf(buffer,"\tModulation period: %f ms",sim_nucleus[i]->modul_period);
	      sim_nucleus[i]->pulse_down = (unsigned long)(sim_nucleus[i]->modul_period * simu->time_step)+1;
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->modul_amp));
	    if (sim_nucleus[i]->modul_amp > 0.)
	    {
	      sprintf(buffer,"\tModulation amplitude: %f mV",sim_nucleus[i]->modul_amp);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->modul_phase));
	    if (sim_nucleus[i]->modul_phase > 0.)
	    {
	      sprintf(buffer,"\tModulation phase %f",sim_nucleus[i]->modul_phase);
	      sim_nucleus[i]->pulse_up = (unsigned long)(sim_nucleus[i]->modul_phase * simu->time_step)+1;
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %c",field,&(sim_nucleus[i]->modul_type));
	    if (sim_nucleus[i]->modul_type > ' ')
	    {
	      sprintf(buffer,"\tModulation type: %c",sim_nucleus[i]->modul_type);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %d",field,&(sim_nucleus[i]->nb_pulses));
	    if (sim_nucleus[i]->nb_pulses > 0)
	    {
	      sprintf(buffer,"\tNb of pulses: %d",sim_nucleus[i]->nb_pulses);
	      sim_nucleus[i]->pulses_restants = sim_nucleus[i]->nb_pulses;
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->fluctuation));
	    if (sim_nucleus[i]->fluctuation > 0.)
	    {
	      sprintf(buffer,"\tWeight fluctuation: %f",sim_nucleus[i]->fluctuation);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->hebb));
	    if (sim_nucleus[i]->hebb > 0.)
	    {
	      sprintf(buffer,"\tHebb factor: %f",sim_nucleus[i]->hebb);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %c",field,&(sim_nucleus[i]->alive));
	    if (sim_nucleus[i]->alive > ' ')
	    {
	      sprintf(buffer,"\tAlive at start: %c",sim_nucleus[i]->alive);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %d",field,&(sim_nucleus[i]->prob_spike));
	    if (sim_nucleus[i]->prob_spike)
	    {
	      sprintf(buffer,"\tPercentage of spiking units: %d",sim_nucleus[i]->prob_spike);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %d",field,&(sim_nucleus[i]->old_last_spike));
	    if (sim_nucleus[i]->old_last_spike)
	    {
	      sprintf(buffer,"\tOldest last spike at: %d",sim_nucleus[i]->old_last_spike);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %d",field,&(sim_nucleus[i]->recent_last_spike));
	    if (sim_nucleus[i]->recent_last_spike)
	    {
	      sprintf(buffer,"\tRecentest last spike at: %d",sim_nucleus[i]->recent_last_spike);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->low_mb_pot));
	    if (sim_nucleus[i]->low_mb_pot)
	    {
	      sprintf(buffer,"\tLower limit of Mb pot: %.2f",sim_nucleus[i]->low_mb_pot);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %f",field,&(sim_nucleus[i]->up_mb_pot));
	    if (sim_nucleus[i]->up_mb_pot)
	    {
	      sprintf(buffer,"\tUpper limit of Mb pot: %.2f",sim_nucleus[i]->up_mb_pot);
	      _output(buffer);
	    }
	    fscanf(fp_nucl,"%s %c",field,&(sim_nucleus[i]->filter_noise));
	    if (sim_nucleus[i]->filter_noise > ' ')
	    {
	      sprintf(buffer,"\tFiltered noise: %c",sim_nucleus[i]->filter_noise);
	      _output(buffer);
	    }
	  }
	  fclose(fp_nucl);
	}

	
	sprintf(buffer,"\nNetwork loaded from file %s/%s.ntw successfully\n",dir,without_ext_name);
	if(!batch)
	{
#if MESSAGES
		display_message(widget_array[ID_sim_mainW],buffer,"Done...");
#endif
		_output(buffer);
	}
	else
	{
		strcat(buffer,"\n");
		fprintf(stderr,buffer);
	}
	return 0;	
		
}


/*******************************************************************************
	Function for creating nucleus file
*******************************************************************************/
int create_nucleus_file()
{
	/* .x_sim file contains simulation parameters */
	
	FILE *fp_nucl;
	char buffer[256];
	int i;

	fp_nucl = fopen (simu->nucl_name, "w");
	
	/* testing file pointer , in case of failure -> return -1*/
	
	if(!fp_nucl)
	{	
	  sprintf(buffer,"Can't open %s... stimulation parameters not saved...",simu->nucl_name);
	  display_message(widget_array[ID_sim_mainW],buffer,"");
	  return -1;
	}
	else
	{
#if DEBUG_FILES
	  fprintf(stderr,"%s file successfuly created\n",simu->nucl_name);
#endif
	  for (i = 0; i < simu->nb_nucleus; i++)
	  {
	    fprintf(fp_nucl,"Nucleus: %s\n",sim_nucleus[i]->name);
	    fprintf(fp_nucl,"input_mean: %f\n",sim_nucleus[i]->input_mean);
	    fprintf(fp_nucl,"input_sd: %f\n",sim_nucleus[i]->input_sd);
	    fprintf(fp_nucl,"input_type: %c\n",sim_nucleus[i]->input_type);
	    fprintf(fp_nucl,"inhib: %d\n",sim_nucleus[i]->inhib);
	    fprintf(fp_nucl,"scale_f: %f\n",sim_nucleus[i]->scale_f);
	    fprintf(fp_nucl,"noise_active: %d\n",sim_nucleus[i]->noise_active);
	    fprintf(fp_nucl,"background_noise_m: %f\n",sim_nucleus[i]->backgrd_noise_m);
	    fprintf(fp_nucl,"background_noise_sd: %f\n",sim_nucleus[i]->backgrd_noise_sd);
	    fprintf(fp_nucl,"modul_period: %f\n",sim_nucleus[i]->modul_period);
	    fprintf(fp_nucl,"modul_amp: %f\n",sim_nucleus[i]->modul_amp);
	    fprintf(fp_nucl,"modul_phase: %f\n",sim_nucleus[i]->modul_phase);
	    fprintf(fp_nucl,"modul_type: %c\n",sim_nucleus[i]->modul_type);
	    fprintf(fp_nucl,"nb_pulses: %d\n",sim_nucleus[i]->nb_pulses);
	    fprintf(fp_nucl,"fluctuation: %f\n",sim_nucleus[i]->fluctuation);
	    fprintf(fp_nucl,"hebb: %f\n",sim_nucleus[i]->hebb);
	    fprintf(fp_nucl,"alive: %c\n",sim_nucleus[i]->alive);
	    fprintf(fp_nucl,"prob_spike: %d\n",sim_nucleus[i]->prob_spike);
	    fprintf(fp_nucl,"old_last_spike: %d\n",sim_nucleus[i]->old_last_spike);
	    fprintf(fp_nucl,"recent_last_spike: %d\n",sim_nucleus[i]->recent_last_spike);
	    fprintf(fp_nucl,"low_mb_pot: %f\n",sim_nucleus[i]->low_mb_pot);
	    fprintf(fp_nucl,"up_mb_pot: %f\n",sim_nucleus[i]->up_mb_pot);
	    fprintf(fp_nucl,"filter_noise: %c\n",sim_nucleus[i]->filter_noise);
	  }
	}

	fclose(fp_nucl);

	status("Current stimulation parameters saved successfully");
	XFlush(the_display);
	
	return 1;
	
}


#if OLD_VISU
/*******************************************************************************
	Function for creating compatibility with visu
*******************************************************************************/
int create_cnx_for_visu(char *cnx_name)
{
	FILE *fp;
	char *cnx_buffer;
	int i,j,k,l,m;
	char buffer[256];
	unsigned long size;
	short short_value;
	NEURON *neuron_tmp;
	NEURON *target;
	
	
	size = 0;
	cnx_buffer = NULL;
	
	short_value = (short)simu->nb_nucleus;
	memcpy(buffer,&short_value,sizeof(short));
	cnx_buffer = data_bufferize(cnx_buffer,buffer,size,sizeof(short));
	size += sizeof(short);
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		short_value = (short)sim_nucleus[i]->nucleus_size;
		memcpy(buffer,&short_value,sizeof(short));
		cnx_buffer = data_bufferize(cnx_buffer,buffer,size,sizeof(short));
		size += sizeof(short);
	}
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		for(j=0 ; j<sim_nucleus[i]->nucleus_size ; j++)
		{
			neuron_tmp = sim_nucleus[i]->neuron_array[j];
			for(k=0 ; k<simu->nb_nucleus ; k++)
			{
				for(l=0 ; l<sim_nucleus[k]->nucleus_size ;l++)
				{
					target = sim_nucleus[k]->neuron_array[l];
					short_value = 0;
					for(m=0 ; m<neuron_tmp->connected_neurons ; m++)
					{
						if(target->id == neuron_tmp->targets[m])
						{
							short_value = (short)neuron_tmp->connections[m];
							break;
						}
					}
					memcpy(buffer,&short_value,sizeof(short));
					cnx_buffer = data_bufferize(cnx_buffer,buffer,size,sizeof(short));
					size += sizeof(short);
				}
			}
			
		}
	
	}
	
	fp = fopen(cnx_name,"wb");
	fwrite(cnx_buffer,1,size,fp);
	free(cnx_buffer);
	cnx_buffer = NULL;
	fclose(fp);

	return 0;
}
#endif

/*******************************************************************************
	Function for creating compatibility with graph n b c
*******************************************************************************/
int create_prm_file_for_graph(char *prm_name)
{
	FILE *fp;
	char *prm_buffer;
	int i,j,k,l,m;
	char buffer[256];
	short short_value;
	
	
	prm_buffer = NULL;
	
	sprintf(buffer,"X simulation\n");
	prm_buffer = bufferize(prm_buffer,buffer);
	
	sprintf(buffer,"Number of neurons in the network: %d\n",simu->nb_neurons);
	prm_buffer = bufferize(prm_buffer,buffer);
	sprintf(buffer,"Number of clusters in the network: %d\n",simu->nb_nucleus);
	prm_buffer = bufferize(prm_buffer,buffer);
	
	for (i = 0; i < simu->nb_nucleus; i++)
	{
		sprintf(buffer,"CLUSTER %d (%s):\n",
			sim_nucleus[i]->id,
			sim_nucleus[i]->name);
		prm_buffer = bufferize(prm_buffer,buffer);
			
		sprintf(buffer,"    Number of neurons: %d\n",
				sim_nucleus[i]->nucleus_size);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tConnection intra cluster %d: r\n",
					sim_nucleus[i]->id);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tMean axon length: %.2f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tAxon length sd: %.2f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tBackground noise mean: %.2f\n",sim_nucleus[i]->backgrd_noise_m);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tBackground noise sd: %.3f\n",sim_nucleus[i]->backgrd_noise_sd);
		prm_buffer = bufferize(prm_buffer,buffer);
/****************************************************************************/
		if (sim_nucleus[i]->modul_type)
		{
			sprintf(buffer,"\t\tWith modulation\n");
			prm_buffer = bufferize(prm_buffer,buffer);
			sprintf(buffer,"\t\tfonction: %c\n",sim_nucleus[i]->modul_type);
			prm_buffer = bufferize(prm_buffer,buffer);
			sprintf(buffer,"\t\tperiod : %g\n",sim_nucleus[i]->modul_period);
			prm_buffer = bufferize(prm_buffer,buffer);
			sprintf(buffer,"\t\tamplitude : %g\n",sim_nucleus[i]->modul_amp);
			prm_buffer = bufferize(prm_buffer,buffer);
			sprintf(buffer,"\t\tphase : %g\n",sim_nucleus[i]->modul_phase);
			prm_buffer = bufferize(prm_buffer,buffer);
			
		} /* fin du if */
		else
		{
			sprintf(buffer,"\t\twithout modulation\n");
			prm_buffer = bufferize(prm_buffer,buffer);
		}
/****************************************************************************/
		if (sim_nucleus[i]->input_type)
		{
			sprintf(buffer,"\t\tWith supplemental input\n");
			prm_buffer = bufferize(prm_buffer,buffer);
			sprintf(buffer,"\t\tInput type: %c\n",sim_nucleus[i]->input_type);
			prm_buffer = bufferize(prm_buffer,buffer);
			sprintf(buffer,"\t\tMean input: %f\n",sim_nucleus[i]->input_mean);
			prm_buffer = bufferize(prm_buffer,buffer);
			sprintf(buffer,"\t\tInput sd: %f\n",sim_nucleus[i]->input_sd);
			prm_buffer = bufferize(prm_buffer,buffer);
		} /* fin du if */
		else
		{
			sprintf(buffer,"\t\tWithout supplemental input\n");
			prm_buffer = bufferize(prm_buffer,buffer);
		}	
		sprintf(buffer,"\t\tMembrane rest potential: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tMembrane time constant: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tMembrane shunt time constant: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tPost spike potential: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tE_K potential: %.1f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tE_Na potential: %.1f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tPost spike potential: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tThreshold  potential: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tThreshold time constant: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tThreshold Post spike: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tEPSP potential size: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tEPSP attack time constant: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tEPSP decay time constant: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tIPSP potential size: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tIPSP attack time constant: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tIPSP decay time constant: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tInput additional scale factor: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tEPSP reversal potential: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\tIPSP reversal potential: %f\n",0.0);
		prm_buffer = bufferize(prm_buffer,buffer);
		sprintf(buffer,"\t\t%s auto-connections\n","Without");
		prm_buffer = bufferize(prm_buffer,buffer);
		for ( j = 0; j < simu->nb_nucleus; j++)
		{
			if ( i == j) continue;
			sprintf(buffer,"\t\tEffect of cluster %d on the cluster %d: %2c\n",sim_nucleus[i]->id,
				sim_nucleus[j]->id,'r');
			prm_buffer = bufferize(prm_buffer,buffer);	
			sprintf(buffer,"\t\tMean axon length from %d to %d: %.2f\n",sim_nucleus[i]->id,
				sim_nucleus[j]->id,0.0);
			prm_buffer = bufferize(prm_buffer,buffer);	
			sprintf(buffer,"\t\tAxon length sd from %d to %d: %.2f\n",sim_nucleus[i]->id,
				sim_nucleus[j]->id,0.0);
			prm_buffer = bufferize(prm_buffer,buffer);
				
		} /* fin du for */
	}

	sprintf(buffer,"\nMatrix of  inter-clusters relationship:\n\n");
	prm_buffer = bufferize(prm_buffer,buffer);
	sprintf(buffer,"No  Nb RestP Thres  Noise  Sd  b.sup Tau   Dur ACx ");
	prm_buffer = bufferize(prm_buffer,buffer);
	for (k = 0; k < simu->nb_nucleus; k++) 
	{
		sprintf(buffer," D%1d",k+1);
		prm_buffer = bufferize(prm_buffer,buffer);
	}
	for (k = 0; k < simu->nb_nucleus; k++) 
	{
		sprintf(buffer,"%2d",k+1);
		prm_buffer = bufferize(prm_buffer,buffer);
	}
	sprintf(buffer,"\n");
	prm_buffer = bufferize(prm_buffer,buffer);
/*
 * No  Nb RestP Thres  Noiset   Sd  *B.sup*  Tau   Dur ACx  D1 D2 D3 1 2 3
 *  1 100 -80.0 -60.0  0.001  0.001 *  y  * -100.0 100  n   -- 20 30 0 + a
 */
	for (k = 0; k < simu->nb_nucleus; k++)
	{                                                       /**/
		sprintf(buffer,"%2d %3d %5.1f %5.1f %6.3f %6.3f %2c %5.1f %4.1f  %c  ",
			sim_nucleus[k]->id, sim_nucleus[k]->nucleus_size, 
			0.0, 0.0, 
			sim_nucleus[k]->backgrd_noise_m, sim_nucleus[k]->backgrd_noise_sd,
/*****************************************************************************/
			(sim_nucleus[k]->modul_type)?'y':'n',
/*****************************************************************************/
			0.0, 0.0,
			'n');
		prm_buffer = bufferize(prm_buffer,buffer);
		
		for (j = 0; j < simu->nb_nucleus; j++)
		{
			sprintf(buffer,"%.1f",0.0);
			prm_buffer = bufferize(prm_buffer,buffer);
		}
		for (j = 0; j < simu->nb_nucleus; j++)
		{
			sprintf(buffer,"%2c",'r');
			prm_buffer = bufferize(prm_buffer,buffer);
		}
		sprintf(buffer,"\n");
		prm_buffer = bufferize(prm_buffer,buffer);
	}

	sprintf(buffer,"\nNumber of synaptic buttons (constraints of the connection matrix)\n");
	prm_buffer = bufferize(prm_buffer,buffer);
	for (k = 0; k < simu->nb_nucleus; k++)
	{
		for (j = 0; j < simu->nb_nucleus; j++)
		{
			sprintf(buffer,"Cluster %d -> %d\n",sim_nucleus[k]->id,
				sim_nucleus[j]->id);
			prm_buffer = bufferize(prm_buffer,buffer);	
			sprintf(buffer,"\tfrom %d to %d\n",
				0,
				0);
			prm_buffer = bufferize(prm_buffer,buffer);
			
		} /* fin du for */
	}
		
	fp = fopen(prm_name,"w");
	if (fp)
	{
		fprintf(fp,"%s",prm_buffer);
		free(prm_buffer);
		prm_buffer = NULL;
		fclose(fp);
	} /* fin du if */
	
	return 0;
}

/*******************************************************************************
	Function for reading neur file
*******************************************************************************/
int read_neur_file(char *neur_name)
{
	printf("\007,Sorry, not yet re-implemented in the X version...:-(\n");
	return 0;
}

/*******************************************************************************
	Function for creating a neur file
*******************************************************************************/
int create_neur_file(char *neur_name)
{
	printf("\007,Sorry, not yet implemented...:-(\n");
	return 0;
}


/*******************************************************************************
	Function for creating x_sim file
*******************************************************************************/
int create_x_sim_file(char *x_sim_name)
{
	/* .x_sim file contains simulation parameters */
	
	FILE *fp;
	char msg_error[256];
			
	if((fp = fopen(x_sim_name,"w")) == NULL)
	{
		    printf("Impossible to open the parameter file (%s)...\n",x_sim_name);
		    sprintf(msg_error,"Impossible to open the parameter file (%s)...",x_sim_name);
    		    display_error(widget_array[ID_sim_mainW],msg_error,"Using the default parameters!");
		    return 0;
	}
	
	/*
	simu->watch_sim = TRUE;
	simu->look_at_dot_display = TRUE;
	simu->look_at_glob_act = FALSE;
	simu->look_at_it_count = FALSE;
	simu->look_at_ms_count = FALSE;

	simu->time_step = TIME_STEP;
	simu->spike_width = SPIKE_WIDTH;

	simu->nb_step_spk = (unsigned long)(simu->spike_width/TIME_STEP);
	simu->nb_step_save_it = (unsigned long)(1./TIME_STEP);
	simu->nb_step_save_ms = 1.;
	simu->count_show_it = NB_STEP_SHOW;
	simu->count_show_ms = (float)NB_STEP_SHOW / (float)NB_STEP_MS;
        simu->nb_it = 0;
        simu->time_ms = 0.;
        simu->it_to_save = 0;
        simu->it_to_show = 0;
	simu->next_stop = NEXT_STOP;
	simu->last_it = LAST_IT;	
	simu->nb_next_it = NB_NEXT_IT;

	simu->stop_at_ms = (float)simu->next_stop * simu->time_step;
	simu->end_at_ms = (float)simu->last_it * simu->time_step;

	 */

	fprintf(fp,"simu_watch: %d\n",simu->watch_sim);
	fprintf(fp,"simu_look_at_dot_display: %d\n",simu->look_at_dot_display);
	fprintf(fp,"simu_look_at_glob_act: %d\n",simu->look_at_glob_act);
	fprintf(fp,"simu_look_at_it_count: %d\n",simu->look_at_it_count);
	fprintf(fp,"simu_look_at_ms_count: %d\n",simu->look_at_ms_count);
	fprintf(fp,"simu_spike_width: %.5f\n",simu->spike_width);
	fprintf(fp,"simu_time_step: %.5f\n",simu->time_step);
	fprintf(fp,"simu_nb_step_spk: %u\n",simu->nb_step_spk);
	fprintf(fp,"simu_nb_step_save_it: %d\n",simu->nb_step_save_it);
	fprintf(fp,"simu_nb_step_save_ms: %.5f\n",simu->nb_step_save_ms);
	fprintf(fp,"simu_nb_step_watch_it: %d\n",simu->nb_step_watch_it);
	fprintf(fp,"simu_nb_step_watch_ms: %.5f\n",simu->nb_step_watch_ms);
	fprintf(fp,"simu_count_show_it: %d\n",simu->count_show_it);
	fprintf(fp,"simu_count_show_ms: %.5f\n",simu->count_show_ms);
	fprintf(fp,"simu_last_it: %d\n",simu->last_it);
	fprintf(fp,"simu_nb_next_it: %d\n",simu->nb_next_it);
	fprintf(fp,"simu_output_abe_f: %d\n",simu->output_abe_f);
	fprintf(fp,"simu_output_sim_f: %d\n",simu->output_sim_f);
	fprintf(fp,"simu_output_tms_f: %d\n",simu->output_tms_f);
	fprintf(fp,"simu_output_pmb_f: %d\n",simu->output_pmb_f);
	fprintf(fp,"simu_output_gnp_f: %d\n",simu->output_gnp_f);

	fclose(fp);	
	
	strcpy(simu->x_sim_name,x_sim_name);

	status("Current simulation parameters saved successfully");
	XFlush(the_display);
	
	return 1;
	
}

/*******************************************************************************
	Function for reading x_sim file
*******************************************************************************/
int read_x_sim_file(char *x_sim_name)
{
	
	FILE *fp;
	char buffer[256];
	char field[100];
	char value[100];
	char msg_error[256];
			

	if((fp = fopen(x_sim_name,"r")) == NULL)
	{
		    printf("Impossible to open the parameter file (%s)...\n",x_sim_name);
		    sprintf(msg_error,"Impossible to open the parameter file (%s)...",x_sim_name);
    		    display_error(widget_array[ID_sim_mainW],msg_error,"Using the current parameters!");
		    return 0;
	}
	
	while(fgets(buffer,255,fp))
	{
	    sscanf(buffer,"%s %s",field,value);
		
	    if(!strcmp("simu_watch:",field))
	    {
	      sscanf(value,"%hd",&(simu->watch_sim));
#if 0
	      if (!simu->watch_sim)
	      {
		XmToggleButtonSetState(widget_array[ID_pushB_silent],True,False);
	      }
#endif
	    }
	    if(!strcmp("simu_look_at_dot_display:",field))
	    {
	      sscanf(value,"%hd",&(simu->look_at_dot_display));
#if 0
	      XmToggleButtonSetState(widget_array[ID_toggle_dot],simu->look_at_dot_display,False);
#endif
	    }
	    if(!strcmp("simu_look_at_glob_act:",field))
	    {
#if 0
	      XmToggleButtonSetState(widget_array[ID_toggle_global],simu->look_at_glob_act,False);
#endif
	      sscanf(value,"%hd",&(simu->look_at_glob_act));
	    }
	    if(!strcmp("simu_look_at_it_count:",field))
	    {
	      XmToggleButtonSetState(widget_array[ID_pushB_it_count],simu->look_at_it_count,False);
#if 0
	      XmToggleButtonSetState(widget_array[ID_pushB_silent],False,False);
#endif
	      sscanf(value,"%d",&(simu->look_at_it_count));
	    }
	    if(!strcmp("simu_look_at_ms_count:",field))
	    {
	      XmToggleButtonSetState(widget_array[ID_pushB_watch_sampling],simu->look_at_ms_count,False);
#if 0
	      XmToggleButtonSetState(widget_array[ID_pushB_silent],False,False);
#endif
	      sscanf(value,"%hd",&(simu->look_at_ms_count));
	    }
	    if(!strcmp("simu_time_step:",field))
	    {
	      sscanf(value,"%f",&(simu->time_step));
	    }
	    if(!strcmp("simu_spike_width:",field))
	    {
	      sscanf(value,"%f",&(simu->spike_width));
	    }
	    if(!strcmp("simu_time_step:",field))
	    {
	      sscanf(value,"%f",&(simu->time_step));
	    }
	    if(!strcmp("simu_nb_step_spk:",field))
	    {
	      sscanf(value,"%d",&(simu->nb_step_spk));
	    }
	    if(!strcmp("simu_nb_step_save_it:",field))
	    {
	      sscanf(value,"%d",&(simu->nb_step_save_it));
	    }
	    if(!strcmp("simu_nb_step_save_ms:",field))
	    {
	      sscanf(value,"%f",&(simu->nb_step_save_ms));
	    }
	    if(!strcmp("simu_nb_step_watch_it:",field))
	    {
	      sscanf(value,"%d",&(simu->nb_step_watch_it));
	    }
	    if(!strcmp("simu_nb_step_watch_ms:",field))
	    {
	      sscanf(value,"%f",&(simu->nb_step_watch_ms));
	    }
	    if(!strcmp("simu_count_show_it:",field))
	    {
	      sscanf(value,"%d",&(simu->count_show_it));
	    }
	    if(!strcmp("simu_count_show_ms:",field))
	    {
	      sscanf(value,"%f",&(simu->count_show_ms));
	    }
	    if(!strcmp("simu_last_it:",field))
	    {
	      sscanf(value,"%d",&(simu->last_it));
	    }
	    if(!strcmp("simu_nb_next_it:",field))
	    {
	      sscanf(value,"%d",&(simu->nb_next_it));
	    }
	    if (!strcmp("simu_output_abe_f:",field))
	    {
	      sscanf(value,"%hd",&(simu->output_abe_f));
	    }
	    if (!strcmp("simu_output_sim_f:",field))
	    {
	      sscanf(value,"%hd",&(simu->output_sim_f));
	    }
	    if (!strcmp("simu_output_tms_f:",field))
	    {
	      sscanf(value,"%hd",&(simu->output_tms_f));
	    }
	    if (!strcmp("simu_output_pmb_f:",field))
	    {
	      sscanf(value,"%hd",&(simu->output_pmb_f));
	    }
	    if (!strcmp("simu_output_gnp_f:",field))
	    {
	      sscanf(value,"%hd",&(simu->output_gnp_f));
	    }
	}

	if (simu->time_step == 0.)
	{
	  simu->time_step = TIME_STEP;
	}
	if (simu->spike_width == 0.)
	{
	  simu->spike_width = SPIKE_WIDTH;
	  simu->nb_step_spk = (unsigned long)(simu->spike_width/TIME_STEP);
	}
	if (simu->nb_step_save_it == 0)
	{
	  simu->nb_step_save_it = 1;
	  simu->nb_step_save_ms = 1.;
	}
	if (simu->nb_step_watch_it == 0)
	{
	  simu->nb_step_watch_it = 1;
	  simu->nb_step_watch_ms = 1.;
	}
	if (simu->count_show_it == 0)
	{
/*
	  simu->count_show_it = NB_STEP_SHOW;
	  simu->count_show_ms = (float)NB_STEP_SHOW / (float)NB_STEP_MS;
*/
	  simu->count_show_it = 1;
	  simu->count_show_ms = 1.;
	}
	if (simu->last_it == 0)
	{
	  simu->last_it = LAST_IT;
	}
	if (simu->nb_next_it == 0)
	{
	  simu->nb_next_it = NB_NEXT_IT;
	}
	if (simu->output_tms_f == 0)
	{
	  simu->output_tms_f = 1;
	}
	if (simu->output_pmb_f == 0)
	{
	  simu->output_pmb_f = 1;
	}
	if (simu->output_sim_f == 0)
	{
	  simu->output_sim_f = 1;
	}

	simu->nb_it = 0;
	simu->time_ms = 0.;
	strcpy(simu->x_sim_name,x_sim_name);
	simu->parameters_loaded = True;		
	
	status("New parameters read successfully");
	XFlush(the_display);
	
	return 1;

}

#if 0
/*******************************************************************************
	Function for reading x_def file
*******************************************************************************/
int read_x_def_file(char *x_def_name)
{
	
	FILE *fp;
	SIMULATION simu_tmp;
	NUCLEUS nucleus_tmp;
	CLUSTER cluster_tmp;
	void *pt1;
	void *pt2;
	void *pt3;
	int i,j;
	
	if(!(fp = fopen(x_def_name,"rb")))
	{
		return -1;
	}
	
	fread(&simu_tmp,1,sizeof(SIMULATION),fp);
	
	if(read_lnk_file(simu_tmp.lnk_name))
	{
		return -1;
	}
	
	if((simu->nb_neurons != simu_tmp.nb_neurons)
		|| (simu->nb_nucleus != simu_tmp.nb_nucleus)
		|| (simu->nb_clusters != simu_tmp.nb_clusters))
	{
	
		return -1;
	}
	
	strcpy(output_file,simu_tmp.name);
	
	memcpy(simu,&simu_tmp,sizeof(SIMULATION));
	
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		fread(&nucleus_tmp,1,sizeof(NUCLEUS),fp);
		
		if((nucleus_tmp.nucleus_size != sim_nucleus[i]->nucleus_size)
			|| (nucleus_tmp.nb_clusters != sim_nucleus[i]->nb_clusters))
		{
			return -1;
		}
		
		pt1 = (NEURON **)sim_nucleus[i]->neuron_array;
		pt2 = (CLUSTER **)sim_nucleus[i]->cluster_array;
		
		memcpy(sim_nucleus[i],&nucleus_tmp,sizeof(NUCLEUS));
		
		sim_nucleus[i]->neuron_array = (NEURON **)pt1;
		sim_nucleus[i]->cluster_array = (CLUSTER **)pt2;
		
		
		switch(sim_nucleus[i]->law)
		{
			case 'h':
				sim_nucleus[i]->learning = hebb_learn;
				break;
			
			default:
				sim_nucleus[i]->learning = NULL;
				break;
		
		}	
		
		
	
	}
	
	for(i=0 ; i<simu->nb_clusters ; i++)
	{
		fread(&cluster_tmp,1,sizeof(CLUSTER),fp);
		
		if((cluster_tmp.cluster_size != sim_clusters[i]->cluster_size)
			|| (cluster_tmp.nb_nucleus != sim_clusters[i]->nb_nucleus))
		{
			return -1;
		}
		
		pt1 = (NEURON **)sim_clusters[i]->neuron_array;
		pt2 = (NUCLEUS **)sim_clusters[i]->nucleus_array;
		
		if(sim_clusters[i]->clu_data)
		{
			free(sim_clusters[i]->clu_data);
		}
		
		memcpy(sim_clusters[i],&cluster_tmp,sizeof(CLUSTER));
		
		sim_clusters[i]->clu_data = NULL;
		sim_clusters[i]->neuron_array = (NEURON **)pt1;
		sim_clusters[i]->nucleus_array = (NUCLEUS **)pt2;
		
		if(read_clu_unit(sim_clusters[i]->file_name,i))
		{
			return -1;
		}
		
		switch(sim_clusters[i]->model)
		{
#if ADD_NEW_MODEL
/*************** TO ADD A MODEL COPY THIS AND ADAPT *************/
			case 'X':
				sim_clusters[i]->update_soma = update_X_res;
				break;
/************************ STOP **********************************/
#endif
			case 'L':
				sim_clusters[i]->update_soma = update_L_res;
				break;
			case 'B':
				sim_clusters[i]->update_soma = update_B_res;
				break;
			case 'V':
				sim_clusters[i]->update_soma = update_V_res;
				break;
			case 'G':
				if (simu->use_ntr)
				{
					if (((CBM *)sim_clusters[i]->clu_data)->model_type == HH_SIMPLE_MODEL)
						sim_clusters[i]->update_soma = update_G_res_use_ntr_simple;
					else
						sim_clusters[i]->update_soma = update_G_res_use_ntr_full;
				}
				else
				{ 
					if (((CBM *)sim_clusters[i]->clu_data)->model_type == HH_SIMPLE_MODEL)
						sim_clusters[i]->update_soma = update_G_res_no_ntr_simple;
					else
						sim_clusters[i]->update_soma = update_G_res_no_ntr_full;
				}
				break;
			case 'P':
			default:
				sim_clusters[i]->update_soma = update_P_res;
				break;
		}
	}
	
	simu->nb_it = 0;
	simu->time_ms = 0.;
	strcpy(simu->x_def_name,x_def_name);
	simu->parameters_loaded = True;		
	
	return 0;

}

/*******************************************************************************
	Function for creating x_def file
*******************************************************************************/
int create_x_def_file(char *x_def_name)
{
	/* .x_def file containts lnk name, simu, nucleus and clusters parameters */
	
	FILE *fp;
	char *x_def_buffer;
	int i,j,k,l,m;
	char *buffer;
	unsigned long size;
	SIMULATION simu_tmp;
	
	
	
	size = 0;
	x_def_buffer = NULL;
	
	
	buffer = (char *)calloc(1,sizeof(SIMULATION));
	memcpy(&simu_tmp,simu,sizeof(SIMULATION));
	simu_tmp.nb_next_it = simu_tmp.next_stop - simu_tmp.nb_it;
	simu_tmp.next_stop = simu_tmp.nb_next_it;
	simu_tmp.nb_it = 0;
	simu_tmp.time_ms = 0.;
	simu_tmp.stop_at_ms = (float)simu_tmp.next_stop*simu_tmp.time_step;
	memcpy(buffer,&simu_tmp,sizeof(SIMULATION));
	x_def_buffer = data_bufferize(x_def_buffer,buffer,size,sizeof(SIMULATION));
	size += sizeof(SIMULATION);
	free(buffer);
	
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		
		buffer = (char *)calloc(1,sizeof(NUCLEUS));
		memcpy(buffer,sim_nucleus[i],sizeof(NUCLEUS));
		x_def_buffer = data_bufferize(x_def_buffer,buffer,size,sizeof(NUCLEUS));
		size += sizeof(NUCLEUS);
		free(buffer);
	
	}
	
	for(i=0 ; i<simu->nb_clusters ; i++)
	{
	
		buffer = (char *)calloc(1,sizeof(CLUSTER));
		memcpy(buffer,sim_clusters[i],sizeof(CLUSTER));
		x_def_buffer = data_bufferize(x_def_buffer,buffer,size,sizeof(CLUSTER));
		size += sizeof(CLUSTER);
		free(buffer);
	
	
	}	
	
	if(!(fp = fopen(x_def_name,"wb")))
	{
		free(x_def_buffer);
		return -1;
	}
	
	fwrite(x_def_buffer,1,size,fp);
	fclose(fp);	
	free(x_def_buffer);
	
	strcpy(simu->x_def_name,x_def_name);
	
	return 0;
	
}
#endif
/*******************************************************************************
	Function for reading a clu unit file for all types
*******************************************************************************/
int read_clu_unit(char *unit_name,int cluster_pos)
{
	char without_ext_name[256];
	char ext[10];
	char dir[256];
	char *pt;
	char buffer[256];
	
	strcpy(buffer,unit_name);
	if(pt = strrchr(buffer,'.'))
	{
		strcpy(ext,pt);
		*pt = '\0';
	}
	else
	{
		if(sim_clusters[cluster_pos]->model == 'V')
			strcpy(ext,".tms");
#if ADD_NEW_MODEL
/*************** TO ADD A MODEL COPY THIS AND ADAPT *************/
		else if(sim_clusters[cluster_pos]->model == 'X')
			strcpy(ext,".X_unit");
/************************ STOP **********************************/
#endif
		else if(sim_clusters[cluster_pos]->model == 'L')
			strcpy(ext,".L_unit");
		else if(sim_clusters[cluster_pos]->model == 'B')
			strcpy(ext,".B_unit");
		else if(sim_clusters[cluster_pos]->model == 'G')
			strcpy(ext,".G_unit");
		else if(sim_clusters[cluster_pos]->model == 'P')
			strcpy(ext,".P_unit");
	}	
	if(pt = strrchr(buffer,'/'))
	{
		*pt = '\0';
		pt++;
		strcpy(without_ext_name,pt);
		strcpy(dir,buffer);
	}
	else
	{
		strcpy(without_ext_name,buffer);
		strcpy(dir,project_directory);
	}
	
	sprintf(buffer,"%s%s",without_ext_name,ext);
	if(!file_exists(buffer,dir))
		return -1;
		
	if(!strcmp(ext,".tms"))
	{
		sprintf(buffer,"%s/%s%s",dir,without_ext_name,ext);
		if(read_unit_V_file(buffer,cluster_pos))
			return -1;
		sim_clusters[cluster_pos]->model = 'V';
		strcpy(sim_clusters[cluster_pos]->file_name,buffer);
	}
	else if(!strcmp(ext,".G_unit"))
	{
		sprintf(buffer,"%s/%s%s",dir,without_ext_name,ext);
		if(read_unit_G_file(buffer,cluster_pos))
			return -1;
		sim_clusters[cluster_pos]->model = 'G';
		strcpy(sim_clusters[cluster_pos]->file_name,buffer);	
	}
#if ADD_NEW_MODEL
/*************** TO ADD A MODEL COPY THIS AND ADAPT *************/
	else if(!strcmp(ext,".X_unit"))
	{
		sprintf(buffer,"%s/%s%s",dir,without_ext_name,ext);
		if(read_unit_X_file(buffer,cluster_pos))
			return -1;
		sim_clusters[cluster_pos]->model = 'X';
		strcpy(sim_clusters[cluster_pos]->file_name,buffer);	
	}
/************************ STOP **********************************/
#endif
	else if(!strcmp(ext,".L_unit"))
	{
		sprintf(buffer,"%s/%s%s",dir,without_ext_name,ext);
		if(read_unit_L_file(buffer,cluster_pos))
			return -1;
		sim_clusters[cluster_pos]->model = 'L';
		strcpy(sim_clusters[cluster_pos]->file_name,buffer);	
	}
	else if(!strcmp(ext,".B_unit"))
	{
		sprintf(buffer,"%s/%s%s",dir,without_ext_name,ext);
		if(read_unit_B_file(buffer,cluster_pos))
			return -1;
		sim_clusters[cluster_pos]->model = 'B';
		strcpy(sim_clusters[cluster_pos]->file_name,buffer);	
	}
	else if(!strcmp(ext,".P_unit"))
	{
		sprintf(buffer,"%s/%s%s",dir,without_ext_name,ext);
		if(read_unit_P_file(buffer,cluster_pos))
			return -1;
		sim_clusters[cluster_pos]->model = 'P';
		strcpy(sim_clusters[cluster_pos]->file_name,buffer);
	
	}
	else
	{
		return -1;
	}
	
	return 0;	

}

/*******************************************************************************
	Function for reading unit P file (model PUM)
*******************************************************************************/
int read_unit_P_file(char *unit_P_name,int cluster_pos)
{
	PUM *pum;
	FILE *fp;
	char parametre[256];
	char value[256];
	char buffer[256];
	float f_value;
	
	pum = sim_clusters[cluster_pos]->clu_data = (PUM *)calloc(1,sizeof(PUM));
	
	/* default values */
	
	pum->rest_pot		= -70.;	/* resting  potential du cluster	*/
	pum->pot_post_spike	= -85.;	/* Pot mb post spike			*/
	pum->tau_mb_pot		= 10.;	/* cste de temps de la mb		*/
	pum->seuil		= -60.;	/* firing threshold par cluster		*/
	pum->seuil_post_spike	= 20.;	/* seuil apres un spike			*/
	pum->E_K 		= -90.;	/* Potentiel d'equilibre du potassium	*/
	pum->E_Na		= 65.;	/* Potentiel d'equilibre du sodium	*/
	pum->E_Cl		= -89.;	/* Potentiel d'equilibre du chlore	*/
	pum->E_Ca		= 20.;	/* Potentiel d'equilibre du calcium	*/
	pum->rev_pot_pos	= 0.;	/* Reversal Potential positif (pour epsp)*/
	pum->rev_pot_neg	= -90.;	/* Resersal Potential negatif (pour ipsp)*/
	pum->tau_seuil		= 20.;	/* cste de temps du seuil apres un spike */
	pum->epsp		= 1.;	/* taille d'un psp (e ou i)		*/
	pum->tau_attack_epsp	= 2.;	/* conste de temps de montee		*/
	pum->tau_decay_epsp	= 5.;	/* conste de temps de descente		*/
	pum->ipsp		= 1.;	/* taille d'un psp (e ou i)		*/
	pum->tau_attack_ipsp	= 2.;	/* conste de temps de montee		*/
	pum->tau_decay_ipsp	= 5.;	/* conste de temps de descente		*/
	pum->shunt_tau		= 20.;	/* constante de temps du shunt de la mb */
	pum->backgrd_noise_m	= 0.;	/* Bruit de fond (moyenne)		*/
	pum->backgrd_noise_sd	= 0.;	/* Bruit de fond (sd)			*/
	pum->capacite   	= 1.;	/* Capacite pour le filtre	       	*/
	pum->resistance   	= 10.;	/* Resistance pour le filtre     	*/
	pum->filter_noise       = 0;    /* Bruit a la Kohn                      */
	
	/* reading the P unit file */
	
	if (fp = fopen(unit_P_name,"r"))	
	{
		while(fgets(buffer,255,fp))
		{
			sscanf(buffer,"%s %s",parametre,value);
			
			if (!strcmp(parametre,"RestPotential:"))	/* resting  potential	*/
				sscanf(value,"%f",&pum->rest_pot);
			
			if (!strcmp(parametre,"PostSpikePotential:"))	/* Pot mb post spike */
				sscanf(value,"%f",&(pum->pot_post_spike));
#if 0			
			if (!strcmp(parametre,"TimeStep:"))/* Time step */
			{
			        sscanf(value,"%f",&f_value);
				if (f_value < simu->time_step)
				      simu->time_step = f_value;
			}
#endif
			if (!strcmp(parametre,"TimeCsteMbPot:"))	/* cste de temps de la mb */
			{
				sscanf(value,"%f",&(pum->tau_mb_pot));
			} /* fin du if */
			
			if (!strcmp(parametre,"Threshold:"))		/* firing threshold par cluster */
				sscanf(value,"%f",&(pum->seuil));
			
			if (!strcmp(parametre,"Adaptation:"))		/* seuil apres un spike */
				sscanf(value,"%f",&(pum->seuil_post_spike));
			
			if (!strcmp(parametre,"E_K:"))		/* Potentiel d'equilibre du potassium */
				sscanf(value,"%f",&(pum->E_K));
			
			if (!strcmp(parametre,"E_Na:"))		/* Potentiel d'equilibre du sodium */
				sscanf(value,"%f",&(pum->E_Na));
			
			if (!strcmp(parametre,"E_Cl:"))		/* Potentiel d'equilibre du chlore */
				sscanf(value,"%f",&(pum->E_Cl));
			
			if (!strcmp(parametre,"E_Ca:"))		/* Potentiel d'equilibre du calcium */
				sscanf(value,"%f",&(pum->E_Ca));
			
			if (!strcmp(parametre,"PosReversalPot:"))	/* Reversal Potential positif (pour epsp) */
				sscanf(value,"%f",&(pum->rev_pot_pos));
			
			if (!strcmp(parametre,"NegReversalPot:"))	/* Resersal Potential negatif (pour ipsp) */
				sscanf(value,"%f",&(pum->rev_pot_neg));
			
			if (!strcmp(parametre,"TimeCsteThreshold:"))	/* cste de temps du seuil apres un spike */
			{
				sscanf(value,"%f",&(pum->tau_seuil));
			} /* fin du if */
			
			if (!strcmp(parametre,"EpspSize:"))		/* taille d'un epsp  */
				sscanf(value,"%f",&(pum->epsp));
			
			if (!strcmp(parametre,"EpspAttack:"))	/* conste de temps de montee */
			{
				sscanf(value,"%f",&(pum->tau_attack_epsp));
			} /* fin du if */
			
			if (!strcmp(parametre,"EpspDecay:"))	/* conste de temps de descente */
			{
				sscanf(value,"%f",&(pum->tau_decay_epsp));
			} /* fin du if */
			
			if (!strcmp(parametre,"IpspSize:"))		/* taille d'un ipsp  */
				sscanf(value,"%f",&(pum->ipsp));
			
			if (!strcmp(parametre,"IpspAttack:"))	/* conste de temps de montee */
			{
				sscanf(value,"%f",&(pum->tau_attack_ipsp));
			} /* fin du if */
			
			if (!strcmp(parametre,"IpspDecay:"))	/* conste de temps de descente */
			{
				sscanf(value,"%f",&(pum->tau_decay_ipsp));
			} /* fin du if */
			
			if (!strcmp(parametre,"MembraneShunt:"))/* constante de temps du shunt de la mb */
				sscanf(value,"%f",&(pum->shunt_tau));
			
			if (!strcmp(parametre,"NoiseMean:"))/* Bruit surajoute (moyenne) */
			{
				sscanf(value,"%f",&(pum->backgrd_noise_m));
			}
			if (!strcmp(parametre,"NoiseFilter:"))/* Bruit a la Kohn */
			{
				sscanf(value,"%hd",&(pum->filter_noise));
			}
			if (!strcmp(parametre,"Capacity:"))/* Bruit a la Kohn */
			{
				sscanf(value,"%f",&(pum->capacite));
			}
			if (!strcmp(parametre,"NoiseSd:"))/* Bruit surajoute (sd) */
			{
				sscanf(value,"%f",&(pum->backgrd_noise_sd));
			}
			if (!strcmp(parametre,"FilterResistance:"))/* Resistance du filtre */
			{
			        sscanf(value,"%f",&(pum->resistance));
			}
			if (!strcmp(parametre,"Fatigue:"))/* Fatigue du seuil */
			{
				sscanf(value,"%f",&(pum->fatigue));
			}
			if (!strcmp(parametre,"LessFatigue:"))/* Fatigue du seuil */
			{
				sscanf(value,"%hd",&(pum->less_fatigue));
			}
		} /* fin du while */

#if 0
		pum->tau_mb_pot = pum->tau_mb_pot / simu->time_step;
		pum->tau_seuil = pum->tau_seuil / simu->time_step;
		pum->shunt_tau = pum->shunt_tau / simu->time_step;
		pum->tau_attack_epsp = pum->tau_attack_epsp / simu->time_step;	
		pum->tau_decay_epsp = pum->tau_decay_epsp / simu->time_step;	
		pum->tau_attack_ipsp = pum->tau_attack_ipsp / simu->time_step;	
		pum->tau_decay_ipsp = pum->tau_decay_ipsp / simu->time_step;	
#endif

		pum->i_tau_mb_pot = 1. / pum->tau_mb_pot;
		pum->i_tau_seuil = 1. / pum->tau_seuil;	

		pum->tau_i_mb_pot = pum->tau_mb_pot;
		pum->tau_i_seuil = pum->tau_seuil;	
		pum->shunt_i_tau = pum->shunt_tau;	

		pum->i_tau_attack_epsp = 1. / pum->tau_attack_epsp;	
		pum->i_tau_decay_epsp = 1. / pum->tau_decay_epsp;	
		pum->i_tau_attack_ipsp = 1. / pum->tau_attack_ipsp;	
		pum->i_tau_decay_ipsp = 1. / pum->tau_decay_ipsp;	

		pum->tau_a_epsp = pum->tau_attack_epsp;	
		pum->tau_d_epsp = pum->tau_decay_epsp;	
		pum->tau_a_ipsp = pum->tau_attack_ipsp;	
		pum->tau_d_ipsp = pum->tau_decay_ipsp;	

		pum->i_capacite = 1. / pum->capacite;
		pum->res_capa = pum->capacite * pum->resistance;
		pum->overshoot = - pum->rest_pot + pum->pot_post_spike;

		pum->backgrd_n_sd = pum->backgrd_noise_sd * simu->time_step; 
		if(pum->backgrd_noise_sd || pum->backgrd_noise_m)
			pum->noise_active = True;
		else
			pum->noise_active = False;
		
		fclose(fp);

		return 0;
		
	} /* fin du if */
	else
	{
		free(sim_clusters[cluster_pos]->clu_data);
		sim_clusters[cluster_pos]->clu_data = NULL;
		return -1;
		
	} /* fin du else */

}

/*******************************************************************************
	Function for reading unit L file (model LUM)
*******************************************************************************/
int read_unit_L_file(char *unit_L_name, int cluster_pos)
{
	LIM *lim;
	FILE *fp;
	float f_value;
	char parametre[256];
	char value[256];
	char buffer[256];
	
	lim = sim_clusters[cluster_pos]->clu_data = (LIM *)calloc(1,sizeof(LIM));
	
	/* default values */
	
	lim->rest_pot		= -70.;	/* resting  potential du cluster	*/
	lim->pot_post_spike	= -85.;	/* Pot mb post spike			*/
	lim->tau_mb_pot		= 10.;	/* cste de temps de la mb		*/
	lim->seuil		= -60.;	/* firing threshold par cluster		*/
	lim->seuil_post_spike	= 20.;	/* seuil apres un spike			*/
	lim->tau_seuil		= 20.;	/* cste de temps du seuil apres un spike */
	lim->epsp		= 1.;	/* taille d'un psp (e ou i)		*/
	lim->ipsp		= 1.;	/* taille d'un psp (e ou i)		*/
	lim->backgrd_noise_m	= 0.;	/* Bruit de fond (moyenne)		*/
	lim->backgrd_noise_sd	= 0.;	/* Bruit de fond (sd)			*/
	lim->capacite   	= 1.;	/* Capacite pour le filtre	       	*/
	lim->resistance   	= 10.;	/* Resistance pour le filtre     	*/
	lim->filter_noise       = 0;    /* Bruit a la Kohn                      */
	
	/* reading the L unit file */

#if DEBUG_FILES
       	fprintf(stderr,"Entering Read_L_unit\n");
#endif

	
	if (fp = fopen(unit_L_name,"r"))	
	{
		while(fgets(buffer,255,fp))
		{
			sscanf(buffer,"%s %s",parametre,value);

			if (!strcmp(parametre,"RestPotential:"))	/* resting  potential	*/
				sscanf(value,"%f",&lim->rest_pot);
			
			if (!strcmp(parametre,"PostSpikePotential:"))	/* Pot mb post spike */
				sscanf(value,"%f",&(lim->pot_post_spike));
#if 0			
			if (!strcmp(parametre,"TimeStep:"))/* Time step */
			{
			        sscanf(value,"%f",&f_value);
				if (f_value < simu->time_step)
				      simu->time_step = f_value;
			}
#endif
			if (!strcmp(parametre,"TimeCsteMbPot:"))	/* cste de temps de la mb */
			{
				sscanf(value,"%f",&(lim->tau_mb_pot));
			} /* fin du if */
			
			if (!strcmp(parametre,"Threshold:"))		/* firing threshold par cluster */
				sscanf(value,"%f",&(lim->seuil));
			
			if (!strcmp(parametre,"Adaptation:"))		/* seuil apres un spike */
				sscanf(value,"%f",&(lim->seuil_post_spike));

			if (!strcmp(parametre,"TimeCsteThreshold:"))	/* cste de temps du seuil apres un spike */
			{
				sscanf(value,"%f",&(lim->tau_seuil));
			} /* fin du if */
			
			if (!strcmp(parametre,"EpspSize:"))		/* taille d'un epsp  */
				sscanf(value,"%f",&(lim->epsp));
			
			if (!strcmp(parametre,"IpspSize:"))		/* taille d'un ipsp  */
				sscanf(value,"%f",&(lim->ipsp));
			
			if (!strcmp(parametre,"NoiseMean:"))/* Bruit surajoute (moyenne) */
			{
				sscanf(value,"%f",&(lim->backgrd_noise_m));
			}
			if (!strcmp(parametre,"NoiseFilter:"))/* Bruit a la Kohn */
			{
				sscanf(value,"%hd",&(lim->filter_noise));

			}
			if (!strcmp(parametre,"Capacity:"))/* Bruit a la Kohn */
			{
				sscanf(value,"%f",&(lim->capacite));
			}
			if (!strcmp(parametre,"NoiseSd:"))/* Bruit surajoute (sd) */
			{
				sscanf(value,"%f",&(lim->backgrd_noise_sd));
			}
			if (!strcmp(parametre,"FilterResistance:"))/* Resistance du filtre */
			{
			        sscanf(value,"%f",&(lim->resistance));
			}
			if (!strcmp(parametre,"Fatigue:"))/* Fatigue du seuil */
			{
				sscanf(value,"%f",&(lim->fatigue));
			}
			if (!strcmp(parametre,"LessFatigue:"))/* Fatigue du seuil */
			{
				sscanf(value,"%hd",&(lim->less_fatigue));
			}
		} /* fin du while */
#if 0
		lim->tau_mb_pot = lim->tau_mb_pot / simu->time_step;
		lim->tau_seuil = lim->tau_seuil / simu->time_step;
#endif
		lim->i_tau_mb_pot = 1. - (simu->time_step / lim->tau_mb_pot);
		lim->i_tau_i_mb_pot = lim->rest_pot * (simu->time_step / lim->tau_mb_pot);

		lim->i_tau_seuil = 1. / lim->tau_seuil;	
		lim->tau_i_seuil = lim->tau_seuil;	

		lim->i_capacite = 1. / lim->capacite;
		lim->res_capa = lim->capacite * lim->resistance;

		lim->backgrd_n_sd = lim->backgrd_noise_sd * sqrt(simu->time_step); 
		lim->backgrd_n_m = lim->backgrd_noise_m * simu->time_step; 

		if(lim->backgrd_noise_sd || lim->backgrd_noise_m)
			lim->noise_active = True;
		else
			lim->noise_active = False;
		
		fclose(fp);
#if DEBUG_FILES
		fprintf(stderr,"Leaving Read_L_unit\n");
#endif

		return 0;
		
	} /* fin du if */
	else
	{
		free(sim_clusters[cluster_pos]->clu_data);
		sim_clusters[cluster_pos]->clu_data = NULL;
#if DEBUG_FILES
		fprintf(stderr,"Leaving Read_L_unit\n");
#endif
		return -1;
		
	} /* fin du else */

}
#if ADD_NEW_MODEL
/*************** TO ADD A MODEL COPY THIS AND ADAPT *************/
/*******************************************************************************
	Function for reading unit X file (model XUM)
*******************************************************************************/
int read_unit_X_file(char *unit_X_name,int cluster_pos)
{
	XUM *xum;
	FILE *fp;
	char parametre[256];
	char value[256];
	char buffer[256];
	
	xum = sim_clusters[cluster_pos]->clu_data = (XUM *)calloc(1,sizeof(XUM));
	
	/* default values */
	
	xum->rest_pot		= -70.;	/* resting  potential du cluster	*/
	xum->pot_post_spike	= -85.;	/* Pot mb post spike			*/

	/* .... */

	xum->backgrd_noise_m	= 0.;	/* Bruit de fond (moyenne)		*/
	xum->backgrd_noise_sd	= 0.;	/* Bruit de fond (sd)			*/
	xum->capacite   	= 5.;	/* Capacite de la mb			*/

	
	/* reading the X unit file */
	
	if (fp = fopen(unit_X_name,"r"))	
	{
		while(fgets(buffer,255,fp))
		{
			sscanf(buffer,"%s %s",parametre,value);
			
			if (!strcmp(parametre,"RestPotential:"))	/* resting  potential	*/
				sscanf(value,"%f",&xum->rest_pot);
			
			if (!strcmp(parametre,"PostSpikePotential:"))	/* Pot mb post spike */
				sscanf(value,"%f",&(xum->pot_post_spike));
			
			/* .... */

			if (!strcmp(parametre,"NoiseMean:"))/* Bruit surajoute (moyenne) */
			{
				sscanf(value,"%f",&(xum->backgrd_noise_m));
			}
			if (!strcmp(parametre,"NoiseSd:"))/* Bruit surajoute (sd) */
				sscanf(value,"%f",&(xum->backgrd_noise_sd));
			if (!strcmp(parametre,"TimeStep:"))/* Time step */
			{
			        sscanf(value,"%f",&f_value);
				if (f_value < simu->time_step)
				      simu->time_step = f_value;
			}
			
			if (!strcmp(parametre,"FilterResistance:"))/* Resistance du filtre */
				sscanf(value,"%f",&(xum->resistance));
			if (!strcmp(parametre,"Fatigue:"))/* Fatigue du seuil */
				sscanf(value,"%f",&(xum->fatigue));

		} /* fin du while */

		xum->i_capacite = 1./xum->capacite;
		xum->overshoot = - xum->rest_pot + xum->pot_post_spike;
		if(xum->backgrd_noise_sd || xum->backgrd_noise_m)
			xum->noise_active = True;
		else
			xum->noise_active = False;
		
		fclose(fp);
		return 0;
		
	} /* fin du if */
	else
	{
		free(sim_clusters[cluster_pos]->clu_data);
		sim_clusters[cluster_pos]->clu_data = NULL;
		return -1;
		
	} /* fin du else */

}
/************************ STOP **********************************/
#endif

/*******************************************************************************
	Function for reading unit B file (model BUM)
*******************************************************************************/
int read_unit_B_file(char *unit_B_name,int cluster_pos)
{
	BUM *bum;
	FILE *fp;
	float f_value;
	char parametre[256];
	char value[256];
	char buffer[256];
	
	bum = sim_clusters[cluster_pos]->clu_data = (BUM *)calloc(1,sizeof(BUM));
	
	/*
	 * Mise en place des valeurs par defauts. 
	 */
	bum->rest_pot	       = -70.;	/* resting  potential du cluster	*/
	bum->freq_spike	       = 20.;	/* Freq des spikes			*/
	bum->freq_max          = 150.;	/* freq maxima		*/
	bum->compose_fact      = 2.;	/* facteur de composition 		*/
	bum->duree_burst_min   = 50.;	/* duree min d un burst        	*/
	bum->duree_burst_max   = 150.;	/* duree max d un burst		*/
	bum->tau_mb_pot	       = 10.;	/* cste de temps de la mb		*/
	bum->seuil_burst       = -55.;	/* firing threshold par cluster		*/
	bum->pot_post_spike	= -85.;	/* Pot mb post spike			*/
	bum->seuil		= -60.;	/* firing threshold par cluster		*/
	bum->seuil_post_spike	= 0.;	/* seuil apres un spike			*/
	bum->E_K 		= -90.;	/* Potentiel d'equilibre du potassium	*/
	bum->E_Na		= 65.;	/* Potentiel d'equilibre du sodium	*/
	bum->rev_pot_pos	= 0.;	/* Reversal Potential positif (pour epsp)*/
	bum->rev_pot_neg	= -90.;	/* Resersal Potential negatif (pour ipsp)*/
	bum->tau_seuil		= 20.;	/* cste de temps du seuil apres un spike */
	bum->epsp		= 1.;	/* taille d'un psp (e ou i)		*/
	bum->tau_attack_epsp	= 2.;	/* conste de temps de montee		*/
	bum->tau_decay_epsp	= 5.;	/* conste de temps de descente		*/
	bum->ipsp		= 1.;	/* taille d'un psp (e ou i)		*/
	bum->tau_attack_ipsp	= 2.;	/* conste de temps de montee		*/
	bum->tau_decay_ipsp	= 5.;	/* conste de temps de descente		*/
	bum->shunt_tau		= 20.;	/* constante de temps du shunt de la mb */
	bum->backgrd_noise_m	= 0.;	/* Bruit de fond (moyenne)		*/
	bum->backgrd_noise_sd	= 0.;	/* Bruit de fond (sd)			*/
	bum->capacite   	= 1.;	/* Capacite pour le filtre	       	*/
	bum->resistance         = 10.;  /* resistance pour le filtre            */
	bum->filter_noise       = 0;    /* Bruit a la Kohn                      */

	bum->burst_range = bum->duree_burst_max - bum->duree_burst_min; 
	
	/* reading the B  unit file */
	
	if (fp = fopen(unit_B_name,"r"))	
	{
		while(fgets(buffer,255,fp))
		{
			sscanf(buffer,"%s %s",parametre,value);
			

			if (!strcmp(parametre,"RestPotential:"))	/* resting  potential	*/
				sscanf(value,"%f",&(bum->rest_pot));
#if 0
			if (!strcmp(parametre,"TimeStep:"))/* Time step */
			{
			        sscanf(value,"%f",&f_value);
				if (f_value < simu->time_step)
				      simu->time_step = f_value;
			}
#endif
			if (!strcmp(parametre,"SpikeFrequency:"))	/* Pot mb post spike */
				sscanf(value,"%f",&(bum->freq_spike));
			if (!strcmp(parametre,"MaxSpikeFrequency:"))	/* cste de temps de la mb */
				sscanf(value,"%f",&(bum->freq_max));
			if (!strcmp(parametre,"ComposeFact:"))		/* firing threshold par cluster */
				sscanf(value,"%f",&(bum->compose_fact));
			if (!strcmp(parametre,"MinBurstDuration:"))		/* seuil apres un spike */
				sscanf(value,"%f",&(bum->duree_burst_min));
			if (!strcmp(parametre,"MaxBurstDuration:"))		/* Potentiel d'equilibre du potassium */
				sscanf(value,"%f",&(bum->duree_burst_max));
			if (!strcmp(parametre,"Threshold:"))		/* seuil normal  */
				sscanf(value,"%f",&(bum->seuil));
			if (!strcmp(parametre,"ThresholdBurst:"))      	/* seuil burst  */
				sscanf(value,"%f",&(bum->seuil_burst));
			if (!strcmp(parametre,"EpspSize:"))		/* taille d'un epsp  */
				sscanf(value,"%f",&(bum->epsp));
			if (!strcmp(parametre,"IpspSize:"))		/* variabilite d'un epsp  */
				sscanf(value,"%f",&(bum->ipsp));
			if (!strcmp(parametre,"PostSpikePotential:"))	/* Pot mb post spike */
				sscanf(value,"%f",&(bum->pot_post_spike));
			if (!strcmp(parametre,"TimeCsteMbPot:"))	/* cste de temps de la mb */
			{
				sscanf(value,"%f",&(bum->tau_mb_pot));
			} /* fin du if */			
			if (!strcmp(parametre,"Threshold:"))		/* firing threshold par cluster */
				sscanf(value,"%f",&(bum->seuil));
			if (!strcmp(parametre,"Adaptation:"))		/* seuil apres un spike */
				sscanf(value,"%f",&(bum->seuil_post_spike));
			if (!strcmp(parametre,"E_K:"))		/* Potentiel d'equilibre du potassium */
				sscanf(value,"%f",&(bum->E_K));
			if (!strcmp(parametre,"E_Na:"))		/* Potentiel d'equilibre du sodium */
				sscanf(value,"%f",&(bum->E_Na));
			if (!strcmp(parametre,"PosReversalPot:"))	/* Reversal Potential positif (pour epsp) */
				sscanf(value,"%f",&(bum->rev_pot_pos));
			if (!strcmp(parametre,"NegReversalPot:"))	/* Resersal Potential negatif (pour ipsp) */
				sscanf(value,"%f",&(bum->rev_pot_neg));
			if (!strcmp(parametre,"TimeCsteThreshold:"))	/* cste de temps du seuil apres un spike */
			{
				sscanf(value,"%f",&(bum->tau_seuil));
			} /* fin du if */
			if (!strcmp(parametre,"EpspSize:"))		/* taille d'un epsp  */
				sscanf(value,"%f",&(bum->epsp));
			if (!strcmp(parametre,"EpspAttack:"))	/* conste de temps de montee */
			{
				sscanf(value,"%f",&(bum->tau_attack_epsp));
			} /* fin du if */
			if (!strcmp(parametre,"EpspDecay:"))	/* conste de temps de descente */
			{
				sscanf(value,"%f",&(bum->tau_decay_epsp));
			} /* fin du if */
			if (!strcmp(parametre,"IpspSize:"))		/* taille d'un ipsp  */
				sscanf(value,"%f",&(bum->ipsp));
			if (!strcmp(parametre,"IpspAttack:"))	/* conste de temps de montee */
			{
				sscanf(value,"%f",&(bum->tau_attack_ipsp));
			} /* fin du if */
			if (!strcmp(parametre,"IpspDecay:"))	/* conste de temps de descente */
			{
				sscanf(value,"%f",&(bum->tau_decay_ipsp));
			} /* fin du if */
			if (!strcmp(parametre,"MembraneShunt:"))/* constante de temps du shunt de la mb */
			{
				sscanf(value,"%f",&(bum->shunt_tau));
			}
			if (!strcmp(parametre,"NoiseMean:"))	/* Bruit de fond (moyenne) */
			{
				sscanf(value,"%f",&(bum->backgrd_noise_m));
			}
			if (!strcmp(parametre,"NoiseSd:"))/* Bruit surajoute (sd) */
			{
				sscanf(value,"%f",&(bum->backgrd_noise_sd));
			}
			if (!strcmp(parametre,"FilterResistance:"))/* Resistance du filtre */
			{
				sscanf(value,"%f",&(bum->resistance));
			}
			if (!strcmp(parametre,"Fatigue:"))/* Fatigue du seuil */
			{
				sscanf(value,"%f",&(bum->fatigue));
			}
			if (!strcmp(parametre,"LessFatigue:"))/* Fatigue du seuil */
			{
				sscanf(value,"%hd",&(bum->less_fatigue));
			}
			if (!strcmp(parametre,"NoiseFilter:"))/* Bruit a la Kohn */
			{
				sscanf(value,"%hd",&(bum->filter_noise));
			}
			if (!strcmp(parametre,"Capacity:"))/* Bruit a la Kohn */
			{
				sscanf(value,"%f",&(bum->capacite));
			}
		} /* fin du while */
#if 0
		bum->tau_mb_pot = bum->tau_mb_pot / simu->time_step;
		bum->tau_seuil = bum->tau_seuil / simu->time_step;
		bum->shunt_tau = bum->shunt_tau / simu->time_step;
		bum->tau_attack_epsp = bum->tau_attack_epsp / simu->time_step;	
		bum->tau_decay_epsp = bum->tau_decay_epsp / simu->time_step;	
		bum->tau_attack_ipsp = bum->tau_attack_ipsp / simu->time_step;	
		bum->tau_decay_ipsp = bum->tau_decay_ipsp / simu->time_step;	
#endif

		bum->i_tau_mb_pot = 1. / bum->tau_mb_pot;
		bum->i_tau_seuil = 1. / bum->tau_seuil;	

		bum->tau_i_mb_pot = bum->tau_mb_pot;
		bum->tau_i_seuil = bum->tau_seuil;	
		bum->shunt_i_tau = bum->shunt_tau;	

		bum->i_tau_attack_epsp = 1. / bum->tau_attack_epsp;	
		bum->i_tau_decay_epsp = 1. / bum->tau_decay_epsp;	
		bum->i_tau_attack_ipsp = 1. / bum->tau_attack_ipsp;	
		bum->i_tau_decay_ipsp = 1. / bum->tau_decay_ipsp;	

		bum->tau_a_epsp = bum->tau_attack_epsp;	
		bum->tau_d_epsp = bum->tau_decay_epsp;	
		bum->tau_a_ipsp = bum->tau_attack_ipsp;	
		bum->tau_d_ipsp = bum->tau_decay_ipsp;	

		bum->freq_b_spike = bum->freq_spike;	        /* Freq des spikes		*/
		bum->duree_b_min = bum->duree_burst_min;	/* duree min d un burst        	*/
		bum->duree_b_max = bum->duree_burst_max;	/* duree max d un burst		*/

		bum->i_capacite = 1. / bum->capacite;
		bum->res_capa = bum->capacite * bum->resistance;
		bum->overshoot = - bum->rest_pot + bum->pot_post_spike;

		bum->backgrd_n_sd = bum->backgrd_noise_sd * simu->time_step; 
		if(bum->backgrd_noise_sd || bum->backgrd_noise_m)
			bum->noise_active = True;
		else
			bum->noise_active = False;
		
		fclose(fp);
		return 0;
		
	} /* fin du if */
	else
	{
		free(sim_clusters[cluster_pos]->clu_data);
		sim_clusters[cluster_pos]->clu_data = NULL;
		return -1;
		
	} /* fin du else */

}
/*******************************************************************************
	Function for reading unit V file (external)
*******************************************************************************/
int read_unit_V_file(char *tms_name,int cluster_pos)
{
	VIRTUAL *tms;
	
	tms = sim_clusters[cluster_pos]->clu_data = (VIRTUAL *)calloc(1,sizeof(VIRTUAL));
	if(tms->fp_tms = fopen(tms_name,"r"))
		return 0;
	free(sim_clusters[cluster_pos]->clu_data);
	sim_clusters[cluster_pos]->clu_data = NULL;
	return -1;

}
/*******************************************************************************
	Function for reading unit G file (model CBM)
*******************************************************************************/
int read_unit_G_file(char *unit_G_name,int cluster_pos)
{
	CBM *cbm;
	FILE *fp;
	float f_value;
	int i;
	char parametre[256];
	char value[256];
	char buffer[256];

	cbm = sim_clusters[cluster_pos]->clu_data = (CBM *)calloc(1,sizeof(CBM));
	
	/* default values */

/*

  

*/	

    	cbm->soma_diam_m = 20.;
    	cbm->E_Ca = 184.;            /* potentiel d'equilibre du calcium */
	cbm->Na_ext = 150.;          /* concentration extracellulaire de sodium */
	cbm->Na_int = 15.;           /* concentration intracellulaire de sodium */
	cbm->K_ext = 5.5;             /* concentration extracellulaire de potassium */
	cbm->K_int = 100.;           /* concentration intracellulaire de potassium */
	cbm->Cl_ext = 125.;          /* concentration extracellulaire de Chlore */
	cbm->Cl_int = 9.;           /* concentration intracellulaire de Chlore */

	cbm->E_K = -72.;		/* potentiel d'equilibre du potassium */
	cbm->E_Na = 55.;		/* potentiel d'equilibre du sodium */
	cbm->E_Cl = -89.;		/* potentiel d'equilibre du chlore */
	cbm->E_H = -43.;		/* potentiel d'equilibre du courant H */
#if 0
	cbm->E_fuite = cbm->E_Goldman;         /* potentiel de fuite */
	cbm->rest_pot = cbm->E_fuite;    	/* potentiel de repos du neurone */
#endif
	cbm->rev_pot_pos = -10.;	/* potentiel de reversion positif */
	cbm->rev_pot_neg = -90.;	/* potentiel de reversion negatif */
	cbm->g_fuite = 0.3;		/* conductance du courant de fuite en S/cm2 */
	cbm->g_fuite_Na = 0;		/* conductance du courant de fuite Na en S/cm2 */
	cbm->g_fuite_K = 0;		/* conductance du courant de fuite K en S/cm2 */
	cbm->g_Na = 120.0;		/* conductance Na  en S/cm2 */
	cbm->g_K = 36.0;		/* conductance K en S/cm2 */
	cbm->g_Ca = 1.0;		/* conductance Ca */
	cbm->g_Cl = 0.;			/* conductance Cl */
	cbm->g_A = 0.;			/* conductance K pour Ia */
	cbm->g_M = 0.;			/* conductance K pour Im */
	cbm->g_C = 0.;			/* conductance K pour Ic */
	cbm->g_ahp = 0.;		/* conductance K pour Iahp */
	cbm->g_Nap = 0.;		/* conductance K pour INap */
	cbm->g_Cab = 0.;		/* conductance K pour ICab */
	cbm->g_H = 0.;			/* conductance K pour Ih */
	cbm->g_Syn_pos = 0.05;		/* conductance synaptique*/
	cbm->g_Syn_neg = 0.05;		/* conductance synaptique*/
	cbm->capacite = 1.0;		/* capacite de la membrane en F/cm2 */
	cbm->tau_attack_epsp = 2.5;	/* constante de temps de montee du epsp */
	cbm->tau_decay_epsp = 10.;	/* constante de temps de descente du epsp */
	cbm->tau_attack_ipsp = 2.5;	/* constante de temps de montee du ipsp */
	cbm->tau_decay_ipsp = 10.;	/* constante de temps de descente du ipsp */
	cbm->spike_slope = 20.;		/* Detecteur de spikes mV/ms */
	cbm->g_NMDA = 1.8;		/* conductance des canaux NMDA sensibles en S*/
	cbm->tau_attack_NMDA = 80.;	/* cste montee NMDA en ms*/
	cbm->tau_decay_NMDA = 0.66;	/* cste descente NMDA en ms*/
	cbm->eta_NMDA = 0.33;		/* coefficient de dependance de G_NMDA a la
					concentration extracellulaire en Mg++ en mM-1*/
	cbm->gamma_NMDA = 0.06;		/* coefficient reliant G_NMDA et Vm en mV-1*/
	cbm->magnesium = 1.;		/* concentration extracellulaire en Mg++ */
	cbm->rev_pot_NMDA = 0.;		/* potentiel de reversion du NMDA */
	cbm->Ca_Influx = 0.00015;	/* Vitesse d'entree du calcium */
	cbm->Ca_Removal = 0.005;	/* Vitesse de sortie du calcium */
	cbm->Ca_Kd = 1.;		/* Constante de dissociation du calcium */

	cbm->K_Ca_Kd = 0.5;		/* Constante de dissociation du calcium pour I_K */
	cbm->lambda_Ik = .081;		/* Constante dependant de la temperature */
	cbm->lambda_Ic = 5.;		/* Constante dependant de la temperature */
	cbm->lambda_Im = 0.003;		/* Constante dependant de la temperature */
	cbm->lambda_Inap = 0.1;		/* Constante dependant de la temperature */
	cbm->lambda_Icab = 0.005;	/* Constante dependant de la temperature */
	cbm->lambda_Ih = 0.0005;	/* Constante dependant de la temperature */
	cbm->tau_m_cab = 10.0;		/* cste de temps m Icab */
	cbm->tau_Ca_init = 5.0;		/* cste de temps m Icab */
	cbm->Ca_i_init = 0.0001;
	cbm->K_ext_init = 4.;           /* concentration en potassium extracellulaire en mMol*/
	cbm->m_ahp_init = 0.;
	cbm->m_Nap_init = 0.;
	cbm->m_Cab_init = 0.;
	cbm->m_Ih_init = 0.;
	cbm->h_Cab_init = 0.;
	cbm->m_K_init = .16;
	cbm->m_Ca_init = .001;
	cbm->h_A_init = .05;
			/*
			 * variable globales pour la sigmoide
			 * d'activation/inactivation
			 */

	cbm->V_Na = -31.;		/* V 1/2 pour la Na */
	cbm->A_Na = .0651;		/* coeff a pour le Na */
	cbm->Pow_Na = 3.;		/* Exposant pour le Na */
	cbm->V_K = -46.;		/* V 1/2 pour la K */
	cbm->A_K = .0551;		/* coeff a pour le K */
	cbm->Pow_K = 4.;		/* Exposant pour le K */
	cbm->V_Ca = -40.;		/* V 1/2 pour la Ca */
	cbm->A_Ca = .2;			/* coeff a pour le Ca */
	cbm->Pow_Ca = 2.;		/* Exposant pour le Ca */
	cbm->Tau_Ca = 50.;		/* Cste de temps pour le Ca */
	cbm->V_Ia_A = -20.;		/* V 1/2 pour Ia activation */
	cbm->A_Ia_A = .021;		/* coeff a pour Ia activation */
	cbm->Pow_Ia_A = 1.;		/* Exposant pour Ia activation */
	cbm->V_Ia_B = -70.;		/* V 1/2 pour Ia inactivation */
	cbm->A_Ia_B = -0.1;		/* coeff a pour Ia inactivation */
	cbm->Pow_Ia_B = 1.;		/* Exposant pour Ia inactivation */
	cbm->Tau_Ia_B = 10.;		/* Cste de temps pour Ia inactivation */
	cbm->V_Im = -35.;		/* V 1/2 pour Im  (potentiel du point d'inflexion) */
	cbm->A_Im = 0.05;		/* coeff a pour Im (pente de la sigmoide) */
	cbm->V_Ic = -90.;		/* V 1/2 pour Ic (potentiel du point d'inflexion) */
	cbm->A_Ic = 0.05;		/* coeff a pour Ic (pente de la sigmoide) */
	cbm->V_Inap = -56.;		/* V 1/2 pour Inap (potentiel du point d'inflexion) */
	cbm->A_Inap = 0.07;		/* coeff a pour Inap (pente de la sigmoide) */
	cbm->Vm_Icab = -45.;		/* V 1/2 pour m Icab (potentiel du point d'inflexion) */
	cbm->Am_Icab = 0.1;		/* coeff a pour h Icab (pente de la sigmoide) */
	cbm->Vh_Icab = -70.;		/* V 1/2 pour h Icab (potentiel du point d'inflexion) */
	cbm->Ah_Icab = 0.1;		/* coeff a pour h Icab (pente de la sigmoide) */
	cbm->Pow_m_cab = 3.;		/* Exposant pour le Ca LVA */
	cbm->V_Ih = -75.;		/* V 1/2 pour Ih (potentiel du point d'inflexion) */
	cbm->A_Ih = -0.09;		/* coeff a pour Ih (pente de la sigmoide) */

  
	cbm->A_INa_A = .056;		/* coeff a pour le Na */
	cbm->A_INa_B = -0.04;	/* coeff a pour Ia inactivation */
	cbm->Tau_INa_B = 1.;
	cbm->Tau_INa_A = 3.;
	cbm->Pow_INa_A = 3.;
	cbm->Pow_INa_B = 1.;
	cbm->V_INa_A = -31;
	cbm->V_INa_B = -59;

	cbm->resistance   	= 10.;	/* Resistance pour le filtre     	*/
	cbm->filter_noise   	= 0;	/* Bruit a la Kohn     	                */

	cbm->backgrd_noise_m = 0.;	/* bruit de fond */
	cbm->backgrd_noise_sd = 0.;
	cbm->K_rest = 2.5;
	simu->Temp = 20.;               /* Temperature de la manip */

	/* reading the G unit file */
	
	if (fp = fopen(unit_G_name,"r"))	
	{
		while(fgets(buffer,255,fp))
		{
			sscanf(buffer,"%s %s",parametre,value);

			if (!strcmp (parametre, "Model_Type:"))
			{
				 cbm->model_type = HH_FULL_MODEL;
			         if (!strcmp (value, "Michaelis_Menton"))
				 {
				   cbm->model_type = MICHAELIS_MENTON_MODEL;
				 }
			         if (!strcmp (value, "Hodgkin_Huxley_Simple"))
				 {
				   cbm->model_type = HH_SIMPLE_MODEL;
				 }
			         if (!strcmp (value, "Hodgkin_Huxley_Full"))
				 {
				   cbm->model_type = HH_FULL_MODEL;
				 }
			         if (!strcmp (value, "Hodgkin_Huxley_with_pump"))
				 {
				   cbm->model_type = HH_PUMP_MODEL;
				   strcpy(buffer,"Only Michaelis Menton and HH models supported yet");
				   display_error(widget_array[ID_sim_mainW],buffer,
						 "Model type error");
				   free(sim_clusters[cluster_pos]->clu_data);
				   sim_clusters[cluster_pos]->clu_data = NULL;
				   return -1;
				 }
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new model */
				 if (!strcmp (value, "New_Model"))
				 {
				   cbm->model_type = NEW_MODEL;
				 }
#endif
			}
			if (!strcmp (parametre, "Integration:"))
			{
				 cbm->integration_type = EXPONENTIELLE;
			         if (!strcmp (value, "Exponentielle"))
				 {
				   cbm->integration_type = EXPONENTIELLE;
				 }
#ifdef ADD_INTEGRATION_METHOD
/* Adapt here with the new model */
			         if (!strcmp (value, "Autre"))
				 {
				   cbm->integration_type = AUTRE;
				 }
#endif
			         else
				 {
					/* RUNGE_KUTTA 
					   EULER */
					     strcpy(buffer,"Only Exponential method supported yet");
					     display_error(widget_array[ID_sim_mainW],buffer,
							   "Integration method error");
					     free(sim_clusters[cluster_pos]->clu_data);
					     sim_clusters[cluster_pos]->clu_data = NULL;
					     return -1;
				 }
			}
			if (!strcmp (parametre, "diametre:"))	/* rem: le diametre doit etre lu en premier */
			{
				cbm->soma_diam_m = atof(value);
			} 
			if (!strcmp (parametre, "Temp:"))
			{
				simu->Temp = atof(value);
			}
			if (!strcmp (parametre, "E_fuite:"))
			{
				cbm->E_fuite = atof(value);
			}
			if (!strcmp (parametre, "E_K:"))
			{
				cbm->E_K = atof(value);
			}
			if (!strcmp (parametre, "E_Na:"))
			{
				cbm->E_Na = atof(value);
			}
			if (!strcmp(parametre,"K_ext:"))		/* Potassium extra cell */
			{
			        cbm->K_ext = atof(value);
			}
			if (!strcmp(parametre,"K_int:"))		/* Potassium intra cell */
			{
			        cbm->K_int = atof(value);
			}
			if (!strcmp(parametre,"Na_ext:"))		/* Sodium extra cell*/
			{
			        cbm->Na_ext = atof(value);
			}
			if (!strcmp(parametre,"Na_int:"))		/* Sodium intra cell*/
			{
			        cbm->Na_int = atof(value);
			}
			if (!strcmp (parametre, "E_Ca:"))
			{
				cbm->E_Ca = atof (value);
			}
			if (!strcmp (parametre, "E_H:"))
			{
				cbm->E_H = atof (value);
			}
			if (!strcmp (parametre, "E_Cl:"))
			{
				cbm->E_Cl = atof (value);
			} /* fin du if */
			if (!strcmp (parametre, "PosReversalPot:"))
			{
				cbm->rev_pot_pos = atof(value);
			}
			if (!strcmp (parametre, "NegReversalPot:"))
			{
				cbm->rev_pot_neg = atof (value);
			}
			if (!strcmp (parametre, "spike_slope:"))
			{
				cbm->spike_slope = atof (value);
				/* sinon, on ne declenche pas !! */
				if (cbm->spike_slope > 500.)
					cbm->spike_slope = 20.;
			}
			if (!strcmp (parametre, "g_K:"))
			{
				cbm->g_K = atof (value);
			}
			if (!strcmp (parametre, "g_Na:"))
			{
				cbm->g_Na = atof(value);
			}
			if (!strcmp (parametre, "g_Nap:"))
			{
				cbm->g_Nap = atof(value);
			}
			if (!strcmp (parametre, "g_Ca:"))
			{
				cbm->g_Ca = atof(value);
			}
			if (!strcmp (parametre, "g_Cab:"))
			{
				cbm->g_Cab = atof(value);
			}
			if (!strcmp (parametre, "g_Cl:"))
			{
				cbm->g_Cl = atof (value);
			} /* fin du if */
			if (!strcmp (parametre, "g_A:"))
			{
				cbm->g_A = atof (value);
			}
			if (!strcmp (parametre, "g_M:"))
			{
				cbm->g_M = atof (value);
			}
			if (!strcmp (parametre, "g_C:"))
			{
				cbm->g_C = atof (value);
			}
			if (!strcmp (parametre, "g_ahp:"))
			{
				cbm->g_ahp = atof (value);
			}
			if (!strcmp (parametre, "g_H:"))
			{
				cbm->g_H = atof (value);
			}
			if (!strcmp (parametre, "g_fuite:"))
			{
				cbm->g_fuite = atof (value);
			}
			if (!strcmp (parametre, "g_fuite_Na:"))
			{
				cbm->g_fuite_Na = atof (value);
			}
			if (!strcmp (parametre, "g_fuite_K:"))
			{
				cbm->g_fuite_K = atof (value);
			}
			if (!strcmp (parametre, "g_Syn_pos:"))
			{
				cbm->g_Syn_pos = atof (value);
			}
			if (!strcmp (parametre, "g_Syn_neg:"))
			{
				cbm->g_Syn_neg = atof (value);
			}
			if (!strcmp (parametre, "capacite:"))
			{
				cbm->capacite = atof (value);
			}
			if (!strcmp (parametre, "tau_attack_epsp:"))
			{
				cbm->tau_attack_epsp = atof (value);
			}
			if (!strcmp (parametre, "tau_decay_epsp:"))
			{
				cbm->tau_decay_epsp = atof (value);
			}
			if (!strcmp (parametre, "tau_attack_ipsp:"))
			{
				cbm->tau_attack_ipsp = atof (value);
			}
			if (!strcmp (parametre, "tau_decay_ipsp:"))
			{
				cbm->tau_decay_ipsp = atof (value);
			}
			if (!strcmp (parametre, "NoiseMean:"))
			{
				cbm->backgrd_noise_m = atof (value);
			}
			if (!strcmp (parametre, "NoiseSd:"))
			{
				cbm->backgrd_noise_sd = atof (value);
			}
			if (!strcmp (parametre, "Ca_i:"))
			{
				cbm->Ca_i_init = atof (value);
			} /* fin du if */
			if (!strcmp (parametre, "K_ext_init:"))
			{
				cbm->K_ext_init = atof (value);
			} /* fin du if */
			if (!strcmp (parametre, "magnesium:"))
			{
				cbm->magnesium = atof(value);
			} 
			if (!strcmp (parametre, "g_NMDA:"))
			{
				cbm->g_NMDA = atof(value);
			}
			if (!strcmp (parametre, "rev_pot_NMDA:"))
			{
				cbm->rev_pot_NMDA = atof(value);
			} 
			if (!strcmp (parametre, "eta_NMDA:"))
			{
				cbm->eta_NMDA = atof(value);
			}
			if (!strcmp (parametre, "gamma_NMDA:"))
			{
				cbm->gamma_NMDA = atof(value);
			} 
			if (!strcmp (parametre, "tau_attack_NMDA:"))
			{
				cbm->tau_attack_NMDA = atof(value);
			} 
			if (!strcmp (parametre, "tau_decay_NMDA:"))
			{
				cbm->tau_decay_NMDA = atof(value);
			} 
			if (!strcmp(parametre, "Ca_Influx:"))	
				sscanf(value,"%f",&(cbm->Ca_Influx));

			if (!strcmp(parametre, "Ca_Removal:"))  
				sscanf(value,"%f",&(cbm->Ca_Removal));

			if (!strcmp(parametre, "Ca_Kd:"))  
				sscanf(value,"%f",&(cbm->Ca_Kd));

			if (!strcmp(parametre, "K_Ca_Kd:"))  
				sscanf(value,"%f",&(cbm->K_Ca_Kd));

			if (!strcmp(parametre, "lambda_Ik:"))  /* Constante dependant de la temperature */
				sscanf(value,"%f",&(cbm->lambda_Ik));

			if (!strcmp(parametre, "lambda_Ic:"))  /* Constante dependant de la temperature */
				sscanf(value,"%f",&(cbm->lambda_Ic));

			if (!strcmp(parametre, "lambda_Im:"))  /* Constante dependant de la temperature */
				sscanf(value,"%f",&(cbm->lambda_Im));

			if (!strcmp(parametre, "V_Na:")) /* V 1/2 pour le Na */
				sscanf(value,"%f",&(cbm->V_Na));
				
			if (!strcmp(parametre, "A_Na:")) /* coeff a pour le Na */
				sscanf(value,"%f",&(cbm->A_Na));
				
			if (!strcmp(parametre, "Pow_Na:")) /* Exposant pour le Na */
				sscanf(value,"%f",&(cbm->Pow_Na));
				
			if (!strcmp(parametre, "V_K:")) /* V 1/2 pour la K */
				sscanf(value,"%f",&(cbm->V_K));
				
			if (!strcmp(parametre, "A_K:")) /* coeff a pour le K */
				sscanf(value,"%f",&(cbm->A_K));
				
			if (!strcmp(parametre, "Pow_K:")) /* Exposant pour le K */
				sscanf(value,"%f",&(cbm->Pow_K));
				
			if (!strcmp(parametre, "V_Ca:")) /* V 1/2 pour la Ca */
				sscanf(value,"%f",&(cbm->V_Ca));
				
			if (!strcmp(parametre, "A_Ca:")) /* coeff a pour le Ca */
				sscanf(value,"%f",&(cbm->A_Ca));
				
			if (!strcmp(parametre, "Pow_Ca:")) /* Exposant pour le Ca */
				sscanf(value,"%f",&(cbm->Pow_Ca));
				
			if (!strcmp(parametre, "Tau_Ca:")) /* Cste de temps pour le Ca */
				sscanf(value,"%f",&(cbm->Tau_Ca));
				
			if (!strcmp(parametre, "V_Ia_A:")) /* V 1/2 pour Ia activation */
				sscanf(value,"%f",&(cbm->V_Ia_A));
				
			if (!strcmp(parametre, "A_Ia_A:")) /* coeff a pour Ia activation */
				sscanf(value,"%f",&(cbm->A_Ia_A));
				
			if (!strcmp(parametre, "Pow_Ia_A:")) /* Exposant pour Ia activation */
				sscanf(value,"%f",&(cbm->Pow_Ia_A));
				
			if (!strcmp(parametre, "V_Ia_B:")) /* V 1/2 pour Ia inactivation */
				sscanf(value,"%f",&(cbm->V_Ia_B));
				
			if (!strcmp(parametre, "A_Ia_B:")) /* coeff a pour Ia inactivation */
				sscanf(value,"%f",&(cbm->A_Ia_B));
				
			if (!strcmp(parametre, "Pow_Ia_B:")) /* Exposant pour Ia inactivation */
				sscanf(value,"%f",&(cbm->Pow_Ia_B));
				
			if (!strcmp(parametre, "Tau_Ia_B:")) /* Cste de temps pour Ia inactivation */
				sscanf(value,"%f",&(cbm->Tau_Ia_B));

			if (!strcmp(parametre, "V_Ic:")) /* V 1/2 pour Ia inactivation */
				sscanf(value,"%f",&(cbm->V_Ic));
				
			if (!strcmp(parametre, "A_Ic:")) /* coeff a pour Ia inactivation */
				sscanf(value,"%f",&(cbm->A_Ic));
				
			if (!strcmp(parametre, "V_Im:")) /* V 1/2 pour Ia inactivation */
				sscanf(value,"%f",&(cbm->V_Im));
				
			if (!strcmp(parametre, "A_Im:")) /* coeff a pour Ia inactivation */
				sscanf(value,"%f",&(cbm->A_Im));

			if (!strcmp(parametre, "V_Inap:")) /* V 1/2 pour Inap inactivation */
				sscanf(value,"%f",&(cbm->V_Inap));
				
			if (!strcmp(parametre, "A_Inap:")) /* coeff a pour Inap inactivation */
				sscanf(value,"%f",&(cbm->A_Inap));

			if (!strcmp(parametre, "Vm_Icab:")) /* V 1/2 pour Icab activation */
				sscanf(value,"%f",&(cbm->Vm_Icab));
				
			if (!strcmp(parametre, "Am_Icab:")) /* coeff a pour Icab activation */
				sscanf(value,"%f",&(cbm->Am_Icab));

			if (!strcmp(parametre, "Vh_Icab:")) /* V 1/2 pour Icab inactivation */
				sscanf(value,"%f",&(cbm->Vh_Icab));
				
			if (!strcmp(parametre, "Ah_Icab:")) /* coeff a pour Icab inactivation */
				sscanf(value,"%f",&(cbm->Ah_Icab));

			if (!strcmp(parametre, "lambda_Inap:"))  /* Constante dependant de la temperature */
				sscanf(value,"%f",&(cbm->lambda_Inap));

			if (!strcmp(parametre, "lambda_Icab:"))  /* Constante dependant de la temperature */
				sscanf(value,"%f",&(cbm->lambda_Icab));

			if (!strcmp(parametre, "Tau_m_Cab:")) /* Cste de temps pour Ia inactivation */
				sscanf(value,"%f",&(cbm->tau_m_cab));

			if (!strcmp(parametre, "K_rest:")) /* * Potatium au repos */
				sscanf(value,"%f",&(cbm->K_rest));

			if (!strcmp(parametre, "V_Ih:")) /* V 1/2 pour Ih inactivation */
				sscanf(value,"%f",&(cbm->V_Ih));
				
			if (!strcmp(parametre, "A_Ih:")) /* coeff a pour Ih inactivation */
				sscanf(value,"%f",&(cbm->A_Ih));
				
			if (!strcmp(parametre, "lambda_Ih:"))  /* Constante dependant de la temperature */
				sscanf(value,"%f",&(cbm->lambda_Ih));

			if (!strcmp(parametre, "A_INa_A:"))
			  sscanf(value,"%f",&(cbm->A_INa_A));
			if (!strcmp(parametre, "A_INa_B:"))
			  sscanf(value,"%f",&(cbm->A_INa_B));
			if (!strcmp(parametre, "Tau_INa_A:"))
			  sscanf(value,"%f",&(cbm->Tau_INa_A));
			if (!strcmp(parametre, "Tau_INa_B:"))
			  sscanf(value,"%f",&(cbm->Tau_INa_B));
			if (!strcmp(parametre, "Pow_INa_A:"))
			  sscanf(value,"%f",&(cbm->Pow_INa_A));
			if (!strcmp(parametre, "Pow_INa_B:"))
			  sscanf(value,"%f",&(cbm->Pow_INa_B));
			if (!strcmp(parametre, "V_INa_A:"))
			  sscanf(value,"%f",&(cbm->V_INa_A));
			if (!strcmp(parametre, "V_INa_B:"))
			  sscanf(value,"%f",&(cbm->V_INa_B));

			/*  Initialisations */

			if (!strcmp(parametre, "m_ahp_init:"))
			  sscanf(value,"%f",&(cbm->m_ahp_init));
			if (!strcmp(parametre, "m_K_init:"))
			  sscanf(value,"%f",&(cbm->m_K_init));
			if (!strcmp(parametre, "le_potentiel_init:"))
			  sscanf(value,"%f",&(cbm->le_potentiel_init));			
			if (!strcmp(parametre, "le_potentiel_E_Na_init:"))
			  sscanf(value,"%f",&(cbm->le_potentiel_E_Na_init));
			if (!strcmp(parametre, "le_potentiel_E_K_init:"))
			  sscanf(value,"%f",&(cbm->le_potentiel_E_K_init));

			if (!strcmp(parametre, "m_Ca_init:"))
			  sscanf(value,"%f",&(cbm->m_Ca_init));
			if (!strcmp(parametre, "Ca_i_init:"))
			  sscanf(value,"%f",&(cbm->Ca_i_init));
			if (!strcmp(parametre, "h_A_init:"))
			  sscanf(value,"%f",&(cbm->h_A_init));
			if (!strcmp(parametre, "h_Na_init:"))
			  sscanf(value,"%f",&(cbm->h_Na_init));
			if (!strcmp(parametre, "m_Nap_init:"))
			  sscanf(value,"%f",&(cbm->m_Nap_init));
			if (!strcmp(parametre, "m_Cab_init:"))
			  sscanf(value,"%f",&(cbm->m_Cab_init));
			if (!strcmp(parametre, "m_Ih_init:"))
			  sscanf(value,"%f",&(cbm->m_Ih_init));
			if (!strcmp(parametre, "h_Cab_init:"))
			  sscanf(value,"%f",&(cbm->h_Cab_init));

			if (!strcmp(parametre, "Nb_receptors:"))
			{
			        sscanf(value,"%d",&(cbm->nb_receptors));

				for (i= 0; i < cbm->nb_receptors; i++)
				{
				  fgets(buffer,80,fp);

				  fgets(buffer,80,fp);
				  sscanf(buffer, "%s %s", parametre, value);
				  if (!strcmp(parametre, "Receptor_tau_attack:"))
				     sscanf(value,"%f",&(cbm->Receptors[i].tau_attack));

				  fgets(buffer,80,fp);
				  sscanf(buffer, "%s %s", parametre, value);
				  if (!strcmp(parametre, "Receptor_tau_decay:"))
				     sscanf(value,"%f",&(cbm->Receptors[i]).tau_decay);

				  fgets(buffer,80,fp);
				  sscanf(buffer, "%s %s", parametre, value);
				  if (!strcmp(parametre, "Receptor_tau_a_psp:"))
				     sscanf(value,"%f",&(cbm->Receptors[i]).tau_a_psp);

				  fgets(buffer,80,fp);
				  sscanf(buffer, "%s %s", parametre, value);
				  if (!strcmp(parametre, "Receptor_tau_d_psp:"))
				     sscanf(value,"%f",&(cbm->Receptors[i]).tau_d_psp);

				  fgets(buffer,80,fp);
				  sscanf(buffer, "%s %s", parametre, value);
				  if (!strcmp(parametre, "Receptor_g_Syn:"))
				     sscanf(value,"%f",&(cbm->Receptors[i]).g_Syn);

				  fgets(buffer,80,fp);
				  sscanf(buffer, "%s %s", parametre, value);
				  if (!strcmp(parametre, "Receptor_rev_pot:"))
				     sscanf(value,"%f",&(cbm->Receptors[i]).rev_pot);

				  fgets(buffer,80,fp);
				  sscanf(buffer, "%s %s", parametre, value);
				  if (!strcmp(parametre, "Receptor_transmittor:"))
				     sscanf(value,"%d",&(cbm->Receptors[i]).transmetteur);

				  fgets(buffer,80,fp);
				  sscanf(buffer, "%s %s", parametre, value);
				  if (!strcmp(parametre, "Receptor_num_transm:"))
				     sscanf(value,"%d",&(cbm->Receptors[i]).num_transm);

				  fgets(buffer,80,fp);
				  sscanf(buffer, "%s %s", parametre, value);
				  if (!strcmp(parametre, "Receptor_nom:"))
				     sscanf(value,"%s",&(cbm->Receptors[i]).nom);

				}
			}
			if (!strcmp(parametre, "Axone_transmittor:"))
				sscanf(value,"%d",&(cbm->neurotransmitor));

#ifdef ADD_CURRENT

/*--------   To add a current modify and adapt   -------*/   

			if (!strcmp(parametre, "m_INew_init:"))
			  sscanf(value,"%f",&(m_INew_init));
			if (!strcmp(parametre, "h_INew_init:"))
			  sscanf(value,"%f",&(h_INew_init));
#endif
		}
#if 0
		cbm->i_tau_attack_epsp = 1. / cbm->tau_attack_epsp;	
		cbm->i_tau_decay_epsp = 1. / cbm->tau_decay_epsp;	
		cbm->i_tau_attack_ipsp = 1. / cbm->tau_attack_ipsp;	
		cbm->i_tau_decay_ipsp = 1. / cbm->tau_decay_ipsp;	

		cbm->tau_a_epsp = cbm->tau_attack_epsp;	
		cbm->tau_d_epsp = cbm->tau_decay_epsp;	
		cbm->tau_a_ipsp = cbm->tau_attack_ipsp;	
		cbm->tau_d_ipsp = cbm->tau_decay_ipsp;	
#endif


		cbm->tau_a_NMDA = cbm->tau_attack_NMDA;
		cbm->tau_d_NMDA = cbm->tau_decay_NMDA;

		cbm->i_capacite = 1. / cbm->capacite;
		cbm->res_capa = cbm->capacite * cbm->resistance;

		if(cbm->backgrd_noise_sd || cbm->backgrd_noise_m)
			cbm->noise_active = True;
		else
			cbm->noise_active = False;

		
		fclose(fp);
		return 0;
		/* return 0  when G unit file has been successfully read */
		
	} /* fin du if */
	else
	{
		free(sim_clusters[cluster_pos]->clu_data);
		sim_clusters[cluster_pos]->clu_data = NULL;
		return -1;
		/* return -1  when G unit file has not been successfully read */
	} /* fin du else */


}
/*------------------------------------------------------------
 *	I N I T _ G _ N E U R O N
 *------------------------------------------------------------*/
void init_G_neuron(int pos)
{
	CBM *cbm;
	CBM_DYNAMIC *cbm_dyn;
	
	cbm = (CBM *)sim_neurons[pos]->its_cluster->clu_data;
	cbm_dyn = (CBM_DYNAMIC *)sim_neurons[pos]->neuron_data;

	/* Calcul des potentiels d equilibre */
/*
	cbm->E_K = R * (simu->Temp + 273.15) / (ZF) *
			log( cbm->K_ext / cbm->K_int);
  
	cbm->E_Na = R * (simu->Temp + 273.15) / (ZF) *
			log( cbm->Na_ext / cbm->Na_int);

	cbm->E_K = -89.;
  
	cbm->E_Na = 57.;

*/
/*	cbm->E_Na = cbm->le_potentiel_E_Na_init;
	cbm->E_K = cbm->le_potentiel_E_K_init;
*/

	cbm->K_ext = cbm->K_ext_init;/* concentration en potassium extracellulaire en mMol*/

	if (cbm->model_type == HH_SIMPLE_MODEL)
	{
		reactualise_E_Na_K_simple(cbm); 
	}
	else
	{
		reactualise_E_Na_K(cbm); 
	}	
	/* initialisation des variables d'ouverture et de fermeture des canaux */

	cbm_dyn->soma =  cbm->rest_pot = cbm->le_potentiel_init = cbm->E_Goldman;
	cbm_dyn->Ca_i = cbm->Ca_i_init;
	cbm_dyn->m_ahp = cbm->m_ahp_init;
	cbm_dyn->m_Nap = cbm->m_Nap_init;
	cbm_dyn->m_Cab = cbm->m_Cab_init;
	cbm_dyn->m_Ih = cbm->m_Ih_init;
	cbm_dyn->h_Cab = cbm->h_Cab_init;
	cbm_dyn->m_K = cbm->m_K_init;
	cbm_dyn->m_Ca = cbm->m_Ca_init;
	cbm_dyn->h_Na = cbm->h_Na_init;
	cbm_dyn->h_A = cbm->h_A_init;

	cbm_dyn->m_M = 1. / (1. + (exp ((cbm->E_fuite + cbm->V_Im) * cbm->A_Im)));

	if((cbm_dyn->Ca_i == 0.0001) || (cbm->E_fuite < -32.))
		cbm_dyn->m_C = 0.;
	else
		cbm_dyn->m_C = (250. * cbm_dyn->Ca_i * exp (cbm->E_fuite/24.)) /
			((250. * cbm_dyn->Ca_i * exp (cbm->E_fuite/24.)) +
			(0.1 * exp (cbm->E_fuite/(-24.))));

        cbm_dyn->surface = 4 * M_PI * (0.5 * cbm->soma_diam_m * 1e-4) * (0.5 * cbm->soma_diam_m * 1e-4);
        cbm_dyn->surface_normalisee = cbm_dyn->surface / (4 * M_PI * (0.5 * 20. * 1e-4) * (0.5 * 20. * 1e-4));
	cbm_dyn->e_K = cbm->E_K;	/* Pot equil K si [K] change */
	cbm_dyn->e_Na = cbm->E_Na;	/* Pot equil Na si [Na] change */
	cbm_dyn->e_fuite = cbm->E_fuite;	/* Potentiel de repos */
#if 0
	cbm_dyn->K_ext = cbm->K_ext;	/* Concentration K si [K] change */
	cbm_dyn->K_int = cbm->K_int;	/* Concentration K si [K] change */
	cbm_dyn->Na_ext = cbm->Na_ext;	/* Concentration Na si [Na] change */
	cbm_dyn->Na_int = cbm->Na_int;	/* Concentration Na si [Na] change */
#endif
	cbm_dyn->tau_Ca = cbm->tau_Ca_init / simu->time_step;		/* constante de temps de g_Ca */
	cbm->K_rest = 2.5;

} /* fin du void */


/*--------------------------------------------------------------------------
 *	I D E N T I F Y _ C L U S T E R
 *-------------------------------------------------------------------------*/ 
CLUSTER *identify_cluster(int cluster_id)
{
	int i,j;
	
	for(i=0 ; i<simu->nb_clusters ; i++)
	{
		for(j=0 ; j<clu_index[i].nb_refs ; j++)
		{
			if(cluster_id == clu_index[i].refs[j])
			{
				sim_clusters[i]->cluster_size++;
				return (CLUSTER *)sim_clusters[i];
			}
		}
	}
	return(NULL);
}

/*-----------------------------------------------------------------------------
 *	W H I C H _ N E U R O N
 *--------------------------------------------------------------------------*/
int which_neuron(int id)
{
	int i;
	
	for(i=0 ; i<simu->nb_neurons ; i++)
	{
		if(sim_neurons[i]->id == id)
			return i;
	}
	return (-1);
}

/*-----------------------------------------------------------------------------
 *	R E A R R A N G E _ S I M _ F I L E
 *--------------------------------------------------------------------------*/
int rearrange_sim_file(void)
{
        int i, j, k;
	FILE *tmp_fp;
	char tmp_name[256];
	char buffer[256];

	if ((sim_fp = fopen(simu->sim_name,"r")) == NULL)
	{
		sprintf(buffer,"Sorry, can't open %s \n(insufficient privilege ?)...",
				simu->sim_name);
		display_error(widget_array[ID_sim_mainW],buffer,"Read Error !");
		return (0);
	}
	strcpy(tmp_name,simu->sim_name);
	strcat(tmp_name,"_tmp");
	if ((tmp_fp = fopen(tmp_name,"w")) == NULL)
	{
		sprintf(buffer,"Sorry, can't create %s \n(disk quota exceeded or insufficient privilege ?)...",
				tmp_name);
		display_error(widget_array[ID_sim_mainW],buffer,"Write Error !");
		return (0);
	}

	for(i = 0 ; i <= simu->nb_nucleus; i++)
	{
	  fgets(buffer,100,sim_fp);
	  fputs(buffer,tmp_fp);
	  for(k =  0; k < i; k++)
	      fgets(buffer,100,sim_fp);
	  
	  while(fgets(buffer,100,sim_fp))
	  {
	    fputs(buffer,tmp_fp);
       	    for(k =  0; k < simu->nb_nucleus; k++)
	      fgets(buffer,100,sim_fp);
	  }
	  rewind(sim_fp);
	}
	fclose(sim_fp);
	fclose(tmp_fp);
	sprintf(buffer,"mv %s %s",tmp_name, simu->sim_name);
	system(buffer);
	return(1);
}

create_3d_anat_file(void)
{
	FILE *fp_3d_anat;
	int i,j,k;
	char buffer[256];
	char	dir[256];
	char	simul[256];
	char	tmp_name[256];

	sprintf(tmp_name,"%s.xyz",get_simulation_name());
	if ((fp_3d_anat = fopen(tmp_name,"w")) == NULL)
	{
		sprintf(buffer,"Sorry, can't create %s \n(disk quota exceeded or insufficient privilege ?)...",
				tmp_name);
		display_error(widget_array[ID_sim_mainW],buffer,"Write Error !");
		return (0);
	} /* fin du if */

	k = 0; 
	for(i=0 ; i<simu->nb_nucleus ; i++)
	{
		for(j=0 ; j<sim_nucleus[i]->nucleus_size ; j++)
		{
			sprintf(buffer,"%c %f %f %f",
				(sim_neurons[k]->its_nucleus->number+'@'),
				sim_neurons[k]->HC_lat,
				sim_neurons[k]->HC_vert,
				sim_neurons[k]->HC_ap);
			fprintf(fp_3d_anat,"%s\n",buffer);
			k++;
		}
	}
	fclose(fp_3d_anat);
	
	
} /* fin du void */
/*
 * fabrique l'entete du fichier abe
 */
void start_abe_file()
{
	fprintf(abe_fp,"\"VERSION=0\"\n");
#if 0
  	fprintf(abe_fp,"\'File created by %s the %s at %s\'\n", creator, jour, heure);
#endif
	fprintf(abe_fp,"\"TITLE(0)=\'Simulation name: %s\'\"\n",get_project_name());
	fprintf(abe_fp,"\"TITLE(1)=\'n,i represents a spike from neuron i of nucleus n\'\"\n");
	fprintf(abe_fp,"\"TITLE(2)=\'F,i represents a spike from neuron i of virtual cluster\'\"\n");
	fprintf(abe_fp,"\"TITLE(3)=\'AB,n represents the begining of a pulse train on nucleus n\'\"\n");
	fprintf(abe_fp,"\"TITLE(4)=\'AE,n represents the end of a pulse train on nucleus n\'\"\n");
	fprintf(abe_fp,"\"TITLE(5)=\'BB,n represents the begining of a background noise on nucleus n\'\"\n");
	fprintf(abe_fp,"\"TITLE(6)=\'BE,n represents the end of a background noise on nucleus n\'\"\n");
	fprintf(abe_fp,"\"TITLE(7)=\'CB,n represents the begining of a modulation on nucleus n\'\"\n");
	fprintf(abe_fp,"\"TITLE(8)=\'CE,n represents the end of a modulation on nucleus n\'\"\n");
	fprintf(abe_fp,"\"TITLE(9)=\'DB,n represents the begining of a drug injection in nucleus n\'\"\n");
	fprintf(abe_fp,"\"TITLE(10)=\'DE,n represents the end of a drug injection in nucleus n\'\"\n");
	fprintf(abe_fp,"\"TIME_UNITS=%f\"\n",simu->time_step/1000.);
	fprintf(abe_fp,"0,1,0\n");
}
#endif




